// Note: For maximum-speed code, see "Optimizing Code" on the Emscripten wiki, https://github.com/kripken/emscripten/wiki/Optimizing-Code
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');
// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}
// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };
  var nodeFS = require('fs');
  var nodePath = require('path');
  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };
  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };
  Module['load'] = function load(f) {
    globalEval(read(f));
  };
  Module['arguments'] = process['argv'].slice(2);
  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm
  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }
  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };
  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  this['Module'] = Module;
  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };
  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  if (typeof console !== 'undefined') {
    Module['print'] = function print(x) {
      console.log(x);
    };
    Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }
  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}
function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***
// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];
// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];
// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}
// === Auto-generated preamble library stuff ===
//========================================
// Runtime code shared with compiler
//========================================
var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?{ ?[^}]* ?}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [null,null,null,null,null,null,null,null,null,null],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + Pointer_stringify(code) + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;
      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }
      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }
      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}
function jsCall() {
  var args = Array.prototype.slice.call(arguments);
  return Runtime.functionPointers[args[0]].apply(null, args.slice(1));
}
//========================================
// Runtime essentials
//========================================
var __THREW__ = 0; // Used in checking for thrown exceptions.
var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;
var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}
var globalScope = this;
// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;
// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}
// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}
// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;
// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;
// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;
var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;
// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }
  var singleType = typeof types === 'string' ? types : null;
  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }
  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }
  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }
  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];
    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }
    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later
    setValue(ret+i, curr, type);
    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }
  return ret;
}
Module['allocate'] = allocate;
function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;
  var ret = '';
  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }
  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;
// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;
// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;
function demangle(func) {
  try {
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    var i = 3;
    // params, etc.
    var basicTypes = {
      'v': 'void',
      'b': 'bool',
      'c': 'char',
      's': 'short',
      'i': 'int',
      'l': 'long',
      'f': 'float',
      'd': 'double',
      'w': 'wchar_t',
      'a': 'signed char',
      'h': 'unsigned char',
      't': 'unsigned short',
      'j': 'unsigned int',
      'm': 'unsigned long',
      'x': 'long long',
      'y': 'unsigned long long',
      'z': '...'
    };
    function dump(x) {
      //return;
      if (x) Module.print(x);
      Module.print(func);
      var pre = '';
      for (var a = 0; a < i; a++) pre += ' ';
      Module.print (pre + '^');
    }
    var subs = [];
    function parseNested() {
      i++;
      if (func[i] === 'K') i++; // ignore const
      var parts = [];
      while (func[i] !== 'E') {
        if (func[i] === 'S') { // substitution
          i++;
          var next = func.indexOf('_', i);
          var num = func.substring(i, next) || 0;
          parts.push(subs[num] || '?');
          i = next+1;
          continue;
        }
        if (func[i] === 'C') { // constructor
          parts.push(parts[parts.length-1]);
          i += 2;
          continue;
        }
        var size = parseInt(func.substr(i));
        var pre = size.toString().length;
        if (!size || !pre) { i--; break; } // counter i++ below us
        var curr = func.substr(i + pre, size);
        parts.push(curr);
        subs.push(curr);
        i += pre + size;
      }
      i++; // skip E
      return parts;
    }
    var first = true;
    function parse(rawList, limit, allowVoid) { // main parser
      limit = limit || Infinity;
      var ret = '', list = [];
      function flushList() {
        return '(' + list.join(', ') + ')';
      }
      var name;
      if (func[i] === 'N') {
        // namespaced N-E
        name = parseNested().join('::');
        limit--;
        if (limit === 0) return rawList ? [name] : name;
      } else {
        // not namespaced
        if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
        var size = parseInt(func.substr(i));
        if (size) {
          var pre = size.toString().length;
          name = func.substr(i + pre, size);
          i += pre + size;
        }
      }
      first = false;
      if (func[i] === 'I') {
        i++;
        var iList = parse(true);
        var iRet = parse(true, 1, true);
        ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
      } else {
        ret = name;
      }
      paramLoop: while (i < func.length && limit-- > 0) {
        //dump('paramLoop');
        var c = func[i++];
        if (c in basicTypes) {
          list.push(basicTypes[c]);
        } else {
          switch (c) {
            case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
            case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
            case 'L': { // literal
              i++; // skip basic type
              var end = func.indexOf('E', i);
              var size = end - i;
              list.push(func.substr(i, size));
              i += size + 2; // size + 'EE'
              break;
            }
            case 'A': { // array
              var size = parseInt(func.substr(i));
              i += size.toString().length;
              if (func[i] !== '_') throw '?';
              i++; // skip _
              list.push(parse(true, 1, true)[0] + ' [' + size + ']');
              break;
            }
            case 'E': break paramLoop;
            default: ret += '?' + c; break paramLoop;
          }
        }
      }
      if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
      return rawList ? list : ret + flushList();
    }
    return parse();
  } catch(e) {
    return func;
  }
}
function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}
function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}
// Memory management
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk
function enlargeMemory() {
  abort('Cannot enlarge memory arrays in asm.js. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', or (2) set Module.TOTAL_MEMORY before the program runs.');
}
var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 33554432;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;
// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'Cannot fallback to non-typed array case: Code is too specialized');
var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');
Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}
var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited
var runtimeInitialized = false;
function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}
function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;
function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;
function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;
function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;
function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;
// Tools
// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;
function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;
// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;
function unSign(value, bits, ignore, sig) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore, sig) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}
if (!Math['imul']) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;
Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data
var memoryInitializer = null;
// === Body ===
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 18202608;
var _stdout;
var _stdout=_stdout=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stdin;
var _stdin=_stdin=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stderr;
var _stderr=_stderr=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } },{ func: function() { __GLOBAL__I_a() } },{ func: function() { __GLOBAL__I_a43() } },{ func: function() { __GLOBAL__I_a1926() } },{ func: function() { __GLOBAL__I_a2115() } });
var ___fsmu8;
var ___dso_handle;
var ___dso_handle=___dso_handle=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv120__si_class_type_infoE;
__ZTVN10__cxxabiv120__si_class_type_infoE=allocate([0,0,0,0,136,129,1,0,90,1,0,0,184,0,0,0,104,0,0,0,142,0,0,0,36,0,0,0,28,0,0,0,24,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv117__class_type_infoE;
__ZTVN10__cxxabiv117__class_type_infoE=allocate([0,0,0,0,152,129,1,0,90,1,0,0,84,1,0,0,104,0,0,0,142,0,0,0,36,0,0,0,48,0,0,0,22,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZN10VicePluginC1EPKh;
var __ZN5reSID17EnvelopeGeneratorC1Ev;
var __ZN5reSID14ExternalFilterC1Ev;
var __ZN5reSID6FilterC1Ev;
var __ZN5reSID3SIDC1Ev;
var __ZN5reSID3SIDD1Ev;
var __ZN5reSID3SID5StateC1Ev;
var __ZN5reSID5VoiceC1Ev;
var __ZN5reSID17WaveformGeneratorC1Ev;
var __ZNSt13runtime_errorC1EPKc;
var __ZNSt13runtime_errorD1Ev;
var __ZNSt12length_errorD1Ev;
var __ZNSt12out_of_rangeD1Ev;
var __ZNSt14overflow_errorD1Ev;
var __ZNSt3__16localeC1Ev;
var __ZNSt3__16localeC1ERKS0_;
var __ZNSt3__16localeD1Ev;
var __ZNSt8bad_castC1Ev;
var __ZNSt8bad_castD1Ev;
/* memory initializer */ allocate([255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,32,112,112,124,124,126,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,28,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,192,192,192,192,207,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,192,192,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,192,192,192,192,192,192,128,128,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,224,227,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,224,224,192,192,192,192,192,192,192,224,192,192,192,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,240,240,240,224,224,224,224,224,224,224,240,224,224,224,240,240,240,240,240,224,240,240,240,240,240,240,240,240,240,240,240,240,240,248,248,240,240,240,248,248,248,248,248,248,248,248,248,248,248,252,252,252,252,252,252,252,252,252,254,254,254,254,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,63,0,0,0,63,0,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,94,0,0,0,0,0,0,0,95,0,0,0,95,0,95,95,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,111,0,0,0,111,64,111,111,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,0,0,64,64,119,0,64,64,119,64,119,119,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,64,0,64,64,121,0,0,0,0,0,0,0,64,0,0,0,64,0,64,64,120,0,0,0,64,0,64,64,120,64,96,96,120,96,123,123,123,0,0,0,0,0,64,64,96,0,64,64,96,64,96,96,124,64,64,64,96,64,112,112,124,96,112,112,124,112,124,125,125,64,96,96,112,96,112,120,126,112,120,120,126,120,126,126,126].concat([120,124,124,127,124,127,127,127,124,127,127,127,127,127,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,157,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,158,0,0,0,128,0,128,128,159,128,128,128,159,128,159,159,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,133,0,0,0,0,0,0,0,128,0,128,0,128,128,128,128,174,0,128,128,128,128,128,128,175,128,128,128,175,128,175,175,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,0,0,0,128,128,128,128,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,128,0,128,128,128,0,128,128,128,128,128,128,161,0,0,128,128,0,128,128,128,128,128,128,128,128,128,128,176,128,128,128,128,128,128,128,176,128,128,128,181,128,183,183,183,0,0,0,0,0,128,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,177,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,184,128,128,128,128,128,128,128,184,128,128,128,184,128,184,187,187,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,188,128,128,128,160,128,160,160,188,128,160,160,188,176,188,188,189,128,128,128,176,128,176,176,188,160,176,176,188,184,188,190,190,176,184,184,190,188,190,191,191,188,191,191,191,191,191,191,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,128,0,0,0,128,0,128,128,128,0,128,128,128,128,128,128,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,195,0,0,0,128,0,128,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,197,128,128,128,128,128,128,128,192,128,128,128,192,128,192,192,206,128,128,128,192,128,192,192,207,128,192,192,207,192,207,207,207,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,128,0,0,0,128,128,128,128,128,128,128,128,128,128,128,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,192,195,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,192,128,128,128,192,128,192,192,193,128,128,128,128,128,128,128,192,128,128,128,192,128,192,192,192,128,128,192,192,192,192,192,192,192,192,192,208,192,213,215,215,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,192,128,192,192,192,192,192,192,209,128,128,128,192,128,192,192,192,128,192,192,192,192,192,192,208,192,192,192,192,192,192,192,208,192,192,192,216,192,216,217,219,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,216,192,192,192,192,192,192,192,220,192,192,192,220,208,220,220,221,192,192,192,208,192,208,208,220,192,208,208,220,208,220,222,222,208,216,216,222,216,222,222,223,220,223,223,223,223,223,223,223,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,192,128,128,128,128,128,128,128,192,128,128,128,192,128,192,192,192,128,128,128,192,128,192,192,192,128,192,192,192,192,192,192,227,128,128,128,128,128,128,128,192,128,128,128,192,128,192,192,192,128,192,192,192,192,192,192,192,192,192,192,192,192,192,192,225,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,192,192,192,192,192,192,192,224,192,224,224,224,224,225,231,231,128,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,224,225,192,192,192,192,192,192,192,224,192,192,192,224,192,224,224,224,192,192,192,224,192,224,224,224,224,224,224,224,224,232,232,235,192,192,192,192,192,192,192,224,192,224,224,224,224,224,224,232,192,224,224,224,224,224,224,232,224,224,224,236,224,236,236,237,224,224,224,224,224,224,224,236,224,224,224,236,224,236,236,238,224,232,232,238,232,238,238,239,236,239,239,239,239,239,239,239,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,192,192,192,192,192,224,224,224,192,224,224,224,224,224,224,240,192,192,192,224,192,224,224,224,224,224,224,224,224,224,224,240,224,224,224,224,224,224,224,240,224,224,240,240,240,240,240,243,224,224,224,224,224,224,224,240,224,224,224,240,224,240,240,240,224,224,224,240,224,240,240,240,224,240,240,240,240,240,244,245,224,240,240,240,240,240,240,244,240,240,240,244,240,244,244,246,240,240,240,244,240,244,246,247,244,246,247,247,247,247,247,247,224,224,224,240,224,240,240,240,240,240,240,240,240,240,240,248,240,240,240,240,240,240,240,248,240,240,248,248,248,248,248,249,240,240,240,248,240,248,248,248,240,248,248,248,248,248,248,250,248,248,248,248,248,248,250,251,248,250,250,251,251,251,251,251,248,248,248,248,248,248,248,252,248,248,248,252,252,252,252,252,248,252,252,252,252,252,252,253,252,252,252,253,253,253,253,253,252,252,252,254,252,254,254,254,254,254,254,254,254,254,254,254,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,28,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,64,64,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,64,64,96,96,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,64,64,96,0,64,64,96,64,112,112,123,0,0,64,64,64,64,64,112,64,96,96,112,96,112,120,124,96,112,112,120,112,120,124,126,120,124,124,127,126,127,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,128,128,128,0,128,128,128,128,128,128,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,128,0,128,128,128,0,0,0,128,128,128,128,128,128,128,128,128,128,128,128,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,0,0,128,128,128,128,128,128,0,0,0,0,0,128,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,183,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,160,128,160,176,187,128,128,128,128,128,128,128,160,128,128,128,176,160,176,176,188,128,160,160,176,176,184,184,190,184,188,188,191,188,191,191,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,128,128,0,128,128,128,128,128,128,128,0,0,0,0,0,0,0,128,0,0,0,128,0,128,128,128,0,0,0,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,192,128,192,192,192,192,192,192,207,0,0,128,128,0,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,192,128,128,128,192,128,192,192,192,192,192,192,192,192,192,192,215,128,128,128,128,128,128,128,192,128,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,208,216,192,192,192,192,192,192,192,192,192,192,192,192,192,208,208,220,192,192,192,208,208,216,216,222,208,216,220,223,220,223,223,223,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,192,192,192,128,192,192,192,192,192,192,192,128,128,128,192,128,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,192,192,192,224,192,224,224,231,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,192,192,192,192,192,192,224,224,192,224,224,224,224,224,224,232,192,192,192,224,224,224,224,224,224,224,224,224,224,224,224,236,224,224,224,224,224,224,232,238,224,232,236,238,236,239,239,239,192,192,192,192,192,192,192,224,192,192,224,224,224,224,224,224,224,224,224,224,224,224,224,240,224,224,224,240,224,240,240,240,224,224,224,224,224,224,224,240,224,240,240,240,240,240,240,244,240,240,240,240,240,240,240,244,240,240,240,246,244,247,247,247,224,240,240,240,240,240,240,240,240,240,240,248,240,248,248,248,240,240,240,248,248,248,248,248,248,248,248,250,248,251,251,251,248,248,248,248,248,252,252,252,248,252,252,252,252,253,253,253,252,252,252,254,254,254,254,254,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,254,254,254,254,254,252,252,252,253,253,252,252,252,252,252,248,252,252,252,248,248,248,248,248,251,251,251,248,250,248,248,248,248,248,248,248,248,240,240,240,248,248,248,240,248,240,240,240,240,240,240,240,240,240,240,224,247,247,247,244,246,240,240,240,244,240,240,240,240,240,240,240,244,240,240,240,240,240,240,224,240,224,224,224,224,224,224,224,240,240,240,224,240,224,224,224,240,224,224,224,224,224,224,192,224,224,224,224,224,224,192,192,224,192,192,192,192,192,192,192,239,239,239,236,238,236,232,224,238,232,224,224,224,224,224,224,236,224,224,224,224,224,224,224,224,224,224,224,224,192,192,192,232,224,224,224,224,224,224,192,224,224,192,192,192,192,192,192,224,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,231,224,224,192,224,192,192,192,224,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,128,192,128,128,128,192,192,192,192,192,192,192,128,192,192,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,223,223,223,220,223,220,220,208,222,216,216,208,208,192,192,192,220,208,208,192,208,192,192,192,192,192,192,192,192,192,192,192,216,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,128,192,128,128,128,128,128,128,128,215,192,192,192,192,192,192,192,192,192,192,128,192,128,128,128,192,192,192,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,0,0,207,192,192,192,192,192,192,128,192,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,192,128,128,128,128,128,128,128,128,128,128,128,128,128,0,0,128,128,128,0,128,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,0,128,128,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,191,191,188,191,188,188,184,190,184,184,176,184,160,160,128,188,176,176,160,176,128,128,128,160,128,128,128,128,128,128,128,187,176,160,128,160,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,183,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,0,0,0,0,0,0,128,128,128,128,128,128,0,0,128,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,175,128,128,128,128,128,128,128,128,128,128,128,128,128,0,0,128,128,128,0,128,0,0,0,128,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,159,128,128,128,128,128,128,0,128,128,128,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,127,126,127,124,124,120,126,124,120,112,120,112,112,96,124,120,112,96,112,96,96,64,112,96,64,64,64,64,0,0,123,112,112,64,96,64,64,0,96,64,64,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,96,64,64,64,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,64,64,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,63,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,128,128,183,0,128,128,187,128,189,190,191,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,128,0,128,128,216,0,0,0,128,128,224,0,128,128,224,128,224,224,239,0,128,192,240,192,240,240,247,192,240,248,251,248,253,254,253,248,251,248,240,192,247,240,240,224,243,224,224,128,239,238,237,224,235,224,192,128,231,192,192,0,192,0,223,192,192,128,192,128,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,0,0,64,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,14,14,14,15,15,15,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,28,28,28,28,28,28,28,28,30,30,30,30,31,31,31,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,14,14,14,15,15,15,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,60,60,60,60,60,60,60,60,62,62,63,63,127,127,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,14,14,14,15,15,15,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,28,28,28,28,28,28,28,28,30,30,30,30,31,31,31,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,14,14,14,15,15,31,31,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,129,131,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,135,135,135,143,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,227,227,224,240,240,240,240,240,240,240,240,240,240,240,224,224,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,241,240,240,240,240,240,240,240,240,240,248,240,240,240,240,248,248,248,248,248,248,248,248,248,248,248,248,248,248,248,248,248,248,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,254,254,254,254,254,254,254,255,255,255,255,255,255,255,255,82,73,70,70,108,108,108,108,87,65,86,69,102,109,116,32,16,0,0,0,1,0,99,99,114,114,114,114,98,98,98,98,56,56,16,0,100,97,116,97,108,108,108,108,0,0,0,0,40,85,1,0,40,0,0,0,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,115,115,115,0,0,0,0,67,114,101,97,116,105,118,101,32,86,111,105,99,101,32,70,105,108,101,26,26,0,20,1,31,17,0,0,0,0,0,0,9,115,115,115,114,114,114,114,22,99,4,0,0,0,0,0,48,85,1,0,22,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,7,0,0,0,2,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([4,0,0,0,9,0,0,0,2,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,9,0,0,0,2,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,9,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,9,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,13,0,0,0,1,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,11,0,0,0,2,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,13,0,0,0,1,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,11,0,0,0,2,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,13,0,0,0,1,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,9,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,9,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,13,0,0,0,1,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,11,0,0,0,2,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,13,0,0,0,1,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,7,0,0,0,2,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,13,0,0,0,2,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,13,0,0,0,2,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,7,0,0,0,5,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,13,0,0,0,2,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,4,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,13,0,0,0,2,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,13,0,0,0,2,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,15,0,0,0,1,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,6,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,7,0,0,0,2,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,4,0,0,0,9,0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,9,0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,11,0,0,0,1,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,4,0,0,0,14,0,0,0,5,0,0,0,7,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,5,0,0,0,3,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,7,0,0,0,2,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,12,0,0,0,7,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,5,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,11,0,0,0,4,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,13,0,0,0,3,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,15,0,0,0,2,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,17,0,0,0,1,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,7,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,248,255,255,255,247,255,255,255,248,255,255,255,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,216,255,255,255,215,255,255,255,0,0,0,0,16,0,0,0,8,181,0,0,0,0,64,66,0,0,144,192,16,0,0,0,8,182,0,0,0,0,64,66,0,0,144,192,112,93,1,0,0,0,0,0,0,0,0,0,0,211,255,211,63,0,0,0,1,0,0,0,102,0,0,0,88,0,0,0,228,0,0,0,30,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,136,90,1,0,0,0,0,0,0,0,0,0,0,210,255,210,63,0,0,0,1,0,0,0,102,0,0,0,88,0,0,0,228,0,0,0,30,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,248,88,1,0,0,0,0,0,0,0,0,0,0,209,255,209,63,0,0,0,1,0,0,0,102,0,0,0,88,0,0,0,228,0,0,0,30,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,88,87,1,0,0,0,0,0,0,0,0,0,0,208,255,208,63,0,0,0,1,0,0,0,102,0,0,0,88,0,0,0,228,0,0,0,30,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,52,194,0,0,0,0,96,84,1,0,0,0,128,67,0,128,29,67,0,0,0,0,16,91,1,0,0,0,96,66,0,0,225,66,1,0,0,0,168,77,1,0,0,0,63,67,0,0,225,66,255,255,255,255,0,69,1,0,0,0,0,67,0,0,7,195,255,255,255,255,32,63,1,0,0,0,0,67,0,0,7,195,1,0,0,0,72,58,1,0,0,0,96,66,0,0,0,0,1,0,0,0,192,54,1,0,0,0,63,67,0,0,0,0,255,255,255,255,208,51,1,0,0,0,0,67,0,0,52,194,255,255,255,255,160,49,1,0,0,0,96,66,0,128,29,67,1,0,0,0,160,47,1,0,0,0,0,67,0,0,225,66,1,0,0,0,104,95,1,0,0,0,96,66,0,0,225,66,0,0,0,0,8,93,1,0,0,0,0,67,0,0,7,195,0,0,0,0,64,90,1,0,0,0,63,67,0,0,7,195,1,0,0,0,168,88,1,0,0,0,0,67,0,0,0,0,1,0,0,0,232,86,1,0,0,0,63,67,0,0,0,0,0,0,0,0,72,85,1,0,0,0,0,0,0,0,52,194,0,0,0,0,96,84,1,0,0,0,128,67,0,128,29,67,0,0,0,0,16,91,1,0,0,0,148,66,0,0,225,66,1,0,0,0,168,77,1,0,0,0,35,67,0,0,225,66,255,255,255,255,0,69,1,0,0,0,184,66,0,0,7,195,255,255,255,255,32,63,1,0,0,0,0,67,0,0,7,195,1,0,0,0,72,58,1,0,0,0,96,66,0,0,0,0,1,0,0,0,192,54,1,0,0,0,71,67,0,0,0,0,255,255,255,255,208,51,1,0,0,0,184,66,0,0,52,194,255,255,255,255,160,49,1,0,0,0,96,66,0,128,29,67,1,0,0,0,160,47,1,0,0,0,0,67,0,0,225,66,1,0,0,0,104,95,1,0,0,0,148,66,0,0,225,66,0,0,0,0,8,93,1,0,0,0,234,66,0,0,7,195,0,0,0,0,64,90,1,0,0,0,71,67,0,0,7,195,1,0,0,0,168,88,1,0,0,0,234,66,0,0,0,0,1,0,0,0,232,86,1,0,0,0,35,67,0,0,0,0,0,0,0,0,72,85,1,0,240,63,1,0,248,62,1,0,168,62,1,0,32,62,1,0,176,61,1,0,96,61,1,0,8,61,1,0,144,60,1,0,40,60,1,0,0,0,0,0,96,61,1,0,8,61,1,0,144,60,1,0,192,59,1,0,0,0,0,0,16,59,1,0,8,59,1,0,32,58,1,0,8,58,1,0,0,0,0,0,224,57,1,0,8,59,1,0,32,58,1,0,8,58,1,0,0,0,0,0,16,59,1,0,104,57,1,0,56,57,1,0,176,56,1,0,0,0,0,0,224,57,1,0,104,57,1,0,56,57,1,0,176,56,1,0,0,0,0,0,16,59,1,0,104,57,1,0,56,57,1,0,96,56,1,0,0,0,0,0,224,57,1,0,104,57,1,0,56,57,1,0,96,56,1,0,0,0,0,0,232,55,1,0,128,55,1,0,96,55,1,0,144,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,75,1,0,0,0,0,0,0,0,0,0,0,0,0,0,144,240,4,0,146,0,0,0,0,0,0,0,248,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,136,240,4,0,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,1,0,0,0,112,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,255,0,0,0,252,0,0,0,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,1,0,0,0,112,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,240,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,240,47,1,0,1,0,0,0,144,80,1,0,0,223,31,223,31,0,0,0,1,0,0,0,34,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,46,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,74,13,0,78,79,84,32,73,77,80,76,69,77,69,78,84,69,68,0,56,71,1,0,1,0,0,0,144,80,1,0,0,222,31,222,31,0,0,0,1,0,0,0,24,0,0,0,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,78,1,0,0,0,0,0,1,0,0,0,0,0,0,0,32,245,6,0,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,91,1,0,30,0,0,0,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,230,0,0,0,32,0,0,0,92,1,0,0,22,0,0,0,56,0,0,0,166,0,0,0,152,0,0,0,22,0,0,0,26,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,72,55,1,0,0,0,0,0,0,0,0,0,0,215,255,215,31,0,0,0,1,0,0,0,60,0,0,0,234,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,32,52,1,0,0,0,0,0,0,0,0,0,0,214,255,214,31,0,0,0,1,0,0,0,60,0,0,0,234,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,240,49,1,0,0,0,0,0,0,0,0,0,0,213,255,213,31,0,0,0,1,0,0,0,60,0,0,0,234,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,48,48,1,0,0,0,0,0,0,0,0,0,32,212,255,212,31,0,0,0,1,0,0,0,60,0,0,0,234,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,200,95,1,0,0,0,0,0,0,0,0,0,0,212,31,212,31,0,0,0,1,0,0,0,60,0,0,0,234,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,254,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,50,1,0,240,48,1,0,0,0,0,0,0,0,0,0,200,240,4,0,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,67,1,0,88,74,13,0,0,0,0,0,0,0,0,0,88,67,12,0,38,0,0,0,0,0,0,0,104,66,1,0,88,74,13,0,0,0,0,0,0,0,0,0,96,67,12,0,62,0,0,0,0,0,0,0,184,46,1,0,88,74,13,0,2,0,0,0,88,74,13,0,56,9,7,0,182,0,0,0,0,0,0,0,232,64,1,0,88,74,13,0,0,0,0,0,0,0,0,0,64,9,7,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,73,1,0,88,72,1,0,0,0,0,0,0,0,0,0,160,8,7,0,26,0,0,0,0,0,0,0,152,71,1,0,144,74,13,0,0,0,0,0,0,0,0,0,168,8,7,0,54,0,0,0,0,0,0,0,240,70,1,0,88,72,1,0,0,0,0,0,0,0,0,0,152,8,7,0,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,1,0,128,74,13,0,0,0,0,0,0,0,0,0,72,63,12,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,8,66,12,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,55,1,0,24,52,1,0,0,0,0,0,0,0,0,0,24,200,12,0,40,0,0,0,0,0,0,0,224,49,1,0,40,48,1,0,0,0,0,0,0,0,0,0,80,64,12,0,92,0,0,0,0,0,0,0,184,95,1,0,104,93,1,0,0,0,0,0,0,0,0,0,8,41,13,0,124,0,0,0,0,0,0,0,120,90,1,0,136,74,13,0,1,0,0,0,0,0,0,0,88,64,12,0,88,0,0,0,0,0,0,0,72,87,1,0,136,85,1,0,0,0,0,0,0,0,0,0,16,31,12,0,112,0,0,0,0,0,0,0,104,84,1,0,0,83,1,0,0,0,0,0,0,0,0,0,20,31,12,0,112,0,0,0,1,0,0,0,0,82,1,0,136,85,1,0,0,0,0,0,0,0,0,0,24,31,12,0,112,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,95,1,0,48,93,1,0,0,0,0,0,0,0,0,0,248,66,12,0,176,0,0,0,0,0,0,0,88,90,1,0,232,88,1,0,0,0,0,0,0,0,0,0,224,66,12,0,90,0,0,0,0,0,0,0,48,87,1,0,128,85,1,0,0,0,0,0,0,0,0,0,24,67,12,0,212,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,104,64,12,0,126,0,0,0,0,0,0,0,64,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,80,73,7,0,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,1,0,0,0,0,0,0,0,0,0,0,0,0,0,192,65,12,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,72,1,0,100,0,0,0,1,0,0,0,0,0,0,0,232,8,7,0,210,0,0,0,0,0,0,0,104,60,1,0,0,0,0,0,2,0,0,0,1,0,0,0,32,9,7,0,130,0,0,0,0,0,0,0,248,52,1,0,0,0,0,0,2,0,0,0,0,0,0,0,8,233,4,0,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,56,1,0,1,0,0,0,1,0,0,0,0,0,0,0,168,240,4,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,81,1,0,1,0,0,0,1,0,0,0,0,0,0,0,152,73,7,0,48,0,0,0,0,0,0,0,64,72,1,0,68,172,0,0,0,0,0,0,0,0,0,0,128,8,7,0,196,0,0,0,0,0,0,0,224,70,1,0,0,0,0,0,0,0,0,0,0,0,0,0,216,40,13,0,194,0,0,0,0,0,0,0,232,68,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,66,12,0,160,0,0,0,0,0,0,0,120,62,1,0,0,0,0,0,0,0,0,0,0,0,0,0,216,240,4,0,148,0,0,0,0,0,0,0,8,64,1,0,2,0,0,0,0,0,0,0,0,0,0,0,8,243,4,0,206,0,0,0,0,0,0,0,184,61,1,0,100,0,0,0,0,0,0,0,0,0,0,0,120,233,4,0,174,0,0,0,0,0,0,0,184,62,1,0,0,0,0,0,0,0,0,0,0,0,0,0,176,105,7,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,74,1,0,1,0,0,0,0,0,0,0,0,0,0,0,144,8,7,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,57,1,0,0,0,0,0,1,0,0,0,0,0,0,0,232,240,4,0,134,0,0,0,0,0,0,0,240,50,1,0,64,0,0,0,1,0,0,0,0,0,0,0,128,240,4,0,142,0,0,0,0,0,0,0,224,46,1,0,0,0,0,0,1,0,0,0,0,0,0,0,160,73,7,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,62,1,0,0,0,0,0,0,0,0,0,0,0,0,0,108,65,12,0,186,0,0,0,6,0,0,0,248,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,112,65,12,0,186,0,0,0,7,0,0,0,80,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,116,65,12,0,186,0,0,0,8,0,0,0,88,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,104,65,12,0,186,0,0,0,5,0,0,0,64,49,1,0,0,0,0,0,0,0,0,0,0,0,0,0,96,65,12,0,186,0,0,0,3,0,0,0,48,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,92,65,12,0,186,0,0,0,2,0,0,0,48,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,88,65,12,0,186,0,0,0,1,0,0,0,120,92,1,0,0,0,0,0,0,0,0,0,0,0,0,0,100,65,12,0,186,0,0,0,4,0,0,0,200,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,84,65,12,0,186,0,0,0,0,0,0,0,32,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,144,65,12,0,190,0,0,0,6,0,0,0,104,86,1,0,0,0,0,0,0,0,0,0,0,0,0,0,148,65,12,0,190,0,0,0,7,0,0,0,8,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,152,65,12,0,190,0,0,0,8,0,0,0,8,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,140,65,12,0,190,0,0,0,5,0,0,0,184,82,1,0,0,0,0,0,0,0,0,0,0,0,0,0,132,65,12,0,190,0,0,0,3,0,0,0,168,81,1,0,0,0,0,0,0,0,0,0,0,0,0,0,128,65,12,0,190,0,0,0,2,0,0,0,64,80,1,0,0,0,0,0,0,0,0,0,0,0,0,0,124,65,12,0,190,0,0,0,1,0,0,0,112,79,1,0,0,0,0,0,0,0,0,0,0,0,0,0,136,65,12,0,190,0,0,0,4,0,0,0,72,78,1,0,0,0,0,0,0,0,0,0,0,0,0,0,120,65,12,0,190,0,0,0,0,0,0,0,168,76,1,0,1,0,0,0,0,0,0,0,0,0,0,0,40,65,12,0,44,0,0,0,0,0,0,0,80,75,1,0,0,0,0,0,0,0,0,0,0,0,0,0,160,64,12,0,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,77,1,0,0,0,0,0,1,0,0,0,0,0,0,0,40,234,4,0,184,0,0,0,0,0,0,0,208,68,1,0,1,0,0,0,1,0,0,0,0,0,0,0,44,234,4,0,36,0,0,0,0,0,0,0,8,63,1,0,1,0,0,0,1,0,0,0,0,0,0,0,48,234,4,0,66,0,0,0,0,0,0,0,48,58,1,0,1,0,0,0,0,0,0,0,0,0,0,0,52,234,4,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,49,1,0,0,0,0,0,0,0,0,0,0,0,0,0,232,66,12,0,172,0,0,0,0,0,0,0,16,48,1,0,1,0,0,0,0,0,0,0,0,0,0,0,16,67,12,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,94,1,0,255,255,255,255,1,0,0,0,0,0,0,0,208,240,4,0,116,0,0,0,0,0,0,0,176,93,1,0,0,0,0,0,1,0,0,0,0,0,0,0,16,200,12,0,180,0,0,0,0,0,0,0,176,78,1,0,0,0,0,0,1,0,0,0,0,0,0,0,8,200,12,0,200,0,0,0,0,0,0,0,0,70,1,0,0,0,0,0,0,0,0,0,0,0,0,0,8,31,12,0,74,0,0,0,0,0,0,0,184,63,1,0,0,222,0,0,1,0,0,0,0,0,0,0,16,245,6,0,156,0,0,0,0,0,0,0,232,58,1,0,0,223,0,0,1,0,0,0,0,0,0,0,248,244,6,0,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,112,67,12,0,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,69,1,0,0,0,0,0,0,0,0,0,0,0,0,0,56,245,6,0,122,0,0,0,0,0,0,0,48,63,1,0,90,0,0,0,0,0,0,0,0,0,0,0,64,245,6,0,106,0,0,0,0,0,0,0,120,58,1,0,97,0,0,0,0,0,0,0,0,0,0,0,72,245,6,0,100,0,0,0,0,0,0,0,240,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,80,245,6,0,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,236,0,0,0,62,0,0,0,134,0,0,0,192,0,0,0])
.concat([24,0,0,0,74,0,0,0,58,0,0,0,234,0,0,0,202,0,0,0,76,0,0,0,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,78,75,78,79,87,78,0,54,53,56,49,0,0,0,0,56,53,56,48,0,0,0,0,65,78,89,0,0,0,0,0,1,0,111,54,53,0,3,0,0,16,27,1,0,4,0,0,0,64,0,0,4,0,0,0,0,0,14,0,112,115,105,100,100,114,118,46,111,54,53,0,28,3,68,97,103,32,76,101,109,32,60,114,101,115,105,100,64,110,105,109,114,111,100,46,110,111,62,0,0,76,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,247,16,17,17,23,17,169,0,141,26,208,173,25,208,141,25,208,169,127,141,13,220,141,13,221,173,13,220,173,13,221,162,8,189,3,16,157,0,128,202,16,247,173,15,16,201,3,144,20,208,7,173,14,16,201,26,144,11,162,5,189,26,16,157,20,3,202,16,247,169,27,162,0,141,17,208,142,18,208,173,24,16,240,6,169,37,162,64,208,4,169,149,162,66,141,4,220,142,5,220,169,15,141,24,212,172,12,16,136,204,13,16,144,2,160,0,152,72,173,19,16,240,36,32,230,16,141,25,16,192,32,144,2,160,31,169,0,170,56,42,144,2,42,232,136,16,248,61,20,16,208,7,169,129,141,26,208,208,10,169,129,162,1,141,13,220,142,14,220,169,47,133,0,173,17,16,32,230,16,133,1,104,32,224,16,173,19,16,240,4,169,54,133,1,88,76,221,16,108,16,16,108,18,16,201,224,144,3,169,53,96,201,208,144,3,169,52,96,169,54,96,173,19,16,240,12,173,25,16,133,1,32,227,16,169,54,133,1,173,25,208,141,25,208,173,13,220,104,168,104,170,104,64,44,13,221,64,0,0,2,130,25,130,2,130,2,130,30,130,9,130,9,130,9,130,19,130,26,130,4,130,9,130,5,130,3,130,21,130,26,130,3,130,6,130,3,130,10,130,3,130,3,130,20,130,5,130,5,130,0,0,0,0,0,0,0,0,0,0,36,64,0,0,0,0,0,0,89,64,0,0,0,0,0,136,195,64,0,0,0,0,132,215,151,65,0,128,224,55,121,195,65,67,23,110,5,181,181,184,147,70,245,249,63,233,3,79,56,77,50,29,48,249,72,119,130,90,60,191,115,127,221,79,21,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,45,228,32,0,30,0,171,0,32,0,30,0,171,0,32,0,30,0,171,0,76,0,65,0,228,0,54,0,119,228,32,0,32,0,42,0,42,0,42,0,42,0,32,0,67,0,79,0,77,0,77,0,79,0,68,0,79,0,82,0,69,0,32,0,54,0,52,0,32,0,66,0,65,0,83,0,73,0,67,0,32,0,86,0,50,0,32,0,42,0,42,0,42,0,42,0,13,0,13,0,32,0,54,0,52,0,75,0,32,0,82,0,65,0,77,0,32,0,83,0,89,0,83,0,84,0,69,0,77,0,32,0,32,0,0,0,92,0,32,0,32,0,42,0,42,0,42,0,42,0,32,0,67,0,79,0,77,0,77,0,79,0,68,0,79,0,82,0,69,0,32,0,54,0,52,0,32,0,66,0,65,0,83,0,73,0,67,0,32,0,86,0,50,0,32,0,42,0,42,0,42,0,42,0,13,0,13,0,32,0,54,0,52,0,75,0,32,0,82,0,65,0,77,0,32,0,83,0,89,0,83,0,84,0,69,0,77,0,32,0,32,0,0,0,129,0,32,0,32,0,32,0,42,0,42,0,42,0,42,0,42,0,32,0,32,0,83,0,88,0,45,0,54,0,52,0,32,0,66,0,65,0,83,0,73,0,67,0,32,0,86,0,50,0,46,0,48,0,32,0,32,0,42,0,42,0,42,0,42,0,42,0,13,0,13,0,32,0,54,0,52,0,75,0,32,0,82,0,65,0,77,0,32,0,83,0,89,0,83,0,84,0,69,0,77,0,32,0,32,0,0,0,179,0,42,0,42,0,42,0,42,0,32,0,67,0,79,0,77,0,77,0,79,0,68,0,79,0,82,0,69,0,32,0,52,0,48,0,54,0,52,0,32,0,32,0,66,0,65,0,83,0,73,0,67,0,32,0,86,0,50,0,46,0,48,0,32,0,42,0,42,0,42,0,42,0,13,0,13,0,0,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,32,0,99,0,21,0,200,228,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,173,0,33,0,208,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,133,0,169,0,169,0,1,0,133,0,171,0,96,0,173,0,134,0,2,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,170,0,133,0,169,0,169,0,1,0,133,0,171,0,96,0,173,0,134,0,2,0,44,0,134,0,2,0,48,0,10,0,169,0,0,0,162,0,14,0,157,0,32,0,208,0,202,0,16,0,250,0,76,0,135,0,234,0,173,0,33,0,208,0,1,0,53,229,14,0,14,0,6,0,1,0,30,0,124,229,181,0,217,0,41,0,3,0,13,0,136,0,2,0,133,0,210,0,189,0,240,0,236,0,133,0,209,0,169,0,39,0,232,0,180,0,217,0,48,0,6,0,24,0,105,0,40,0,232,0,16,0,246,0,133,0,213,0,96,0,32,0,240,0,233,0,169,0,39,0,232,0,180,0,217,0,48,0,6,0,24,0,105,0,40,0,232,0,16,0,246,0,133,0,213,0,76,0,36,0,234,0,228,0,201,0,240,0,3,0,76,0,237,0,230,0,96,0,234,0,32,0,240,0,233,0,169,0,39,0,232,0,180,0,217,0,48,0,6,0,24,0,105,0,40,0,232,0,16,0,246,0,133,0,213,0,76,0,36,0,234,0,228,0,201,0,240,0,3,0,76,0,237,0,230,0,96,0,234,0,32,0,240,0,233,0,169,0,39,0,232,0,180,0,217,0,48,0,6,0,24,0,105,0,40,0,232,0,16,0,246,0,133,0,213,0,76,0,36,0,234,0,228,0,201,0,240,0,3,0,76,0,237,0,230,0,96,0,234,0,1,0,239,229,9,0,9,0,15,0,9,0,2,0,244,229,230,0,236,0,230,0,236,0,215,0,240,0,230,0,236,0,2,0,34,230,237,0,230,0,145,0,229,0,145,0,229,0,145,0,229,0,12,0,7,234,169,0,32,0,145,0,209,0,32,0,218,0,228,0,234,0,136,0,16,0,245,0,96,0,32,0,218,0,228,0,169,0,32,0,145,0,209,0,136,0,16,0,246,0,96,0,234,0,32,0,218,0,228,0,169,0,32,0,145,0,209,0,136,0,16,0,246,0,96,0,234,0,169,0,32,0,145,0,209,0,32,0,218,0,228,0,234,0,136,0,16,0,245,0,96,0,14,0,217,236,14,0,6,0,1,0,2,0,3,0,4,0,0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,14,0,6,0,1,0,2,0,3,0,4,0,0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,3,0,1,0,1,0,2,0,3,0,4,0,0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,148,239,133,0,169,0,96,0,76,0,211,0,228,0,76,0,211,0,228,0,133,0,169,0,96,0,15,0,216,240,13,0,80,0,82,0,69,0,83,0,83,0,32,0,80,0,76,0,65,0,89,0,32,0,79,0,78,0,32,0,13,0,80,0,82,0,69,0,83,0,83,0,32,0,80,0,76,0,65,0,89,0,32,0,79,0,78,0,32,0,76,0,79,0,65,0,68,0,34,0,58,0,42,0,34,0,44,0,56,0,13,0,82,0,85,0,78,0,13,0,13,0,80,0,82,0,69,0,83,0,83,0,32,0,80,0,76,0,65,0,89,0,32,0,79,0,78,0,32,0,1,0,135,243,3,0,3,0,8,0,3,0,1,0,183,244,123,0,123,0,247,0,123,0,1,0,249,245,95,0,95,0,247,0,95,0,1,0,31,248,47,0,47,0,47,0,43,0,1,0,44,248,47,0,47,0,47,0,43,0,1,0,128,255,0,0,3,0,67,0,100,0,2,0,248,255,66,0,89,0,66,0,89,0,66,0,89,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,16,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,208,0,0,0,224,0,0,0,0,0,0,0,15,0,0,0,127,0,0,0,159,0,0,0,191,0,0,0,207,0,0,0,223,0,0,0,255,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,67,54,52,0,0,0,0,0,216,95,1,0,232,93,1,0,192,78,1,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,128,74,13,0,0,75,1,0,160,67,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,15,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,159,0,0,253,127,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,159,0,0,253,255,0,0,253,207,0,0,253,159,0,0,255,255,255,255,253,255,0,0,253,207,0,0,253,159,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,253,159,0,0,255,255,255,255,253,255,0,0,253,207,0,0,253,159,0,0,255,255,255,255,253,255,0,0,253,207,0,0,253,207,0,0,253,191,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,191,0,0,253,255,0,0,253,207,0,0,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,253,255,0,0,253,207,0,0,253,207,0,0,253,207,0,0,253,255,0,0,253,223,0,0,253,223,0,0,253,223,0,0,253,255,0,0,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,223,0,0,253,223,0,0,253,223,0,0,253,255,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,223,0,0,253,223,0,0,253,223,0,0,253,255,0,0,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,253,255,0,0,254,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,70,79,82,77,115,115,115,115,56,83,86,88,86,72,68,82,0,0,0,20,111,111,111,111,0,0,0,0,0,0,0,0,114,114,1,0,0,1,0,0,67,72,65,78,0,0,0,4,0,0,0,6,66,79,68,89,115,115,115,115,0,0,0,0,70,79,82,77,115,115,115,115,56,83,86,88,86,72,68,82,0,0,0,20,111,111,111,111,0,0,0,0,0,0,0,0,114,114,1,0,0,1,0,0,66,79,68,89,115,115,115,115,152,85,1,0,26,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,160,85,1,0,64,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,35,32,86,105,99,101,32,102,108,105,112,108,105,115,116,32,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,104,0,0,0,44,0,0,0,110,0,0,0,52,0,0,0,66,0,0,0,156,0,0,0,24,0,0,0,144,0,0,0,226,0,0,0,176,0,0,0,158,0,0,0,0,0,0,0,248,73,1,0,8,73,1,0,48,72,1,0,144,71,1,0,216,70,1,0,72,70,1,0,184,68,1,0,48,68,1,0,152,67,1,0,64,67,1,0,96,66,1,0,144,65,1,0,16,65,1,0,216,64,1,0,56,64,1,0,0,0,0,0,0,0,0,48,0,0,0,28,0,0,0,14,0,0,0,8,0,0,0,4,0,0,0,0,254,255,255,255,0,0,0,0,232,85,1,0,62,0,0,0,164,0,0,0,64,0,0,0,116,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,160,81,1,0,44,0,0,0,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,47,1,0,56,80,1,0,0,71,1,0,64,64,1,0,96,59,1,0,160,55,1,0,160,55,1,0,160,55,1,0,88,52,1,0,48,50,1,0,104,48,1,0,104,46,1,0,24,94,1,0,168,90,1,0,160,55,1,0,160,55,1,0,64,89,1,0,104,87,1,0,216,85,1,0,136,84,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,48,86,1,0,99,0,0,0,2,0,0,0,1,0,0,0,112,245,6,0,96,0,0,0,0,0,0,0,232,51,1,0,1,0,0,0,1,0,0,0,0,0,0,0,104,245,6,0,128,0,0,0,0,0,0,0,248,91,1,0,99,0,0,0,1,0,0,0,0,0,0,0,96,245,6,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,111,54,53,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,160,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,160,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,148,227,123,227,67,66,77,66,65,83,73,67,48,168,65,167,29,173,247,168,164,171,190,171,128,176,5,172,164,169,159,168,112,168,39,169,28,168,130,168,209,168,58,169,46,168,74,169,44,184,103,225,85,225,100,225,178,179,35,184,127,170,159,170,86,168,155,166,93,166,133,170,41,225,189,225,198,225,122,171,65,166,57,188,204,188,88,188,16,3,125,179,158,179,113,191,151,224,234,185,237,191,100,226,107,226,180,226,14,227,13,184,124,183,101,180,173,183,139,183,236,182,0,183,44,183,55,183,121,105,184,121,82,184,123,42,186,123,17,187,127,122,191,80,232,175,70,229,175,125,179,191,90,211,174,100,21,176,69,78,196,70,79,210,78,69,88,212,68,65,84,193,73,78,80,85,84,163,73,78,80,85,212,68,73,205,82,69,65,196,76,69,212,71,79,84,207,82,85,206,73,198,82,69,83,84,79,82,197,71,79,83,85,194,82,69,84,85,82,206,82,69,205,83,84,79,208,79,206,87,65,73,212,76,79,65,196,83,65,86,197,86,69,82,73,70,217,68,69,198,80,79,75,197,80,82,73,78,84,163,80,82,73,78,212,67,79,78,212,76,73,83,212,67,76,210,67,77,196,83,89,211,79,80,69,206,67,76,79,83,197,71,69,212,78,69,215,84,65,66,168,84,207,70,206,83,80,67,168,84,72,69,206,78,79,212,83,84,69,208,171,173,170,175,222,65,78,196,79,210,190,189,188,83,71,206,73,78,212,65,66,211,85,83,210,70,82,197,80,79,211,83,81,210,82,78,196,76,79,199,69,88,208,67,79,211,83,73,206,84,65,206,65,84,206,80,69,69,203,76,69,206,83,84,82,164,86,65,204,65,83,195,67,72,82,164,76,69,70,84,164,82,73,71,72,84,164,77,73,68,164,71,207,0,84,79,79,32,77,65,78,89,32,70,73,76,69,211,70,73,76,69,32,79,80,69,206,70,73,76,69,32,78,79,84,32,79,80,69,206,70,73,76,69,32,78,79,84,32,70,79,85,78,196,68,69,86,73,67,69,32,78,79,84,32,80,82,69,83,69,78,212,78,79,84,32,73,78,80,85,84,32,70,73,76,197,78,79,84,32,79,85,84,80,85,84,32,70,73,76,197,77,73,83,83,73,78,71,32,70,73,76,69,32,78,65,77,197,73,76,76,69,71,65,76,32,68,69,86,73,67,69,32,78,85,77,66,69,210,78,69,88,84,32,87,73,84,72,79,85,84,32,70,79,210,83,89,78,84,65,216,82,69,84,85,82,78,32,87,73,84,72,79,85,84,32,71,79,83,85,194,79,85,84,32,79,70,32,68,65,84,193,73,76,76,69,71,65,76,32,81,85,65,78,84,73,84,217,79,86,69,82,70,76,79,215,79,85,84,32,79,70,32,77,69,77,79,82,217,85,78,68,69,70,39,68,32,83,84,65,84,69,77,69,78,212,66,65,68,32,83,85,66,83,67,82,73,80,212,82,69,68,73,77,39,68,32,65,82,82,65,217,68,73,86,73,83,73,79,78,32,66,89,32,90,69,82,207,73,76,76,69,71,65,76,32,68,73,82,69,67,212,84,89,80,69,32,77,73,83,77,65,84,67,200,83,84,82,73,78,71,32,84,79,79,32,76,79,78,199,70,73,76,69,32,68,65,84,193,70,79,82,77,85,76,65,32,84,79,79,32,67,79,77,80,76,69,216,67,65,78,39,84,32,67,79,78,84,73,78,85,197,85,78,68,69,70,39,68,32,70,85,78,67,84,73,79,206,86,69,82,73,70,217,76,79,65,196,158,161,172,161,181,161,194,161,208,161,226,161,240,161,255,161,16,162,37,162,53,162,59,162,79,162,90,162,106,162,114,162,127,162,144,162,157,162,170,162,186,162,200,162,213,162,228,162,237,162,0,163,14,163,30,163,36,163,131,163,13,79,75,13,0,32,32,69,82,82,79,82,0,32,73,78,32,0,13,10,82,69,65,68,89,46,13,10,0,13,10,66,82,69,65,75,0,160,186,232,232,232,232,189,1,1,201,129,208,33,165,74,208,10,189,2,1,133,73,189,3,1,133,74,221,3,1,208,7,165,73,221,2,1,240,7,138,24,105,18,170,208,216,96,32,8,164,133,49,132,50,56,165,90,229,95,133,34,168,165,91,229,96,170,232,152,240,35,165,90,56,229,34,133,90,176,3,198,91,56,165,88,229,34,133,88,176,8,198,89,144,4,177,90,145,88,136,208,249,177,90,145,88,198,91,198,89,202,208,242,96,10,105,62,176,53,133,34,186,228,34,144,46,96,196,52,144,40,208,4,197,51,144,34,72,162,9,152,72,181,87,202,16,250,32,38,181,162,247,104,149,97,232,48,250,104,168,104,196,52,144,6,208,5,197,51,176,1,96,162,16,108,0,3,138,10,170,189,38,163,133,34,189,39,163,133,35,32,204,255,169,0,133,19,32,215,170,32,69,171,160,0,177,34,72,41,127,32,71,171,200,104,16,244,32,122,166,169,105,160,163,32,30,171,164,58,200,240,3,32,194,189,169,118,160,163,32,30,171,169,128,32,144,255,108,2,3,32,96,165,134,122,132,123,32,115,0,170,240,240,162,255,134,58,144,6,32,121,165,76,225,167,32,107,169,32,121,165,132,11,32,19,166,144,68,160,1,177,95,133,35,165,45,133,34,165,96,133,37,165,95,136,241,95,24,101,45,133,45,133,36,165,46,105,255,133,46,229,96,170,56,165,95,229,45,168,176,3,232,198,37,24,101,34,144,3,198,35,24,177,34,145,36,200,208,249,230,35,230,37,202,208,242,32,89,166,32,51,165,173,0,2,240,136,24,165,45,133,90,101,11,133,88,164,46,132,91,144,1,200,132,89,32,184,163,165,20,164,21,141,254,1,140,255,1,165,49,164,50,133,45,132,46,164,11,136,185,252,1,145,95,136,16,248,32,89,166,32,51,165,76,128,164,165,43,164,44,133,34,132,35,24,160,1,177,34,240,29,160,4,200,177,34,208,251,200,152,101,34,170,160,0,145,34,165,35,105,0,200,145,34,134,34,133,35,144,221,96,162,0,32,18,225,201,13,240,13,157,0,2,232,224,89,144,241,162,23,76,55,164,76,202,170,108,4,3,166,122,160,4,132,15,189,0,2,16,7,201,255,240,62,232,208,244,201,32,240,55,133,8,201,34,240,86,36,15,112,45,201,63,208,4,169,153,208,37,201,48,144,4,201,60,144,29,132,113,160,0,132,11,136,134,122,202,200,232,189,0,2,56,249,158,160,240,245,201,128,208,48,5,11,164,113,232,200,153,251,1,185,251,1,240,54,56,233,58,240,4,201,73,208,2,133,15,56,233,85,208,159,133,8,189,0,2,240,223,197,8,240,219,200,153,251,1,232,208,240,166,122,230,11,200,185,157,160,16,250,185,158,160,208,180,189,0,2,16,190,153,253,1,198,123,169,255,133,122,96,165,43,166,44,160,1,133,95,134,96,177,95,240,31,200,200,165,21,209,95,144,24,240,3,136,208,9,165,20,136,209,95,144,12,240,10,136,177,95,170,136,177,95,176,215,24,96,208,253,169,0,168,145,43,200,145,43,165,43,24,105,2,133,45,165,44,105,0,133,46,32,142,166,169,0,208,45,32,231,255,165,55,164,56,133,51,132,52,165,45,164,46,133,47,132,48,133,49,132,50,32,29,168,162,25,134,22,104,168,104,162,250,154,72,152,72,169,0,133,62,133,16,96,24,165,43,105,255,133,122,165,44,105,255,133,123,96,144,6,240,4,201,171,208,233,32,107,169,32,19,166,32,121,0,240,12,201,171,208,142,32,115,0,32,107,169,208,134,104,104,165,20,5,21,208,6,169,255,133,20,133,21,160,1,132,15,177,95,240,67,32,44,168,32,215,170,200,177,95,170,200,177,95,197,21,208,4,228,20,240,2,176,44,132,73,32,205,189,169,32,164,73,41,127,32,71,171,201,34,208,6,165,15,73,255,133,15,200,240,17,177,95,208,16,168,177,95,170,200,177,95,134,95,133,96,208,181,76,134,227,108,6,3,16,215,201,255,240,211,36,15,48,207,56,233,127,170,132,73,160,255,202,240,8,200,185,158,160,16,250,48,245,200,185,158,160,48,178,32,71,171,208,245,169,128,133,16,32,165,169,32,138,163,208,5,138,105,15,170,154,104,104,169,9,32,251,163,32,6,169,24,152,101,122,72,165,123,105,0,72,165,58,72,165,57,72,169,164,32,255,174,32,141,173,32,138,173,165,102,9,127,37,98,133,98,169,139,160,167,133,34,132,35,76,67,174,169,188,160,185,32,162,187,32,121,0,201,169,208,6,32,115,0,32,138,173,32,43,188,32,56,174,165,74,72,165,73,72,169,129,72,32,44,168,165,122,164,123,192,2,234,240,4,133,61,132,62,160,0,177,122,208,67,160,2,177,122,24,208,3,76,75,168,200,177,122,133,57,200,177,122,133,58,152,101,122,133,122,144,2,230,123,108,8,3,32,115,0,32,237,167,76,174,167,240,60,233,128,144,17,201,35,176,23,10,168,185,13,160,72,185,12,160,72,76,115,0,76,165,169,201,58,240,214,76,8,175,201,75,208,249,32,115,0,169,164,32,255,174,76,160,168,56,165,43,233,1,164,44,176,1,136,133,65,132,66,96,32,225,255,176,1,24,208,60,165,122,164,123,166,58,232,240,12,133,61,132,62,165,57,164,58,133,59,132,60,104,104,169,129,160,163,144,3,76,105,164,76,134,227,208,23,162,26,164,62,208,3,76,55,164,165,61,133,122,132,123,165,59,164,60,133,57,132,58,96,8,169,0,32,144,255,40,208,3,76,89,166,32,96,166,76,151,168,169,3,32,251,163,165,123,72,165,122,72,165,58,72,165,57,72,169,141,72,32,121,0,32,160,168,76,174,167,32,107,169,32,9,169,56,165,57,229,20,165,58,229,21,176,11,152,56,101,122,166,123,144,7,232,176,4,165,43,166,44,32,23,166,144,30,165,95,233,1,133,122,165,96,233,0,133,123,96,208,253,169,255,133,74,32,138,163,154,201,141,240,11,162,12,44,162,17,76,55,164,76,8,175,104,104,133,57,104,133,58,104,133,122,104,133,123,32,6,169,152,24,101,122,133,122,144,2,230,123,96,162,58,44,162,0,134,7,160,0,132,8,165,8,166,7,133,7,134,8,177,122,240,232,197,8,240,228,200,201,34,208,243,240,233,32,158,173,32,121,0,201,137,240,5,169,167,32,255,174,165,97,208,5,32,9,169,240,187,32,121,0,176,3,76,160,168,76,237,167,32,158,183,72,201,141,240,4,201,137,208,145,198,101,208,4,104,76,239,167,32,115,0,32,107,169,201,44,240,238,104,96,162,0,134,20,134,21,176,247,233,47,133,7,165,21,133,34,201,25,176,212,165,20,10,38,34,10,38,34,101,20,133,20,165,34,101,21,133,21,6,20,38,21,165,20,101,7,133,20,144,2,230,21,32,115,0,76,113,169,32,139,176,133,73,132,74,169,178,32,255,174,165,14,72,165,13,72,32,158,173,104,42,32,144,173,208,24,104,16,18,32,27,188,32,191,177,160,0,165,100,145,73,200,165,101,145,73,96,76,208,187,104,164,74,192,191,208,76,32,166,182,201,6,208,61,160,0,132,97,132,102,132,113,32,29,170,32,226,186,230,113,164,113,32,29,170,32,12,188,170,240,5,232,138,32,237,186,164,113,200,192,6,208,223,32,226,186,32,155,188,166,100,164,99,165,101,76,219,255,177,34,32,128,0,144,3,76,72,178,233,47,76,126,189,160,2,177,100,197,52,144,23,208,7,136,177,100,197,51,144,14,164,101,196,46,144,8,208,13,165,100,197,45,176,7,165,100,164,101,76,104,170,160,0,177,100,32,117,180,165,80,164,81,133,111,132,112,32,122,182,169,97,160,0,133,80,132,81,32,219,182,160,0,177,80,145,73,200,177,80,145,73,200,177,80,145,73,96,32,134,170,76,181,171,32,158,183,240,5,169,44,32,255,174,8,134,19,32,24,225,40,76,160,170,32,33,171,32,121,0,240,53,240,67,201,163,240,80,201,166,24,240,75,201,44,240,55,201,59,240,94,32,158,173,36,13,48,222,32,221,189,32,135,180,32,33,171,32,59,171,208,211,169,0,157,0,2,162,255,160,1,165,19,208,16,169,13,32,71,171,36,19,16,5,169,10,32,71,171,73,255,96,56,32,240,255,152,56,233,10,176,252,73,255,105,1,208,22,8,56,32,240,255,132,9,32,155,183,201,41,208,89,40,144,6,138,229,9,144,5,170,232,202,208,6,32,115,0,76,162,170,32,59,171,208,242,32,135,180,32,166,182,170,160,0,232,202,240,188,177,34,32,71,171,200,201,13,208,243,32,229,170,76,40,171,165,19,240,3,169,32,44,169,29,44,169,63,32,12,225,41,255,96,165,17,240,17,48,4,160,255,208,4,165,63,164,64,133,57,132,58,76,8,175,165,19,240,5,162,24,76,55,164,169,12,160,173,32,30,171,165,61,164,62,133,122,132,123,96,32,166,179,201,35,208,16,32,115,0,32,158,183,169,44,32,255,174,134,19,32,30,225,162,1,160,2,169,0,141,1,2,169,64,32,15,172,166,19,208,19,96,32,158,183,169,44,32,255,174,134,19,32,30,225,32,206,171,165,19,32,204,255,162,0,134,19,96,201,34,208,11,32,189,174,169,59,32,255,174,32,33,171,32,166,179,169,44,141,255,1,32,249,171,165,19,240,13,32,183,255,41,2,240,6,32,181,171,76,248,168,173,0,2,208,30,165,19,208,227,32,6,169,76,251,168,165,19,208,6,32,69,171,32,59,171,76,96,165,166,65,164,66,169,152,44,169,0,133,17,134,67,132,68,32,139,176,133,73,132,74,165,122,164,123,133,75,132,76,166,67,164,68,134,122,132,123,32,121,0,208,32,36,17,80,12,32,36,225,141,0,2,162,255,160,1,208,12,48,117,165,19,208,3,32,69,171,32,249,171,134,122,132,123,32,115,0,36,13,16,49,36,17,80,9,232,134,122,169,0,133,7,240,12,133,7,201,34,240,7,169,58,133,7,169,44,24,133,8,165,122,164,123,105,0,144,1,200,32,141,180,32,226,183,32,218,169,76,145,172,32,243,188,165,14,32,194,169,32,121,0,240,7,201,44,240,3,76,77,171,165,122,164,123,133,67,132,68,165,75,164,76,133,122,132,123,32,121,0,240,45,32,253,174,76,21,172,32,6,169,200,170,208,18,162,13,200,177,122,240,108,200,177,122,133,63,200,177,122,200,133,64,32,251,168,32,121,0,170,224,131,208,220,76,81,172,165,67,164,68,166,17,16,3,76,39,168,160,0,177,67,240,11,165,19,208,7,169,252,160,172,76,30,171,96,63,69,88,84,82,65,32,73,71,78,79,82,69,68,13,0,63,82,69,68,79,32,70,82,79,77,32,83,84,65,82,84,13,0,208,4,160,0,240,3,32,139,176,133,73,132,74,32,138,163,240,5,162,10,76,55,164,154,138,24,105,4,72,105,6,133,36,104,160,1,32,162,187,186,189,9,1,133,102,165,73,164,74,32,103,184,32,208,187,160,1,32,93,188,186,56,253,9,1,240,23,189,15,1,133,57,189,16,1,133,58,189,18,1,133,122,189,17,1,133,123,76,174,167,138,105,17,170,154,32,121,0,201,44,208,241,32,115,0,32,36,173,32,158,173,24,36,56,36,13,48,3,176,3,96,176,253,162,22,76,55,164,166,122,208,2,198,123,198,122,162,0,36,72,138,72,169,1,32,251,163,32,131,174,169,0,133,77,32,121,0,56,233,177,144,23,201,3,176,19,201,1,42,73,1,69,77,197,77,144,97,133,77,32,115,0,76,187,173,166,77,208,44,176,123,105,7,144,119,101,13,208,3,76,61,182,105,255,133,34,10,101,34,168,104,217,128,160,176,103,32,141,173,72,32,32,174,104,164,75,16,23,170,240,86,208,95,70,13,138,42,166,122,208,2,198,123,198,122,160,27,133,77,208,215,217,128,160,176,72,144,217,185,130,160,72,185,129,160,72,32,51,174,165,77,76,169,173,76,8,175,165,102,190,128,160,168,104,133,34,230,34,104,133,35,152,72,32,27,188,165,101,72,165,100,72,165,99,72,165,98,72,165,97,72,108,34,0,160,255,104,240,35,201,100,240,3,32,141,173,132,75,104,74,133,18,104,133,105,104,133,106,104,133,107,104,133,108,104,133,109,104,133,110,69,102,133,111,165,97,96,108,10,3,169,0,133,13,32,115,0,176,3,76,243,188,32,19,177,144,3,76,40,175,201,255,208,15,169,168,160,174,32,162,187,76,115,0,130,73,15,218,161,201,46,240,222,201,171,240,88,201,170,240,209,201,34,208,15,165,122,164,123,105,0,144,1,200,32,135,180,76,226,183,201,168,208,19,160,24,208,59,32,191,177,165,101,73,255,168,165,100,73,255,76,145,179,201,165,208,3,76,244,179,201,180,144,3,76,167,175,32,250,174,32,158,173,169,41,44,169,40,44,169,44,160,0,209,122,208,3,76,115,0,162,11,76,55,164,160,21,104,104,76,250,173,56,165,100,233,0,165,101,233,160,144,8,169,162,229,100,169,227,229,101,96,32,139,176,133,100,132,101,166,69,164,70,165,13,240,38,169,0,133,112,32,20,175,144,28,224,84,208,24,192,201,208,20,32,132,175,132,94,136,132,113,160,6,132,93,160,36,32,104,190,76,111,180,96,36,14,16,13,160,0,177,100,170,200,177,100,168,138,76,145,179,32,20,175,144,45,224,84,208,27,192,73,208,37,32,132,175,152,162,160,76,79,188,32,222,255,134,100,132,99,133,101,160,0,132,98,96,224,83,208,10,192,84,208,6,32,183,255,76,60,188,165,100,164,101,76,162,187,10,72,170,32,115,0,224,143,144,32,32,250,174,32,158,173,32,253,174,32,143,173,104,170,165,101,72,165,100,72,138,72,32,158,183,104,168,138,72,76,214,175,32,241,174,104,168,185,234,159,133,85,185,235,159,133,86,32,84,0,76,141,173,160,255,44,160,0,132,11,32,191,177,165,100,69,11,133,7,165,101,69,11,133,8,32,252,187,32,191,177,165,101,69,11,37,8,69,11,168,165,100,69,11,37,7,69,11,76,145,179,32,144,173,176,19,165,110,9,127,37,106,133,106,169,105,160,0,32,91,188,170,76,97,176,169,0,133,13,198,77,32,166,182,133,97,134,98,132,99,165,108,164,109,32,170,182,134,108,132,109,170,56,229,97,240,8,169,1,144,4,166,97,169,255,133,102,160,255,232,200,202,208,7,166,102,48,15,24,144,12,177,108,209,98,240,239,162,255,176,2,162,1,232,138,42,37,18,240,2,169,255,76,60,188,32,253,174,170,32,144,176,32,121,0,208,244,96,162,0,32,121,0,134,12,133,69,32,121,0,32,19,177,176,3,76,8,175,162,0,134,13,134,14,32,115,0,144,5,32,19,177,144,11,170,32,115,0,144,251,32,19,177,176,246,201,36,208,6,169,255,133,13,208,16,201,37,208,19,165,16,208,208,169,128,133,14,5,69,133,69,138,9,128,170,32,115,0,134,70,56,5,16,233,40,208,3,76,209,177,160,0,132,16,165,45,166,46,134,96,133,95,228,48,208,4,197,47,240,34,165,69,209,95,208,8,165,70,200,209,95,240,125,136,24,165,95,105,7,144,225,232,208,220,201,65,144,5,233,91,56,233,165,96,104,72,201,42,208,5,169,19,160,191,96,165,69,164,70,201,84,208,11,192,201,240,239,192,73,208,3,76,8,175,201,83,208,4,192,84,240,245,165,47,164,48,133,95,132,96,165,49,164,50,133,90,132,91,24,105,7,144,1,200,133,88,132,89,32,184,163,165,88,164,89,200,133,47,132,48,160,0,165,69,145,95,200,165,70,145,95,169,0,200,145,95,200,145,95,200,145,95,200,145,95,200,145,95,165,95,24,105,2,164,96,144,1,200,133,71,132,72,96,165,11,10,105,5,101,95,164,96,144,1,200,133,88,132,89,96,144,128,0,0,0,32,191,177,165,100,164,101,96,32,115,0,32,158,173,32,141,173,165,102,48,13,165,97,201,144,144,9,169,165,160,177,32,91,188,208,122,76,155,188,165,12,5,14,72,165,13,72,160,0,152,72,165,70,72,165,69,72,32,178,177,104,133,69,104,133,70,104,168,186,189,2,1,72,189,1,1,72,165,100,157,2,1,165,101,157,1,1,200,32,121,0,201,44,240,210,132,11,32,247,174,104,133,13,104,133,14,41,127,133,12,166,47,165,48,134,95,133,96,197,50,208,4,228,49,240,57,160,0,177,95,200,197,69,208,6,165,70,209,95,240,22,200,177,95,24,101,95,170,200,177,95,101,96,144,215,162,18,44,162,14,76,55,164,162,19,165,12,208,247,32,148,177,165,11,160,4,209,95,208,231,76,234,178,32,148,177,32,8,164,160,0,132,114,162,5,165,69,145,95,16,1,202,200,165,70,145])
.concat([95,16,2,202,202,134,113,165,11,200,200,200,145,95,162,11,169,0,36,12,80,8,104,24,105,1,170,104,105,0,200,145,95,200,138,145,95,32,76,179,134,113,133,114,164,34,198,11,208,220,101,89,176,93,133,89,168,138,101,88,144,3,200,240,82,32,8,164,133,49,132,50,169,0,230,114,164,113,240,5,136,145,88,208,251,198,89,198,114,208,245,230,89,56,165,49,229,95,160,2,145,95,165,50,200,229,96,145,95,165,12,208,98,200,177,95,133,11,169,0,133,113,133,114,200,104,170,133,100,104,133,101,209,95,144,14,208,6,200,138,209,95,144,7,76,69,178,76,53,164,200,165,114,5,113,24,240,10,32,76,179,138,101,100,170,152,164,34,101,101,134,113,198,11,208,202,133,114,162,5,165,69,16,1,202,165,70,16,2,202,202,134,40,169,0,32,85,179,138,101,88,133,71,152,101,89,133,72,168,165,71,96,132,34,177,95,133,40,136,177,95,133,41,169,16,133,93,162,0,160,0,138,10,170,152,42,168,176,164,6,113,38,114,144,11,24,138,101,40,170,152,101,41,168,176,147,198,93,208,227,96,165,13,240,3,32,166,182,32,38,181,56,165,51,229,49,168,165,52,229,50,162,0,134,13,133,98,132,99,162,144,76,68,188,56,32,240,255,169,0,240,235,166,58,232,208,160,162,21,44,162,27,76,55,164,32,225,179,32,166,179,32,250,174,169,128,133,16,32,139,176,32,141,173,32,247,174,169,178,32,255,174,72,165,72,72,165,71,72,165,123,72,165,122,72,32,248,168,76,79,180,169,165,32,255,174,9,128,133,16,32,146,176,133,78,132,79,76,141,173,32,225,179,165,79,72,165,78,72,32,241,174,32,141,173,104,133,78,104,133,79,160,2,177,78,133,71,170,200,177,78,240,153,133,72,200,177,71,72,136,16,250,164,72,32,212,187,165,123,72,165,122,72,177,78,133,122,200,177,78,133,123,165,72,72,165,71,72,32,138,173,104,133,78,104,133,79,32,121,0,240,3,76,8,175,104,133,122,104,133,123,160,0,104,145,78,104,200,145,78,104,200,145,78,104,200,145,78,104,200,145,78,96,32,141,173,160,0,32,223,189,104,104,169,255,160,0,240,18,166,100,164,101,134,80,132,81,32,244,180,134,98,132,99,133,97,96,162,34,134,7,134,8,133,111,132,112,133,98,132,99,160,255,200,177,111,240,12,197,7,240,4,197,8,208,243,201,34,240,1,24,132,97,152,101,111,133,113,166,112,144,1,232,134,114,165,112,240,4,201,2,208,11,152,32,117,180,166,111,164,112,32,136,182,166,22,224,34,208,5,162,25,76,55,164,165,97,149,0,165,98,149,1,165,99,149,2,160,0,134,100,132,101,132,112,136,132,13,134,23,232,232,232,134,22,96,70,15,72,73,255,56,101,51,164,52,176,1,136,196,50,144,17,208,4,197,49,144,11,133,51,132,52,133,53,132,54,170,104,96,162,16,165,15,48,182,32,38,181,169,128,133,15,104,208,208,166,55,165,56,134,51,133,52,160,0,132,79,132,78,165,49,166,50,133,95,134,96,169,25,162,0,133,34,134,35,197,22,240,5,32,199,181,240,247,169,7,133,83,165,45,166,46,133,34,134,35,228,48,208,4,197,47,240,5,32,189,181,240,243,133,88,134,89,169,3,133,83,165,88,166,89,228,50,208,7,197,49,208,3,76,6,182,133,34,134,35,160,0,177,34,170,200,177,34,8,200,177,34,101,88,133,88,200,177,34,101,89,133,89,40,16,211,138,48,208,200,177,34,160,0,10,105,5,101,34,133,34,144,2,230,35,166,35,228,89,208,4,197,88,240,186,32,199,181,240,243,177,34,48,53,200,177,34,16,48,200,177,34,240,43,200,177,34,170,200,177,34,197,52,144,6,208,30,228,51,176,26,197,96,144,22,208,4,228,95,144,16,134,95,133,96,165,34,166,35,133,78,134,79,165,83,133,85,165,83,24,101,34,133,34,144,2,230,35,166,35,160,0,96,165,79,5,78,240,245,165,85,41,4,74,168,133,85,177,78,101,95,133,90,165,96,105,0,133,91,165,51,166,52,133,88,134,89,32,191,163,164,85,200,165,88,145,78,170,230,89,165,89,200,145,78,76,42,181,165,101,72,165,100,72,32,131,174,32,143,173,104,133,111,104,133,112,160,0,177,111,24,113,100,144,5,162,23,76,55,164,32,117,180,32,122,182,165,80,164,81,32,170,182,32,140,182,165,111,164,112,32,170,182,32,202,180,76,184,173,160,0,177,111,72,200,177,111,170,200,177,111,168,104,134,34,132,35,168,240,10,72,136,177,34,145,53,152,208,248,104,24,101,53,133,53,144,2,230,54,96,32,143,173,165,100,164,101,133,34,132,35,32,219,182,8,160,0,177,34,72,200,177,34,170,200,177,34,168,104,40,208,19,196,52,208,15,228,51,208,11,72,24,101,51,133,51,144,2,230,52,104,134,34,132,35,96,196,24,208,12,197,23,208,8,133,22,233,3,133,23,160,0,96,32,161,183,138,72,169,1,32,125,180,104,160,0,145,98,104,104,76,202,180,32,97,183,209,80,152,144,4,177,80,170,152,72,138,72,32,125,180,165,80,164,81,32,170,182,104,168,104,24,101,34,133,34,144,2,230,35,152,32,140,182,76,202,180,32,97,183,24,241,80,73,255,76,6,183,169,255,133,101,32,121,0,201,41,240,6,32,253,174,32,158,183,32,97,183,240,75,202,138,72,24,162,0,241,80,176,182,73,255,197,101,144,177,165,101,176,173,32,247,174,104,168,104,133,85,104,104,104,170,104,133,80,104,133,81,165,85,72,152,72,160,0,138,96,32,130,183,76,162,179,32,163,182,162,0,134,13,168,96,32,130,183,240,8,160,0,177,34,168,76,162,179,76,72,178,32,115,0,32,138,173,32,184,177,166,100,208,240,166,101,76,121,0,32,130,183,208,3,76,247,184,166,122,164,123,134,113,132,114,166,34,134,122,24,101,34,133,36,166,35,134,123,144,1,232,134,37,160,0,177,36,72,152,145,36,32,121,0,32,243,188,104,160,0,145,36,166,113,164,114,134,122,132,123,96,32,138,173,32,247,183,32,253,174,76,158,183,165,102,48,157,165,97,201,145,176,151,32,155,188,165,100,164,101,132,20,133,21,96,165,21,72,165,20,72,32,247,183,160,0,177,20,168,104,133,20,104,133,21,76,162,179,32,235,183,138,160,0,145,20,96,32,235,183,134,73,162,0,32,121,0,240,3,32,241,183,134,74,160,0,177,20,69,74,37,73,240,248,96,169,17,160,191,76,103,184,32,140,186,165,102,73,255,133,102,69,110,133,111,165,97,76,106,184,32,153,185,144,60,32,140,186,208,3,76,252,187,166,112,134,86,162,105,165,105,168,240,206,56,229,97,240,36,144,18,132,97,164,110,132,102,73,255,105,0,160,0,132,86,162,97,208,4,160,0,132,112,201,249,48,199,168,165,112,86,1,32,176,185,36,111,16,87,160,97,224,105,240,2,160,105,56,73,255,101,86,133,112,185,4,0,245,4,133,101,185,3,0,245,3,133,100,185,2,0,245,2,133,99,185,1,0,245,1,133,98,176,3,32,71,185,160,0,152,24,166,98,208,74,166,99,134,98,166,100,134,99,166,101,134,100,166,112,134,101,132,112,105,8,201,32,208,228,169,0,133,97,133,102,96,101,86,133,112,165,101,101,109,133,101,165,100,101,108,133,100,165,99,101,107,133,99,165,98,101,106,133,98,76,54,185,105,1,6,112,38,101,38,100,38,99,38,98,16,242,56,229,97,176,199,73,255,105,1,133,97,144,14,230,97,240,66,102,98,102,99,102,100,102,101,102,112,96,165,102,73,255,133,102,165,98,73,255,133,98,165,99,73,255,133,99,165,100,73,255,133,100,165,101,73,255,133,101,165,112,73,255,133,112,230,112,208,14,230,101,208,10,230,100,208,6,230,99,208,2,230,98,96,162,15,76,55,164,162,37,180,4,132,112,180,3,148,4,180,2,148,3,180,1,148,2,164,104,148,1,105,8,48,232,240,230,233,8,168,165,112,176,20,22,1,144,2,246,1,118,1,118,1,118,2,118,3,118,4,106,200,208,236,24,96,129,0,0,0,0,3,127,94,86,203,121,128,19,155,11,100,128,118,56,147,22,130,56,170,59,32,128,53,4,243,52,129,53,4,243,52,128,128,0,0,0,128,49,114,23,248,32,43,188,240,2,16,3,76,72,178,165,97,233,127,72,169,128,133,97,169,214,160,185,32,103,184,169,219,160,185,32,15,187,169,188,160,185,32,80,184,169,193,160,185,32,67,224,169,224,160,185,32,103,184,104,32,126,189,169,229,160,185,32,140,186,208,3,76,139,186,32,183,186,169,0,133,38,133,39,133,40,133,41,165,112,32,89,186,165,101,32,89,186,165,100,32,89,186,165,99,32,89,186,165,98,32,94,186,76,143,187,208,3,76,131,185,74,9,128,168,144,25,24,165,41,101,109,133,41,165,40,101,108,133,40,165,39,101,107,133,39,165,38,101,106,133,38,102,38,102,39,102,40,102,41,102,112,152,74,208,214,96,133,34,132,35,160,4,177,34,133,109,136,177,34,133,108,136,177,34,133,107,136,177,34,133,110,69,102,133,111,165,110,9,128,133,106,136,177,34,133,105,165,97,96,165,105,240,31,24,101,97,144,4,48,29,24,44,16,20,105,128,133,97,208,3,76,251,184,165,111,133,102,96,165,102,73,255,48,5,104,104,76,247,184,76,126,185,32,12,188,170,240,16,24,105,2,176,242,162,0,134,111,32,119,184,230,97,240,231,96,132,32,0,0,0,32,12,188,169,249,160,186,162,0,134,111,32,162,187,76,18,187,32,140,186,240,118,32,27,188,169,0,56,229,97,133,97,32,183,186,230,97,240,186,162,252,169,1,164,106,196,98,208,16,164,107,196,99,208,10,164,108,196,100,208,4,164,109,196,101,8,42,144,9,232,149,41,240,50,16,52,169,1,40,176,14,6,109,38,108,38,107,38,106,176,230,48,206,16,226,168,165,109,229,101,133,109,165,108,229,100,133,108,165,107,229,99,133,107,165,106,229,98,133,106,152,76,79,187,169,64,208,206,10,10,10,10,10,10,133,112,40,76,143,187,162,20,76,55,164,165,38,133,98,165,39,133,99,165,40,133,100,165,41,133,101,76,215,184,133,34,132,35,160,4,177,34,133,101,136,177,34,133,100,136,177,34,133,99,136,177,34,133,102,9,128,133,98,136,177,34,133,97,132,112,96,162,92,44,162,87,160,0,240,4,166,73,164,74,32,27,188,134,34,132,35,160,4,165,101,145,34,136,165,100,145,34,136,165,99,145,34,136,165,102,9,127,37,98,145,34,136,165,97,145,34,132,112,96,165,110,133,102,162,5,181,104,149,96,202,208,249,134,112,96,32,27,188,162,6,181,96,149,104,202,208,249,134,112,96,165,97,240,251,6,112,144,247,32,111,185,208,242,76,56,185,165,97,240,9,165,102,42,169,255,176,2,169,1,96,32,43,188,133,98,169,0,133,99,162,136,165,98,73,255,42,169,0,133,101,133,100,134,97,133,112,133,102,76,210,184,70,102,96,133,36,132,37,160,0,177,36,200,170,240,196,177,36,69,102,48,194,228,97,208,33,177,36,9,128,197,98,208,25,200,177,36,197,99,208,18,200,177,36,197,100,208,11,200,169,127,197,112,177,36,229,101,240,40,165,102,144,2,73,255,76,49,188,165,97,240,74,56,233,160,36,102,16,9,170,169,255,133,104,32,77,185,138,162,97,201,249,16,6,32,153,185,132,104,96,168,165,102,41,128,70,98,5,98,133,98,32,176,185,132,104,96,165,97,201,160,176,32,32,155,188,132,112,165,102,132,102,73,128,42,169,160,133,97,165,101,133,7,76,210,184,133,98,133,99,133,100,133,101,168,96,160,0,162,10,148,93,202,16,251,144,15,201,45,208,4,134,103,240,4,201,43,208,5,32,115,0,144,91,201,46,240,46,201,69,208,48,32,115,0,144,23,201,171,240,14,201,45,240,10,201,170,240,8,201,43,240,4,208,7,102,96,32,115,0,144,92,36,96,16,14,169,0,56,229,94,76,73,189,102,95,36,95,80,195,165,94,56,229,93,133,94,240,18,16,9,32,254,186,230,94,208,249,240,7,32,226,186,198,94,208,249,165,103,48,1,96,76,180,191,72,36,95,16,2,230,93,32,226,186,104,56,233,48,32,126,189,76,10,189,72,32,12,188,104,32,60,188,165,110,69,102,133,111,166,97,76,106,184,165,94,201,10,144,9,169,100,36,96,48,17,76,126,185,10,10,24,101,94,10,24,160,0,113,122,56,233,48,133,94,76,48,189,155,62,188,31,253,158,110,107,39,253,158,110,107,40,0,169,113,160,163,32,218,189,165,58,166,57,133,98,134,99,162,144,56,32,73,188,32,223,189,76,30,171,160,1,169,32,36,102,16,2,169,45,153,255,0,133,102,132,113,200,169,48,166,97,208,3,76,4,191,169,0,224,128,240,2,176,9,169,189,160,189,32,40,186,169,247,133,93,169,184,160,189,32,91,188,240,30,16,18,169,179,160,189,32,91,188,240,2,16,14,32,226,186,198,93,208,238,32,254,186,230,93,208,220,32,73,184,32,155,188,162,1,165,93,24,105,10,48,9,201,11,176,6,105,255,170,169,2,56,233,2,133,94,134,93,138,240,2,16,19,164,113,169,46,200,153,255,0,138,240,6,169,48,200,153,255,0,132,113,160,0,162,128,165,101,24,121,25,191,133,101,165,100,121,24,191,133,100,165,99,121,23,191,133,99,165,98,121,22,191,133,98,232,176,4,16,222,48,2,48,218,138,144,4,73,255,105,10,105,47,200,200,200,200,132,71,164,113,200,170,41,127,153,255,0,198,93,208,6,169,46,200,153,255,0,132,113,164,71,138,73,255,41,128,170,192,36,240,4,192,60,208,166,164,113,185,255,0,136,201,48,240,248,201,46,240,1,200,169,43,166,94,240,46,16,8,169,0,56,229,94,170,169,45,153,1,1,169,69,153,0,1,138,162,47,56,232,233,10,176,251,105,58,153,3,1,138,153,2,1,169,0,153,4,1,240,8,153,255,0,169,0,153,0,1,169,0,160,1,96,128,0,0,0,0,250,10,31,0,0,152,150,128,255,240,189,192,0,1,134,160,255,255,216,240,0,0,3,232,255,255,255,156,0,0,0,10,255,255,255,255,255,223,10,128,0,3,75,192,255,255,115,96,0,0,14,16,255,255,253,168,0,0,0,60,236,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,32,12,188,169,17,160,191,32,162,187,240,112,165,105,208,3,76,249,184,162,78,160,0,32,212,187,165,110,16,15,32,204,188,169,78,160,0,32,91,188,208,3,152,164,7,32,254,187,152,72,32,234,185,169,78,160,0,32,40,186,32,237,191,104,74,144,10,165,97,240,6,165,102,73,255,133,102,96,129,56,170,59,41,7,113,52,88,62,86,116,22,126,179,27,119,47,238,227,133,122,29,132,28,42,124,99,89,88,10,126,117,253,231,198,128,49,114,24,16,129,0,0,0,0,169,191,160,191,32,40,186,165,112,105,80,144,3,32,35,188,76,0,224,60,102,110,110,96,98,60,0,24,60,102,126,102,102,102,0,124,102,102,124,102,102,124,0,60,102,96,96,96,102,60,0,120,108,102,102,102,108,120,0,126,96,96,120,96,96,126,0,126,96,96,120,96,96,96,0,60,102,96,110,102,102,60,0,102,102,102,126,102,102,102,0,60,24,24,24,24,24,60,0,30,12,12,12,12,108,56,0,102,108,120,112,120,108,102,0,96,96,96,96,96,96,126,0,99,119,127,107,99,99,99,0,102,118,126,126,110,102,102,0,60,102,102,102,102,102,60,0,124,102,102,124,96,96,96,0,60,102,102,102,102,60,14,0,124,102,102,124,120,108,102,0,60,102,96,60,6,102,60,0,126,24,24,24,24,24,24,0,102,102,102,102,102,102,60,0,102,102,102,102,102,60,24,0,99,99,99,107,127,119,99,0,102,102,60,24,60,102,102,0,102,102,102,60,24,24,24,0,126,6,12,24,48,96,126,0,60,48,48,48,48,48,60,0,12,18,48,124,48,98,252,0,60,12,12,12,12,12,60,0,0,24,60,126,24,24,24,24,0,16,48,127,127,48,16,0,0,0,0,0,0,0,0,0,24,24,24,24,0,0,24,0,102,102,102,0,0,0,0,0,102,102,255,102,255,102,102,0,24,62,96,60,6,124,24,0,98,102,12,24,48,102,70,0,60,102,60,56,103,102,63,0,6,12,24,0,0,0,0,0,12,24,48,48,48,24,12,0,48,24,12,12,12,24,48,0,0,102,60,255,60,102,0,0,0,24,24,126,24,24,0,0,0,0,0,0,0,24,24,48,0,0,0,126,0,0,0,0,0,0,0,0,0,24,24,0,0,3,6,12,24,48,96,0,60,102,110,118,102,102,60,0,24,24,56,24,24,24,126,0,60,102,6,12,48,96,126,0,60,102,6,28,6,102,60,0,6,14,30,102,127,6,6,0,126,96,124,6,6,102,60,0,60,102,96,124,102,102,60,0,126,102,12,24,24,24,24,0,60,102,102,60,102,102,60,0,60,102,102,62,6,102,60,0,0,0,24,0,0,24,0,0,0,0,24,0,0,24,24,48,14,24,48,96,48,24,14,0,0,0,126,0,126,0,0,0,112,24,12,6,12,24,112,0,60,102,6,12,24,0,24,0,0,0,0,255,255,0,0,0,8,28,62,127,127,28,62,0,24,24,24,24,24,24,24,24,0,0,0,255,255,0,0,0,0,0,255,255,0,0,0,0,0,255,255,0,0,0,0,0,0,0,0,0,255,255,0,0,48,48,48,48,48,48,48,48,12,12,12,12,12,12,12,12,0,0,0,224,240,56,24,24,24,24,28,15,7,0,0,0,24,24,56,240,224,0,0,0,192,192,192,192,192,192,255,255,192,224,112,56,28,14,7,3,3,7,14,28,56,112,224,192,255,255,192,192,192,192,192,192,255,255,3,3,3,3,3,3,0,60,126,126,126,126,60,0,0,0,0,0,0,255,255,0,54,127,127,127,62,28,8,0,96,96,96,96,96,96,96,96,0,0,0,7,15,28,24,24,195,231,126,60,60,126,231,195,0,60,126,102,102,126,60,0,24,24,102,102,24,24,60,0,6,6,6,6,6,6,6,6,8,28,62,127,62,28,8,0,24,24,24,255,255,24,24,24,192,192,48,48,192,192,48,48,24,24,24,24,24,24,24,24,0,0,3,62,118,54,54,0,255,127,63,31,15,7,3,1,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,192,192,192,192,192,192,192,192,204,204,51,51,204,204,51,51,3,3,3,3,3,3,3,3,0,0,0,0,204,204,51,51,255,254,252,248,240,224,192,128,3,3,3,3,3,3,3,3,24,24,24,31,31,24,24,24,0,0,0,0,15,15,15,15,24,24,24,31,31,0,0,0,0,0,0,248,248,24,24,24,0,0,0,0,0,0,255,255,0,0,0,31,31,24,24,24,24,24,24,255,255,0,0,0,0,0,0,255,255,24,24,24,24,24,24,248,248,24,24,24,192,192,192,192,192,192,192,192,224,224,224,224,224,224,224,224,7,7,7,7,7,7,7,7,255,255,0,0,0,0,0,0,255,255,255,0,0,0,0,0,0,0,0,0,0,255,255,255,3,3,3,3,3,3,255,255,0,0,0,0,240,240,240,240,15,15,15,15,0,0,0,0,24,24,24,248,248,0,0,0,240,240,240,240,0,0,0,0,240,240,240,240,15,15,15,15,195,153,145,145,159,153,195,255,231,195,153,129,153,153,153,255,131,153,153,131,153,153,131,255,195,153,159,159,159,153,195,255,135,147,153,153,153,147,135,255,129,159,159,135,159,159,129,255,129,159,159,135,159,159,159,255,195,153,159,145,153,153,195,255,153,153,153,129,153,153,153,255,195,231,231,231,231,231,195,255,225,243,243,243,243,147,199,255,153,147,135,143,135,147,153,255,159,159,159,159,159,159,129,255,156,136,128,148,156,156,156,255,153,137,129,129,145,153,153,255,195,153,153,153,153,153,195,255,131,153,153,131,159,159,159,255,195,153,153,153,153,195,241,255,131,153,153,131,135,147,153,255,195,153,159,195,249,153,195,255,129,231,231,231,231,231,231,255,153,153,153,153,153,153,195,255,153,153,153,153,153,195,231,255,156,156,156,148,128,136,156,255,153,153,195,231,195,153,153,255,153,153,153,195,231,231,231,255,129,249,243,231,207,159,129,255,195,207,207,207,207,207,195,255,243,237,207,131,207,157,3,255,195,243,243,243,243,243,195,255,255,231,195,129,231,231,231,231,255,239,207,128,128,207,239,255,255,255,255,255,255,255,255,255,231,231,231,231,255,255,231,255,153,153,153,255,255,255,255,255,153,153,0,153,0,153,153,255,231,193,159,195,249,131,231,255,157,153,243,231,207,153,185,255,195,153,195,199,152,153,192,255,249,243,231,255,255,255,255,255,243,231,207,207,207,231,243,255,207,231,243,243,243,231,207,255,255,153,195,0,195,153,255,255,255,231,231,129,231,231,255,255,255,255,255,255,255,231,231,207,255,255,255,129,255,255,255,255,255,255,255,255,255,231,231,255,255,252,249,243,231,207,159,255,195,153,145,137,153,153,195,255,231,231,199,231,231,231,129,255,195,153,249,243,207,159,129,255,195,153,249,227,249,153,195,255,249,241,225,153,128,249,249,255,129,159,131,249,249,153,195,255,195,153,159,131,153,153,195,255,129,153,243,231,231,231,231,255,195,153,153,195,153,153,195,255,195,153,153,193,249,153,195,255,255,255,231,255,255,231,255,255,255,255,231,255,255,231,231,207,241,231,207,159,207,231,241,255,255,255,129,255,129,255,255,255,143,231,243,249,243,231,143,255,195,153,249,243,231,255,231,255,255,255,255,0,0,255,255,255,247,227,193,128,128,227,193,255,231,231,231,231,231,231,231,231,255,255,255,0,0,255,255,255,255,255,0,0,255,255,255,255,255,0,0,255,255,255,255,255,255,255,255,255,0,0,255,255,207,207,207,207,207,207,207,207,243,243,243,243,243,243,243,243,255,255,255,31,15,199,231,231,231,231,227,240,248,255,255,255,231,231,199,15,31,255,255,255,63,63,63,63,63,63,0,0,63,31,143,199,227,241,248,252,252,248,241,227,199,143,31,63,0,0,63,63,63,63,63,63,0,0,252,252,252,252,252,252,255,195,129,129,129,129,195,255,255,255,255,255,255,0,0,255,201,128,128,128,193,227,247,255,159,159,159,159,159,159,159,159,255,255,255,248,240,227,231,231,60,24,129,195,195,129,24,60,255,195,129,153,153,129,195,255,231,231,153,153,231,231,195,255,249,249,249,249,249,249,249,249,247,227,193,128,193,227,247,255,231,231,231,0,0,231,231,231,63,63,207,207,63,63,207,207,231,231,231,231,231,231,231,231,255,255,252,193,137,201,201,255,0,128,192,224,240,248,252,254,255,255,255,255,255,255,255,255,15,15,15,15,15,15,15,15,255,255,255,255,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,63,63,63,63,63,63,63,63,51,51,204,204,51,51,204,204,252,252,252,252,252,252,252,252,255,255,255,255,51,51,204,204,0,1,3,7,15,31,63,127,252,252,252,252,252,252,252,252,231,231,231,224,224,231,231,231,255,255,255,255,240,240,240,240,231,231,231,224,224,255,255,255,255,255,255,7,7,231,231,231,255,255,255,255,255,255,0,0,255,255,255,224,224,231,231,231,231,231,231,0,0,255,255,255,255,255,255,0,0,231,231,231,231,231,231,7,7,231,231,231,63,63,63,63,63,63,63,63,31,31,31,31,31,31,31,31,248,248,248,248,248,248,248,248,0,0,255,255,255,255,255,255,0,0,0,255,255,255,255,255,255,255,255,255,255,0,0,0,252,252,252,252,252,252,0,0,255,255,255,255,15,15,15,15,240,240,240,240,255,255,255,255,231,231,231,7,7,255,255,255,15,15,15,15,255,255,255,255,15,15,15,15,240,240,240,240,60,102,110,110,96,98,60,0,0,0,60,6,62,102,62,0,0,96,96,124,102,102,124,0,0,0,60,96,96,96,60,0,0,6,6,62,102,102,62,0,0,0,60,102,126,96,60,0,0,14,24,62,24,24,24,0,0,0,62,102,102,62,6,124,0,96,96,124,102,102,102,0,0,24,0,56,24,24,60,0,0,6,0,6,6,6,6,60,0,96,96,108,120,108,102,0,0,56,24,24,24,24,60,0,0,0,102,127,127,107,99,0,0,0,124,102,102,102,102,0,0,0,60,102,102,102,60,0,0,0,124,102,102,124,96,96,0,0,62,102,102,62,6,6,0,0,124,102,96,96,96,0,0,0,62,96,60,6,124,0,0,24,126,24,24,24,14,0,0,0,102,102,102,102,62,0,0,0,102,102,102,60,24,0,0,0,99,107,127,62,54,0,0,0,102,60,24,60,102,0,0,0,102,102,102,62,12,120,0,0,126,12,24,48,126,0,60,48,48,48,48,48,60,0,12,18,48,124,48,98,252,0,60,12,12,12,12,12,60,0,0,24,60,126,24,24,24,24,0,16,48,127,127,48,16,0,0,0,0,0,0,0,0,0,24,24,24,24,0,0,24,0,102,102,102,0,0,0,0,0,102,102,255,102,255,102,102,0,24,62,96,60,6,124,24,0,98,102,12,24,48,102,70,0,60,102,60,56,103,102,63,0,6,12,24,0,0,0,0,0,12,24,48,48,48,24,12,0,48,24,12,12,12,24,48,0,0,102,60,255,60,102,0,0,0,24,24,126,24,24,0,0,0,0,0,0,0,24,24,48,0,0,0,126,0,0,0,0,0,0,0,0,0,24,24,0,0,3,6,12,24,48,96,0,60,102,110,118,102,102,60,0,24,24,56,24,24,24,126,0,60,102,6,12,48,96,126,0,60,102,6,28,6,102,60,0,6,14,30,102,127,6,6,0,126,96,124,6,6,102,60,0,60,102,96,124,102,102,60,0,126,102,12,24,24,24,24,0,60,102,102,60,102,102,60,0,60,102,102,62,6,102,60,0,0,0,24,0,0,24,0,0,0,0,24,0,0,24,24,48,14,24,48,96,48,24,14,0,0,0,126,0,126,0,0,0,112,24,12,6,12,24,112,0,60,102,6,12,24,0,24,0,0,0,0,255,255,0,0,0,24,60,102,126,102,102,102,0,124,102,102,124,102,102,124,0,60,102,96,96,96,102,60,0,120,108,102,102,102,108,120,0,126,96,96,120,96,96,126,0,126,96,96,120,96,96,96,0,60,102,96,110,102,102,60,0,102,102,102,126,102,102,102,0,60,24,24,24,24,24,60,0,30,12,12,12,12,108,56,0,102,108,120,112,120,108,102,0,96,96,96,96,96,96,126,0,99,119,127,107,99,99,99,0,102,118,126,126,110,102,102,0,60,102,102,102,102,102,60,0,124,102,102,124,96,96,96,0,60,102,102,102,102,60,14,0,124,102,102,124,120,108,102,0,60,102,96,60,6,102,60,0,126,24,24,24,24,24,24,0,102,102,102,102,102,102,60,0,102,102,102,102,102,60,24,0,99,99,99,107,127,119,99,0,102,102,60,24,60,102,102,0,102,102,102,60,24,24,24,0,126,6,12,24,48,96,126,0,24,24,24,255,255,24,24,24,192,192,48,48,192,192,48,48,24,24,24,24,24,24,24,24,51,51,204,204,51,51,204,204,51,153,204,102,51,153,204,102,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,192,192,192,192,192,192,192,192,204,204,51,51,204,204,51,51,3,3,3,3,3,3,3,3,0,0,0,0,204,204,51,51,204,153,51,102,204,153,51,102,3,3,3,3,3,3,3,3,24,24,24,31,31,24,24,24,0,0,0,0,15,15,15,15,24,24,24,31,31,0,0,0,0,0,0,248,248,24,24,24,0,0,0,0,0,0,255,255,0,0,0,31,31,24,24,24,24,24,24,255,255,0,0,0,0,0,0,255,255,24,24,24,24,24,24,248,248,24,24,24,192,192,192,192,192,192,192,192,224,224,224,224,224,224,224,224,7,7,7,7,7,7,7,7,255,255,0,0,0,0,0,0,255,255,255,0,0,0,0,0,0,0,0,0,0,255,255,255,1,3,6,108,120,112,96,0,0,0,0,0,240,240,240,240,15,15,15,15,0,0,0,0,24,24,24,248,248,0,0,0,240,240,240,240,0,0,0,0,240,240,240,240,15,15,15,15,195,153,145,145,159,153,195,255,255,255,195,249,193,153,193,255,255,159,159,131,153,153,131,255,255,255,195,159,159,159,195,255,255,249,249,193,153,153,193,255,255,255,195,153,129,159,195,255,255,241,231,193,231,231,231,255,255,255,193,153,153,193,249,131,255,159,159,131,153,153,153,255,255,231,255,199,231,231,195,255,255,249,255,249,249,249,249,195,255,159,159,147,135,147,153,255,255,199,231,231,231,231,195,255,255,255,153,128,128,148,156,255,255,255,131,153,153,153,153,255,255,255,195,153,153,153,195,255,255,255,131,153,153,131,159,159,255,255,193,153,153,193,249,249,255,255,131,153,159,159,159,255,255,255,193,159,195,249,131,255,255,231,129,231,231,231,241,255,255,255,153,153,153,153,193,255,255,255,153,153,153,195,231,255,255,255,156,148,128,193,201,255,255,255,153,195,231,195,153,255,255,255,153,153,153,193,243,135,255,255,129,243,231,207,129,255,195,207,207,207,207,207,195,255,243,237,207,131,207,157,3,255,195,243,243,243,243,243,195,255,255,231,195,129,231,231,231,231,255,239,207,128,128,207,239,255,255,255,255,255,255,255,255,255,231,231,231,231,255,255,231,255,153,153,153,255,255,255,255,255,153,153,0,153,0,153,153,255,231,193,159,195,249,131,231,255,157,153,243,231,207,153,185,255,195,153,195,199,152,153,192,255,249,243,231,255,255,255,255,255,243,231,207,207,207,231,243,255,207,231,243,243,243,231,207,255,255,153,195,0,195,153,255,255,255,231,231,129,231,231,255,255,255,255,255,255,255,231,231,207,255,255,255,129,255,255,255,255,255,255,255,255,255,231,231,255,255,252,249,243,231,207,159,255,195,153,145,137,153,153,195,255,231,231,199,231,231,231,129,255,195,153,249,243,207,159,129,255,195,153,249,227,249,153,195,255,249,241,225,153,128,249,249,255,129,159,131,249,249,153,195,255,195,153,159,131,153,153,195,255,129,153,243,231,231,231,231,255,195,153,153,195,153,153,195,255,195,153,153,193,249,153,195,255,255,255,231,255,255,231,255,255,255,255,231,255,255,231,231,207,241,231,207,159,207,231,241,255,255,255,129,255,129,255,255,255,143,231,243,249,243,231,143,255,195,153,249,243,231,255,231,255,255,255,255,0,0,255,255,255,231,195,153,129,153,153,153,255,131,153,153,131,153,153,131,255,195,153,159,159,159,153,195,255,135,147,153,153,153,147,135,255,129,159,159,135,159,159,129,255,129,159,159,135,159,159,159,255,195,153,159,145,153,153,195,255,153,153,153,129,153,153,153,255,195,231,231,231,231,231,195,255,225,243,243,243,243,147,199,255,153,147,135,143,135,147,153,255,159,159,159,159,159,159,129,255,156,136,128,148,156,156,156,255,153,137,129,129,145,153,153,255,195,153,153,153,153,153,195,255,131,153,153,131,159,159,159,255,195,153,153,153,153,195,241,255,131,153,153,131,135,147,153,255,195,153,159,195,249,153,195,255,129,231,231,231,231,231,231,255,153,153,153,153,153,153,195,255,153,153,153,153,153,195,231,255,156,156,156,148,128,136,156,255,153,153,195,231,195,153,153,255,153,153,153,195,231,231,231,255,129,249,243,231,207,159,129,255,231,231,231,0,0,231,231,231,63,63,207,207,63,63,207,207,231,231,231,231,231,231,231,231,204,204,51,51,204,204,51,51,204,102,51,153,204,102,51,153,255,255,255,255,255,255,255,255,15,15,15,15,15,15,15,15,255,255,255,255,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,63,63,63,63,63,63,63,63,51,51,204,204,51,51,204,204,252,252,252,252,252,252,252,252,255,255,255,255,51,51,204,204,51,102,204,153,51,102,204,153,252,252,252,252,252,252,252,252,231,231,231,224,224,231,231,231,255,255,255,255,240,240,240,240,231,231,231,224,224,255,255,255,255,255,255,7,7,231,231,231,255,255,255,255,255,255,0,0,255,255,255,224,224,231,231,231,231,231,231,0,0,255,255,255,255,255,255,0,0,231,231,231,231,231,231,7,7,231,231,231,63,63,63,63,63,63,63,63,31,31,31,31,31,31,31,31,248,248,248,248,248,248,248,248,0,0,255,255,255,255,255,255,0,0,0,255,255,255,255,255,255,255,255,255,255,0,0,0,254,252,249,147,135,143,159,255,255,255,255,255,15,15,15,15,240,240,240,240,255,255,255,255,231,231,231,7,7,255,255,255,15,15,15,15,255,255,255,255,15,15,15,15,240,240,240,240,133,86,32,15,188,165,97,201,136,144,3,32,212,186,32,204,188,165,7,24,105,129,240,243,56,233,1,72,162,5,181,105,180,97,149,97,148,105,202,16,245,165,86,133,112,32,83,184,32,180,191,169,196,160,191,32,89,224,169,0,133,111,104,32,185,186,96,133,113,132,114,32,202,187,169,87,32,40,186,32,93,224,169,87,160,0,76,40,186,133,113,132,114,32,199,187,177,113,133,103,164,113,200,152,208,2,230,114,133,113,164,114,32,40,186,165,113,164,114,24,105,5,144,1,200,133,113,132,114,32,103,184,169,92,160,0,198,103,208,228,96,152,53,68,122,0,104,40,177,70,0,32,43,188,48,55,208,32,32,243,255,134,34,132,35,160,4,177,34,133,98,200,177,34,133,100,160,8,177,34,133,99,200,177,34,133,101,76,227,224,169,139,160,0,32,162,187,169,141,160,224,32,40,186,169,146,160,224,32,103,184,166,101,165,98,133,101,134,98,166,99,165,100,133,99,134,100,169,0,133,102,165,97,133,112,169,128,133,97,32,215,184,162,139,160,0,76,212,187,201,240,208,7,132,56,134,55,76,99,166,170,208,2,162,30,76,55,164,32,210,255,176,232,96,32,207,255,176,226,96,32,173,228,176,220,96,32,198,255,176,214,96,32,228,255,176,208,96,32,138,173,32,247,183,169,225,72,169,70,72,173,15,3,72,173,12,3,174,13,3,172,14,3,40,108,20,0,8,141,12,3,142,13,3,140,14,3,104,141,15,3,96,32,212,225,166,45,164,46,169,43,32,216,255,176,149,96,169,1,44,169,0,133,10,32,212,225,165,10,166,43,164,44,32,213,255,176,87,165,10,240,23,162,28,32,183,255,41,16,208,23,165,122,201,2,240,7,169,100,160,163,76,30,171,96,32,183,255,41,191,240,5,162,29,76,55,164,165,123,201,2,208,14,134,45,132,46,169,118,160,163,32,30,171,76,42,165,32,142,166,32,51,165,76,119,166,32,25,226,32,192,255,176,11,96,32,25,226,165,73,32,195,255,144,195,76,249,224,169,0,32,189,255,162,1,160,0,32,186,255,32,6,226,32,87,226,32,6,226,32,0,226,160,0,134,73,32,186,255,32,6,226,32,0,226,138,168,166,73,76,186,255,32,14,226,76,158,183,32,121,0,208,2,104,104,96,32,253,174,32,121,0,208,247,76,8,175,169,0,32,189,255,32,17,226,32,158,183,134,73,138,162,1,160,0,32,186,255,32,6,226,32,0,226,134,74,160,0,165,73,224,3,144,1,136,32,186,255,32,6,226,32,0,226,138,168,166,74,165,73,32,186,255,32,6,226,32,14,226,32,158,173,32,163,182,166,34,164,35,76,189,255,169,224,160,226,32,103,184,32,12,188,169,229,160,226,166,110,32,7,187,32,12,188,32,204,188,169,0,133,111,32,83,184,169,234,160,226,32,80,184,165,102,72,16,13,32,73,184,165,102,48,9,165,18,73,255,133,18,32,180,191,169,234,160,226,32,103,184,104,16,3,32,180,191,169,239,160,226,76,67,224,32,202,187,169,0,133,18,32,107,226,162,78,160,0,32,246,224,169,87,160,0,32,162,187,169,0,133,102,165,18,32,220,226,169,78,160,0,76,15,187,72,76,157,226,129,73,15,218,162,131,73,15,218,162,127,0,0,0,0,5,132,230,26,45,27,134,40,7,251,248,135,153,104,137,1,135,35,53,223,225,134,165,93,231,40,131,73,15,218,162,165,102,72,16,3,32,180,191,165,97,72,201,129,144,7,169,188,160,185,32,15,187,169,62,160,227,32,67,224,104,201,129,144,7,169,224,160,226,32,80,184,104,16,3,76,180,191,96,11,118,179,131,189,211,121,30,244,166,245,123,131,252,176,16,124,12,31,103,202,124,222,83,203,193,125,20,100,112,76,125,183,234,81,122,125,99,48,136,126,126,146,68,153,58,126,76,204,145,199,127,170,170,170,19,129,0,0,0,0,32,204,255,169,0,133,19,32,122,166,88,162,128,108,0,3,138,48,3,76,58,164,76,116,164,32,83,228,32,191,227,32,34,228,162,251,154,208,228,230,122,208,2,230,123,173,96,234,201,58,176,10,201,32,240,239,56,233,48,56,233,208,96,128,79,199,82,88,169,76,133,84,141,16,3,169,72,160,178,141,17,3,140,18,3,169,145,160,179,133,5,132,6,169,170,160,177,133,3,132,4,162,28,189,162,227,149,115,202,16,248,169,3,133,83,169,0,133,104,133,19,133,24,162,1,142,253,1,142,252,1,162,25,134,22,56,32,156,255,134,43,132,44,56,32,153,255,134,55,132,56,134,51,132,52,160,0,152,145,43,230,43,208,2,230,44,96,165,43,164,44,32,8,164,169,115,160,228,32,30,171,165,55,56,229,43,170,165,56,229,44,32,205,189,169,96,160,228,32,30,171,76,68,166,139,227,131,164,124,165,26,167,228,167,134,174,162,11,189,71,228,157,0,3,202,16,247,96,0,32,66,65,83,73,67,32,66,89,84,69,83,32,70,82,69,69,13,0,147,13,32,32,32,32,42,42,42,42,32,67,79,77,77,79,68,79,82,69,32,54,52,32,66,65,83,73,67,32,86,50,32,42,42,42,42,13,13,32,54,52,75,32,82,65,77,32,83,89,83,84,69,77,32,32,0,129,72,32,201,255,170,104,144,1,138,96,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,170,133,169,169,1,133,171,96,173,134,2,145,243,96,105,2,164,145,200,208,4,197,161,208,247,96,25,38,68,25,26,17,232,13,112,12,6,6,209,2,55,1,174,0,105,0,162,0,160,220,96,162,40,160,25,96,176,7,134,214,132,211,32,108,229,166,214,164,211,96,32,160,229,169,0,141,145,2,133,207,169,72,141,143,2,169,235,141,144,2,169,10,141,137,2,141,140,2,169,14,141,134,2,169,4,141,139,2,169,12,133,205,133,204,173,136,2,9,128,168,169,0,170,148,217,24,105,40,144,1,200,232,224,26,208,243,169,255,149,217,162,24,32,255,233,202,16,250,160,0,132,211,132,214,166,214,165,211,180,217,48,8,24,105,40,133,211,202,16,244,32,240,233,169,39,232,180,217,48,6,24,105,40,232,16,246,133,213,76,36,234,228,201,240,3,76,237,230,96,234,32,160,229,76,102,229,169,3,133,154,169,0,133,153,162,47,189,184,236,157,255,207,202,208,247,96,172,119,2,162,0,189,120,2,157,119,2,232,228,198,208,245,198,198,152,88,24,96,32,22,231,165,198,133,204,141,146,2,240,247,120,165,207,240,12,165,206,174,135,2,160,0,132,207,32,19,234,32,180,229,201,131,208,16,162,9,120,134,198,189,230,236,157,118,2,202,208,247,240,207,201,13,208,200,164,213,132,208,177,209,201,32,208,3,136,208,247,200,132,200,160,0,140,146,2,132,211,132,212,165,201,48,27,166,214,32,145,229,228,201,208,18,165,202,133,211,197,200,144,10,176,43,152,72,138,72,165,208,240,147,164,211,177,209,133,215,41,63,6,215,36,215,16,2,9,128,144,4,166,212,208,4,112,2,9,64,230,211,32,132,230,196,200,208,23,169,0,133,208,169,13,166,153,224,3,240,6,166,154,224,3,240,3,32,22,231,169,13,133,215,104,170,104,168,165,215,201,222,208,2,169,255,24,96,201,34,208,8,165,212,73,1,133,212,169,34,96,9,64,166,199,240,2,9,128,166,216,240,2,198,216,174,134,2,32,19,234,32,182,230,104,168,165,216,240,2,70,212,104,170,104,24,88,96,32,179,232,230,211,165,213,197,211,176,63,201,79,240,50,173,146,2,240,3,76,103,233,166,214,224,25,144,7,32,234,232,198,214,166,214,22,217,86,217,232,181,217,9,128,149,217,202,165,213,24,105,40,133,213,181,217,48,3,202,208,249,76,240,233,198,214,32,124,232,169,0,133,211,96,166,214,208,6,134,211,104,104,208,157,202,134,214,32,108,229,164,213,132,211,96,72,133,215,138,72,152,72,169,0,133,208,164,211,165,215,16,3,76,212,231,201,13,208,3,76,145,232,201,32,144,16,201,96,144,4,41,223,208,2,41,63,32,132,230,76,147,230,166,216,240,3,76,151,230,201,20,208,46,152,208,6,32,1,231,76,115,231,32,161,232,136,132,211,32,36,234,200,177,209,136,145,209,200,177,243,136,145,243,200,196,213,208,239,169,32,145,209,173,134,2,145,243,16,77,166,212,240,3,76,151,230,201,18,208,2,133,199,201,19,208,3,32,102,229,201,29,208,23,200,32,179,232,132,211,136,196,213,144,9,198,214,32,124,232,160,0,132,211,76,168,230,201,17,208,29,24,152,105,40,168,230,214,197,213,144,236,240,234,198,214,233,40,144,4,133,211,208,248,32,124,232,76,168,230,32,203,232,76,68,236,41,127,201,127,208,2,169,94,201,32,144,3,76,145,230,201,13,208,3,76,145,232,166,212,208,63,201,20,208,55,164,213,177,209,201,32,208,4,196,211,208,7,192,79,240,36,32,101,233,164,213,32,36,234,136,177,209,200,145,209,136,177,243,200,145,243,136,196,211,208,239,169,32,145,209,173,134,2,145,243,230,216,76,168,230,166,216,240,5,9,64,76,151,230,201,17,208,22,166,214,240,55,198,214,165,211,56,233,40,144,4,133,211,16,42,32,108,229,208,37,201,18,208,4,169,0,133,199,201,29,208,18,152,240,9,32,161,232,136,132,211,76,168,230,32,1,231,76,168,230,201,19,208,6,32,68,229,76,168,230,9,128,32,203,232,76,79,236,70,201,166,214,232,224,25,208,3,32,234,232,181,217,16,244,134,214,76,108,229,162,0,134,216,134,199,134,212,134,211,32,124,232,76,168,230,162,2,169,0,197,211,240,7,24,105,40,202,208,246,96,198,214,96,162,2,169,39,197,211,240,7,24,105,40,202,208,246,96,166,214,224,25,240,2,230,214,96,162,15,221,218,232,240,4,202,16,248,96,142,134,2,96,144,5,28,159,156,30,31,158,129,149,150,151,152,153,154,155,165,172,72,165,173,72,165,174,72,165,175,72,162,255,198,214,198,201,206,165,2,232,32,240,233,224,24,176,12,189,241,236,133,172,181,218,32,200,233,48,236,32,255,233,162,0,181,217,41,127,180,218,16,2,9,128,149,217,232,224,24,208,239,165,241,9,128,133,241,165,217,16,195,230,214,238,165,2,169,127,141,0,220,173,1,220,201,251,8,169,127,141,0,220,40,208,11,160,0,234,202,208,252,136,208,249,132,198,166,214,104,133,175,104,133,174,104,133,173,104,133,172,96,166,214,232,181,217,16,251,142,165,2,224,24,240,14,144,12,32,234,232,174,165,2,202,198,214,76,218,230,165,172,72,165,173,72,165,174,72,165,175,72,162,25,202,32,240,233,236,165,2,144,14,240,12,189,239,236,133,172,181,216,32,200,233,48,233,32,255,233,162,23,236,165,2,144,15,181,218,41,127,180,217,16,2,9,128,149,218,202,208,236,174,165,2,32,218,230,76,88,233,41,3,13,136,2,133,173,32,224,233,160,39,177,172,145,209,177,174,145,243,136,16,245,96,32,36,234,165,172,133,174,165,173,41,3,9,216,133,175,96,189,240,236,133,209,181,217,41,3,13,136,2,133,210,96,160,39,32,240,233,32,36,234,32,218,228,169,32,145,209,136,16,246,96,234,168,169,2,133,205,32,36,234,152,164,211,145,209,138,145,243,96,165,209,133,243,165,210,41,3,9,216,133,244,96,32,234,255,165,204,208,41,198,205,208,37,169,20,133,205,164,211,70,207,174,135,2,177,209,176,17,230,207,133,206,32,36,234,177,243,141,135,2,174,134,2,165,206,73,128,32,28,234,165,1,41,16,240,10,160,0,132,192,165,1,9,32,208,8,165,192,208,6,165,1,41])
.concat([31,133,1,32,135,234,173,13,220,104,168,104,170,104,64,169,0,141,141,2,160,64,132,203,141,0,220,174,1,220,224,255,240,97,168,169,129,133,245,169,235,133,246,169,254,141,0,220,162,8,72,173,1,220,205,1,220,208,248,74,176,22,72,177,245,201,5,176,12,201,3,240,8,13,141,2,141,141,2,16,2,132,203,104,200,192,65,176,11,202,208,223,56,104,42,141,0,220,208,204,104,108,143,2,164,203,177,245,170,196,197,240,7,160,16,140,140,2,208,54,41,127,44,138,2,48,22,112,73,201,127,240,41,201,20,240,12,201,32,240,8,201,29,240,4,201,17,208,53,172,140,2,240,5,206,140,2,208,43,206,139,2,208,38,160,4,140,139,2,164,198,136,16,28,164,203,132,197,172,141,2,140,142,2,224,255,240,14,138,166,198,236,137,2,176,6,157,119,2,232,134,198,169,127,141,0,220,96,173,141,2,201,3,208,21,205,142,2,240,238,173,145,2,48,29,173,24,208,73,2,141,24,208,76,118,235,10,201,8,144,2,169,6,170,189,121,235,133,245,189,122,235,133,246,76,224,234,129,235,194,235,3,236,120,236,20,13,29,136,133,134,135,17,51,87,65,52,90,83,69,1,53,82,68,54,67,70,84,88,55,89,71,56,66,72,85,86,57,73,74,48,77,75,79,78,43,80,76,45,46,58,64,44,92,42,59,19,1,61,94,47,49,95,4,50,32,2,81,3,255,148,141,157,140,137,138,139,145,35,215,193,36,218,211,197,1,37,210,196,38,195,198,212,216,39,217,199,40,194,200,213,214,41,201,202,48,205,203,207,206,219,208,204,221,62,91,186,60,169,192,93,147,1,61,222,63,33,95,4,34,160,2,209,131,255,148,141,157,140,137,138,139,145,150,179,176,151,173,174,177,1,152,178,172,153,188,187,163,189,154,183,165,155,191,180,184,190,41,162,181,48,167,161,185,170,166,175,182,220,62,91,164,60,168,223,93,147,1,61,222,63,129,95,4,149,160,2,171,131,255,201,14,208,7,173,24,208,9,2,208,9,201,142,208,11,173,24,208,41,253,141,24,208,76,168,230,201,8,208,7,169,128,13,145,2,48,9,201,9,208,238,169,127,45,145,2,141,145,2,76,168,230,255,255,255,255,255,255,255,255,28,23,1,159,26,19,5,255,156,18,4,30,3,6,20,24,31,25,7,158,2,8,21,22,18,9,10,146,13,11,15,14,255,16,12,255,255,27,0,255,28,255,29,255,255,31,30,255,144,6,255,5,255,255,17,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,155,55,0,0,0,8,0,20,15,0,0,0,0,0,0,14,6,1,2,3,4,0,1,2,3,4,5,6,7,76,79,65,68,13,82,85,78,13,0,40,80,120,160,200,240,24,64,104,144,184,224,8,48,88,128,168,208,248,32,72,112,152,192,9,64,44,9,32,32,164,240,72,36,148,16,10,56,102,163,32,64,237,70,148,70,163,104,133,149,120,32,151,238,201,63,208,3,32,133,238,173,0,221,9,8,141,0,221,120,32,142,238,32,151,238,32,179,238,120,32,151,238,32,169,238,176,100,32,133,238,36,163,16,10,32,169,238,144,251,32,169,238,176,251,32,169,238,144,251,32,142,238,169,8,133,165,173,0,221,205,0,221,208,248,10,144,63,102,149,176,5,32,160,238,208,3,32,151,238,32,133,238,234,234,234,234,173,0,221,41,223,9,16,141,0,221,198,165,208,212,169,4,141,7,220,169,25,141,15,220,173,13,220,173,13,220,41,2,208,10,32,169,238,176,244,88,96,169,128,44,169,3,32,28,254,88,24,144,74,133,149,32,54,237,173,0,221,41,247,141,0,221,96,133,149,32,54,237,120,32,160,238,32,190,237,32,133,238,32,169,238,48,251,88,96,36,148,48,5,56,102,148,208,5,72,32,64,237,104,133,149,24,96,120,32,142,238,173,0,221,9,8,141,0,221,169,95,44,169,63,32,17,237,32,190,237,138,162,10,202,208,253,170,32,133,238,76,151,238,120,169,0,133,165,32,133,238,32,169,238,16,251,169,1,141,7,220,169,25,141,15,220,32,151,238,173,13,220,173,13,220,41,2,208,7,32,169,238,48,244,16,24,165,165,240,5,169,2,76,178,237,32,160,238,32,133,238,169,64,32,28,254,230,165,208,202,169,8,133,165,173,0,221,205,0,221,208,248,10,16,245,102,164,173,0,221,205,0,221,208,248,10,48,245,198,165,208,228,32,160,238,36,144,80,3,32,6,238,165,164,88,24,96,173,0,221,41,239,141,0,221,96,173,0,221,9,16,141,0,221,96,173,0,221,41,223,141,0,221,96,173,0,221,9,32,141,0,221,96,173,0,221,205,0,221,208,248,10,96,138,162,184,202,208,253,170,96,165,180,240,71,48,63,70,182,162,0,144,1,202,138,69,189,133,189,198,180,240,6,138,41,4,133,181,96,169,32,44,148,2,240,20,48,28,112,20,165,189,208,1,202,198,180,173,147,2,16,227,198,180,208,223,230,180,208,240,165,189,240,237,208,234,112,233,80,230,230,180,162,255,208,203,173,148,2,74,144,7,44,1,221,16,29,80,30,169,0,133,189,133,181,174,152,2,134,180,172,157,2,204,158,2,240,19,177,249,133,182,238,157,2,96,169,64,44,169,16,13,151,2,141,151,2,169,1,141,13,221,77,161,2,9,128,141,161,2,141,13,221,96,162,9,169,32,44,147,2,240,1,202,80,2,202,202,96,166,169,208,51,198,168,240,54,48,13,165,167,69,171,133,171,70,167,102,170,96,198,168,165,167,240,103,173,147,2,10,169,1,101,168,208,239,169,144,141,13,221,13,161,2,141,161,2,133,169,169,2,76,59,239,165,167,208,234,76,211,228,172,155,2,200,204,156,2,240,42,140,155,2,136,165,170,174,152,2,224,9,240,4,74,232,208,248,145,247,169,32,44,148,2,240,180,48,177,165,167,69,171,240,3,112,169,44,80,166,169,1,44,169,4,44,169,128,44,169,2,13,151,2,141,151,2,76,126,239,165,170,208,241,240,236,133,154,173,148,2,74,144,41,169,2,44,1,221,16,29,208,32,173,161,2,41,2,208,249,44,1,221,112,251,173,1,221,9,2,141,1,221,44,1,221,112,7,48,249,169,64,141,151,2,24,96,32,40,240,172,158,2,200,204,157,2,240,244,140,158,2,136,165,158,145,249,173,161,2,74,176,30,169,16,141,14,221,173,153,2,141,4,221,173,154,2,141,5,221,169,129,32,59,239,32,6,239,169,17,141,14,221,96,133,153,173,148,2,74,144,40,41,8,240,36,169,2,44,1,221,16,173,240,34,173,161,2,74,176,250,173,1,221,41,253,141,1,221,173,1,221,41,4,240,249,169,144,24,76,59,239,173,161,2,41,18,240,243,24,96,173,151,2,172,156,2,204,155,2,240,11,41,247,141,151,2,177,247,238,156,2,96,9,8,141,151,2,169,0,96,72,173,161,2,240,17,173,161,2,41,3,208,249,169,16,141,13,221,169,0,141,161,2,104,96,13,73,47,79,32,69,82,82,79,82,32,163,13,83,69,65,82,67,72,73,78,71,160,70,79,82,160,13,80,82,69,83,83,32,80,76,65,89,32,79,78,32,84,65,80,197,80,82,69,83,83,32,82,69,67,79,82,68,32,38,32,80,76,65,89,32,79,78,32,84,65,80,197,13,76,79,65,68,73,78,199,13,83,65,86,73,78,71,160,13,86,69,82,73,70,89,73,78,199,13,70,79,85,78,68,160,13,79,75,141,36,157,16,13,185,189,240,8,41,127,32,210,255,200,40,16,243,24,96,165,153,208,8,165,198,240,15,120,76,180,229,201,2,208,24,132,151,32,134,240,164,151,24,96,165,153,208,11,165,211,133,202,165,214,133,201,76,50,230,201,3,208,9,133,208,165,213,133,200,76,50,230,176,56,201,2,240,63,134,151,32,153,241,176,22,72,32,153,241,176,13,208,5,169,64,32,28,254,198,166,166,151,104,96,170,104,138,166,151,96,32,13,248,208,11,32,65,248,176,17,169,0,133,166,240,240,177,178,24,96,165,144,240,4,169,13,24,96,76,19,238,32,78,241,176,247,201,0,208,242,173,151,2,41,96,208,233,240,238,72,165,154,201,3,208,4,104,76,22,231,144,4,104,76,221,237,74,104,133,158,138,72,152,72,144,35,32,13,248,208,14,32,100,248,176,14,169,2,160,0,145,178,200,132,166,165,158,145,178,24,104,168,104,170,165,158,144,2,169,0,96,32,23,240,76,252,241,32,15,243,240,3,76,1,247,32,31,243,165,186,240,22,201,3,240,18,176,20,201,2,208,3,76,77,240,166,185,224,96,240,3,76,10,247,133,153,24,96,170,32,9,237,165,185,16,6,32,204,237,76,72,242,32,199,237,138,36,144,16,230,76,7,247,32,15,243,240,3,76,1,247,32,31,243,165,186,208,3,76,13,247,201,3,240,15,176,17,201,2,208,3,76,225,239,166,185,224,96,240,234,133,154,24,96,170,32,12,237,165,185,16,5,32,190,237,208,3,32,185,237,138,36,144,16,231,76,7,247,32,20,243,240,2,24,96,32,31,243,138,72,165,186,240,80,201,3,240,76,176,71,201,2,208,29,104,32,242,242,32,131,244,32,39,254,165,248,240,1,200,165,250,240,1,200,169,0,133,248,133,250,76,125,244,165,185,41,15,240,35,32,208,247,169,0,56,32,221,241,32,100,248,144,4,104,169,0,96,165,185,201,98,208,11,169,5,32,106,247,76,241,242,32,66,246,104,170,198,152,228,152,240,20,164,152,185,89,2,157,89,2,185,99,2,157,99,2,185,109,2,157,109,2,24,96,169,0,133,144,138,166,152,202,48,21,221,89,2,208,248,96,189,89,2,133,184,189,99,2,133,186,189,109,2,133,185,96,169,0,133,152,162,3,228,154,176,3,32,254,237,228,153,176,3,32,239,237,134,154,169,0,133,153,96,166,184,208,3,76,10,247,32,15,243,208,3,76,254,246,166,152,224,10,144,3,76,251,246,230,152,165,184,157,89,2,165,185,9,96,133,185,157,109,2,165,186,157,99,2,240,90,201,3,240,86,144,5,32,213,243,144,79,201,2,208,3,76,9,244,32,208,247,176,3,76,19,247,165,185,41,15,208,31,32,23,248,176,54,32,175,245,165,183,240,10,32,234,247,144,24,240,40,76,4,247,32,44,247,240,32,144,12,176,244,32,56,248,176,23,169,4,32,106,247,169,191,164,185,192,96,240,7,160,0,169,2,145,178,152,133,166,24,96,165,185,48,250,164,183,240,246,169,0,133,144,165,186,32,12,237,165,185,9,240,32,185,237,165,144,16,5,104,104,76,7,247,165,183,240,12,160,0,177,187,32,221,237,200,196,183,208,246,76,84,246,32,131,244,140,151,2,196,183,240,10,177,187,153,147,2,200,192,4,208,242,32,74,239,142,152,2,173,147,2,41,15,240,28,10,170,173,166,2,208,9,188,193,254,189,192,254,76,64,244,188,235,228,189,234,228,140,150,2,141,149,2,173,149,2,10,32,46,255,173,148,2,74,144,9,173,1,221,10,176,3,32,13,240,173,155,2,141,156,2,173,158,2,141,157,2,32,39,254,165,248,208,5,136,132,248,134,247,165,250,208,5,136,132,250,134,249,56,169,240,76,45,254,169,127,141,13,221,169,6,141,3,221,141,1,221,169,4,13,0,221,141,0,221,160,0,140,161,2,96,134,195,132,196,108,48,3,133,147,169,0,133,144,165,186,208,3,76,19,247,201,3,240,249,144,123,164,183,208,3,76,16,247,166,185,32,175,245,169,96,133,185,32,213,243,165,186,32,9,237,165,185,32,199,237,32,19,238,133,174,165,144,74,74,176,80,32,19,238,133,175,138,208,8,165,195,133,174,165,196,133,175,32,210,245,169,253,37,144,133,144,32,225,255,208,3,76,51,246,32,19,238,170,165,144,74,74,176,232,138,164,147,240,12,160,0,209,174,240,8,169,16,32,28,254,44,145,174,230,174,208,2,230,175,36,144,80,203,32,239,237,32,66,246,144,121,76,4,247,74,176,3,76,19,247,32,208,247,176,3,76,19,247,32,23,248,176,104,32,175,245,165,183,240,9,32,234,247,144,11,240,90,176,218,32,44,247,240,83,176,211,165,144,41,16,56,208,74,224,1,240,17,224,3,208,221,160,1,177,178,133,195,200,177,178,133,196,176,4,165,185,208,239,160,3,177,178,160,1,241,178,170,160,4,177,178,160,2,241,178,168,24,138,101,195,133,174,152,101,196,133,175,165,195,133,193,165,196,133,194,32,210,245,32,74,248,36,24,166,174,164,175,96,165,157,16,30,160,12,32,47,241,165,183,240,21,160,23,32,47,241,164,183,240,12,160,0,177,187,32,210,255,200,196,183,208,246,96,160,73,165,147,240,2,160,89,76,43,241,134,174,132,175,170,181,0,133,193,181,1,133,194,108,50,3,165,186,208,3,76,19,247,201,3,240,249,144,95,169,97,133,185,164,183,208,3,76,16,247,32,213,243,32,143,246,165,186,32,12,237,165,185,32,185,237,160,0,32,142,251,165,172,32,221,237,165,173,32,221,237,32,209,252,176,22,177,172,32,221,237,32,225,255,208,7,32,66,246,169,0,56,96,32,219,252,208,229,32,254,237,36,185,48,17,165,186,32,12,237,165,185,41,239,9,224,32,185,237,32,254,237,24,96,74,176,3,76,19,247,32,208,247,144,141,32,56,248,176,37,32,143,246,162,3,165,185,41,1,208,2,162,1,138,32,106,247,176,18,32,103,248,176,13,165,185,41,2,240,6,169,5,32,106,247,36,24,96,165,157,16,251,160,81,32,47,241,76,193,245,162,0,230,162,208,6,230,161,208,2,230,160,56,165,162,233,1,165,161,233,26,165,160,233,79,144,6,134,160,134,161,134,162,173,1,220,205,1,220,208,248,170,48,19,162,189,142,0,220,174,1,220,236,1,220,208,248,141,0,220,232,208,2,133,145,96,120,165,162,166,161,164,160,120,133,162,134,161,132,160,88,96,165,145,201,127,208,7,8,32,204,255,133,198,40,96,169,1,44,169,2,44,169,3,44,169,4,44,169,5,44,169,6,44,169,7,44,169,8,44,169,9,72,32,204,255,160,0,36,157,80,10,32,47,241,104,72,9,48,32,210,255,104,56,96,165,147,72,32,65,248,104,133,147,176,50,160,0,177,178,201,5,240,42,201,1,240,8,201,3,240,4,201,4,208,225,170,36,157,16,23,160,99,32,47,241,160,5,177,178,32,210,255,200,192,21,208,246,165,161,32,224,228,234,24,136,96,133,158,32,208,247,144,94,165,194,72,165,193,72,165,175,72,165,174,72,160,191,169,32,145,178,136,208,251,165,158,145,178,200,165,193,145,178,200,165,194,145,178,200,165,174,145,178,200,165,175,145,178,200,132,159,160,0,132,158,164,158,196,183,240,12,177,187,164,159,145,178,230,158,230,159,208,238,32,215,247,169,105,133,171,32,107,248,168,104,133,174,104,133,175,104,133,193,104,133,194,152,96,166,178,164,179,192,2,96,32,208,247,138,133,193,24,105,192,133,174,152,133,194,105,0,133,175,96,32,44,247,176,29,160,5,132,159,160,0,132,158,196,183,240,16,177,187,164,159,209,178,208,231,230,158,230,159,164,158,208,236,24,96,32,208,247,230,166,164,166,192,192,96,32,46,248,240,26,160,27,32,47,241,32,208,248,32,46,248,208,248,160,106,76,47,241,169,16,36,1,208,2,36,1,24,96,32,46,248,240,249,160,46,208,221,169,0,133,144,133,147,32,215,247,32,23,248,176,31,120,169,0,133,170,133,180,133,176,133,158,133,159,133,156,169,144,162,14,208,17,32,215,247,169,20,133,171,32,56,248,176,108,120,169,130,162,8,160,127,140,13,220,141,13,220,173,14,220,9,25,141,15,220,41,145,141,162,2,32,164,240,173,17,208,41,239,141,17,208,173,20,3,141,159,2,173,21,3,141,160,2,32,189,252,169,2,133,190,32,151,251,165,1,41,31,133,1,133,192,162,255,160,255,136,208,253,202,208,248,88,173,160,2,205,21,3,24,240,21,32,208,248,32,188,246,76,190,248,32,225,255,24,208,11,32,147,252,56,104,104,169,0,141,160,2,96,134,177,165,176,10,10,24,101,176,24,101,177,133,177,169,0,36,176,48,1,42,6,177,42,6,177,42,170,173,6,220,201,22,144,249,101,177,141,4,220,138,109,7,220,141,5,220,173,162,2,141,14,220,141,164,2,173,13,220,41,16,240,9,169,249,72,169,42,72,76,67,255,88,96,174,7,220,160,255,152,237,6,220,236,7,220,208,242,134,177,170,140,6,220,140,7,220,169,25,141,15,220,173,13,220,141,163,2,152,229,177,134,177,74,102,177,74,102,177,165,176,24,105,60,197,177,176,74,166,156,240,3,76,96,250,166,163,48,27,162,0,105,48,101,176,197,177,176,28,232,105,38,101,176,197,177,176,23,105,44,101,176,197,177,144,3,76,16,250,165,180,240,29,133,168,208,25,230,169,176,2,198,169,56,233,19,229,177,101,146,133,146,165,164,73,1,133,164,240,43,134,215,165,180,240,34,173,163,2,41,1,208,5,173,164,2,208,22,169,0,133,164,141,164,2,165,163,16,48,48,191,162,166,32,226,248,165,155,208,185,76,188,254,165,146,240,7,48,3,198,176,44,230,176,169,0,133,146,228,215,208,15,138,208,160,165,169,48,189,201,16,144,185,133,150,176,181,138,69,155,133,155,165,180,240,210,198,163,48,197,70,215,102,191,162,218,32,226,248,76,188,254,165,150,240,4,165,180,240,7,165,163,48,3,76,151,249,70,177,169,147,56,229,177,101,176,10,170,32,226,248,230,156,165,180,208,17,165,150,240,38,133,168,169,0,133,150,169,129,141,13,220,133,180,165,150,133,181,240,9,169,0,133,180,169,1,141,13,220,165,191,133,189,165,168,5,169,133,182,76,188,254,32,151,251,133,156,162,218,32,226,248,165,190,240,2,133,167,169,15,36,170,16,23,165,181,208,12,166,190,202,208,11,169,8,32,28,254,208,4,169,0,133,170,76,188,254,112,49,208,24,165,181,208,245,165,182,208,241,165,167,74,165,189,48,3,144,24,24,176,21,41,15,133,170,198,170,208,221,169,64,133,170,32,142,251,169,0,133,171,240,208,169,128,133,170,208,202,165,181,240,10,169,4,32,28,254,169,0,76,74,251,32,209,252,144,3,76,72,251,166,167,202,240,45,165,147,240,12,160,0,165,189,209,172,240,4,169,1,133,182,165,182,240,75,162,61,228,158,144,62,166,158,165,173,157,1,1,165,172,157,0,1,232,232,134,158,76,58,251,166,159,228,158,240,53,165,172,221,0,1,208,46,165,173,221,1,1,208,39,230,159,230,159,165,147,240,11,165,189,160,0,209,172,240,23,200,132,182,165,182,240,7,169,16,32,28,254,208,9,165,147,208,5,168,165,189,145,172,32,219,252,208,67,169,128,133,170,120,162,1,142,13,220,174,13,220,166,190,202,48,2,134,190,198,167,240,8,165,158,208,39,133,190,240,35,32,147,252,32,142,251,160,0,132,171,177,172,69,171,133,171,32,219,252,32,209,252,144,242,165,171,69,189,240,5,169,32,32,28,254,76,188,254,165,194,133,173,165,193,133,172,96,169,8,133,163,169,0,133,164,133,168,133,155,133,169,96,165,189,74,169,96,144,2,169,176,162,0,141,6,220,142,7,220,173,13,220,169,25,141,15,220,165,1,73,8,133,1,41,8,96,56,102,182,48,60,165,168,208,18,169,16,162,1,32,177,251,208,47,230,168,165,182,16,41,76,87,252,165,169,208,9,32,173,251,208,29,230,169,208,25,32,166,251,208,20,165,164,73,1,133,164,240,15,165,189,73,1,133,189,41,1,69,155,133,155,76,188,254,70,189,198,163,165,163,240,58,16,243,32,151,251,88,165,165,240,18,162,0,134,215,198,165,166,190,224,2,208,2,9,128,133,189,208,217,32,209,252,144,10,208,145,230,173,165,215,133,189,176,202,160,0,177,172,133,189,69,215,133,215,32,219,252,208,187,165,155,73,1,133,189,76,188,254,198,190,208,3,32,202,252,169,80,133,167,162,8,120,32,189,252,208,234,169,120,32,175,251,208,227,198,167,208,223,32,151,251,198,171,16,216,162,10,32,189,252,88,230,171,165,190,240,48,32,142,251,162,9,134,165,134,182,208,131,8,120,173,17,208,9,16,141,17,208,32,202,252,169,127,141,13,220,32,221,253,173,160,2,240,9,141,21,3,173,159,2,141,20,3,40,96,32,147,252,240,151,189,147,253,141,20,3,189,148,253,141,21,3,96,165,1,9,32,133,1,96,56,165,172,229,174,165,173,229,175,96,230,172,208,2,230,173,96,162,255,120,154,216,32,2,253,208,3,108,0,128,142,22,208,32,163,253,32,80,253,32,21,253,32,91,255,88,108,0,160,162,5,189,15,253,221,3,128,208,3,202,208,245,96,195,194,205,56,48,162,48,160,253,24,134,195,132,196,160,31,185,20,3,176,2,177,195,145,195,153,20,3,136,16,241,96,49,234,102,254,71,254,74,243,145,242,14,242,80,242,51,243,87,241,202,241,237,246,62,241,47,243,102,254,165,244,237,245,169,0,168,153,2,0,153,0,2,153,0,3,200,208,244,162,60,160,3,134,178,132,179,168,169,3,133,194,230,194,177,193,170,169,85,145,193,209,193,208,15,42,145,193,209,193,208,8,138,145,193,200,208,232,240,228,152,170,164,194,24,32,45,254,169,8,141,130,2,169,4,141,136,2,96,106,252,205,251,49,234,44,249,169,127,141,13,220,141,13,221,141,0,220,169,8,141,14,220,141,14,221,141,15,220,141,15,221,162,0,142,3,220,142,3,221,142,24,212,202,142,2,220,169,7,141,0,221,169,63,141,2,221,169,231,133,1,169,47,133,0,173,166,2,240,10,169,37,141,4,220,169,64,76,243,253,169,149,141,4,220,169,66,141,5,220,76,110,255,133,183,134,187,132,188,96,133,184,134,186,132,185,96,165,186,201,2,208,13,173,151,2,72,169,0,141,151,2,104,96,133,157,165,144,5,144,133,144,96,141,133,2,96,144,6,174,131,2,172,132,2,142,131,2,140,132,2,96,144,6,174,129,2,172,130,2,142,129,2,140,130,2,96,120,108,24,3,72,138,72,152,72,169,127,141,13,221,172,13,221,48,28,32,2,253,208,3,108,2,128,32,188,246,32,225,255,208,12,32,21,253,32,163,253,32,24,229,108,2,160,152,45,161,2,170,41,1,240,40,173,0,221,41,251,5,181,141,0,221,173,161,2,141,13,221,138,41,18,240,13,41,2,240,6,32,214,254,76,157,254,32,7,255,32,187,238,76,182,254,138,41,2,240,6,32,214,254,76,182,254,138,41,16,240,3,32,7,255,173,161,2,141,13,221,104,168,104,170,104,64,193,39,62,26,197,17,116,14,237,12,69,6,240,2,70,1,184,0,113,0,173,1,221,41,1,133,167,173,6,221,233,28,109,153,2,141,6,221,173,7,221,109,154,2,141,7,221,169,17,141,15,221,173,161,2,141,13,221,169,255,141,6,221,141,7,221,76,89,239,173,149,2,141,6,221,173,150,2,141,7,221,169,17,141,15,221,169,18,77,161,2,141,161,2,169,255,141,6,221,141,7,221,174,152,2,134,168,96,170,173,150,2,42,168,138,105,200,141,153,2,152,105,0,141,154,2,96,234,234,8,104,41,239,72,72,138,72,152,72,186,189,4,1,41,16,240,3,108,22,3,108,20,3,32,24,229,173,18,208,208,251,173,25,208,41,1,141,166,2,76,221,253,169,129,141,13,220,173,14,220,41,128,9,17,141,14,220,76,142,238,3,76,91,255,76,163,253,76,80,253,76,21,253,76,26,253,76,24,254,76,185,237,76,199,237,76,37,254,76,52,254,76,135,234,76,33,254,76,19,238,76,221,237,76,239,237,76,254,237,76,12,237,76,9,237,76,7,254,76,0,254,76,249,253,108,26,3,108,28,3,108,30,3,108,32,3,108,34,3,108,36,3,108,38,3,76,158,244,76,221,245,76,228,246,76,221,246,108,40,3,108,42,3,108,44,3,76,155,246,76,5,229,76,10,229,76,0,229,82,82,66,89,67,254,226,252,72,255,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,144,78,1,0,248,69,1,0,144,63,1,0,224,58,1,0,48,55,1,0,0,0,0,0,47,118,105,99,101,46,88,88,88,88,88,88,0,0,0,0,47,118,105,99,101,46,88,88,88,88,88,88,0,0,0,0,70,79,82,77,115,115,115,115,65,73,70,70,67,79,77,77,0,0,0,18,0,99,102,102,102,102,0,16,64,114,114,114,0,0,0,0,0,0,83,83,78,68,115,115,115,115,0,0,0,0,0,0,0,0,0,0,24,86,1,0,48,0,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,1,0,4,0,8,0,12,0,19,0,28,0,34,0,40,0,50,0,125,0,250,0,144,1,244,1,220,5,196,9,160,15,54,53,56,49,82,52,65,82,95,51,55,56,57,0,0,0,74,117,108,0,0,0,0,0,66,97,115,105,99,78,97,109,101,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,74,117,110,0,0,0,0,0,98,122,105,112,50,0,0,0,65,112,114,0,0,0,0,0,58,0,0,0,0,0,0,0,83,111,117,110,100,82,101,99,111,114,100,68,101,118,105,99,101,78,97,109,101,0,0,0,77,97,114,0,0,0,0,0,70,101,98,0,0,0,0,0,82,65,77,73,110,105,116,80,97,116,116,101,114,110,73,110,118,101,114,116,0,0,0,0,74,97,110,0,0,0,0,0,76,111,103,70,105,108,101,78,97,109,101,0,0,0,0,0,54,53,56,49,0,0,0,0,71,101,116,116,105,110,103,32,37,115,32,102,114,111,109,32,99,97,99,104,101,0,0,0,75,101,121,83,101,116,49,83,111,117,116,104,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,115,120,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,100,105,115,107,32,105,109,97,103,101,0,0,0,0,0,0,66,114,111,119,110,0,0,0,70,105,108,101,32,37,115,32,105,115,32,110,111,116,32,97,32,102,108,105,112,108,105,115,116,32,102,105,108,101,0,0,77,79,83,56,53,56,48,32,43,32,100,105,103,105,32,98,111,111,115,116,0,0,0,0,32,77,117,108,116,105,32,67,111,108,111,114,0,0,0,0,84,114,105,112,108,101,32,83,73,68,0,0,0,0,0,0,84,105,109,101,114,32,66,58,32,37,48,52,120,10,0,0,69,118,101,110,116,73,109,97,103,101,73,110,99,108,117,100,101,0,0,0,0,0,0,0,107,101,114,110,97,108,0,0,83,73,68,32,36,68,52,50,48,45,36,68,52,70,70,32,109,105,114,114,111,114,115,0,79,99,116,111,98,101,114,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,46,114,115,105,100,0,0,0,54,53,56,49,82,51,95,51,57,56,52,0,0,0,0,0,80,97,116,99,104,32,105,110,115,116,97,108,108,101,100,46,0,0,0,0,0,0,0,0,65,117,103,117,115,116,0,0,75,101,114,110,97,108,78,97,109,101,0,0,0,0,0,0,75,101,114,110,97,108,32,114,101,118,32,35,37,100,46,0,74,117,108,121,0,0,0,0,87,97,114,110,105,110,103,58,32,99,111,117,108,100,32,110,111,116,32,114,101,109,111,118,101,32,98,97,99,107,117,112,32,102,105,108,101,46,0,0,74,117,110,101,0,0,0,0,36,36,0,0,0,0,0,0,77,97,121,0,0,0,0,0,100,101,118,105,99,101,32,33,61,32,78,85,76,76,0,0,65,112,114,105,108,0,0,0,71,108,117,101,0,0,0,0,77,97,114,99,104,0,0,0,71,69,84,0,0,0,0,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,75,101,121,83,101,116,49,83,111,117,116,104,69,97,115,116,0,0,0,0,0,0,0,0,97,108,97,114,109,95,115,101,116,40,41,58,32,84,111,111,32,109,97,110,121,32,97,108,97,114,109,115,32,115,101,116,33,0,0,0,0,0,0,0,74,97,110,117,97,114,121,0,102,105,108,101,32,115,121,115,116,101,109,32,100,101,118,105,99,101,0,0,0,0,0,0,79,114,97,110,103,101,0,0,114,98,0,0,0,0,0,0,32,83,116,97,110,100,97,114,100,0,0,0,0,0,0,0,84,105,109,101,114,32,65,58,32,37,48,52,120,10,0,0,69,118,101,110,116,83,116,97,114,116,77,111,100,101,0,0,75,101,114,110,97,108,78,97,109,101,0,0,0,0,0,0,83,73,68,32,36,68,53,48,48,45,36,68,53,70,70,32,109,105,114,114,111,114,115,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,46,112,115,105,100,0,0,0,54,53,56,49,82,51,95,48,52,56,54,83,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,67,54,52,77,69,77,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,114,101,115,116,111,114,101,32,98,97,99,107,117,112,32,102,105,108,101,32,97,102,116,101,114,32,102,97,105,108,101,100,32,99,111,109,112,114,101,115,115,105,111,110,46,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,68,105,114,101,99,116,111,114,121,0,0,0,0,0,0,0,44,32,115,116,101,114,101,111,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,82,65,77,73,110,105,116,86,97,108,117,101,73,110,118,101,114,116,0,0,0,0,0,0,80,97,108,101,116,116,101,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,71,101,116,105,110,103,32,39,37,115,39,32,116,111,32,39,37,115,39,0,0,0,0,0,67,97,110,110,111,116,32,117,110,108,105,110,107,32,96,37,115,39,58,32,37,115,0,0,75,101,121,83,101,116,49,69,97,115,116,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,76,83,72,73,70,84,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,102,105,108,101,32,115,121,115,116,101,109,0,0,0,0,0,89,111,117,114,32,109,97,99,104,105,110,101,32,105,115,32,116,111,111,32,115,108,111,119,32,102,111,114,32,99,117,114,114,101,110,116,32,115,101,116,116,105,110,103,115,33,0,0,89,101,108,108,111,119,0,0,32,69,120,116,101,110,100,101,100,0,0,0,0,0,0,0,83,105,100,70,105,108,116,101,114,115,0,0,0,0,0,0,80,111,114,116,32,66,58,32,32,37,48,50,120,32,68,68,82,58,32,37,48,50,120,10,0,0,0,0,0,0,0,0,99,104,97,114,103,101,110,0,83,73,68,32,36,68,54,48,48,45,36,68,54,70,70,32,109,105,114,114,111,114,115,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,54,53,56,49,82,51,95,52,56,56,53,0,0,0,0,0,115,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,67,111,117,108,100,110,39,116,32,108,111,97,100,32,99,104,97,114,97,99,116,101,114,32,82,79,77,32,96,37,115,39,46,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,109,97,107,101,32,112,114,101,45,99,111,109,112,114,101,115,115,105,111,110,32,98,97,99,107,117,112,46,0,0,87,97,114,112,77,111,100,101,0,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,112,101,110,101,100,32,100,101,118,105,99,101,32,96,37,115,39,44,32,115,112,101,101,100,32,37,100,72,122,44,32,102,114,97,103,109,101,110,116,32,115,105,122,101,32,37,100,109,115,44,32,98,117,102,102,101,114,32,115,105,122,101,32,37,100,109,115,37,115,0,0,47,102,108,105,112,108,105,115,116,45,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,77,105,115,115,105,110,103,32,110,97,109,101,32,102,111,114,32,115,121,115,116,101,109,32,102,105,108,101,46,0,0,0,45,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,95,95,110,101,120,116,95,112,114,105,109,101,32,111,118,101,114,102,108,111,119,0,0,0,58,47,92,63,59,0,0,0,75,101,121,83,101,116,49,78,111,114,116,104,69,97,115,116,0,0,0,0,0,0,0,0,90,70,105,108,101,0,0,0,82,83,72,73,70,84,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,46,122,111,111,0,0,0,0,102,108,105,112,32,108,105,115,116,0,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,66,108,117,101,0,0,0,0,68,105,115,112,108,97,121,32,77,111,100,101,58,0,0,0,83,105,100,82,101,115,105,100,70,105,108,116,101,114,66,105,97,115,0,0,0,0,0,0,83,105,100,82,101,115,105,100,70,105,108,116,101,114,66,105,97,115,0,0,0,0,0,0,80,111,114,116,32,65,58,32,32,37,48,50,120,32,68,68,82,58,32,37,48,50,120,10,0,0,0,0,0,0,0,0,69,118,101,110,116,0,0,0,105,111,0,0,0,0,0,0,67,104,97,114,103,101,110,78,97,109,101,0,0,0,0,0,83,73,68,32,36,68,55,48,48,45,36,68,55,70,70,32,109,105,114,114,111,114,115,0,120,112,113,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,108,102,49,113,0,0,0,0,86,105,99,101,80,108,117,103,105,110,32,100,101,115,116,114,111,121,10,0,0,0,0,0,63,0,0,0,0,0,0,0,37,46,52,88,32,40,37,100,32,98,121,116,101,37,115,41,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,99,104,105,112,32,33,61,32,78,85,76,76,0,0,0,0,122,111,111,0,0,0,0,0,67,111,117,108,100,110,39,116,32,108,111,97,100,32,98,97,115,105,99,32,82,79,77,32,96,37,115,39,46,0,0,0,115,111,117,114,99,101,45,62,100,101,116,95,99,97,114,116,105,100,32,33,61,32,67,65,82,84,82,73,68,71,69,95,67,82,84,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,46,116,103,122,0,0,0,0,99,111,109,112,114,101,115,115,58,32,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,116,121,112,101,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,46,116,97,114,46,103,122,0,86,105,114,116,117,97,108,68,101,118,105,99,101,115,0,0,41,0,0,0,0,0,0,0,82,79,77,32,96,37,115,39,58,32,108,111,110,103,32,102,105,108,101,44,32,100,105,115,99,97,114,100,105,110,103,32,101,110,100,46,0,0,0,0,115,111,117,110,100,32,100,101,118,105,99,101,32,108,97,99,107,115,32,115,116,101,114,101,111,32,99,97,112,97,98,105,108,105,116,121,44,32,115,119,105,116,99,104,105,110,103,32,116,111,32,109,111,110,111,32,111,117,116,112,117,116,0,0,45,122,120,79,102,0,0,0,80,83,73,68,84,117,110,101,0,0,0,0,0,0,0,0,80,77,0,0,0,0,0,0,83,99,114,101,101,110,115,104,111,116,0,0,0,0,0,0,45,122,116,102,0,0,0,0,80,83,73,68,75,101,101,112,69,110,118,0,0,0,0,0,84,114,121,105,110,103,32,116,111,32,114,101,97,100,32,118,97,108,117,101,32,102,114,111,109,32,117,110,107,110,111,119,110,32,114,101,115,111,117,114,99,101,32,96,37,115,39,46,0,0,0,0,0,0,0,0,46,118,102,108,0,0,0,0,82,65,77,73,110,105,116,83,116,97,114,116,86,97,108,117,101,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,116,97,114,0,0,0,0,0,37,115,0,0,0,0,0,0,102,105,108,101,115,47,0,0,75,101,121,83,101,116,49,78,111,114,116,104,0,0,0,0,46,116,97,114,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,45,120,79,102,0,0,0,0,85,73,0,0,0,0,0,0,86,73,67,73,73,78,101,119,76,117,109,105,110,97,110,99,101,115,0,0,0,0,0,0,71,114,101,101,110,0,0,0,82,97,115,116,101,114,108,105,110,101,58,32,32,32,99,117,114,114,101,110,116,58,32,37,100,32,73,82,81,58,32,37,100,10,0,0,0,0,0,0,83,105,100,82,101,115,105,100,71,97,105,110,0,0,0,0,83,105,100,82,101,115,105,100,71,97,105,110,0,0,0,0,83,105,100,77,111,100,101,108,0,0,0,0,0,0,0,0,73,67,82,58,32,37,48,50,120,32,67,84,82,76,65,58,32,37,48,50,120,32,67,84,82,76,66,58,32,37,48,50,120,10,10,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,114,111,109,0,0,0,0,0,83,105,100,84,114,105,112,108,101,65,100,100,114,101,115,115,83,116,97,114,116,0,0,0,86,83,73,68,0,0,0,0,45,116,102,0,0,0,0,0,103,116,97,114,0,0,0,0,47,104,111,109,101,47,115,97,115,113,47,112,114,111,106,101,99,116,115,47,99,104,105,112,109,97,99,104,105,110,101,47,115,114,99,47,112,108,117,103,105,110,115,47,86,105,99,101,80,108,117,103,105,110,47,86,105,99,101,80,108,117,103,105,110,46,99,112,112,0,0,0,68,84,86,83,73,68,0,0,73,110,115,116,97,108,108,105,110,103,32,82,79,77,32,112,97,116,99,104,32,102,111,114,32,114,101,118,105,115,105,111,110,32,35,37,100,58,0,0,73,110,99,111,110,115,105,115,116,101,110,116,32,114,101,115,111,117,114,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,46,10,0,0,0,0,0,0,0,0,46,108,104,97,0,0,0,0,87,97,114,110,105,110,103,58,32,85,110,107,110,111,119,110,32,66,97,115,105,99,32,105,109,97,103,101,46,32,32,83,117,109,58,32,37,100,32,40,36,37,48,52,88,41,46,0,44,32,0,0,0,0,0,0,71,108,117,101,76,111,103,105,99,0,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,46,108,122,104,0,0,0,0,82,101,108,111,99,97,116,105,111,110,46,0,0,0,0,0,99,111,109,112,114,101,115,115,58,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,114,101,115,115,32,116,122,120,45,102,105,108,101,46,0,0,82,101,102,114,101,115,104,82,97,116,101,0,0,0,0,0,67,97,110,110,111,116,32,108,111,97,100,32,112,97,108,101,116,116,101,46,0,0,0,0,112,113,0,0,0,0,0,0,83,105,100,83,116,101,114,101,111,65,100,100,114,101,115,115,83,116,97,114,116,0,0,0,44,32,0,0,0,0,0,0,82,79,77,32,96,37,115,39,58,32,116,119,111,32,98,121,116,101,115,32,116,111,111,32,108,97,114,103,101,32,45,32,114,101,109,111,118,105,110,103,32,97,115,115,117,109,101,100,32,115,116,97,114,116,32,97,100,100,114,101,115,115,46,0,86,73,67,73,73,86,105,100,101,111,67,97,99,104,101,0,108,118,0,0,0,0,0,0,97,118,97,105,108,97,98,108,101,32,115,111,117,110,100,32,100,101,118,105,99,101,115,32,101,120,99,101,101,100,32,86,73,67,69,115,32,115,116,111,114,97,103,101,0,0,0,0,50,110,100,32,83,73,68,32,97,116,32,36,37,48,52,120,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,108,104,97,0,0,0,0,0,83,105,100,83,116,101,114,101,111,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,114,101,115,111,117,114,99,101,32,116,121,112,101,32,102,111,114,32,96,37,115,39,0,0,47,46,118,105,99,101,47,102,108,105,112,108,105,115,116,45,0,0,0,0,0,0,0,0,78,97,109,101,0,0,0,0,83,111,117,110,100,86,111,108,117,109,101,0,0,0,0,0,10,77,117,108,116,105,32,67,111,108,111,114,32,49,58,32,37,100,32,32,77,117,108,116,105,32,67,111,108,111,114,32,50,58,32,37,100,0,0,0,46,0,0,0,0,0,0,0,80,108,97,121,105,110,103,32,116,117,110,101,32,37,100,32,111,117,116,32,111,102,32,37,100,32,40,100,101,102,97,117,108,116,61,37,100,41,0,0,46,122,105,112,0,0,0,0,37,115,58,32,37,115,0,0,10,67,111,108,111,114,58,32,32,32,0,0,0,0,0,0,75,101,121,83,101,116,49,78,111,114,116,104,87,101,115,116,0,0,0,0,0,0,0,0,67,111,117,108,100,110,39,116,32,111,112,101,110,32,97,117,100,105,111,58,32,37,115,10,0,0,0,0,0,0,0,0,83,111,117,110,100,83,117,115,112,101,110,100,84,105,109,101,0,0,0,0,0,0,0,0,85,115,105,110,103,32,37,115,32,105,110,116,101,114,114,117,112,116,0,0,0,0,0,0,45,112,0,0,0,0,0,0,115,116,100,0,0,0,0,0,83,111,117,110,100,79,117,116,112,117,116,0,0,0,0,0,83,73,68,32,109,111,100,101,108,58,32,37,115,32,32,40,85,115,105,110,103,32,37,115,41,0,0,0,0,0,0,0,91,37,115,58,37,100,93,32,0,0,0,0,0,0,0,0,45,108,0,0,0,0,0,0,114,111,109,115,101,116,0,0,86,73,67,73,73,67,104,101,99,107,83,98,67,111,108,108,0,0,0,0,0,0,0,0,80,117,114,112,108,101,0,0,119,0,0,0,0,0,0,0,83,105,100,82,101,115,105,100,80,97,115,115,98,97,110,100,0,0,0,0,0,0,0,0,83,105,100,70,105,108,116,101,114,115,0,0,0,0,0,0,83,105,100,82,101,115,105,100,80,97,115,115,98,97,110,100,0,0,0,0,0,0,0,0,85,110,107,110,111,119,32,101,118,101,110,116,32,116,121,112,101,32,37,105,46,0,0,0,109,117,99,111,0,0,0,0,114,97,109,0,0,0,0,0,100,97,116,97,115,101,116,116,101,32,98,105,116,95,119,114,105,116,101,32,102,97,105,108,101,100,46,0,0,0,0,0,83,105,100,83,116,101,114,101,111,65,100,100,114,101,115,115,83,116,97,114,116,0,0,0,85,110,107,110,111,119,110,32,109,97,99,104,105,110,101,32,116,105,109,105,110,103,46,0,78,84,83,67,0,0,0,0,117,110,122,105,112,0,0,0,10,77,111,100,101,58,32,32,32,32,0,0,0,0,0,0])
.concat([83,111,117,110,100,83,112,101,101,100,65,100,106,117,115,116,109,101,110,116,0,0,0,0,99,54,52,47,107,101,114,110,97,108,0,0,0,0,0,0,80,65,76,0,0,0,0,0,46,116,97,112,0,0,0,0,54,53,56,49,82,52,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,77,97,105,110,32,67,80,85,58,32,82,69,83,69,84,46,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,112,97,116,99,104,32,82,79,77,32,116,111,32,114,101,118,105,115,105,111,110,32,35,37,100,46,0,0,0,0,0,0,0,115,112,114,0,0,0,0,0,85,115,105,110,103,32,37,115,32,115,121,110,99,0,0,0,67,111,117,108,100,110,39,116,32,108,111,97,100,32,107,101,114,110,97,108,32,82,79,77,32,96,37,115,39,46,0,0,46,108,110,120,0,0,0,0,98,103,0,0,0,0,0,0,83,111,117,110,100,82,101,99,111,114,100,68,101,118,105,99,101,65,114,103,0,0,0,0,82,101,108,101,97,115,101,100,58,32,37,115,0,0,0,0,46,112,114,103,0,0,0,0,99,111,109,112,114,101,115,115,58,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,114,101,115,115,32,108,121,110,120,45,102,105,108,101,46,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,10,80,114,105,111,114,105,116,121,58,0,0,0,0,0,0,32,32,65,117,116,104,111,114,58,32,37,115,0,0,0,0,46,112,48,48,0,0,0,0,73,110,99,111,114,114,101,99,116,32,99,104,101,99,107,98,121,116,101,32,102,111,114,32,116,114,97,112,32,96,37,115,39,46,32,32,78,111,116,32,105,110,115,116,97,108,108,101,100,46,0,0,0,0,0,0,83,112,101,99,105,102,121,32,83,73,68,32,101,110,103,105,110,101,32,97,110,100,32,109,111,100,101,108,32,40,0,0,82,79,77,32,37,115,58,32,115,104,111,114,116,32,102,105,108,101,46,0,0,0,0,0,32,9,44,13,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,10,89,45,69,120,112,97,110,100,58,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,105,110,105,116,32,109,97,105,110,0,0,0,0,0,37,115,32,37,115,0,0,0,32,32,32,84,105,116,108,101,58,32,37,115,0,0,0,0,46,116,54,52,0,0,0,0,83,111,117,110,100,68,101,118,105,99,101,65,114,103,0,0,85,78,68,69,70,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,10,88,45,69,120,112,97,110,100,58,0,0,0,0,0,0,68,105,114,101,99,116,111,114,121,0,0,0,0,0,0,0,99,117,115,116,111,109,32,40,37,115,32,63,41,0,0,0,84,114,121,105,110,103,32,116,111,32,97,115,115,105,103,110,32,118,97,108,117,101,32,116,111,32,117,110,107,110,111,119,110,32,114,101,115,111,117,114,99,101,32,96,37,115,39,46,0,0,0,0,0,0,0,0,46,100,115,107,0,0,0,0,73,78,67,76,85,68,69,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,10,89,45,80,111,115,58,32,32,32,0,0,0,0,0,0,60,78,85,76,76,62,0,0,86,73,67,73,73,86,105,100,101,111,67,97,99,104,101,0,86,73,67,73,73,0,0,0,46,120,54,52,0,0,0,0,69,114,114,111,114,32,45,32,0,0,0,0,0,0,0,0,83,111,117,110,100,68,101,118,105,99,101,78,97,109,101,0,67,76,69,65,82,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,32,32,37,53,100,0,0,0,69,120,116,114,97,74,111,121,84,121,112,101,0,0,0,0,83,105,100,82,101,115,105,100,83,97,109,112,108,105,110,103,0,0,0,0,0,0,0,0,67,73,65,32,49,0,0,0,102,105,108,101,115,0,0,0,46,112,52,49,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,72,73,70,84,76,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,10,88,45,80,111,115,58,32,32,32,0,0,0,0,0,0,67,97,110,110,111,116,32,115,101,116,32,100,101,102,97,117,108,116,115,46,10,0,0,0,73,109,97,103,101,32,105,115,32,80,108,97,121,83,73,68,32,115,112,101,99,105,102,105,99,32,45,32,116,114,121,105,110,103,32,97,110,121,119,97,121,46,0,0,0,0,0,0,46,103,52,49,0,0,0,0,97,117,116,111,115,116,97,114,116,0,0,0,0,0,0,0,86,73,67,73,73,67,104,101,99,107,83,115,67,111,108,108,0,0,0,0,0,0,0,0,83,111,117,110,100,70,114,97,103,109,101,110,116,83,105,122,101,0,0,0,0,0,0,0,67,121,97,110,0,0,0,0,86,105,99,73,73,82,97,115,116,101,114,68,114,97,119,0,119,98,0,0,0,0,0,0,119,98,0,0,0,0,0,0,119,98,0,0,0,0,0,0,118,105,99,101,115,110,100,46,115,105,100,0,0,0,0,0,119,98,0,0,0,0,0,0,83,105,100,82,101,115,105,100,83,97,109,112,108,105,110,103,0,0,0,0,0,0,0,0,35,83,73,68,58,32,86,37,100,58,32,101,61,37,53,46,49,102,37,37,40,37,99,41,32,119,61,37,54,46,49,102,72,122,40,37,99,41,32,102,61,37,53,46,49,102,37,37,32,112,61,37,53,46,49,102,37,37,10,0,0,0,0,0,37,115,95,84,79,68,0,0,86,83,72,73,70,84,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,105,100,82,101,115,105,100,83,97,109,112,108,105,110,103,0,0,0,0,0,0,0,0,32,32,36,37,48,52,120,0,99,112,117,0,0,0,0,0,75,101,121,109,97,112,73,110,100,101,120,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,105,110,105,116,32,114,101,115,111,117,114,99,101,115,0,0,0,0,0,0,0,0,84,117,110,101,32,111,117,116,32,111,102,32,114,97,110,103,101,46,0,0,0,0,0,0,46,103,54,52,0,0,0,0,66,97,100,32,114,111,119,47,99,111,108,117,109,110,32,118,97,108,117,101,32,40,37,100,47,37,100,41,32,102,111,114,32,107,101,121,115,121,109,32,96,37,115,39,46,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,10,65,100,100,114,101,115,115,58,32,0,0,0,0,0,0,67,54,52,0,0,0,0,0,99,54,52,47,99,104,97,114,103,101,110,0,0,0,0,0,83,105,100,77,111,100,101,108,0,0,0,0,0,0,0,0,74,111,121,115,116,105,99,107,0,0,0,0,0,0,0,0,46,100,56,50,0,0,0,0,83,111,117,110,100,66,117,102,102,101,114,83,105,122,101,0,82,111,109,115,101,116,70,105,108,101,78,97,109,101,0,0,56,53,56,48,68,0,0,0,82,79,77,32,110,111,116,32,112,97,116,99,104,101,100,58,32,65,108,114,101,97,100,121,32,114,101,118,105,115,105,111,110,32,35,37,100,46,0,0,32,9,0,0,0,0,0,0,83,116,101,114,101,111,32,83,73,68,0,0,0,0,0,0,32,32,32,32,36,37,48,50,120,0,0,0,0,0,0,0,83,105,100,77,111,100,101,108,0,0,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,86,105,114,116,117,97,108,68,101,118,105,99,101,115,0,0,46,100,56,49,0,0,0,0,82,111,109,115,101,116,65,114,99,104,105,118,101,65,99,116,105,118,101,0,0,0,0,0,32,9,44,0,0,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,10,80,111,105,110,116,101,114,58,32,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,68,114,105,118,101,114,61,36,37,48,52,88,44,32,73,109,97,103,101,61,36,37,48,52,88,45,36,37,48,52,88,44,32,73,110,105,116,61,36,37,48,52,88,44,32,80,108,97,121,61,36,37,48,52,88,0,46,100,56,48,0,0,0,0,46,122,0,0,0,0,0,0,83,111,117,110,100,83,97,109,112,108,101,82,97,116,101,0,37,112,0,0,0,0,0,0,100,101,102,97,117,108,116,0,99,111,109,112,114,101,115,115,58,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,114,101,115,115,32,122,105,112,99,111,100,101,45,102,105,108,101,46,0,0,0,0,0,0,102,97,108,115,101,0,0,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,107,101,121,32,96,37,115,39,33,0,0,0,0,0,0,0,0,83,112,101,101,100,0,0,0,110,111,0,0,0,0,0,0,47,104,111,109,101,47,115,97,115,113,47,112,114,111,106,101,99,116,115,47,103,114,97,112,112,105,120,47,112,108,97,121,115,105,100,46,99,112,112,0,78,111,32,115,112,97,99,101,32,102,111,114,32,100,114,105,118,101,114,46,0,0,0,0,46,100,55,49,0,0,0,0,78,111,32,116,114,97,112,32,96,37,115,39,32,105,110,115,116,97,108,108,101,100,63,0,46,103,122,0,0,0,0,0,73,68,32,48,32,116,114,97,110,115,108,97,116,101,32,101,114,114,111,114,0,0,0,0,82,111,109,115,101,116,65,114,99,104,105,118,101,78,97,109,101,0,0,0,0,0,0,0,76,111,97,100,105,110,103,32,115,121,115,116,101,109,32,102,105,108,101,32,96,37,115,39,46,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,32,9,58,0,0,0,0,0,121,101,115,0,0,0,0,0,86,105,99,101,112,108,97,121,101,114,32,100,101,115,116,114,111,121,0,0,0,0,0,0,77,111,114,101,32,116,104,97,110,32,54,52,75,32,80,83,73,68,32,100,97,116,97,46,0,0,0,0,0,0,0,0,40,111,102,102,115,101,116,32,62,62,32,53,41,32,60,32,50,48,0,0,0,0,0,0,46,100,54,52,0,0,0,0,47,116,109,112,0,0,0,0,82,111,109,115,101,116,83,111,117,114,99,101,70,105,108,101,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,76,111,97,100,105,110,103,32,107,101,121,109,97,112,32,96,37,115,39,46,0,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,37,115,32,114,101,115,111,117,114,99,101,115,46,10,0,0,0,0,0,0,0,0,32,32,37,53,115,0,0,0,82,101,97,100,105,110,103,32,80,83,73,68,32,100,97,116,97,46,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,77,80,68,73,82,0,0,82,111,109,115,101,116,0,0,114,0,0,0,0,0,0,0,10,69,110,97,98,108,101,100,58,32,0,0,0,0,0,0,58,32,0,0,0,0,0,0,83,101,116,116,105,110,103,32,99,97,108,108,98,97,99,107,32,105,110,32,37,112,0,0,82,101,97,100,105,110,103,32,80,83,73,68,32,108,111,97,100,32,97,100,100,114,101,115,115,46,0,0,0,0,0,0,45,99,100,0,0,0,0,0,87,97,114,110,105,110,103,32,45,32,0,0,0,0,0,0,92,93,0,0,0,0,0,0,83,111,117,110,100,58,32,37,115,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,0,0,0,0,74,111,121,79,112,112,111,115,105,116,101,0,0,0,0,0,67,111,110,115,111,108,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,102,97,105,108,101,100,46,0,0,10,32,32,32,32,32,32,32,32,32,32,32,83,112,114,46,48,32,32,83,112,114,46,49,32,32,83,112,114,46,50,32,32,83,112,114,46,51,32,32,83,112,114,46,52,32,32,83,112,114,46,53,32,32,83,112,114,46,54,32,32,83,112,114,46,55,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,69,120,116,114,97,74,111,121,0,0,0,0,0,0,0,0,115,116,100,58,58,101,120,99,101,112,116,105,111,110,0,0,83,73,68,80,76,65,89,69,82,32,77,85,83,32,102,105,108,101,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,0,0,0,0,0,0,68,111,110,101,32,99,98,32,37,100,0,0,0,0,0,0,46,98,122,50,0,0,0,0,93,0,0,0,0,0,0,0,66,117,102,102,101,114,32,111,118,101,114,102,108,111,119,32,119,97,114,110,105,110,103,32,114,101,112,101,97,116,101,100,32,50,53,32,116,105,109,101,115,44,32,119,105,108,108,32,110,111,119,32,98,101,32,105,103,110,111,114,101,100,0,0,105,110,116,101,114,114,117,112,116,95,115,101,116,95,105,114,113,40,41,58,32,119,114,111,110,103,32,110,105,114,113,33,0,0,0,0,0,0,0,0,75,101,121,83,101,116,69,110,97,98,108,101,0,0,0,0,82,101,115,116,111,114,101,0,77,97,99,104,105,110,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,102,97,105,108,101,100,46,0,0,10,83,112,114,105,116,101,115,58,0,0,0,0,0,0,0,65,116,116,97,99,104,68,101,118,105,99,101,37,100,82,101,97,100,111,110,108,121,0,0,67,97,108,108,105,110,103,32,99,97,108,108,98,97,99,107,32,102,111,114,32,39,37,115,39,0,0,0,0,0,0,0,82,101,97,100,105,110,103,32,80,83,73,68,32,104,101,97,100,101,114,46,0,0,0,0,37,48,50,100,58,37,48,50,100,46,37,48,50,100,32,45,32,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,45,122,99,114,101,97,116,101,0,0,0,0,0,0,0,0,115,121,115,116,101,109,32,102,105,108,101,32,108,111,99,97,116,111,114,0,0,0,0,0,86,73,67,73,73,66,111,114,100,101,114,77,111,100,101,0,92,91,0,0,0,0,0,0,37,115,0,0,0,0,0,0,82,101,100,0,0,0,0,0,86,73,67,45,73,73,0,0,118,105,99,101,115,110,100,46,119,97,118,0,0,0,0,0,118,105,99,101,115,110,100,46,118,111,99,0,0,0,0,0,118,105,99,101,115,110,100,46,105,102,102,0,0,0,0,0,119,98,0,0,0,0,0,0,37,100,32,37,100,32,37,100,10,0,0,0,0,0,0,0,118,105,99,101,115,110,100,46,97,105,102,102,0,0,0,0,83,105,100,83,116,101,114,101,111,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,0,0,0,0,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,75,101,121,83,101,116,50,70,105,114,101,0,0,0,0,0,37,115,95,84,66,0,0,0,75,101,121,98,111,97,114,100,0,0,0,0,0,0,0,0,67,104,97,114,97,99,116,101,114,32,83,101,116,58,32,32,32,32,32,36,37,48,52,120,10,0,0,0,0,0,0,0,100,101,102,97,117,108,116,0,119,98,0,0,0,0,0,0,83,105,100,77,111,100,101,108,0,0,0,0,0,0,0,0,67,73,65,50,77,111,100,101,108,0,0,0,0,0,0,0,75,101,121,109,97,112,83,121,109,68,101,70,105,108,101,0,46,46,47,99,104,105,112,109,97,99,104,105,110,101,47,115,114,99,47,112,108,117,103,105,110,115,47,86,105,99,101,80,108,117,103,105,110,47,47,46,47,46,46,47,46,46,47,67,104,105,112,80,108,97,121,101,114,46,104,0,0,0,0,0,85,110,107,110,111,119,110,32,80,83,73,68,32,118,101,114,115,105,111,110,32,110,117,109,98,101,114,58,32,37,100,46,0,0,0,0,0,0,0,0,45,117,110,108,121,110,120,0,115,117,115,112,101,110,100,44,32,100,105,115,97,98,108,105,110,103,32,115,111,117,110,100,32,102,111,114,32,37,100,32,115,101,99,115,32,40,37,115,41,0,0,0,0,0,0,0,75,101,121,83,101,116,50,87,101,115,116,0,0,0,0,0,75,101,121,109,97,112,73,110,100,101,120,0,0,0,0,0,66,105,116,109,97,112,32,77,101,109,111,114,121,58,32,32,32,32,32,36,37,48,52,120,10,0,0,0,0,0,0,0,73,109,97,103,101,32,119,97,115,110,39,116,32,97,116,116,97,99,104,101,100,46,32,80,108,97,121,98,97,99,107,32,119,105,108,108,32,112,114,111,98,97,98,108,121,32,103,101,116,32,111,117,116,32,111,102,32,115,121,110,99,46,0,0,91,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,82,83,73,68,0,0,0,0,120,54,52,0,0,0,0,0,92,92,0,0,0,0,0,0,65,118,97,105,108,97,98,108,101,32,115,111,117,110,100,32,100,101,118,105,99,101,115,58,37,115,0,0,0,0,0,0,56,53,56,48,0,0,0,0,75,101,121,83,101,116,50,83,111,117,116,104,87,101,115,116,0,0,0,0,0,0,0,0,37,37,37,48,50,120,0,0,73,110,118,97,108,105,100,32,82,79,77,32,114,101,118,105,115,105,111,110,32,96,37,115,39,46,0,0,0,0,0,0,40,110,117,108,108,41,0,0,71,114,97,112,112,105,120,0,83,105,100,83,116,101,114,101,111,0,0,0,0,0,0,0,10,86,105,100,101,111,32,77,101,109,111,114,121,58,32,32,32,32,32,32,36,37,48,52,120,10,0,0,0,0,0,0,80,108,101,97,115,101,32,97,116,116,97,99,104,32,105,109,97,103,101,32,37,115,32,40,67,82,67,51,50,32,99,104,101,99,107,115,117,109,32,48,120,37,120,41,0,0,0,0,109,101,116,97,101,110,100,0,80,83,73,68,0,0,0,0,87,97,114,110,105,110,103,58,32,85,110,107,110,111,119,110,32,75,101,114,110,97,108,32,105,109,97,103,101,46,32,32,83,117,109,58,32,37,100,32,40,36,37,48,52,88,41,46,0,0,0,0,0,0,0,0,108,121,110,120,105,109,97,103,101,44,48,48,0,0,0,0,92,0,0,0,0,0,0,0,83,111,117,110,100,0,0,0,47,104,111,109,101,47,115,97,115,113,47,112,114,111,106,101,99,116,115,47,99,104,105,112,109,97,99,104,105,110,101,47,115,114,99,47,112,108,117,103,105,110,115,47,86,105,99,101,80,108,117,103,105,110,47,118,105,99,101,47,99,54,52,47,99,54,52,105,111,46,99,0,100,117,109,109,121,0,0,0,75,101,121,83,101,116,50,83,111,117,116,104,0,0,0,0,67,97,110,110,111,116,32,108,111,97,100,32,107,101,121,109,97,112,32,96,37,115,39,46,0,0,0,0,0,0,0,0,10,86,73,67,32,77,101,109,111,114,121,32,66,97,110,107,58,32,32,32,36,37,48,52,120,32,45,32,36,37,48,52,120,10,0,0,0,0,0,0,75,101,121,109,97,112,83,121,109,68,101,70,105,108,101,0,115,116,97,114,116,115,111,110,103,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,32,32,32,77,97,105,110,32,67,80,85,58,32,74,65,77,32,97,116,32,36,37,48,52,88,32,32,32,0,0,0,0,45,102,111,114,109,97,116,0,114,117,110,110,105,110,103,32,116,111,111,32,115,108,111,119,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,99,111,109,112,114,101,115,115,58,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,114,101,115,115,32,97,114,99,104,105,118,101,45,102,105,108,101,46,0,0,0,0,0,0,75,101,121,83,101,116,50,83,111,117,116,104,69,97,115,116,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,111,102,102,0,0,0,0,0,109,111,110,105,116,111,114,0,83,99,114,101,101,110,32,83,105,122,101,58,32,32,37,100,32,120,32,37,100,10,0,0,120,49,49,95,112,111,115,46,118,107,109,0,0,0,0,0,115,111,110,103,115,0,0,0,86,115,105,100,0,0,0,0,100,101,102,97,117,108,116,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,114,101,115,111,117,114,99,101,32,104,97,110,100,108,105,110,103,46,10,0,0,0,99,49,53,52,49,0,0,0,84,82,65,78,83,76,65,84,69,32,69,82,82,79,82,58,32,73,68,32,48,32,119,97,115,32,114,101,113,117,101,115,116,101,100,46,0,0,0,0,66,117,102,102,101,114,32,100,114,97,105,110,101,100,32,119,97,114,110,105,110,103,32,114,101,112,101,97,116,101,100,32,50,53,32,116,105,109,101,115,44,32,119,105,108,108,32,110,111,119,32,98,101,32,105,103,110,111,114,101,100,0,0,0,83,80,65,87,78,33,32,37,115,10,0,0,0,0,0,0,86,73,67,73,73,0,0,0,86,105,99,73,73,82,97,115,116,101,114,70,101,116,99,104,0,0,0,0,0,0,0,0,115,116,97,114,116,115,111,110,103,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,75,101,121,83,101,116,50,69,97,115,116,0,0,0,0,0,118,101,99,116,111,114,0,0,111,110,0,0,0,0,0,0,110,101,116,119,111,114,107,0,70,108,105,112,108,105,115,116,78,97,109,101,0,0,0,0,83,99,114,111,108,108,32,88,47,89,58,32,32,32,37,100,47,37,100,10,0,0,0,0,47,0,0,0,0,0,0,0,66,108,97,99,107,0,0,0,75,101,121,109,97,112,80,111,115,70,105,108,101,0,0,0,99,111,112,121,114,105,103,104,116,0,0,0,0,0,0,0,56,53,56,48,82,53,95,49,52,56,57,68,0,0,0,0,47,104,111,109,101,47,115,97,115,113,47,112,114,111,106,101,99,116,115,47,99,104,105,112,109,97,99,104,105,110,101,47,115,114,99,47,112,108,117,103,105,110,115,47,86,105,99,101,80,108,117,103,105,110,47,118,105,99,101,47,115,111,117,110,100,46,99,0,0,0,0,0,66,117,102,102,101,114,32,100,114,97,105,110,101,100,0,0,37,115,0,0,0,0,0,0,115,111,110,103,115,0,0,0,86,73,67,45,73,73,101,0,75,101,121,83,101,116,50,78,111,114,116,104,69,97,115,116,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,119,97,118,0,0,0,0,0,118,111,99,0,0,0,0,0,71,70,88,79,85,84,80,85,84,0,0,0,0,0,0,0,76,105,103,104,116,32,71,114,101,121,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,77,117,67,111,108,49,58,32,37,50,100,32,77,117,67,111,108,50,58,32,37,50,100,10,0,0,101,110,100,46,118,115,102,0,120,49,49,95,115,121,109,46,118,107,109,0,0,0,0,0,105,102,102,0,0,0,0,0,102,115,0,0,0,0,0,0,114,101,83,73,68,58,32,37,115,44,32,102,105,108,116,101,114,32,37,115,44,32,115,97,109,112,108,105,110,103,32,114,97,116,101,32,37,100,72,122,32,45,32,37,115,0,0,0,56,53,56,48,82,53,95,49,52,56,57,0,0,0,0,0,100,117,109,112,0,0,0,0,68,117,112,108,105,99,97,116,101,100,32,114,101,115,111,117,114,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,46,10,0,0,97,105,102,102,0,0,0,0,54,52,116,122,120,116,97,112,0,0,0,0,0,0,0,0,83,105,100,69,110,103,105,110,101,0,0,0,0,0,0,0,98,117,102,102,101,114,32,111,118,101,114,114,117,110,115,0,126,0,0,0,0,0,0,0,99,111,112,121,114,105,103,104,116,0,0,0,0,0,0,0,75,101,121,83,101,116,50,78,111,114,116,104,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,114,101,83,73,68,58,32,79,117,116,32,111,102,32,115,112,101,99,44,32,105,110,99,114,101,97,115,101,32,115,97,109,112,108,105,110,103,32,114,97,116,101,32,111,114,32,100,101,99,114,101,97,115,101,32,109,97,120,105,109,117,109,32,115,112,101,101,100,0,0,0,0,82,65,77,0,0,0,0,0,9,110,111,116,104,105,110,103,0,0,0,0,0,0,0,0,76,105,103,104,116,32,66,108,117,101,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,66,71,67,111,108,49,58,32,37,50,100,32,66,71,67,111,108,50,58,32,37,50,100,32,66,71,67,111,108,51,58,32,37,50,100,10,0,0,0,0,0,0,69,118,101,110,116,69,110,100,83,110,97,112,115,104,111,116,0,0,0,0,0,0,0,0,75,101,121,109,97,112,83,121,109,70,105,108,101,0,0,0,86,73,67,45,73,73,0,0,116,105,116,108,101,0,0,0,56,53,56,48,82,53,95,51,54,57,49,68,0,0,0,0,77,97,105,110,67,80,85,0,83,105,100,69,110,103,105,110,101,0,0,0,0,0,0,0,35,83,73,68,58,32,99,108,107,61,37,108,100,32,118,61,37,100,32,115,51,61,37,100,10,0,0,0,0,0,0,0,86,105,100,101,111,67,97,99,104,101,0,0,0,0,0,0,46,116,122,120,0,0,0,0,102,114,97,103,109,101,110,116,32,112,114,111,98,108,101,109,115,32,37,100,32,37,100,0,86,73,67,69,58,32,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,0,0,0,0,83,97,116,0,0,0,0,0,70,114,105,0,0,0,0,0,75,101,121,83,101,116,50,78,111,114,116,104,87,101,115,116,0,0,0,0,0,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,37,76,102,0,0,0,0,0,84,104,117,0,0,0,0,0,114,101,115,97,109,112,108,105,110,103,44,32,112,97,115,115,32,116,111,32,37,100,72,122,0,0,0,0,0,0,0,0,106,111,121,115,116,105,99,107,0,0,0,0,0,0,0,0,9,85,110,105,116,32,37,100,32,37,115,32,40,110,58,32,37,115,44,32,112,58,37,115,41,0,0,0,0,0,0,0,76,105,103,104,116,32,71,114,101,101,110,0,0,0,0,0,10,67,111,108,111,114,115,58,32,32,32,32,32,32,32,66,111,114,100,101,114,58,32,37,50,100,32,66,97,99,107,103,114,111,117,110,100,58,32,37,50,100,10,0,0,0,0,0,115,116,97,114,116,46,118,115,102,0,0,0,0,0,0,0,86,73,67,45,73,73,32,36,68,49,48,48,45,36,68,49,70,70,32,109,105,114,114,111,114,115,0,0,0,0,0,0,87,101,100,0,0,0,0,0,37,115,95,73,68,76,69,0,84,117,101,0,0,0,0,0,76,111,97,100,101,100,32,37,115,32,45,62,32,37,100,0,56,53,56,48,82,53,95,51,54,57,49,0,0,0,0,0,77,111,110,0,0,0,0,0,83,117,110,0,0,0,0,0,119,98,57,0,0,0,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,67,108,111,115,105,110,103,32,114,101,99,111,114,100,105,110,103,32,100,101,118,105,99,101,32,96,37,115,39,0,0,0,70,114,105,100,97,121,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,116,105,116,108,101,0,0,0,75,101,121,83,101,116,49,70,105,114,101,0,0,0,0,0,84,117,101,115,100,97,121,0,105,110,116,101,114,114,117,112,116,95,115,101,116,95,110,109,105,40,41,58,32,119,114,111,110,103,32,110,110,109,105,33,0,0,0,0,0,0,0,0,77,111,110,100,97,121,0,0,109,97,99,104,105,110,101,0,105,110,116,101,114,112,111,108,97,116,105,110,103,0,0,0,70,108,105,112,108,105,115,116,91,37,100,93,32,99,111,110,116,97,105,110,115,58,0,0,77,101,100,105,117,109,32,71,114,101,121,0,0,0,0,0,32,84,101,120,116,0,0,0,69,118,101,110,116,83,116,97,114,116,83,110,97,112,115,104,111,116,0,0,0,0,0,0,83,117,110,100,97,121,0,0,75,101,114,110,97,108,82,101,118,0,0,0,0,0,0,0,86,73,67,45,73,73,32,36,68,50,48,48,45,36,68,50,70,70,32,109,105,114,114,111,114,115,0,0,0,0,0,0,54,53,56,49,82,52,95,49,57,56,54,83,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,108,111,103,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,86,73,67,73,73,0,0,0,86,105,99,73,73,82,97,115,116,101,114,73,114,113,0,0,87,104,105,116,101,0,0,0,67,108,111,115,105,110,103,32,100,101,118,105,99,101,32,96,37,115,39,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,86,73,67,45,73,73,32,68,84,86,0,0,0,0,0,0,69,82,82,79,82,32,119,97,118,95,99,108,111,115,101,32,102,97,105,108,101,100,46,0,69,82,82,79,82,32,118,111,99,95,99,108,111,115,101,32,102,97,105,108,101,100,46,0,115,111,117,110,100,109,111,118,105,101,0,0,0,0,0,0,69,82,82,79,82,32,105,102,102,95,99,108,111,115,101,32,102,97,105,108,101,100,46,0,118,105,99,101,115,110,100,46,114,97,119,0,0,0,0,0,67,73,65,49,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,37,115,0,0,0,0,0,0,69,82,82,79,82,32,97,105,102,102,95,99,108,111,115,101,32,102,97,105,108,101,100,46,0,0,0,0,0,0,0,0,83,105,100,77,111,100,101,108,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,83,105,100,83,116,101,114,101,111,0,0,0,0,0,0,0,65,68,83,82,73,0,0,0,111,110,76,111,97,100,32,39,37,115,39,0,0,0,0,0,32,101,109,117,108,97,116,111,114,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,75,101,121,83,101,116,49,87,101,115,116,0,0,0,0,0,37,115,95,84,65,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,100,101,98,117,103,0,0,0,70,108,105,112,108,105,115,116,32,104,97,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,118,105,101,119,32,102,111,114,32,117,110,105,116,44,32,97,115,115,117,109,105,110,103,32,56,46,10,0,0,0,68,97,114,107,32,71,114,101,121,0,0,0,0,0,0,0,32,66,105,116,109,97,112,0,67,73,65,50,0,0,0,0,67,73,65,50,0,0,0,0,46,47,0,0,0,0,0,0,10,83,121,110,99,104,114,111,110,111,117,115,32,83,101,114,105,97,108,32,73,47,79,32,68,97,116,97,32,66,117,102,102,101,114,58,32,37,48,50,120,10,0,0,0,0,0,0,98,97,115,105,99,0,0,0,86,73,67,45,73,73,32,36,68,51,48,48,45,36,68,51,70,70,32,109,105,114,114,111,114,115,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,67,73,65,49,77,111,100,101,108,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,75,101,121,109,97,112,80,111,115,70,105,108,101,0,0,0,83,105,100,70,105,108,116,101,114,115,0,0,0,0,0,0,102,97,115,116,0,0,0,0,67,73,65,49,0,0,0,0,54,53,56,49,82,51,95,52,52,56,53,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,67,104,97,114,103,101,110,78,97,109,101,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,45,99,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,97,99,104,105,110,101,86,105,100,101,111,83,116,97,110,100,97,114,100,0,0,0,0,47,0,0,0,0,0,0,0,79,112,101,110,101,100,32,114,101,99,111,114,100,105,110,103,32,100,101,118,105,99,101,32,100,101,118,105,99,101,32,96,37,115,39,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,68,111,67,111,114,101,68,117,109,112,0,0,0,0,0,0,68,101,99,0,0,0,0,0,114,98,0,0,0,0,0,0,75,101,121,83,101,116,49,83,111,117,116,104,87,101,115,116,0,0,0,0,0,0,0,0,78,111,118,0,0,0,0,0,79,99,116,0,0,0,0,0,101,118,101,110,116,0,0,0,68,84,86,83,73,68,0,0,76,105,103,104,116,32,82,101,100,0,0,0,0,0,0,0,85,78,73,84,32,0,0,0,32,72,105,114,101,115,0,0,69,118,101,110,116,83,110,97,112,115,104,111,116,68,105,114,0,0,0,0,0,0,0,0,84,79,68,58,32,32,32,32,32,37,100,58,37,100,58,37,100,58,37,100,10,0,0,0,66,97,115,105,99,78,97,109,101,0,0,0,0,0,0,0,83,73,68,0,0,0,0,0,83,101,112,0,0,0,0,0,75,101,121,109,97,112,83,121,109,70,105,108,101,0,0,0,65,117,103,0,0,0,0,0,46,50,115,105,100,0,0,0,99,54,52,47,98,97,115,105,99,0,0,0,0,0,0,0,99,54,52,0,0,0,0,0,115,111,117,110,100,95,99,104,105,112,95,114,101,103,105,115,116,101,114,0,0,0,0,0,105,111,95,115,111,117,114,99,101,95,117,110,114,101,103,105,115,116,101,114,0,0,0,0,105,111,95,115,111,117,114,99,101,95,114,101,103,105,115,116,101,114,0,0,0,0,0,0,105,111,95,115,111,117,114,99,101,95,100,101,116,97,99,104,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,72,58,37,77,58,37,83,37,72,58,37,77,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,89,45,37,109,45,37,100,37,109,47,37,100,47,37,121,37,72,58,37,77,58,37,83,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,5,0,0,48,5,0,0,194,4,0,0,93,4,0,0,0,4,0,0,171,3,0,0,93,3,0,0,22,3,0,0,212,2,0,0,152,2,0,0,97,2,0,0,46,2,0,0,0,2,0,0,214,1,0,0,175,1,0,0,139,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,172,0,0,16,128,2,0,0,64,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,48,123,1,0,204,0,0,0,168,0,0,0,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,123,1,0,16,1,0,0,226,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,123,1,0,216,0,0,0,124,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,123,1,0,216,0,0,0,104,1,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,123,1,0,140,0,0,0,72,1,0,0,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,123,1,0,140,0,0,0,30,0,0,0,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,123,1,0,140,0,0,0,44,0,0,0,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,123,1,0,232,0,0,0,126,0,0,0,84,0,0,0,24,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,123,1,0,98,1,0,0,0,1,0,0,84,0,0,0,22,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,123,1,0,224,0,0,0,2,1,0,0,84,0,0,0,28,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,124,1,0,100,1,0,0,196,0,0,0,84,0,0,0,26,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,124,1,0,94,1,0,0,138,0,0,0,84,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,124,1,0,220,0,0,0,208,0,0,0,84,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,124,1,0,66,0,0,0,210,0,0,0,84,0,0,0,212,0,0,0,26,0,0,0,50,0,0,0,28,0,0,0,40,0,0,0,76,0,0,0,24,0,0,0,248,255,255,255,232,124,1,0,56,0,0,0,30,0,0,0,74,0,0,0,44,0,0,0,22,0,0,0,72,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,125,1,0,80,1,0,0,56,1,0,0,84,0,0,0,54,0,0,0,22,0,0,0,80,0,0,0,46,0,0,0,38,0,0,0,24,0,0,0,22,0,0,0,248,255,255,255,16,125,1,0,132,0,0,0,184,0,0,0,204,0,0,0,220,0,0,0,174,0,0,0,94,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,125,1,0,116,0,0,0,4,1,0,0,84,0,0,0,100,0,0,0,86,0,0,0,40,0,0,0,136,0,0,0,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,125,1,0,150,0,0,0,106,0,0,0,84,0,0,0,90,0,0,0,158,0,0,0,54,0,0,0,170,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,125,1,0,86,1,0,0,22,0,0,0,84,0,0,0,56,0,0,0,52,0,0,0,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,125,1,0,78,0,0,0,26,0,0,0,84,0,0,0,38,0,0,0,34,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,125,1,0,42,1,0,0,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,125,1,0,56,0,0,0,194,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,125,1,0,86,0,0,0,236,0,0,0,84,0,0,0,46,0,0,0,26,0,0,0,34,0,0,0,24,0,0,0,32,0,0,0,24,0,0,0,22,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,125,1,0,146,0,0,0,42,0,0,0,84,0,0,0,38,0,0,0,42,0,0,0,52,0,0,0,40,0,0,0,42,0,0,0,28,0,0,0,26,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,125,1,0,68,0,0,0,48,0,0,0,84,0,0,0,68,0,0,0,56,0,0,0,62,0,0,0,64,0,0,0,48,0,0,0,54,0,0,0,60,0,0,0,72,0,0,0,70,0,0,0,58,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,126,1,0,90,0,0,0,24,0,0,0,84,0,0,0,96,0,0,0,90,0,0,0,84,0,0,0,86,0,0,0,78,0,0,0,88,0,0,0,82,0,0,0,74,0,0,0,94,0,0,0,92,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,126,1,0,112,0,0,0,136,0,0,0,84,0,0,0,36,0,0,0,34,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,126,1,0,54,0,0,0,240,0,0,0,84,0,0,0,50,0,0,0,38,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,126,1,0,98,0,0,0,252,0,0,0,84,0,0,0,22,0,0,0,30,0,0,0,46,0,0,0,210,0,0,0,128,0,0,0,60,0,0,0,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,126,1,0,244,0,0,0,186,0,0,0,84,0,0,0,34,0,0,0,36,0,0,0,52,0,0,0,106,0,0,0,28,0,0,0,54,0,0,0,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,126,1,0,244,0,0,0,238,0,0,0,84,0,0,0,26,0,0,0,24,0,0,0,32,0,0,0,176,0,0,0,122,0,0,0,42,0,0,0,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,126,1,0,244,0,0,0,152,0,0,0,84,0,0,0,32,0,0,0,28,0,0,0,56,0,0,0,70,0,0,0,38,0,0,0,38,0,0,0,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,126,1,0,244,0,0,0,60,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,126,1,0,96,0,0,0,214,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,126,1,0,244,0,0,0,120,0,0,0])
.concat([84,0,0,0,52,0,0,0,22,0,0,0,24,0,0,0,34,0,0,0,70,0,0,0,66,0,0,0,158,0,0,0,28,0,0,0,46,0,0,0,32,0,0,0,40,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,127,1,0,102,1,0,0,62,0,0,0,84,0,0,0,28,0,0,0,26,0,0,0,108,0,0,0,74,0,0,0,56,0,0,0,26,0,0,0,58,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,127,1,0,108,0,0,0,50,1,0,0,144,0,0,0,54,0,0,0,46,0,0,0,70,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,80,127,1,0,24,1,0,0,62,1,0,0,56,0,0,0,248,255,255,255,80,127,1,0,82,0,0,0,100,0,0,0,192,255,255,255,192,255,255,255,80,127,1,0,34,1,0,0,26,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,127,1,0,172,0,0,0,192,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,127,1,0,244,0,0,0,128,0,0,0,84,0,0,0,32,0,0,0,28,0,0,0,56,0,0,0,70,0,0,0,38,0,0,0,38,0,0,0,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,127,1,0,244,0,0,0,74,1,0,0,84,0,0,0,32,0,0,0,28,0,0,0,56,0,0,0,70,0,0,0,38,0,0,0,38,0,0,0,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,127,1,0,82,1,0,0,40,1,0,0,180,0,0,0,76,0,0,0,44,0,0,0,24,0,0,0,102,0,0,0,160,0,0,0,50,0,0,0,216,0,0,0,32,0,0,0,178,0,0,0,48,0,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,127,1,0,182,0,0,0,68,1,0,0,66,0,0,0,54,0,0,0,32,0,0,0,36,0,0,0,164,0,0,0,180,0,0,0,72,0,0,0,68,0,0,0,50,0,0,0,50,0,0,0,80,0,0,0,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,127,1,0,32,0,0,0,170,0,0,0,180,0,0,0,76,0,0,0,50,0,0,0,32,0,0,0,102,0,0,0,160,0,0,0,50,0,0,0,26,0,0,0,32,0,0,0,202,0,0,0,48,0,0,0,150,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,248,127,1,0,74,0,0,0,38,1,0,0,252,255,255,255,252,255,255,255,248,127,1,0,200,0,0,0,180,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,16,128,1,0,76,0,0,0,70,1,0,0,252,255,255,255,252,255,255,255,16,128,1,0,160,0,0,0,20,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,40,128,1,0,132,0,0,0,106,1,0,0,248,255,255,255,248,255,255,255,40,128,1,0,246,0,0,0,66,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,64,128,1,0,158,0,0,0,30,1,0,0,248,255,255,255,248,255,255,255,64,128,1,0,190,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,128,1,0,28,1,0,0,248,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,1,0,88,1,0,0,60,1,0,0,62,0,0,0,54,0,0,0,32,0,0,0,36,0,0,0,114,0,0,0,180,0,0,0,72,0,0,0,68,0,0,0,50,0,0,0,50,0,0,0,68,0,0,0,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,128,1,0,212,0,0,0,242,0,0,0,106,0,0,0,76,0,0,0,50,0,0,0,32,0,0,0,166,0,0,0,160,0,0,0,50,0,0,0,26,0,0,0,32,0,0,0,202,0,0,0,78,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,128,1,0,52,1,0,0,198,0,0,0,84,0,0,0,130,0,0,0,206,0,0,0,154,0,0,0,236,0,0,0,28,0,0,0,90,0,0,0,108,0,0,0,70,0,0,0,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,128,1,0,156,0,0,0,92,0,0,0,84,0,0,0,192,0,0,0,198,0,0,0,200,0,0,0,220,0,0,0,228,0,0,0,78,0,0,0,196,0,0,0,164,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,129,1,0,58,1,0,0,166,0,0,0,84,0,0,0,46,0,0,0,120,0,0,0,32,0,0,0,148,0,0,0,244,0,0,0,166,0,0,0,172,0,0,0,172,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,129,1,0,114,0,0,0,234,0,0,0,84,0,0,0,182,0,0,0,186,0,0,0,88,0,0,0,216,0,0,0,80,0,0,0,68,0,0,0,146,0,0,0,210,0,0,0,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,129,1,0,14,1,0,0,40,0,0,0,174,0,0,0,54,0,0,0,32,0,0,0,36,0,0,0,164,0,0,0,180,0,0,0,72,0,0,0,134,0,0,0,152,0,0,0,60,0,0,0,80,0,0,0,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,129,1,0,38,0,0,0,44,1,0,0,198,0,0,0,76,0,0,0,50,0,0,0,32,0,0,0,102,0,0,0,160,0,0,0,50,0,0,0,48,0,0,0,64,0,0,0,30,0,0,0,48,0,0,0,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,129,1,0,90,1,0,0,18,1,0,0,104,0,0,0,142,0,0,0,36,0,0,0,22,0,0,0,26,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,129,1,0,64,1,0,0,118,0,0,0,58,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,129,1,0,162,0,0,0,148,0,0,0,60,0,0,0,30,0,0,0,32,0,0,0,126,0,0,0,50,0,0,0,62,0,0,0,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,129,1,0,96,1,0,0,34,0,0,0,44,0,0,0,30,0,0,0,34,0,0,0,126,0,0,0,50,0,0,0,62,0,0,0,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,83,116,57,101,120,99,101,112,116,105,111,110,0,0,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,83,116,49,52,111,118,101,114,102,108,111,119,95,101,114,114,111,114,0,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,78,83,116,51,95,95,49,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,55,98,97,100,95,102,117,110,99,116,105,111,110,95,99,97,108,108,69,0,0,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,49,48,86,105,99,101,80,108,117,103,105,110,0,0,0,0,49,48,86,105,99,101,80,108,97,121,101,114,0,0,0,0,49,48,67,104,105,112,80,108,117,103,105,110,0,0,0,0,49,48,67,104,105,112,80,108,97,121,101,114,0,0,0,0,0,0,0,0,40,110,1,0,0,0,0,0,56,110,1,0,0,0,0,0,72,110,1,0,40,123,1,0,0,0,0,0,0,0,0,0,88,110,1,0,40,123,1,0,0,0,0,0,0,0,0,0,104,110,1,0,96,123,1,0,0,0,0,0,0,0,0,0,128,110,1,0,40,123,1,0,0,0,0,0,0,0,0,0,152,110,1,0,144,123,1,0,0,0,0,0,0,0,0,0,176,110,1,0,144,123,1,0,0,0,0,0,0,0,0,0,200,110,1,0,40,123,1,0,0,0,0,0,0,0,0,0,216,110,1,0,112,109,1,0,240,110,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,160,128,1,0,0,0,0,0,112,109,1,0,56,111,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,168,128,1,0,0,0,0,0,112,109,1,0,128,111,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,176,128,1,0,0,0,0,0,112,109,1,0,200,111,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,184,128,1,0,0,0,0,0,0,0,0,0,16,112,1,0,152,125,1,0,0,0,0,0,0,0,0,0,64,112,1,0,152,125,1,0,0,0,0,0,112,109,1,0,112,112,1,0,0,0,0,0,1,0,0,0,224,127,1,0,0,0,0,0,112,109,1,0,136,112,1,0,0,0,0,0,1,0,0,0,224,127,1,0,0,0,0,0,112,109,1,0,160,112,1,0,0,0,0,0,1,0,0,0,232,127,1,0,0,0,0,0,112,109,1,0,184,112,1,0,0,0,0,0,1,0,0,0,232,127,1,0,0,0,0,0,112,109,1,0,208,112,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,80,129,1,0,0,8,0,0,112,109,1,0,24,113,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,80,129,1,0,0,8,0,0,112,109,1,0,96,113,1,0,0,0,0,0,3,0,0,0,208,126,1,0,2,0,0,0,160,123,1,0,2,0,0,0,48,127,1,0,0,8,0,0,112,109,1,0,168,113,1,0,0,0,0,0,3,0,0,0,208,126,1,0,2,0,0,0,160,123,1,0,2,0,0,0,56,127,1,0,0,8,0,0,0,0,0,0,240,113,1,0,208,126,1,0,0,0,0,0,0,0,0,0,8,114,1,0,208,126,1,0,0,0,0,0,112,109,1,0,32,114,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,240,127,1,0,2,0,0,0,112,109,1,0,56,114,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,240,127,1,0,2,0,0,0,0,0,0,0,80,114,1,0,0,0,0,0,104,114,1,0,88,128,1,0,0,0,0,0,112,109,1,0,136,114,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,72,124,1,0,0,0,0,0,112,109,1,0,208,114,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,96,124,1,0,0,0,0,0,112,109,1,0,24,115,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,120,124,1,0,0,0,0,0,112,109,1,0,96,115,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,144,124,1,0,0,0,0,0,0,0,0,0,168,115,1,0,208,126,1,0,0,0,0,0,0,0,0,0,192,115,1,0,208,126,1,0,0,0,0,0,112,109,1,0,216,115,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,104,128,1,0,2,0,0,0,112,109,1,0,0,116,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,104,128,1,0,2,0,0,0,112,109,1,0,40,116,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,104,128,1,0,2,0,0,0,112,109,1,0,80,116,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,104,128,1,0,2,0,0,0,0,0,0,0,120,116,1,0,216,127,1,0,0,0,0,0,0,0,0,0,144,116,1,0,208,126,1,0,0,0,0,0,112,109,1,0,168,116,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,72,129,1,0,2,0,0,0,112,109,1,0,192,116,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,72,129,1,0,2,0,0,0,0,0,0,0,216,116,1,0,0,0,0,0,0,117,1,0,0,0,0,0,40,117,1,0,112,128,1,0,0,0,0,0,0,0,0,0,72,117,1,0,184,127,1,0,0,0,0,0,0,0,0,0,144,117,1,0,40,123,1,0,0,0,0,0,0,0,0,0,176,117,1,0,176,126,1,0,0,0,0,0,0,0,0,0,216,117,1,0,176,126,1,0,0,0,0,0,0,0,0,0,0,118,1,0,168,127,1,0,0,0,0,0,0,0,0,0,72,118,1,0,0,0,0,0,128,118,1,0,0,0,0,0,184,118,1,0,112,109,1,0,216,118,1,0,3,0,0,0,2,0,0,0,64,128,1,0,2,0,0,0,16,128,1,0,2,8,0,0,0,0,0,0,8,119,1,0,0,0,0,0,40,119,1,0,0,0,0,0,72,119,1,0,0,0,0,0,104,119,1,0,112,109,1,0,128,119,1,0,0,0,0,0,1,0,0,0,40,124,1,0,3,244,255,255,112,109,1,0,176,119,1,0,0,0,0,0,1,0,0,0,56,124,1,0,3,244,255,255,112,109,1,0,224,119,1,0,0,0,0,0,1,0,0,0,40,124,1,0,3,244,255,255,112,109,1,0,16,120,1,0,0,0,0,0,1,0,0,0,56,124,1,0,3,244,255,255,0,0,0,0,64,120,1,0,96,123,1,0,0,0,0,0,0,0,0,0,88,120,1,0,0,0,0,0,112,120,1,0,176,127,1,0,0,0,0,0,0,0,0,0,136,120,1,0,160,127,1,0,0,0,0,0,0,0,0,0,168,120,1,0,168,127,1,0,0,0,0,0,0,0,0,0,200,120,1,0,0,0,0,0,232,120,1,0,0,0,0,0,8,121,1,0,0,0,0,0,40,121,1,0,112,109,1,0,72,121,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,64,129,1,0,2,0,0,0,112,109,1,0,104,121,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,64,129,1,0,2,0,0,0,112,109,1,0,136,121,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,64,129,1,0,2,0,0,0,112,109,1,0,168,121,1,0,0,0,0,0,2,0,0,0,208,126,1,0,2,0,0,0,64,129,1,0,2,0,0,0,0,0,0,0,200,121,1,0,0,0,0,0,224,121,1,0,0,0,0,0,248,121,1,0,0,0,0,0,16,122,1,0,160,127,1,0,0,0,0,0,0,0,0,0,40,122,1,0,168,127,1,0,0,0,0,0,0,0,0,0,64,122,1,0,152,129,1,0,0,0,0,0,0,0,0,0,104,122,1,0,152,129,1,0,0,0,0,0,0,0,0,0,144,122,1,0,168,129,1,0,0,0,0,0,0,0,0,0,184,122,1,0,32,123,1,0,0,0,0,0,0,0,0,0,224,122,1,0,216,129,1,0,0,0,0,0,0,0,0,0,240,122,1,0,224,129,1,0,0,0,0,0,0,0,0,0,0,123,1,0,0,0,0,0,16,123,1,0,64,0,0,0,0,0,0,0,64,128,1,0,158,0,0,0,30,1,0,0,192,255,255,255,192,255,255,255,64,128,1,0,190,0,0,0,88,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,1,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,121,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,143,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,169,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,187,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,209,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,5,0,0,0,7,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,211,0,0,0,1,0,0,0,0,0,0,0,205,204,204,204,204,204,244,63,82,184,30,133,235,209,33,64,205,204,204,204,204,204,244,63,82,184,30,133,235,209,33,64,10,215,163,112,61,10,19,64,82,184,30,133,235,209,33,64,20,174,71,225,122,20,19,64,205,204,204,204,204,204,33,64,31,133,235,81,184,30,19,64,195,245,40,92,143,194,33,64,164,112,61,10,215,35,19,64,184,30,133,235,81,184,33,64,41,92,143,194,245,40,19,64,154,153,153,153,153,153,33,64,174,71,225,122,20,46,19,64,51,51,51,51,51,51,33,64,51,51,51,51,51,51,19,64,0,0,0,0,0,128,32,64,184,30,133,235,81,56,19,64,0,0,0,0,0,0,30,64,61,10,215,163,112,61,19,64,102,102,102,102,102,102,24,64,195,245,40,92,143,66,19,64,51,51,51,51,51,51,16,64,72,225,122,20,174,71,19,64,41,92,143,194,245,40,2,64,205,204,204,204,204,76,19,64,102,102,102,102,102,102,250,63,82,184,30,133,235,81,19,64,205,204,204,204,204,204,248,63,92,143,194,245,40,92,19,64,133,235,81,184,30,133,247,63,102,102,102,102,102,102,19,64,225,122,20,174,71,225,246,63,123,20,174,71,225,122,19,64,236,81,184,30,133,235,245,63,154,153,153,153,153,153,19,64,113,61,10,215,163,112,245,63,0,0,0,0,0,0,20,64,205,204,204,204,204,204,244,63,102,102,102,102,102,102,20,64,205,204,204,204,204,204,244,63,82,184,30,133,235,209,33,64,205,204,204,204,204,204,244,63,82,184,30,133,235,209,33,64,205,204,204,204,204,204,244,63,236,81,184,30,133,235,233,63,31,133,235,81,184,158,36,64,236,81,184,30,133,235,233,63,31,133,235,81,184,158,36,64,51,51,51,51,51,51,3,64,31,133,235,81,184,158,36,64,205,204,204,204,204,204,4,64,154,153,153,153,153,153,36,64,154,153,153,153,153,153,5,64,20,174,71,225,122,148,36,64,102,102,102,102,102,102,6,64,133,235,81,184,30,133,36,64,51,51,51,51,51,51,7,64,215,163,112,61,10,87,36,64,0,0,0,0,0,0,8,64,20,174,71,225,122,20,36,64,205,204,204,204,204,204,8,64,41,92,143,194,245,168,35,64,154,153,153,153,153,153,9,64,41,92,143,194,245,40,35,64,102,102,102,102,102,102,10,64,164,112,61,10,215,163,34,64,0,0,0,0,0,0,12,64,225,122,20,174,71,97,33,64,154,153,153,153,153,153,13,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,16,64,143,194,245,40,92,143,27,64,154,153,153,153,153,153,17,64,215,163,112,61,10,215,20,64,41,92,143,194,245,40,18,64,41,92,143,194,245,40,18,64,102,102,102,102,102,102,18,64,195,245,40,92,143,194,16,64,51,51,51,51,51,51,19,64,0,0,0,0,0,0,8,64,154,153,153,153,153,153,19,64,102,102,102,102,102,102,2,64,205,204,204,204,204,204,19,64,61,10,215,163,112,61,0,64,0,0,0,0,0,0,20,64,20,174,71,225,122,20,254,63,51,51,51,51,51,51,20,64,82,184,30,133,235,81,252,63,102,102,102,102,102,102,20,64,10,215,163,112,61,10,251,63,205,204,204,204,204,204,20,64,72,225,122,20,174,71,249,63,154,153,153,153,153,153,21,64,10,215,163,112,61,10,247,63,102,102,102,102,102,102,22,64,72,225,122,20,174,71,245,63,51,51,51,51,51,51,23,64,41,92,143,194,245,40,244,63,0,0,0,0,0,0,24,64,92,143,194,245,40,92,243,63,154,153,153,153,153,153,25,64,236,81,184,30,133,235,241,63,0,0,0,0,0,0,28,64,82,184,30,133,235,81,240,63,0,0,0,0,0,0,30,64,10,215,163,112,61,10,239,63,0,0,0,0,0,0,33,64,123,20,174,71,225,122,236,63,0,0,0,0,0,0,36,64,236,81,184,30,133,235,233,63,31,133,235,81,184,158,36,64,236,81,184,30,133,235,233,63,31,133,235,81,184,158,36,64,236,81,184,30,133,235,233,63,48,133,1,0,35,0,0,0,0,0,0,0,0,0,248,63,0,0,0,0,0,0,20,64,222,37,149,233,41,38,0,62,92,143,194,245,40,92,40,64,246,40,92,143,194,245,244,63,57,180,200,118,190,159,154,63,0,0,0,0,0,0,240,63,241,104,227,136,181,248,244,62,0,0,0,0,0,0,34,64,29,129,162,173,6,207,129,63,154,153,153,153,153,153,26,64,10,215,163,112,61,10,5,64,154,153,153,153,153,153,1,64,0,0,0,0,0,0,0,0,192,131,1,0,23,0,0,0,0,0,0,0,0,0,240,63,205,204,204,204,204,204,244,63,12,103,53,95,80,159,87,62,174,71,225,122,20,46,34,64,154,153,153,153,153,153,233,63,57,180,200,118,190,159,154,63,0,0,0,0,0,0,240,63,241,104,227,136,181,248,228,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,1,192,1,192,1,192,1,192,1,192,1,192,1,192,1,224,1,224,1,224,1,224,1,240,1,240,1,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,192,3,192,3,192,3,192,3,192,3,192,3,192,3,192,3,224,3,224,3,240,3,240,3,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,1,192,1,192,1,192,1,192,1,192,1,192,1,192,1,224,1,224,1,224,1,224,1,240,1,240,1,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,192,3,192,3,192,3,192,3,192,3,192,3,192,3,192,3,224,3,224,3,240,3,240,3,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4,0,4,240,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,6,0,0,0,6,0,6,240,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,6,0,7,112,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,7])
.concat([0,4,0,7,0,7,176,7,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,7,0,0,0,4,0,4,0,7,0,6,0,7,128,7,208,7,0,0,0,4,0,6,128,7,0,6,128,7,128,7,224,7,0,7,192,7,192,7,240,7,224,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,240,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,8,0,8,0,10,0,10,240,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,10,0,0,0,8,0,8,0,10,0,8,0,10,0,11,112,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,10,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,10,0,0,0,8,0,8,0,10,0,8,0,11,0,11,176,11,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,11,0,8,0,8,0,8,0,11,0,8,0,11,128,11,208,11,0,8,0,8,0,8,128,11,0,10,128,11,128,11,224,11,0,10,128,11,192,11,240,11,224,11,240,11,240,11,240,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,0,0,8,0,8,0,12,0,12,0,12,0,12,240,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,0,0,0,0,0,0,8,0,0,0,8,0,12,0,12,0,8,0,12,0,12,0,12,0,12,0,12,0,13,112,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,12,0,12,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,12,0,8,0,12,0,12,0,12,0,12,0,13,0,13,176,13,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,13,0,8,0,12,0,12,0,13,0,12,0,13,128,13,208,13,0,12,0,12,0,12,0,13,0,12,128,13,128,13,224,13,0,12,128,13,192,13,240,13,192,13,240,13,240,13,240,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,12,0,12,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,14,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,14,0,8,0,12,0,12,0,14,0,12,0,14,0,14,112,14,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,12,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,14,0,0,0,8,0,8,0,12,0,8,0,12,0,12,0,14,0,12,0,12,0,12,0,14,0,14,0,14,0,14,176,14,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,14,0,14,0,14,0,14,0,14,0,14,208,14,0,12,0,14,0,14,0,14,0,14,128,14,128,14,224,14,0,14,128,14,192,14,240,14,192,14,240,14,240,14,240,14,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,15,0,8,0,12,0,12,0,12,0,12,0,14,0,14,0,15,0,12,0,14,0,14,0,15,0,14,0,15,0,15,48,15,0,8,0,12,0,12,0,14,0,12,0,14,0,14,0,15,0,12,0,14,0,14,0,15,0,14,0,15,0,15,80,15,0,14,0,14,0,14,0,15,0,15,0,15,0,15,96,15,0,15,0,15,64,15,112,15,64,15,112,15,112,15,112,15,0,12,0,12,0,12,0,14,0,14,0,14,0,14,0,15,0,14,0,14,0,14,128,15,0,15,128,15,128,15,144,15,0,14,0,15,0,15,128,15,0,15,128,15,128,15,160,15,0,15,128,15,128,15,176,15,128,15,176,15,176,15,176,15,0,14,0,15,0,15,128,15,0,15,128,15,192,15,192,15,128,15,192,15,192,15,208,15,192,15,208,15,208,15,208,15,128,15,192,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,192,15,128,15,208,15,208,15,208,15,192,15,208,15,192,15,192,15,128,15,192,15,192,15,192,15,0,15,128,15,0,15,0,15,0,14,176,15,176,15,176,15,128,15,176,15,128,15,128,15,0,15,160,15,128,15,128,15,0,15,128,15,0,15,0,15,0,14,144,15,128,15,128,15,0,15,128,15,0,15,0,14,0,14,0,15,0,14,0,14,0,14,0,14,0,12,0,12,0,12,112,15,112,15,112,15,64,15,112,15,64,15,0,15,0,15,96,15,0,15,0,15,0,15,0,15,0,14,0,14,0,14,80,15,0,15,0,15,0,14,0,15,0,14,0,14,0,12,0,15,0,14,0,14,0,12,0,14,0,12,0,12,0,8,48,15,0,15,0,15,0,14,0,15,0,14,0,14,0,12,0,15,0,14,0,14,0,12,0,12,0,12,0,12,0,8,0,15,0,14,0,12,0,12,0,12,0,12,0,8,0,8,0,12,0,8,0,8,0,8,0,8,0,0,0,0,0,0,240,14,240,14,240,14,192,14,240,14,192,14,128,14,0,14,224,14,128,14,128,14,0,14,0,14,0,14,0,14,0,12,208,14,128,14,0,14,0,14,0,14,0,14,0,14,0,12,0,14,0,14,0,12,0,12,0,12,0,12,0,8,0,8,176,14,0,14,0,14,0,14,0,14,0,12,0,12,0,12,0,14,0,12,0,12,0,8,0,12,0,8,0,8,0,0,0,14,0,12,0,12,0,8,0,12,0,8,0,8,0,0,0,12,0,8,0,8,0,0,0,8,0,0,0,0,0,0,112,14,0,14,0,14,0,12,0,14,0,12,0,12,0,8,0,14,0,12,0,12,0,8,0,12,0,8,0,8,0,0,0,14,0,12,0,12,0,8,0,12,0,8,0,8,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,12,0,12,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,13,240,13,240,13,192,13,240,13,192,13,128,13,0,12,224,13,128,13,128,13,0,12,128,13,0,12,0,12,0,12,208,13,128,13,0,13,0,12,0,13,0,12,0,12,0,8,0,13,0,12,0,12,0,8,0,12,0,8,0,8,0,0,176,13,0,13,0,13,0,12,0,12,0,12,0,12,0,8,0,12,0,12,0,12,0,8,0,12,0,8,0,8,0,0,0,12,0,12,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,13,0,13,0,12,0,12,0,12,0,12,0,12,0,8,0,12,0,12,0,8,0,0,0,8,0,0,0,0,0,0,0,12,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,12,0,12,0,12,0,12,0,12,0,8,0,8,0,0,0,12,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,12,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,11,240,11,240,11,224,11,240,11,192,11,192,11,0,10,224,11,192,11,128,11,0,10,128,11,0,10,0,8,0,8,208,11,128,11,0,11,0,8,0,11,0,8,0,8,0,8,0,11,0,8,0,8,0,8,0,8,0,0,0,0,0,0,176,11,0,11,0,11,0,8,0,10,0,8,0,8,0,0,0,10,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,10,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,11,0,11,0,10,0,8,0,10,0,8,0,8,0,0,0,10,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,10,0,10,0,10,0,8,0,8,0,8,0,8,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,9,0,9,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,7,240,7,240,7,224,7,240,7,192,7,192,7,0,7,224,7,192,7,128,7,0,6,128,7,0,6,0,6,0,0,208,7,128,7,128,7,0,6,0,7,0,4,0,4,0,0,0,7,0,4,0,0,0,0,0,0,0,0,0,0,0,0,176,7,128,7,0,7,0,4,0,7,0,4,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,7,0,7,0,7,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,6,0,6,0,6,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,5,128,5,0,4,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,3,192,3,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,240,3,0,0,0,3,128,3,240,3,224,3,240,3,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,5,0,0,0,0,0,0,0,0,0,0,0,0,0,4,240,5,0,0,0,4,0,4,240,5,192,5,240,5,240,5,240,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,176,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,4,208,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,4,0,4,224,6,0,0,0,0,0,0,0,4,0,0,0,6,0,6,240,6,0,0,0,6,0,6,240,6,0,6,240,6,240,6,240,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,4,0,6,48,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,6,0,6,80,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,6,0,6,96,7,0,0,0,0,0,0,0,6,0,0,0,6,0,6,112,7,0,0,0,7,0,7,112,7,0,7,112,7,112,7,112,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,6,0,6,144,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,7,0,7,160,7,0,0,0,0,0,0,0,7,0,0,0,7,0,7,176,7,0,4,0,7,0,7,176,7,128,7,176,7,176,7,176,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,7,0,0,0,7,0,7,192,7,0,0,0,0,0,0,0,7,0,4,0,7,0,7,208,7,0,4,0,7,128,7,208,7])
.concat([128,7,208,7,208,7,208,7,0,0,0,4,0,4,128,7,0,6,128,7,128,7,224,7,0,6,128,7,128,7,224,7,192,7,224,7,224,7,224,7,0,7,192,7,192,7,240,7,224,7,240,7,240,7,240,7,224,7,240,7,240,7,240,7,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,240,3,0,0,0,3,128,3,240,3,224,3,240,3,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,5,0,0,0,0,0,0,0,0,0,0,0,0,0,4,240,5,0,0,0,4,0,4,240,5,192,5,240,5,240,5,240,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,176,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,208,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,4,0,4,224,6,0,0,0,0,0,0,0,4,0,0,0,6,0,6,240,6,0,0,0,6,0,6,240,6,0,6,240,6,240,6,240,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,4,0,6,48,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,6,0,6,80,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,6,0,6,96,7,0,0,0,0,0,0,0,6,0,0,0,6,0,6,112,7,0,0,0,7,0,7,112,7,0,7,112,7,112,7,112,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,6,0,6,144,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,6,0,0,0,7,0,7,160,7,0,0,0,0,0,0,0,7,0,0,0,7,0,7,176,7,0,4,0,7,0,7,176,7,128,7,176,7,176,7,176,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,7,0,0,0,7,0,7,192,7,0,0,0,0,0,0,0,7,0,4,0,7,0,7,208,7,0,4,0,7,128,7,208,7,128,7,208,7,208,7,208,7,0,0,0,4,0,4,128,7,0,6,128,7,128,7,224,7,0,6,128,7,128,7,224,7,192,7,224,7,224,7,224,7,0,7,192,7,192,7,240,7,192,7,240,7,240,7,240,7,224,7,240,7,240,7,240,7,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,128,7,128,7,224,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,128,7,128,7,224,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,1,192,1,192,1,192,1,192,1,192,1,192,1,192,1,224,1,224,1,240,1,240,1,240,1,240,1,240,1,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,128,3,192,3,192,3,192,3,192,3,192,3,192,3,192,3,224,3,240,7,240,7,240,7,240,7,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,1,192,1,192,1,192,1,192,1,192,1,192,1,192,1,224,1,224,1,240,1,240,1,240,1,240,1,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,112,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,224,0,224,0,224,0,240,0,240,0,240,1,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,48,8,48,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,112,8,112,8,112,8,240,8,0,12,0,14,0,14,0,12,0,12,0,14,0,14,0,14,0,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,14,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,14,0,12,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,12,0,14,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,48,14,48,14,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,16,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,1,0,0,192,3,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,224,5,240,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,4,0,6,0,6,240,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,4,0,0,0,0,0,0,0,4,0,4,0,4,0,4,0,6,0,4,0,4,0,6,0,6,0,6,0,6,0,7,112,7,0,0,0,0,0,0,0,0,0,0,0,4,0,4,0,4,0,4,0,4,0,4,0,4,0,4,0,6,0,6,0,6,0,4,0,4,0,4,0,6,0,6,0,6,0,6,0,7,0,6,0,6,0,6,0,7,0,7,0,7,128,7,176,7,0,6,0,6,0,6,0,7,0,6,0,7,0,7,0,7,0,7,0,7,0,7,128,7,128,7,128,7,128,7,192,7,128,7,128,7,128,7,192,7,128,7,192,7,192,7,224,7,192,7,224,7,224,7,240,7,240,7,240,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,224,8,240,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,8,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,240,10,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,10,0,10,0,10,112,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,10,0,10,0,10,0,10,0,11,0,10,0,11,0,11,176,11,0,10,0,10,0,10,0,10,0,10,0,10,0,11,0,11,0,10,0,11,0,11,128,11,0,11,128,11,128,11,192,11,0,11,128,11,128,11,128,11,128,11,192,11,192,11,224,11,192,11,192,11,224,11,240,11,224,11,240,11,240,11,240,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,8,0,8,0,8,0,12,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,240,12,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,12,0,12,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,112,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,13,0,13,144,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,13,0,12,0,13,0,13,0,13,0,13,128,13,128,13,192,13,0,13,0,13,128,13,128,13,128,13,192,13,192,13,224,13,192,13,192,13,224,13,240,13,224,13,240,13,240,13,240,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,14,0,14,0,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,112,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,128,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,128,14,192,14,0,14,0,14,0,14,128,14,128,14,128,14,192,14,224,14,192,14,192,14,192,14,224,14,224,14,240,14,240,14,240,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,15,0,15,0,15,0,14,0,14,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,64,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,64,15,0,15,64,15,64,15,96,15,96,15,112,15,112,15,112,15,0,15,0,15,0,15,128,15,0,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,160,15,160,15,176,15,176,15,176,15,128,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,208,15,208,15,208,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,192,15,208,15,208,15,208,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,128,15,176,15,176,15,176,15,160,15,160,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,0,15,0,15,0,15,0,15,0,15,112,15,112,15,112,15,96,15,96,15,64,15,64,15,0,15,64,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,64,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,14,0,14,0,15,0,15,0,15,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,240,14,240,14,240,14,224,14,224,14,192,14,192,14,128,14,224,14,192,14,128,14,128,14,128,14,0,14,0,14,0,14,192,14,128,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,128,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,112,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,12,0,12,0,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,14,0,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,240,13,240,13,240,13,224,13,240,13,224,13,192,13,192,13,224,13,192,13,192,13,128,13,128,13,128,13,0,13,0,13,192,13,128,13,128,13,0,13,0,13,0,13,0,13,0,12,0,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,144,13,0,13,0,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,112,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,8,0,12,0,12,0,12,0,8,0,8,0,8,0,8,0,8,240,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,8,0,12,0,8,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,8,0,8,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,12,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,240,11,240,11,240,11,224,11,240,11,224,11,192,11,192,11,224,11,192,11,192,11,128,11,128,11,128,11,128,11,0,11,192,11,128,11,128,11,0,11,128,11,0,11,0,11,0,11,0,11,0,11,0,10,0,10,0,10,0,10,0,10,0,10,176,11,0,11,0,11,0,10,0,11,0,10,0,10,0,10,0,10,0,10,0,10,0,8,0,8,0,8,0,8,0,8,0,10,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,112,11,0,11,0,10,0,10,0,10,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,240,10,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,8,0,8,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,9,224,9,128,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,7,240,7,240,7,240,7,240,7,224,7,224,7,192,7,224,7,192,7,192,7,128,7,192,7,128,7,128,7,128,7,192,7,128,7,128,7,128,7,128,7,0,7,0,7,0,7,128,7,0,7,0,7,0,6,0,7,0,6,0,6,0,6,176,7,128,7,0,7,0,7,0,7,0,6,0,6,0,6,0,7,0,6,0,6,0,6,0,6,0,4,0,4,0,4,0,6,0,6,0,6,0,4,0,4,0,4,0,4,0,4,0,4,0,4,0,4,0,0,0,4,0,0,0,0,0,0,112,7,0,7,0,6,0,6,0,6,0,6,0,4,0,4,0,6,0,4,0,4,0,4,0,4,0,0,0,0,0,0,0,4,0,4,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,6,64,6,0,6,0,4,0,4,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,5,224,5,192,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,3,240,3,224,3,0,0,192,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,112,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,3,0,0,192,0,192,1,240,3,224,1,240,3,240,3,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,5,0,0,0,0,0,0,240,5,192,0,240,5,240,5,240,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,6,0,0,0,4,0,4,240,6,0,4,240,6,240,6,240,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,16,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,4,0,4,0,7,0,0,0,0,0,4,0,4,0,4,0,4,0,4,0,7,0,4,0,6,0,6,112,7,0,6,112,7,112,7,112,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,6,0,0,0,4,0,4,0,6,0,4,0,6,0,6,144,7,0,0,0,4,0,4,0,4,0,4,0,4,0,4,0,6,0,4,0,4,0,4,0,6,0,6,0,6,0,6,128,7,0,4,0,6,0,6,0,6,0,6,0,6,0,6,128,7,0,6,0,7,0,7,128,7,0,7,144,7,176,7,176,7,0,6,0,6,0,6,0,6,0,6,0,6,0,6,0,7,0,6,0,6,0,6,0,7,0,6,0,7,0,7,192,7,0,6,0,7,0,7,0,7,0,7,0,7,0,7,192,7,0,7,128,7,128,7,192,7,128,7,192,7,192,7,208,7,0,7,128,7,128,7,128,7,128,7,128,7,128,7,192,7,128,7,192,7,192,7,224,7,192,7,224,7,224,7,224,7,192,7,192,7,192,7,224,7,224,7,240,7,240,7,240,7,224,7,240,7,240,7,240,7,240,7,240,7,240,7,240,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,208,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,224,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,240,8,0,8,0,8,0,8,240,9,0,8,240,9,240,9,240,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,112,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,48,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,16,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,64,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,112,8,0,8,0,8,0,8,112,8,0,8,240,8,240,10,240,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,8,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,48,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,16,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,8,0,8,0,8,0,10,0,8,48,10,112,11,112,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,16,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,11,0,8,0,10,0,10,0,11,0,10,128,11,144,11,176,11,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,10,0,8,0,8,0,8,0,10,0,8,0,10,0,10,128,11,0,8,0,10,0,10,0,10,0,10,0,10,0,10,128,11,0,10,0,11,0,11,128,11,0,11,192,11,192,11,208,11,0,10,0,11,0,11,0,11,0,11,128,11,128,11,192,11,0,11,128,11,128,11,192,11,128,11,192,11,224,11,224,11,128,11,192,11,192,11,224,11,192,11,224,11,224,11,240,11,224,11,240,11,240,11,240,11,240,11,240,11,240,11,240,11,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,16,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,112,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,48,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,12,0,8,0,12,0,12,16,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,112,12,0,12,0,12,0,12,112,12,0,12,240,12,240,12,240,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,12,0,8,0,12,0,12,0,12,0,12,0,12,0,12,48,12,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,8,0,8,0,8,0,12,0,8,0,12,0,12,0,12,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,16,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,16,12,112,12,112,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,13,0,12,0,12,0,12,0,13,0,12,0,13,128,13,176,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,128,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,128,13,0,12,0,12,0,12,128,13,0,13,128,13,128,13,208,13,0,12,0,12,0,12,0,13,0,12,0,13,0,13,192,13,0,13,128,13,128,13,192,13,128,13,192,13,192,13,224,13,128,13,192,13,192,13,224,13,192,13,224,13,224,13,240,13,224,13,240,13,240,13,240,13,240,13,240,13,240,13,240,13,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,48,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,12,0,14,0,12,0,14,0,14,16,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,12,0,14,0,14,0,14,0,14,0,14,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,16,14,48,14,112,14,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,12,0,14,0,12,0,14,0,14,0,14,0,12,0,12,0,12,0,14,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,176,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,128,14,0,14,128,14,128,14,208,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,192,14,0,14,0,14,0,14,192,14,128,14,192,14,192,14,224,14,128,14,128,14,128,14,192,14,192,14,224,14,224,14,240,14,192,14,240,14,240,14,240,14,240,14,240,14,240,14,240,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,15,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,15,0,14,0,14,0,14,0,15,0,14,0,15,0,15,0,15,0,14,0,14,0,14,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,48,15,0,14,0,14,0,14,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,80,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,64,15,64,15,96,15,0,15,0,15,0,15,64,15,0,15,64,15,96,15,112,15,64,15,96,15,96,15,112,15,112,15,112,15,112,15,112,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,128,15,0,15,0,15,0,15,0,15,0,15,128,15,128,15,128,15,0,15,0,15,0,15,128,15,0,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,144,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,160,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,176,15,128,15,160,15,160,15,176,15,176,15,176,15,176,15,176,15,128,15,128,15,128,15,192,15,128,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,208,15,192,15,192,15,192,15,208,15,208,15,208,15,208,15,208,15,192,15,192,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,224,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])
.concat([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,7,0,6,0,2,0,7,0,7,0,7,0,7,0,7,128,7,128,7,128,7,192,7,192,7,224,7,224,7,240,7,240,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,224,1,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,192,8,240,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,0,0,0,0,8,0,0,0,0,0,8,0,8,0,8,0,8,0,0,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,240,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,12,0,14,0,12,0,12,0,12,0,12,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,48,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,0,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,128,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,192,15,224,15,224,15,224,15,224,15,240,15,240,15,240,15,240,15,240,15,240,15,240,15,9,0,0,0,32,0,0,0,63,0,0,0,95,0,0,0,149,0,0,0,220,0,0,0,11,1,0,0,57,1,0,0,136,1,0,0,209,3,0,0,162,7,0,0,54,12,0,0,67,15,0,0,200,45,0,0,76,76,0,0,19,122,0,0,0,0,0,0,17,0,0,0,34,0,0,0,51,0,0,0,68,0,0,0,85,0,0,0,102,0,0,0,119,0,0,0,136,0,0,0,153,0,0,0,170,0,0,0,187,0,0,0,204,0,0,0,221,0,0,0,238,0,0,0,255,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,0,0,0,0])
, "i8", ALLOC_NONE, Runtime.GLOBAL_BASE)
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
}
function copyTempDouble(ptr) {
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];
  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];
  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];
  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];
}
  function ___gxx_personality_v0() {
    }
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value
      return value;
    }
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 0777, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 0777 | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },reconcile:function (src, dst, callback) {
        var total = 0;
        var create = {};
        for (var key in src.files) {
          if (!src.files.hasOwnProperty(key)) continue;
          var e = src.files[key];
          var e2 = dst.files[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create[key] = e;
            total++;
          }
        }
        var remove = {};
        for (var key in dst.files) {
          if (!dst.files.hasOwnProperty(key)) continue;
          var e = dst.files[key];
          var e2 = src.files[key];
          if (!e2) {
            remove[key] = e;
            total++;
          }
        }
        if (!total) {
          // early out
          return callback(null);
        }
        var completed = 0;
        function done(err) {
          if (err) return callback(err);
          if (++completed >= total) {
            return callback(null);
          }
        };
        // create a single transaction to handle and IDB reads / writes we'll need to do
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        transaction.onerror = function transaction_onerror() { callback(this.error); };
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
        for (var path in create) {
          if (!create.hasOwnProperty(path)) continue;
          var entry = create[path];
          if (dst.type === 'local') {
            // save file to local
            try {
              if (FS.isDir(entry.mode)) {
                FS.mkdir(path, entry.mode);
              } else if (FS.isFile(entry.mode)) {
                var stream = FS.open(path, 'w+', 0666);
                FS.write(stream, entry.contents, 0, entry.contents.length, 0, true /* canOwn */);
                FS.close(stream);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // save file to IDB
            var req = store.put(entry, path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
        for (var path in remove) {
          if (!remove.hasOwnProperty(path)) continue;
          var entry = remove[path];
          if (dst.type === 'local') {
            // delete file from local
            try {
              if (FS.isDir(entry.mode)) {
                // TODO recursive delete?
                FS.rmdir(path);
              } else if (FS.isFile(entry.mode)) {
                FS.unlink(path);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // delete file from IDB
            var req = store.delete(path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
      },getLocalSet:function (mount, callback) {
        var files = {};
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
        var check = FS.readdir(mount.mountpoint)
          .filter(isRealDir)
          .map(toAbsolute(mount.mountpoint));
        while (check.length) {
          var path = check.pop();
          var stat, node;
          try {
            var lookup = FS.lookupPath(path);
            node = lookup.node;
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path)
              .filter(isRealDir)
              .map(toAbsolute(path)));
            files[path] = { mode: stat.mode, timestamp: stat.mtime };
          } else if (FS.isFile(stat.mode)) {
            files[path] = { contents: node.contents, mode: stat.mode, timestamp: stat.mtime };
          } else {
            return callback(new Error('node type not supported'));
          }
        }
        return callback(null, { type: 'local', files: files });
      },getDB:function (name, callback) {
        // look it up in the cache
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        req.onupgradeneeded = function req_onupgradeneeded() {
          db = req.result;
          db.createObjectStore(IDBFS.DB_STORE_NAME);
        };
        req.onsuccess = function req_onsuccess() {
          db = req.result;
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function req_onerror() {
          callback(this.error);
        };
      },getRemoteSet:function (mount, callback) {
        var files = {};
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function transaction_onerror() { callback(this.error); };
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          store.openCursor().onsuccess = function store_openCursor_onsuccess(event) {
            var cursor = event.target.result;
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, files: files });
            }
            files[cursor.key] = cursor.value;
            cursor.continue();
          };
        });
      }};
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.position = position;
          return position;
        }}};
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[null],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || { recurse_count: 0 };
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
        // start at the root
        var current = FS.root;
        var current_path = '/';
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            current = current.mount.root;
          }
          // follow symlinks
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
            this.parent = null;
            this.mount = null;
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            FS.hashAddNode(this);
          };
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
          FS.FSNode.prototype = {};
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
        return new FS.FSNode(parent, name, mode, rdev);
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 1;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
        var completed = 0;
        var total = FS.mounts.length;
        function done(err) {
          if (err) {
            return callback(err);
          }
          if (++completed >= total) {
            callback(null);
          }
        };
        // sync all mounts
        for (var i = 0; i < FS.mounts.length; i++) {
          var mount = FS.mounts[i];
          if (!mount.type.syncfs) {
            done(null);
            continue;
          }
          mount.type.syncfs(mount, populate, done);
        }
      },mount:function (type, opts, mountpoint) {
        var lookup;
        if (mountpoint) {
          lookup = FS.lookupPath(mountpoint, { follow: false });
          mountpoint = lookup.path;  // use the absolute path
        }
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          root: null
        };
        // create a root node for the fs
        var root = type.mount(mount);
        root.mount = mount;
        mount.root = root;
        // assign the mount info to the mountpoint's node
        if (lookup) {
          lookup.node.mount = mount;
          lookup.node.mounted = true;
          // compatibility update FS.root if we mount to /
          if (mountpoint === '/') {
            FS.root = mount.root;
          }
        }
        // add to our cached list of mounts
        FS.mounts.push(mount);
        return root;
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 0666;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 0777;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 0666;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path, { follow: false });
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 0666 : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.errnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0);
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=stdin.fd;
        assert(stdin.fd === 1, 'invalid handle for stdin (' + stdin.fd + ')');
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=stdout.fd;
        assert(stdout.fd === 2, 'invalid handle for stdout (' + stdout.fd + ')');
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=stderr.fd;
        assert(stderr.fd === 3, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
          this.stack = stackTrace();
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
        FS.nameTable = new Array(4096);
        FS.root = FS.createNode(null, '/', 16384 | 0777, 0);
        FS.mount(MEMFS, {}, '/');
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
        FS.ensureErrnoError();
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
              if (!hasByteServing) chunkSize = datalength;
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};function _mknod(path, mode, dev) {
      // int mknod(const char *path, mode_t mode, dev_t dev);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/mknod.html
      path = Pointer_stringify(path);
      // we don't want this in the JS API as the JS API
      // uses mknod to create all nodes.
      switch (mode & 61440) {
        case 32768:
        case 8192:
        case 24576:
        case 4096:
        case 49152:
          break;
        default:
          ___setErrNo(ERRNO_CODES.EINVAL);
          return -1;
      }
      try {
        FS.mknod(path, mode, dev);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _mkdir(path, mode) {
      // int mkdir(const char *path, mode_t mode);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/mkdir.html
      path = Pointer_stringify(path);
      try {
        FS.mkdir(path, mode, 0);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var ret = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return (ret == -1) ? 0 : ret;
    }
  var _mkport=undefined;var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 0777, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var bytesWritten = _write(stream, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      _fsync(stream);
      return _close(stream);
    }
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }function __ZSt9terminatev() {
      _exit(-1234);
    }
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      return ptr;
    }
  Module["_memcpy"] = _memcpy;var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;
  Module["_memcmp"] = _memcmp;
  Module["_strlen"] = _strlen;
  function ___cxa_allocate_exception(size) {
      return _malloc(size);
    }
  function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr);
      } catch(e) { // XXX FIXME
      }
    }
  function _llvm_eh_exception() {
      return HEAP32[((_llvm_eh_exception.buf)>>2)];
    }
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  function ___resumeException(ptr) {
      if (HEAP32[((_llvm_eh_exception.buf)>>2)] == 0) HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr;
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";;
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = HEAP32[((_llvm_eh_exception.buf)>>2)];
      if (throwntype == -1) throwntype = HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=type
      HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=destructor
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";;
    }
  Module["_memset"] = _memset;var _llvm_memset_p0i8_i32=_memset;
  function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Clear type.
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=0
      // Call destructor if one is registered then clear it.
      var ptr = HEAP32[((_llvm_eh_exception.buf)>>2)];
      var destructor = HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)];
      if (destructor) {
        Runtime.dynCall('vi', destructor, [ptr]);
        HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=0
      }
      // Free ptr if it isn't null.
      if (ptr) {
        ___cxa_free_exception(ptr);
        HEAP32[((_llvm_eh_exception.buf)>>2)]=0
      }
    }
  Module["_memmove"] = _memmove;var _llvm_memmove_p0i8_p0i8_i32=_memmove;
  var _ceilf=Math_ceil;
  var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC); 
  Module["_llvm_ctlz_i32"] = _llvm_ctlz_i32;
  function ___cxa_pure_virtual() {
      ABORT = true;
      throw 'Pure virtual function called!';
    }
  function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      return _write(stream, s, _strlen(s));
    }
  function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr
      var ret = _write(stream, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  function _llvm_lifetime_start() {}
  function _llvm_lifetime_end() {}
  var _llvm_memset_p0i8_i64=_memset;
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = HEAPF64[(((varargs)+(argIndex))>>3)];
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+8))>>2)]];
          argIndex += 8; // each 32-bit chunk is in a 64-bit block
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Math.max(Runtime.getNativeFieldSize(type), Runtime.getAlignSize(type, null, true));
        return ret;
      }
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
          // Handle precision.
          var precisionSet = false;
          if (next == 46) {
            var precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          } else {
            var precision = 6; // Standard default.
          }
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }
  var Browser={mainLoop:{scheduler:null,shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
        // Canvas event setup
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
            var errorInfo = '?';
            function onContextCreationError(event) {
              errorInfo = event.statusMessage || errorInfo;
            }
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (window.scrollX + rect.left);
              y = t.pageY - (window.scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (window.scrollX + rect.left);
            y = event.pageY - (window.scrollY + rect.top);
          }
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};var SDL={defaults:{width:320,height:200,copyOnLock:true},version:null,surfaces:{},canvasPool:[],events:[],fonts:[null],audios:[null],rwops:[null],music:{audio:null,volume:1},mixerFrequency:22050,mixerFormat:32784,mixerNumChannels:2,mixerChunkSize:1024,channelMinimumNumber:0,GL:false,glAttributes:{0:3,1:3,2:2,3:0,4:0,5:1,6:16,7:0,8:0,9:0,10:0,11:0,12:0,13:0,14:0,15:1,16:0,17:0,18:0},keyboardState:null,keyboardMap:{},canRequestFullscreen:false,isRequestingFullscreen:false,textInput:false,startTime:null,initFlags:0,buttonState:0,modState:0,DOMButtons:[0,0,0],DOMEventToSDLEvent:{},keyCodes:{16:1249,17:1248,18:1250,33:1099,34:1102,37:1104,38:1106,39:1103,40:1105,46:127,96:1112,97:1113,98:1114,99:1115,100:1116,101:1117,102:1118,103:1119,104:1120,105:1121,112:1082,113:1083,114:1084,115:1085,116:1086,117:1087,118:1088,119:1089,120:1090,121:1091,122:1092,123:1093,173:45,188:44,190:46,191:47,192:96},scanCodes:{8:42,9:43,13:40,27:41,32:44,44:54,46:55,47:56,48:39,49:30,50:31,51:32,52:33,53:34,54:35,55:36,56:37,57:38,59:51,61:46,91:47,92:49,93:48,96:52,97:4,98:5,99:6,100:7,101:8,102:9,103:10,104:11,105:12,106:13,107:14,108:15,109:16,110:17,111:18,112:19,113:20,114:21,115:22,116:23,117:24,118:25,119:26,120:27,121:28,122:29,305:224,308:226},loadRect:function (rect) {
        return {
          x: HEAP32[((rect + 0)>>2)],
          y: HEAP32[((rect + 4)>>2)],
          w: HEAP32[((rect + 8)>>2)],
          h: HEAP32[((rect + 12)>>2)]
        };
      },loadColorToCSSRGB:function (color) {
        var rgba = HEAP32[((color)>>2)];
        return 'rgb(' + (rgba&255) + ',' + ((rgba >> 8)&255) + ',' + ((rgba >> 16)&255) + ')';
      },loadColorToCSSRGBA:function (color) {
        var rgba = HEAP32[((color)>>2)];
        return 'rgba(' + (rgba&255) + ',' + ((rgba >> 8)&255) + ',' + ((rgba >> 16)&255) + ',' + (((rgba >> 24)&255)/255) + ')';
      },translateColorToCSSRGBA:function (rgba) {
        return 'rgba(' + (rgba&0xff) + ',' + (rgba>>8 & 0xff) + ',' + (rgba>>16 & 0xff) + ',' + (rgba>>>24)/0xff + ')';
      },translateRGBAToCSSRGBA:function (r, g, b, a) {
        return 'rgba(' + (r&0xff) + ',' + (g&0xff) + ',' + (b&0xff) + ',' + (a&0xff)/255 + ')';
      },translateRGBAToColor:function (r, g, b, a) {
        return r | g << 8 | b << 16 | a << 24;
      },makeSurface:function (width, height, flags, usePageCanvas, source, rmask, gmask, bmask, amask) {
        flags = flags || 0;
        var surf = _malloc(60);  // SDL_Surface has 15 fields of quantum size
        var buffer = _malloc(width*height*4); // TODO: only allocate when locked the first time
        var pixelFormat = _malloc(44);
        flags |= 1; // SDL_HWSURFACE - this tells SDL_MUSTLOCK that this needs to be locked
        //surface with SDL_HWPALETTE flag is 8bpp surface (1 byte)
        var is_SDL_HWPALETTE = flags & 0x00200000;  
        var bpp = is_SDL_HWPALETTE ? 1 : 4;
        HEAP32[((surf)>>2)]=flags         // SDL_Surface.flags
        HEAP32[(((surf)+(4))>>2)]=pixelFormat // SDL_Surface.format TODO
        HEAP32[(((surf)+(8))>>2)]=width         // SDL_Surface.w
        HEAP32[(((surf)+(12))>>2)]=height        // SDL_Surface.h
        HEAP32[(((surf)+(16))>>2)]=width * bpp       // SDL_Surface.pitch, assuming RGBA or indexed for now,
                                                                                 // since that is what ImageData gives us in browsers
        HEAP32[(((surf)+(20))>>2)]=buffer      // SDL_Surface.pixels
        HEAP32[(((surf)+(36))>>2)]=0      // SDL_Surface.offset
        HEAP32[(((surf)+(56))>>2)]=1
        HEAP32[((pixelFormat)>>2)]=0 /* XXX missing C define SDL_PIXELFORMAT_RGBA8888 */ // SDL_PIXELFORMAT_RGBA8888
        HEAP32[(((pixelFormat)+(4))>>2)]=0 // TODO
        HEAP8[(((pixelFormat)+(8))|0)]=bpp * 8
        HEAP8[(((pixelFormat)+(9))|0)]=bpp
        HEAP32[(((pixelFormat)+(12))>>2)]=rmask || 0x000000ff
        HEAP32[(((pixelFormat)+(16))>>2)]=gmask || 0x0000ff00
        HEAP32[(((pixelFormat)+(20))>>2)]=bmask || 0x00ff0000
        HEAP32[(((pixelFormat)+(24))>>2)]=amask || 0xff000000
        // Decide if we want to use WebGL or not
        var useWebGL = (flags & 0x04000000) != 0; // SDL_OPENGL
        SDL.GL = SDL.GL || useWebGL;
        var canvas;
        if (!usePageCanvas) {
          if (SDL.canvasPool.length > 0) {
            canvas = SDL.canvasPool.pop();
          } else {
            canvas = document.createElement('canvas');
          }
          canvas.width = width;
          canvas.height = height;
        } else {
          canvas = Module['canvas'];
        }
        var webGLContextAttributes = {
          antialias: ((SDL.glAttributes[13 /*SDL_GL_MULTISAMPLEBUFFERS*/] != 0) && (SDL.glAttributes[14 /*SDL_GL_MULTISAMPLESAMPLES*/] > 1)),
          depth: (SDL.glAttributes[6 /*SDL_GL_DEPTH_SIZE*/] > 0),
          stencil: (SDL.glAttributes[7 /*SDL_GL_STENCIL_SIZE*/] > 0)
        };
        var ctx = Browser.createContext(canvas, useWebGL, usePageCanvas, webGLContextAttributes);
        SDL.surfaces[surf] = {
          width: width,
          height: height,
          canvas: canvas,
          ctx: ctx,
          surf: surf,
          buffer: buffer,
          pixelFormat: pixelFormat,
          alpha: 255,
          flags: flags,
          locked: 0,
          usePageCanvas: usePageCanvas,
          source: source,
          isFlagSet: function(flag) {
            return flags & flag;
          }
        };
        return surf;
      },copyIndexedColorData:function (surfData, rX, rY, rW, rH) {
        // HWPALETTE works with palette
        // setted by SDL_SetColors
        if (!surfData.colors) {
          return;
        }
        var fullWidth  = Module['canvas'].width;
        var fullHeight = Module['canvas'].height;
        var startX  = rX || 0;
        var startY  = rY || 0;
        var endX    = (rW || (fullWidth - startX)) + startX;
        var endY    = (rH || (fullHeight - startY)) + startY;
        var buffer  = surfData.buffer;
        var data    = surfData.image.data;
        var colors  = surfData.colors;
        for (var y = startY; y < endY; ++y) {
          var indexBase = y * fullWidth;
          var colorBase = indexBase * 4;
          for (var x = startX; x < endX; ++x) {
            // HWPALETTE have only 256 colors (not rgba)
            var index = HEAPU8[((buffer + indexBase + x)|0)] * 3;
            var colorOffset = colorBase + x * 4;
            data[colorOffset   ] = colors[index   ];
            data[colorOffset +1] = colors[index +1];
            data[colorOffset +2] = colors[index +2];
            //unused: data[colorOffset +3] = color[index +3];
          }
        }
      },freeSurface:function (surf) {
        var refcountPointer = surf + 56;
        var refcount = HEAP32[((refcountPointer)>>2)];
        if (refcount > 1) {
          HEAP32[((refcountPointer)>>2)]=refcount - 1;
          return;
        }
        var info = SDL.surfaces[surf];
        if (!info.usePageCanvas && info.canvas) SDL.canvasPool.push(info.canvas);
        _free(info.buffer);
        _free(info.pixelFormat);
        _free(surf);
        SDL.surfaces[surf] = null;
      },touchX:0,touchY:0,savedKeydown:null,receiveEvent:function (event) {
        switch(event.type) {
          case 'touchstart':
            event.preventDefault();
            var touch = event.touches[0];
            touchX = touch.pageX;
            touchY = touch.pageY;
            var event = {
              type: 'mousedown',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.DOMButtons[0] = 1;
            SDL.events.push(event);
            break;
          case 'touchmove':
            event.preventDefault();
            var touch = event.touches[0];
            touchX = touch.pageX;
            touchY = touch.pageY;
            event = {
              type: 'mousemove',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.events.push(event);
            break;
          case 'touchend':
            event.preventDefault();
            event = {
              type: 'mouseup',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.DOMButtons[0] = 0;
            SDL.events.push(event);
            break;
          case 'mousemove':
            if (Browser.pointerLock) {
              // workaround for firefox bug 750111
              if ('mozMovementX' in event) {
                event['movementX'] = event['mozMovementX'];
                event['movementY'] = event['mozMovementY'];
              }
              // workaround for Firefox bug 782777
              if (event['movementX'] == 0 && event['movementY'] == 0) {
                // ignore a mousemove event if it doesn't contain any movement info
                // (without pointer lock, we infer movement from pageX/pageY, so this check is unnecessary)
                event.preventDefault();
                return;
              }
            }
            // fall through
          case 'keydown': case 'keyup': case 'keypress': case 'mousedown': case 'mouseup': case 'DOMMouseScroll': case 'mousewheel':
            // If we preventDefault on keydown events, the subsequent keypress events
            // won't fire. However, it's fine (and in some cases necessary) to
            // preventDefault for keys that don't generate a character. Otherwise,
            // preventDefault is the right thing to do in general.
            if (event.type !== 'keydown' || (event.keyCode === 8 /* backspace */ || event.keyCode === 9 /* tab */)) {
              event.preventDefault();
            }
            if (event.type == 'DOMMouseScroll' || event.type == 'mousewheel') {
              var button = (event.type == 'DOMMouseScroll' ? event.detail : -event.wheelDelta) > 0 ? 4 : 3;
              var event2 = {
                type: 'mousedown',
                button: button,
                pageX: event.pageX,
                pageY: event.pageY
              };
              SDL.events.push(event2);
              event = {
                type: 'mouseup',
                button: button,
                pageX: event.pageX,
                pageY: event.pageY
              };
            } else if (event.type == 'mousedown') {
              SDL.DOMButtons[event.button] = 1;
            } else if (event.type == 'mouseup') {
              // ignore extra ups, can happen if we leave the canvas while pressing down, then return,
              // since we add a mouseup in that case
              if (!SDL.DOMButtons[event.button]) {
                return;
              }
              SDL.DOMButtons[event.button] = 0;
            }
            // We can only request fullscreen as the result of user input.
            // Due to this limitation, we toggle a boolean on keydown which
            // SDL_WM_ToggleFullScreen will check and subsequently set another
            // flag indicating for us to request fullscreen on the following
            // keyup. This isn't perfect, but it enables SDL_WM_ToggleFullScreen
            // to work as the result of a keypress (which is an extremely
            // common use case).
            if (event.type === 'keydown') {
              SDL.canRequestFullscreen = true;
            } else if (event.type === 'keyup') {
              if (SDL.isRequestingFullscreen) {
                Module['requestFullScreen'](true, true);
                SDL.isRequestingFullscreen = false;
              }
              SDL.canRequestFullscreen = false;
            }
            // SDL expects a unicode character to be passed to its keydown events.
            // Unfortunately, the browser APIs only provide a charCode property on
            // keypress events, so we must backfill in keydown events with their
            // subsequent keypress event's charCode.
            if (event.type === 'keypress' && SDL.savedKeydown) {
              // charCode is read-only
              SDL.savedKeydown.keypressCharCode = event.charCode;
              SDL.savedKeydown = null;
            } else if (event.type === 'keydown') {
              SDL.savedKeydown = event;
            }
            // Don't push keypress events unless SDL_StartTextInput has been called.
            if (event.type !== 'keypress' || SDL.textInput) {
              SDL.events.push(event);
            }
            break;
          case 'mouseout':
            // Un-press all pressed mouse buttons, because we might miss the release outside of the canvas
            for (var i = 0; i < 3; i++) {
              if (SDL.DOMButtons[i]) {
                SDL.events.push({
                  type: 'mouseup',
                  button: i,
                  pageX: event.pageX,
                  pageY: event.pageY
                });
                SDL.DOMButtons[i] = 0;
              }
            }
            event.preventDefault();
            break;
          case 'blur':
          case 'visibilitychange': {
            // Un-press all pressed keys: TODO
            for (var code in SDL.keyboardMap) {
              SDL.events.push({
                type: 'keyup',
                keyCode: SDL.keyboardMap[code]
              });
            }
            event.preventDefault();
            break;
          }
          case 'unload':
            if (Browser.mainLoop.runner) {
              SDL.events.push(event);
              // Force-run a main event loop, since otherwise this event will never be caught!
              Browser.mainLoop.runner();
            }
            return;
          case 'resize':
            SDL.events.push(event);
            // manually triggered resize event doesn't have a preventDefault member
            if (event.preventDefault) {
              event.preventDefault();
            }
            break;
        }
        if (SDL.events.length >= 10000) {
          Module.printErr('SDL event queue full, dropping events');
          SDL.events = SDL.events.slice(0, 10000);
        }
        return;
      },handleEvent:function (event) {
        if (event.handled) return;
        event.handled = true;
        switch (event.type) {
          case 'keydown': case 'keyup': {
            var down = event.type === 'keydown';
            var code = event.keyCode;
            if (code >= 65 && code <= 90) {
              code += 32; // make lowercase for SDL
            } else {
              code = SDL.keyCodes[event.keyCode] || event.keyCode;
            }
            HEAP8[(((SDL.keyboardState)+(code))|0)]=down;
            // TODO: lmeta, rmeta, numlock, capslock, KMOD_MODE, KMOD_RESERVED
            SDL.modState = (HEAP8[(((SDL.keyboardState)+(1248))|0)] ? 0x0040 | 0x0080 : 0) | // KMOD_LCTRL & KMOD_RCTRL
              (HEAP8[(((SDL.keyboardState)+(1249))|0)] ? 0x0001 | 0x0002 : 0) | // KMOD_LSHIFT & KMOD_RSHIFT
              (HEAP8[(((SDL.keyboardState)+(1250))|0)] ? 0x0100 | 0x0200 : 0); // KMOD_LALT & KMOD_RALT
            if (down) {
              SDL.keyboardMap[code] = event.keyCode; // save the DOM input, which we can use to unpress it during blur
            } else {
              delete SDL.keyboardMap[code];
            }
            break;
          }
          case 'mousedown': case 'mouseup':
            if (event.type == 'mousedown') {
              // SDL_BUTTON(x) is defined as (1 << ((x)-1)).  SDL buttons are 1-3,
              // and DOM buttons are 0-2, so this means that the below formula is
              // correct.
              SDL.buttonState |= 1 << event.button;
            } else if (event.type == 'mouseup') {
              SDL.buttonState &= ~(1 << event.button);
            }
            // fall through
          case 'mousemove': {
            Browser.calculateMouseEvent(event);
            break;
          }
        }
      },makeCEvent:function (event, ptr) {
        if (typeof event === 'number') {
          // This is a pointer to a native C event that was SDL_PushEvent'ed
          _memcpy(ptr, event, 28); // XXX
          return;
        }
        SDL.handleEvent(event);
        switch (event.type) {
          case 'keydown': case 'keyup': {
            var down = event.type === 'keydown';
            //Module.print('Received key event: ' + event.keyCode);
            var key = event.keyCode;
            if (key >= 65 && key <= 90) {
              key += 32; // make lowercase for SDL
            } else {
              key = SDL.keyCodes[event.keyCode] || event.keyCode;
            }
            var scan;
            if (key >= 1024) {
              scan = key - 1024;
            } else {
              scan = SDL.scanCodes[key] || key;
            }
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type]
            HEAP8[(((ptr)+(8))|0)]=down ? 1 : 0
            HEAP8[(((ptr)+(9))|0)]=0 // TODO
            HEAP32[(((ptr)+(12))>>2)]=scan
            HEAP32[(((ptr)+(16))>>2)]=key
            HEAP16[(((ptr)+(20))>>1)]=SDL.modState
            // some non-character keys (e.g. backspace and tab) won't have keypressCharCode set, fill in with the keyCode.
            HEAP32[(((ptr)+(24))>>2)]=event.keypressCharCode || key
            break;
          }
          case 'keypress': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type]
            // Not filling in windowID for now
            var cStr = intArrayFromString(String.fromCharCode(event.charCode));
            for (var i = 0; i < cStr.length; ++i) {
              HEAP8[(((ptr)+(8 + i))|0)]=cStr[i];
            }
            break;
          }
          case 'mousedown': case 'mouseup': case 'mousemove': {
            if (event.type != 'mousemove') {
              var down = event.type === 'mousedown';
              HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
              HEAP8[(((ptr)+(8))|0)]=event.button+1; // DOM buttons are 0-2, SDL 1-3
              HEAP8[(((ptr)+(9))|0)]=down ? 1 : 0;
              HEAP32[(((ptr)+(12))>>2)]=Browser.mouseX;
              HEAP32[(((ptr)+(16))>>2)]=Browser.mouseY;
            } else {
              HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
              HEAP8[(((ptr)+(8))|0)]=SDL.buttonState;
              HEAP32[(((ptr)+(12))>>2)]=Browser.mouseX;
              HEAP32[(((ptr)+(16))>>2)]=Browser.mouseY;
              HEAP32[(((ptr)+(20))>>2)]=Browser.mouseMovementX;
              HEAP32[(((ptr)+(24))>>2)]=Browser.mouseMovementY;
            }
            break;
          }
          case 'unload': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            break;
          }
          case 'resize': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP32[(((ptr)+(4))>>2)]=event.w;
            HEAP32[(((ptr)+(8))>>2)]=event.h;
            break;
          }
          case 'joystick_button_up': case 'joystick_button_down': {
            var state = event.type === 'joystick_button_up' ? 0 : 1;
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP8[(((ptr)+(4))|0)]=event.index;
            HEAP8[(((ptr)+(5))|0)]=event.button;
            HEAP8[(((ptr)+(6))|0)]=state;
            break;
          }
          case 'joystick_axis_motion': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP8[(((ptr)+(4))|0)]=event.index;
            HEAP8[(((ptr)+(5))|0)]=event.axis;
            HEAP32[(((ptr)+(8))>>2)]=SDL.joystickAxisValueConversion(event.value);
            break;
          }
          default: throw 'Unhandled SDL event: ' + event.type;
        }
      },estimateTextWidth:function (fontData, text) {
        var h = fontData.size;
        var fontString = h + 'px ' + fontData.name;
        var tempCtx = SDL.ttfContext;
        tempCtx.save();
        tempCtx.font = fontString;
        var ret = tempCtx.measureText(text).width | 0;
        tempCtx.restore();
        return ret;
      },allocateChannels:function (num) { // called from Mix_AllocateChannels and init
        if (SDL.numChannels && SDL.numChannels >= num && num != 0) return;
        SDL.numChannels = num;
        SDL.channels = [];
        for (var i = 0; i < num; i++) {
          SDL.channels[i] = {
            audio: null,
            volume: 1.0
          };
        }
      },setGetVolume:function (info, volume) {
        if (!info) return 0;
        var ret = info.volume * 128; // MIX_MAX_VOLUME
        if (volume != -1) {
          info.volume = volume / 128;
          if (info.audio) info.audio.volume = info.volume;
        }
        return ret;
      },debugSurface:function (surfData) {
        console.log('dumping surface ' + [surfData.surf, surfData.source, surfData.width, surfData.height]);
        var image = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
        var data = image.data;
        var num = Math.min(surfData.width, surfData.height);
        for (var i = 0; i < num; i++) {
          console.log('   diagonal ' + i + ':' + [data[i*surfData.width*4 + i*4 + 0], data[i*surfData.width*4 + i*4 + 1], data[i*surfData.width*4 + i*4 + 2], data[i*surfData.width*4 + i*4 + 3]]);
        }
      },joystickEventState:1,lastJoystickState:{},joystickNamePool:{},recordJoystickState:function (joystick, state) {
        // Standardize button state.
        var buttons = new Array(state.buttons.length);
        for (var i = 0; i < state.buttons.length; i++) {
          buttons[i] = SDL.getJoystickButtonState(state.buttons[i]);
        }
        SDL.lastJoystickState[joystick] = {
          buttons: buttons,
          axes: state.axes.slice(0),
          timestamp: state.timestamp,
          index: state.index,
          id: state.id
        };
      },getJoystickButtonState:function (button) {
        if (typeof button === 'object') {
          // Current gamepad API editor's draft (Firefox Nightly)
          // https://dvcs.w3.org/hg/gamepad/raw-file/default/gamepad.html#idl-def-GamepadButton
          return button.pressed;
        } else {
          // Current gamepad API working draft (Firefox / Chrome Stable)
          // http://www.w3.org/TR/2012/WD-gamepad-20120529/#gamepad-interface
          return button > 0;
        }
      },queryJoysticks:function () {
        for (var joystick in SDL.lastJoystickState) {
          var state = SDL.getGamepad(joystick - 1);
          var prevState = SDL.lastJoystickState[joystick];
          // Check only if the timestamp has differed.
          // NOTE: Timestamp is not available in Firefox.
          if (typeof state.timestamp !== 'number' || state.timestamp !== prevState.timestamp) {
            var i;
            for (i = 0; i < state.buttons.length; i++) {
              var buttonState = SDL.getJoystickButtonState(state.buttons[i]);
              // NOTE: The previous state already has a boolean representation of
              //       its button, so no need to standardize its button state here.
              if (buttonState !== prevState.buttons[i]) {
                // Insert button-press event.
                SDL.events.push({
                  type: buttonState ? 'joystick_button_down' : 'joystick_button_up',
                  joystick: joystick,
                  index: joystick - 1,
                  button: i
                });
              }
            }
            for (i = 0; i < state.axes.length; i++) {
              if (state.axes[i] !== prevState.axes[i]) {
                // Insert axes-change event.
                SDL.events.push({
                  type: 'joystick_axis_motion',
                  joystick: joystick,
                  index: joystick - 1,
                  axis: i,
                  value: state.axes[i]
                });
              }
            }
            SDL.recordJoystickState(joystick, state);
          }
        }
      },joystickAxisValueConversion:function (value) {
        // Ensures that 0 is 0, 1 is 32767, and -1 is 32768.
        return Math.ceil(((value+1) * 32767.5) - 32768);
      },getGamepads:function () {
        var fcn = navigator.getGamepads || navigator.webkitGamepads || navigator.mozGamepads || navigator.gamepads || navigator.webkitGetGamepads;
        if (fcn !== undefined) {
          // The function must be applied on the navigator object.
          return fcn.apply(navigator);
        } else {
          return [];
        }
      },getGamepad:function (deviceIndex) {
        var gamepads = SDL.getGamepads();
        if (gamepads.length > deviceIndex && deviceIndex >= 0) {
          return gamepads[deviceIndex];
        }
        return null;
      }};function _SDL_OpenAudio(desired, obtained) {
      try {
        SDL.audio = {
          freq: HEAPU32[((desired)>>2)],
          format: HEAPU16[(((desired)+(4))>>1)],
          channels: HEAPU8[(((desired)+(6))|0)],
          samples: HEAPU16[(((desired)+(8))>>1)], // Samples in the CB buffer per single sound channel.
          callback: HEAPU32[(((desired)+(16))>>2)],
          userdata: HEAPU32[(((desired)+(20))>>2)],
          paused: true,
          timer: null
        };
        // The .silence field tells the constant sample value that corresponds to the safe un-skewed silence value for the wave data.
        if (SDL.audio.format == 0x0008 /*AUDIO_U8*/) {
          SDL.audio.silence = 128; // Audio ranges in [0, 255], so silence is half-way in between.
        } else if (SDL.audio.format == 0x8010 /*AUDIO_S16LSB*/) {
          SDL.audio.silence = 0; // Signed data in range [-32768, 32767], silence is 0.
        } else {
          throw 'Invalid SDL audio format ' + SDL.audio.format + '!';
        }
        // Round the desired audio frequency up to the next 'common' frequency value.
        // Web Audio API spec states 'An implementation must support sample-rates in at least the range 22050 to 96000.'
        if (SDL.audio.freq <= 0) {
          throw 'Unsupported sound frequency ' + SDL.audio.freq + '!';
        } else if (SDL.audio.freq <= 22050) {
          SDL.audio.freq = 22050; // Take it safe and clamp everything lower than 22kHz to that.
        } else if (SDL.audio.freq <= 32000) {
          SDL.audio.freq = 32000;
        } else if (SDL.audio.freq <= 44100) {
          SDL.audio.freq = 44100;
        } else if (SDL.audio.freq <= 48000) {
          SDL.audio.freq = 48000;
        } else if (SDL.audio.freq <= 96000) {
          SDL.audio.freq = 96000;
        } else {
          throw 'Unsupported sound frequency ' + SDL.audio.freq + '!';
        }
        if (SDL.audio.channels == 0) {
          SDL.audio.channels = 1; // In SDL both 0 and 1 mean mono.
        } else if (SDL.audio.channels < 0 || SDL.audio.channels > 32) {
          throw 'Unsupported number of audio channels for SDL audio: ' + SDL.audio.channels + '!';
        } else if (SDL.audio.channels != 1 && SDL.audio.channels != 2) { // Unsure what SDL audio spec supports. Web Audio spec supports up to 32 channels.
          console.log('Warning: Using untested number of audio channels ' + SDL.audio.channels);
        }
        if (SDL.audio.samples < 128 || SDL.audio.samples > 524288 /* arbitrary cap */) {
          throw 'Unsupported audio callback buffer size ' + SDL.audio.samples + '!';
        } else if ((SDL.audio.samples & (SDL.audio.samples-1)) != 0) {
          throw 'Audio callback buffer size ' + SDL.audio.samples + ' must be a power-of-two!';
        }
        var totalSamples = SDL.audio.samples*SDL.audio.channels;
        SDL.audio.bytesPerSample = (SDL.audio.format == 0x0008 /*AUDIO_U8*/ || SDL.audio.format == 0x8008 /*AUDIO_S8*/) ? 1 : 2;
        SDL.audio.bufferSize = totalSamples*SDL.audio.bytesPerSample;
        SDL.audio.buffer = _malloc(SDL.audio.bufferSize);
        // To account for jittering in frametimes, always have multiple audio buffers queued up for the audio output device.
        // This helps that we won't starve that easily if a frame takes long to complete.
        SDL.audio.numSimultaneouslyQueuedBuffers = Module['SDL_numSimultaneouslyQueuedBuffers'] || 3;
        // Create a callback function that will be routinely called to ask more audio data from the user application.
        SDL.audio.caller = function SDL_audio_caller() {
          if (!SDL.audio) {
            return;
          }
          Runtime.dynCall('viii', SDL.audio.callback, [SDL.audio.userdata, SDL.audio.buffer, SDL.audio.bufferSize]);
          SDL.audio.pushAudio(SDL.audio.buffer, SDL.audio.bufferSize);
        };
        SDL.audio.audioOutput = new Audio();
        // As a workaround use Mozilla Audio Data API on Firefox until it ships with Web Audio and sound quality issues are fixed.
        if (typeof(SDL.audio.audioOutput['mozSetup'])==='function') {
          SDL.audio.audioOutput['mozSetup'](SDL.audio.channels, SDL.audio.freq); // use string attributes on mozOutput for closure compiler
          SDL.audio.mozBuffer = new Float32Array(totalSamples);
          SDL.audio.nextPlayTime = 0;
          SDL.audio.pushAudio = function SDL_audio_pushAudio(ptr, size) {
            --SDL.audio.numAudioTimersPending;
            var mozBuffer = SDL.audio.mozBuffer;
            // The input audio data for SDL audio is either 8-bit or 16-bit interleaved across channels, output for Mozilla Audio Data API
            // needs to be Float32 interleaved, so perform a sample conversion.
            if (SDL.audio.format == 0x8010 /*AUDIO_S16LSB*/) {
              for (var i = 0; i < totalSamples; i++) {
                mozBuffer[i] = (HEAP16[(((ptr)+(i*2))>>1)]) / 0x8000;
              }
            } else if (SDL.audio.format == 0x0008 /*AUDIO_U8*/) {
              for (var i = 0; i < totalSamples; i++) {
                var v = (HEAP8[(((ptr)+(i))|0)]);
                mozBuffer[i] = ((v >= 0) ? v-128 : v+128) /128;
              }
            }
            // Submit the audio data to audio device.
            SDL.audio.audioOutput['mozWriteAudio'](mozBuffer);
            // Compute when the next audio callback should be called.
            var curtime = Date.now() / 1000.0 - SDL.audio.startTime;
            var playtime = Math.max(curtime, SDL.audio.nextPlayTime);
            var buffer_duration = SDL.audio.samples / SDL.audio.freq;
            SDL.audio.nextPlayTime = playtime + buffer_duration;
            // Schedule the next audio callback call to occur when the current one finishes.
            SDL.audio.timer = Browser.safeSetTimeout(SDL.audio.caller, 1000.0 * (playtime-curtime));
            ++SDL.audio.numAudioTimersPending;
            // And also schedule extra buffers _now_ if we have too few in queue.
            if (SDL.audio.numAudioTimersPending < SDL.audio.numSimultaneouslyQueuedBuffers) {
              ++SDL.audio.numAudioTimersPending;
              Browser.safeSetTimeout(SDL.audio.caller, 1.0);
            }
          }
        } else {
          // Initialize Web Audio API if we haven't done so yet. Note: Only initialize Web Audio context ever once on the web page,
          // since initializing multiple times fails on Chrome saying 'audio resources have been exhausted'.
          if (!SDL.audioContext) {
            if (typeof(AudioContext) === 'function') {
              SDL.audioContext = new AudioContext();
            } else if (typeof(webkitAudioContext) === 'function') {
              SDL.audioContext = new webkitAudioContext();
            } else {
              throw 'Web Audio API is not available!';
            }
          }
          SDL.audio.soundSource = new Array(); // Use an array of sound sources as a ring buffer to queue blocks of synthesized audio to Web Audio API.
          SDL.audio.nextSoundSource = 0; // Index of the next sound buffer in the ring buffer queue to play.
          SDL.audio.nextPlayTime = 0; // Time in seconds when the next audio block is due to start.
          // The pushAudio function with a new audio buffer whenever there is new audio data to schedule to be played back on the device.
          SDL.audio.pushAudio=function(ptr,sizeBytes) {
            try {
              --SDL.audio.numAudioTimersPending;
              var sizeSamples = sizeBytes / SDL.audio.bytesPerSample; // How many samples fit in the callback buffer?
              var sizeSamplesPerChannel = sizeSamples / SDL.audio.channels; // How many samples per a single channel fit in the cb buffer?
              if (sizeSamplesPerChannel != SDL.audio.samples) {
                throw 'Received mismatching audio buffer size!';
              }
              // Allocate new sound buffer to be played.
              var source = SDL.audioContext['createBufferSource']();
              if (SDL.audio.soundSource[SDL.audio.nextSoundSource]) {
                SDL.audio.soundSource[SDL.audio.nextSoundSource]['disconnect'](); // Explicitly disconnect old source, since we know it shouldn't be running anymore.
              }
              SDL.audio.soundSource[SDL.audio.nextSoundSource] = source;
              var soundBuffer = SDL.audioContext['createBuffer'](SDL.audio.channels,sizeSamplesPerChannel,SDL.audio.freq);
              SDL.audio.soundSource[SDL.audio.nextSoundSource]['connect'](SDL.audioContext['destination']);
              // The input audio data is interleaved across the channels, i.e. [L, R, L, R, L, R, ...] and is either 8-bit or 16-bit as
              // supported by the SDL API. The output audio wave data for Web Audio API must be in planar buffers of [-1,1]-normalized Float32 data,
              // so perform a buffer conversion for the data.
              var numChannels = SDL.audio.channels;
              for(var i = 0; i < numChannels; ++i) {
                var channelData = soundBuffer['getChannelData'](i);
                if (channelData.length != sizeSamplesPerChannel) {
                  throw 'Web Audio output buffer length mismatch! Destination size: ' + channelData.length + ' samples vs expected ' + sizeSamplesPerChannel + ' samples!';
                }
                if (SDL.audio.format == 0x8010 /*AUDIO_S16LSB*/) {
                  for(var j = 0; j < sizeSamplesPerChannel; ++j) {
                    channelData[j] = (HEAP16[(((ptr)+((j*numChannels + i)*2))>>1)]) / 0x8000;
                  }
                } else if (SDL.audio.format == 0x0008 /*AUDIO_U8*/) {
                  for(var j = 0; j < sizeSamplesPerChannel; ++j) {
                    var v = (HEAP8[(((ptr)+(j*numChannels + i))|0)]);
                    channelData[j] = ((v >= 0) ? v-128 : v+128) /128;
                  }
                }
              }
              // Workaround https://bugzilla.mozilla.org/show_bug.cgi?id=883675 by setting the buffer only after filling. The order is important here!
              source['buffer'] = soundBuffer;
              // Schedule the generated sample buffer to be played out at the correct time right after the previously scheduled
              // sample buffer has finished.
              var curtime = SDL.audioContext['currentTime'];
              var playtime = Math.max(curtime, SDL.audio.nextPlayTime);
              SDL.audio.soundSource[SDL.audio.nextSoundSource]['start'](playtime);
              var buffer_duration = sizeSamplesPerChannel / SDL.audio.freq;
              SDL.audio.nextPlayTime = playtime + buffer_duration;
              SDL.audio.nextSoundSource = (SDL.audio.nextSoundSource + 1) % 4;
              var secsUntilNextCall = playtime-curtime;
              // Queue the next audio frame push to be performed when the previously queued buffer has finished playing.
              if (SDL.audio.numAudioTimersPending == 0) {
                var preemptBufferFeedMSecs = buffer_duration/2.0;
                SDL.audio.timer = Browser.safeSetTimeout(SDL.audio.caller, Math.max(0.0, 1000.0*secsUntilNextCall-preemptBufferFeedMSecs));
                ++SDL.audio.numAudioTimersPending;
              }
              // If we are risking starving, immediately queue extra buffers.
              if (secsUntilNextCall <= buffer_duration && SDL.audio.numAudioTimersPending < SDL.audio.numSimultaneouslyQueuedBuffers) {
                ++SDL.audio.numAudioTimersPending;
                Browser.safeSetTimeout(SDL.audio.caller, 1.0);
              }
            } catch(e) {
              console.log('Web Audio API error playing back audio: ' + e.toString());
            }
          }
        }
        if (obtained) {
          // Report back the initialized audio parameters.
          HEAP32[((obtained)>>2)]=SDL.audio.freq;
          HEAP16[(((obtained)+(4))>>1)]=SDL.audio.format;
          HEAP8[(((obtained)+(6))|0)]=SDL.audio.channels;
          HEAP8[(((obtained)+(7))|0)]=SDL.audio.silence;
          HEAP16[(((obtained)+(8))>>1)]=SDL.audio.samples;
          HEAP32[(((obtained)+(16))>>2)]=SDL.audio.callback;
          HEAP32[(((obtained)+(20))>>2)]=SDL.audio.userdata;
        }
        SDL.allocateChannels(32);
      } catch(e) {
        console.log('Initializing SDL audio threw an exception: "' + e.toString() + '"! Continuing without audio.');
        SDL.audio = null;
        SDL.allocateChannels(0);
        if (obtained) {
          HEAP32[((obtained)>>2)]=0;
          HEAP16[(((obtained)+(4))>>1)]=0;
          HEAP8[(((obtained)+(6))|0)]=0;
          HEAP8[(((obtained)+(7))|0)]=0;
          HEAP16[(((obtained)+(8))>>1)]=0;
          HEAP32[(((obtained)+(16))>>2)]=0;
          HEAP32[(((obtained)+(20))>>2)]=0;
        }
      }
      if (!SDL.audio) {
        return -1;
      }
      return 0;
    }
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }
  function _SDL_GetError() {
      if (!SDL.errorMessage) {
        SDL.errorMessage = allocate(intArrayFromString("unknown SDL-emscripten error"), 'i8', ALLOC_NORMAL);
      }
      return SDL.errorMessage;
    }
  function _SDL_PauseAudio(pauseOn) {
      if (!SDL.audio) {
        return;
      }
      if (pauseOn) {
        if (SDL.audio.timer !== undefined) {
          clearTimeout(SDL.audio.timer);
          SDL.audio.numAudioTimersPending = 0;
          SDL.audio.timer = undefined;
        }
      } else if (!SDL.audio.timer) {
        // Start the audio playback timer callback loop.
        SDL.audio.numAudioTimersPending = 1;
        SDL.audio.timer = Browser.safeSetTimeout(SDL.audio.caller, 1);
        SDL.audio.startTime = Date.now() / 1000.0; // Only used for Mozilla Audio Data API. Not needed for Web Audio API.
      }
      SDL.audio.paused = pauseOn;
    }
  function _emscripten_async_wget2(url, file, request, param, arg, onload, onerror, onprogress) {
      var _url = Pointer_stringify(url);
      var _file = Pointer_stringify(file);
      var _request = Pointer_stringify(request);
      var _param = Pointer_stringify(param);
      var index = _file.lastIndexOf('/');
      var http = new XMLHttpRequest();
      http.open(_request, _url, true);
      http.responseType = 'arraybuffer';
      // LOAD
      http.onload = function http_onload(e) {
        if (http.status == 200) {
          FS.createDataFile( _file.substr(0, index), _file.substr(index + 1), new Uint8Array(http.response), true, true);
          if (onload) Runtime.dynCall('vii', onload, [arg, file]);
        } else {
          if (onerror) Runtime.dynCall('vii', onerror, [arg, http.status]);
        }
      };
      // ERROR
      http.onerror = function http_onerror(e) {
        if (onerror) Runtime.dynCall('vii', onerror, [arg, http.status]);
      };
      // PROGRESS
      http.onprogress = function http_onprogress(e) {
        var percentComplete = (e.position / e.totalSize)*100;
        if (onprogress) Runtime.dynCall('vii', onprogress, [arg, percentComplete]);
      };
      // Useful because the browser can limit the number of redirection
      try {
        if (http.channel instanceof Ci.nsIHttpChannel)
        http.channel.redirectionLimit = 0;
      } catch (ex) { /* whatever */ }
      if (_request == "POST") {
        //Send the proper header information along with the request
        http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        http.setRequestHeader("Content-length", _param.length);
        http.setRequestHeader("Connection", "close");
        http.send(_param);
      } else {
        http.send(null);
      }
    }
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
      // Apply sign.
      ret *= multiplier;
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }
  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }
  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }
  var _environ=allocate(1, "i32*", ALLOC_STATIC);var ___environ=_environ;function ___buildEnvironment(env) {
      // WARNING: Arbitrary limit!
      var MAX_ENV_VALUES = 64;
      var TOTAL_ENV_SIZE = 1024;
      // Statically allocate memory for the environment.
      var poolPtr;
      var envPtr;
      if (!___buildEnvironment.called) {
        ___buildEnvironment.called = true;
        // Set default values. Use string keys for Closure Compiler compatibility.
        ENV['USER'] = 'root';
        ENV['PATH'] = '/';
        ENV['PWD'] = '/';
        ENV['HOME'] = '/home/emscripten';
        ENV['LANG'] = 'en_US.UTF-8';
        ENV['_'] = './this.program';
        // Allocate memory.
        poolPtr = allocate(TOTAL_ENV_SIZE, 'i8', ALLOC_STATIC);
        envPtr = allocate(MAX_ENV_VALUES * 4,
                          'i8*', ALLOC_STATIC);
        HEAP32[((envPtr)>>2)]=poolPtr
        HEAP32[((_environ)>>2)]=envPtr;
      } else {
        envPtr = HEAP32[((_environ)>>2)];
        poolPtr = HEAP32[((envPtr)>>2)];
      }
      // Collect key=value lines.
      var strings = [];
      var totalSize = 0;
      for (var key in env) {
        if (typeof env[key] === 'string') {
          var line = key + '=' + env[key];
          strings.push(line);
          totalSize += line.length;
        }
      }
      if (totalSize > TOTAL_ENV_SIZE) {
        throw new Error('Environment size exceeded TOTAL_ENV_SIZE!');
      }
      // Make new.
      var ptrSize = 4;
      for (var i = 0; i < strings.length; i++) {
        var line = strings[i];
        writeAsciiToMemory(line, poolPtr);
        HEAP32[(((envPtr)+(i * ptrSize))>>2)]=poolPtr;
        poolPtr += line.length + 1;
      }
      HEAP32[(((envPtr)+(strings.length * ptrSize))>>2)]=0;
    }var ENV={};function _getenv(name) {
      // char *getenv(const char *name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/getenv.html
      if (name === 0) return 0;
      name = Pointer_stringify(name);
      if (!ENV.hasOwnProperty(name)) return 0;
      if (_getenv.ret) _free(_getenv.ret);
      _getenv.ret = allocate(intArrayFromString(ENV[name]), 'i8', ALLOC_NORMAL);
      return _getenv.ret;
    }
  function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }
  var _llvm_va_start=undefined;
  Module["_strncpy"] = _strncpy;
  function _creat(path, mode) {
      // int creat(const char *path, mode_t mode);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/creat.html
      return _open(path, 1 | 64 | 512, allocate([mode, 0, 0, 0], 'i32', ALLOC_STACK));
    }
  function _mktemp(template) {
      if (!_mktemp.counter) _mktemp.counter = 0;
      var c = (_mktemp.counter++).toString();
      var rep = 'XXXXXX';
      while (c.length < rep.length) c = '0' + c;
      writeArrayToMemory(intArrayFromString(c), template + Pointer_stringify(template).indexOf(rep));
      return template;
    }function _mkstemp(template) {
      return _creat(_mktemp(template), 0600);
    }
  function _fdopen(fildes, mode) {
      // FILE *fdopen(int fildes, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fdopen.html
      mode = Pointer_stringify(mode);
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      if ((mode.indexOf('w') != -1 && !stream.isWrite) ||
          (mode.indexOf('r') != -1 && !stream.isRead) ||
          (mode.indexOf('a') != -1 && !stream.isAppend) ||
          (mode.indexOf('+') != -1 && (!stream.isRead || !stream.isWrite))) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      } else {
        stream.error = false;
        stream.eof = false;
        return fildes;
      }
    }
  Module["_tolower"] = _tolower; 
  Module["_strncasecmp"] = _strncasecmp; 
  Module["_strcasecmp"] = _strcasecmp;
  function _toupper(chr) {
      if (chr >= 97 && chr <= 122) {
        return chr - 97 + 65;
      } else {
        return chr;
      }
    }
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode
        HEAP32[(((buf)+(16))>>2)]=stat.nlink
        HEAP32[(((buf)+(20))>>2)]=stat.uid
        HEAP32[(((buf)+(24))>>2)]=stat.gid
        HEAP32[(((buf)+(28))>>2)]=stat.rdev
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size
        HEAP32[(((buf)+(40))>>2)]=4096
        HEAP32[(((buf)+(44))>>2)]=stat.blocks
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000)
        HEAP32[(((buf)+(52))>>2)]=0
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000)
        HEAP32[(((buf)+(60))>>2)]=0
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000)
        HEAP32[(((buf)+(68))>>2)]=0
        HEAP32[(((buf)+(72))>>2)]=stat.ino
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _gettimeofday(ptr) {
      var now = Date.now();
      HEAP32[((ptr)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((ptr)+(4))>>2)]=Math.floor((now-1000*Math.floor(now/1000))*1000); // microseconds
      return 0;
    }
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    }
  function _strncmp(px, py, n) {
      var i = 0;
      while (i < n) {
        var x = HEAPU8[(((px)+(i))|0)];
        var y = HEAPU8[(((py)+(i))|0)];
        if (x == y && x == 0) return 0;
        if (x == 0) return -1;
        if (y == 0) return 1;
        if (x == y) {
          i ++;
          continue;
        } else {
          return x > y ? 1 : -1;
        }
      }
      return 0;
    }
  function _strcmp(px, py) {
      return _strncmp(px, py, TOTAL_MEMORY);
    }
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStream(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop()
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(stream, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }
  var _sqrt=Math_sqrt;
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var ret = _lseek(stream, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStream(stream);
      stream.eof = false;
      return 0;
    }
  Module["_strcpy"] = _strcpy;
  function _strchr(ptr, chr) {
      ptr--;
      do {
        ptr++;
        var val = HEAP8[(ptr)];
        if (val == chr) return ptr;
      } while (val);
      return 0;
    }
  function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStream(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }function _fgets(s, n, stream) {
      // char *fgets(char *restrict s, int n, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgets.html
      var streamObj = FS.getStream(stream);
      if (!streamObj) return 0;
      if (streamObj.error || streamObj.eof) return 0;
      var byte_;
      for (var i = 0; i < n - 1 && byte_ != 10; i++) {
        byte_ = _fgetc(stream);
        if (byte_ == -1) {
          if (streamObj.error || (streamObj.eof && i == 0)) return 0;
          else if (streamObj.eof) break;
        }
        HEAP8[(((s)+(i))|0)]=byte_
      }
      HEAP8[(((s)+(i))|0)]=0
      return s;
    }
  function _feof(stream) {
      // int feof(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/feof.html
      stream = FS.getStream(stream);
      return Number(stream && stream.eof);
    }
  function ___errno_location() {
      return ___errno_state;
    }
  function _getcwd(buf, size) {
      // char *getcwd(char *buf, size_t size);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/getcwd.html
      if (size == 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var cwd = FS.cwd();
      if (size < cwd.length + 1) {
        ___setErrNo(ERRNO_CODES.ERANGE);
        return 0;
      } else {
        writeAsciiToMemory(cwd, buf);
        return buf;
      }
    }
  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _rename(old_path, new_path) {
      // int rename(const char *old, const char *new);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rename.html
      old_path = Pointer_stringify(old_path);
      new_path = Pointer_stringify(new_path);
      try {
        FS.rename(old_path, new_path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _rand() {
      return Math.floor(Math.random()*0x80000000);
    }
  var ___strtok_state=0;
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }
  function _llvm_va_end() {}
  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }
  function _setvbuf(stream, buf, type, size) {
      // int setvbuf(FILE *restrict stream, char *restrict buf, int type, size_t size);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/setvbuf.html
      // TODO: Implement custom buffering.
      return 0;
    }function _setbuf(stream, buf) {
      // void setbuf(FILE *restrict stream, char *restrict buf);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/setbuf.html
      if (buf) _setvbuf(stream, buf, 0, 8192);  // _IOFBF, BUFSIZ.
      else _setvbuf(stream, buf, 2, 8192);  // _IONBF, BUFSIZ.
    }
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStream(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }
  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }
  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret
      }
      return ret;
    }
  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }
  function _gzopen() {
  Module['printErr']('missing function: gzopen'); abort(-1);
  }
  function _gzwrite() {
  Module['printErr']('missing function: gzwrite'); abort(-1);
  }
  function _gzclose() {
  Module['printErr']('missing function: gzclose'); abort(-1);
  }
  function _gzread() {
  Module['printErr']('missing function: gzread'); abort(-1);
  }
  function _ferror(stream) {
      // int ferror(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ferror.html
      stream = FS.getStream(stream);
      return Number(stream && stream.error);
    }
  var _exp=Math_exp;
  function _llvm_uadd_with_overflow_i32(x, y) {
      x = x>>>0;
      y = y>>>0;
      return ((asm["setTempRet0"](x+y > 4294967295),(x+y)>>>0)|0);
    }
  function _llvm_bswap_i16(x) {
      return ((x&0xff)<<8) | ((x>>8)&0xff);
    }
  function _memchr(ptr, chr, num) {
      chr = unSign(chr);
      for (var i = 0; i < num; i++) {
        if (HEAP8[(ptr)] == chr) return ptr;
        ptr++;
      }
      return 0;
    }
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset())
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds()
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes()
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours()
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate()
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth()
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay()
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }
  var _putc=_fputc;
  var _log=Math_log;
  var _ceil=Math_ceil;
  function _llvm_umul_with_overflow_i32(x, y) {
      x = x>>>0;
      y = y>>>0;
      return ((asm["setTempRet0"](x*y > 4294967295),(x*y)>>>0)|0);
    }
  var _fabs=Math_abs;
  var _sin=Math_sin;
  var _floor=Math_floor;
  function _pthread_mutex_lock() {}
  function _pthread_mutex_unlock() {}
  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }
  function ___cxa_guard_release() {}
  function _pthread_cond_broadcast() {
      return 0;
    }
  function _pthread_cond_wait() {
      return 0;
    }
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStream(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }
  var _getc=_fgetc;
  function _abort() {
      Module['abort']();
    }
  function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      throw HEAP32[((_llvm_eh_exception.buf)>>2)] + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";;
    }
  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }
  function ___cxa_guard_abort() {}
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }var _isxdigit_l=_isxdigit;
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }var _isdigit_l=_isdigit;
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16)
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text)
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text)
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j]
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }
  function _catopen() { throw 'TODO: ' + aborter }
  function _catgets() { throw 'TODO: ' + aborter }
  function _catclose() { throw 'TODO: ' + aborter }
  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }
  function _freelocale(locale) {
      _free(locale);
    }
  function _isascii(chr) {
      return chr >= 0 && (chr & 0x80) == 0;
    }
  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i]
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
      var pattern = Pointer_stringify(format);
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }var _strftime_l=_strftime;
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }var _strtoull_l=_strtoull;
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }var _strtoll_l=_strtoll;
  function _uselocale(locale) {
      return 0;
    }
  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }
  function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }
  function ___cxa_call_unexpected(exception) {
      Module.printErr('Unexpected exception thrown, this is not properly supported - aborting');
      ABORT = true;
      throw exception;
    }
FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_llvm_eh_exception.buf = allocate(12, "void*", ALLOC_STATIC);
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
___buildEnvironment(ENV);
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
___strtok_state = Runtime.staticAlloc(4);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true; // seal the static portion of memory
STACK_MAX = STACK_BASE + 5242880;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY); // Stack must fit in TOTAL_MEMORY; allocations from here on may enlarge TOTAL_MEMORY
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);
var Math_min = Math.min;
function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.__ZTVN10__cxxabiv117__class_type_infoE|0;var p=env.___fsmu8|0;var q=env._stdout|0;var r=env.___dso_handle|0;var s=env._stdin|0;var t=env.__ZTVN10__cxxabiv120__si_class_type_infoE|0;var u=env._stderr|0;var v=+env.NaN;var w=+env.Infinity;var x=0;var y=0;var z=0;var A=0;var B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=0;var U=global.Math.floor;var V=global.Math.abs;var W=global.Math.sqrt;var X=global.Math.pow;var Y=global.Math.cos;var Z=global.Math.sin;var _=global.Math.tan;var $=global.Math.acos;var aa=global.Math.asin;var ab=global.Math.atan;var ac=global.Math.atan2;var ad=global.Math.exp;var ae=global.Math.log;var af=global.Math.ceil;var ag=global.Math.imul;var ah=env.abort;var ai=env.assert;var aj=env.asmPrintInt;var ak=env.asmPrintFloat;var al=env.min;var am=env.jsCall;var an=env.invoke_viiiii;var ao=env.invoke_viiii;var ap=env.invoke_i;var aq=env.invoke_vi;var ar=env.invoke_vii;var as=env.invoke_iiiiiii;var at=env.invoke_iii;var au=env.invoke_iiii;var av=env.invoke_viiiiiid;var aw=env.invoke_ii;var ax=env.invoke_viiiiiii;var ay=env.invoke_viiiiid;var az=env.invoke_v;var aA=env.invoke_iiiiiiiii;var aB=env.invoke_viiiiiiiii;var aC=env.invoke_viiiiiiii;var aD=env.invoke_viiiiii;var aE=env.invoke_iiiii;var aF=env.invoke_iiiiii;var aG=env.invoke_viii;var aH=env._llvm_lifetime_end;var aI=env._llvm_uadd_with_overflow_i32;var aJ=env._sysconf;var aK=env._lseek;var aL=env.__scanString;var aM=env._fclose;var aN=env._pthread_mutex_lock;var aO=env.___cxa_end_catch;var aP=env._strtoull;var aQ=env._fflush;var aR=env._strtol;var aS=env._fputc;var aT=env._strtok;var aU=env._fwrite;var aV=env._llvm_eh_exception;var aW=env._fputs;var aX=env._llvm_umul_with_overflow_i32;var aY=env._isspace;var aZ=env._localtime;var a_=env._read;var a$=env._ceil;var a0=env._strstr;var a1=env._fsync;var a2=env.___cxa_guard_abort;var a3=env._newlocale;var a4=env._SDL_PauseAudio;var a5=env.___gxx_personality_v0;var a6=env._pthread_cond_wait;var a7=env.___cxa_rethrow;var a8=env.___resumeException;var a9=env._strcmp;var ba=env._memchr;var bb=env._strncmp;var bc=env._vsscanf;var bd=env._snprintf;var be=env._fgetc;var bf=env._ceilf;var bg=env.__getFloat;var bh=env._atexit;var bi=env._mknod;var bj=env.___cxa_free_exception;var bk=env._fgets;var bl=env._close;var bm=env._mktemp;var bn=env.___setErrNo;var bo=env._isxdigit;var bp=env._access;var bq=env._ftell;var br=env._exit;var bs=env._sprintf;var bt=env._asprintf;var bu=env.___ctype_b_loc;var bv=env._strrchr;var bw=env._freelocale;var bx=env._catopen;var by=env._catgets;var bz=env._getcwd;var bA=env._ferror;var bB=env.___cxa_is_number_type;var bC=env.___cxa_does_inherit;var bD=env.___cxa_guard_acquire;var bE=env._localtime_r;var bF=env.___cxa_begin_catch;var bG=env._recv;var bH=env.__parseInt64;var bI=env._log;var bJ=env.__ZSt18uncaught_exceptionv;var bK=env._putchar;var bL=env.___cxa_call_unexpected;var bM=env.__exit;var bN=env._strftime;var bO=env._rand;var bP=env._tzset;var bQ=env.___cxa_throw;var bR=env._send;var bS=env._toupper;var bT=env._printf;var bU=env._pread;var bV=env._fopen;var bW=env._open;var bX=env.__arraySum;var bY=env.___assert_fail;var bZ=env._puts;var b_=env._fdopen;var b$=env._mkdir;var b0=env.___cxa_find_matching_catch;var b1=env._SDL_GetError;var b2=env.__formatString;var b3=env._pthread_cond_broadcast;var b4=env._getenv;var b5=env.__ZSt9terminatev;var b6=env._gettimeofday;var b7=env._atoi;var b8=env._vfprintf;var b9=env._isascii;var ca=env._pthread_mutex_unlock;var cb=env._llvm_bswap_i16;var cc=env._sbrk;var cd=env.___errno_location;var ce=env._strerror;var cf=env._gzopen;var cg=env._catclose;var ch=env._llvm_lifetime_start;var ci=env.__parseInt;var cj=env.___cxa_guard_release;var ck=env._ungetc;var cl=env._SDL_OpenAudio;var cm=env._uselocale;var cn=env._rename;var co=env._vsnprintf;var cp=env._sscanf;var cq=env._creat;var cr=env._fread;var cs=env._strtok_r;var ct=env._abort;var cu=env._fprintf;var cv=env._isdigit;var cw=env._strtoll;var cx=env.___buildEnvironment;var cy=env._feof;var cz=env.__addDays;var cA=env._emscripten_async_wget2;var cB=env._fabs;var cC=env._floor;var cD=env.__reallyNegative;var cE=env._fseek;var cF=env._sqrt;var cG=env._write;var cH=env._gzread;var cI=env._mkstemp;var cJ=env.___cxa_allocate_exception;var cK=env._sin;var cL=env._strchr;var cM=env._stat;var cN=env.___cxa_pure_virtual;var cO=env._vasprintf;var cP=env._gzwrite;var cQ=env.___ctype_toupper_loc;var cR=env.___ctype_tolower_loc;var cS=env._setbuf;var cT=env._llvm_va_end;var cU=env._unlink;var cV=env._pwrite;var cW=env._strerror_r;var cX=env._gzclose;var cY=env.__isLeapYear;var cZ=env._exp;var c_=env._time;var c$=env._setvbuf;var c0=0.0;
// EMSCRIPTEN_START_FUNCS
function dl(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function dm(){return i|0}function dn(a){a=a|0;i=a}function dp(a,b){a=a|0;b=b|0;if((x|0)==0){x=a;y=b}}function dq(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function dr(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function ds(a){a=a|0;K=a}function dt(a){a=a|0;L=a}function du(a){a=a|0;M=a}function dv(a){a=a|0;N=a}function dw(a){a=a|0;O=a}function dx(a){a=a|0;P=a}function dy(a){a=a|0;Q=a}function dz(a){a=a|0;R=a}function dA(a){a=a|0;S=a}function dB(a){a=a|0;T=a}function dC(){c[24264]=o+8;c[24266]=o+8;c[24268]=t+8;c[24272]=t+8;c[24276]=t+8;c[24280]=t+8;c[24284]=t+8;c[24288]=t+8;c[24292]=t+8;c[24296]=o+8;c[24330]=t+8;c[24334]=t+8;c[24398]=t+8;c[24402]=t+8;c[24422]=o+8;c[24424]=t+8;c[24460]=t+8;c[24464]=t+8;c[24500]=t+8;c[24504]=t+8;c[24524]=o+8;c[24526]=o+8;c[24528]=t+8;c[24532]=t+8;c[24536]=t+8;c[24540]=t+8;c[24544]=t+8;c[24548]=t+8;c[24552]=o+8;c[24554]=o+8;c[24556]=o+8;c[24566]=o+8;c[24568]=o+8;c[24570]=o+8;c[24572]=o+8;c[24598]=t+8;c[24602]=o+8;c[24604]=t+8;c[24608]=t+8;c[24612]=t+8;c[24616]=o+8;c[24618]=o+8;c[24620]=o+8;c[24622]=o+8;c[24656]=o+8;c[24658]=o+8;c[24660]=o+8;c[24662]=t+8;c[24666]=t+8;c[24670]=t+8;c[24674]=t+8;c[24678]=t+8;c[24682]=t+8;c[24686]=t+8;c[24690]=t+8;c[24694]=o+8;c[24696]=o+8}function dD(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;qz();kH();mY();hD();iQ(83616)|0;mH()|0;if((gw()|0)<0){e$(83472,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0);i=e;f=0;i=d;return f|0}if((ie()|0)<0){e$(83056,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0);i=e;f=0;i=d;return f|0}h8(82952,0)|0;h8(82816,0)|0;if((a[b]&1)==0){g=b+1|0}else{g=c[b+8>>2]|0}h9(82664,g)|0;if((gx()|0)>=0){f=1;i=d;return f|0}e$(82480,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0);i=e;f=0;i=d;return f|0}function dE(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e|0;c[b>>2]=93600;b$(90120,511)|0;b=bV(90104,86008)|0;aU(d|0,1,8192,b|0)|0;aM(b|0)|0;b=bV(83624,86008)|0;aU(d+8192|0,1,4096,b|0)|0;aM(b|0)|0;b=bV(81952,86008)|0;aU(d+12288|0,1,8192,b|0)|0;aM(b|0)|0;b=f;a[b]=6;d=f+1|0;a[d]=a[90120]|0;a[d+1|0]=a[90121]|0;a[d+2|0]=a[90122]|0;a[f+4|0]=0;dD(f)|0;if((a[b]&1)==0){i=e;return}AT(c[f+8>>2]|0);i=e;return}function dF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d|0;f=e;c[b>>2]=93600;g=AR(32)|0;h=e+8|0;c[h>>2]=g;c[e>>2]=33;c[e+4>>2]=19;A$(g|0,79752,19)|0;a[g+19|0]=0;ru(80664,161,1,e);if((a[f]&1)!=0){AT(c[h>>2]|0)}hG();AT(b);i=d;return}function dG(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d|0;c[b>>2]=93600;b=AR(32)|0;f=e+8|0;c[f>>2]=b;c[e>>2]=33;c[e+4>>2]=19;A$(b|0,79752,19)|0;a[b+19|0]=0;ru(80664,161,1,e);if((a[e]&1)!=0){AT(c[f>>2]|0)}hG();i=d;return}function dH(a){a=a|0;dK(a|0,c[a+4>>2]|0);return}function dI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;e=b|0;f=c[4550594]|0;if((f|0)==18202380){g=0;i=b;return g|0}h=e;j=e+8|0;k=e+1|0;l=e|0;m=e+4|0;n=f;while(1){f=n+16|0;if((a[f]&1)==0){c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2]}else{f=c[n+24>>2]|0;o=c[n+20>>2]|0;if(o>>>0>4294967279>>>0){p=50;break}if(o>>>0<11>>>0){a[h]=o<<1&255;q=k}else{r=o+16&-16;s=AR(r)|0;c[j>>2]=s;c[l>>2]=r|1;c[m>>2]=o;q=s}A$(q|0,f|0,o)|0;a[q+o|0]=0}o=rC(d,e)|0;if((a[h]&1)!=0){AT(c[j>>2]|0)}if(o){g=1;p=69;break}o=c[n+4>>2]|0;if((o|0)==0){f=n|0;while(1){s=c[f+8>>2]|0;if((f|0)==(c[s>>2]|0)){t=s;break}else{f=s}}}else{f=o;while(1){s=c[f>>2]|0;if((s|0)==0){t=f;break}else{f=s}}}if((t|0)==18202380){g=0;p=70;break}else{n=t}}if((p|0)==50){tB(0);return 0}else if((p|0)==69){i=b;return g|0}else if((p|0)==70){i=b;return g|0}return 0}function dJ(a,b){a=a|0;b=b|0;a=AR(36)|0;dP(a,b);return a|0}function dK(b,d){b=b|0;d=d|0;if((d|0)==0){return}dK(b,c[d>>2]|0);dK(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){AT(c[d+24>>2]|0)}AT(d);return}function dL(a){a=a|0;bF(a|0)|0;b5()}function dM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=i;h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=b+4|0;j=c[d>>2]|0;do{if((j|0)!=(h|0)){d=f;k=a[f]|0;l=k&255;m=(l&1|0)==0;if(m){n=l>>>1}else{n=c[f+4>>2]|0}o=j+16|0;p=o;q=a[o]|0;o=q&255;r=(o&1|0)==0;if(r){s=o>>>1}else{s=c[j+20>>2]|0}t=(k&1)==0;if(t){u=d+1|0}else{u=c[f+8>>2]|0}k=(q&1)==0;if(k){v=p+1|0}else{v=c[j+24>>2]|0}q=A0(u|0,v|0,(s>>>0<n>>>0?s:n)|0)|0;if((q|0)==0){if(n>>>0<s>>>0){break}}else{if((q|0)<0){break}}if(r){w=o>>>1}else{w=c[j+20>>2]|0}if(m){x=l>>>1}else{x=c[f+4>>2]|0}if(k){y=p+1|0}else{y=c[j+24>>2]|0}if(t){z=d+1|0}else{z=c[f+8>>2]|0}p=A0(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((p|0)==0){if(w>>>0>=x>>>0){A=161}}else{if((p|0)>=0){A=161}}if((A|0)==161){c[e>>2]=j;B=e;i=g;return B|0}p=j+4|0;k=c[p>>2]|0;o=(k|0)==0;if(o){r=j|0;while(1){q=c[r+8>>2]|0;if((r|0)==(c[q>>2]|0)){C=q;break}else{r=q}}}else{r=k;while(1){q=c[r>>2]|0;if((q|0)==0){C=r;break}else{r=q}}}do{if((C|0)!=(h|0)){if(m){D=l>>>1}else{D=c[f+4>>2]|0}r=C+16|0;k=a[r]|0;q=k&255;if((q&1|0)==0){E=q>>>1}else{E=c[C+20>>2]|0}if(t){F=d+1|0}else{F=c[f+8>>2]|0}if((k&1)==0){G=r+1|0}else{G=c[C+24>>2]|0}r=A0(F|0,G|0,(E>>>0<D>>>0?E:D)|0)|0;if((r|0)==0){if(D>>>0<E>>>0){break}}else{if((r|0)<0){break}}B=dO(b,e,f)|0;i=g;return B|0}}while(0);if(o){c[e>>2]=j;B=p;i=g;return B|0}else{c[e>>2]=C;B=C|0;i=g;return B|0}}}while(0);C=c[j>>2]|0;do{if((j|0)==(c[b>>2]|0)){H=j}else{if((C|0)==0){E=j|0;while(1){D=c[E+8>>2]|0;if((E|0)==(c[D>>2]|0)){E=D}else{I=D;break}}}else{E=C;while(1){p=c[E+4>>2]|0;if((p|0)==0){I=E;break}else{E=p}}}E=I;p=I+16|0;o=a[p]|0;D=o&255;if((D&1|0)==0){J=D>>>1}else{J=c[I+20>>2]|0}D=a[f]|0;G=D&255;if((G&1|0)==0){K=G>>>1}else{K=c[f+4>>2]|0}if((o&1)==0){L=p+1|0}else{L=c[I+24>>2]|0}if((D&1)==0){M=f+1|0}else{M=c[f+8>>2]|0}D=A0(L|0,M|0,(K>>>0<J>>>0?K:J)|0)|0;if((D|0)==0){if(J>>>0<K>>>0){H=E;break}}else{if((D|0)<0){H=E;break}}B=dO(b,e,f)|0;i=g;return B|0}}while(0);if((C|0)==0){c[e>>2]=j;B=j|0;i=g;return B|0}else{c[e>>2]=H;B=H+4|0;i=g;return B|0}return 0}function dN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=(d|0)==(b|0);a[d+12|0]=e&1;if(e){return}else{f=d}while(1){g=f+8|0;h=c[g>>2]|0;d=h+12|0;if((a[d]&1)!=0){i=207;break}j=h+8|0;k=c[j>>2]|0;e=c[k>>2]|0;if((h|0)==(e|0)){l=c[k+4>>2]|0;if((l|0)==0){i=176;break}m=l+12|0;if((a[m]&1)!=0){i=176;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}else{if((e|0)==0){i=193;break}m=e+12|0;if((a[m]&1)!=0){i=193;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}if((k|0)==(b|0)){i=209;break}else{f=k}}if((i|0)==176){if((f|0)==(c[h>>2]|0)){n=h;o=k}else{b=h+4|0;m=c[b>>2]|0;d=m|0;e=c[d>>2]|0;c[b>>2]=e;if((e|0)==0){p=k}else{c[e+8>>2]=h;p=c[j>>2]|0}e=m+8|0;c[e>>2]=p;p=c[j>>2]|0;b=p|0;if((c[b>>2]|0)==(h|0)){c[b>>2]=m}else{c[p+4>>2]=m}c[d>>2]=h;c[j>>2]=m;n=m;o=c[e>>2]|0}a[n+12|0]=1;a[o+12|0]=0;n=o|0;e=c[n>>2]|0;m=e+4|0;d=c[m>>2]|0;c[n>>2]=d;if((d|0)!=0){c[d+8>>2]=o}d=o+8|0;c[e+8>>2]=c[d>>2];n=c[d>>2]|0;p=n|0;if((c[p>>2]|0)==(o|0)){c[p>>2]=e}else{c[n+4>>2]=e}c[m>>2]=o;c[d>>2]=e;return}else if((i|0)==193){e=h|0;if((f|0)==(c[e>>2]|0)){d=f+4|0;o=c[d>>2]|0;c[e>>2]=o;if((o|0)==0){q=k}else{c[o+8>>2]=h;q=c[j>>2]|0}c[g>>2]=q;q=c[j>>2]|0;o=q|0;if((c[o>>2]|0)==(h|0)){c[o>>2]=f}else{c[q+4>>2]=f}c[d>>2]=h;c[j>>2]=f;r=f;s=c[g>>2]|0}else{r=h;s=k}a[r+12|0]=1;a[s+12|0]=0;r=s+4|0;k=c[r>>2]|0;h=k|0;g=c[h>>2]|0;c[r>>2]=g;if((g|0)!=0){c[g+8>>2]=s}g=s+8|0;c[k+8>>2]=c[g>>2];r=c[g>>2]|0;f=r|0;if((c[f>>2]|0)==(s|0)){c[f>>2]=k}else{c[r+4>>2]=k}c[h>>2]=s;c[g>>2]=k;return}else if((i|0)==207){return}else if((i|0)==209){return}}function dO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L259:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=A0(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=237}}else{if((o|0)<0){u=237}}if((u|0)==237){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=250;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=A0(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=264;break L259}}else{if((n|0)>=0){B=e;u=264;break L259}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=263;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=A0(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=249}}else{if((p|0)<0){u=249}}if((u|0)==249){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=250;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=A0(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=264;break L259}}else{if((m|0)>=0){B=e;u=264;break L259}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=263;break}else{e=s}}}}while(0);if((u|0)==250){c[d>>2]=w;h=x;return h|0}else if((u|0)==263){c[d>>2]=C;h=D;return h|0}else if((u|0)==264){c[d>>2]=B;h=d;return h|0}return 0}function dP(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+176|0;f=e|0;h=e+16|0;j=e+24|0;k=e+40|0;l=e+48|0;m=e+64|0;n=e+80|0;o=e+96|0;p=e+112|0;q=e+128|0;r=e+144|0;s=e+160|0;t=b|0;A2(b+4|0,0,16);g[b+20>>2]=1.0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;c[b>>2]=93632;if((a[d]&1)==0){u=d+1|0}else{u=c[d+8>>2]|0}c[h>>2]=ks(u)|0;u=AR(16)|0;v=j+8|0;c[v>>2]=u;c[j>>2]=17;c[j+4>>2]=15;A$(u|0,88368,15)|0;a[u+15|0]=0;eu(f,j,d,h);ru(80664,101,1,f);if((a[f]&1)!=0){AT(c[f+8>>2]|0)}if((a[j]&1)!=0){AT(c[v>>2]|0)}if((c[h>>2]|0)!=0){i=e;return}h=kz(k)|0;v=b;j=c[(c[v>>2]|0)+24>>2]|0;f=l;d=l;a[d]=10;u=f+1|0;a[u]=a[87904]|0;a[u+1|0]=a[87905]|0;a[u+2|0]=a[87906]|0;a[u+3|0]=a[87907]|0;a[u+4|0]=a[87908]|0;a[f+6|0]=0;f=kt()|0;u=A1(f|0)|0;if(u>>>0>4294967279>>>0){tB(0)}if(u>>>0<11>>>0){a[m]=u<<1&255;w=m+1|0}else{x=u+16&-16;y=AR(x)|0;c[m+8>>2]=y;c[m>>2]=x|1;c[m+4>>2]=u;w=y}A$(w|0,f|0,u)|0;a[w+u|0]=0;dk[j&127](t,l,m);if((a[m]&1)!=0){AT(c[m+8>>2]|0)}if((a[d]&1)!=0){AT(c[l+8>>2]|0)}l=c[(c[v>>2]|0)+24>>2]|0;d=n;m=n;a[m]=16;j=d+1|0;u=j|0;C=1886220131;a[u]=C&255;C=C>>8;a[u+1|0]=C&255;C=C>>8;a[u+2|0]=C&255;C=C>>8;a[u+3|0]=C&255;u=j+4|0;C=1919251311;a[u]=C&255;C=C>>8;a[u+1|0]=C&255;C=C>>8;a[u+2|0]=C&255;C=C>>8;a[u+3|0]=C&255;a[d+9|0]=0;d=ku()|0;u=A1(d|0)|0;if(u>>>0>4294967279>>>0){tB(0)}if(u>>>0<11>>>0){a[o]=u<<1&255;z=o+1|0}else{j=u+16&-16;w=AR(j)|0;c[o+8>>2]=w;c[o>>2]=j|1;c[o+4>>2]=u;z=w}A$(z|0,d|0,u)|0;a[z+u|0]=0;dk[l&127](t,n,o);if((a[o]&1)!=0){AT(c[o+8>>2]|0)}if((a[m]&1)!=0){AT(c[n+8>>2]|0)}n=c[(c[v>>2]|0)+24>>2]|0;v=p;m=p;a[m]=18;o=v+1|0;A$(o|0,87160,9)|0;a[v+10|0]=0;v=kv()|0;o=A1(v|0)|0;if(o>>>0>4294967279>>>0){tB(0)}if(o>>>0<11>>>0){a[q]=o<<1&255;A=q+1|0}else{l=o+16&-16;u=AR(l)|0;c[q+8>>2]=u;c[q>>2]=l|1;c[q+4>>2]=o;A=u}A$(A|0,v|0,o)|0;a[A+o|0]=0;dk[n&127](t,p,q);if((a[q]&1)!=0){AT(c[q+8>>2]|0)}if((a[m]&1)!=0){AT(c[p+8>>2]|0)}p=b;m=c[(c[p>>2]|0)+28>>2]|0;q=r;n=r;a[n]=10;o=q+1|0;a[o]=a[86800]|0;a[o+1|0]=a[86801]|0;a[o+2|0]=a[86802]|0;a[o+3|0]=a[86803]|0;a[o+4|0]=a[86804]|0;a[q+6|0]=0;dk[m&127](t,r,h);if((a[n]&1)!=0){AT(c[r+8>>2]|0)}r=c[(c[p>>2]|0)+28>>2]|0;p=s;n=s;a[n]=18;h=p+1|0;A$(h|0,86544,9)|0;a[p+10|0]=0;dk[r&127](t,s,(c[k>>2]|0)-1|0);if((a[n]&1)!=0){AT(c[s+8>>2]|0)}c4[c[(c[b>>2]|0)+32>>2]&511](t);h8(83936,-1)|0;h8(83800,0)|0;hz(0);i=e;return}function dQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;c[b>>2]=93688;d=b+24|0;e=c[d>>2]|0;if((e|0)!=0){f=b+28|0;g=c[f>>2]|0;if((e|0)==(g|0)){h=e}else{i=g;do{g=i-24|0;c[f>>2]=g;j=c[i-24+16>>2]|0;do{if((j|0)==(g|0)){c4[c[(c[j>>2]|0)+16>>2]&511](j)}else{if((j|0)==0){break}c4[c[(c[j>>2]|0)+20>>2]&511](j)}}while(0);i=c[f>>2]|0;}while((e|0)!=(i|0));h=c[d>>2]|0}AT(h|0)}h=c[b+12>>2]|0;if((h|0)!=0){d=h;while(1){h=c[d>>2]|0;if((a[d+20|0]&1)!=0){AT(c[d+28>>2]|0)}if((a[d+8|0]&1)!=0){AT(c[d+16>>2]|0)}AT(d);if((h|0)==0){break}else{d=h}}}d=b+4|0;b=c[d>>2]|0;c[d>>2]=0;if((b|0)==0){return}AT(b);return}function dR(a){a=a|0;eq(a);return}function dS(a){a=a|0;eq(a);AT(a);return}function dT(a,b,c){a=a|0;b=b|0;c=c|0;qC(b,c);return c|0}function dU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=d_(d+4|0,e)|0;e=f;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];return}e=c[f+8>>2]|0;d=c[f+4>>2]|0;if(d>>>0>4294967279>>>0){tB(0)}if(d>>>0<11>>>0){a[b]=d<<1&255;g=b+1|0}else{f=d+16&-16;h=AR(f)|0;c[b+8>>2]=h;c[b>>2]=f|1;c[b+4>>2]=d;g=h}A$(g|0,e|0,d)|0;a[g+d|0]=0;return}function dV(a,b,c){a=a|0;b=b|0;c=c|0;if((b|0)<=-1){return}kx(b+1|0);h8(83936,-1)|0;h8(83800,0)|0;hz(0);return}function dW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+80|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+56|0;l=e+64|0;m=AR(32)|0;n=j+8|0;c[n>>2]=m;c[j>>2]=33;c[j+4>>2]=22;A$(m|0,84672,22)|0;a[m+22|0]=0;c[k>>2]=b;ep(h,j,k);ru(85712,46,1,h);if((a[h]&1)!=0){AT(c[h+8>>2]|0)}if((a[j]&1)!=0){AT(c[n>>2]|0)}n=b+28|0;j=c[n>>2]|0;if((j|0)==(c[b+32>>2]|0)){eo(b+24|0,d)}else{do{if((j|0)!=0){h=d+16|0;k=c[h>>2]|0;if((k|0)==0){c[j+16>>2]=0;break}if((k|0)==(d|0)){m=j;c[j+16>>2]=m;o=c[h>>2]|0;c5[c[(c[o>>2]|0)+12>>2]&255](o,m);break}else{c[j+16>>2]=da[c[(c[k>>2]|0)+8>>2]&255](k)|0;break}}}while(0);c[n>>2]=(c[n>>2]|0)+24}n=c[b+12>>2]|0;if((n|0)==0){i=e;return}j=l+8|0;k=l|0;m=l+4|0;o=g;h=l;p=d+16|0;d=g+8|0;q=n;while(1){n=AR(32)|0;c[j>>2]=n;c[k>>2]=33;c[m>>2]=25;A$(n|0,85256,25)|0;a[n+25|0]=0;n=q+8|0;d2(g,l,n);ru(85712,49,1,g);if((a[o]&1)!=0){AT(c[d>>2]|0)}if((a[h]&1)!=0){AT(c[j>>2]|0)}c[f>>2]=b;r=c[p>>2]|0;if((r|0)==0){s=429;break}dk[c[(c[r>>2]|0)+24>>2]&127](r,n,f);n=c[q>>2]|0;if((n|0)==0){s=440;break}else{q=n}}if((s|0)==429){q=cJ(4)|0;c[q>>2]=92424;bQ(q|0,98144,172)}else if((s|0)==440){i=e;return}}function dX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+64|0;g=f|0;h=f+8|0;j=f+24|0;k=f+48|0;tI(d_(b+4|0,d)|0,e)|0;e=c[b+24>>2]|0;l=c[b+28>>2]|0;if((e|0)==(l|0)){i=f;return}m=j+16|0;n=k+8|0;o=k|0;p=k+4|0;q=h;r=k;s=j;t=h+8|0;u=e;while(1){e=u+16|0;v=c[e>>2]|0;do{if((v|0)==0){c[m>>2]=0}else{if((v|0)==(u|0)){c[m>>2]=s;w=c[e>>2]|0;c5[c[(c[w>>2]|0)+12>>2]&255](w,s);break}else{c[m>>2]=da[c[(c[v>>2]|0)+8>>2]&255](v)|0;break}}}while(0);v=AR(32)|0;c[n>>2]=v;c[o>>2]=33;c[p>>2]=25;A$(v|0,85256,25)|0;a[v+25|0]=0;d2(h,k,d);ru(85712,60,1,h);if((a[q]&1)!=0){AT(c[t>>2]|0)}if((a[r]&1)!=0){AT(c[n>>2]|0)}c[g>>2]=b;v=c[m>>2]|0;if((v|0)==0){break}dk[c[(c[v>>2]|0)+24>>2]&127](v,d,g);v=c[m>>2]|0;do{if((v|0)==(s|0)){c4[c[(c[j>>2]|0)+16>>2]&511](s)}else{if((v|0)==0){break}c4[c[(c[v>>2]|0)+20>>2]&511](v)}}while(0);v=u+24|0;if((v|0)==(l|0)){x=479;break}else{u=v}}if((x|0)==479){i=f;return}f=cJ(4)|0;c[f>>2]=92424;bQ(f|0,98144,172)}function dY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=c[(c[b>>2]|0)+24>>2]|0;t0(g,e);dk[h&127](b,d,g);if((a[g]&1)==0){i=f;return}AT(c[g+8>>2]|0);i=f;return}function dZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d|0;f=d+16|0;g=c[(c[b>>2]|0)+24>>2]|0;h=e;a[h]=14;j=e+1|0;a[j]=a[86256]|0;a[j+1|0]=a[86257]|0;a[j+2|0]=a[86258]|0;a[j+3|0]=a[86259]|0;a[j+4|0]=a[86260]|0;a[j+5|0]=a[86261]|0;a[j+6|0]=a[86262]|0;j=e+8|0;a[j]=0;k=f;a[k]=0;a[f+1|0]=0;dk[g&127](b,e,f);if((a[k]&1)!=0){AT(c[f+8>>2]|0)}if((a[h]&1)==0){i=d;return}AT(c[j>>2]|0);i=d;return}function d_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e|0;g=e+8|0;h=b|0;en(f,h,d);b=c[f>>2]|0;if((b|0)!=0){j=b;k=j+20|0;i=e;return k|0}b=AR(32)|0;f=b+8|0;l=d;if((a[l]&1)==0){c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){tB(0);return 0}if(m>>>0<11>>>0){a[f]=m<<1&255;n=b+9|0}else{d=m+16&-16;o=AR(d)|0;c[b+16>>2]=o;c[f>>2]=d|1;c[b+12>>2]=m;n=o}A$(n|0,l|0,m)|0;a[n+m|0]=0}A2(b+20|0,0,12);ek(g,h,b);j=c[g>>2]|0;k=j+20|0;i=e;return k|0}function d$(a){a=a|0;return}function d0(a){a=a|0;AT(a);return}function d1(a){a=a|0;return 84968}function d2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+144|0;l=d;if((a[l]&1)==0){m=j;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[j]=m<<1&255;n=j+1|0}else{d=m+16&-16;o=AR(d)|0;c[j+8>>2]=o;c[j>>2]=d|1;c[j+4>>2]=m;n=o}A$(n|0,l|0,m)|0;a[n+m|0]=0}m=k|0;n=k+8|0;l=n|0;c[l>>2]=92376;o=k+12|0;c[m>>2]=98804;d=k+64|0;c[d>>2]=98824;c[k+4>>2]=0;t4(k+64|0,o);c[k+136>>2]=0;c[k+140>>2]=-1;c[m>>2]=92356;c[k+64>>2]=92396;c[l>>2]=92376;l=o|0;c[l>>2]=92712;p=k+16|0;yq(p);A2(k+20|0,0,24);c[l>>2]=92568;A2(k+44|0,0,16);c[k+60>>2]=24;A2(h|0,0,12);ej(o,g);if((a[h]&1)!=0){AT(c[g+8>>2]|0)}g=n;if((rq(k,j)|0)<<24>>24!=0){d3(g,e)|0}d3(g,j)|0;eh(b,o);c[m>>2]=92356;c[d>>2]=92396;c[k+8>>2]=92376;d=k+12|0;c[d>>2]=92568;if((a[k+44|0]&1)!=0){AT(c[k+52>>2]|0)}c[d>>2]=92712;ys(p);t2(k+64|0);if((a[j]&1)==0){i=f;return}AT(c[j+8>>2]|0);i=f;return}function d3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){uB(o)|0}a[k]=1;o=d;p=a[d]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[d+4>>2]|0}q=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(q+24)>>2];s=(p&1)==0;if(s){t=o+1|0}else{t=c[d+8>>2]|0}do{if((c[n+(q+4)>>2]&176|0)==32){if(s){u=o+1+r|0;v=585;break}else{w=(c[d+8>>2]|0)+r|0;v=584;break}}else{if(s){u=o+1|0;v=585;break}else{w=c[d+8>>2]|0;v=584;break}}}while(0);if((v|0)==584){x=c[d+8>>2]|0;y=w}else if((v|0)==585){x=o+1|0;y=u}s=n+q|0;p=n+(q+76)|0;z=c[p>>2]|0;if((z|0)==-1){t3(f,s);A=yt(f,874624)|0;B=c7[c[(c[A>>2]|0)+28>>2]&255](A,32)|0;ys(f);c[p>>2]=B<<24>>24;C=B}else{C=z&255}ei(j,h,t,y,x+r|0,s,C);if((c[j>>2]|0)!=0){break}s=c[(c[l>>2]|0)-12>>2]|0;t1(n+s|0,c[n+(s+16)>>2]|5)}}while(0);uM(g);i=e;return b|0}function d4(b){b=b|0;var d=0;c[b>>2]=92356;c[b+64>>2]=92396;c[b+8>>2]=92376;d=b+12|0;c[d>>2]=92568;if((a[b+44|0]&1)!=0){AT(c[b+52>>2]|0)}c[d>>2]=92712;ys(b+16|0);t2(b+64|0);return}function d5(b){b=b|0;var d=0,e=0;d=b-144+136|0;c[d>>2]=92356;b=d+64|0;c[b>>2]=92396;c[d+8>>2]=92376;e=d+12|0;c[e>>2]=92568;if((a[d+44|0]&1)!=0){AT(c[d+52>>2]|0)}c[e>>2]=92712;ys(d+16|0);t2(b);return}function d6(b){b=b|0;var d=0,e=0,f=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;c[d+e>>2]=92356;b=d+(e+64)|0;c[b>>2]=92396;c[d+(e+8)>>2]=92376;f=d+(e+12)|0;c[f>>2]=92568;if((a[d+(e+44)|0]&1)!=0){AT(c[d+(e+52)>>2]|0)}c[f>>2]=92712;ys(d+(e+16)|0);t2(b);return}function d7(b){b=b|0;var d=0;c[b>>2]=92356;c[b+64>>2]=92396;c[b+8>>2]=92376;d=b+12|0;c[d>>2]=92568;if((a[b+44|0]&1)!=0){AT(c[b+52>>2]|0)}c[d>>2]=92712;ys(b+16|0);t2(b+64|0);AT(b);return}function d8(b){b=b|0;var d=0,e=0;d=b-144+136|0;c[d>>2]=92356;b=d+64|0;c[b>>2]=92396;c[d+8>>2]=92376;e=d+12|0;c[e>>2]=92568;if((a[d+44|0]&1)!=0){AT(c[d+52>>2]|0)}c[e>>2]=92712;ys(d+16|0);t2(b);AT(d);return}function d9(b){b=b|0;var d=0,e=0,f=0,g=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;b=d+e|0;c[b>>2]=92356;f=d+(e+64)|0;c[f>>2]=92396;c[d+(e+8)>>2]=92376;g=d+(e+12)|0;c[g>>2]=92568;if((a[d+(e+44)|0]&1)!=0){AT(c[d+(e+52)>>2]|0)}c[g>>2]=92712;ys(d+(e+16)|0);t2(f);AT(b);return}function ea(b){b=b|0;var d=0;d=b|0;c[d>>2]=92568;if((a[b+32|0]&1)!=0){AT(c[b+40>>2]|0)}c[d>>2]=92712;ys(b+4|0);return}function eb(b){b=b|0;var d=0;d=b|0;c[d>>2]=92568;if((a[b+32|0]&1)!=0){AT(c[b+40>>2]|0)}c[d>>2]=92712;ys(b+4|0);AT(b);return}function ec(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=d+44|0;j=c[i>>2]|0;k=d+24|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[i>>2]=l;m=l}else{m=j}j=h&24;do{if((j|0)==0){i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else if((j|0)==24){if((g|0)==2){n=639;break}else if((g|0)==0){o=0;p=0;break}else if((g|0)!=1){n=643;break}i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else{if((g|0)==2){n=639;break}else if((g|0)==0){o=0;p=0;break}else if((g|0)!=1){n=643;break}if((h&8|0)==0){i=l-(c[d+20>>2]|0)|0;o=(i|0)<0|0?-1:0;p=i;break}else{i=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;o=(i|0)<0|0?-1:0;p=i;break}}}while(0);if((n|0)==643){g=b;c[g>>2]=0;c[g+4>>2]=0;g=b+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}if((n|0)==639){n=d+32|0;if((a[n]&1)==0){q=n+1|0}else{q=c[d+40>>2]|0}n=m-q|0;o=(n|0)<0|0?-1:0;p=n}n=Ba(p,o,e,f)|0;f=K;e=0;do{if(!((f|0)<(e|0)|(f|0)==(e|0)&n>>>0<0>>>0)){o=d+32|0;if((a[o]&1)==0){r=o+1|0}else{r=c[d+40>>2]|0}o=m-r|0;p=(o|0)<0|0?-1:0;if((p|0)<(f|0)|(p|0)==(f|0)&o>>>0<n>>>0){break}o=h&8;do{if(!((n|0)==0&(f|0)==0)){do{if((o|0)!=0){if((c[d+12>>2]|0)!=0){break}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=-1;c[p+4>>2]=-1;return}}while(0);if(!((h&16|0)!=0&(l|0)==0)){break}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=-1;c[p+4>>2]=-1;return}}while(0);if((o|0)!=0){c[d+12>>2]=(c[d+8>>2]|0)+n;c[d+16>>2]=m}if((h&16|0)!=0){c[k>>2]=(c[d+20>>2]|0)+n}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=n;c[p+4>>2]=f;return}}while(0);f=b;c[f>>2]=0;c[f+4>>2]=0;f=b+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}function ed(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=d;d=i;i=i+16|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];g=d+8|0;dh[c[(c[b>>2]|0)+16>>2]&63](a,b,c[g>>2]|0,c[g+4>>2]|0,0,e);i=f;return}function ee(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0;b=a+44|0;e=c[b>>2]|0;f=c[a+24>>2]|0;if(e>>>0<f>>>0){c[b>>2]=f;g=f}else{g=e}if((c[a+48>>2]&8|0)==0){h=-1;return h|0}e=a+16|0;f=c[e>>2]|0;b=c[a+12>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;i=g}else{i=f}if(b>>>0>=i>>>0){h=-1;return h|0}h=d[b]|0;return h|0}function ef(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+44|0;f=c[e>>2]|0;g=c[b+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;h=g}else{h=f}f=b+8|0;g=c[f>>2]|0;e=b+12|0;i=c[e>>2]|0;if(g>>>0>=i>>>0){j=-1;return j|0}if((d|0)==-1){c[f>>2]=g;c[e>>2]=i-1;c[b+16>>2]=h;j=0;return j|0}k=i-1|0;do{if((c[b+48>>2]&16|0)==0){if((d<<24>>24|0)==(a[k]|0)){break}else{j=-1}return j|0}}while(0);c[f>>2]=g;c[e>>2]=k;c[b+16>>2]=h;a[k]=d&255;j=d;return j|0}function eg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)==-1){e=0;return e|0}f=b|0;g=b+12|0;h=b+8|0;i=(c[g>>2]|0)-(c[h>>2]|0)|0;j=b+24|0;k=c[j>>2]|0;l=b+28|0;m=c[l>>2]|0;if((k|0)==(m|0)){n=b+48|0;if((c[n>>2]&16|0)==0){e=-1;return e|0}o=b+20|0;p=c[o>>2]|0;q=k-p|0;r=b+44|0;s=(c[r>>2]|0)-p|0;p=b+32|0;t=p;u=p;v=a[u]|0;if((v&1)==0){w=(v&255)>>>1;x=10}else{w=c[b+36>>2]|0;x=(c[p>>2]&-2)-1|0}if((w|0)==(x|0)){tQ(p,x,1,x,x,0,0);y=a[u]|0}else{y=v}if((y&1)==0){a[u]=(w<<1)+2&255;z=t+1|0;A=w+1|0}else{y=c[b+40>>2]|0;v=w+1|0;c[b+36>>2]=v;z=y;A=v}a[z+w|0]=0;a[z+A|0]=0;A=a[u]|0;if((A&1)==0){B=10;C=A}else{A=c[p>>2]|0;B=(A&-2)-1|0;C=A&255}A=C&255;if((A&1|0)==0){D=A>>>1}else{D=c[b+36>>2]|0}do{if(D>>>0<B>>>0){A=B-D|0;tL(p,A,0)|0}else{if((C&1)==0){a[t+1+B|0]=0;a[u]=B<<1&255;break}else{a[(c[b+40>>2]|0)+B|0]=0;c[b+36>>2]=B;break}}}while(0);B=a[u]|0;if((B&1)==0){E=t+1|0}else{E=c[b+40>>2]|0}t=B&255;if((t&1|0)==0){F=t>>>1}else{F=c[b+36>>2]|0}t=E+F|0;c[o>>2]=E;c[l>>2]=t;l=E+q|0;c[j>>2]=l;q=E+s|0;c[r>>2]=q;G=l;H=t;I=q;J=n}else{G=k;H=m;I=c[b+44>>2]|0;J=b+48|0}m=G+1|0;k=m>>>0<I>>>0?I:m;c[b+44>>2]=k;if((c[J>>2]&8|0)!=0){J=b+32|0;if((a[J]&1)==0){K=J+1|0}else{K=c[b+40>>2]|0}c[h>>2]=K;c[g>>2]=K+i;c[b+16>>2]=k}if((G|0)==(H|0)){e=c7[c[(c[b>>2]|0)+52>>2]&255](f,d&255)|0;return e|0}else{c[j>>2]=m;a[G]=d&255;e=d&255;return e|0}return 0}function eh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=b;f=c[d+48>>2]|0;if((f&16|0)!=0){g=d+44|0;h=c[g>>2]|0;i=c[d+24>>2]|0;if(h>>>0<i>>>0){c[g>>2]=i;j=i}else{j=h}h=c[d+20>>2]|0;i=h;g=j-i|0;if(g>>>0>4294967279>>>0){tB(0)}if(g>>>0<11>>>0){a[e]=g<<1&255;k=b+1|0}else{l=g+16&-16;m=AR(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=g;k=m}if((h|0)==(j|0)){n=k}else{m=j+(-i|0)|0;i=k;g=h;while(1){a[i]=a[g]|0;h=g+1|0;if((h|0)==(j|0)){break}else{i=i+1|0;g=h}}n=k+m|0}a[n]=0;return}if((f&8|0)==0){A2(e|0,0,12);return}f=c[d+8>>2]|0;n=c[d+16>>2]|0;d=f;m=n-d|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[e]=m<<1&255;o=b+1|0}else{e=m+16&-16;k=AR(e)|0;c[b+8>>2]=k;c[b>>2]=e|1;c[b+4>>2]=m;o=k}if((f|0)==(n|0)){p=o}else{k=n+(-d|0)|0;d=o;m=f;while(1){a[d]=a[m]|0;f=m+1|0;if((f|0)==(n|0)){break}else{d=d+1|0;m=f}}p=o+k|0}a[p]=0;return}function ei(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g|0;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;do{if((h|0)>0){if((c8[c[(c[d>>2]|0)+48>>2]&127](d,e,h)|0)==(h|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){if(q>>>0<11>>>0){h=q<<1&255;e=l;a[e]=h;r=l+1|0;s=h;t=e}else{e=q+16&-16;h=AR(e)|0;c[l+8>>2]=h;g=e|1;c[l>>2]=g;c[l+4>>2]=q;r=h;s=g&255;t=l}A2(r|0,j|0,q|0);a[r+q|0]=0;if((s&1)==0){u=l+1|0}else{u=c[l+8>>2]|0}if((c8[c[(c[d>>2]|0)+48>>2]&127](d,u,q)|0)==(q|0)){if((a[t]&1)==0){break}AT(c[l+8>>2]|0);break}c[m>>2]=0;c[b>>2]=0;if((a[t]&1)==0){i=k;return}AT(c[l+8>>2]|0);i=k;return}}while(0);l=n-o|0;do{if((l|0)>0){if((c8[c[(c[d>>2]|0)+48>>2]&127](d,f,l)|0)==(l|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function ej(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=b+32|0;tI(e,d)|0;d=b+44|0;c[d>>2]=0;f=b+48|0;g=c[f>>2]|0;if((g&8|0)!=0){h=e;i=a[e]|0;j=(i&1)==0;if(j){k=h+1|0}else{k=c[b+40>>2]|0}l=i&255;if((l&1|0)==0){m=l>>>1}else{m=c[b+36>>2]|0}l=k+m|0;c[d>>2]=l;if(j){n=h+1|0;o=h+1|0}else{h=c[b+40>>2]|0;n=h;o=h}c[b+8>>2]=o;c[b+12>>2]=n;c[b+16>>2]=l}if((g&16|0)==0){return}g=e;l=e;n=a[l]|0;o=n&255;if((o&1|0)==0){p=o>>>1}else{p=c[b+36>>2]|0}if((n&1)==0){c[d>>2]=g+1+p;q=10;r=n}else{c[d>>2]=(c[b+40>>2]|0)+p;d=c[e>>2]|0;q=(d&-2)-1|0;r=d&255}d=r&255;if((d&1|0)==0){s=d>>>1}else{s=c[b+36>>2]|0}do{if(s>>>0<q>>>0){d=q-s|0;tL(e,d,0)|0}else{if((r&1)==0){a[g+1+q|0]=0;a[l]=q<<1&255;break}else{a[(c[b+40>>2]|0)+q|0]=0;c[b+36>>2]=q;break}}}while(0);q=a[l]|0;if((q&1)==0){t=g+1|0;u=g+1|0}else{g=c[b+40>>2]|0;t=g;u=g}g=q&255;if((g&1|0)==0){v=g>>>1}else{v=c[b+36>>2]|0}g=b+24|0;c[g>>2]=u;c[b+20>>2]=u;c[b+28>>2]=t+v;if((c[f>>2]&3|0)==0){return}c[g>>2]=u+p;return}function ek(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0;h=f+8|0;i=h;j=a[h]|0;h=(j&1)==0;if(h){k=i+1|0}else{k=c[f+16>>2]|0}l=j&255;j=(l&1|0)==0;if(j){m=l>>>1}else{m=c[f+12>>2]|0}if(m>>>0>3>>>0){n=m;o=k;p=m;while(1){q=o;r=ag(d[q]|d[q+1|0]<<8|d[q+2|0]<<16|d[q+3|0]<<24|0,1540483477)|0;q=(ag(r>>>24^r,1540483477)|0)^(ag(n,1540483477)|0);r=o+4|0;s=p-4|0;if(s>>>0>3>>>0){n=q;o=r;p=s}else{t=q;u=r;v=s;break}}}else{t=m;u=k;v=m}if((v|0)==2){w=t;x=847}else if((v|0)==3){w=d[u+2|0]<<16^t;x=847}else if((v|0)==1){y=t;x=848}else{z=t}if((x|0)==847){y=d[u+1|0]<<8^w;x=848}if((x|0)==848){z=ag(d[u]^y,1540483477)|0}y=ag(z>>>13^z,1540483477)|0;z=y>>>15^y;y=f+4|0;c[y>>2]=z;u=e+4|0;w=c[u>>2]|0;t=(w|0)==0;L958:do{if(t){A=0}else{v=w-1|0;m=(v&w|0)!=0;if(m){B=(z>>>0)%(w>>>0)|0}else{B=z&v}k=c[(c[e>>2]|0)+(B<<2)>>2]|0;if((k|0)==0){A=B;break}p=c[k>>2]|0;if((p|0)==0){A=B;break}k=i+1|0;o=f+16|0;n=f+12|0;s=p;L966:while(1){p=c[s+4>>2]|0;if(m){C=(p>>>0)%(w>>>0)|0}else{C=p&v}if((C|0)!=(B|0)){A=B;break L958}p=s+8|0;r=p;q=a[p]|0;p=q&255;if((p&1|0)==0){D=p>>>1}else{D=c[s+12>>2]|0}if(j){E=l>>>1}else{E=c[n>>2]|0}L981:do{if((D|0)==(E|0)){p=(q&1)==0;if(p){F=r+1|0}else{F=c[s+16>>2]|0}if(h){G=k}else{G=c[o>>2]|0}if(!p){if((A0(F|0,G|0,D|0)|0)==0){H=s;I=0;x=894;break L966}else{break}}if((D|0)==0){H=s;I=0;x=893;break L966}else{J=G;K=F;L=D}while(1){if((a[K]|0)!=(a[J]|0)){break L981}p=L-1|0;if((p|0)==0){H=s;I=0;x=896;break L966}else{J=J+1|0;K=K+1|0;L=p}}}}while(0);r=c[s>>2]|0;if((r|0)==0){A=B;break L958}else{s=r}}if((x|0)==893){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}else if((x|0)==894){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}else if((x|0)==896){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}}}while(0);x=e+12|0;O=+(((c[x>>2]|0)+1|0)>>>0>>>0);P=+g[e+16>>2];do{if(O>+(w>>>0>>>0)*P|t){if(w>>>0>2>>>0){Q=(w-1&w|0)!=0|0}else{Q=1}B=Q|w<<1;L=~~+af(O/P);el(e,B>>>0<L>>>0?L:B);B=c[u>>2]|0;L=c[y>>2]|0;K=B-1|0;if((K&B|0)==0){R=L&K;S=B;break}else{R=(L>>>0)%(B>>>0)|0;S=B;break}}else{R=A;S=w}}while(0);w=e|0;A=c[(c[w>>2]|0)+(R<<2)>>2]|0;do{if((A|0)==0){y=e+8|0;u=y|0;Q=f|0;c[Q>>2]=c[u>>2];c[u>>2]=f;c[(c[w>>2]|0)+(R<<2)>>2]=y;y=c[Q>>2]|0;if((y|0)==0){break}Q=c[y+4>>2]|0;y=S-1|0;if((y&S|0)==0){T=Q&y}else{T=(Q>>>0)%(S>>>0)|0}c[(c[w>>2]|0)+(T<<2)>>2]=f}else{Q=A|0;c[f>>2]=c[Q>>2];c[Q>>2]=f}}while(0);c[x>>2]=(c[x>>2]|0)+1;H=f;I=1;M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}function el(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;do{if((b|0)==1){d=2}else{if((b-1&b|0)==0){d=b;break}d=tz(b)|0}}while(0);b=c[a+4>>2]|0;if(d>>>0>b>>>0){em(a,d);return}if(d>>>0>=b>>>0){return}do{if(b>>>0>2>>>0){if((b-1&b|0)!=0){e=906;break}f=1<<32-(A4(~~+af(+((c[a+12>>2]|0)>>>0>>>0)/+g[a+16>>2])-1|0)|0)}else{e=906}}while(0);if((e|0)==906){f=tz(~~+af(+((c[a+12>>2]|0)>>>0>>>0)/+g[a+16>>2]))|0}e=d>>>0<f>>>0?f:d;if(e>>>0>=b>>>0){return}em(a,e);return}function em(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=(d|0)!=0;if(e){f=AR(d<<2)|0}else{f=0}g=b|0;h=c[g>>2]|0;c[g>>2]=f;if((h|0)!=0){AT(h)}c[b+4>>2]=d;if(e){i=0}else{return}do{c[(c[g>>2]|0)+(i<<2)>>2]=0;i=i+1|0;}while(i>>>0<d>>>0);i=b+8|0;b=c[i>>2]|0;if((b|0)==0){return}e=c[b+4>>2]|0;h=d-1|0;f=(h&d|0)!=0;if(f){j=(e>>>0)%(d>>>0)|0}else{j=e&h}c[(c[g>>2]|0)+(j<<2)>>2]=i;i=b|0;e=c[i>>2]|0;if((e|0)==0){return}else{k=b;l=j;m=i;n=e}L1064:while(1){e=k;i=m;j=n;L1066:while(1){o=j;while(1){b=c[o+4>>2]|0;if(f){p=(b>>>0)%(d>>>0)|0}else{p=b&h}if((p|0)==(l|0)){break}q=(c[g>>2]|0)+(p<<2)|0;if((c[q>>2]|0)==0){break L1066}b=o|0;r=c[b>>2]|0;L1076:do{if((r|0)==0){s=b;t=0}else{u=o+8|0;v=a[u]|0;w=v&255;x=(w&1|0)==0;y=w>>>1;w=u+1|0;u=o+16|0;z=o+12|0;A=b;B=r;while(1){if(x){C=y}else{C=c[z>>2]|0}D=B+8|0;E=a[D]|0;F=E&255;if((F&1|0)==0){G=F>>>1}else{G=c[B+12>>2]|0}if((C|0)!=(G|0)){s=A;t=B;break L1076}F=(v&1)==0;if(F){H=w}else{H=c[u>>2]|0}if((E&1)==0){I=D+1|0}else{I=c[B+16>>2]|0}do{if(F){if((C|0)==0){break}else{J=I;K=H;L=C}while(1){if((a[K]|0)!=(a[J]|0)){s=A;t=B;break L1076}D=L-1|0;if((D|0)==0){break}else{J=J+1|0;K=K+1|0;L=D}}}else{if((A0(H|0,I|0,C|0)|0)!=0){s=A;t=B;break L1076}}}while(0);F=B|0;D=c[F>>2]|0;if((D|0)==0){s=F;t=0;break}else{A=F;B=D}}}}while(0);c[i>>2]=t;c[s>>2]=c[c[(c[g>>2]|0)+(p<<2)>>2]>>2];c[c[(c[g>>2]|0)+(p<<2)>>2]>>2]=o;r=c[i>>2]|0;if((r|0)==0){M=958;break L1064}else{o=r}}r=o|0;b=c[r>>2]|0;if((b|0)==0){M=955;break L1064}else{e=o;i=r;j=b}}c[q>>2]=e;j=o|0;i=c[j>>2]|0;if((i|0)==0){M=959;break}else{k=o;l=p;m=j;n=i}}if((M|0)==955){return}else if((M|0)==958){return}else if((M|0)==959){return}}function en(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f;h=a[f]|0;i=(h&1)==0;if(i){j=g+1|0}else{j=c[f+8>>2]|0}k=h&255;h=(k&1|0)==0;if(h){l=k>>>1}else{l=c[f+4>>2]|0}if(l>>>0>3>>>0){m=l;n=j;o=l;while(1){p=n;q=ag(d[p]|d[p+1|0]<<8|d[p+2|0]<<16|d[p+3|0]<<24|0,1540483477)|0;p=(ag(q>>>24^q,1540483477)|0)^(ag(m,1540483477)|0);q=n+4|0;r=o-4|0;if(r>>>0>3>>>0){m=p;n=q;o=r}else{s=p;t=q;u=r;break}}}else{s=l;t=j;u=l}if((u|0)==3){v=d[t+2|0]<<16^s;w=971}else if((u|0)==2){v=s;w=971}else if((u|0)==1){x=s;w=972}else{y=s}if((w|0)==971){x=d[t+1|0]<<8^v;w=972}if((w|0)==972){y=ag(d[t]^x,1540483477)|0}x=ag(y>>>13^y,1540483477)|0;y=x>>>15^x;x=c[e+4>>2]|0;L1129:do{if((x|0)!=0){t=x-1|0;w=(t&x|0)!=0;if(w){z=(y>>>0)%(x>>>0)|0}else{z=y&t}v=c[(c[e>>2]|0)+(z<<2)>>2]|0;if((v|0)==0){break}s=c[v>>2]|0;if((s|0)==0){break}v=g+1|0;u=f+8|0;l=f+4|0;j=s;L1137:while(1){s=c[j+4>>2]|0;if(w){A=(s>>>0)%(x>>>0)|0}else{A=s&t}if((A|0)!=(z|0)){break L1129}s=j+8|0;o=s;n=a[s]|0;s=n&255;if((s&1|0)==0){B=s>>>1}else{B=c[j+12>>2]|0}if(h){C=k>>>1}else{C=c[l>>2]|0}L1152:do{if((B|0)==(C|0)){s=(n&1)==0;if(s){D=o+1|0}else{D=c[j+16>>2]|0}if(i){E=v}else{E=c[u>>2]|0}if(!s){if((A0(D|0,E|0,B|0)|0)==0){break L1137}else{break}}if((B|0)==0){break L1137}else{F=E;G=D;H=B}while(1){if((a[G]|0)!=(a[F]|0)){break L1152}s=H-1|0;if((s|0)==0){break L1137}else{F=F+1|0;G=G+1|0;H=s}}}}while(0);o=c[j>>2]|0;if((o|0)==0){break L1129}else{j=o}}c[b>>2]=j;return}}while(0);c[b>>2]=0;return}function eo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=((c[d>>2]|0)-f|0)/24|0;h=g+1|0;if(h>>>0>178956970>>>0){yk(0)}i=a+8|0;a=((c[i>>2]|0)-f|0)/24|0;if(a>>>0>89478484>>>0){j=178956970;k=1011}else{f=a<<1;a=f>>>0<h>>>0?h:f;if((a|0)==0){l=0;m=0}else{j=a;k=1011}}if((k|0)==1011){l=AR(j*24|0)|0;m=j}j=l+(g*24|0)|0;k=l+(m*24|0)|0;do{if((j|0)!=0){m=c[b+16>>2]|0;if((m|0)==0){c[l+(g*24|0)+16>>2]=0;break}if((m|0)==(b|0)){a=j;c[l+(g*24|0)+16>>2]=a;c5[c[(c[m>>2]|0)+12>>2]&255](m,a);break}c[l+(g*24|0)+16>>2]=da[c[(c[m>>2]|0)+8>>2]&255](m)|0}}while(0);g=l+(h*24|0)|0;h=c[e>>2]|0;l=c[d>>2]|0;do{if((l|0)==(h|0)){c[e>>2]=j;c[d>>2]=g;c[i>>2]=k;n=h}else{b=l;m=j;while(1){a=b-24|0;f=m-24|0;o=b-24+16|0;p=c[o>>2]|0;do{if((p|0)==0){c[m-24+16>>2]=0}else{if((p|0)==(a|0)){q=f;c[m-24+16>>2]=q;r=c[o>>2]|0;c5[c[(c[r>>2]|0)+12>>2]&255](r,q);break}else{c[m-24+16>>2]=p;c[o>>2]=0;break}}}while(0);s=m-24|0;if((a|0)==(h|0)){break}else{b=a;m=s}}m=c[e>>2]|0;b=c[d>>2]|0;c[e>>2]=s;c[d>>2]=g;c[i>>2]=k;if((m|0)==(b|0)){n=m;break}else{t=b}while(1){b=t-24|0;o=c[t-24+16>>2]|0;do{if((o|0)==(b|0)){c4[c[(c[o>>2]|0)+16>>2]&511](o)}else{if((o|0)==0){break}c4[c[(c[o>>2]|0)+20>>2]&511](o)}}while(0);if((m|0)==(b|0)){n=m;break}else{t=b}}}}while(0);if((n|0)==0){return}AT(n|0);return}function ep(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+144|0;l=d;if((a[l]&1)==0){m=j;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[j]=m<<1&255;n=j+1|0}else{d=m+16&-16;o=AR(d)|0;c[j+8>>2]=o;c[j>>2]=d|1;c[j+4>>2]=m;n=o}A$(n|0,l|0,m)|0;a[n+m|0]=0}m=k|0;n=k+8|0;l=n|0;c[l>>2]=92376;o=k+12|0;c[m>>2]=98804;d=k+64|0;c[d>>2]=98824;c[k+4>>2]=0;t4(k+64|0,o);c[k+136>>2]=0;c[k+140>>2]=-1;c[m>>2]=92356;c[k+64>>2]=92396;c[l>>2]=92376;l=o|0;c[l>>2]=92712;p=k+16|0;yq(p);A2(k+20|0,0,24);c[l>>2]=92568;A2(k+44|0,0,16);c[k+60>>2]=24;A2(h|0,0,12);ej(o,g);if((a[h]&1)!=0){AT(c[g+8>>2]|0)}g=n;if((rq(k,j)|0)<<24>>24!=0){n=c[e>>2]|0;uO(g,n)|0}d3(g,j)|0;eh(b,o);c[m>>2]=92356;c[d>>2]=92396;c[k+8>>2]=92376;d=k+12|0;c[d>>2]=92568;if((a[k+44|0]&1)!=0){AT(c[k+52>>2]|0)}c[d>>2]=92712;ys(p);t2(k+64|0);if((a[j]&1)==0){i=f;return}AT(c[j+8>>2]|0);i=f;return}function eq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d|0;c[b>>2]=93632;f=AR(32)|0;g=e+8|0;c[g>>2]=f;c[e>>2]=33;c[e+4>>2]=18;A$(f|0,84392,18)|0;a[f+18|0]=0;ru(80664,119,1,e);if((a[e]&1)!=0){AT(c[g>>2]|0)}kx(-1);dQ(b|0);i=d;return}function er(a){a=a|0;dQ(a);return}function es(a){a=a|0;dQ(a);AT(a);return}function et(a,b,c){a=a|0;b=b|0;c=c|0;bZ(47832)|0;return}function eu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g|0;j=h;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+144|0;m=d;if((a[m]&1)==0){n=k;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){tB(0)}if(n>>>0<11>>>0){a[k]=n<<1&255;o=k+1|0}else{d=n+16&-16;p=AR(d)|0;c[k+8>>2]=p;c[k>>2]=d|1;c[k+4>>2]=n;o=p}A$(o|0,m|0,n)|0;a[o+n|0]=0}n=l|0;o=l+8|0;m=o|0;c[m>>2]=92376;p=l+12|0;c[n>>2]=98804;d=l+64|0;c[d>>2]=98824;c[l+4>>2]=0;t4(l+64|0,p);c[l+136>>2]=0;c[l+140>>2]=-1;c[n>>2]=92356;c[l+64>>2]=92396;c[m>>2]=92376;m=p|0;c[m>>2]=92712;q=l+16|0;yq(q);A2(l+20|0,0,24);c[m>>2]=92568;A2(l+44|0,0,16);c[l+60>>2]=24;A2(j|0,0,12);ej(p,h);if((a[j]&1)!=0){AT(c[h+8>>2]|0)}if((rq(l,k)|0)<<24>>24!=0){h=o;d3(h,e)|0}e=o;if((rq(l,k)|0)<<24>>24!=0){o=c[f>>2]|0;uN(e,o)|0}d3(e,k)|0;eh(b,p);c[n>>2]=92356;c[d>>2]=92396;c[l+8>>2]=92376;d=l+12|0;c[d>>2]=92568;if((a[l+44|0]&1)!=0){AT(c[l+52>>2]|0)}c[d>>2]=92712;ys(q);t2(l+64|0);if((a[k]&1)==0){i=g;return}AT(c[k+8>>2]|0);i=g;return}function ev(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0;b=i;i=i+80|0;d=b|0;e=b+8|0;f=b+16|0;g=f;h=f;a[g]=8;j=h+1|0;C=1684632366;a[j]=C&255;C=C>>8;a[j+1|0]=C&255;C=C>>8;a[j+2|0]=C&255;C=C>>8;a[j+3|0]=C&255;a[h+5|0]=0;h=f+12|0;j=h;k=h;a[k]=10;h=j+1|0;a[h]=a[78376]|0;a[h+1|0]=a[78377]|0;a[h+2|0]=a[78378]|0;a[h+3|0]=a[78379]|0;a[h+4|0]=a[78380]|0;a[j+6|0]=0;j=f+24|0;h=j;l=j;a[l]=10;j=h+1|0;a[j]=a[77920]|0;a[j+1|0]=a[77921]|0;a[j+2|0]=a[77922]|0;a[j+3|0]=a[77923]|0;a[j+4|0]=a[77924]|0;a[h+6|0]=0;h=f+36|0;j=h;m=h;a[m]=10;h=j+1|0;a[h]=a[90096]|0;a[h+1|0]=a[90097]|0;a[h+2|0]=a[90098]|0;a[h+3|0]=a[90099]|0;a[h+4|0]=a[90100]|0;a[j+6|0]=0;j=f+48|0;h=j;n=j;a[n]=8;j=h+1|0;C=1937075502;a[j]=C&255;C=C>>8;a[j+1|0]=C&255;C=C>>8;a[j+2|0]=C&255;C=C>>8;a[j+3|0]=C&255;a[h+5|0]=0;c[4550595]=0;c[4550596]=0;c[4550594]=18202380;h=f+60|0;j=e|0;o=f|0;do{c[j>>2]=18202380;p=dM(18202376,e,d,o)|0;if((c[p>>2]|0)==0){q=AR(28)|0;s=q+16|0;t=o;if((a[t]&1)==0){c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2]}else{t=c[o+8>>2]|0;u=c[o+4>>2]|0;if(u>>>0>4294967279>>>0){v=1140;break}if(u>>>0<11>>>0){a[s]=u<<1&255;w=q+17|0}else{x=u+16&-16;y=AR(x)|0;c[q+24>>2]=y;c[s>>2]=x|1;c[q+20>>2]=u;w=y}A$(w|0,t|0,u)|0;a[w+u|0]=0}u=c[d>>2]|0;t=q;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=u;c[p>>2]=t;u=c[c[4550594]>>2]|0;if((u|0)==0){z=t}else{c[4550594]=u;z=c[p>>2]|0}dN(c[4550595]|0,z);c[4550596]=(c[4550596]|0)+1}o=o+12|0;}while((o|0)!=(h|0));if((v|0)==1140){tB(0)}if((a[n]&1)!=0){AT(c[f+56>>2]|0)}if((a[m]&1)!=0){AT(c[f+44>>2]|0)}if((a[l]&1)!=0){AT(c[f+32>>2]|0)}if((a[k]&1)!=0){AT(c[f+20>>2]|0)}if((a[g]&1)==0){A=bh(174,18202376,r|0)|0;B=60;D=0;i=b;return}AT(c[f+8>>2]|0);A=bh(174,18202376,r|0)|0;B=60;D=0;i=b;return}function ew(a){a=a|0;var b=0,e=0,f=0;b=AR(4)|0;e=b;f=AR(632)|0;r_(f);c[b>>2]=f;b=0;do{r5(f,b,d[a+b|0]|0);b=b+1|0;}while((b|0)<25);return e|0}function ex(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0;f=i;i=i+256|0;g=f|0;h=f+104|0;j=f+208|0;k=f+216|0;l=f+224|0;m=f+232|0;n=f+240|0;o=f+248|0;if((ic(89592,j)|0)<0){p=0;i=f;return p|0}if((ic(85664,k)|0)<0){p=0;i=f;return p|0}if((ic(83416,l)|0)<0){p=0;i=f;return p|0}if((ic(81752,m)|0)<0){p=0;i=f;return p|0}if((ic(80520,n)|0)<0){p=0;i=f;return p|0}if((ic(79576,o)|0)<0){p=0;i=f;return p|0}q=+(ag(c[m>>2]|0,d)|0)/200.0;r=+(c[n>>2]|0)/100.0;n=c[k>>2]|0;if((n|0)==2){k=b|0;r1(c[k>>2]|0,1);sa(c[k>>2]|0,15);r3(c[k>>2]|0,-32768);m=g|0;A$(m|0,77768,21)|0;s=k}else if((n|0)==4){k=g|0;a[k]=a[89952]|0;a[k+1|0]=a[89953]|0;a[k+2|0]=a[89954]|0;a[k+3|0]=a[89955]|0;a[k+4|0]=a[89956]|0;a[k+5|0]=a[89957]|0;a[k+6|0]=a[89958]|0;s=b|0}else if((n|0)==1){n=b|0;r1(c[n>>2]|0,1);sa(c[n>>2]|0,7);r3(c[n>>2]|0,0);k=g;c[k>>2]=944983885;c[k+4>>2]=3160117;s=n}else{n=b|0;r1(c[n>>2]|0,0);sa(c[n>>2]|0,7);r3(c[n>>2]|0,0);b=g;c[b>>2]=911429453;c[b+4>>2]=3225653;s=n}sb(c[s>>2]|0,(c[j>>2]|0)!=0);sc(c[s>>2]|0,+(c[o>>2]|0)/1.0e3);sd(c[s>>2]|0,(c[j>>2]|0)!=0);o=c[l>>2]|0;if((o|0)==2){l=h|0;n=~~q;bs(l|0,88152,(t=i,i=i+8|0,c[t>>2]=n,t)|0)|0;i=t;u=2}else if((o|0)==1){n=h|0;A$(n|0,88600,14)|0;u=1}else if((o|0)==3){bs(h|0,88152,(t=i,i=i+8|0,c[t>>2]=~~q,t)|0)|0;i=t;u=3}else{o=h|0;a[o]=a[89608]|0;a[o+1|0]=a[89609]|0;a[o+2|0]=a[89610]|0;a[o+3|0]=a[89611]|0;a[o+4|0]=a[89612]|0;u=0}if(r$(c[s>>2]|0,+(e|0),u,+(d|0),q,r)|0){u=g|0;g=(c[j>>2]|0)!=0?87072:86744;j=h|0;hs(-2,87464,(t=i,i=i+32|0,c[t>>2]=u,c[t+8>>2]=g,c[t+16>>2]=d,c[t+24>>2]=j,t)|0)|0;i=t;p=1;i=f;return p|0}else{hu(-2,87688,(t=i,i=i+1|0,i=i+7&-8,c[t>>2]=0,t)|0)|0;i=t;p=0;i=f;return p|0}return 0}function ey(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=0){r0(b);AT(b)}AT(a);return}function ez(a,b){a=a|0;b=b|0;return(r4(c[a>>2]|0,b&65535)|0)&255|0}function eA(a,b,d){a=a|0;b=b|0;d=d|0;r5(c[a>>2]|0,b&65535,d&255);return}function eB(a,b){a=a|0;b=b|0;r2(c[a>>2]|0);return}function eC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;return sk(c[a>>2]|0,f,b,d,e)|0}function eD(a,b){a=a|0;b=b|0;return}function eE(a){a=a|0;return hk(871016)|0}function eF(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=e|0;h=i;i=i+212|0;i=i+7&-8;j=i;i=i+212|0;i=i+7&-8;r7(h);r8(j,c[d>>2]|0);d=h|0;k=j|0;A$(d|0,k|0,212)|0;A$(g|0,k|0,32)|0;a[e+32|0]=c[h+32>>2]&255;c[e+36>>2]=c[h+36>>2];k=0;do{c[e+40+(k<<2)>>2]=c[h+52+(k<<2)>>2];c[e+52+(k<<2)>>2]=c[h+64+(k<<2)>>2];b[e+64+(k<<1)>>1]=c[h+124+(k<<2)>>2]&65535;b[e+70+(k<<1)>>1]=c[h+136+(k<<2)>>2]&65535;b[e+76+(k<<1)>>1]=c[h+148+(k<<2)>>2]&65535;b[e+82+(k<<1)>>1]=c[h+160+(k<<2)>>2]&65535;a[e+88+k|0]=c[h+172+(k<<2)>>2]&255;a[e+91+k|0]=c[h+184+(k<<2)>>2]&255;a[e+94+k|0]=a[h+196+k|0]&1;a[e+97+k|0]=c[h+200+(k<<2)>>2]&255;a[e+100+k|0]=c[h+88+(k<<2)>>2]&255;c[e+104+(k<<2)>>2]=c[h+76+(k<<2)>>2];c[e+116+(k<<2)>>2]=c[h+112+(k<<2)>>2];b[e+128+(k<<1)>>1]=c[h+100+(k<<2)>>2]&65535;k=k+1|0;}while(k>>>0<3>>>0);a[e+134|0]=c[h+40>>2]&255;a[e+135|0]=c[h+44>>2]&255;i=f;return}function eG(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;j=g|0;k=i;i=i+212|0;i=i+7&-8;l=k|0;m=i;i=i+212|0;i=i+7&-8;r7(k);A$(l|0,j|0,32)|0;c[k+32>>2]=d[g+32|0]|0;c[k+36>>2]=c[g+36>>2];j=0;do{c[k+52+(j<<2)>>2]=c[g+40+(j<<2)>>2];c[k+64+(j<<2)>>2]=c[g+52+(j<<2)>>2];c[k+124+(j<<2)>>2]=e[g+64+(j<<1)>>1]|0;l=b[g+70+(j<<1)>>1]|0;if(l<<16>>16!=0){c[k+136+(j<<2)>>2]=l&65535}c[k+148+(j<<2)>>2]=e[g+76+(j<<1)>>1]|0;l=b[g+82+(j<<1)>>1]|0;if(l<<16>>16!=0){c[k+160+(j<<2)>>2]=l&65535}c[k+172+(j<<2)>>2]=d[g+88+j|0]|0;c[k+184+(j<<2)>>2]=d[g+91+j|0]|0;a[k+196+j|0]=(a[g+94+j|0]|0)!=0|0;c[k+200+(j<<2)>>2]=d[g+97+j|0]|0;c[k+88+(j<<2)>>2]=d[g+100+j|0]|0;c[k+76+(j<<2)>>2]=c[g+104+(j<<2)>>2];c[k+112+(j<<2)>>2]=c[g+116+(j<<2)>>2];c[k+100+(j<<2)>>2]=e[g+128+(j<<1)>>1]|0;j=j+1|0;}while(j>>>0<3>>>0);c[k+40>>2]=d[g+134|0]|0;c[k+44>>2]=d[g+135|0]|0;g=c[f>>2]|0;f=m|0;j=k|0;A$(f|0,j|0,212)|0;r9(g,m);i=h;return}function eH(a){a=a|0;var b=0;b=a|0;a=c[b>>2]|0;c[b>>2]=0;if((a|0)==0){return}c4[c[(c[a>>2]|0)+4>>2]&511](a);return}function eI(b){b=b|0;a[231632]=(b|0)==0|0;return}function eJ(a){a=a|0;c[57910]=a;return}function eK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=i;i=i+120|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+104|0;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;c[j>>2]=b;c[k>>2]=d;c[4550600]=d;a[231632]=1;d=l;t=l;a[t]=20;v=d+1|0;A$(v|0,85024,10)|0;a[d+11|0]=0;eQ(h,l,k);ru(84168,81,1,h);if((a[h]&1)!=0){AT(c[h+8>>2]|0)}if((a[t]&1)!=0){AT(c[l+8>>2]|0)}do{if((c[4550602]|0)==0){b$(82984,511)|0;l=AR(4)|0;dE(l,56720);t=c[4550602]|0;c[4550602]=l;if((t|0)!=0){c4[c[(c[t>>2]|0)+4>>2]&511](t)}t=m;c[t>>2]=c[22654];c[t+4>>2]=c[22655];c[t+8>>2]=c[22656];c[t+12>>2]=c[22657];c[t+16>>2]=c[22658];c[t+20>>2]=c[22659];if((cl(m|0,0)|0)<0){t=c[u>>2]|0;l=b1()|0;cu(t|0,81496,(t=i,i=i+8|0,c[t>>2]=l,t)|0)|0;i=t;br(0)}else{a4(0);break}}}while(0);m=A1(b|0)|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[p]=m<<1&255;w=p+1|0}else{t=m+16&-16;l=AR(t)|0;c[p+8>>2]=l;c[p>>2]=t|1;c[p+4>>2]=m;w=l}A$(w|0,b|0,m)|0;a[w+m|0]=0;m=q;w=q;a[w]=10;b=m+1|0;a[b]=a[79432]|0;a[b+1|0]=a[79433]|0;a[b+2|0]=a[79434]|0;a[b+3|0]=a[79435]|0;a[b+4|0]=a[79436]|0;a[m+6|0]=0;rB(o,p,q);m=tR(o,0,80368,6)|0;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];A2(m|0,0,12);if((a[18202352]&1)==0){a[18202353]=0;a[18202352]=0}else{a[c[4550590]|0]=0;c[4550589]=0}tM(18202352,0);c[4550588]=c[n>>2];c[4550589]=c[n+4>>2];c[4550590]=c[n+8>>2];A2(n|0,0,12);if((a[o]&1)!=0){AT(c[o+8>>2]|0)}if((a[w]&1)!=0){AT(c[q+8>>2]|0)}if((a[p]&1)!=0){AT(c[p+8>>2]|0)}c[57912]=-1;c[4550586]=0;p=rp(18202352)|0;q=AR(32)|0;if(p){p=s+8|0;c[p>>2]=q;c[s>>2]=33;c[s+4>>2]=21;A$(q|0,77592,21)|0;a[q+21|0]=0;d2(f,s,18202352);ru(84168,105,1,f);if((a[f]&1)!=0){AT(c[f+8>>2]|0)}if((a[s]&1)!=0){AT(c[p>>2]|0)}eM(0,(a[18202352]&1)==0?18202353:c[4550590]|0);i=e;return}else{p=r+8|0;c[p>>2]=q;c[r>>2]=33;c[r+4>>2]=19;A$(q|0,78632,19)|0;a[q+19|0]=0;eO(g,r,j,18202352);ru(84168,102,1,g);if((a[g]&1)!=0){AT(c[g+8>>2]|0)}if((a[r]&1)!=0){AT(c[p>>2]|0)}cA(c[j>>2]|0,((a[18202352]&1)==0?18202353:c[4550590]|0)|0,78120,0,0,240,238,0);i=e;return}}function eL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=c[57910]|0;if((b|0)>-1){f=c[4550592]|0;if((f|0)!=0){dk[c[(c[f>>2]|0)+16>>2]&127](f,b,-1)}c[57910]=-1}b=c[4550592]|0;if((a[231632]&1)!=0&(b|0)!=0){f=c[(c[b>>2]|0)+8>>2]|0;g=d;h=(e|0)/2|0;c8[f&127](b,g,h)|0;return}else{A2(d|0,0,e|0);return}}function eM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0;b=i;i=i+216|0;e=b|0;f=b+16|0;g=b+32|0;h=b+48|0;j=b+56|0;k=b+72|0;l=b+88|0;m=b+104|0;n=b+120|0;o=b+136|0;p=b+152|0;q=b+168|0;r=b+184|0;s=b+200|0;c[h>>2]=d;d=AR(16)|0;t=j+8|0;c[t>>2]=d;c[j>>2]=17;c[j+4>>2]=11;A$(d|0,89136,11)|0;a[d+11|0]=0;eR(g,j,h);ru(84168,49,1,g);if((a[g]&1)!=0){AT(c[g+8>>2]|0)}if((a[j]&1)!=0){AT(c[t>>2]|0)}t=c[4550592]|0;if((t|0)!=0){c4[c[(c[t>>2]|0)+4>>2]&511](t)}t=c[4550602]|0;j=c[(c[t>>2]|0)+12>>2]|0;g=c[h>>2]|0;h=A1(g|0)|0;if(h>>>0>4294967279>>>0){tB(0)}if(h>>>0<11>>>0){a[k]=h<<1&255;u=k+1|0}else{d=h+16&-16;v=AR(d)|0;c[k+8>>2]=v;c[k>>2]=d|1;c[k+4>>2]=h;u=v}A$(u|0,g|0,h)|0;a[u+h|0]=0;h=c7[j&255](t,k)|0;c[4550592]=h;if((a[k]&1)==0){w=h}else{AT(c[k+8>>2]|0);w=c[4550592]|0}k=c[(c[w>>2]|0)+12>>2]|0;h=m;t=m;a[t]=10;j=h+1|0;a[j]=a[88512]|0;a[j+1|0]=a[88513]|0;a[j+2|0]=a[88514]|0;a[j+3|0]=a[88515]|0;a[j+4|0]=a[88516]|0;a[h+6|0]=0;dk[k&127](l,w,m);if((a[t]&1)!=0){AT(c[m+8>>2]|0)}m=c[4550592]|0;t=c[(c[m>>2]|0)+12>>2]|0;w=o;k=o;a[k]=16;h=w+1|0;j=h|0;C=1886220131;a[j]=C&255;C=C>>8;a[j+1|0]=C&255;C=C>>8;a[j+2|0]=C&255;C=C>>8;a[j+3|0]=C&255;j=h+4|0;C=1919251311;a[j]=C&255;C=C>>8;a[j+1|0]=C&255;C=C>>8;a[j+2|0]=C&255;C=C>>8;a[j+3|0]=C&255;a[w+9|0]=0;dk[t&127](n,m,o);if((a[k]&1)!=0){AT(c[o+8>>2]|0)}o=c[4550592]|0;k=c[(c[o>>2]|0)+12>>2]|0;m=q;t=q;a[t]=18;w=m+1|0;A$(w|0,87640,9)|0;a[m+10|0]=0;dk[k&127](p,o,q);if((a[t]&1)!=0){AT(c[q+8>>2]|0)}q=c[4550592]|0;t=r;o=r;a[o]=10;k=t+1|0;a[k]=a[87288]|0;a[k+1|0]=a[87289]|0;a[k+2|0]=a[87290]|0;a[k+3|0]=a[87291]|0;a[k+4|0]=a[87292]|0;a[t+6|0]=0;dk[c[(c[q>>2]|0)+12>>2]&127](f,q,r);if((a[f]&1)==0){x=b7(f+1|0)|0}else{q=c[f+8>>2]|0;f=b7(q|0)|0;AT(q);x=f}c[4550586]=x;if((a[o]&1)!=0){AT(c[r+8>>2]|0)}r=c[4550592]|0;o=s;x=s;a[x]=18;f=o+1|0;A$(f|0,87024,9)|0;a[o+10|0]=0;dk[c[(c[r>>2]|0)+12>>2]&127](e,r,s);if((a[e]&1)==0){y=b7(e+1|0)|0}else{r=c[e+8>>2]|0;e=b7(r|0)|0;AT(r);y=e}c[57912]=y;if((a[x]&1)!=0){AT(c[s+8>>2]|0)}s=c[4550600]|0;if((s|0)>0){if((a[l]&1)==0){z=l+1|0}else{z=c[l+8>>2]|0}if((a[n]&1)==0){A=n+1|0}else{A=c[n+8>>2]|0}x=p;if((a[x]&1)==0){B=p+1|0}else{B=c[p+8>>2]|0}c1[s&31](z,A,B,c[4550586]|0,c[57912]|0);D=x}else{D=p}if((a[D]&1)!=0){AT(c[p+8>>2]|0)}if((a[n]&1)!=0){AT(c[n+8>>2]|0)}if((a[l]&1)==0){i=b;return}AT(c[l+8>>2]|0);i=b;return}function eN(a,b){a=a|0;b=b|0;return}function eO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g|0;j=h;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+144|0;m=d;if((a[m]&1)==0){n=k;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){tB(0)}if(n>>>0<11>>>0){a[k]=n<<1&255;o=k+1|0}else{d=n+16&-16;p=AR(d)|0;c[k+8>>2]=p;c[k>>2]=d|1;c[k+4>>2]=n;o=p}A$(o|0,m|0,n)|0;a[o+n|0]=0}n=l|0;o=l+8|0;m=o|0;c[m>>2]=92376;p=l+12|0;c[n>>2]=98804;d=l+64|0;c[d>>2]=98824;c[l+4>>2]=0;t4(l+64|0,p);c[l+136>>2]=0;c[l+140>>2]=-1;c[n>>2]=92356;c[l+64>>2]=92396;c[m>>2]=92376;m=p|0;c[m>>2]=92712;q=l+16|0;yq(q);A2(l+20|0,0,24);c[m>>2]=92568;A2(l+44|0,0,16);c[l+60>>2]=24;A2(j|0,0,12);ej(p,h);if((a[j]&1)!=0){AT(c[h+8>>2]|0)}h=c[e>>2]|0;if((rq(l,k)|0)<<24>>24!=0){e=o;eP(e,h)|0}h=o;if((rq(l,k)|0)<<24>>24!=0){d3(h,f)|0}d3(h,k)|0;eh(b,p);c[n>>2]=92356;c[d>>2]=92396;c[l+8>>2]=92376;d=l+12|0;c[d>>2]=92568;if((a[l+44|0]&1)!=0){AT(c[l+52>>2]|0)}c[d>>2]=92712;ys(q);t2(l+64|0);if((a[k]&1)==0){i=g;return}AT(c[k+8>>2]|0);i=g;return}function eP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){uB(o)|0}a[k]=1;o=A1(d|0)|0;p=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(p+24)>>2];q=d+o|0;o=(c[n+(p+4)>>2]&176|0)==32?q:d;r=n+p|0;s=n+(p+76)|0;p=c[s>>2]|0;if((p|0)==-1){t3(f,r);t=yt(f,874624)|0;u=c7[c[(c[t>>2]|0)+28>>2]&255](t,32)|0;ys(f);c[s>>2]=u<<24>>24;v=u}else{v=p&255}ei(j,h,d,o,q,r,v);if((c[j>>2]|0)!=0){break}r=c[(c[l>>2]|0)-12>>2]|0;t1(n+r|0,c[n+(r+16)>>2]|5)}}while(0);uM(g);i=e;return b|0}function eQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+144|0;l=d;if((a[l]&1)==0){m=j;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[j]=m<<1&255;n=j+1|0}else{d=m+16&-16;o=AR(d)|0;c[j+8>>2]=o;c[j>>2]=d|1;c[j+4>>2]=m;n=o}A$(n|0,l|0,m)|0;a[n+m|0]=0}m=k|0;n=k+8|0;l=n|0;c[l>>2]=92376;o=k+12|0;c[m>>2]=98804;d=k+64|0;c[d>>2]=98824;c[k+4>>2]=0;t4(k+64|0,o);c[k+136>>2]=0;c[k+140>>2]=-1;c[m>>2]=92356;c[k+64>>2]=92396;c[l>>2]=92376;l=o|0;c[l>>2]=92712;p=k+16|0;yq(p);A2(k+20|0,0,24);c[l>>2]=92568;A2(k+44|0,0,16);c[k+60>>2]=24;A2(h|0,0,12);ej(o,g);if((a[h]&1)!=0){AT(c[g+8>>2]|0)}g=n;if((rq(k,j)|0)<<24>>24!=0){n=c[e>>2]|0;uN(g,n)|0}d3(g,j)|0;eh(b,o);c[m>>2]=92356;c[d>>2]=92396;c[k+8>>2]=92376;d=k+12|0;c[d>>2]=92568;if((a[k+44|0]&1)!=0){AT(c[k+52>>2]|0)}c[d>>2]=92712;ys(p);t2(k+64|0);if((a[j]&1)==0){i=f;return}AT(c[j+8>>2]|0);i=f;return}function eR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+144|0;l=d;if((a[l]&1)==0){m=j;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[j]=m<<1&255;n=j+1|0}else{d=m+16&-16;o=AR(d)|0;c[j+8>>2]=o;c[j>>2]=d|1;c[j+4>>2]=m;n=o}A$(n|0,l|0,m)|0;a[n+m|0]=0}m=k|0;n=k+8|0;l=n|0;c[l>>2]=92376;o=k+12|0;c[m>>2]=98804;d=k+64|0;c[d>>2]=98824;c[k+4>>2]=0;t4(k+64|0,o);c[k+136>>2]=0;c[k+140>>2]=-1;c[m>>2]=92356;c[k+64>>2]=92396;c[l>>2]=92376;l=o|0;c[l>>2]=92712;p=k+16|0;yq(p);A2(k+20|0,0,24);c[l>>2]=92568;A2(k+44|0,0,16);c[k+60>>2]=24;A2(h|0,0,12);ej(o,g);if((a[h]&1)!=0){AT(c[g+8>>2]|0)}g=c[e>>2]|0;e=n;if((rq(k,j)|0)<<24>>24!=0){eP(e,g)|0}d3(e,j)|0;eh(b,o);c[m>>2]=92356;c[d>>2]=92396;c[k+8>>2]=92376;d=k+12|0;c[d>>2]=92568;if((a[k+44|0]&1)!=0){AT(c[k+52>>2]|0)}c[d>>2]=92712;ys(p);t2(k+64|0);if((a[j]&1)==0){i=f;return}AT(c[j+8>>2]|0);i=f;return}function eS(){c[4550602]=0;bh(50,18202408,r|0)|0;A2(18202352|0,0|0,12|0);bh(334,18202352,r|0)|0;return}function eT(a){a=a|0;return 81392}function eU(a){a=a|0;var b=0,d=0;b=i;d=i0(a,(a=i,i=i+16|0,c[a>>2]=87632,c[a+8>>2]=0,a)|0)|0;i=a;i=b;return d|0}function eV(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;b=c[217680]|0;d=kU()|0;if((b|0)==0){e=i0(81392,(f=i,i=i+32|0,c[f>>2]=81304,c[f+8>>2]=d,c[f+16>>2]=80312,c[f+24>>2]=0,f)|0)|0;i=f;g=e;i=a;return g|0}else{e=i0(b,(f=i,i=i+32|0,c[f>>2]=79256,c[f+8>>2]=d,c[f+16>>2]=80312,c[f+24>>2]=0,f)|0)|0;i=f;g=e;i=a;return g|0}return 0}function eW(){return c[q>>2]|0}function eX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[q>>2]|0;if((aW(a|0,e|0)|0)==-1){i=d;return-1|0}a=cu(e|0,87280,(f=i,i=i+8|0,c[f>>2]=b,f)|0)|0;i=f;if((a|0)<0){i=d;return-1|0}else{a=((aS(10,e|0)|0)==-1)<<31>>31;i=d;return a|0}return 0}function eY(b){b=b|0;var c=0;if((b|0)==0){c=0;return c|0}c=(a[b]|0)!=47|0;return c|0}function eZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;bT(86976,(d=i,i=i+8|0,c[d>>2]=a,d)|0)|0;i=d;i=e;return-1|0}function e_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((a[d]|0)==47){c[b>>2]=hk(d)|0;i=e;return 0}else{f=gT()|0;c[217682]=f;g=i0(f,(f=i,i=i+24|0,c[f>>2]=86632,c[f+8>>2]=d,c[f+16>>2]=0,f)|0)|0;i=f;c[b>>2]=g;hj(c[217682]|0);i=e;return 0}return 0}function e$(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a|0;c[d>>2]=b;c[d+4>>2]=0;i=a;return}function e0(a){a=a|0;return hk(a)|0}function e1(a){a=a|0;return i4(i4(i4(a,86344,86032)|0,86e3,85400)|0,85048,84752)|0}function e2(){var b=0,c=0,d=0,e=0;b=hg(gQ()|0)|0;c=b4(84624)|0;if((c|0)==0){a[b]=a[84480]|0;a[b+1|0]=a[84481]|0;a[b+2|0]=a[84482]|0;a[b+3|0]=a[84483]|0;a[b+4|0]=a[84484]|0}else{d=gQ()|0;A5(b|0,c|0,d|0)|0;a[b+((gQ()|0)-13)|0]=0}d=b+(A1(b|0)|0)|0;A$(d|0,77248,13)|0;d=cI(b|0)|0;if((d|0)<0){a[b]=0;e=hk(b)|0;hj(b);return e|0}else{bl(d|0)|0;e=hk(b)|0;hj(b);return e|0}return 0}function e3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b4(84624)|0;if((e|0)==0){f=i0(84480,(g=i,i=i+16|0,c[g>>2]=77264,c[g+8>>2]=0,g)|0)|0;i=g;h=f}else{f=i0(e,(g=i,i=i+16|0,c[g>>2]=77264,c[g+8>>2]=0,g)|0)|0;i=g;h=f}f=cI(h|0)|0;if((f|0)<0){hj(h);j=0;i=d;return j|0}g=b_(f|0,b|0)|0;if((g|0)==0){hj(h);j=0;i=d;return j|0}else{c[a>>2]=h;j=g;i=d;return j|0}return 0}function e4(b){b=b|0;var c=0,d=0,e=0,f=0;c=A1(b|0)|0;d=c>>>0<4>>>0;do{if(d){if(c>>>0<3>>>0){e=0}else{f=1596;break}return e|0}else{if((A8(b+(c-3)|0,84264)|0)!=0){f=1596}}}while(0);do{if((f|0)==1596){if((A8(b+(c-2)|0,84024)|0)==0){break}if(d){e=0;return e|0}if((bS(a[b+(c-1)|0]|0)|0)!=90){e=0;return e|0}if((a[b+(c-4)|0]|0)==46){break}else{e=0}return e|0}}while(0);e=1;return e|0}function e5(a){a=a|0;return 0}function e6(){hj(c[217678]|0);return}function e7(){return 0}function e8(){return 0}function e9(){return 0}function fa(){return 0}function fb(a){a=a|0;return}function fc(){return 1e6}function fd(){var a=0,b=0;a=i;i=i+8|0;b=a|0;b6(b|0,0)|0;i=a;return((c[b>>2]|0)*1e6|0)+(c[b+4>>2]|0)|0}function fe(){c[80934]=38;return}function ff(a,b,c){a=+a;b=+b;c=c|0;fw(a,b,c);return}function fg(){gV();return}function fh(){dd[c[80934]&63]();return}function fi(){return 0}function fj(a){a=a|0;return}function fk(a){a=a|0;return}function fl(a){a=a|0;return}function fm(a){a=a|0;return}function fn(a){a=a|0;return}function fo(a){a=a|0;return}function fp(a){a=a|0;return}function fq(a){a=a|0;return}function fr(a){a=a|0;return}function fs(a){a=a|0;return}function ft(){return}function fu(a){a=a|0;return}function fv(a){a=a|0;c[a>>2]=0;return}function fw(a,b,c){a=+a;b=+b;c=c|0;return}function fx(){return}function fy(){return 0}function fz(){return}function fA(){return 0}function fB(){return}function fC(a,b){a=a|0;b=b|0;return}function fD(a,b){a=a|0;b=b|0;return 0}function fE(a){a=a|0;return}function fF(a){a=a|0;return}function fG(a){a=a|0;return}function fH(a,b){a=a|0;b=b|0;return 3}function fI(){return}function fJ(a,b){a=a|0;b=b|0;return}function fK(a,b){a=a|0;b=b|0;return}function fL(a){a=a|0;return}function fM(a){a=a|0;return}function fN(){return}function fO(a){a=a|0;return 0}function fP(a){a=a|0;return}function fQ(a){a=a|0;var b=0;b=hg(2068)|0;c[b>>2]=hk(a)|0;c[b+4>>2]=0;c[b+2056>>2]=0;c[b+2060>>2]=-1;return b|0}function fR(a){a=a|0;var b=0,d=0,e=0;hj(c[a>>2]|0);b=c[a+4>>2]|0;if((b|0)==0){d=a;hj(d);return}else{e=b}while(1){b=c[e+20>>2]|0;fS(e);if((b|0)==0){break}else{e=b}}d=a;hj(d);return}function fS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((a|0)==0){return}b=a+12|0;d=c[b>>2]|0;e=a+4|0;if((d|0)>=0){f=c[e>>2]|0;g=f+2056|0;h=c[g>>2]|0;do{if(h>>>0>1>>>0){i=h-1|0;c[g>>2]=i;if((i|0)!=(d|0)){j=c[f+8+(i<<3)>>2]|0;c[f+8+(d<<3)>>2]=j;c[f+8+(d<<3)+4>>2]=c[f+8+(i<<3)+4>>2];c[j+12>>2]=d}j=f+2064|0;k=c[j>>2]|0;if((k|0)!=(d|0)){if((k|0)!=(i|0)){break}c[j>>2]=d;break}i=c[g>>2]|0;if((i|0)==0){l=d;m=-1}else{k=d;n=0;o=-1;while(1){p=c[f+8+(n<<3)+4>>2]|0;q=p>>>0>o>>>0;r=q?k:n;s=q?o:p;p=n+1|0;if(p>>>0<i>>>0){k=r;n=p;o=s}else{l=r;m=s;break}}}c[f+2060>>2]=m;c[j>>2]=l}else{c[g>>2]=0;c[f+2060>>2]=-1;c[f+2064>>2]=-1}}while(0);c[b>>2]=-1}b=(c[e>>2]|0)+4|0;e=a+20|0;if((c[b>>2]|0)==(a|0)){c[b>>2]=c[e>>2]}b=c[e>>2]|0;f=a+24|0;if((b|0)!=0){c[b+24>>2]=c[f>>2]}b=c[f>>2]|0;if((b|0)!=0){c[b+20>>2]=c[e>>2]}hj(c[a>>2]|0);hj(a);return}function fT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((d|0)==0){return}e=c[a+2056>>2]|0;f=(d|0)>0;if((e|0)!=0){d=f?b:-b|0;g=0;do{h=a+8+(g<<3)+4|0;c[h>>2]=(c[h>>2]|0)+d;g=g+1|0;}while(g>>>0<e>>>0)}e=a+2060|0;a=c[e>>2]|0;if(f){c[e>>2]=a+b;return}else{c[e>>2]=a-b;return}}function fU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=hg(28)|0;g=f;c[f>>2]=hk(b)|0;c[f+4>>2]=a;c[f+8>>2]=d;c[f+16>>2]=e;c[f+12>>2]=-1;e=a+4|0;a=c[e>>2]|0;if((a|0)==0){c[e>>2]=g;c[f+20>>2]=0;h=f+24|0;i=h;c[i>>2]=0;return g|0}else{c[f+20>>2]=a;c[(c[e>>2]|0)+24>>2]=g;c[e>>2]=g;h=f+24|0;i=h;c[i>>2]=0;return g|0}return 0}function fV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+12|0;d=c[b>>2]|0;if((d|0)<0){return}e=c[a+4>>2]|0;a=e+2056|0;f=c[a>>2]|0;do{if(f>>>0>1>>>0){g=f-1|0;c[a>>2]=g;if((g|0)!=(d|0)){h=c[e+8+(g<<3)>>2]|0;c[e+8+(d<<3)>>2]=h;c[e+8+(d<<3)+4>>2]=c[e+8+(g<<3)+4>>2];c[h+12>>2]=d}h=e+2064|0;i=c[h>>2]|0;if((i|0)!=(d|0)){if((i|0)!=(g|0)){break}c[h>>2]=d;break}g=c[a>>2]|0;if((g|0)==0){j=d;k=-1}else{i=d;l=0;m=-1;while(1){n=c[e+8+(l<<3)+4>>2]|0;o=n>>>0>m>>>0;p=o?i:l;q=o?m:n;n=l+1|0;if(n>>>0<g>>>0){i=p;l=n;m=q}else{j=p;k=q;break}}}c[e+2060>>2]=k;c[h>>2]=j}else{c[a>>2]=0;c[e+2060>>2]=-1;c[e+2064>>2]=-1}}while(0);c[b>>2]=-1;return}function fW(){var a=0,b=0;a=i;hv(-2,78168,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;i=a;return}function fX(a,b){a=a|0;b=b|0;var d=0,e=0;d=hg(16)|0;if(b>>>0<3145725>>>0){e=0;return e|0}c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=b;c[d+12>>2]=0;e=d;return e|0}function fY(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function fZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=hg(12)|0;c[e>>2]=b;c[e+4>>2]=d;d=a+12|0;c[e+8>>2]=c[d>>2];c[d>>2]=e;return}function f_(a){a=a|0;var b=0,d=0,e=0;b=c[a+12>>2]|0;if((b|0)==0){d=a;hj(d);return}else{e=b}while(1){b=c[e+8>>2]|0;hj(e);if((b|0)==0){break}else{e=b}}d=a;hj(d);return}function f$(a){a=a|0;var b=0,d=0,e=0;b=(c[a+8>>2]|0)-1048575|0;d=c[a+4>>2]|0;if((d|0)==0){e=b;return e|0}e=b-((b>>>0)%(d>>>0)|0)|0;return e|0}function f0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=c[a>>2]|0;d=c[b>>2]|0;e=c[a+8>>2]|0;if(d>>>0<e>>>0){f=0;return f|0}g=e-1048575|0;e=c[a+4>>2]|0;if((e|0)==0){h=g}else{h=g-((g>>>0)%(e>>>0)|0)|0}c[b>>2]=d-h;d=c[a+12>>2]|0;if((d|0)==0){f=h;return f|0}else{i=d}while(1){c5[c[i>>2]&255](h,c[i+4>>2]|0);d=c[i+8>>2]|0;if((d|0)==0){f=h;break}else{i=d}}return f|0}function f1(){var a=0,b=0,d=0;if((c[121472]|0)==0){a=c[121456]|0;b=a;hj(b);return}else{d=0}do{hj(c[(c[121456]|0)+(d*52|0)>>2]|0);hj(c[(c[121456]|0)+(d*52|0)+20>>2]|0);d=d+1|0;}while(d>>>0<(c[121472]|0)>>>0);a=c[121456]|0;b=a;hj(b);return}function f2(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(a[56304]|0)){f=0;do{g=f>>>1;h=(f&1|0)!=0?g^-306674912:g;g=h>>>1;i=(h&1|0)!=0?g^-306674912:g;g=i>>>1;h=(i&1|0)!=0?g^-306674912:g;g=h>>>1;i=(h&1|0)!=0?g^-306674912:g;g=i>>>1;h=(i&1|0)!=0?g^-306674912:g;g=h>>>1;i=(h&1|0)!=0?g^-306674912:g;g=i>>>1;h=(i&1|0)!=0?g^-306674912:g;g=h>>>1;c[803832+(f<<2)>>2]=(h&1|0)!=0?g^-306674912:g;f=f+1|0;}while((f|0)<256);a[56304]=1}if((e|0)==0){j=0;return j|0}else{k=e;l=-1;m=b}while(1){n=c[803832+(((d[m]|0)^l&255)<<2)>>2]^l>>>8;b=k-1|0;if((b|0)==0){break}else{k=b;l=n;m=m+1|0}}j=~n;return j|0}function f3(a){a=a|0;var b=0,c=0,d=0,e=0;if((i2(a)|0)<0){b=0;return b|0}c=bV(a|0,89896)|0;if((c|0)==0){b=0;return b|0}a=i5(c)|0;d=hg(a)|0;if((cr(d|0,a|0,1,c|0)|0)==1){e=f2(d,a)|0}else{e=0}aM(c|0)|0;hj(d);b=e;return b|0}function f4(){return h1(50936)|0}function f5(a,b){a=a|0;b=b|0;return}function f6(a,b){a=a|0;b=b|0;c[200924]=a;return 0}function f7(a,b){a=a|0;b=b|0;f8(c[b>>2]|0);return}function f8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;b=i;i=i+8|0;d=b|0;e=c[200954]|0;if((e|0)==0){i=b;return}L1931:do{switch(a|0){case 0:{f=e;g=1786;break};case 6:{h=e+56|0;j=+(c[200934]|0)*.125;k=(~~((+W(+(c[h>>2]|0)/j*1193.0354789591731+709839.4196788392)+ -842.51968503937)*.525)+1e3|0)%1e3|0;c[200936]=k;c[e+64>>2]=(1e3-k+~~((+W(+(c[h>>2]|0)/j*1193.0354789591731+709839.4196788392)+ -842.51968503937)*.525)|0)%1e3|0;fG(c[(c[200954]|0)+64>>2]|0);break};case 5:{if(((c[e+68>>2]|0)-1|0)>>>0<3>>>0){fV(c[200940]|0);c[200938]=0}do{if((gf()|0)==0){h=d;c[d>>2]=0;if((hL()|0)==0){gc(4,h,4)}else{hK(4,h,4)}if((hL()|0)!=0){break}h=c[200954]|0;if((h|0)==0){break}c[h+68>>2]=0;m0(0);c[200690]=0;fF(c[(c[200954]|0)+68>>2]|0);c[121674]=0;c[200692]=0}}while(0);if((c[217676]|0)==0){h=c[200954]|0;mO(h)|0}c[(c[200954]|0)+56>>2]=0;c[200936]=0;c[200928]=0;c[200930]=0;c[200932]=0;c[121708]=0;h=c[200954]|0;if((h|0)==0){l=0}else{c[h+64>>2]=(~~((+W(+(c[h+56>>2]|0)/(+(c[200934]|0)*.125)*1193.0354789591731+709839.4196788392)+ -842.51968503937)*.525)+1e3|0)%1e3|0;fG(c[(c[200954]|0)+64>>2]|0);l=c[200954]|0}c[200824]=0;f=l;g=1786;break};case 2:{c[e+68>>2]=2;h=c[(c[200954]|0)+68>>2]|0;if((h|0)==1|(h|0)==3){fV(c[200940]|0);c[200938]=0}h=c[200940]|0;k=(c[198580]|0)+1e3|0;m=c[h+4>>2]|0;n=h+12|0;o=c[n>>2]|0;do{if((o|0)<0){p=m+2056|0;q=c[p>>2]|0;if(q>>>0>255>>>0){fW();break}c[m+8+(q<<3)>>2]=h;c[m+8+(q<<3)+4>>2]=k;c[p>>2]=(c[p>>2]|0)+1;p=m+2060|0;if((c[p>>2]|0)>>>0>k>>>0){c[p>>2]=k;c[m+2064>>2]=q}c[n>>2]=q}else{c[m+8+(o<<3)+4>>2]=k;q=m+2060|0;p=m+2064|0;r=c[p>>2]|0;if((c[q>>2]|0)>>>0>k>>>0){s=r}else{if((o|0)==(r|0)){s=o}else{break}}r=c[m+2056>>2]|0;if((r|0)==0){t=s;u=-1}else{v=s;w=0;x=-1;while(1){y=c[m+8+(w<<3)+4>>2]|0;z=y>>>0>x>>>0;A=z?v:w;B=z?x:y;y=w+1|0;if(y>>>0<r>>>0){v=A;w=y;x=B}else{t=A;u=B;break}}}c[q>>2]=u;c[p>>2]=t}}while(0);c[200938]=1;m0(1);c[200690]=0;if((c[200926]|0)==0){break L1931}m=c[200954]|0;cE(c[m+4>>2]|0,(c[m+48>>2]|0)+(c[m+32>>2]|0)|0,0)|0;if((c[200938]|0)!=0){break L1931}m=c[200940]|0;o=(c[198580]|0)+32e3|0;k=c[m+4>>2]|0;n=m+12|0;h=c[n>>2]|0;do{if((h|0)<0){x=k+2056|0;w=c[x>>2]|0;if(w>>>0>255>>>0){fW();break}c[k+8+(w<<3)>>2]=m;c[k+8+(w<<3)+4>>2]=o;c[x>>2]=(c[x>>2]|0)+1;x=k+2060|0;if((c[x>>2]|0)>>>0>o>>>0){c[x>>2]=o;c[k+2064>>2]=w}c[n>>2]=w}else{c[k+8+(h<<3)+4>>2]=o;w=k+2060|0;x=k+2064|0;v=c[x>>2]|0;if((c[w>>2]|0)>>>0>o>>>0){C=v}else{if((h|0)==(v|0)){C=h}else{break}}v=c[k+2056>>2]|0;if((v|0)==0){D=C;E=-1}else{r=C;B=0;A=-1;while(1){y=c[k+8+(B<<3)+4>>2]|0;z=y>>>0>A>>>0;F=z?r:B;G=z?A:y;y=B+1|0;if(y>>>0<v>>>0){r=F;B=y;A=G}else{D=F;E=G;break}}}c[w>>2]=E;c[x>>2]=D}}while(0);c[200938]=1;break};case 3:{c[e+68>>2]=3;if(((c[(c[200954]|0)+68>>2]|0)-1|0)>>>0<2>>>0){fV(c[200940]|0);c[200938]=0}k=c[200940]|0;h=(c[198580]|0)+1e3|0;o=c[k+4>>2]|0;n=k+12|0;m=c[n>>2]|0;do{if((m|0)<0){A=o+2056|0;B=c[A>>2]|0;if(B>>>0>255>>>0){fW();break}c[o+8+(B<<3)>>2]=k;c[o+8+(B<<3)+4>>2]=h;c[A>>2]=(c[A>>2]|0)+1;A=o+2060|0;if((c[A>>2]|0)>>>0>h>>>0){c[A>>2]=h;c[o+2064>>2]=B}c[n>>2]=B}else{c[o+8+(m<<3)+4>>2]=h;B=o+2060|0;A=o+2064|0;r=c[A>>2]|0;if((c[B>>2]|0)>>>0>h>>>0){H=r}else{if((m|0)==(r|0)){H=m}else{break}}r=c[o+2056>>2]|0;if((r|0)==0){I=H;J=-1}else{v=H;p=0;q=-1;while(1){G=c[o+8+(p<<3)+4>>2]|0;F=G>>>0>q>>>0;y=F?v:p;z=F?q:G;G=p+1|0;if(G>>>0<r>>>0){v=y;p=G;q=z}else{I=y;J=z;break}}}c[B>>2]=J;c[A>>2]=I}}while(0);c[200938]=1;m0(1);c[200690]=0;if((c[200926]|0)==0){break L1931}o=c[200954]|0;cE(c[o+4>>2]|0,(c[o+48>>2]|0)+(c[o+32>>2]|0)|0,0)|0;if((c[200938]|0)!=0){break L1931}o=c[200940]|0;m=(c[198580]|0)+32e3|0;h=c[o+4>>2]|0;n=o+12|0;k=c[n>>2]|0;do{if((k|0)<0){q=h+2056|0;p=c[q>>2]|0;if(p>>>0>255>>>0){fW();break}c[h+8+(p<<3)>>2]=o;c[h+8+(p<<3)+4>>2]=m;c[q>>2]=(c[q>>2]|0)+1;q=h+2060|0;if((c[q>>2]|0)>>>0>m>>>0){c[q>>2]=m;c[h+2064>>2]=p}c[n>>2]=p}else{c[h+8+(k<<3)+4>>2]=m;p=h+2060|0;q=h+2064|0;v=c[q>>2]|0;if((c[p>>2]|0)>>>0>m>>>0){K=v}else{if((k|0)==(v|0)){K=k}else{break}}v=c[h+2056>>2]|0;if((v|0)==0){L=K;M=-1}else{r=K;x=0;w=-1;while(1){z=c[h+8+(x<<3)+4>>2]|0;y=z>>>0>w>>>0;G=y?r:x;F=y?w:z;z=x+1|0;if(z>>>0<v>>>0){r=G;x=z;w=F}else{L=G;M=F;break}}}c[p>>2]=M;c[q>>2]=L}}while(0);c[200938]=1;break};case 1:{c[e+68>>2]=1;m0(1);c[200690]=0;if((c[200926]|0)==0){break L1931}h=c[200954]|0;cE(c[h+4>>2]|0,(c[h+48>>2]|0)+(c[h+32>>2]|0)|0,0)|0;if((c[200938]|0)!=0){break L1931}h=c[200940]|0;k=(c[198580]|0)+32e3|0;m=c[h+4>>2]|0;n=h+12|0;o=c[n>>2]|0;do{if((o|0)<0){w=m+2056|0;x=c[w>>2]|0;if(x>>>0>255>>>0){fW();break}c[m+8+(x<<3)>>2]=h;c[m+8+(x<<3)+4>>2]=k;c[w>>2]=(c[w>>2]|0)+1;w=m+2060|0;if((c[w>>2]|0)>>>0>k>>>0){c[w>>2]=k;c[m+2064>>2]=x}c[n>>2]=x}else{c[m+8+(o<<3)+4>>2]=k;x=m+2060|0;w=m+2064|0;r=c[w>>2]|0;if((c[x>>2]|0)>>>0>k>>>0){N=r}else{if((o|0)==(r|0)){N=o}else{break}}r=c[m+2056>>2]|0;if((r|0)==0){O=N;P=-1}else{v=N;A=0;B=-1;while(1){F=c[m+8+(A<<3)+4>>2]|0;G=F>>>0>B>>>0;z=G?v:A;y=G?B:F;F=A+1|0;if(F>>>0<r>>>0){v=z;A=F;B=y}else{O=z;P=y;break}}}c[x>>2]=P;c[w>>2]=O}}while(0);c[200938]=1;break};case 4:{if((c[e+72>>2]|0)!=0){break L1931}c[e+68>>2]=4;m0(1);c[200690]=0;break};default:{}}}while(0);if((g|0)==1786){c[f+68>>2]=0;m0(0);c[200690]=0}fF(c[(c[200954]|0)+68>>2]|0);c[121674]=0;c[200692]=0;i=b;return}function f9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=c[200954]|0;if((b|0)==0){return}d=(a|0)==0;if(d){e=(c[200926]|0)!=0}else{c[121708]=0;if((c[200926]|0)!=0){return}c[200690]=0;a=c[b+4>>2]|0;f=(c[b+48>>2]|0)+(c[b+32>>2]|0)|0;cE(a|0,f|0,0)|0;if((c[200938]|0)==0){f=c[200940]|0;a=(c[198580]|0)+32e3|0;b=c[f+4>>2]|0;g=f+12|0;h=c[g>>2]|0;do{if((h|0)<0){i=b+2056|0;j=c[i>>2]|0;if(j>>>0>255>>>0){fW();break}c[b+8+(j<<3)>>2]=f;c[b+8+(j<<3)+4>>2]=a;c[i>>2]=(c[i>>2]|0)+1;i=b+2060|0;if((c[i>>2]|0)>>>0>a>>>0){c[i>>2]=a;c[b+2064>>2]=j}c[g>>2]=j}else{c[b+8+(h<<3)+4>>2]=a;j=b+2060|0;i=b+2064|0;k=c[i>>2]|0;if((c[j>>2]|0)>>>0>a>>>0){l=k}else{if((h|0)==(k|0)){l=h}else{break}}k=c[b+2056>>2]|0;if((k|0)==0){m=l;n=-1}else{o=l;p=0;q=-1;while(1){r=c[b+8+(p<<3)+4>>2]|0;s=r>>>0>q>>>0;t=s?o:p;u=s?q:r;r=p+1|0;if(r>>>0<k>>>0){o=t;p=r;q=u}else{m=t;n=u;break}}}c[j>>2]=n;c[i>>2]=m}}while(0);c[200938]=1}fE(1);c[200926]=1;e=1}if(!(d&e&(c[121708]|0)==0)){return}e=(c[198580]|0)+32e3|0;c[121708]=e;if((c[200938]|0)!=0){return}d=c[200940]|0;m=c[d+4>>2]|0;n=d+12|0;b=c[n>>2]|0;do{if((b|0)<0){l=m+2056|0;h=c[l>>2]|0;if(h>>>0>255>>>0){fW();break}c[m+8+(h<<3)>>2]=d;c[m+8+(h<<3)+4>>2]=e;c[l>>2]=(c[l>>2]|0)+1;l=m+2060|0;if((c[l>>2]|0)>>>0>e>>>0){c[l>>2]=e;c[m+2064>>2]=h}c[n>>2]=h}else{c[m+8+(b<<3)+4>>2]=e;h=m+2060|0;l=m+2064|0;a=c[l>>2]|0;if((c[h>>2]|0)>>>0>e>>>0){v=a}else{if((b|0)==(a|0)){v=b}else{break}}a=c[m+2056>>2]|0;if((a|0)==0){w=v;x=-1}else{g=v;f=0;q=-1;while(1){p=c[m+8+(f<<3)+4>>2]|0;o=p>>>0>q>>>0;k=o?g:f;u=o?q:p;p=f+1|0;if(p>>>0<a>>>0){g=k;f=p;q=u}else{w=k;x=u;break}}}c[h>>2]=x;c[l>>2]=w}}while(0);c[200938]=1;return}function ga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=c[200954]|0;if((j|0)==0|(b|0)==0){i=d;return}if(!((c[j+68>>2]|0)==4&(c[200926]|0)!=0)){i=d;return}b=c[200690]|0;if((b|0)==0){c[200690]=c[198580];i=d;return}k=h|0;l=c[198580]|0;c[200690]=l;m=(l-b|0)>>>(((c[13586]|0)==7|0)>>>0);if(m>>>0<7>>>0){i=d;return}do{if(m>>>0<2047>>>0){a[g]=m>>>3&255;if((aU(g|0,1,1,c[j+4>>2]|0)|0)!=0){b=(c[200954]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1;n=m;break}if((gf()|0)!=0){i=d;return}b=f;c[f>>2]=0;if((hL()|0)==0){gc(4,b,4)}else{hK(4,b,4)}if((hL()|0)!=0){i=d;return}b=c[200954]|0;if((b|0)==0){i=d;return}c[b+68>>2]=0;m0(0);c[200690]=0;fF(c[(c[200954]|0)+68>>2]|0);c[121674]=0;c[200692]=0;i=d;return}else{a[g]=0;if((aU(g|0,1,1,c[j+4>>2]|0)|0)!=1){hw(81816,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b}b=(c[200954]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1;b=c[200954]|0;if((a[b+12|0]|0)==0){n=m;break}a[k]=m&255;a[h+1|0]=m>>>8&255;a[h+2|0]=m>>>16&255;l=aU(k|0,1,3,c[b+4>>2]|0)|0;b=(c[200954]|0)+32|0;c[b>>2]=(c[b>>2]|0)+l;if((l|0)>=3){n=m&16777215;break}if((gf()|0)!=0){i=d;return}l=e;c[e>>2]=0;if((hL()|0)==0){gc(4,l,4)}else{hK(4,l,4)}if((hL()|0)!=0){i=d;return}l=c[200954]|0;if((l|0)==0){i=d;return}c[l+68>>2]=0;m0(0);c[200690]=0;fF(c[(c[200954]|0)+68>>2]|0);c[121674]=0;c[200692]=0;i=d;return}}while(0);e=c[200954]|0;m=e+8|0;k=c[e+32>>2]|0;if((c[m>>2]|0)<(k|0)){c[m>>2]=k;o=c[200954]|0}else{o=e}e=n>>>3;n=o+56|0;c[n>>2]=(c[n>>2]|0)+e;if((c[13586]|0)==7){n=(c[200954]|0)+56|0;c[n>>2]=(c[n>>2]|0)+e}e=c[200954]|0;n=e+60|0;o=c[e+56>>2]|0;if((c[n>>2]|0)<(o|0)){c[n>>2]=o;p=c[200954]|0}else{p=e}c[p+76>>2]=1;p=c[200954]|0;if((p|0)==0){i=d;return}c[p+64>>2]=(1e3-(c[200936]|0)+~~((+W(+(c[p+56>>2]|0)/(+(c[200934]|0)*.125)*1193.0354789591731+709839.4196788392)+ -842.51968503937)*.525)|0)%1e3|0;fG(c[(c[200954]|0)+64>>2]|0);i=d;return}function gb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=c[198576]|0;if((b|0)==0){return}f=d+a|0;d=e+80120|0;g=e+80116|0;if((c[d>>2]|0)==(a|0)){h=(c[g>>2]|0)+b|0}else{h=b}c[g>>2]=h;h=e+28|0;c[e+32+(c[h>>2]<<2)>>2]=(c[198580]|0)-f;c[e+40060+(c[h>>2]<<2)>>2]=f;g=c[h>>2]|0;c[h>>2]=g+1;h=((c[c[e+80112>>2]>>2]|0)>>>8&1)+1|0;i=e+16|0;if((c[i>>2]|0)>>>0<a>>>0){j=0}else{j=(f|0)==((c[198580]|0)-h|0)&(g|0)==0&1}k=e+24|0;e=c[198580]|0;do{if((c[k>>2]|0)>>>0<a>>>0){l=0}else{if((f|0)!=(e-h|0)){l=0;break}l=(g|0)==0|0}}while(0);c[198580]=e+b;e=f+b|0;c[d>>2]=e;d=c[i>>2]|0;g=d>>>0>f>>>0?e:d+b|0;c[i>>2]=g;d=c[k>>2]|0;c[i>>2]=g-j;c[k>>2]=(d>>>0>f>>>0?e:d+b|0)-l;return}function gc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(!(a[51248]|0)){return}f=c[200896]|0;switch(b|0){case 8:{c[121672]=(c[121672]|0)-(c[198580]|0);g=1964;break};case 0:case 11:case 15:{h=0;break};case 1:case 2:case 12:case 3:case 4:case 6:case 7:case 10:case 5:case 14:case 16:{g=1964;break};default:{return}}if((g|0)==1964){g=hg(e)|0;A$(g|0,d|0,e)|0;h=g}g=f+4|0;c[c[g>>2]>>2]=b;c[(c[g>>2]|0)+4>>2]=c[198580];c[(c[g>>2]|0)+8>>2]=e;c[(c[g>>2]|0)+12>>2]=h;h=hh(1,20)|0;c[(c[g>>2]|0)+16>>2]=h;h=c[(c[g>>2]|0)+16>>2]|0;c[g>>2]=h;c[h>>2]=0;return}function gd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e|0;c[f>>2]=0;g=a[b]|0;h=g<<24>>24;j=a[b+1|0]|0;k=b+2|0;L2209:do{if((a[k]|0)==0){l=b+7|0;m=c[200898]|0;while(1){n=m+8|0;o=c[n>>2]|0;if((o|0)==0){p=1975;break}if((a9(l|0,c[o>>2]|0)|0)==0){p=1974;break}else{m=o}}do{if((p|0)==1975){m=hh(1,12)|0;c[n>>2]=m;c[m+8>>2]=0;c[m>>2]=hk(l)|0;c[m+4>>2]=0}else if((p|0)==1974){m=c[o+4>>2]|0;if((m|0)==0){break}c[f>>2]=hk(m)|0;p=2004;break L2209}}while(0);m=c[b+3>>2]|0;while(1){q=fD(86208,(r=i,i=i+16|0,c[r>>2]=l,c[r+8>>2]=m,r)|0)|0;i=r;c[f>>2]=q;if((q|0)==0){break}if((m|0)==(f3(q)|0)){p=1980;break}}do{if((p|0)==1980){m=c[f>>2]|0;if((m|0)==0){break}q=c[200898]|0;while(1){s=q+8|0;t=c[s>>2]|0;if((t|0)==0){p=1986;break}if((a9(l|0,c[t>>2]|0)|0)==0){p=1985;break}else{q=t}}if((p|0)==1985){q=hk(m)|0;c[(c[s>>2]|0)+4>>2]=q;p=2004;break L2209}else if((p|0)==1986){q=hh(1,12)|0;c[s>>2]=q;c[q+8>>2]=0;c[q>>2]=hk(l)|0;t=q+4|0;c[t>>2]=0;c[t>>2]=hk(c[f>>2]|0)|0;p=2004;break L2209}}}while(0);fC(85936,(r=i,i=i+1|0,i=i+7&-8,c[r>>2]=0,r)|0);i=r;i=e;return}else{l=d-(A1(k|0)|0)-3|0;if((l|0)==0){t=c[200898]|0;while(1){u=t+8|0;v=c[u>>2]|0;if((v|0)==0){p=2001;break}if((a9(k|0,c[v>>2]|0)|0)==0){p=2e3;break}else{t=v}}do{if((p|0)==2e3){t=c[v+4>>2]|0;if((t|0)==0){break}c[f>>2]=hk(t)|0;p=2004;break L2209}else if((p|0)==2001){t=hh(1,12)|0;c[u>>2]=t;c[t+8>>2]=0;c[t>>2]=hk(k)|0;c[t+4>>2]=0}}while(0);fC(iX(65590)|0,(r=i,i=i+8|0,c[r>>2]=k,r)|0);i=r;i=e;return}t=e3(f,85656)|0;if((t|0)==0){q=iX(65564)|0;fC(q,(r=i,i=i+8|0,c[r>>2]=c[f>>2],r)|0);i=r;break}if((aU(b+((A1(k|0)|0)+3)|0,l|0,1,t|0)|0)!=1){q=iX(65577)|0;fC(q,(r=i,i=i+8|0,c[r>>2]=c[f>>2],r)|0);i=r;break}aM(t|0)|0;t=c[200898]|0;while(1){w=t+8|0;q=c[w>>2]|0;if((q|0)==0){p=1996;break}if((a9(k|0,c[q>>2]|0)|0)==0){p=1995;break}else{t=q}}if((p|0)==1995){t=hk(c[f>>2]|0)|0;c[(c[w>>2]|0)+4>>2]=t;p=2004;break}else if((p|0)==1996){t=hh(1,12)|0;c[w>>2]=t;c[t+8>>2]=0;c[t>>2]=hk(k)|0;l=t+4|0;c[l>>2]=0;c[l>>2]=hk(c[f>>2]|0)|0;p=2004;break}}}while(0);do{if((p|0)==2004){if(g<<24>>24==1){mN(h,c[f>>2]|0);break}else{ia(85232,j,(r=i,i=i+8|0,c[r>>2]=h,r)|0)|0;i=r;qt(h,c[f>>2]|0);break}}}while(0);hj(c[f>>2]|0);i=e;return}function ge(){var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=c[200896]|0;if((b|0)==0){return}do{if(a[51768]|0){a[51768]=0;d=c[(c[b+4>>2]|0)+4>>2]|0;e=c[198580]|0;if(e>>>0>1048575>>>0&d>>>0<(e-1048575|0)>>>0){f=(f$(c[198578]|0)|0)+d|0}else{f=d}d=c[200904]|0;e=c[d+4>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h|0)<0){i=e+2056|0;j=c[i>>2]|0;if(j>>>0>255>>>0){fW();break}c[e+8+(j<<3)>>2]=d;c[e+8+(j<<3)+4>>2]=f;c[i>>2]=(c[i>>2]|0)+1;i=e+2060|0;if((c[i>>2]|0)>>>0>f>>>0){c[i>>2]=f;c[e+2064>>2]=j}c[g>>2]=j;break}else{c[e+8+(h<<3)+4>>2]=f;j=e+2060|0;g=e+2064|0;i=c[g>>2]|0;if((c[j>>2]|0)>>>0>f>>>0){k=i}else{if((h|0)==(i|0)){k=h}else{break}}h=c[e+2056>>2]|0;if((h|0)==0){l=k;m=-1}else{i=k;d=0;n=-1;while(1){o=c[e+8+(d<<3)+4>>2]|0;p=o>>>0>n>>>0;q=p?i:d;r=p?n:o;o=d+1|0;if(o>>>0<h>>>0){i=q;d=o;n=r}else{l=q;m=r;break}}}c[j>>2]=m;c[g>>2]=l;break}}}while(0);l=(c[200896]|0)+4|0;m=c[l>>2]|0;do{if((m|0)!=0){if((c[m>>2]|0)!=8){break}c[l>>2]=c[m+16>>2];k=c[(c[(c[200896]|0)+4>>2]|0)+4>>2]|0;f=c[198580]|0;if(f>>>0>1048575>>>0&k>>>0<(f-1048575|0)>>>0){s=(f$(c[198578]|0)|0)+k|0}else{s=k}k=c[200904]|0;f=c[k+4>>2]|0;b=k+12|0;n=c[b>>2]|0;if((n|0)<0){d=f+2056|0;i=c[d>>2]|0;if(i>>>0>255>>>0){fW();break}c[f+8+(i<<3)>>2]=k;c[f+8+(i<<3)+4>>2]=s;c[d>>2]=(c[d>>2]|0)+1;d=f+2060|0;if((c[d>>2]|0)>>>0>s>>>0){c[d>>2]=s;c[f+2064>>2]=i}c[b>>2]=i;break}else{c[f+8+(n<<3)+4>>2]=s;i=f+2060|0;b=f+2064|0;d=c[b>>2]|0;if((c[i>>2]|0)>>>0>s>>>0){t=d}else{if((n|0)==(d|0)){t=n}else{break}}n=c[f+2056>>2]|0;if((n|0)==0){u=t;v=-1}else{d=t;k=0;h=-1;while(1){e=c[f+8+(k<<3)+4>>2]|0;r=e>>>0>h>>>0;q=r?d:k;o=r?h:e;e=k+1|0;if(e>>>0<n>>>0){d=q;k=e;h=o}else{u=q;v=o;break}}}c[i>>2]=v;c[b>>2]=u;break}}}while(0);if(!(a[51248]|0)){return}u=c[200904]|0;v=c[121672]|0;t=c[u+4>>2]|0;s=u+12|0;m=c[s>>2]|0;if((m|0)<0){l=t+2056|0;h=c[l>>2]|0;if(h>>>0>255>>>0){fW();return}c[t+8+(h<<3)>>2]=u;c[t+8+(h<<3)+4>>2]=v;c[l>>2]=(c[l>>2]|0)+1;l=t+2060|0;if((c[l>>2]|0)>>>0>v>>>0){c[l>>2]=v;c[t+2064>>2]=h}c[s>>2]=h;return}else{c[t+8+(m<<3)+4>>2]=v;h=t+2060|0;s=t+2064|0;l=c[s>>2]|0;do{if((c[h>>2]|0)>>>0>v>>>0){w=l}else{if((m|0)==(l|0)){w=m;break}return}}while(0);m=c[t+2056>>2]|0;if((m|0)==0){x=w;y=-1}else{l=w;w=0;v=-1;while(1){u=c[t+8+(w<<3)+4>>2]|0;k=u>>>0>v>>>0;d=k?l:w;n=k?v:u;u=w+1|0;if(u>>>0<m>>>0){l=d;w=u;v=n}else{x=d;y=n;break}}}c[h>>2]=y;c[s>>2]=x;return}}function gf(){return a[51776]&1|0}function gg(){var a=0;if((h2(49064)|0)<0){a=-1;return a|0}a=h1(50648)|0;return a|0}function gh(){var a=0,b=0,d=0,e=0,f=0;hj(c[200888]|0);hj(c[200902]|0);hj(c[200894]|0);hj(c[200892]|0);c[200892]=0;a=c[200896]|0;do{if((a|0)==0){b=0}else{d=c[a>>2]|0;if((d|0)==0){b=a;break}else{e=d}while(1){d=c[e+16>>2]|0;hj(c[e+12>>2]|0);hj(e);if((d|0)==0){break}else{e=d}}b=c[200896]|0}}while(0);hj(b);b=c[200898]|0;if((b|0)==0){c[200898]=0;return}else{f=b}while(1){b=c[f+8>>2]|0;hj(c[f>>2]|0);hj(c[f+4>>2]|0);hj(f);if((b|0)==0){break}else{f=b}}c[200898]=0;return}function gi(){c[14030]=hq(79656)|0;c[200904]=fU(c[198582]|0,79656,208,0)|0;fZ(c[198578]|0,222,0);return}function gj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;fV(c[200904]|0);if(a[51248]|0){e=c[200950]|0;c[200950]=e+1;fK(e,0);e=c[121672]|0;f=(kP()|0)+e|0;c[121672]=f;e=c[200904]|0;g=c[e+4>>2]|0;h=e+12|0;j=c[h>>2]|0;if((j|0)<0){k=g+2056|0;l=c[k>>2]|0;if(l>>>0>255>>>0){fW();i=d;return}c[g+8+(l<<3)>>2]=e;c[g+8+(l<<3)+4>>2]=f;c[k>>2]=(c[k>>2]|0)+1;k=g+2060|0;if((c[k>>2]|0)>>>0>f>>>0){c[k>>2]=f;c[g+2064>>2]=l}c[h>>2]=l;i=d;return}else{c[g+8+(j<<3)+4>>2]=f;l=g+2060|0;h=g+2064|0;k=c[h>>2]|0;do{if((c[l>>2]|0)>>>0>f>>>0){m=k}else{if((j|0)==(k|0)){m=j;break}i=d;return}}while(0);j=c[g+2056>>2]|0;if((j|0)==0){n=m;o=-1}else{k=m;m=0;f=-1;while(1){e=c[g+8+(m<<3)+4>>2]|0;p=e>>>0>f>>>0;q=p?k:m;r=p?f:e;e=m+1|0;if(e>>>0<j>>>0){k=q;m=e;f=r}else{n=q;o=r;break}}}c[l>>2]=o;c[h>>2]=n;i=d;return}}n=c[(c[200896]|0)+4>>2]|0;h=c[n>>2]|0;L2380:do{switch(h|0){case 10:{gd(c[n+12>>2]|0,c[n+8>>2]|0);break};case 1:{gW(b,c[n+12>>2]|0);break};case 4:{f7(b,c[n+12>>2]|0);break};case 2:{gX(b,c[n+12>>2]|0);break};case 3:{g4(b,c[n+12>>2]|0);break};case 6:case 7:{o=c[n+12>>2]|0;l=a[o]|0;f=l<<24>>24;m=o+1|0;if(l<<24>>24==1){mN(f,m);break L2380}else{qt(f,m);break L2380}break};case 8:{hA(b,c[n+12>>2]|0);break};case 9:{m=c[200950]|0;c[200950]=m+1;fK(m,c[119396]|0);break};case 0:{if(!(a[51776]|0)){break L2380}a[51776]=0;fV(c[200904]|0);fJ(0,0);break};case 11:{break};default:{hv(c[14030]|0,81776,(m=i,i=i+8|0,c[m>>2]=h,m)|0)|0;i=m}}}while(0);h=(c[200896]|0)+4|0;n=c[h>>2]|0;b=c[n>>2]|0;if((b|0)==0|(b|0)==8){i=d;return}c[h>>2]=c[n+16>>2];n=c[(c[(c[200896]|0)+4>>2]|0)+4>>2]|0;h=c[198580]|0;if(h>>>0>1048575>>>0&n>>>0<(h-1048575|0)>>>0){s=(f$(c[198578]|0)|0)+n|0}else{s=n}n=c[200904]|0;h=c[n+4>>2]|0;b=n+12|0;m=c[b>>2]|0;if((m|0)<0){f=h+2056|0;l=c[f>>2]|0;if(l>>>0>255>>>0){fW();i=d;return}c[h+8+(l<<3)>>2]=n;c[h+8+(l<<3)+4>>2]=s;c[f>>2]=(c[f>>2]|0)+1;f=h+2060|0;if((c[f>>2]|0)>>>0>s>>>0){c[f>>2]=s;c[h+2064>>2]=l}c[b>>2]=l;i=d;return}else{c[h+8+(m<<3)+4>>2]=s;l=h+2060|0;b=h+2064|0;f=c[b>>2]|0;do{if((c[l>>2]|0)>>>0>s>>>0){t=f}else{if((m|0)==(f|0)){t=m;break}i=d;return}}while(0);m=c[h+2056>>2]|0;if((m|0)==0){u=t;v=-1}else{f=t;t=0;s=-1;while(1){n=c[h+8+(t<<3)+4>>2]|0;o=n>>>0>s>>>0;k=o?f:t;j=o?s:n;n=t+1|0;if(n>>>0<m>>>0){f=k;t=n;s=j}else{u=k;v=j;break}}}c[l>>2]=v;c[b>>2]=u;i=d;return}}function gk(b,d){b=b|0;d=d|0;var e=0;if(a[51248]|0){d=(c[200896]|0)+4|0;c[c[d>>2]>>2]=11;c[(c[d>>2]|0)+4>>2]=c[198580];c[(c[d>>2]|0)+8>>2]=0;c[(c[d>>2]|0)+12>>2]=0;e=hh(1,20)|0;c[(c[d>>2]|0)+16>>2]=e;e=c[(c[d>>2]|0)+16>>2]|0;c[d>>2]=e;c[e>>2]=0}e=c[121672]|0;if((e|0)==0){return}c[121672]=e-b;return}function gl(a,b){a=a|0;b=b|0;var d=0;if(a>>>0>3>>>0){d=-1}else{c[200890]=a;d=0}return d|0}function gm(a,b){a=a|0;b=b|0;c[200900]=a;return 0}function gn(b,d){b=b|0;d=d|0;var e=0;d=i;if((a[b+((A1(b|0)|0)-1)|0]|0)==47){i1(803576,b)|0;i=d;return 0}else{hj(c[200894]|0);e=i0(b,(b=i,i=i+16|0,c[b>>2]=87128,c[b+8>>2]=0,b)|0)|0;i=b;c[200894]=e;i=d;return 0}return 0}function go(a,b){a=a|0;b=b|0;i1(803552,a)|0;return 0}function gp(a,b){a=a|0;b=b|0;i1(803608,a)|0;return 0}function gq(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=gQ()|0;f=hg(e)|0;a[f]=0;L2444:do{if((cL(b|0,47)|0)==0){g=(A1(b|0)|0)+1|0;if((c|0)==0){h=2185;break}i=e-5|0;j=f+1|0;k=c;while(1){l=cL(k|0,58)|0;m=(l|0)==0;if(m){n=A1(k|0)|0}else{n=l-k|0}if((n+g|0)>>>0<=i>>>0){A$(j|0,k|0,n)|0;o=f+(n+1)|0;if((a[f+n|0]|0)==47){p=o}else{a[o]=47;p=f+(n+2)|0}A$(p|0,b|0,g)|0;o=j;while(1){q=a[o]|0;if((q<<24>>24|0)==92){a[o]=47}else if((q<<24>>24|0)==0){break}o=o+1|0}if((gO(j,d)|0)==0){break}}if(m){h=2185;break L2444}else{k=l+1|0}}if((p|0)==0){h=2185}else{r=j;h=2184}}else{if((eY(b)|0)==0){s=0}else{k=f+1|0;if((gP(k,e-128|0)|0)==0){h=2185;break}s=A1(k|0)|0}if(((A1(b|0)|0)+s|0)>>>0>=(e-5|0)>>>0){h=2185;break}k=f+(s+1)|0;if((a[f+s|0]|0)==47){t=k}else{a[k]=47;t=f+(s+2)|0}k=a[b]|0;if(k<<24>>24==0){u=t}else{g=1;i=b;o=t;q=k;while(1){do{if((g|0)==3){if(q<<24>>24!=47){v=o;w=0;break}k=o-4|0;while(1){x=a[k]|0;if((x<<24>>24|0)==47|(x<<24>>24|0)==0){break}k=k-1|0}v=x<<24>>24==0?k+1|0:k;w=1}else if((g|0)==0){v=o;w=q<<24>>24==47|0}else if((g|0)==1){if((q<<24>>24|0)==46){v=o;w=2;break}else if((q<<24>>24|0)==47){v=o-1|0;w=1;break}else{v=o;w=0;break}}else if((g|0)==2){if((q<<24>>24|0)==46){v=o;w=3;break}else if((q<<24>>24|0)==47){v=o-2|0;w=1;break}else{v=o;w=0;break}}else{v=o;w=g}}while(0);l=i+1|0;m=v+1|0;a[v]=q;y=a[l]|0;if(y<<24>>24==0){u=m;break}else{g=w;i=l;o=m;q=y}}}a[u]=0;r=f+1|0;h=2184}}while(0);if((h|0)==2185){hj(f);z=0;return z|0}else if((h|0)==2184){h=hk(r)|0;hj(f);z=h;return z|0}return 0}function gr(){c[12197]=eV()|0;return(h2(48784)|0)>>31|0}function gs(){var a=0,b=0,d=0,e=0,f=0;a=c[200836]|0;if((a|0)!=0){b=a;while(1){a=c[b>>2]|0;hj(c[b+8>>2]|0);hj(b);if((a|0)==(c[200836]|0)){break}else{b=a}}c[200836]=0}b=c[200837]|0;if((b|0)!=0){a=b;while(1){b=c[a>>2]|0;hj(c[a+8>>2]|0);hj(a);if((b|0)==(c[200837]|0)){break}else{a=b}}c[200837]=0}a=c[200838]|0;if((a|0)!=0){b=a;while(1){a=c[b>>2]|0;hj(c[b+8>>2]|0);hj(b);if((a|0)==(c[200838]|0)){break}else{b=a}}c[200838]=0}b=c[200839]|0;if((b|0)==0){d=c[200834]|0;hj(d);e=c[12197]|0;hj(e);return}else{f=b}while(1){b=c[f>>2]|0;hj(c[f+8>>2]|0);hj(f);if((b|0)==(c[200839]|0)){break}else{f=b}}c[200839]=0;d=c[200834]|0;hj(d);e=c[12197]|0;hj(e);return}function gt(){hj(c[200952]|0);c[200952]=0;return}function gu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+1032|0;g=f|0;h=f+1024|0;if((d|0)==0){j=-1;i=f;return j|0}if((a[d]|0)==0){j=-1;i=f;return j|0}k=bV(d|0,78248)|0;if((k|0)==0){j=-1;i=f;return j|0}l=g|0;a[l]=0;if((bk(l|0,1024,k|0)|0)==0){aM(k|0)|0;j=-1;i=f;return j|0}if((bb(l|0,55704,20)|0)!=0){hs(-2,77736,(m=i,i=i+8|0,c[m>>2]=d,m)|0)|0;i=m;aM(k|0)|0;j=-1;i=f;return j|0}do{if((b|0)==-1){d=c[200836]|0;if((d|0)!=0){n=d;while(1){d=c[n>>2]|0;hj(c[n+8>>2]|0);hj(n);if((d|0)==(c[200836]|0)){break}else{n=d}}c[200836]=0}n=c[200837]|0;if((n|0)!=0){d=n;while(1){n=c[d>>2]|0;hj(c[d+8>>2]|0);hj(d);if((n|0)==(c[200837]|0)){break}else{d=n}}c[200837]=0}d=c[200838]|0;if((d|0)!=0){n=d;while(1){d=c[n>>2]|0;hj(c[n+8>>2]|0);hj(n);if((d|0)==(c[200838]|0)){break}else{n=d}}c[200838]=0}n=c[200839]|0;if((n|0)==0){o=1;break}else{p=n}while(1){n=c[p>>2]|0;hj(c[p+8>>2]|0);hj(p);if((n|0)==(c[200839]|0)){break}else{p=n}}c[200839]=0;o=1}else{n=803344+(b-8<<2)|0;d=c[n>>2]|0;if((d|0)==0){o=0;break}else{q=d}while(1){d=c[q>>2]|0;hj(c[q+8>>2]|0);hj(q);if((d|0)==(c[n>>2]|0)){break}else{q=d}}c[n>>2]=0;o=0}}while(0);q=g+5|0;p=0;d=o;o=b;L2568:while(1){b=d;r=o;L2570:while(1){s=b;while(1){if((cy(k|0)|0)!=0){break L2568}while(1){a[l]=0;if((bk(l|0,1024,k|0)|0)==0){break L2568}if((bb(89976,l|0,5)|0)==0){break}t=g+(A1(l|0)|0)|0;while(1){if(t>>>0<=l>>>0){break}u=t-1|0;if((aY(a[u]|0)|0)==0){break L2570}else{t=u}}if((cy(k|0)|0)!=0){break L2568}}if((s|0)==0){s=0}else{break}}i3(q,0,10,h)|0;b=s;r=c[h>>2]|0}a[t]=0;if((r|0)==-1){hs(-2,89296,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m;v=8}else{v=r}b=hg(16)|0;n=b;c[b+8>>2]=hk(l)|0;c[b+12>>2]=v;u=803344+(v-8<<2)|0;w=c[u>>2]|0;if((w|0)==0){c[u>>2]=n;c[b+4>>2]=n;c[b>>2]=n;p=1;d=s;o=v;continue}else{c[b>>2]=w;x=b+4|0;c[x>>2]=c[(c[u>>2]|0)+4>>2];c[w+4>>2]=n;c[c[x>>2]>>2]=n;c[u>>2]=n;p=1;d=s;o=v;continue}}aM(k|0)|0;if((p|0)==0){j=-1;i=f;return j|0}c[200956]=r;do{if((s|0)==0){p=803344+(r-8<<2)|0;k=c[p>>2]|0;hs(-2,88616,(m=i,i=i+8|0,c[m>>2]=r,m)|0)|0;i=m;if((k|0)==0){hs(-2,87768,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m;break}else{v=k;do{k=c[v+8>>2]|0;o=v|0;d=c[(c[o>>2]|0)+8>>2]|0;l=c[(c[v+4>>2]|0)+8>>2]|0;hs(-2,88200,(m=i,i=i+32|0,c[m>>2]=c[v+12>>2],c[m+8>>2]=k,c[m+16>>2]=d,c[m+24>>2]=l,m)|0)|0;i=m;v=c[o>>2]|0;}while((v|0)!=(c[p>>2]|0))}}else{p=c[200836]|0;hs(-2,88616,(m=i,i=i+8|0,c[m>>2]=8,m)|0)|0;i=m;if((p|0)==0){hs(-2,87768,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m}else{v=p;do{p=c[v+8>>2]|0;o=v|0;l=c[(c[o>>2]|0)+8>>2]|0;d=c[(c[v+4>>2]|0)+8>>2]|0;hs(-2,88200,(m=i,i=i+32|0,c[m>>2]=c[v+12>>2],c[m+8>>2]=p,c[m+16>>2]=l,c[m+24>>2]=d,m)|0)|0;i=m;v=c[o>>2]|0;}while((v|0)!=(c[200836]|0))}v=c[200837]|0;hs(-2,88616,(m=i,i=i+8|0,c[m>>2]=9,m)|0)|0;i=m;if((v|0)==0){hs(-2,87768,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m}else{o=v;do{v=c[o+8>>2]|0;d=o|0;l=c[(c[d>>2]|0)+8>>2]|0;p=c[(c[o+4>>2]|0)+8>>2]|0;hs(-2,88200,(m=i,i=i+32|0,c[m>>2]=c[o+12>>2],c[m+8>>2]=v,c[m+16>>2]=l,c[m+24>>2]=p,m)|0)|0;i=m;o=c[d>>2]|0;}while((o|0)!=(c[200837]|0))}o=c[200838]|0;hs(-2,88616,(m=i,i=i+8|0,c[m>>2]=10,m)|0)|0;i=m;if((o|0)==0){hs(-2,87768,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m}else{d=o;do{o=c[d+8>>2]|0;p=d|0;l=c[(c[p>>2]|0)+8>>2]|0;v=c[(c[d+4>>2]|0)+8>>2]|0;hs(-2,88200,(m=i,i=i+32|0,c[m>>2]=c[d+12>>2],c[m+8>>2]=o,c[m+16>>2]=l,c[m+24>>2]=v,m)|0)|0;i=m;d=c[p>>2]|0;}while((d|0)!=(c[200838]|0))}d=c[200839]|0;hs(-2,88616,(m=i,i=i+8|0,c[m>>2]=11,m)|0)|0;i=m;if((d|0)==0){hs(-2,87768,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m;break}else{p=d;do{d=c[p+8>>2]|0;v=p|0;l=c[(c[v>>2]|0)+8>>2]|0;o=c[(c[p+4>>2]|0)+8>>2]|0;hs(-2,88200,(m=i,i=i+32|0,c[m>>2]=c[p+12>>2],c[m+8>>2]=d,c[m+16>>2]=l,c[m+24>>2]=o,m)|0)|0;i=m;p=c[v>>2]|0;}while((p|0)!=(c[200839]|0))}}}while(0);if((e|0)==0){j=0;i=f;return j|0}e=803344+(r-8<<2)|0;r=c[e>>2]|0;if((r|0)==0){j=0;i=f;return j|0}m=c[r>>2]|0;c[e>>2]=m;qr(c[m+12>>2]|0,c[m+8>>2]|0)|0;j=0;i=f;return j|0}function gv(a,b){a=a|0;b=b|0;if((i1(803336,a)|0)!=0){return 0}gu(-1,c[200834]|0,0)|0;return 0}function gw(){var a=0,b=0,d=0;a=i;if((h5(kU()|0)|0)!=0){e$(86824,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0);i=b;d=-1;i=a;return d|0}if((ho()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=88800,b)|0);i=b;d=-1;i=a;return d|0}if((iS()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=85360,b)|0);i=b;d=-1;i=a;return d|0}if((qu()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=83136,b)|0);i=b;d=-1;i=a;return d|0}if((hV()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=81664,b)|0);i=b;d=-1;i=a;return d|0}if((fy()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=80424,b)|0);i=b;d=-1;i=a;return d|0}if((gr()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=79512,b)|0);i=b;d=-1;i=a;return d|0}if((qo()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=78736,b)|0);i=b;d=-1;i=a;return d|0}if((mP()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=78216,b)|0);i=b;d=-1;i=a;return d|0}if((mT()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=77712,b)|0);i=b;d=-1;i=a;return d|0}if((gg()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=89944,b)|0);i=b;d=-1;i=a;return d|0}if((f4()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=89288,b)|0);i=b;d=-1;i=a;return d|0}if((kF()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=88592,b)|0);i=b;d=-1;i=a;return d|0}if((g6()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=88184,b)|0);i=b;d=-1;i=a;return d|0}if((hQ()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=87760,b)|0);i=b;d=-1;i=a;return d|0}if((mI()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=87352,b)|0);i=b;d=-1;i=a;return d|0}if((hJ()|0)<0){e$(84544,(b=i,i=i+8|0,c[b>>2]=87080,b)|0);i=b;d=-1;i=a;return d|0}if((qE()|0)>=0){d=0;i=a;return d|0}e$(84544,(b=i,i=i+8|0,c[b>>2]=86752,b)|0);i=b;d=-1;i=a;return d|0}function gx(){var a=0,b=0,d=0;a=i;fb(c[200924]|0);hY();if((c[7356]|0)==0){hP()}if((c[13586]|0)!=10){mJ()|0;ih()|0;mZ()}hH();hC();gi();if((hF()|0)<0){hv(-2,85184,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;d=-1;i=a;return d|0}if((e7()|0)<0){hv(-2,84832,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;d=-1;i=a;return d|0}g$();if((c[7356]|0)==0){g7()|0}if((c[13586]|0)!=10){mU();m$()}fA()|0;d=0;i=a;return d|0}function gy(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+80112>>2]=b;return}function gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=a|0;d=c[b>>2]|0;e=a+4|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;i=a+80112|0;j=c[i>>2]|0;if((d|0)!=0){A2(f|0,0,d<<2|0)}A2(a|0,0,80136);c[b>>2]=d;c[e>>2]=f;c[g>>2]=h;c[i>>2]=j;c[a+80116>>2]=0;c[a+80120>>2]=0;c[a+28>>2]=0;c[a+80088>>2]=0;c[a+80092>>2]=0;c[a+80128>>2]=0;c[a+80132>>2]=0;c[a+80136>>2]=0;c[a+80124>>2]=-1;return}function gA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=a|0;e=(c[d>>2]|0)+1|0;c[d>>2]=e;f=a+4|0;g=hi(c[f>>2]|0,e<<2)|0;c[f>>2]=g;c[g+((c[d>>2]|0)-1<<2)>>2]=0;g=a+8|0;c[g>>2]=hi(c[g>>2]|0,c[d>>2]<<2)|0;a=hk(b)|0;c[(c[g>>2]|0)+((c[d>>2]|0)-1<<2)>>2]=a;return(c[d>>2]|0)-1|0}function gB(){return hh(1,80140)|0}function gC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a|0)==0){b=a;hj(b);return}d=a|0;e=a+8|0;f=c[e>>2]|0;if((c[d>>2]|0)==0){g=f}else{h=0;i=f;while(1){hj(c[i+(h<<2)>>2]|0);f=h+1|0;j=c[e>>2]|0;if(f>>>0<(c[d>>2]|0)>>>0){h=f;i=j}else{g=j;break}}}hj(g);hj(c[a+4>>2]|0);b=a;hj(b);return}function gD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==0){return}e=a+16|0;f=c[e>>2]|0;if((d|0)>0){c[e>>2]=f+b;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;d=a+80120|0;c[d>>2]=(c[d>>2]|0)+b;d=a+80124|0;g=c[d>>2]|0;if((g|0)==-1){return}c[d>>2]=g+b;return}c[e>>2]=f>>>0>b>>>0?f-b|0:0;f=a+24|0;e=c[f>>2]|0;c[f>>2]=e>>>0>b>>>0?e-b|0:0;e=a+80120|0;f=c[e>>2]|0;c[e>>2]=f>>>0>b>>>0?f-b|0:0;f=a+80124|0;a=c[f>>2]|0;if((a|0)==-1){return}if(a>>>0>b>>>0){c[f>>2]=a-b;return}else{c[f>>2]=0;return}}function gE(){var a=0,b=0;a=i;hv(-2,85120,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;i=a;return}function gF(){var a=0,b=0;a=i;hv(-2,88544,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;i=a;return}function gG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+4>>2]|0)+(b<<2)|0;b=c[e>>2]|0;c[e>>2]=(d|0)==0?b&-3:b|2;return}function gH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+4>>2]|0)+(b<<2)|0;b=c[e>>2]|0;c[e>>2]=(d|0)==0?b&-2:b|1;return}function gI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(c[c[a+80112>>2]>>2]|0)>>>8&1;f=e+1|0;g=a+28|0;h=-1;i=c[g>>2]|0;j=0;while(1){if((i|0)==0){k=j;break}l=i-1|0;m=c[a+32+(l<<2)>>2]|0;n=c[a+40060+(l<<2)>>2]|0;if((n-1|0)>>>0>b>>>0){h=n;i=l;j=m}else{k=m;break}}i=~b;if((k-j|0)>>>0>(h+i|0)>>>0){o=j+i+h|0}else{o=k}k=c[a+80120>>2]|0;c[d>>2]=k;do{if((c[g>>2]|0)==0){p=k}else{h=c[a+40060>>2]|0;if(h>>>0<=b>>>0){p=k;break}i=k+b-h|0;c[d>>2]=i;p=i}}while(0);if(o>>>0<f>>>0){return}c[d>>2]=p-(e|2);return}function gJ(a){a=a|0;var b=0;b=a+80128|0;c[b>>2]=c[b>>2]&-33;return}function gK(a,b){a=a|0;b=b|0;if((a|0)==0){return}b=a+80128|0;c[b>>2]=c[b>>2]|4;return}function gL(a){a=a|0;var b=0;b=a+80128|0;c[b>>2]=c[b>>2]&-5;b=c[a+80136>>2]|0;if((b|0)==0){return}dd[b&63]();return}function gM(a,b){a=a|0;b=b|0;var d=0;d=a+80128|0;c[d>>2]=c[d>>2]&-9;c5[c[a+80104>>2]&255](b,c[a+80108>>2]|0);return}function gN(a){a=a|0;var b=0;b=a+80128|0;c[b>>2]=c[b>>2]|16;return}function gO(a,b){a=a|0;b=b|0;return bp(a|0,b&7|0)|0}function gP(a,b){a=a|0;b=b|0;return bz(a|0,b|0)|0}function gQ(){return 4096}function gR(a){a=a|0;return cU(a|0)|0}function gS(a,b){a=a|0;b=b|0;return cn(a|0,b|0)|0}function gT(){var a=0,b=0,d=0,e=0,f=0,g=0;a=hg(c[13866]|0)|0;if((bz(a|0,c[13866]|0)|0)!=0){b=a;return b|0}d=cd()|0;e=a;while(1){if((c[d>>2]|0)!=34){b=0;f=2424;break}a=c[13866]<<1;c[13866]=a;g=hi(e,a)|0;if((bz(g|0,c[13866]|0)|0)==0){e=g}else{b=g;f=2423;break}}if((f|0)==2424){return b|0}else if((f|0)==2423){return b|0}return 0}function gU(){hj(c[200740]|0);return}function gV(){var b=0,d=0,e=0;if((c[121470]|0)==0|a[55456]^1){return}if((c[198580]|0)>>>0<(c[200728]|0)>>>0){return}if((l_(c[121468]&65535)|0)<<24>>24!=0){return}b=c[121470]|0;d=c[215608]|0;e=(b|0)>(d|0)?d:b;if((e|0)!=0){b=0;d=c[200812]|0;do{lZ((c[215610]|0)+b&65535,a[461136+d|0]|0);d=((c[200812]|0)+1|0)%16384|0;c[200812]=d;b=b+1|0;}while(b>>>0<e>>>0)}lZ(c[121468]&65535,e&255);c[121470]=(c[121470]|0)-e;return}function gW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;A$(802680,b|0,64)|0;b=0;do{a=802680+(b<<2)|0;d=1<<b;e=~d;f=0;g=c[a>>2]|0;while(1){h=1<<f;do{if((f|b|0)<0){i=g}else{if((g&h|0)==0){j=g&~h;c[a>>2]=j;k=802648+(f<<2)|0;c[k>>2]=c[k>>2]&e;i=j;break}else{j=g|h;c[a>>2]=j;k=802648+(f<<2)|0;c[k>>2]=c[k>>2]|d;i=j;break}}}while(0);h=f+1|0;if((h|0)<8){f=h;g=i}else{break}}b=b+1|0;}while((b|0)<16);if((hL()|0)==0){A$(802832,802680,64)|0;A$(460976,802648,32)|0}else{A$(802832,486736,64)|0;A$(460976,486704,32)|0}b=c[200704]|0;if((b|0)==0){return}c4[b&511](802832);return}function gX(a,b){a=a|0;b=b|0;kO(c[b>>2]|0);return}function gY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=c[200700]|0;L2852:do{if((f|0)>0){g=c[200698]|0;h=0;while(1){if((c[g+(h*20|0)>>2]|0)==(a|0)){if((c[g+(h*20|0)+12>>2]&288|0)==0){break}}i=h+1|0;if((i|0)<(f|0)){h=i}else{j=i;k=f;break L2852}}c[g+(h*20|0)+4>>2]=b;c[(c[200698]|0)+(h*20|0)+8>>2]=d;c[(c[200698]|0)+(h*20|0)+12>>2]=e;j=h;k=c[200700]|0}else{j=0;k=f}}while(0);if((j|0)<(k|0)){return}j=c[200702]|0;if((k|0)<(j|0)){l=k;m=j}else{k=((j|0)/2|0)+j|0;c[200702]=k;c[200698]=hi(c[200698]|0,(k*20|0)+20|0)|0;l=c[200700]|0;m=c[200702]|0}if((l|0)>=(m|0)){return}c[(c[200698]|0)+(l*20|0)>>2]=a;c[(c[200698]|0)+((c[200700]|0)*20|0)+4>>2]=b;c[(c[200698]|0)+((c[200700]|0)*20|0)+8>>2]=d;c[(c[200698]|0)+((c[200700]|0)*20|0)+12>>2]=e;e=(c[200700]|0)+1|0;c[200700]=e;c[(c[200698]|0)+(e*20|0)>>2]=0;return}function gZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d|0;if((id(c[54320+(b<<2)>>2]|0,e)|0)<0){f=-1;i=d;return f|0}if(!(a[54384]|0)){c[198594]=b;f=0;i=d;return f|0}g=c[e>>2]|0;do{if((g|0)==0){h=0}else{j=c[200698]|0;if((j|0)!=0){hj(j);c[200698]=0}j=hg(3e3)|0;c[200698]=j;c[200700]=0;c[200702]=149;c[j>>2]=0;if((g3(g)|0)<=-1){h=c[e>>2]|0;break}c[198594]=b;f=0;i=d;return f|0}}while(0);hv(c[13854]|0,86456,(b=i,i=i+8|0,c[b>>2]=(h|0)!=0?h:86144,b)|0)|0;i=b;f=-1;i=d;return f|0}function g_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d|0;f=b;do{if((f|0)<(kT()|0)){if((ic(85888,e)|0)<0){g=-1;break}if((i1(794384+(f<<2)|0,a)|0)!=0){g=0;break}if((c[e>>2]|0)!=(f|0)){g=0;break}h8(85888,f)|0;g=0}else{g=-1}}while(0);i=d;return g|0}function g$(){c[13854]=hq(85600)|0;c[200706]=fU(c[198582]|0,85600,84,0)|0;c[115252]=fU(c[198582]|0,85176,48,0)|0;fN();a[54384]=1;gZ(c[198594]|0,0)|0;return}function g0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;fV(c[200706]|0);b=c[(c[200706]|0)+4>>2]|0;a=b+2064|0;d=c[a>>2]|0;e=c[b+2056>>2]|0;if((e|0)==0){f=d;g=-1}else{h=d;d=0;i=-1;while(1){j=c[b+8+(d<<3)+4>>2]|0;k=j>>>0>i>>>0;l=k?h:d;m=k?i:j;j=d+1|0;if(j>>>0<e>>>0){h=l;d=j;i=m}else{f=l;g=m;break}}}c[b+2060>>2]=g;c[a>>2]=f;if((hL()|0)==0){A$(802832,802680,64)|0;A$(460976,802648,32)|0}else{A$(802832,486736,64)|0;A$(460976,486704,32)|0}f=c[200704]|0;if((f|0)==0){gc(1,802832,64);return}c4[f&511](802832);gc(1,802832,64);return}function g1(b,d){b=b|0;d=d|0;var e=0,f=0.0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;b=d|0;fV(c[115252]|0);e=a[48408]&1;c[b>>2]=e;kO(e);gc(2,b,4);a[48408]=0;if(!(a[48400]|0)){i=d;return}a[48400]=0;b=c[115252]|0;e=c[198580]|0;f=+(kQ()|0);g=e+1+~~(f*+(bO()|0)*4.656612873077393e-10)|0;e=c[b+4>>2]|0;h=b+12|0;j=c[h>>2]|0;if((j|0)<0){k=e+2056|0;l=c[k>>2]|0;if(l>>>0>255>>>0){fW();i=d;return}c[e+8+(l<<3)>>2]=b;c[e+8+(l<<3)+4>>2]=g;c[k>>2]=(c[k>>2]|0)+1;k=e+2060|0;if((c[k>>2]|0)>>>0>g>>>0){c[k>>2]=g;c[e+2064>>2]=l}c[h>>2]=l;i=d;return}else{c[e+8+(j<<3)+4>>2]=g;l=e+2060|0;h=e+2064|0;k=c[h>>2]|0;do{if((c[l>>2]|0)>>>0>g>>>0){m=k}else{if((j|0)==(k|0)){m=j;break}i=d;return}}while(0);j=c[e+2056>>2]|0;if((j|0)==0){n=m;o=-1}else{k=m;m=0;g=-1;while(1){b=c[e+8+(m<<3)+4>>2]|0;p=b>>>0>g>>>0;q=p?k:m;r=p?g:b;b=m+1|0;if(b>>>0<j>>>0){k=q;m=b;g=r}else{n=q;o=r;break}}}c[l>>2]=o;c[h>>2]=n;i=d;return}}function g2(){hj(c[200698]|0);c[200698]=0;return}function g3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+1008|0;e=d|0;f=d+8|0;g=iU(b,e,84640)|0;if((g|0)==0){h=-1;i=d;return h|0}hs(c[13854]|0,84520,(b=i,i=i+8|0,c[b>>2]=c[e>>2],b)|0)|0;i=b;j=f|0;k=f+1|0;L2940:do{a[j]=0;do{if((bk(j|0,999,g|0)|0)!=0){if((a[j]|0)==0){break L2940}a[f+((A1(j|0)|0)-1)|0]=0;l=cL(j|0,35)|0;if((l|0)!=0){a[l]=0}l=a[j]|0;if((l|0)==0){break}else if((l|0)!=33){l=aT(j|0,84376)|0;m=fO(l)|0;if((m|0)<0){n=c[13854]|0;hv(n,84120,(b=i,i=i+8|0,c[b>>2]=l,b)|0)|0;i=b;break}n=aT(0,83888)|0;if((n|0)==0){break}o=aR(n|0,0,10)|0;n=aT(0,83888)|0;if((n|0)==0){break}p=b7(n|0)|0;n=aT(0,83760)|0;q=(n|0)!=0;if(!(q|(o|0)<0)){break}if(q){r=b7(n|0)|0}else{r=0}if((o|0)>-1){gY(m,o,p,r);break}n=(o|0)==-3;q=(p|0)==0;if(n&q){c[13858]=m;break}s=(p|0)==1;if(n&s){c[13856]=m;break}n=(o|0)==-4;if(n&q){c[13860]=m;break}if(n&s){c[13862]=m;break}else{m=c[13854]|0;hv(m,83536,(b=i,i=i+24|0,c[b>>2]=o,c[b+8>>2]=p,c[b+16>>2]=l,b)|0)|0;i=b;break}}l=aT(k|0,84376)|0;L2975:do{if((a9(l|0,78712)|0)==0){p=aT(0,83888)|0;if((p|0)==0){break}c[200736]=b7(p|0)|0;p=aT(0,83888)|0;if((p|0)==0){break}c[200738]=b7(p|0)|0}else{if((a9(l|0,79472)|0)==0){p=aT(0,83888)|0;if((p|0)==0){break}c[200732]=b7(p|0)|0;p=aT(0,83888)|0;if((p|0)==0){break}c[200734]=b7(p|0)|0;break}if((a9(l|0,83368)|0)==0){p=aT(0,82440)|0;if((a9(p|0,79472)|0)==0){t=1}else{o=(a9(p|0,78712)|0)==0;t=o?2:0}c[80476]=t;break}if((a9(l|0,83016)|0)==0){o=aT(0,82440)|0;if((a9(o|0,79472)|0)==0){u=1}else{p=(a9(o|0,78712)|0)==0;u=p?2:0}c[114038]=u;break}if((a9(l|0,82880)|0)==0){c[200700]=0;c[c[200698]>>2]=0;c[13858]=-1;c[13856]=-1;c[13862]=-1;c[13860]=-1;c[80476]=0;c[114038]=0;break}if((a9(l|0,82760)|0)==0){p=aT(0,83760)|0;g3(p)|0;break}if((a9(l|0,82552)|0)!=0){break}p=fO(aT(0,83760)|0)|0;if((p|0)<=-1){break}o=c[200700]|0;if((o|0)<=0){break}m=c[200698]|0;s=0;while(1){v=m+(s*20|0)|0;s=s+1|0;if((c[v>>2]|0)==(p|0)){break}if((s|0)>=(o|0)){break L2975}}if((o|0)==0){w=0}else{s=o-1|0;c[200700]=s;p=v;n=m+(s*20|0)|0;c[p>>2]=c[n>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];c[p+16>>2]=c[n+16>>2];w=s}c[m+(w*20|0)>>2]=0}}while(0);g5()}}while(0);}while((cy(g|0)|0)==0);aM(g|0)|0;hj(c[e>>2]|0);h=0;i=d;return h|0}function g4(b,d){b=b|0;d=d|0;a[802744]=a[d]|0;a[802745]=a[d+1|0]|0;a[802746]=a[d+2|0]|0;a[802747]=a[d+3|0]|0;a[802748]=a[d+4|0]|0;do{if((hL()|0)==0){a[802968]=a[802744]|0;a[802969]=a[802745]|0;a[802970]=a[802746]|0;a[802971]=a[802747]|0;a[802972]=a[802748]|0}else{d=a[486800]|0;b=d&255;if(d<<24>>24==0){a[802968]=a[486800]|0;a[802969]=a[486801]|0;a[802970]=a[486802]|0;a[802971]=a[486803]|0;a[802972]=a[486804]|0;break}else{a[802968+b|0]=a[486800+b|0]|0;break}}}while(0);b=c[200746]|0;if((b|0)==0){fL(802968);return}dd[b&63]();fL(802968);return}function g5(){A2(803e3|0,0|0,108|0);return}function g6(){h1(49912)|0;if((c[13586]|0)!=7){h1(47080)|0}return e9()|0}function g7(){c[200748]=fU(c[198582]|0,83656,182,0)|0;fP(803120);return fa()|0}function g8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;fV(c[200748]|0);d=c[(c[200748]|0)+4>>2]|0;b=d+2064|0;e=c[b>>2]|0;f=c[d+2056>>2]|0;if((f|0)==0){g=e;h=-1}else{i=e;e=0;j=-1;while(1){k=c[d+8+(e<<3)+4>>2]|0;l=k>>>0>j>>>0;m=l?i:e;n=l?j:k;k=e+1|0;if(k>>>0<f>>>0){i=m;e=k;j=n}else{g=m;h=n;break}}}c[d+2060>>2]=h;c[b>>2]=g;do{if((hL()|0)==0){a[802968]=a[802744]|0;a[802969]=a[802745]|0;a[802970]=a[802746]|0;a[802971]=a[802747]|0;a[802972]=a[802748]|0}else{g=a[486800]|0;b=g&255;if(g<<24>>24==0){a[802968]=a[486800]|0;a[802969]=a[486801]|0;a[802970]=a[486802]|0;a[802971]=a[486803]|0;a[802972]=a[486804]|0;break}else{a[802968+b|0]=a[486800+b|0]|0;break}}}while(0);b=c[200746]|0;if((b|0)==0){fL(802968);gc(3,802968,5);return}dd[b&63]();fL(802968);gc(3,802968,5);return}function g9(a,b){a=a|0;b=b|0;c[80932]=a;return 0}function ha(a,b){a=a|0;b=b|0;var d=0;if((a|0)>6){d=-1}else{c[80930]=a;d=0}return d|0}function hb(a,b){a=a|0;b=b|0;c[803156+(b<<2)>>2]=a;return 0}function hc(a,b){a=a|0;b=b|0;c[803192+(b<<2)>>2]=a;return 0}function hd(a,b){a=a|0;b=b|0;c[200778]=a;return 0}function he(a,b){a=a|0;b=b|0;c[200744]=a;return 0}function hf(){return}function hg(a){a=a|0;var b=0;b=AL(a)|0;if(!((b|0)!=0|(a|0)==0)){br(-1|0);return 0}if((b|0)==0){return b|0}A2(b|0,0,a|0);return b|0}function hh(a,b){a=a|0;b=b|0;var c=0;c=AN(a,b)|0;if((c|0)!=0|(ag(b,a)|0)==0){return c|0}else{br(-1|0);return 0}return 0}function hi(a,b){a=a|0;b=b|0;var c=0;c=AO(a,b)|0;if((c|0)==0){br(-1|0);return 0}else{return c|0}return 0}function hj(a){a=a|0;AM(a);return}function hk(a){a=a|0;var b=0,c=0;if((a|0)==0){br(-1|0);return 0}b=(A1(a|0)|0)+1|0;c=AL(b)|0;if(!((c|0)!=0|(b|0)==0)){br(-1|0);return 0}if((c|0)==0){A$(c|0,a|0,b)|0;return c|0}A2(c|0,0,b|0);A$(c|0,a|0,b)|0;return c|0}function hl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=e+16|0;j=AL(10)|0;if((j|0)==0){br(-1|0);return 0}A2(j|0,0,10);c[f>>2]=j;c[g>>2]=0;c[h>>2]=10;if((b|0)==0){a[j]=0;k=j;i=e;return k|0}else{l=b}L3096:while(1){b=a[l]|0;L3098:do{if((b<<24>>24|0)==37){j=0;m=l;L3105:while(1){n=m+1|0;o=a[n]|0;switch(o<<24>>24|0){case 43:{j=j|4;m=n;continue L3105;break};case 32:{j=j|8;m=n;continue L3105;break};case 45:{j=j|16;m=n;continue L3105;break};case 48:{j=j|1;m=n;continue L3105;break};case 35:{j=j|32;m=n;continue L3105;break};default:{break L3105}}}do{if((o-48&255)>>>0<10>>>0){p=0;q=n;r=o;while(1){s=q+1|0;t=(p*10|0)-48+(r<<24>>24)|0;u=a[s]|0;if((u-48&255)>>>0<10>>>0){p=t;q=s;r=u}else{v=t;w=j;x=s;break}}}else{if(o<<24>>24!=42){v=-1;w=j;x=n;break}r=m+2|0;q=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0);if((q|0)>=0){v=q;w=j;x=r;break}v=-q|0;w=j|16;x=r}}while(0);j=a[x]|0;if(j<<24>>24==46){m=x+1|0;r=a[m]|0;do{if((r-48&255)>>>0<10>>>0){q=0;p=m;s=r;while(1){t=p+1|0;u=(q*10|0)-48+(s<<24>>24)|0;y=a[t]|0;if((y-48&255)>>>0<10>>>0){q=u;p=t;s=y}else{z=u;A=t;C=y;break}}}else{if(r<<24>>24!=42){z=-1;A=m;C=r;break}s=x+2|0;z=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0);A=s;C=a[s]|0}}while(0);D=(z|0)<0?0:z;E=A;F=C}else{D=-1;E=x;F=j}if((F<<24>>24|0)==104|(F<<24>>24|0)==108|(F<<24>>24|0)==76){r=E+1|0;G=F<<24>>24;H=r;I=a[r]|0}else{G=-1;H=E;I=F}switch(I<<24>>24|0){case 115:{r=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0);m=(r|0)!=0?r:82808;L3135:do{if((D|0)==0){J=m}else{r=m;s=D;while(1){p=s-1|0;q=r+1|0;if((a[r]|0)==0){J=r;break L3135}if((p|0)==0){J=q;break}else{r=q;s=p}}}}while(0);j=J-m|0;L3140:do{if((w&16|0)==0&(v|0)>0){s=v;while(1){r=s-1|0;if(j>>>0>=s>>>0){K=r;break L3140}p=c[g>>2]|0;if((p|0)==(c[h>>2]|0)){q=p<<1;c[h>>2]=q;y=AO(c[f>>2]|0,q)|0;if((y|0)==0){L=2700;break L3096}c[f>>2]=y;M=c[g>>2]|0;N=y}else{M=p;N=c[f>>2]|0}a[N+M|0]=32;c[g>>2]=(c[g>>2]|0)+1;if((r|0)>0){s=r}else{K=r;break}}}else{K=v}}while(0);L3150:do{if((J|0)!=(m|0)){s=1;r=m;p=c[g>>2]|0;while(1){y=r+1|0;q=a[r]|0;if((p|0)==(c[h>>2]|0)){t=p<<1;c[h>>2]=t;u=AO(c[f>>2]|0,t)|0;if((u|0)==0){L=2708;break L3096}c[f>>2]=u;O=c[g>>2]|0;P=u}else{O=p;P=c[f>>2]|0}a[P+O|0]=q;q=(c[g>>2]|0)+1|0;c[g>>2]=q;if(s>>>0>=j>>>0){break L3150}s=s+1|0;r=y;p=q}}}while(0);if(!((K|0)>0&j>>>0<K>>>0)){Q=H;break L3098}m=K;p=c[g>>2]|0;while(1){r=m-1|0;if((p|0)==(c[h>>2]|0)){s=p<<1;c[h>>2]=s;q=AO(c[f>>2]|0,s)|0;if((q|0)==0){L=2717;break L3096}c[f>>2]=q;R=c[g>>2]|0;S=q}else{R=p;S=c[f>>2]|0}a[S+R|0]=32;q=(c[g>>2]|0)+1|0;c[g>>2]=q;if((r|0)>0&j>>>0<r>>>0){m=r;p=q}else{Q=H;break L3098}}break};case 111:{T=w;U=8;break};case 88:{V=w|64;L=2729;break};case 120:{V=w;L=2729;break};case 100:case 105:{T=w|2;U=10;break};case 37:{p=c[g>>2]|0;if((p|0)==(c[h>>2]|0)){m=p<<1;c[h>>2]=m;j=AO(c[f>>2]|0,m)|0;if((j|0)==0){L=2724;break L3096}c[f>>2]=j;W=c[g>>2]|0;X=j}else{W=p;X=c[f>>2]|0}a[X+W|0]=37;c[g>>2]=(c[g>>2]|0)+1;Q=H;break L3098;break};case 112:{p=(v|0)==-1;hm(f,h,g,(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0),16,p?8:v,D,p&1|w);Q=H;break L3098;break};case 99:{do{if((w&16|0)==0){p=v-1|0;if((p|0)<=0){Y=p;break}j=p;p=c[g>>2]|0;while(1){if((p|0)==(c[h>>2]|0)){m=p<<1;c[h>>2]=m;q=AO(c[f>>2]|0,m)|0;if((q|0)==0){L=2677;break L3096}c[f>>2]=q;Z=c[g>>2]|0;_=q}else{Z=p;_=c[f>>2]|0}a[_+Z|0]=32;q=(c[g>>2]|0)+1|0;c[g>>2]=q;m=j-1|0;if((m|0)>0){j=m;p=q}else{Y=m;break}}}else{Y=v}}while(0);p=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0)&255;j=c[g>>2]|0;if((j|0)==(c[h>>2]|0)){m=j<<1;c[h>>2]=m;q=AO(c[f>>2]|0,m)|0;if((q|0)==0){L=2683;break L3096}c[f>>2]=q;$=c[g>>2]|0;aa=q}else{$=j;aa=c[f>>2]|0}a[aa+$|0]=p;p=(c[g>>2]|0)+1|0;c[g>>2]=p;j=Y-1|0;if((j|0)>0){ab=j;ac=p}else{Q=H;break L3098}while(1){if((ac|0)==(c[h>>2]|0)){p=ac<<1;c[h>>2]=p;j=AO(c[f>>2]|0,p)|0;if((j|0)==0){L=2689;break L3096}c[f>>2]=j;ad=c[g>>2]|0;ae=j}else{ad=ac;ae=c[f>>2]|0}a[ae+ad|0]=32;j=(c[g>>2]|0)+1|0;c[g>>2]=j;p=ab-1|0;if((p|0)>0){ab=p;ac=j}else{Q=H;break L3098}}break};case 117:{T=w;U=10;break};default:{j=c[g>>2]|0;if((j|0)==(c[h>>2]|0)){p=j<<1;c[h>>2]=p;q=AO(c[f>>2]|0,p)|0;if((q|0)==0){L=2734;break L3096}c[f>>2]=q;af=c[g>>2]|0;ag=q}else{af=j;ag=c[f>>2]|0}a[ag+af|0]=37;j=(c[g>>2]|0)+1|0;c[g>>2]=j;q=a[H]|0;if(q<<24>>24==0){Q=H-1|0;break L3098}if((j|0)==(c[h>>2]|0)){p=j<<1;c[h>>2]=p;m=AO(c[f>>2]|0,p)|0;if((m|0)==0){L=2740;break L3096}c[f>>2]=m;ah=c[g>>2]|0;ai=m}else{ah=j;ai=c[f>>2]|0}a[ai+ah|0]=q;c[g>>2]=(c[g>>2]|0)+1;Q=H;break L3098}}if((L|0)==2729){L=0;T=V;U=16}do{if((G|0)==108){aj=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0)}else{q=(B=c[d+4>>2]|0,c[d+4>>2]=B+8,c[(c[d>>2]|0)+B>>2]|0);if((G|0)!=104){aj=q;break}if((T&2|0)==0){aj=q&65535;break}aj=q<<16>>16}}while(0);hm(f,h,g,aj,U,v,D,T);Q=H}else if((b<<24>>24|0)==0){L=2751;break L3096}else{q=c[g>>2]|0;if((q|0)==(c[h>>2]|0)){j=q<<1;c[h>>2]=j;m=AO(c[f>>2]|0,j)|0;if((m|0)==0){L=2648;break L3096}c[f>>2]=m;ak=c[g>>2]|0;al=m}else{ak=q;al=c[f>>2]|0}a[al+ak|0]=b;c[g>>2]=(c[g>>2]|0)+1;Q=l}}while(0);l=Q+1|0}if((L|0)==2648){br(-1|0);return 0}else if((L|0)==2700){br(-1|0);return 0}else if((L|0)==2683){br(-1|0);return 0}else if((L|0)==2724){br(-1|0);return 0}else if((L|0)==2734){br(-1|0);return 0}else if((L|0)==2717){br(-1|0);return 0}else if((L|0)==2708){br(-1|0);return 0}else if((L|0)==2689){br(-1|0);return 0}else if((L|0)==2751){Q=c[g>>2]|0;do{if((Q|0)==(c[h>>2]|0)){l=Q<<1;c[h>>2]=l;ak=AO(c[f>>2]|0,l)|0;if((ak|0)==0){br(-1|0);return 0}else{c[f>>2]=ak;am=c[g>>2]|0;an=ak;break}}else{am=Q;an=c[f>>2]|0}}while(0);a[an+am|0]=0;c[g>>2]=(c[g>>2]|0)+1;g=c[f>>2]|0;am=AO(g,(A1(g|0)|0)+1|0)|0;if((am|0)==0){br(-1|0);return 0}c[f>>2]=am;k=am;i=e;return k|0}else if((L|0)==2677){br(-1|0);return 0}else if((L|0)==2740){br(-1|0);return 0}return 0}function hm(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;l=i;i=i+72|0;m=l|0;n=(k&64|0)!=0?84776:88040;o=(k&16|0)==0?k:k&-2;if((g-2|0)>>>0>34>>>0){i=l;return}k=(o<<4&16|32)&255;do{if((o&2|0)==0){p=0;q=h;r=f}else{if((f|0)<0){p=45;q=h-1|0;r=-f|0;break}if((o&4|0)==0){s=(o&8|0)==0;p=s?0:32;q=((s^1)<<31>>31)+h|0;r=f;break}else{p=43;q=h-1|0;r=f;break}}}while(0);f=(o&32|0)!=0;do{if(f){if((g|0)==16){t=q-2|0;break}else if((g|0)==8){t=q-1|0;break}else{t=q;break}}else{t=q}}while(0);if((r|0)==0){a[m|0]=48;u=1}else{q=r;r=0;while(1){h=(q>>>0)/(g>>>0)|0;s=r+1|0;a[m+r|0]=a[n+((q>>>0)%(g>>>0)|0)|0]|0;if((h|0)==0){u=s;break}else{q=h;r=s}}}r=(u|0)>(j|0)?u:j;j=t-r|0;L3274:do{if((o&17|0)==0){t=j-1|0;if((j|0)<=0){v=t;break}q=t;t=c[e>>2]|0;while(1){if((t|0)==(c[d>>2]|0)){s=t<<1;c[d>>2]=s;h=AO(c[b>>2]|0,s)|0;if((h|0)==0){break}c[b>>2]=h;w=c[e>>2]|0;x=h}else{w=t;x=c[b>>2]|0}a[x+w|0]=32;h=(c[e>>2]|0)+1|0;c[e>>2]=h;s=q-1|0;if((q|0)>0){q=s;t=h}else{v=s;break L3274}}br(-1|0)}else{v=j}}while(0);if(p<<24>>24!=0){j=c[e>>2]|0;do{if((j|0)==(c[d>>2]|0)){w=j<<1;c[d>>2]=w;x=AO(c[b>>2]|0,w)|0;if((x|0)==0){br(-1|0)}else{c[b>>2]=x;y=c[e>>2]|0;z=x;break}}else{y=j;z=c[b>>2]|0}}while(0);a[z+y|0]=p;c[e>>2]=(c[e>>2]|0)+1}do{if(f){if((g|0)==8){p=c[e>>2]|0;do{if((p|0)==(c[d>>2]|0)){y=p<<1;c[d>>2]=y;z=AO(c[b>>2]|0,y)|0;if((z|0)==0){br(-1|0)}else{c[b>>2]=z;A=c[e>>2]|0;B=z;break}}else{A=p;B=c[b>>2]|0}}while(0);a[B+A|0]=48;c[e>>2]=(c[e>>2]|0)+1;break}else if((g|0)!=16){break}p=c[e>>2]|0;do{if((p|0)==(c[d>>2]|0)){z=p<<1;c[d>>2]=z;y=AO(c[b>>2]|0,z)|0;if((y|0)==0){br(-1|0)}else{c[b>>2]=y;C=c[e>>2]|0;D=y;break}}else{C=p;D=c[b>>2]|0}}while(0);a[D+C|0]=48;p=(c[e>>2]|0)+1|0;c[e>>2]=p;y=a[n+33|0]|0;do{if((p|0)==(c[d>>2]|0)){z=p<<1;c[d>>2]=z;j=AO(c[b>>2]|0,z)|0;if((j|0)==0){br(-1|0)}else{c[b>>2]=j;E=c[e>>2]|0;F=j;break}}else{E=p;F=c[b>>2]|0}}while(0);a[F+E|0]=y;c[e>>2]=(c[e>>2]|0)+1}}while(0);L3323:do{if((o&16|0)==0){E=v-1|0;if((v|0)<=0){G=E;break}F=E;E=c[e>>2]|0;while(1){if((E|0)==(c[d>>2]|0)){n=E<<1;c[d>>2]=n;C=AO(c[b>>2]|0,n)|0;if((C|0)==0){break}c[b>>2]=C;H=c[e>>2]|0;I=C}else{H=E;I=c[b>>2]|0}a[I+H|0]=k;C=(c[e>>2]|0)+1|0;c[e>>2]=C;n=F-1|0;if((F|0)>0){F=n;E=C}else{G=n;break L3323}}br(-1|0)}else{G=v}}while(0);L3335:do{if((u|0)<(r|0)){v=r;k=c[e>>2]|0;while(1){v=v-1|0;if((k|0)==(c[d>>2]|0)){H=k<<1;c[d>>2]=H;I=AO(c[b>>2]|0,H)|0;if((I|0)==0){break}c[b>>2]=I;J=c[e>>2]|0;K=I}else{J=k;K=c[b>>2]|0}a[K+J|0]=48;k=(c[e>>2]|0)+1|0;c[e>>2]=k;if((u|0)>=(v|0)){break L3335}}br(-1|0)}}while(0);L3346:do{if((u|0)>0){J=u;K=c[e>>2]|0;while(1){J=J-1|0;r=a[m+J|0]|0;if((K|0)==(c[d>>2]|0)){v=K<<1;c[d>>2]=v;k=AO(c[b>>2]|0,v)|0;if((k|0)==0){break}c[b>>2]=k;L=c[e>>2]|0;M=k}else{L=K;M=c[b>>2]|0}a[M+L|0]=r;K=(c[e>>2]|0)+1|0;c[e>>2]=K;if((J|0)<=0){break L3346}}br(-1|0)}}while(0);if((G|0)<=0){i=l;return}L=G;G=c[e>>2]|0;while(1){M=L-1|0;if((G|0)==(c[d>>2]|0)){m=G<<1;c[d>>2]=m;u=AO(c[b>>2]|0,m)|0;if((u|0)==0){N=2841;break}c[b>>2]=u;O=c[e>>2]|0;P=u}else{O=G;P=c[b>>2]|0}a[P+O|0]=32;u=(c[e>>2]|0)+1|0;c[e>>2]=u;if((M|0)>0){L=M;G=u}else{N=2845;break}}if((N|0)==2845){i=l;return}else if((N|0)==2841){br(-1|0)}}function hn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d|0;f=e;c[f>>2]=b;c[f+4>>2]=0;f=hl(a,e|0)|0;i=d;return f|0}function ho(){return h2(48728)|0}function hp(){hj(c[200658]|0);return}function hq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=c[121474]|0;L3374:do{if((b|0)>0){d=c[200656]|0;e=0;while(1){f=e+1|0;if((c[d+(e<<2)>>2]|0)==0){g=e;h=e;break L3374}if((f|0)<(b|0)){e=f}else{g=0;h=f;break}}}else{g=0;h=0}}while(0);if((h|0)==(b|0)){h=b+1|0;c[121474]=h;c[200656]=hi(c[200656]|0,h<<2)|0;i=b}else{i=g}g=hk(a)|0;c[(c[200656]|0)+(i<<2)>>2]=g;return i|0}function hr(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a=c[121474]|0;b=c[200656]|0;if((a|0)>0){d=0;e=b;f=a}else{g=b;h=g;hj(h);return}while(1){b=c[e+(d<<2)>>2]|0;if((b|0)==0){i=f;j=e}else{hj(b);c[(c[200656]|0)+(d<<2)>>2]=0;i=c[121474]|0;j=c[200656]|0}b=d+1|0;if((b|0)<(i|0)){d=b;e=j;f=i}else{g=j;break}}h=g;hj(h);return}function hs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e|0;g=f;c[g>>2]=d;c[g+4>>2]=0;g=ht(a,0,b,f|0)|0;i=e;return g|0}function ht(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;if((c[13592]|0)==0){h=0;i=g;return h|0}do{if(b>>>0<4294967294>>>0){j=c[200656]|0;if((j|0)==0){h=-1;i=g;return h|0}k=c[j+(b<<2)>>2]|0;if((k|0)==0){h=-1;i=g;return h|0}if((a[k]|0)==0){l=2872;break}j=c[54352+(d<<2)>>2]|0;m=hn(81448,(n=i,i=i+16|0,c[n>>2]=k,c[n+8>>2]=j,n)|0)|0;i=n;o=m}else{l=2872}}while(0);if((l|0)==2872){l=hn(80360,(n=i,i=i+8|0,c[n>>2]=c[54352+(d<<2)>>2],n)|0)|0;i=n;o=l}l=c[200660]|0;L3409:do{if((l|0)==0){n=hl(e,f)|0;d=(A1(n|0)|0)+1|0;b=n+d|0;L3411:do{if((d|0)>0){m=n;while(1){j=cL(m|0,10)|0;k=(j|0)!=0;if(k){a[j]=0}p=eX((a[m]|0)!=0?o:871040,m)|0;q=j+1|0;if((p|0)<0|k^1){break}if(q>>>0<b>>>0){m=q}else{r=0;break L3411}}r=p>>31}else{r=0}}while(0);hj(n);s=r}else{do{if((aW(o|0,l|0)|0)!=-1){if((b8(c[200660]|0,e|0,f|0)|0)<0){break}if((aS(10,c[200660]|0)|0)!=-1){s=0;break L3409}}}while(0);s=-1}}while(0);hj(o);h=s;i=g;return h|0}function hu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e|0;g=f;c[g>>2]=d;c[g+4>>2]=0;g=ht(a,1,b,f|0)|0;i=e;return g|0}function hv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e|0;g=f;c[g>>2]=d;c[g+4>>2]=0;g=ht(a,2,b,f|0)|0;i=e;return g|0}function hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d|0;f=e;c[f>>2]=b;c[f+4>>2]=0;f=ht(-2,0,a,e|0)|0;i=d;return f|0}function hx(b,d){b=b|0;d=d|0;var e=0;if(a[54376]|0){return 0}if((i1(802632,b)|0)<0){return 0}b=c[200660]|0;if((b|0)==0){return 0}aM(b|0)|0;b=c[200658]|0;do{if((b|0)!=0){if((a[b]|0)==0){break}if((a9(b|0,79376)|0)==0){e=c[q>>2]|0}else{e=bV(b|0,78624)|0}c[200660]=e;if((e|0)==0){return 0}cS(e|0,0);return 0}}while(0);c[200660]=eW()|0;return 0}function hy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e|0;if(a[55472]|0){g=0;i=e;return g|0}h=f;c[h>>2]=d;c[h+4>>2]=0;h=hl(b,f|0)|0;if((qS()|0)==0){f=fH(h,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;k=f}else{f=qT(h,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;k=f}hj(h);if((k|0)==2){g=3;i=e;return g|0}else if((k|0)==0){g=1;i=e;return g|0}else if((k|0)==1){g=2;i=e;return g|0}else{a[55472]=1;g=0;i=e;return g|0}return 0}function hz(b){b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d|0;c[e>>2]=b;if((gf()|0)!=0){i=d;return}b=e;if((hL()|0)!=0){hK(8,b,4);i=d;return}gc(8,b,4);b=c[e>>2]|0;a[55472]=0;if((b|0)==1){c[80458]=0;l8();kL()}else if((b|0)!=0){i=d;return}gK(c[198576]|0,c[198580]|0);i=d;return}function hA(b,d){b=b|0;d=d|0;b=c[d>>2]|0;a[55472]=0;if((b|0)==1){c[80458]=0;l8();kL()}else if((b|0)!=0){return}gK(c[198576]|0,c[198580]|0);return}function hB(){var a=0,b=0;a=i;hs(-2,82016,(b=i,i=i+1|0,i=i+7&-8,c[b>>2]=0,b)|0)|0;i=b;kK();qw();l5();ge();ja();i=a;return}function hC(){qA();c[198574]=hg(72)|0;return}function hD(){var a=0;c[198582]=fQ(87928)|0;a=fX(794320,-1048576)|0;c[198578]=a;fZ(a,212,0);return}function hE(a,b){a=a|0;b=b|0;fT(c[198582]|0,a,-1);gD(c[198576]|0,a,-1);return}function hF(){a[54336]=1;ko();mQ();qp();l5();return kI()|0}function hG(){var b=0;if(!(a[54336]|0)){return}qs();kM();qx();ir();mL();mK();gt();qq();mR();mM();iZ();gU();g2();qG();e8()|0;f1();h3();m_();b=c[198582]|0;if((b|0)!=0){fR(b)}b=c[198578]|0;if((b|0)!=0){f_(b)}hj(c[198574]|0);qB();q4();fB();iR();hr();gh();hN();qv();mS();mV();kG();iT();ji();fz();hp();gs();hW();e6();hf();return}function hH(){var a=0,b=0;a=0;do{b=qX(a)|0;c[b>>2]=0;c[b+76>>2]=24;c[b+80>>2]=24;c[b+84>>2]=24;c[b+88>>2]=24;c[b+92>>2]=0;c[b+96>>2]=0;a=a+1|0;}while(a>>>0<16>>>0);mX();return}function hI(){return 128}function hJ(){return 0}function hK(a,b,c){a=a|0;b=b|0;c=c|0;return}function hL(){return 0}function hM(){return}function hN(){return}function hO(){return 0}function hP(){c[13298]=hq(78600)|0;return}function hQ(){return h1(49800)|0}function hR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((d|0)==0){return}e=0;f=(c[80928]|0)-1|0;g=(c[119400]|0)-1|0;h=c[80954]&255;while(1){a[b+e|0]=h;if((e|0)==(f|0)){i=~h;j=(c[80928]|0)+f|0}else{i=h;j=f}if((e|0)==(g|0)){k=~i;l=(c[119400]|0)+g|0}else{k=i;l=g}m=e+1|0;if(m>>>0<d>>>0){e=m;f=j;g=l;h=k}else{break}}return}function hS(a,b){a=a|0;b=b|0;b=(a|0)<0?0:a;c[80954]=(b|0)>255?255:b;return 0}function hT(a,b){a=a|0;b=b|0;c[80928]=a;return 0}function hU(a,b){a=a|0;b=b|0;c[119400]=a;return 0}function hV(){var a=0;if((h2(48616)|0)<0){a=-1;return a|0}a=h1(49744)|0;return a|0}function hW(){hj(c[115240]|0);hj(c[115242]|0);hj(c[115238]|0);return}function hX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+256|0;e=d|0;f=c[121464]|0;if((f|0)<=0){g=-1;i=d;return g|0}h=c[115234]|0;j=0;while(1){if((a9(b|0,c[h>>2]|0)|0)==0){break}k=j+1|0;if((k|0)<(f|0)){h=h+8|0;j=k}else{g=-1;l=3007;break}}if((l|0)==3007){i=d;return g|0}l=c[h+4>>2]|0;if((l|0)==0){g=0;i=d;return g|0}h=e|0;e=l;while(1){l=c[e>>2]|0;j=h;while(1){f=a[l]|0;if((f<<24>>24|0)==0|(f<<24>>24|0)==61){break}a[j]=f;l=l+1|0;j=j+1|0}f=j+1|0;a[j]=0;do{if((a[l]|0)==61){b=l;k=f;L3559:while(1){m=b;while(1){n=m+1|0;o=a[n]|0;if((o<<24>>24|0)==34){m=n}else if((o<<24>>24|0)==0){break L3559}else{break}}a[k]=o;b=n;k=k+1|0}a[k]=0;b=h4(h)|0;if((b|0)==1){h9(h,f)|0;break}else if((b|0)==0){h8(h,b7(f|0)|0)|0;break}else{break}}}while(0);f=c[e+4>>2]|0;if((f|0)==0){g=0;break}else{e=f}}i=d;return g|0}function hY(){c[12094]=hq(84632)|0;kc();return}function hZ(a,b){a=a|0;b=b|0;var d=0;if(a>>>0>1>>>0){d=-1}else{c[115236]=a;d=0}return d|0}function h_(a,b){a=a|0;b=b|0;i1(460960,a)|0;return 0}function h$(a,b){a=a|0;b=b|0;if((i1(460968,a)|0)!=0){return 0}hX(c[115242]|0)|0;return 0}function h0(a,b){a=a|0;b=b|0;i1(460952,a)|0;return 0}function h1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b|0;b=c[e>>2]|0;if((b|0)==0){f=0;i=d;return f|0}g=(c[115254]|0)+((c[121466]|0)*44|0)|0;h=e;e=b;L3586:while(1){b=h+16|0;if((c[b>>2]|0)==0){j=3025;break}k=h+20|0;if((c[k>>2]|0)==0){j=3025;break}l=a[e]|0;if(l<<24>>24==0){m=0}else{n=0;o=0;p=0;q=l;while(1){l=A6(q<<24>>24|0)|0;r=o>>>0>9>>>0?0:o;s=l<<r^p;if((r+8|0)>>>0>10>>>0){t=s^l>>>((10-r|0)>>>0)}else{t=s}s=n+1|0;l=a[e+s|0]|0;if(l<<24>>24==0){m=t;break}else{n=s;o=r+1|0;p=t;q=l}}}q=c[(c[200814]|0)+((m&1023)<<2)>>2]|0;L3597:do{if((q|0)>-1){p=c[115254]|0;o=p+(q*44|0)|0;if((o|0)==0){break}else{u=o}do{if((A8(c[u>>2]|0,e|0)|0)==0){j=3035;break L3586}o=c[u+40>>2]|0;if((o|0)<=-1){break L3597}u=p+(o*44|0)|0;}while((u|0)!=0)}}while(0);q=c[121476]|0;if(q>>>0>(c[121466]|0)>>>0){v=g}else{c[121476]=q<<1;p=hi(c[115254]|0,q*88|0)|0;c[115254]=p;v=p+((c[121466]|0)*44|0)|0}c[v>>2]=hk(c[h>>2]|0)|0;c[v+4>>2]=0;c[v+8>>2]=c[h+4>>2];c[v+20>>2]=c[b>>2];c[v+12>>2]=c[h+8>>2];c[v+16>>2]=c[h+12>>2];c[v+24>>2]=c[k>>2];c[v+32>>2]=c[h+24>>2];c[v+36>>2]=0;p=c[h>>2]|0;q=a[p]|0;if(q<<24>>24==0){w=0}else{o=0;n=0;l=0;r=q;while(1){q=A6(r<<24>>24|0)|0;s=n>>>0>9>>>0?0:n;x=q<<s^l;if((s+8|0)>>>0>10>>>0){y=x^q>>>((10-s|0)>>>0)}else{y=x}x=o+1|0;q=a[p+x|0]|0;if(q<<24>>24==0){w=y;break}else{o=x;n=s+1|0;l=y;r=q}}}r=w&1023;c[v+40>>2]=c[(c[200814]|0)+(r<<2)>>2];c[(c[200814]|0)+(r<<2)>>2]=(v-(c[115254]|0)|0)/44|0;c[121466]=(c[121466]|0)+1;r=h+28|0;l=c[r>>2]|0;if((l|0)==0){f=0;j=3045;break}else{g=v+44|0;h=r;e=l}}if((j|0)==3035){e$(87536,(z=i,i=i+8|0,c[z>>2]=c[h>>2],z)|0);i=z;f=-1;i=d;return f|0}else if((j|0)==3045){i=d;return f|0}else if((j|0)==3025){e$(80784,(z=i,i=i+8|0,c[z>>2]=e,z)|0);i=z;f=-1;i=d;return f|0}return 0}function h2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b|0;b=c[e>>2]|0;if((b|0)==0){f=0;i=d;return f|0}g=(c[115254]|0)+((c[121466]|0)*44|0)|0;h=e;e=b;L3624:while(1){b=h+4|0;if((c[b>>2]|0)==0){j=3053;break}k=h+16|0;if((c[k>>2]|0)==0){j=3053;break}l=h+20|0;if((c[l>>2]|0)==0){j=3053;break}m=a[e]|0;if(m<<24>>24==0){n=0}else{o=0;p=0;q=0;r=m;while(1){m=A6(r<<24>>24|0)|0;s=p>>>0>9>>>0?0:p;t=m<<s^q;if((s+8|0)>>>0>10>>>0){u=t^m>>>((10-s|0)>>>0)}else{u=t}t=o+1|0;m=a[e+t|0]|0;if(m<<24>>24==0){n=u;break}else{o=t;p=s+1|0;q=u;r=m}}}r=c[(c[200814]|0)+((n&1023)<<2)>>2]|0;L3636:do{if((r|0)>-1){q=c[115254]|0;p=q+(r*44|0)|0;if((p|0)==0){break}else{v=p}do{if((A8(c[v>>2]|0,e|0)|0)==0){j=3063;break L3624}p=c[v+40>>2]|0;if((p|0)<=-1){break L3636}v=q+(p*44|0)|0;}while((v|0)!=0)}}while(0);r=c[121476]|0;if(r>>>0>(c[121466]|0)>>>0){w=g}else{c[121476]=r<<1;q=hi(c[115254]|0,r*88|0)|0;c[115254]=q;w=q+((c[121466]|0)*44|0)|0}c[w>>2]=hk(c[h>>2]|0)|0;c[w+4>>2]=1;c[w+8>>2]=c[b>>2];c[w+20>>2]=c[k>>2];c[w+12>>2]=c[h+8>>2];c[w+16>>2]=c[h+12>>2];c[w+28>>2]=c[l>>2];c[w+32>>2]=c[h+24>>2];c[w+36>>2]=0;q=c[h>>2]|0;r=a[q]|0;if(r<<24>>24==0){x=0}else{p=0;o=0;m=0;s=r;while(1){r=A6(s<<24>>24|0)|0;t=o>>>0>9>>>0?0:o;y=r<<t^m;if((t+8|0)>>>0>10>>>0){z=y^r>>>((10-t|0)>>>0)}else{z=y}y=p+1|0;r=a[q+y|0]|0;if(r<<24>>24==0){x=z;break}else{p=y;o=t+1|0;m=z;s=r}}}s=x&1023;c[w+40>>2]=c[(c[200814]|0)+(s<<2)>>2];c[(c[200814]|0)+(s<<2)>>2]=(w-(c[115254]|0)|0)/44|0;c[121466]=(c[121466]|0)+1;s=h+28|0;m=c[s>>2]|0;if((m|0)==0){f=0;j=3072;break}else{g=w+44|0;h=s;e=m}}if((j|0)==3072){i=d;return f|0}else if((j|0)==3063){e$(87536,(A=i,i=i+8|0,c[A>>2]=c[h>>2],A)|0);i=A;f=-1;i=d;return f|0}else if((j|0)==3053){e$(80784,(A=i,i=i+8|0,c[A>>2]=e,A)|0);i=A;f=-1;i=d;return f|0}return 0}function h3(){var a=0;if((c[121466]|0)!=0){a=0;do{hj(c[(c[115254]|0)+(a*44|0)>>2]|0);a=a+1|0;}while(a>>>0<(c[121466]|0)>>>0)}hj(c[115254]|0);hj(c[200814]|0);hj(c[198600]|0);hj(c[80922]|0);return}function h4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((b|0)==0){d=-1;return d|0}e=a[b]|0;if(e<<24>>24==0){f=0}else{g=0;h=0;i=0;j=e;while(1){e=A6(j<<24>>24|0)|0;k=h>>>0>9>>>0?0:h;l=e<<k^i;if((k+8|0)>>>0>10>>>0){m=l^e>>>((10-k|0)>>>0)}else{m=l}l=g+1|0;e=a[b+l|0]|0;if(e<<24>>24==0){f=m;break}else{g=l;h=k+1|0;i=m;j=e}}}j=c[(c[200814]|0)+((f&1023)<<2)>>2]|0;if((j|0)<=-1){d=-1;return d|0}f=c[115254]|0;m=f+(j*44|0)|0;if((m|0)==0){d=-1;return d|0}else{n=m}while(1){if((A8(c[n>>2]|0,b|0)|0)==0){o=3089;break}m=c[n+40>>2]|0;if((m|0)<=-1){d=-1;o=3095;break}j=f+(m*44|0)|0;if((j|0)==0){d=-1;o=3093;break}else{n=j}}if((o|0)==3095){return d|0}else if((o|0)==3093){return d|0}else if((o|0)==3089){d=c[n+4>>2]|0;return d|0}return 0}function h5(a){a=a|0;var b=0,d=0;c[198600]=hk(a)|0;c[121476]=100;c[121466]=0;c[115254]=hg(4400)|0;a=hg(4096)|0;c[200814]=a;b=0;d=a;while(1){c[d+(b<<2)>>2]=-1;a=b+1|0;if(a>>>0>=1024>>>0){break}b=a;d=c[200814]|0}return 0}function h6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;L3695:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){q=p|0;if((A8(c[q>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3695}l=k+(j*44|0)|0;if((l|0)==0){break L3695}else{p=l}}k=p+12|0;l=c[k>>2]|0;do{if((l|0)==2){if((hO()|0)==0){r=c[k>>2]|0;break}else{s=-2;i=e;return s|0}}else{r=l}}while(0);do{if((r|0)==1){if((hL()|0)==0){break}h7(p,d);s=0;i=e;return s|0}}while(0);l=c[p+4>>2]|0;if((l|0)==1){t=c7[c[p+28>>2]&255](d,c[p+32>>2]|0)|0}else if((l|0)==0){t=c7[c[p+24>>2]&255](d,c[p+32>>2]|0)|0}else{s=0;i=e;return s|0}if((t|0)==0){s=0;i=e;return s|0}l=c[p+36>>2]|0;if((l|0)!=0){k=c[q>>2]|0;j=l;do{c5[c[j>>2]&255](k,c[j+4>>2]|0);j=c[j+8>>2]|0;}while((j|0)!=0)}j=c[115256]|0;if((j|0)==0){s=t;i=e;return s|0}k=c[q>>2]|0;l=j;while(1){c5[c[l>>2]&255](k,c[l+4>>2]|0);j=c[l+8>>2]|0;if((j|0)==0){s=t;break}else{l=j}}i=e;return s|0}}while(0);hu(-2,82696,(t=i,i=i+8|0,c[t>>2]=b,t)|0)|0;i=t;s=-1;i=e;return s|0}function h7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=c[a>>2]|0;e=A1(d|0)|0;f=e+1|0;g=a+4|0;if((c[g>>2]|0)==0){h=e+5|0}else{h=e+2+(A1(b|0)|0)|0}e=hg(h)|0;A9(e|0,d|0)|0;if((c[g>>2]|0)==0){c[e+f>>2]=b;hK(16,e,h);hj(e);return}else{g=e+f|0;A9(g|0,b|0)|0;hK(16,e,h);hj(e);return}}function h8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;L3753:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){q=p|0;if((A8(c[q>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3753}l=k+(j*44|0)|0;if((l|0)==0){break L3753}else{p=l}}k=p+12|0;l=c[k>>2]|0;do{if((l|0)==2){if((hO()|0)==0){r=c[k>>2]|0;break}else{s=-2;i=e;return s|0}}else{r=l}}while(0);do{if((r|0)==1){if((hL()|0)==0){break}h7(p,d);s=0;i=e;return s|0}}while(0);if((c[p+4>>2]|0)!=0){s=-1;i=e;return s|0}l=c7[c[p+24>>2]&255](d,c[p+32>>2]|0)|0;if((l|0)==0){s=0;i=e;return s|0}k=c[p+36>>2]|0;if((k|0)!=0){j=c[q>>2]|0;h=k;do{c5[c[h>>2]&255](j,c[h+4>>2]|0);h=c[h+8>>2]|0;}while((h|0)!=0)}h=c[115256]|0;if((h|0)==0){s=l;i=e;return s|0}j=c[q>>2]|0;k=h;while(1){c5[c[k>>2]&255](j,c[k+4>>2]|0);h=c[k+8>>2]|0;if((h|0)==0){s=l;break}else{k=h}}i=e;return s|0}}while(0);hu(-2,82696,(q=i,i=i+8|0,c[q>>2]=b,q)|0)|0;i=q;s=-1;i=e;return s|0}function h9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;L3799:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){q=p|0;if((A8(c[q>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3799}l=k+(j*44|0)|0;if((l|0)==0){break L3799}else{p=l}}k=p+12|0;l=c[k>>2]|0;do{if((l|0)==2){if((hO()|0)==0){r=c[k>>2]|0;break}else{s=-2;i=e;return s|0}}else{r=l}}while(0);do{if((r|0)==1){if((hL()|0)==0){break}h7(p,d);s=0;i=e;return s|0}}while(0);if((c[p+4>>2]|0)!=1){s=-1;i=e;return s|0}l=c7[c[p+28>>2]&255](d,c[p+32>>2]|0)|0;if((l|0)==0){s=0;i=e;return s|0}k=c[p+36>>2]|0;if((k|0)!=0){j=c[q>>2]|0;h=k;do{c5[c[h>>2]&255](j,c[h+4>>2]|0);h=c[h+8>>2]|0;}while((h|0)!=0)}h=c[115256]|0;if((h|0)==0){s=l;i=e;return s|0}j=c[q>>2]|0;k=h;while(1){c5[c[k>>2]&255](j,c[k+4>>2]|0);h=c[k+8>>2]|0;if((h|0)==0){s=l;break}else{k=h}}i=e;return s|0}}while(0);hu(-2,82696,(q=i,i=i+8|0,c[q>>2]=b,q)|0)|0;i=q;s=-1;i=e;return s|0}function ia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e|0;g=f;c[g>>2]=d;c[g+4>>2]=0;g=hl(a,f|0)|0;f=h8(g,b)|0;hj(g);i=e;return f|0}function ib(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;L3846:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){if((A8(c[p>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3846}l=k+(j*44|0)|0;if((l|0)==0){break L3846}else{p=l}}k=c[p+4>>2]|0;if((k|0)==1){c[d>>2]=c[c[p+20>>2]>>2];q=0;i=e;return q|0}else if((k|0)==0){c[d>>2]=c[c[p+20>>2]>>2];q=0;i=e;return q|0}else{hu(-2,81272,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}}}while(0);hu(-2,80256,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}function ic(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;L3871:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){if((A8(c[p>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3871}l=k+(j*44|0)|0;if((l|0)==0){break L3871}else{p=l}}if((c[p+4>>2]|0)==0){c[d>>2]=c[c[p+20>>2]>>2];q=0;i=e;return q|0}else{hu(-2,81272,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}}}while(0);hu(-2,80256,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}function id(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;L3894:do{if((b|0)!=0){f=a[b]|0;if(f<<24>>24==0){g=0}else{h=0;j=0;k=0;l=f;while(1){f=A6(l<<24>>24|0)|0;m=j>>>0>9>>>0?0:j;n=f<<m^k;if((m+8|0)>>>0>10>>>0){o=n^f>>>((10-m|0)>>>0)}else{o=n}n=h+1|0;f=a[b+n|0]|0;if(f<<24>>24==0){g=o;break}else{h=n;j=m+1|0;k=o;l=f}}}l=c[(c[200814]|0)+((g&1023)<<2)>>2]|0;if((l|0)<=-1){break}k=c[115254]|0;j=k+(l*44|0)|0;if((j|0)==0){break}else{p=j}while(1){if((A8(c[p>>2]|0,b|0)|0)==0){break}j=c[p+40>>2]|0;if((j|0)<=-1){break L3894}l=k+(j*44|0)|0;if((l|0)==0){break L3894}else{p=l}}if((c[p+4>>2]|0)==1){c[d>>2]=c[c[p+20>>2]>>2];q=0;i=e;return q|0}else{hu(-2,81272,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}}}while(0);hu(-2,80256,(r=i,i=i+8|0,c[r>>2]=b,r)|0)|0;i=r;q=-1;i=e;return q|0}function ie(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;L3917:do{if((c[121466]|0)!=0){a=0;while(1){b=c[115254]|0;d=c[b+(a*44|0)+4>>2]|0;if((d|0)==1){if((c7[c[b+(a*44|0)+28>>2]&255](c[b+(a*44|0)+8>>2]|0,c[b+(a*44|0)+32>>2]|0)|0)<0){e=-1;f=3279;break}}else if((d|0)==0){if((c7[c[b+(a*44|0)+24>>2]&255](c[b+(a*44|0)+8>>2]|0,c[b+(a*44|0)+32>>2]|0)|0)<0){e=-1;f=3281;break}}b=c[115254]|0;d=c[b+(a*44|0)+36>>2]|0;if((d|0)!=0){g=c[b+(a*44|0)>>2]|0;b=d;do{c5[c[b>>2]&255](g,c[b+4>>2]|0);b=c[b+8>>2]|0;}while((b|0)!=0)}a=a+1|0;if(a>>>0>=(c[121466]|0)>>>0){break L3917}}if((f|0)==3279){return e|0}else if((f|0)==3281){return e|0}}}while(0);f=c[115256]|0;if((f|0)==0){e=0;return e|0}else{h=f}while(1){c5[c[h>>2]&255](0,c[h+4>>2]|0);f=c[h+8>>2]|0;if((f|0)==0){e=0;break}else{h=f}}return e|0}function ig(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b|0;if((ib(a,d)|0)<0){e=-1;i=b;return e|0}e=h6(a,c[d>>2]|0)|0;i=b;return e|0}function ih(){c[12092]=hq(80216)|0;c[115274]=0;c[115276]=0;return 0}function ii(a){a=a|0;var d=0;if((a|0)==0){bY(79832,87192,80,90128);return 0}d=b[242924]|0;c[324528+((d&65535)>>>5<<2)>>2]=a;a=d+32&65535;b[242924]=a;if((a&65535)>>>0<640>>>0){return d|0}else{bY(84448,87192,85,90128);return 0}return 0}function ij(){var a=0;if((h2(48472)|0)<0){a=-1;return a|0}a=h1(49488)|0;return a|0}function ik(){hj(c[200918]|0);hj(c[200920]|0);hj(c[115278]|0);hj(c[115280]|0);return}function il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=0;while(1){e=324400+(d<<2)|0;f=(d|0)<32;if((c[e>>2]|0)!=0&f){d=d+1|0}else{break}}if(f){c[e>>2]=a;e=c[a>>2]|0;a=hn(82504,(g=i,i=i+16|0,c[g>>2]=c[200916],c[g+8>>2]=e,g)|0)|0;i=g;hj(c[200916]|0);c[200916]=a;i=b;return 0}else{a=c[12006]|0;hv(a,81168,(g=i,i=i+1|0,i=i+7&-8,c[g>>2]=0,g)|0)|0;i=g;i=b;return 0}return 0}function im(){var d=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+32|0;f=d|0;g=d+8|0;j=d+16|0;k=d+24|0;if((c[80950]|0)>0&(c[200914]|0)!=0){l=1;i=d;return l|0}ja();if((e[242924]|0)>>>0>31>>>0){m=0;n=0;while(1){o=c3[c[(c[324528+(n<<2)>>2]|0)+32>>2]&31]()|0;p=(o|0)>(m|0)?o:m;o=n+1|0;if((o|0)<((e[242924]|0)>>>5|0)){m=p;n=o}else{q=p;break}}}else{q=0}c[81153]=q;n=c[200918]|0;if((n|0)==0){r=0}else{r=(a[n]|0)==0?0:n}n=c[200920]|0;if((n|0)==0){s=0}else{s=(a[n]|0)==0?0:n}n=c[115278]|0;if((n|0)==0){t=0}else{t=(a[n]|0)==0?0:n}n=c[115280]|0;if((n|0)==0){u=0}else{u=(a[n]|0)==0?0:n}n=c[215606]|0;v=((n-1|0)>>>0>999>>>0?100.0:+(n|0))/1.0e3;n=c[115232]|0;m=(n-8e3|0)>>>0>88e3>>>0?44100:n;c[g>>2]=m;n=c[121452]|0;if((n-1|0)>>>0<2>>>0){w=n}else{w=(q|0)>1?2:1}q=c[81100]|0;n=(q|0)!=0;L3989:do{if((r|0)==0|n^1){x=q;y=n}else{p=0;o=q;z=n;while(1){A=c[o>>2]|0;if((A|0)!=0){if((A8(r|0,A|0)|0)==0){x=o;y=z;break L3989}}A=p+1|0;B=c[324400+(A<<2)>>2]|0;if((B|0)==0){x=0;y=0;break}else{p=A;o=B;z=1}}}}while(0);C=+h[6049];if(C<1.0){D=1}else{D=~~C}n=((m|0)/(D|0)|0|0)/(c[55688+(c[200832]<<2)>>2]|0)|0;c[j>>2]=n;do{if(y){if((w|0)>(c[x+40>>2]|0)){E=n;break}D=ag(n,w)|0;c[j>>2]=D;E=D}else{E=n}}while(0);n=1;while(1){F=1<<n;if((F|0)<(E|0)){n=n+1|0}else{break}}c[j>>2]=F;C=+(F|0);F=~~((C+v*+(m|0)+-1.0)/C);c[k>>2]=(F|0)<3?3:F;if(!y){y=hn(iX(65811)|0,(G=i,i=i+8|0,c[G>>2]=r,G)|0)|0;i=G;io(y);hj(y);l=1;i=d;return l|0}y=x+4|0;do{if((c[y>>2]|0)==0){H=c[81152]|0;I=3342}else{c[f>>2]=w;if((dj[c[y>>2]&127](s,g,j,k,f)|0)!=0){r=iX(65746)|0;F=hn(r,(G=i,i=i+8|0,c[G>>2]=c[x>>2],G)|0)|0;i=G;io(F);hj(F);l=1;i=d;return l|0}if((c[f>>2]|0)==(w|0)){c[81152]=w;H=w;I=3342;break}if((c[121452]|0)!=1){F=c[12006]|0;hu(F,80120,(G=i,i=i+1|0,i=i+7&-8,c[G>>2]=0,G)|0)|0;i=G}c[81152]=1;c[113944]=0;J=0;I=3343}}while(0);if((I|0)==3342){c[113944]=0;if((H|0)>0){J=0;I=3343}else{K=H}}if((I|0)==3343){while(1){I=0;b[455780+(J<<1)>>1]=0;H=J+1|0;w=c[81152]|0;if((H|0)<(w|0)){J=H;I=3343}else{K=w;break}}}c[113937]=x;J=c[j>>2]|0;c[113939]=J;w=c[k>>2]|0;c[113940]=w;H=ag(w,J)|0;c[113941]=H;c[113936]=0;w=c[g>>2]|0;C=+(w|0);hs(c[12006]|0,79184,(G=i,i=i+40|0,c[G>>2]=c[x>>2],c[G+8>>2]=w,c[G+16>>2]=~~(+(J|0)*1.0e3/C),c[G+24>>2]=~~(+(H|0)*1.0e3/C),c[G+32>>2]=(K|0)>1?78528:871e3,G)|0)|0;i=G;c[115232]=c[g>>2];L4029:do{if((c[81153]|0)>0){K=0;H=b[242924]|0;while(1){if((H&65535)>>>0>31>>>0){L=0;M=0;N=H}else{I=3348;break}while(1){J=c[c[324528+(M<<2)>>2]>>2]|0;if((J|0)==0){O=L;P=N}else{w=da[J&255](K)|0;O=w;P=b[242924]|0}w=M+1|0;if((w|0)<((P&65535)>>>5|0)){L=O;M=w;N=P}else{break}}c[324616+(K<<2)>>2]=O;w=K+1|0;if((O|0)==0){break}if((w|0)<(c[81153]|0)){K=w;H=P}else{break L4029}}if((I|0)==3348){c[324616+(K<<2)>>2]=0}io(iX(65785)|0);l=1;i=d;return l|0}}while(0);if((ip()|0)!=0){l=1;i=d;return l|0}c[113994]=0;I=c[x+20>>2]|0;do{if((I|0)!=0){P=c3[I&31]()|0;O=c[113939]|0;N=P-O|0;if((N|0)<=0){break}iq(N-((N|0)%(O|0)|0)|0,0)}}while(0);a[48360]=1;c[81092]=0;I=c[81100]|0;L4052:do{if((I|0)==0){Q=0;R=0}else{if((t|0)==0){O=0;while(1){N=O+1|0;if((c[324400+(N<<2)>>2]|0)==0){Q=0;R=0;break L4052}else{O=N}}}else{S=0;T=I}while(1){O=c[T>>2]|0;if((O|0)!=0){if((A8(t|0,O|0)|0)==0){Q=T;R=1;break L4052}}O=S+1|0;K=c[324400+(O<<2)>>2]|0;if((K|0)==0){Q=0;R=0;break}else{S=O;T=K}}}}while(0);if((t|0)!=0&(Q|0)==0){fC(iX(65707)|0,(G=i,i=i+8|0,c[G>>2]=t,G)|0);i=G}if(!R){l=0;i=d;return l|0}if((Q|0)==(x|0)){fC(iX(65720)|0,(G=i,i=i+1|0,i=i+7&-8,c[G>>2]=0,G)|0);i=G;h9(77496,871e3)|0;l=0;i=d;return l|0}if((c[Q+20>>2]|0)!=0){fC(iX(65733)|0,(G=i,i=i+1|0,i=i+7&-8,c[G>>2]=0,G)|0);i=G}x=Q+4|0;if((c[x>>2]|0)==0){l=0;i=d;return l|0}c[f>>2]=c[81152];if((dj[c[x>>2]&127](u,g,j,k,f)|0)!=0){u=iX(65746)|0;fC(u,(G=i,i=i+8|0,c[G>>2]=c[Q>>2],G)|0);i=G;h9(77496,871e3)|0;l=0;i=d;return l|0}do{if((c[115232]|0)==(c[g>>2]|0)){if((c[113939]|0)!=(c[j>>2]|0)){break}if((c[113940]|0)!=(c[k>>2]|0)){break}if((c[81152]|0)!=(c[f>>2]|0)){break}c[113938]=Q;u=c[12006]|0;x=c[Q>>2]|0;hs(u,89800,(G=i,i=i+8|0,c[G>>2]=x,G)|0)|0;i=G;l=0;i=d;return l|0}}while(0);fC(iX(65759)|0,(G=i,i=i+1|0,i=i+7&-8,c[G>>2]=0,G)|0);i=G;dd[c[Q+24>>2]&63]();h9(77496,871e3)|0;l=0;i=d;return l|0}function io(a){a=a|0;var b=0,d=0,e=0;b=i;ir();if((c[7356]|c[14078]|0)==0){d=hn(84760,(e=i,i=i+8|0,c[e>>2]=a,e)|0)|0;i=e;fC(d,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0);i=e;hj(d)}else{d=c[12006]|0;hs(d,85408,(e=i,i=i+8|0,c[e>>2]=a,e)|0)|0;i=e}c[119398]=0;if((c[14078]|0)!=0){i=b;return}fI();i=b;return}function ip(){var a=0,d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;a=b[242924]|0;if((a&65535)>>>0>31>>>0){d=0;e=0;while(1){f=c3[c[(c[324528+(d<<2)>>2]|0)+28>>2]&31]()|0|e;g=d+1|0;i=b[242924]|0;if((g|0)<((i&65535)>>>5|0)){d=g;e=f}else{j=f;k=i;break}}}else{j=0;k=a}c[200948]=j;j=c[81086]|0;a=c[115232]|0;e=(a*100|0|0)/(((j|0)!=0?j:100)|0)|0;j=c[81153]|0;do{if((j|0)>0){d=0;i=k;f=j;while(1){g=c[324616+(d<<2)>>2]|0;l=c[200944]|0;if((i&65535)>>>0>31>>>0){m=1;n=0;o=i;while(1){p=c[(c[324528+(n<<2)>>2]|0)+4>>2]|0;if((p|0)==0){q=m;r=o}else{s=(c8[p&127](g,e,l)|0)&m;q=s;r=b[242924]|0}s=n+1|0;if((s|0)<((r&65535)>>>5|0)){m=q;n=s;o=r}else{break}}if((q|0)==0){break}t=r;u=c[81153]|0}else{t=i;u=f}o=d+1|0;if((o|0)<(u|0)){d=o;i=t;f=u}else{v=3412;break}}if((v|0)==3412){w=c[115232]|0;break}io(iX(65798)|0);x=1;return x|0}else{w=a}}while(0);y=+((c[200944]|0)>>>0>>>0)/+(w|0);h[40579]=y;h[40580]=y;h[40581]=1.0;w=c[198580]|0;h[40582]=+(w>>>0>>>0);c[81166]=w;c[81167]=w;x=0;return x|0}function iq(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0;e=hg(ag(a<<1,c[81152]|0)|0)|0;f=e;if((e|0)==0){return}g=c[81152]|0;if((g|0)>0){h=(a|0)>0;i=(d|0)<0;j=+(a|0);k=(d|0)>0;d=0;l=g;while(1){if(h){m=455780+(d<<1)|0;if(i){n=0;do{b[f+((ag(c[81152]|0,n)|0)+d<<1)>>1]=~~(+(a-n|0)/j*+(b[m>>1]|0));n=n+1|0;}while((n|0)<(a|0))}else{if(k){n=0;do{b[f+((ag(c[81152]|0,n)|0)+d<<1)>>1]=~~(+(n|0)/j*+(b[m>>1]|0));n=n+1|0;}while((n|0)<(a|0))}else{n=0;do{b[f+((ag(c[81152]|0,n)|0)+d<<1)>>1]=b[m>>1]|0;n=n+1|0;}while((n|0)<(a|0))}}o=c[81152]|0}else{o=l}n=d+1|0;if((n|0)<(o|0)){d=n;l=o}else{p=o;break}}}else{p=g}g=ag(p,a)|0;a=c7[c[(c[113937]|0)+8>>2]&255](f,g)|0;hj(e);if((a|0)==0){return}io(iX(65772)|0);return}function ir(){var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[113937]|0;if((e|0)!=0){f=c[12006]|0;g=c[e>>2]|0;hs(f,88856,(h=i,i=i+8|0,c[h>>2]=g,h)|0)|0;i=h;g=c[(c[113937]|0)+24>>2]|0;if((g|0)!=0){dd[g&63]()}c[113937]=0}g=c[113938]|0;if((g|0)!=0){f=c[12006]|0;e=c[g>>2]|0;hs(f,88440,(h=i,i=i+8|0,c[h>>2]=e,h)|0)|0;i=h;h=c[(c[113938]|0)+24>>2]|0;if((h|0)!=0){dd[h&63]()}c[113938]=0}h=c[81153]|0;if((h|0)>0){j=0;k=h}else{c[113943]=0;c[113942]=0;a[48360]=0;c[81092]=0;ja();i=d;return}while(1){h=324616+(j<<2)|0;e=c[h>>2]|0;if((e|0)==0){l=k}else{f=b[242924]|0;if((f&65535)>>>0>31>>>0){g=0;m=f;while(1){f=c[(c[324528+(g<<2)>>2]|0)+8>>2]|0;if((f|0)==0){n=m}else{c4[f&511](e);n=b[242924]|0}f=g+1|0;if((f|0)<((n&65535)>>>5|0)){g=f;m=n}else{break}}}c[h>>2]=0;l=c[81153]|0}m=j+1|0;if((m|0)<(l|0)){j=m;k=l}else{break}}c[113943]=0;c[113942]=0;a[48360]=0;c[81092]=0;ja();i=d;return}function is(){var a=0,d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;a=c[198580]|0;h[40582]=+(a>>>0>>>0);c[81166]=a;c[81167]=a;c[113936]=0;a=c[81153]|0;if((a|0)>0){d=0;e=a}else{return}while(1){a=c[324616+(d<<2)>>2]|0;do{if((a|0)==0){f=e}else{g=c[198580]|0;i=b[242924]|0;if((i&65535)>>>0>31>>>0){j=0;k=i}else{f=e;break}while(1){i=c[(c[324528+(j<<2)>>2]|0)+24>>2]|0;if((i|0)==0){l=k}else{c5[i&255](a,g);l=b[242924]|0}i=j+1|0;if((i|0)<((l&65535)>>>5|0)){j=i;k=l}else{break}}f=c[81153]|0}}while(0);a=d+1|0;if((a|0)<(f|0)){d=a;e=f}else{break}}return}function it(){var d=0,e=0.0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0;d=i;if((c[119398]|0)==0){if(!(a[48360]|0)){e=0.0;i=d;return+e}ir();e=0.0;i=d;return+e}if((c[81092]|0)!=0){if(a[48360]|0){ir()}c[81092]=0}do{if(!((c[80950]|0)<1|(c[200914]|0)==0)){f=c_(0)|0;g=f-(c[200914]|0)|0;if((g|0)>-1&(g|0)<(c[80950]|0)){break}c[200914]=0}}while(0);if((iu()|0)!=0){e=0.0;i=d;return+e}do{if((c[113994]|0)!=0){if((ip()|0)==0){c[113994]=0;break}else{e=0.0;i=d;return+e}}}while(0);if((c[80452]|0)!=0&(c[113938]|0)==0){c[113936]=0;e=0.0;i=d;return+e}g=c[113937]|0;do{if((g|0)!=0&(c[113944]|0)!=0){f=c[g+32>>2]|0;if((f|0)==0){j=0;k=g}else{l=c3[f&31]()|0;j=l;k=c[113937]|0}c[113944]=j;if((c[k+8>>2]|0)==0|(j|0)!=0){m=k;break}if((c[k+36>>2]|0)==0){m=k;break}iq(c[113939]|0,1);m=c[113937]|0}else{m=g}}while(0);do{if((c[m+16>>2]|0)!=0){g=ki(c[81154]|0)|0;k=da[c[(c[113937]|0)+16>>2]&255](g)|0;hj(g);if((k|0)==0){break}io(iX(65850)|0);e=0.0;i=d;return+e}}while(0);m=c[113936]|0;k=(m|0)%(c[113939]|0)|0;g=m-k|0;if((m|0)==(k|0)){e=0.0;i=d;return+e}k=c[(c[113937]|0)+20>>2]|0;do{if((k|0)==0){n=g}else{m=c3[k&31]()|0;j=c[113941]|0;if((m|0)<0|(m|0)>(j|0)){l=c[12006]|0;hu(l,88008,(o=i,i=i+16|0,c[o>>2]=m,c[o+8>>2]=j,o)|0)|0;i=o;io(iX(65863)|0);e=0.0;i=d;return+e}l=c[113939]|0;f=m-((m|0)%(l|0)|0)|0;m=j-f|0;if((m|0)<(l|0)){do{if((c[80950]|0)>0){l=c_(0)|0;if((l|0)!=(c[81096]|0)){c[81096]=l;p=c[113941]|0;break}c[200914]=c_(0)|0;l=c[12006]|0;q=c[80950]|0;hu(l,85824,(o=i,i=i+16|0,c[o>>2]=q,c[o+8>>2]=87616,o)|0)|0;i=o;c[81092]=1;e=0.0;i=d;return+e}else{p=j}}while(0);j=p-g|0;if((j|0)>0){iq(j,0)}c[113943]=j;j=c[81098]|0;do{if((j|0)<25){q=c[12006]|0;hu(q,87264,(o=i,i=i+1|0,i=i+7&-8,c[o>>2]=0,o)|0)|0;i=o;c[81098]=(c[81098]|0)+1}else{if((j|0)!=25){break}q=c[12006]|0;hu(q,86912,(o=i,i=i+1|0,i=i+7&-8,c[o>>2]=0,o)|0)|0;i=o;c[81098]=(c[81098]|0)+1}}while(0);jd()}j=c[200948]|0;q=c[81090]|0;do{if((j|0)!=0|(q|0)!=1){l=c[81086]|0;if((l|0)<=0){break}h[40581]=+(l|0)/100.0}else{if((c[113943]|0)==0){r=c[113942]|0}else{c[113942]=m;r=m}h[40581]=+h[40581]*(+(m-r|0)*.9/+(c[113941]|0)+1.0)}}while(0);c[113942]=m;c[113943]=0;s=+h[40581];if((j|0)==0&(q|0)!=2&(c[113938]|0)==0){l=c[113941]|0;t=s*(+(m+g|0)*.12/+(l|0)+.9);h[40581]=t;u=t;v=l}else{u=s;v=c[113941]|0}s=+h[40580]*u;h[40579]=s;if(+((c[200946]|0)>>>0>>>0)/s<+(v|0)){n=(g|0)>(f|0)?f:g;break}if((c[80950]|0)>0){c[200914]=c_(0)|0;l=c[12006]|0;w=c[80950]|0;hu(l,85824,(o=i,i=i+16|0,c[o>>2]=w,c[o+8>>2]=86608,o)|0)|0;i=o;c[81092]=1;e=0.0;i=d;return+e}else{io(iX(65876)|0);e=0.0;i=d;return+e}}}while(0);do{if((n|0)!=0){o=ag(c[81152]|0,n)|0;if((c7[c[(c[113937]|0)+8>>2]&255](324672,o)|0)!=0){io(iX(65772)|0);e=0.0;i=d;return+e}o=c[113938]|0;if((o|0)==0){break}g=ag(c[81152]|0,n)|0;if((c7[c[o+8>>2]&255](324672,g)|0)==0){break}io(iX(65772)|0);e=0.0;i=d;return+e}}while(0);g=c[113936]|0;o=(c[81086]|0)==0?g:n;c[113936]=g-o;g=c[81152]|0;if((g|0)>0){n=o-1|0;v=0;r=g;do{b[455780+(v<<1)>>1]=b[324672+((ag(r,n)|0)+v<<1)>>1]|0;if((c[113936]|0)>0){g=0;do{p=c[81152]|0;b[324672+((ag(p,g)|0)+v<<1)>>1]=b[324672+((ag(p,g+o|0)|0)+v<<1)>>1]|0;g=g+1|0;}while((g|0)<(c[113936]|0))}v=v+1|0;r=c[81152]|0;}while((v|0)<(r|0))}r=c[(c[113937]|0)+20>>2]|0;if((r|0)==0){e=0.0;i=d;return+e}if(!((c[200948]|0)!=0|(c[81090]|0)==2)){e=0.0;i=d;return+e}v=c3[r&31]()|0;e=+(v-(c[113936]|0)|0)/+(c[115232]|0);i=d;return+e}function iu(){var a=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a=i;i=i+8|0;d=a|0;c[d>>2]=0;if((c[119398]|0)==0){e=1;i=a;return e|0}if((c[80950]|0)>0&(c[200914]|0)!=0){e=1;i=a;return e|0}do{if((c[113937]|0)==0){f=im()|0;if((f|0)==0){break}else{e=f}i=a;return e|0}}while(0);f=c[198580]|0;do{if((c[200948]|0)==0){g=~~((+(f>>>0>>>0)- +h[40582])/+h[40579]);if((g|0)==0){e=0;i=a;return e|0}j=c[113936]|0;if((j+g|0)>32768){io(iX(65837)|0);e=1;i=a;return e|0}k=c[81152]|0;l=ag(k,j)|0;j=324672+(l<<1)|0;m=c[81153]|0;n=(c3[c[(c[81132]|0)+28>>2]&31]()|0)==0;o=c[81132]|0;do{if(n){if((c3[c[o+28>>2]&31]()|0)!=0){p=g;break}q=c[81132]|0;if((c[q+36>>2]|0)==0){p=g}else{r=q;s=3581}}else{r=o;s=3581}}while(0);if((s|0)==3581){p=c6[c[r+12>>2]&31](324616,j,g,k,m,d)|0}o=b[242924]|0;if((o&65535)>>>0>63>>>0){n=1;q=o;while(1){o=c[324528+(n<<2)>>2]|0;if((c[o+36>>2]|0)==0){t=q}else{u=c[o+12>>2]|0;c6[u&31](324616,j,p,k,m,d)|0;t=b[242924]|0}u=n+1|0;if((u|0)<((t&65535)>>>5|0)){n=u;q=t}else{break}}}q=c[80478]|0;do{if((q|0)<100){if((ag(c[81152]|0,g)|0)<=0){break}n=(q|0)==0;m=0;do{k=324672+(m+l<<1)|0;if(n){v=0}else{v=((b[k>>1]|0)/(100/(q|0)|0|0)|0)&65535}b[k>>1]=v;m=m+1|0;}while((m|0)<(ag(c[81152]|0,g)|0))}}while(0);h[40582]=+h[40582]+ +(g|0)*+h[40579];w=g}else{c[d>>2]=f-(c[81167]|0);q=c[113936]|0;l=c[81152]|0;m=ag(l,q)|0;n=324672+(m<<1)|0;k=32768-q|0;q=c[81153]|0;j=(c3[c[(c[81132]|0)+28>>2]&31]()|0)==0;u=c[81132]|0;do{if(j){if((c3[c[u+28>>2]&31]()|0)!=0){x=k;break}o=c[81132]|0;if((c[o+36>>2]|0)==0){x=k}else{y=o;s=3559}}else{y=u;s=3559}}while(0);if((s|0)==3559){x=c6[c[y+12>>2]&31](324616,n,k,l,q,d)|0}u=b[242924]|0;if((u&65535)>>>0>63>>>0){j=1;g=u;while(1){u=c[324528+(j<<2)>>2]|0;if((c[u+36>>2]|0)==0){z=g}else{o=c[u+12>>2]|0;c6[o&31](324616,n,x,l,q,d)|0;z=b[242924]|0}o=j+1|0;if((o|0)<((z&65535)>>>5|0)){j=o;g=z}else{break}}}g=c[80478]|0;do{if((g|0)<100){if((ag(c[81152]|0,x)|0)<=0){break}j=(g|0)==0;q=0;do{l=324672+(q+m<<1)|0;if(j){A=0}else{A=((b[l>>1]|0)/(100/(g|0)|0|0)|0)&65535}b[l>>1]=A;q=q+1|0;}while((q|0)<(ag(c[81152]|0,x)|0))}}while(0);if((c[d>>2]|0)==0){w=x;break}g=c[81094]|0;if((g|0)<25){m=c[12006]|0;q=iX(65824)|0;hu(m,85408,(B=i,i=i+8|0,c[B>>2]=q,B)|0)|0;i=B;c[81094]=(c[81094]|0)+1;w=x;break}if((g|0)!=25){w=x;break}g=c[12006]|0;hu(g,85056,(B=i,i=i+1|0,i=i+7&-8,c[B>>2]=0,B)|0)|0;i=B;c[81094]=(c[81094]|0)+1;w=x}}while(0);c[113936]=(c[113936]|0)+w;c[81167]=c[198580];e=0;i=a;return e|0}function iv(){var a=0,b=0,d=0,e=0;a=c[113937]|0;if((a|0)==0){return}b=c[113944]|0;do{if((c[a+8>>2]|0)==0|(b|0)!=0){d=a;e=b}else{if((c[a+36>>2]|0)==0){d=a;e=0;break}iq(c[113939]|0,-1);d=c[113937]|0;e=c[113944]|0}}while(0);a=c[d+28>>2]|0;do{if(!((a|0)==0|(e|0)!=0)){if((c3[a&31]()|0)==0){break}return}}while(0);c[113944]=1;return}function iw(a,b){a=a|0;b=b|0;c[113994]=1;c[200944]=a;c[200946]=b;h[6049]=1.0/(+(b>>>0>>>0)/+(a>>>0>>>0));return}function ix(a,b){a=a|0;b=b|0;var d=0;d=i;c[12006]=hq(86352)|0;c[81092]=0;c[113994]=0;c[200944]=a;c[200946]=b;h[6049]=1.0/(+(b>>>0>>>0)/+(a>>>0>>>0));fZ(c[198578]|0,86,0);c[200916]=hk(871e3)|0;qY()|0;o$()|0;oV()|0;pf()|0;pb()|0;o3()|0;oR()|0;o7()|0;hs(c[12006]|0,86040,(a=i,i=i+8|0,c[a>>2]=c[200916],a)|0)|0;i=a;hj(c[200916]|0);i=d;return}function iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[81167]=(c[81167]|0)-a;h[40582]=+h[40582]- +(a>>>0>>>0);c[81166]=(c[81166]|0)-a;b=c[81153]|0;if((b|0)>0){d=0;e=b}else{return}while(1){b=c[324616+(d<<2)>>2]|0;if((b|0)==0){f=e}else{kh(b,a);f=c[81153]|0}b=d+1|0;if((b|0)<(f|0)){d=b;e=f}else{break}}return}function iz(){var a=0.0,b=0;a=+h[40579];if(a==0.0){b=0;return b|0}b=~~((+((c[198580]|0)>>>0>>>0)- +h[40582])/a);return b|0}function iA(a,b){a=a|0;b=b|0;var d=0,e=0;d=(iu()|0)==0;if(!(d&(c[81153]|0)>(b|0))){e=-1;return e|0}e=(c7[c[(c[324528+((a&65535)>>>5<<2)>>2]|0)+20>>2]&255](c[324616+(b<<2)>>2]|0,a&31)|0)&255;return e|0}function iB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(iu()|0)==0;if(!(e&(c[81153]|0)>(d|0))){return}dk[c[(c[324528+((a&65535)>>>5<<2)>>2]|0)+16>>2]&127](c[324616+(d<<2)>>2]|0,a&31,b);d=c[(c[113937]|0)+12>>2]|0;if((d|0)==0){return}e=c8[d&127](a,b,(c[198580]|0)-(c[81166]|0)|0)|0;c[81166]=c[198580];if((e|0)==0){return}io(iX(65889)|0);return}function iC(a){a=a|0;if((c[81086]|0)!=(a|0)){c[113994]=1}c[81086]=a;return}function iD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;c[80452]=a;b=c[113937]|0;if((a|0)==0){if(!((b|0)!=0&(c[113944]|0)!=0)){return}a=c[b+32>>2]|0;if((a|0)==0){d=0;e=b}else{f=c3[a&31]()|0;d=f;e=c[113937]|0}c[113944]=d;if((c[e+8>>2]|0)==0|(d|0)!=0){return}if((c[e+36>>2]|0)==0){return}iq(c[113939]|0,1);return}else{if((b|0)==0){return}e=c[113944]|0;do{if((c[b+8>>2]|0)==0|(e|0)!=0){g=b;h=e}else{if((c[b+36>>2]|0)==0){g=b;h=0;break}iq(c[113939]|0,-1);g=c[113937]|0;h=c[113944]|0}}while(0);b=c[g+28>>2]|0;do{if(!((b|0)==0|(h|0)!=0)){if((c3[b&31]()|0)==0){break}return}}while(0);c[113944]=1;return}}function iE(a,b){a=a|0;b=b|0;if((a|0)!=0){jc()|0}c[119398]=a;kj(a);return 0}function iF(a,b){a=a|0;b=b|0;c[115232]=a;c[81092]=1;return 0}function iG(a,b){a=a|0;b=b|0;do{if((a|0)>0){c[215606]=a}else{if((c[13586]|0)==10){c[215606]=1e3;break}else{c[215606]=100;break}}}while(0);c[81092]=1;return 0}function iH(a,b){a=a|0;b=b|0;c[200832]=a;c[81092]=1;return 0}function iI(a,b){a=a|0;b=b|0;c[80950]=(a|0)<0?0:a;c[81092]=1;return 0}function iJ(a,b){a=a|0;b=b|0;if((a|0)!=-1){c[81090]=a;return 0}if((c[13586]|0)==10){c[81090]=2;return 0}else{c[81090]=0;return 0}return 0}function iK(a,b){a=a|0;b=b|0;b=(a|0)<0?0:a;a=(b|0)>100?100:b;c[80478]=a;fM(a);return 0}function iL(a,b){a=a|0;b=b|0;if(a>>>0<3>>>0){c[121452]=a}return 0}function iM(a,b){a=a|0;b=b|0;i1(803672,a)|0;c[81092]=1;return 0}function iN(a,b){a=a|0;b=b|0;i1(803680,a)|0;c[81092]=1;return 0}function iO(a,b){a=a|0;b=b|0;i1(461112,a)|0;c[81092]=1;return 0}function iP(a,b){a=a|0;b=b|0;i1(461120,a)|0;c[81092]=1;return 0}function iQ(a){a=a|0;c[200922]=eT(a)|0;return 0}function iR(){hj(c[200886]|0);return}function iS(){return h2(48416)|0}function iT(){hj(c[80946]|0);return}function iU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;do{if((b|0)==0){g=3700}else{if((a[b]|0)==0){g=3700;break}h=gq(b,c[200886]|0,4)|0;if((h|0)==0){if((d|0)==0){j=0;break}c[d>>2]=0;j=0;break}k=bV(h|0,e|0)|0;l=(d|0)==0;if((k|0)==0|l){hj(h);m=0}else{m=h}if(l){j=k;break}c[d>>2]=m;j=k}}while(0);if((g|0)==3700){hv(-2,79344,(g=i,i=i+1|0,i=i+7&-8,c[g>>2]=0,g)|0)|0;i=g;j=0}i=f;return j|0}function iV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;do{if((b|0)==0){h=3711}else{if((a[b]|0)==0){h=3711;break}j=gq(b,c[200886]|0,4)|0;if((j|0)==0){h=3715;break}k=bV(j|0,87040)|0;if((k|0)!=0){l=k;m=j;h=3723;break}hj(j);h=3715}}while(0);if((h|0)==3711){hv(-2,79344,(n=i,i=i+1|0,i=i+7&-8,c[n>>2]=0,n)|0)|0;i=n;h=3715}L4522:do{if((h|0)==3715){j=i0(47808,(n=i,i=i+16|0,c[n>>2]=b,c[n+8>>2]=0,n)|0)|0;i=n;do{if((j|0)==0){h=3717}else{if((a[j]|0)==0){h=3717;break}k=gq(j,c[200886]|0,4)|0;if((k|0)==0){break}o=bV(k|0,87040)|0;if((o|0)==0){hj(k);break}else{hj(j);l=o;m=k;h=3723;break L4522}}}while(0);if((h|0)==3717){hv(-2,79344,(n=i,i=i+1|0,i=i+7&-8,c[n>>2]=0,n)|0)|0;i=n}hj(j);p=0}}while(0);do{if((h|0)==3723){hs(-2,84320,(n=i,i=i+8|0,c[n>>2]=m,n)|0)|0;i=n;b=i5(l)|0;k=(e|0)<0?-e|0:e;if(b>>>0<k>>>0){hv(-2,82416,(n=i,i=i+8|0,c[n>>2]=m,n)|0)|0;i=n;p=m;break}if((b|0)==(f+2|0)){hu(-2,81080,(n=i,i=i+8|0,c[n>>2]=m,n)|0)|0;i=n;if((cr(d|0,1,2,l|0)|0)>>>0<2>>>0){p=m;break}q=b-2|0}else{q=b}do{if((e|0)>-1&q>>>0<f>>>0){r=q;s=d+(f-q)|0}else{if(q>>>0<=f>>>0){r=q;s=d;break}hu(-2,80080,(n=i,i=i+8|0,c[n>>2]=m,n)|0)|0;i=n;r=f;s=d}}while(0);j=cr(s|0,1,r|0,l|0)|0;if(j>>>0<k>>>0){p=m;break}aM(l|0)|0;hj(m);t=j;i=g;return t|0}}while(0);hj(p);t=-1;i=g;return t|0}function iW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i1(323784,b)|0;hj(c[200886]|0);c[200886]=0;b=i4(c[80946]|0,78064,c[200922]|0)|0;e=gT()|0;f=b;while(1){g=cL(f|0,58)|0;h=(g|0)!=0;if(h){a[g]=0}j=(eY(f)|0)==0;k=c[200886]|0;l=(k|0)==0;do{if(j){if(l){m=i0(f,(n=i,i=i+8|0,c[n>>2]=0,n)|0)|0;i=n;o=m;break}else{m=i0(k,(n=i,i=i+24|0,c[n>>2]=77488,c[n+8>>2]=f,c[n+16>>2]=0,n)|0)|0;i=n;o=m;break}}else{if(l){m=i0(e,(n=i,i=i+24|0,c[n>>2]=89792,c[n+8>>2]=f,c[n+16>>2]=0,n)|0)|0;i=n;o=m;break}else{m=i0(k,(n=i,i=i+40|0,c[n>>2]=77488,c[n+8>>2]=e,c[n+16>>2]=89792,c[n+24>>2]=f,c[n+32>>2]=0,n)|0)|0;i=n;o=m;break}}}while(0);hj(c[200886]|0);c[200886]=o;if(h){f=g+1|0}else{break}}hj(e);hj(b);i=d;return 0}function iX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;if((a|0)==0){hv(-2,86872,(d=i,i=i+1|0,i=i+7&-8,c[d>>2]=0,d)|0)|0;i=d;e=84272;i=b;return e|0}else if((a|0)==65537){e=0;i=b;return e|0}else{f=(a|0)==16777213;if(!((a&-2|0)==16777214|f)){e=(c[11956]|0)==(a|0)?c[11957]|0:0;i=b;return e|0}g=c[113996]|0;if((g|0)!=0){hj(g)}g=hk(82384)|0;h=i0(g,(d=i,i=i+16|0,c[d>>2]=(c[11956]|0)==70829?c[11957]|0:0,c[d+8>>2]=0,d)|0)|0;i=d;hj(g);if((a|0)==16777215){j=h}else{a=(c[11956]|0)==70842?c[11957]|0:0;g=i0(h,(d=i,i=i+24|0,c[d>>2]=81072,c[d+8>>2]=a,c[d+16>>2]=0,d)|0)|0;i=d;hj(h);j=g}if(f){f=(c[11956]|0)==70855?c[11957]|0:0;g=i0(j,(d=i,i=i+24|0,c[d>>2]=81072,c[d+8>>2]=f,c[d+16>>2]=0,d)|0)|0;i=d;hj(j);k=g}else{k=j}j=i0(k,(d=i,i=i+16|0,c[d>>2]=80072,c[d+8>>2]=0,d)|0)|0;i=d;hj(k);c[113996]=j;e=j;i=b;return e|0}return 0}function iY(){return h1(49432)|0}function iZ(){var a=0,b=0;a=c[80940]|0;if((a|0)==0){return}else{b=a}while(1){a=c[b>>2]|0;hj(b);if((a|0)==0){break}else{b=a}}return}function i_(){var a=0,f=0,g=0,h=0,i=0,j=0,k=0;a=c[198570]|0;f=c[80940]|0;if((f|0)==0){g=-1;return g|0}else{h=f}while(1){i=h+4|0;j=c[i>>2]|0;if((e[j+4>>1]|0|0)==(a|0)){break}f=c[h>>2]|0;if((f|0)==0){g=-1;k=3781;break}else{h=f}}if((k|0)==3781){return g|0}k=b[j+6>>1]|0;if((c3[c[j+12>>2]&31]()|0)==0){j=c[i>>2]|0;g=(d[j+9|0]|0)<<8|(d[j+8|0]|0)|(d[j+10|0]|0)<<16;return g|0}else{c[198570]=k&65535;g=0;return g|0}return 0}function i$(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=(c[80938]|0)!=0;h=(d|0)==0;L4611:do{if(g&h|(g|h)^1){j=c[80940]|0;k=(j|0)==0;if(h){if(k){break}else{l=j}while(1){m=c[l+4>>2]|0;n=m+4|0;if((da[c[m+16>>2]&255](b[n>>1]|0)|0)<<24>>24==2){c5[c[m+20>>2]&255](b[n>>1]|0,a[m+8|0]|0)}else{n=c[11950]|0;o=c[m>>2]|0;hv(n,84240,(p=i,i=i+8|0,c[p>>2]=o,p)|0)|0;i=p}l=c[l>>2]|0;if((l|0)==0){break L4611}}}if(k){break}else{q=j}do{o=c[q+4>>2]|0;n=o+16|0;m=o+4|0;r=0;while(1){s=da[c[n>>2]&255]((e[m>>1]|0)+r&65535)|0;t=r+1|0;if(s<<24>>24!=(a[o+8+r|0]|0)){u=3794;break}if((t|0)<3){r=t}else{u=3795;break}}if((u|0)==3794){u=0;r=c[11950]|0;n=c[o>>2]|0;hv(r,82328,(p=i,i=i+8|0,c[p>>2]=n,p)|0)|0;i=p}else if((u|0)==3795){u=0;c5[c[o+20>>2]&255](b[m>>1]|0,2)}q=c[q>>2]|0;}while((q|0)!=0)}}while(0);c[80938]=d;mW(d);i=f;return 0}function i0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+528|0;f=e|0;g=e+512|0;h=A1(b|0)|0;j=f|0;c[j>>2]=h;k=g|0;l=g;c[l>>2]=d;c[l+4>>2]=0;g=h;h=1;while(1){m=(B=c[k+4>>2]|0,c[k+4>>2]=B+8,c[(c[k>>2]|0)+B>>2]|0);if((m|0)==0){n=g;o=h;break}p=A1(m|0)|0;c[f+(h<<2)>>2]=p;m=p+g|0;p=h+1|0;if((p|0)<128){g=m;h=p}else{n=m;o=p;break}}h=hg(n+1|0)|0;n=c[j>>2]|0;if((n|0)!=0){A$(h|0,b|0,n)|0}b=h+n|0;c[l>>2]=d;c[l+4>>2]=0;if((o|0)>1){q=b;r=1}else{s=b;a[s]=0;i=e;return h|0}while(1){b=(B=c[k+4>>2]|0,c[k+4>>2]=B+8,c[(c[k>>2]|0)+B>>2]|0);l=f+(r<<2)|0;d=c[l>>2]|0;A$(q|0,b|0,d)|0;d=q+(c[l>>2]|0)|0;l=r+1|0;if((l|0)<(o|0)){q=d;r=l}else{s=d;break}}a[s]=0;i=e;return h|0}function i1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a>>2]|0;e=(b|0)==0;if((d|0)==0){if(e){f=0;return f|0}c[a>>2]=hk(b)|0;f=0;return f|0}if(e){hj(d);c[a>>2]=0;f=0;return f|0}if((a9(d|0,b|0)|0)==0){f=-1;return f|0}e=hi(d,(A1(b|0)|0)+1|0)|0;c[a>>2]=e;A9(e|0,b|0)|0;f=0;return f|0}function i2(b){b=b|0;var c=0,d=0;if((b|0)==0){c=3823}else{if((a[b]|0)==0){c=3823}else{d=0}}if((c|0)==3823){d=-1}return d|0}function i3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=(e|0)>10;if(g){h=(e<<24)+905969664>>24}else{h=0}i=(bS(a[b]|0)|0)<<24;j=i>>24;do{if(!((aY(j|0)|0)!=0|(j-48|0)>>>0<10>>>0)){if(!((e|0)<11|(j|0)>(h|0)|(i|0)<1090519040)){break}if((j|0)==45|(j|0)==43){break}else{k=-1}return k|0}}while(0);j=a[b]|0;if((j<<24>>24|0)==43){l=1;m=b+1|0}else if((j<<24>>24|0)==45){l=-1;m=b+1|0}else{l=1;m=b}b=m;while(1){if((aY(a[b]|0)|0)==0){break}b=b+1|0}L4684:do{if(g){m=b;while(1){j=a[m]|0;if((j-48|0)>>>0>=10>>>0){if((bS(j|0)|0)>(h|0)){n=m;break L4684}if((bS(a[m]|0)|0)<=64){n=m;break L4684}}m=m+1|0}}else{m=b;while(1){if(((a[m]|0)-48|0)>>>0>=10>>>0){n=m;break L4684}m=m+1|0}}}while(0);if((n|0)==(b|0)){k=-1;return k|0}if((d|0)!=0){c[d>>2]=n}d=n-1|0;L4701:do{if(d>>>0<b>>>0){o=0}else{if(g){p=1;q=0;r=d}else{n=1;h=0;m=d;while(1){j=(ag((a[m]|0)-48|0,n)|0)+h|0;i=ag(n,e)|0;s=m-1|0;if(s>>>0<b>>>0){o=j;break L4701}else{n=i;h=j;m=s}}}while(1){m=(bS(a[r]|0)|0)>64;h=a[r]|0;if(m){t=(bS(h|0)|0)-55|0}else{t=h-48|0}h=(ag(t,p)|0)+q|0;m=ag(p,e)|0;n=r-1|0;if(n>>>0<b>>>0){o=h;break}else{p=m;q=h;r=n}}}}while(0);c[f>>2]=ag(o,l)|0;k=0;return k|0}function i4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=A1(a|0)|0;e=A1(b|0)|0;f=A1(c|0)|0;g=a0(a|0,b|0)|0;if((g|0)==0){h=0}else{i=0;j=g;while(1){g=i+1|0;k=a0(j+e|0,b|0)|0;if((k|0)==0){h=g;break}else{i=g;j=k}}}j=hg(d+1-(ag(h,e-f|0)|0)|0)|0;i=h;h=d;d=j;k=a;while(1){a=a0(k|0,b|0)|0;if((a|0)==0){l=h;m=d;n=k;o=3865;break}g=a-k|0;A$(d|0,k|0,g)|0;p=d+g|0;A$(p|0,c|0,f)|0;p=d+(g+f)|0;q=h-e-g|0;g=a+e|0;a=i-1|0;if((a|0)==0){l=q;m=p;n=g;o=3864;break}else{i=a;h=q;d=p;k=g}}if((o|0)==3864){r=l+1|0;A$(m|0,n|0,r)|0;return j|0}else if((o|0)==3865){r=l+1|0;A$(m|0,n|0,r)|0;return j|0}return 0}function i5(a){a=a|0;var b=0,c=0;b=bq(a|0)|0;cE(a|0,0,2)|0;c=bq(a|0)|0;cE(a|0,b|0,0)|0;return c|0}function i6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((b|0)==0){c[e>>2]=0;c[d>>2]=0;return}f=bv(b|0,47)|0;g=(d|0)!=0;if((f|0)==0){if(g){c[d>>2]=0}if((e|0)==0){return}c[e>>2]=hk(b)|0;return}else{if(g){g=f-b|0;h=hg(g+1|0)|0;c[d>>2]=h;A$(h|0,b|0,g)|0;a[(c[d>>2]|0)+g|0]=0}if((e|0)==0){return}c[e>>2]=hk(f+1|0)|0;return}}function i7(){return h1(49320)|0}function i8(b,d){b=+b;d=d|0;var e=0;h[6405]=b;c[200942]=d;d=c[115258]|0;a[47968]=0;a[47816]=0;if((d|0)>0&b>0.0){c[80942]=d;e=~~(+(c[80454]|0)/b*100.0/+(d|0));c[200830]=e;c[200828]=e;return}else{c[80942]=0;c[200830]=0;return}}function i9(b){b=b|0;c[80456]=b;hM();iv();a[47816]=0;a[47968]=0;fZ(c[198578]|0,160,0);fe();c[80454]=fc()|0;return}function ja(){hM();iv();a[47816]=0;a[47968]=0;return}function jb(a,b){a=a|0;b=b|0;c[81088]=(c[81088]|0)-a;return}function jc(){return 0}function jd(){a[47816]=0;return}function je(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;c[80458]=(c[80458]|0)+1;fg();if((hL()|0)==0){e=0}else{e=fd()|0}dd[c[80456]&63]();do{if((hL()|0)!=0){f=(fd()|0)-e|0;if(f>>>0<=(c[200830]|0)>>>0){break}c[80466]=(c[80466]|0)+f;c[121478]=(c[121478]|0)+f}}while(0);e=(c[80470]|0)+1|0;c[80470]=e;do{if(a[47968]|0){f=c[121478]|0;g=f-(c[200912]|0)|0;h=c[80454]|0;if((g|0)<(h<<1|0)){break}if((c[80942]|0)==0){j=1.0}else{j=+(c[200830]|0)/+(c[200828]|0)}k=+(g|0)/+(h|0)/j;if((c[14078]|0)==0&(c[13586]|0)!=10){ff(+(((c[198580]|0)-(c[81088]|0)|0)>>>0>>>0)*100.0/(k*+(c[200942]|0)),+(e-(c[80462]|0)|0)/k,c[80450]|0);l=c[121478]|0}else{l=f}c[81088]=c[198580];c[200912]=l;c[80470]=0;c[80462]=0}}while(0);if((d|0)!=0){c[80462]=(c[80462]|0)+1}j=+it();d=fd()|0;c[121478]=d;if(!(a[47968]|0)){a[47968]=1;c[81088]=c[198580];c[200912]=d;c[80470]=0;c[80462]=0;c[80466]=d;c[80460]=0}if(a[47816]|0){m=c[200830]|0}else{a[47816]=1;c[80474]=d;c[80468]=0;c[80472]=0;c[80464]=0;l=((c[200830]|0)+(c[200828]|0)|0)/2|0;c[200830]=l;m=l}l=d-(c[80466]|0)|0;e=c[80942]|0;f=(ag(((m|0)/100|0)*3|0,e)|0)+((ag(((m|0)%100|0)*3|0,e)|0)/100|0)|0;m=c[80460]|0;L4788:do{if((m|0)<10){do{if((c[80450]|0)==0){h=c[115272]|0;if((m|0)<(h-1|0)){break}if((e|0)==0){if((h|0)==0){break}else{n=0;o=0;break L4788}}else{if((l|0)<=(f|0)|(h|0)!=0){n=0;o=0;break L4788}else{break}}}}while(0);n=1;o=m+1|0}else{n=0;o=0}}while(0);c[80460]=o;if((l|0)>=((c[80454]|0)/8|0|0)){if((c[80450]|0)==0&(c[115258]|0)!=0){hu(-2,78752,(l=i,i=i+1|0,i=i+7&-8,c[l>>2]=0,l)|0)|0;i=l;p=c[121478]|0}else{p=d}a[47816]=0;c[80466]=p}p=c[80468]|0;if((p|0)!=2147483647){c[80468]=p+1}do{if((hL()|0)==0){p=c[121478]|0;d=c[80454]|0;if((p-(c[80474]|0)|0)<((d|0)/5|0|0)){q=d;break}d=c[80468]|0;l=(c[80472]|0)/(d|0)|0;c[80472]=l;o=(l-(c[80464]|0)+((l|0)/8|0)|0)/(d|0)|0;d=(o|0)>-1?o:-o|0;m=c[200830]|0;if((d|0)>((m|0)/100|0|0)){r=(ag((o|0)/(d|0)|0,m)|0)/100|0}else{r=o}o=m-r|0;c[200830]=o;c[80468]=0;c[80464]=l;c[80472]=0;c[80474]=p;s=o;t=c[80466]|0;u=t+s|0;c[80466]=u;fh();i=b;return n|0}else{q=c[80454]|0}}while(0);c[80472]=~~(j*+(q|0))+(c[80472]|0);s=c[200830]|0;t=c[80466]|0;u=t+s|0;c[80466]=u;fh();i=b;return n|0}function jf(b,d){b=b|0;d=d|0;var e=0.0;c[115258]=b;iC(b);b=c[115258]|0;a[47968]=0;a[47816]=0;e=+h[6405];if((b|0)>0&e>0.0){c[80942]=b;d=~~(+(c[80454]|0)/e*100.0/+(b|0));c[200830]=d;c[200828]=d;return 0}else{c[80942]=0;c[200830]=0;return 0}return 0}function jg(a,b){a=a|0;b=b|0;var d=0;if((a|0)<0){d=-1}else{c[115272]=a;d=0}return d|0}function jh(b,d){b=b|0;d=d|0;var e=0.0;c[80450]=b;iD(b);b=c[115258]|0;a[47968]=0;a[47816]=0;e=+h[6405];if((b|0)>0&e>0.0){c[80942]=b;d=~~(+(c[80454]|0)/e*100.0/+(b|0));c[200830]=d;c[200828]=d;return 0}else{c[80942]=0;c[200830]=0;return 0}return 0}function ji(){var a=0,b=0;a=c[57914]|0;if((a|0)==0){c[57914]=0;return}else{b=a}while(1){hj(c[b+4>>2]|0);hj(c[b>>2]|0);a=c[b+28>>2]|0;hj(b);if((a|0)==0){break}else{b=a}}c[57914]=0;return}function jj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;e=i;i=i+1480|0;f=e|0;g=e+8|0;h=e+88|0;j=e+96|0;k=e+104|0;l=e+128|0;m=e+136|0;n=e+152|0;o=e+160|0;p=e+416|0;q=e+424|0;r=e+456|0;if(!(a[16]|0)){c[2]=hq(79464)|0;s=c[57914]|0;if((s|0)!=0){t=s;while(1){hj(c[t+4>>2]|0);hj(c[t>>2]|0);s=c[t+28>>2]|0;hj(t);if((s|0)==0){break}else{t=s}}}c[57914]=0;a[16]=1}if((b|0)==0){u=0;i=e;return u|0}if((a[b]|0)==0){u=0;i=e;return u|0}if((cL(d|0,119)|0)==0){if((cL(d|0,43)|0)==0){v=0;w=1}else{x=3966}}else{x=3966}do{if((x|0)==3966){if((gO(b,2)|0)<0){u=0}else{v=1;w=0;break}i=e;return u|0}}while(0);t=r|0;s=q|0;y=q+4|0;z=q+8|0;A=q+12|0;B=q+16|0;C=q+20|0;D=q+24|0;E=q+28|0;q=0;while(1){F=c[46856+(q*20|0)>>2]|0;G=c[46860+(q*20|0)>>2]|0;H=c[46864+(q*20|0)>>2]|0;I=c[46868+(q*20|0)>>2]|0;J=c[46872+(q*20|0)>>2]|0;c[p>>2]=0;K=A1(b|0)|0;L=A1(I|0)|0;do{if(K>>>0>L>>>0){if((A8(b+(K-L)|0,I|0)|0)!=0){M=0;break}c[s>>2]=hk(F)|0;c[y>>2]=hk(G)|0;c[z>>2]=e0(b)|0;c[A>>2]=0;N=eZ(F,s,p,0)|0;hj(c[s>>2]|0);hj(c[y>>2]|0);hj(c[z>>2]|0);O=c[p>>2]|0;if((N|0)!=0){gR(O)|0;hj(c[p>>2]|0);M=0;break}N=bV(O|0,88792)|0;if((N|0)==0){O=c[p>>2]|0;gR(O)|0;hj(c[p>>2]|0);M=0;break}O=(q|0)==0;P=O<<31>>31;if(O){Q=A1(J|0)|0}else{Q=0}L4873:do{if((cy(N|0)|0)==0){O=P;R=0;S=1;while(1){if((bk(t|0,1024,N|0)|0)==0){T=O;U=S;break L4873}V=A1(t|0)|0;L4877:do{if((V|0)==0){W=R;X=O}else{Y=V;Z=O;while(1){_=Y-1|0;a[r+_|0]=0;if(Z>>>0<1025>>>0|_>>>0<Q>>>0){$=Z}else{aa=(A8(r+(_-Q)|0,J|0)|0)==0;$=aa?Y-5|0:Z}if($>>>0<1025>>>0){do{if(($+2|0)>>>0<_>>>0){if(((a[r+$|0]|0)-49&255)>>>0>=4>>>0){ab=0;break}if((a[r+($+1)|0]|0)==33){W=1;X=$;break L4877}else{ab=0}}else{ab=0}}while(0);do{aa=c[56032+(ab<<2)>>2]|0;ac=A1(aa|0)|0;if((ac+$|0)>>>0<=_>>>0){if((A8(aa|0,r+(_-ac)|0)|0)==0){W=1;X=$;break L4877}}ab=ab+1|0;}while((ab|0)!=15)}if((_|0)==0){W=R;X=$;break}else{Y=_;Z=$}}}}while(0);V=(W|0)==0;if((cy(N|0)|0|W|0)==0){O=X;R=W;S=V}else{T=X;U=V;break}}}else{T=P;U=1}}while(0);aM(N|0)|0;P=c[p>>2]|0;gR(P)|0;if(U){hj(c[p>>2]|0);M=0;break}if(!w){hj(c[p>>2]|0);M=871032;break}c[s>>2]=hk(F)|0;c[y>>2]=hk(H)|0;c[z>>2]=e0(b)|0;P=r+T|0;do{if(((a[P]|0)-49&255)>>>0<4>>>0){if((a[r+(T+1)|0]|0)!=33){x=3998;break}c[A>>2]=hk(P)|0;c[B>>2]=hk(P)|0;c[C>>2]=hk(P)|0;c[D>>2]=hk(P)|0;c[E>>2]=0;a[c[A>>2]|0]=49;a[c[B>>2]|0]=50;a[c[C>>2]|0]=51;a[c[D>>2]|0]=52}else{x=3998}}while(0);if((x|0)==3998){x=0;c[A>>2]=e1(P)|0;c[B>>2]=0}N=eZ(F,s,p,0)|0;hj(c[s>>2]|0);hj(c[y>>2]|0);hj(c[z>>2]|0);hj(c[A>>2]|0);do{if(((a[P]|0)-49&255)>>>0<4>>>0){if((a[r+(T+1)|0]|0)!=33){break}hj(c[B>>2]|0);hj(c[C>>2]|0);hj(c[D>>2]|0)}}while(0);P=c[p>>2]|0;if((N|0)==0){M=P;break}gR(P)|0;hj(c[p>>2]|0);M=0}else{M=0}}while(0);F=q+1|0;if((M|0)!=0){ad=M;ae=3;break}if((F|0)==10){x=4005;break}else{q=F}}L4915:do{if((x|0)==4005){q=o|0;c[n>>2]=0;do{if((e4(b)|0)!=0){M=e3(n,84616)|0;if((M|0)==0){break}p=cf(b|0,88792)|0;if((p|0)==0){aM(M|0)|0;D=c[n>>2]|0;gR(D)|0;hj(c[n>>2]|0);break}while(1){D=cH(p|0,q|0,256)|0;if((D|0)<=0){x=4012;break}if((aU(q|0,1,D|0,M|0)|0)>>>0<D>>>0){x=4011;break}}if((x|0)==4011){cX(p|0)|0;aM(M|0)|0;N=c[n>>2]|0;gR(N)|0;hj(c[n>>2]|0);break}else if((x|0)==4012){cX(p|0)|0;aM(M|0)|0;N=c[n>>2]|0;if((N|0)==0){break}else{ad=N;ae=1;break L4915}}}}while(0);c[l>>2]=0;N=A1(b|0)|0;do{if(N>>>0>=5>>>0){if((A8(b+(N-4)|0,85040)|0)!=0){break}D=m|0;c[D>>2]=hk(77472)|0;C=m+4|0;c[C>>2]=hk(84728)|0;B=m+8|0;c[B>>2]=e0(b)|0;c[m+12>>2]=0;T=eZ(77472,D,l,0)|0;hj(c[D>>2]|0);hj(c[C>>2]|0);hj(c[B>>2]|0);B=c[l>>2]|0;if((T|0)==0){if((B|0)==0){break}else{ad=B;ae=2;break L4915}}else{gR(B)|0;hj(c[l>>2]|0);break}}}while(0);c[h>>2]=0;i6(b,0,h);N=c[h>>2]|0;L4936:do{if((N|0)==0){af=0}else{do{if((A1(N|0)|0)>>>0>=3>>>0){if((a[N+1|0]|0)!=33){break}hj(N);B=bV(b|0,88792)|0;if((B|0)==0){af=0;break L4936}cE(B|0,4,0)|0;T=0;C=1;while(1){if((jl(B,1,j,q)|0)!=0){x=4027;break}D=c[j>>2]|0;if(D>>>0>20>>>0){x=4027;break}r=1<<D;if((r&T|0)!=0){x=4027;break}D=C+1|0;if((D|0)<21){T=r|T;C=D}else{break}}if((x|0)==4027){aM(B|0)|0;af=0;break L4936}aM(B|0)|0;if(!w){af=871032;break L4936}c[h>>2]=e2()|0;C=k|0;c[C>>2]=hk(86864)|0;T=k+4|0;c[T>>2]=hk(85344)|0;D=k+8|0;c[D>>2]=hk(c[h>>2]|0)|0;r=k+12|0;c[r>>2]=e0(b)|0;c[k+16>>2]=0;A=eZ(86864,C,0,0)|0;hj(c[C>>2]|0);hj(c[T>>2]|0);hj(c[D>>2]|0);hj(c[r>>2]|0);r=c[h>>2]|0;if((A|0)==0){af=r;break L4936}gR(r)|0;hj(c[h>>2]|0);af=0;break L4936}}while(0);hj(N);af=0}}while(0);if((af|0)!=0){ad=af;ae=4;break}N=bV(b|0,88792)|0;L4955:do{if((N|0)!=0){M=(cr(q|0,1,2,N|0)|0)==2;do{if(M&(a[q]|0)==1){if((a[o+1|0]|0)==8){ag=0}else{break}do{if((cr(q|0,1,1,N|0)|0)!=1){x=4038;break}ag=(a[q]|0)==0?ag+1|0:0;}while((ag|0)!=3);if((x|0)==4038){aM(N|0)|0;break L4955}B=(cr(q|0,1,1,N|0)|0)==1;if(B&(a[q]|0)==13){ah=0}else{aM(N|0)|0;break L4955}do{B=o+ah|0;if((cr(B|0,1,1,N|0)|0)!=1|(ah|0)==254){x=4043;break}ah=ah+1|0;}while((a[B]|0)!=13);if((x|0)==4043){aM(N|0)|0;break L4955}a[o+ah|0]=0;B=(b7(q|0)|0)==0;aM(N|0)|0;if(B){break L4955}if(!w){ad=871032;ae=5;break L4915}B=e2()|0;p=g|0;c[p>>2]=hk(86864)|0;r=g+4|0;c[r>>2]=hk(86600)|0;A=g+8|0;c[A>>2]=hk(86328)|0;D=g+12|0;c[D>>2]=hk(86024)|0;T=g+16|0;c[T>>2]=hk(B)|0;C=g+20|0;c[C>>2]=hk(85816)|0;z=g+24|0;c[z>>2]=e0(b)|0;c[g+28>>2]=0;y=eZ(86864,p,0,0)|0;hj(c[p>>2]|0);hj(c[r>>2]|0);hj(c[A>>2]|0);hj(c[D>>2]|0);hj(c[T>>2]|0);hj(c[C>>2]|0);hj(c[z>>2]|0);if((y|0)==0){if((B|0)==0){break L4955}else{ad=B;ae=5;break L4915}}else{gR(B)|0;hj(B);break L4955}}}while(0);aM(N|0)|0}}while(0);c[f>>2]=0;N=A1(b|0)|0;do{if(N>>>0<4>>>0){ai=0}else{if((A8(b+(N-4)|0,88e3)|0)!=0){ai=0;break}q=m|0;c[q>>2]=hk(87584)|0;M=m+4|0;c[M>>2]=e0(b)|0;c[m+8>>2]=0;B=eZ(87584,q,f,0)|0;hj(c[q>>2]|0);hj(c[M>>2]|0);M=c[f>>2]|0;if((B|0)==0){B=(M|0)==0;q=B?0:6;if(B){ai=q;break}else{ad=M;ae=q;break L4915}}else{gR(M)|0;hj(c[f>>2]|0);ai=0;break}}}while(0);N=bV(b|0,d|0)|0;if((N|0)==0){u=0;i=e;return u|0}M=hg(40)|0;q=M;B=M+4|0;e_(B,b)|0;c[M>>2]=0;c[M+8>>2]=v;c[M+12>>2]=N;c[M+16>>2]=0;c[M+20>>2]=ai;c[M+32>>2]=0;c[M+36>>2]=0;c[M+28>>2]=c[57914];c[M+24>>2]=0;M=c[57914]|0;if((M|0)!=0){c[M+24>>2]=q}c[57914]=q;u=N;i=e;return u|0}}while(0);if((a[ad]|0)==0){c[(cd()|0)>>2]=13;u=0;i=e;return u|0}ai=bV(ad|0,d|0)|0;if((ai|0)==0){u=0;i=e;return u|0}d=hg(40)|0;f=d;e_(d+4|0,b)|0;if((ad|0)==0){aj=0}else{aj=hk(ad)|0}c[d>>2]=aj;c[d+8>>2]=v;c[d+12>>2]=ai;c[d+16>>2]=0;c[d+20>>2]=ae;c[d+32>>2]=0;c[d+36>>2]=0;c[d+28>>2]=c[57914];c[d+24>>2]=0;d=c[57914]|0;if((d|0)!=0){c[d+24>>2]=f}c[57914]=f;hj(ad);u=ai;i=e;return u|0}function jk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+264|0;e=d|0;f=d+8|0;if(!(a[16]|0)){c[(cd()|0)>>2]=9;g=-1;i=d;return g|0}h=c[57914]|0;L5014:do{if((h|0)!=0){j=h;while(1){if((c[j+12>>2]|0)==(b|0)){break}k=c[j+28>>2]|0;if((k|0)==0){break L5014}else{j=k}}if((aM(b|0)|0)==-1){g=-1;i=d;return g|0}k=j|0;l=c[k>>2]|0;m=j+4|0;do{if((l|0)!=0){n=c[m>>2]|0;L5024:do{if((n|0)!=0){if((c[j+8>>2]|0)==0){break}o=c[j+20>>2]|0;L5027:do{if((o|0)==6){p=c[2]|0;hv(p,80960,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q}else if((o|0)==4){hv(c[2]|0,84064,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q}else if((o|0)==3){hv(c[2]|0,86664,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q}else if((o|0)==5){hv(c[2]|0,82200,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q}else{if((o-1|0)>>>0>1>>>0){p=c[2]|0;hv(p,79976,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break}if((gO(n,2)|0)<0){break}do{if((gO(n,4)|0)<0){r=0}else{p=eU(n)|0;if((p|0)==0){r=0;break}if((gS(n,p)|0)>=0){r=p;break}p=c[2]|0;hv(p,79056,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break L5027}}while(0);L5040:do{if((o|0)==1){p=f|0;s=bV(n|0,88792)|0;do{if((s|0)!=0){t=cf(l|0,88416)|0;if((t|0)==0){aM(s|0)|0;break}u=cr(p|0,256,1,s|0)|0;if((u|0)!=0){v=u;do{cP(t|0,p|0,v|0)|0;v=cr(p|0,256,1,s|0)|0;}while((v|0)!=0)}cX(t|0)|0;aM(s|0)|0;e5(n)|0;if((r|0)==0){break L5024}else{w=0;x=4111;break L5040}}}while(0);if((r|0)==0){break L5027}else{x=4108}}else if((o|0)==2){c[201214]=hk(77472)|0;c[201215]=hk(89728)|0;c[201216]=hk(l)|0;c[201217]=0;c[e>>2]=hk(n)|0;s=eZ(77472,804856,e,0)|0;hj(c[e>>2]|0);hj(c[201214]|0);hj(c[201215]|0);hj(c[201216]|0);p=(s|0)!=0;s=p<<31>>31;v=(r|0)!=0;if(p){if(v){x=4108;break}else{break L5027}}else{if(v){w=s;x=4111;break}else{y=s;break}}}else{if((r|0)==0){break L5027}else{x=4108}}}while(0);do{if((x|0)==4111){if((gR(r)|0)>=0){z=w;x=4113;break}s=c[2]|0;hv(s,78016,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;z=w;x=4113}else if((x|0)==4108){if((gS(r,n)|0)>=0){z=-1;x=4113;break}hv(c[2]|0,78440,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;z=-1;x=4113}}while(0);if((x|0)==4113){hj(r);y=z}if((y|0)==0){break L5024}}}while(0);c[(cd()|0)>>2]=9;g=-1;i=d;return g|0}}while(0);if((gR(c[k>>2]|0)|0)>=0){break}n=c[2]|0;o=c[k>>2]|0;s=ce(c[(cd()|0)>>2]|0)|0;hv(n,78656,(q=i,i=i+16|0,c[q>>2]=o,c[q+8>>2]=s,q)|0)|0;i=q}}while(0);l=c[m>>2]|0;do{if((l|0)!=0){if(((c[j+32>>2]|0)-1|0)>>>0>=2>>>0){break}if((gR(l)|0)>=0){break}s=c[2]|0;o=c[m>>2]|0;n=ce(c[(cd()|0)>>2]|0)|0;hv(s,78656,(q=i,i=i+16|0,c[q>>2]=o,c[q+8>>2]=n,q)|0)|0;i=q}}while(0);l=j+24|0;n=c[l>>2]|0;o=j+28|0;s=c[o>>2]|0;if((n|0)==0){c[57914]=s}else{c[n+28>>2]=s}s=c[o>>2]|0;if((s|0)!=0){c[s+24>>2]=c[l>>2]}l=c[m>>2]|0;if((l|0)!=0){hj(l)}l=c[k>>2]|0;if((l|0)!=0){hj(l)}l=c[j+36>>2]|0;if((l|0)!=0){hj(l)}hj(j);g=0;i=d;return g|0}}while(0);g=aM(b|0)|0;i=d;return g|0}function jl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h|0;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=cr(j|0,1,1,b|0)|0;q=cr(k|0,1,1,b|0)|0;c[f>>2]=d[k]|0;k=d[j]|0;if((k&63|0)!=(e|0)|(p|0)==0|(q|0)==0){r=-1;i=h;return r|0}if((k&128|0)==0){if((k&64|0)==0){k=(cr(g|0,256,1,b|0)|0)==0;r=k?-5:0;i=h;return r|0}if((cr(o|0,1,1,b|0)|0)==0){r=-4;i=h;return r|0}A2(g|0,a[o]|0,256);r=0;i=h;return r|0}k=cr(l|0,1,1,b|0)|0;if((k|0)==0|(cr(m|0,1,1,b|0)|0)==0){r=-2;i=h;return r|0}k=a[l]|0;if(k<<24>>24==0){r=0;i=h;return r|0}l=a[m]|0;m=k&255;k=0;q=0;L5117:while(1){if((cr(o|0,1,1,b|0)|0)==0){r=-3;s=4159;break}p=a[o]|0;do{if(p<<24>>24==l<<24>>24){e=cr(n|0,1,1,b|0)|0;if((e|0)==0|(cr(o|0,1,1,b|0)|0)==0){r=1;s=4158;break L5117}e=k+2|0;j=a[n]|0;if(j<<24>>24==0){t=q;u=e;break}f=j&255;j=f>>>0>1>>>0?f:1;A2(g+q|0,a[o]|0,j|0);t=q+j|0;u=e}else{a[g+q|0]=p;t=q+1|0;u=k}}while(0);p=u+1|0;if(p>>>0<m>>>0){k=p;q=t}else{r=0;s=4160;break}}if((s|0)==4158){i=h;return r|0}else if((s|0)==4159){i=h;return r|0}else if((s|0)==4160){i=h;return r|0}return 0}function jm(){return 0}function jn(a){a=a|0;if((c[215604]|0)==0){l9(a)}else{ml(a)}c[121460]=a;return}function jo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;L5137:do{if((c[200816]|0)==1){d=c[121460]|0;e=(d^a|0)==3;do{if(e){if(!((a-1&a|0)==0&(a|0)!=0)){break}jp();f=3;break L5137}}while(0);if((b|0)==0){f=a;break}if((d|0)<=(a|0)|e){f=a;break}jp();c[121460]=a;return}else{f=a}}while(0);if((c[215604]|0)==0){l9(f);c[121460]=a;return}else{ml(f);c[121460]=a;return}}function jp(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=c[200820]|0;b=(c[198580]|0)+1|0;d=c[a+4>>2]|0;e=a+12|0;f=c[e>>2]|0;if((f|0)<0){g=d+2056|0;h=c[g>>2]|0;if(h>>>0>255>>>0){fW();c[200818]=1;return}c[d+8+(h<<3)>>2]=a;c[d+8+(h<<3)+4>>2]=b;c[g>>2]=(c[g>>2]|0)+1;g=d+2060|0;if((c[g>>2]|0)>>>0>b>>>0){c[g>>2]=b;c[d+2064>>2]=h}c[e>>2]=h;c[200818]=1;return}else{c[d+8+(f<<3)+4>>2]=b;h=d+2060|0;e=d+2064|0;g=c[e>>2]|0;do{if((c[h>>2]|0)>>>0>b>>>0){i=g}else{if((f|0)==(g|0)){i=f;break}c[200818]=1;return}}while(0);f=c[d+2056>>2]|0;if((f|0)==0){j=i;k=-1}else{g=i;i=0;b=-1;while(1){a=c[d+8+(i<<3)+4>>2]|0;l=a>>>0>b>>>0;m=l?g:i;n=l?b:a;a=i+1|0;if(a>>>0<f>>>0){g=m;i=a;b=n}else{j=m;k=n;break}}}c[h>>2]=k;c[e>>2]=j;c[200818]=1;return}}function jq(){if((c[200818]|0)!=0){fV(c[200820]|0);c[200818]=0}c[121460]=0;if((c[215604]|0)==0){l9(0);return}else{ml(0);return}}function jr(){return h1(49264)|0}function js(){c[200820]=fU(c[198582]|0,78104,52,0)|0;return}function jt(a,b){a=a|0;b=b|0;b=c[121460]|0;if((c[215604]|0)==0){l9(b)}else{ml(b)}fV(c[200820]|0);c[200818]=0;return}function ju(a,b){a=a|0;b=b|0;c[200816]=a;return 0}function jv(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=hg(12)|0;e=d;if((a|0)==0){bY(78080,86360,414,90176);return 0}switch(b[a+12>>1]&65280|0){case 53760:{f=862368;break};case 55040:{f=862288;break};case 54016:{f=862352;break};case 54784:{f=862304;break};case 54528:{f=862320;break};case 53504:{f=862384;break};case 57088:{f=862256;break};case 56832:{f=862272;break};case 53248:{f=862400;break};case 54272:{f=862336;break};default:{f=0}}while(1){g=f+8|0;h=c[g>>2]|0;if((h|0)==0){break}else{f=h}}c[g>>2]=e;c[d>>2]=f;f=d+4|0;c[f>>2]=a;c[d+8>>2]=0;d=c[121454]|0;c[121454]=d+1;c[(c[f>>2]|0)+48>>2]=d;return e|0}function jw(a){a=a|0;var b=0,d=0,e=0,f=0;if((a|0)==0){bY(78080,86360,466,90152)}b=c[a>>2]|0;d=a+8|0;c[b+8>>2]=c[d>>2];e=c[d>>2]|0;if((e|0)!=0){c[e>>2]=b}b=c[(c[a+4>>2]|0)+48>>2]|0;e=c[121454]|0;if(!((b|0)==(e-1|0)&(e|0)!=0)){f=a;hj(f);return}c[121454]=b;f=a;hj(f);return}function jx(a){a=a|0;return jy(862400,a)|0}function jy(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;g=c[a+8>>2]|0;pp(0);do{if((g|0)!=0){h=g;j=0;k=0;l=0;m=-1;L5222:while(1){n=h+4|0;o=c[n>>2]|0;p=c[o+28>>2]|0;do{if((p|0)==0){q=m;r=l;s=k;t=j}else{if((e[o+12>>1]|0)>>>0>(d&65535)>>>0){q=m;r=l;s=k;t=j;break}if((e[o+14>>1]|0)>>>0<(d&65535)>>>0){q=m;r=l;s=k;t=j;break}u=da[p&255](b[o+16>>1]&d)|0;v=c[n>>2]|0;if((c[v+20>>2]|0)==0){q=m;r=u;s=k;t=j;break}w=c[v+44>>2]|0;if((w|0)==1){x=u;y=4330;break L5222}z=c[200808]|0;if((z|0)==1){A=c[v+48>>2]|0;v=A>>>0<m>>>0;B=v?A:m;C=v?u:k}else{B=m;C=k}q=B;r=u;s=((z|0)==2?u:-1)&C;t=((w|0)!=-1)+j|0}}while(0);n=c[h+8>>2]|0;if((n|0)==0){break}else{h=n;j=t;k=s;l=r;m=q}}if((y|0)==4330){i=f;return x|0}if((t|0)==0){break}else if((t|0)==1){x=r;i=f;return x|0}m=c[200808]|0;if((m|0)==1){l=hg(t*20|0)|0;k=l;j=t-1|0;h=0;n=0;o=0;p=a;L5242:while(1){w=c[p+8>>2]|0;if((w|0)==0){D=h;E=o;break}else{F=w}L5244:while(1){G=F+4|0;H=c[G>>2]|0;do{if((c[H+20>>2]|0)!=0){if((e[H+12>>1]|0)>>>0>(d&65535)>>>0){break}if((e[H+14>>1]|0)>>>0<(d&65535)>>>0){break}if((c[H+44>>2]|0)==0){break L5244}}}while(0);w=c[F+8>>2]|0;if((w|0)==0){D=h;E=o;break L5242}else{F=w}}c[k+(h*20|0)>>2]=c[H+4>>2];c[k+(h*20|0)+8>>2]=c[(c[G>>2]|0)+8>>2];c[k+(h*20|0)+4>>2]=c[c[G>>2]>>2];c[k+(h*20|0)+12>>2]=c[(c[G>>2]|0)+40>>2];c[k+(h*20|0)+16>>2]=c[(c[G>>2]|0)+48>>2];w=c[G>>2]|0;if((c[w+48>>2]|0)==(q|0)){I=c[w>>2]|0}else{I=n}do{if((h|0)==0){u=hk(iX(65954)|0)|0;z=i0(u,(J=i,i=i+16|0,c[J>>2]=c[c[G>>2]>>2],c[J+8>>2]=0,J)|0)|0;i=J;hj(u);K=z}else{if((h|0)==(j|0)){K=o;break}z=c[w>>2]|0;u=i0(o,(J=i,i=i+24|0,c[J>>2]=80888,c[J+8>>2]=z,c[J+16>>2]=0,J)|0)|0;i=J;hj(o);K=u}}while(0);if((h|0)==(j|0)){w=iX(65967)|0;u=c[c[G>>2]>>2]|0;z=iX(65993)|0;v=iX(66006)|0;A=i0(K,(J=i,i=i+48|0,c[J>>2]=w,c[J+8>>2]=u,c[J+16>>2]=z,c[J+24>>2]=I,c[J+32>>2]=v,c[J+40>>2]=0,J)|0)|0;i=J;hj(K);L=A}else{L=K}A=h+1|0;if((A|0)==(t|0)){D=t;E=L;break}else{h=A;n=I;o=L;p=F}}L5264:do{if((D|0)!=0){p=d&65535;hs(-2,E,(J=i,i=i+8|0,c[J>>2]=p,J)|0)|0;i=J;fC(E,(J=i,i=i+8|0,c[J>>2]=p,J)|0);i=J;hj(E);if((D|0)>0){M=0}else{break}L5266:while(1){if((c[k+(M*20|0)+16>>2]|0)!=(q|0)){p=c[k+(M*20|0)>>2]|0;do{if((p|0)==1){o=c[k+(M*20|0)+8>>2]|0;h8(o,0)|0}else if((p|0)==0){o=c[k+(M*20|0)+12>>2]|0;if((o|0)==(-1|0)){break}else if((o|0)==0){break L5266}mn(o)}}while(0);fI()}M=M+1|0;if((M|0)>=(D|0)){break L5264}}bY(79888,86360,93,90200);return 0}}while(0);hj(l);x=s;i=f;return x|0}else if((m|0)==0){k=hg(t*20|0)|0;p=k;o=t-1|0;n=0;h=0;j=a;L5280:while(1){A=c[j+8>>2]|0;if((A|0)==0){N=n;O=h;break}else{P=A}L5282:while(1){Q=P+4|0;R=c[Q>>2]|0;do{if((c[R+20>>2]|0)!=0){if((e[R+12>>1]|0)>>>0>(d&65535)>>>0){break}if((e[R+14>>1]|0)>>>0<(d&65535)>>>0){break}if((c[R+44>>2]|0)==0){break L5282}}}while(0);A=c[P+8>>2]|0;if((A|0)==0){N=n;O=h;break L5280}else{P=A}}c[p+(n*20|0)>>2]=c[R+4>>2];c[p+(n*20|0)+8>>2]=c[(c[Q>>2]|0)+8>>2];c[p+(n*20|0)+4>>2]=c[c[Q>>2]>>2];c[p+(n*20|0)+12>>2]=c[(c[Q>>2]|0)+40>>2];do{if((n|0)==0){A=hk(iX(65954)|0)|0;v=i0(A,(J=i,i=i+16|0,c[J>>2]=c[c[Q>>2]>>2],c[J+8>>2]=0,J)|0)|0;i=J;hj(A);S=v}else{if((n|0)==(o|0)){S=h;break}v=c[c[Q>>2]>>2]|0;A=i0(h,(J=i,i=i+24|0,c[J>>2]=80888,c[J+8>>2]=v,c[J+16>>2]=0,J)|0)|0;i=J;hj(h);S=A}}while(0);if((n|0)==(o|0)){A=iX(65967)|0;v=c[c[Q>>2]>>2]|0;z=iX(65980)|0;u=i0(S,(J=i,i=i+32|0,c[J>>2]=A,c[J+8>>2]=v,c[J+16>>2]=z,c[J+24>>2]=0,J)|0)|0;i=J;hj(S);T=u}else{T=S}u=n+1|0;if((u|0)==(t|0)){N=t;O=T;break}else{n=u;h=T;j=P}}L5299:do{if((N|0)!=0){j=d&65535;hs(-2,O,(J=i,i=i+8|0,c[J>>2]=j,J)|0)|0;i=J;fC(O,(J=i,i=i+8|0,c[J>>2]=j,J)|0);i=J;hj(O);if((N|0)>0){U=0}else{break}L5301:while(1){j=c[p+(U*20|0)>>2]|0;do{if((j|0)==1){h=c[p+(U*20|0)+8>>2]|0;h8(h,0)|0}else if((j|0)==0){h=c[p+(U*20|0)+12>>2]|0;if((h|0)==(-1|0)){break}else if((h|0)==0){break L5301}mn(h)}}while(0);fI();U=U+1|0;if((U|0)>=(N|0)){break L5299}}bY(79888,86360,93,90200);return 0}}while(0);hj(k);x=p3()|0;i=f;return x|0}else if((m|0)==2){p=t-1|0;j=0;h=0;n=a;L5312:while(1){o=c[n+8>>2]|0;if((o|0)==0){V=j;W=h;break}else{X=o}L5314:while(1){Y=X+4|0;Z=c[Y>>2]|0;do{if((c[Z+20>>2]|0)!=0){if((e[Z+12>>1]|0)>>>0>(d&65535)>>>0){break}if((e[Z+14>>1]|0)>>>0<(d&65535)>>>0){break}if((c[Z+44>>2]|0)==0){break L5314}}}while(0);o=c[X+8>>2]|0;if((o|0)==0){V=j;W=h;break L5312}else{X=o}}do{if((j|0)==0){o=hk(iX(65954)|0)|0;l=i0(o,(J=i,i=i+16|0,c[J>>2]=c[c[Y>>2]>>2],c[J+8>>2]=0,J)|0)|0;i=J;hj(o);_=l}else{if((j|0)==(p|0)){_=h;break}l=c[Z>>2]|0;o=i0(h,(J=i,i=i+24|0,c[J>>2]=80888,c[J+8>>2]=l,c[J+16>>2]=0,J)|0)|0;i=J;hj(h);_=o}}while(0);if((j|0)==(p|0)){o=iX(65967)|0;l=c[c[Y>>2]>>2]|0;u=i0(_,(J=i,i=i+24|0,c[J>>2]=o,c[J+8>>2]=l,c[J+16>>2]=0,J)|0)|0;i=J;hj(_);$=u}else{$=_}u=j+1|0;if((u|0)==(t|0)){V=t;W=$;break}else{j=u;h=$;n=X}}if((V|0)==0){x=s;i=f;return x|0}hs(-2,W,(J=i,i=i+8|0,c[J>>2]=d&65535,J)|0)|0;i=J;hj(W);x=s;i=f;return x|0}else{x=p3()|0;i=f;return x|0}}}while(0);x=p3()|0;i=f;return x|0}function jz(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215602]|0;L5340:do{if((d|0)!=0){f=d;L5341:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4335;break L5341}j=c[g+28>>2]|0;if((j|0)!=0){i=4338;break L5341}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5340}}if((i|0)==4335){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4338){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jA(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215602]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jB(a){a=a|0;return jy(862384,a)|0}function jC(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215598]|0;L5373:do{if((d|0)!=0){f=d;L5374:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4362;break L5374}j=c[g+28>>2]|0;if((j|0)!=0){i=4365;break L5374}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5373}}if((i|0)==4362){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4365){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jD(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215598]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jE(a){a=a|0;return jy(862368,a)|0}function jF(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215594]|0;L5406:do{if((d|0)!=0){f=d;L5407:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4389;break L5407}j=c[g+28>>2]|0;if((j|0)!=0){i=4392;break L5407}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5406}}if((i|0)==4389){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4392){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jG(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215594]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jH(a){a=a|0;return jy(862352,a)|0}function jI(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215590]|0;L5439:do{if((d|0)!=0){f=d;L5440:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4416;break L5440}j=c[g+28>>2]|0;if((j|0)!=0){i=4419;break L5440}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5439}}if((i|0)==4416){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4419){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jJ(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215590]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jK(a){a=a|0;return jy(862336,a)|0}function jL(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215586]|0;L5472:do{if((d|0)!=0){f=d;L5473:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4443;break L5473}j=c[g+28>>2]|0;if((j|0)!=0){i=4446;break L5473}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5472}}if((i|0)==4446){k=da[j&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4443){k=da[h&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jM(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215586]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jN(a){a=a|0;return jy(862320,a)|0}function jO(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215582]|0;L5505:do{if((d|0)!=0){f=d;L5506:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4470;break L5506}j=c[g+28>>2]|0;if((j|0)!=0){i=4473;break L5506}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5505}}if((i|0)==4470){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4473){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jP(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215582]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jQ(a){a=a|0;return jy(862304,a)|0}function jR(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215578]|0;L5538:do{if((d|0)!=0){f=d;L5539:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4497;break L5539}j=c[g+28>>2]|0;if((j|0)!=0){i=4500;break L5539}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5538}}if((i|0)==4497){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4500){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jS(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215578]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jT(a){a=a|0;return jy(862288,a)|0}function jU(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;d=c[215574]|0;L5571:do{if((d|0)!=0){f=d;L5572:while(1){g=c[f+4>>2]|0;do{if((e[g+12>>1]|0)>>>0<=(a&65535)>>>0){if((e[g+14>>1]|0)>>>0<(a&65535)>>>0){break}h=c[g+32>>2]|0;if((h|0)!=0){i=4524;break L5572}j=c[g+28>>2]|0;if((j|0)!=0){i=4527;break L5572}}}while(0);f=c[f+8>>2]|0;if((f|0)==0){break L5571}}if((i|0)==4524){k=da[h&255](b[g+16>>1]&a)|0;return k|0}else if((i|0)==4527){k=da[j&255](b[g+16>>1]&a)|0;return k|0}}}while(0);k=p3()|0;return k|0}function jV(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215574]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jW(a){a=a|0;return jy(862272,a)|0}function jX(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215570]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function jY(a){a=a|0;return jy(862256,a)|0}function jZ(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=c[215566]|0;pq();if((f|0)==0){return}else{g=0;h=-1;i=f;j=0}while(1){f=c[i+4>>2]|0;k=c[f+24>>2]|0;do{if((k|0)==0){l=j;m=h;n=g}else{if((e[f+12>>1]|0)>>>0>(a&65535)>>>0){l=j;m=h;n=g;break}if((e[f+14>>1]|0)>>>0<(a&65535)>>>0){l=j;m=h;n=g;break}o=b[f+16>>1]&a;if((c[f+44>>2]|0)==-1){l=k;m=o;n=g;break}c5[k&255](o,d);l=j;m=h;n=g+1|0}}while(0);k=c[i+8>>2]|0;if((k|0)==0){break}else{g=n;h=m;i=k;j=l}}if((n|0)!=0|(l|0)==0|m<<16>>16==-1){return}c5[l&255](m,d);return}function j_(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0;d=c[215602]|0;if((d|0)!=0){f=d;do{d=c[f+4>>2]|0;g=b[d+14>>1]|0;h=e[d+12>>1]|0;i=(e[d+16>>1]|0)+h|0;qQ(a,c[d>>2]|0,h,((g&65535|0)>(i|0)?i&65535:g)&65535,c[d+36>>2]|0);f=c[f+8>>2]|0;}while((f|0)!=0)}f=c[215598]|0;if((f|0)!=0){d=f;do{f=c[d+4>>2]|0;g=b[f+14>>1]|0;i=e[f+12>>1]|0;h=(e[f+16>>1]|0)+i|0;qQ(a,c[f>>2]|0,i,((g&65535|0)>(h|0)?h&65535:g)&65535,c[f+36>>2]|0);d=c[d+8>>2]|0;}while((d|0)!=0)}d=c[215594]|0;if((d|0)!=0){f=d;do{d=c[f+4>>2]|0;g=b[d+14>>1]|0;h=e[d+12>>1]|0;i=(e[d+16>>1]|0)+h|0;qQ(a,c[d>>2]|0,h,((g&65535|0)>(i|0)?i&65535:g)&65535,c[d+36>>2]|0);f=c[f+8>>2]|0;}while((f|0)!=0)}f=c[215590]|0;if((f|0)!=0){d=f;do{f=c[d+4>>2]|0;g=b[f+14>>1]|0;i=e[f+12>>1]|0;h=(e[f+16>>1]|0)+i|0;qQ(a,c[f>>2]|0,i,((g&65535|0)>(h|0)?h&65535:g)&65535,c[f+36>>2]|0);d=c[d+8>>2]|0;}while((d|0)!=0)}d=c[215586]|0;if((d|0)!=0){f=d;do{d=c[f+4>>2]|0;g=b[d+14>>1]|0;h=e[d+12>>1]|0;i=(e[d+16>>1]|0)+h|0;qQ(a,c[d>>2]|0,h,((g&65535|0)>(i|0)?i&65535:g)&65535,c[d+36>>2]|0);f=c[f+8>>2]|0;}while((f|0)!=0)}f=c[215582]|0;if((f|0)!=0){d=f;do{f=c[d+4>>2]|0;g=b[f+14>>1]|0;i=e[f+12>>1]|0;h=(e[f+16>>1]|0)+i|0;qQ(a,c[f>>2]|0,i,((g&65535|0)>(h|0)?h&65535:g)&65535,c[f+36>>2]|0);d=c[d+8>>2]|0;}while((d|0)!=0)}d=c[215578]|0;if((d|0)!=0){f=d;do{d=c[f+4>>2]|0;g=b[d+14>>1]|0;h=e[d+12>>1]|0;i=(e[d+16>>1]|0)+h|0;qQ(a,c[d>>2]|0,h,((g&65535|0)>(i|0)?i&65535:g)&65535,c[d+36>>2]|0);f=c[f+8>>2]|0;}while((f|0)!=0)}f=c[215574]|0;if((f|0)!=0){d=f;do{f=c[d+4>>2]|0;g=b[f+14>>1]|0;i=e[f+12>>1]|0;h=(e[f+16>>1]|0)+i|0;qQ(a,c[f>>2]|0,i,((g&65535|0)>(h|0)?h&65535:g)&65535,c[f+36>>2]|0);d=c[d+8>>2]|0;}while((d|0)!=0)}d=c[215570]|0;if((d|0)!=0){f=d;do{d=c[f+4>>2]|0;g=b[d+14>>1]|0;h=e[d+12>>1]|0;i=(e[d+16>>1]|0)+h|0;qQ(a,c[d>>2]|0,h,((g&65535|0)>(i|0)?i&65535:g)&65535,c[d+36>>2]|0);f=c[f+8>>2]|0;}while((f|0)!=0)}f=c[215566]|0;if((f|0)==0){return}else{j=f}do{f=c[j+4>>2]|0;d=b[f+14>>1]|0;g=e[f+12>>1]|0;i=(e[f+16>>1]|0)+g|0;qQ(a,c[f>>2]|0,g,((d&65535|0)>(i|0)?i&65535:d)&65535,c[f+36>>2]|0);j=c[j+8>>2]|0;}while((j|0)!=0);return}function j$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=a+3|0;d=a+7|0;e=a+11|0;f=a+15|0;g=160;while(1){l3(b,g,78);l3(d,g,78);l3(e,g,78);l3(f,g,78);h=854064+(g<<8&7936)|0;l4(b,g,h);l4(d,g,h);l4(e,g,h);l4(f,g,h);h=g+1|0;if(h>>>0<192>>>0){g=h}else{i=0;break}}do{if((-536813344>>>(i>>>0)&1|0)!=0){g=i+a|0;l3(g,208,34);l2(g,208,134);l3(g,209,200);l2(g,209,192);l3(g,210,218);l2(g,210,168);l3(g,211,162);l2(g,211,26);l3(g,212,98);l2(g,212,138);l3(g,213,138);l2(g,213,250);l3(g,214,52);l2(g,214,184);l3(g,215,142);l2(g,215,120);l3(g,216,214);l2(g,216,112);l3(g,217,214);l2(g,217,112);l3(g,218,214);l2(g,218,112);l3(g,219,214);l2(g,219,112);l3(g,220,170);l2(g,220,188);l3(g,221,240);l2(g,221,104);l3(g,222,96);l2(g,222,242);l3(g,223,140);l2(g,223,42);l4(g,208,0);l4(g,209,0);l4(g,210,0);l4(g,211,0);l4(g,212,0);l4(g,213,0);l4(g,214,0);l4(g,215,0);l4(g,216,0);l4(g,217,0);l4(g,218,0);l4(g,219,0);l4(g,220,0);l4(g,221,0);l4(g,222,0);l4(g,223,0)}if((i-16|0)>>>0<8>>>0){g=i+a|0;h=208;do{l3(g,h,112);l2(g,h,122);l4(g,h,0);h=h+1|0;}while(h>>>0<224>>>0)}i=i+1|0;}while(i>>>0<32>>>0);i=a+2|0;h=a+6|0;g=a+10|0;j=a+14|0;k=a+26|0;l=a+27|0;m=a+30|0;n=a+31|0;o=224;while(1){l3(i,o,76);l3(b,o,76);l3(h,o,76);l3(d,o,76);l3(g,o,76);l3(e,o,76);l3(j,o,76);l3(f,o,76);l3(k,o,76);l3(l,o,76);l3(m,o,76);l3(n,o,76);p=837680+(o<<8&7936)|0;l4(i,o,p);l4(b,o,p);l4(h,o,p);l4(d,o,p);l4(g,o,p);l4(e,o,p);l4(j,o,p);l4(f,o,p);l4(k,o,p);l4(l,o,p);l4(m,o,p);l4(n,o,p);p=o+1|0;if(p>>>0<256>>>0){o=p}else{q=0;break}}do{if((-1996519424>>>(q>>>0)&1|0)!=0){o=q+a|0;n=128;do{l3(o,n,156);l4(o,n,0);l2(o,n,132);n=n+1|0;}while(n>>>0<160>>>0)}q=q+1|0;}while(q>>>0<32>>>0);q=a+8|0;n=128;do{l2(q,n,50);n=n+1|0;}while(n>>>0<160>>>0);n=a+9|0;q=128;while(1){l2(n,q,50);o=q+1|0;if(o>>>0<160>>>0){q=o}else{r=128;break}}do{l2(g,r,50);r=r+1|0;}while(r>>>0<160>>>0);r=a+12|0;g=128;do{l2(r,g,50);g=g+1|0;}while(g>>>0<160>>>0);g=a+13|0;r=128;while(1){l2(g,r,50);q=r+1|0;if(q>>>0<160>>>0){r=q}else{s=128;break}}do{l2(j,s,50);s=s+1|0;}while(s>>>0<160>>>0);s=a+24|0;j=128;do{l2(s,j,50);j=j+1|0;}while(j>>>0<160>>>0);j=a+25|0;s=128;while(1){l2(j,s,50);r=s+1|0;if(r>>>0<160>>>0){s=r}else{t=128;break}}do{l2(k,t,50);t=t+1|0;}while(t>>>0<160>>>0);t=a+28|0;k=128;do{l2(t,k,50);k=k+1|0;}while(k>>>0<160>>>0);k=a+29|0;t=128;while(1){l2(k,t,50);s=t+1|0;if(s>>>0<160>>>0){t=s}else{u=128;break}}while(1){l2(m,u,50);t=u+1|0;if(t>>>0<160>>>0){u=t}else{v=128;break}}do{l2(a,v,50);v=v+1|0;}while(v>>>0<160>>>0);v=a+1|0;u=128;while(1){l2(v,u,50);m=u+1|0;if(m>>>0<160>>>0){u=m}else{w=128;break}}while(1){l2(i,w,50);u=w+1|0;if(u>>>0<160>>>0){w=u}else{x=128;break}}do{l2(b,x,50);x=x+1|0;}while(x>>>0<160>>>0);x=a+4|0;b=128;do{l2(x,b,50);b=b+1|0;}while(b>>>0<160>>>0);b=a+5|0;x=128;while(1){l2(b,x,50);w=x+1|0;if(w>>>0<160>>>0){x=w}else{y=128;break}}while(1){l2(h,y,50);x=y+1|0;if(x>>>0<160>>>0){y=x}else{z=128;break}}while(1){l2(d,z,50);y=z+1|0;if(y>>>0<160>>>0){z=y}else{A=24;break}}while(1){if((-855703552>>>(A>>>0)&1|0)!=0){z=c[56456+(A<<2)>>2]|0;d=A+a|0;y=z+31|0;h=z;do{l3(d,h,124);l4(d,h,0);l2(d,h,128);h=h+1|0;}while(h>>>0<=y>>>0)}y=A+1|0;if(y>>>0<32>>>0){A=y}else{B=16;break}}while(1){if((-855703552>>>(B>>>0)&1|0)!=0){A=c[56456+(B<<2)>>2]|0;y=B+a|0;h=A+31|0;if((B&2|0)==0){d=A;do{l3(y,d,124);l4(y,d,0);d=d+1|0;}while(d>>>0<=h>>>0)}else{d=A;do{l3(y,d,58);l4(y,d,0);d=d+1|0;}while(d>>>0<=h>>>0)}}h=B+1|0;if(h>>>0<24>>>0){B=h}else{C=16;break}}do{B=C+a|0;h=16;while(1){l3(B,h,188);l2(B,h,204);l4(B,h,0);d=h+1|0;if(d>>>0<128>>>0){h=d}else{D=128;break}}while(1){l2(B,D,72);h=D+1|0;if(h>>>0<160>>>0){D=h}else{E=160;break}}while(1){l3(B,E,40);l2(B,E,214);l4(B,E,0);h=E+1|0;if(h>>>0<192>>>0){E=h}else{F=192;break}}while(1){l3(B,F,154);l2(B,F,82);l4(B,F,0);h=F+1|0;if(h>>>0<208>>>0){F=h}else{G=224;break}}do{l2(B,G,140);G=G+1|0;}while(G>>>0<256>>>0);C=C+1|0;}while(C>>>0<24>>>0);return}function j0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=0;do{d=0;do{e=c[53224+(d<<2)>>2]|0;f=c[53256+(d<<2)>>2]|0;if((e|0)<=(f|0)){g=c[54392+(d<<7)+(b<<2)>>2]|0;h=e;while(1){c[a+(b*1028|0)+(h<<2)>>2]=g;if((h|0)<(f|0)){h=h+1|0}else{break}}}d=d+1|0;}while((d|0)<8);c[a+(b*1028|0)+1024>>2]=-1;b=b+1|0;}while((b|0)<32);return}function j1(b){b=b|0;return a[845872+(b&8191)|0]|0}function j2(b){b=b|0;return a[854064+(b&8191)|0]|0}function j3(b){b=b|0;var c=0,d=0,e=0;c=b&65535;d=c&61440;if((d|0)==40960|(d|0)==45056){e=a[854064+(c&8191)|0]|0}else if((d|0)==57344|(d|0)==61440){e=a[845872+(c&8191)|0]|0}else if((d|0)==53248){e=lU(b)|0}else{e=0}return e|0}function j4(b,c){b=b|0;c=c|0;var d=0,e=0;d=b&65535;e=d&61440;if((e|0)==57344|(e|0)==61440){a[845872+(d&8191)|0]=c;return}else if((e|0)==40960|(e|0)==45056){a[854064+(d&8191)|0]=c;return}else if((e|0)==53248){lV(b,c);return}else{return}}function j5(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=a[477560]|0;g=~f;h=a[477561]|0;i=h&f;j=i|a[477564]&g;a[477564]=j;k=(h|g)&(j|e);j=(e&64)!=0&(c|0)==0?k&-65:k;k=(f&32)==0;c=j&-33;e=k?c:j;a[477563]=k?c:j;do{if((b|0)!=0){if((f&16)!=0){break}a[477563]=e&-17}}while(0);e=i&32;if((e|0)==(d[53216]|0|0)){l=f;m=h}else{h=e&255;a[53216]=h;f9(((h&255)>>>5^1)&255);l=a[477560]|0;m=a[477561]|0}h=(m&255|l&255^8)&8;if((h|0)==(d[53208]|0|0)){n=l;a[477562]=n;return}a[53208]=h&255;ga(h);n=a[477560]|0;a[477562]=n;return}function j6(){a[477561]=63;a[477564]=63;a[477563]=63;a[477560]=0;a[477562]=0;c[119394]=0;return}function j7(){var a=0,b=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=0;e=0;while(1){f=b+1|0;g=(d[845872+b|0]|0)+e&65535;if((f|0)<8192){b=f;e=g}else{break}}e=j3(-128)|0;hs(c[14112]|0,77992,(b=i,i=i+8|0,c[b>>2]=e&255,b)|0)|0;i=b;f=(g|0)==50955;do{if(e<<24>>24!=0|f){if(e<<24>>24==3){if(!((g|0)==50954|(g|0)==50633)){h=4701;break}}else{if(!(e<<24>>24!=67|f)){h=4701;break}if(!(e<<24>>24!=100|(g|0)==49680)){h=4701;break}}j=c[200726]|0;if((j|0)==0){break}if((kq(j)|0)<0){k=-1}else{break}i=a;return k|0}else{h=4701}}while(0);if((h|0)==4701){h=c[14112]|0;hu(h,86272,(b=i,i=i+16|0,c[b>>2]=g,c[b+8>>2]=g,b)|0)|0;i=b}k=0;i=a;return k|0}function j8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e|0;if(!(a[48384]|0)){g=0;i=e;return g|0}ic(83840,f)|0;h8(83840,1)|0;do{if((d|0)==0){if((c[209418]|0)==1){g=-1;i=e;return g|0}if((iV(b,845872,8192,8192)|0)>=0){break}h=c[14112]|0;hv(h,82104,(h=i,i=i+8|0,c[h>>2]=b,h)|0)|0;i=h;h=c[f>>2]|0;h8(83840,h)|0;g=-1;i=e;return g|0}else{A$(845872,d|0,8192)|0;c[209418]=1}}while(0);j7()|0;A$(837680,845872,8192)|0;h8(83840,c[f>>2]|0)|0;g=0;i=e;return g|0}function j9(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!(a[48384]|0)){f=0;i=e;return f|0}if((iV(b,854064,8192,8192)|0)<0){g=c[14112]|0;hv(g,79856,(h=i,i=i+8|0,c[h>>2]=b,h)|0)|0;i=h;f=-1;i=e;return f|0}else{j=0;k=0}while(1){b=j+1|0;l=(d[854064+j|0]|0)+k&65535;if((b|0)<8192){j=b;k=l}else{break}}if((l|0)==15702){f=0;i=e;return f|0}hu(c[14112]|0,80840,(h=i,i=i+16|0,c[h>>2]=l,c[h+8>>2]=l,h)|0)|0;i=h;f=0;i=e;return f|0}function ka(b){b=b|0;var d=0,e=0,f=0;d=i;if(!(a[48384]|0)){e=0;i=d;return e|0}if((iV(b,789904,4096,4096)|0)>=0){e=0;i=d;return e|0}hv(c[14112]|0,78976,(f=i,i=i+8|0,c[f>>2]=b,f)|0)|0;i=f;e=-1;i=d;return e|0}function kb(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;e=b|0;c[e>>2]=0;l8();if((c[14112]|0)==-1){c[14112]=hq(78416)|0}a[48384]=1;if((id(77976,e)|0)<0){f=-1;i=b;return f|0}if((j8(c[e>>2]|0,0)|0)<0){f=-1;i=b;return f|0}if((id(77440,e)|0)<0){f=-1;i=b;return f|0}g=c[e>>2]|0;do{if(a[48384]|0){if((iV(g,854064,8192,8192)|0)<0){h=c[14112]|0;hv(h,79856,(j=i,i=i+8|0,c[j>>2]=g,j)|0)|0;i=j;f=-1;i=b;return f|0}else{k=0;l=0}while(1){h=k+1|0;m=(d[854064+k|0]|0)+l&65535;if((h|0)<8192){k=h;l=m}else{break}}if((m|0)==15702){break}hu(c[14112]|0,80840,(j=i,i=i+16|0,c[j>>2]=m,c[j+8>>2]=m,j)|0)|0;i=j}}while(0);if((id(89680,e)|0)<0){f=-1;i=b;return f|0}m=c[e>>2]|0;if(!(a[48384]|0)){f=0;i=b;return f|0}if((iV(m,789904,4096,4096)|0)>=0){f=0;i=b;return f|0}hv(c[14112]|0,78976,(j=i,i=i+8|0,c[j>>2]=m,j)|0)|0;i=j;f=-1;i=b;return f|0}function kc(){return}function kd(){ii(48032)|0;return}function ke(a){a=a|0;var d=0,e=0,f=0;d=a-54272|0;if((c[13586]|0)==2){if(!(d>>>0<225>>>0|(a-55040|0)>>>0<2273>>>0)){e=-1;return e|0}b[23930]=a&65535;b[23931]=a+31&65535;f=c[80952]|0;if((f|0)!=0){jw(f);c[80952]=jv(47848)|0;e=0;return e|0}if((c[113992]|0)<=0){e=0;return e|0}c[80952]=jv(47848)|0;e=0;return e|0}else{if(d>>>0>=3041>>>0){e=-1;return e|0}b[23930]=a&65535;b[23931]=a+31&65535;a=c[80952]|0;if((a|0)!=0){jw(a);c[80952]=jv(47848)|0;e=0;return e|0}if((c[113992]|0)<=0){e=0;return e|0}c[80952]=jv(47848)|0;e=0;return e|0}return 0}function kf(a){a=a|0;var d=0,e=0,f=0;d=a-54272|0;if((c[13586]|0)==2){if(!(d>>>0<225>>>0|(a-55040|0)>>>0<2273>>>0)){e=-1;return e|0}b[23878]=a&65535;b[23879]=a+31&65535;f=c[80936]|0;if((f|0)!=0){jw(f);c[80936]=jv(47744)|0;e=0;return e|0}if((c[113992]|0)!=2){e=0;return e|0}c[80936]=jv(47744)|0;e=0;return e|0}else{if(d>>>0>=3041>>>0){e=-1;return e|0}b[23878]=a&65535;b[23879]=a+31&65535;a=c[80936]|0;if((a|0)!=0){jw(a);c[80936]=jv(47744)|0;e=0;return e|0}if((c[113992]|0)!=2){e=0;return e|0}c[80936]=jv(47744)|0;e=0;return e|0}return 0}function kg(a){a=a|0;var b=0;b=c[80952]|0;if((b|0)!=0){jw(b);c[80952]=0}b=c[80936]|0;if((b|0)!=0){jw(b);c[80936]=0}if((a|0)==2){c[80952]=jv(47848)|0;c[80936]=jv(47744)|0;return}else if((a|0)==1){c[80952]=jv(47848)|0;return}else{return}}function kh(a,b){a=a|0;b=b|0;ox(a,b);return}function ki(a){a=a|0;return oy(a)|0}function kj(a){a=a|0;oB(a);return}function kk(a,b){a=a|0;b=b|0;oo(a,b);return}function kl(a){a=a|0;return ol(a)|0}function km(a,b){a=a|0;b=b|0;on(a,b);return}function kn(a){a=a|0;return ok(a)|0}function ko(){rn();ro();return}function kp(){return(rg()|0)>>31|0}function kq(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;if((d|0)==0){f=0;i=e;return f|0}g=a[d]|0;if(g<<24>>24==0){f=0;i=e;return f|0}else{h=1;j=0;k=g}do{h=((k<<24>>24)-48|0)>>>0<10>>>0?h:0;j=j+1&65535;k=a[d+(j<<16>>16)|0]|0;}while(k<<24>>24!=0);do{if((h|0)==0){if((A8(d|0,77648)|0)==0){l=67;break}hv(-2,86112,(m=i,i=i+8|0,c[m>>2]=d,m)|0)|0;i=m;f=-1;i=e;return f|0}else{l=b7(d|0)|0}}while(0);if((l|0)==((j3(-128)|0)&255|0)){hu(-2,83720,(m=i,i=i+8|0,c[m>>2]=l,m)|0)|0;i=m;f=0;i=e;return f|0}d=(l|0)<0?0:l;switch(d|0){case 4064:case 100:{n=3;break};case 67:{n=2;break};case 0:{n=0;break};case 3:{n=1;break};default:{hv(-2,82040,(m=i,i=i+8|0,c[m>>2]=d,m)|0)|0;i=m;f=-1;i=e;return f|0}}hs(-2,80744,(m=i,i=i+8|0,c[m>>2]=d,m)|0)|0;i=m;d=n^3;l=0;h=3;k=3;while(1){j=b[51784+((l+1&65535)<<16>>16<<1)>>1]|0;hs(-2,79784,(m=i,i=i+24|0,c[m>>2]=j&65535,c[m+8>>2]=k,c[m+16>>2]=h<<16>>16>1?78952:871008,m)|0)|0;i=m;g=(ag(k,n)|0)+(l+2&65535)&65535;if(h<<16>>16==0){o=g}else{p=h;q=g;r=j;while(1){j=p-1&65535;j4(r,b[51784+(q<<16>>16<<1)>>1]&255);if(j<<16>>16==0){break}else{p=j;q=q+1&65535;r=r+1&65535}}o=h+g&65535}r=(o&65535)+(ag(k,d)|0)&65535;q=b[51784+(r<<16>>16<<1)>>1]|0;if(q<<16>>16>0){l=r;h=q;k=q<<16>>16}else{break}}hs(-2,77944,(m=i,i=i+1|0,i=i+7&-8,c[m>>2]=0,m)|0)|0;i=m;f=0;i=e;return f|0}function kr(){return h1(49176)|0}function ks(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+1152|0;h=g|0;j=g+128|0;k=h|0;if((c[7354]|0)==-1){c[7354]=hq(86808)|0}l=jj(f,86560)|0;if((l|0)==0){m=-1;i=g;return m|0}hj(c[119388]|0);c[119388]=hg(65668)|0;L6030:do{if((cr(k|0,1,6,l|0)|0)==6){if((A0(k|0,86264,4)|0)!=0){if((A0(k|0,86016,4)|0)!=0){break}}f=h+6|0;b[c[119388]>>1]=d[h+4|0]<<8|d[h+5|0];n=b[c[119388]>>1]|0;if(n<<16>>16==0|(n&65535)>>>0>3>>>0){o=c[7354]|0;p=n&65535;hv(o,85776,(q=i,i=i+8|0,c[q>>2]=p,q)|0)|0;i=q;break}p=n<<16>>16==1?112:118;if((cr(f|0,1,p|0,l|0)|0)!=(p|0)){p=c[7354]|0;hv(p,85288,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break}b[(c[119388]|0)+2>>1]=d[f]<<8|d[h+7|0];b[(c[119388]|0)+4>>1]=d[h+8|0]<<8|d[h+9|0];b[(c[119388]|0)+6>>1]=d[h+10|0]<<8|d[h+11|0];b[(c[119388]|0)+8>>1]=d[h+12|0]<<8|d[h+13|0];b[(c[119388]|0)+10>>1]=d[h+14|0]<<8|d[h+15|0];b[(c[119388]|0)+12>>1]=d[h+16|0]<<8|d[h+17|0];c[(c[119388]|0)+16>>2]=((d[h+18|0]<<8|d[h+19|0])&65535)<<16;f=h+22|0;p=(c[119388]|0)+16|0;c[p>>2]=(d[h+20|0]<<8|d[h+21|0])&65535|c[p>>2];c[(c[119388]|0)+65664>>2]=0;p=c[119388]|0;n=p+20|0;A$(n|0,f|0,32)|0;a[p+52|0]=0;p=h+54|0;f=c[119388]|0;n=f+53|0;A$(n|0,p|0,32)|0;a[f+85|0]=0;f=h+86|0;p=c[119388]|0;n=p+86|0;A$(n|0,f|0,32)|0;a[p+118|0]=0;p=h+118|0;f=c[119388]|0;if((e[f>>1]|0)>>>0>1>>>0){b[f+120>>1]=d[p]<<8|d[h+119|0];a[(c[119388]|0)+122|0]=a[h+120|0]|0;a[(c[119388]|0)+123|0]=a[h+121|0]|0;b[(c[119388]|0)+124>>1]=d[h+122|0]<<8|d[h+123|0];r=h+124|0}else{b[f+120>>1]=0;a[(c[119388]|0)+122|0]=0;a[(c[119388]|0)+123|0]=0;b[(c[119388]|0)+124>>1]=0;r=p}p=c[119388]|0;if((b[p+120>>1]&1)!=0){f=c[7354]|0;hv(f,84984,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break}do{if((b[p+4>>1]|0)==0){if((cr(r|0,1,2,l|0)|0)==2){b[(c[119388]|0)+4>>1]=d[r+1|0]<<8|d[r];s=c[119388]|0;break}else{f=c[7354]|0;hv(f,84696,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break L6030}}else{s=p}}while(0);p=s+6|0;if((b[p>>1]|0)==0){b[p>>1]=b[s+4>>1]|0;t=c[119388]|0}else{t=s}p=(cr(t+128|0,1,65536,l|0)|0)&65535;b[(c[119388]|0)+126>>1]=p;if((bA(l|0)|0)!=0){p=c[7354]|0;hv(p,84592,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break}if((cy(l|0)|0)==0){p=c[7354]|0;hv(p,84416,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q;break}p=c[119388]|0;do{if((a[p+122|0]|0)==0){f=e[p+4>>1]|0;n=f>>>8;o=f-1+(e[p+126>>1]|0)>>8;A2(j|0,0,1024);f=0;while(1){c[j+(f<<2)>>2]=1;u=f+1|0;if(u>>>0>3>>>0){v=160;break}else{f=u}}while(1){c[j+(v<<2)>>2]=1;f=v+1|0;if(f>>>0>191>>>0){w=208;break}else{v=f}}do{c[j+(w<<2)>>2]=1;w=w+1|0;}while(w>>>0<=255>>>0);if(n>>>0<=o>>>0){f=n;do{c[j+(f<<2)>>2]=1;f=f+1|0;}while(f>>>0<=o>>>0)}a[p+123|0]=0;o=0;f=0;while(1){if((c[j+(f<<2)>>2]|0)==0){x=o;y=f+1|0}else{n=f-o|0;u=c[119388]|0;if(n>>>0>(d[u+123|0]|0)>>>0){a[u+122|0]=o&255;a[(c[119388]|0)+123|0]=n&255}n=f+1|0;x=n;y=n}if(y>>>0<256>>>0){o=x;f=y}else{break}}f=c[119388]|0;if((a[f+123|0]|0)!=0){z=f;break}a[f+122|0]=-1;z=c[119388]|0}else{z=p}}while(0);do{if((a[z+122|0]|0)!=-1){if((d[z+123|0]|0)>>>0<2>>>0){break}jk(l)|0;m=0;i=g;return m|0}}while(0);p=c[7354]|0;hv(p,84208,(q=i,i=i+1|0,i=i+7&-8,c[q>>2]=0,q)|0)|0;i=q}}while(0);jk(l)|0;hj(c[119388]|0);c[119388]=0;m=-1;i=g;return m|0}function kt(){var a=0;a=c[119388]|0;return((a|0)==0?0:a+20|0)|0}function ku(){var a=0;a=c[119388]|0;return((a|0)==0?0:a+53|0)|0}function kv(){var a=0;a=c[119388]|0;return((a|0)==0?0:a+86|0)|0}function kw(){var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+40|0;f=d|0;g=d+8|0;h=d+16|0;j=c[119380]|0;k=c[119388]|0;if((k|0)==0){i=d;return}c[k+65664>>2]=0;k=c[119388]|0;l=a[k+122|0]|0;m=(l&255)<<8;n=m&65535;o=e[k+4>>1]|0;p=o-1+(e[k+126>>1]|0)|0;q=e[k+6>>1]|0;r=e[k+8>>1]|0;hs(c[7354]|0,83960,(k=i,i=i+40|0,c[k>>2]=n,c[k+8>>2]=o,c[k+16>>2]=p,c[k+24>>2]=q,c[k+32>>2]=r,k)|0)|0;i=k;ic(83816,f)|0;ic(83640,g)|0;do{if((j|0)==0){r=c[119388]|0;s=e[r+12>>1]|0;t=r}else{if((j|0)>=1){r=c[119388]|0;if((j|0)<=(e[r+10>>1]|0)){s=j;t=r;break}}r=c[7354]|0;hu(r,83504,(k=i,i=i+1|0,i=i+7&-8,c[k>>2]=0,k)|0)|0;i=k;r=c[119388]|0;s=e[r+12>>1]|0;t=r}}while(0);if((b[t+120>>1]&2)!=0){t=c[7354]|0;hu(t,83080,(k=i,i=i+1|0,i=i+7&-8,c[k>>2]=0,k)|0)|0;i=k}if((s|0)>1){t=1;j=1;while(1){r=t<<1;q=j+1|0;if((q|0)<(s|0)&(q|0)<32){t=r;j=q}else{u=r;break}}}else{u=1}j=c[119388]|0;t=(c[j+16>>2]&u|0)!=0?82976:82832;u=h|0;if((b[j+8>>1]|0)==0){bs(u|0,82680,(k=i,i=i+8|0,c[k>>2]=t,k)|0)|0;i=k}else{a[u]=a[t]|0;a[u+1|0]=a[t+1|0]|0;a[u+2|0]=a[t+2|0]|0;a[u+3|0]=a[t+3|0]|0;a[u+4|0]=a[t+4|0]|0;a[u+5|0]=a[t+5|0]|0}if((c[14078]|0)==0){if((c[13586]|0)==10){t=c[119388]|0;j=e[t+4>>1]|0;h=j-1+(e[t+126>>1]|0)|0;r=e[t+6>>1]|0;q=e[t+8>>1]|0;t=hn(83960,(k=i,i=i+40|0,c[k>>2]=n,c[k+8>>2]=j,c[k+16>>2]=h,c[k+24>>2]=r,c[k+32>>2]=q,k)|0)|0;i=k;fu(t);hj(t)}fj((c[119388]|0)+20|0);fk((c[119388]|0)+53|0);fl((c[119388]|0)+86|0);fm(c[f>>2]|0);fn(c[g>>2]|0);fs(u);fp(s);fo(e[(c[119388]|0)+12>>1]|0);fq(e[(c[119388]|0)+10>>1]|0);fr(0)}else{t=c[7354]|0;q=(c[119388]|0)+20|0;hs(t,82512,(k=i,i=i+8|0,c[k>>2]=q,k)|0)|0;i=k;q=c[7354]|0;t=(c[119388]|0)+53|0;hs(q,82304,(k=i,i=i+8|0,c[k>>2]=t,k)|0)|0;i=k;t=c[7354]|0;q=(c[119388]|0)+86|0;hs(t,82176,(k=i,i=i+8|0,c[k>>2]=q,k)|0)|0;i=k;q=c[7354]|0;t=(c[f>>2]|0)==-1?81968:81896;hs(q,82088,(k=i,i=i+8|0,c[k>>2]=t,k)|0)|0;i=k;t=c[7354]|0;q=51256+(((e[(c[119388]|0)+120>>1]|0)>>>4&3)<<3)|0;r=c[g>>2]|0;g=c[56224+(((r|0)>19?9:r)<<2)>>2]|0;hs(t,81608,(k=i,i=i+16|0,c[k>>2]=q,c[k+8>>2]=g,k)|0)|0;i=k;g=c[7354]|0;hs(g,81552,(k=i,i=i+8|0,c[k>>2]=u,k)|0)|0;i=k;u=c[7354]|0;g=c[119388]|0;q=e[g+10>>1]|0;t=e[g+12>>1]|0;hs(u,81400,(k=i,i=i+24|0,c[k>>2]=s,c[k+8>>2]=q,c[k+16>>2]=t,k)|0)|0;i=k}k=m|3;lX(k,lW(-32768)|0);lX(-32768,0);lX(k+1&65535,lW(-32767)|0);lX(-32767,l);lX(k+2&65535,lW(-32766)|0);lX(-32766,0);lX(k+3&65535,lW(-32765)|0);lX(-32765,0);lX(m|7,lW(-32764)|0);lX(-32764,-61);lX(k+5&65535,lW(-32763)|0);lX(-32763,-62);lX(k+6&65535,lW(-32762)|0);lX(-32762,-51);lX(k+7&65535,lW(-32761)|0);lX(-32761,56);lX(m|11,lW(-32760)|0);lX(-32760,48);lX(k+9&65535,s&255);lX(678,(c[f>>2]|0)!=-2|0);i=d;return}function kx(a){a=a|0;if((a|0)==-1){c[119380]=0;hj(c[119388]|0);c[119388]=0;return}else{c[119380]=a;return}}function ky(a,b){a=a|0;b=b|0;c[119380]=(a|0)==-1?0:a;ja();hz(0);return 0}function kz(a){a=a|0;var b=0,d=0,f=0;b=c[119388]|0;if((b|0)==0){d=0}else{d=e[b+12>>1]|0}c[a>>2]=d;d=c[119388]|0;if((d|0)==0){f=0;return f|0}f=e[d+10>>1]|0;return f|0}function kA(){var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+432|0;g=f+408|0;h=f+416|0;j=f+424|0;k=f|0;A$(k|0,51288,408)|0;c[g>>2]=k;if((c[119388]|0)==0){i=f;return}ic(83816,j)|0;do{if((c[200730]|0)==0){k=(e[(c[119388]|0)+120>>1]|0)>>>2&3;if((k|0)==2){c[j>>2]=-2;h8(83816,-2)|0;break}else if((k|0)==1){c[j>>2]=-1;h8(83816,-1)|0;break}else{break}}}while(0);h8(81256,0)|0;k=c[119388]|0;do{if((e[k>>1]|0)>>>0>2>>>0){l=(e[k+124>>1]|0)>>>4;m=l&4080|53248;n=c[7354]|0;hs(n,81216,(o=i,i=i+8|0,c[o>>2]=m,o)|0)|0;i=o;if(!((m-54304|0)>>>0<992>>>0|m>>>0>56831>>>0)){break}if((l&16|0)!=0){break}h8(81256,1)|0;h8(81048,m)|0}}while(0);do{if((c[200730]|0)==0){k=(e[(c[119388]|0)+120>>1]|0)>>>4&3;if((k|0)==2){h8(83640,1)|0;p=0;break}else if((k|0)==1){h8(83640,0)|0;p=0;break}else{p=0;break}}else{p=0}}while(0);do{lX(p,0);p=p+1&65535;}while((p&65535)>>>0<2048>>>0);p=d[(c[119388]|0)+122|0]<<8;c[h>>2]=408;k=p&65535;if((kD(g,h,k)|0)==0){m=c[7354]|0;hv(m,80944,(o=i,i=i+1|0,i=i+7&-8,c[o>>2]=0,o)|0)|0;i=o;c[119380]=0;hj(c[119388]|0);c[119388]=0;i=f;return}if((c[h>>2]|0)>0){o=0;do{lX(o+k&65535,a[(c[g>>2]|0)+o|0]|0);o=o+1|0;}while((o|0)<(c[h>>2]|0))}h=c[119388]|0;if((b[h+126>>1]|0)!=0){o=0;g=h;do{lX((e[g+4>>1]|0)+o&65535,a[g+128+o|0]|0);o=o+1|0;g=c[119388]|0;}while((o|0)<(e[g+126>>1]|0))}g=p|3;lX(g+9&65535,0);lX(g+10&65535,b[(c[119388]|0)+10>>1]&255);o=p|15;lX(g+11&65535,b[(c[119388]|0)+4>>1]&255);lX(o,(e[(c[119388]|0)+4>>1]|0)>>>8&255);lX(o+1&65535,b[(c[119388]|0)+6>>1]&255);lX(o+2&65535,(e[(c[119388]|0)+6>>1]|0)>>>8&255);lX(o+3&65535,b[(c[119388]|0)+8>>1]&255);lX(o+4&65535,(e[(c[119388]|0)+8>>1]|0)>>>8&255);lX(o+5&65535,c[(c[119388]|0)+16>>2]&255);lX(o+6&65535,(c[(c[119388]|0)+16>>2]|0)>>>8&255);lX(o+7&65535,(c[(c[119388]|0)+16>>2]|0)>>>16&255);lX(o+8&65535,(c[(c[119388]|0)+16>>2]|0)>>>24&255);lX(o+9&65535,(c[j>>2]|0)==-1|0);i=f;return}function kB(){var a=0,b=0,d=0;a=c[119388]|0;if((a|0)==0){b=0;return b|0}d=a+65664|0;c[d>>2]=(c[d>>2]|0)+1;b=c[(c[119388]|0)+65664>>2]|0;return b|0}function kC(a,b){a=a|0;b=b|0;c[200730]=a;return 0}function kD(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=c[b>>2]|0;c[200862]=g;c[200861]=c[e>>2];if((A0(g|0,56432,5)|0)!=0){h=0;return h|0}if((a[g+7|0]&96)!=0){h=0;return h|0}i=a[g+26|0]|0;if(i<<24>>24==0){j=27}else{k=0;l=i;do{k=(l&255)+k|0;l=a[g+(k+26)|0]|0;}while(l<<24>>24!=0);j=k+27|0}k=d[g+9|0]<<8|d[g+8|0];c[200863]=k;l=d[g+11|0]<<8|d[g+10|0];c[200864]=l;c[200871]=f-k;c[200865]=d[g+13|0]<<8|d[g+12|0];k=d[g+15|0]<<8|d[g+14|0];c[200866]=k;c[200872]=0;c[200867]=d[g+17|0]<<8|d[g+16|0];c[200868]=d[g+19|0]<<8|d[g+18|0];c[200873]=0;i=g+21|0;c[200869]=d[i]<<8|d[g+20|0];c[200870]=d[g+23|0]<<8|d[i];c[200874]=0;i=g+j|0;c[200875]=i;m=l+j|0;c[200876]=g+m;j=m+k|0;k=g+j|0;c[200877]=k;m=d[g+(j+1)|0]<<8|d[k];if((m|0)==0){n=2}else{k=m;m=2;while(1){l=m;while(1){o=l+1|0;if((a[g+(l+j)|0]|0)==0){l=o}else{break}}l=k-1|0;if((l|0)==0){n=o;break}else{k=l;m=o}}}o=g+(n+j)|0;c[200878]=o;j=kE(i,o)|0;c[200879]=j;o=kE(c[200876]|0,j)|0;c[200880]=o;j=d[o+1|0]<<8|d[o];if((j|0)!=0){i=j;j=o+2|0;while(1){o=j;while(1){p=o+1|0;if((a[o]|0)==0){break}else{o=p}}n=a[p]|0;g=o+2|0;m=o+3|0;k=d[m]<<8|d[g];if((n<<24>>24|0)==2){q=c[200871]|0}else if((n<<24>>24|0)==5){q=c[200874]|0}else if((n<<24>>24|0)==4){q=c[200873]|0}else if((n<<24>>24|0)==3){q=c[200872]|0}else{q=0}n=q+k|0;a[g]=n&255;a[m]=n>>>8&255;n=i-1|0;if((n|0)==0){break}else{i=n;j=o+4|0}}}a[(c[200862]|0)+9|0]=f>>>8&255;a[(c[200862]|0)+8|0]=f&255;c[b>>2]=c[200875];c[e>>2]=c[200864];h=1;return h|0}function kE(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=e;e=-1;while(1){g=a[f]|0;if((g<<24>>24|0)==(-1|0)){f=f+1|0;e=e+254|0;continue}else if((g<<24>>24|0)==0){break}h=(g&255)+e|0;g=d[f+1|0]|0;i=g&224;j=g&7;g=f+2|0;if((i|0)==64){k=b+h|0;l=(d[k]|0)<<8|(d[g]|0);if((j|0)==5){m=c[200874]|0}else if((j|0)==3){m=c[200872]|0}else if((j|0)==4){m=c[200873]|0}else if((j|0)==2){m=c[200871]|0}else{m=0}n=m+l|0;a[k]=n>>>8&255;a[g]=n&255;o=f+3|0}else if((i|0)==32){n=b+h|0;k=d[n]|0;if((j|0)==5){p=c[200874]|0}else if((j|0)==3){p=c[200872]|0}else if((j|0)==2){p=c[200871]|0}else if((j|0)==4){p=c[200873]|0}else{p=0}a[n]=p+k&255;o=g}else if((i|0)==128){i=b+h|0;k=b+(h+1)|0;n=(d[k]|0)<<8|(d[i]|0);if((j|0)==4){q=c[200873]|0}else if((j|0)==2){q=c[200871]|0}else if((j|0)==3){q=c[200872]|0}else if((j|0)==5){q=c[200874]|0}else{q=0}l=q+n|0;a[i]=l&255;a[k]=l>>>8&255;o=g}else{o=g}f=(j|0)==0?o+2|0:o;e=h}return f+1|0}function kF(){do{if((iY()|0)>=0){if((i7()|0)<0){break}if((kp()|0)<0){break}if((kX()|0)<0){break}if((jm()|0)<0){break}if((p5()|0)<0){break}if((ij()|0)<0){break}if((oI()|0)<0){break}if((qU()|0)<0){break}if((jr()|0)<0){break}return(kr()|0)>>31|0}}while(0);return-1|0}function kG(){qV();rh();kY();ik();return}function kH(){k9(794408);lw(794408);return}function kI(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+64|0;b=a|0;d=a+40|0;e=a+56|0;c[7326]=1;c[7356]=1;c[14178]=hq(54312)|0;if((kb()|0)<0){f=-1;i=a;return f|0}g=(pr(0)|0)!=0;if(!(g|(c[7356]|0)!=0)){f=-1;i=a;return f|0}lP();k8(c[198602]|0);lv(c[198603]|0);g=e|0;c[g>>2]=b;c[e+4>>2]=0;qR(b);b=d|0;c[b>>2]=qy()|0;c[d+4>>2]=qy()|0;c[d+8>>2]=qy()|0;c[d+12>>2]=qy()|0;qF(qy()|0,b,g);i9(30);i8(+h[99295],c[198588]|0);kd();ix(c[198588]|0,c[198587]|0);c[80532]=jv(46288)|0;c[80530]=jv(46232)|0;c[80528]=jv(46176)|0;c[80526]=jv(46120)|0;c[114036]=jv(48304)|0;c[114034]=jv(48248)|0;c[114032]=jv(48192)|0;c[114030]=jv(48136)|0;c[114028]=jv(48080)|0;if((c[14078]|0)==0){fi()|0}js();mm();f=0;i=a;return f|0}function kJ(){var a=0,b=0;a=kB()|0;b=ag(c[198587]|0,a)|0;a=(b>>>0)/((c[198588]|0)>>>0)|0;if((a|0)!=(c[198584]|0)){fr(a);c[198584]=a}f0(c[198578]|0)|0;return}function kK(){qW();m1(c[198602]|0);m1(c[198603]|0);op();pv();kA();kw();return}function kL(){pw();return}function kM(){nf(c[198602]|0);nf(c[198603]|0);pz();if((c[14078]|0)!=0){return}ft();return}function kN(a){a=a|0;pp(a);return}function kO(a){a=a|0;return}function kP(){return c[198588]|0}function kQ(){return c[198587]|0}function kR(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=((((c[198580]|0)>>>0)/((c[198586]|0)>>>0)|0)>>>0)%((c[198592]|0)>>>0)|0;c[b>>2]=((c[198580]|0)>>>0)%((c[198586]|0)>>>0)|0;c[d>>2]=-1;return}function kS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0;b=i;switch(a|0){case-4097:case-4098:case-4099:case-4100:{d=1;e=a^4096;break};case-12292:case-12291:case-12290:case-12289:{d=3;e=a^12288;break};case-8193:case-8194:case-8195:case-8196:{d=2;e=a^8192;break};default:{d=0;e=a}}if((e|0)==(-3|0)){c[198588]=1022730;c[198587]=16768;h[99295]=60.99296278625955;c[198586]=64;c[198592]=262;f=60.99296278625955;g=1022730}else if((e|0)==(-1|0)){c[198588]=985248;c[198587]=19656;h[99295]=50.124542124542124;c[198586]=63;c[198592]=312;f=50.124542124542124;g=985248}else if((e|0)==(-4|0)){c[198588]=1023440;c[198587]=20280;h[99295]=50.465483234714;c[198586]=65;c[198592]=312;f=50.465483234714;g=1023440}else if((e|0)==(-2|0)){c[198588]=1022730;c[198587]=17095;h[99295]=59.82626498976309;c[198586]=65;c[198592]=263;f=59.82626498976309;g=1022730}else{hv(c[14178]|0,81872,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0)|0;i=e;f=+h[99295];g=c[198588]|0}i8(f,g);iw(c[198588]|0,c[198587]|0);f5(c[198586]|0,c[198592]|0);oD(c[198588]|0);fY(c[198578]|0,c[198587]|0);pk(794344,d);lq(c[198602]|0,c[198587]|0);lN(c[198603]|0,c[198587]|0);hz(1);i=b;return}function kT(){return 3}function kU(){return 80640}function kV(a,b){a=a|0;b=b|0;var d=0;do{if(a>>>0<2>>>0){b=c[209412]|0;c[209412]=a;if((b|0)==(a|0)){d=0;break}k5();d=0}else{d=-1}}while(0);return d|0}function kW(a,b){a=a|0;b=b|0;var d=0;do{if(a>>>0<2>>>0){b=c[209410]|0;c[209410]=a;if((b|0)==(a|0)){d=0;break}lu();d=0}else{d=-1}}while(0);return d|0}function kX(){var a=0;if((h2(48840)|0)<0){a=-1;return a|0}a=h1(50736)|0;return a|0}function kY(){hj(c[209414]|0);hj(c[215618]|0);hj(c[200724]|0);hj(c[200726]|0);hj(c[198596]|0);hj(c[198597]|0);hj(c[198598]|0);return}function kZ(a,b){a=a|0;b=b|0;var d=0,e=0;b=c[80522]<<12;d=(c[80948]|0)==(a|0);do{if((a|0)==(-1|0)){c[80948]=-1;if(d){e=0;break}kS(~b);e=0}else if((a|0)==(-4|0)){c[80948]=-4;if(d){e=0;break}kS(b^-4);e=0}else if((a|0)==(-2|0)){c[80948]=-2;if(d){e=0;break}kS(b^-2);e=0}else if((a|0)==(-3|0)){c[80948]=-3;if(d){e=0;break}kS(b^-3);e=0}else{e=-1}}while(0);return e|0}function k_(a,b){a=a|0;b=b|0;var d=0;if((i1(837656,a)|0)!=0){d=0;return d|0}d=ka(c[209414]|0)|0;return d|0}function k$(a,b){a=a|0;b=b|0;var d=0;if((i1(802896,a)|0)!=0){d=0;return d|0}d=j8(c[200724]|0,0)|0;return d|0}function k0(a,b){a=a|0;b=b|0;var d=0;if((i1(862472,a)|0)!=0){d=0;return d|0}d=j9(c[215618]|0)|0;return d|0}function k1(a,b){a=a|0;b=b|0;i1(802904,a)|0;return 0}function k2(a,b){a=a|0;b=b|0;m2(c[198602]|0,a,b);return}function k3(a){a=a|0;return m4(c[198602]|0,a)|0}function k4(a){a=a|0;return m7(c[198602]|0,a)|0}function k5(){var a=0;a=c[198602]|0;if((a|0)==0){return}c[a+140>>2]=c[209412];return}function k6(a){a=a|0;return}function k7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=~a[802970]&b&255;if((e&1|0)==0){f=(c[200708]^255)&255}else{f=-1}if((e&2|0)==0){g=(c[200709]^255)&(f&255)&255}else{g=f}if((e&4|0)==0){h=(c[200710]^255)&(g&255)&255}else{h=g}if((e&8|0)==0){i=(c[200711]^255)&(h&255)&255}else{i=h}if((e&16|0)==0){j=(c[200712]^255)&(i&255)&255}else{j=i}if((e&32|0)==0){k=(c[200713]^255)&(j&255)&255}else{k=j}if((e&64|0)==0){l=(c[200714]^255)&(k&255)&255}else{l=k}if((e&128|0)!=0){m=l;n=m&d;o=a[802969]|0;p=o^16;q=n&p;r=c[198580]|0;s=(q&255)>>>4;t=s&1;u=t^1;v=u&255;py(r,v);return}m=(c[200715]^255)&(l&255)&255;n=m&d;o=a[802969]|0;p=o^16;q=n&p;r=c[198580]|0;s=(q&255)>>>4;t=s&1;u=t^1;v=u&255;py(r,v);return}function k8(a){a=a|0;m9(c[198602]|0,c[198582]|0,c[198576]|0,c[198578]|0);return}function k9(a){a=a|0;var b=0,d=0,e=0;b=i;d=hh(1,220)|0;e=d;c[a>>2]=e;c[d+148>>2]=0;c[d+152>>2]=0;c[d+132>>2]=794272;c[d+128>>2]=794320;c[d+80>>2]=19656;m8(e);c[d+140>>2]=c[209412];c[d+112>>2]=0;c[d+116>>2]=2;e=hn(89616,(a=i,i=i+1|0,i=i+7&-8,c[a>>2]=0,a)|0)|0;i=a;c[d+124>>2]=e;c[d+156>>2]=26;c[d+160>>2]=28;c[d+164>>2]=22;c[d+168>>2]=36;c[d+172>>2]=196;c[d+176>>2]=208;c[d+180>>2]=222;c[d+184>>2]=222;c[d+188>>2]=80;c[d+192>>2]=52;c[d+196>>2]=96;c[d+200>>2]=52;c[d+204>>2]=108;c[d+208>>2]=50;c[d+212>>2]=34;c[d+216>>2]=32;i=b;return}function la(a,b,c){a=a|0;b=b|0;c=c|0;return}function lb(a,b,c){a=a|0;b=b|0;c=c|0;return}function lc(b,d,e){b=b|0;d=d|0;e=e|0;k7(e,a[(c[198602]|0)+66|0]|0);return}function ld(b,d,e){b=b|0;d=d|0;e=e|0;k7(a[(c[198602]|0)+65|0]|0,e);return}function le(a,b){a=a|0;b=b|0;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a[b+66|0]&~a[802969]&255;if((d&1|0)==0){e=(c[115244]^255)&255}else{e=-1}if((d&2|0)==0){f=(c[115245]^255)&(e&255)&255}else{f=e}if((d&4|0)==0){g=(c[115246]^255)&(f&255)&255}else{g=f}if((d&8|0)==0){h=(c[115247]^255)&(g&255)&255}else{h=g}if((d&16|0)==0){i=(c[115248]^255)&(h&255)&255}else{i=h}if((d&32|0)==0){j=(c[115249]^255)&(i&255)&255}else{j=i}if((d&64|0)==0){k=(c[115250]^255)&(j&255)&255}else{k=j}if((d&128|0)!=0){l=k;m=b|0;n=a[m]|0;o=b+2|0;p=a[o]|0;q=~p;r=n|q;s=r&l;t=a[802970]|0;u=~t;v=s&u;return v|0}l=(c[115251]^255)&(k&255)&255;m=b|0;n=a[m]|0;o=b+2|0;p=a[o]|0;q=~p;r=n|q;s=r&l;t=a[802970]|0;u=~t;v=s&u;return v|0}function lg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a[b+65|0]&~a[802970]&255;if((d&1|0)==0){e=(c[200708]^255)&255}else{e=-1}if((d&2|0)==0){f=(c[200709]^255)&(e&255)&255}else{f=e}if((d&4|0)==0){g=(c[200710]^255)&(f&255)&255}else{g=f}if((d&8|0)==0){h=(c[200711]^255)&(g&255)&255}else{h=g}if((d&16|0)==0){i=(c[200712]^255)&(h&255)&255}else{i=h}if((d&32|0)==0){j=(c[200713]^255)&(i&255)&255}else{j=i}if((d&64|0)==0){k=(c[200714]^255)&(j&255)&255}else{k=j}if((d&128|0)==0){l=(c[200715]^255)&(k&255)&255}else{l=k}k=a[b+1|0]|0;d=a[b+3|0]|0;return(k|~d)&l&~a[802969]|d&k&a[b+2|0]|0}function lh(a){a=a|0;return}function li(a){a=a|0;return}function lj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=c[198576]|0;f=c[a+120>>2]|0;if((e|0)==0){return}if((c[e>>2]|0)>>>0<=f>>>0){return}a=(c[e+4>>2]|0)+(f<<2)|0;f=c[a>>2]|0;g=(f&2|0)!=0;if((b|0)!=0){if(g){return}b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;b=e+80128|0;c[b>>2]=c[b>>2]|66;c[a>>2]=c[a>>2]|2;c[e+80124>>2]=-1;c[e+80088>>2]=0;b=e+16|0;if((c[e+80120>>2]|0)>>>0>d>>>0){gI(e,d,b);return}else{c[b>>2]=d;return}}if(!g){return}g=e+12|0;if((c[g>>2]|0)<=0){gE();return}c[a>>2]=f&-3;f=(c[g>>2]|0)-1|0;c[g>>2]=f;if((f|0)!=0){return}f=e+80128|0;c[f>>2]=c[f>>2]&-3;c[e+80124>>2]=d+3;return}function lk(a,b){a=a|0;b=b|0;gG(c[198576]|0,c[a+120>>2]|0,b);return}function ll(a){a=a|0;return}function lm(a,b){a=a|0;b=b|0;return}function ln(){pq();return}function lo(){pp(0);return}function lp(){pp(0);return}function lq(a,b){a=a|0;b=b|0;c[a+80>>2]=b;return}function lr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=c[198603]|0;if((b&15)==2){if((a[e+2|0]|0)==d<<24>>24){f=5215}else{g=1}}else{f=5215}if((f|0)==5215){g=0}a[53200]=g;m2(e,b,d);return}function ls(a){a=a|0;return m4(c[198603]|0,a)|0}function lt(a){a=a|0;return m7(c[198603]|0,a)|0}function lu(){var a=0;a=c[198603]|0;if((a|0)==0){return}c[a+140>>2]=c[209410];return}function lv(a){a=a|0;m9(c[198603]|0,c[198582]|0,c[198576]|0,c[198578]|0);return}function lw(a){a=a|0;var b=0,d=0,e=0;b=i;d=hh(1,220)|0;e=d;c[a+4>>2]=e;c[d+148>>2]=0;c[d+152>>2]=0;c[d+132>>2]=794272;c[d+128>>2]=794320;c[d+80>>2]=19656;m8(e);c[d+140>>2]=c[209410];c[d+112>>2]=0;c[d+116>>2]=1;e=hn(89384,(a=i,i=i+1|0,i=i+7&-8,c[a>>2]=0,a)|0)|0;i=a;c[d+124>>2]=e;c[d+156>>2]=60;c[d+160>>2]=64;c[d+164>>2]=68;c[d+168>>2]=46;c[d+172>>2]=248;c[d+176>>2]=42;c[d+180>>2]=126;c[d+184>>2]=228;c[d+188>>2]=262;c[d+192>>2]=42;c[d+196>>2]=110;c[d+200>>2]=188;c[d+204>>2]=218;c[d+208>>2]=42;c[d+212>>2]=54;c[d+216>>2]=48;i=b;return}function lx(a,b,d){a=a|0;b=b|0;d=d|0;b=d&3^3;c[80926]=b;jn(b);return}function ly(a,b,c){a=a|0;b=b|0;c=c|0;return}function lz(b,d,e){b=b|0;d=d|0;e=e|0;if((a[b+65|0]|0)==e<<24>>24){return}b=(e^3)&3;if((b|0)==(c[80926]|0)){return}c[80926]=b;jo(b,a[53200]&1);return}function lA(a,b,c){a=a|0;b=b|0;c=c|0;return}function lB(a,b){a=a|0;b=b|0;return}function lC(b){b=b|0;return(a[b+2|0]^63|a[b|0])&63|0}function lD(b){b=b|0;var c=0;c=a[b+3|0]|0;return a[b+1|0]&c|~c|0}function lE(a){a=a|0;return}function lF(a){a=a|0;return}function lG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=c[198576]|0;f=c[a+120>>2]|0;if((e|0)==0){return}if((c[e>>2]|0)>>>0<=f>>>0){return}a=e+4|0;g=c[a>>2]|0;h=g+(f<<2)|0;i=(c[h>>2]&1|0)!=0;if((b|0)==0){if(!i){return}b=e+20|0;j=c[b>>2]|0;if((j|0)>0){c[b>>2]=j-1;c[h>>2]=c[h>>2]&-2;return}else{gF();return}}if(i){return}i=e+20|0;h=c[i>>2]|0;do{if((h|0)==0){j=e+80128|0;b=c[j>>2]|0;if((b&1|0)!=0){k=0;l=g;break}c[j>>2]=b|1;c[e+80092>>2]=0;b=e+24|0;if((c[e+80120>>2]|0)>>>0>d>>>0){gI(e,d,b);k=c[i>>2]|0;l=c[a>>2]|0;break}else{c[b>>2]=d;k=0;l=g;break}}else{k=h;l=g}}while(0);c[i>>2]=k+1;k=l+(f<<2)|0;c[k>>2]=c[k>>2]|1;return}function lH(a,b){a=a|0;b=b|0;gH(c[198576]|0,c[a+120>>2]|0,b);return}function lI(a){a=a|0;c[80926]=0;jq();return}function lJ(a,b){a=a|0;b=b|0;return}function lK(){pq();return}function lL(){pp(0);return}function lM(){pp(0);return}function lN(a,b){a=a|0;b=b|0;c[a+80>>2]=b;return}function lO(a,b){a=a|0;b=b|0;var d=0;if((a|0)==0){b=c[197212]|0;c[217768]=620512+(b*1028|0);d=487896+((c[80924]|0)*32896|0)+(b*1028|0)|0}else{c[217768]=619480;d=486864}c[217766]=d;c[80448]=a;return}function lP(){fZ(c[198578]|0,124,0);return}function lQ(b,d){b=b|0;d=d|0;var e=0;d=a[477578]|0;do{if(d<<24>>24!=0){e=d+1&255;a[477578]=e;if(e<<24>>24!=3){break}a[477576]=0;a[477578]=0}}while(0);d=a[477579]|0;do{if(d<<24>>24!=0){e=d+1&255;a[477579]=e;if(e<<24>>24!=3){break}a[477577]=0;a[477579]=0}}while(0);c[119392]=(c[119392]|0)-b;c[119393]=(c[119393]|0)-b;return}function lR(){var a=0,b=0,e=0;c[197212]=(d[477561]|0|(d[477560]|0)^7)&7|(d[803536]|0)<<3|(d[803537]|0)<<4;j5(c[80944]|0,1,23);if((c[80448]|0)==0){a=c[197212]|0;c[217768]=620512+(a*1028|0);b=487896+((c[80924]|0)*32896|0)+(a*1028|0)|0;e=a}else{c[217768]=619480;b=486864;e=c[197212]|0}c[217766]=b;c[217770]=686312+(e*1028|0);c[163352]=653416+(e*1028|0);if((c[215622]|0)==0){return}c[c[215626]>>2]=c[686312+(e*1028|0)+((c[197210]|0)>>>8<<2)>>2];e=c[215626]|0;if((c[e>>2]|0)!=0){b=c[197210]|0;c[e>>2]=(c[(c[217770]|0)+(b>>>8<<2)>>2]|0)+(-(b&65280)|0)}c[c[215622]>>2]=c[(c[163352]|0)+((c[197210]|0)>>>8<<2)>>2];return}function lS(b){b=b|0;var d=0,e=0;d=b&255;if((d|0)==0){e=a[477562]|0;return e|0}else if((d|0)==1){do{if((a[477579]|a[477578])<<24>>24!=0){d=c[198580]|0;if((c[119392]|0)>>>0<d>>>0){a[477578]=0;a[477576]=0}if((c[119393]|0)>>>0>=d>>>0){break}a[477577]=0;a[477579]=0}}while(0);e=a[477563]&~(((a[477577]|0)==0)<<7|((a[477576]|0)==0)<<6);return e|0}else{e=a[719208+(b&255)|0]|0;return e|0}return 0}function lT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b&255;b=e&65535;if((b|0)==0){f=(c[80924]|0)==0;g=p2()|0;if(f){pU(0,g)}else{a[719208]=g;kN((c[198568]|0)+1|0)}g=a[477577]|0;f=d<<24>>24>-1;h=a[477579]|0;if(g<<24>>24!=0&f&h<<24>>24==0){a[477579]=1;c[119393]=(c[198580]|0)+35e4;i=1}else{i=h}h=(a[477576]|0)==0;do{if(!h){if((a[477578]|d&64)<<24>>24!=0){break}a[477578]=1;c[119392]=(c[198580]|0)+35e4}}while(0);if(!(f|g<<24>>24==0|i<<24>>24==0)){a[477579]=0}do{if(!h){if((d&64)==0|(a[477578]|0)==0){break}a[477578]=0}}while(0);if((a[477560]|0)==d<<24>>24){return}a[477560]=d;lR();return}else if((b|0)==1){h=(c[80924]|0)==0;i=p2()|0;if(h){pU(1,i)}else{a[719209]=i;kN((c[198568]|0)+1|0)}i=a[477560]|0;if((i&d)<<24>>24<0){a[477577]=1}do{if((i&64)!=0){if((d&64)==0){break}a[477576]=1}}while(0);if((a[477561]|0)==d<<24>>24){return}a[477561]=d;lR();return}else{if((c[80924]|0)==0){pU(e,d);return}else{a[719208+b|0]=d;return}}}function lU(b){b=b|0;return a[789904+(b&4095)|0]|0}function lV(b,c){b=b|0;c=c|0;a[789904+(b&4095)|0]=c;return}function lW(b){b=b|0;return a[719208+(b&65535)|0]|0}function lX(b,c){b=b|0;c=c|0;a[719208+(b&65535)|0]=c;return}function lY(b,d){b=b|0;d=d|0;if((c[80924]|0)==3){pX(b,d);return}else{a[719208+(b&65535)|0]=d;return}}function lZ(a,b){a=a|0;b=b|0;c5[c[(c[217766]|0)+((a&65535)>>>8<<2)>>2]&255](a,b);return}function l_(a){a=a|0;return da[c[(c[217768]|0)+((a&65535)>>>8<<2)>>2]&255](a)|0}function l$(a,b){a=a|0;b=b|0;c5[c[487896+((c[80924]|0)*32896|0)+((a&65535)>>>8<<2)>>2]&255](a,b);return}function l0(b,c){b=b|0;c=c|0;a[788872+(b&1023)|0]=c&15;return}function l1(b){b=b|0;var c=0;c=a[788872+(b&1023)|0]|0;return(p3()|0)&-16|c|0}function l2(a,b,d){a=a|0;b=b|0;d=d|0;c[487896+(a*1028|0)+(b<<2)>>2]=d;c[520792+(a*1028|0)+(b<<2)>>2]=d;c[553688+(a*1028|0)+(b<<2)>>2]=d;c[586584+(a*1028|0)+(b<<2)>>2]=d;return}function l3(a,b,d){a=a|0;b=b|0;d=d|0;c[620512+(a*1028|0)+(b<<2)>>2]=d;return}function l4(a,b,d){a=a|0;b=b|0;d=d|0;c[686312+(a*1028|0)+(b<<2)>>2]=d;return}function l5(){var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c[197474]=789904;c[197216]=788872;c[197214]=788872;j0(653416);b=0;while(1){c[619480+(b<<2)>>2]=148;c[486864+(b<<2)>>2]=94;d=b+1|0;if((d|0)<257){b=d}else{e=0;break}}while(1){c[487896+(e*1028|0)>>2]=190;c[520792+(e*1028|0)>>2]=190;c[553688+(e*1028|0)>>2]=190;c[586584+(e*1028|0)>>2]=190;c[620512+(e*1028|0)>>2]=136;c[686312+(e*1028|0)>>2]=719208;b=1;do{c[620512+(e*1028|0)+(b<<2)>>2]=118;c[686312+(e*1028|0)+(b<<2)>>2]=719208+(b<<8);d=b&192;f=b&63;L6661:do{if((f|0)==57){g=487896+(e*1028|0)+(b<<2)|0;do{if((d|0)==0){c[g>>2]=44;c[520792+(e*1028|0)+(b<<2)>>2]=178;h=5383}else{c[g>>2]=178;i=520792+(e*1028|0)+(b<<2)|0;if((d|0)==64){c[i>>2]=44;h=5383;break}c[i>>2]=178;i=553688+(e*1028|0)+(b<<2)|0;if((d|0)==128){c[i>>2]=44;break}c[i>>2]=178;if((d|0)!=192){break}c[586584+(e*1028|0)+(b<<2)>>2]=44;break L6661}}while(0);if((h|0)==5383){h=0;c[553688+(e*1028|0)+(b<<2)>>2]=178}c[586584+(e*1028|0)+(b<<2)>>2]=178}else if((f|0)==63){g=0;do{if((d|0)==(g<<6|0)){j=224}else{j=178}c[487896+(g*32896|0)+(e*1028|0)+(b<<2)>>2]=j;g=g+1|0;}while((g|0)<4)}else{g=0;do{if((d|0)==(g<<6|0)){k=202}else{k=178}c[487896+(g*32896|0)+(e*1028|0)+(b<<2)>>2]=k;g=g+1|0;}while((g|0)<4)}}while(0);b=b+1|0;}while((b|0)<255);c[621532+(e*1028|0)>>2]=118;c[687332+(e*1028|0)>>2]=784488;c[488916+(e*1028|0)>>2]=114;c[521812+(e*1028|0)>>2]=114;c[554708+(e*1028|0)>>2]=114;c[587604+(e*1028|0)>>2]=114;b=e+1|0;if((b|0)<32){e=b}else{l=208;break}}do{c[621540+(l<<2)>>2]=150;c[622568+(l<<2)>>2]=150;c[623596+(l<<2)>>2]=150;c[629764+(l<<2)>>2]=150;c[630792+(l<<2)>>2]=150;c[631820+(l<<2)>>2]=150;c[646212+(l<<2)>>2]=150;c[647240+(l<<2)>>2]=150;c[648268+(l<<2)>>2]=150;e=789904+(l<<8&3840)|0;c[687340+(l<<2)>>2]=e;c[688368+(l<<2)>>2]=e;c[689396+(l<<2)>>2]=e;c[695564+(l<<2)>>2]=e;c[696592+(l<<2)>>2]=e;c[697620+(l<<2)>>2]=e;c[712012+(l<<2)>>2]=e;c[713040+(l<<2)>>2]=e;c[714068+(l<<2)>>2]=e;l=l+1|0;}while((l|0)<224);j$(0);l=0;do{c[621536+(l*1028|0)>>2]=c[620512+(l*1028|0)>>2];c[488920+(l*1028|0)>>2]=c[487896+(l*1028|0)>>2];c[521816+(l*1028|0)>>2]=c[520792+(l*1028|0)>>2];c[554712+(l*1028|0)>>2]=c[553688+(l*1028|0)>>2];c[587608+(l*1028|0)>>2]=c[586584+(l*1028|0)>>2];c[687336+(l*1028|0)>>2]=c[686312+(l*1028|0)>>2];l=l+1|0;}while((l|0)<32);c[217768]=627708;c[217766]=495092+((c[80924]|0)*32896|0);c[217770]=693508;c[163352]=660612;pj(28672,4096);j6();a[803536]=0;a[803537]=0;lR();return}function l6(a){a=a|0;qM(a,1);return da[c[620512+((c[197212]|0)*1028|0)+((a&65535)>>>8<<2)>>2]&255](a)|0}function l7(a,b){a=a|0;b=b|0;qN(a,1);c5[c[487896+((c[80924]|0)*32896|0)+((c[197212]|0)*1028|0)+((a&65535)>>>8<<2)>>2]&255](a,b);return}function l8(){hR(719208,65536);mG();return}function l9(a){a=a|0;c[80924]=a;if((c[217766]|0)==486864){px(a);return}c[217766]=487896+(a*32896|0)+((c[197212]|0)*1028|0);px(a);return}function ma(a){a=a|0;var b=0;L6705:do{if((a&65535)>>>0>57343>>>0){switch(c[197212]|0){case 2:case 3:case 6:case 7:case 10:case 11:case 14:case 15:case 26:case 27:case 30:case 31:{b=1;break L6705;break};default:{}}b=0}else{b=0}}while(0);return b|0}function mb(b,c){b=b|0;c=c|0;var d=0;d=b&65535;switch(d&65280|0){case 53760:{jG(b,c);return};case 56320:{k2(b,c);return};case 54528:{jP(b,c);return};case 53248:{jA(b,c);return};case 56576:{lr(b,c);return};case 55296:case 55552:case 55808:case 56064:{a[788872+(d&1023)|0]=c&15;return};case 57088:{jZ(b,c);return};case 55040:{jV(b,c);return};case 54272:{jM(b,c);return};case 53504:{jD(b,c);return};case 56832:{jX(b,c);return};case 54016:{jJ(b,c);return};case 54784:{jS(b,c);return};default:{return}}}function mc(b){b=b|0;var c=0,d=0;c=b&65535;switch(c&65280|0){case 57088:{d=jY(b)|0;break};case 54272:{d=jK(b)|0;break};case 56320:{d=k3(b)|0;break};case 53248:{d=jx(b)|0;break};case 54016:{d=jH(b)|0;break};case 54528:{d=jN(b)|0;break};case 53504:{d=jB(b)|0;break};case 55040:{d=jT(b)|0;break};case 54784:{d=jQ(b)|0;break};case 56576:{d=ls(b)|0;break};case 53760:{d=jE(b)|0;break};case 56832:{d=jW(b)|0;break};case 55296:case 55552:case 55808:case 56064:{d=a[788872+(c&1023)|0]|(p3()|0)&-16;break};default:{d=-1}}return d|0}function md(){return 77224}function me(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=c[19306]|0;if((b|0)==0){d=-1;return d|0}else{e=0;f=b}while(1){b=e+1|0;if((a9(a|0,f|0)|0)==0){break}g=c[77224+(b<<2)>>2]|0;if((g|0)==0){d=-1;h=5449;break}else{e=b;f=g}}if((h|0)==5449){return d|0}d=c[77200+(e<<2)>>2]|0;return d|0}function mf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;do{if((b|0)==0){f=da[c[(c[217768]|0)+((d&65535)>>>8<<2)>>2]&255](d)|0;return f|0}else if((b|0)==2){g=5457}else if((b|0)==3){if((d+12288&65535)>>>0>=4096>>>0){g=5457;break}f=mc(d)|0;return f|0}else{h=d&65535}}while(0);do{if((g|0)==5457){b=d&65535;if((d+24576&65535)>>>0<8192>>>0){f=a[854064+(b&8191)|0]|0;return f|0}if((d+12288&65535)>>>0<4096>>>0){f=a[789904+(b&4095)|0]|0;return f|0}if((d&65535)>>>0<=57343>>>0){h=b;break}f=a[845872+(b&8191)|0]|0;return f|0}}while(0);f=a[719208+h|0]|0;return f|0}function mg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;do{if((b|0)==4|(b|0)==0){if((c[56584+(c[197212]<<2)>>2]|0)!=0&(d&65535)>>>0>53247>>>0&(d&65535)>>>0<57344>>>0){f=mh(d)|0;return f|0}else{f=da[c[(c[217768]|0)+((d&65535)>>>8<<2)>>2]&255](d)|0;return f|0}}else if((b|0)==2){g=5478}else if((b|0)==3){if((d+12288&65535)>>>0>=4096>>>0){g=5478;break}f=mh(d)|0;return f|0}else{h=d&65535}}while(0);do{if((g|0)==5478){b=d&65535;if((d+24576&65535)>>>0<8192>>>0){f=a[854064+(b&8191)|0]|0;return f|0}if((d+12288&65535)>>>0<4096>>>0){f=a[789904+(b&4095)|0]|0;return f|0}if((d&65535)>>>0<=57343>>>0){h=b;break}f=a[845872+(b&8191)|0]|0;return f|0}}while(0);f=a[719208+h|0]|0;return f|0}function mh(b){b=b|0;var c=0,d=0;c=b&65535;switch(c&65280|0){case 56320:{d=k4(b)|0;break};case 53248:{d=jz(b)|0;break};case 54272:{d=jL(b)|0;break};case 53504:{d=jC(b)|0;break};case 54528:{d=jO(b)|0;break};case 54016:{d=jI(b)|0;break};case 55296:case 55552:case 55808:case 56064:{d=a[788872+(c&1023)|0]|(p3()|0)&-16;break};case 56576:{d=lt(b)|0;break};case 55040:{d=jU(b)|0;break};case 53760:{d=jF(b)|0;break};case 54784:{d=jR(b)|0;break};default:{d=-1}}return d|0}function mi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((b|0)==2){g=5510}else if((b|0)==0){c5[c[(c[217766]|0)+((d&65535)>>>8<<2)>>2]&255](d,e);return}else if((b|0)==3){g=5508}do{if((g|0)==5508){if((d+12288&65535)>>>0>=4096>>>0){g=5510;break}mb(d,e);return}}while(0);do{if((g|0)==5510){if((d+24576&65535)>>>0<8192>>>0){return}if(!((d+12288&65535)>>>0<4096>>>0|(d&65535)>>>0>57343>>>0)){break}return}}while(0);a[719208+(d&65535)|0]=e;return}function mj(a){a=a|0;var b=0;a=i;i=i+8|0;b=a|0;c[b>>2]=0;qQ(b,89016,56320,56335,24);qQ(b,89376,56576,56591,24);j_(b);i=a;return c[b>>2]|0}function mk(a){a=a|0;var b=0;if((a+9216&65535)>>>0<64>>>0){b=ng(c[198602]|0)|0;return b|0}if((a+8960&65535)>>>0>=64>>>0){b=-1;return b|0}b=ng(c[198603]|0)|0;return b|0}function ml(a){a=a|0;return}function mm(){return}function mn(a){a=a|0;return}function mo(a){a=a|0;return p3()|0}function mp(a,b){a=a|0;b=b|0;return}function mq(a){a=a|0;return p3()|0}function mr(a){a=a|0;return p3()|0}function ms(a,b){a=a|0;b=b|0;return}function mt(a,b){a=a|0;b=b|0;l$(a,b);return}function mu(a,b){a=a|0;b=b|0;lX(a,b);return}function mv(a,b){a=a|0;b=b|0;lX(a,b);return}function mw(a){a=a|0;return p3()|0}function mx(a,b){a=a|0;b=b|0;return}function my(a){a=a|0;return p3()|0}function mz(a,b){a=a|0;b=b|0;return}function mA(a){a=a|0;return p3()|0}function mB(a,b){a=a|0;b=b|0;return}function mC(a){a=a|0;return mc(a)|0}function mD(a,b){a=a|0;b=b|0;mb(a,b);return}function mE(a){a=a|0;return 784744}function mF(a){a=a|0;return 784744}function mG(){return}function mH(){return 0}function mI(){return 0}function mJ(){return 0}function mK(){return}function mL(){return}function mM(){return}function mN(a,b){a=a|0;b=b|0;return}function mO(a){a=a|0;return 0}function mP(){return 0}function mQ(){return}function mR(){return}function mS(){return}function mT(){return 0}function mU(){return}function mV(){return}function mW(a){a=a|0;return}function mX(){return}function mY(){return}function mZ(){return}function m_(){return}function m$(){return}function m0(a){a=a|0;return}function m1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;A2(b|0,0,16);c[b+40>>2]=0;c[b+56>>2]=0;c[b+100>>2]=0;d=b+128|0;nk(c[b+92>>2]|0,c[c[d>>2]>>2]|0);nk(c[b+96>>2]|0,c[c[d>>2]>>2]|0);c[b+60>>2]=0;e=b+69|0;C=0;a[e]=C&255;C=C>>8;a[e+1|0]=C&255;C=C>>8;a[e+2|0]=C&255;C=C>>8;a[e+3|0]=C&255;e=b+73|0;C=0;a[e]=C&255;C=C>>8;a[e+1|0]=C&255;C=C>>8;a[e+2|0]=C&255;C=C>>8;a[e+3|0]=C&255;a[b+68|0]=0;a[b+67|0]=1;a[b+11|0]=1;e=(c[b+80>>2]|0)+(c[c[d>>2]>>2]|0)|0;c[b+52>>2]=e;f=c[b+24>>2]|0;g=c[f+4>>2]|0;h=f+12|0;i=c[h>>2]|0;do{if((i|0)<0){j=g+2056|0;k=c[j>>2]|0;if(k>>>0>255>>>0){fW();break}c[g+8+(k<<3)>>2]=f;c[g+8+(k<<3)+4>>2]=e;c[j>>2]=(c[j>>2]|0)+1;j=g+2060|0;if((c[j>>2]|0)>>>0>e>>>0){c[j>>2]=e;c[g+2064>>2]=k}c[h>>2]=k}else{c[g+8+(i<<3)+4>>2]=e;k=g+2060|0;j=g+2064|0;l=c[j>>2]|0;if((c[k>>2]|0)>>>0>e>>>0){m=l}else{if((i|0)==(l|0)){m=i}else{break}}l=c[g+2056>>2]|0;if((l|0)==0){n=m;o=-1}else{p=m;q=0;r=-1;while(1){s=c[g+8+(q<<3)+4>>2]|0;t=s>>>0>r>>>0;u=t?p:q;v=t?r:s;s=q+1|0;if(s>>>0<l>>>0){p=u;q=s;r=v}else{n=u;o=v;break}}}c[k>>2]=o;c[j>>2]=n}}while(0);a[b+84|0]=0;c[b+32>>2]=0;n=b+36|0;a[n]=0;dk[c[b+192>>2]&127](b,0,c[c[d>>2]>>2]|0);a[n]=0;a[b+65|0]=-1;a[b+66|0]=-1;c4[c[b+200>>2]&511](b);c[b+144>>2]=1;return}function m2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=c[b+208>>2]|0;if((f|0)!=0){dd[f&63]()}if((c[c[b+132>>2]>>2]|0)==0){m3(b,d,e);return}f=b+128|0;g=c[f>>2]|0;c[g>>2]=(c[g>>2]|0)-1;m3(b,d,a[b+108|0]|0);g=c[f>>2]|0;c[g>>2]=(c[g>>2]|0)+1;m3(b,d,e);return}function m3(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=e&15;e=d+128|0;h=c[e>>2]|0;i=c[h>>2]|0;j=i-(c[d+136>>2]|0)|0;k=g&65535;switch(k|0){case 0:case 2:{a[d+k|0]=f;l=a[d|0]|~a[d+2|0];m=d+65|0;if(l<<24>>24==(a[m]|0)){return}dk[c[d+164>>2]&127](d,c[c[e>>2]>>2]|0,l);a[m]=l;return};case 6:{m5(d,j);l=c[d+96>>2]|0;m=l+6|0;n=f&255;b[m>>1]=(b[m>>1]&65280|n)&65535;if((b[l+4>>1]&512)!=0){m=l+8|0;b[m>>1]=(b[m>>1]&65280|n)&65535}m6(l);return};case 1:case 3:{a[d+k|0]=f;l=a[d+1|0]|~a[d+3|0];n=d+14|0;m=a[n]|0;o=d+15|0;do{if(((a[o]|m)&2)==0){p=l}else{do{if((m&2)==0){q=l}else{r=d+92|0;s=c[r>>2]|0;t=c[s+12>>2]|0;if(t>>>0>j>>>0){u=0;v=s}else{s=d|0;w=t;while(1){nb((c[c[e>>2]>>2]|0)-w|0,s);t=c[r>>2]|0;x=c[t+12>>2]|0;if(x>>>0>j>>>0){u=w;v=t;break}else{w=x}}}do{if((u|0)!=(j|0)){w=nh(v,j)|0;if((w|0)==0){break}s=d+32|0;c[s>>2]=c[s>>2]|1;s=d+44|0;c[s>>2]=(c[s>>2]|0)+w&1}}while(0);w=l&-65;if((a[n]&4)==0){if((b[(c[r>>2]|0)+4>>1]&1024)==0){q=w;break}}else{if((c[d+44>>2]|0)==0){q=w;break}}q=l|64}}while(0);if((a[o]&2)==0){p=q;break}m5(d,j);w=q&127;if((a[o]&4)==0){if((b[(c[d+96>>2]|0)+4>>1]&1024)==0){p=w;break}}else{if((c[d+48>>2]|0)==0){p=w;break}}p=q|-128}}while(0);q=d+66|0;if(p<<24>>24!=(a[q]|0)){dk[c[d+168>>2]&127](d,c[c[e>>2]>>2]|0,p);a[q]=p}if(g<<16>>16!=1){return}c5[c[d+204>>2]&255](d,j);return};case 5:{p=d+92|0;q=c[p>>2]|0;o=c[q+12>>2]|0;L6968:do{if(o>>>0>j>>>0){y=0;z=q}else{l=d|0;n=o;v=i;while(1){nb(v-n|0,l);u=c[p>>2]|0;m=c[u+12>>2]|0;if(m>>>0>j>>>0){y=n;z=u;break L6968}n=m;v=c[c[e>>2]>>2]|0}}}while(0);do{if((y|0)!=(j|0)){o=nh(z,j)|0;if((o|0)==0){break}q=d+32|0;c[q>>2]=c[q>>2]|1;q=d+44|0;c[q>>2]=(c[q>>2]|0)+o&1}}while(0);z=c[p>>2]|0;p=z+6|0;y=b[p>>1]&255|(f&255)<<8;b[p>>1]=y;if((b[z+4>>1]&513)!=1){b[z+8>>1]=y}m6(z);return};case 14:{do{if((f&1)!=0){if((a[d+14|0]&1)!=0){break}c[d+44>>2]=1}}while(0);z=d+92|0;y=c[z>>2]|0;p=c[y+12>>2]|0;L6987:do{if(p>>>0>j>>>0){A=0;B=y}else{o=d|0;q=p;v=h;while(1){nb((c[v>>2]|0)-q|0,o);n=c[z>>2]|0;l=c[n+12>>2]|0;if(l>>>0>j>>>0){A=q;B=n;break L6987}q=l;v=c[e>>2]|0}}}while(0);do{if((A|0)!=(j|0)){p=nh(B,j)|0;if((p|0)==0){break}y=d+32|0;c[y>>2]=c[y>>2]|1;y=d+44|0;c[y>>2]=(c[y>>2]|0)+p&1}}while(0);B=c[z>>2]|0;z=B+4|0;b[z>>1]=(b[z>>1]&-58|f&57)^32;m6(B);a[d+14|0]=f&-17;return};case 4:{B=d+92|0;z=c[B>>2]|0;A=c[z+12>>2]|0;L6999:do{if(A>>>0>j>>>0){C=0;D=z}else{p=d|0;y=A;v=i;while(1){nb(v-y|0,p);q=c[B>>2]|0;o=c[q+12>>2]|0;if(o>>>0>j>>>0){C=y;D=q;break L6999}y=o;v=c[c[e>>2]>>2]|0}}}while(0);do{if((C|0)!=(j|0)){A=nh(D,j)|0;if((A|0)==0){break}z=d+32|0;c[z>>2]=c[z>>2]|1;z=d+44|0;c[z>>2]=(c[z>>2]|0)+A&1}}while(0);D=c[B>>2]|0;B=D+6|0;C=f&255;b[B>>1]=(b[B>>1]&65280|C)&65535;if((b[D+4>>1]&512)!=0){B=D+8|0;b[B>>1]=(b[B>>1]&65280|C)&65535}m6(D);return};case 12:{a[d+12|0]=f;if((a[d+14|0]&64)==0){return}c[d+60>>2]=1;D=d+92|0;C=c[D>>2]|0;B=c[C+12>>2]|0;L7017:do{if(B>>>0>j>>>0){E=0;F=C}else{A=d|0;z=B;v=h;while(1){nb((c[v>>2]|0)-z|0,A);y=c[D>>2]|0;p=c[y+12>>2]|0;if(p>>>0>j>>>0){E=z;F=y;break L7017}z=p;v=c[e>>2]|0}}}while(0);do{if((E|0)!=(j|0)){B=nh(F,j)|0;if((B|0)==0){break}C=d+32|0;c[C>>2]=c[C>>2]|1;C=d+44|0;c[C>>2]=(c[C>>2]|0)+B&1}}while(0);m6(c[D>>2]|0);return};case 13:{D=d+92|0;F=c[D>>2]|0;E=c[F+12>>2]|0;L7029:do{if(E>>>0>j>>>0){G=0;H=F}else{B=d|0;C=E;v=i;while(1){nb(v-C|0,B);z=c[D>>2]|0;A=c[z+12>>2]|0;if(A>>>0>j>>>0){G=C;H=z;break L7029}C=A;v=c[c[e>>2]>>2]|0}}}while(0);do{if((G|0)!=(j|0)){i=nh(H,j)|0;if((i|0)==0){break}E=d+32|0;c[E>>2]=c[E>>2]|1;E=d+44|0;c[E>>2]=(c[E>>2]|0)+i&1}}while(0);m5(d,j);if(f<<24>>24>-1){H=d+13|0;G=a[H]&((f|-128)^127);a[H]=G;I=G}else{G=d+13|0;H=a[G]|f&127;a[G]=H;I=H}H=d+13|0;G=d+32|0;i=c[G>>2]|0;do{if((i&127&(I&255)|0)==0){J=I}else{E=j+1|0;F=c[d+40>>2]|0;if((F|0)==(j|0)){K=((c[d+140>>2]|0)==1)+E|0}else{K=E}E=(c[d+140>>2]|0)!=1;if(E&(F|0)==(K|0)){J=I;break}F=(E&1)+K|0;if((i&256|0)!=0){c[G>>2]=i&-259}E=c[d+116>>2]|0;v=c[d+192>>2]|0;if((E|0)==0){dk[v&127](d,0,F);a[d+36|0]=0}else{dk[v&127](d,E,F);a[d+36|0]=1}c[G>>2]=c[G>>2]|128;J=a[H]|0}}while(0);if((J&1)==0){L=J}else{m6(c[D>>2]|0);L=a[H]|0}if((L&2)==0){return}m6(c[d+96>>2]|0);return};case 7:{m5(d,j);L=c[d+96>>2]|0;H=L+6|0;D=b[H>>1]&255|(f&255)<<8;b[H>>1]=D;if((b[L+4>>1]&513)!=1){b[L+8>>1]=D}m6(L);return};case 8:case 11:case 9:case 10:{L=g<<16>>16==11;do{if(L){D=f&-97;if((f&31)!=18){M=D;break}M=(a[d+15|0]|0)<0?D:D^-128}else{M=f}}while(0);if((a[d+15|0]|0)<0){a[k-8+(d+69)|0]=M}else{if(g<<16>>16==8){a[d+67|0]=0}if(L){a[d+67|0]=1}a[d+k|0]=M}if((a[d+67|0]|0)!=0){return}if((A0(d+69|0,d+8|0,4)|0)!=0){return}M=d+32|0;L=c[M>>2]|0;c[M>>2]=L|4;if((a[d+13|0]&4)==0){return}c[M>>2]=L|132;L=c[d+116>>2]|0;M=c[c[e>>2]>>2]|0;g=c[d+192>>2]|0;if((L|0)==0){dk[g&127](d,0,M);a[d+36|0]=0;return}else{dk[g&127](d,L,M);a[d+36|0]=1;return}break};case 15:{M=f&255;do{if((M&1|0)!=0){if((a[d+15|0]&1)!=0){break}c[d+48>>2]=1}}while(0);L=d+92|0;g=c[L>>2]|0;D=c[g+12>>2]|0;L7103:do{if(D>>>0>j>>>0){N=0;O=g}else{H=d|0;J=D;G=h;while(1){nb((c[G>>2]|0)-J|0,H);i=c[L>>2]|0;K=c[i+12>>2]|0;if(K>>>0>j>>>0){N=J;O=i;break L7103}J=K;G=c[e>>2]|0}}}while(0);do{if((N|0)!=(j|0)){e=nh(O,j)|0;if((e|0)==0){break}h=d+32|0;c[h>>2]=c[h>>2]|1;h=d+44|0;c[h>>2]=(c[h>>2]|0)+e&1}}while(0);m5(d,j);if((M&64|0)==0){M=c[d+96>>2]|0;j=M+4|0;b[j>>1]=(b[j>>1]&-58|f&57)^32;m6(M)}else{m6(c[L>>2]|0);L=c[d+96>>2]|0;M=L+4|0;b[M>>1]=b[M>>1]&-58|f&25;m6(L)}a[d+15|0]=f&-17;return};default:{a[d+k|0]=f;return}}}function m4(f,g){f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0;h=g&15;g=f+212|0;i=c[g>>2]|0;if((i|0)==0){j=0}else{dd[i&63]();j=c[g>>2]|0}g=f+128|0;i=c[g>>2]|0;c[f+100>>2]=c[i>>2];c[f+104>>2]=0;k=c[i>>2]|0;if((j|0)!=0){dd[j&63]()}j=h&65535;switch(j|0){case 14:{i=f+92|0;l=c[i>>2]|0;m=c[l+12>>2]|0;if(m>>>0>k>>>0){n=0;o=l}else{l=f|0;p=m;while(1){nb((c[c[g>>2]>>2]|0)-p|0,l);m=c[i>>2]|0;q=c[m+12>>2]|0;if(q>>>0>k>>>0){n=p;o=m;break}else{p=q}}}do{if((n|0)!=(k|0)){p=nh(o,k)|0;if((p|0)==0){break}l=f+32|0;c[l>>2]=c[l>>2]|1;l=f+44|0;c[l>>2]=(c[l>>2]|0)+p&1}}while(0);o=b[(c[i>>2]|0)+4>>1]&1|a[f+14|0]&-2;a[f+108|0]=o;r=o;return r|0};case 0:{o=da[c[f+176>>2]&255](f)|0;a[f+108|0]=o;r=o;return r|0};case 7:{m5(f,k);o=(e[(c[f+96>>2]|0)+8>>1]|0)>>>8&255;a[f+108|0]=o;r=o;return r|0};case 8:case 9:case 10:case 11:{o=f+68|0;if((a[o]|0)==0){i=f+8|0;n=f+73|0;C=d[i]|d[i+1|0]<<8|d[i+2|0]<<16|d[i+3|0]<<24|0;a[n]=C&255;C=C>>8;a[n+1|0]=C&255;C=C>>8;a[n+2|0]=C&255;C=C>>8;a[n+3|0]=C&255}if((h<<16>>16|0)==11){a[o]=1}else if((h<<16>>16|0)==8){a[o]=0}o=a[j-8+(f+73)|0]|0;a[f+108|0]=o;r=o;return r|0};case 5:{o=f+92|0;h=c[o>>2]|0;n=c[h+12>>2]|0;if(n>>>0>k>>>0){s=0;t=h}else{h=f|0;i=n;while(1){nb((c[c[g>>2]>>2]|0)-i|0,h);n=c[o>>2]|0;p=c[n+12>>2]|0;if(p>>>0>k>>>0){s=i;t=n;break}else{i=p}}}do{if((s|0)!=(k|0)){i=nh(t,k)|0;if((i|0)==0){break}h=f+32|0;c[h>>2]=c[h>>2]|1;h=f+44|0;c[h>>2]=(c[h>>2]|0)+i&1}}while(0);t=(e[(c[o>>2]|0)+8>>1]|0)>>>8&255;a[f+108|0]=t;r=t;return r|0};case 13:{c[f+40>>2]=k;t=f+92|0;o=c[t>>2]|0;s=c[o+12>>2]|0;if(s>>>0>k>>>0){u=0;v=o}else{o=f|0;i=s;while(1){nb((c[c[g>>2]>>2]|0)-i|0,o);s=c[t>>2]|0;h=c[s+12>>2]|0;if(h>>>0>k>>>0){u=i;v=s;break}else{i=h}}}do{if((u|0)!=(k|0)){i=nh(v,k)|0;if((i|0)==0){break}o=f+32|0;c[o>>2]=c[o>>2]|1;o=f+44|0;c[o>>2]=(c[o>>2]|0)+i&1}}while(0);m5(f,k);c4[c[f+184>>2]&511](f);m6(c[t>>2]|0);m6(c[f+96>>2]|0);t=f+32|0;v=c[t>>2]|0;if((v&256|0)==0){w=v&255}else{u=v&-259;c[t>>2]=u;w=u&255}c[t>>2]=0;dk[c[f+192>>2]&127](f,0,k);a[f+36|0]=0;a[f+108|0]=w;r=w;return r|0};case 1:{w=da[c[f+180>>2]&255](f)|0;c5[c[f+204>>2]&255](f,k);t=f+14|0;u=a[t]|0;v=f+15|0;do{if(((a[v]|u)&2)==0){x=w}else{do{if((u&2)==0){y=w}else{i=f+92|0;o=c[i>>2]|0;h=c[o+12>>2]|0;if(h>>>0>k>>>0){z=0;A=o}else{o=f|0;s=h;while(1){nb((c[c[g>>2]>>2]|0)-s|0,o);h=c[i>>2]|0;p=c[h+12>>2]|0;if(p>>>0>k>>>0){z=s;A=h;break}else{s=p}}}do{if((z|0)!=(k|0)){s=nh(A,k)|0;if((s|0)==0){break}o=f+32|0;c[o>>2]=c[o>>2]|1;o=f+44|0;c[o>>2]=(c[o>>2]|0)+s&1}}while(0);s=w&-65;if((a[t]&4)==0){if((b[(c[i>>2]|0)+4>>1]&1024)==0){y=s;break}}else{if((c[f+44>>2]|0)==0){y=s;break}}y=w|64}}while(0);if((a[v]&2)==0){x=y;break}m5(f,k);s=y&127;if((a[v]&4)==0){if((b[(c[f+96>>2]|0)+4>>1]&1024)==0){x=s;break}}else{if((c[f+48>>2]|0)==0){x=s;break}}x=y|-128}}while(0);a[f+108|0]=x;r=x;return r|0};case 15:{m5(f,k);x=b[(c[f+96>>2]|0)+4>>1]&1|a[f+15|0]&-2;a[f+108|0]=x;r=x;return r|0};case 6:{m5(f,k);x=b[(c[f+96>>2]|0)+8>>1]&255;a[f+108|0]=x;r=x;return r|0};case 12:{c4[c[f+188>>2]&511](f);x=a[f+12|0]|0;a[f+108|0]=x;r=x;return r|0};case 4:{x=f+92|0;y=c[x>>2]|0;v=c[y+12>>2]|0;if(v>>>0>k>>>0){B=0;D=y}else{y=f|0;w=v;while(1){nb((c[c[g>>2]>>2]|0)-w|0,y);v=c[x>>2]|0;t=c[v+12>>2]|0;if(t>>>0>k>>>0){B=w;D=v;break}else{w=t}}}do{if((B|0)!=(k|0)){w=nh(D,k)|0;if((w|0)==0){break}y=f+32|0;c[y>>2]=c[y>>2]|1;y=f+44|0;c[y>>2]=(c[y>>2]|0)+w&1}}while(0);k=b[(c[x>>2]|0)+8>>1]&255;a[f+108|0]=k;r=k;return r|0};default:{k=f+j|0;a[f+108|0]=a[k]|0;r=a[k]|0;return r|0}}return 0}function m5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;do{if((a[b+15|0]&65)==65){e=b+92|0;f=c[e>>2]|0;g=c[f+12>>2]|0;if(g>>>0>d>>>0){h=0;i=f}else{f=b+128|0;j=b|0;k=g;while(1){nb((c[c[f>>2]>>2]|0)-k|0,j);g=c[e>>2]|0;l=c[g+12>>2]|0;if(l>>>0>d>>>0){h=k;i=g;break}else{k=l}}}if((h|0)==(d|0)){break}k=nh(i,d)|0;if((k|0)==0){break}e=b+32|0;c[e>>2]=c[e>>2]|1;e=b+44|0;c[e>>2]=(c[e>>2]|0)+k&1}}while(0);i=b+96|0;h=c[i>>2]|0;k=c[h+12>>2]|0;if(k>>>0>d>>>0){m=0;n=h}else{h=b+128|0;e=b|0;j=k;while(1){nc((c[c[h>>2]>>2]|0)-j|0,e);k=c[i>>2]|0;f=c[k+12>>2]|0;if(f>>>0>d>>>0){m=j;n=k;break}else{j=f}}}if((m|0)==(d|0)){return}m=nh(n,d)|0;if((m|0)==0){return}n=b+32|0;j=c[n>>2]|0;i=j|2;c[n>>2]=i;do{if((c[b+140>>2]|0)==0){if((c[b+40>>2]|0)!=(d-1|0)){o=5830;break}p=j|258}else{o=5830}}while(0);if((o|0)==5830){p=i&-257}c[n>>2]=p;p=b+48|0;c[p>>2]=(c[p>>2]|0)+m&1;return}function m6(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+6|0;e=b[a+4>>1]|0;f=b[a+8>>1]|0;g=c[a+16>>2]|0;L7252:while(1){h=e&65535;if((h&2803|0)==2147){i=h&4360;if((i|0)==4360|(i|0)==0){j=5839;break}}do{if((h&2114|0)==0){if(!((h&1|0)==0|(h&36|0)==0)){break}i=h&4360;if((i|0)==4360|(i|0)==0){j=5850;break L7252}}}while(0);if(f<<16>>16==0){k=b[804872+(h<<1)>>1]|0;l=g+1|0;j=5846}else{i=(h<<25>>31&65535)+f&65535;m=b[804872+(h<<1)>>1]|0;n=g+1|0;if(i<<16>>16==0){k=m;l=n;j=5846}else{o=i;p=m;q=n}}if((j|0)==5846){j=0;if((k&64)==0){o=0;p=k;q=l}else{r=l;j=5851;break}}if((p&512)==0){s=p;t=o}else{s=p&-65;t=b[d>>1]|0}n=s&65535;e=(n&1024|0)==0|(n&4352|0)==0?s:s&-4;f=t;g=q}if((j|0)==5839){r=(f&65535)+g|0;j=5851}else if((j|0)==5850){c[a+12>>2]=-1;u=c[a+20>>2]|0}do{if((j|0)==5851){c[a+12>>2]=r;g=c[a+20>>2]|0;if((r|0)==-1){u=g;break}f=c[g+4>>2]|0;q=g+12|0;t=c[q>>2]|0;if((t|0)<0){s=f+2056|0;e=c[s>>2]|0;if(e>>>0>255>>>0){fW();return}c[f+8+(e<<3)>>2]=g;c[f+8+(e<<3)+4>>2]=r;c[s>>2]=(c[s>>2]|0)+1;s=f+2060|0;if((c[s>>2]|0)>>>0>r>>>0){c[s>>2]=r;c[f+2064>>2]=e}c[q>>2]=e;return}else{c[f+8+(t<<3)+4>>2]=r;e=f+2060|0;q=f+2064|0;s=c[q>>2]|0;do{if((c[e>>2]|0)>>>0>r>>>0){v=s}else{if((t|0)==(s|0)){v=t;break}return}}while(0);t=c[f+2056>>2]|0;if((t|0)==0){w=v;x=-1}else{s=v;h=0;g=-1;while(1){d=c[f+8+(h<<3)+4>>2]|0;p=d>>>0>g>>>0;o=p?s:h;l=p?g:d;d=h+1|0;if(d>>>0<t>>>0){s=o;h=d;g=l}else{w=o;x=l;break}}}c[e>>2]=x;c[q>>2]=w;return}}}while(0);fV(u);return}function m7(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f&15;f=c[e+216>>2]|0;if((f|0)!=0){dd[f&63]()}f=e+128|0;h=c[c[f>>2]>>2]|0;i=g&65535;switch(i|0){case 1:{j=da[c[e+180>>2]&255](e)|0;k=e+14|0;l=a[k]|0;m=e+15|0;if(((a[m]|l)&2)==0){n=j;return n|0}do{if((l&2)==0){o=j}else{p=e+92|0;q=c[p>>2]|0;r=c[q+12>>2]|0;if(r>>>0>h>>>0){s=0;t=q}else{q=e|0;u=r;while(1){nb((c[c[f>>2]>>2]|0)-u|0,q);r=c[p>>2]|0;v=c[r+12>>2]|0;if(v>>>0>h>>>0){s=u;t=r;break}else{u=v}}}do{if((s|0)!=(h|0)){u=nh(t,h)|0;if((u|0)==0){break}q=e+32|0;c[q>>2]=c[q>>2]|1;q=e+44|0;c[q>>2]=(c[q>>2]|0)+u&1}}while(0);u=j&-65;if((a[k]&4)==0){if((b[(c[p>>2]|0)+4>>1]&1024)==0){o=u;break}}else{if((c[e+44>>2]|0)==0){o=u;break}}o=j|64}}while(0);if((a[m]&2)==0){n=o;return n|0}m5(e,h);j=o&127;do{if((a[m]&4)==0){if((b[(c[e+96>>2]|0)+4>>1]&1024)==0){n=j}else{break}return n|0}else{if((c[e+48>>2]|0)==0){n=j}else{break}return n|0}}while(0);n=o|-128;return n|0};case 13:{o=e+92|0;j=c[o>>2]|0;m=c[j+12>>2]|0;L7334:do{if(m>>>0>h>>>0){w=0;x=j}else{k=e|0;t=m;s=h;while(1){nb(s-t|0,k);l=c[o>>2]|0;u=c[l+12>>2]|0;if(u>>>0>h>>>0){w=t;x=l;break L7334}t=u;s=c[c[f>>2]>>2]|0}}}while(0);do{if((w|0)!=(h|0)){f=nh(x,h)|0;if((f|0)==0){break}m=e+32|0;c[m>>2]=c[m>>2]|1;m=e+44|0;c[m>>2]=(c[m>>2]|0)+f&1}}while(0);m5(e,h);m6(c[o>>2]|0);m6(c[e+96>>2]|0);n=c[e+32>>2]&255;return n|0};case 8:case 9:case 10:case 11:{if((a[e+68|0]|0)==0){o=e+8|0;h=e+73|0;C=d[o]|d[o+1|0]<<8|d[o+2|0]<<16|d[o+3|0]<<24|0;a[h]=C&255;C=C>>8;a[h+1|0]=C&255;C=C>>8;a[h+2|0]=C&255;C=C>>8;a[h+3|0]=C&255}n=a[e+i|0]|0;return n|0};default:{n=m4(e,g)|0;return n|0}}return 0}function m8(b){b=b|0;c[b+88>>2]=-1;c[b+100>>2]=0;c[b+104>>2]=0;a[b+108|0]=0;c[b+136>>2]=1;c[b+140>>2]=0;return}function m9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+92|0;c[g>>2]=hg(24)|0;h=a+96|0;c[h>>2]=hg(24)|0;ni();j=a+124|0;c[a+88>>2]=hq(c[j>>2]|0)|0;k=hn(88352,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;m=a|0;n=a+28|0;c[n>>2]=fU(b,k,232,m)|0;hj(k);k=c[n>>2]|0;n=a+128|0;o=(c[c[n>>2]>>2]|0)+5e3|0;p=c[k+4>>2]|0;q=k+12|0;r=c[q>>2]|0;do{if((r|0)<0){s=p+2056|0;t=c[s>>2]|0;if(t>>>0>255>>>0){fW();break}c[p+8+(t<<3)>>2]=k;c[p+8+(t<<3)+4>>2]=o;c[s>>2]=(c[s>>2]|0)+1;s=p+2060|0;if((c[s>>2]|0)>>>0>o>>>0){c[s>>2]=o;c[p+2064>>2]=t}c[q>>2]=t}else{c[p+8+(r<<3)+4>>2]=o;t=p+2060|0;s=p+2064|0;u=c[s>>2]|0;if((c[t>>2]|0)>>>0>o>>>0){v=u}else{if((r|0)==(u|0)){v=r}else{break}}u=c[p+2056>>2]|0;if((u|0)==0){w=v;x=-1}else{y=v;z=0;A=-1;while(1){B=c[p+8+(z<<3)+4>>2]|0;C=B>>>0>A>>>0;D=C?y:z;E=C?A:B;B=z+1|0;if(B>>>0<u>>>0){y=D;z=B;A=E}else{w=D;x=E;break}}}c[t>>2]=x;c[s>>2]=w}}while(0);w=hn(89224,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;x=a+16|0;c[x>>2]=fU(b,w,116,m)|0;hj(w);w=hn(85592,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;p=a+20|0;c[p>>2]=fU(b,w,118,m)|0;hj(w);w=hn(83360,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;c[a+24>>2]=fU(b,w,146,m)|0;hj(w);c[a+120>>2]=gA(d,c[j>>2]|0)|0;fZ(e,38,m);m=hn(89224,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;nj(c[g>>2]|0,m,c[c[n>>2]>>2]|0,c[x>>2]|0);hj(m);m=hn(85592,(l=i,i=i+8|0,c[l>>2]=c[j>>2],l)|0)|0;i=l;nj(c[h>>2]|0,m,c[c[n>>2]>>2]|0,c[p>>2]|0);hj(m);i=f;return}function na(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=b;e=b+128|0;f=c[c[e>>2]>>2]|0;g=f-a|0;a=b+92|0;h=c[a>>2]|0;i=c[h+12>>2]|0;L7372:do{if(i>>>0>g>>>0){j=0;k=h}else{l=i;m=f;while(1){nb(m-l|0,b);n=c[a>>2]|0;o=c[n+12>>2]|0;if(o>>>0>g>>>0){j=l;k=n;break L7372}l=o;m=c[c[e>>2]>>2]|0}}}while(0);do{if((j|0)!=(g|0)){e=nh(k,g)|0;if((e|0)==0){break}a=b+32|0;c[a>>2]=c[a>>2]|1;a=b+44|0;c[a>>2]=(c[a>>2]|0)+e&1}}while(0);m5(d,g);d=c[b+28>>2]|0;b=g+5e3|0;g=c[d+4>>2]|0;k=d+12|0;j=c[k>>2]|0;if((j|0)<0){e=g+2056|0;a=c[e>>2]|0;if(a>>>0>255>>>0){fW();return}c[g+8+(a<<3)>>2]=d;c[g+8+(a<<3)+4>>2]=b;c[e>>2]=(c[e>>2]|0)+1;e=g+2060|0;if((c[e>>2]|0)>>>0>b>>>0){c[e>>2]=b;c[g+2064>>2]=a}c[k>>2]=a;return}else{c[g+8+(j<<3)+4>>2]=b;a=g+2060|0;k=g+2064|0;e=c[k>>2]|0;do{if((c[a>>2]|0)>>>0>b>>>0){p=e}else{if((j|0)==(e|0)){p=j;break}return}}while(0);j=c[g+2056>>2]|0;if((j|0)==0){q=p;r=-1}else{e=p;p=0;b=-1;while(1){d=c[g+8+(p<<3)+4>>2]|0;f=d>>>0>b>>>0;i=f?e:p;h=f?b:d;d=p+1|0;if(d>>>0<j>>>0){e=i;p=d;b=h}else{q=i;r=h;break}}}c[a>>2]=r;c[k>>2]=q;return}}function nb(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=f;h=(c[c[f+128>>2]>>2]|0)-e|0;e=f+92|0;i=nh(c[e>>2]|0,h)|0;if((i|0)!=0){j=f+32|0;c[j>>2]=c[j>>2]|1;j=f+44|0;c[j>>2]=(c[j>>2]|0)+i&1}i=c[e>>2]|0;fV(c[i+20>>2]|0);c[i+12>>2]=-1;i=f+14|0;j=a[i]|0;L7405:do{if((j&41)==1){if((a[f+13|0]&1)==0){k=5951}else{if((c[f+32>>2]&128|0)!=0){k=5951}}do{if((k|0)==5951){if((j&66)!=0){break}if((a[f+15|0]&64)==0){l=j;break L7405}}}while(0);m6(c[e>>2]|0);l=a[i]|0}else{l=j}}while(0);do{if((l&64)!=0){j=f+56|0;i=c[j>>2]|0;if((i|0)!=0){e=i-1|0;c[j>>2]=e;if((e|0)!=0){break}e=f+32|0;c[e>>2]=c[e>>2]|8;c5[c[f+172>>2]&255](g,a[f+64|0]|0);if((c[j>>2]|0)!=0){break}}e=f+60|0;if((c[e>>2]|0)==0){break}a[f+64|0]=a[f+12|0]|0;c[e>>2]=0;c[j>>2]=14}}while(0);do{if((a[f+15|0]&65)==65){m5(g,h);l=c[f+96>>2]|0;j=l+4|0;e=b[j>>1]|0;if((e&1)==0){break}b[j>>1]=e|4;m6(l)}}while(0);l=c[f+40>>2]|0;if((l|0)==(h-1|0)){m=((c[f+140>>2]|0)==1)+h|0}else{m=h}h=f+32|0;e=c[h>>2]|0;if((e&127&(d[f+13|0]|0)|0)==0){return}j=(c[f+140>>2]|0)!=1;if(j&(l|0)==(m|0)){return}l=(j&1)+m|0;if((e&256|0)!=0){c[h>>2]=e&-259}e=c[f+116>>2]|0;m=c[f+192>>2]|0;if((e|0)==0){dk[m&127](g,0,l);a[f+36|0]=0}else{dk[m&127](g,e,l);a[f+36|0]=1}c[h>>2]=c[h>>2]|128;return}function nc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=e;g=(c[c[e+128>>2]>>2]|0)-b|0;b=e+96|0;h=nh(c[b>>2]|0,g)|0;if((h|0)!=0){i=e+32|0;j=c[i>>2]|0;k=j|2;c[i>>2]=k;do{if((c[e+140>>2]|0)==0){if((c[e+40>>2]|0)!=(g-1|0)){l=5981;break}m=j|258}else{l=5981}}while(0);if((l|0)==5981){m=k&-257}c[i>>2]=m;m=e+48|0;c[m>>2]=(c[m>>2]|0)+h&1}h=c[b>>2]|0;fV(c[h+20>>2]|0);c[h+12>>2]=-1;do{if((a[e+15|0]&105)==1){if((a[e+13|0]&2)==0){break}m6(c[b>>2]|0)}}while(0);b=c[e+40>>2]|0;if((b|0)==(g-1|0)){n=((c[e+140>>2]|0)==1)+g|0}else{n=g}g=e+32|0;h=c[g>>2]|0;if((h&127&(d[e+13|0]|0)|0)==0){return}m=(c[e+140>>2]|0)!=1;if(m&(b|0)==(n|0)){return}b=(m&1)+n|0;if((h&256|0)!=0){c[g>>2]=h&-259}h=c[e+116>>2]|0;n=c[e+192>>2]|0;if((h|0)==0){dk[n&127](f,0,b);a[e+36|0]=0}else{dk[n&127](f,h,b);a[e+36|0]=1}c[g>>2]=c[g>>2]|128;return}function nd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=e;f=e+128|0;g=(c[e+80>>2]|0)+(c[c[f>>2]>>2]|0)|0;c[e+52>>2]=g;h=c[e+24>>2]|0;i=c[h+4>>2]|0;j=h+12|0;k=c[j>>2]|0;do{if((k|0)<0){l=i+2056|0;m=c[l>>2]|0;if(m>>>0>255>>>0){fW();break}c[i+8+(m<<3)>>2]=h;c[i+8+(m<<3)+4>>2]=g;c[l>>2]=(c[l>>2]|0)+1;l=i+2060|0;if((c[l>>2]|0)>>>0>g>>>0){c[l>>2]=g;c[i+2064>>2]=m}c[j>>2]=m}else{c[i+8+(k<<3)+4>>2]=g;m=i+2060|0;l=i+2064|0;n=c[l>>2]|0;if((c[m>>2]|0)>>>0>g>>>0){o=n}else{if((k|0)==(n|0)){o=k}else{break}}n=c[i+2056>>2]|0;if((n|0)==0){p=o;q=-1}else{r=o;s=0;t=-1;while(1){u=c[i+8+(s<<3)+4>>2]|0;v=u>>>0>t>>>0;w=v?r:s;x=v?t:u;u=s+1|0;if(u>>>0<n>>>0){r=w;s=u;t=x}else{p=w;q=x;break}}}c[m>>2]=q;c[l>>2]=p}}while(0);if((a[e+67|0]|0)!=0){return}p=e+84|0;q=(a[p]|0)+1&7;i=(q&255|0)==(((a[e+14|0]|0)<0?5:6)|0);a[p]=i?0:q;if(!i){return}i=e+8|0;q=e+9|0;p=d[q]|0;o=p&15;k=p>>>4;g=e+10|0;j=d[g]|0;h=j&15;t=j>>>4;s=e+11|0;r=d[s]|0;n=r&15;x=r>>>4&1;w=r&128;u=(d[i]|0)+1&15;v=u&255;do{if((u|0)==10|(u|0)==0){y=p+1&15;if(!((y|0)==10|(y|0)==0)){z=0;A=y;B=w;C=x;D=n;E=t;F=h;G=k;break}y=k+1&15;if(!((y|0)==6|(y|0)==0)){z=0;A=0;B=w;C=x;D=n;E=t;F=h;G=y;break}y=j+1&15;if(!((y|0)==10|(y|0)==0)){z=0;A=0;B=w;C=x;D=n;E=t;F=y;G=0;break}y=t+1&15;if(!((y|0)==6|(y|0)==0)){z=0;A=0;B=w;C=x;D=n;E=y;F=0;G=0;break}y=r+1&15;if((x|0)==0){H=(y|0)==10;z=0;A=0;B=w;C=H&1;D=H?0:y;E=0;F=0;G=0;break}else{H=(y|0)==3;z=0;A=0;B=H?w^128:w;C=H?0:x;D=H?1:y;E=0;F=0;G=0;break}}else{z=v;A=o;B=w;C=x;D=n;E=t;F=h;G=k}}while(0);a[i]=z;a[q]=(A|G<<4)&255;a[g]=(E<<4|F)&255;a[s]=(C<<4|D|B)&255;if((A0(e+69|0,i|0,4)|0)!=0){return}i=e+32|0;B=c[i>>2]|0;c[i>>2]=B|4;if((a[e+13|0]&4)==0){return}c[i>>2]=B|132;B=c[e+116>>2]|0;i=c[c[f>>2]>>2]|0;f=c[e+192>>2]|0;if((B|0)==0){dk[f&127](b,0,i);a[e+36|0]=0;return}else{dk[f&127](b,B,i);a[e+36|0]=1;return}}function ne(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=b;if((c[b+144>>2]|0)==0){return}e=b+128|0;f=c[c[e>>2]>>2]|0;g=f+a|0;h=b+92|0;i=c[h>>2]|0;j=c[i+12>>2]|0;L7523:do{if(j>>>0>g>>>0){k=0;l=i}else{m=j;n=f;while(1){nb(n-m|0,b);o=c[h>>2]|0;p=c[o+12>>2]|0;if(p>>>0>g>>>0){k=m;l=o;break L7523}m=p;n=c[c[e>>2]>>2]|0}}}while(0);do{if((k|0)!=(g|0)){f=nh(l,g)|0;if((f|0)==0){break}j=b+32|0;c[j>>2]=c[j>>2]|1;j=b+44|0;c[j>>2]=(c[j>>2]|0)+f&1}}while(0);m5(d,(c[c[e>>2]>>2]|0)+a|0);nl(c[h>>2]|0,a);nl(c[b+96>>2]|0,a);h=b+40|0;e=c[h>>2]|0;c[h>>2]=e>>>0>a>>>0?e-a|0:0;e=b+100|0;h=c[e>>2]|0;c[e>>2]=h>>>0>a>>>0?h-a|0:0;h=b+52|0;b=c[h>>2]|0;if((b|0)==0){return}c[h>>2]=b-a;return}function nf(a){a=a|0;hj(c[a+148>>2]|0);hj(c[a+92>>2]|0);hj(c[a+96>>2]|0);hj(c[a+124>>2]|0);hj(a|0);return}function ng(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0;g=i;h=(m7(f,13)|0)&255;j=f+216|0;k=c[j>>2]|0;if((k|0)!=0){dd[k&63]()}k=f+128|0;l=(m4(f,14)|0)&255;m=c[j>>2]|0;if((m|0)!=0){dd[m&63]()}m=f+212|0;n=c[m>>2]|0;if((n|0)==0){o=0}else{dd[n&63]();o=c[m>>2]|0}n=c[k>>2]|0;p=f+100|0;c[p>>2]=c[n>>2];q=f+104|0;c[q>>2]=0;r=c[n>>2]|0;if((o|0)!=0){dd[o&63]()}m5(f,r);r=f+96|0;o=b[(c[r>>2]|0)+4>>1]&1|a[f+15|0]&-2;n=f+108|0;a[n]=o;qO(80552,(s=i,i=i+24|0,c[s>>2]=h,c[s+8>>2]=l,c[s+16>>2]=o&255,s)|0)|0;i=s;o=c[j>>2]|0;if((o|0)!=0){dd[o&63]()}o=c[m>>2]|0;do{if((o|0)==0){c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0}else{dd[o&63]();l=c[m>>2]|0;c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0;if((l|0)==0){break}dd[l&63]()}}while(0);o=da[c[f+176>>2]&255](f)|0;a[n]=o;l=o&255;o=c[j>>2]|0;if((o|0)!=0){dd[o&63]()}o=c[m>>2]|0;do{if((o|0)==0){c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0}else{dd[o&63]();h=c[m>>2]|0;c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0;if((h|0)==0){break}dd[h&63]()}}while(0);o=a[f+2|0]|0;a[n]=o;qO(79624,(s=i,i=i+16|0,c[s>>2]=l,c[s+8>>2]=o&255,s)|0)|0;i=s;o=(m7(f,1)|0)&255;l=c[j>>2]|0;if((l|0)!=0){dd[l&63]()}l=c[m>>2]|0;do{if((l|0)==0){c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0}else{dd[l&63]();h=c[m>>2]|0;c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0;if((h|0)==0){break}dd[h&63]()}}while(0);l=a[f+3|0]|0;a[n]=l;qO(78840,(s=i,i=i+16|0,c[s>>2]=o,c[s+8>>2]=l&255,s)|0)|0;i=s;l=c[j>>2]|0;if((l|0)!=0){dd[l&63]()}l=(m4(f,4)|0)&255;o=c[j>>2]|0;if((o|0)!=0){dd[o&63]()}o=((m4(f,5)|0)&255)<<8|l;qO(78272,(s=i,i=i+8|0,c[s>>2]=o,s)|0)|0;i=s;o=c[j>>2]|0;if((o|0)!=0){dd[o&63]()}o=c[m>>2]|0;do{if((o|0)==0){l=c[k>>2]|0;c[p>>2]=c[l>>2];c[q>>2]=0;t=c[l>>2]|0}else{dd[o&63]();l=c[m>>2]|0;h=c[k>>2]|0;c[p>>2]=c[h>>2];c[q>>2]=0;u=c[h>>2]|0;if((l|0)==0){t=u;break}dd[l&63]();t=u}}while(0);m5(f,t);t=b[(c[r>>2]|0)+8>>1]|0;a[n]=t&255;o=t&255;t=c[j>>2]|0;if((t|0)!=0){dd[t&63]()}t=c[m>>2]|0;do{if((t|0)==0){u=c[k>>2]|0;c[p>>2]=c[u>>2];c[q>>2]=0;v=c[u>>2]|0}else{dd[t&63]();u=c[m>>2]|0;l=c[k>>2]|0;c[p>>2]=c[l>>2];c[q>>2]=0;h=c[l>>2]|0;if((u|0)==0){v=h;break}dd[u&63]();v=h}}while(0);m5(f,v);v=(e[(c[r>>2]|0)+8>>1]|0)>>>8;a[n]=v&255;qO(77824,(s=i,i=i+8|0,c[s>>2]=(v&65535)<<8|o,s)|0)|0;i=s;o=c[j>>2]|0;if((o|0)!=0){dd[o&63]()}o=f+68|0;v=a[o]|0;if(v<<24>>24==0){r=f+8|0;t=f+73|0;C=d[r]|d[r+1|0]<<8|d[r+2|0]<<16|d[r+3|0]<<24|0;a[t]=C&255;C=C>>8;a[t+1|0]=C&255;C=C>>8;a[t+2|0]=C&255;C=C>>8;a[t+3|0]=C&255}t=d[f+11|0]|0;r=c[j>>2]|0;if((r|0)==0){w=v}else{dd[r&63]();w=a[o]|0}if(w<<24>>24==0){r=f+8|0;v=f+73|0;C=d[r]|d[r+1|0]<<8|d[r+2|0]<<16|d[r+3|0]<<24|0;a[v]=C&255;C=C>>8;a[v+1|0]=C&255;C=C>>8;a[v+2|0]=C&255;C=C>>8;a[v+3|0]=C&255}v=d[f+10|0]|0;r=c[j>>2]|0;if((r|0)==0){x=w}else{dd[r&63]();x=a[o]|0}if(x<<24>>24==0){r=f+8|0;w=f+73|0;C=d[r]|d[r+1|0]<<8|d[r+2|0]<<16|d[r+3|0]<<24|0;a[w]=C&255;C=C>>8;a[w+1|0]=C&255;C=C>>8;a[w+2|0]=C&255;C=C>>8;a[w+3|0]=C&255}w=d[f+9|0]|0;r=c[j>>2]|0;if((r|0)==0){y=x}else{dd[r&63]();y=a[o]|0}if(y<<24>>24==0){y=f+8|0;o=f+73|0;r=d[y]|d[y+1|0]<<8|d[y+2|0]<<16|d[y+3|0]<<24|0;C=r;a[o]=C&255;C=C>>8;a[o+1|0]=C&255;C=C>>8;a[o+2|0]=C&255;C=C>>8;a[o+3|0]=C&255;z=r&255}else{z=a[f+8|0]|0}qO(90016,(s=i,i=i+32|0,c[s>>2]=t,c[s+8>>2]=v,c[s+16>>2]=w,c[s+24>>2]=z&255,s)|0)|0;i=s;z=c[j>>2]|0;if((z|0)!=0){dd[z&63]()}z=c[m>>2]|0;if((z|0)==0){c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0;A=f+188|0;B=c[A>>2]|0;D=B;c4[D&511](f);E=f+12|0;F=a[E]|0;a[n]=F;G=F&255;H=qO(89400,(s=i,i=i+8|0,c[s>>2]=G,s)|0)|0;i=s;i=g;return 0}dd[z&63]();z=c[m>>2]|0;c[p>>2]=c[c[k>>2]>>2];c[q>>2]=0;if((z|0)==0){A=f+188|0;B=c[A>>2]|0;D=B;c4[D&511](f);E=f+12|0;F=a[E]|0;a[n]=F;G=F&255;H=qO(89400,(s=i,i=i+8|0,c[s>>2]=G,s)|0)|0;i=s;i=g;return 0}dd[z&63]();A=f+188|0;B=c[A>>2]|0;D=B;c4[D&511](f);E=f+12|0;F=a[E]|0;a[n]=F;G=F&255;H=qO(89400,(s=i,i=i+8|0,c[s>>2]=G,s)|0)|0;i=s;i=g;return 0}function nh(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=a+4|0;g=b[f>>1]|0;h=a+16|0;i=c[h>>2]|0;if(i>>>0>=d>>>0){j=0;k=g;b[f>>1]=k;return j|0}l=a+8|0;m=a+6|0;a=0;n=g;g=i;while(1){i=n&65535;do{if((i&2803|0)==2147){o=i&4360;if(!((o|0)==4360|(o|0)==0)){p=6125;break}o=e[l>>1]|0;q=o+g|0;if(q>>>0>d>>>0){r=g-d+o&65535;b[l>>1]=r;c[h>>2]=d;s=n;t=r;u=d;p=6138;break}c[h>>2]=q;b[l>>1]=0;if((i&264|0)!=0){v=q;w=a;x=n;p=6139;break}r=d-q|0;o=(e[m>>1]|0)+1|0;if((r&65535)>>>0<o>>>0){v=q;w=a;x=n;p=6139;break}y=(r>>>0)/(o>>>0)|0;r=(ag(y,o)|0)+q|0;c[h>>2]=r;v=r;w=y+a|0;x=n;p=6139}else{p=6125}}while(0);L7646:do{if((p|0)==6125){p=0;do{if((i&2114|0)==0){if(!(((i&1|0)==0|(i&36|0)==0)&(i&656|0)==0)){break}y=i&4360;if(!((y|0)==4360|(y|0)==0)){break}c[h>>2]=d;s=n;t=b[l>>1]|0;u=d;p=6138;break L7646}}while(0);y=b[l>>1]|0;do{if(n<<16>>16==3619&y<<16>>16==1){if((b[m>>1]|0)!=1){z=1;p=6135;break}r=d-g|0;q=r&-2;if((q|0)==0){o=b[804872+(i<<1)>>1]|0;A=g+1|0;c[h>>2]=A;B=o;C=a;D=A;p=6141;break L7646}else{A=q+g|0;c[h>>2]=A;E=A;F=(r>>1)+a|0;G=3619;p=6142;break L7646}}else{if(y<<16>>16==0){H=0}else{z=y;p=6135}}}while(0);do{if((p|0)==6135){p=0;if((i&64|0)==0){H=z;break}y=z-1&65535;b[l>>1]=y;H=y}}while(0);y=b[804872+(i<<1)>>1]|0;r=g+1|0;c[h>>2]=r;s=y;t=H;u=r;p=6138}}while(0);if((p|0)==6138){p=0;if(t<<16>>16==0){v=u;w=a;x=s;p=6139}else{B=s;C=a;D=u;p=6141}}do{if((p|0)==6139){p=0;if((x&64)==0){B=x;C=w;D=v;p=6141;break}B=x|1536;C=w+1|0;D=v;p=6141}}while(0);if((p|0)==6141){p=0;if((B&512)==0){I=B;J=D;K=C}else{E=D;F=C;G=B;p=6142}}if((p|0)==6142){p=0;b[l>>1]=b[m>>1]|0;I=G&-65;J=E;K=F}i=I&65535;r=(i&1024|0)==0|(i&4352|0)==0?I:I&-4;if(J>>>0<d>>>0){a=K;n=r;g=J}else{j=K;k=r;break}}b[f>>1]=k;return j|0}function ni(){var c=0,d=0,e=0,f=0;if(a[56440]|0){return}a[56440]=1;c=0;do{d=c&65535;e=d&41;f=(c&33|0)!=33?e:e|2;e=d<<5;b[804872+(c<<1)>>1]=d<<3&128|e&2048|d<<2&512|e&256|d<<4&4096|((c&2|0)!=0|(c&5|0)==5?f|64:f);c=c+1|0;}while((c|0)<16384);return}function nj(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;c[a>>2]=d;c[a+16>>2]=e;c[a+12>>2]=-1;b[a+8>>1]=-1;b[a+6>>1]=-1;c[a+20>>2]=f;return}function nk(a,d){a=a|0;d=d|0;c[a+16>>2]=d;c[a+12>>2]=-1;b[a+8>>1]=-1;b[a+6>>1]=-1;b[a+4>>1]=0;fV(c[a+20>>2]|0);return}function nl(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)-b;d=a+12|0;a=c[d>>2]|0;if((a|0)==-1){return}c[d>>2]=a-b;return}function nm(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+64>>2]|0;d=c[a+4>>2]|0;if(b>>>0<(c[d+36>>2]|0)>>>0){e=c[d+4>>2]|0;f=e>>>0>(c[d+40>>2]|0)>>>0?0:e}else{f=0}e=c[d+44>>2]|0;c[a+28>>2]=(c[c[(c[a+20>>2]|0)+8>>2]>>2]|0)+((ag(e+(c[d>>2]|0)+(c[d+48>>2]|0)|0,b+f|0)|0)+e);return}function nn(a,b){a=a|0;b=b|0;var d=0;c[a+692>>2]=0;d=hg(12)|0;c[a+8>>2]=d;nP(d,b);nB(a);nD(a);b=a+16|0;c[c[c[b>>2]>>2]>>2]=0;c[c[(c[b>>2]|0)+4>>2]>>2]=0;c[c[(c[b>>2]|0)+8>>2]>>2]=0;c[c[(c[b>>2]|0)+12>>2]>>2]=0;c[c[(c[b>>2]|0)+16>>2]>>2]=0;c[(c[b>>2]|0)+20>>2]=0;c[a+108>>2]=0;c[a+112>>2]=0;c[a+132>>2]=0;c[a+136>>2]=0;c[a+140>>2]=0;A2(a+36|0,0,32);A2(a+84|0,0,16);c[a+144>>2]=-1;c[a+148>>2]=0;c[a+152>>2]=0;A2(a+116|0,0,16);c[a+156>>2]=1;c[a+160>>2]=0;c[a+32>>2]=0;c[a+100>>2]=0;c[a+104>>2]=0;b=a+20|0;A2(a+68|0,0,16);A2(a+168|0,0,512);rd(c[b>>2]|0,a|0,a+4|0);c[c[b>>2]>>2]=1;c[(c[(c[b>>2]|0)+12>>2]|0)+24>>2]=1;return 0}function no(a){a=a|0;var b=0;b=a+16|0;c[c[c[b>>2]>>2]>>2]=0;c[c[(c[b>>2]|0)+4>>2]>>2]=0;c[c[(c[b>>2]|0)+8>>2]>>2]=0;c[c[(c[b>>2]|0)+12>>2]>>2]=0;c[c[(c[b>>2]|0)+16>>2]>>2]=0;c[(c[b>>2]|0)+20>>2]=0;c[a+108>>2]=0;c[a+104>>2]=0;c[a+112>>2]=0;c[a+132>>2]=0;c[a+136>>2]=0;c[a+140>>2]=0;A2(a+36|0,0,32);A2(a+84|0,0,16);c[a+144>>2]=-1;return}function np(){var a=0,b=0,d=0,e=0,f=0,g=0;a=c[4550652]|0;if((a|0)==0){return}else{b=a}do{a=c[b>>2]|0;d=a+20|0;do{if((c[7356]|0)==0){e=c[d>>2]|0;if((e|0)==0){f=6170;break}g=c[e+20>>2]|0;if((g|0)==0){f=6170;break}if((q9(e,g)|0)>=0){f=6170}}else{f=6170}}while(0);if((f|0)==6170){f=0;c[a+156>>2]=1;c[a+160>>2]=0;re(c[d>>2]|0,1)}b=c[b+4>>2]|0;}while((b|0)!=0);return}function nq(a,b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;r=c[a+4>>2]|0;s=r+4|0;t=c[s>>2]|0;u=c[a+148>>2]|0;do{if((t|0)==(f|0)){if((u|0)!=0){break}v=a+148|0;w=6181}else{x=a+148|0;if((u|0)==0|(t|0)==0){v=x;w=6181;break}y=a+12|0;ny(u,c[y>>2]|0);if(t>>>0>1>>>0){z=1}else{v=x;w=6181;break}while(1){ny((c[x>>2]|0)+(z*1640|0)|0,c[y>>2]|0);A=z+1|0;if(A>>>0<t>>>0){z=A}else{v=x;w=6181;break}}}}while(0);do{if((w|0)==6181){nz(v,f);if((f|0)==0){break}z=a+12|0;t=0;do{nx((c[v>>2]|0)+(t*1640|0)|0,c[z>>2]|0);t=t+1|0;}while(t>>>0<f>>>0)}}while(0);c[r+36>>2]=n;c[r+40>>2]=o;o=r|0;do{if((c[o>>2]|0)==(e|0)){if((c[s>>2]|0)!=(f|0)){w=6188;break}if((c[r+44>>2]|0)!=(p|0)){w=6188;break}if((c[r+48>>2]|0)!=(q|0)){w=6188}}else{w=6188}}while(0);if((w|0)==6188){c[o>>2]=e;c[s>>2]=f;c[r+44>>2]=p;c[r+48>>2]=q;nr(a)|0}c[r+8>>2]=g;c[r+12>>2]=h;c[r+16>>2]=i;c[r+20>>2]=j;c[r+24>>2]=k;c[r+28>>2]=l;c[r+32>>2]=m;m=a+20|0;c[(c[(c[m>>2]|0)+8>>2]|0)+32>>2]=b;c[(c[(c[m>>2]|0)+8>>2]|0)+36>>2]=d;return}function nr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b|0;e=a+20|0;f=c[e>>2]|0;g=c[f+28>>2]|0;if((g|0)==0){h=f+8|0;hj(c[c[h>>2]>>2]|0);c[c[h>>2]>>2]=0}else{c5[c[g+4>>2]&255](f,c[c[f+8>>2]>>2]|0)}f=c[a+4>>2]|0;g=(c[f+44>>2]|0)+(c[f>>2]|0)+(c[f+48>>2]|0)|0;h=c[f+4>>2]|0;j=c[f+40>>2]|0;f=h>>>0>j>>>0?h:j+1|0;do{if(!((g|0)==0|(f|0)==0)){j=c[e>>2]|0;h=c[j+28>>2]|0;do{if((h|0)==0){k=hg(ag(f+1|0,g)|0)|0;c[c[j+8>>2]>>2]=k;c[d>>2]=g}else{if((dj[c[h>>2]&127](j,c[j+8>>2]|0,g,f,d)|0)==0){break}else{l=-1}i=b;return l|0}}while(0);c[(c[(c[e>>2]|0)+8>>2]|0)+4>>2]=g;c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]=f;c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]=c[d>>2];j=c[e>>2]|0;h=c[j+28>>2]|0;if((h|0)==0){A2(c[c[j+8>>2]>>2]|0,0,ag(f,g)|0);break}else{dh[c[h+8>>2]&63](j,c[c[j+8>>2]>>2]|0,0,g,f,c[d>>2]|0);break}}}while(0);d=a+32|0;a=hi(c[d>>2]|0,g)|0;c[d>>2]=a;A2(a|0,0,g|0);l=0;i=b;return l|0}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+20|0;c[a+692>>2]=1;do{if((c[7356]|0)==0){d=c[b>>2]|0;e=c[d+8>>2]|0;f=q5(d,e+24|0,e+28|0,1)|0;if((f|0)==0){g=-1;return g|0}else{c[b>>2]=f;ra(f);break}}}while(0);if((nr(a)|0)<0){g=-1;return g|0}re(c[b>>2]|0,1);f=c[115282]|0;if((f|0)==0){c[4550652]=0}c[115282]=f+1;rc(c[b>>2]|0);b=hg(8)|0;f=b;c[b>>2]=a;c[b+4>>2]=0;b=c[4550652]|0;if((b|0)==0){c[4550652]=f;g=0;return g|0}else{h=b}do{i=h+4|0;h=c[i>>2]|0;}while((h|0)!=0);c[i>>2]=f;g=0;return g|0}function nt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=i0(88032,(f=i,i=i+24|0,c[f>>2]=b,c[f+8>>2]=89152,c[f+16>>2]=0,f)|0)|0;i=f;rf(c[a+20>>2]|0,e);hj(e);i=d;return}function nu(a,b){a=a|0;b=b|0;c[a+60>>2]=b;return}function nv(a,b){a=a|0;b=b|0;c[a+152>>2]=b;c[a+156>>2]=1;c[a+160>>2]=0;return}function nw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=a+20|0;d=c[b>>2]|0;do{if((d|0)!=0){e=c[d+28>>2]|0;if((e|0)==0){f=d+8|0;hj(c[c[f>>2]>>2]|0);c[c[f>>2]>>2]=0;break}else{c5[c[e+4>>2]&255](d,c[c[d+8>>2]>>2]|0);break}}}while(0);d=a+148|0;e=c[d>>2]|0;if((e|0)!=0){f=c[(c[a+4>>2]|0)+4>>2]|0;if((f|0)==0){g=e}else{h=a+12|0;ny(e,c[h>>2]|0);if(f>>>0>1>>>0){e=1;do{ny((c[d>>2]|0)+(e*1640|0)|0,c[h>>2]|0);e=e+1|0;}while(e>>>0<f>>>0)}g=c[d>>2]|0}hj(g)}g=a+8|0;d=c[g>>2]|0;if((d|0)!=0){nQ(d);hj(c[g>>2]|0)}nE(a);hj(c[a+32>>2]|0);nC(a);rm(c[(c[b>>2]|0)+20>>2]|0);rb(c[b>>2]|0);nU(a);b=c[4550652]|0;L7789:do{if((b|0)!=0){g=0;d=b;while(1){if((c[d>>2]|0)==(a|0)){break}f=c[d+4>>2]|0;if((f|0)==0){break L7789}else{g=d;d=f}}f=c[d+4>>2]|0;if((g|0)==0){c[4550652]=f}else{c[g+4>>2]=f}hj(d)}}while(0);a=c[115282]|0;if((a|0)<=0){return}b=a-1|0;c[115282]=b;if((b|0)!=0){return}c[4550652]=0;return}function nx(a,b){a=a|0;b=b|0;var d=0,e=0;A2(a|0,0,1640);if((b|0)==0){d=a+4|0;c[d>>2]=1;return}e=b+52|0;c4[c[e>>2]&511](a+44|0);c4[c[e>>2]&511](a+80|0);c4[c[e>>2]&511](a+116|0);c4[c[e>>2]&511](a+152|0);c4[c[e>>2]&511](a+188|0);c4[c[e>>2]&511](a+224|0);c4[c[e>>2]&511](a+260|0);c4[c[e>>2]&511](a+296|0);c[a+332>>2]=hh(1,256)|0;d=a+4|0;c[d>>2]=1;return}function ny(a,b){a=a|0;b=b|0;if((b|0)==0){return}hj(c[a+332>>2]|0);return}function nz(a,b){a=a|0;b=b|0;c[a>>2]=hi(c[a>>2]|0,b*1640|0)|0;return}function nA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((c[7356]|0)!=0){return}if((c[a+60>>2]|0)!=0){return}b=c[a+20>>2]|0;d=c[b+12>>2]|0;if((c[d+24>>2]|0)==0){return}if((c[a+156>>2]|0)!=0){rc(b);return}e=c[a+164>>2]|0;a=e+16|0;if((c[a>>2]|0)!=0){return}f=c[e>>2]|0;g=c[e+4>>2]|0;h=f-(c[d+20>>2]|0)|0;i=g-(c[d+12>>2]|0)|0;j=(c[e+8>>2]|0)-f|0;k=(c[e+12>>2]|0)-g|0;if((c[(c[b+4>>2]|0)+76>>2]|0)==1){l=k+3|0;m=j+9|0;n=i-1|0;o=h-4|0;p=g-1|0;q=f-4|0}else{l=k+1|0;m=j+1|0;n=i;o=h;p=g;q=f}if((o|0)<0){r=m+o|0;s=0;t=q-o|0}else{r=m;s=o;t=q}if((n|0)<0){u=l+n|0;v=0;w=p-n|0}else{u=l;v=n;w=p}p=(c[(c[b+16>>2]|0)+44>>2]|0)+t|0;t=(c[d+4>>2]|0)+s|0;s=(c[d+8>>2]|0)+v|0;v=c[b+8>>2]|0;d=c[v+28>>2]|0;do{if((d|0)>=(s|0)){n=c[v+24>>2]|0;if((n|0)<(t|0)){break}l=n-t|0;n=d-s|0;q8(b,p,w,t,s,(r|0)<(l|0)?r:l,(u|0)<(n|0)?u:n)}}while(0);c[a>>2]=1;return}function nB(a){a=a|0;var b=0;b=hg(20)|0;c[a+164>>2]=b;c[b+16>>2]=1;return}function nC(a){a=a|0;hj(c[a+164>>2]|0);return}function nD(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=hh(1,24)|0;a=hh(1,16388)|0;c[c[b>>2]>>2]=a;a=hh(1,16388)|0;c[(c[b>>2]|0)+4>>2]=a;a=hh(1,16388)|0;c[(c[b>>2]|0)+8>>2]=a;a=hh(1,16388)|0;c[(c[b>>2]|0)+12>>2]=a;a=hh(1,16388)|0;c[(c[b>>2]|0)+16>>2]=a;return}function nE(a){a=a|0;var b=0;b=a+16|0;a=c[b>>2]|0;if((a|0)==0){return}hj(c[a>>2]|0);hj(c[(c[b>>2]|0)+4>>2]|0);hj(c[(c[b>>2]|0)+8>>2]|0);hj(c[(c[b>>2]|0)+12>>2]|0);hj(c[(c[b>>2]|0)+16>>2]|0);hj(c[b>>2]|0);return}function nF(a){a=a|0;var b=0;if((c[a+132>>2]|0)==0){b=a+140|0}else{b=(c[a+8>>2]|0)+8|0}return c[b>>2]|0}function nG(a){a=a|0;var b=0;if((c[a+104>>2]|0)!=0){return}if((c[a+96>>2]|0)==0){A2(c[a+28>>2]|0,c[a+68>>2]&255|0,c[a+124>>2]|0)}if((c[a+92>>2]|0)!=0){return}b=c[a+128>>2]|0;A2((c[a+28>>2]|0)+b|0,c[a+68>>2]&255|0,(c[c[a+4>>2]>>2]|0)-b|0);return}function nH(a){a=a|0;var b=0;b=c[a+36>>2]|0;if((b|0)==0){return}A2((c[a+28>>2]|0)+(c[(c[a+4>>2]|0)+24>>2]|0)|0,c[a+80>>2]&255|0,b|0);return}function nI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;nm(b);d=b+64|0;e=c[d>>2]|0;do{if((e|0)==(c[b+116>>2]|0)){if((c[b+112>>2]|0)!=0){if((c[b+108>>2]|0)==0){break}}c[b+84>>2]=0}}while(0);if((e|0)==(c[b+120>>2]|0)){c[b+84>>2]=1}f=b+4|0;g=c[f>>2]|0;h=c[g+40>>2]|0;do{if(e>>>0<(c[g+36>>2]|0)>>>0|e>>>0>h>>>0){i=c[g+4>>2]|0;if(!(e>>>0>(h-i|0)>>>0|i>>>0>h>>>0)){j=6316;break}i=c[b+12>>2]|0;do{if((i|0)!=0){k=c[i+8>>2]|0;if((k|0)==0){break}c5[k&255]((c[b+32>>2]|0)+(c[g+44>>2]|0)|0,b+424|0)}}while(0);i=b+16|0;k=c[i>>2]|0;if((c[k+20>>2]|0)==0){break}l=c[k>>2]|0;k=l|0;if((c[k>>2]|0)!=0){m=0;do{n=l+4+(m<<4)+8|0;o=l+4+(m<<4)+12|0;if((c[l+4+(m<<4)+4>>2]|0)==0){c[c[n>>2]>>2]=c[o>>2]}else{c[c[n>>2]>>2]=c[o>>2]}m=m+1|0;}while(m>>>0<(c[k>>2]|0)>>>0)}c[k>>2]=0;m=c[(c[i>>2]|0)+4>>2]|0;l=m|0;if((c[l>>2]|0)!=0){o=0;do{n=m+4+(o<<4)+8|0;p=m+4+(o<<4)+12|0;if((c[m+4+(o<<4)+4>>2]|0)==0){c[c[n>>2]>>2]=c[p>>2]}else{c[c[n>>2]>>2]=c[p>>2]}o=o+1|0;}while(o>>>0<(c[l>>2]|0)>>>0)}c[l>>2]=0;o=c[(c[i>>2]|0)+8>>2]|0;m=o|0;if((c[m>>2]|0)!=0){k=0;do{p=o+4+(k<<4)+8|0;n=o+4+(k<<4)+12|0;if((c[o+4+(k<<4)+4>>2]|0)==0){c[c[p>>2]>>2]=c[n>>2]}else{c[c[p>>2]>>2]=c[n>>2]}k=k+1|0;}while(k>>>0<(c[m>>2]|0)>>>0)}c[m>>2]=0;k=c[(c[i>>2]|0)+12>>2]|0;o=k|0;if((c[o>>2]|0)!=0){l=0;do{n=k+4+(l<<4)+8|0;p=k+4+(l<<4)+12|0;if((c[k+4+(l<<4)+4>>2]|0)==0){c[c[n>>2]>>2]=c[p>>2]}else{c[c[n>>2]>>2]=c[p>>2]}l=l+1|0;}while(l>>>0<(c[o>>2]|0)>>>0)}c[o>>2]=0;c[(c[i>>2]|0)+20>>2]=0}else{j=6316}}while(0);do{if((j|0)==6316){do{if((c[b+100>>2]|0)==0){j=6320}else{if((c[b+104>>2]|0)==0){if((c[(c[b+16>>2]|0)+20>>2]|0)==0){j=6320;break}}nJ(b)}}while(0);L7934:do{if((j|0)==6320){if((c[b+88>>2]|0)==0){if((c[b+84>>2]|0)!=0){j=6322}}else{j=6322}do{if((j|0)==6322){if((c[b+96>>2]|0)!=0){break}i=b+16|0;o=c[i>>2]|0;L7941:do{if((c[o+20>>2]|0)==0){g=b+148|0;h=c[g>>2]|0;do{if((c[b+156>>2]|0)==0){if((c[h+(e*1640|0)+4>>2]|0)!=0){break}if((c[b+68>>2]|0)!=(c[h+(e*1640|0)+356>>2]|0)){break}if((c[h+(e*1640|0)+20>>2]|0)!=0){break L7941}}}while(0);l=b+68|0;c[h+(e*1640|0)+356>>2]=c[l>>2];c[(c[g>>2]|0)+((c[d>>2]|0)*1640|0)+20>>2]=1;c[(c[g>>2]|0)+((c[d>>2]|0)*1640|0)+4>>2]=0;A2(c[b+28>>2]|0,c[l>>2]&255|0,c[c[f>>2]>>2]|0);l=c[b+164>>2]|0;k=c[f>>2]|0;m=c[d>>2]|0;if((c[k+36>>2]|0)>>>0>m>>>0){p=c[k+4>>2]|0;q=(p>>>0>(c[k+40>>2]|0)>>>0?0:p)+m|0}else{q=m}m=(c[k>>2]|0)-1|0;k=l+16|0;if((c[k>>2]|0)==0){c[l>>2]=0;p=l+8|0;n=c[p>>2]|0;c[p>>2]=n>>>0<m>>>0?m:n;n=l+4|0;p=c[n>>2]|0;c[n>>2]=p>>>0>q>>>0?q:p;p=l+12|0;n=c[p>>2]|0;c[p>>2]=n>>>0<q>>>0?q:n;break}else{c[l+12>>2]=q;c[l+4>>2]=q;c[l>>2]=0;c[l+8>>2]=m;c[k>>2]=0;break}}else{k=c[o>>2]|0;m=k|0;if((c[m>>2]|0)!=0){l=0;do{n=k+4+(l<<4)+8|0;p=k+4+(l<<4)+12|0;if((c[k+4+(l<<4)+4>>2]|0)==0){c[c[n>>2]>>2]=c[p>>2]}else{c[c[n>>2]>>2]=c[p>>2]}l=l+1|0;}while(l>>>0<(c[m>>2]|0)>>>0)}c[m>>2]=0;l=c[(c[i>>2]|0)+4>>2]|0;k=l|0;if((c[k>>2]|0)!=0){g=0;do{h=l+4+(g<<4)+8|0;p=l+4+(g<<4)+12|0;if((c[l+4+(g<<4)+4>>2]|0)==0){c[c[h>>2]>>2]=c[p>>2]}else{c[c[h>>2]>>2]=c[p>>2]}g=g+1|0;}while(g>>>0<(c[k>>2]|0)>>>0)}c[k>>2]=0;g=c[(c[i>>2]|0)+12>>2]|0;l=g|0;if((c[l>>2]|0)!=0){m=0;do{p=g+4+(m<<4)+8|0;h=g+4+(m<<4)+12|0;if((c[g+4+(m<<4)+4>>2]|0)==0){c[c[p>>2]>>2]=c[h>>2]}else{c[c[p>>2]>>2]=c[h>>2]}m=m+1|0;}while(m>>>0<(c[l>>2]|0)>>>0)}c[l>>2]=0;m=c[(c[i>>2]|0)+8>>2]|0;g=m|0;L7967:do{if((c[g>>2]|0)==0){k=c[d>>2]|0;h=b+148|0;p=c[h>>2]|0;do{if((c[b+156>>2]|0)==0){if((c[p+(k*1640|0)+4>>2]|0)!=0){break}if((c[b+68>>2]|0)!=(c[p+(k*1640|0)+356>>2]|0)){break}if((c[p+(k*1640|0)+20>>2]|0)!=0){break L7967}}}while(0);n=b+68|0;c[p+(k*1640|0)+356>>2]=c[n>>2];c[(c[h>>2]|0)+((c[d>>2]|0)*1640|0)+20>>2]=1;c[(c[h>>2]|0)+((c[d>>2]|0)*1640|0)+4>>2]=0;A2(c[b+28>>2]|0,c[n>>2]&255|0,c[c[f>>2]>>2]|0);n=c[b+164>>2]|0;r=c[f>>2]|0;s=c[d>>2]|0;if((c[r+36>>2]|0)>>>0>s>>>0){t=c[r+4>>2]|0;u=(t>>>0>(c[r+40>>2]|0)>>>0?0:t)+s|0}else{u=s}s=(c[r>>2]|0)-1|0;r=n+16|0;if((c[r>>2]|0)==0){c[n>>2]=0;t=n+8|0;v=c[t>>2]|0;c[t>>2]=v>>>0<s>>>0?s:v;v=n+4|0;t=c[v>>2]|0;c[v>>2]=t>>>0>u>>>0?u:t;t=n+12|0;v=c[t>>2]|0;c[t>>2]=v>>>0<u>>>0?u:v;break}else{c[n+12>>2]=u;c[n+4>>2]=u;c[n>>2]=0;c[n+8>>2]=s;c[r>>2]=0;break}}else{r=b+28|0;s=b+68|0;n=0;v=0;t=0;while(1){w=c[m+4+(v<<4)>>2]|0;if(n>>>0<w>>>0){A2((c[r>>2]|0)+n|0,c[s>>2]&255|0,t+1+w|0);x=w}else{x=n}w=m+4+(v<<4)+8|0;y=m+4+(v<<4)+12|0;if((c[m+4+(v<<4)+4>>2]|0)==0){c[c[w>>2]>>2]=c[y>>2]}else{c[c[w>>2]>>2]=c[y>>2]}y=v+1|0;if(y>>>0<(c[g>>2]|0)>>>0){n=x;v=y;t=-x|0}else{break}}t=c[c[f>>2]>>2]|0;if(x>>>0<(t-1|0)>>>0){A2((c[r>>2]|0)+x|0,c[s>>2]&255|0,t-x|0)}t=b+148|0;c[(c[t>>2]|0)+((c[d>>2]|0)*1640|0)+356>>2]=255;c[(c[t>>2]|0)+((c[d>>2]|0)*1640|0)+20>>2]=1;c[g>>2]=0;t=c[b+164>>2]|0;v=c[f>>2]|0;n=c[d>>2]|0;if((c[v+36>>2]|0)>>>0>n>>>0){h=c[v+4>>2]|0;z=(h>>>0>(c[v+40>>2]|0)>>>0?0:h)+n|0}else{z=n}n=(c[v>>2]|0)-1|0;v=t+16|0;if((c[v>>2]|0)==0){c[t>>2]=0;h=t+8|0;k=c[h>>2]|0;c[h>>2]=k>>>0<n>>>0?n:k;k=t+4|0;h=c[k>>2]|0;c[k>>2]=h>>>0>z>>>0?z:h;h=t+12|0;k=c[h>>2]|0;c[h>>2]=k>>>0<z>>>0?z:k;break}else{c[t+12>>2]=z;c[t+4>>2]=z;c[t>>2]=0;c[t+8>>2]=n;c[v>>2]=0;break}}}while(0);c[(c[i>>2]|0)+20>>2]=0}}while(0);i=c[b+12>>2]|0;if((i|0)==0){break L7934}o=c[i+8>>2]|0;if((o|0)==0){break L7934}c5[o&255]((c[b+32>>2]|0)+(c[(c[f>>2]|0)+44>>2]|0)|0,b+424|0);break L7934}}while(0);nJ(b)}}while(0);o=b+160|0;i=(c[o>>2]|0)+1|0;c[o>>2]=i;g=c[f>>2]|0;if((i|0)!=((c[g+40>>2]|0)+1-(c[g+36>>2]|0)|0)){break}c[b+156>>2]=0;c[o>>2]=0}}while(0);z=(c[d>>2]|0)+1|0;c[d>>2]=z;x=c[f>>2]|0;u=x+4|0;q=c[u>>2]|0;do{if((z|0)==(q|0)){c[d>>2]=0;e=c[u>>2]|0;if(e>>>0<=(c[x+40>>2]|0)>>>0){A=x;B=e;break}nA(b);e=c[f>>2]|0;A=e;B=c[e+4>>2]|0}else{A=x;B=q}}while(0);q=c[A+40>>2]|0;do{if(B>>>0<=q>>>0){if((c[d>>2]|0)!=(1-B+q|0)){break}nA(b)}}while(0);q=c[(c[b+16>>2]|0)+16>>2]|0;B=q|0;if((c[B>>2]|0)!=0){d=0;do{A=q+4+(d<<4)+8|0;x=q+4+(d<<4)+12|0;if((c[q+4+(d<<4)+4>>2]|0)==0){c[c[A>>2]>>2]=c[x>>2]}else{c[c[A>>2]>>2]=c[x>>2]}d=d+1|0;}while(d>>>0<(c[B>>2]|0)>>>0)}c[B>>2]=0;B=b+92|0;c[b+96>>2]=c[B>>2];c[B>>2]=0;B=c[b+12>>2]|0;if((B|0)==0){C=b+88|0;c[C>>2]=0;return}a[B+21|0]=a[B+22|0]|0;C=b+88|0;c[C>>2]=0;return}
function vK(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;v_(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=c[m>>2]|0;m=w;w=c[h>>2]|0;L2753:while(1){do{if((w|0)==0){B=0}else{C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0)){D=da[c[(c[w>>2]|0)+36>>2]&255](w)|0}else{D=c[C>>2]|0}if((D|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);E=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){F=2363}else{G=c[C+12>>2]|0;if((G|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[G>>2]|0}if((H|0)==-1){c[f>>2]=0;F=2363;break}else{G=(C|0)==0;if(E^G){I=C;J=G;break}else{K=m;L=C;M=G;break L2753}}}}while(0);if((F|0)==2363){F=0;if(E){K=m;L=0;M=1;break}else{I=0;J=1}}C=d[p]|0;G=(C&1|0)==0;if(((c[q>>2]|0)-m|0)==((G?C>>>1:c[z>>2]|0)|0)){if(G){N=C>>>1;O=C>>>1}else{C=c[z>>2]|0;N=C;O=C}tK(o,N<<1,0);if((a[p]&1)==0){P=10}else{P=(c[g>>2]&-2)-1|0}tK(o,P,0);if((a[p]&1)==0){Q=x}else{Q=c[y>>2]|0}c[q>>2]=Q+O;R=Q}else{R=m}C=B+12|0;G=c[C>>2]|0;S=B+16|0;if((G|0)==(c[S>>2]|0)){T=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{T=c[G>>2]|0}if((vW(T,v,R,q,t,A,n,l,s,u)|0)!=0){K=R;L=I;M=J;break}G=c[C>>2]|0;if((G|0)==(c[S>>2]|0)){S=c[(c[B>>2]|0)+40>>2]|0;da[S&255](B)|0;m=R;w=B;continue}else{c[C>>2]=G+4;m=R;w=B;continue}}w=d[n]|0;if((w&1|0)==0){U=w>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}R=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=R}}while(0);c[k>>2]=z1(K,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(E){V=0}else{s=c[B+12>>2]|0;if((s|0)==(c[B+16>>2]|0)){W=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{W=c[s>>2]|0}if((W|0)!=-1){V=B;break}c[h>>2]=0;V=0}}while(0);h=(V|0)==0;do{if(M){F=2405}else{B=c[L+12>>2]|0;if((B|0)==(c[L+16>>2]|0)){X=da[c[(c[L>>2]|0)+36>>2]&255](L)|0}else{X=c[B>>2]|0}if((X|0)==-1){c[f>>2]=0;F=2405;break}if(!(h^(L|0)==0)){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);do{if((F|0)==2405){if(h){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}function vL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vM(a,0,j,k,f,g,h);i=b;return}function vM(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==8){v=16}else if((u|0)==64){v=8}else{v=10}u=l|0;v_(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=c[m>>2]|0;m=w;w=c[h>>2]|0;L2843:while(1){do{if((w|0)==0){B=0}else{C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0)){D=da[c[(c[w>>2]|0)+36>>2]&255](w)|0}else{D=c[C>>2]|0}if((D|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);E=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){F=2434}else{G=c[C+12>>2]|0;if((G|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[G>>2]|0}if((H|0)==-1){c[f>>2]=0;F=2434;break}else{G=(C|0)==0;if(E^G){I=C;J=G;break}else{K=m;L=C;M=G;break L2843}}}}while(0);if((F|0)==2434){F=0;if(E){K=m;L=0;M=1;break}else{I=0;J=1}}C=d[p]|0;G=(C&1|0)==0;if(((c[q>>2]|0)-m|0)==((G?C>>>1:c[z>>2]|0)|0)){if(G){N=C>>>1;O=C>>>1}else{C=c[z>>2]|0;N=C;O=C}tK(o,N<<1,0);if((a[p]&1)==0){P=10}else{P=(c[g>>2]&-2)-1|0}tK(o,P,0);if((a[p]&1)==0){Q=x}else{Q=c[y>>2]|0}c[q>>2]=Q+O;R=Q}else{R=m}C=B+12|0;G=c[C>>2]|0;S=B+16|0;if((G|0)==(c[S>>2]|0)){T=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{T=c[G>>2]|0}if((vW(T,v,R,q,t,A,n,l,s,u)|0)!=0){K=R;L=I;M=J;break}G=c[C>>2]|0;if((G|0)==(c[S>>2]|0)){S=c[(c[B>>2]|0)+40>>2]|0;da[S&255](B)|0;m=R;w=B;continue}else{c[C>>2]=G+4;m=R;w=B;continue}}w=d[n]|0;if((w&1|0)==0){U=w>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}R=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=R}}while(0);c[k>>2]=z0(K,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(E){V=0}else{s=c[B+12>>2]|0;if((s|0)==(c[B+16>>2]|0)){W=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{W=c[s>>2]|0}if((W|0)!=-1){V=B;break}c[h>>2]=0;V=0}}while(0);h=(V|0)==0;do{if(M){F=2476}else{B=c[L+12>>2]|0;if((B|0)==(c[L+16>>2]|0)){X=da[c[(c[L>>2]|0)+36>>2]&255](L)|0}else{X=c[B>>2]|0}if((X|0)==-1){c[f>>2]=0;F=2476;break}if(!(h^(L|0)==0)){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);do{if((F|0)==2476){if(h){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}function vN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vO(a,0,j,k,f,g,h);i=b;return}function vO(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;v_(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=c[m>>2]|0;m=w;w=c[h>>2]|0;L2933:while(1){do{if((w|0)==0){B=0}else{C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0)){D=da[c[(c[w>>2]|0)+36>>2]&255](w)|0}else{D=c[C>>2]|0}if((D|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);E=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){F=2505}else{G=c[C+12>>2]|0;if((G|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[G>>2]|0}if((H|0)==-1){c[f>>2]=0;F=2505;break}else{G=(C|0)==0;if(E^G){I=C;J=G;break}else{L=m;M=C;N=G;break L2933}}}}while(0);if((F|0)==2505){F=0;if(E){L=m;M=0;N=1;break}else{I=0;J=1}}C=d[p]|0;G=(C&1|0)==0;if(((c[q>>2]|0)-m|0)==((G?C>>>1:c[z>>2]|0)|0)){if(G){O=C>>>1;P=C>>>1}else{C=c[z>>2]|0;O=C;P=C}tK(o,O<<1,0);if((a[p]&1)==0){Q=10}else{Q=(c[g>>2]&-2)-1|0}tK(o,Q,0);if((a[p]&1)==0){R=x}else{R=c[y>>2]|0}c[q>>2]=R+P;S=R}else{S=m}C=B+12|0;G=c[C>>2]|0;T=B+16|0;if((G|0)==(c[T>>2]|0)){U=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{U=c[G>>2]|0}if((vW(U,v,S,q,t,A,n,l,s,u)|0)!=0){L=S;M=I;N=J;break}G=c[C>>2]|0;if((G|0)==(c[T>>2]|0)){T=c[(c[B>>2]|0)+40>>2]|0;da[T&255](B)|0;m=S;w=B;continue}else{c[C>>2]=G+4;m=S;w=B;continue}}w=d[n]|0;if((w&1|0)==0){V=w>>>1}else{V=c[n+4>>2]|0}do{if((V|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}S=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=S}}while(0);t=z$(L,c[q>>2]|0,j,v)|0;c[k>>2]=t;c[k+4>>2]=K;xQ(n,l,c[s>>2]|0,j);do{if(E){W=0}else{s=c[B+12>>2]|0;if((s|0)==(c[B+16>>2]|0)){X=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{X=c[s>>2]|0}if((X|0)!=-1){W=B;break}c[h>>2]=0;W=0}}while(0);h=(W|0)==0;do{if(N){F=2547}else{B=c[M+12>>2]|0;if((B|0)==(c[M+16>>2]|0)){Y=da[c[(c[M>>2]|0)+36>>2]&255](M)|0}else{Y=c[B>>2]|0}if((Y|0)==-1){c[f>>2]=0;F=2547;break}if(!(h^(M|0)==0)){break}Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}}while(0);do{if((F|0)==2547){if(h){break}Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}function vP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vQ(a,0,j,k,f,g,h);i=b;return}function vQ(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;v$(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=h|0;h=p|0;C=p+4|0;D=c[m>>2]|0;m=c[n>>2]|0;n=z;z=c[j>>2]|0;L3018:while(1){do{if((z|0)==0){E=0}else{F=c[z+12>>2]|0;if((F|0)==(c[z+16>>2]|0)){G=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{G=c[F>>2]|0}if((G|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);H=(E|0)==0;F=c[f>>2]|0;do{if((F|0)==0){I=2572}else{J=c[F+12>>2]|0;if((J|0)==(c[F+16>>2]|0)){K=da[c[(c[F>>2]|0)+36>>2]&255](F)|0}else{K=c[J>>2]|0}if((K|0)==-1){c[f>>2]=0;I=2572;break}else{J=(F|0)==0;if(H^J){L=F;M=J;break}else{N=n;O=F;P=J;break L3018}}}}while(0);if((I|0)==2572){I=0;if(H){N=n;O=0;P=1;break}else{L=0;M=1}}F=d[q]|0;J=(F&1|0)==0;if(((c[r>>2]|0)-n|0)==((J?F>>>1:c[C>>2]|0)|0)){if(J){Q=F>>>1;R=F>>>1}else{F=c[C>>2]|0;Q=F;R=F}tK(p,Q<<1,0);if((a[q]&1)==0){S=10}else{S=(c[h>>2]&-2)-1|0}tK(p,S,0);if((a[q]&1)==0){T=A}else{T=c[B>>2]|0}c[r>>2]=T+R;U=T}else{U=n}F=E+12|0;J=c[F>>2]|0;V=E+16|0;if((J|0)==(c[V>>2]|0)){W=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{W=c[J>>2]|0}if((v0(W,v,w,U,r,D,m,o,y,t,u,x)|0)!=0){N=U;O=L;P=M;break}J=c[F>>2]|0;if((J|0)==(c[V>>2]|0)){V=c[(c[E>>2]|0)+40>>2]|0;da[V&255](E)|0;n=U;z=E;continue}else{c[F>>2]=J+4;n=U;z=E;continue}}z=d[o]|0;if((z&1|0)==0){X=z>>>1}else{X=c[o+4>>2]|0}do{if((X|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}U=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=U}}while(0);g[l>>2]=+z_(N,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(H){Y=0}else{t=c[E+12>>2]|0;if((t|0)==(c[E+16>>2]|0)){Z=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{Z=c[t>>2]|0}if((Z|0)!=-1){Y=E;break}c[j>>2]=0;Y=0}}while(0);j=(Y|0)==0;do{if(P){I=2615}else{E=c[O+12>>2]|0;if((E|0)==(c[O+16>>2]|0)){_=da[c[(c[O>>2]|0)+36>>2]&255](O)|0}else{_=c[E>>2]|0}if((_|0)==-1){c[f>>2]=0;I=2615;break}if(!(j^(O|0)==0)){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);do{if((I|0)==2615){if(j){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}function vR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vS(a,0,j,k,f,g,h);i=b;return}function vS(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;v$(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=g|0;g=p|0;C=p+4|0;D=c[m>>2]|0;m=c[n>>2]|0;n=z;z=c[j>>2]|0;L3104:while(1){do{if((z|0)==0){E=0}else{F=c[z+12>>2]|0;if((F|0)==(c[z+16>>2]|0)){G=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{G=c[F>>2]|0}if((G|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);H=(E|0)==0;F=c[f>>2]|0;do{if((F|0)==0){I=2640}else{J=c[F+12>>2]|0;if((J|0)==(c[F+16>>2]|0)){K=da[c[(c[F>>2]|0)+36>>2]&255](F)|0}else{K=c[J>>2]|0}if((K|0)==-1){c[f>>2]=0;I=2640;break}else{J=(F|0)==0;if(H^J){L=F;M=J;break}else{N=n;O=F;P=J;break L3104}}}}while(0);if((I|0)==2640){I=0;if(H){N=n;O=0;P=1;break}else{L=0;M=1}}F=d[q]|0;J=(F&1|0)==0;if(((c[r>>2]|0)-n|0)==((J?F>>>1:c[C>>2]|0)|0)){if(J){Q=F>>>1;R=F>>>1}else{F=c[C>>2]|0;Q=F;R=F}tK(p,Q<<1,0);if((a[q]&1)==0){S=10}else{S=(c[g>>2]&-2)-1|0}tK(p,S,0);if((a[q]&1)==0){T=A}else{T=c[B>>2]|0}c[r>>2]=T+R;U=T}else{U=n}F=E+12|0;J=c[F>>2]|0;V=E+16|0;if((J|0)==(c[V>>2]|0)){W=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{W=c[J>>2]|0}if((v0(W,v,w,U,r,D,m,o,y,t,u,x)|0)!=0){N=U;O=L;P=M;break}J=c[F>>2]|0;if((J|0)==(c[V>>2]|0)){V=c[(c[E>>2]|0)+40>>2]|0;da[V&255](E)|0;n=U;z=E;continue}else{c[F>>2]=J+4;n=U;z=E;continue}}z=d[o]|0;if((z&1|0)==0){X=z>>>1}else{X=c[o+4>>2]|0}do{if((X|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}U=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=U}}while(0);h[l>>3]=+zZ(N,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(H){Y=0}else{t=c[E+12>>2]|0;if((t|0)==(c[E+16>>2]|0)){Z=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{Z=c[t>>2]|0}if((Z|0)!=-1){Y=E;break}c[j>>2]=0;Y=0}}while(0);j=(Y|0)==0;do{if(P){I=2683}else{E=c[O+12>>2]|0;if((E|0)==(c[O+16>>2]|0)){_=da[c[(c[O>>2]|0)+36>>2]&255](O)|0}else{_=c[E>>2]|0}if((_|0)==-1){c[f>>2]=0;I=2683;break}if(!(j^(O|0)==0)){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);do{if((I|0)==2683){if(j){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}function vT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vU(a,0,j,k,f,g,h);i=b;return}function vU(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;v$(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=g|0;g=p|0;C=p+4|0;D=c[m>>2]|0;m=c[n>>2]|0;n=z;z=c[j>>2]|0;L3190:while(1){do{if((z|0)==0){E=0}else{F=c[z+12>>2]|0;if((F|0)==(c[z+16>>2]|0)){G=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{G=c[F>>2]|0}if((G|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);H=(E|0)==0;F=c[f>>2]|0;do{if((F|0)==0){I=2708}else{J=c[F+12>>2]|0;if((J|0)==(c[F+16>>2]|0)){K=da[c[(c[F>>2]|0)+36>>2]&255](F)|0}else{K=c[J>>2]|0}if((K|0)==-1){c[f>>2]=0;I=2708;break}else{J=(F|0)==0;if(H^J){L=F;M=J;break}else{N=n;O=F;P=J;break L3190}}}}while(0);if((I|0)==2708){I=0;if(H){N=n;O=0;P=1;break}else{L=0;M=1}}F=d[q]|0;J=(F&1|0)==0;if(((c[r>>2]|0)-n|0)==((J?F>>>1:c[C>>2]|0)|0)){if(J){Q=F>>>1;R=F>>>1}else{F=c[C>>2]|0;Q=F;R=F}tK(p,Q<<1,0);if((a[q]&1)==0){S=10}else{S=(c[g>>2]&-2)-1|0}tK(p,S,0);if((a[q]&1)==0){T=A}else{T=c[B>>2]|0}c[r>>2]=T+R;U=T}else{U=n}F=E+12|0;J=c[F>>2]|0;V=E+16|0;if((J|0)==(c[V>>2]|0)){W=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{W=c[J>>2]|0}if((v0(W,v,w,U,r,D,m,o,y,t,u,x)|0)!=0){N=U;O=L;P=M;break}J=c[F>>2]|0;if((J|0)==(c[V>>2]|0)){V=c[(c[E>>2]|0)+40>>2]|0;da[V&255](E)|0;n=U;z=E;continue}else{c[F>>2]=J+4;n=U;z=E;continue}}z=d[o]|0;if((z&1|0)==0){X=z>>>1}else{X=c[o+4>>2]|0}do{if((X|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}U=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=U}}while(0);h[l>>3]=+zY(N,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(H){Y=0}else{t=c[E+12>>2]|0;if((t|0)==(c[E+16>>2]|0)){Z=da[c[(c[E>>2]|0)+36>>2]&255](E)|0}else{Z=c[t>>2]|0}if((Z|0)!=-1){Y=E;break}c[j>>2]=0;Y=0}}while(0);j=(Y|0)==0;do{if(P){I=2751}else{E=c[O+12>>2]|0;if((E|0)==(c[O+16>>2]|0)){_=da[c[(c[O>>2]|0)+36>>2]&255](O)|0}else{_=c[E>>2]|0}if((_|0)==-1){c[f>>2]=0;I=2751;break}if(!(j^(O|0)==0)){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);do{if((I|0)==2751){if(j){break}$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;$=b|0;c[$>>2]=Y;tH(p);tH(o);i=e;return}function vV(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+136|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+120|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;A2(n|0,0,12);u=p;t3(o,h);h=o|0;o=c[h>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;v=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-v>>2>>>0>l>>>0){w=c[v+(l<<2)>>2]|0;if((w|0)==0){break}x=w;y=m|0;z=c[(c[w>>2]|0)+48>>2]|0;di[z&63](x,98832,98858,y)|0;x=c[h>>2]|0;td(x)|0;A2(u|0,0,12);x=p;tK(p,10,0);if((a[u]&1)==0){z=x+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=x+1|0;C=z}c[q>>2]=A;z=r|0;c[s>>2]=z;c[t>>2]=0;x=f|0;w=g|0;D=p|0;E=p+4|0;F=A;G=c[x>>2]|0;L3283:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=da[c[(c[G>>2]|0)+36>>2]&255](G)|0}else{J=c[I>>2]|0}if((J|0)!=-1){H=G;break}c[x>>2]=0;H=0}}while(0);I=(H|0)==0;K=c[w>>2]|0;do{if((K|0)==0){L=2783}else{M=c[K+12>>2]|0;if((M|0)==(c[K+16>>2]|0)){N=da[c[(c[K>>2]|0)+36>>2]&255](K)|0}else{N=c[M>>2]|0}if((N|0)==-1){c[w>>2]=0;L=2783;break}else{if(I^(K|0)==0){break}else{O=F;break L3283}}}}while(0);if((L|0)==2783){L=0;if(I){O=F;break}}K=d[u]|0;M=(K&1|0)==0;if(((c[q>>2]|0)-F|0)==((M?K>>>1:c[E>>2]|0)|0)){if(M){P=K>>>1;Q=K>>>1}else{K=c[E>>2]|0;P=K;Q=K}tK(p,P<<1,0);if((a[u]&1)==0){R=10}else{R=(c[D>>2]&-2)-1|0}tK(p,R,0);if((a[u]&1)==0){S=B}else{S=c[C>>2]|0}c[q>>2]=S+Q;T=S}else{T=F}K=H+12|0;M=c[K>>2]|0;U=H+16|0;if((M|0)==(c[U>>2]|0)){V=da[c[(c[H>>2]|0)+36>>2]&255](H)|0}else{V=c[M>>2]|0}if((vW(V,16,T,q,t,0,n,z,s,y)|0)!=0){O=T;break}M=c[K>>2]|0;if((M|0)==(c[U>>2]|0)){U=c[(c[H>>2]|0)+40>>2]|0;da[U&255](H)|0;F=T;G=H;continue}else{c[K>>2]=M+4;F=T;G=H;continue}}a[O+3|0]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);G=vy(O,c[218270]|0,84048,(F=i,i=i+8|0,c[F>>2]=k,F)|0)|0;i=F;if((G|0)!=1){c[j>>2]=4}G=c[x>>2]|0;do{if((G|0)==0){W=0}else{F=c[G+12>>2]|0;if((F|0)==(c[G+16>>2]|0)){X=da[c[(c[G>>2]|0)+36>>2]&255](G)|0}else{X=c[F>>2]|0}if((X|0)!=-1){W=G;break}c[x>>2]=0;W=0}}while(0);x=(W|0)==0;G=c[w>>2]|0;do{if((G|0)==0){L=2828}else{F=c[G+12>>2]|0;if((F|0)==(c[G+16>>2]|0)){Y=da[c[(c[G>>2]|0)+36>>2]&255](G)|0}else{Y=c[F>>2]|0}if((Y|0)==-1){c[w>>2]=0;L=2828;break}if(!(x^(G|0)==0)){break}Z=b|0;c[Z>>2]=W;tH(p);tH(n);i=e;return}}while(0);do{if((L|0)==2828){if(x){break}Z=b|0;c[Z>>2]=W;tH(p);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b|0;c[Z>>2]=W;tH(p);tH(n);i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function vW(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(c[m+96>>2]|0)==(b|0);if(!p){if((c[m+100>>2]|0)!=(b|0)){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&(b|0)==(i|0)){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+104|0;i=m;while(1){l=i+4|0;if((c[i>>2]|0)==(b|0)){s=i;break}if((l|0)==(k|0)){s=k;break}else{i=l}}i=s-m|0;m=i>>2;if((i|0)>92){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((m|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<88){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;s=a[98832+m|0]|0;k=c[g>>2]|0;c[g>>2]=k+1;a[k]=s;q=0;return q|0}}while(0);f=a[98832+m|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function vX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;t3(k,d);d=k|0;k=c[d>>2]|0;if((c[218656]|0)!=-1){c[j>>2]=874624;c[j+4>>2]=36;c[j+8>>2]=0;tA(874624,j,144)}j=(c[218657]|0)-1|0;l=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-l>>2>>>0>j>>>0){m=c[l+(j<<2)>>2]|0;if((m|0)==0){break}n=m;o=c[(c[m>>2]|0)+32>>2]|0;di[o&63](n,98832,98858,e)|0;n=c[d>>2]|0;if((c[218560]|0)!=-1){c[h>>2]=874240;c[h+4>>2]=36;c[h+8>>2]=0;tA(874240,h,144)}o=(c[218561]|0)-1|0;m=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-m>>2>>>0>o>>>0){p=c[m+(o<<2)>>2]|0;if((p|0)==0){break}q=p;a[f]=da[c[(c[p>>2]|0)+16>>2]&255](q)|0;c5[c[(c[p>>2]|0)+20>>2]&255](b,q);q=c[d>>2]|0;td(q)|0;i=g;return}}while(0);o=cJ(4)|0;Aq(o);bQ(o|0,97088,288)}}while(0);g=cJ(4)|0;Aq(g);bQ(g|0,97088,288)}function vY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+40|0;j=h|0;k=h+16|0;l=h+32|0;t3(l,d);d=l|0;l=c[d>>2]|0;if((c[218656]|0)!=-1){c[k>>2]=874624;c[k+4>>2]=36;c[k+8>>2]=0;tA(874624,k,144)}k=(c[218657]|0)-1|0;m=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-m>>2>>>0>k>>>0){n=c[m+(k<<2)>>2]|0;if((n|0)==0){break}o=n;p=c[(c[n>>2]|0)+32>>2]|0;di[p&63](o,98832,98864,e)|0;o=c[d>>2]|0;if((c[218560]|0)!=-1){c[j>>2]=874240;c[j+4>>2]=36;c[j+8>>2]=0;tA(874240,j,144)}p=(c[218561]|0)-1|0;n=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-n>>2>>>0>p>>>0){q=c[n+(p<<2)>>2]|0;if((q|0)==0){break}r=q;s=q;a[f]=da[c[(c[s>>2]|0)+12>>2]&255](r)|0;a[g]=da[c[(c[s>>2]|0)+16>>2]&255](r)|0;c5[c[(c[q>>2]|0)+20>>2]&255](b,r);r=c[d>>2]|0;td(r)|0;i=h;return}}while(0);p=cJ(4)|0;Aq(p);bQ(p|0,97088,288)}}while(0);h=cJ(4)|0;Aq(h);bQ(h|0,97088,288)}function vZ(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if(b<<24>>24==i<<24>>24){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if(b<<24>>24==j<<24>>24){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+32|0;j=o;while(1){q=j+1|0;if((a[j]|0)==b<<24>>24){s=j;break}if((q|0)==(r|0)){s=r;break}else{j=q}}j=s-o|0;if((j|0)>31){p=-1;return p|0}o=a[98832+j|0]|0;if((j|0)==25|(j|0)==24){s=c[h>>2]|0;do{if((s|0)!=(g|0)){if((a[s-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=s+1;a[s]=o;p=0;return p|0}else if((j|0)==22|(j|0)==23){a[f]=80;s=c[h>>2]|0;c[h>>2]=s+1;a[s]=o;p=0;return p|0}else{s=a[f]|0;do{if((o&95|0)==(s<<24>>24|0)){a[f]=s|-128;if((a[e]&1)==0){break}a[e]=0;g=d[k]|0;if((g&1|0)==0){t=g>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}g=c[m>>2]|0;if((g-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=g+4;c[g>>2]=r}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=o;if((j|0)>21){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}return 0}function v_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+40|0;g=f|0;h=f+16|0;j=f+32|0;t3(j,b);b=j|0;j=c[b>>2]|0;if((c[218654]|0)!=-1){c[h>>2]=874616;c[h+4>>2]=36;c[h+8>>2]=0;tA(874616,h,144)}h=(c[218655]|0)-1|0;k=c[j+8>>2]|0;do{if((c[j+12>>2]|0)-k>>2>>>0>h>>>0){l=c[k+(h<<2)>>2]|0;if((l|0)==0){break}m=l;n=c[(c[l>>2]|0)+48>>2]|0;di[n&63](m,98832,98858,d)|0;m=c[b>>2]|0;if((c[218558]|0)!=-1){c[g>>2]=874232;c[g+4>>2]=36;c[g+8>>2]=0;tA(874232,g,144)}n=(c[218559]|0)-1|0;l=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-l>>2>>>0>n>>>0){o=c[l+(n<<2)>>2]|0;if((o|0)==0){break}p=o;c[e>>2]=da[c[(c[o>>2]|0)+16>>2]&255](p)|0;c5[c[(c[o>>2]|0)+20>>2]&255](a,p);p=c[b>>2]|0;td(p)|0;i=f;return}}while(0);n=cJ(4)|0;Aq(n);bQ(n|0,97088,288)}}while(0);f=cJ(4)|0;Aq(f);bQ(f|0,97088,288)}function v$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;t3(k,b);b=k|0;k=c[b>>2]|0;if((c[218654]|0)!=-1){c[j>>2]=874616;c[j+4>>2]=36;c[j+8>>2]=0;tA(874616,j,144)}j=(c[218655]|0)-1|0;l=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-l>>2>>>0>j>>>0){m=c[l+(j<<2)>>2]|0;if((m|0)==0){break}n=m;o=c[(c[m>>2]|0)+48>>2]|0;di[o&63](n,98832,98864,d)|0;n=c[b>>2]|0;if((c[218558]|0)!=-1){c[h>>2]=874232;c[h+4>>2]=36;c[h+8>>2]=0;tA(874232,h,144)}o=(c[218559]|0)-1|0;m=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-m>>2>>>0>o>>>0){p=c[m+(o<<2)>>2]|0;if((p|0)==0){break}q=p;r=p;c[e>>2]=da[c[(c[r>>2]|0)+12>>2]&255](q)|0;c[f>>2]=da[c[(c[r>>2]|0)+16>>2]&255](q)|0;c5[c[(c[p>>2]|0)+20>>2]&255](a,q);q=c[b>>2]|0;td(q)|0;i=g;return}}while(0);o=cJ(4)|0;Aq(o);bQ(o|0,97088,288)}}while(0);g=cJ(4)|0;Aq(g);bQ(g|0,97088,288)}function v0(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if((b|0)==(i|0)){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if((b|0)==(j|0)){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+128|0;j=o;while(1){q=j+4|0;if((c[j>>2]|0)==(b|0)){s=j;break}if((q|0)==(r|0)){s=r;break}else{j=q}}j=s-o|0;o=j>>2;if((j|0)>124){p=-1;return p|0}s=a[98832+o|0]|0;do{if((o|0)==25|(o|0)==24){r=c[h>>2]|0;do{if((r|0)!=(g|0)){if((a[r-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=r+1;a[r]=s;p=0;return p|0}else if((o|0)==22|(o|0)==23){a[f]=80}else{b=a[f]|0;if((s&95|0)!=(b<<24>>24|0)){break}a[f]=b|-128;if((a[e]&1)==0){break}a[e]=0;b=d[k]|0;if((b&1|0)==0){t=b>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}q=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=q}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=s;if((j|0)>84){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}function v1(a){a=a|0;tb(a|0);AT(a);return}function v2(a){a=a|0;tb(a|0);return}function v3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];dh[o&63](b,d,l,f,g,h&1);i=j;return}t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218560]|0)!=-1){c[k>>2]=874240;c[k+4>>2]=36;c[k+8>>2]=0;tA(874240,k,144)}k=(c[218561]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;o=c[f>>2]|0;td(o)|0;o=c[l>>2]|0;if(h){c5[c[o+24>>2]&255](n,d)}else{c5[c[o+28>>2]&255](n,d)}d=n;o=n;l=a[o]|0;if((l&1)==0){p=d+1|0;q=p;r=p;s=n+8|0}else{p=n+8|0;q=c[p>>2]|0;r=d+1|0;s=p}p=e|0;d=n+4|0;t=q;u=l;while(1){if((u&1)==0){v=r}else{v=c[s>>2]|0}l=u&255;if((t|0)==(v+((l&1|0)==0?l>>>1:c[d>>2]|0)|0)){break}l=a[t]|0;w=c[p>>2]|0;do{if((w|0)!=0){x=w+24|0;y=c[x>>2]|0;if((y|0)!=(c[w+28>>2]|0)){c[x>>2]=y+1;a[y]=l;break}if((c7[c[(c[w>>2]|0)+52>>2]&255](w,l&255)|0)!=-1){break}c[p>>2]=0}}while(0);t=t+1|0;u=a[o]|0}c[b>>2]=c[p>>2];tH(n);i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function v4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[90512]|0;a[q+1|0]=a[90513]|0;a[q+2|0]=a[90514]|0;a[q+3|0]=a[90515]|0;a[q+4|0]=a[90516]|0;a[q+5|0]=a[90517]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);t=v5(u,12,c[218270]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=3091;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3091;break}w=k+2|0}else if((h|0)==32){w=q}else{x=3091}}while(0);if((x|0)==3091){w=u}x=l|0;t3(o,f);v6(u,w,q,x,m,n,o);td(c[o>>2]|0)|0;c[p>>2]=c[e>>2];ei(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}function v5(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g|0;j=h;c[j>>2]=f;c[j+4>>2]=0;j=cm(d|0)|0;d=co(a|0,b|0,e|0,h|0)|0;if((j|0)==0){i=g;return d|0}cm(j|0)|0;i=g;return d|0}function v6(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[218656]|0)!=-1){c[n>>2]=874624;c[n+4>>2]=36;c[n+8>>2]=0;tA(874624,n,144)}n=(c[218657]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}r=k;s=c[p>>2]|0;if((c[218560]|0)!=-1){c[m>>2]=874240;c[m+4>>2]=36;c[m+8>>2]=0;tA(874240,m,144)}m=(c[218561]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}t=s;c5[c[(c[s>>2]|0)+20>>2]&255](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}do{if((v|0)==0){p=c[(c[k>>2]|0)+32>>2]|0;di[p&63](r,b,f,g)|0;c[j>>2]=g+(f-b)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=c7[c[(c[k>>2]|0)+28>>2]&255](r,p)|0;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n;w=b+1|0}else{w=b}do{if((f-w|0)>1){if((a[w]|0)!=48){x=w;break}n=w+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){x=w;break}p=k;q=c7[c[(c[p>>2]|0)+28>>2]&255](r,48)|0;y=c[j>>2]|0;c[j>>2]=y+1;a[y]=q;q=c7[c[(c[p>>2]|0)+28>>2]&255](r,a[n]|0)|0;n=c[j>>2]|0;c[j>>2]=n+1;a[n]=q;x=w+2|0}else{x=w}}while(0);do{if((x|0)!=(f|0)){q=f-1|0;if(x>>>0<q>>>0){z=x;A=q}else{break}do{q=a[z]|0;a[z]=a[A]|0;a[A]=q;z=z+1|0;A=A-1|0;}while(z>>>0<A>>>0)}}while(0);q=da[c[(c[s>>2]|0)+16>>2]&255](t)|0;if(x>>>0<f>>>0){n=u+1|0;p=k;y=o+4|0;B=o+8|0;C=0;D=0;E=x;while(1){F=(a[m]&1)==0;do{if((a[(F?n:c[B>>2]|0)+D|0]|0)==0){G=D;H=C}else{if((C|0)!=(a[(F?n:c[B>>2]|0)+D|0]|0)){G=D;H=C;break}I=c[j>>2]|0;c[j>>2]=I+1;a[I]=q;I=d[m]|0;G=(D>>>0<(((I&1|0)==0?I>>>1:c[y>>2]|0)-1|0)>>>0)+D|0;H=0}}while(0);F=c7[c[(c[p>>2]|0)+28>>2]&255](r,a[E]|0)|0;I=c[j>>2]|0;c[j>>2]=I+1;a[I]=F;F=E+1|0;if(F>>>0<f>>>0){C=H+1|0;D=G;E=F}else{break}}}E=g+(x-b)|0;D=c[j>>2]|0;if((E|0)==(D|0)){break}C=D-1|0;if(E>>>0<C>>>0){J=E;K=C}else{break}do{C=a[J]|0;a[J]=a[K]|0;a[K]=C;J=J+1|0;K=K-1|0;}while(J>>>0<K>>>0)}}while(0);if((e|0)==(f|0)){L=c[j>>2]|0;c[h>>2]=L;tH(o);i=l;return}else{L=g+(e-b)|0;c[h>>2]=L;tH(o);i=l;return}}function v7(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=l|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);t=v5(u,22,c[218270]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=3174;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3174;break}w=l+2|0}else{x=3174}}while(0);if((x|0)==3174){w=u}x=m|0;t3(p,f);v6(u,w,r,x,n,o,p);td(c[p>>2]|0)|0;c[q>>2]=c[e>>2];ei(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}function v8(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[90512]|0;a[q+1|0]=a[90513]|0;a[q+2|0]=a[90514]|0;a[q+3|0]=a[90515]|0;a[q+4|0]=a[90516]|0;a[q+5|0]=a[90517]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=117}}while(0);u=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);v=v5(u,12,c[218270]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+v|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((v|0)>1&s<<24>>24==48)){x=3199;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3199;break}w=k+2|0}else{x=3199}}while(0);if((x|0)==3199){w=u}x=l|0;t3(o,f);v6(u,w,q,x,m,n,o);td(c[o>>2]|0)|0;c[p>>2]=c[e>>2];ei(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}function v9(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=l|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);t=v5(u,23,c[218270]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=3224;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3224;break}w=l+2|0}else{x=3224}}while(0);if((x|0)==3224){w=u}x=m|0;t3(p,f);v6(u,w,r,x,n,o,p);td(c[p>>2]|0)|0;c[q>>2]=c[e>>2];ei(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}function wa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[x]=97;y=0;break}else{a[x]=65;y=0;break}}else{a[x]=46;v=x+2|0;a[x+1|0]=42;if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=c[218270]|0;if(y){w=v5(k,30,l,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;A=w}else{w=v5(k,30,l,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;A=w}do{if((A|0)>29){w=(a[18202480]|0)==0;if(y){do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=l}else{do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);w=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=w}w=c[m>>2]|0;if((w|0)!=0){C=B;D=w;E=w;break}AY();w=c[m>>2]|0;C=B;D=w;E=w}else{C=A;D=0;E=c[m>>2]|0}}while(0);A=E+C|0;B=c[u>>2]&176;do{if((B|0)==16){u=a[E]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){F=E+1|0;break}if(!((C|0)>1&u<<24>>24==48)){G=3280;break}u=a[E+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){G=3280;break}F=E+2|0}else if((B|0)==32){F=A}else{G=3280}}while(0);if((G|0)==3280){F=E}do{if((E|0)==(k|0)){H=n|0;I=0;J=k}else{G=AL(C<<1)|0;if((G|0)!=0){H=G;I=G;J=E;break}AY();H=0;I=0;J=c[m>>2]|0}}while(0);t3(q,f);wc(J,F,A,H,o,p,q);td(c[q>>2]|0)|0;q=e|0;c[s>>2]=c[q>>2];ei(r,s,H,c[o>>2]|0,c[p>>2]|0,f,g);g=c[r>>2]|0;c[q>>2]=g;c[b>>2]=g;if((I|0)!=0){AM(I)}if((D|0)==0){i=d;return}AM(D);i=d;return}function wb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=cm(b|0)|0;b=cO(a|0,d|0,g|0)|0;if((h|0)==0){i=f;return b|0}cm(h|0)|0;i=f;return b|0}function wc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[218656]|0)!=-1){c[n>>2]=874624;c[n+4>>2]=36;c[n+8>>2]=0;tA(874624,n,144)}n=(c[218657]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}r=k;s=c[p>>2]|0;if((c[218560]|0)!=-1){c[m>>2]=874240;c[m+4>>2]=36;c[m+8>>2]=0;tA(874240,m,144)}m=(c[218561]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}t=s;c5[c[(c[s>>2]|0)+20>>2]&255](o,t);c[j>>2]=g;u=a[b]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=c7[c[(c[k>>2]|0)+28>>2]&255](r,u)|0;u=c[j>>2]|0;c[j>>2]=u+1;a[u]=m;v=b+1|0}else{v=b}m=f;L3955:do{if((m-v|0)>1){if((a[v]|0)!=48){w=3333;break}u=v+1|0;p=a[u]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){w=3333;break}p=k;n=c7[c[(c[p>>2]|0)+28>>2]&255](r,48)|0;q=c[j>>2]|0;c[j>>2]=q+1;a[q]=n;n=v+2|0;q=c7[c[(c[p>>2]|0)+28>>2]&255](r,a[u]|0)|0;u=c[j>>2]|0;c[j>>2]=u+1;a[u]=q;if(n>>>0<f>>>0){x=n}else{y=n;z=n;break}while(1){q=a[x]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);u=x+1|0;if((bo(q<<24>>24|0,c[218270]|0)|0)==0){y=x;z=n;break L3955}if(u>>>0<f>>>0){x=u}else{y=u;z=n;break}}}else{w=3333}}while(0);L3970:do{if((w|0)==3333){if(v>>>0<f>>>0){A=v}else{y=v;z=v;break}while(1){x=a[A]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);q=A+1|0;if((cv(x<<24>>24|0,c[218270]|0)|0)==0){y=A;z=v;break L3970}if(q>>>0<f>>>0){A=q}else{y=q;z=v;break}}}}while(0);v=o;A=o;w=d[A]|0;if((w&1|0)==0){B=w>>>1}else{B=c[o+4>>2]|0}do{if((B|0)==0){w=c[j>>2]|0;q=c[(c[k>>2]|0)+32>>2]|0;di[q&63](r,z,y,w)|0;c[j>>2]=(c[j>>2]|0)+(y-z)}else{do{if((z|0)!=(y|0)){w=y-1|0;if(z>>>0<w>>>0){C=z;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D-1|0;}while(C>>>0<D>>>0)}}while(0);x=da[c[(c[s>>2]|0)+16>>2]&255](t)|0;if(z>>>0<y>>>0){w=v+1|0;q=o+4|0;n=o+8|0;u=k;p=0;E=0;F=z;while(1){G=(a[A]&1)==0;do{if((a[(G?w:c[n>>2]|0)+E|0]|0)>0){if((p|0)!=(a[(G?w:c[n>>2]|0)+E|0]|0)){H=E;I=p;break}J=c[j>>2]|0;c[j>>2]=J+1;a[J]=x;J=d[A]|0;H=(E>>>0<(((J&1|0)==0?J>>>1:c[q>>2]|0)-1|0)>>>0)+E|0;I=0}else{H=E;I=p}}while(0);G=c7[c[(c[u>>2]|0)+28>>2]&255](r,a[F]|0)|0;J=c[j>>2]|0;c[j>>2]=J+1;a[J]=G;G=F+1|0;if(G>>>0<y>>>0){p=I+1|0;E=H;F=G}else{break}}}F=g+(z-b)|0;E=c[j>>2]|0;if((F|0)==(E|0)){break}p=E-1|0;if(F>>>0<p>>>0){K=F;L=p}else{break}do{p=a[K]|0;a[K]=a[L]|0;a[L]=p;K=K+1|0;L=L-1|0;}while(K>>>0<L>>>0)}}while(0);L4010:do{if(y>>>0<f>>>0){L=k;K=y;while(1){z=a[K]|0;if(z<<24>>24==46){break}H=c7[c[(c[L>>2]|0)+28>>2]&255](r,z)|0;z=c[j>>2]|0;c[j>>2]=z+1;a[z]=H;H=K+1|0;if(H>>>0<f>>>0){K=H}else{M=H;break L4010}}L=da[c[(c[s>>2]|0)+12>>2]&255](t)|0;H=c[j>>2]|0;c[j>>2]=H+1;a[H]=L;M=K+1|0}else{M=y}}while(0);di[c[(c[k>>2]|0)+32>>2]&63](r,M,f,c[j>>2]|0)|0;r=(c[j>>2]|0)+(m-M)|0;c[j>>2]=r;if((e|0)==(f|0)){N=r;c[h>>2]=N;tH(o);i=l;return}N=g+(e-b)|0;c[h>>2]=N;tH(o);i=l;return}function wd(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[x]=76;v=x+1|0;if((k&1|0)==0){a[v]=97;y=0;break}else{a[v]=65;y=0;break}}else{a[x]=46;a[x+1|0]=42;a[x+2|0]=76;v=x+3|0;if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=c[218270]|0;if(y){w=v5(k,30,l,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;A=w}else{w=v5(k,30,l,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;A=w}do{if((A|0)>29){w=(a[18202480]|0)==0;if(y){do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=l}else{do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);w=wb(m,c[218270]|0,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;B=w}w=c[m>>2]|0;if((w|0)!=0){C=B;D=w;E=w;break}AY();w=c[m>>2]|0;C=B;D=w;E=w}else{C=A;D=0;E=c[m>>2]|0}}while(0);A=E+C|0;B=c[u>>2]&176;do{if((B|0)==16){u=a[E]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){F=E+1|0;break}if(!((C|0)>1&u<<24>>24==48)){G=3444;break}u=a[E+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){G=3444;break}F=E+2|0}else if((B|0)==32){F=A}else{G=3444}}while(0);if((G|0)==3444){F=E}do{if((E|0)==(k|0)){H=n|0;I=0;J=k}else{G=AL(C<<1)|0;if((G|0)!=0){H=G;I=G;J=E;break}AY();H=0;I=0;J=c[m>>2]|0}}while(0);t3(q,f);wc(J,F,A,H,o,p,q);td(c[q>>2]|0)|0;q=e|0;c[s>>2]=c[q>>2];ei(r,s,H,c[o>>2]|0,c[p>>2]|0,f,g);g=c[r>>2]|0;c[q>>2]=g;c[b>>2]=g;if((I|0)!=0){AM(I)}if((D|0)==0){i=d;return}AM(D);i=d;return}function we(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+104|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+88|0;n=d+96|0;o=d+16|0;a[o]=a[90520]|0;a[o+1|0]=a[90521]|0;a[o+2|0]=a[90522]|0;a[o+3|0]=a[90523]|0;a[o+4|0]=a[90524]|0;a[o+5|0]=a[90525]|0;p=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);q=v5(p,20,c[218270]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==32){r=o}else if((h|0)==16){s=a[p]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){r=k+1|0;break}if(!((q|0)>1&s<<24>>24==48)){t=3477;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){t=3477;break}r=k+2|0}else{t=3477}}while(0);if((t|0)==3477){r=p}t3(m,f);t=m|0;m=c[t>>2]|0;if((c[218656]|0)!=-1){c[j>>2]=874624;c[j+4>>2]=36;c[j+8>>2]=0;tA(874624,j,144)}j=(c[218657]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){s=c[h+(j<<2)>>2]|0;if((s|0)==0){break}u=s;v=c[t>>2]|0;td(v)|0;v=l|0;w=c[(c[s>>2]|0)+32>>2]|0;di[w&63](u,p,o,v)|0;u=l+q|0;if((r|0)==(o|0)){x=u;y=e|0;z=c[y>>2]|0;A=n|0;c[A>>2]=z;ei(b,n,v,x,u,f,g);i=d;return}x=l+(r-k)|0;y=e|0;z=c[y>>2]|0;A=n|0;c[A>>2]=z;ei(b,n,v,x,u,f,g);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function wf(a){a=a|0;tb(a|0);AT(a);return}function wg(a){a=a|0;tb(a|0);return}function wh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];dh[o&63](b,d,l,f,g,h&1);i=j;return}t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218558]|0)!=-1){c[k>>2]=874232;c[k+4>>2]=36;c[k+8>>2]=0;tA(874232,k,144)}k=(c[218559]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;o=c[f>>2]|0;td(o)|0;o=c[l>>2]|0;if(h){c5[c[o+24>>2]&255](n,d)}else{c5[c[o+28>>2]&255](n,d)}d=n;o=a[d]|0;if((o&1)==0){l=n+4|0;p=l;q=l;r=n+8|0}else{l=n+8|0;p=c[l>>2]|0;q=n+4|0;r=l}l=e|0;s=p;t=o;while(1){if((t&1)==0){u=q}else{u=c[r>>2]|0}o=t&255;if((o&1|0)==0){v=o>>>1}else{v=c[q>>2]|0}if((s|0)==(u+(v<<2)|0)){break}o=c[s>>2]|0;w=c[l>>2]|0;do{if((w|0)!=0){x=w+24|0;y=c[x>>2]|0;if((y|0)==(c[w+28>>2]|0)){z=c7[c[(c[w>>2]|0)+52>>2]&255](w,o)|0}else{c[x>>2]=y+4;c[y>>2]=o;z=o}if((z|0)!=-1){break}c[l>>2]=0}}while(0);s=s+4|0;t=a[d]|0}c[b>>2]=c[l>>2];tV(n);i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function wi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[90512]|0;a[q+1|0]=a[90513]|0;a[q+2|0]=a[90514]|0;a[q+3|0]=a[90515]|0;a[q+4|0]=a[90516]|0;a[q+5|0]=a[90517]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);t=v5(u,12,c[218270]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=3548;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3548;break}w=k+2|0}else{x=3548}}while(0);if((x|0)==3548){w=u}x=l|0;t3(o,f);wj(u,w,q,x,m,n,o);td(c[o>>2]|0)|0;c[p>>2]=c[e>>2];wk(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}function wj(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[218654]|0)!=-1){c[n>>2]=874616;c[n+4>>2]=36;c[n+8>>2]=0;tA(874616,n,144)}n=(c[218655]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}r=k;s=c[p>>2]|0;if((c[218558]|0)!=-1){c[m>>2]=874232;c[m+4>>2]=36;c[m+8>>2]=0;tA(874232,m,144)}m=(c[218559]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}t=s;c5[c[(c[s>>2]|0)+20>>2]&255](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}do{if((v|0)==0){p=c[(c[k>>2]|0)+48>>2]|0;di[p&63](r,b,f,g)|0;c[j>>2]=g+(f-b<<2)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=c7[c[(c[k>>2]|0)+44>>2]&255](r,p)|0;p=c[j>>2]|0;c[j>>2]=p+4;c[p>>2]=n;w=b+1|0}else{w=b}do{if((f-w|0)>1){if((a[w]|0)!=48){x=w;break}n=w+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){x=w;break}p=k;q=c7[c[(c[p>>2]|0)+44>>2]&255](r,48)|0;y=c[j>>2]|0;c[j>>2]=y+4;c[y>>2]=q;q=c7[c[(c[p>>2]|0)+44>>2]&255](r,a[n]|0)|0;n=c[j>>2]|0;c[j>>2]=n+4;c[n>>2]=q;x=w+2|0}else{x=w}}while(0);do{if((x|0)!=(f|0)){q=f-1|0;if(x>>>0<q>>>0){z=x;A=q}else{break}do{q=a[z]|0;a[z]=a[A]|0;a[A]=q;z=z+1|0;A=A-1|0;}while(z>>>0<A>>>0)}}while(0);q=da[c[(c[s>>2]|0)+16>>2]&255](t)|0;if(x>>>0<f>>>0){n=u+1|0;p=k;y=o+4|0;B=o+8|0;C=0;D=0;E=x;while(1){F=(a[m]&1)==0;do{if((a[(F?n:c[B>>2]|0)+D|0]|0)==0){G=D;H=C}else{if((C|0)!=(a[(F?n:c[B>>2]|0)+D|0]|0)){G=D;H=C;break}I=c[j>>2]|0;c[j>>2]=I+4;c[I>>2]=q;I=d[m]|0;G=(D>>>0<(((I&1|0)==0?I>>>1:c[y>>2]|0)-1|0)>>>0)+D|0;H=0}}while(0);F=c7[c[(c[p>>2]|0)+44>>2]&255](r,a[E]|0)|0;I=c[j>>2]|0;c[j>>2]=I+4;c[I>>2]=F;F=E+1|0;if(F>>>0<f>>>0){C=H+1|0;D=G;E=F}else{break}}}E=g+(x-b<<2)|0;D=c[j>>2]|0;if((E|0)==(D|0)){break}C=D-4|0;if(E>>>0<C>>>0){J=E;K=C}else{break}do{C=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=C;J=J+4|0;K=K-4|0;}while(J>>>0<K>>>0)}}while(0);if((e|0)==(f|0)){L=c[j>>2]|0;c[h>>2]=L;tH(o);i=l;return}else{L=g+(e-b<<2)|0;c[h>>2]=L;tH(o);i=l;return}}function wk(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((c8[c[(c[d>>2]|0)+48>>2]&127](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){tU(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((c8[c[(c[d>>2]|0)+48>>2]&127](d,r,q)|0)==(q|0)){tV(l);break}c[m>>2]=0;c[b>>2]=0;tV(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((c8[c[(c[d>>2]|0)+48>>2]&127](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function wl(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+232|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+200|0;o=d+208|0;p=d+216|0;q=d+224|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=100}}while(0);u=l|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);v=v5(u,22,c[218270]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+v|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((v|0)>1&s<<24>>24==48)){x=3649;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3649;break}w=l+2|0}else if((j|0)==32){w=r}else{x=3649}}while(0);if((x|0)==3649){w=u}x=m|0;t3(p,f);wj(u,w,r,x,n,o,p);td(c[p>>2]|0)|0;c[q>>2]=c[e>>2];wk(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}function wm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[90512]|0;a[q+1|0]=a[90513]|0;a[q+2|0]=a[90514]|0;a[q+3|0]=a[90515]|0;a[q+4|0]=a[90516]|0;a[q+5|0]=a[90517]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);t=v5(u,12,c[218270]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=3674;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3674;break}w=k+2|0}else{x=3674}}while(0);if((x|0)==3674){w=u}x=l|0;t3(o,f);wj(u,w,q,x,m,n,o);td(c[o>>2]|0)|0;c[p>>2]=c[e>>2];wk(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}function wn(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+240|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+208|0;o=d+216|0;p=d+224|0;q=d+232|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=117}}while(0);u=l|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);v=v5(u,23,c[218270]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+v|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((v|0)>1&s<<24>>24==48)){x=3699;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=3699;break}w=l+2|0}else if((j|0)==32){w=r}else{x=3699}}while(0);if((x|0)==3699){w=u}x=m|0;t3(p,f);wj(u,w,r,x,n,o,p);td(c[p>>2]|0)|0;c[q>>2]=c[e>>2];wk(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}function wo(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[x]=97;y=0;break}else{a[x]=65;y=0;break}}else{a[x]=46;v=x+2|0;a[x+1|0]=42;if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=c[218270]|0;if(y){w=v5(k,30,l,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;A=w}else{w=v5(k,30,l,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;A=w}do{if((A|0)>29){w=(a[18202480]|0)==0;if(y){do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=l}else{do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);w=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=w}w=c[m>>2]|0;if((w|0)!=0){C=B;D=w;E=w;break}AY();w=c[m>>2]|0;C=B;D=w;E=w}else{C=A;D=0;E=c[m>>2]|0}}while(0);A=E+C|0;B=c[u>>2]&176;do{if((B|0)==16){u=a[E]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){F=E+1|0;break}if(!((C|0)>1&u<<24>>24==48)){G=3755;break}u=a[E+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){G=3755;break}F=E+2|0}else if((B|0)==32){F=A}else{G=3755}}while(0);if((G|0)==3755){F=E}do{if((E|0)==(k|0)){H=n|0;I=0;J=k}else{G=AL(C<<3)|0;B=G;if((G|0)!=0){H=B;I=B;J=E;break}AY();H=B;I=B;J=c[m>>2]|0}}while(0);t3(q,f);wp(J,F,A,H,o,p,q);td(c[q>>2]|0)|0;q=e|0;c[s>>2]=c[q>>2];wk(r,s,H,c[o>>2]|0,c[p>>2]|0,f,g);g=c[r>>2]|0;c[q>>2]=g;c[b>>2]=g;if((I|0)!=0){AM(I)}if((D|0)==0){i=d;return}AM(D);i=d;return}function wp(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[218654]|0)!=-1){c[n>>2]=874616;c[n+4>>2]=36;c[n+8>>2]=0;tA(874616,n,144)}n=(c[218655]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cJ(4)|0;s=r;Aq(s);bQ(r|0,97088,288)}r=k;s=c[p>>2]|0;if((c[218558]|0)!=-1){c[m>>2]=874232;c[m+4>>2]=36;c[m+8>>2]=0;tA(874232,m,144)}m=(c[218559]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cJ(4)|0;u=t;Aq(u);bQ(t|0,97088,288)}t=s;c5[c[(c[s>>2]|0)+20>>2]&255](o,t);c[j>>2]=g;u=a[b]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=c7[c[(c[k>>2]|0)+44>>2]&255](r,u)|0;u=c[j>>2]|0;c[j>>2]=u+4;c[u>>2]=m;v=b+1|0}else{v=b}m=f;L4495:do{if((m-v|0)>1){if((a[v]|0)!=48){w=3797;break}u=v+1|0;p=a[u]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){w=3797;break}p=k;n=c7[c[(c[p>>2]|0)+44>>2]&255](r,48)|0;q=c[j>>2]|0;c[j>>2]=q+4;c[q>>2]=n;n=v+2|0;q=c7[c[(c[p>>2]|0)+44>>2]&255](r,a[u]|0)|0;u=c[j>>2]|0;c[j>>2]=u+4;c[u>>2]=q;if(n>>>0<f>>>0){x=n}else{y=n;z=n;break}while(1){q=a[x]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);u=x+1|0;if((bo(q<<24>>24|0,c[218270]|0)|0)==0){y=x;z=n;break L4495}if(u>>>0<f>>>0){x=u}else{y=u;z=n;break}}}else{w=3797}}while(0);L4510:do{if((w|0)==3797){if(v>>>0<f>>>0){A=v}else{y=v;z=v;break}while(1){x=a[A]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);q=A+1|0;if((cv(x<<24>>24|0,c[218270]|0)|0)==0){y=A;z=v;break L4510}if(q>>>0<f>>>0){A=q}else{y=q;z=v;break}}}}while(0);v=o;A=o;w=d[A]|0;if((w&1|0)==0){B=w>>>1}else{B=c[o+4>>2]|0}do{if((B|0)==0){w=c[j>>2]|0;q=c[(c[k>>2]|0)+48>>2]|0;di[q&63](r,z,y,w)|0;c[j>>2]=(c[j>>2]|0)+(y-z<<2)}else{do{if((z|0)!=(y|0)){w=y-1|0;if(z>>>0<w>>>0){C=z;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D-1|0;}while(C>>>0<D>>>0)}}while(0);x=da[c[(c[s>>2]|0)+16>>2]&255](t)|0;if(z>>>0<y>>>0){w=v+1|0;q=o+4|0;n=o+8|0;u=k;p=0;E=0;F=z;while(1){G=(a[A]&1)==0;do{if((a[(G?w:c[n>>2]|0)+E|0]|0)>0){if((p|0)!=(a[(G?w:c[n>>2]|0)+E|0]|0)){H=E;I=p;break}J=c[j>>2]|0;c[j>>2]=J+4;c[J>>2]=x;J=d[A]|0;H=(E>>>0<(((J&1|0)==0?J>>>1:c[q>>2]|0)-1|0)>>>0)+E|0;I=0}else{H=E;I=p}}while(0);G=c7[c[(c[u>>2]|0)+44>>2]&255](r,a[F]|0)|0;J=c[j>>2]|0;c[j>>2]=J+4;c[J>>2]=G;G=F+1|0;if(G>>>0<y>>>0){p=I+1|0;E=H;F=G}else{break}}}F=g+(z-b<<2)|0;E=c[j>>2]|0;if((F|0)==(E|0)){break}p=E-4|0;if(F>>>0<p>>>0){K=F;L=p}else{break}do{p=c[K>>2]|0;c[K>>2]=c[L>>2];c[L>>2]=p;K=K+4|0;L=L-4|0;}while(K>>>0<L>>>0)}}while(0);L4550:do{if(y>>>0<f>>>0){L=k;K=y;while(1){z=a[K]|0;if(z<<24>>24==46){break}H=c7[c[(c[L>>2]|0)+44>>2]&255](r,z)|0;z=c[j>>2]|0;c[j>>2]=z+4;c[z>>2]=H;H=K+1|0;if(H>>>0<f>>>0){K=H}else{M=H;break L4550}}L=da[c[(c[s>>2]|0)+12>>2]&255](t)|0;H=c[j>>2]|0;c[j>>2]=H+4;c[H>>2]=L;M=K+1|0}else{M=y}}while(0);di[c[(c[k>>2]|0)+48>>2]&63](r,M,f,c[j>>2]|0)|0;r=(c[j>>2]|0)+(m-M<<2)|0;c[j>>2]=r;if((e|0)==(f|0)){N=r;c[h>>2]=N;tH(o);i=l;return}N=g+(e-b<<2)|0;c[h>>2]=N;tH(o);i=l;return}function wq(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[x]=76;v=x+1|0;if((k&1|0)==0){a[v]=97;y=0;break}else{a[v]=65;y=0;break}}else{a[x]=46;a[x+1|0]=42;a[x+2|0]=76;v=x+3|0;if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=c[218270]|0;if(y){w=v5(k,30,l,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;A=w}else{w=v5(k,30,l,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;A=w}do{if((A|0)>29){w=(a[18202480]|0)==0;if(y){do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=wb(m,c[218270]|0,t,(z=i,i=i+16|0,c[z>>2]=c[f+8>>2],h[z+8>>3]=j,z)|0)|0;i=z;B=l}else{do{if(w){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);w=wb(m,c[218270]|0,t,(z=i,i=i+8|0,h[z>>3]=j,z)|0)|0;i=z;B=w}w=c[m>>2]|0;if((w|0)!=0){C=B;D=w;E=w;break}AY();w=c[m>>2]|0;C=B;D=w;E=w}else{C=A;D=0;E=c[m>>2]|0}}while(0);A=E+C|0;B=c[u>>2]&176;do{if((B|0)==32){F=A}else if((B|0)==16){u=a[E]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){F=E+1|0;break}if(!((C|0)>1&u<<24>>24==48)){G=3908;break}u=a[E+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){G=3908;break}F=E+2|0}else{G=3908}}while(0);if((G|0)==3908){F=E}do{if((E|0)==(k|0)){H=n|0;I=0;J=k}else{G=AL(C<<3)|0;B=G;if((G|0)!=0){H=B;I=B;J=E;break}AY();H=B;I=B;J=c[m>>2]|0}}while(0);t3(q,f);wp(J,F,A,H,o,p,q);td(c[q>>2]|0)|0;q=e|0;c[s>>2]=c[q>>2];wk(r,s,H,c[o>>2]|0,c[p>>2]|0,f,g);g=c[r>>2]|0;c[q>>2]=g;c[b>>2]=g;if((I|0)!=0){AM(I)}if((D|0)==0){i=d;return}AM(D);i=d;return}function wr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+216|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+200|0;n=d+208|0;o=d+16|0;a[o]=a[90520]|0;a[o+1|0]=a[90521]|0;a[o+2|0]=a[90522]|0;a[o+3|0]=a[90523]|0;a[o+4|0]=a[90524]|0;a[o+5|0]=a[90525]|0;p=k|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);q=v5(p,20,c[218270]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==16){r=a[p]|0;if((r<<24>>24|0)==45|(r<<24>>24|0)==43){s=k+1|0;break}if(!((q|0)>1&r<<24>>24==48)){t=3941;break}r=a[k+1|0]|0;if(!((r<<24>>24|0)==120|(r<<24>>24|0)==88)){t=3941;break}s=k+2|0}else if((h|0)==32){s=o}else{t=3941}}while(0);if((t|0)==3941){s=p}t3(m,f);t=m|0;m=c[t>>2]|0;if((c[218654]|0)!=-1){c[j>>2]=874616;c[j+4>>2]=36;c[j+8>>2]=0;tA(874616,j,144)}j=(c[218655]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){r=c[h+(j<<2)>>2]|0;if((r|0)==0){break}u=r;v=c[t>>2]|0;td(v)|0;v=l|0;w=c[(c[r>>2]|0)+48>>2]|0;di[w&63](u,p,o,v)|0;u=l+(q<<2)|0;if((s|0)==(o|0)){x=u;y=e|0;z=c[y>>2]|0;A=n|0;c[A>>2]=z;wk(b,n,v,x,u,f,g);i=d;return}x=l+(s-k<<2)|0;y=e|0;z=c[y>>2]|0;A=n|0;c[A>>2]=z;wk(b,n,v,x,u,f,g);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function ws(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;n=i;i=i+48|0;o=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[o>>2];o=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[o>>2];o=n|0;p=n+16|0;q=n+24|0;r=n+32|0;s=n+40|0;t3(p,h);t=p|0;p=c[t>>2]|0;if((c[218656]|0)!=-1){c[o>>2]=874624;c[o+4>>2]=36;c[o+8>>2]=0;tA(874624,o,144)}o=(c[218657]|0)-1|0;u=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-u>>2>>>0>o>>>0){v=c[u+(o<<2)>>2]|0;if((v|0)==0){break}w=v;x=c[t>>2]|0;td(x)|0;c[j>>2]=0;x=f|0;L4680:do{if((l|0)==(m|0)){y=4020}else{z=g|0;A=v;B=v+8|0;C=v;D=e;E=r|0;F=s|0;G=q|0;H=l;I=0;L4682:while(1){J=I;while(1){if((J|0)!=0){y=4020;break L4680}K=c[x>>2]|0;do{if((K|0)==0){L=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){L=K;break}if((da[c[(c[K>>2]|0)+36>>2]&255](K)|0)!=-1){L=K;break}c[x>>2]=0;L=0}}while(0);K=(L|0)==0;M=c[z>>2]|0;L4692:do{if((M|0)==0){y=3973}else{do{if((c[M+12>>2]|0)==(c[M+16>>2]|0)){if((da[c[(c[M>>2]|0)+36>>2]&255](M)|0)!=-1){break}c[z>>2]=0;y=3973;break L4692}}while(0);if(K){N=M}else{y=3974;break L4682}}}while(0);if((y|0)==3973){y=0;if(K){y=3974;break L4682}else{N=0}}if((c8[c[(c[A>>2]|0)+36>>2]&127](w,a[H]|0,0)|0)<<24>>24==37){y=3977;break}M=a[H]|0;if(M<<24>>24>-1){O=c[B>>2]|0;if((b[O+(M<<24>>24<<1)>>1]&8192)!=0){P=H;y=3988;break}}Q=L+12|0;M=c[Q>>2]|0;R=L+16|0;if((M|0)==(c[R>>2]|0)){S=(da[c[(c[L>>2]|0)+36>>2]&255](L)|0)&255}else{S=a[M]|0}M=c7[c[(c[C>>2]|0)+12>>2]&255](w,S)|0;if(M<<24>>24==(c7[c[(c[C>>2]|0)+12>>2]&255](w,a[H]|0)|0)<<24>>24){y=4015;break}c[j>>2]=4;J=4}L4710:do{if((y|0)==3988){while(1){y=0;J=P+1|0;if((J|0)==(m|0)){T=m;break}M=a[J]|0;if(M<<24>>24<=-1){T=J;break}if((b[O+(M<<24>>24<<1)>>1]&8192)==0){T=J;break}else{P=J;y=3988}}K=L;J=N;while(1){do{if((K|0)==0){U=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){U=K;break}if((da[c[(c[K>>2]|0)+36>>2]&255](K)|0)!=-1){U=K;break}c[x>>2]=0;U=0}}while(0);M=(U|0)==0;do{if((J|0)==0){y=4001}else{if((c[J+12>>2]|0)!=(c[J+16>>2]|0)){if(M){V=J;break}else{W=T;break L4710}}if((da[c[(c[J>>2]|0)+36>>2]&255](J)|0)==-1){c[z>>2]=0;y=4001;break}else{if(M^(J|0)==0){V=J;break}else{W=T;break L4710}}}}while(0);if((y|0)==4001){y=0;if(M){W=T;break L4710}else{V=0}}X=U+12|0;Y=c[X>>2]|0;Z=U+16|0;if((Y|0)==(c[Z>>2]|0)){_=(da[c[(c[U>>2]|0)+36>>2]&255](U)|0)&255}else{_=a[Y]|0}if(_<<24>>24<=-1){W=T;break L4710}if((b[(c[B>>2]|0)+(_<<24>>24<<1)>>1]&8192)==0){W=T;break L4710}Y=c[X>>2]|0;if((Y|0)==(c[Z>>2]|0)){Z=c[(c[U>>2]|0)+40>>2]|0;da[Z&255](U)|0;K=U;J=V;continue}else{c[X>>2]=Y+1;K=U;J=V;continue}}}else if((y|0)==4015){y=0;J=c[Q>>2]|0;if((J|0)==(c[R>>2]|0)){K=c[(c[L>>2]|0)+40>>2]|0;da[K&255](L)|0}else{c[Q>>2]=J+1}W=H+1|0}else if((y|0)==3977){y=0;J=H+1|0;if((J|0)==(m|0)){y=3978;break L4682}K=c8[c[(c[A>>2]|0)+36>>2]&127](w,a[J]|0,0)|0;if((K<<24>>24|0)==69|(K<<24>>24|0)==48){Y=H+2|0;if((Y|0)==(m|0)){y=3981;break L4682}$=K;aa=c8[c[(c[A>>2]|0)+36>>2]&127](w,a[Y]|0,0)|0;ab=Y}else{$=0;aa=K;ab=J}J=c[(c[D>>2]|0)+36>>2]|0;c[E>>2]=L;c[F>>2]=N;df[J&31](q,e,r,s,h,j,k,aa,$);c[x>>2]=c[G>>2];W=ab+1|0}}while(0);if((W|0)==(m|0)){y=4020;break L4680}H=W;I=c[j>>2]|0}if((y|0)==3978){c[j>>2]=4;ac=L;break}else if((y|0)==3974){c[j>>2]=4;ac=L;break}else if((y|0)==3981){c[j>>2]=4;ac=L;break}}}while(0);if((y|0)==4020){ac=c[x>>2]|0}w=f|0;do{if((ac|0)!=0){if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){break}if((da[c[(c[ac>>2]|0)+36>>2]&255](ac)|0)!=-1){break}c[w>>2]=0}}while(0);x=c[w>>2]|0;v=(x|0)==0;I=g|0;H=c[I>>2]|0;L4768:do{if((H|0)==0){y=4030}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if((da[c[(c[H>>2]|0)+36>>2]&255](H)|0)!=-1){break}c[I>>2]=0;y=4030;break L4768}}while(0);if(!v){break}ad=d|0;c[ad>>2]=x;i=n;return}}while(0);do{if((y|0)==4030){if(v){break}ad=d|0;c[ad>>2]=x;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ad=d|0;c[ad>>2]=x;i=n;return}}while(0);n=cJ(4)|0;Aq(n);bQ(n|0,97088,288)}function wt(a){a=a|0;tb(a|0);AT(a);return}function wu(a){a=a|0;tb(a|0);return}function wv(a){a=a|0;return 2}function ww(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];ws(a,b,k,l,f,g,h,90504,90512);i=j;return}function wx(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=da[c[(c[n>>2]|0)+20>>2]&255](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=o;e=a[o]|0;if((e&1)==0){p=f+1|0;q=f+1|0}else{f=c[o+8>>2]|0;p=f;q=f}f=e&255;if((f&1|0)==0){r=f>>>1}else{r=c[o+4>>2]|0}ws(b,d,l,m,g,h,j,q,p+r|0);i=k;return}function wy(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;n=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-n>>2>>>0>l>>>0){o=c[n+(l<<2)>>2]|0;if((o|0)==0){break}p=o;o=c[f>>2]|0;td(o)|0;o=c[e>>2]|0;q=b+8|0;r=da[c[c[q>>2]>>2]&255](q)|0;c[k>>2]=o;o=(vd(d,k,r,r+168|0,p,g,0)|0)-r|0;if((o|0)>=168){s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}c[h+24>>2]=((o|0)/12|0|0)%7|0;s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function wz(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;n=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-n>>2>>>0>l>>>0){o=c[n+(l<<2)>>2]|0;if((o|0)==0){break}p=o;o=c[f>>2]|0;td(o)|0;o=c[e>>2]|0;q=b+8|0;r=da[c[(c[q>>2]|0)+4>>2]&255](q)|0;c[k>>2]=o;o=(vd(d,k,r,r+288|0,p,g,0)|0)-r|0;if((o|0)>=288){s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}c[h+16>>2]=((o|0)/12|0|0)%12|0;s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function wA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;t3(l,f);f=l|0;l=c[f>>2]|0;if((c[218656]|0)!=-1){c[k>>2]=874624;c[k+4>>2]=36;c[k+8>>2]=0;tA(874624,k,144)}k=(c[218657]|0)-1|0;m=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-m>>2>>>0>k>>>0){n=c[m+(k<<2)>>2]|0;if((n|0)==0){break}o=n;n=c[f>>2]|0;td(n)|0;c[j>>2]=c[e>>2];n=wF(d,j,g,o,4)|0;if((c[g>>2]&4|0)!=0){p=4;q=0;r=d|0;s=c[r>>2]|0;t=a|0;c[t>>2]=s;i=b;return}if((n|0)<69){u=n+2e3|0}else{u=(n-69|0)>>>0<31>>>0?n+1900|0:n}c[h+20>>2]=u-1900;p=4;q=0;r=d|0;s=c[r>>2]|0;t=a|0;c[t>>2]=s;i=b;return}}while(0);b=cJ(4)|0;Aq(b);bQ(b|0,97088,288)}function wB(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+112|0;A=l+120|0;B=l+128|0;C=l+136|0;D=l+144|0;E=l+152|0;F=l+160|0;G=l+168|0;H=l+176|0;I=l+184|0;J=l+192|0;K=l+200|0;L=l+208|0;M=l+216|0;N=l+224|0;O=l+232|0;P=l+240|0;Q=l+248|0;R=l+256|0;S=l+264|0;T=l+272|0;U=l+280|0;V=l+288|0;W=l+296|0;X=l+304|0;Y=l+312|0;Z=l+320|0;c[h>>2]=0;t3(z,g);_=z|0;z=c[_>>2]|0;if((c[218656]|0)!=-1){c[y>>2]=874624;c[y+4>>2]=36;c[y+8>>2]=0;tA(874624,y,144)}y=(c[218657]|0)-1|0;$=c[z+8>>2]|0;do{if((c[z+12>>2]|0)-$>>2>>>0>y>>>0){aa=c[$+(y<<2)>>2]|0;if((aa|0)==0){break}ab=aa;aa=c[_>>2]|0;td(aa)|0;L4845:do{switch(k<<24>>24|0){case 112:{c[K>>2]=c[f>>2];wD(d,j+8|0,e,K,h,ab);break};case 82:{aa=e|0;c[P>>2]=c[aa>>2];c[Q>>2]=c[f>>2];ws(O,d,P,Q,g,h,j,90464,90469);c[aa>>2]=c[O>>2];break};case 99:{aa=d+8|0;ac=da[c[(c[aa>>2]|0)+12>>2]&255](aa)|0;aa=e|0;c[B>>2]=c[aa>>2];c[C>>2]=c[f>>2];ad=ac;ae=a[ac]|0;if((ae&1)==0){af=ad+1|0;ag=ad+1|0}else{ad=c[ac+8>>2]|0;af=ad;ag=ad}ad=ae&255;if((ad&1|0)==0){ah=ad>>>1}else{ah=c[ac+4>>2]|0}ws(A,d,B,C,g,h,j,ag,af+ah|0);c[aa>>2]=c[A>>2];break};case 120:{aa=c[(c[d>>2]|0)+20>>2]|0;c[U>>2]=c[e>>2];c[V>>2]=c[f>>2];db[aa&127](b,d,U,V,g,h,j);i=l;return};case 88:{aa=d+8|0;ac=da[c[(c[aa>>2]|0)+24>>2]&255](aa)|0;aa=e|0;c[X>>2]=c[aa>>2];c[Y>>2]=c[f>>2];ad=ac;ae=a[ac]|0;if((ae&1)==0){ai=ad+1|0;aj=ad+1|0}else{ad=c[ac+8>>2]|0;ai=ad;aj=ad}ad=ae&255;if((ad&1|0)==0){ak=ad>>>1}else{ak=c[ac+4>>2]|0}ws(W,d,X,Y,g,h,j,aj,ai+ak|0);c[aa>>2]=c[W>>2];break};case 72:{c[u>>2]=c[f>>2];aa=wF(e,u,h,ab,2)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(aa|0)<24){c[j+8>>2]=aa;break L4845}else{c[h>>2]=ac|4;break L4845}break};case 119:{c[o>>2]=c[f>>2];ac=wF(e,o,h,ab,1)|0;aa=c[h>>2]|0;if((aa&4|0)==0&(ac|0)<7){c[j+24>>2]=ac;break L4845}else{c[h>>2]=aa|4;break L4845}break};case 121:{c[n>>2]=c[f>>2];aa=wF(e,n,h,ab,4)|0;if((c[h>>2]&4|0)!=0){break L4845}if((aa|0)<69){al=aa+2e3|0}else{al=(aa-69|0)>>>0<31>>>0?aa+1900|0:aa}c[j+20>>2]=al-1900;break};case 114:{aa=e|0;c[M>>2]=c[aa>>2];c[N>>2]=c[f>>2];ws(L,d,M,N,g,h,j,90472,90483);c[aa>>2]=c[L>>2];break};case 106:{c[s>>2]=c[f>>2];aa=wF(e,s,h,ab,3)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(aa|0)<366){c[j+28>>2]=aa;break L4845}else{c[h>>2]=ac|4;break L4845}break};case 110:case 116:{c[J>>2]=c[f>>2];wC(0,e,J,h,ab);break};case 89:{c[m>>2]=c[f>>2];ac=wF(e,m,h,ab,4)|0;if((c[h>>2]&4|0)!=0){break L4845}c[j+20>>2]=ac-1900;break};case 37:{c[Z>>2]=c[f>>2];wE(0,e,Z,h,ab);break};case 83:{c[p>>2]=c[f>>2];ac=wF(e,p,h,ab,2)|0;aa=c[h>>2]|0;if((aa&4|0)==0&(ac|0)<61){c[j>>2]=ac;break L4845}else{c[h>>2]=aa|4;break L4845}break};case 98:case 66:case 104:{aa=c[f>>2]|0;ac=d+8|0;ad=da[c[(c[ac>>2]|0)+4>>2]&255](ac)|0;c[w>>2]=aa;aa=(vd(e,w,ad,ad+288|0,ab,h,0)|0)-ad|0;if((aa|0)>=288){break L4845}c[j+16>>2]=((aa|0)/12|0|0)%12|0;break};case 84:{aa=e|0;c[S>>2]=c[aa>>2];c[T>>2]=c[f>>2];ws(R,d,S,T,g,h,j,90456,90464);c[aa>>2]=c[R>>2];break};case 109:{c[r>>2]=c[f>>2];aa=wF(e,r,h,ab,2)|0;ad=c[h>>2]|0;if((ad&4|0)==0&(aa|0)<13){c[j+16>>2]=aa-1;break L4845}else{c[h>>2]=ad|4;break L4845}break};case 97:case 65:{ad=c[f>>2]|0;aa=d+8|0;ac=da[c[c[aa>>2]>>2]&255](aa)|0;c[x>>2]=ad;ad=(vd(e,x,ac,ac+168|0,ab,h,0)|0)-ac|0;if((ad|0)>=168){break L4845}c[j+24>>2]=((ad|0)/12|0|0)%7|0;break};case 68:{ad=e|0;c[E>>2]=c[ad>>2];c[F>>2]=c[f>>2];ws(D,d,E,F,g,h,j,90496,90504);c[ad>>2]=c[D>>2];break};case 100:case 101:{ad=j+12|0;c[v>>2]=c[f>>2];ac=wF(e,v,h,ab,2)|0;aa=c[h>>2]|0;do{if((aa&4|0)==0){if((ac-1|0)>>>0>=31>>>0){break}c[ad>>2]=ac;break L4845}}while(0);c[h>>2]=aa|4;break};case 73:{ac=j+8|0;c[t>>2]=c[f>>2];ad=wF(e,t,h,ab,2)|0;ae=c[h>>2]|0;do{if((ae&4|0)==0){if((ad-1|0)>>>0>=12>>>0){break}c[ac>>2]=ad;break L4845}}while(0);c[h>>2]=ae|4;break};case 70:{ad=e|0;c[H>>2]=c[ad>>2];c[I>>2]=c[f>>2];ws(G,d,H,I,g,h,j,90488,90496);c[ad>>2]=c[G>>2];break};case 77:{c[q>>2]=c[f>>2];ad=wF(e,q,h,ab,2)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(ad|0)<60){c[j+4>>2]=ad;break L4845}else{c[h>>2]=ac|4;break L4845}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=cJ(4)|0;Aq(l);bQ(l|0,97088,288)}function wC(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;j=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[j>>2];j=e|0;e=f|0;f=h+8|0;L4926:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((da[c[(c[h>>2]|0)+36>>2]&255](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;L4935:do{if((l|0)==0){m=4170}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if((da[c[(c[l>>2]|0)+36>>2]&255](l)|0)!=-1){break}c[e>>2]=0;m=4170;break L4935}}while(0);if(h){n=l;o=0}else{p=l;q=0;break L4926}}}while(0);if((m|0)==4170){m=0;if(h){p=0;q=1;break}else{n=0;o=1}}l=c[j>>2]|0;r=c[l+12>>2]|0;if((r|0)==(c[l+16>>2]|0)){s=(da[c[(c[l>>2]|0)+36>>2]&255](l)|0)&255}else{s=a[r]|0}if(s<<24>>24<=-1){p=n;q=o;break}if((b[(c[f>>2]|0)+(s<<24>>24<<1)>>1]&8192)==0){p=n;q=o;break}r=c[j>>2]|0;l=r+12|0;t=c[l>>2]|0;if((t|0)==(c[r+16>>2]|0)){u=c[(c[r>>2]|0)+40>>2]|0;da[u&255](r)|0;continue}else{c[l>>2]=t+1;continue}}o=c[j>>2]|0;do{if((o|0)==0){v=0}else{if((c[o+12>>2]|0)!=(c[o+16>>2]|0)){v=o;break}if((da[c[(c[o>>2]|0)+36>>2]&255](o)|0)==-1){c[j>>2]=0;v=0;break}else{v=c[j>>2]|0;break}}}while(0);j=(v|0)==0;do{if(q){m=4189}else{if((c[p+12>>2]|0)!=(c[p+16>>2]|0)){if(!(j^(p|0)==0)){break}i=d;return}if((da[c[(c[p>>2]|0)+36>>2]&255](p)|0)==-1){c[e>>2]=0;m=4189;break}if(!j){break}i=d;return}}while(0);do{if((m|0)==4189){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function wD(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=da[c[(c[l>>2]|0)+8>>2]&255](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=vd(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function wE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=d|0;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((da[c[(c[d>>2]|0)+36>>2]&255](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e|0;e=c[j>>2]|0;L5009:do{if((e|0)==0){k=4227}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((da[c[(c[e>>2]|0)+36>>2]&255](e)|0)!=-1){break}c[j>>2]=0;k=4227;break L5009}}while(0);if(d){l=e;m=0}else{k=4228}}}while(0);if((k|0)==4227){if(d){k=4228}else{l=0;m=1}}if((k|0)==4228){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){n=(da[c[(c[d>>2]|0)+36>>2]&255](d)|0)&255}else{n=a[e]|0}if((c8[c[(c[g>>2]|0)+36>>2]&127](g,n,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;i=b;return}n=c[h>>2]|0;g=n+12|0;e=c[g>>2]|0;if((e|0)==(c[n+16>>2]|0)){d=c[(c[n>>2]|0)+40>>2]|0;da[d&255](n)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){o=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){o=e;break}if((da[c[(c[e>>2]|0)+36>>2]&255](e)|0)==-1){c[h>>2]=0;o=0;break}else{o=c[h>>2]|0;break}}}while(0);h=(o|0)==0;do{if(m){k=4247}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(!(h^(l|0)==0)){break}i=b;return}if((da[c[(c[l>>2]|0)+36>>2]&255](l)|0)==-1){c[j>>2]=0;k=4247;break}if(!h){break}i=b;return}}while(0);do{if((k|0)==4247){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function wF(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((da[c[(c[d>>2]|0)+36>>2]&255](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e|0;e=c[l>>2]|0;L5063:do{if((e|0)==0){m=4267}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((da[c[(c[e>>2]|0)+36>>2]&255](e)|0)!=-1){break}c[l>>2]=0;m=4267;break L5063}}while(0);if(d){n=e}else{m=4268}}}while(0);if((m|0)==4267){if(d){m=4268}else{n=0}}if((m|0)==4268){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(da[c[(c[d>>2]|0)+36>>2]&255](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=g;q=(c8[c[(c[d>>2]|0)+36>>2]&127](g,p,0)|0)<<24>>24;r=c[k>>2]|0;s=r+12|0;t=c[s>>2]|0;if((t|0)==(c[r+16>>2]|0)){u=c[(c[r>>2]|0)+40>>2]|0;da[u&255](r)|0;v=q;w=h;x=n}else{c[s>>2]=t+1;v=q;w=h;x=n}while(1){y=v-48|0;q=w-1|0;t=c[k>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if((da[c[(c[t>>2]|0)+36>>2]&255](t)|0)==-1){c[k>>2]=0;z=0;break}else{z=c[k>>2]|0;break}}}while(0);t=(z|0)==0;if((x|0)==0){A=z;B=0}else{do{if((c[x+12>>2]|0)==(c[x+16>>2]|0)){if((da[c[(c[x>>2]|0)+36>>2]&255](x)|0)!=-1){C=x;break}c[l>>2]=0;C=0}else{C=x}}while(0);A=c[k>>2]|0;B=C}D=(B|0)==0;if(!((t^D)&(q|0)>0)){m=4297;break}s=c[A+12>>2]|0;if((s|0)==(c[A+16>>2]|0)){E=(da[c[(c[A>>2]|0)+36>>2]&255](A)|0)&255}else{E=a[s]|0}if(E<<24>>24<=-1){o=y;m=4311;break}if((b[(c[e>>2]|0)+(E<<24>>24<<1)>>1]&2048)==0){o=y;m=4315;break}s=((c8[c[(c[d>>2]|0)+36>>2]&127](g,E,0)|0)<<24>>24)+(y*10|0)|0;r=c[k>>2]|0;u=r+12|0;F=c[u>>2]|0;if((F|0)==(c[r+16>>2]|0)){G=c[(c[r>>2]|0)+40>>2]|0;da[G&255](r)|0;v=s;w=q;x=B;continue}else{c[u>>2]=F+1;v=s;w=q;x=B;continue}}if((m|0)==4297){do{if((A|0)==0){H=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){H=A;break}if((da[c[(c[A>>2]|0)+36>>2]&255](A)|0)==-1){c[k>>2]=0;H=0;break}else{H=c[k>>2]|0;break}}}while(0);d=(H|0)==0;L5120:do{if(D){m=4307}else{do{if((c[B+12>>2]|0)==(c[B+16>>2]|0)){if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){break}c[l>>2]=0;m=4307;break L5120}}while(0);if(d){o=y}else{break}i=j;return o|0}}while(0);do{if((m|0)==4307){if(d){break}else{o=y}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=y;i=j;return o|0}else if((m|0)==4311){i=j;return o|0}else if((m|0)==4315){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function wG(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;l=i;i=i+48|0;m=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[m>>2];m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=l|0;n=l+16|0;o=l+24|0;p=l+32|0;q=l+40|0;t3(n,f);r=n|0;n=c[r>>2]|0;if((c[218654]|0)!=-1){c[m>>2]=874616;c[m+4>>2]=36;c[m+8>>2]=0;tA(874616,m,144)}m=(c[218655]|0)-1|0;s=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-s>>2>>>0>m>>>0){t=c[s+(m<<2)>>2]|0;if((t|0)==0){break}u=t;v=c[r>>2]|0;td(v)|0;c[g>>2]=0;v=d|0;L5143:do{if((j|0)==(k|0)){w=4387}else{x=e|0;y=t;z=t;A=t;B=b;C=p|0;D=q|0;E=o|0;F=j;G=0;L5145:while(1){H=G;while(1){if((H|0)!=0){w=4387;break L5143}I=c[v>>2]|0;do{if((I|0)==0){J=0}else{K=c[I+12>>2]|0;if((K|0)==(c[I+16>>2]|0)){L=da[c[(c[I>>2]|0)+36>>2]&255](I)|0}else{L=c[K>>2]|0}if((L|0)!=-1){J=I;break}c[v>>2]=0;J=0}}while(0);I=(J|0)==0;K=c[x>>2]|0;do{if((K|0)==0){w=4339}else{M=c[K+12>>2]|0;if((M|0)==(c[K+16>>2]|0)){N=da[c[(c[K>>2]|0)+36>>2]&255](K)|0}else{N=c[M>>2]|0}if((N|0)==-1){c[x>>2]=0;w=4339;break}else{if(I^(K|0)==0){O=K;break}else{w=4341;break L5145}}}}while(0);if((w|0)==4339){w=0;if(I){w=4341;break L5145}else{O=0}}if((c8[c[(c[y>>2]|0)+52>>2]&127](u,c[F>>2]|0,0)|0)<<24>>24==37){w=4344;break}if(c8[c[(c[z>>2]|0)+12>>2]&127](u,8192,c[F>>2]|0)|0){P=F;w=4354;break}Q=J+12|0;K=c[Q>>2]|0;R=J+16|0;if((K|0)==(c[R>>2]|0)){S=da[c[(c[J>>2]|0)+36>>2]&255](J)|0}else{S=c[K>>2]|0}K=c7[c[(c[A>>2]|0)+28>>2]&255](u,S)|0;if((K|0)==(c7[c[(c[A>>2]|0)+28>>2]&255](u,c[F>>2]|0)|0)){w=4382;break}c[g>>2]=4;H=4}L5177:do{if((w|0)==4344){w=0;H=F+4|0;if((H|0)==(k|0)){w=4345;break L5145}K=c8[c[(c[y>>2]|0)+52>>2]&127](u,c[H>>2]|0,0)|0;if((K<<24>>24|0)==69|(K<<24>>24|0)==48){M=F+8|0;if((M|0)==(k|0)){w=4348;break L5145}T=K;U=c8[c[(c[y>>2]|0)+52>>2]&127](u,c[M>>2]|0,0)|0;V=M}else{T=0;U=K;V=H}H=c[(c[B>>2]|0)+36>>2]|0;c[C>>2]=J;c[D>>2]=O;df[H&31](o,b,p,q,f,g,h,U,T);c[v>>2]=c[E>>2];W=V+4|0}else if((w|0)==4354){while(1){w=0;H=P+4|0;if((H|0)==(k|0)){X=k;break}if(c8[c[(c[z>>2]|0)+12>>2]&127](u,8192,c[H>>2]|0)|0){P=H;w=4354}else{X=H;break}}I=J;H=O;while(1){do{if((I|0)==0){Y=0}else{K=c[I+12>>2]|0;if((K|0)==(c[I+16>>2]|0)){Z=da[c[(c[I>>2]|0)+36>>2]&255](I)|0}else{Z=c[K>>2]|0}if((Z|0)!=-1){Y=I;break}c[v>>2]=0;Y=0}}while(0);K=(Y|0)==0;do{if((H|0)==0){w=4369}else{M=c[H+12>>2]|0;if((M|0)==(c[H+16>>2]|0)){_=da[c[(c[H>>2]|0)+36>>2]&255](H)|0}else{_=c[M>>2]|0}if((_|0)==-1){c[x>>2]=0;w=4369;break}else{if(K^(H|0)==0){$=H;break}else{W=X;break L5177}}}}while(0);if((w|0)==4369){w=0;if(K){W=X;break L5177}else{$=0}}M=Y+12|0;aa=c[M>>2]|0;ab=Y+16|0;if((aa|0)==(c[ab>>2]|0)){ac=da[c[(c[Y>>2]|0)+36>>2]&255](Y)|0}else{ac=c[aa>>2]|0}if(!(c8[c[(c[z>>2]|0)+12>>2]&127](u,8192,ac)|0)){W=X;break L5177}aa=c[M>>2]|0;if((aa|0)==(c[ab>>2]|0)){ab=c[(c[Y>>2]|0)+40>>2]|0;da[ab&255](Y)|0;I=Y;H=$;continue}else{c[M>>2]=aa+4;I=Y;H=$;continue}}}else if((w|0)==4382){w=0;H=c[Q>>2]|0;if((H|0)==(c[R>>2]|0)){I=c[(c[J>>2]|0)+40>>2]|0;da[I&255](J)|0}else{c[Q>>2]=H+4}W=F+4|0}}while(0);if((W|0)==(k|0)){w=4387;break L5143}F=W;G=c[g>>2]|0}if((w|0)==4345){c[g>>2]=4;ad=J;break}else if((w|0)==4341){c[g>>2]=4;ad=J;break}else if((w|0)==4348){c[g>>2]=4;ad=J;break}}}while(0);if((w|0)==4387){ad=c[v>>2]|0}u=d|0;do{if((ad|0)!=0){t=c[ad+12>>2]|0;if((t|0)==(c[ad+16>>2]|0)){ae=da[c[(c[ad>>2]|0)+36>>2]&255](ad)|0}else{ae=c[t>>2]|0}if((ae|0)!=-1){break}c[u>>2]=0}}while(0);v=c[u>>2]|0;t=(v|0)==0;G=e|0;F=c[G>>2]|0;do{if((F|0)==0){w=4400}else{z=c[F+12>>2]|0;if((z|0)==(c[F+16>>2]|0)){af=da[c[(c[F>>2]|0)+36>>2]&255](F)|0}else{af=c[z>>2]|0}if((af|0)==-1){c[G>>2]=0;w=4400;break}if(!(t^(F|0)==0)){break}ag=a|0;c[ag>>2]=v;i=l;return}}while(0);do{if((w|0)==4400){if(t){break}ag=a|0;c[ag>>2]=v;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ag=a|0;c[ag>>2]=v;i=l;return}}while(0);l=cJ(4)|0;Aq(l);bQ(l|0,97088,288)}function wH(a){a=a|0;tb(a|0);AT(a);return}function wI(a){a=a|0;tb(a|0);return}function wJ(a){a=a|0;return 2}function wK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];wG(a,b,k,l,f,g,h,90424,90456);i=j;return}function wL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=da[c[(c[n>>2]|0)+20>>2]&255](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=a[o]|0;if((f&1)==0){p=o+4|0;q=o+4|0}else{e=c[o+8>>2]|0;p=e;q=e}e=f&255;if((e&1|0)==0){r=e>>>1}else{r=c[o+4>>2]|0}wG(b,d,l,m,g,h,j,q,p+(r<<2)|0);i=k;return}function wM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;n=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-n>>2>>>0>l>>>0){o=c[n+(l<<2)>>2]|0;if((o|0)==0){break}p=o;o=c[f>>2]|0;td(o)|0;o=c[e>>2]|0;q=b+8|0;r=da[c[c[q>>2]>>2]&255](q)|0;c[k>>2]=o;o=(vC(d,k,r,r+168|0,p,g,0)|0)-r|0;if((o|0)>=168){s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}c[h+24>>2]=((o|0)/12|0|0)%7|0;s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function wN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;t3(m,f);f=m|0;m=c[f>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;n=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-n>>2>>>0>l>>>0){o=c[n+(l<<2)>>2]|0;if((o|0)==0){break}p=o;o=c[f>>2]|0;td(o)|0;o=c[e>>2]|0;q=b+8|0;r=da[c[(c[q>>2]|0)+4>>2]&255](q)|0;c[k>>2]=o;o=(vC(d,k,r,r+288|0,p,g,0)|0)-r|0;if((o|0)>=288){s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}c[h+16>>2]=((o|0)/12|0|0)%12|0;s=4;t=0;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=j;return}}while(0);j=cJ(4)|0;Aq(j);bQ(j|0,97088,288)}function wO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;t3(l,f);f=l|0;l=c[f>>2]|0;if((c[218654]|0)!=-1){c[k>>2]=874616;c[k+4>>2]=36;c[k+8>>2]=0;tA(874616,k,144)}k=(c[218655]|0)-1|0;m=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-m>>2>>>0>k>>>0){n=c[m+(k<<2)>>2]|0;if((n|0)==0){break}o=n;n=c[f>>2]|0;td(n)|0;c[j>>2]=c[e>>2];n=wT(d,j,g,o,4)|0;if((c[g>>2]&4|0)!=0){p=4;q=0;r=d|0;s=c[r>>2]|0;t=a|0;c[t>>2]=s;i=b;return}if((n|0)<69){u=n+2e3|0}else{u=(n-69|0)>>>0<31>>>0?n+1900|0:n}c[h+20>>2]=u-1900;p=4;q=0;r=d|0;s=c[r>>2]|0;t=a|0;c[t>>2]=s;i=b;return}}while(0);b=cJ(4)|0;Aq(b);bQ(b|0,97088,288)}function wP(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+112|0;A=l+120|0;B=l+128|0;C=l+136|0;D=l+144|0;E=l+152|0;F=l+160|0;G=l+168|0;H=l+176|0;I=l+184|0;J=l+192|0;K=l+200|0;L=l+208|0;M=l+216|0;N=l+224|0;O=l+232|0;P=l+240|0;Q=l+248|0;R=l+256|0;S=l+264|0;T=l+272|0;U=l+280|0;V=l+288|0;W=l+296|0;X=l+304|0;Y=l+312|0;Z=l+320|0;c[h>>2]=0;t3(z,g);_=z|0;z=c[_>>2]|0;if((c[218654]|0)!=-1){c[y>>2]=874616;c[y+4>>2]=36;c[y+8>>2]=0;tA(874616,y,144)}y=(c[218655]|0)-1|0;$=c[z+8>>2]|0;do{if((c[z+12>>2]|0)-$>>2>>>0>y>>>0){aa=c[$+(y<<2)>>2]|0;if((aa|0)==0){break}ab=aa;aa=c[_>>2]|0;td(aa)|0;L5320:do{switch(k<<24>>24|0){case 83:{c[p>>2]=c[f>>2];aa=wT(e,p,h,ab,2)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(aa|0)<61){c[j>>2]=aa;break L5320}else{c[h>>2]=ac|4;break L5320}break};case 97:case 65:{ac=c[f>>2]|0;aa=d+8|0;ad=da[c[c[aa>>2]>>2]&255](aa)|0;c[x>>2]=ac;ac=(vC(e,x,ad,ad+168|0,ab,h,0)|0)-ad|0;if((ac|0)>=168){break L5320}c[j+24>>2]=((ac|0)/12|0|0)%7|0;break};case 73:{ac=j+8|0;c[t>>2]=c[f>>2];ad=wT(e,t,h,ab,2)|0;aa=c[h>>2]|0;do{if((aa&4|0)==0){if((ad-1|0)>>>0>=12>>>0){break}c[ac>>2]=ad;break L5320}}while(0);c[h>>2]=aa|4;break};case 88:{ad=d+8|0;ac=da[c[(c[ad>>2]|0)+24>>2]&255](ad)|0;ad=e|0;c[X>>2]=c[ad>>2];c[Y>>2]=c[f>>2];ae=a[ac]|0;if((ae&1)==0){af=ac+4|0;ag=ac+4|0}else{ah=c[ac+8>>2]|0;af=ah;ag=ah}ah=ae&255;if((ah&1|0)==0){ai=ah>>>1}else{ai=c[ac+4>>2]|0}wG(W,d,X,Y,g,h,j,ag,af+(ai<<2)|0);c[ad>>2]=c[W>>2];break};case 72:{c[u>>2]=c[f>>2];ad=wT(e,u,h,ab,2)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(ad|0)<24){c[j+8>>2]=ad;break L5320}else{c[h>>2]=ac|4;break L5320}break};case 106:{c[s>>2]=c[f>>2];ac=wT(e,s,h,ab,3)|0;ad=c[h>>2]|0;if((ad&4|0)==0&(ac|0)<366){c[j+28>>2]=ac;break L5320}else{c[h>>2]=ad|4;break L5320}break};case 68:{ad=e|0;c[E>>2]=c[ad>>2];c[F>>2]=c[f>>2];wG(D,d,E,F,g,h,j,90392,90424);c[ad>>2]=c[D>>2];break};case 120:{ad=c[(c[d>>2]|0)+20>>2]|0;c[U>>2]=c[e>>2];c[V>>2]=c[f>>2];db[ad&127](b,d,U,V,g,h,j);i=l;return};case 121:{c[n>>2]=c[f>>2];ad=wT(e,n,h,ab,4)|0;if((c[h>>2]&4|0)!=0){break L5320}if((ad|0)<69){aj=ad+2e3|0}else{aj=(ad-69|0)>>>0<31>>>0?ad+1900|0:ad}c[j+20>>2]=aj-1900;break};case 82:{ad=e|0;c[P>>2]=c[ad>>2];c[Q>>2]=c[f>>2];wG(O,d,P,Q,g,h,j,90320,90340);c[ad>>2]=c[O>>2];break};case 77:{c[q>>2]=c[f>>2];ad=wT(e,q,h,ab,2)|0;ac=c[h>>2]|0;if((ac&4|0)==0&(ad|0)<60){c[j+4>>2]=ad;break L5320}else{c[h>>2]=ac|4;break L5320}break};case 37:{c[Z>>2]=c[f>>2];wS(0,e,Z,h,ab);break};case 112:{c[K>>2]=c[f>>2];wR(d,j+8|0,e,K,h,ab);break};case 100:case 101:{ac=j+12|0;c[v>>2]=c[f>>2];ad=wT(e,v,h,ab,2)|0;ah=c[h>>2]|0;do{if((ah&4|0)==0){if((ad-1|0)>>>0>=31>>>0){break}c[ac>>2]=ad;break L5320}}while(0);c[h>>2]=ah|4;break};case 89:{c[m>>2]=c[f>>2];ad=wT(e,m,h,ab,4)|0;if((c[h>>2]&4|0)!=0){break L5320}c[j+20>>2]=ad-1900;break};case 114:{ad=e|0;c[M>>2]=c[ad>>2];c[N>>2]=c[f>>2];wG(L,d,M,N,g,h,j,90344,90388);c[ad>>2]=c[L>>2];break};case 99:{ad=d+8|0;ac=da[c[(c[ad>>2]|0)+12>>2]&255](ad)|0;ad=e|0;c[B>>2]=c[ad>>2];c[C>>2]=c[f>>2];aa=a[ac]|0;if((aa&1)==0){ak=ac+4|0;al=ac+4|0}else{ae=c[ac+8>>2]|0;ak=ae;al=ae}ae=aa&255;if((ae&1|0)==0){am=ae>>>1}else{am=c[ac+4>>2]|0}wG(A,d,B,C,g,h,j,al,ak+(am<<2)|0);c[ad>>2]=c[A>>2];break};case 70:{ad=e|0;c[H>>2]=c[ad>>2];c[I>>2]=c[f>>2];wG(G,d,H,I,g,h,j,90256,90288);c[ad>>2]=c[G>>2];break};case 84:{ad=e|0;c[S>>2]=c[ad>>2];c[T>>2]=c[f>>2];wG(R,d,S,T,g,h,j,90288,90320);c[ad>>2]=c[R>>2];break};case 98:case 66:case 104:{ad=c[f>>2]|0;ac=d+8|0;ae=da[c[(c[ac>>2]|0)+4>>2]&255](ac)|0;c[w>>2]=ad;ad=(vC(e,w,ae,ae+288|0,ab,h,0)|0)-ae|0;if((ad|0)>=288){break L5320}c[j+16>>2]=((ad|0)/12|0|0)%12|0;break};case 109:{c[r>>2]=c[f>>2];ad=wT(e,r,h,ab,2)|0;ae=c[h>>2]|0;if((ae&4|0)==0&(ad|0)<13){c[j+16>>2]=ad-1;break L5320}else{c[h>>2]=ae|4;break L5320}break};case 110:case 116:{c[J>>2]=c[f>>2];wQ(0,e,J,h,ab);break};case 119:{c[o>>2]=c[f>>2];ae=wT(e,o,h,ab,1)|0;ad=c[h>>2]|0;if((ad&4|0)==0&(ae|0)<7){c[j+24>>2]=ae;break L5320}else{c[h>>2]=ad|4;break L5320}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=cJ(4)|0;Aq(l);bQ(l|0,97088,288)}function wQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=d|0;d=f;L5401:while(1){h=c[g>>2]|0;do{if((h|0)==0){j=1}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){l=da[c[(c[h>>2]|0)+36>>2]&255](h)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[g>>2]=0;j=1;break}else{j=(c[g>>2]|0)==0;break}}}while(0);h=c[b>>2]|0;do{if((h|0)==0){m=4544}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){n=da[c[(c[h>>2]|0)+36>>2]&255](h)|0}else{n=c[k>>2]|0}if((n|0)==-1){c[b>>2]=0;m=4544;break}else{k=(h|0)==0;if(j^k){o=h;p=k;break}else{q=h;r=k;break L5401}}}}while(0);if((m|0)==4544){m=0;if(j){q=0;r=1;break}else{o=0;p=1}}h=c[g>>2]|0;k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){s=da[c[(c[h>>2]|0)+36>>2]&255](h)|0}else{s=c[k>>2]|0}if(!(c8[c[(c[d>>2]|0)+12>>2]&127](f,8192,s)|0)){q=o;r=p;break}k=c[g>>2]|0;h=k+12|0;t=c[h>>2]|0;if((t|0)==(c[k+16>>2]|0)){u=c[(c[k>>2]|0)+40>>2]|0;da[u&255](k)|0;continue}else{c[h>>2]=t+4;continue}}p=c[g>>2]|0;do{if((p|0)==0){v=1}else{o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0)){w=da[c[(c[p>>2]|0)+36>>2]&255](p)|0}else{w=c[o>>2]|0}if((w|0)==-1){c[g>>2]=0;v=1;break}else{v=(c[g>>2]|0)==0;break}}}while(0);do{if(r){m=4566}else{g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){x=da[c[(c[q>>2]|0)+36>>2]&255](q)|0}else{x=c[g>>2]|0}if((x|0)==-1){c[b>>2]=0;m=4566;break}if(!(v^(q|0)==0)){break}i=a;return}}while(0);do{if((m|0)==4566){if(v){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function wR(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=da[c[(c[l>>2]|0)+8>>2]&255](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=vC(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function wS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=da[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=4606}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=da[c[(c[d>>2]|0)+36>>2]&255](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=4606;break}else{b=(d|0)==0;if(h^b){n=d;o=b;break}else{l=4608;break}}}}while(0);if((l|0)==4606){if(h){l=4608}else{n=0;o=1}}if((l|0)==4608){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){p=da[c[(c[h>>2]|0)+36>>2]&255](h)|0}else{p=c[d>>2]|0}if((c8[c[(c[f>>2]|0)+52>>2]&127](f,p,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;i=a;return}p=c[g>>2]|0;f=p+12|0;d=c[f>>2]|0;if((d|0)==(c[p+16>>2]|0)){h=c[(c[p>>2]|0)+40>>2]|0;da[h&255](p)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){q=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){r=da[c[(c[d>>2]|0)+36>>2]&255](d)|0}else{r=c[f>>2]|0}if((r|0)==-1){c[g>>2]=0;q=1;break}else{q=(c[g>>2]|0)==0;break}}}while(0);do{if(o){l=4630}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){s=da[c[(c[n>>2]|0)+36>>2]&255](n)|0}else{s=c[g>>2]|0}if((s|0)==-1){c[k>>2]=0;l=4630;break}if(!(q^(n|0)==0)){break}i=a;return}}while(0);do{if((l|0)==4630){if(q){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function wT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=i;h=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[h>>2];h=a|0;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=da[c[(c[a>>2]|0)+36>>2]&255](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b|0;b=c[l>>2]|0;do{if((b|0)==0){m=4652}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=da[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=4652;break}else{if(j^(b|0)==0){o=b;break}else{m=4654;break}}}}while(0);if((m|0)==4652){if(j){m=4654}else{o=0}}if((m|0)==4654){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=da[c[(c[j>>2]|0)+36>>2]&255](j)|0}else{q=c[b>>2]|0}b=e;if(!(c8[c[(c[b>>2]|0)+12>>2]&127](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}j=e;n=(c8[c[(c[j>>2]|0)+52>>2]&127](e,q,0)|0)<<24>>24;q=c[h>>2]|0;a=q+12|0;k=c[a>>2]|0;if((k|0)==(c[q+16>>2]|0)){r=c[(c[q>>2]|0)+40>>2]|0;da[r&255](q)|0;s=n;t=f;u=o}else{c[a>>2]=k+4;s=n;t=f;u=o}while(1){v=s-48|0;o=t-1|0;f=c[h>>2]|0;do{if((f|0)==0){w=0}else{n=c[f+12>>2]|0;if((n|0)==(c[f+16>>2]|0)){x=da[c[(c[f>>2]|0)+36>>2]&255](f)|0}else{x=c[n>>2]|0}if((x|0)==-1){c[h>>2]=0;w=0;break}else{w=c[h>>2]|0;break}}}while(0);f=(w|0)==0;if((u|0)==0){y=w;z=0}else{n=c[u+12>>2]|0;if((n|0)==(c[u+16>>2]|0)){A=da[c[(c[u>>2]|0)+36>>2]&255](u)|0}else{A=c[n>>2]|0}if((A|0)==-1){c[l>>2]=0;B=0}else{B=u}y=c[h>>2]|0;z=B}C=(z|0)==0;if(!((f^C)&(o|0)>0)){break}f=c[y+12>>2]|0;if((f|0)==(c[y+16>>2]|0)){D=da[c[(c[y>>2]|0)+36>>2]&255](y)|0}else{D=c[f>>2]|0}if(!(c8[c[(c[b>>2]|0)+12>>2]&127](e,2048,D)|0)){p=v;m=4707;break}f=((c8[c[(c[j>>2]|0)+52>>2]&127](e,D,0)|0)<<24>>24)+(v*10|0)|0;n=c[h>>2]|0;k=n+12|0;a=c[k>>2]|0;if((a|0)==(c[n+16>>2]|0)){q=c[(c[n>>2]|0)+40>>2]|0;da[q&255](n)|0;s=f;t=o;u=z;continue}else{c[k>>2]=a+4;s=f;t=o;u=z;continue}}if((m|0)==4707){i=g;return p|0}do{if((y|0)==0){E=1}else{u=c[y+12>>2]|0;if((u|0)==(c[y+16>>2]|0)){F=da[c[(c[y>>2]|0)+36>>2]&255](y)|0}else{F=c[u>>2]|0}if((F|0)==-1){c[h>>2]=0;E=1;break}else{E=(c[h>>2]|0)==0;break}}}while(0);do{if(C){m=4698}else{h=c[z+12>>2]|0;if((h|0)==(c[z+16>>2]|0)){G=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{G=c[h>>2]|0}if((G|0)==-1){c[l>>2]=0;m=4698;break}if(E^(z|0)==0){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==4698){if(E){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function wU(b){b=b|0;var d=0,e=0,f=0,g=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);if((f|0)==(c[218270]|0)){g=b|0;tb(g);AT(d);return}bw(c[e>>2]|0);g=b|0;tb(g);AT(d);return}function wV(b){b=b|0;var d=0,e=0,f=0;d=b+8|0;e=c[d>>2]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);if((e|0)==(c[218270]|0)){f=b|0;tb(f);return}bw(c[d>>2]|0);f=b|0;tb(f);return}function wW(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;f=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[f>>2];f=g|0;l=g+8|0;m=l|0;n=f|0;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(k<<24>>24!=0){a[o]=k;a[p]=j}j=bN(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b|0;c[r>>2]=q;i=g;return}else{s=l;t=m}while(1){m=a[t]|0;if((s|0)==0){u=0}else{l=s+24|0;j=c[l>>2]|0;if((j|0)==(c[s+28>>2]|0)){v=c7[c[(c[s>>2]|0)+52>>2]&255](s,m&255)|0}else{c[l>>2]=j+1;a[j]=m;v=m&255}u=(v|0)==-1?0:s}m=t+1|0;if((m|0)==(d|0)){q=u;break}else{s=u;t=m}}r=b|0;c[r>>2]=q;i=g;return}function wX(b){b=b|0;var d=0,e=0,f=0,g=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);if((f|0)==(c[218270]|0)){g=b|0;tb(g);AT(d);return}bw(c[e>>2]|0);g=b|0;tb(g);AT(d);return}function wY(b){b=b|0;var d=0,e=0,f=0;d=b+8|0;e=c[d>>2]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);if((e|0)==(c[218270]|0)){f=b|0;tb(f);return}bw(c[d>>2]|0);f=b|0;tb(f);return}function wZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+408|0;e=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[e>>2];e=f|0;k=f+400|0;l=e|0;c[k>>2]=e+400;w_(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a|0;c[n>>2]=m;i=f;return}else{o=k;p=l}while(1){l=c[p>>2]|0;if((o|0)==0){q=0}else{k=o+24|0;d=c[k>>2]|0;if((d|0)==(c[o+28>>2]|0)){r=c7[c[(c[o>>2]|0)+52>>2]&255](o,l)|0}else{c[k>>2]=d+4;c[d>>2]=l;r=l}q=(r|0)==-1?0:o}l=p+4|0;if((l|0)==(j|0)){m=q;break}else{o=q;p=l}}n=a|0;c[n>>2]=m;i=f;return}function w_(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j|0;l=j+112|0;m=i;i=i+4|0;i=i+7&-8;n=j+8|0;o=k|0;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(h<<24>>24!=0){a[p]=h;a[q]=g}g=b|0;bN(n|0,100,o|0,f|0,c[g>>2]|0)|0;c[l>>2]=0;c[l+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=cm(c[g>>2]|0)|0;g=Ag(d,m,n,l)|0;if((f|0)!=0){cm(f|0)|0}if((g|0)==-1){xM(81992)}else{c[e>>2]=d+(g<<2);i=j;return}}function w$(a){a=a|0;tb(a|0);AT(a);return}function w0(a){a=a|0;tb(a|0);return}function w1(a){a=a|0;return 127}function w2(a){a=a|0;return 127}function w3(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function w4(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function w5(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function w6(a,b){a=a|0;b=b|0;tF(a,1,45);return}function w7(a){a=a|0;return 0}function w8(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function w9(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xa(a){a=a|0;tb(a|0);AT(a);return}function xb(a){a=a|0;tb(a|0);return}function xc(a){a=a|0;return 127}function xd(a){a=a|0;return 127}function xe(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xf(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xg(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xh(a,b){a=a|0;b=b|0;tF(a,1,45);return}function xi(a){a=a|0;return 0}function xj(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xk(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xl(a){a=a|0;tb(a|0);AT(a);return}function xm(a){a=a|0;tb(a|0);return}function xn(a){a=a|0;return 2147483647}function xo(a){a=a|0;return 2147483647}function xp(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xq(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xr(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xs(a,b){a=a|0;b=b|0;tU(a,1,45);return}function xt(a){a=a|0;return 0}function xu(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xv(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xw(a){a=a|0;tb(a|0);AT(a);return}function xx(a){a=a|0;tb(a|0);return}function xy(a){a=a|0;return 2147483647}function xz(a){a=a|0;return 2147483647}function xA(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xB(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xC(a,b){a=a|0;b=b|0;A2(a|0,0,12);return}function xD(a,b){a=a|0;b=b|0;tU(a,1,45);return}function xE(a){a=a|0;return 0}function xF(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xG(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C&255;C=C>>8;a[c+1|0]=C&255;C=C>>8;a[c+2|0]=C&255;C=C>>8;a[c+3|0]=C&255;return}function xH(a){a=a|0;tb(a|0);AT(a);return}function xI(a){a=a|0;tb(a|0);return}function xJ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+280|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=d+176|0;u=n|0;c[u>>2]=m;v=n+4|0;c[v>>2]=230;w=m+100|0;t3(p,h);m=p|0;x=c[m>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;y=c[x+8>>2]|0;do{if((c[x+12>>2]|0)-y>>2>>>0>l>>>0){z=c[y+(l<<2)>>2]|0;if((z|0)==0){break}A=z;a[q]=0;B=f|0;c[r>>2]=c[B>>2];do{if(xL(e,r,g,p,c[h+4>>2]|0,j,q,A,n,o,w)|0){C=s|0;D=c[(c[z>>2]|0)+32>>2]|0;di[D&63](A,90240,90250,C)|0;D=t|0;E=c[o>>2]|0;F=c[u>>2]|0;G=E-F|0;do{if((G|0)>98){H=AL(G+2|0)|0;if((H|0)!=0){I=H;J=H;break}AY();I=0;J=0}else{I=D;J=0}}while(0);if((a[q]&1)==0){K=I}else{a[I]=45;K=I+1|0}if(F>>>0<E>>>0){G=s+10|0;H=s;L=K;M=F;while(1){N=a[M]|0;O=C;while(1){P=O+1|0;if((a[O]|0)==N<<24>>24){Q=O;break}if((P|0)==(G|0)){Q=G;break}else{O=P}}a[L]=a[90240+(Q-H)|0]|0;O=M+1|0;N=L+1|0;if(O>>>0<(c[o>>2]|0)>>>0){L=N;M=O}else{R=N;break}}}else{R=K}a[R]=0;M=cp(D|0,88136,(L=i,i=i+8|0,c[L>>2]=k,L)|0)|0;i=L;if((M|0)==1){if((J|0)==0){break}AM(J);break}M=cJ(8)|0;tj(M,87672);bQ(M|0,97120,46)}}while(0);A=e|0;z=c[A>>2]|0;do{if((z|0)==0){S=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){S=z;break}if((da[c[(c[z>>2]|0)+36>>2]&255](z)|0)!=-1){S=z;break}c[A>>2]=0;S=0}}while(0);A=(S|0)==0;z=c[B>>2]|0;do{if((z|0)==0){T=4881}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(A){break}else{T=4883;break}}if((da[c[(c[z>>2]|0)+36>>2]&255](z)|0)==-1){c[B>>2]=0;T=4881;break}else{if(A^(z|0)==0){break}else{T=4883;break}}}}while(0);if((T|0)==4881){if(A){T=4883}}if((T|0)==4883){c[j>>2]=c[j>>2]|2}c[b>>2]=S;z=c[m>>2]|0;td(z)|0;z=c[u>>2]|0;c[u>>2]=0;if((z|0)==0){i=d;return}c4[c[v>>2]&511](z);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function xK(a){a=a|0;return}function xL(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0;q=i;i=i+440|0;r=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[r>>2];r=q|0;s=q+400|0;t=q+408|0;u=q+416|0;v=q+424|0;w=v;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=r|0;c[s>>2]=0;A2(w|0,0,12);E=x;F=y;G=z;H=A;A2(E|0,0,12);A2(F|0,0,12);A2(G|0,0,12);A2(H|0,0,12);xP(g,h,s,t,u,v,x,y,z,B);h=n|0;c[o>>2]=c[h>>2];g=e|0;e=f|0;f=s;s=m+8|0;m=z+1|0;I=z+4|0;J=z+8|0;K=y+1|0;L=y+4|0;M=y+8|0;N=(j&512|0)!=0;j=x+1|0;O=x+4|0;P=x+8|0;Q=A+1|0;R=A+4|0;S=A+8|0;T=f+3|0;U=v+4|0;V=n+4|0;n=p;p=230;W=D;X=D;D=r+400|0;r=0;Y=0;L5833:while(1){Z=c[g>>2]|0;do{if((Z|0)==0){_=0}else{if((c[Z+12>>2]|0)!=(c[Z+16>>2]|0)){_=Z;break}if((da[c[(c[Z>>2]|0)+36>>2]&255](Z)|0)==-1){c[g>>2]=0;_=0;break}else{_=c[g>>2]|0;break}}}while(0);Z=(_|0)==0;$=c[e>>2]|0;do{if(($|0)==0){aa=4909}else{if((c[$+12>>2]|0)!=(c[$+16>>2]|0)){if(Z){ab=$;break}else{ac=p;ad=W;ae=X;af=r;aa=5168;break L5833}}if((da[c[(c[$>>2]|0)+36>>2]&255]($)|0)==-1){c[e>>2]=0;aa=4909;break}else{if(Z){ab=$;break}else{ac=p;ad=W;ae=X;af=r;aa=5168;break L5833}}}}while(0);if((aa|0)==4909){aa=0;if(Z){ac=p;ad=W;ae=X;af=r;aa=5168;break}else{ab=0}}L5855:do{switch(a[f+Y|0]|0){case 3:{$=a[F]|0;ag=$&255;ah=(ag&1|0)==0?ag>>>1:c[L>>2]|0;ag=a[G]|0;ai=ag&255;aj=(ai&1|0)==0?ai>>>1:c[I>>2]|0;if((ah|0)==(-aj|0)){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L5855}ai=(ah|0)==0;ah=c[g>>2]|0;aq=c[ah+12>>2]|0;ar=c[ah+16>>2]|0;as=(aq|0)==(ar|0);if(!(ai|(aj|0)==0)){if(as){aj=(da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0)&255;at=c[g>>2]|0;au=aj;av=a[F]|0;aw=at;ax=c[at+12>>2]|0;ay=c[at+16>>2]|0}else{au=a[aq]|0;av=$;aw=ah;ax=aq;ay=ar}ar=aw+12|0;at=(ax|0)==(ay|0);if(au<<24>>24==(a[(av&1)==0?K:c[M>>2]|0]|0)){if(at){aj=c[(c[aw>>2]|0)+40>>2]|0;da[aj&255](aw)|0}else{c[ar>>2]=ax+1}ar=d[F]|0;ak=((ar&1|0)==0?ar>>>1:c[L>>2]|0)>>>0>1>>>0?y:r;al=D;am=X;an=W;ao=p;ap=n;break L5855}if(at){az=(da[c[(c[aw>>2]|0)+36>>2]&255](aw)|0)&255}else{az=a[ax]|0}if(az<<24>>24!=(a[(a[G]&1)==0?m:c[J>>2]|0]|0)){aa=5004;break L5833}at=c[g>>2]|0;ar=at+12|0;aj=c[ar>>2]|0;if((aj|0)==(c[at+16>>2]|0)){aA=c[(c[at>>2]|0)+40>>2]|0;da[aA&255](at)|0}else{c[ar>>2]=aj+1}a[l]=1;aj=d[G]|0;ak=((aj&1|0)==0?aj>>>1:c[I>>2]|0)>>>0>1>>>0?z:r;al=D;am=X;an=W;ao=p;ap=n;break L5855}if(ai){if(as){ai=(da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0)&255;aB=ai;aC=a[G]|0}else{aB=a[aq]|0;aC=ag}if(aB<<24>>24!=(a[(aC&1)==0?m:c[J>>2]|0]|0)){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L5855}ag=c[g>>2]|0;ai=ag+12|0;aj=c[ai>>2]|0;if((aj|0)==(c[ag+16>>2]|0)){ar=c[(c[ag>>2]|0)+40>>2]|0;da[ar&255](ag)|0}else{c[ai>>2]=aj+1}a[l]=1;aj=d[G]|0;ak=((aj&1|0)==0?aj>>>1:c[I>>2]|0)>>>0>1>>>0?z:r;al=D;am=X;an=W;ao=p;ap=n;break L5855}if(as){as=(da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0)&255;aD=as;aE=a[F]|0}else{aD=a[aq]|0;aE=$}if(aD<<24>>24!=(a[(aE&1)==0?K:c[M>>2]|0]|0)){a[l]=1;ak=r;al=D;am=X;an=W;ao=p;ap=n;break L5855}$=c[g>>2]|0;aq=$+12|0;as=c[aq>>2]|0;if((as|0)==(c[$+16>>2]|0)){ah=c[(c[$>>2]|0)+40>>2]|0;da[ah&255]($)|0}else{c[aq>>2]=as+1}as=d[F]|0;ak=((as&1|0)==0?as>>>1:c[L>>2]|0)>>>0>1>>>0?y:r;al=D;am=X;an=W;ao=p;ap=n;break};case 0:{aa=4937;break};case 1:{if((Y|0)==3){ac=p;ad=W;ae=X;af=r;aa=5168;break L5833}as=c[g>>2]|0;aq=c[as+12>>2]|0;if((aq|0)==(c[as+16>>2]|0)){aF=(da[c[(c[as>>2]|0)+36>>2]&255](as)|0)&255}else{aF=a[aq]|0}aq=aF<<24>>24;if((b9(aq|0)|0)==0){aa=4936;break L5833}if((b[(c[s>>2]|0)+(aq<<1)>>1]&8192)==0){aa=4936;break L5833}aq=c[g>>2]|0;as=aq+12|0;$=c[as>>2]|0;if(($|0)==(c[aq+16>>2]|0)){aG=(da[c[(c[aq>>2]|0)+40>>2]&255](aq)|0)&255}else{c[as>>2]=$+1;aG=a[$]|0}tN(A,aG);aa=4937;break};case 2:{if(!((r|0)!=0|Y>>>0<2>>>0)){if((Y|0)==2){aH=(a[T]|0)!=0}else{aH=0}if(!(N|aH)){ak=0;al=D;am=X;an=W;ao=p;ap=n;break L5855}}$=a[E]|0;as=c[P>>2]|0;aq=($&1)==0?j:as;L5930:do{if((Y|0)==0){aI=aq;aJ=$;aK=as}else{if((d[f+(Y-1)|0]|0)>>>0>=2>>>0){aI=aq;aJ=$;aK=as;break}ah=$&255;L5933:do{if((((ah&1|0)==0?ah>>>1:c[O>>2]|0)|0)==0){aL=aq;aM=$;aN=as}else{aj=aq;while(1){ai=a[aj]|0;if((b9(ai|0)|0)==0){break}if((b[(c[s>>2]|0)+(ai<<1)>>1]&8192)==0){break}ai=aj+1|0;ag=a[E]|0;ar=c[P>>2]|0;at=ag&255;if((ai|0)==(((ag&1)==0?j:ar)+((at&1|0)==0?at>>>1:c[O>>2]|0)|0)){aL=ai;aM=ag;aN=ar;break L5933}else{aj=ai}}aL=aj;aM=a[E]|0;aN=c[P>>2]|0}}while(0);ah=(aM&1)==0?j:aN;ai=aL-ah|0;ar=a[H]|0;ag=ar&255;at=(ag&1|0)==0?ag>>>1:c[R>>2]|0;if(ai>>>0>at>>>0){aI=ah;aJ=aM;aK=aN;break}ag=(ar&1)==0?Q:c[S>>2]|0;ar=ag+at|0;if((aL|0)==(ah|0)){aI=aL;aJ=aM;aK=aN;break}aA=ag+(at-ai)|0;ai=ah;while(1){if((a[aA]|0)!=(a[ai]|0)){aI=ah;aJ=aM;aK=aN;break L5930}at=aA+1|0;if((at|0)==(ar|0)){aI=aL;aJ=aM;aK=aN;break}else{aA=at;ai=ai+1|0}}}}while(0);aq=aJ&255;L5947:do{if((aI|0)==(((aJ&1)==0?j:aK)+((aq&1|0)==0?aq>>>1:c[O>>2]|0)|0)){aO=aI}else{as=ab;$=aI;while(1){ai=c[g>>2]|0;do{if((ai|0)==0){aP=0}else{if((c[ai+12>>2]|0)!=(c[ai+16>>2]|0)){aP=ai;break}if((da[c[(c[ai>>2]|0)+36>>2]&255](ai)|0)==-1){c[g>>2]=0;aP=0;break}else{aP=c[g>>2]|0;break}}}while(0);ai=(aP|0)==0;do{if((as|0)==0){aa=5035}else{if((c[as+12>>2]|0)!=(c[as+16>>2]|0)){if(ai){aQ=as;break}else{aO=$;break L5947}}if((da[c[(c[as>>2]|0)+36>>2]&255](as)|0)==-1){c[e>>2]=0;aa=5035;break}else{if(ai){aQ=as;break}else{aO=$;break L5947}}}}while(0);if((aa|0)==5035){aa=0;if(ai){aO=$;break L5947}else{aQ=0}}aj=c[g>>2]|0;aA=c[aj+12>>2]|0;if((aA|0)==(c[aj+16>>2]|0)){aR=(da[c[(c[aj>>2]|0)+36>>2]&255](aj)|0)&255}else{aR=a[aA]|0}if(aR<<24>>24!=(a[$]|0)){aO=$;break L5947}aA=c[g>>2]|0;aj=aA+12|0;ar=c[aj>>2]|0;if((ar|0)==(c[aA+16>>2]|0)){ah=c[(c[aA>>2]|0)+40>>2]|0;da[ah&255](aA)|0}else{c[aj>>2]=ar+1}ar=$+1|0;aj=a[E]|0;aA=aj&255;if((ar|0)==(((aj&1)==0?j:c[P>>2]|0)+((aA&1|0)==0?aA>>>1:c[O>>2]|0)|0)){aO=ar;break}else{as=aQ;$=ar}}}}while(0);if(!N){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L5855}aq=a[E]|0;$=aq&255;if((aO|0)==(((aq&1)==0?j:c[P>>2]|0)+(($&1|0)==0?$>>>1:c[O>>2]|0)|0)){ak=r;al=D;am=X;an=W;ao=p;ap=n}else{aa=5048;break L5833}break};case 4:{$=0;aq=D;as=X;ar=W;aA=p;aj=n;L5982:while(1){ah=c[g>>2]|0;do{if((ah|0)==0){aS=0}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){aS=ah;break}if((da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0)==-1){c[g>>2]=0;aS=0;break}else{aS=c[g>>2]|0;break}}}while(0);ah=(aS|0)==0;at=c[e>>2]|0;do{if((at|0)==0){aa=5061}else{if((c[at+12>>2]|0)!=(c[at+16>>2]|0)){if(ah){break}else{break L5982}}if((da[c[(c[at>>2]|0)+36>>2]&255](at)|0)==-1){c[e>>2]=0;aa=5061;break}else{if(ah){break}else{break L5982}}}}while(0);if((aa|0)==5061){aa=0;if(ah){break}}at=c[g>>2]|0;ag=c[at+12>>2]|0;if((ag|0)==(c[at+16>>2]|0)){aT=(da[c[(c[at>>2]|0)+36>>2]&255](at)|0)&255}else{aT=a[ag]|0}ag=aT<<24>>24;do{if((b9(ag|0)|0)==0){aa=5081}else{if((b[(c[s>>2]|0)+(ag<<1)>>1]&2048)==0){aa=5081;break}at=c[o>>2]|0;if((at|0)==(aj|0)){aU=(c[V>>2]|0)!=230;aV=c[h>>2]|0;aW=aj-aV|0;aX=aW>>>0<2147483647>>>0?aW<<1:-1;aY=AO(aU?aV:0,aX)|0;if((aY|0)==0){AY()}do{if(aU){c[h>>2]=aY;aZ=aY}else{aV=c[h>>2]|0;c[h>>2]=aY;if((aV|0)==0){aZ=aY;break}c4[c[V>>2]&511](aV);aZ=c[h>>2]|0}}while(0);c[V>>2]=122;aY=aZ+aW|0;c[o>>2]=aY;a_=(c[h>>2]|0)+aX|0;a$=aY}else{a_=aj;a$=at}c[o>>2]=a$+1;a[a$]=aT;a0=$+1|0;a1=aq;a2=as;a3=ar;a4=aA;a5=a_}}while(0);if((aa|0)==5081){aa=0;ag=d[w]|0;if((((ag&1|0)==0?ag>>>1:c[U>>2]|0)|0)==0|($|0)==0){break}if(aT<<24>>24!=(a[u]|0)){break}if((as|0)==(aq|0)){ag=as-ar|0;ah=ag>>>0<2147483647>>>0?ag<<1:-1;if((aA|0)==230){a6=0}else{a6=ar}aY=AO(a6,ah)|0;aU=aY;if((aY|0)==0){AY()}a7=aU+(ah>>>2<<2)|0;a8=aU+(ag>>2<<2)|0;a9=aU;ba=122}else{a7=aq;a8=as;a9=ar;ba=aA}c[a8>>2]=$;a0=0;a1=a7;a2=a8+4|0;a3=a9;a4=ba;a5=aj}aU=c[g>>2]|0;ag=aU+12|0;ah=c[ag>>2]|0;if((ah|0)==(c[aU+16>>2]|0)){aY=c[(c[aU>>2]|0)+40>>2]|0;da[aY&255](aU)|0;$=a0;aq=a1;as=a2;ar=a3;aA=a4;aj=a5;continue}else{c[ag>>2]=ah+1;$=a0;aq=a1;as=a2;ar=a3;aA=a4;aj=a5;continue}}if((ar|0)==(as|0)|($|0)==0){bb=aq;bc=as;bd=ar;be=aA}else{if((as|0)==(aq|0)){ah=as-ar|0;ag=ah>>>0<2147483647>>>0?ah<<1:-1;if((aA|0)==230){bf=0}else{bf=ar}aU=AO(bf,ag)|0;aY=aU;if((aU|0)==0){AY()}bg=aY+(ag>>>2<<2)|0;bh=aY+(ah>>2<<2)|0;bi=aY;bj=122}else{bg=aq;bh=as;bi=ar;bj=aA}c[bh>>2]=$;bb=bg;bc=bh+4|0;bd=bi;be=bj}if((c[B>>2]|0)>0){aY=c[g>>2]|0;do{if((aY|0)==0){bk=0}else{if((c[aY+12>>2]|0)!=(c[aY+16>>2]|0)){bk=aY;break}if((da[c[(c[aY>>2]|0)+36>>2]&255](aY)|0)==-1){c[g>>2]=0;bk=0;break}else{bk=c[g>>2]|0;break}}}while(0);aY=(bk|0)==0;$=c[e>>2]|0;do{if(($|0)==0){aa=5114}else{if((c[$+12>>2]|0)!=(c[$+16>>2]|0)){if(aY){bl=$;break}else{aa=5121;break L5833}}if((da[c[(c[$>>2]|0)+36>>2]&255]($)|0)==-1){c[e>>2]=0;aa=5114;break}else{if(aY){bl=$;break}else{aa=5121;break L5833}}}}while(0);if((aa|0)==5114){aa=0;if(aY){aa=5121;break L5833}else{bl=0}}$=c[g>>2]|0;aA=c[$+12>>2]|0;if((aA|0)==(c[$+16>>2]|0)){bm=(da[c[(c[$>>2]|0)+36>>2]&255]($)|0)&255}else{bm=a[aA]|0}if(bm<<24>>24!=(a[t]|0)){aa=5121;break L5833}aA=c[g>>2]|0;$=aA+12|0;ar=c[$>>2]|0;if((ar|0)==(c[aA+16>>2]|0)){as=c[(c[aA>>2]|0)+40>>2]|0;da[as&255](aA)|0;bn=aj;bo=bl}else{c[$>>2]=ar+1;bn=aj;bo=bl}while(1){ar=c[g>>2]|0;do{if((ar|0)==0){bp=0}else{if((c[ar+12>>2]|0)!=(c[ar+16>>2]|0)){bp=ar;break}if((da[c[(c[ar>>2]|0)+36>>2]&255](ar)|0)==-1){c[g>>2]=0;bp=0;break}else{bp=c[g>>2]|0;break}}}while(0);ar=(bp|0)==0;do{if((bo|0)==0){aa=5137}else{if((c[bo+12>>2]|0)!=(c[bo+16>>2]|0)){if(ar){bq=bo;break}else{aa=5146;break L5833}}if((da[c[(c[bo>>2]|0)+36>>2]&255](bo)|0)==-1){c[e>>2]=0;aa=5137;break}else{if(ar){bq=bo;break}else{aa=5146;break L5833}}}}while(0);if((aa|0)==5137){aa=0;if(ar){aa=5146;break L5833}else{bq=0}}$=c[g>>2]|0;aA=c[$+12>>2]|0;if((aA|0)==(c[$+16>>2]|0)){br=(da[c[(c[$>>2]|0)+36>>2]&255]($)|0)&255}else{br=a[aA]|0}aA=br<<24>>24;if((b9(aA|0)|0)==0){aa=5146;break L5833}if((b[(c[s>>2]|0)+(aA<<1)>>1]&2048)==0){aa=5146;break L5833}aA=c[o>>2]|0;if((aA|0)==(bn|0)){$=(c[V>>2]|0)!=230;as=c[h>>2]|0;aq=bn-as|0;ah=aq>>>0<2147483647>>>0?aq<<1:-1;ag=AO($?as:0,ah)|0;if((ag|0)==0){AY()}do{if($){c[h>>2]=ag;bs=ag}else{as=c[h>>2]|0;c[h>>2]=ag;if((as|0)==0){bs=ag;break}c4[c[V>>2]&511](as);bs=c[h>>2]|0}}while(0);c[V>>2]=122;ag=bs+aq|0;c[o>>2]=ag;bt=(c[h>>2]|0)+ah|0;bu=ag}else{bt=bn;bu=aA}ag=c[g>>2]|0;$=c[ag+12>>2]|0;if(($|0)==(c[ag+16>>2]|0)){ar=(da[c[(c[ag>>2]|0)+36>>2]&255](ag)|0)&255;bv=ar;bw=c[o>>2]|0}else{bv=a[$]|0;bw=bu}c[o>>2]=bw+1;a[bw]=bv;$=(c[B>>2]|0)-1|0;c[B>>2]=$;ar=c[g>>2]|0;ag=ar+12|0;as=c[ag>>2]|0;if((as|0)==(c[ar+16>>2]|0)){aU=c[(c[ar>>2]|0)+40>>2]|0;da[aU&255](ar)|0}else{c[ag>>2]=as+1}if(($|0)>0){bn=bt;bo=bq}else{bx=bt;break}}}else{bx=aj}if((c[o>>2]|0)==(c[h>>2]|0)){aa=5166;break L5833}else{ak=r;al=bb;am=bc;an=bd;ao=be;ap=bx}break};default:{ak=r;al=D;am=X;an=W;ao=p;ap=n}}}while(0);L6138:do{if((aa|0)==4937){aa=0;if((Y|0)==3){ac=p;ad=W;ae=X;af=r;aa=5168;break L5833}else{by=ab}while(1){Z=c[g>>2]|0;do{if((Z|0)==0){bz=0}else{if((c[Z+12>>2]|0)!=(c[Z+16>>2]|0)){bz=Z;break}if((da[c[(c[Z>>2]|0)+36>>2]&255](Z)|0)==-1){c[g>>2]=0;bz=0;break}else{bz=c[g>>2]|0;break}}}while(0);Z=(bz|0)==0;do{if((by|0)==0){aa=4950}else{if((c[by+12>>2]|0)!=(c[by+16>>2]|0)){if(Z){bA=by;break}else{ak=r;al=D;am=X;an=W;ao=p;ap=n;break L6138}}if((da[c[(c[by>>2]|0)+36>>2]&255](by)|0)==-1){c[e>>2]=0;aa=4950;break}else{if(Z){bA=by;break}else{ak=r;al=D;am=X;an=W;ao=p;ap=n;break L6138}}}}while(0);if((aa|0)==4950){aa=0;if(Z){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L6138}else{bA=0}}aA=c[g>>2]|0;ah=c[aA+12>>2]|0;if((ah|0)==(c[aA+16>>2]|0)){bB=(da[c[(c[aA>>2]|0)+36>>2]&255](aA)|0)&255}else{bB=a[ah]|0}ah=bB<<24>>24;if((b9(ah|0)|0)==0){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L6138}if((b[(c[s>>2]|0)+(ah<<1)>>1]&8192)==0){ak=r;al=D;am=X;an=W;ao=p;ap=n;break L6138}ah=c[g>>2]|0;aA=ah+12|0;aq=c[aA>>2]|0;if((aq|0)==(c[ah+16>>2]|0)){bC=(da[c[(c[ah>>2]|0)+40>>2]&255](ah)|0)&255}else{c[aA>>2]=aq+1;bC=a[aq]|0}tN(A,bC);by=bA}}}while(0);aj=Y+1|0;if(aj>>>0<4>>>0){n=ap;p=ao;W=an;X=am;D=al;r=ak;Y=aj}else{ac=ao;ad=an;ae=am;af=ak;aa=5168;break}}L6176:do{if((aa|0)==4936){c[k>>2]=c[k>>2]|4;bD=0;bE=W;bF=p}else if((aa|0)==5004){c[k>>2]=c[k>>2]|4;bD=0;bE=W;bF=p}else if((aa|0)==5048){c[k>>2]=c[k>>2]|4;bD=0;bE=W;bF=p}else if((aa|0)==5121){c[k>>2]=c[k>>2]|4;bD=0;bE=bd;bF=be}else if((aa|0)==5146){c[k>>2]=c[k>>2]|4;bD=0;bE=bd;bF=be}else if((aa|0)==5166){c[k>>2]=c[k>>2]|4;bD=0;bE=bd;bF=be}else if((aa|0)==5168){L6184:do{if((af|0)!=0){ak=af;am=af+1|0;an=af+8|0;ao=af+4|0;Y=1;L6186:while(1){r=d[ak]|0;if((r&1|0)==0){bG=r>>>1}else{bG=c[ao>>2]|0}if(Y>>>0>=bG>>>0){break L6184}r=c[g>>2]|0;do{if((r|0)==0){bH=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){bH=r;break}if((da[c[(c[r>>2]|0)+36>>2]&255](r)|0)==-1){c[g>>2]=0;bH=0;break}else{bH=c[g>>2]|0;break}}}while(0);r=(bH|0)==0;Z=c[e>>2]|0;do{if((Z|0)==0){aa=5186}else{if((c[Z+12>>2]|0)!=(c[Z+16>>2]|0)){if(r){break}else{break L6186}}if((da[c[(c[Z>>2]|0)+36>>2]&255](Z)|0)==-1){c[e>>2]=0;aa=5186;break}else{if(r){break}else{break L6186}}}}while(0);if((aa|0)==5186){aa=0;if(r){break}}Z=c[g>>2]|0;al=c[Z+12>>2]|0;if((al|0)==(c[Z+16>>2]|0)){bI=(da[c[(c[Z>>2]|0)+36>>2]&255](Z)|0)&255}else{bI=a[al]|0}if((a[ak]&1)==0){bJ=am}else{bJ=c[an>>2]|0}if(bI<<24>>24!=(a[bJ+Y|0]|0)){break}al=Y+1|0;Z=c[g>>2]|0;D=Z+12|0;X=c[D>>2]|0;if((X|0)==(c[Z+16>>2]|0)){ap=c[(c[Z>>2]|0)+40>>2]|0;da[ap&255](Z)|0;Y=al;continue}else{c[D>>2]=X+1;Y=al;continue}}c[k>>2]=c[k>>2]|4;bD=0;bE=ad;bF=ac;break L6176}}while(0);if((ad|0)==(ae|0)){bD=1;bE=ae;bF=ac;break}c[C>>2]=0;xQ(v,ad,ae,C);if((c[C>>2]|0)==0){bD=1;bE=ad;bF=ac;break}c[k>>2]=c[k>>2]|4;bD=0;bE=ad;bF=ac}}while(0);tH(A);tH(z);tH(y);tH(x);tH(v);if((bE|0)==0){i=q;return bD|0}c4[bF&511](bE);i=q;return bD|0}function xM(a){a=a|0;var b=0;b=cJ(8)|0;tj(b,a);bQ(b|0,97120,46)}function xN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+160|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=n|0;c[s>>2]=m;t=n+4|0;c[t>>2]=230;u=m+100|0;t3(p,h);m=p|0;v=c[m>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;w=c[v+8>>2]|0;do{if((c[v+12>>2]|0)-w>>2>>>0>l>>>0){x=c[w+(l<<2)>>2]|0;if((x|0)==0){break}y=x;a[q]=0;z=f|0;A=c[z>>2]|0;c[r>>2]=A;if(xL(e,r,g,p,c[h+4>>2]|0,j,q,y,n,o,u)|0){B=k;if((a[B]&1)==0){a[k+1|0]=0;a[B]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}B=x;if((a[q]&1)!=0){tN(k,c7[c[(c[B>>2]|0)+28>>2]&255](y,45)|0)}x=c7[c[(c[B>>2]|0)+28>>2]&255](y,48)|0;y=c[s>>2]|0;B=c[o>>2]|0;C=B-1|0;L6256:do{if(y>>>0<C>>>0){D=y;while(1){E=D+1|0;if((a[D]|0)!=x<<24>>24){F=D;break L6256}if(E>>>0<C>>>0){D=E}else{F=E;break}}}else{F=y}}while(0);xO(k,F,B)|0}y=e|0;C=c[y>>2]|0;do{if((C|0)==0){G=0}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){G=C;break}if((da[c[(c[C>>2]|0)+36>>2]&255](C)|0)!=-1){G=C;break}c[y>>2]=0;G=0}}while(0);y=(G|0)==0;do{if((A|0)==0){H=5244}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){if(y){break}else{H=5246;break}}if((da[c[(c[A>>2]|0)+36>>2]&255](A)|0)==-1){c[z>>2]=0;H=5244;break}else{if(y^(A|0)==0){break}else{H=5246;break}}}}while(0);if((H|0)==5244){if(y){H=5246}}if((H|0)==5246){c[j>>2]=c[j>>2]|2}c[b>>2]=G;A=c[m>>2]|0;td(A)|0;A=c[s>>2]|0;c[s>>2]=0;if((A|0)==0){i=d;return}c4[c[t>>2]&511](A);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function xO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=10;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g|0;if((e|0)==(d|0)){return b|0}if((k-j|0)>>>0<h>>>0){tQ(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;l=g+1|0;if((l|0)==(e|0)){break}else{g=l;d=d+1|0}}a[n+m|0]=0;m=j+h|0;if((a[f]&1)==0){a[f]=m<<1&255;return b|0}else{c[b+4>>2]=m;return b|0}return 0}function xP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=A;D=i;i=i+12|0;i=i+7&-8;E=D;F=i;i=i+12|0;i=i+7&-8;G=F;H=i;i=i+12|0;i=i+7&-8;I=H;if(b){b=c[d>>2]|0;if((c[218774]|0)!=-1){c[p>>2]=875096;c[p+4>>2]=36;c[p+8>>2]=0;tA(875096,p,144)}p=(c[218775]|0)-1|0;J=c[b+8>>2]|0;if((c[b+12>>2]|0)-J>>2>>>0<=p>>>0){K=cJ(4)|0;L=K;Aq(L);bQ(K|0,97088,288)}b=c[J+(p<<2)>>2]|0;if((b|0)==0){K=cJ(4)|0;L=K;Aq(L);bQ(K|0,97088,288)}K=b;c5[c[(c[b>>2]|0)+44>>2]&255](q,K);L=e;C=c[q>>2]|0;a[L]=C&255;C=C>>8;a[L+1|0]=C&255;C=C>>8;a[L+2|0]=C&255;C=C>>8;a[L+3|0]=C&255;L=b;c5[c[(c[L>>2]|0)+32>>2]&255](r,K);q=l;if((a[q]&1)==0){a[l+1|0]=0;a[q]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];A2(s|0,0,12);tH(r);c5[c[(c[L>>2]|0)+28>>2]&255](t,K);r=k;if((a[r]&1)==0){a[k+1|0]=0;a[r]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}tM(k,0);c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];A2(u|0,0,12);tH(t);t=b;a[f]=da[c[(c[t>>2]|0)+12>>2]&255](K)|0;a[g]=da[c[(c[t>>2]|0)+16>>2]&255](K)|0;c5[c[(c[L>>2]|0)+20>>2]&255](v,K);t=h;if((a[t]&1)==0){a[h+1|0]=0;a[t]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}tM(h,0);c[t>>2]=c[w>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];A2(w|0,0,12);tH(v);c5[c[(c[L>>2]|0)+24>>2]&255](x,K);L=j;if((a[L]&1)==0){a[j+1|0]=0;a[L]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[L>>2]=c[y>>2];c[L+4>>2]=c[y+4>>2];c[L+8>>2]=c[y+8>>2];A2(y|0,0,12);tH(x);M=da[c[(c[b>>2]|0)+36>>2]&255](K)|0;c[m>>2]=M;i=n;return}else{K=c[d>>2]|0;if((c[218776]|0)!=-1){c[o>>2]=875104;c[o+4>>2]=36;c[o+8>>2]=0;tA(875104,o,144)}o=(c[218777]|0)-1|0;d=c[K+8>>2]|0;if((c[K+12>>2]|0)-d>>2>>>0<=o>>>0){N=cJ(4)|0;O=N;Aq(O);bQ(N|0,97088,288)}K=c[d+(o<<2)>>2]|0;if((K|0)==0){N=cJ(4)|0;O=N;Aq(O);bQ(N|0,97088,288)}N=K;c5[c[(c[K>>2]|0)+44>>2]&255](z,N);O=e;C=c[z>>2]|0;a[O]=C&255;C=C>>8;a[O+1|0]=C&255;C=C>>8;a[O+2|0]=C&255;C=C>>8;a[O+3|0]=C&255;O=K;c5[c[(c[O>>2]|0)+32>>2]&255](A,N);z=l;if((a[z]&1)==0){a[l+1|0]=0;a[z]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];A2(B|0,0,12);tH(A);c5[c[(c[O>>2]|0)+28>>2]&255](D,N);A=k;if((a[A]&1)==0){a[k+1|0]=0;a[A]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}tM(k,0);c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];A2(E|0,0,12);tH(D);D=K;a[f]=da[c[(c[D>>2]|0)+12>>2]&255](N)|0;a[g]=da[c[(c[D>>2]|0)+16>>2]&255](N)|0;c5[c[(c[O>>2]|0)+20>>2]&255](F,N);D=h;if((a[D]&1)==0){a[h+1|0]=0;a[D]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}tM(h,0);c[D>>2]=c[G>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];A2(G|0,0,12);tH(F);c5[c[(c[O>>2]|0)+24>>2]&255](H,N);O=j;if((a[O]&1)==0){a[j+1|0]=0;a[O]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[O>>2]=c[I>>2];c[O+4>>2]=c[I+4>>2];c[O+8>>2]=c[I+8>>2];A2(I|0,0,12);tH(H);M=da[c[(c[K>>2]|0)+36>>2]&255](N)|0;c[m>>2]=M;i=n;return}}function xQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=b;h=b;i=a[h]|0;j=i&255;if((j&1|0)==0){k=j>>>1}else{k=c[b+4>>2]|0}if((k|0)==0){return}do{if((d|0)==(e|0)){l=i}else{k=e-4|0;if(k>>>0>d>>>0){m=d;n=k}else{l=i;break}do{k=c[m>>2]|0;c[m>>2]=c[n>>2];c[n>>2]=k;m=m+4|0;n=n-4|0;}while(m>>>0<n>>>0);l=a[h]|0}}while(0);if((l&1)==0){o=g+1|0}else{o=c[b+8>>2]|0}g=l&255;if((g&1|0)==0){p=g>>>1}else{p=c[b+4>>2]|0}b=e-4|0;e=a[o]|0;g=e<<24>>24;l=e<<24>>24<1|e<<24>>24==127;L6400:do{if(b>>>0>d>>>0){e=o+p|0;h=o;n=d;m=g;i=l;while(1){if(!i){if((m|0)!=(c[n>>2]|0)){break}}k=(e-h|0)>1?h+1|0:h;j=n+4|0;q=a[k]|0;r=q<<24>>24;s=q<<24>>24<1|q<<24>>24==127;if(j>>>0<b>>>0){h=k;n=j;m=r;i=s}else{t=r;u=s;break L6400}}c[f>>2]=4;return}else{t=g;u=l}}while(0);if(u){return}u=c[b>>2]|0;if(!(t>>>0<u>>>0|(u|0)==0)){return}c[f>>2]=4;return}function xR(a){a=a|0;tb(a|0);AT(a);return}function xS(a){a=a|0;tb(a|0);return}function xT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+600|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=d+496|0;u=n|0;c[u>>2]=m;v=n+4|0;c[v>>2]=230;w=m+400|0;t3(p,h);m=p|0;x=c[m>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;y=c[x+8>>2]|0;do{if((c[x+12>>2]|0)-y>>2>>>0>l>>>0){z=c[y+(l<<2)>>2]|0;if((z|0)==0){break}A=z;a[q]=0;B=f|0;c[r>>2]=c[B>>2];do{if(xU(e,r,g,p,c[h+4>>2]|0,j,q,A,n,o,w)|0){C=s|0;D=c[(c[z>>2]|0)+48>>2]|0;di[D&63](A,90224,90234,C)|0;D=t|0;E=c[o>>2]|0;F=c[u>>2]|0;G=E-F|0;do{if((G|0)>392){H=AL((G>>2)+2|0)|0;if((H|0)!=0){I=H;J=H;break}AY();I=0;J=0}else{I=D;J=0}}while(0);if((a[q]&1)==0){K=I}else{a[I]=45;K=I+1|0}if(F>>>0<E>>>0){G=s+40|0;H=s;L=K;M=F;while(1){N=c[M>>2]|0;O=C;while(1){P=O+4|0;if((c[O>>2]|0)==(N|0)){Q=O;break}if((P|0)==(G|0)){Q=G;break}else{O=P}}a[L]=a[90224+(Q-H>>2)|0]|0;O=M+4|0;N=L+1|0;if(O>>>0<(c[o>>2]|0)>>>0){L=N;M=O}else{R=N;break}}}else{R=K}a[R]=0;M=cp(D|0,88136,(L=i,i=i+8|0,c[L>>2]=k,L)|0)|0;i=L;if((M|0)==1){if((J|0)==0){break}AM(J);break}M=cJ(8)|0;tj(M,87672);bQ(M|0,97120,46)}}while(0);A=e|0;z=c[A>>2]|0;do{if((z|0)==0){S=0}else{M=c[z+12>>2]|0;if((M|0)==(c[z+16>>2]|0)){T=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{T=c[M>>2]|0}if((T|0)!=-1){S=z;break}c[A>>2]=0;S=0}}while(0);A=(S|0)==0;z=c[B>>2]|0;do{if((z|0)==0){U=46}else{M=c[z+12>>2]|0;if((M|0)==(c[z+16>>2]|0)){V=da[c[(c[z>>2]|0)+36>>2]&255](z)|0}else{V=c[M>>2]|0}if((V|0)==-1){c[B>>2]=0;U=46;break}else{if(A^(z|0)==0){break}else{U=48;break}}}}while(0);if((U|0)==46){if(A){U=48}}if((U|0)==48){c[j>>2]=c[j>>2]|2}c[b>>2]=S;z=c[m>>2]|0;td(z)|0;z=c[u>>2]|0;c[u>>2]=0;if((z|0)==0){i=d;return}c4[c[v>>2]&511](z);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function xU(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0;p=i;i=i+448|0;q=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[q>>2];q=p|0;r=p+8|0;s=p+408|0;t=p+416|0;u=p+424|0;v=p+432|0;w=v;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;c[q>>2]=o;o=r|0;c[s>>2]=0;A2(w|0,0,12);D=x;E=y;F=z;G=A;A2(D|0,0,12);A2(E|0,0,12);A2(F|0,0,12);A2(G|0,0,12);xX(f,g,s,t,u,v,x,y,z,B);g=m|0;c[n>>2]=c[g>>2];f=b|0;b=e|0;e=s;s=l;H=z+4|0;I=z+8|0;J=y+4|0;K=y+8|0;L=(h&512|0)!=0;h=x+4|0;M=x+8|0;N=A+4|0;O=A+8|0;P=e+3|0;Q=v+4|0;R=230;S=o;T=o;o=r+400|0;r=0;U=0;L65:while(1){V=c[f>>2]|0;do{if((V|0)==0){W=1}else{X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){Y=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{Y=c[X>>2]|0}if((Y|0)==-1){c[f>>2]=0;W=1;break}else{W=(c[f>>2]|0)==0;break}}}while(0);V=c[b>>2]|0;do{if((V|0)==0){Z=74}else{X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){_=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{_=c[X>>2]|0}if((_|0)==-1){c[b>>2]=0;Z=74;break}else{if(W^(V|0)==0){$=V;break}else{aa=R;ab=S;ac=T;ad=r;Z=314;break L65}}}}while(0);if((Z|0)==74){Z=0;if(W){aa=R;ab=S;ac=T;ad=r;Z=314;break}else{$=0}}L89:do{switch(a[e+U|0]|0){case 1:{if((U|0)==3){aa=R;ab=S;ac=T;ad=r;Z=314;break L65}V=c[f>>2]|0;X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){ae=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{ae=c[X>>2]|0}if(!(c8[c[(c[s>>2]|0)+12>>2]&127](l,8192,ae)|0)){Z=98;break L65}X=c[f>>2]|0;V=X+12|0;af=c[V>>2]|0;if((af|0)==(c[X+16>>2]|0)){ag=da[c[(c[X>>2]|0)+40>>2]&255](X)|0}else{c[V>>2]=af+4;ag=c[af>>2]|0}tZ(A,ag);Z=99;break};case 0:{Z=99;break};case 3:{af=a[E]|0;V=af&255;X=(V&1|0)==0;ah=a[F]|0;ai=ah&255;aj=(ai&1|0)==0;if(((X?V>>>1:c[J>>2]|0)|0)==(-(aj?ai>>>1:c[H>>2]|0)|0)){ak=r;al=o;am=T;an=S;ao=R;break L89}do{if(((X?V>>>1:c[J>>2]|0)|0)!=0){if(((aj?ai>>>1:c[H>>2]|0)|0)==0){break}ap=c[f>>2]|0;aq=c[ap+12>>2]|0;if((aq|0)==(c[ap+16>>2]|0)){ar=da[c[(c[ap>>2]|0)+36>>2]&255](ap)|0;as=ar;at=a[E]|0}else{as=c[aq>>2]|0;at=af}aq=c[f>>2]|0;ar=aq+12|0;ap=c[ar>>2]|0;au=(ap|0)==(c[aq+16>>2]|0);if((as|0)==(c[((at&1)==0?J:c[K>>2]|0)>>2]|0)){if(au){av=c[(c[aq>>2]|0)+40>>2]|0;da[av&255](aq)|0}else{c[ar>>2]=ap+4}ar=d[E]|0;ak=((ar&1|0)==0?ar>>>1:c[J>>2]|0)>>>0>1>>>0?y:r;al=o;am=T;an=S;ao=R;break L89}if(au){aw=da[c[(c[aq>>2]|0)+36>>2]&255](aq)|0}else{aw=c[ap>>2]|0}if((aw|0)!=(c[((a[F]&1)==0?H:c[I>>2]|0)>>2]|0)){Z=164;break L65}ap=c[f>>2]|0;aq=ap+12|0;au=c[aq>>2]|0;if((au|0)==(c[ap+16>>2]|0)){ar=c[(c[ap>>2]|0)+40>>2]|0;da[ar&255](ap)|0}else{c[aq>>2]=au+4}a[k]=1;au=d[F]|0;ak=((au&1|0)==0?au>>>1:c[H>>2]|0)>>>0>1>>>0?z:r;al=o;am=T;an=S;ao=R;break L89}}while(0);ai=c[f>>2]|0;aj=c[ai+12>>2]|0;au=(aj|0)==(c[ai+16>>2]|0);if(((X?V>>>1:c[J>>2]|0)|0)==0){if(au){aq=da[c[(c[ai>>2]|0)+36>>2]&255](ai)|0;ax=aq;ay=a[F]|0}else{ax=c[aj>>2]|0;ay=ah}if((ax|0)!=(c[((ay&1)==0?H:c[I>>2]|0)>>2]|0)){ak=r;al=o;am=T;an=S;ao=R;break L89}aq=c[f>>2]|0;ap=aq+12|0;ar=c[ap>>2]|0;if((ar|0)==(c[aq+16>>2]|0)){av=c[(c[aq>>2]|0)+40>>2]|0;da[av&255](aq)|0}else{c[ap>>2]=ar+4}a[k]=1;ar=d[F]|0;ak=((ar&1|0)==0?ar>>>1:c[H>>2]|0)>>>0>1>>>0?z:r;al=o;am=T;an=S;ao=R;break L89}if(au){au=da[c[(c[ai>>2]|0)+36>>2]&255](ai)|0;az=au;aA=a[E]|0}else{az=c[aj>>2]|0;aA=af}if((az|0)!=(c[((aA&1)==0?J:c[K>>2]|0)>>2]|0)){a[k]=1;ak=r;al=o;am=T;an=S;ao=R;break L89}aj=c[f>>2]|0;au=aj+12|0;ai=c[au>>2]|0;if((ai|0)==(c[aj+16>>2]|0)){ar=c[(c[aj>>2]|0)+40>>2]|0;da[ar&255](aj)|0}else{c[au>>2]=ai+4}ai=d[E]|0;ak=((ai&1|0)==0?ai>>>1:c[J>>2]|0)>>>0>1>>>0?y:r;al=o;am=T;an=S;ao=R;break};case 2:{if(!((r|0)!=0|U>>>0<2>>>0)){if((U|0)==2){aB=(a[P]|0)!=0}else{aB=0}if(!(L|aB)){ak=0;al=o;am=T;an=S;ao=R;break L89}}ai=a[D]|0;au=(ai&1)==0?h:c[M>>2]|0;L161:do{if((U|0)==0){aC=au;aD=ai;aE=$}else{if((d[e+(U-1)|0]|0)>>>0<2>>>0){aF=au;aG=ai}else{aC=au;aD=ai;aE=$;break}while(1){aj=aG&255;if((aF|0)==(((aG&1)==0?h:c[M>>2]|0)+(((aj&1|0)==0?aj>>>1:c[h>>2]|0)<<2)|0)){aH=aG;break}if(!(c8[c[(c[s>>2]|0)+12>>2]&127](l,8192,c[aF>>2]|0)|0)){Z=175;break}aF=aF+4|0;aG=a[D]|0}if((Z|0)==175){Z=0;aH=a[D]|0}aj=(aH&1)==0;ar=aF-(aj?h:c[M>>2]|0)>>2;ap=a[G]|0;aq=ap&255;av=(aq&1|0)==0;L171:do{if(ar>>>0<=(av?aq>>>1:c[N>>2]|0)>>>0){aI=(ap&1)==0;aJ=(aI?N:c[O>>2]|0)+((av?aq>>>1:c[N>>2]|0)-ar<<2)|0;aK=(aI?N:c[O>>2]|0)+((av?aq>>>1:c[N>>2]|0)<<2)|0;if((aJ|0)==(aK|0)){aC=aF;aD=aH;aE=$;break L161}else{aL=aJ;aM=aj?h:c[M>>2]|0}while(1){if((c[aL>>2]|0)!=(c[aM>>2]|0)){break L171}aJ=aL+4|0;if((aJ|0)==(aK|0)){aC=aF;aD=aH;aE=$;break L161}aL=aJ;aM=aM+4|0}}}while(0);aC=aj?h:c[M>>2]|0;aD=aH;aE=$}}while(0);L178:while(1){ai=aD&255;if((aC|0)==(((aD&1)==0?h:c[M>>2]|0)+(((ai&1|0)==0?ai>>>1:c[h>>2]|0)<<2)|0)){break}ai=c[f>>2]|0;do{if((ai|0)==0){aN=1}else{au=c[ai+12>>2]|0;if((au|0)==(c[ai+16>>2]|0)){aO=da[c[(c[ai>>2]|0)+36>>2]&255](ai)|0}else{aO=c[au>>2]|0}if((aO|0)==-1){c[f>>2]=0;aN=1;break}else{aN=(c[f>>2]|0)==0;break}}}while(0);do{if((aE|0)==0){Z=196}else{ai=c[aE+12>>2]|0;if((ai|0)==(c[aE+16>>2]|0)){aP=da[c[(c[aE>>2]|0)+36>>2]&255](aE)|0}else{aP=c[ai>>2]|0}if((aP|0)==-1){c[b>>2]=0;Z=196;break}else{if(aN^(aE|0)==0){aQ=aE;break}else{break L178}}}}while(0);if((Z|0)==196){Z=0;if(aN){break}else{aQ=0}}ai=c[f>>2]|0;aj=c[ai+12>>2]|0;if((aj|0)==(c[ai+16>>2]|0)){aR=da[c[(c[ai>>2]|0)+36>>2]&255](ai)|0}else{aR=c[aj>>2]|0}if((aR|0)!=(c[aC>>2]|0)){break}aj=c[f>>2]|0;ai=aj+12|0;au=c[ai>>2]|0;if((au|0)==(c[aj+16>>2]|0)){af=c[(c[aj>>2]|0)+40>>2]|0;da[af&255](aj)|0}else{c[ai>>2]=au+4}aC=aC+4|0;aD=a[D]|0;aE=aQ}if(!L){ak=r;al=o;am=T;an=S;ao=R;break L89}au=a[D]|0;ai=au&255;if((aC|0)==(((au&1)==0?h:c[M>>2]|0)+(((ai&1|0)==0?ai>>>1:c[h>>2]|0)<<2)|0)){ak=r;al=o;am=T;an=S;ao=R}else{Z=208;break L65}break};case 4:{ai=0;au=o;aj=T;af=S;ah=R;L214:while(1){V=c[f>>2]|0;do{if((V|0)==0){aS=1}else{X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){aT=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{aT=c[X>>2]|0}if((aT|0)==-1){c[f>>2]=0;aS=1;break}else{aS=(c[f>>2]|0)==0;break}}}while(0);V=c[b>>2]|0;do{if((V|0)==0){Z=222}else{X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){aU=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{aU=c[X>>2]|0}if((aU|0)==-1){c[b>>2]=0;Z=222;break}else{if(aS^(V|0)==0){break}else{break L214}}}}while(0);if((Z|0)==222){Z=0;if(aS){break}}V=c[f>>2]|0;X=c[V+12>>2]|0;if((X|0)==(c[V+16>>2]|0)){aV=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{aV=c[X>>2]|0}if(c8[c[(c[s>>2]|0)+12>>2]&127](l,2048,aV)|0){X=c[n>>2]|0;if((X|0)==(c[q>>2]|0)){xY(m,n,q);aW=c[n>>2]|0}else{aW=X}c[n>>2]=aW+4;c[aW>>2]=aV;aX=ai+1|0;aY=au;aZ=aj;a_=af;a$=ah}else{X=d[w]|0;if((((X&1|0)==0?X>>>1:c[Q>>2]|0)|0)==0|(ai|0)==0){break}if((aV|0)!=(c[u>>2]|0)){break}if((aj|0)==(au|0)){X=(ah|0)!=230;V=aj-af|0;aq=V>>>0<2147483647>>>0?V<<1:-1;if(X){a0=af}else{a0=0}X=AO(a0,aq)|0;av=X;if((X|0)==0){AY()}a1=av+(aq>>>2<<2)|0;a2=av+(V>>2<<2)|0;a3=av;a4=122}else{a1=au;a2=aj;a3=af;a4=ah}c[a2>>2]=ai;aX=0;aY=a1;aZ=a2+4|0;a_=a3;a$=a4}av=c[f>>2]|0;V=av+12|0;aq=c[V>>2]|0;if((aq|0)==(c[av+16>>2]|0)){X=c[(c[av>>2]|0)+40>>2]|0;da[X&255](av)|0;ai=aX;au=aY;aj=aZ;af=a_;ah=a$;continue}else{c[V>>2]=aq+4;ai=aX;au=aY;aj=aZ;af=a_;ah=a$;continue}}if((af|0)==(aj|0)|(ai|0)==0){a5=au;a6=aj;a7=af;a8=ah}else{if((aj|0)==(au|0)){aq=(ah|0)!=230;V=aj-af|0;av=V>>>0<2147483647>>>0?V<<1:-1;if(aq){a9=af}else{a9=0}aq=AO(a9,av)|0;X=aq;if((aq|0)==0){AY()}ba=X+(av>>>2<<2)|0;bb=X+(V>>2<<2)|0;bc=X;bd=122}else{ba=au;bb=aj;bc=af;bd=ah}c[bb>>2]=ai;a5=ba;a6=bb+4|0;a7=bc;a8=bd}X=c[B>>2]|0;if((X|0)>0){V=c[f>>2]|0;do{if((V|0)==0){be=1}else{av=c[V+12>>2]|0;if((av|0)==(c[V+16>>2]|0)){bf=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{bf=c[av>>2]|0}if((bf|0)==-1){c[f>>2]=0;be=1;break}else{be=(c[f>>2]|0)==0;break}}}while(0);V=c[b>>2]|0;do{if((V|0)==0){Z=271}else{ai=c[V+12>>2]|0;if((ai|0)==(c[V+16>>2]|0)){bg=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{bg=c[ai>>2]|0}if((bg|0)==-1){c[b>>2]=0;Z=271;break}else{if(be^(V|0)==0){bh=V;break}else{Z=277;break L65}}}}while(0);if((Z|0)==271){Z=0;if(be){Z=277;break L65}else{bh=0}}V=c[f>>2]|0;ai=c[V+12>>2]|0;if((ai|0)==(c[V+16>>2]|0)){bi=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{bi=c[ai>>2]|0}if((bi|0)!=(c[t>>2]|0)){Z=277;break L65}ai=c[f>>2]|0;V=ai+12|0;ah=c[V>>2]|0;if((ah|0)==(c[ai+16>>2]|0)){af=c[(c[ai>>2]|0)+40>>2]|0;da[af&255](ai)|0;bj=bh;bk=X}else{c[V>>2]=ah+4;bj=bh;bk=X}while(1){ah=c[f>>2]|0;do{if((ah|0)==0){bl=1}else{V=c[ah+12>>2]|0;if((V|0)==(c[ah+16>>2]|0)){bm=da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0}else{bm=c[V>>2]|0}if((bm|0)==-1){c[f>>2]=0;bl=1;break}else{bl=(c[f>>2]|0)==0;break}}}while(0);do{if((bj|0)==0){Z=294}else{ah=c[bj+12>>2]|0;if((ah|0)==(c[bj+16>>2]|0)){bn=da[c[(c[bj>>2]|0)+36>>2]&255](bj)|0}else{bn=c[ah>>2]|0}if((bn|0)==-1){c[b>>2]=0;Z=294;break}else{if(bl^(bj|0)==0){bo=bj;break}else{Z=301;break L65}}}}while(0);if((Z|0)==294){Z=0;if(bl){Z=301;break L65}else{bo=0}}ah=c[f>>2]|0;V=c[ah+12>>2]|0;if((V|0)==(c[ah+16>>2]|0)){bp=da[c[(c[ah>>2]|0)+36>>2]&255](ah)|0}else{bp=c[V>>2]|0}if(!(c8[c[(c[s>>2]|0)+12>>2]&127](l,2048,bp)|0)){Z=301;break L65}if((c[n>>2]|0)==(c[q>>2]|0)){xY(m,n,q)}V=c[f>>2]|0;ah=c[V+12>>2]|0;if((ah|0)==(c[V+16>>2]|0)){bq=da[c[(c[V>>2]|0)+36>>2]&255](V)|0}else{bq=c[ah>>2]|0}ah=c[n>>2]|0;c[n>>2]=ah+4;c[ah>>2]=bq;ah=bk-1|0;c[B>>2]=ah;V=c[f>>2]|0;ai=V+12|0;af=c[ai>>2]|0;if((af|0)==(c[V+16>>2]|0)){aj=c[(c[V>>2]|0)+40>>2]|0;da[aj&255](V)|0}else{c[ai>>2]=af+4}if((ah|0)>0){bj=bo;bk=ah}else{break}}}if((c[n>>2]|0)==(c[g>>2]|0)){Z=312;break L65}else{ak=r;al=a5;am=a6;an=a7;ao=a8}break};default:{ak=r;al=o;am=T;an=S;ao=R}}}while(0);L358:do{if((Z|0)==99){Z=0;if((U|0)==3){aa=R;ab=S;ac=T;ad=r;Z=314;break L65}else{br=$}while(1){X=c[f>>2]|0;do{if((X|0)==0){bs=1}else{ah=c[X+12>>2]|0;if((ah|0)==(c[X+16>>2]|0)){bt=da[c[(c[X>>2]|0)+36>>2]&255](X)|0}else{bt=c[ah>>2]|0}if((bt|0)==-1){c[f>>2]=0;bs=1;break}else{bs=(c[f>>2]|0)==0;break}}}while(0);do{if((br|0)==0){Z=113}else{X=c[br+12>>2]|0;if((X|0)==(c[br+16>>2]|0)){bu=da[c[(c[br>>2]|0)+36>>2]&255](br)|0}else{bu=c[X>>2]|0}if((bu|0)==-1){c[b>>2]=0;Z=113;break}else{if(bs^(br|0)==0){bv=br;break}else{ak=r;al=o;am=T;an=S;ao=R;break L358}}}}while(0);if((Z|0)==113){Z=0;if(bs){ak=r;al=o;am=T;an=S;ao=R;break L358}else{bv=0}}X=c[f>>2]|0;ah=c[X+12>>2]|0;if((ah|0)==(c[X+16>>2]|0)){bw=da[c[(c[X>>2]|0)+36>>2]&255](X)|0}else{bw=c[ah>>2]|0}if(!(c8[c[(c[s>>2]|0)+12>>2]&127](l,8192,bw)|0)){ak=r;al=o;am=T;an=S;ao=R;break L358}ah=c[f>>2]|0;X=ah+12|0;af=c[X>>2]|0;if((af|0)==(c[ah+16>>2]|0)){bx=da[c[(c[ah>>2]|0)+40>>2]&255](ah)|0}else{c[X>>2]=af+4;bx=c[af>>2]|0}tZ(A,bx);br=bv}}}while(0);af=U+1|0;if(af>>>0<4>>>0){R=ao;S=an;T=am;o=al;r=ak;U=af}else{aa=ao;ab=an;ac=am;ad=ak;Z=314;break}}L395:do{if((Z|0)==98){c[j>>2]=c[j>>2]|4;by=0;bz=S;bA=R}else if((Z|0)==164){c[j>>2]=c[j>>2]|4;by=0;bz=S;bA=R}else if((Z|0)==208){c[j>>2]=c[j>>2]|4;by=0;bz=S;bA=R}else if((Z|0)==277){c[j>>2]=c[j>>2]|4;by=0;bz=a7;bA=a8}else if((Z|0)==301){c[j>>2]=c[j>>2]|4;by=0;bz=a7;bA=a8}else if((Z|0)==312){c[j>>2]=c[j>>2]|4;by=0;bz=a7;bA=a8}else if((Z|0)==314){L403:do{if((ad|0)!=0){ak=ad;am=ad+4|0;an=ad+8|0;ao=1;L405:while(1){U=d[ak]|0;if((U&1|0)==0){bB=U>>>1}else{bB=c[am>>2]|0}if(ao>>>0>=bB>>>0){break L403}U=c[f>>2]|0;do{if((U|0)==0){bC=1}else{r=c[U+12>>2]|0;if((r|0)==(c[U+16>>2]|0)){bD=da[c[(c[U>>2]|0)+36>>2]&255](U)|0}else{bD=c[r>>2]|0}if((bD|0)==-1){c[f>>2]=0;bC=1;break}else{bC=(c[f>>2]|0)==0;break}}}while(0);U=c[b>>2]|0;do{if((U|0)==0){Z=333}else{r=c[U+12>>2]|0;if((r|0)==(c[U+16>>2]|0)){bE=da[c[(c[U>>2]|0)+36>>2]&255](U)|0}else{bE=c[r>>2]|0}if((bE|0)==-1){c[b>>2]=0;Z=333;break}else{if(bC^(U|0)==0){break}else{break L405}}}}while(0);if((Z|0)==333){Z=0;if(bC){break}}U=c[f>>2]|0;r=c[U+12>>2]|0;if((r|0)==(c[U+16>>2]|0)){bF=da[c[(c[U>>2]|0)+36>>2]&255](U)|0}else{bF=c[r>>2]|0}if((a[ak]&1)==0){bG=am}else{bG=c[an>>2]|0}if((bF|0)!=(c[bG+(ao<<2)>>2]|0)){break}r=ao+1|0;U=c[f>>2]|0;al=U+12|0;o=c[al>>2]|0;if((o|0)==(c[U+16>>2]|0)){T=c[(c[U>>2]|0)+40>>2]|0;da[T&255](U)|0;ao=r;continue}else{c[al>>2]=o+4;ao=r;continue}}c[j>>2]=c[j>>2]|4;by=0;bz=ab;bA=aa;break L395}}while(0);if((ab|0)==(ac|0)){by=1;bz=ac;bA=aa;break}c[C>>2]=0;xQ(v,ab,ac,C);if((c[C>>2]|0)==0){by=1;bz=ab;bA=aa;break}c[j>>2]=c[j>>2]|4;by=0;bz=ab;bA=aa}}while(0);tV(A);tV(z);tV(y);tV(x);tH(v);if((bz|0)==0){i=p;return by|0}c4[bA&511](bz);i=p;return by|0}function xV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+456|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=n|0;c[s>>2]=m;t=n+4|0;c[t>>2]=230;u=m+400|0;t3(p,h);m=p|0;v=c[m>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;w=c[v+8>>2]|0;do{if((c[v+12>>2]|0)-w>>2>>>0>l>>>0){x=c[w+(l<<2)>>2]|0;if((x|0)==0){break}y=x;a[q]=0;z=f|0;A=c[z>>2]|0;c[r>>2]=A;if(xU(e,r,g,p,c[h+4>>2]|0,j,q,y,n,o,u)|0){B=k;if((a[B]&1)==0){c[k+4>>2]=0;a[B]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}B=x;if((a[q]&1)!=0){tZ(k,c7[c[(c[B>>2]|0)+44>>2]&255](y,45)|0)}x=c7[c[(c[B>>2]|0)+44>>2]&255](y,48)|0;y=c[s>>2]|0;B=c[o>>2]|0;C=B-4|0;L474:do{if(y>>>0<C>>>0){D=y;while(1){E=D+4|0;if((c[D>>2]|0)!=(x|0)){F=D;break L474}if(E>>>0<C>>>0){D=E}else{F=E;break}}}else{F=y}}while(0);xW(k,F,B)|0}y=e|0;C=c[y>>2]|0;do{if((C|0)==0){G=0}else{x=c[C+12>>2]|0;if((x|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[x>>2]|0}if((H|0)!=-1){G=C;break}c[y>>2]=0;G=0}}while(0);y=(G|0)==0;do{if((A|0)==0){I=388}else{C=c[A+12>>2]|0;if((C|0)==(c[A+16>>2]|0)){J=da[c[(c[A>>2]|0)+36>>2]&255](A)|0}else{J=c[C>>2]|0}if((J|0)==-1){c[z>>2]=0;I=388;break}else{if(y^(A|0)==0){break}else{I=390;break}}}}while(0);if((I|0)==388){if(y){I=390}}if((I|0)==390){c[j>>2]=c[j>>2]|2}c[b>>2]=G;A=c[m>>2]|0;td(A)|0;A=c[s>>2]|0;c[s>>2]=0;if((A|0)==0){i=d;return}c4[c[t>>2]&511](A);i=d;return}}while(0);d=cJ(4)|0;Aq(d);bQ(d|0,97088,288)}function xW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=1;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g>>2;if((h|0)==0){return b|0}if((k-j|0)>>>0<h>>>0){t$(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{l=j+((e-4+(-g|0)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{g=m;d=d+4|0}}o=n+(l<<2)|0}c[o>>2]=0;o=j+h|0;if((a[f]&1)==0){a[f]=o<<1&255;return b|0}else{c[b+4>>2]=o;return b|0}return 0}function xX(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=A;D=i;i=i+12|0;i=i+7&-8;E=D;F=i;i=i+12|0;i=i+7&-8;G=F;H=i;i=i+12|0;i=i+7&-8;I=H;if(b){b=c[d>>2]|0;if((c[218770]|0)!=-1){c[p>>2]=875080;c[p+4>>2]=36;c[p+8>>2]=0;tA(875080,p,144)}p=(c[218771]|0)-1|0;J=c[b+8>>2]|0;if((c[b+12>>2]|0)-J>>2>>>0<=p>>>0){K=cJ(4)|0;L=K;Aq(L);bQ(K|0,97088,288)}b=c[J+(p<<2)>>2]|0;if((b|0)==0){K=cJ(4)|0;L=K;Aq(L);bQ(K|0,97088,288)}K=b;c5[c[(c[b>>2]|0)+44>>2]&255](q,K);L=e;C=c[q>>2]|0;a[L]=C&255;C=C>>8;a[L+1|0]=C&255;C=C>>8;a[L+2|0]=C&255;C=C>>8;a[L+3|0]=C&255;L=b;c5[c[(c[L>>2]|0)+32>>2]&255](r,K);q=l;if((a[q]&1)==0){c[l+4>>2]=0;a[q]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];A2(s|0,0,12);tV(r);c5[c[(c[L>>2]|0)+28>>2]&255](t,K);r=k;if((a[r]&1)==0){c[k+4>>2]=0;a[r]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}tY(k,0);c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];A2(u|0,0,12);tV(t);t=b;c[f>>2]=da[c[(c[t>>2]|0)+12>>2]&255](K)|0;c[g>>2]=da[c[(c[t>>2]|0)+16>>2]&255](K)|0;c5[c[(c[b>>2]|0)+20>>2]&255](v,K);b=h;if((a[b]&1)==0){a[h+1|0]=0;a[b]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}tM(h,0);c[b>>2]=c[w>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];A2(w|0,0,12);tH(v);c5[c[(c[L>>2]|0)+24>>2]&255](x,K);L=j;if((a[L]&1)==0){c[j+4>>2]=0;a[L]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}tY(j,0);c[L>>2]=c[y>>2];c[L+4>>2]=c[y+4>>2];c[L+8>>2]=c[y+8>>2];A2(y|0,0,12);tV(x);M=da[c[(c[t>>2]|0)+36>>2]&255](K)|0;c[m>>2]=M;i=n;return}else{K=c[d>>2]|0;if((c[218772]|0)!=-1){c[o>>2]=875088;c[o+4>>2]=36;c[o+8>>2]=0;tA(875088,o,144)}o=(c[218773]|0)-1|0;d=c[K+8>>2]|0;if((c[K+12>>2]|0)-d>>2>>>0<=o>>>0){N=cJ(4)|0;O=N;Aq(O);bQ(N|0,97088,288)}K=c[d+(o<<2)>>2]|0;if((K|0)==0){N=cJ(4)|0;O=N;Aq(O);bQ(N|0,97088,288)}N=K;c5[c[(c[K>>2]|0)+44>>2]&255](z,N);O=e;C=c[z>>2]|0;a[O]=C&255;C=C>>8;a[O+1|0]=C&255;C=C>>8;a[O+2|0]=C&255;C=C>>8;a[O+3|0]=C&255;O=K;c5[c[(c[O>>2]|0)+32>>2]&255](A,N);z=l;if((a[z]&1)==0){c[l+4>>2]=0;a[z]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];A2(B|0,0,12);tV(A);c5[c[(c[O>>2]|0)+28>>2]&255](D,N);A=k;if((a[A]&1)==0){c[k+4>>2]=0;a[A]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}tY(k,0);c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];A2(E|0,0,12);tV(D);D=K;c[f>>2]=da[c[(c[D>>2]|0)+12>>2]&255](N)|0;c[g>>2]=da[c[(c[D>>2]|0)+16>>2]&255](N)|0;c5[c[(c[K>>2]|0)+20>>2]&255](F,N);K=h;if((a[K]&1)==0){a[h+1|0]=0;a[K]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}tM(h,0);c[K>>2]=c[G>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];A2(G|0,0,12);tH(F);c5[c[(c[O>>2]|0)+24>>2]&255](H,N);O=j;if((a[O]&1)==0){c[j+4>>2]=0;a[O]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}tY(j,0);c[O>>2]=c[I>>2];c[O+4>>2]=c[I+4>>2];c[O+8>>2]=c[I+8>>2];A2(I|0,0,12);tV(H);M=da[c[(c[D>>2]|0)+36>>2]&255](N)|0;c[m>>2]=M;i=n;return}}function xY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;f=(c[e>>2]|0)!=230;g=a|0;a=c[g>>2]|0;h=a;i=(c[d>>2]|0)-h|0;j=i>>>0<2147483647>>>0?i<<1:-1;i=(c[b>>2]|0)-h>>2;if(f){k=a}else{k=0}a=AO(k,j)|0;k=a;if((a|0)==0){AY()}do{if(f){c[g>>2]=k;l=k}else{a=c[g>>2]|0;c[g>>2]=k;if((a|0)==0){l=k;break}c4[c[e>>2]&511](a);l=c[g>>2]|0}}while(0);c[e>>2]=122;c[b>>2]=l+(i<<2);c[d>>2]=(c[g>>2]|0)+(j>>>2<<2);return}function xZ(a){a=a|0;tb(a|0);AT(a);return}function x_(a){a=a|0;tb(a|0);return}function x$(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+248|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+232|0;p=e+240|0;q=p;r=i;i=i+1|0;i=i+7&-8;s=i;i=i+1|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+100|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bd(E|0,100,87328,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;do{if(G>>>0>99>>>0){do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);H=wb(n,c[218270]|0,87328,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;I=c[n>>2]|0;if((I|0)==0){AY();J=c[n>>2]|0}else{J=I}I=AL(H)|0;if((I|0)!=0){K=I;L=H;M=J;N=I;break}AY();K=0;L=H;M=J;N=0}else{K=F;L=G;M=0;N=0}}while(0);t3(o,j);G=o|0;F=c[G>>2]|0;if((c[218656]|0)!=-1){c[m>>2]=874624;c[m+4>>2]=36;c[m+8>>2]=0;tA(874624,m,144)}m=(c[218657]|0)-1|0;J=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-J>>2>>>0>m>>>0){E=c[J+(m<<2)>>2]|0;if((E|0)==0){break}H=E;I=c[n>>2]|0;O=I+L|0;P=c[(c[E>>2]|0)+32>>2]|0;di[P&63](H,I,O,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[n>>2]|0]|0)==45}c[p>>2]=0;A2(u|0,0,12);A2(w|0,0,12);A2(y|0,0,12);x0(g,Q,o,q,r,s,t,v,x,z);O=A|0;I=c[z>>2]|0;if((L|0)>(I|0)){P=d[y]|0;if((P&1|0)==0){R=P>>>1}else{R=c[x+4>>2]|0}P=d[w]|0;if((P&1|0)==0){S=P>>>1}else{S=c[v+4>>2]|0}T=(L-I<<1|1)+R+S|0}else{P=d[y]|0;if((P&1|0)==0){U=P>>>1}else{U=c[x+4>>2]|0}P=d[w]|0;if((P&1|0)==0){V=P>>>1}else{V=c[v+4>>2]|0}T=U+2+V|0}P=T+I|0;do{if(P>>>0>100>>>0){E=AL(P)|0;if((E|0)!=0){W=E;X=E;break}AY();W=0;X=0}else{W=O;X=0}}while(0);x1(W,B,C,c[j+4>>2]|0,K,K+L|0,H,Q,q,a[r]|0,a[s]|0,t,v,x,I);c[D>>2]=c[f>>2];ei(b,D,W,c[B>>2]|0,c[C>>2]|0,j,k);if((X|0)!=0){AM(X)}tH(x);tH(v);tH(t);O=c[G>>2]|0;td(O)|0;if((N|0)!=0){AM(N)}if((M|0)==0){i=e;return}AM(M);i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function x0(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+12|0;i=i+7&-8;z=y;A=i;i=i+12|0;i=i+7&-8;B=A;D=i;i=i+4|0;i=i+7&-8;E=D;F=i;i=i+12|0;i=i+7&-8;G=F;H=i;i=i+4|0;i=i+7&-8;I=H;J=i;i=i+12|0;i=i+7&-8;K=J;L=i;i=i+12|0;i=i+7&-8;M=L;N=i;i=i+12|0;i=i+7&-8;O=N;P=c[e>>2]|0;if(b){if((c[218774]|0)!=-1){c[p>>2]=875096;c[p+4>>2]=36;c[p+8>>2]=0;tA(875096,p,144)}p=(c[218775]|0)-1|0;b=c[P+8>>2]|0;if((c[P+12>>2]|0)-b>>2>>>0<=p>>>0){Q=cJ(4)|0;R=Q;Aq(R);bQ(Q|0,97088,288)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){Q=cJ(4)|0;R=Q;Aq(R);bQ(Q|0,97088,288)}Q=e;R=c[e>>2]|0;if(d){c5[c[R+44>>2]&255](r,Q);r=f;C=c[q>>2]|0;a[r]=C&255;C=C>>8;a[r+1|0]=C&255;C=C>>8;a[r+2|0]=C&255;C=C>>8;a[r+3|0]=C&255;c5[c[(c[e>>2]|0)+32>>2]&255](s,Q);r=l;if((a[r]&1)==0){a[l+1|0]=0;a[r]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];A2(t|0,0,12);tH(s)}else{c5[c[R+40>>2]&255](v,Q);v=f;C=c[u>>2]|0;a[v]=C&255;C=C>>8;a[v+1|0]=C&255;C=C>>8;a[v+2|0]=C&255;C=C>>8;a[v+3|0]=C&255;c5[c[(c[e>>2]|0)+28>>2]&255](w,Q);v=l;if((a[v]&1)==0){a[l+1|0]=0;a[v]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[v>>2]=c[x>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];A2(x|0,0,12);tH(w)}w=e;a[g]=da[c[(c[w>>2]|0)+12>>2]&255](Q)|0;a[h]=da[c[(c[w>>2]|0)+16>>2]&255](Q)|0;w=e;c5[c[(c[w>>2]|0)+20>>2]&255](y,Q);x=j;if((a[x]&1)==0){a[j+1|0]=0;a[x]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[x>>2]=c[z>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];A2(z|0,0,12);tH(y);c5[c[(c[w>>2]|0)+24>>2]&255](A,Q);w=k;if((a[w]&1)==0){a[k+1|0]=0;a[w]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}tM(k,0);c[w>>2]=c[B>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];A2(B|0,0,12);tH(A);S=da[c[(c[e>>2]|0)+36>>2]&255](Q)|0;c[m>>2]=S;i=n;return}else{if((c[218776]|0)!=-1){c[o>>2]=875104;c[o+4>>2]=36;c[o+8>>2]=0;tA(875104,o,144)}o=(c[218777]|0)-1|0;Q=c[P+8>>2]|0;if((c[P+12>>2]|0)-Q>>2>>>0<=o>>>0){T=cJ(4)|0;U=T;Aq(U);bQ(T|0,97088,288)}P=c[Q+(o<<2)>>2]|0;if((P|0)==0){T=cJ(4)|0;U=T;Aq(U);bQ(T|0,97088,288)}T=P;U=c[P>>2]|0;if(d){c5[c[U+44>>2]&255](E,T);E=f;C=c[D>>2]|0;a[E]=C&255;C=C>>8;a[E+1|0]=C&255;C=C>>8;a[E+2|0]=C&255;C=C>>8;a[E+3|0]=C&255;c5[c[(c[P>>2]|0)+32>>2]&255](F,T);E=l;if((a[E]&1)==0){a[l+1|0]=0;a[E]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[E>>2]=c[G>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];A2(G|0,0,12);tH(F)}else{c5[c[U+40>>2]&255](I,T);I=f;C=c[H>>2]|0;a[I]=C&255;C=C>>8;a[I+1|0]=C&255;C=C>>8;a[I+2|0]=C&255;C=C>>8;a[I+3|0]=C&255;c5[c[(c[P>>2]|0)+28>>2]&255](J,T);I=l;if((a[I]&1)==0){a[l+1|0]=0;a[I]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}tM(l,0);c[I>>2]=c[K>>2];c[I+4>>2]=c[K+4>>2];c[I+8>>2]=c[K+8>>2];A2(K|0,0,12);tH(J)}J=P;a[g]=da[c[(c[J>>2]|0)+12>>2]&255](T)|0;a[h]=da[c[(c[J>>2]|0)+16>>2]&255](T)|0;J=P;c5[c[(c[J>>2]|0)+20>>2]&255](L,T);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[h>>2]=c[M>>2];c[h+4>>2]=c[M+4>>2];c[h+8>>2]=c[M+8>>2];A2(M|0,0,12);tH(L);c5[c[(c[J>>2]|0)+24>>2]&255](N,T);J=k;if((a[J]&1)==0){a[k+1|0]=0;a[J]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}tM(k,0);c[J>>2]=c[O>>2];c[J+4>>2]=c[O+4>>2];c[J+8>>2]=c[O+8>>2];A2(O|0,0,12);tH(N);S=da[c[(c[P>>2]|0)+36>>2]&255](T)|0;c[m>>2]=S;i=n;return}}function x1(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0;c[f>>2]=d;s=j;t=q;u=q+1|0;v=q+8|0;w=q+4|0;q=p;x=(g&512|0)==0;y=p+1|0;z=p+4|0;A=p+8|0;p=(r|0)>0;B=o;C=o+1|0;D=o+8|0;E=o+4|0;o=j+8|0;F=-r|0;G=h;h=0;while(1){L756:do{switch(a[l+h|0]|0){case 0:{c[e>>2]=c[f>>2];H=G;break};case 1:{c[e>>2]=c[f>>2];I=c7[c[(c[s>>2]|0)+28>>2]&255](j,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;H=G;break};case 3:{I=a[t]|0;J=I&255;if((J&1|0)==0){K=J>>>1}else{K=c[w>>2]|0}if((K|0)==0){H=G;break L756}if((I&1)==0){L=u}else{L=c[v>>2]|0}I=a[L]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;H=G;break};case 2:{I=a[q]|0;J=I&255;M=(J&1|0)==0;if(M){N=J>>>1}else{N=c[z>>2]|0}if((N|0)==0|x){H=G;break L756}if((I&1)==0){O=y;P=y}else{I=c[A>>2]|0;O=I;P=I}if(M){Q=J>>>1}else{Q=c[z>>2]|0}J=O+Q|0;M=c[f>>2]|0;if((P|0)==(J|0)){R=M}else{I=P;S=M;while(1){a[S]=a[I]|0;M=I+1|0;T=S+1|0;if((M|0)==(J|0)){R=T;break}else{I=M;S=T}}}c[f>>2]=R;H=G;break};case 4:{S=c[f>>2]|0;I=k?G+1|0:G;L786:do{if(I>>>0<i>>>0){J=I;while(1){T=a[J]|0;if(T<<24>>24<=-1){U=J;break L786}M=J+1|0;if((b[(c[o>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=J;break L786}if(M>>>0<i>>>0){J=M}else{U=M;break}}}else{U=I}}while(0);J=U;if(p){if(U>>>0>I>>>0){M=I+(-J|0)|0;J=M>>>0<F>>>0?F:M;M=J+r|0;T=U;V=r;W=S;while(1){X=T-1|0;Y=a[X]|0;c[f>>2]=W+1;a[W]=Y;Y=V-1|0;Z=(Y|0)>0;if(!(X>>>0>I>>>0&Z)){break}T=X;V=Y;W=c[f>>2]|0}W=U+J|0;if(Z){_=M;$=W;aa=661}else{ab=0;ac=M;ad=W}}else{_=r;$=U;aa=661}if((aa|0)==661){aa=0;ab=c7[c[(c[s>>2]|0)+28>>2]&255](j,48)|0;ac=_;ad=$}W=c[f>>2]|0;c[f>>2]=W+1;if((ac|0)>0){V=ac;T=W;while(1){a[T]=ab;Y=V-1|0;X=c[f>>2]|0;c[f>>2]=X+1;if((Y|0)>0){V=Y;T=X}else{ae=X;break}}}else{ae=W}a[ae]=m;af=ad}else{af=U}if((af|0)==(I|0)){T=c7[c[(c[s>>2]|0)+28>>2]&255](j,48)|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=T}else{T=a[B]|0;V=T&255;if((V&1|0)==0){ag=V>>>1}else{ag=c[E>>2]|0}if((ag|0)==0){ah=af;ai=0;aj=0;ak=-1}else{if((T&1)==0){al=C}else{al=c[D>>2]|0}ah=af;ai=0;aj=0;ak=a[al]|0}while(1){do{if((ai|0)==(ak|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=n;T=aj+1|0;V=a[B]|0;M=V&255;if((M&1|0)==0){am=M>>>1}else{am=c[E>>2]|0}if(T>>>0>=am>>>0){an=ak;ao=T;ap=0;break}M=(V&1)==0;if(M){aq=C}else{aq=c[D>>2]|0}if((a[aq+T|0]|0)==127){an=-1;ao=T;ap=0;break}if(M){ar=C}else{ar=c[D>>2]|0}an=a[ar+T|0]|0;ao=T;ap=0}else{an=ak;ao=aj;ap=ai}}while(0);T=ah-1|0;M=a[T]|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=M;if((T|0)==(I|0)){break}else{ah=T;ai=ap+1|0;aj=ao;ak=an}}}W=c[f>>2]|0;if((S|0)==(W|0)){H=I;break L756}T=W-1|0;if(S>>>0<T>>>0){as=S;at=T}else{H=I;break L756}while(1){T=a[as]|0;a[as]=a[at]|0;a[at]=T;T=as+1|0;W=at-1|0;if(T>>>0<W>>>0){as=T;at=W}else{H=I;break}}break};default:{H=G}}}while(0);I=h+1|0;if(I>>>0<4>>>0){G=H;h=I}else{break}}h=a[t]|0;t=h&255;H=(t&1|0)==0;if(H){au=t>>>1}else{au=c[w>>2]|0}if(au>>>0>1>>>0){if((h&1)==0){av=u;aw=u}else{u=c[v>>2]|0;av=u;aw=u}if(H){ax=t>>>1}else{ax=c[w>>2]|0}w=av+ax|0;ax=c[f>>2]|0;av=aw+1|0;if((av|0)==(w|0)){ay=ax}else{aw=ax;ax=av;while(1){a[aw]=a[ax]|0;av=aw+1|0;t=ax+1|0;if((t|0)==(w|0)){ay=av;break}else{aw=av;ax=t}}}c[f>>2]=ay}ay=g&176;if((ay|0)==32){c[e>>2]=c[f>>2];return}else if((ay|0)==16){return}else{c[e>>2]=d;return}}function x2(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;e=i;i=i+32|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=n;p=i;i=i+1|0;i=i+7&-8;q=i;i=i+1|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+4|0;i=i+7&-8;y=i;i=i+100|0;i=i+7&-8;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;t3(m,h);C=m|0;D=c[C>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;E=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-E>>2>>>0>l>>>0){F=c[E+(l<<2)>>2]|0;if((F|0)==0){break}G=F;H=k;I=k;J=a[I]|0;K=J&255;if((K&1|0)==0){L=K>>>1}else{L=c[k+4>>2]|0}if((L|0)==0){M=0}else{if((J&1)==0){N=H+1|0}else{N=c[k+8>>2]|0}J=a[N]|0;M=J<<24>>24==(c7[c[(c[F>>2]|0)+28>>2]&255](G,45)|0)<<24>>24}c[n>>2]=0;A2(s|0,0,12);A2(u|0,0,12);A2(w|0,0,12);x0(g,M,m,o,p,q,r,t,v,x);F=y|0;J=a[I]|0;K=J&255;O=(K&1|0)==0;if(O){P=K>>>1}else{P=c[k+4>>2]|0}Q=c[x>>2]|0;if((P|0)>(Q|0)){if(O){R=K>>>1}else{R=c[k+4>>2]|0}K=d[w]|0;if((K&1|0)==0){S=K>>>1}else{S=c[v+4>>2]|0}K=d[u]|0;if((K&1|0)==0){T=K>>>1}else{T=c[t+4>>2]|0}U=(R-Q<<1|1)+S+T|0}else{K=d[w]|0;if((K&1|0)==0){V=K>>>1}else{V=c[v+4>>2]|0}K=d[u]|0;if((K&1|0)==0){W=K>>>1}else{W=c[t+4>>2]|0}U=V+2+W|0}K=U+Q|0;do{if(K>>>0>100>>>0){O=AL(K)|0;if((O|0)!=0){X=O;Y=O;Z=J;break}AY();X=0;Y=0;Z=a[I]|0}else{X=F;Y=0;Z=J}}while(0);if((Z&1)==0){_=H+1|0;$=H+1|0}else{J=c[k+8>>2]|0;_=J;$=J}J=Z&255;if((J&1|0)==0){aa=J>>>1}else{aa=c[k+4>>2]|0}x1(X,z,A,c[h+4>>2]|0,$,_+aa|0,G,M,o,a[p]|0,a[q]|0,r,t,v,Q);c[B>>2]=c[f>>2];ei(b,B,X,c[z>>2]|0,c[A>>2]|0,h,j);if((Y|0)==0){tH(v);tH(t);tH(r);ab=c[C>>2]|0;ac=ab|0;ad=td(ac)|0;i=e;return}AM(Y);tH(v);tH(t);tH(r);ab=c[C>>2]|0;ac=ab|0;ad=td(ac)|0;i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function x3(a){a=a|0;tb(a|0);AT(a);return}function x4(a){a=a|0;tb(a|0);return}function x5(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+544|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+528|0;p=e+536|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+400|0;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bd(E|0,100,87328,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;do{if(G>>>0>99>>>0){do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);H=wb(n,c[218270]|0,87328,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;I=c[n>>2]|0;if((I|0)==0){AY();J=c[n>>2]|0}else{J=I}I=AL(H<<2)|0;K=I;if((I|0)!=0){L=K;M=H;N=J;O=K;break}AY();L=K;M=H;N=J;O=K}else{L=F;M=G;N=0;O=0}}while(0);t3(o,j);G=o|0;F=c[G>>2]|0;if((c[218654]|0)!=-1){c[m>>2]=874616;c[m+4>>2]=36;c[m+8>>2]=0;tA(874616,m,144)}m=(c[218655]|0)-1|0;J=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-J>>2>>>0>m>>>0){E=c[J+(m<<2)>>2]|0;if((E|0)==0){break}K=E;H=c[n>>2]|0;I=H+M|0;P=c[(c[E>>2]|0)+48>>2]|0;di[P&63](K,H,I,L)|0;if((M|0)==0){Q=0}else{Q=(a[c[n>>2]|0]|0)==45}c[p>>2]=0;A2(u|0,0,12);A2(w|0,0,12);A2(y|0,0,12);x6(g,Q,o,q,r,s,t,v,x,z);I=A|0;H=c[z>>2]|0;if((M|0)>(H|0)){P=d[y]|0;if((P&1|0)==0){R=P>>>1}else{R=c[x+4>>2]|0}P=d[w]|0;if((P&1|0)==0){S=P>>>1}else{S=c[v+4>>2]|0}T=(M-H<<1|1)+R+S|0}else{P=d[y]|0;if((P&1|0)==0){U=P>>>1}else{U=c[x+4>>2]|0}P=d[w]|0;if((P&1|0)==0){V=P>>>1}else{V=c[v+4>>2]|0}T=U+2+V|0}P=T+H|0;do{if(P>>>0>100>>>0){E=AL(P<<2)|0;W=E;if((E|0)!=0){X=W;Y=W;break}AY();X=W;Y=W}else{X=I;Y=0}}while(0);x7(X,B,C,c[j+4>>2]|0,L,L+(M<<2)|0,K,Q,q,c[r>>2]|0,c[s>>2]|0,t,v,x,H);c[D>>2]=c[f>>2];wk(b,D,X,c[B>>2]|0,c[C>>2]|0,j,k);if((Y|0)!=0){AM(Y)}tV(x);tV(v);tH(t);I=c[G>>2]|0;td(I)|0;if((O|0)!=0){AM(O)}if((N|0)==0){i=e;return}AM(N);i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function x6(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+12|0;i=i+7&-8;z=y;A=i;i=i+12|0;i=i+7&-8;B=A;D=i;i=i+4|0;i=i+7&-8;E=D;F=i;i=i+12|0;i=i+7&-8;G=F;H=i;i=i+4|0;i=i+7&-8;I=H;J=i;i=i+12|0;i=i+7&-8;K=J;L=i;i=i+12|0;i=i+7&-8;M=L;N=i;i=i+12|0;i=i+7&-8;O=N;P=c[e>>2]|0;if(b){if((c[218770]|0)!=-1){c[p>>2]=875080;c[p+4>>2]=36;c[p+8>>2]=0;tA(875080,p,144)}p=(c[218771]|0)-1|0;b=c[P+8>>2]|0;if((c[P+12>>2]|0)-b>>2>>>0<=p>>>0){Q=cJ(4)|0;R=Q;Aq(R);bQ(Q|0,97088,288)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){Q=cJ(4)|0;R=Q;Aq(R);bQ(Q|0,97088,288)}Q=e;R=c[e>>2]|0;if(d){c5[c[R+44>>2]&255](r,Q);r=f;C=c[q>>2]|0;a[r]=C&255;C=C>>8;a[r+1|0]=C&255;C=C>>8;a[r+2|0]=C&255;C=C>>8;a[r+3|0]=C&255;c5[c[(c[e>>2]|0)+32>>2]&255](s,Q);r=l;if((a[r]&1)==0){c[l+4>>2]=0;a[r]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];A2(t|0,0,12);tV(s)}else{c5[c[R+40>>2]&255](v,Q);v=f;C=c[u>>2]|0;a[v]=C&255;C=C>>8;a[v+1|0]=C&255;C=C>>8;a[v+2|0]=C&255;C=C>>8;a[v+3|0]=C&255;c5[c[(c[e>>2]|0)+28>>2]&255](w,Q);v=l;if((a[v]&1)==0){c[l+4>>2]=0;a[v]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[v>>2]=c[x>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];A2(x|0,0,12);tV(w)}w=e;c[g>>2]=da[c[(c[w>>2]|0)+12>>2]&255](Q)|0;c[h>>2]=da[c[(c[w>>2]|0)+16>>2]&255](Q)|0;c5[c[(c[e>>2]|0)+20>>2]&255](y,Q);x=j;if((a[x]&1)==0){a[j+1|0]=0;a[x]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[x>>2]=c[z>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];A2(z|0,0,12);tH(y);c5[c[(c[e>>2]|0)+24>>2]&255](A,Q);e=k;if((a[e]&1)==0){c[k+4>>2]=0;a[e]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}tY(k,0);c[e>>2]=c[B>>2];c[e+4>>2]=c[B+4>>2];c[e+8>>2]=c[B+8>>2];A2(B|0,0,12);tV(A);S=da[c[(c[w>>2]|0)+36>>2]&255](Q)|0;c[m>>2]=S;i=n;return}else{if((c[218772]|0)!=-1){c[o>>2]=875088;c[o+4>>2]=36;c[o+8>>2]=0;tA(875088,o,144)}o=(c[218773]|0)-1|0;Q=c[P+8>>2]|0;if((c[P+12>>2]|0)-Q>>2>>>0<=o>>>0){T=cJ(4)|0;U=T;Aq(U);bQ(T|0,97088,288)}P=c[Q+(o<<2)>>2]|0;if((P|0)==0){T=cJ(4)|0;U=T;Aq(U);bQ(T|0,97088,288)}T=P;U=c[P>>2]|0;if(d){c5[c[U+44>>2]&255](E,T);E=f;C=c[D>>2]|0;a[E]=C&255;C=C>>8;a[E+1|0]=C&255;C=C>>8;a[E+2|0]=C&255;C=C>>8;a[E+3|0]=C&255;c5[c[(c[P>>2]|0)+32>>2]&255](F,T);E=l;if((a[E]&1)==0){c[l+4>>2]=0;a[E]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[E>>2]=c[G>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];A2(G|0,0,12);tV(F)}else{c5[c[U+40>>2]&255](I,T);I=f;C=c[H>>2]|0;a[I]=C&255;C=C>>8;a[I+1|0]=C&255;C=C>>8;a[I+2|0]=C&255;C=C>>8;a[I+3|0]=C&255;c5[c[(c[P>>2]|0)+28>>2]&255](J,T);I=l;if((a[I]&1)==0){c[l+4>>2]=0;a[I]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}tY(l,0);c[I>>2]=c[K>>2];c[I+4>>2]=c[K+4>>2];c[I+8>>2]=c[K+8>>2];A2(K|0,0,12);tV(J)}J=P;c[g>>2]=da[c[(c[J>>2]|0)+12>>2]&255](T)|0;c[h>>2]=da[c[(c[J>>2]|0)+16>>2]&255](T)|0;c5[c[(c[P>>2]|0)+20>>2]&255](L,T);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}tM(j,0);c[h>>2]=c[M>>2];c[h+4>>2]=c[M+4>>2];c[h+8>>2]=c[M+8>>2];A2(M|0,0,12);tH(L);c5[c[(c[P>>2]|0)+24>>2]&255](N,T);P=k;if((a[P]&1)==0){c[k+4>>2]=0;a[P]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}tY(k,0);c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2];A2(O|0,0,12);tV(N);S=da[c[(c[J>>2]|0)+36>>2]&255](T)|0;c[m>>2]=S;i=n;return}}function x7(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0;c[e>>2]=b;r=i;s=p;t=p+4|0;u=p+8|0;p=o;v=(f&512|0)==0;w=o+4|0;x=o+8|0;o=(q|0)>0;y=n;z=n+1|0;A=n+8|0;B=n+4|0;n=i;C=g;g=0;while(1){L1078:do{switch(a[k+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 1:{c[d>>2]=c[e>>2];E=c7[c[(c[r>>2]|0)+44>>2]&255](i,32)|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 3:{E=a[s]|0;F=E&255;if((F&1|0)==0){G=F>>>1}else{G=c[t>>2]|0}if((G|0)==0){D=C;break L1078}if((E&1)==0){H=t}else{H=c[u>>2]|0}E=c[H>>2]|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 2:{E=a[p]|0;F=E&255;I=(F&1|0)==0;if(I){J=F>>>1}else{J=c[w>>2]|0}if((J|0)==0|v){D=C;break L1078}if((E&1)==0){K=w;L=w;M=w}else{E=c[x>>2]|0;K=E;L=E;M=E}if(I){N=F>>>1}else{N=c[w>>2]|0}F=K+(N<<2)|0;I=c[e>>2]|0;if((L|0)==(F|0)){O=I}else{E=(K+(N-1<<2)+(-M|0)|0)>>>2;P=L;Q=I;while(1){c[Q>>2]=c[P>>2];R=P+4|0;if((R|0)==(F|0)){break}P=R;Q=Q+4|0}O=I+(E+1<<2)|0}c[e>>2]=O;D=C;break};case 4:{Q=c[e>>2]|0;P=j?C+4|0:C;L1112:do{if(P>>>0<h>>>0){F=P;while(1){R=F+4|0;if(!(c8[c[(c[n>>2]|0)+12>>2]&127](i,2048,c[F>>2]|0)|0)){S=F;break L1112}if(R>>>0<h>>>0){F=R}else{S=R;break}}}else{S=P}}while(0);if(o){if(S>>>0>P>>>0){E=S;I=q;do{E=E-4|0;F=c[E>>2]|0;R=c[e>>2]|0;c[e>>2]=R+4;c[R>>2]=F;I=I-1|0;T=(I|0)>0;}while(E>>>0>P>>>0&T);if(T){U=I;V=E;W=937}else{X=0;Y=I;Z=E}}else{U=q;V=S;W=937}if((W|0)==937){W=0;X=c7[c[(c[r>>2]|0)+44>>2]&255](i,48)|0;Y=U;Z=V}F=c[e>>2]|0;c[e>>2]=F+4;if((Y|0)>0){R=Y;_=F;while(1){c[_>>2]=X;$=R-1|0;aa=c[e>>2]|0;c[e>>2]=aa+4;if(($|0)>0){R=$;_=aa}else{ab=aa;break}}}else{ab=F}c[ab>>2]=l;ac=Z}else{ac=S}if((ac|0)==(P|0)){_=c7[c[(c[r>>2]|0)+44>>2]&255](i,48)|0;R=c[e>>2]|0;c[e>>2]=R+4;c[R>>2]=_}else{_=a[y]|0;R=_&255;if((R&1|0)==0){ad=R>>>1}else{ad=c[B>>2]|0}if((ad|0)==0){ae=ac;af=0;ag=0;ah=-1}else{if((_&1)==0){ai=z}else{ai=c[A>>2]|0}ae=ac;af=0;ag=0;ah=a[ai]|0}while(1){do{if((af|0)==(ah|0)){_=c[e>>2]|0;c[e>>2]=_+4;c[_>>2]=m;_=ag+1|0;R=a[y]|0;E=R&255;if((E&1|0)==0){aj=E>>>1}else{aj=c[B>>2]|0}if(_>>>0>=aj>>>0){ak=ah;al=_;am=0;break}E=(R&1)==0;if(E){an=z}else{an=c[A>>2]|0}if((a[an+_|0]|0)==127){ak=-1;al=_;am=0;break}if(E){ao=z}else{ao=c[A>>2]|0}ak=a[ao+_|0]|0;al=_;am=0}else{ak=ah;al=ag;am=af}}while(0);_=ae-4|0;E=c[_>>2]|0;R=c[e>>2]|0;c[e>>2]=R+4;c[R>>2]=E;if((_|0)==(P|0)){break}else{ae=_;af=am+1|0;ag=al;ah=ak}}}F=c[e>>2]|0;if((Q|0)==(F|0)){D=P;break L1078}_=F-4|0;if(Q>>>0<_>>>0){ap=Q;aq=_}else{D=P;break L1078}while(1){_=c[ap>>2]|0;c[ap>>2]=c[aq>>2];c[aq>>2]=_;_=ap+4|0;F=aq-4|0;if(_>>>0<F>>>0){ap=_;aq=F}else{D=P;break}}break};default:{D=C}}}while(0);P=g+1|0;if(P>>>0<4>>>0){C=D;g=P}else{break}}g=a[s]|0;s=g&255;D=(s&1|0)==0;if(D){ar=s>>>1}else{ar=c[t>>2]|0}if(ar>>>0>1>>>0){if((g&1)==0){as=t;at=t;au=t}else{g=c[u>>2]|0;as=g;at=g;au=g}if(D){av=s>>>1}else{av=c[t>>2]|0}t=as+(av<<2)|0;s=c[e>>2]|0;D=at+4|0;if((D|0)==(t|0)){aw=s}else{at=((as+(av-2<<2)+(-au|0)|0)>>>2)+1|0;au=s;av=D;while(1){c[au>>2]=c[av>>2];D=av+4|0;if((D|0)==(t|0)){break}else{au=au+4|0;av=D}}aw=s+(at<<2)|0}c[e>>2]=aw}aw=f&176;if((aw|0)==32){c[d>>2]=c[e>>2];return}else if((aw|0)==16){return}else{c[d>>2]=b;return}}function x8(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;e=i;i=i+32|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=n;p=i;i=i+4|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+4|0;i=i+7&-8;y=i;i=i+400|0;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;t3(m,h);C=m|0;D=c[C>>2]|0;if((c[218654]|0)!=-1){c[l>>2]=874616;c[l+4>>2]=36;c[l+8>>2]=0;tA(874616,l,144)}l=(c[218655]|0)-1|0;E=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-E>>2>>>0>l>>>0){F=c[E+(l<<2)>>2]|0;if((F|0)==0){break}G=F;H=k;I=a[H]|0;J=I&255;if((J&1|0)==0){K=J>>>1}else{K=c[k+4>>2]|0}if((K|0)==0){L=0}else{if((I&1)==0){M=k+4|0}else{M=c[k+8>>2]|0}I=c[M>>2]|0;L=(I|0)==(c7[c[(c[F>>2]|0)+44>>2]&255](G,45)|0)}c[n>>2]=0;A2(s|0,0,12);A2(u|0,0,12);A2(w|0,0,12);x6(g,L,m,o,p,q,r,t,v,x);F=y|0;I=a[H]|0;J=I&255;N=(J&1|0)==0;if(N){O=J>>>1}else{O=c[k+4>>2]|0}P=c[x>>2]|0;if((O|0)>(P|0)){if(N){Q=J>>>1}else{Q=c[k+4>>2]|0}J=d[w]|0;if((J&1|0)==0){R=J>>>1}else{R=c[v+4>>2]|0}J=d[u]|0;if((J&1|0)==0){S=J>>>1}else{S=c[t+4>>2]|0}T=(Q-P<<1|1)+R+S|0}else{J=d[w]|0;if((J&1|0)==0){U=J>>>1}else{U=c[v+4>>2]|0}J=d[u]|0;if((J&1|0)==0){V=J>>>1}else{V=c[t+4>>2]|0}T=U+2+V|0}J=T+P|0;do{if(J>>>0>100>>>0){N=AL(J<<2)|0;W=N;if((N|0)!=0){X=W;Y=W;Z=I;break}AY();X=W;Y=W;Z=a[H]|0}else{X=F;Y=0;Z=I}}while(0);if((Z&1)==0){_=k+4|0;$=k+4|0}else{I=c[k+8>>2]|0;_=I;$=I}I=Z&255;if((I&1|0)==0){aa=I>>>1}else{aa=c[k+4>>2]|0}x7(X,z,A,c[h+4>>2]|0,$,_+(aa<<2)|0,G,L,o,c[p>>2]|0,c[q>>2]|0,r,t,v,P);c[B>>2]=c[f>>2];wk(b,B,X,c[z>>2]|0,c[A>>2]|0,h,j);if((Y|0)==0){tV(v);tV(t);tH(r);ab=c[C>>2]|0;ac=ab|0;ad=td(ac)|0;i=e;return}AM(Y);tV(v);tV(t);tH(r);ab=c[C>>2]|0;ac=ab|0;ad=td(ac)|0;i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function x9(a){a=a|0;tb(a|0);AT(a);return}function ya(a){a=a|0;tb(a|0);return}function yb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=bx(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function yc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;j=d|0;k=j;A2(k|0,0,12);l=b;m=h;n=a[h]|0;if((n&1)==0){o=m+1|0;p=m+1|0}else{m=c[h+8>>2]|0;o=m;p=m}m=n&255;if((m&1|0)==0){q=m>>>1}else{q=c[h+4>>2]|0}h=o+q|0;do{if(p>>>0<h>>>0){q=p;do{tN(j,a[q]|0);q=q+1|0;}while(q>>>0<h>>>0);q=(e|0)==-1?-1:e<<1;if((a[k]&1)==0){r=q;s=1069;break}t=c[j+8>>2]|0;u=q}else{r=(e|0)==-1?-1:e<<1;s=1069}}while(0);if((s|0)==1069){t=j+1|0;u=r}r=by(u|0,f|0,g|0,t|0)|0;A2(l|0,0,12);l=A1(r|0)|0;t=r+l|0;if((l|0)>0){v=r}else{tH(j);i=d;return}do{tN(b,a[v]|0);v=v+1|0;}while(v>>>0<t>>>0);tH(j);i=d;return}function yd(a,b){a=a|0;b=b|0;cg(((b|0)==-1?-1:b<<1)|0)|0;return}function ye(a){a=a|0;tb(a|0);AT(a);return}function yf(a){a=a|0;tb(a|0);return}function yg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=bx(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function yh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+224|0;j=d|0;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=r;t=i;i=i+8|0;u=i;i=i+8|0;A2(s|0,0,12);v=b;w=j;x=n;y=t|0;c[t+4>>2]=0;c[t>>2]=92512;z=a[h]|0;if((z&1)==0){A=h+4|0;B=h+4|0}else{C=c[h+8>>2]|0;A=C;B=C}C=z&255;if((C&1|0)==0){D=C>>>1}else{D=c[h+4>>2]|0}h=A+(D<<2)|0;c[j>>2]=0;c[j+4>>2]=0;L1312:do{if(B>>>0<h>>>0){j=t;D=k|0;A=k+32|0;C=B;z=92512;while(1){c[m>>2]=C;E=(de[c[z+12>>2]&63](y,w,C,h,m,D,A,l)|0)==2;F=c[m>>2]|0;if(E|(F|0)==(C|0)){break}if(D>>>0<(c[l>>2]|0)>>>0){E=D;do{tN(r,a[E]|0);E=E+1|0;}while(E>>>0<(c[l>>2]|0)>>>0);G=c[m>>2]|0}else{G=F}if(G>>>0>=h>>>0){break L1312}C=G;z=c[j>>2]|0}j=cJ(8)|0;tj(j,81992);bQ(j|0,97120,46)}}while(0);tb(t|0);if((a[s]&1)==0){H=r+1|0}else{H=c[r+8>>2]|0}s=by(((e|0)==-1?-1:e<<1)|0,f|0,g|0,H|0)|0;A2(v|0,0,12);v=u|0;c[u+4>>2]=0;c[u>>2]=92456;H=A1(s|0)|0;g=s+H|0;c[n>>2]=0;c[n+4>>2]=0;if((H|0)<1){I=u|0;tb(I);tH(r);i=d;return}H=u;n=g;f=o|0;e=o+128|0;o=s;s=92456;while(1){c[q>>2]=o;t=(de[c[s+16>>2]&63](v,x,o,(n-o|0)>32?o+32|0:g,q,f,e,p)|0)==2;G=c[q>>2]|0;if(t|(G|0)==(o|0)){break}if(f>>>0<(c[p>>2]|0)>>>0){t=f;do{tZ(b,c[t>>2]|0);t=t+4|0;}while(t>>>0<(c[p>>2]|0)>>>0);J=c[q>>2]|0}else{J=G}if(J>>>0>=g>>>0){K=1136;break}o=J;s=c[H>>2]|0}if((K|0)==1136){I=u|0;tb(I);tH(r);i=d;return}d=cJ(8)|0;tj(d,81992);bQ(d|0,97120,46)}function yi(a,b){a=a|0;b=b|0;cg(((b|0)==-1?-1:b<<1)|0)|0;return}function yj(b){b=b|0;var d=0,e=0,f=0;c[b>>2]=91872;d=b+8|0;e=c[d>>2]|0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);if((e|0)==(c[218270]|0)){f=b|0;tb(f);return}bw(c[d>>2]|0);f=b|0;tb(f);return}function yk(a){a=a|0;a=cJ(8)|0;te(a,87064);c[a>>2]=90808;bQ(a|0,97152,58)}function yl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+448|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d-1;c[b>>2]=92128;d=b+8|0;I=b+12|0;a[b+136|0]=1;J=b+24|0;K=J;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J+112;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J-1|0;}while((J|0)!=0);tE(b+144|0,86736,1);J=c[d>>2]|0;d=c[I>>2]|0;if((J|0)!=(d|0)){c[I>>2]=d+(~((d-4+(-J|0)|0)>>>2)<<2)}c[218327]=0;c[218326]=91832;if((c[218576]|0)!=-1){c[H>>2]=874304;c[H+4>>2]=36;c[H+8>>2]=0;tA(874304,H,144)}ym(b,873304,(c[218577]|0)-1|0);c[218325]=0;c[218324]=91792;if((c[218574]|0)!=-1){c[G>>2]=874296;c[G+4>>2]=36;c[G+8>>2]=0;tA(874296,G,144)}ym(b,873296,(c[218575]|0)-1|0);c[218381]=0;c[218380]=92240;c[218382]=0;a[873532]=0;c[218382]=c[(bu()|0)>>2];if((c[218656]|0)!=-1){c[F>>2]=874624;c[F+4>>2]=36;c[F+8>>2]=0;tA(874624,F,144)}ym(b,873520,(c[218657]|0)-1|0);c[218379]=0;c[218378]=92160;if((c[218654]|0)!=-1){c[E>>2]=874616;c[E+4>>2]=36;c[E+8>>2]=0;tA(874616,E,144)}ym(b,873512,(c[218655]|0)-1|0);c[218333]=0;c[218332]=91928;if((c[218580]|0)!=-1){c[D>>2]=874320;c[D+4>>2]=36;c[D+8>>2]=0;tA(874320,D,144)}ym(b,873328,(c[218581]|0)-1|0);c[218329]=0;c[218328]=91872;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);c[218330]=c[218270];if((c[218578]|0)!=-1){c[C>>2]=874312;c[C+4>>2]=36;c[C+8>>2]=0;tA(874312,C,144)}ym(b,873312,(c[218579]|0)-1|0);c[218335]=0;c[218334]=91984;if((c[218582]|0)!=-1){c[B>>2]=874328;c[B+4>>2]=36;c[B+8>>2]=0;tA(874328,B,144)}ym(b,873336,(c[218583]|0)-1|0);c[218337]=0;c[218336]=92040;if((c[218584]|0)!=-1){c[A>>2]=874336;c[A+4>>2]=36;c[A+8>>2]=0;tA(874336,A,144)}ym(b,873344,(c[218585]|0)-1|0);c[218307]=0;c[218306]=91336;a[873232]=46;a[873233]=44;A2(873236,0,12);if((c[218560]|0)!=-1){c[z>>2]=874240;c[z+4>>2]=36;c[z+8>>2]=0;tA(874240,z,144)}ym(b,873224,(c[218561]|0)-1|0);c[218299]=0;c[218298]=91288;c[218300]=46;c[218301]=44;A2(873208,0,12);if((c[218558]|0)!=-1){c[y>>2]=874232;c[y+4>>2]=36;c[y+8>>2]=0;tA(874232,y,144)}ym(b,873192,(c[218559]|0)-1|0);c[218323]=0;c[218322]=91720;if((c[218572]|0)!=-1){c[x>>2]=874288;c[x+4>>2]=36;c[x+8>>2]=0;tA(874288,x,144)}ym(b,873288,(c[218573]|0)-1|0);c[218321]=0;c[218320]=91648;if((c[218570]|0)!=-1){c[w>>2]=874280;c[w+4>>2]=36;c[w+8>>2]=0;tA(874280,w,144)}ym(b,873280,(c[218571]|0)-1|0);c[218319]=0;c[218318]=91584;if((c[218568]|0)!=-1){c[v>>2]=874272;c[v+4>>2]=36;c[v+8>>2]=0;tA(874272,v,144)}ym(b,873272,(c[218569]|0)-1|0);c[218317]=0;c[218316]=91520;if((c[218566]|0)!=-1){c[u>>2]=874264;c[u+4>>2]=36;c[u+8>>2]=0;tA(874264,u,144)}ym(b,873264,(c[218567]|0)-1|0);c[218391]=0;c[218390]=93344;if((c[218776]|0)!=-1){c[t>>2]=875104;c[t+4>>2]=36;c[t+8>>2]=0;tA(875104,t,144)}ym(b,873560,(c[218777]|0)-1|0);c[218389]=0;c[218388]=93280;if((c[218774]|0)!=-1){c[s>>2]=875096;c[s+4>>2]=36;c[s+8>>2]=0;tA(875096,s,144)}ym(b,873552,(c[218775]|0)-1|0);c[218387]=0;c[218386]=93216;if((c[218772]|0)!=-1){c[r>>2]=875088;c[r+4>>2]=36;c[r+8>>2]=0;tA(875088,r,144)}ym(b,873544,(c[218773]|0)-1|0);c[218385]=0;c[218384]=93152;if((c[218770]|0)!=-1){c[q>>2]=875080;c[q+4>>2]=36;c[q+8>>2]=0;tA(875080,q,144)}ym(b,873536,(c[218771]|0)-1|0);c[218281]=0;c[218280]=90992;if((c[218548]|0)!=-1){c[p>>2]=874192;c[p+4>>2]=36;c[p+8>>2]=0;tA(874192,p,144)}ym(b,873120,(c[218549]|0)-1|0);c[218279]=0;c[218278]=90952;if((c[218546]|0)!=-1){c[o>>2]=874184;c[o+4>>2]=36;c[o+8>>2]=0;tA(874184,o,144)}ym(b,873112,(c[218547]|0)-1|0);c[218277]=0;c[218276]=90912;if((c[218544]|0)!=-1){c[n>>2]=874176;c[n+4>>2]=36;c[n+8>>2]=0;tA(874176,n,144)}ym(b,873104,(c[218545]|0)-1|0);c[218275]=0;c[218274]=90872;if((c[218542]|0)!=-1){c[m>>2]=874168;c[m+4>>2]=36;c[m+8>>2]=0;tA(874168,m,144)}ym(b,873096,(c[218543]|0)-1|0);c[218295]=0;c[218294]=91192;c[218296]=91240;if((c[218556]|0)!=-1){c[l>>2]=874224;c[l+4>>2]=36;c[l+8>>2]=0;tA(874224,l,144)}ym(b,873176,(c[218557]|0)-1|0);c[218291]=0;c[218290]=91096;c[218292]=91144;if((c[218554]|0)!=-1){c[k>>2]=874216;c[k+4>>2]=36;c[k+8>>2]=0;tA(874216,k,144)}ym(b,873160,(c[218555]|0)-1|0);c[218287]=0;c[218286]=92096;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);c[218288]=c[218270];c[218286]=91064;if((c[218552]|0)!=-1){c[j>>2]=874208;c[j+4>>2]=36;c[j+8>>2]=0;tA(874208,j,144)}ym(b,873144,(c[218553]|0)-1|0);c[218283]=0;c[218282]=92096;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);c[218284]=c[218270];c[218282]=91032;if((c[218550]|0)!=-1){c[h>>2]=874200;c[h+4>>2]=36;c[h+8>>2]=0;tA(874200,h,144)}ym(b,873128,(c[218551]|0)-1|0);c[218315]=0;c[218314]=91424;if((c[218564]|0)!=-1){c[g>>2]=874256;c[g+4>>2]=36;c[g+8>>2]=0;tA(874256,g,144)}ym(b,873256,(c[218565]|0)-1|0);c[218313]=0;c[218312]=91384;if((c[218562]|0)!=-1){c[f>>2]=874248;c[f+4>>2]=36;c[f+8>>2]=0;tA(874248,f,144)}ym(b,873248,(c[218563]|0)-1|0);i=e;return}function ym(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;tc(b|0);e=a+8|0;f=a+12|0;a=c[f>>2]|0;g=e|0;h=c[g>>2]|0;i=a-h>>2;do{if(i>>>0>d>>>0){j=h}else{k=d+1|0;if(i>>>0<k>>>0){z6(e,k-i|0);j=c[g>>2]|0;break}if(i>>>0<=k>>>0){j=h;break}l=h+(k<<2)|0;if((l|0)==(a|0)){j=h;break}c[f>>2]=a+(~((a-4+(-l|0)|0)>>>2)<<2);j=h}}while(0);h=c[j+(d<<2)>>2]|0;if((h|0)==0){m=j;n=m+(d<<2)|0;c[n>>2]=b;return}td(h|0)|0;m=c[g>>2]|0;n=m+(d<<2)|0;c[n>>2]=b;return}function yn(a){a=a|0;yo(a);AT(a);return}function yo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c[b>>2]=92128;d=b+12|0;e=c[d>>2]|0;f=b+8|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=0;i=g;g=e;while(1){e=c[i+(h<<2)>>2]|0;if((e|0)==0){j=g;k=i}else{l=e|0;td(l)|0;j=c[d>>2]|0;k=c[f>>2]|0}l=h+1|0;if(l>>>0<j-k>>2>>>0){h=l;i=k;g=j}else{break}}}tH(b+144|0);j=c[f>>2]|0;if((j|0)==0){m=b|0;tb(m);return}f=c[d>>2]|0;if((j|0)!=(f|0)){c[d>>2]=f+(~((f-4+(-j|0)|0)>>>2)<<2)}if((j|0)==(b+24|0)){a[b+136|0]=0;m=b|0;tb(m);return}else{AT(j);m=b|0;tb(m);return}}function yp(){var b=0,d=0;if((a[18202464]|0)!=0){b=c[218262]|0;return b|0}if((bD(18202464)|0)==0){b=c[218262]|0;return b|0}do{if((a[18202472]|0)==0){if((bD(18202472)|0)==0){break}yl(873352,1);c[218266]=873352;c[218264]=873064}}while(0);d=c[c[218264]>>2]|0;c[218268]=d;tc(d|0);c[218262]=873072;b=c[218262]|0;return b|0}function yq(a){a=a|0;var b=0;b=c[(yp()|0)>>2]|0;c[a>>2]=b;tc(b|0);return}function yr(a,b){a=a|0;b=b|0;var d=0;d=c[b>>2]|0;c[a>>2]=d;tc(d|0);return}function ys(a){a=a|0;td(c[a>>2]|0)|0;return}function yt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d|0;f=c[a>>2]|0;a=b|0;if((c[a>>2]|0)!=-1){c[e>>2]=b;c[e+4>>2]=36;c[e+8>>2]=0;tA(a,e,144)}e=(c[b+4>>2]|0)-1|0;b=c[f+8>>2]|0;if((c[f+12>>2]|0)-b>>2>>>0<=e>>>0){g=cJ(4)|0;h=g;Aq(h);bQ(g|0,97088,288);return 0}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=cJ(4)|0;h=g;Aq(h);bQ(g|0,97088,288);return 0}else{i=d;return f|0}return 0}function yu(a){a=a|0;tb(a|0);AT(a);return}function yv(a){a=a|0;if((a|0)==0){return}c4[c[(c[a>>2]|0)+4>>2]&511](a);return}function yw(a){a=a|0;c[a+4>>2]=(I=c[218586]|0,c[218586]=I+1,I)+1;return}function yx(a){a=a|0;tb(a|0);AT(a);return}function yy(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;if(e>>>0>=128>>>0){f=0;return f|0}f=(b[(c[(bu()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;return f|0}function yz(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){f=c[h>>2]|0;if(f>>>0<128>>>0){j=b[(c[(bu()|0)>>2]|0)+(f<<1)>>1]|0}else{j=0}b[i>>1]=j;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;i=i+2|0}}return g|0}function yA(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((e|0)==(f|0)){g=e;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128>>>0){if((b[(c[(bu()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0){g=h;i=1358;break}}e=h+4|0;if((e|0)==(f|0)){g=f;i=1359;break}else{h=e}}if((i|0)==1358){return g|0}else if((i|0)==1359){return g|0}return 0}function yB(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;L1603:do{if((e|0)==(f|0)){g=e}else{a=e;while(1){h=c[a>>2]|0;if(h>>>0>=128>>>0){g=a;break L1603}i=a+4|0;if((b[(c[(bu()|0)>>2]|0)+(h<<1)>>1]&d)<<16>>16==0){g=a;break L1603}if((i|0)==(f|0)){g=f;break}else{a=i}}}}while(0);return g|0}function yC(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}d=c[(c[(cQ()|0)>>2]|0)+(b<<2)>>2]|0;return d|0}function yD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){g=c[(c[(cQ()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}return e|0}function yE(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}d=c[(c[(cR()|0)>>2]|0)+(b<<2)>>2]|0;return d|0}function yF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){g=c[(c[(cR()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}return e|0}function yG(a,b){a=a|0;b=b|0;return b<<24>>24|0}function yH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){c[i>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{h=f;i=i+4|0}}return g|0}function yI(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128>>>0?b&255:c)|0}function yJ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;if((d|0)==(e|0)){h=d;return h|0}b=((e-4+(-d|0)|0)>>>2)+1|0;i=d;j=g;while(1){g=c[i>>2]|0;a[j]=g>>>0<128>>>0?g&255:f;g=i+4|0;if((g|0)==(e|0)){break}else{i=g;j=j+1|0}}h=d+(b<<2)|0;return h|0}function yK(b){b=b|0;var d=0;c[b>>2]=92240;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}AU(d)}}while(0);tb(b|0);AT(b);return}function yL(b){b=b|0;var d=0;c[b>>2]=92240;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}AU(d)}}while(0);tb(b|0);return}function yM(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<=-1){d=b;return d|0}d=c[(c[(cQ()|0)>>2]|0)+((b&255)<<2)>>2]&255;return d|0}function yN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(cQ()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}return f|0}function yO(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<=-1){d=b;return d|0}d=c[(c[(cR()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;return d|0}function yP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(cR()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}return f|0}function yQ(a,b){a=a|0;b=b|0;return b|0}function yR(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((c|0)==(d|0)){f=c;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{g=e;h=h+1|0}}return f|0}function yS(a,b,c){a=a|0;b=b|0;c=c|0;return(b<<24>>24>-1?b:c)|0}function yT(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((c|0)==(d|0)){g=c;return g|0}else{h=c;i=f}while(1){f=a[h]|0;a[i]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{h=f;i=i+1|0}}return g|0}function yU(a){a=a|0;tb(a|0);AT(a);return}function yV(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function yW(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function yX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function yY(a){a=a|0;return 1}function yZ(a){a=a|0;return 1}function y_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return(b>>>0<e>>>0?b:e)|0}function y$(a){a=a|0;return 1}function y0(a){a=a|0;yj(a);AT(a);return}function y1(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;l=i;i=i+8|0;m=l|0;n=m;o=i;i=i+4|0;i=i+7&-8;p=(e|0)==(f|0);L1724:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=d;s=j;u=b+8|0;v=o|0;w=h;x=e;y=t;while(1){z=c[r+4>>2]|0;c[m>>2]=c[r>>2];c[m+4>>2]=z;z=cm(c[u>>2]|0)|0;A=Aj(w,g,y-x>>2,s-w|0,d)|0;if((z|0)!=0){cm(z|0)|0}if((A|0)==(-1|0)){B=1490;break}else if((A|0)==0){C=1;B=1526;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=1523;break}if((y|0)==(f|0)){D=f;E=z;F=c[g>>2]|0}else{z=cm(c[u>>2]|0)|0;A=Ai(v,0,d)|0;if((z|0)!=0){cm(z|0)|0}if((A|0)==-1){C=2;B=1528;break}z=c[k>>2]|0;if(A>>>0>(s-z|0)>>>0){C=1;B=1529;break}L1748:do{if((A|0)!=0){G=A;H=v;I=z;while(1){J=a[H]|0;c[k>>2]=I+1;a[I]=J;J=G-1|0;if((J|0)==0){break L1748}G=J;H=H+1|0;I=c[k>>2]|0}}}while(0);z=(c[g>>2]|0)+4|0;c[g>>2]=z;L1753:do{if((z|0)==(f|0)){K=f}else{A=z;while(1){I=A+4|0;if((c[A>>2]|0)==0){K=A;break L1753}if((I|0)==(f|0)){K=f;break}else{A=I}}}}while(0);D=K;E=c[k>>2]|0;F=z}if((F|0)==(f|0)|(E|0)==(j|0)){q=F;break L1724}else{w=E;x=F;y=D}}if((B|0)==1490){c[k>>2]=w;L1761:do{if((x|0)==(c[g>>2]|0)){L=x}else{y=x;v=w;while(1){s=c[y>>2]|0;r=cm(c[u>>2]|0)|0;A=Ai(v,s,n)|0;if((r|0)!=0){cm(r|0)|0}if((A|0)==-1){L=y;break L1761}r=(c[k>>2]|0)+A|0;c[k>>2]=r;A=y+4|0;if((A|0)==(c[g>>2]|0)){L=A;break}else{y=A;v=r}}}}while(0);c[g>>2]=L;C=2;i=l;return C|0}else if((B|0)==1523){q=c[g>>2]|0;break}else if((B|0)==1526){i=l;return C|0}else if((B|0)==1528){i=l;return C|0}else if((B|0)==1529){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function y2(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=i;i=i+8|0;m=l|0;n=m;o=(e|0)==(f|0);L1778:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=d;r=j;t=b+8|0;u=h;v=e;w=s;while(1){x=c[q+4>>2]|0;c[m>>2]=c[q>>2];c[m+4>>2]=x;y=w;x=cm(c[t>>2]|0)|0;z=Af(u,g,y-v|0,r-u>>2,d)|0;if((x|0)!=0){cm(x|0)|0}if((z|0)==(-1|0)){A=1546;break}else if((z|0)==0){B=2;A=1581;break}x=(c[k>>2]|0)+(z<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=1578;break}z=c[g>>2]|0;if((w|0)==(f|0)){C=f;D=x;E=z}else{F=cm(c[t>>2]|0)|0;G=Ae(x,z,1,d)|0;if((F|0)!=0){cm(F|0)|0}if((G|0)!=0){B=2;A=1585;break}c[k>>2]=(c[k>>2]|0)+4;G=(c[g>>2]|0)+1|0;c[g>>2]=G;L1800:do{if((G|0)==(f|0)){H=f}else{F=G;while(1){z=F+1|0;if((a[F]|0)==0){H=F;break L1800}if((z|0)==(f|0)){H=f;break}else{F=z}}}}while(0);C=H;D=c[k>>2]|0;E=G}if((E|0)==(f|0)|(D|0)==(j|0)){p=E;break L1778}else{u=D;v=E;w=C}}if((A|0)==1546){c[k>>2]=u;L1808:do{if((v|0)==(c[g>>2]|0)){I=v}else{w=u;r=v;while(1){q=cm(c[t>>2]|0)|0;F=Ae(w,r,y-r|0,n)|0;if((q|0)!=0){cm(q|0)|0}if((F|0)==0){J=r+1|0}else if((F|0)==(-1|0)){A=1557;break}else if((F|0)==(-2|0)){A=1558;break}else{J=r+F|0}F=(c[k>>2]|0)+4|0;c[k>>2]=F;if((J|0)==(c[g>>2]|0)){I=J;break L1808}else{w=F;r=J}}if((A|0)==1557){c[g>>2]=r;B=2;i=l;return B|0}else if((A|0)==1558){c[g>>2]=r;B=1;i=l;return B|0}}}while(0);c[g>>2]=I;B=(I|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==1578){p=c[g>>2]|0;break}else if((A|0)==1581){i=l;return B|0}else if((A|0)==1585){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function y3(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h|0;j=cm(c[b+8>>2]|0)|0;b=Ai(e,0,d)|0;if((j|0)!=0){cm(j|0)|0}if((b|0)==(-1|0)|(b|0)==0){k=2;i=h;return k|0}j=b-1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=j;m=e;n=b}while(1){b=a[m]|0;c[g>>2]=n+1;a[n]=b;b=l-1|0;if((b|0)==0){k=0;break}l=b;m=m+1|0;n=c[g>>2]|0}i=h;return k|0}function y4(a){a=a|0;var b=0,d=0,e=0;b=a+8|0;a=cm(c[b>>2]|0)|0;d=Ah(0,0,4)|0;if((a|0)!=0){cm(a|0)|0}if((d|0)!=0){e=-1;return e|0}d=c[b>>2]|0;if((d|0)==0){e=1;return e|0}b=cm(d|0)|0;if((b|0)==0){e=0;return e|0}cm(b|0)|0;e=0;return e|0}function y5(a){a=a|0;return 0}function y6(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((f|0)==0|(d|0)==(e|0)){g=0;return g|0}h=e;i=a+8|0;a=d;d=0;j=0;while(1){k=cm(c[i>>2]|0)|0;l=Ad(a,h-a|0,b)|0;if((k|0)!=0){cm(k|0)|0}if((l|0)==0){m=1;n=a+1|0}else if((l|0)==(-1|0)|(l|0)==(-2|0)){g=d;o=1644;break}else{m=l;n=a+l|0}l=m+d|0;k=j+1|0;if(k>>>0>=f>>>0|(n|0)==(e|0)){g=l;o=1643;break}else{a=n;d=l;j=k}}if((o|0)==1643){return g|0}else if((o|0)==1644){return g|0}return 0}function y7(a){a=a|0;var b=0,d=0;b=c[a+8>>2]|0;do{if((b|0)==0){d=1}else{a=cm(b|0)|0;if((a|0)==0){d=4;break}cm(a|0)|0;d=4}}while(0);return d|0}function y8(a){a=a|0;tb(a|0);AT(a);return}function y9(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=za(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function za(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;c[g>>2]=d;c[j>>2]=h;do{if((l&2|0)!=0){if((i-h|0)<3){m=1;return m|0}else{c[j>>2]=h+1;a[h]=-17;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-69;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-65;break}}}while(0);h=f;l=c[g>>2]|0;if(l>>>0>=f>>>0){m=0;return m|0}d=i;i=l;L1901:while(1){l=b[i>>1]|0;n=l&65535;if(n>>>0>k>>>0){m=2;o=1689;break}do{if((l&65535)>>>0<128>>>0){p=c[j>>2]|0;if((d-p|0)<1){m=1;o=1688;break L1901}c[j>>2]=p+1;a[p]=l&255}else{if((l&65535)>>>0<2048>>>0){p=c[j>>2]|0;if((d-p|0)<2){m=1;o=1687;break L1901}c[j>>2]=p+1;a[p]=(n>>>6|192)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n&63|128)&255;break}if((l&65535)>>>0<55296>>>0){p=c[j>>2]|0;if((d-p|0)<3){m=1;o=1682;break L1901}c[j>>2]=p+1;a[p]=(n>>>12|224)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n>>>6&63|128)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n&63|128)&255;break}if((l&65535)>>>0>=56320>>>0){if((l&65535)>>>0<57344>>>0){m=2;o=1690;break L1901}p=c[j>>2]|0;if((d-p|0)<3){m=1;o=1691;break L1901}c[j>>2]=p+1;a[p]=(n>>>12|224)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n>>>6&63|128)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n&63|128)&255;break}if((h-i|0)<4){m=1;o=1681;break L1901}p=i+2|0;q=e[p>>1]|0;if((q&64512|0)!=56320){m=2;o=1692;break L1901}if((d-(c[j>>2]|0)|0)<4){m=1;o=1684;break L1901}r=n&960;if(((r<<10)+65536|n<<10&64512|q&1023)>>>0>k>>>0){m=2;o=1685;break L1901}c[g>>2]=p;p=(r>>>6)+1|0;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=(p>>>2|240)&255;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=(n>>>2&15|p<<4&48|128)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(n<<4&48|q>>>6&15|128)&255;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=(q&63|128)&255}}while(0);n=(c[g>>2]|0)+2|0;c[g>>2]=n;if(n>>>0<f>>>0){i=n}else{m=0;o=1683;break}}if((o|0)==1681){return m|0}else if((o|0)==1682){return m|0}else if((o|0)==1683){return m|0}else if((o|0)==1684){return m|0}else if((o|0)==1685){return m|0}else if((o|0)==1687){return m|0}else if((o|0)==1688){return m|0}else if((o|0)==1689){return m|0}else if((o|0)==1692){return m|0}else if((o|0)==1690){return m|0}else if((o|0)==1691){return m|0}return 0}function zb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=zc(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function zc(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c[g>>2]=e;c[j>>2]=h;h=c[g>>2]|0;do{if((l&4|0)==0){m=h}else{if((f-h|0)<=2){m=h;break}if((a[h]|0)!=-17){m=h;break}if((a[h+1|0]|0)!=-69){m=h;break}if((a[h+2|0]|0)!=-65){m=h;break}e=h+3|0;c[g>>2]=e;m=e}}while(0);L1947:do{if(m>>>0<f>>>0){h=f;l=i;e=c[j>>2]|0;n=m;L1949:while(1){if(e>>>0>=i>>>0){o=n;break L1947}p=a[n]|0;q=p&255;if(q>>>0>k>>>0){r=2;s=1736;break}do{if(p<<24>>24>-1){b[e>>1]=p&255;c[g>>2]=(c[g>>2]|0)+1}else{if((p&255)>>>0<194>>>0){r=2;s=1737;break L1949}if((p&255)>>>0<224>>>0){if((h-n|0)<2){r=1;s=1738;break L1949}t=d[n+1|0]|0;if((t&192|0)!=128){r=2;s=1739;break L1949}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=1740;break L1949}b[e>>1]=u&65535;c[g>>2]=(c[g>>2]|0)+2;break}if((p&255)>>>0<240>>>0){if((h-n|0)<3){r=1;s=1735;break L1949}u=a[n+1|0]|0;t=a[n+2|0]|0;if((q|0)==237){if((u&-32)<<24>>24!=-128){r=2;s=1741;break L1949}}else if((q|0)==224){if((u&-32)<<24>>24!=-96){r=2;s=1753;break L1949}}else{if((u&-64)<<24>>24!=-128){r=2;s=1752;break L1949}}v=t&255;if((v&192|0)!=128){r=2;s=1747;break L1949}t=(u&255)<<6&4032|q<<12|v&63;if((t&65535)>>>0>k>>>0){r=2;s=1742;break L1949}b[e>>1]=t&65535;c[g>>2]=(c[g>>2]|0)+3;break}if((p&255)>>>0>=245>>>0){r=2;s=1746;break L1949}if((h-n|0)<4){r=1;s=1749;break L1949}t=a[n+1|0]|0;v=a[n+2|0]|0;u=a[n+3|0]|0;if((q|0)==240){if((t+112&255)>>>0>=48>>>0){r=2;s=1744;break L1949}}else if((q|0)==244){if((t&-16)<<24>>24!=-128){r=2;s=1745;break L1949}}else{if((t&-64)<<24>>24!=-128){r=2;s=1754;break L1949}}w=v&255;if((w&192|0)!=128){r=2;s=1755;break L1949}v=u&255;if((v&192|0)!=128){r=2;s=1750;break L1949}if((l-e|0)<4){r=1;s=1751;break L1949}u=q&7;x=t&255;t=w<<6;y=v&63;if((x<<12&258048|u<<18|t&4032|y)>>>0>k>>>0){r=2;s=1748;break L1949}b[e>>1]=(x<<2&60|w>>>4&3|((x>>>4&3|u<<2)<<6)+16320|55296)&65535;u=(c[j>>2]|0)+2|0;c[j>>2]=u;b[u>>1]=(y|t&960|56320)&65535;c[g>>2]=(c[g>>2]|0)+4}}while(0);q=(c[j>>2]|0)+2|0;c[j>>2]=q;p=c[g>>2]|0;if(p>>>0<f>>>0){e=q;n=p}else{o=p;break L1947}}if((s|0)==1751){return r|0}else if((s|0)==1752){return r|0}else if((s|0)==1753){return r|0}else if((s|0)==1754){return r|0}else if((s|0)==1740){return r|0}else if((s|0)==1741){return r|0}else if((s|0)==1742){return r|0}else if((s|0)==1747){return r|0}else if((s|0)==1748){return r|0}else if((s|0)==1749){return r|0}else if((s|0)==1750){return r|0}else if((s|0)==1744){return r|0}else if((s|0)==1745){return r|0}else if((s|0)==1746){return r|0}else if((s|0)==1735){return r|0}else if((s|0)==1736){return r|0}else if((s|0)==1737){return r|0}else if((s|0)==1738){return r|0}else if((s|0)==1739){return r|0}else if((s|0)==1755){return r|0}}else{o=m}}while(0);r=o>>>0<f>>>0|0;return r|0}function zd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function ze(a){a=a|0;return 0}function zf(a){a=a|0;return 0}function zg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zh(c,d,e,1114111,0)|0}function zh(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L2020:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=0;j=h;L2022:while(1){k=a[j]|0;l=k&255;if(l>>>0>f>>>0){m=j;break L2020}do{if(k<<24>>24>-1){n=j+1|0;o=i}else{if((k&255)>>>0<194>>>0){m=j;break L2020}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L2020}p=d[j+1|0]|0;if((p&192|0)!=128){m=j;break L2020}if((p&63|l<<6&1984)>>>0>f>>>0){m=j;break L2020}n=j+2|0;o=i;break}if((k&255)>>>0<240>>>0){q=j;if((g-q|0)<3){m=j;break L2020}p=a[j+1|0]|0;r=a[j+2|0]|0;if((l|0)==224){if((p&-32)<<24>>24!=-96){s=1780;break L2022}}else if((l|0)==237){if((p&-32)<<24>>24!=-128){s=1782;break L2022}}else{if((p&-64)<<24>>24!=-128){s=1784;break L2022}}t=r&255;if((t&192|0)!=128){m=j;break L2020}if(((p&255)<<6&4032|l<<12&61440|t&63)>>>0>f>>>0){m=j;break L2020}n=j+3|0;o=i;break}if((k&255)>>>0>=245>>>0){m=j;break L2020}u=j;if((g-u|0)<4){m=j;break L2020}if((e-i|0)>>>0<2>>>0){m=j;break L2020}t=a[j+1|0]|0;p=a[j+2|0]|0;r=a[j+3|0]|0;if((l|0)==244){if((t&-16)<<24>>24!=-128){s=1795;break L2022}}else if((l|0)==240){if((t+112&255)>>>0>=48>>>0){s=1793;break L2022}}else{if((t&-64)<<24>>24!=-128){s=1797;break L2022}}v=p&255;if((v&192|0)!=128){m=j;break L2020}p=r&255;if((p&192|0)!=128){m=j;break L2020}if(((t&255)<<12&258048|l<<18&1835008|v<<6&4032|p&63)>>>0>f>>>0){m=j;break L2020}n=j+4|0;o=i+1|0}}while(0);l=o+1|0;if(n>>>0<c>>>0&l>>>0<e>>>0){i=l;j=n}else{m=n;break L2020}}if((s|0)==1793){w=u-b|0;return w|0}else if((s|0)==1795){w=u-b|0;return w|0}else if((s|0)==1780){w=q-b|0;return w|0}else if((s|0)==1782){w=q-b|0;return w|0}else if((s|0)==1784){w=q-b|0;return w|0}else if((s|0)==1797){w=u-b|0;return w|0}}else{m=h}}while(0);w=m-b|0;return w|0}function zi(a){a=a|0;return 4}function zj(a){a=a|0;tb(a|0);AT(a);return}function zk(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=zl(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function zl(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;c[e>>2]=b;c[h>>2]=f;do{if((j&2|0)!=0){if((g-f|0)<3){k=1;return k|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(f>>>0>=d>>>0){k=0;return k|0}j=g;g=f;L2086:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>i>>>0){k=2;l=1834;break}do{if(f>>>0<128>>>0){b=c[h>>2]|0;if((j-b|0)<1){k=1;l=1841;break L2086}c[h>>2]=b+1;a[b]=f&255}else{if(f>>>0<2048>>>0){b=c[h>>2]|0;if((j-b|0)<2){k=1;l=1838;break L2086}c[h>>2]=b+1;a[b]=(f>>>6|192)&255;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=(f&63|128)&255;break}b=c[h>>2]|0;m=j-b|0;if(f>>>0<65536>>>0){if((m|0)<3){k=1;l=1836;break L2086}c[h>>2]=b+1;a[b]=(f>>>12|224)&255;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=(f>>>6&63|128)&255;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=(f&63|128)&255;break}else{if((m|0)<4){k=1;l=1839;break L2086}c[h>>2]=b+1;a[b]=(f>>>18|240)&255;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=(f>>>12&63|128)&255;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=(f>>>6&63|128)&255;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=(f&63|128)&255;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{k=0;l=1837;break}}if((l|0)==1837){return k|0}else if((l|0)==1841){return k|0}else if((l|0)==1838){return k|0}else if((l|0)==1834){return k|0}else if((l|0)==1839){return k|0}else if((l|0)==1836){return k|0}return 0}function zm(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=zn(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function zn(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c[f>>2]=b;c[i>>2]=g;g=c[f>>2]|0;do{if((k&4|0)==0){l=g}else{if((e-g|0)<=2){l=g;break}if((a[g]|0)!=-17){l=g;break}if((a[g+1|0]|0)!=-69){l=g;break}if((a[g+2|0]|0)!=-65){l=g;break}b=g+3|0;c[f>>2]=b;l=b}}while(0);L2119:do{if(l>>>0<e>>>0){g=e;k=c[i>>2]|0;b=l;L2121:while(1){if(k>>>0>=h>>>0){m=b;break L2119}n=a[b]|0;o=n&255;do{if(n<<24>>24>-1){if(o>>>0>j>>>0){p=2;q=1886;break L2121}c[k>>2]=o;c[f>>2]=(c[f>>2]|0)+1}else{if((n&255)>>>0<194>>>0){p=2;q=1890;break L2121}if((n&255)>>>0<224>>>0){if((g-b|0)<2){p=1;q=1891;break L2121}r=d[b+1|0]|0;if((r&192|0)!=128){p=2;q=1883;break L2121}s=r&63|o<<6&1984;if(s>>>0>j>>>0){p=2;q=1894;break L2121}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+2;break}if((n&255)>>>0<240>>>0){if((g-b|0)<3){p=1;q=1892;break L2121}s=a[b+1|0]|0;r=a[b+2|0]|0;if((o|0)==224){if((s&-32)<<24>>24!=-96){p=2;q=1895;break L2121}}else if((o|0)==237){if((s&-32)<<24>>24!=-128){p=2;q=1898;break L2121}}else{if((s&-64)<<24>>24!=-128){p=2;q=1893;break L2121}}t=r&255;if((t&192|0)!=128){p=2;q=1897;break L2121}r=(s&255)<<6&4032|o<<12&61440|t&63;if(r>>>0>j>>>0){p=2;q=1900;break L2121}c[k>>2]=r;c[f>>2]=(c[f>>2]|0)+3;break}if((n&255)>>>0>=245>>>0){p=2;q=1899;break L2121}if((g-b|0)<4){p=1;q=1888;break L2121}r=a[b+1|0]|0;t=a[b+2|0]|0;s=a[b+3|0]|0;if((o|0)==244){if((r&-16)<<24>>24!=-128){p=2;q=1887;break L2121}}else if((o|0)==240){if((r+112&255)>>>0>=48>>>0){p=2;q=1889;break L2121}}else{if((r&-64)<<24>>24!=-128){p=2;q=1884;break L2121}}u=t&255;if((u&192|0)!=128){p=2;q=1885;break L2121}t=s&255;if((t&192|0)!=128){p=2;q=1901;break L2121}s=(r&255)<<12&258048|o<<18&1835008|u<<6&4032|t&63;if(s>>>0>j>>>0){p=2;q=1896;break L2121}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+4}}while(0);o=(c[i>>2]|0)+4|0;c[i>>2]=o;n=c[f>>2]|0;if(n>>>0<e>>>0){k=o;b=n}else{m=n;break L2119}}if((q|0)==1894){return p|0}else if((q|0)==1895){return p|0}else if((q|0)==1896){return p|0}else if((q|0)==1897){return p|0}else if((q|0)==1887){return p|0}else if((q|0)==1888){return p|0}else if((q|0)==1889){return p|0}else if((q|0)==1890){return p|0}else if((q|0)==1891){return p|0}else if((q|0)==1892){return p|0}else if((q|0)==1893){return p|0}else if((q|0)==1884){return p|0}else if((q|0)==1885){return p|0}else if((q|0)==1886){return p|0}else if((q|0)==1883){return p|0}else if((q|0)==1898){return p|0}else if((q|0)==1899){return p|0}else if((q|0)==1900){return p|0}else if((q|0)==1901){return p|0}}else{m=l}}while(0);p=m>>>0<e>>>0|0;return p|0}function zo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function zp(a){a=a|0;return 0}function zq(a){a=a|0;return 0}function zr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zs(c,d,e,1114111,0)|0}function zs(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L2190:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=1;j=h;L2192:while(1){k=a[j]|0;l=k&255;do{if(k<<24>>24>-1){if(l>>>0>f>>>0){m=j;break L2190}n=j+1|0}else{if((k&255)>>>0<194>>>0){m=j;break L2190}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L2190}o=d[j+1|0]|0;if((o&192|0)!=128){m=j;break L2190}if((o&63|l<<6&1984)>>>0>f>>>0){m=j;break L2190}n=j+2|0;break}if((k&255)>>>0<240>>>0){p=j;if((g-p|0)<3){m=j;break L2190}o=a[j+1|0]|0;q=a[j+2|0]|0;if((l|0)==224){if((o&-32)<<24>>24!=-96){r=1927;break L2192}}else if((l|0)==237){if((o&-32)<<24>>24!=-128){r=1929;break L2192}}else{if((o&-64)<<24>>24!=-128){r=1931;break L2192}}s=q&255;if((s&192|0)!=128){m=j;break L2190}if(((o&255)<<6&4032|l<<12&61440|s&63)>>>0>f>>>0){m=j;break L2190}n=j+3|0;break}if((k&255)>>>0>=245>>>0){m=j;break L2190}t=j;if((g-t|0)<4){m=j;break L2190}s=a[j+1|0]|0;o=a[j+2|0]|0;q=a[j+3|0]|0;if((l|0)==240){if((s+112&255)>>>0>=48>>>0){r=1939;break L2192}}else if((l|0)==244){if((s&-16)<<24>>24!=-128){r=1941;break L2192}}else{if((s&-64)<<24>>24!=-128){r=1943;break L2192}}u=o&255;if((u&192|0)!=128){m=j;break L2190}o=q&255;if((o&192|0)!=128){m=j;break L2190}if(((s&255)<<12&258048|l<<18&1835008|u<<6&4032|o&63)>>>0>f>>>0){m=j;break L2190}n=j+4|0}}while(0);if(!(n>>>0<c>>>0&i>>>0<e>>>0)){m=n;break L2190}i=i+1|0;j=n}if((r|0)==1939){v=t-b|0;return v|0}else if((r|0)==1943){v=t-b|0;return v|0}else if((r|0)==1941){v=t-b|0;return v|0}else if((r|0)==1927){v=p-b|0;return v|0}else if((r|0)==1929){v=p-b|0;return v|0}else if((r|0)==1931){v=p-b|0;return v|0}}else{m=h}}while(0);v=m-b|0;return v|0}function zt(a){a=a|0;return 4}function zu(a){a=a|0;tb(a|0);AT(a);return}function zv(a){a=a|0;tb(a|0);AT(a);return}function zw(a){a=a|0;c[a>>2]=91336;tH(a+12|0);tb(a|0);AT(a);return}function zx(a){a=a|0;c[a>>2]=91336;tH(a+12|0);tb(a|0);return}function zy(a){a=a|0;c[a>>2]=91288;tH(a+16|0);tb(a|0);AT(a);return}function zz(a){a=a|0;c[a>>2]=91288;tH(a+16|0);tb(a|0);return}function zA(b){b=b|0;return a[b+8|0]|0}function zB(a){a=a|0;return c[a+8>>2]|0}function zC(b){b=b|0;return a[b+9|0]|0}function zD(a){a=a|0;return c[a+12>>2]|0}function zE(a,b){a=a|0;b=b|0;tD(a,b+12|0);return}function zF(a,b){a=a|0;b=b|0;tD(a,b+16|0);return}function zG(a,b){a=a|0;b=b|0;tE(a,84512,4);return}function zH(a,b){a=a|0;b=b|0;tT(a,84352,Al(84352)|0);return}function zI(a,b){a=a|0;b=b|0;tE(a,84112,5);return}function zJ(a,b){a=a|0;b=b|0;tT(a,83896,Al(83896)|0);return}function zK(b){b=b|0;var d=0;if((a[18202560]|0)!=0){d=c[218416]|0;return d|0}if((bD(18202560)|0)==0){d=c[218416]|0;return d|0}do{if((a[18202448]|0)==0){if((bD(18202448)|0)==0){break}A2(872592,0,168);bh(364,0,r|0)|0}}while(0);tJ(872592,88688)|0;tJ(872604,88584)|0;tJ(872616,88536)|0;tJ(872628,88496)|0;tJ(872640,88480)|0;tJ(872652,88472)|0;tJ(872664,88424)|0;tJ(872676,88408)|0;tJ(872688,88400)|0;tJ(872700,88360)|0;tJ(872712,88344)|0;tJ(872724,88144)|0;tJ(872736,88088)|0;tJ(872748,88080)|0;c[218416]=872592;d=c[218416]|0;return d|0}function zL(b){b=b|0;var d=0;if((a[18202504]|0)!=0){d=c[218394]|0;return d|0}if((bD(18202504)|0)==0){d=c[218394]|0;return d|0}do{if((a[18202424]|0)==0){if((bD(18202424)|0)==0){break}A2(871848,0,168);bh(206,0,r|0)|0}}while(0);tW(871848,89840)|0;tW(871860,89736)|0;tW(871872,89696)|0;tW(871884,89640)|0;tW(871896,89536)|0;tW(871908,89488)|0;tW(871920,89248)|0;tW(871932,89232)|0;tW(871944,89096)|0;tW(871956,89024)|0;tW(871968,88880)|0;tW(871980,88808)|0;tW(871992,88776)|0;tW(872004,88760)|0;c[218394]=871848;d=c[218394]|0;return d|0}function zM(b){b=b|0;var d=0;if((a[18202552]|0)!=0){d=c[218414]|0;return d|0}if((bD(18202552)|0)==0){d=c[218414]|0;return d|0}do{if((a[18202440]|0)==0){if((bD(18202440)|0)==0){break}A2(872304,0,288);bh(264,0,r|0)|0}}while(0);tJ(872304,78208)|0;tJ(872316,78128)|0;tJ(872328,78112)|0;tJ(872340,78096)|0;tJ(872352,78072)|0;tJ(872364,78056)|0;tJ(872376,78008)|0;tJ(872388,77968)|0;tJ(872400,77904)|0;tJ(872412,77896)|0;tJ(872424,77696)|0;tJ(872436,77632)|0;tJ(872448,77560)|0;tJ(872460,77528)|0;tJ(872472,77520)|0;tJ(872484,77480)|0;tJ(872496,78072)|0;tJ(872508,77464)|0;tJ(872520,77432)|0;tJ(872532,90088)|0;tJ(872544,90064)|0;tJ(872556,89936)|0;tJ(872568,89928)|0;tJ(872580,89888)|0;c[218414]=872304;d=c[218414]|0;return d|0}function zN(b){b=b|0;var d=0;if((a[18202496]|0)!=0){d=c[218392]|0;return d|0}if((bD(18202496)|0)==0){d=c[218392]|0;return d|0}do{if((a[18202416]|0)==0){if((bD(18202416)|0)==0){break}A2(871560,0,288);bh(178,0,r|0)|0}}while(0);tW(871560,80016)|0;tW(871572,79928)|0;tW(871584,79808)|0;tW(871596,79720)|0;tW(871608,78696)|0;tW(871620,79480)|0;tW(871632,79384)|0;tW(871644,79312)|0;tW(871656,79272)|0;tW(871668,79152)|0;tW(871680,79112)|0;tW(871692,79016)|0;tW(871704,78960)|0;tW(871716,78920)|0;tW(871728,78904)|0;tW(871740,78720)|0;tW(871752,78696)|0;tW(871764,78608)|0;tW(871776,78560)|0;tW(871788,78544)|0;tW(871800,78496)|0;tW(871812,78424)|0;tW(871824,78400)|0;tW(871836,78360)|0;c[218392]=871560;d=c[218392]|0;return d|0}function zO(b){b=b|0;var d=0;if((a[18202568]|0)!=0){d=c[218418]|0;return d|0}if((bD(18202568)|0)==0){d=c[218418]|0;return d|0}do{if((a[18202456]|0)==0){if((bD(18202456)|0)==0){break}A2(872760,0,288);bh(176,0,r|0)|0}}while(0);tJ(872760,80344)|0;tJ(872772,80208)|0;c[218418]=872760;d=c[218418]|0;return d|0}function zP(b){b=b|0;var d=0;if((a[18202512]|0)!=0){d=c[218396]|0;return d|0}if((bD(18202512)|0)==0){d=c[218396]|0;return d|0}do{if((a[18202432]|0)==0){if((bD(18202432)|0)==0){break}A2(872016,0,288);bh(332,0,r|0)|0}}while(0);tW(872016,80592)|0;tW(872028,80400)|0;c[218396]=872016;d=c[218396]|0;return d|0}function zQ(b){b=b|0;if((a[18202576]|0)!=0){return 873680}if((bD(18202576)|0)==0){return 873680}tE(873680,83584,8);bh(334,873680,r|0)|0;return 873680}function zR(b){b=b|0;if((a[18202520]|0)!=0){return 873592}if((bD(18202520)|0)==0){return 873592}tT(873592,83376,Al(83376)|0);bh(266,873592,r|0)|0;return 873592}function zS(b){b=b|0;if((a[18202600]|0)!=0){return 873728}if((bD(18202600)|0)==0){return 873728}tE(873728,83024,8);bh(334,873728,r|0)|0;return 873728}function zT(b){b=b|0;if((a[18202544]|0)!=0){return 873640}if((bD(18202544)|0)==0){return 873640}tT(873640,82888,Al(82888)|0);bh(266,873640,r|0)|0;return 873640}function zU(b){b=b|0;if((a[18202592]|0)!=0){return 873712}if((bD(18202592)|0)==0){return 873712}tE(873712,82768,20);bh(334,873712,r|0)|0;return 873712}function zV(b){b=b|0;if((a[18202536]|0)!=0){return 873624}if((bD(18202536)|0)==0){return 873624}tT(873624,82560,Al(82560)|0);bh(266,873624,r|0)|0;return 873624}function zW(b){b=b|0;if((a[18202584]|0)!=0){return 873696}if((bD(18202584)|0)==0){return 873696}tE(873696,82448,11);bh(334,873696,r|0)|0;return 873696}function zX(b){b=b|0;if((a[18202528]|0)!=0){return 873608}if((bD(18202528)|0)==0){return 873608}tT(873608,82240,Al(82240)|0);bh(266,873608,r|0)|0;return 873608}function zY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=cd()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=+A_(b,g,c[218270]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function zZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=cd()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=+A_(b,g,c[218270]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function z_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=cd()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);l=+A_(b,g,c[218270]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function z$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g|0;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=cd()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);n=aP(b|0,h|0,f|0,c[218270]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=K;k=n;break}c[e>>2]=4;j=-1;k=-1}}while(0);i=g;return(K=j,k)|0}function z0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=cd()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);m=aP(b|0,h|0,f|0,c[218270]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function z1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=cd()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);m=aP(b|0,h|0,f|0,c[218270]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function z2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=cd()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);m=aP(b|0,h|0,f|0,c[218270]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>65535>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function z3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(K=j,k)|0}l=cd()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);n=cw(b|0,h|0,f|0,c[218270]|0)|0;f=K;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(K=j,k)|0}if((b|0)!=34){j=f;k=n;i=g;return(K=j,k)|0}c[e>>2]=4;e=0;b=(f|0)>(e|0)|(f|0)==(e|0)&n>>>0>0>>>0;j=b?2147483647:-2147483648;k=b?-1:0;i=g;return(K=j,k)|0}function z4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=cd()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);m=cw(b|0,h|0,f|0,c[218270]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=-1;h=0;if((b|0)==34|((f|0)<(d|0)|(f|0)==(d|0)&m>>>0<-2147483648>>>0)|((f|0)>(h|0)|(f|0)==(h|0)&m>>>0>2147483647>>>0)){c[e>>2]=4;e=0;j=(f|0)>(e|0)|(f|0)==(e|0)&m>>>0>0>>>0?2147483647:-2147483648;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function z5(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;d=(c[a>>2]|0)+(c[b+4>>2]|0)|0;a=d;e=c[b>>2]|0;if((e&1|0)==0){f=e;c4[f&511](a);return}else{f=c[(c[d>>2]|0)+(e-1)>>2]|0;c4[f&511](a);return}}function z6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=b+8|0;f=b+4|0;g=c[f>>2]|0;h=c[e>>2]|0;i=g;if(h-i>>2>>>0>=d>>>0){j=d;k=g;do{if((k|0)==0){l=0}else{c[k>>2]=0;l=c[f>>2]|0}k=l+4|0;c[f>>2]=k;j=j-1|0;}while((j|0)!=0);return}j=b+16|0;k=b|0;l=c[k>>2]|0;g=i-l>>2;i=g+d|0;if(i>>>0>1073741823>>>0){yk(0)}m=h-l|0;do{if(m>>2>>>0>536870910>>>0){n=1073741823;o=2387}else{l=m>>1;h=l>>>0<i>>>0?i:l;if((h|0)==0){p=0;q=0;break}l=b+128|0;if(!((a[l]&1)==0&h>>>0<29>>>0)){n=h;o=2387;break}a[l]=1;p=j;q=h}}while(0);if((o|0)==2387){p=AR(n<<2)|0;q=n}n=d;d=p+(g<<2)|0;do{if((d|0)==0){r=0}else{c[d>>2]=0;r=d}d=r+4|0;n=n-1|0;}while((n|0)!=0);n=p+(q<<2)|0;q=c[k>>2]|0;r=(c[f>>2]|0)-q|0;o=p+(g-(r>>2)<<2)|0;g=o;p=q;A$(g|0,p|0,r)|0;c[k>>2]=o;c[f>>2]=d;c[e>>2]=n;if((q|0)==0){return}if((q|0)==(j|0)){a[b+128|0]=0;return}else{AT(p);return}}function z7(a){a=a|0;tV(872292);tV(872280);tV(872268);tV(872256);tV(872244);tV(872232);tV(872220);tV(872208);tV(872196);tV(872184);tV(872172);tV(872160);tV(872148);tV(872136);tV(872124);tV(872112);tV(872100);tV(872088);tV(872076);tV(872064);tV(872052);tV(872040);tV(872028);tV(872016);return}function z8(a){a=a|0;tH(873036);tH(873024);tH(873012);tH(873e3);tH(872988);tH(872976);tH(872964);tH(872952);tH(872940);tH(872928);tH(872916);tH(872904);tH(872892);tH(872880);tH(872868);tH(872856);tH(872844);tH(872832);tH(872820);tH(872808);tH(872796);tH(872784);tH(872772);tH(872760);return}function z9(a){a=a|0;tV(871836);tV(871824);tV(871812);tV(871800);tV(871788);tV(871776);tV(871764);tV(871752);tV(871740);tV(871728);tV(871716);tV(871704);tV(871692);tV(871680);tV(871668);tV(871656);tV(871644);tV(871632);tV(871620);tV(871608);tV(871596);tV(871584);tV(871572);tV(871560);return}function Aa(a){a=a|0;tH(872580);tH(872568);tH(872556);tH(872544);tH(872532);tH(872520);tH(872508);tH(872496);tH(872484);tH(872472);tH(872460);tH(872448);tH(872436);tH(872424);tH(872412);tH(872400);tH(872388);tH(872376);tH(872364);tH(872352);tH(872340);tH(872328);tH(872316);tH(872304);return}function Ab(a){a=a|0;tV(872004);tV(871992);tV(871980);tV(871968);tV(871956);tV(871944);tV(871932);tV(871920);tV(871908);tV(871896);tV(871884);tV(871872);tV(871860);tV(871848);return}function Ac(a){a=a|0;tH(872748);tH(872736);tH(872724);tH(872712);tH(872700);tH(872688);tH(872676);tH(872664);tH(872652);tH(872640);tH(872628);tH(872616);tH(872604);tH(872592);return}function Ad(a,b,c){a=a|0;b=b|0;c=c|0;return Ae(0,a,b,(c|0)!=0?c:794264)|0}function Ae(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;j=((f|0)==0?794256:f)|0;f=c[j>>2]|0;L2739:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n-194|0;if(l>>>0>50>>>0){break L2739}o=d+1|0;q=c[p+(l<<2)>>2]|0;r=e-1|0;break}}else{o=d;q=f;r=e}}while(0);L2755:do{if((r|0)==0){s=q}else{l=a[o]|0;n=(l&255)>>>3;if((n-16|n+(q>>26))>>>0>7>>>0){break L2739}else{t=o;u=q;v=r;w=l}while(1){t=t+1|0;u=(w&255)-128|u<<6;v=v-1|0;if((u|0)>=0){break}if((v|0)==0){s=u;break L2755}w=a[t]|0;if(((w&255)-128|0)>>>0>63>>>0){break L2739}}c[j>>2]=0;c[m>>2]=u;k=e-v|0;i=g;return k|0}}while(0);c[j>>2]=s;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(cd()|0)>>2]=84;k=-1;i=g;return k|0}function Af(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g|0;m=k?e:256;e=k?a:l;L2770:do{if((j|0)==0|(m|0)==0){n=0;o=d;p=m;q=e;r=j}else{a=m;s=d;t=0;u=e;v=j;while(1){w=s>>>2;x=w>>>0>=a>>>0;if(!(x|s>>>0>131>>>0)){n=t;o=s;p=a;q=u;r=v;break L2770}y=x?a:w;z=s-y|0;w=Ag(u,h,y,f)|0;if((w|0)==-1){break}if((u|0)==(l|0)){A=l;B=a}else{A=u+(w<<2)|0;B=a-w|0}y=w+t|0;w=c[h>>2]|0;if((w|0)==0|(B|0)==0){n=y;o=z;p=B;q=A;r=w;break L2770}else{a=B;s=z;t=y;u=A;v=w}}n=-1;o=z;p=0;q=u;r=c[h>>2]|0}}while(0);L2780:do{if((r|0)==0){C=n}else{if((p|0)==0|(o|0)==0){C=n;break}else{D=p;E=o;F=n;G=q;H=r}while(1){I=Ae(G,H,E,f)|0;if((I+2|0)>>>0<3>>>0){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;A=D-1|0;B=F+1|0;if((A|0)==0|(E|0)==(I|0)){C=B;break L2780}else{D=A;E=E-I|0;F=B;G=G+4|0;H=z}}if((I|0)==(-1|0)){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=F;break}else{c[f>>2]=0;C=F;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Ag(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;h=c[e>>2]|0;do{if((g|0)==0){i=2456}else{j=g|0;k=c[j>>2]|0;if((k|0)==0){i=2456;break}if((b|0)==0){l=k;m=h;n=f;i=2467;break}c[j>>2]=0;o=k;q=h;r=b;s=f;i=2487}}while(0);if((i|0)==2456){if((b|0)==0){t=h;u=f;i=2458}else{v=h;w=b;x=f;i=2457}}L2801:while(1){if((i|0)==2457){i=0;if((x|0)==0){y=f;i=2505;break}else{z=x;A=w;B=v}while(1){h=a[B]|0;do{if(((h&255)-1|0)>>>0<127>>>0){if((B&3|0)==0&z>>>0>3>>>0){C=z;D=A;E=B}else{F=B;G=A;H=z;I=h;break}while(1){J=c[E>>2]|0;if(((J-16843009|J)&-2139062144|0)!=0){i=2481;break}c[D>>2]=J&255;c[D+4>>2]=d[E+1|0]|0;c[D+8>>2]=d[E+2|0]|0;K=E+4|0;L=D+16|0;c[D+12>>2]=d[E+3|0]|0;M=C-4|0;if(M>>>0>3>>>0){C=M;D=L;E=K}else{i=2482;break}}if((i|0)==2481){i=0;F=E;G=D;H=C;I=J&255;break}else if((i|0)==2482){i=0;F=K;G=L;H=M;I=a[K]|0;break}}else{F=B;G=A;H=z;I=h}}while(0);N=I&255;if((N-1|0)>>>0>=127>>>0){break}c[G>>2]=N;h=H-1|0;if((h|0)==0){y=f;i=2509;break L2801}else{z=h;A=G+4|0;B=F+1|0}}h=N-194|0;if(h>>>0>50>>>0){O=H;P=G;Q=F;i=2498;break}o=c[p+(h<<2)>>2]|0;q=F+1|0;r=G;s=H;i=2487;continue}else if((i|0)==2467){i=0;h=(d[m]|0)>>>3;if((h-16|h+(l>>26))>>>0>7>>>0){i=2468;break}h=m+1|0;do{if((l&33554432|0)==0){R=h}else{if(((d[h]|0)-128|0)>>>0>63>>>0){i=2471;break L2801}g=m+2|0;if((l&524288|0)==0){R=g;break}if(((d[g]|0)-128|0)>>>0>63>>>0){i=2474;break L2801}R=m+3|0}}while(0);t=R;u=n-1|0;i=2458;continue}else if((i|0)==2487){i=0;h=d[q]|0;g=h>>>3;if((g-16|g+(o>>26))>>>0>7>>>0){i=2488;break}g=q+1|0;S=h-128|o<<6;do{if((S|0)<0){h=(d[g]|0)-128|0;if(h>>>0>63>>>0){i=2491;break L2801}k=q+2|0;T=h|S<<6;if((T|0)>=0){U=T;V=k;break}h=(d[k]|0)-128|0;if(h>>>0>63>>>0){i=2494;break L2801}U=h|T<<6;V=q+3|0}else{U=S;V=g}}while(0);c[r>>2]=U;v=V;w=r+4|0;x=s-1|0;i=2457;continue}else if((i|0)==2458){i=0;g=a[t]|0;do{if(((g&255)-1|0)>>>0<127>>>0){if((t&3|0)!=0){W=t;X=u;Y=g;break}h=c[t>>2]|0;if(((h-16843009|h)&-2139062144|0)==0){Z=u;_=t}else{W=t;X=u;Y=h&255;break}do{_=_+4|0;Z=Z-4|0;$=c[_>>2]|0;}while((($-16843009|$)&-2139062144|0)==0);W=_;X=Z;Y=$&255}else{W=t;X=u;Y=g}}while(0);g=Y&255;if((g-1|0)>>>0<127>>>0){t=W+1|0;u=X-1|0;i=2458;continue}h=g-194|0;if(h>>>0>50>>>0){O=X;P=b;Q=W;i=2498;break}l=c[p+(h<<2)>>2]|0;m=W+1|0;n=X;i=2467;continue}}if((i|0)==2491){aa=S;ab=q-1|0;ac=r;ad=s;i=2497}else if((i|0)==2488){aa=o;ab=q-1|0;ac=r;ad=s;i=2497}else if((i|0)==2494){aa=T;ab=q-1|0;ac=r;ad=s;i=2497}else if((i|0)==2471){aa=l;ab=m-1|0;ac=b;ad=n;i=2497}else if((i|0)==2474){aa=l;ab=m-1|0;ac=b;ad=n;i=2497}else if((i|0)==2505){return y|0}else if((i|0)==2509){return y|0}else if((i|0)==2468){aa=l;ab=m-1|0;ac=b;ad=n;i=2497}if((i|0)==2497){if((aa|0)==0){O=ad;P=ac;Q=ab;i=2498}else{ae=ac;af=ab}}do{if((i|0)==2498){if((a[Q]|0)!=0){ae=P;af=Q;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}y=f-O|0;return y|0}}while(0);c[(cd()|0)>>2]=84;if((ae|0)==0){y=-1;return y|0}c[e>>2]=af;y=-1;return y|0}function Ah(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m-194|0;if(k>>>0>50>>>0){break}m=e+1|0;n=c[p+(k<<2)>>2]|0;if(f>>>0<4>>>0){if((n&-2147483648>>>(((f*6|0)-6|0)>>>0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m-16|m+(n>>26))>>>0>7>>>0){break}m=k-128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)-128|0;if(n>>>0>63>>>0){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)-128|0;if(m>>>0>63>>>0){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(cd()|0)>>2]=84;j=-1;i=g;return j|0}function Ai(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((b|0)==0){f=1;return f|0}if(d>>>0<128>>>0){a[b]=d&255;f=1;return f|0}if(d>>>0<2048>>>0){a[b]=(d>>>6|192)&255;a[b+1|0]=(d&63|128)&255;f=2;return f|0}if(d>>>0<55296>>>0|(d-57344|0)>>>0<8192>>>0){a[b]=(d>>>12|224)&255;a[b+1|0]=(d>>>6&63|128)&255;a[b+2|0]=(d&63|128)&255;f=3;return f|0}if((d-65536|0)>>>0<1048576>>>0){a[b]=(d>>>18|240)&255;a[b+1|0]=(d>>>12&63|128)&255;a[b+2|0]=(d>>>6&63|128)&255;a[b+3|0]=(d&63|128)&255;f=4;return f|0}else{c[(cd()|0)>>2]=84;f=-1;return f|0}return 0}function Aj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=c[b>>2]|0;c[g>>2]=h;j=(a|0)!=0;k=f|0;l=j?e:256;e=j?a:k;L2922:do{if((h|0)==0|(l|0)==0){m=0;n=d;o=l;p=e;q=h}else{a=l;r=d;s=0;t=e;u=h;while(1){v=r>>>0>=a>>>0;if(!(v|r>>>0>32>>>0)){m=s;n=r;o=a;p=t;q=u;break L2922}w=v?a:r;x=r-w|0;v=Ak(t,g,w,0)|0;if((v|0)==-1){break}if((t|0)==(k|0)){y=k;z=a}else{y=t+v|0;z=a-v|0}w=v+s|0;v=c[g>>2]|0;if((v|0)==0|(z|0)==0){m=w;n=x;o=z;p=y;q=v;break L2922}else{a=z;r=x;s=w;t=y;u=v}}m=-1;n=x;o=0;p=t;q=c[g>>2]|0}}while(0);L2932:do{if((q|0)==0){A=m}else{if((o|0)==0|(n|0)==0){A=m;break}else{B=o;C=n;D=m;E=p;F=q}while(1){G=Ai(E,c[F>>2]|0,0)|0;if((G+1|0)>>>0<2>>>0){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;y=C-1|0;z=D+1|0;if((B|0)==(G|0)|(y|0)==0){A=z;break L2932}else{B=B-G|0;C=y;D=z;E=E+G|0;F=x}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=D}}while(0);if(!j){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function Ak(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f|0;if((b|0)==0){h=c[d>>2]|0;j=g|0;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=h;o=k}while(1){if(o>>>0>127>>>0){k=Ai(j,o,0)|0;if((k|0)==-1){l=-1;p=2601;break}else{q=k}}else{q=1}k=q+m|0;h=n+4|0;r=c[h>>2]|0;if((r|0)==0){l=k;p=2597;break}else{m=k;n=h;o=r}}if((p|0)==2597){i=f;return l|0}else if((p|0)==2601){i=f;return l|0}}L2958:do{if(e>>>0>3>>>0){o=e;n=b;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break L2958}if(q>>>0>127>>>0){j=Ai(n,q,0)|0;if((j|0)==-1){l=-1;break}u=n+j|0;v=o-j|0;w=m}else{a[n]=q&255;u=n+1|0;v=o-1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3>>>0){o=v;n=u;m=q}else{s=v;t=u;break L2958}}i=f;return l|0}else{s=e;t=b}}while(0);L2970:do{if((s|0)==0){x=0}else{b=g|0;u=s;v=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=2593;break}if(m>>>0>127>>>0){n=Ai(b,m,0)|0;if((n|0)==-1){l=-1;p=2598;break}if(n>>>0>u>>>0){p=2589;break}o=c[w>>2]|0;Ai(v,o,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m&255;y=v+1|0;z=u-1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break L2970}else{u=z;v=y;w=m}}if((p|0)==2589){l=e-u|0;i=f;return l|0}else if((p|0)==2598){i=f;return l|0}else if((p|0)==2593){a[v]=0;x=u;break}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function Al(a){a=a|0;var b=0;b=a;while(1){if((c[b>>2]|0)==0){break}else{b=b+4|0}}return b-a>>2|0}function Am(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==0){return a|0}else{e=b;f=d;g=a}while(1){d=f-1|0;c[g>>2]=c[e>>2];if((d|0)==0){break}else{e=e+4|0;f=d;g=g+4|0}}return a|0}function An(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(e){return a|0}else{f=d}do{f=f-1|0;c[a+(f<<2)>>2]=c[b+(f<<2)>>2];}while((f|0)!=0);return a|0}else{if(e){return a|0}else{g=b;h=d;i=a}while(1){d=h-1|0;c[i>>2]=c[g>>2];if((d|0)==0){break}else{g=g+4|0;h=d;i=i+4|0}}return a|0}return 0}function Ao(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((d|0)==0){return a|0}else{e=d;f=a}while(1){d=e-1|0;c[f>>2]=b;if((d|0)==0){break}else{e=d;f=f+4|0}}return a|0}function Ap(a){a=a|0;return}function Aq(a){a=a|0;c[a>>2]=90680;return}function Ar(a){a=a|0;AT(a);return}function As(a){a=a|0;return}function At(a){a=a|0;return 84936}function Au(a){a=a|0;Ap(a|0);return}function Av(a){a=a|0;return}function Aw(a){a=a|0;return}function Ax(a){a=a|0;Ap(a|0);AT(a);return}function Ay(a){a=a|0;Ap(a|0);AT(a);return}function Az(a){a=a|0;Ap(a|0);AT(a);return}function AA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+56|0;f=e|0;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=AE(b,98728,98712,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}A2(f|0,0,56);c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;c2[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function AB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((c[d+8>>2]|0)!=(b|0)){return}b=d+16|0;g=c[b>>2]|0;if((g|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((g|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function AC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((b|0)!=(c[d+8>>2]|0)){g=c[b+8>>2]|0;c2[c[(c[g>>2]|0)+28>>2]&63](g,d,e,f);return}g=d+16|0;b=c[g>>2]|0;if((b|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function AD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(c[d+8>>2]|0)){g=d+16|0;h=c[g>>2]|0;if((h|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((h|0)!=(e|0)){h=d+36|0;c[h>>2]=(c[h>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}h=d+24|0;if((c[h>>2]|0)!=2){return}c[h>>2]=f;return}h=c[b+12>>2]|0;g=b+16+(h<<3)|0;i=c[b+20>>2]|0;j=i>>8;if((i&1|0)==0){k=j}else{k=c[(c[e>>2]|0)+j>>2]|0}j=c[b+16>>2]|0;c2[c[(c[j>>2]|0)+28>>2]&63](j,d,e+k|0,(i&2|0)!=0?f:2);if((h|0)<=1){return}h=d+54|0;i=e;k=b+24|0;while(1){b=c[k+4>>2]|0;j=b>>8;if((b&1|0)==0){l=j}else{l=c[(c[i>>2]|0)+j>>2]|0}j=c[k>>2]|0;c2[c[(c[j>>2]|0)+28>>2]&63](j,d,e+l|0,(b&2|0)!=0?f:2);if((a[h]&1)!=0){m=2696;break}b=k+8|0;if(b>>>0<g>>>0){k=b}else{m=2695;break}}if((m|0)==2695){return}else if((m|0)==2696){return}}function AE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+56|0;g=f|0;h=c[a>>2]|0;j=a+(c[h-8>>2]|0)|0;k=c[h-4>>2]|0;h=k;c[g>>2]=d;c[g+4>>2]=a;c[g+8>>2]=b;c[g+12>>2]=e;e=g+16|0;b=g+20|0;a=g+24|0;l=g+28|0;m=g+32|0;n=g+40|0;A2(e|0,0,39);if((k|0)==(d|0)){c[g+48>>2]=1;dh[c[(c[k>>2]|0)+20>>2]&63](h,g,j,j,1,0);i=f;return((c[a>>2]|0)==1?j:0)|0}c1[c[(c[k>>2]|0)+24>>2]&31](h,g,j,1,0);j=c[g+36>>2]|0;if((j|0)==1){do{if((c[a>>2]|0)!=1){if((c[n>>2]|0)!=0){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}if((c[m>>2]|0)==1){break}else{o=0}i=f;return o|0}}while(0);o=c[e>>2]|0;i=f;return o|0}else if((j|0)==0){if((c[n>>2]|0)!=1){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}o=(c[m>>2]|0)==1?c[b>>2]|0:0;i=f;return o|0}else{o=0;i=f;return o|0}return 0}function AF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=c[b+12>>2]|0;k=b+16+(j<<3)|0;L3152:do{if((j|0)>0){l=d+52|0;m=d+53|0;n=d+54|0;o=b+8|0;p=d+24|0;q=e;r=0;s=b+16|0;t=0;L3154:while(1){a[l]=0;a[m]=0;u=c[s+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[q>>2]|0)+v>>2]|0}v=c[s>>2]|0;dh[c[(c[v>>2]|0)+20>>2]&63](v,d,e,e+w|0,2-(u>>>1&1)|0,g);if((a[n]&1)!=0){x=t;y=r;break}do{if((a[m]&1)==0){z=t;A=r}else{if((a[l]&1)==0){if((c[o>>2]&1|0)==0){x=1;y=r;break L3154}else{z=1;A=r;break}}if((c[p>>2]|0)==1){B=2744;break L3152}if((c[o>>2]&2|0)==0){B=2744;break L3152}else{z=1;A=1}}}while(0);u=s+8|0;if(u>>>0<k>>>0){r=A;s=u;t=z}else{x=z;y=A;break}}if(y){C=x;B=2743}else{D=x;B=2740}}else{D=0;B=2740}}while(0);do{if((B|0)==2740){c[h>>2]=e;k=d+40|0;c[k>>2]=(c[k>>2]|0)+1;if((c[d+36>>2]|0)!=1){C=D;B=2743;break}if((c[d+24>>2]|0)!=2){C=D;B=2743;break}a[d+54|0]=1;if(D){B=2744}else{B=2745}}}while(0);if((B|0)==2743){if(C){B=2744}else{B=2745}}if((B|0)==2744){c[i>>2]=3;return}else if((B|0)==2745){c[i>>2]=4;return}}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}C=c[b+12>>2]|0;D=b+16+(C<<3)|0;x=c[b+20>>2]|0;y=x>>8;if((x&1|0)==0){E=y}else{E=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;c1[c[(c[y>>2]|0)+24>>2]&31](y,d,e+E|0,(x&2|0)!=0?f:2,g);x=b+24|0;if((C|0)<=1){return}C=c[b+8>>2]|0;do{if((C&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((C&1|0)==0){E=d+54|0;y=e;A=x;while(1){if((a[E]&1)!=0){B=2775;break}if((c[b>>2]|0)==1){B=2783;break}z=c[A+4>>2]|0;w=z>>8;if((z&1|0)==0){F=w}else{F=c[(c[y>>2]|0)+w>>2]|0}w=c[A>>2]|0;c1[c[(c[w>>2]|0)+24>>2]&31](w,d,e+F|0,(z&2|0)!=0?f:2,g);z=A+8|0;if(z>>>0<D>>>0){A=z}else{B=2773;break}}if((B|0)==2773){return}else if((B|0)==2775){return}else if((B|0)==2783){return}}A=d+24|0;y=d+54|0;E=e;i=x;while(1){if((a[y]&1)!=0){B=2781;break}if((c[b>>2]|0)==1){if((c[A>>2]|0)==1){B=2779;break}}z=c[i+4>>2]|0;w=z>>8;if((z&1|0)==0){G=w}else{G=c[(c[E>>2]|0)+w>>2]|0}w=c[i>>2]|0;c1[c[(c[w>>2]|0)+24>>2]&31](w,d,e+G|0,(z&2|0)!=0?f:2,g);z=i+8|0;if(z>>>0<D>>>0){i=z}else{B=2774;break}}if((B|0)==2774){return}else if((B|0)==2779){return}else if((B|0)==2781){return}}}while(0);G=d+54|0;F=e;C=x;while(1){if((a[G]&1)!=0){B=2778;break}x=c[C+4>>2]|0;i=x>>8;if((x&1|0)==0){H=i}else{H=c[(c[F>>2]|0)+i>>2]|0}i=c[C>>2]|0;c1[c[(c[i>>2]|0)+24>>2]&31](i,d,e+H|0,(x&2|0)!=0?f:2,g);x=C+8|0;if(x>>>0<D>>>0){C=x}else{B=2777;break}}if((B|0)==2777){return}else if((B|0)==2778){return}}function AG(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)!=(c[d>>2]|0)){h=c[b+8>>2]|0;c1[c[(c[h>>2]|0)+24>>2]&31](h,d,e,f,g);return}do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=d+52|0;a[j]=0;k=d+53|0;a[k]=0;l=c[b+8>>2]|0;dh[c[(c[l>>2]|0)+20>>2]&63](l,d,e,e,1,g);if((a[k]&1)==0){m=0;n=2800}else{if((a[j]&1)==0){m=1;n=2800}}L3254:do{if((n|0)==2800){c[h>>2]=e;j=d+40|0;c[j>>2]=(c[j>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){n=2803;break}a[d+54|0]=1;if(m){break L3254}}else{n=2803}}while(0);if((n|0)==2803){if(m){break}}c[i>>2]=4;return}}while(0);c[i>>2]=3;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function AH(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){return}g=d+28|0;if((c[g>>2]|0)==1){return}c[g>>2]=f;return}if((c[d>>2]|0)!=(b|0)){return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function AI(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)!=(c[d+8>>2]|0)){i=d+52|0;j=a[i]&1;k=d+53|0;l=a[k]&1;m=c[b+12>>2]|0;n=b+16+(m<<3)|0;a[i]=0;a[k]=0;o=c[b+20>>2]|0;p=o>>8;if((o&1|0)==0){q=p}else{q=c[(c[f>>2]|0)+p>>2]|0}p=c[b+16>>2]|0;dh[c[(c[p>>2]|0)+20>>2]&63](p,d,e,f+q|0,(o&2|0)!=0?g:2,h);L3303:do{if((m|0)>1){o=d+24|0;q=b+8|0;p=d+54|0;r=f;s=b+24|0;do{if((a[p]&1)!=0){break L3303}do{if((a[i]&1)==0){if((a[k]&1)==0){break}if((c[q>>2]&1|0)==0){break L3303}}else{if((c[o>>2]|0)==1){break L3303}if((c[q>>2]&2|0)==0){break L3303}}}while(0);a[i]=0;a[k]=0;t=c[s+4>>2]|0;u=t>>8;if((t&1|0)==0){v=u}else{v=c[(c[r>>2]|0)+u>>2]|0}u=c[s>>2]|0;dh[c[(c[u>>2]|0)+20>>2]&63](u,d,e,f+v|0,(t&2|0)!=0?g:2,h);s=s+8|0;}while(s>>>0<n>>>0)}}while(0);a[i]=j;a[k]=l;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;l=c[f>>2]|0;if((l|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((l|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;l=c[e>>2]|0;if((l|0)==2){c[e>>2]=g;w=g}else{w=l}if(!((c[d+48>>2]|0)==1&(w|0)==1)){return}a[d+54|0]=1;return}function AJ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;if((b|0)!=(c[d+8>>2]|0)){i=c[b+8>>2]|0;dh[c[(c[i>>2]|0)+20>>2]&63](i,d,e,f,g,h);return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;j=g}else{j=h}if(!((c[d+48>>2]|0)==1&(j|0)==1)){return}a[d+54|0]=1;return}function AK(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;if((c[d+8>>2]|0)!=(b|0)){return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;i=g}else{i=b}if(!((c[d+48>>2]|0)==1&(i|0)==1)){return}a[d+54|0]=1;return}function AL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aK=0;do{if(a>>>0<245>>>0){if(a>>>0<11>>>0){b=16}else{b=a+11&-8}d=b>>>3;e=c[217772]|0;f=e>>>(d>>>0);if((f&3|0)!=0){g=(f&1^1)+d|0;h=g<<1;i=871128+(h<<2)|0;j=871128+(h+2<<2)|0;h=c[j>>2]|0;k=h+8|0;l=c[k>>2]|0;do{if((i|0)==(l|0)){c[217772]=e&~(1<<g)}else{if(l>>>0<(c[217776]|0)>>>0){ct();return 0}m=l+12|0;if((c[m>>2]|0)==(h|0)){c[m>>2]=i;c[j>>2]=l;break}else{ct();return 0}}}while(0);l=g<<3;c[h+4>>2]=l|3;j=h+(l|4)|0;c[j>>2]=c[j>>2]|1;n=k;return n|0}if(b>>>0<=(c[217774]|0)>>>0){o=b;break}if((f|0)!=0){j=2<<d;l=f<<d&(j|-j);j=(l&-l)-1|0;l=j>>>12&16;i=j>>>(l>>>0);j=i>>>5&8;m=i>>>(j>>>0);i=m>>>2&4;p=m>>>(i>>>0);m=p>>>1&2;q=p>>>(m>>>0);p=q>>>1&1;r=(j|l|i|m|p)+(q>>>(p>>>0))|0;p=r<<1;q=871128+(p<<2)|0;m=871128+(p+2<<2)|0;p=c[m>>2]|0;i=p+8|0;l=c[i>>2]|0;do{if((q|0)==(l|0)){c[217772]=e&~(1<<r)}else{if(l>>>0<(c[217776]|0)>>>0){ct();return 0}j=l+12|0;if((c[j>>2]|0)==(p|0)){c[j>>2]=q;c[m>>2]=l;break}else{ct();return 0}}}while(0);l=r<<3;m=l-b|0;c[p+4>>2]=b|3;q=p;e=q+b|0;c[q+(b|4)>>2]=m|1;c[q+l>>2]=m;l=c[217774]|0;if((l|0)!=0){q=c[217777]|0;d=l>>>3;l=d<<1;f=871128+(l<<2)|0;k=c[217772]|0;h=1<<d;do{if((k&h|0)==0){c[217772]=k|h;s=f;t=871128+(l+2<<2)|0}else{d=871128+(l+2<<2)|0;g=c[d>>2]|0;if(g>>>0>=(c[217776]|0)>>>0){s=g;t=d;break}ct();return 0}}while(0);c[t>>2]=q;c[s+12>>2]=q;c[q+8>>2]=s;c[q+12>>2]=f}c[217774]=m;c[217777]=e;n=i;return n|0}l=c[217773]|0;if((l|0)==0){o=b;break}h=(l&-l)-1|0;l=h>>>12&16;k=h>>>(l>>>0);h=k>>>5&8;p=k>>>(h>>>0);k=p>>>2&4;r=p>>>(k>>>0);p=r>>>1&2;d=r>>>(p>>>0);r=d>>>1&1;g=c[871392+((h|l|k|p|r)+(d>>>(r>>>0))<<2)>>2]|0;r=g;d=g;p=(c[g+4>>2]&-8)-b|0;while(1){g=c[r+16>>2]|0;if((g|0)==0){k=c[r+20>>2]|0;if((k|0)==0){break}else{u=k}}else{u=g}g=(c[u+4>>2]&-8)-b|0;k=g>>>0<p>>>0;r=u;d=k?u:d;p=k?g:p}r=d;i=c[217776]|0;if(r>>>0<i>>>0){ct();return 0}e=r+b|0;m=e;if(r>>>0>=e>>>0){ct();return 0}e=c[d+24>>2]|0;f=c[d+12>>2]|0;do{if((f|0)==(d|0)){q=d+20|0;g=c[q>>2]|0;if((g|0)==0){k=d+16|0;l=c[k>>2]|0;if((l|0)==0){v=0;break}else{w=l;x=k}}else{w=g;x=q}while(1){q=w+20|0;g=c[q>>2]|0;if((g|0)!=0){w=g;x=q;continue}q=w+16|0;g=c[q>>2]|0;if((g|0)==0){break}else{w=g;x=q}}if(x>>>0<i>>>0){ct();return 0}else{c[x>>2]=0;v=w;break}}else{q=c[d+8>>2]|0;if(q>>>0<i>>>0){ct();return 0}g=q+12|0;if((c[g>>2]|0)!=(d|0)){ct();return 0}k=f+8|0;if((c[k>>2]|0)==(d|0)){c[g>>2]=f;c[k>>2]=q;v=f;break}else{ct();return 0}}}while(0);L3470:do{if((e|0)!=0){f=d+28|0;i=871392+(c[f>>2]<<2)|0;do{if((d|0)==(c[i>>2]|0)){c[i>>2]=v;if((v|0)!=0){break}c[217773]=c[217773]&~(1<<c[f>>2]);break L3470}else{if(e>>>0<(c[217776]|0)>>>0){ct();return 0}q=e+16|0;if((c[q>>2]|0)==(d|0)){c[q>>2]=v}else{c[e+20>>2]=v}if((v|0)==0){break L3470}}}while(0);if(v>>>0<(c[217776]|0)>>>0){ct();return 0}c[v+24>>2]=e;f=c[d+16>>2]|0;do{if((f|0)!=0){if(f>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[v+16>>2]=f;c[f+24>>2]=v;break}}}while(0);f=c[d+20>>2]|0;if((f|0)==0){break}if(f>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[v+20>>2]=f;c[f+24>>2]=v;break}}}while(0);if(p>>>0<16>>>0){e=p+b|0;c[d+4>>2]=e|3;f=r+(e+4)|0;c[f>>2]=c[f>>2]|1}else{c[d+4>>2]=b|3;c[r+(b|4)>>2]=p|1;c[r+(p+b)>>2]=p;f=c[217774]|0;if((f|0)!=0){e=c[217777]|0;i=f>>>3;f=i<<1;q=871128+(f<<2)|0;k=c[217772]|0;g=1<<i;do{if((k&g|0)==0){c[217772]=k|g;y=q;z=871128+(f+2<<2)|0}else{i=871128+(f+2<<2)|0;l=c[i>>2]|0;if(l>>>0>=(c[217776]|0)>>>0){y=l;z=i;break}ct();return 0}}while(0);c[z>>2]=e;c[y+12>>2]=e;c[e+8>>2]=y;c[e+12>>2]=q}c[217774]=p;c[217777]=m}n=d+8|0;return n|0}else{if(a>>>0>4294967231>>>0){o=-1;break}f=a+11|0;g=f&-8;k=c[217773]|0;if((k|0)==0){o=g;break}r=-g|0;i=f>>>8;do{if((i|0)==0){A=0}else{if(g>>>0>16777215>>>0){A=31;break}f=(i+1048320|0)>>>16&8;l=i<<f;h=(l+520192|0)>>>16&4;j=l<<h;l=(j+245760|0)>>>16&2;B=14-(h|f|l)+(j<<l>>>15)|0;A=g>>>((B+7|0)>>>0)&1|B<<1}}while(0);i=c[871392+(A<<2)>>2]|0;L3518:do{if((i|0)==0){C=0;D=r;E=0}else{if((A|0)==31){F=0}else{F=25-(A>>>1)|0}d=0;m=r;p=i;q=g<<F;e=0;while(1){B=c[p+4>>2]&-8;l=B-g|0;if(l>>>0<m>>>0){if((B|0)==(g|0)){C=p;D=l;E=p;break L3518}else{G=p;H=l}}else{G=d;H=m}l=c[p+20>>2]|0;B=c[p+16+(q>>>31<<2)>>2]|0;j=(l|0)==0|(l|0)==(B|0)?e:l;if((B|0)==0){C=G;D=H;E=j;break}else{d=G;m=H;p=B;q=q<<1;e=j}}}}while(0);if((E|0)==0&(C|0)==0){i=2<<A;r=k&(i|-i);if((r|0)==0){o=g;break}i=(r&-r)-1|0;r=i>>>12&16;e=i>>>(r>>>0);i=e>>>5&8;q=e>>>(i>>>0);e=q>>>2&4;p=q>>>(e>>>0);q=p>>>1&2;m=p>>>(q>>>0);p=m>>>1&1;I=c[871392+((i|r|e|q|p)+(m>>>(p>>>0))<<2)>>2]|0}else{I=E}if((I|0)==0){J=D;K=C}else{p=I;m=D;q=C;while(1){e=(c[p+4>>2]&-8)-g|0;r=e>>>0<m>>>0;i=r?e:m;e=r?p:q;r=c[p+16>>2]|0;if((r|0)!=0){p=r;m=i;q=e;continue}r=c[p+20>>2]|0;if((r|0)==0){J=i;K=e;break}else{p=r;m=i;q=e}}}if((K|0)==0){o=g;break}if(J>>>0>=((c[217774]|0)-g|0)>>>0){o=g;break}q=K;m=c[217776]|0;if(q>>>0<m>>>0){ct();return 0}p=q+g|0;k=p;if(q>>>0>=p>>>0){ct();return 0}e=c[K+24>>2]|0;i=c[K+12>>2]|0;do{if((i|0)==(K|0)){r=K+20|0;d=c[r>>2]|0;if((d|0)==0){j=K+16|0;B=c[j>>2]|0;if((B|0)==0){L=0;break}else{M=B;N=j}}else{M=d;N=r}while(1){r=M+20|0;d=c[r>>2]|0;if((d|0)!=0){M=d;N=r;continue}r=M+16|0;d=c[r>>2]|0;if((d|0)==0){break}else{M=d;N=r}}if(N>>>0<m>>>0){ct();return 0}else{c[N>>2]=0;L=M;break}}else{r=c[K+8>>2]|0;if(r>>>0<m>>>0){ct();return 0}d=r+12|0;if((c[d>>2]|0)!=(K|0)){ct();return 0}j=i+8|0;if((c[j>>2]|0)==(K|0)){c[d>>2]=i;c[j>>2]=r;L=i;break}else{ct();return 0}}}while(0);L3568:do{if((e|0)!=0){i=K+28|0;m=871392+(c[i>>2]<<2)|0;do{if((K|0)==(c[m>>2]|0)){c[m>>2]=L;if((L|0)!=0){break}c[217773]=c[217773]&~(1<<c[i>>2]);break L3568}else{if(e>>>0<(c[217776]|0)>>>0){ct();return 0}r=e+16|0;if((c[r>>2]|0)==(K|0)){c[r>>2]=L}else{c[e+20>>2]=L}if((L|0)==0){break L3568}}}while(0);if(L>>>0<(c[217776]|0)>>>0){ct();return 0}c[L+24>>2]=e;i=c[K+16>>2]|0;do{if((i|0)!=0){if(i>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[L+16>>2]=i;c[i+24>>2]=L;break}}}while(0);i=c[K+20>>2]|0;if((i|0)==0){break}if(i>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[L+20>>2]=i;c[i+24>>2]=L;break}}}while(0);L3596:do{if(J>>>0<16>>>0){e=J+g|0;c[K+4>>2]=e|3;i=q+(e+4)|0;c[i>>2]=c[i>>2]|1}else{c[K+4>>2]=g|3;c[q+(g|4)>>2]=J|1;c[q+(J+g)>>2]=J;i=J>>>3;if(J>>>0<256>>>0){e=i<<1;m=871128+(e<<2)|0;r=c[217772]|0;j=1<<i;do{if((r&j|0)==0){c[217772]=r|j;O=m;P=871128+(e+2<<2)|0}else{i=871128+(e+2<<2)|0;d=c[i>>2]|0;if(d>>>0>=(c[217776]|0)>>>0){O=d;P=i;break}ct();return 0}}while(0);c[P>>2]=k;c[O+12>>2]=k;c[q+(g+8)>>2]=O;c[q+(g+12)>>2]=m;break}e=p;j=J>>>8;do{if((j|0)==0){Q=0}else{if(J>>>0>16777215>>>0){Q=31;break}r=(j+1048320|0)>>>16&8;i=j<<r;d=(i+520192|0)>>>16&4;B=i<<d;i=(B+245760|0)>>>16&2;l=14-(d|r|i)+(B<<i>>>15)|0;Q=J>>>((l+7|0)>>>0)&1|l<<1}}while(0);j=871392+(Q<<2)|0;c[q+(g+28)>>2]=Q;c[q+(g+20)>>2]=0;c[q+(g+16)>>2]=0;m=c[217773]|0;l=1<<Q;if((m&l|0)==0){c[217773]=m|l;c[j>>2]=e;c[q+(g+24)>>2]=j;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break}l=c[j>>2]|0;if((Q|0)==31){R=0}else{R=25-(Q>>>1)|0}L3616:do{if((c[l+4>>2]&-8|0)==(J|0)){S=l}else{j=l;m=J<<R;while(1){T=j+16+(m>>>31<<2)|0;i=c[T>>2]|0;if((i|0)==0){break}if((c[i+4>>2]&-8|0)==(J|0)){S=i;break L3616}else{j=i;m=m<<1}}if(T>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[T>>2]=e;c[q+(g+24)>>2]=j;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break L3596}}}while(0);l=S+8|0;m=c[l>>2]|0;i=c[217776]|0;if(S>>>0<i>>>0){ct();return 0}if(m>>>0<i>>>0){ct();return 0}else{c[m+12>>2]=e;c[l>>2]=e;c[q+(g+8)>>2]=m;c[q+(g+12)>>2]=S;c[q+(g+24)>>2]=0;break}}}while(0);n=K+8|0;return n|0}}while(0);K=c[217774]|0;if(o>>>0<=K>>>0){S=K-o|0;T=c[217777]|0;if(S>>>0>15>>>0){J=T;c[217777]=J+o;c[217774]=S;c[J+(o+4)>>2]=S|1;c[J+K>>2]=S;c[T+4>>2]=o|3}else{c[217774]=0;c[217777]=0;c[T+4>>2]=K|3;S=T+(K+4)|0;c[S>>2]=c[S>>2]|1}n=T+8|0;return n|0}T=c[217775]|0;if(o>>>0<T>>>0){S=T-o|0;c[217775]=S;T=c[217778]|0;K=T;c[217778]=K+o;c[K+(o+4)>>2]=S|1;c[T+4>>2]=o|3;n=T+8|0;return n|0}do{if((c[121702]|0)==0){T=aJ(30)|0;if((T-1&T|0)==0){c[121704]=T;c[121703]=T;c[121705]=-1;c[121706]=-1;c[121707]=0;c[217883]=0;c[121702]=(c_(0)|0)&-16^1431655768;break}else{ct();return 0}}}while(0);T=o+48|0;S=c[121704]|0;K=o+47|0;J=S+K|0;R=-S|0;S=J&R;if(S>>>0<=o>>>0){n=0;return n|0}Q=c[217882]|0;do{if((Q|0)!=0){O=c[217880]|0;P=O+S|0;if(P>>>0<=O>>>0|P>>>0>Q>>>0){n=0}else{break}return n|0}}while(0);L3661:do{if((c[217883]&4|0)==0){Q=c[217778]|0;L3663:do{if((Q|0)==0){U=3091}else{P=Q;O=871536;while(1){V=O|0;L=c[V>>2]|0;if(L>>>0<=P>>>0){W=O+4|0;if((L+(c[W>>2]|0)|0)>>>0>P>>>0){break}}L=c[O+8>>2]|0;if((L|0)==0){U=3091;break L3663}else{O=L}}if((O|0)==0){U=3091;break}P=J-(c[217775]|0)&R;if(P>>>0>=2147483647>>>0){X=0;break}e=cc(P|0)|0;L=(e|0)==((c[V>>2]|0)+(c[W>>2]|0)|0);Y=L?e:-1;Z=L?P:0;_=e;$=P;U=3100}}while(0);do{if((U|0)==3091){Q=cc(0)|0;if((Q|0)==-1){X=0;break}P=Q;e=c[121703]|0;L=e-1|0;if((L&P|0)==0){aa=S}else{aa=S-P+(L+P&-e)|0}e=c[217880]|0;P=e+aa|0;if(!(aa>>>0>o>>>0&aa>>>0<2147483647>>>0)){X=0;break}L=c[217882]|0;if((L|0)!=0){if(P>>>0<=e>>>0|P>>>0>L>>>0){X=0;break}}L=cc(aa|0)|0;P=(L|0)==(Q|0);Y=P?Q:-1;Z=P?aa:0;_=L;$=aa;U=3100}}while(0);L3683:do{if((U|0)==3100){L=-$|0;if((Y|0)!=-1){ab=Z;ac=Y;U=3111;break L3661}do{if((_|0)!=-1&$>>>0<2147483647>>>0&$>>>0<T>>>0){P=c[121704]|0;Q=K-$+P&-P;if(Q>>>0>=2147483647>>>0){ad=$;break}if((cc(Q|0)|0)==-1){cc(L|0)|0;X=Z;break L3683}else{ad=Q+$|0;break}}else{ad=$}}while(0);if((_|0)==-1){X=Z}else{ab=ad;ac=_;U=3111;break L3661}}}while(0);c[217883]=c[217883]|4;ae=X;U=3108}else{ae=0;U=3108}}while(0);do{if((U|0)==3108){if(S>>>0>=2147483647>>>0){break}X=cc(S|0)|0;_=cc(0)|0;if(!((_|0)!=-1&(X|0)!=-1&X>>>0<_>>>0)){break}ad=_-X|0;_=ad>>>0>(o+40|0)>>>0;if(_){ab=_?ad:ae;ac=X;U=3111}}}while(0);do{if((U|0)==3111){ae=(c[217880]|0)+ab|0;c[217880]=ae;if(ae>>>0>(c[217881]|0)>>>0){c[217881]=ae}ae=c[217778]|0;L3703:do{if((ae|0)==0){S=c[217776]|0;if((S|0)==0|ac>>>0<S>>>0){c[217776]=ac}c[217884]=ac;c[217885]=ab;c[217887]=0;c[217781]=c[121702];c[217780]=-1;S=0;do{X=S<<1;ad=871128+(X<<2)|0;c[871128+(X+3<<2)>>2]=ad;c[871128+(X+2<<2)>>2]=ad;S=S+1|0;}while(S>>>0<32>>>0);S=ac+8|0;if((S&7|0)==0){af=0}else{af=-S&7}S=ab-40-af|0;c[217778]=ac+af;c[217775]=S;c[ac+(af+4)>>2]=S|1;c[ac+(ab-36)>>2]=40;c[217779]=c[121706]}else{S=871536;while(1){ag=c[S>>2]|0;ah=S+4|0;ai=c[ah>>2]|0;if((ac|0)==(ag+ai|0)){U=3123;break}ad=c[S+8>>2]|0;if((ad|0)==0){break}else{S=ad}}do{if((U|0)==3123){if((c[S+12>>2]&8|0)!=0){break}ad=ae;if(!(ad>>>0>=ag>>>0&ad>>>0<ac>>>0)){break}c[ah>>2]=ai+ab;ad=c[217778]|0;X=(c[217775]|0)+ab|0;_=ad;Z=ad+8|0;if((Z&7|0)==0){aj=0}else{aj=-Z&7}Z=X-aj|0;c[217778]=_+aj;c[217775]=Z;c[_+(aj+4)>>2]=Z|1;c[_+(X+4)>>2]=40;c[217779]=c[121706];break L3703}}while(0);if(ac>>>0<(c[217776]|0)>>>0){c[217776]=ac}S=ac+ab|0;X=871536;while(1){ak=X|0;if((c[ak>>2]|0)==(S|0)){U=3133;break}_=c[X+8>>2]|0;if((_|0)==0){break}else{X=_}}do{if((U|0)==3133){if((c[X+12>>2]&8|0)!=0){break}c[ak>>2]=ac;S=X+4|0;c[S>>2]=(c[S>>2]|0)+ab;S=ac+8|0;if((S&7|0)==0){al=0}else{al=-S&7}S=ac+(ab+8)|0;if((S&7|0)==0){am=0}else{am=-S&7}S=ac+(am+ab)|0;_=S;Z=al+o|0;ad=ac+Z|0;$=ad;K=S-(ac+al)-o|0;c[ac+(al+4)>>2]=o|3;L3740:do{if((_|0)==(c[217778]|0)){T=(c[217775]|0)+K|0;c[217775]=T;c[217778]=$;c[ac+(Z+4)>>2]=T|1}else{if((_|0)==(c[217777]|0)){T=(c[217774]|0)+K|0;c[217774]=T;c[217777]=$;c[ac+(Z+4)>>2]=T|1;c[ac+(T+Z)>>2]=T;break}T=ab+4|0;Y=c[ac+(T+am)>>2]|0;if((Y&3|0)==1){aa=Y&-8;W=Y>>>3;L3748:do{if(Y>>>0<256>>>0){V=c[ac+((am|8)+ab)>>2]|0;R=c[ac+(ab+12+am)>>2]|0;J=871128+(W<<1<<2)|0;do{if((V|0)!=(J|0)){if(V>>>0<(c[217776]|0)>>>0){ct();return 0}if((c[V+12>>2]|0)==(_|0)){break}ct();return 0}}while(0);if((R|0)==(V|0)){c[217772]=c[217772]&~(1<<W);break}do{if((R|0)==(J|0)){an=R+8|0}else{if(R>>>0<(c[217776]|0)>>>0){ct();return 0}L=R+8|0;if((c[L>>2]|0)==(_|0)){an=L;break}ct();return 0}}while(0);c[V+12>>2]=R;c[an>>2]=V}else{J=S;L=c[ac+((am|24)+ab)>>2]|0;O=c[ac+(ab+12+am)>>2]|0;do{if((O|0)==(J|0)){Q=am|16;P=ac+(T+Q)|0;e=c[P>>2]|0;if((e|0)==0){M=ac+(Q+ab)|0;Q=c[M>>2]|0;if((Q|0)==0){ao=0;break}else{ap=Q;aq=M}}else{ap=e;aq=P}while(1){P=ap+20|0;e=c[P>>2]|0;if((e|0)!=0){ap=e;aq=P;continue}P=ap+16|0;e=c[P>>2]|0;if((e|0)==0){break}else{ap=e;aq=P}}if(aq>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[aq>>2]=0;ao=ap;break}}else{P=c[ac+((am|8)+ab)>>2]|0;if(P>>>0<(c[217776]|0)>>>0){ct();return 0}e=P+12|0;if((c[e>>2]|0)!=(J|0)){ct();return 0}M=O+8|0;if((c[M>>2]|0)==(J|0)){c[e>>2]=O;c[M>>2]=P;ao=O;break}else{ct();return 0}}}while(0);if((L|0)==0){break}O=ac+(ab+28+am)|0;V=871392+(c[O>>2]<<2)|0;do{if((J|0)==(c[V>>2]|0)){c[V>>2]=ao;if((ao|0)!=0){break}c[217773]=c[217773]&~(1<<c[O>>2]);break L3748}else{if(L>>>0<(c[217776]|0)>>>0){ct();return 0}R=L+16|0;if((c[R>>2]|0)==(J|0)){c[R>>2]=ao}else{c[L+20>>2]=ao}if((ao|0)==0){break L3748}}}while(0);if(ao>>>0<(c[217776]|0)>>>0){ct();return 0}c[ao+24>>2]=L;J=am|16;O=c[ac+(J+ab)>>2]|0;do{if((O|0)!=0){if(O>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[ao+16>>2]=O;c[O+24>>2]=ao;break}}}while(0);O=c[ac+(T+J)>>2]|0;if((O|0)==0){break}if(O>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[ao+20>>2]=O;c[O+24>>2]=ao;break}}}while(0);ar=ac+((aa|am)+ab)|0;as=aa+K|0}else{ar=_;as=K}T=ar+4|0;c[T>>2]=c[T>>2]&-2;c[ac+(Z+4)>>2]=as|1;c[ac+(as+Z)>>2]=as;T=as>>>3;if(as>>>0<256>>>0){W=T<<1;Y=871128+(W<<2)|0;O=c[217772]|0;L=1<<T;do{if((O&L|0)==0){c[217772]=O|L;at=Y;au=871128+(W+2<<2)|0}else{T=871128+(W+2<<2)|0;V=c[T>>2]|0;if(V>>>0>=(c[217776]|0)>>>0){at=V;au=T;break}ct();return 0}}while(0);c[au>>2]=$;c[at+12>>2]=$;c[ac+(Z+8)>>2]=at;c[ac+(Z+12)>>2]=Y;break}W=ad;L=as>>>8;do{if((L|0)==0){av=0}else{if(as>>>0>16777215>>>0){av=31;break}O=(L+1048320|0)>>>16&8;aa=L<<O;T=(aa+520192|0)>>>16&4;V=aa<<T;aa=(V+245760|0)>>>16&2;R=14-(T|O|aa)+(V<<aa>>>15)|0;av=as>>>((R+7|0)>>>0)&1|R<<1}}while(0);L=871392+(av<<2)|0;c[ac+(Z+28)>>2]=av;c[ac+(Z+20)>>2]=0;c[ac+(Z+16)>>2]=0;Y=c[217773]|0;R=1<<av;if((Y&R|0)==0){c[217773]=Y|R;c[L>>2]=W;c[ac+(Z+24)>>2]=L;c[ac+(Z+12)>>2]=W;c[ac+(Z+8)>>2]=W;break}R=c[L>>2]|0;if((av|0)==31){aw=0}else{aw=25-(av>>>1)|0}L3837:do{if((c[R+4>>2]&-8|0)==(as|0)){ax=R}else{L=R;Y=as<<aw;while(1){ay=L+16+(Y>>>31<<2)|0;aa=c[ay>>2]|0;if((aa|0)==0){break}if((c[aa+4>>2]&-8|0)==(as|0)){ax=aa;break L3837}else{L=aa;Y=Y<<1}}if(ay>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[ay>>2]=W;c[ac+(Z+24)>>2]=L;c[ac+(Z+12)>>2]=W;c[ac+(Z+8)>>2]=W;break L3740}}}while(0);R=ax+8|0;Y=c[R>>2]|0;J=c[217776]|0;if(ax>>>0<J>>>0){ct();return 0}if(Y>>>0<J>>>0){ct();return 0}else{c[Y+12>>2]=W;c[R>>2]=W;c[ac+(Z+8)>>2]=Y;c[ac+(Z+12)>>2]=ax;c[ac+(Z+24)>>2]=0;break}}}while(0);n=ac+(al|8)|0;return n|0}}while(0);X=ae;Z=871536;while(1){az=c[Z>>2]|0;if(az>>>0<=X>>>0){aA=c[Z+4>>2]|0;aB=az+aA|0;if(aB>>>0>X>>>0){break}}Z=c[Z+8>>2]|0}Z=az+(aA-39)|0;if((Z&7|0)==0){aC=0}else{aC=-Z&7}Z=az+(aA-47+aC)|0;ad=Z>>>0<(ae+16|0)>>>0?X:Z;Z=ad+8|0;$=ac+8|0;if(($&7|0)==0){aD=0}else{aD=-$&7}$=ab-40-aD|0;c[217778]=ac+aD;c[217775]=$;c[ac+(aD+4)>>2]=$|1;c[ac+(ab-36)>>2]=40;c[217779]=c[121706];c[ad+4>>2]=27;c[Z>>2]=c[217884];c[Z+4>>2]=c[217885];c[Z+8>>2]=c[217886];c[Z+12>>2]=c[217887];c[217884]=ac;c[217885]=ab;c[217887]=0;c[217886]=Z;Z=ad+28|0;c[Z>>2]=7;if((ad+32|0)>>>0<aB>>>0){$=Z;while(1){Z=$+4|0;c[Z>>2]=7;if(($+8|0)>>>0<aB>>>0){$=Z}else{break}}}if((ad|0)==(X|0)){break}$=ad-ae|0;Z=X+($+4)|0;c[Z>>2]=c[Z>>2]&-2;c[ae+4>>2]=$|1;c[X+$>>2]=$;Z=$>>>3;if($>>>0<256>>>0){K=Z<<1;_=871128+(K<<2)|0;S=c[217772]|0;j=1<<Z;do{if((S&j|0)==0){c[217772]=S|j;aE=_;aF=871128+(K+2<<2)|0}else{Z=871128+(K+2<<2)|0;Y=c[Z>>2]|0;if(Y>>>0>=(c[217776]|0)>>>0){aE=Y;aF=Z;break}ct();return 0}}while(0);c[aF>>2]=ae;c[aE+12>>2]=ae;c[ae+8>>2]=aE;c[ae+12>>2]=_;break}K=ae;j=$>>>8;do{if((j|0)==0){aG=0}else{if($>>>0>16777215>>>0){aG=31;break}S=(j+1048320|0)>>>16&8;X=j<<S;ad=(X+520192|0)>>>16&4;Z=X<<ad;X=(Z+245760|0)>>>16&2;Y=14-(ad|S|X)+(Z<<X>>>15)|0;aG=$>>>((Y+7|0)>>>0)&1|Y<<1}}while(0);j=871392+(aG<<2)|0;c[ae+28>>2]=aG;c[ae+20>>2]=0;c[ae+16>>2]=0;_=c[217773]|0;Y=1<<aG;if((_&Y|0)==0){c[217773]=_|Y;c[j>>2]=K;c[ae+24>>2]=j;c[ae+12>>2]=ae;c[ae+8>>2]=ae;break}Y=c[j>>2]|0;if((aG|0)==31){aH=0}else{aH=25-(aG>>>1)|0}L3891:do{if((c[Y+4>>2]&-8|0)==($|0)){aI=Y}else{j=Y;_=$<<aH;while(1){aK=j+16+(_>>>31<<2)|0;X=c[aK>>2]|0;if((X|0)==0){break}if((c[X+4>>2]&-8|0)==($|0)){aI=X;break L3891}else{j=X;_=_<<1}}if(aK>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[aK>>2]=K;c[ae+24>>2]=j;c[ae+12>>2]=ae;c[ae+8>>2]=ae;break L3703}}}while(0);$=aI+8|0;Y=c[$>>2]|0;_=c[217776]|0;if(aI>>>0<_>>>0){ct();return 0}if(Y>>>0<_>>>0){ct();return 0}else{c[Y+12>>2]=K;c[$>>2]=K;c[ae+8>>2]=Y;c[ae+12>>2]=aI;c[ae+24>>2]=0;break}}}while(0);ae=c[217775]|0;if(ae>>>0<=o>>>0){break}Y=ae-o|0;c[217775]=Y;ae=c[217778]|0;$=ae;c[217778]=$+o;c[$+(o+4)>>2]=Y|1;c[ae+4>>2]=o|3;n=ae+8|0;return n|0}}while(0);c[(cd()|0)>>2]=12;n=0;return n|0}function AM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;if((a|0)==0){return}b=a-8|0;d=b;e=c[217776]|0;if(b>>>0<e>>>0){ct()}f=c[a-4>>2]|0;g=f&3;if((g|0)==1){ct()}h=f&-8;i=a+(h-8)|0;j=i;L3922:do{if((f&1|0)==0){k=c[b>>2]|0;if((g|0)==0){return}l=-8-k|0;m=a+l|0;n=m;o=k+h|0;if(m>>>0<e>>>0){ct()}if((n|0)==(c[217777]|0)){p=a+(h-4)|0;if((c[p>>2]&3|0)!=3){q=n;r=o;break}c[217774]=o;c[p>>2]=c[p>>2]&-2;c[a+(l+4)>>2]=o|1;c[i>>2]=o;return}p=k>>>3;if(k>>>0<256>>>0){k=c[a+(l+8)>>2]|0;s=c[a+(l+12)>>2]|0;t=871128+(p<<1<<2)|0;do{if((k|0)!=(t|0)){if(k>>>0<e>>>0){ct()}if((c[k+12>>2]|0)==(n|0)){break}ct()}}while(0);if((s|0)==(k|0)){c[217772]=c[217772]&~(1<<p);q=n;r=o;break}do{if((s|0)==(t|0)){u=s+8|0}else{if(s>>>0<e>>>0){ct()}v=s+8|0;if((c[v>>2]|0)==(n|0)){u=v;break}ct()}}while(0);c[k+12>>2]=s;c[u>>2]=k;q=n;r=o;break}t=m;p=c[a+(l+24)>>2]|0;v=c[a+(l+12)>>2]|0;do{if((v|0)==(t|0)){w=a+(l+20)|0;x=c[w>>2]|0;if((x|0)==0){y=a+(l+16)|0;z=c[y>>2]|0;if((z|0)==0){A=0;break}else{B=z;C=y}}else{B=x;C=w}while(1){w=B+20|0;x=c[w>>2]|0;if((x|0)!=0){B=x;C=w;continue}w=B+16|0;x=c[w>>2]|0;if((x|0)==0){break}else{B=x;C=w}}if(C>>>0<e>>>0){ct()}else{c[C>>2]=0;A=B;break}}else{w=c[a+(l+8)>>2]|0;if(w>>>0<e>>>0){ct()}x=w+12|0;if((c[x>>2]|0)!=(t|0)){ct()}y=v+8|0;if((c[y>>2]|0)==(t|0)){c[x>>2]=v;c[y>>2]=w;A=v;break}else{ct()}}}while(0);if((p|0)==0){q=n;r=o;break}v=a+(l+28)|0;m=871392+(c[v>>2]<<2)|0;do{if((t|0)==(c[m>>2]|0)){c[m>>2]=A;if((A|0)!=0){break}c[217773]=c[217773]&~(1<<c[v>>2]);q=n;r=o;break L3922}else{if(p>>>0<(c[217776]|0)>>>0){ct()}k=p+16|0;if((c[k>>2]|0)==(t|0)){c[k>>2]=A}else{c[p+20>>2]=A}if((A|0)==0){q=n;r=o;break L3922}}}while(0);if(A>>>0<(c[217776]|0)>>>0){ct()}c[A+24>>2]=p;t=c[a+(l+16)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[217776]|0)>>>0){ct()}else{c[A+16>>2]=t;c[t+24>>2]=A;break}}}while(0);t=c[a+(l+20)>>2]|0;if((t|0)==0){q=n;r=o;break}if(t>>>0<(c[217776]|0)>>>0){ct()}else{c[A+20>>2]=t;c[t+24>>2]=A;q=n;r=o;break}}else{q=d;r=h}}while(0);d=q;if(d>>>0>=i>>>0){ct()}A=a+(h-4)|0;e=c[A>>2]|0;if((e&1|0)==0){ct()}do{if((e&2|0)==0){if((j|0)==(c[217778]|0)){B=(c[217775]|0)+r|0;c[217775]=B;c[217778]=q;c[q+4>>2]=B|1;if((q|0)!=(c[217777]|0)){return}c[217777]=0;c[217774]=0;return}if((j|0)==(c[217777]|0)){B=(c[217774]|0)+r|0;c[217774]=B;c[217777]=q;c[q+4>>2]=B|1;c[d+B>>2]=B;return}B=(e&-8)+r|0;C=e>>>3;L4024:do{if(e>>>0<256>>>0){u=c[a+h>>2]|0;g=c[a+(h|4)>>2]|0;b=871128+(C<<1<<2)|0;do{if((u|0)!=(b|0)){if(u>>>0<(c[217776]|0)>>>0){ct()}if((c[u+12>>2]|0)==(j|0)){break}ct()}}while(0);if((g|0)==(u|0)){c[217772]=c[217772]&~(1<<C);break}do{if((g|0)==(b|0)){D=g+8|0}else{if(g>>>0<(c[217776]|0)>>>0){ct()}f=g+8|0;if((c[f>>2]|0)==(j|0)){D=f;break}ct()}}while(0);c[u+12>>2]=g;c[D>>2]=u}else{b=i;f=c[a+(h+16)>>2]|0;t=c[a+(h|4)>>2]|0;do{if((t|0)==(b|0)){p=a+(h+12)|0;v=c[p>>2]|0;if((v|0)==0){m=a+(h+8)|0;k=c[m>>2]|0;if((k|0)==0){E=0;break}else{F=k;G=m}}else{F=v;G=p}while(1){p=F+20|0;v=c[p>>2]|0;if((v|0)!=0){F=v;G=p;continue}p=F+16|0;v=c[p>>2]|0;if((v|0)==0){break}else{F=v;G=p}}if(G>>>0<(c[217776]|0)>>>0){ct()}else{c[G>>2]=0;E=F;break}}else{p=c[a+h>>2]|0;if(p>>>0<(c[217776]|0)>>>0){ct()}v=p+12|0;if((c[v>>2]|0)!=(b|0)){ct()}m=t+8|0;if((c[m>>2]|0)==(b|0)){c[v>>2]=t;c[m>>2]=p;E=t;break}else{ct()}}}while(0);if((f|0)==0){break}t=a+(h+20)|0;u=871392+(c[t>>2]<<2)|0;do{if((b|0)==(c[u>>2]|0)){c[u>>2]=E;if((E|0)!=0){break}c[217773]=c[217773]&~(1<<c[t>>2]);break L4024}else{if(f>>>0<(c[217776]|0)>>>0){ct()}g=f+16|0;if((c[g>>2]|0)==(b|0)){c[g>>2]=E}else{c[f+20>>2]=E}if((E|0)==0){break L4024}}}while(0);if(E>>>0<(c[217776]|0)>>>0){ct()}c[E+24>>2]=f;b=c[a+(h+8)>>2]|0;do{if((b|0)!=0){if(b>>>0<(c[217776]|0)>>>0){ct()}else{c[E+16>>2]=b;c[b+24>>2]=E;break}}}while(0);b=c[a+(h+12)>>2]|0;if((b|0)==0){break}if(b>>>0<(c[217776]|0)>>>0){ct()}else{c[E+20>>2]=b;c[b+24>>2]=E;break}}}while(0);c[q+4>>2]=B|1;c[d+B>>2]=B;if((q|0)!=(c[217777]|0)){H=B;break}c[217774]=B;return}else{c[A>>2]=e&-2;c[q+4>>2]=r|1;c[d+r>>2]=r;H=r}}while(0);r=H>>>3;if(H>>>0<256>>>0){d=r<<1;e=871128+(d<<2)|0;A=c[217772]|0;E=1<<r;do{if((A&E|0)==0){c[217772]=A|E;I=e;J=871128+(d+2<<2)|0}else{r=871128+(d+2<<2)|0;h=c[r>>2]|0;if(h>>>0>=(c[217776]|0)>>>0){I=h;J=r;break}ct()}}while(0);c[J>>2]=q;c[I+12>>2]=q;c[q+8>>2]=I;c[q+12>>2]=e;return}e=q;I=H>>>8;do{if((I|0)==0){K=0}else{if(H>>>0>16777215>>>0){K=31;break}J=(I+1048320|0)>>>16&8;d=I<<J;E=(d+520192|0)>>>16&4;A=d<<E;d=(A+245760|0)>>>16&2;r=14-(E|J|d)+(A<<d>>>15)|0;K=H>>>((r+7|0)>>>0)&1|r<<1}}while(0);I=871392+(K<<2)|0;c[q+28>>2]=K;c[q+20>>2]=0;c[q+16>>2]=0;r=c[217773]|0;d=1<<K;L4111:do{if((r&d|0)==0){c[217773]=r|d;c[I>>2]=e;c[q+24>>2]=I;c[q+12>>2]=q;c[q+8>>2]=q}else{A=c[I>>2]|0;if((K|0)==31){L=0}else{L=25-(K>>>1)|0}L4116:do{if((c[A+4>>2]&-8|0)==(H|0)){M=A}else{J=A;E=H<<L;while(1){N=J+16+(E>>>31<<2)|0;h=c[N>>2]|0;if((h|0)==0){break}if((c[h+4>>2]&-8|0)==(H|0)){M=h;break L4116}else{J=h;E=E<<1}}if(N>>>0<(c[217776]|0)>>>0){ct()}else{c[N>>2]=e;c[q+24>>2]=J;c[q+12>>2]=q;c[q+8>>2]=q;break L4111}}}while(0);A=M+8|0;B=c[A>>2]|0;E=c[217776]|0;if(M>>>0<E>>>0){ct()}if(B>>>0<E>>>0){ct()}else{c[B+12>>2]=e;c[A>>2]=e;c[q+8>>2]=B;c[q+12>>2]=M;c[q+24>>2]=0;break}}}while(0);q=(c[217780]|0)-1|0;c[217780]=q;if((q|0)==0){O=871544}else{return}while(1){q=c[O>>2]|0;if((q|0)==0){break}else{O=q+8|0}}c[217780]=-1;return}function AN(a,b){a=a|0;b=b|0;var d=0,e=0;do{if((a|0)==0){d=0}else{e=ag(b,a)|0;if((b|a)>>>0<=65535>>>0){d=e;break}d=((e>>>0)/(a>>>0)|0|0)==(b|0)?e:-1}}while(0);b=AL(d)|0;if((b|0)==0){return b|0}if((c[b-4>>2]&3|0)==0){return b|0}A2(b|0,0,d|0);return b|0}function AO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if((a|0)==0){d=AL(b)|0;return d|0}if(b>>>0>4294967231>>>0){c[(cd()|0)>>2]=12;d=0;return d|0}if(b>>>0<11>>>0){e=16}else{e=b+11&-8}f=AP(a-8|0,e)|0;if((f|0)!=0){d=f+8|0;return d|0}f=AL(b)|0;if((f|0)==0){d=0;return d|0}e=c[a-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;e=g>>>0<b>>>0?g:b;A$(f|0,a|0,e)|0;AM(a);d=f;return d|0}
function qD(){var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bT=0;f=i;switch(d[485832]|0){case 61:{g=a[461080]|0;h=e[242917]|0;j=d[461048]|0;if(((h&255)+j|0)>255){k=c[(c[217768]|0)+(h>>>8<<2)>>2]|0;l=(j+h&255|h&65280)&65535;da[k&255](l)|0;c[198580]=(c[198580]|0)+1;l=(d[461048]|0)+(e[242917]|0)|0;m=da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0}else{l=j+h|0;m=da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0}l=m&g;a[461080]=l;a[803368]=l;a[803360]=l;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 34:case 82:case 98:case 114:case 146:case 178:case 210:case 242:case 18:case 50:case 66:{c[198580]=(c[198580]|0)-2;l=c[115266]|0;c[198570]=l;a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;g=hy(86568,(m=i,i=i+8|0,c[m>>2]=l,m)|0)|0;i=m;if((g|0)==1){gL(c[198576]|0);m=c[198576]|0;l=c[m+80128>>2]&16;gz(m);if((l|0)!=0){gN(c[198576]|0)}c[198580]=6;hB();l=(da[c[(c[217768]|0)+1020>>2]&255](-3)|0)&255;m=l<<8;h=(da[c[(c[217768]|0)+1020>>2]&255](-4)|0)&255|m;c[115266]=h;j=c[(c[217770]|0)+(l<<2)>>2]|0;if((j|0)==0){n=0}else{n=j+(-m|0)|0}c[215624]=n;c[215620]=c[(c[163352]|0)+(l<<2)>>2];c[197210]=h;i=f;return}else if((g|0)==3){qH(1);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;h=c[198570]|0;c[115266]=h;l=h>>8;n=c[(c[217770]|0)+(l<<2)>>2]|0;if((n|0)==0){o=0}else{o=n+(-(h&65280)|0)|0}c[215624]=o;c[215620]=c[(c[163352]|0)+(l<<2)>>2];c[197210]=h;i=f;return}else if((g|0)==2){l8();gL(c[198576]|0);g=c[198576]|0;h=c[g+80128>>2]&16;gz(g);if((h|0)!=0){gN(c[198576]|0)}c[198580]=6;hB();h=(da[c[(c[217768]|0)+1020>>2]&255](-3)|0)&255;g=h<<8;l=(da[c[(c[217768]|0)+1020>>2]&255](-4)|0)&255|g;c[115266]=l;o=c[(c[217770]|0)+(h<<2)>>2]|0;if((o|0)==0){p=0}else{p=o+(-g|0)|0}c[215624]=p;c[215620]=c[(c[163352]|0)+(h<<2)>>2];c[197210]=l;i=f;return}else{c[198580]=(c[198580]|0)+1;i=f;return}break};case 72:{c[198580]=(c[198580]|0)+1;l=a[461080]|0;h=a[461056]|0;a[461056]=h-1&255;a[719208+(h&255|256)|0]=l;c[115266]=(c[115266]|0)+1;i=f;return};case 73:{l=a[485834]^a[461080];a[461080]=l;a[803368]=l;a[803360]=l;c[115266]=(c[115266]|0)+2;i=f;return};case 80:{l=(c[115266]|0)+2|0;c[115266]=l;if((a[461072]&64)!=0){i=f;return}h=(a[485834]|0)+l|0;da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0;c[198580]=(c[198580]|0)+1;l=c[115266]|0;if(((l^h)&65280|0)==0){c[200694]=c[200694]|256}else{p=l&65280;l=c[(c[217768]|0)+(p>>>8<<2)>>2]|0;g=(p|h&255)&65535;da[l&255](g)|0;c[198580]=(c[198580]|0)+1}g=h&65535;c[115266]=g;l=c[(c[217770]|0)+(g>>>8<<2)>>2]|0;if((l|0)==0){q=0}else{q=l+(-(h&65280)|0)|0}c[215624]=q;c[215620]=c[(c[163352]|0)+(g>>>8<<2)>>2];c[197210]=g;i=f;return};case 83:{g=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;q=g<<8;h=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;c[198580]=(c[198580]|0)+2;da[c[(c[217768]|0)+(g<<2)>>2]&255](((d[461040]|0)+h&255|q)&65535)|0;c[198580]=(c[198580]|0)+1;g=(d[461040]|0)+(h|q)|0;q=g>>>8;h=g&65535;g=da[c[(c[217768]|0)+(q<<2)>>2]&255](h)|0;l=a[461072]|0;a[461072]=(g&1)==0?l&-2:l|1;l=(g&255)>>>1;g=a[461080]^l;a[461080]=g;a[803368]=g;a[803360]=g;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(q<<2)>>2]&255](h,l);c[198568]=0;i=f;return};case 85:{l=a[461080]^(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0);a[461080]=l;a[803368]=l;a[803360]=l;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 1:{l=a[461080]|0;c[198580]=(c[198580]|0)+3;h=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;q=c[217768]|0;g=c[q+(h<<2)>>2]|0;h=((da[c[q>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;q=da[g&255](h)|0|l;a[461080]=q;a[803368]=q;a[803360]=q;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 41:{q=a[485834]&a[461080];a[461080]=q;a[803368]=q;a[803360]=q;c[115266]=(c[115266]|0)+2;i=f;return};case 44:{q=b[242917]|0;l=da[c[(c[217768]|0)+((q&65535)>>>8<<2)>>2]&255](q)|0;c[198580]=(c[198580]|0)+1;a[803368]=l&-128;q=a[461072]|0;a[461072]=(l&64)==0?q&-65:q|64;a[803360]=(a[461080]&l)<<24>>24!=0|0;c[115266]=(c[115266]|0)+3;i=f;return};case 51:{l=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;q=l<<8;h=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;c[198580]=(c[198580]|0)+2;da[c[(c[217768]|0)+(l<<2)>>2]&255](((d[461040]|0)+h&255|q)&65535)|0;c[198580]=(c[198580]|0)+1;l=(d[461040]|0)+(h|q)|0;q=l>>>8;h=l&65535;l=((da[c[(c[217768]|0)+(q<<2)>>2]&255](h)|0)&255)<<1;g=a[461072]|0;p=g&1|l;a[461072]=(l&256|0)==0?g&-2:g|1;g=p&d[461080]&255;a[461080]=g;a[803368]=g;a[803360]=g;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(q<<2)>>2]&255](h,p&255);c[198568]=0;i=f;return};case 59:{p=b[242917]|0;h=p&65535;da[c[(c[217768]|0)+(h>>>8<<2)>>2]&255]((d[461040]|0)+p&255|p&-256)|0;c[198580]=(c[198580]|0)+1;p=(d[461040]|0)+h|0;q=((da[c[(c[217768]|0)+(p>>>8<<2)>>2]&255](p&65535)|0)&255)<<1;p=a[461072]|0;g=p&1|q;a[461072]=(q&256|0)==0?p&-2:p|1;p=g&d[461080]&255;a[461080]=p;a[803368]=p;a[803360]=p;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;p=(d[461040]|0)+h|0;c5[c[(c[217766]|0)+(p>>>8<<2)>>2]&255](p&65535,g&255);c[198568]=0;i=f;return};case 49:{g=a[461080]|0;c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;p=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;h=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;q=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(p){p=c[c[217768]>>2]|0;l=(d[485834]|0)+1&65535;da[p&255](l)|0;l=c[c[217768]>>2]|0;p=d[485834]|0;da[l&255](p)|0;p=c[217768]|0;l=c[p+(h<<2)>>2]|0;o=((da[c[p>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;p=c[c[217768]>>2]|0;n=d[485834]|0;da[p&255](n)|0;n=c[c[217768]>>2]|0;p=(d[485834]|0)+1&65535;da[n&255](p)|0;p=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;n=(d[461040]|0)+p&255|o;da[l&255](n)|0;c[198580]=(c[198580]|0)+1;n=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;l=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|n;n=c[217768]|0;o=c[n+((l+(d[461040]|0)|0)>>>8<<2)>>2]|0;l=((da[c[n>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;n=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|l;r=da[o&255](n+(d[461040]|0)&65535)|0}else{n=c[217768]|0;o=c[n+(((d[461040]|0)+(q&255|h<<8)|0)>>>8<<2)>>2]|0;h=((da[c[n>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;n=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|h;r=da[o&255](n+(d[461040]|0)&65535)|0}n=r&g;a[461080]=n;a[803368]=n;a[803360]=n;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 67:{c[198580]=(c[198580]|0)+3;n=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;g=((da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|n<<8)&65535;r=da[c[(c[217768]|0)+(n<<2)>>2]&255](g)|0;o=a[461072]|0;a[461072]=(r&1)==0?o&-2:o|1;o=(r&255)>>>1;r=a[461080]^o;a[461080]=r;a[803368]=r;a[803360]=r;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(n<<2)>>2]&255](g,o);c[198568]=0;i=f;return};case 69:{o=a[461080]^(da[c[c[217768]>>2]&255](d[485834]|0)|0);a[461080]=o;a[803368]=o;a[803360]=o;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 70:{o=d[485834]|0;g=da[c[c[217768]>>2]&255](o)|0;n=a[461072]|0;a[461072]=(g&1)==0?n&-2:n|1;n=(g&255)>>>1;a[803368]=n;a[803360]=n;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](o,n);c[198568]=0;i=f;return};case 71:{n=d[485834]|0;o=da[c[c[217768]>>2]&255](n)|0;g=a[461072]|0;a[461072]=(o&1)==0?g&-2:g|1;g=(o&255)>>>1;o=a[461080]^g;a[461080]=o;a[803368]=o;a[803360]=o;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](n,g);c[198568]=0;i=f;return};case 48:{g=(c[115266]|0)+2|0;c[115266]=g;if((a[803368]|0)>=0){i=f;return}n=(a[485834]|0)+g|0;da[c[(c[217768]|0)+(g>>>8<<2)>>2]&255](g&65535)|0;c[198580]=(c[198580]|0)+1;g=c[115266]|0;if(((g^n)&65280|0)==0){c[200694]=c[200694]|256}else{o=g&65280;g=c[(c[217768]|0)+(o>>>8<<2)>>2]|0;r=(o|n&255)&65535;da[g&255](r)|0;c[198580]=(c[198580]|0)+1}r=n&65535;c[115266]=r;g=c[(c[217770]|0)+(r>>>8<<2)>>2]|0;if((g|0)==0){s=0}else{s=g+(-(n&65280)|0)|0}c[215624]=s;c[215620]=c[(c[163352]|0)+(r>>>8<<2)>>2];c[197210]=r;i=f;return};case 77:{r=b[242917]|0;s=a[461080]^(da[c[(c[217768]|0)+((r&65535)>>>8<<2)>>2]&255](r)|0);a[461080]=s;a[803368]=s;a[803360]=s;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 78:{s=b[242917]|0;r=(s&65535)>>>8;n=da[c[(c[217768]|0)+(r<<2)>>2]&255](s)|0;g=a[461072]|0;a[461072]=(n&1)==0?g&-2:g|1;g=(n&255)>>>1;a[803368]=g;a[803360]=g;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(r<<2)>>2]&255](s,g);c[198568]=0;i=f;return};case 79:{g=b[242917]|0;s=(g&65535)>>>8;r=da[c[(c[217768]|0)+(s<<2)>>2]&255](g)|0;n=a[461072]|0;a[461072]=(r&1)==0?n&-2:n|1;n=(r&255)>>>1;r=a[461080]^n;a[461080]=r;a[803368]=r;a[803360]=r;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(s<<2)>>2]&255](g,n);c[198568]=0;i=f;return};case 86:{n=(d[461048]|0)+(d[485834]|0)&255;g=da[c[c[217768]>>2]&255](n)|0;s=a[461072]|0;a[461072]=(g&1)==0?s&-2:s|1;s=(g&255)>>>1;a[803368]=s;a[803360]=s;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](n,s);c[198568]=0;i=f;return};case 87:{s=(d[461048]|0)+(d[485834]|0)&255;n=da[c[c[217768]>>2]&255](s)|0;g=a[461072]|0;a[461072]=(n&1)==0?g&-2:g|1;g=(n&255)>>>1;n=a[461080]^g;a[461080]=n;a[803368]=n;a[803360]=n;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](s,g);c[198568]=0;i=f;return};case 88:{c[115266]=(c[115266]|0)+1;g=a[461072]|0;if((g&4)!=0){c[200694]=c[200694]|1024}a[461072]=g&-5;i=f;return};case 89:{g=a[461080]|0;s=e[242917]|0;n=d[461040]|0;if(((s&255)+n|0)>255){r=c[(c[217768]|0)+(s>>>8<<2)>>2]|0;o=(n+s&255|s&65280)&65535;da[r&255](o)|0;c[198580]=(c[198580]|0)+1;o=(d[461040]|0)+(e[242917]|0)|0;t=da[c[(c[217768]|0)+(o>>>8<<2)>>2]&255](o&65535)|0}else{o=n+s|0;t=da[c[(c[217768]|0)+(o>>>8<<2)>>2]&255](o&65535)|0}o=t^g;a[461080]=o;a[803368]=o;a[803360]=o;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 91:{o=b[242917]|0;g=o&65535;da[c[(c[217768]|0)+(g>>>8<<2)>>2]&255]((d[461040]|0)+o&255|o&-256)|0;c[198580]=(c[198580]|0)+1;o=(d[461040]|0)+g|0;t=da[c[(c[217768]|0)+(o>>>8<<2)>>2]&255](o&65535)|0;o=a[461072]|0;a[461072]=(t&1)==0?o&-2:o|1;o=(t&255)>>>1;t=a[461080]^o;a[461080]=t;a[803368]=t;a[803360]=t;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;t=(d[461040]|0)+g|0;c5[c[(c[217766]|0)+(t>>>8<<2)>>2]&255](t&65535,o);c[198568]=0;i=f;return};case 93:{o=a[461080]|0;t=e[242917]|0;g=d[461048]|0;if(((t&255)+g|0)>255){s=c[(c[217768]|0)+(t>>>8<<2)>>2]|0;n=(g+t&255|t&65280)&65535;da[s&255](n)|0;c[198580]=(c[198580]|0)+1;n=(d[461048]|0)+(e[242917]|0)|0;u=da[c[(c[217768]|0)+(n>>>8<<2)>>2]&255](n&65535)|0}else{n=g+t|0;u=da[c[(c[217768]|0)+(n>>>8<<2)>>2]&255](n&65535)|0}n=u^o;a[461080]=n;a[803368]=n;a[803360]=n;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 94:{n=b[242917]|0;o=n&65535;da[c[(c[217768]|0)+(o>>>8<<2)>>2]&255]((d[461048]|0)+n&255|n&-256)|0;c[198580]=(c[198580]|0)+1;n=(d[461048]|0)+o|0;u=da[c[(c[217768]|0)+(n>>>8<<2)>>2]&255](n&65535)|0;n=a[461072]|0;a[461072]=(u&1)==0?n&-2:n|1;n=(u&255)>>>1;a[803368]=n;a[803360]=n;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;u=(d[461048]|0)+o|0;c5[c[(c[217766]|0)+(u>>>8<<2)>>2]&255](u&65535,n);c[198568]=0;i=f;return};case 95:{n=b[242917]|0;u=n&65535;da[c[(c[217768]|0)+(u>>>8<<2)>>2]&255]((d[461048]|0)+n&255|n&-256)|0;c[198580]=(c[198580]|0)+1;n=(d[461048]|0)+u|0;o=da[c[(c[217768]|0)+(n>>>8<<2)>>2]&255](n&65535)|0;n=a[461072]|0;a[461072]=(o&1)==0?n&-2:n|1;n=(o&255)>>>1;o=a[461080]^n;a[461080]=o;a[803368]=o;a[803360]=o;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;o=(d[461048]|0)+u|0;c5[c[(c[217766]|0)+(o>>>8<<2)>>2]&255](o&65535,n);c[198568]=0;i=f;return};case 96:{c[198580]=(c[198580]|0)+3;n=a[461056]|0;o=d[719208+(n+1&255|256)|0]|0;u=n+2&255;a[461056]=u;n=d[719208+(u&255|256)|0]<<8;u=n|o;da[c[(c[217768]|0)+((n&65535)>>>8<<2)>>2]&255](u)|0;c[198580]=(c[198580]|0)+1;n=u+1&65535;c[115266]=n;u=c[(c[217770]|0)+(n>>>8<<2)>>2]|0;if((u|0)==0){v=0}else{v=u+(-(n&65280)|0)|0}c[215624]=v;c[215620]=c[(c[163352]|0)+(n>>>8<<2)>>2];c[197210]=n;i=f;return};case 81:{n=a[461080]|0;c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;v=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;u=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;o=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(v){v=c[c[217768]>>2]|0;t=(d[485834]|0)+1&65535;da[v&255](t)|0;t=c[c[217768]>>2]|0;v=d[485834]|0;da[t&255](v)|0;v=c[217768]|0;t=c[v+(u<<2)>>2]|0;g=((da[c[v>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;v=c[c[217768]>>2]|0;s=d[485834]|0;da[v&255](s)|0;s=c[c[217768]>>2]|0;v=(d[485834]|0)+1&65535;da[s&255](v)|0;v=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;s=(d[461040]|0)+v&255|g;da[t&255](s)|0;c[198580]=(c[198580]|0)+1;s=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;t=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|s;s=c[217768]|0;g=c[s+((t+(d[461040]|0)|0)>>>8<<2)>>2]|0;t=((da[c[s>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;s=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|t;w=da[g&255](s+(d[461040]|0)&65535)|0}else{s=c[217768]|0;g=c[s+(((d[461040]|0)+(o&255|u<<8)|0)>>>8<<2)>>2]|0;u=((da[c[s>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;s=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|u;w=da[g&255](s+(d[461040]|0)&65535)|0}s=w^n;a[461080]=s;a[803368]=s;a[803360]=s;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 97:{c[198580]=(c[198580]|0)+3;s=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;n=c[217768]|0;w=c[n+(s<<2)>>2]|0;s=((da[c[n>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;n=da[w&255](s)|0;s=n&255;c[198580]=(c[198580]|0)+1;w=a[461072]|0;g=w&255;u=a[461080]|0;o=u&255;do{if((g&8|0)==0){t=o+s+(g&1)|0;v=t&255;a[803368]=v;a[803360]=v;do{if((u^n)<<24>>24<0){x=3e3}else{if(((o^t)&128|0)==0){x=3e3;break}y=w|64}}while(0);if((x|0)==3e3){y=w&-65}a[461072]=y;if(t>>>0>255>>>0){a[461072]=y|1;z=v;break}else{a[461072]=y&-2;z=v;break}}else{r=g&1;h=r+(s&15)+(o&15)|0;q=h>>>0>9>>>0?h+6|0:h;h=(q&15|o&240)+(s&240)|0;l=q>>>0<16>>>0?h:h+16|0;a[803360]=(o+s+r&255|0)!=0|0;a[803368]=l&255&-128;do{if(((o^l)&128|0)==0){x=2993}else{if((u^n)<<24>>24<0){x=2993;break}A=w|64}}while(0);if((x|0)==2993){A=w&-65}a[461072]=A;v=(l&496)>>>0>144>>>0?l+96|0:l;if((v&4080)>>>0>240>>>0){a[461072]=A|1;z=v&255;break}else{a[461072]=A&-2;z=v&255;break}}}while(0);a[461080]=z;c[115266]=(c[115266]|0)+2;i=f;return};case 99:{c[198580]=(c[198580]|0)+3;z=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;A=((da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|z<<8)&65535;w=(da[c[(c[217768]|0)+(z<<2)>>2]&255](A)|0)&255;n=w>>>1;u=a[461072]|0;o=(u&1)<<7;s=o|n;g=(w&1|0)==0?u&-2:u|1;a[461072]=g;c[198568]=1;c[115266]=(c[115266]|0)+2;u=g&255;w=d[461080]|0;do{if((u&8|0)==0){y=s+w+(u&1)|0;v=y&255;a[803368]=v;a[803360]=v;do{if((w&128|0)==(o|0)){if(((w^y)&128|0)==0){x=3012;break}B=g|64}else{x=3012}}while(0);if((x|0)==3012){B=g&-65}a[461072]=B;if(y>>>0>255>>>0){a[461072]=B|1;C=v;break}else{a[461072]=B&-2;C=v;break}}else{l=u&1;t=(w&15)+(n&15)+l|0;r=t>>>0>9>>>0?t+6|0:t;t=(r&15|w&240)+(s&240)|0;h=r>>>0<16>>>0?t:t+16|0;a[803360]=(s+w+l&255|0)!=0|0;a[803368]=h&255&-128;l=((w^h)&128|0)!=0&(w&128|0)==(o|0)?g|64:g&-65;a[461072]=l;t=(h&496)>>>0>144>>>0?h+96|0:h;if((t&4080)>>>0>240>>>0){a[461072]=l|1;C=t&255;break}else{a[461072]=l&-2;C=t&255;break}}}while(0);a[461080]=C;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(z<<2)>>2]&255](A,s&255);c[198568]=0;i=f;return};case 101:{s=da[c[c[217768]>>2]&255](d[485834]|0)|0;A=s&255;c[198580]=(c[198580]|0)+1;z=a[461072]|0;C=z&255;g=a[461080]|0;o=g&255;do{if((C&8|0)==0){w=o+A+(C&1)|0;n=w&255;a[803368]=n;a[803360]=n;do{if((g^s)<<24>>24<0){x=3028}else{if(((o^w)&128|0)==0){x=3028;break}D=z|64}}while(0);if((x|0)==3028){D=z&-65}a[461072]=D;if(w>>>0>255>>>0){a[461072]=D|1;E=n;break}else{a[461072]=D&-2;E=n;break}}else{v=C&1;y=v+(A&15)+(o&15)|0;u=y>>>0>9>>>0?y+6|0:y;y=(u&15|o&240)+(A&240)|0;B=u>>>0<16>>>0?y:y+16|0;a[803360]=(o+A+v&255|0)!=0|0;a[803368]=B&255&-128;do{if(((o^B)&128|0)==0){x=3021}else{if((g^s)<<24>>24<0){x=3021;break}F=z|64}}while(0);if((x|0)==3021){F=z&-65}a[461072]=F;n=(B&496)>>>0>144>>>0?B+96|0:B;if((n&4080)>>>0>240>>>0){a[461072]=F|1;E=n&255;break}else{a[461072]=F&-2;E=n&255;break}}}while(0);a[461080]=E;c[115266]=(c[115266]|0)+2;i=f;return};case 102:{E=d[485834]|0;F=(da[c[c[217768]>>2]&255](E)|0)&255;z=a[461072]|0;a[461072]=(F&1|0)==0?z&-2:z|1;s=((z&255)<<8|F)>>>1&255;a[803368]=s;a[803360]=s;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](E,s);c[198568]=0;i=f;return};case 103:{s=d[485834]|0;E=(da[c[c[217768]>>2]&255](s)|0)&255;F=E>>>1;z=a[461072]|0;g=(z&1)<<7;o=g|F;A=(E&1|0)==0?z&-2:z|1;a[461072]=A;c[198568]=1;c[115266]=(c[115266]|0)+2;z=A&255;E=d[461080]|0;do{if((z&8|0)==0){C=o+E+(z&1)|0;D=C&255;a[803368]=D;a[803360]=D;do{if((E&128|0)==(g|0)){if(((E^C)&128|0)==0){x=3041;break}G=A|64}else{x=3041}}while(0);if((x|0)==3041){G=A&-65}a[461072]=G;if(C>>>0>255>>>0){a[461072]=G|1;H=D;break}else{a[461072]=G&-2;H=D;break}}else{B=z&1;n=(E&15)+(F&15)+B|0;w=n>>>0>9>>>0?n+6|0:n;n=(w&15|E&240)+(o&240)|0;v=w>>>0<16>>>0?n:n+16|0;a[803360]=(o+E+B&255|0)!=0|0;a[803368]=v&255&-128;B=((E^v)&128|0)!=0&(E&128|0)==(g|0)?A|64:A&-65;a[461072]=B;n=(v&496)>>>0>144>>>0?v+96|0:v;if((n&4080)>>>0>240>>>0){a[461072]=B|1;H=n&255;break}else{a[461072]=B&-2;H=n&255;break}}}while(0);a[461080]=H;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](s,o&255);c[198568]=0;i=f;return};case 104:{c[198580]=(c[198580]|0)+2;o=(a[461056]|0)+1&255;a[461056]=o;s=a[719208+(o&255|256)|0]|0;a[461080]=s;a[803368]=s;a[803360]=s;c[115266]=(c[115266]|0)+1;i=f;return};case 105:{s=a[485834]|0;o=s&255;H=a[461072]|0;A=H&255;g=a[461080]|0;E=g&255;do{if((A&8|0)==0){F=E+o+(A&1)|0;z=F&255;a[803368]=z;a[803360]=z;do{if((g^s)<<24>>24<0){x=3058}else{if(((E^F)&128|0)==0){x=3058;break}I=H|64}}while(0);if((x|0)==3058){I=H&-65}a[461072]=I;if(F>>>0>255>>>0){a[461072]=I|1;J=z;break}else{a[461072]=I&-2;J=z;break}}else{D=A&1;C=D+(o&15)+(E&15)|0;G=C>>>0>9>>>0?C+6|0:C;C=(G&15|E&240)+(o&240)|0;n=G>>>0<16>>>0?C:C+16|0;a[803360]=(E+o+D&255|0)!=0|0;a[803368]=n&255&-128;do{if(((E^n)&128|0)==0){x=3051}else{if((g^s)<<24>>24<0){x=3051;break}K=H|64}}while(0);if((x|0)==3051){K=H&-65}a[461072]=K;z=(n&496)>>>0>144>>>0?n+96|0:n;if((z&4080)>>>0>240>>>0){a[461072]=K|1;J=z&255;break}else{a[461072]=K&-2;J=z&255;break}}}while(0);a[461080]=J;c[115266]=(c[115266]|0)+2;i=f;return};case 106:{J=a[461080]|0;K=a[461072]|0;H=K<<7|(J&255)>>>1;a[461080]=H;a[461072]=(J&1)==0?K&-2:K|1;a[803368]=H;a[803360]=H;c[115266]=(c[115266]|0)+1;i=f;return};case 107:{H=a[485834]&a[461080]&255;K=a[461072]|0;J=K&255;s=(J<<8&256|H)>>>1;do{if((J&8|0)==0){g=s&255;a[803368]=g;a[803360]=g;E=s&64;o=(E|0)==0?K&-2:K|1;a[461072]=o;L=g;M=(E|0)==(H&64|0)?o&-65:o|64}else{a[803368]=K<<7;a[803360]=(s|0)!=0|0;o=((s^H)&64|0)==0?K&-65:K|64;a[461072]=o;if(((H&15)+(H&1)|0)>>>0>5>>>0){N=s+6&15|s&240}else{N=s}if(((H&240)+(H&16)|0)>>>0>80>>>0){L=(N+96&240|N&15)&255;M=o|1;break}else{L=N&255;M=o&-2;break}}}while(0);a[461072]=M;a[461080]=L;c[115266]=(c[115266]|0)+2;i=f;return};case 108:{L=b[242917]|0;M=da[c[(c[217768]|0)+((L&65535)>>>8<<2)>>2]&255](L)|0;c[198580]=(c[198580]|0)+1;L=b[242917]|0;N=((da[c[(c[217768]|0)+((L&65535)>>>8<<2)>>2]&255](L+1&255|L&-256)|0)&255)<<8|M&255;c[198580]=(c[198580]|0)+1;M=N&65535;c[115266]=M;N=c[(c[217770]|0)+(M>>>8<<2)>>2]|0;if((N|0)==0){O=0}else{O=N+(-(M&65280)|0)|0}c[215624]=O;c[215620]=c[(c[163352]|0)+(M>>>8<<2)>>2];c[197210]=M;i=f;return};case 109:{M=b[242917]|0;O=da[c[(c[217768]|0)+((M&65535)>>>8<<2)>>2]&255](M)|0;M=O&255;c[198580]=(c[198580]|0)+1;N=a[461072]|0;L=N&255;H=a[461080]|0;s=H&255;do{if((L&8|0)==0){K=s+M+(L&1)|0;J=K&255;a[803368]=J;a[803360]=J;do{if((H^O)<<24>>24<0){x=3086}else{if(((s^K)&128|0)==0){x=3086;break}P=N|64}}while(0);if((x|0)==3086){P=N&-65}a[461072]=P;if(K>>>0>255>>>0){a[461072]=P|1;Q=J;break}else{a[461072]=P&-2;Q=J;break}}else{n=L&1;o=n+(M&15)+(s&15)|0;E=o>>>0>9>>>0?o+6|0:o;o=(E&15|s&240)+(M&240)|0;g=E>>>0<16>>>0?o:o+16|0;a[803360]=(s+M+n&255|0)!=0|0;a[803368]=g&255&-128;do{if(((s^g)&128|0)==0){x=3079}else{if((H^O)<<24>>24<0){x=3079;break}R=N|64}}while(0);if((x|0)==3079){R=N&-65}a[461072]=R;J=(g&496)>>>0>144>>>0?g+96|0:g;if((J&4080)>>>0>240>>>0){a[461072]=R|1;Q=J&255;break}else{a[461072]=R&-2;Q=J&255;break}}}while(0);a[461080]=Q;c[115266]=(c[115266]|0)+3;i=f;return};case 55:{Q=(d[461048]|0)+(d[485834]|0)&255;R=((da[c[c[217768]>>2]&255](Q)|0)&255)<<1;N=a[461072]|0;O=N&1|R;a[461072]=(R&256|0)==0?N&-2:N|1;N=O&d[461080]&255;a[461080]=N;a[803368]=N;a[803360]=N;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](Q,O&255);c[198568]=0;i=f;return};case 56:{a[461072]=a[461072]|1;c[115266]=(c[115266]|0)+1;i=f;return};case 3:{c[198580]=(c[198580]|0)+3;O=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;Q=((da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|O<<8)&65535;N=da[c[(c[217768]|0)+(O<<2)>>2]&255](Q)|0;R=a[461072]|0;a[461072]=N<<24>>24>-1?R&-2:R|1;R=N<<1;N=a[461080]|R;a[461080]=N;a[803368]=N;a[803360]=N;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(O<<2)>>2]&255](Q,R);c[198568]=0;i=f;return};case 4:case 68:case 100:{c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 5:{R=a[461080]|(da[c[c[217768]>>2]&255](d[485834]|0)|0);a[461080]=R;a[803368]=R;a[803360]=R;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 6:{R=d[485834]|0;Q=da[c[c[217768]>>2]&255](R)|0;O=a[461072]|0;a[461072]=Q<<24>>24>-1?O&-2:O|1;O=Q<<1;a[803368]=O;a[803360]=O;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](R,O);c[198568]=0;i=f;return};case 7:{O=d[485834]|0;R=da[c[c[217768]>>2]&255](O)|0;Q=a[461072]|0;a[461072]=R<<24>>24>-1?Q&-2:Q|1;Q=R<<1;R=a[461080]|Q;a[461080]=R;a[803368]=R;a[803360]=R;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](O,Q);c[198568]=0;i=f;return};case 8:{c[198580]=(c[198580]|0)+1;Q=a[461072]|a[803368]&-128|((a[803360]|0)==0?2:0)|48;O=a[461056]|0;a[461056]=O-1&255;a[719208+(O&255|256)|0]=Q;c[115266]=(c[115266]|0)+1;i=f;return};case 9:{Q=a[485834]|a[461080];a[461080]=Q;a[803368]=Q;a[803360]=Q;c[115266]=(c[115266]|0)+2;i=f;return};case 10:{Q=a[461080]|0;O=a[461072]|0;a[461072]=Q<<24>>24<0?O|1:O&-2;O=Q<<1;a[461080]=O;a[803368]=O;a[803360]=O;c[115266]=(c[115266]|0)+1;i=f;return};case 11:{O=a[485834]&a[461080];a[461080]=O;a[803368]=O;a[803360]=O;Q=a[461072]|0;a[461072]=O<<24>>24<0?Q|1:Q&-2;c[115266]=(c[115266]|0)+2;i=f;return};case 12:{Q=b[242917]|0;da[c[(c[217768]|0)+((Q&65535)>>>8<<2)>>2]&255](Q)|0;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 13:{Q=b[242917]|0;O=a[461080]|(da[c[(c[217768]|0)+((Q&65535)>>>8<<2)>>2]&255](Q)|0);a[461080]=O;a[803368]=O;a[803360]=O;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 14:{O=b[242917]|0;Q=(O&65535)>>>8;R=da[c[(c[217768]|0)+(Q<<2)>>2]&255](O)|0;N=a[461072]|0;a[461072]=R<<24>>24>-1?N&-2:N|1;N=R<<1;a[803368]=N;a[803360]=N;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(Q<<2)>>2]&255](O,N);c[198568]=0;i=f;return};case 15:{N=b[242917]|0;O=(N&65535)>>>8;Q=da[c[(c[217768]|0)+(O<<2)>>2]&255](N)|0;R=a[461072]|0;a[461072]=Q<<24>>24>-1?R&-2:R|1;R=Q<<1;Q=a[461080]|R;a[461080]=Q;a[803368]=Q;a[803360]=Q;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(O<<2)>>2]&255](N,R);c[198568]=0;i=f;return};case 17:{R=a[461080]|0;c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;N=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;O=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;Q=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(N){N=c[c[217768]>>2]|0;H=(d[485834]|0)+1&65535;da[N&255](H)|0;H=c[c[217768]>>2]|0;N=d[485834]|0;da[H&255](N)|0;N=c[217768]|0;H=c[N+(O<<2)>>2]|0;s=((da[c[N>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;N=c[c[217768]>>2]|0;M=d[485834]|0;da[N&255](M)|0;M=c[c[217768]>>2]|0;N=(d[485834]|0)+1&65535;da[M&255](N)|0;N=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;M=(d[461040]|0)+N&255|s;da[H&255](M)|0;c[198580]=(c[198580]|0)+1;M=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;H=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|M;M=c[217768]|0;s=c[M+((H+(d[461040]|0)|0)>>>8<<2)>>2]|0;H=((da[c[M>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;M=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|H;S=da[s&255](M+(d[461040]|0)&65535)|0}else{M=c[217768]|0;s=c[M+(((d[461040]|0)+(Q&255|O<<8)|0)>>>8<<2)>>2]|0;O=((da[c[M>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;M=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|O;S=da[s&255](M+(d[461040]|0)&65535)|0}M=S|R;a[461080]=M;a[803368]=M;a[803360]=M;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 19:{c[198580]=(c[198580]|0)+2;M=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;R=M<<8;S=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;da[c[(c[217768]|0)+(M<<2)>>2]&255](((d[461040]|0)+S&255|R)&65535)|0;c[198580]=(c[198580]|0)+1;M=(d[461040]|0)+(S|R)|0;R=M>>>8;S=M&65535;M=da[c[(c[217768]|0)+(R<<2)>>2]&255](S)|0;s=a[461072]|0;a[461072]=M<<24>>24>-1?s&-2:s|1;s=M<<1;M=a[461080]|s;a[461080]=M;a[803368]=M;a[803360]=M;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(R<<2)>>2]&255](S,s);c[198568]=0;i=f;return};case 20:case 52:case 84:case 116:case 212:case 244:{c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 21:{s=a[461080]|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0);a[461080]=s;a[803368]=s;a[803360]=s;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 22:{s=(d[461048]|0)+(d[485834]|0)&255;S=da[c[c[217768]>>2]&255](s)|0;R=a[461072]|0;a[461072]=S<<24>>24>-1?R&-2:R|1;R=S<<1;a[803368]=R;a[803360]=R;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](s,R);c[198568]=0;i=f;return};case 23:{R=(d[461048]|0)+(d[485834]|0)&255;s=da[c[c[217768]>>2]&255](R)|0;S=a[461072]|0;a[461072]=s<<24>>24>-1?S&-2:S|1;S=s<<1;s=a[461080]|S;a[461080]=s;a[803368]=s;a[803360]=s;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](R,S);c[198568]=0;i=f;return};case 24:{c[115266]=(c[115266]|0)+1;a[461072]=a[461072]&-2;i=f;return};case 25:{S=a[461080]|0;R=e[242917]|0;s=d[461040]|0;if(((R&255)+s|0)>255){M=c[(c[217768]|0)+(R>>>8<<2)>>2]|0;O=(s+R&255|R&65280)&65535;da[M&255](O)|0;c[198580]=(c[198580]|0)+1;O=(d[461040]|0)+(e[242917]|0)|0;T=da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255](O&65535)|0}else{O=s+R|0;T=da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255](O&65535)|0}O=T|S;a[461080]=O;a[803368]=O;a[803360]=O;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 26:case 58:case 90:case 122:case 218:case 250:{c[115266]=(c[115266]|0)+1;i=f;return};case 27:{O=b[242917]|0;S=O&65535;da[c[(c[217768]|0)+(S>>>8<<2)>>2]&255]((d[461040]|0)+O&255|O&-256)|0;c[198580]=(c[198580]|0)+1;O=(d[461040]|0)+S|0;T=da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255](O&65535)|0;O=a[461072]|0;a[461072]=T<<24>>24>-1?O&-2:O|1;O=T<<1;T=a[461080]|O;a[461080]=T;a[803368]=T;a[803360]=T;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;T=(d[461040]|0)+S|0;c5[c[(c[217766]|0)+(T>>>8<<2)>>2]&255](T&65535,O);c[198568]=0;i=f;return};case 28:case 60:case 92:case 124:case 220:case 252:{O=e[242917]|0;T=d[461048]|0;if(((O&255)+T|0)>255){S=c[(c[217768]|0)+(O>>>8<<2)>>2]|0;R=(T+O&255|O&65280)&65535;da[S&255](R)|0;c[198580]=(c[198580]|0)+1;R=(d[461048]|0)+(e[242917]|0)|0;S=c[(c[217768]|0)+(R>>>8<<2)>>2]|0;s=R&65535;da[S&255](s)|0}else{s=T+O|0;O=c[(c[217768]|0)+(s>>>8<<2)>>2]|0;T=s&65535;da[O&255](T)|0}c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 29:{T=a[461080]|0;O=e[242917]|0;s=d[461048]|0;if(((O&255)+s|0)>255){S=c[(c[217768]|0)+(O>>>8<<2)>>2]|0;R=(s+O&255|O&65280)&65535;da[S&255](R)|0;c[198580]=(c[198580]|0)+1;R=(d[461048]|0)+(e[242917]|0)|0;U=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0}else{R=s+O|0;U=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0}R=U|T;a[461080]=R;a[803368]=R;a[803360]=R;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 30:{R=b[242917]|0;T=R&65535;da[c[(c[217768]|0)+(T>>>8<<2)>>2]&255]((d[461048]|0)+R&255|R&-256)|0;c[198580]=(c[198580]|0)+1;R=(d[461048]|0)+T|0;U=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0;R=a[461072]|0;a[461072]=U<<24>>24>-1?R&-2:R|1;R=U<<1;a[803368]=R;a[803360]=R;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;U=(d[461048]|0)+T|0;c5[c[(c[217766]|0)+(U>>>8<<2)>>2]&255](U&65535,R);c[198568]=0;i=f;return};case 31:{R=b[242917]|0;U=R&65535;da[c[(c[217768]|0)+(U>>>8<<2)>>2]&255]((d[461048]|0)+R&255|R&-256)|0;c[198580]=(c[198580]|0)+1;R=(d[461048]|0)+U|0;T=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0;R=a[461072]|0;a[461072]=T<<24>>24>-1?R&-2:R|1;R=T<<1;T=a[461080]|R;a[461080]=T;a[803368]=T;a[803360]=T;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;T=(d[461048]|0)+U|0;c5[c[(c[217766]|0)+(T>>>8<<2)>>2]&255](T&65535,R);c[198568]=0;i=f;return};case 32:{R=c[198580]|0;T=(c[115266]|0)+2|0;c[115266]=T;c[198580]=R+3;R=T>>>8;U=a[461056]|0;a[719208+(U&255|256)|0]=R&255;a[461056]=U-2&255;a[719208+(U-1&255|256)|0]=T&255;U=d[485834]|0;O=(da[c[(c[217768]|0)+(R<<2)>>2]&255](T&65535)|0)&255;T=O<<8;R=T|U;c[198580]=(c[198580]|0)+1;c[115266]=R;U=c[(c[217770]|0)+(O<<2)>>2]|0;if((U|0)==0){V=0}else{V=U+(-T|0)|0}c[215624]=V;c[215620]=c[(c[163352]|0)+(O<<2)>>2];c[197210]=R;i=f;return};case 33:{R=a[461080]|0;c[198580]=(c[198580]|0)+3;O=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;V=c[217768]|0;T=c[V+(O<<2)>>2]|0;O=((da[c[V>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;V=(da[T&255](O)|0)&R;a[461080]=V;a[803368]=V;a[803360]=V;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 35:{V=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;R=(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|V<<8;c[198580]=(c[198580]|0)+3;O=R&65535;R=((da[c[(c[217768]|0)+(V<<2)>>2]&255](O)|0)&255)<<1;T=a[461072]|0;U=T&1|R;a[461072]=(R&256|0)==0?T&-2:T|1;T=U&d[461080]&255;a[461080]=T;a[803368]=T;a[803360]=T;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(V<<2)>>2]&255](O,U&255);c[198568]=0;i=f;return};case 36:{U=da[c[c[217768]>>2]&255](d[485834]|0)|0;c[198580]=(c[198580]|0)+1;a[803368]=U&-128;O=a[461072]|0;a[461072]=(U&64)==0?O&-65:O|64;a[803360]=(a[461080]&U)<<24>>24!=0|0;c[115266]=(c[115266]|0)+2;i=f;return};case 37:{U=a[461080]&(da[c[c[217768]>>2]&255](d[485834]|0)|0);a[461080]=U;a[803368]=U;a[803360]=U;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 39:{U=d[485834]|0;O=((da[c[c[217768]>>2]&255](U)|0)&255)<<1;V=a[461072]|0;T=V&1|O;a[461072]=(O&256|0)==0?V&-2:V|1;V=T&d[461080]&255;a[461080]=V;a[803368]=V;a[803360]=V;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](U,T&255);c[198568]=0;i=f;return};case 40:{T=(a[461056]|0)+1&255;a[461056]=T;U=a[719208+(T&255|256)|0]|0;T=(a[461072]&4)==0;do{if((U&4)==0){if(T){break}c[200694]=c[200694]|1024}else{if(!T){break}c[200694]=c[200694]|512}}while(0);c[198580]=(c[198580]|0)+2;a[461072]=U&125;a[803360]=(U&255)>>>1&1^1;a[803368]=U;c[115266]=(c[115266]|0)+1;i=f;return};case 38:{U=d[485834]|0;T=((da[c[c[217768]>>2]&255](U)|0)&255)<<1;V=a[461072]|0;a[461072]=(T&256|0)==0?V&-2:V|1;O=(V&1|T)&255;a[803368]=O;a[803360]=O;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](U,O);c[198568]=0;i=f;return};case 74:{O=a[461080]|0;U=a[461072]|0;a[461072]=(O&1)==0?U&-2:U|1;U=(O&255)>>>1;a[461080]=U;a[803368]=U;a[803360]=U;c[115266]=(c[115266]|0)+1;i=f;return};case 75:{U=a[485834]&a[461080];O=a[461072]|0;a[461072]=(U&1)==0?O&-2:O|1;O=(U&255)>>>1;a[461080]=O;a[803368]=O;a[803360]=O;c[115266]=(c[115266]|0)+2;i=f;return};case 57:{O=a[461080]|0;U=e[242917]|0;T=d[461040]|0;if(((U&255)+T|0)>255){V=c[(c[217768]|0)+(U>>>8<<2)>>2]|0;R=(T+U&255|U&65280)&65535;da[V&255](R)|0;c[198580]=(c[198580]|0)+1;R=(d[461040]|0)+(e[242917]|0)|0;W=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0}else{R=T+U|0;W=da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255](R&65535)|0}R=W&O;a[461080]=R;a[803368]=R;a[803360]=R;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 53:{R=a[461080]&(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0);a[461080]=R;a[803368]=R;a[803360]=R;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 54:{R=(d[461048]|0)+(d[485834]|0)&255;O=((da[c[c[217768]>>2]&255](R)|0)&255)<<1;W=a[461072]|0;a[461072]=(O&256|0)==0?W&-2:W|1;U=(W&1|O)&255;a[803368]=U;a[803360]=U;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](R,U);c[198568]=0;i=f;return};case 62:{U=b[242917]|0;R=U&65535;da[c[(c[217768]|0)+(R>>>8<<2)>>2]&255]((d[461048]|0)+U&255|U&-256)|0;c[198580]=(c[198580]|0)+1;U=(d[461048]|0)+R|0;O=((da[c[(c[217768]|0)+(U>>>8<<2)>>2]&255](U&65535)|0)&255)<<1;U=a[461072]|0;a[461072]=(O&256|0)==0?U&-2:U|1;W=(U&1|O)&255;a[803368]=W;a[803360]=W;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;O=(d[461048]|0)+R|0;c5[c[(c[217766]|0)+(O>>>8<<2)>>2]&255](O&65535,W);c[198568]=0;i=f;return};case 63:{W=b[242917]|0;O=W&65535;da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255]((d[461048]|0)+W&255|W&-256)|0;c[198580]=(c[198580]|0)+1;W=(d[461048]|0)+O|0;R=((da[c[(c[217768]|0)+(W>>>8<<2)>>2]&255](W&65535)|0)&255)<<1;W=a[461072]|0;U=W&1|R;a[461072]=(R&256|0)==0?W&-2:W|1;W=U&d[461080]&255;a[461080]=W;a[803368]=W;a[803360]=W;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;W=(d[461048]|0)+O|0;c5[c[(c[217766]|0)+(W>>>8<<2)>>2]&255](W&65535,U&255);c[198568]=0;i=f;return};case 65:{U=a[461080]|0;c[198580]=(c[198580]|0)+3;W=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;O=c[217768]|0;R=c[O+(W<<2)>>2]|0;W=((da[c[O>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;O=(da[R&255](W)|0)^U;a[461080]=O;a[803368]=O;a[803360]=O;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 43:{O=a[485834]&a[461080];a[461080]=O;a[803368]=O;a[803360]=O;U=a[461072]|0;a[461072]=O<<24>>24<0?U|1:U&-2;c[115266]=(c[115266]|0)+2;i=f;return};case 45:{U=b[242917]|0;O=a[461080]&(da[c[(c[217768]|0)+((U&65535)>>>8<<2)>>2]&255](U)|0);a[461080]=O;a[803368]=O;a[803360]=O;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 0:{O=c[115266]|0;c[198570]=O;a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;U=a[461056]|0;a[794287]=U;W=a[461072]|0;a[794288]=W;R=a[803368]|0;a[794289]=R;T=a[803360]|0;a[794290]=T;c[198580]=(c[198580]|0)+5;V=O+2|0;c[115266]=V;a[719208+(U&255|256)|0]=V>>>8&255;a[719208+(U-1&255|256)|0]=V&255;a[461056]=U-3&255;a[719208+(U-2&255|256)|0]=W|R&-128|(T<<24>>24==0?2:0)|48;a[461072]=W|20;W=(da[c[(c[217768]|0)+1020>>2]&255](-1)|0)&255;T=W<<8;R=(da[c[(c[217768]|0)+1020>>2]&255](-2)|0)&255|T;c[115266]=R;U=c[(c[217770]|0)+(W<<2)>>2]|0;if((U|0)==0){X=0}else{X=U+(-T|0)|0}c[215624]=X;c[215620]=c[(c[163352]|0)+(W<<2)>>2];c[197210]=R;i=f;return};case 47:{R=b[242917]|0;W=(R&65535)>>>8;X=((da[c[(c[217768]|0)+(W<<2)>>2]&255](R)|0)&255)<<1;T=a[461072]|0;U=T&1|X;a[461072]=(X&256|0)==0?T&-2:T|1;T=U&d[461080]&255;a[461080]=T;a[803368]=T;a[803360]=T;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(W<<2)>>2]&255](R,U&255);c[198568]=0;i=f;return};case 42:{U=d[461080]<<1;R=a[461072]|0;W=(R&1|U)&255;a[461080]=W;a[461072]=(U&256|0)==0?R&-2:R|1;a[803368]=W;a[803360]=W;c[115266]=(c[115266]|0)+1;i=f;return};case 46:{W=b[242917]|0;R=(W&65535)>>>8;U=((da[c[(c[217768]|0)+(R<<2)>>2]&255](W)|0)&255)<<1;T=a[461072]|0;a[461072]=(U&256|0)==0?T&-2:T|1;X=(T&1|U)&255;a[803368]=X;a[803360]=X;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(R<<2)>>2]&255](W,X);c[198568]=0;i=f;return};case 110:{X=b[242917]|0;W=(X&65535)>>>8;R=(da[c[(c[217768]|0)+(W<<2)>>2]&255](X)|0)&255;U=a[461072]|0;a[461072]=(R&1|0)==0?U&-2:U|1;T=((U&255)<<8|R)>>>1&255;a[803368]=T;a[803360]=T;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(W<<2)>>2]&255](X,T);c[198568]=0;i=f;return};case 111:{T=b[242917]|0;X=(T&65535)>>>8;W=(da[c[(c[217768]|0)+(X<<2)>>2]&255](T)|0)&255;R=W>>>1;U=a[461072]|0;V=(U&1)<<7;O=V|R;s=(W&1|0)==0?U&-2:U|1;a[461072]=s;c[198568]=1;c[115266]=(c[115266]|0)+3;U=s&255;W=d[461080]|0;do{if((U&8|0)==0){S=O+W+(U&1)|0;M=S&255;a[803368]=M;a[803360]=M;do{if((W&128|0)==(V|0)){if(((W^S)&128|0)==0){x=3099;break}Y=s|64}else{x=3099}}while(0);if((x|0)==3099){Y=s&-65}a[461072]=Y;if(S>>>0>255>>>0){a[461072]=Y|1;Z=M;break}else{a[461072]=Y&-2;Z=M;break}}else{g=U&1;Q=(W&15)+(R&15)+g|0;H=Q>>>0>9>>>0?Q+6|0:Q;Q=(H&15|W&240)+(O&240)|0;N=H>>>0<16>>>0?Q:Q+16|0;a[803360]=(O+W+g&255|0)!=0|0;a[803368]=N&255&-128;g=((W^N)&128|0)!=0&(W&128|0)==(V|0)?s|64:s&-65;a[461072]=g;Q=(N&496)>>>0>144>>>0?N+96|0:N;if((Q&4080)>>>0>240>>>0){a[461072]=g|1;Z=Q&255;break}else{a[461072]=g&-2;Z=Q&255;break}}}while(0);a[461080]=Z;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(X<<2)>>2]&255](T,O&255);c[198568]=0;i=f;return};case 112:{O=(c[115266]|0)+2|0;c[115266]=O;if((a[461072]&64)==0){i=f;return}T=(a[485834]|0)+O|0;da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255](O&65535)|0;c[198580]=(c[198580]|0)+1;O=c[115266]|0;if(((O^T)&65280|0)==0){c[200694]=c[200694]|256}else{X=O&65280;O=c[(c[217768]|0)+(X>>>8<<2)>>2]|0;Z=(X|T&255)&65535;da[O&255](Z)|0;c[198580]=(c[198580]|0)+1}Z=T&65535;c[115266]=Z;O=c[(c[217770]|0)+(Z>>>8<<2)>>2]|0;if((O|0)==0){_=0}else{_=O+(-(T&65280)|0)|0}c[215624]=_;c[215620]=c[(c[163352]|0)+(Z>>>8<<2)>>2];c[197210]=Z;i=f;return};case 113:{c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;Z=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;_=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;T=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(Z){Z=c[c[217768]>>2]|0;O=(d[485834]|0)+1&65535;da[Z&255](O)|0;O=c[c[217768]>>2]|0;Z=d[485834]|0;da[O&255](Z)|0;Z=c[217768]|0;O=c[Z+(_<<2)>>2]|0;X=((da[c[Z>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;Z=c[c[217768]>>2]|0;s=d[485834]|0;da[Z&255](s)|0;s=c[c[217768]>>2]|0;Z=(d[485834]|0)+1&65535;da[s&255](Z)|0;Z=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;s=(d[461040]|0)+Z&255|X;da[O&255](s)|0;c[198580]=(c[198580]|0)+1;s=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;O=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|s;s=c[217768]|0;X=c[s+((O+(d[461040]|0)|0)>>>8<<2)>>2]|0;O=((da[c[s>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;s=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|O;$=da[X&255](s+(d[461040]|0)&65535)|0}else{s=c[217768]|0;X=c[s+(((d[461040]|0)+(T&255|_<<8)|0)>>>8<<2)>>2]|0;_=((da[c[s>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;s=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|_;$=da[X&255](s+(d[461040]|0)&65535)|0}s=$&255;c[198580]=(c[198580]|0)+1;X=a[461072]|0;_=X&255;T=a[461080]|0;O=T&255;do{if((_&8|0)==0){Z=O+s+(_&1)|0;V=Z&255;a[803368]=V;a[803360]=V;do{if((T^$)<<24>>24<0){x=3125}else{if(((O^Z)&128|0)==0){x=3125;break}aa=X|64}}while(0);if((x|0)==3125){aa=X&-65}a[461072]=aa;if(Z>>>0>255>>>0){a[461072]=aa|1;ab=V;break}else{a[461072]=aa&-2;ab=V;break}}else{M=_&1;S=M+(s&15)+(O&15)|0;W=S>>>0>9>>>0?S+6|0:S;S=(W&15|O&240)+(s&240)|0;R=W>>>0<16>>>0?S:S+16|0;a[803360]=(O+s+M&255|0)!=0|0;a[803368]=R&255&-128;do{if(((O^R)&128|0)==0){x=3118}else{if((T^$)<<24>>24<0){x=3118;break}ac=X|64}}while(0);if((x|0)==3118){ac=X&-65}a[461072]=ac;V=(R&496)>>>0>144>>>0?R+96|0:R;if((V&4080)>>>0>240>>>0){a[461072]=ac|1;ab=V&255;break}else{a[461072]=ac&-2;ab=V&255;break}}}while(0);a[461080]=ab;c[115266]=(c[115266]|0)+2;i=f;return};case 115:{c[198580]=(c[198580]|0)+2;ab=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;ac=ab<<8;X=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;da[c[(c[217768]|0)+(ab<<2)>>2]&255](((d[461040]|0)+X&255|ac)&65535)|0;c[198580]=(c[198580]|0)+1;ab=(d[461040]|0)+(X|ac)|0;ac=ab>>>8;X=ab&65535;ab=da[c[(c[217768]|0)+(ac<<2)>>2]&255](X)|0;c[198568]=1;c[115266]=(c[115266]|0)+2;$=ab&255;ab=$>>>1;T=a[461072]|0;O=(T&1)<<7;s=O|ab;_=($&1|0)==0?T&-2:T|1;a[461072]=_;T=_&255;$=d[461080]|0;do{if((T&8|0)==0){aa=s+$+(T&1)|0;V=aa&255;a[803368]=V;a[803360]=V;do{if(($&128|0)==(O|0)){if((($^aa)&128|0)==0){x=3137;break}ad=_|64}else{x=3137}}while(0);if((x|0)==3137){ad=_&-65}a[461072]=ad;if(aa>>>0>255>>>0){a[461072]=ad|1;ae=V;break}else{a[461072]=ad&-2;ae=V;break}}else{R=T&1;Z=($&15)+(ab&15)+R|0;M=Z>>>0>9>>>0?Z+6|0:Z;Z=(M&15|$&240)+(s&240)|0;S=M>>>0<16>>>0?Z:Z+16|0;a[803360]=(s+$+R&255|0)!=0|0;a[803368]=S&255&-128;R=(($^S)&128|0)!=0&($&128|0)==(O|0)?_|64:_&-65;a[461072]=R;Z=(S&496)>>>0>144>>>0?S+96|0:S;if((Z&4080)>>>0>240>>>0){a[461072]=R|1;ae=Z&255;break}else{a[461072]=R&-2;ae=Z&255;break}}}while(0);a[461080]=ae;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(ac<<2)>>2]&255](X,s&255);c[198568]=0;i=f;return};case 117:{s=da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;X=s&255;c[198580]=(c[198580]|0)+2;ac=a[461072]|0;ae=ac&255;_=a[461080]|0;O=_&255;do{if((ae&8|0)==0){$=O+X+(ae&1)|0;ab=$&255;a[803368]=ab;a[803360]=ab;do{if((_^s)<<24>>24<0){x=3153}else{if(((O^$)&128|0)==0){x=3153;break}af=ac|64}}while(0);if((x|0)==3153){af=ac&-65}a[461072]=af;if($>>>0>255>>>0){a[461072]=af|1;ag=ab;break}else{a[461072]=af&-2;ag=ab;break}}else{V=ae&1;aa=V+(X&15)+(O&15)|0;T=aa>>>0>9>>>0?aa+6|0:aa;aa=(T&15|O&240)+(X&240)|0;ad=T>>>0<16>>>0?aa:aa+16|0;a[803360]=(O+X+V&255|0)!=0|0;a[803368]=ad&255&-128;do{if(((O^ad)&128|0)==0){x=3146}else{if((_^s)<<24>>24<0){x=3146;break}ah=ac|64}}while(0);if((x|0)==3146){ah=ac&-65}a[461072]=ah;ab=(ad&496)>>>0>144>>>0?ad+96|0:ad;if((ab&4080)>>>0>240>>>0){a[461072]=ah|1;ag=ab&255;break}else{a[461072]=ah&-2;ag=ab&255;break}}}while(0);a[461080]=ag;c[115266]=(c[115266]|0)+2;i=f;return};case 118:{ag=(d[461048]|0)+(d[485834]|0)&255;ah=(da[c[c[217768]>>2]&255](ag)|0)&255;ac=a[461072]|0;a[461072]=(ah&1|0)==0?ac&-2:ac|1;s=((ac&255)<<8|ah)>>>1&255;a[803368]=s;a[803360]=s;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](ag,s);c[198568]=0;i=f;return};case 119:{s=(d[461048]|0)+(d[485834]|0)&255;ag=(da[c[c[217768]>>2]&255](s)|0)&255;ah=ag>>>1;ac=a[461072]|0;_=(ac&1)<<7;O=_|ah;X=(ag&1|0)==0?ac&-2:ac|1;a[461072]=X;c[198568]=1;c[115266]=(c[115266]|0)+2;ac=X&255;ag=d[461080]|0;do{if((ac&8|0)==0){ae=O+ag+(ac&1)|0;af=ae&255;a[803368]=af;a[803360]=af;do{if((ag&128|0)==(_|0)){if(((ag^ae)&128|0)==0){x=3166;break}ai=X|64}else{x=3166}}while(0);if((x|0)==3166){ai=X&-65}a[461072]=ai;if(ae>>>0>255>>>0){a[461072]=ai|1;aj=af;break}else{a[461072]=ai&-2;aj=af;break}}else{ad=ac&1;ab=(ag&15)+(ah&15)+ad|0;$=ab>>>0>9>>>0?ab+6|0:ab;ab=($&15|ag&240)+(O&240)|0;V=$>>>0<16>>>0?ab:ab+16|0;a[803360]=(O+ag+ad&255|0)!=0|0;a[803368]=V&255&-128;ad=((ag^V)&128|0)!=0&(ag&128|0)==(_|0)?X|64:X&-65;a[461072]=ad;ab=(V&496)>>>0>144>>>0?V+96|0:V;if((ab&4080)>>>0>240>>>0){a[461072]=ad|1;aj=ab&255;break}else{a[461072]=ad&-2;aj=ab&255;break}}}while(0);a[461080]=aj;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](s,O&255);c[198568]=0;i=f;return};case 120:{O=a[461072]|0;if((O&4)==0){c[200694]=c[200694]|512}a[461072]=O|4;c[115266]=(c[115266]|0)+1;i=f;return};case 121:{O=e[242917]|0;s=d[461040]|0;if(((O&255)+s|0)>255){aj=c[(c[217768]|0)+(O>>>8<<2)>>2]|0;X=(s+O&255|O&65280)&65535;da[aj&255](X)|0;c[198580]=(c[198580]|0)+1;X=(d[461040]|0)+(e[242917]|0)|0;ak=da[c[(c[217768]|0)+(X>>>8<<2)>>2]&255](X&65535)|0}else{X=s+O|0;ak=da[c[(c[217768]|0)+(X>>>8<<2)>>2]&255](X&65535)|0}X=ak&255;c[198580]=(c[198580]|0)+1;O=a[461072]|0;s=O&255;aj=a[461080]|0;_=aj&255;do{if((s&8|0)==0){ag=_+X+(s&1)|0;ah=ag&255;a[803368]=ah;a[803360]=ah;do{if((aj^ak)<<24>>24<0){x=3188}else{if(((_^ag)&128|0)==0){x=3188;break}al=O|64}}while(0);if((x|0)==3188){al=O&-65}a[461072]=al;if(ag>>>0>255>>>0){a[461072]=al|1;am=ah;break}else{a[461072]=al&-2;am=ah;break}}else{af=s&1;ae=af+(X&15)+(_&15)|0;ac=ae>>>0>9>>>0?ae+6|0:ae;ae=(ac&15|_&240)+(X&240)|0;ai=ac>>>0<16>>>0?ae:ae+16|0;a[803360]=(_+X+af&255|0)!=0|0;a[803368]=ai&255&-128;do{if(((_^ai)&128|0)==0){x=3181}else{if((aj^ak)<<24>>24<0){x=3181;break}an=O|64}}while(0);if((x|0)==3181){an=O&-65}a[461072]=an;ah=(ai&496)>>>0>144>>>0?ai+96|0:ai;if((ah&4080)>>>0>240>>>0){a[461072]=an|1;am=ah&255;break}else{a[461072]=an&-2;am=ah&255;break}}}while(0);a[461080]=am;c[115266]=(c[115266]|0)+3;i=f;return};case 123:{am=b[242917]|0;an=am&65535;da[c[(c[217768]|0)+(an>>>8<<2)>>2]&255]((d[461040]|0)+am&255|am&-256)|0;c[198580]=(c[198580]|0)+1;am=(d[461040]|0)+an|0;O=(da[c[(c[217768]|0)+(am>>>8<<2)>>2]&255](am&65535)|0)&255;am=O>>>1;ak=a[461072]|0;aj=(ak&1)<<7;_=aj|am;X=(O&1|0)==0?ak&-2:ak|1;a[461072]=X;c[198568]=1;c[115266]=(c[115266]|0)+3;ak=X&255;O=d[461080]|0;do{if((ak&8|0)==0){s=_+O+(ak&1)|0;al=s&255;a[803368]=al;a[803360]=al;do{if((O&128|0)==(aj|0)){if(((O^s)&128|0)==0){x=3200;break}ao=X|64}else{x=3200}}while(0);if((x|0)==3200){ao=X&-65}a[461072]=ao;if(s>>>0>255>>>0){a[461072]=ao|1;ap=al;break}else{a[461072]=ao&-2;ap=al;break}}else{ai=ak&1;ah=(O&15)+(am&15)+ai|0;ag=ah>>>0>9>>>0?ah+6|0:ah;ah=(ag&15|O&240)+(_&240)|0;af=ag>>>0<16>>>0?ah:ah+16|0;a[803360]=(_+O+ai&255|0)!=0|0;a[803368]=af&255&-128;ai=((O^af)&128|0)!=0&(O&128|0)==(aj|0)?X|64:X&-65;a[461072]=ai;ah=(af&496)>>>0>144>>>0?af+96|0:af;if((ah&4080)>>>0>240>>>0){a[461072]=ai|1;ap=ah&255;break}else{a[461072]=ai&-2;ap=ah&255;break}}}while(0);a[461080]=ap;c[198580]=(c[198580]|0)+3;ap=(d[461040]|0)+an|0;c5[c[(c[217766]|0)+(ap>>>8<<2)>>2]&255](ap&65535,_&255);c[198568]=0;i=f;return};case 126:{_=b[242917]|0;ap=_&65535;da[c[(c[217768]|0)+(ap>>>8<<2)>>2]&255]((d[461048]|0)+_&255|_&-256)|0;c[198580]=(c[198580]|0)+1;_=(d[461048]|0)+ap|0;an=(da[c[(c[217768]|0)+(_>>>8<<2)>>2]&255](_&65535)|0)&255;_=a[461072]|0;a[461072]=(an&1|0)==0?_&-2:_|1;X=((_&255)<<8|an)>>>1&255;a[803368]=X;a[803360]=X;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;an=(d[461048]|0)+ap|0;c5[c[(c[217766]|0)+(an>>>8<<2)>>2]&255](an&65535,X);c[198568]=0;i=f;return};case 127:{X=b[242917]|0;an=X&65535;da[c[(c[217768]|0)+(an>>>8<<2)>>2]&255]((d[461048]|0)+X&255|X&-256)|0;c[198580]=(c[198580]|0)+1;X=(d[461048]|0)+an|0;ap=(da[c[(c[217768]|0)+(X>>>8<<2)>>2]&255](X&65535)|0)&255;X=ap>>>1;_=a[461072]|0;aj=(_&1)<<7;O=aj|X;am=(ap&1|0)==0?_&-2:_|1;a[461072]=am;c[198568]=1;c[115266]=(c[115266]|0)+3;_=am&255;ap=d[461080]|0;do{if((_&8|0)==0){ak=O+ap+(_&1)|0;ao=ak&255;a[803368]=ao;a[803360]=ao;do{if((ap&128|0)==(aj|0)){if(((ap^ak)&128|0)==0){x=3213;break}aq=am|64}else{x=3213}}while(0);if((x|0)==3213){aq=am&-65}a[461072]=aq;if(ak>>>0>255>>>0){a[461072]=aq|1;ar=ao;break}else{a[461072]=aq&-2;ar=ao;break}}else{al=_&1;s=(ap&15)+(X&15)+al|0;ah=s>>>0>9>>>0?s+6|0:s;s=(ah&15|ap&240)+(O&240)|0;ai=ah>>>0<16>>>0?s:s+16|0;a[803360]=(O+ap+al&255|0)!=0|0;a[803368]=ai&255&-128;al=((ap^ai)&128|0)!=0&(ap&128|0)==(aj|0)?am|64:am&-65;a[461072]=al;s=(ai&496)>>>0>144>>>0?ai+96|0:ai;if((s&4080)>>>0>240>>>0){a[461072]=al|1;ar=s&255;break}else{a[461072]=al&-2;ar=s&255;break}}}while(0);a[461080]=ar;c[198580]=(c[198580]|0)+3;ar=(d[461048]|0)+an|0;c5[c[(c[217766]|0)+(ar>>>8<<2)>>2]&255](ar&65535,O&255);c[198568]=0;i=f;return};case 128:case 130:case 137:case 194:case 226:{c[115266]=(c[115266]|0)+2;i=f;return};case 129:{c[198580]=(c[198580]|0)+3;O=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;ar=(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|O<<8;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+1;c5[c[(c[217766]|0)+(O<<2)>>2]&255](ar&65535,a[461080]|0);i=f;return};case 131:{c[198580]=(c[198580]|0)+3;ar=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;O=(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|ar<<8;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;c5[c[(c[217766]|0)+(ar<<2)>>2]&255](O&65535,a[461048]&a[461080]);i=f;return};case 132:{c[198580]=(c[198580]|0)+1;c5[c[c[217766]>>2]&255](d[485834]|0,a[461040]|0);c[115266]=(c[115266]|0)+2;i=f;return};case 134:{c[198580]=(c[198580]|0)+1;c5[c[c[217766]>>2]&255](d[485834]|0,a[461048]|0);c[115266]=(c[115266]|0)+2;i=f;return};case 135:{c[198580]=(c[198580]|0)+1;c5[c[c[217766]>>2]&255](d[485834]|0,a[461048]&a[461080]);c[115266]=(c[115266]|0)+2;i=f;return};case 138:{O=a[461048]|0;a[461080]=O;a[803368]=O;a[803360]=O;c[115266]=(c[115266]|0)+1;i=f;return};case 139:{O=a[485834]&a[461048];a[461080]=O;a[803368]=O;a[803360]=O;c[115266]=(c[115266]|0)+2;i=f;return};case 140:{O=b[242917]|0;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;c5[c[(c[217766]|0)+((O&65535)>>>8<<2)>>2]&255](O,a[461040]|0);i=f;return};case 142:{O=b[242917]|0;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;c5[c[(c[217766]|0)+((O&65535)>>>8<<2)>>2]&255](O,a[461048]|0);i=f;return};case 143:{O=b[242917]|0;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;c5[c[(c[217766]|0)+((O&65535)>>>8<<2)>>2]&255](O,a[461048]&a[461080]);i=f;return};case 144:{O=(c[115266]|0)+2|0;c[115266]=O;if((a[461072]&1)!=0){i=f;return}ar=(a[485834]|0)+O|0;da[c[(c[217768]|0)+(O>>>8<<2)>>2]&255](O&65535)|0;c[198580]=(c[198580]|0)+1;O=c[115266]|0;if(((O^ar)&65280|0)==0){c[200694]=c[200694]|256}else{an=O&65280;O=c[(c[217768]|0)+(an>>>8<<2)>>2]|0;am=(an|ar&255)&65535;da[O&255](am)|0;c[198580]=(c[198580]|0)+1}am=ar&65535;c[115266]=am;O=c[(c[217770]|0)+(am>>>8<<2)>>2]|0;if((O|0)==0){as=0}else{as=O+(-(ar&65280)|0)|0}c[215624]=as;c[215620]=c[(c[163352]|0)+(am>>>8<<2)>>2];c[197210]=am;i=f;return};case 145:{c[198580]=(c[198580]|0)+2;am=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;as=am<<8;ar=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;da[c[(c[217768]|0)+(am<<2)>>2]&255](((d[461040]|0)+ar&255|as)&65535)|0;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;am=(d[461040]|0)+(ar|as)|0;c5[c[(c[217766]|0)+(am>>>8<<2)>>2]&255](am&65535,a[461080]|0);i=f;return};case 147:{c[198580]=(c[198580]|0)+2;am=da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;as=am&255;ar=as<<8;O=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;da[c[(c[217768]|0)+(as<<2)>>2]&255](((d[461040]|0)+O&255|ar)&65535)|0;c[198580]=(c[198580]|0)+2;as=a[461080]&(am+1&255)&a[461048];am=d[461040]|0;an=am+O|0;if(an>>>0>255>>>0){at=an&255|(as&255)<<8}else{at=am+(O|ar)|0}c[115266]=(c[115266]|0)+2;c5[c[(c[217766]|0)+(at>>>8<<2)>>2]&255](at&65535,as);i=f;return};case 148:{c[198580]=(c[198580]|0)+2;c5[c[c[217766]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535,a[461040]|0);c[115266]=(c[115266]|0)+2;i=f;return};case 149:{c[198580]=(c[198580]|0)+2;c5[c[c[217766]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535,a[461080]|0);c[115266]=(c[115266]|0)+2;i=f;return};case 150:{c[198580]=(c[198580]|0)+2;c5[c[c[217766]>>2]&255]((d[461040]|0)+(d[485834]|0)&65535,a[461048]|0);c[115266]=(c[115266]|0)+2;i=f;return};case 151:{as=(d[461040]|0)+(d[485834]|0)&255;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;c5[c[c[217766]>>2]&255](as,a[461048]&a[461080]);i=f;return};case 152:{as=a[461040]|0;a[461080]=as;a[803368]=as;a[803360]=as;c[115266]=(c[115266]|0)+1;i=f;return};case 154:{a[461056]=a[461048]|0;c[115266]=(c[115266]|0)+1;i=f;return};case 155:{as=b[242917]|0;at=as&65535;c[115266]=(c[115266]|0)+3;ar=at>>>8;da[c[(c[217768]|0)+(ar<<2)>>2]&255]((d[461040]|0)+as&255|as&-256)|0;c[198580]=(c[198580]|0)+2;as=d[461040]|0;O=as+at|0;if((as+(at&255)|0)>255){at=a[461080]|0;as=a[461048]|0;am=ar+1|0;au=(as&at&255&am)<<8|O&255;av=at;aw=as;ax=am}else{au=O;av=a[461080]|0;aw=a[461048]|0;ax=ar+1|0}c5[c[(c[217766]|0)+(au>>>8<<2)>>2]&255](au&65535,aw&av&255&ax&255);a[461056]=a[461048]&a[461080];i=f;return};case 156:{ax=b[242917]|0;av=ax&65535;c[115266]=(c[115266]|0)+3;aw=av>>>8;da[c[(c[217768]|0)+(aw<<2)>>2]&255]((d[461048]|0)+ax&255|ax&-256)|0;c[198580]=(c[198580]|0)+2;ax=d[461048]|0;au=ax+av|0;if((ax+(av&255)|0)>>>0>255>>>0){av=a[461040]|0;ax=aw+1|0;ay=(av&255&ax)<<8|au&255;az=av;aA=ax}else{ay=au;az=a[461040]|0;aA=aw+1|0}c5[c[(c[217766]|0)+(ay>>>8<<2)>>2]&255](ay&65535,az&255&aA&255);i=f;return};case 158:{aA=b[242917]|0;az=aA&65535;c[115266]=(c[115266]|0)+3;ay=az>>>8;da[c[(c[217768]|0)+(ay<<2)>>2]&255]((d[461040]|0)+aA&255|aA&-256)|0;c[198580]=(c[198580]|0)+2;aA=d[461040]|0;aw=aA+az|0;if((aA+(az&255)|0)>>>0>255>>>0){az=a[461048]|0;aA=ay+1|0;aB=(az&255&aA)<<8|aw&255;aC=az;aD=aA}else{aB=aw;aC=a[461048]|0;aD=ay+1|0}c5[c[(c[217766]|0)+(aB>>>8<<2)>>2]&255](aB&65535,aC&255&aD&255);i=f;return};case 159:{aD=b[242917]|0;aC=aD&65535;c[115266]=(c[115266]|0)+3;aB=aC>>>8;da[c[(c[217768]|0)+(aB<<2)>>2]&255]((d[461040]|0)+aD&255|aD&-256)|0;c[198580]=(c[198580]|0)+2;aD=d[461040]|0;ay=aD+aC|0;if((aD+(aC&255)|0)>>>0>255>>>0){aC=a[461080]|0;aD=a[461048]|0;aw=aB+1|0;aE=(aD&aC&255&aw)<<8|ay&255;aF=aC;aG=aD;aH=aw}else{aE=ay;aF=a[461080]|0;aG=a[461048]|0;aH=aB+1|0}c5[c[(c[217766]|0)+(aE>>>8<<2)>>2]&255](aE&65535,aG&aF&255&aH&255);i=f;return};case 160:{aH=a[485834]|0;a[461040]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+2;i=f;return};case 161:{c[198580]=(c[198580]|0)+3;aH=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;aF=c[217768]|0;aG=c[aF+(aH<<2)>>2]|0;aH=((da[c[aF>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;aF=da[aG&255](aH)|0;a[461080]=aF;c[198580]=(c[198580]|0)+1;a[803368]=aF;a[803360]=aF;c[115266]=(c[115266]|0)+2;i=f;return};case 162:{aF=a[485834]|0;a[461048]=aF;a[803368]=aF;a[803360]=aF;c[115266]=(c[115266]|0)+2;i=f;return};case 163:{c[198580]=(c[198580]|0)+3;aF=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;aH=c[217768]|0;aG=c[aH+(aF<<2)>>2]|0;aF=((da[c[aH>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;aH=da[aG&255](aF)|0;a[461048]=aH;a[461080]=aH;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 164:{aH=da[c[c[217768]>>2]&255](d[485834]|0)|0;a[461040]=aH;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 166:{aH=da[c[c[217768]>>2]&255](d[485834]|0)|0;a[461048]=aH;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 167:{aH=da[c[c[217768]>>2]&255](d[485834]|0)|0;a[461048]=aH;a[461080]=aH;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 168:{aH=a[461080]|0;a[461040]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+1;i=f;return};case 169:{aH=a[485834]|0;a[461080]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+2;i=f;return};case 170:{aH=a[461080]|0;a[461048]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+1;i=f;return};case 171:{aH=(a[461080]|-18)&a[485834];a[461048]=aH;a[461080]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+2;i=f;return};case 172:{aH=b[242917]|0;aF=da[c[(c[217768]|0)+((aH&65535)>>>8<<2)>>2]&255](aH)|0;a[461040]=aF;a[803368]=aF;a[803360]=aF;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 175:{aF=b[242917]|0;aH=da[c[(c[217768]|0)+((aF&65535)>>>8<<2)>>2]&255](aF)|0;a[461048]=aH;a[461080]=aH;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 176:{aH=(c[115266]|0)+2|0;c[115266]=aH;if((a[461072]&1)==0){i=f;return}aF=(a[485834]|0)+aH|0;da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255](aH&65535)|0;c[198580]=(c[198580]|0)+1;aH=c[115266]|0;if(((aH^aF)&65280|0)==0){c[200694]=c[200694]|256}else{aG=aH&65280;aH=c[(c[217768]|0)+(aG>>>8<<2)>>2]|0;aE=(aG|aF&255)&65535;da[aH&255](aE)|0;c[198580]=(c[198580]|0)+1}aE=aF&65535;c[115266]=aE;aH=c[(c[217770]|0)+(aE>>>8<<2)>>2]|0;if((aH|0)==0){aI=0}else{aI=aH+(-(aF&65280)|0)|0}c[215624]=aI;c[215620]=c[(c[163352]|0)+(aE>>>8<<2)>>2];c[197210]=aE;i=f;return};case 177:{c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;aE=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;aI=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;aF=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(aE){aE=c[c[217768]>>2]|0;aH=(d[485834]|0)+1&65535;da[aE&255](aH)|0;aH=c[c[217768]>>2]|0;aE=d[485834]|0;da[aH&255](aE)|0;aE=c[217768]|0;aH=c[aE+(aI<<2)>>2]|0;aG=((da[c[aE>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aE=c[c[217768]>>2]|0;aB=d[485834]|0;da[aE&255](aB)|0;aB=c[c[217768]>>2]|0;aE=(d[485834]|0)+1&65535;da[aB&255](aE)|0;aE=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;aB=(d[461040]|0)+aE&255|aG;da[aH&255](aB)|0;c[198580]=(c[198580]|0)+1;aB=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aH=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aB;aB=c[217768]|0;aG=c[aB+((aH+(d[461040]|0)|0)>>>8<<2)>>2]|0;aH=((da[c[aB>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aB=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aH;aJ=da[aG&255](aB+(d[461040]|0)&65535)|0}else{aB=c[217768]|0;aG=c[aB+(((d[461040]|0)+(aF&255|aI<<8)|0)>>>8<<2)>>2]|0;aI=((da[c[aB>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aB=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aI;aJ=da[aG&255](aB+(d[461040]|0)&65535)|0}a[461080]=aJ;c[198580]=(c[198580]|0)+1;a[803368]=aJ;a[803360]=aJ;c[115266]=(c[115266]|0)+2;i=f;return};case 179:{c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;aJ=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;aB=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;aG=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(aJ){aJ=c[c[217768]>>2]|0;aI=(d[485834]|0)+1&65535;da[aJ&255](aI)|0;aI=c[c[217768]>>2]|0;aJ=d[485834]|0;da[aI&255](aJ)|0;aJ=c[217768]|0;aI=c[aJ+(aB<<2)>>2]|0;aF=((da[c[aJ>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aJ=c[c[217768]>>2]|0;aH=d[485834]|0;da[aJ&255](aH)|0;aH=c[c[217768]>>2]|0;aJ=(d[485834]|0)+1&65535;da[aH&255](aJ)|0;aJ=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;aH=(d[461040]|0)+aJ&255|aF;da[aI&255](aH)|0;c[198580]=(c[198580]|0)+1;aH=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aI=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aH;aH=c[217768]|0;aF=c[aH+((aI+(d[461040]|0)|0)>>>8<<2)>>2]|0;aI=((da[c[aH>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aH=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aI;aK=da[aF&255](aH+(d[461040]|0)&65535)|0}else{aH=c[217768]|0;aF=c[aH+(((d[461040]|0)+(aG&255|aB<<8)|0)>>>8<<2)>>2]|0;aB=((da[c[aH>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aH=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aB;aK=da[aF&255](aH+(d[461040]|0)&65535)|0}a[461048]=aK;a[461080]=aK;a[803368]=aK;a[803360]=aK;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 180:{aK=da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;a[461040]=aK;a[803368]=aK;a[803360]=aK;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 181:{aK=da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;a[461080]=aK;c[198580]=(c[198580]|0)+2;a[803368]=aK;a[803360]=aK;c[115266]=(c[115266]|0)+2;i=f;return};case 182:{aK=da[c[c[217768]>>2]&255]((d[461040]|0)+(d[485834]|0)&65535)|0;a[461048]=aK;a[803368]=aK;a[803360]=aK;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 183:{aK=da[c[c[217768]>>2]&255]((d[461040]|0)+(d[485834]|0)&65535)|0;a[461048]=aK;a[461080]=aK;a[803368]=aK;a[803360]=aK;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 184:{c[115266]=(c[115266]|0)+1;a[461072]=a[461072]&-65;i=f;return};case 186:{aK=a[461056]|0;a[461048]=aK;a[803368]=aK;a[803360]=aK;c[115266]=(c[115266]|0)+1;i=f;return};case 187:{aK=a[461056]|0;aH=e[242917]|0;aF=d[461040]|0;if(((aH&255)+aF|0)>255){aB=c[(c[217768]|0)+(aH>>>8<<2)>>2]|0;aG=(aF+aH&255|aH&65280)&65535;da[aB&255](aG)|0;c[198580]=(c[198580]|0)+1;aG=(d[461040]|0)+(e[242917]|0)|0;aL=da[c[(c[217768]|0)+(aG>>>8<<2)>>2]&255](aG&65535)|0}else{aG=aF+aH|0;aL=da[c[(c[217768]|0)+(aG>>>8<<2)>>2]&255](aG&65535)|0}aG=aL&aK;a[461056]=aG;a[461048]=aG;a[461080]=aG;a[803368]=aG;a[803360]=aG;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 188:{aG=e[242917]|0;aK=d[461048]|0;if(((aG&255)+aK|0)>255){aL=c[(c[217768]|0)+(aG>>>8<<2)>>2]|0;aH=(aK+aG&255|aG&65280)&65535;da[aL&255](aH)|0;c[198580]=(c[198580]|0)+1;aH=(d[461048]|0)+(e[242917]|0)|0;aM=da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255](aH&65535)|0}else{aH=aK+aG|0;aM=da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255](aH&65535)|0}a[461040]=aM;a[803368]=aM;a[803360]=aM;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 191:{aM=e[242917]|0;aH=d[461040]|0;if(((aM&255)+aH|0)>255){aG=c[(c[217768]|0)+(aM>>>8<<2)>>2]|0;aK=(aH+aM&255|aM&65280)&65535;da[aG&255](aK)|0;c[198580]=(c[198580]|0)+1;aK=(d[461040]|0)+(e[242917]|0)|0;aN=da[c[(c[217768]|0)+(aK>>>8<<2)>>2]&255](aK&65535)|0}else{aK=aH+aM|0;aN=da[c[(c[217768]|0)+(aK>>>8<<2)>>2]&255](aK&65535)|0}a[461048]=aN;a[461080]=aN;a[803368]=aN;a[803360]=aN;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 192:{aN=(d[461040]|0)-(d[485834]|0)|0;aK=a[461072]|0;a[461072]=aN>>>0<256>>>0?aK|1:aK&-2;aK=aN&255;a[803368]=aK;a[803360]=aK;c[115266]=(c[115266]|0)+2;i=f;return};case 193:{aK=d[461080]|0;c[198580]=(c[198580]|0)+3;aN=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;aM=c[217768]|0;aH=c[aM+(aN<<2)>>2]|0;aN=((da[c[aM>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;aM=aK-((da[aH&255](aN)|0)&255)|0;aN=a[461072]|0;a[461072]=aM>>>0<256>>>0?aN|1:aN&-2;aN=aM&255;a[803368]=aN;a[803360]=aN;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 195:{aN=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;aM=(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|aN<<8;c[198580]=(c[198580]|0)+3;aH=aM&65535;aM=((da[c[(c[217768]|0)+(aN<<2)>>2]&255](aH)|0)&255)+255|0;aK=d[461080]|0;aG=a[461072]|0;a[461072]=aK>>>0<(aM&255)>>>0?aG&-2:aG|1;aG=aK-aM&255;a[803368]=aG;a[803360]=aG;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(aN<<2)>>2]&255](aH,aM&255);c[198568]=0;i=f;return};case 196:{aM=(d[461040]|0)-((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)|0;aH=a[461072]|0;a[461072]=aM>>>0<256>>>0?aH|1:aH&-2;aH=aM&255;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 197:{aH=(d[461080]|0)-((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)|0;aM=a[461072]|0;a[461072]=aH>>>0<256>>>0?aM|1:aM&-2;aM=aH&255;a[803368]=aM;a[803360]=aM;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 198:{aM=d[485834]|0;aH=(da[c[c[217768]>>2]&255](aM)|0)-1&255;a[803368]=aH;a[803360]=aH;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](aM,aH);c[198568]=0;i=f;return};case 199:{aH=d[485834]|0;aM=((da[c[c[217768]>>2]&255](aH)|0)&255)+255|0;aN=d[461080]|0;aG=a[461072]|0;a[461072]=aN>>>0<(aM&255)>>>0?aG&-2:aG|1;aG=aN-aM&255;a[803368]=aG;a[803360]=aG;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](aH,aM&255);c[198568]=0;i=f;return};case 200:{aM=(a[461040]|0)+1&255;a[461040]=aM;a[803368]=aM;a[803360]=aM;c[115266]=(c[115266]|0)+1;i=f;return};case 201:{aM=(d[461080]|0)-(d[485834]|0)|0;aH=a[461072]|0;a[461072]=aM>>>0<256>>>0?aH|1:aH&-2;aH=aM&255;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+2;i=f;return};case 202:{aH=(a[461048]|0)-1&255;a[461048]=aH;a[803368]=aH;a[803360]=aH;c[115266]=(c[115266]|0)+1;i=f;return};case 203:{aH=d[485834]|0;c[115266]=(c[115266]|0)+2;aM=(a[461048]&a[461080]&255)-aH|0;aH=a[461072]|0;a[461072]=aM>>>0<256>>>0?aH|1:aH&-2;aH=aM&255;a[461048]=aH;a[803368]=aH;a[803360]=aH;i=f;return};case 204:{aH=b[242917]|0;aM=(d[461040]|0)-((da[c[(c[217768]|0)+((aH&65535)>>>8<<2)>>2]&255](aH)|0)&255)|0;aH=a[461072]|0;a[461072]=aM>>>0<256>>>0?aH|1:aH&-2;aH=aM&255;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 205:{aH=b[242917]|0;aM=(d[461080]|0)-((da[c[(c[217768]|0)+((aH&65535)>>>8<<2)>>2]&255](aH)|0)&255)|0;aH=a[461072]|0;a[461072]=aM>>>0<256>>>0?aH|1:aH&-2;aH=aM&255;a[803368]=aH;a[803360]=aH;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 206:{aH=b[242917]|0;aM=(aH&65535)>>>8;aG=(da[c[(c[217768]|0)+(aM<<2)>>2]&255](aH)|0)-1&255;a[803368]=aG;a[803360]=aG;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(aM<<2)>>2]&255](aH,aG);c[198568]=0;i=f;return};case 207:{aG=b[242917]|0;aH=(aG&65535)>>>8;aM=((da[c[(c[217768]|0)+(aH<<2)>>2]&255](aG)|0)&255)+255|0;aN=d[461080]|0;aK=a[461072]|0;a[461072]=aN>>>0<(aM&255)>>>0?aK&-2:aK|1;aK=aN-aM&255;a[803368]=aK;a[803360]=aK;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(aH<<2)>>2]&255](aG,aM&255);c[198568]=0;i=f;return};case 209:{aM=d[461080]|0;c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;aG=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;aH=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;aK=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(aG){aG=c[c[217768]>>2]|0;aN=(d[485834]|0)+1&65535;da[aG&255](aN)|0;aN=c[c[217768]>>2]|0;aG=d[485834]|0;da[aN&255](aG)|0;aG=c[217768]|0;aN=c[aG+(aH<<2)>>2]|0;aL=((da[c[aG>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aG=c[c[217768]>>2]|0;aF=d[485834]|0;da[aG&255](aF)|0;aF=c[c[217768]>>2]|0;aG=(d[485834]|0)+1&65535;da[aF&255](aG)|0;aG=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;aF=(d[461040]|0)+aG&255|aL;da[aN&255](aF)|0;c[198580]=(c[198580]|0)+1;aF=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aN=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aF;aF=c[217768]|0;aL=c[aF+((aN+(d[461040]|0)|0)>>>8<<2)>>2]|0;aN=((da[c[aF>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aF=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aN;aO=da[aL&255](aF+(d[461040]|0)&65535)|0}else{aF=c[217768]|0;aL=c[aF+(((d[461040]|0)+(aK&255|aH<<8)|0)>>>8<<2)>>2]|0;aH=((da[c[aF>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;aF=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|aH;aO=da[aL&255](aF+(d[461040]|0)&65535)|0}aF=aM-(aO&255)|0;aO=a[461072]|0;a[461072]=aF>>>0<256>>>0?aO|1:aO&-2;aO=aF&255;a[803368]=aO;a[803360]=aO;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 211:{aO=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;aF=aO<<8;aM=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;c[198580]=(c[198580]|0)+2;da[c[(c[217768]|0)+(aO<<2)>>2]&255](((d[461040]|0)+aM&255|aF)&65535)|0;c[198580]=(c[198580]|0)+1;aO=(d[461040]|0)+(aM|aF)|0;aF=aO>>>8;aM=aO&65535;aO=((da[c[(c[217768]|0)+(aF<<2)>>2]&255](aM)|0)&255)+255|0;aL=d[461080]|0;aH=a[461072]|0;a[461072]=aL>>>0<(aO&255)>>>0?aH&-2:aH|1;aH=aL-aO&255;a[803368]=aH;a[803360]=aH;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(aF<<2)>>2]&255](aM,aO&255);c[198568]=0;i=f;return};case 213:{aO=(d[461080]|0)-((da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255)|0;aM=a[461072]|0;a[461072]=aO>>>0<256>>>0?aM|1:aM&-2;aM=aO&255;a[803368]=aM;a[803360]=aM;c[198580]=(c[198580]|0)+2;c[115266]=(c[115266]|0)+2;i=f;return};case 214:{aM=(d[461048]|0)+(d[485834]|0)&255;aO=(da[c[c[217768]>>2]&255](aM)|0)-1&255;a[803368]=aO;a[803360]=aO;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](aM,aO);c[198568]=0;i=f;return};case 215:{aO=(d[461048]|0)+(d[485834]|0)&255;aM=((da[c[c[217768]>>2]&255](aO)|0)&255)+255|0;aF=d[461080]|0;aH=a[461072]|0;a[461072]=aF>>>0<(aM&255)>>>0?aH&-2:aH|1;aH=aF-aM&255;a[803368]=aH;a[803360]=aH;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](aO,aM&255);c[198568]=0;i=f;return};case 216:{c[115266]=(c[115266]|0)+1;a[461072]=a[461072]&-9;i=f;return};case 217:{aM=d[461080]|0;aO=e[242917]|0;aH=d[461040]|0;if(((aO&255)+aH|0)>255){aF=c[(c[217768]|0)+(aO>>>8<<2)>>2]|0;aL=(aH+aO&255|aO&65280)&65535;da[aF&255](aL)|0;c[198580]=(c[198580]|0)+1;aL=(d[461040]|0)+(e[242917]|0)|0;aP=da[c[(c[217768]|0)+(aL>>>8<<2)>>2]&255](aL&65535)|0}else{aL=aH+aO|0;aP=da[c[(c[217768]|0)+(aL>>>8<<2)>>2]&255](aL&65535)|0}aL=aM-(aP&255)|0;aP=a[461072]|0;a[461072]=aL>>>0<256>>>0?aP|1:aP&-2;aP=aL&255;a[803368]=aP;a[803360]=aP;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 219:{aP=b[242917]|0;aL=aP&65535;da[c[(c[217768]|0)+(aL>>>8<<2)>>2]&255]((d[461040]|0)+aP&255|aP&-256)|0;c[198580]=(c[198580]|0)+1;aP=(d[461040]|0)+aL|0;aM=((da[c[(c[217768]|0)+(aP>>>8<<2)>>2]&255](aP&65535)|0)&255)+255|0;aP=d[461080]|0;aO=a[461072]|0;a[461072]=aP>>>0<(aM&255)>>>0?aO&-2:aO|1;aO=aP-aM&255;a[803368]=aO;a[803360]=aO;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;aO=(d[461040]|0)+aL|0;c5[c[(c[217766]|0)+(aO>>>8<<2)>>2]&255](aO&65535,aM&255);c[198568]=0;i=f;return};case 221:{aM=d[461080]|0;aO=e[242917]|0;aL=d[461048]|0;if(((aO&255)+aL|0)>255){aP=c[(c[217768]|0)+(aO>>>8<<2)>>2]|0;aH=(aL+aO&255|aO&65280)&65535;da[aP&255](aH)|0;c[198580]=(c[198580]|0)+1;aH=(d[461048]|0)+(e[242917]|0)|0;aQ=da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255](aH&65535)|0}else{aH=aL+aO|0;aQ=da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255](aH&65535)|0}aH=aM-(aQ&255)|0;aQ=a[461072]|0;a[461072]=aH>>>0<256>>>0?aQ|1:aQ&-2;aQ=aH&255;a[803368]=aQ;a[803360]=aQ;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 222:{aQ=b[242917]|0;aH=aQ&65535;da[c[(c[217768]|0)+(aH>>>8<<2)>>2]&255]((d[461048]|0)+aQ&255|aQ&-256)|0;c[198580]=(c[198580]|0)+1;aQ=(d[461048]|0)+aH|0;aM=(da[c[(c[217768]|0)+(aQ>>>8<<2)>>2]&255](aQ&65535)|0)-1&255;a[803368]=aM;a[803360]=aM;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;aQ=(d[461048]|0)+aH|0;c5[c[(c[217766]|0)+(aQ>>>8<<2)>>2]&255](aQ&65535,aM);c[198568]=0;i=f;return};case 223:{aM=b[242917]|0;aQ=aM&65535;da[c[(c[217768]|0)+(aQ>>>8<<2)>>2]&255]((d[461048]|0)+aM&255|aM&-256)|0;c[198580]=(c[198580]|0)+1;aM=(d[461048]|0)+aQ|0;aH=((da[c[(c[217768]|0)+(aM>>>8<<2)>>2]&255](aM&65535)|0)&255)+255|0;aM=d[461080]|0;aO=a[461072]|0;a[461072]=aM>>>0<(aH&255)>>>0?aO&-2:aO|1;aO=aM-aH&255;a[803368]=aO;a[803360]=aO;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;aO=(d[461048]|0)+aQ|0;c5[c[(c[217766]|0)+(aO>>>8<<2)>>2]&255](aO&65535,aH&255);c[198568]=0;i=f;return};case 224:{aH=(d[461048]|0)-(d[485834]|0)|0;aO=a[461072]|0;a[461072]=aH>>>0<256>>>0?aO|1:aO&-2;aO=aH&255;a[803368]=aO;a[803360]=aO;c[115266]=(c[115266]|0)+2;i=f;return};case 225:{c[198580]=(c[198580]|0)+3;aO=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;aH=c[217768]|0;aQ=c[aH+(aO<<2)>>2]|0;aO=((da[c[aH>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255)<<8|(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255;aH=da[aQ&255](aO)|0;c[198580]=(c[198580]|0)+1;aO=a[461080]|0;aQ=aO&255;aM=aH&255;aL=a[461072]|0;aP=aL&255;aF=aP&1^1;aK=aQ-aM-aF|0;L4596:do{if((aP&8|0)==0){aN=aK&255;a[803368]=aN;a[803360]=aN;aG=(aK&65280)>>>0<256>>>0?aL|1:aL&-2;a[461072]=aG;do{if(((aQ^aK)&128|0)!=0){if((aO^aH)<<24>>24>=0){break}aR=aN;aS=aG|64;break L4596}}while(0);aR=aN;aS=aG&-65}else{ao=(aQ&15)-(aM&15)-aF|0;if((ao&16|0)==0){aT=ao&15|(aQ&240)-(aM&240)}else{aT=ao+10&15|-16-(aM&240)+(aQ&240)}if((aT&256|0)==0){aU=aT&255}else{aU=aT+160&255}ao=(aK&65280)>>>0<256>>>0?aL|1:aL&-2;a[461072]=ao;ak=aK&255;a[803368]=ak;a[803360]=ak;do{if(((aQ^aK)&128|0)!=0){if((aO^aH)<<24>>24>=0){break}aR=aU;aS=ao|64;break L4596}}while(0);aR=aU;aS=ao&-65}}while(0);a[461072]=aS;a[461080]=aR;c[115266]=(c[115266]|0)+2;i=f;return};case 227:{aR=(da[c[c[217768]>>2]&255](((d[485834]|0)+1&65535)+(d[461048]|0)&65535)|0)&255;aS=(da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0)&255|aR<<8;c[198580]=(c[198580]|0)+3;aU=aS&65535;aS=((da[c[(c[217768]|0)+(aR<<2)>>2]&255](aU)|0)&255)+1|0;aH=aS&255;aO=d[461080]|0;aK=a[461072]|0;aQ=aK&255;aL=aQ&1^1;aT=aO-(aS&255)-aL|0;L4617:do{if((aQ&8|0)==0){aM=aT&255;a[803368]=aM;a[803360]=aM;aF=(aT&65280)>>>0<256>>>0?aK|1:aK&-2;a[461072]=aF;do{if(((aO^aT)&128|0)!=0){if(((aO^aS)&128|0)==0){break}aV=aM;aW=aF|64;break L4617}}while(0);aV=aM;aW=aF&-65}else{ao=(aO&15)-(aS&15)-aL|0;if((ao&16|0)==0){aX=ao&15|(aO&240)-(aS&240)}else{aX=ao+10&15|-16-(aS&240)+(aO&240)}if((aX&256|0)==0){aY=aX&255}else{aY=aX+160&255}ao=(aT&65280)>>>0<256>>>0?aK|1:aK&-2;a[461072]=ao;aP=aT&255;a[803368]=aP;a[803360]=aP;do{if(((aO^aT)&128|0)!=0){if(((aO^aS)&128|0)==0){break}aV=aY;aW=ao|64;break L4617}}while(0);aV=aY;aW=ao&-65}}while(0);a[461072]=aW;a[461080]=aV;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(aR<<2)>>2]&255](aU,aH);c[198568]=0;i=f;return};case 228:{aH=(d[461048]|0)-((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)|0;aU=a[461072]|0;a[461072]=aH>>>0<256>>>0?aU|1:aU&-2;aU=aH&255;a[803368]=aU;a[803360]=aU;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+2;i=f;return};case 229:{aU=da[c[c[217768]>>2]&255](d[485834]|0)|0;c[198580]=(c[198580]|0)+1;aH=a[461080]|0;aR=aH&255;aV=aU&255;aW=a[461072]|0;aY=aW&255;aS=aY&1^1;aO=aR-aV-aS|0;L4640:do{if((aY&8|0)==0){aT=aO&255;a[803368]=aT;a[803360]=aT;aK=(aO&65280)>>>0<256>>>0?aW|1:aW&-2;a[461072]=aK;do{if(((aR^aO)&128|0)!=0){if((aH^aU)<<24>>24>=0){break}aZ=aT;a_=aK|64;break L4640}}while(0);aZ=aT;a_=aK&-65}else{ao=(aR&15)-(aV&15)-aS|0;if((ao&16|0)==0){a$=ao&15|(aR&240)-(aV&240)}else{a$=ao+10&15|-16-(aV&240)+(aR&240)}if((a$&256|0)==0){a0=a$&255}else{a0=a$+160&255}ao=(aO&65280)>>>0<256>>>0?aW|1:aW&-2;a[461072]=ao;aX=aO&255;a[803368]=aX;a[803360]=aX;do{if(((aR^aO)&128|0)!=0){if((aH^aU)<<24>>24>=0){break}aZ=a0;a_=ao|64;break L4640}}while(0);aZ=a0;a_=ao&-65}}while(0);a[461072]=a_;a[461080]=aZ;c[115266]=(c[115266]|0)+2;i=f;return};case 230:{aZ=d[485834]|0;a_=(da[c[c[217768]>>2]&255](aZ)|0)+1&255;a[803368]=a_;a[803360]=a_;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](aZ,a_);c[198568]=0;i=f;return};case 231:{a_=d[485834]|0;aZ=((da[c[c[217768]>>2]&255](a_)|0)&255)+1|0;a0=aZ&255;aU=d[461080]|0;aH=a[461072]|0;aO=aH&255;aR=aO&1^1;aW=aU-(aZ&255)-aR|0;L4663:do{if((aO&8|0)==0){a$=aW&255;a[803368]=a$;a[803360]=a$;aV=(aW&65280)>>>0<256>>>0?aH|1:aH&-2;a[461072]=aV;do{if(((aU^aW)&128|0)!=0){if(((aU^aZ)&128|0)==0){break}a1=a$;a2=aV|64;break L4663}}while(0);a1=a$;a2=aV&-65}else{ao=(aU&15)-(aZ&15)-aR|0;if((ao&16|0)==0){a3=ao&15|(aU&240)-(aZ&240)}else{a3=ao+10&15|-16-(aZ&240)+(aU&240)}if((a3&256|0)==0){a4=a3&255}else{a4=a3+160&255}ao=(aW&65280)>>>0<256>>>0?aH|1:aH&-2;a[461072]=ao;aS=aW&255;a[803368]=aS;a[803360]=aS;do{if(((aU^aW)&128|0)!=0){if(((aU^aZ)&128|0)==0){break}a1=a4;a2=ao|64;break L4663}}while(0);a1=a4;a2=ao&-65}}while(0);a[461072]=a2;a[461080]=a1;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[c[217766]>>2]&255](a_,a0);c[198568]=0;i=f;return};case 232:{a0=(a[461048]|0)+1&255;a[461048]=a0;a[803368]=a0;a[803360]=a0;c[115266]=(c[115266]|0)+1;i=f;return};case 233:{a0=a[485834]|0;a_=a[461080]|0;a1=a_&255;a2=a0&255;a4=a[461072]|0;aZ=a4&255;aU=aZ&1^1;aW=a1-a2-aU|0;L4686:do{if((aZ&8|0)==0){aH=aW&255;a[803368]=aH;a[803360]=aH;a3=(aW&65280)>>>0<256>>>0?a4|1:a4&-2;a[461072]=a3;do{if(((a1^aW)&128|0)!=0){if((a_^a0)<<24>>24>=0){break}a5=aH;a6=a3|64;break L4686}}while(0);a5=aH;a6=a3&-65}else{ao=(a1&15)-(a2&15)-aU|0;if((ao&16|0)==0){a7=ao&15|(a1&240)-(a2&240)}else{a7=ao+10&15|-16-(a2&240)+(a1&240)}if((a7&256|0)==0){a8=a7&255}else{a8=a7+160&255}ao=(aW&65280)>>>0<256>>>0?a4|1:a4&-2;a[461072]=ao;aR=aW&255;a[803368]=aR;a[803360]=aR;do{if(((a1^aW)&128|0)!=0){if((a_^a0)<<24>>24>=0){break}a5=a8;a6=ao|64;break L4686}}while(0);a5=a8;a6=ao&-65}}while(0);a[461072]=a6;a[461080]=a5;c[115266]=(c[115266]|0)+2;i=f;return};case 234:{c[115266]=(c[115266]|0)+1;i=f;return};case 235:{a5=a[485834]|0;a6=a[461080]|0;a8=a6&255;a0=a5&255;a_=a[461072]|0;aW=a_&255;a1=aW&1^1;a4=a8-a0-a1|0;L4709:do{if((aW&8|0)==0){a7=a4&255;a[803368]=a7;a[803360]=a7;a2=(a4&65280)>>>0<256>>>0?a_|1:a_&-2;a[461072]=a2;do{if(((a8^a4)&128|0)!=0){if((a6^a5)<<24>>24>=0){break}a9=a7;ba=a2|64;break L4709}}while(0);a9=a7;ba=a2&-65}else{ao=(a8&15)-(a0&15)-a1|0;if((ao&16|0)==0){bb=ao&15|(a8&240)-(a0&240)}else{bb=ao+10&15|-16-(a0&240)+(a8&240)}if((bb&256|0)==0){bc=bb&255}else{bc=bb+160&255}ao=(a4&65280)>>>0<256>>>0?a_|1:a_&-2;a[461072]=ao;aU=a4&255;a[803368]=aU;a[803360]=aU;do{if(((a8^a4)&128|0)!=0){if((a6^a5)<<24>>24>=0){break}a9=bc;ba=ao|64;break L4709}}while(0);a9=bc;ba=ao&-65}}while(0);a[461072]=ba;a[461080]=a9;c[115266]=(c[115266]|0)+2;i=f;return};case 236:{a9=b[242917]|0;ba=(d[461048]|0)-((da[c[(c[217768]|0)+((a9&65535)>>>8<<2)>>2]&255](a9)|0)&255)|0;a9=a[461072]|0;a[461072]=ba>>>0<256>>>0?a9|1:a9&-2;a9=ba&255;a[803368]=a9;a[803360]=a9;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3;i=f;return};case 237:{a9=b[242917]|0;ba=da[c[(c[217768]|0)+((a9&65535)>>>8<<2)>>2]&255](a9)|0;c[198580]=(c[198580]|0)+1;a9=a[461080]|0;bc=a9&255;a5=ba&255;a6=a[461072]|0;a4=a6&255;a8=a4&1^1;a_=bc-a5-a8|0;L4732:do{if((a4&8|0)==0){bb=a_&255;a[803368]=bb;a[803360]=bb;a0=(a_&65280)>>>0<256>>>0?a6|1:a6&-2;a[461072]=a0;do{if(((bc^a_)&128|0)!=0){if((a9^ba)<<24>>24>=0){break}bd=bb;be=a0|64;break L4732}}while(0);bd=bb;be=a0&-65}else{ao=(bc&15)-(a5&15)-a8|0;if((ao&16|0)==0){bf=ao&15|(bc&240)-(a5&240)}else{bf=ao+10&15|-16-(a5&240)+(bc&240)}if((bf&256|0)==0){bg=bf&255}else{bg=bf+160&255}ao=(a_&65280)>>>0<256>>>0?a6|1:a6&-2;a[461072]=ao;a1=a_&255;a[803368]=a1;a[803360]=a1;do{if(((bc^a_)&128|0)!=0){if((a9^ba)<<24>>24>=0){break}bd=bg;be=ao|64;break L4732}}while(0);bd=bg;be=ao&-65}}while(0);a[461072]=be;a[461080]=bd;c[115266]=(c[115266]|0)+3;i=f;return};case 238:{bd=b[242917]|0;be=(bd&65535)>>>8;bg=(da[c[(c[217768]|0)+(be<<2)>>2]&255](bd)|0)+1&255;a[803368]=bg;a[803360]=bg;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(be<<2)>>2]&255](bd,bg);c[198568]=0;i=f;return};case 239:{bg=b[242917]|0;bd=(bg&65535)>>>8;be=((da[c[(c[217768]|0)+(bd<<2)>>2]&255](bg)|0)&255)+1|0;ba=be&255;a9=d[461080]|0;a_=a[461072]|0;bc=a_&255;a6=bc&1^1;bf=a9-(be&255)-a6|0;L4755:do{if((bc&8|0)==0){a5=bf&255;a[803368]=a5;a[803360]=a5;a8=(bf&65280)>>>0<256>>>0?a_|1:a_&-2;a[461072]=a8;do{if(((a9^bf)&128|0)!=0){if(((a9^be)&128|0)==0){break}bh=a5;bi=a8|64;break L4755}}while(0);bh=a5;bi=a8&-65}else{ao=(a9&15)-(be&15)-a6|0;if((ao&16|0)==0){bj=ao&15|(a9&240)-(be&240)}else{bj=ao+10&15|-16-(be&240)+(a9&240)}if((bj&256|0)==0){bk=bj&255}else{bk=bj+160&255}ao=(bf&65280)>>>0<256>>>0?a_|1:a_&-2;a[461072]=ao;a4=bf&255;a[803368]=a4;a[803360]=a4;do{if(((a9^bf)&128|0)!=0){if(((a9^be)&128|0)==0){break}bh=bk;bi=ao|64;break L4755}}while(0);bh=bk;bi=ao&-65}}while(0);a[461072]=bi;a[461080]=bh;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(bd<<2)>>2]&255](bg,ba);c[198568]=0;i=f;return};case 241:{c[198580]=(c[198580]|0)+2;da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0;ba=(((da[c[c[217768]>>2]&255](d[485834]|0)|0)&255)+(d[461040]|0)|0)>255;bg=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;bd=da[c[c[217768]>>2]&255](d[485834]|0)|0;if(ba){ba=c[c[217768]>>2]|0;bh=(d[485834]|0)+1&65535;da[ba&255](bh)|0;bh=c[c[217768]>>2]|0;ba=d[485834]|0;da[bh&255](ba)|0;ba=c[217768]|0;bh=c[ba+(bg<<2)>>2]|0;bi=((da[c[ba>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;ba=c[c[217768]>>2]|0;bk=d[485834]|0;da[ba&255](bk)|0;bk=c[c[217768]>>2]|0;ba=(d[485834]|0)+1&65535;da[bk&255](ba)|0;ba=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;bk=(d[461040]|0)+ba&255|bi;da[bh&255](bk)|0;c[198580]=(c[198580]|0)+1;bk=((da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;bh=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|bk;bk=c[217768]|0;bi=c[bk+((bh+(d[461040]|0)|0)>>>8<<2)>>2]|0;bh=((da[c[bk>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;bk=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|bh;bl=da[bi&255](bk+(d[461040]|0)&65535)|0}else{bk=c[217768]|0;bi=c[bk+(((d[461040]|0)+(bd&255|bg<<8)|0)>>>8<<2)>>2]|0;bg=((da[c[bk>>2]&255]((d[485834]|0)+1&65535)|0)&255)<<8;bk=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255|bg;bl=da[bi&255](bk+(d[461040]|0)&65535)|0}c[198580]=(c[198580]|0)+1;bk=a[461080]|0;bi=bk&255;bg=bl&255;bd=a[461072]|0;bh=bd&255;ba=bh&1^1;be=bi-bg-ba|0;L4780:do{if((bh&8|0)==0){a9=be&255;a[803368]=a9;a[803360]=a9;bf=(be&65280)>>>0<256>>>0?bd|1:bd&-2;a[461072]=bf;do{if(((bi^be)&128|0)!=0){if((bk^bl)<<24>>24>=0){break}bm=a9;bn=bf|64;break L4780}}while(0);bm=a9;bn=bf&-65}else{ao=(bi&15)-(bg&15)-ba|0;if((ao&16|0)==0){bo=ao&15|(bi&240)-(bg&240)}else{bo=ao+10&15|-16-(bg&240)+(bi&240)}if((bo&256|0)==0){bp=bo&255}else{bp=bo+160&255}ao=(be&65280)>>>0<256>>>0?bd|1:bd&-2;a[461072]=ao;a_=be&255;a[803368]=a_;a[803360]=a_;do{if(((bi^be)&128|0)!=0){if((bk^bl)<<24>>24>=0){break}bm=bp;bn=ao|64;break L4780}}while(0);bm=bp;bn=ao&-65}}while(0);a[461072]=bn;a[461080]=bm;c[115266]=(c[115266]|0)+2;i=f;return};case 243:{bm=(da[c[c[217768]>>2]&255]((d[485834]|0)+1&65535)|0)&255;bn=bm<<8;bp=(da[c[c[217768]>>2]&255](d[485834]|0)|0)&255;c[198580]=(c[198580]|0)+2;da[c[(c[217768]|0)+(bm<<2)>>2]&255](((d[461040]|0)+bp&255|bn)&65535)|0;c[198580]=(c[198580]|0)+1;bm=(d[461040]|0)+(bp|bn)|0;bn=bm>>>8;bp=bm&65535;bm=((da[c[(c[217768]|0)+(bn<<2)>>2]&255](bp)|0)&255)+1|0;bl=bm&255;bk=d[461080]|0;be=a[461072]|0;bi=be&255;bd=bi&1^1;bo=bk-(bm&255)-bd|0;L4801:do{if((bi&8|0)==0){bg=bo&255;a[803368]=bg;a[803360]=bg;ba=(bo&65280)>>>0<256>>>0?be|1:be&-2;a[461072]=ba;do{if(((bk^bo)&128|0)!=0){if(((bk^bm)&128|0)==0){break}bq=bg;br=ba|64;break L4801}}while(0);bq=bg;br=ba&-65}else{ao=(bk&15)-(bm&15)-bd|0;if((ao&16|0)==0){bs=ao&15|(bk&240)-(bm&240)}else{bs=ao+10&15|-16-(bm&240)+(bk&240)}if((bs&256|0)==0){bt=bs&255}else{bt=bs+160&255}ao=(bo&65280)>>>0<256>>>0?be|1:be&-2;a[461072]=ao;bh=bo&255;a[803368]=bh;a[803360]=bh;do{if(((bk^bo)&128|0)!=0){if(((bk^bm)&128|0)==0){break}bq=bt;br=ao|64;break L4801}}while(0);bq=bt;br=ao&-65}}while(0);a[461072]=br;a[461080]=bq;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+3;c5[c[(c[217766]|0)+(bn<<2)>>2]&255](bp,bl);c[198568]=0;i=f;return};case 245:{bl=da[c[c[217768]>>2]&255]((d[461048]|0)+(d[485834]|0)&65535)|0;c[198580]=(c[198580]|0)+2;bp=a[461080]|0;bn=bp&255;bq=bl&255;br=a[461072]|0;bt=br&255;bm=bt&1^1;bk=bn-bq-bm|0;L4822:do{if((bt&8|0)==0){bo=bk&255;a[803368]=bo;a[803360]=bo;be=(bk&65280)>>>0<256>>>0?br|1:br&-2;a[461072]=be;do{if(((bn^bk)&128|0)!=0){if((bp^bl)<<24>>24>=0){break}bu=bo;bv=be|64;break L4822}}while(0);bu=bo;bv=be&-65}else{ao=(bn&15)-(bq&15)-bm|0;if((ao&16|0)==0){bw=ao&15|(bn&240)-(bq&240)}else{bw=ao+10&15|-16-(bq&240)+(bn&240)}if((bw&256|0)==0){bx=bw&255}else{bx=bw+160&255}ao=(bk&65280)>>>0<256>>>0?br|1:br&-2;a[461072]=ao;bs=bk&255;a[803368]=bs;a[803360]=bs;do{if(((bn^bk)&128|0)!=0){if((bp^bl)<<24>>24>=0){break}bu=bx;bv=ao|64;break L4822}}while(0);bu=bx;bv=ao&-65}}while(0);a[461072]=bv;a[461080]=bu;c[115266]=(c[115266]|0)+2;i=f;return};case 246:{bu=(d[461048]|0)+(d[485834]|0)&255;bv=(da[c[c[217768]>>2]&255](bu)|0)+1&255;a[803368]=bv;a[803360]=bv;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](bu,bv);c[198568]=0;i=f;return};case 247:{bv=(d[461048]|0)+(d[485834]|0)&255;bu=((da[c[c[217768]>>2]&255](bv)|0)&255)+1|0;bx=bu&255;bl=d[461080]|0;bp=a[461072]|0;bk=bp&255;bn=bk&1^1;br=bl-(bu&255)-bn|0;L4845:do{if((bk&8|0)==0){bw=br&255;a[803368]=bw;a[803360]=bw;bq=(br&65280)>>>0<256>>>0?bp|1:bp&-2;a[461072]=bq;do{if(((bl^br)&128|0)!=0){if(((bl^bu)&128|0)==0){break}by=bw;bz=bq|64;break L4845}}while(0);by=bw;bz=bq&-65}else{ao=(bl&15)-(bu&15)-bn|0;if((ao&16|0)==0){bA=ao&15|(bl&240)-(bu&240)}else{bA=ao+10&15|-16-(bu&240)+(bl&240)}if((bA&256|0)==0){bB=bA&255}else{bB=bA+160&255}ao=(br&65280)>>>0<256>>>0?bp|1:bp&-2;a[461072]=ao;bm=br&255;a[803368]=bm;a[803360]=bm;do{if(((bl^br)&128|0)!=0){if(((bl^bu)&128|0)==0){break}by=bB;bz=ao|64;break L4845}}while(0);by=bB;bz=ao&-65}}while(0);a[461072]=bz;a[461080]=by;c[198568]=1;c[115266]=(c[115266]|0)+2;c[198580]=(c[198580]|0)+4;c5[c[c[217766]>>2]&255](bv,bx);c[198568]=0;i=f;return};case 248:{a[461072]=a[461072]|8;c[115266]=(c[115266]|0)+1;i=f;return};case 249:{bx=e[242917]|0;bv=d[461040]|0;if(((bx&255)+bv|0)>255){by=c[(c[217768]|0)+(bx>>>8<<2)>>2]|0;bz=(bv+bx&255|bx&65280)&65535;da[by&255](bz)|0;c[198580]=(c[198580]|0)+1;bz=(d[461040]|0)+(e[242917]|0)|0;bC=da[c[(c[217768]|0)+(bz>>>8<<2)>>2]&255](bz&65535)|0}else{bz=bv+bx|0;bC=da[c[(c[217768]|0)+(bz>>>8<<2)>>2]&255](bz&65535)|0}c[198580]=(c[198580]|0)+1;bz=a[461080]|0;bx=bz&255;bv=bC&255;by=a[461072]|0;bB=by&255;bu=bB&1^1;bl=bx-bv-bu|0;L4872:do{if((bB&8|0)==0){br=bl&255;a[803368]=br;a[803360]=br;bp=(bl&65280)>>>0<256>>>0?by|1:by&-2;a[461072]=bp;do{if(((bx^bl)&128|0)!=0){if((bz^bC)<<24>>24>=0){break}bD=br;bE=bp|64;break L4872}}while(0);bD=br;bE=bp&-65}else{ao=(bx&15)-(bv&15)-bu|0;if((ao&16|0)==0){bF=ao&15|(bx&240)-(bv&240)}else{bF=ao+10&15|-16-(bv&240)+(bx&240)}if((bF&256|0)==0){bG=bF&255}else{bG=bF+160&255}ao=(bl&65280)>>>0<256>>>0?by|1:by&-2;a[461072]=ao;bA=bl&255;a[803368]=bA;a[803360]=bA;do{if(((bx^bl)&128|0)!=0){if((bz^bC)<<24>>24>=0){break}bD=bG;bE=ao|64;break L4872}}while(0);bD=bG;bE=ao&-65}}while(0);a[461072]=bE;a[461080]=bD;c[115266]=(c[115266]|0)+3;i=f;return};case 251:{bD=b[242917]|0;bE=bD&65535;da[c[(c[217768]|0)+(bE>>>8<<2)>>2]&255]((d[461040]|0)+bD&255|bD&-256)|0;c[198580]=(c[198580]|0)+1;bD=(d[461040]|0)+bE|0;bG=((da[c[(c[217768]|0)+(bD>>>8<<2)>>2]&255](bD&65535)|0)&255)+1|0;bD=bG&255;bC=d[461080]|0;bz=a[461072]|0;bl=bz&255;bx=bl&1^1;by=bC-(bG&255)-bx|0;L4893:do{if((bl&8|0)==0){bF=by&255;a[803368]=bF;a[803360]=bF;bv=(by&65280)>>>0<256>>>0?bz|1:bz&-2;a[461072]=bv;do{if(((bC^by)&128|0)!=0){if(((bC^bG)&128|0)==0){break}bH=bF;bI=bv|64;break L4893}}while(0);bH=bF;bI=bv&-65}else{ao=(bC&15)-(bG&15)-bx|0;if((ao&16|0)==0){bJ=ao&15|(bC&240)-(bG&240)}else{bJ=ao+10&15|-16-(bG&240)+(bC&240)}if((bJ&256|0)==0){bK=bJ&255}else{bK=bJ+160&255}ao=(by&65280)>>>0<256>>>0?bz|1:bz&-2;a[461072]=ao;bu=by&255;a[803368]=bu;a[803360]=bu;do{if(((bC^by)&128|0)!=0){if(((bC^bG)&128|0)==0){break}bH=bK;bI=ao|64;break L4893}}while(0);bH=bK;bI=ao&-65}}while(0);a[461072]=bI;a[461080]=bH;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;bH=(d[461040]|0)+bE|0;c5[c[(c[217766]|0)+(bH>>>8<<2)>>2]&255](bH&65535,bD);c[198568]=0;i=f;return};case 253:{bD=e[242917]|0;bH=d[461048]|0;if(((bD&255)+bH|0)>255){bE=c[(c[217768]|0)+(bD>>>8<<2)>>2]|0;bI=(bH+bD&255|bD&65280)&65535;da[bE&255](bI)|0;c[198580]=(c[198580]|0)+1;bI=(d[461048]|0)+(e[242917]|0)|0;bL=da[c[(c[217768]|0)+(bI>>>8<<2)>>2]&255](bI&65535)|0}else{bI=bH+bD|0;bL=da[c[(c[217768]|0)+(bI>>>8<<2)>>2]&255](bI&65535)|0}c[198580]=(c[198580]|0)+1;bI=a[461080]|0;bD=bI&255;bH=bL&255;bE=a[461072]|0;bK=bE&255;bG=bK&1^1;bC=bD-bH-bG|0;L4918:do{if((bK&8|0)==0){by=bC&255;a[803368]=by;a[803360]=by;bz=(bC&65280)>>>0<256>>>0?bE|1:bE&-2;a[461072]=bz;do{if(((bD^bC)&128|0)!=0){if((bI^bL)<<24>>24>=0){break}bM=by;bN=bz|64;break L4918}}while(0);bM=by;bN=bz&-65}else{ao=(bD&15)-(bH&15)-bG|0;if((ao&16|0)==0){bO=ao&15|(bD&240)-(bH&240)}else{bO=ao+10&15|-16-(bH&240)+(bD&240)}if((bO&256|0)==0){bP=bO&255}else{bP=bO+160&255}ao=(bC&65280)>>>0<256>>>0?bE|1:bE&-2;a[461072]=ao;bJ=bC&255;a[803368]=bJ;a[803360]=bJ;do{if(((bD^bC)&128|0)!=0){if((bI^bL)<<24>>24>=0){break}bM=bP;bN=ao|64;break L4918}}while(0);bM=bP;bN=ao&-65}}while(0);a[461072]=bN;a[461080]=bM;c[115266]=(c[115266]|0)+3;i=f;return};case 254:{bM=b[242917]|0;bN=bM&65535;da[c[(c[217768]|0)+(bN>>>8<<2)>>2]&255]((d[461048]|0)+bM&255|bM&-256)|0;c[198580]=(c[198580]|0)+1;bM=(d[461048]|0)+bN|0;bP=(da[c[(c[217768]|0)+(bM>>>8<<2)>>2]&255](bM&65535)|0)+1&255;a[803368]=bP;a[803360]=bP;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;bM=(d[461048]|0)+bN|0;c5[c[(c[217766]|0)+(bM>>>8<<2)>>2]&255](bM&65535,bP);c[198568]=0;i=f;return};case 255:{bP=b[242917]|0;bM=bP&65535;da[c[(c[217768]|0)+(bM>>>8<<2)>>2]&255]((d[461048]|0)+bP&255|bP&-256)|0;c[198580]=(c[198580]|0)+1;bP=(d[461048]|0)+bM|0;bN=((da[c[(c[217768]|0)+(bP>>>8<<2)>>2]&255](bP&65535)|0)&255)+1|0;bP=bN&255;bL=d[461080]|0;bI=a[461072]|0;bC=bI&255;bD=bC&1^1;bE=bL-(bN&255)-bD|0;L4941:do{if((bC&8|0)==0){bO=bE&255;a[803368]=bO;a[803360]=bO;bH=(bE&65280)>>>0<256>>>0?bI|1:bI&-2;a[461072]=bH;do{if(((bL^bE)&128|0)!=0){if(((bL^bN)&128|0)==0){break}bQ=bO;bR=bH|64;break L4941}}while(0);bQ=bO;bR=bH&-65}else{ao=(bL&15)-(bN&15)-bD|0;if((ao&16|0)==0){bS=ao&15|(bL&240)-(bN&240)}else{bS=ao+10&15|-16-(bN&240)+(bL&240)}if((bS&256|0)==0){bT=bS&255}else{bT=bS+160&255}ao=(bE&65280)>>>0<256>>>0?bI|1:bI&-2;a[461072]=ao;bG=bE&255;a[803368]=bG;a[803360]=bG;do{if(((bL^bE)&128|0)!=0){if(((bL^bN)&128|0)==0){break}bQ=bT;bR=ao|64;break L4941}}while(0);bQ=bT;bR=ao&-65}}while(0);a[461072]=bR;a[461080]=bQ;c[198568]=1;c[115266]=(c[115266]|0)+3;c[198580]=(c[198580]|0)+3;bQ=(d[461048]|0)+bM|0;c5[c[(c[217766]|0)+(bQ>>>8<<2)>>2]&255](bQ&65535,bP);c[198568]=0;i=f;return};default:{i=f;return}}}function qE(){return 0}function qF(a,b,c){a=a|0;b=b|0;c=c|0;return}function qG(){return}function qH(a){a=a|0;return}function qI(a){a=a|0;return 0}function qJ(a){a=a|0;return}function qK(){return}function qL(a,b){a=a|0;b=b|0;return}function qM(a,b){a=a|0;b=b|0;return}function qN(a,b){a=a|0;b=b|0;return}function qO(a,b){a=a|0;b=b|0;return 0}function qP(a,b){a=a|0;b=b|0;return 0}function qQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function qR(a){a=a|0;return}function qS(){return 0}function qT(a,b){a=a|0;b=b|0;return 0}function qU(){return 0}function qV(){return}function qW(){return}function qX(a){a=a|0;return 456160+(a*296|0)|0}function qY(){return il(56176)|0}function qZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[209416]=c[f>>2];return 0}function q_(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c[119402]|0;L4985:do{if((e|0)!=0){f=0;g=e;while(1){h=c[119384]|0;if((h|0)==(c[119382]|0)){break}i=477616+(f<<1)|0;if((c[209416]|0)==1){j=b[i>>1]|0;c[119384]=h+1;b[(c[119386]|0)+(h<<1)>>1]=j;k=c[119384]|0}else{k=h}h=f+1|0;j=b[i>>1]|0;c[119384]=k+1;b[(c[119386]|0)+(k<<1)>>1]=j;j=c[119402]|0;if((h|0)==(j|0)){break L4985}else{f=h;g=j}}if((f|0)==(g|0)){break}l=d-f+g|0;return l|0}}while(0);c[119402]=0;if((d|0)==0){l=0;return l|0}else{m=d;n=0}while(1){d=c[119384]|0;if((d|0)==(c[119382]|0)){break}k=a+(n<<1)|0;if((c[209416]|0)==1){e=b[k>>1]|0;c[119384]=d+1;b[(c[119386]|0)+(d<<1)>>1]=e;o=c[119384]|0}else{o=d}d=b[k>>1]|0;c[119384]=o+1;b[(c[119386]|0)+(o<<1)>>1]=d;d=m-1|0;if((d|0)==0){l=0;p=3860;break}else{m=d;n=n+1|0}}if((p|0)==3860){return l|0}p=c[119402]|0;if((m|0)!=0&(p|0)!=4096){q=m;r=n;s=p}else{l=m;return l|0}while(1){m=b[a+(r<<1)>>1]|0;p=s+1|0;c[119402]=p;b[477616+(s<<1)>>1]=m;m=q-1|0;if((m|0)!=0&(p|0)!=4096){q=m;r=r+1|0;s=p}else{l=m;break}}return l|0}function q$(){nR(c[80537]|0,0,30,44,22,226,226);nR(c[80537]|0,1,30,44,22,226,226);nR(c[80537]|0,2,30,44,22,226,226);nR(c[80537]|0,3,30,44,22,226,226);nR(c[80537]|0,4,30,44,22,226,226);nR(c[80537]|0,19,30,44,22,226,226);nR(c[80537]|0,5,30,44,22,226,226);nR(c[80537]|0,6,30,44,22,226,226);nR(c[80537]|0,7,30,44,22,226,226);return}function q0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function q1(a,b,c){a=a|0;b=b|0;c=c|0;return}function q2(){return}function q3(a,b){a=a|0;b=b|0;return}function q4(){return}function q5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function q6(a){a=a|0;if((a|0)==0){return}hj(c[a+4>>2]|0);hj(c[a+8>>2]|0);hj(c[a+12>>2]|0);hj(c[a+16>>2]|0);hj(a);return}function q7(){var a=0;a=hh(1,32)|0;c[a+4>>2]=hh(1,57480)|0;c[a+8>>2]=hh(1,40)|0;c[a+12>>2]=hh(1,32)|0;c[a+16>>2]=hh(1,56)|0;return a|0}function q8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return}function q9(a,b){a=a|0;b=b|0;return 0}function ra(a){a=a|0;return}function rb(a){a=a|0;return}function rc(a){a=a|0;return}function rd(a,b,d){a=a|0;b=b|0;d=d|0;c[b>>2]=c[a+12>>2];c[d>>2]=c[a+16>>2];return}function re(a,b){a=a|0;b=b|0;return}function rf(a,b){a=a|0;b=b|0;return}function rg(){return 0}function rh(){return}function ri(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function rj(a){a=a|0;return}function rk(a,b){a=a|0;b=b|0;return}function rl(a){a=a|0;return 0}function rm(a){a=a|0;return}function rn(){return}function ro(){return}function rp(b){b=b|0;var d=0,e=0;d=i;i=i+80|0;if((a[b]&1)==0){e=b+1|0}else{e=c[b+8>>2]|0}b=(cM(e|0,d|0)|0)==0;i=d;return b|0}function rq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e|0;g=e+16|0;h=d;j=d+1|0;k=d+8|0;l=d+4|0;m=0;while(1){n=a[h]|0;o=n&255;p=(o&1|0)==0;if(p){q=o>>>1}else{q=c[l>>2]|0}if(q>>>0<=m>>>0){r=0;s=3939;break}t=(n&1)==0;if(t){u=j}else{u=c[k>>2]|0}n=ba(u+m|0,37,q-m|0)|0;if((n|0)==0){r=0;s=3937;break}v=n-u|0;if((v|0)==-1){r=0;s=3936;break}if(p){w=o>>>1}else{w=c[l>>2]|0}if(v>>>0>=(w-1|0)>>>0){r=0;s=3938;break}x=v+1|0;if(t){y=j}else{y=c[k>>2]|0}if((a[y+x|0]|0)!=37){s=3913;break}tS(d,v,2,85336,1)|0;m=x}if((s|0)==3937){i=e;return r|0}else if((s|0)==3938){i=e;return r|0}else if((s|0)==3913){m=b;y=b+8|0;tG(f,d,0,v,0);d3(y,f)|0;if((a[f]&1)!=0){AT(c[f+8>>2]|0)}f=a[h]|0;h=f&255;if((h&1|0)==0){z=h>>>1}else{z=c[l>>2]|0}if((f&1)==0){A=j;B=j}else{j=c[k>>2]|0;A=j;B=j}j=B+z|0;z=A+x|0;if(z>>>0>=j>>>0){r=0;i=e;return r|0}x=A+(v+2)|0;v=a[z]|0;if((v|0)==32){c[m+((c[(c[b>>2]|0)-12>>2]|0)+76)>>2]=32;C=x}else if((v|0)==45){A=y+((c[(c[y>>2]|0)-12>>2]|0)+4)|0;c[A>>2]=c[A>>2]&-177|32;C=x}else if((v|0)==48){c[m+((c[(c[b>>2]|0)-12>>2]|0)+76)>>2]=48;C=x}else{C=z}if(C>>>0>=j>>>0){r=0;i=e;return r|0}z=aR(C|0,g|0,10)|0;x=c[g>>2]|0;if((x|0)!=0&x>>>0>C>>>0){c[m+((c[(c[b>>2]|0)-12>>2]|0)+12)>>2]=z;D=x}else{D=C}if(D>>>0>=j>>>0){r=0;i=e;return r|0}j=a[D]|0;C=y+((c[(c[y>>2]|0)-12>>2]|0)+4)|0;c[C>>2]=c[C>>2]&-75|(j<<24>>24==120?8:2);tJ(d,D+1|0)|0;r=j;i=e;return r|0}else if((s|0)==3939){i=e;return r|0}else if((s|0)==3936){i=e;return r|0}return 0}function rr(b){b=b|0;var d=0,e=0;d=c[b+8>>2]|0;if((d|0)!=0){e=d;while(1){d=c[e>>2]|0;if((a[e+20|0]&1)!=0){AT(c[e+28>>2]|0)}if((a[e+8|0]&1)!=0){AT(c[e+16>>2]|0)}AT(e);if((d|0)==0){break}else{e=d}}}e=b|0;b=c[e>>2]|0;c[e>>2]=0;if((b|0)==0){return}AT(b);return}function rs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,r=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;if((c[24814]|0)<=(b|0)){if((a[d]&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}b=A1(j|0)|0;k=c[q>>2]|0;aU(j|0,1,b|0,k|0)|0;bK(10)|0}if((c[218778]|0)==0){i=e;return}c[f>>2]=c_(0)|0;k=aZ(f|0)|0;f=AR(32)|0;b=h+8|0;c[b>>2]=f;c[h>>2]=33;c[h+4>>2]=17;A$(f|0,85312,17)|0;a[f+17|0]=0;rt(g,h,k+8|0,k+4|0,k|0);if((a[h]&1)!=0){AT(c[b>>2]|0)}b=g;h=a[b]|0;if((h&1)==0){l=g+1|0}else{l=c[g+8>>2]|0}k=h&255;if((k&1|0)==0){m=k>>>1}else{m=c[g+4>>2]|0}aU(l|0,1,m|0,c[218778]|0)|0;m=d;l=d;k=a[l]|0;if((k&1)==0){n=m+1|0}else{n=c[d+8>>2]|0}h=k&255;if((h&1|0)==0){o=h>>>1}else{o=c[d+4>>2]|0}aU(n|0,1,o|0,c[218778]|0)|0;o=a[l]|0;l=o&255;if((l&1|0)==0){p=l>>>1}else{p=c[d+4>>2]|0}if((o&1)==0){r=m+1|0}else{r=c[d+8>>2]|0}d=a[r+(p-1)|0]|0;if(!((d<<24>>24|0)==10|(d<<24>>24|0)==13)){d=c[218778]|0;aS(10,d|0)|0}aQ(c[218778]|0)|0;if((a[b]&1)==0){i=e;return}AT(c[g+8>>2]|0);i=e;return}function rt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+16|0;j=h|0;k=j;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+144|0;n=d;if((a[n]&1)==0){o=l;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){tB(0)}if(o>>>0<11>>>0){a[l]=o<<1&255;p=l+1|0}else{d=o+16&-16;q=AR(d)|0;c[l+8>>2]=q;c[l>>2]=d|1;c[l+4>>2]=o;p=q}A$(p|0,n|0,o)|0;a[p+o|0]=0}o=m|0;p=m+8|0;n=p|0;c[n>>2]=92376;q=m+12|0;c[o>>2]=98804;d=m+64|0;c[d>>2]=98824;c[m+4>>2]=0;t4(m+64|0,q);c[m+136>>2]=0;c[m+140>>2]=-1;r=m+8|0;c[o>>2]=92356;c[m+64>>2]=92396;c[n>>2]=92376;n=q|0;c[n>>2]=92712;s=m+16|0;yq(s);t=m+20|0;A2(t|0,0,24);c[n>>2]=92568;n=m+44|0;u=m+56|0;v=m+60|0;A2(m+44|0,0,16);c[v>>2]=24;A2(k|0,0,12);ej(q,j);if((a[k]&1)!=0){AT(c[j+8>>2]|0)}if((rq(m,l)|0)<<24>>24!=0){j=p;k=c[e>>2]|0;uN(j,k)|0}if((rq(m,l)|0)<<24>>24!=0){k=p;j=c[f>>2]|0;uN(k,j)|0}j=p;if((rq(m,l)|0)<<24>>24!=0){p=c[g>>2]|0;uN(j,p)|0}d3(j,l)|0;j=b;p=c[v>>2]|0;do{if((p&16|0)==0){if((p&8|0)==0){A2(j|0,0,12);break}v=c[t>>2]|0;g=c[m+28>>2]|0;k=v;f=g-k|0;if(f>>>0>4294967279>>>0){tB(0)}if(f>>>0<11>>>0){a[j]=f<<1&255;w=b+1|0}else{e=f+16&-16;q=AR(e)|0;c[b+8>>2]=q;c[b>>2]=e|1;c[b+4>>2]=f;w=q}if((v|0)==(g|0)){x=w}else{q=g+(-k|0)|0;k=w;f=v;while(1){a[k]=a[f]|0;v=f+1|0;if((v|0)==(g|0)){break}else{k=k+1|0;f=v}}x=w+q|0}a[x]=0}else{f=c[u>>2]|0;k=c[m+36>>2]|0;if(f>>>0<k>>>0){c[u>>2]=k;y=k}else{y=f}f=c[m+32>>2]|0;k=f;g=y-k|0;if(g>>>0>4294967279>>>0){tB(0)}if(g>>>0<11>>>0){a[j]=g<<1&255;z=b+1|0}else{v=g+16&-16;e=AR(v)|0;c[b+8>>2]=e;c[b>>2]=v|1;c[b+4>>2]=g;z=e}if((f|0)==(y|0)){A=z}else{e=y+(-k|0)|0;k=z;g=f;while(1){a[k]=a[g]|0;f=g+1|0;if((f|0)==(y|0)){break}else{k=k+1|0;g=f}}A=z+e|0}a[A]=0}}while(0);c[o>>2]=92356;c[d>>2]=92396;c[r>>2]=92376;r=m+12|0;c[r>>2]=92568;if((a[n]&1)!=0){AT(c[m+52>>2]|0)}c[r>>2]=92712;ys(s);t2(m+64|0);if((a[l]&1)==0){i=h;return}AT(c[l+8>>2]|0);i=h;return}function ru(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+2080|0;j=h|0;k=h+16|0;l=h+2064|0;m=A1(b|0)|0;if(m>>>0>4294967279>>>0){tB(0)}if(m>>>0<11>>>0){a[j]=m<<1&255;n=j+1|0}else{o=m+16&-16;p=AR(o)|0;c[j+8>>2]=p;c[j>>2]=o|1;c[j+4>>2]=m;n=p}A$(n|0,b|0,m)|0;a[n+m|0]=0;m=rv(875120,j)|0;if((a[j]&1)!=0){AT(c[j+8>>2]|0)}do{if((a[m+12|0]&1)==0){j=d[m]|0;if((j&1|0)==0){q=j>>>1}else{q=c[m+4>>2]|0}if((q|0)==0){break}i=h;return}}while(0);q=k|0;bs(q|0,81640,(k=i,i=i+16|0,c[k>>2]=b,c[k+8>>2]=e,k)|0)|0;i=k;k=A1(q|0)|0;if(k>>>0>4294967279>>>0){tB(0)}if(k>>>0<11>>>0){a[l]=k<<1&255;r=l+1|0}else{e=k+16&-16;b=AR(e)|0;c[l+8>>2]=b;c[l>>2]=e|1;c[l+4>>2]=k;r=b}A$(r|0,q|0,k)|0;a[r+k|0]=0;k=a[g]|0;if((k&1)==0){s=g+1|0}else{s=c[g+8>>2]|0}r=k&255;if((r&1|0)==0){t=r>>>1}else{t=c[g+4>>2]|0}rs(f,tO(l,s,t)|0);if((a[l]&1)==0){i=h;return}AT(c[l+8>>2]|0);i=h;return}function rv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=a|0;rz(e,g,b);a=c[e>>2]|0;if((a|0)!=0){h=a;j=h+20|0;i=d;return j|0}a=b;b=AR(36)|0;e=b+8|0;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];A2(a|0,0,12);A2(b+20|0,0,13);rw(f,g,b);h=c[f>>2]|0;j=h+20|0;i=d;return j|0}function rw(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0;h=f+8|0;i=h;j=a[h]|0;h=(j&1)==0;if(h){k=i+1|0}else{k=c[f+16>>2]|0}l=j&255;j=(l&1|0)==0;if(j){m=l>>>1}else{m=c[f+12>>2]|0}if(m>>>0>3>>>0){n=m;o=k;p=m;while(1){q=o;r=ag(d[q]|d[q+1|0]<<8|d[q+2|0]<<16|d[q+3|0]<<24|0,1540483477)|0;q=(ag(r>>>24^r,1540483477)|0)^(ag(n,1540483477)|0);r=o+4|0;s=p-4|0;if(s>>>0>3>>>0){n=q;o=r;p=s}else{t=q;u=r;v=s;break}}}else{t=m;u=k;v=m}if((v|0)==1){w=t;x=4125}else if((v|0)==2){y=t;x=4124}else if((v|0)==3){y=d[u+2|0]<<16^t;x=4124}else{z=t}if((x|0)==4124){w=d[u+1|0]<<8^y;x=4125}if((x|0)==4125){z=ag(d[u]^w,1540483477)|0}w=ag(z>>>13^z,1540483477)|0;z=w>>>15^w;w=f+4|0;c[w>>2]=z;u=e+4|0;y=c[u>>2]|0;t=(y|0)==0;L5310:do{if(t){A=0}else{v=y-1|0;m=(v&y|0)!=0;if(m){B=(z>>>0)%(y>>>0)|0}else{B=z&v}k=c[(c[e>>2]|0)+(B<<2)>>2]|0;if((k|0)==0){A=B;break}p=c[k>>2]|0;if((p|0)==0){A=B;break}k=i+1|0;o=f+16|0;n=f+12|0;s=p;L5318:while(1){p=c[s+4>>2]|0;if(m){C=(p>>>0)%(y>>>0)|0}else{C=p&v}if((C|0)!=(B|0)){A=B;break L5310}p=s+8|0;r=p;q=a[p]|0;p=q&255;if((p&1|0)==0){D=p>>>1}else{D=c[s+12>>2]|0}if(j){E=l>>>1}else{E=c[n>>2]|0}L5333:do{if((D|0)==(E|0)){p=(q&1)==0;if(p){F=r+1|0}else{F=c[s+16>>2]|0}if(h){G=k}else{G=c[o>>2]|0}if(!p){if((A0(F|0,G|0,D|0)|0)==0){H=s;I=0;x=4171;break L5318}else{break}}if((D|0)==0){H=s;I=0;x=4172;break L5318}else{J=G;K=F;L=D}while(1){if((a[K]|0)!=(a[J]|0)){break L5333}p=L-1|0;if((p|0)==0){H=s;I=0;x=4173;break L5318}else{J=J+1|0;K=K+1|0;L=p}}}}while(0);r=c[s>>2]|0;if((r|0)==0){A=B;break L5310}else{s=r}}if((x|0)==4171){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}else if((x|0)==4172){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}else if((x|0)==4173){M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}}}while(0);x=e+12|0;O=+(((c[x>>2]|0)+1|0)>>>0>>>0);P=+g[e+16>>2];do{if(O>+(y>>>0>>>0)*P|t){if(y>>>0>2>>>0){Q=(y-1&y|0)!=0|0}else{Q=1}B=Q|y<<1;L=~~+af(O/P);rx(e,B>>>0<L>>>0?L:B);B=c[u>>2]|0;L=c[w>>2]|0;K=B-1|0;if((K&B|0)==0){R=L&K;S=B;break}else{R=(L>>>0)%(B>>>0)|0;S=B;break}}else{R=A;S=y}}while(0);y=e|0;A=c[(c[y>>2]|0)+(R<<2)>>2]|0;do{if((A|0)==0){w=e+8|0;u=w|0;Q=f|0;c[Q>>2]=c[u>>2];c[u>>2]=f;c[(c[y>>2]|0)+(R<<2)>>2]=w;w=c[Q>>2]|0;if((w|0)==0){break}Q=c[w+4>>2]|0;w=S-1|0;if((w&S|0)==0){T=Q&w}else{T=(Q>>>0)%(S>>>0)|0}c[(c[y>>2]|0)+(T<<2)>>2]=f}else{Q=A|0;c[f>>2]=c[Q>>2];c[Q>>2]=f}}while(0);c[x>>2]=(c[x>>2]|0)+1;H=f;I=1;M=b|0;c[M>>2]=H;N=b+4|0;a[N]=I;return}function rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;do{if((b|0)==1){d=2}else{if((b-1&b|0)==0){d=b;break}d=tz(b)|0}}while(0);b=c[a+4>>2]|0;if(d>>>0>b>>>0){ry(a,d);return}if(d>>>0>=b>>>0){return}do{if(b>>>0>2>>>0){if((b-1&b|0)!=0){e=4183;break}f=1<<32-(A4(~~+af(+((c[a+12>>2]|0)>>>0>>>0)/+g[a+16>>2])-1|0)|0)}else{e=4183}}while(0);if((e|0)==4183){f=tz(~~+af(+((c[a+12>>2]|0)>>>0>>>0)/+g[a+16>>2]))|0}e=d>>>0<f>>>0?f:d;if(e>>>0>=b>>>0){return}ry(a,e);return}function ry(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=(d|0)!=0;if(e){f=AR(d<<2)|0}else{f=0}g=b|0;h=c[g>>2]|0;c[g>>2]=f;if((h|0)!=0){AT(h)}c[b+4>>2]=d;if(e){i=0}else{return}do{c[(c[g>>2]|0)+(i<<2)>>2]=0;i=i+1|0;}while(i>>>0<d>>>0);i=b+8|0;b=c[i>>2]|0;if((b|0)==0){return}e=c[b+4>>2]|0;h=d-1|0;f=(h&d|0)!=0;if(f){j=(e>>>0)%(d>>>0)|0}else{j=e&h}c[(c[g>>2]|0)+(j<<2)>>2]=i;i=b|0;e=c[i>>2]|0;if((e|0)==0){return}else{k=b;l=j;m=i;n=e}L5416:while(1){e=k;i=m;j=n;L5418:while(1){o=j;while(1){b=c[o+4>>2]|0;if(f){p=(b>>>0)%(d>>>0)|0}else{p=b&h}if((p|0)==(l|0)){break}q=(c[g>>2]|0)+(p<<2)|0;if((c[q>>2]|0)==0){break L5418}b=o|0;r=c[b>>2]|0;L5428:do{if((r|0)==0){s=b;t=0}else{u=o+8|0;v=a[u]|0;w=v&255;x=(w&1|0)==0;y=w>>>1;w=u+1|0;u=o+16|0;z=o+12|0;A=b;B=r;while(1){if(x){C=y}else{C=c[z>>2]|0}D=B+8|0;E=a[D]|0;F=E&255;if((F&1|0)==0){G=F>>>1}else{G=c[B+12>>2]|0}if((C|0)!=(G|0)){s=A;t=B;break L5428}F=(v&1)==0;if(F){H=w}else{H=c[u>>2]|0}if((E&1)==0){I=D+1|0}else{I=c[B+16>>2]|0}do{if(F){if((C|0)==0){break}else{J=I;K=H;L=C}while(1){if((a[K]|0)!=(a[J]|0)){s=A;t=B;break L5428}D=L-1|0;if((D|0)==0){break}else{J=J+1|0;K=K+1|0;L=D}}}else{if((A0(H|0,I|0,C|0)|0)!=0){s=A;t=B;break L5428}}}while(0);F=B|0;D=c[F>>2]|0;if((D|0)==0){s=F;t=0;break}else{A=F;B=D}}}}while(0);c[i>>2]=t;c[s>>2]=c[c[(c[g>>2]|0)+(p<<2)>>2]>>2];c[c[(c[g>>2]|0)+(p<<2)>>2]>>2]=o;r=c[i>>2]|0;if((r|0)==0){M=4237;break L5416}else{o=r}}r=o|0;b=c[r>>2]|0;if((b|0)==0){M=4233;break L5416}else{e=o;i=r;j=b}}c[q>>2]=e;j=o|0;i=c[j>>2]|0;if((i|0)==0){M=4235;break}else{k=o;l=p;m=j;n=i}}if((M|0)==4237){return}else if((M|0)==4233){return}else if((M|0)==4235){return}}function rz(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=f;h=a[f]|0;i=(h&1)==0;if(i){j=g+1|0}else{j=c[f+8>>2]|0}k=h&255;h=(k&1|0)==0;if(h){l=k>>>1}else{l=c[f+4>>2]|0}if(l>>>0>3>>>0){m=l;n=j;o=l;while(1){p=n;q=ag(d[p]|d[p+1|0]<<8|d[p+2|0]<<16|d[p+3|0]<<24|0,1540483477)|0;p=(ag(q>>>24^q,1540483477)|0)^(ag(m,1540483477)|0);q=n+4|0;r=o-4|0;if(r>>>0>3>>>0){m=p;n=q;o=r}else{s=p;t=q;u=r;break}}}else{s=l;t=j;u=l}if((u|0)==3){v=d[t+2|0]<<16^s;w=4248}else if((u|0)==1){x=s;w=4249}else if((u|0)==2){v=s;w=4248}else{y=s}if((w|0)==4248){x=d[t+1|0]<<8^v;w=4249}if((w|0)==4249){y=ag(d[t]^x,1540483477)|0}x=ag(y>>>13^y,1540483477)|0;y=x>>>15^x;x=c[e+4>>2]|0;L5481:do{if((x|0)!=0){t=x-1|0;w=(t&x|0)!=0;if(w){z=(y>>>0)%(x>>>0)|0}else{z=y&t}v=c[(c[e>>2]|0)+(z<<2)>>2]|0;if((v|0)==0){break}s=c[v>>2]|0;if((s|0)==0){break}v=g+1|0;u=f+8|0;l=f+4|0;L5489:do{if(w){j=s;while(1){if((((c[j+4>>2]|0)>>>0)%(x>>>0)|0|0)!=(z|0)){break L5481}o=j+8|0;n=o;m=a[o]|0;o=m&255;if((o&1|0)==0){A=o>>>1}else{A=c[j+12>>2]|0}if(h){B=k>>>1}else{B=c[l>>2]|0}L5501:do{if((A|0)==(B|0)){o=(m&1)==0;if(o){C=n+1|0}else{C=c[j+16>>2]|0}if(i){D=v}else{D=c[u>>2]|0}if(!o){if((A0(C|0,D|0,A|0)|0)==0){E=j;break L5489}else{break}}if((A|0)==0){E=j;break L5489}else{F=D;G=C;H=A}while(1){if((a[G]|0)!=(a[F]|0)){break L5501}o=H-1|0;if((o|0)==0){E=j;break L5489}else{F=F+1|0;G=G+1|0;H=o}}}}while(0);j=c[j>>2]|0;if((j|0)==0){break L5481}}}else{j=s;while(1){if((c[j+4>>2]&t|0)!=(z|0)){break L5481}n=j+8|0;m=n;o=a[n]|0;n=o&255;if((n&1|0)==0){I=n>>>1}else{I=c[j+12>>2]|0}if(h){J=k>>>1}else{J=c[l>>2]|0}L5528:do{if((I|0)==(J|0)){n=(o&1)==0;if(n){K=m+1|0}else{K=c[j+16>>2]|0}if(i){L=v}else{L=c[u>>2]|0}if(!n){if((A0(K|0,L|0,I|0)|0)==0){E=j;break L5489}else{break}}if((I|0)==0){E=j;break L5489}else{M=L;N=K;O=I}while(1){if((a[N]|0)!=(a[M]|0)){break L5528}n=O-1|0;if((n|0)==0){E=j;break L5489}else{M=M+1|0;N=N+1|0;O=n}}}}while(0);j=c[j>>2]|0;if((j|0)==0){break L5481}}}}while(0);c[b>>2]=E;return}}while(0);c[b>>2]=0;return}function rA(){a[18202328]=14;a[18202329]=a[86152]|0;a[18202330]=a[86153]|0;a[18202331]=a[86154]|0;a[18202332]=a[86155]|0;a[18202333]=a[86156]|0;a[18202334]=a[86157]|0;a[18202335]=a[86158]|0;a[18202336]=0;bh(334,18202328,r|0)|0;A2(875120|0,0|0,16|0);g[218784]=1.0;bh(268,875120,r|0)|0;return}function rB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=d;h=a[g]|0;j=h&255;if((j&1|0)==0){k=j>>>1;l=d+4|0}else{j=d+4|0;k=c[j>>2]|0;l=j}j=i;i=i+((k*3|0)+1)|0;i=i+7&-8;k=d+1|0;m=e;n=e+1|0;o=e+8|0;p=e+4|0;e=d+8|0;d=j;q=0;r=h;while(1){h=r&255;if((h&1|0)==0){s=h>>>1}else{s=c[l>>2]|0}if(q>>>0>=s>>>0){break}if((r&1)==0){t=k}else{t=c[e>>2]|0}h=a[t+q|0]|0;u=a[m]|0;v=u&255;if((v&1|0)==0){w=v>>>1}else{w=c[p>>2]|0}do{if((w|0)==0){x=4320}else{if((u&1)==0){y=n}else{y=c[o>>2]|0}v=ba(y|0,h&255|0,w|0)|0;if((v|0)==0){x=4320;break}if((v-y|0)==-1){x=4320;break}v=h<<24>>24;bs(d|0,86104,(z=i,i=i+8|0,c[z>>2]=v,z)|0)|0;i=z;A=d+3|0}}while(0);if((x|0)==4320){x=0;a[d]=h;A=d+1|0}d=A;q=q+1|0;r=a[g]|0}a[d]=0;d=A1(j|0)|0;if(d>>>0>4294967279>>>0){tB(0)}if(d>>>0<11>>>0){a[b]=d<<1&255;B=b+1|0;A$(B|0,j|0,d)|0;C=B+d|0;a[C]=0;i=f;return}else{g=d+16&-16;r=AR(g)|0;c[b+8>>2]=r;c[b>>2]=g|1;c[b+4>>2]=d;B=r;A$(B|0,j|0,d)|0;C=B+d|0;a[C]=0;i=f;return}}function rC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=a[d]|0;if((e&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}g=e&255;e=(g&1|0)==0;if(e){h=g>>>1}else{h=c[d+4>>2]|0}i=a[b]|0;j=i&255;k=(j&1|0)==0;if(k){l=j>>>1}else{l=c[b+4>>2]|0}if((i&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}i=m+l|0;L5604:do{if((h|0)==0|(l|0)<(h|0)){n=i}else{o=h-1|0;p=m+o|0;q=f+o|0;if((o|0)==(l|0)){n=i;break}o=a[q]|0;r=i;while(1){s=r-1|0;if((a[s]|0)==o<<24>>24){t=q;u=s;do{if((t|0)==(f|0)){n=u;break L5604}u=u-1|0;t=t-1|0;}while((a[u]|0)==(a[t]|0))}if((p|0)==(s|0)){n=i;break}else{r=s}}}}while(0);if((h|0)!=0&(n|0)==(i|0)){v=-1}else{v=n-m|0}if(k){w=j>>>1}else{w=c[b+4>>2]|0}if(e){x=g>>>1;y=w-x|0;z=(v|0)==(y|0);return z|0}else{x=c[d+4>>2]|0;y=w-x|0;z=(v|0)==(y|0);return z|0}return 0}function rD(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0;f=i;i=i+96|0;g=f|0;j=(c|0)>0;if(j){k=e?d:w;e=k==w;l=0;m=-1;while(1){if((l|0)>0){n=0;o=k;p=e;do{if(p){q=d}else{q=o*d/(o+d)}o=q+1.0;n=n+1|0;p=o==w}while((n|0)<(l|0));n=m+2|0;if(p){r=d;s=1.0;t=n}else{u=o;v=n;x=4373}}else{if(e){r=d;s=1.0;t=1}else{u=k;v=1;x=4373}}if((x|0)==4373){x=0;y=u*d/(u+d);r=y;s=y/d;t=v}if((t|0)<(c|0)){y=s;z=r;n=t;while(1){A=z+1.0;B=A*d/(A+d);C=y/A*B;D=n+1|0;if((D|0)<(c|0)){y=C;z=B;n=D}else{E=C;break}}}else{E=s}h[g+(l<<3)>>3]=E;n=l+1|0;if((n|0)<(c|0)){l=n;m=m+1|0}else{break}}}m=1<<c;if((m|0)<=0){i=f;return}E=+(m-1|0);if(j){F=0}else{j=0;do{b[a+(j<<1)>>1]=~~(E*0.0+.5);j=j+1|0;}while((j|0)<(m|0));i=f;return}do{j=F;s=0.0;l=0;while(1){G=s+ +(j&1|0)*+h[g+(l<<3)>>3];t=l+1|0;if((t|0)<(c|0)){j=j>>1;s=G;l=t}else{break}}b[a+(F<<1)>>1]=~~(E*G+.5);F=F+1|0;}while((F|0)<(m|0));i=f;return}function rE(b){b=b|0;if(!(a[90608]|0)){rD(18201304,8,2.2,0);rD(18201816,8,2.0,1);a[90608]=1}c[b+52>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b>>2]=0;c[b+8>>2]=0;A2(b+28|0,0,20);c[b+12>>2]=1;c[b+48>>2]=2;c[b+4>>2]=c[57876];a[b+24|0]=1;return}function rF(a,b){a=a|0;b=b|0;c[a+52>>2]=b;return}function rG(b){b=b|0;c[b+16>>2]=0;c[b+20>>2]=0;c[b>>2]=0;c[b+8>>2]=0;A2(b+28|0,0,20);c[b+12>>2]=1;c[b+48>>2]=2;c[b+4>>2]=c[57876];a[b+24|0]=1;return}function rH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=d&1;d=b+44|0;f=(c[d>>2]|0)!=0;g=(e|0)==0;if(!(f|g)){c[b+48>>2]=0;c[b+4>>2]=c[231504+(c[b+28>>2]<<2)>>2];a[b+24|0]=0;c[b+20>>2]=0;c[d>>2]=e;return}if(!(f&g)){c[d>>2]=e;return}c[b+48>>2]=2;c[b+4>>2]=c[231504+(c[b+40>>2]<<2)>>2];c[d>>2]=e;return}function rI(a,b){a=a|0;b=b|0;var d=0,e=0;d=b>>>4&15;c[a+28>>2]=d;e=b&15;c[a+32>>2]=e;b=c[a+48>>2]|0;if((b|0)==0){c[a+4>>2]=c[231504+(d<<2)>>2];return}else if((b|0)==1){c[a+4>>2]=c[231504+(e<<2)>>2];return}else{return}}function rJ(a,b){a=a|0;b=b|0;var d=0;c[a+36>>2]=b>>>4&15;d=b&15;c[a+40>>2]=d;if((c[a+48>>2]|0)!=2){return}c[a+4>>2]=c[231504+(d<<2)>>2];return}function rK(a){a=a|0;return c[a+16>>2]|0}function rL(b){b=b|0;c[b+4>>2]=0;c[b+8>>2]=0;a[b|0]=1;c[b+12>>2]=13;c[b+16>>2]=10;return}function rM(a){a=a|0;c[a+4>>2]=0;c[a+8>>2]=0;return}function rN(b,c){b=b|0;c=c|0;a[b|0]=c&1;return}function rO(d){d=d|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0.0,af=0,ah=0.0,ai=0.0,aj=0.0,ak=0.0,al=0.0,am=0.0,an=0.0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0;f=i;i=i+808|0;g=f|0;j=f+800|0;if(a[90528]|0){k=d|0;a[k]=1;l=d+12|0;m=c[l>>2]|0;n=d+24|0;o=d+28|0;p=d+16|0;q=c[p>>2]|0;r=q&112;s=q>>>5;t=s&4;u=d+32|0;v=d+100|0;c[v>>2]=0;w=d+36|0;x=w;A2(x|0,0,28);c[n>>2]=247;y=m&247;c[o>>2]=y;z=m&7;A=r|z;B=A|t;C=B^7;c[u>>2]=C;D=b[2993494]|0;E=D&65535;F=d+64|0;c[F>>2]=E;G=d+4|0;H=G;A2(H|0,0,20);A2(x|0,0,28);I=d+84|0;J=c[I>>2]|0;K=b[4828503]|0;L=K&65535;M=c[284323]|0;N=L+J|0;O=M-N|0;P=ag(O,O)|0;Q=P>>>1;R=d+80|0;c[R>>2]=Q;S=d+92|0;c[S>>2]=40;T=d+88|0;c[T>>2]=15;U=d+96|0;c[U>>2]=1448;c[o>>2]=0;c[u>>2]=7;i=f;return}V=AS(262144)|0;X=V;Y=g|0;Z=j|0;_=g|0;$=0;do{aa=c[100192+($*120|0)>>2]|0;ab=aa|0;ac=+h[ab>>3];af=aa+8|0;ah=+h[af>>3];ai=+h[100248+($*120|0)>>3];aj=ai*(+h[100224+($*120|0)>>3]- +h[100232+($*120|0)>>3]);ak=(aj<ah?ah:aj)-ac;ah=1.0/ak;al=ah*65535.0;am=ah*1073741823.0;an=ah*2147483647.0;c[1137288+(ag($,8523816)|0)>>2]=~~al;c[1137300+(ag($,8523816)|0)>>2]=~~(ah*16384.0*+h[100200+($*120|0)>>3]);c[1137304+(ag($,8523816)|0)>>2]=~~(al*(+h[100208+($*120|0)>>3]-ac));ao=1137292+(ag($,8523816)|0)|0;c[ao>>2]=~~(al*(aj-ac)+.5);c[1137296+(ag($,8523816)|0)>>2]=~~(ak*8192.0*(+h[100256+($*120|0)>>3]/(ai*2.0)*+h[100272+($*120|0)>>3]*1.0e-6/+h[100216+($*120|0)>>3])+.5);ap=c[100196+($*120|0)>>2]|0;if((ap|0)>0){aq=0;ar=0;while(1){as=aa+(aq<<4)|0;at=ar-1+ap|0;h[g+(at<<4)>>3]=+(~~((al*(+h[aa+(aq<<4)+8>>3]- +h[as>>3])+65536.0)*.5+.5)|0);h[g+(at<<4)+8>>3]=an*(+h[as>>3]-ac);as=aq+1|0;at=~aq;if((as|0)<(ap|0)){aq=as;ar=at}else{break}}}ar=ap-1|0;aq=g+(ar<<4)|0;if(+h[aq>>3]>=65536.0){h[g+(ap-2<<4)>>3]=65535.0;h[aq>>3]=65535.0}c[Z>>2]=X;rP(Y,g+(ar<<4)|0,j,1.0);at=~~+h[_>>3];as=1137308+(ag($,8523816)|0)|0;c[as>>2]=at;au=~~+h[aq>>3];aq=1137312+(ag($,8523816)|0)|0;c[aq>>2]=au;if((at|0)>0){av=(at|0)>1?at:1;aw=av<<2;A2(V|0,0,aw|0);ax=av;ay=V+aw|0}else{ax=0;ay=X}if((ax|0)>(au|0)){az=ax}else{aw=(c[ay>>2]<<1)-(c[X+(ax+1<<2)>>2]|0)|0;av=ax;while(1){aA=X+(av<<2)|0;aB=c[aA>>2]|0;c[aA>>2]=aB-aw<<12&-65536|aB>>15;if((av|0)<(au|0)){aw=aB;av=av+1|0}else{break}}az=au+1|0}if((az|0)<65536){av=az<<2;A2(V+av|0,0,262144-av|0);aC=0;aD=at}else{aC=0;aD=at}while(1){av=aC<<4;aw=av+128|0;ap=aD;aB=0;aA=aD;while(1){aE=c[ao>>2]|0;aF=aE-aB|0;aG=(aF|0)<0?0:aF;aF=ag((ag(aG,aG)|0)>>>12,av)|0;aG=aA;aH=c[aq>>2]|0;aI=ap;while(1){aJ=c[X+(aI<<2)>>2]|0;aK=aJ&65535;aL=aJ>>16;aJ=(aI<<1)-65536+aK|0;if((aJ|0)>65535){aM=65535}else{aM=(aJ|0)<0?0:aJ}aJ=aE-aK|0;aK=(aJ|0)<0?0:aJ;aJ=aE-aM|0;aN=(aJ|0)<0?0:aJ;aJ=(ag((ag(aK,aK)|0)>>>12,aw)|0)-aF-((ag(aN,aN)|0)>>>5)|0;aO=(aJ|0)/((ag(aN,aL+2048|0)|0)-(ag((ag(aK,aL)|0)>>7,aw)|0)>>15|0)|0;aL=aI-aO|0;if((aO|0)==0){aP=aL;break}aO=(aJ|0)<0;aJ=aO?aH:aI;aK=aO?aI:aG;if((aL|0)>(aK|0)&(aL|0)<(aJ|0)){aG=aK;aH=aJ;aI=aL;continue}aL=aK+aJ>>1;if((aL|0)==(aK|0)){aP=aK;break}else{aG=aK;aH=aJ;aI=aL}}b[3889836+(ag($,8523816)|0)+(aC<<17)+(aB<<1)>>1]=aM&65535;aI=aB+1|0;if((aI|0)>=65536){break}ap=aP;aB=aI;aA=c[as>>2]|0}aA=aC+1|0;if((aA|0)>=16){aQ=0;aR=0;break}aC=aA;aD=c[as>>2]|0}while(1){at=aQ+2|0;au=at<<7;aA=at<<16;aB=c[as>>2]|0;ap=au+128|0;aw=aB;av=0;aI=aB;while(1){aB=c[ao>>2]|0;aH=aB-((av|0)/(at|0)|0)|0;aG=(aH|0)<0?0:aH;aH=ag((ag(aG,aG)|0)>>>12,au)|0;aG=aI;aF=c[aq>>2]|0;aE=aw;while(1){aL=c[X+(aE<<2)>>2]|0;aJ=aL&65535;aK=aL>>16;aL=(aE<<1)-65536+aJ|0;if((aL|0)>65535){aS=65535}else{aS=(aL|0)<0?0:aL}aL=aB-aJ|0;aJ=(aL|0)<0?0:aL;aL=aB-aS|0;aO=(aL|0)<0?0:aL;aL=(ag((ag(aJ,aJ)|0)>>>12,ap)|0)-aH-((ag(aO,aO)|0)>>>5)|0;aN=(aL|0)/((ag(aO,aK+2048|0)|0)-(ag((ag(aJ,aK)|0)>>7,ap)|0)>>15|0)|0;aK=aE-aN|0;if((aN|0)==0){aT=aK;break}aN=(aL|0)<0;aL=aN?aF:aE;aJ=aN?aE:aG;if((aK|0)>(aJ|0)&(aK|0)<(aL|0)){aG=aJ;aF=aL;aE=aK;continue}aK=aJ+aL>>1;if((aK|0)==(aJ|0)){aT=aJ;break}else{aG=aJ;aF=aL;aE=aK}}b[1268396+(ag($,8523816)|0)+(av+aR<<1)>>1]=aS&65535;aE=av+1|0;if((aE|0)>=(aA|0)){break}aw=aT;av=aE;aI=c[as>>2]|0}aI=aQ+1|0;if((aI|0)<5){aQ=aI;aR=aA+aR|0}else{aU=0;aV=1;aW=0;break}}while(1){aI=(aU<<10|0)/6|0;av=(aU|0)==0?1:aU;L5747:do{if((aV|0)>0){aw=c[as>>2]|0;ap=aI+128|0;au=aw;at=0;aE=aw;while(1){aw=c[ao>>2]|0;aF=aw-((at|0)/(av|0)|0)|0;aG=(aF|0)<0?0:aF;aF=ag((ag(aG,aG)|0)>>>12,aI)|0;aG=aE;aH=c[aq>>2]|0;aB=au;while(1){aK=c[X+(aB<<2)>>2]|0;aL=aK&65535;aJ=aK>>16;aK=(aB<<1)-65536+aL|0;if((aK|0)>65535){aX=65535}else{aX=(aK|0)<0?0:aK}aK=aw-aL|0;aL=(aK|0)<0?0:aK;aK=aw-aX|0;aN=(aK|0)<0?0:aK;aK=(ag((ag(aL,aL)|0)>>>12,ap)|0)-aF-((ag(aN,aN)|0)>>>5)|0;aO=(aK|0)/((ag(aN,aJ+2048|0)|0)-(ag((ag(aL,aJ)|0)>>7,ap)|0)>>15|0)|0;aJ=aB-aO|0;if((aO|0)==0){aY=aJ;break}aO=(aK|0)<0;aK=aO?aH:aB;aL=aO?aB:aG;if((aJ|0)>(aL|0)&(aJ|0)<(aK|0)){aG=aL;aH=aK;aB=aJ;continue}aJ=aL+aK>>1;if((aJ|0)==(aL|0)){aY=aL;break}else{aG=aL;aH=aK;aB=aJ}}b[5986988+(ag($,8523816)|0)+(at+aW<<1)>>1]=aX&65535;aB=at+1|0;if((aB|0)>=(aV|0)){break L5747}au=aY;at=aB;aE=c[as>>2]|0}}}while(0);aI=aW+aV|0;av=aU+1|0;if((av|0)<8){aU=av;aV=av<<16;aW=aI}else{aZ=0;break}}do{b[1137324+(ag($,8523816)|0)+(aZ<<1)>>1]=c[X+(aZ<<2)>>2]&65535;aZ=aZ+1|0;}while((aZ|0)<65536);c[1137320+(ag($,8523816)|0)>>2]=~~(am*(+h[af>>3]- +h[ab>>3]));c[1137316+(ag($,8523816)|0)>>2]=~~(am*(+h[aa+(ar<<4)+8>>3]- +h[aa+(ar<<4)>>3]));as=9657006+(ag($,8523816)|0)|0;rD(as,11,+h[100296+($*120|0)>>3],(a[100304+($*120|0)|0]&1)!=0);an=+h[100280+($*120|0)>>3];ai=+h[100288+($*120|0)>>3];as=0;do{aq=9657006+(ag($,8523816)|0)+(as<<1)|0;b[aq>>1]=~~(al*(an+ai*+(e[aq>>1]|0|0)*.00048828125-ac)+.5);as=as+1|0;}while((as|0)<2048);$=$+1|0;}while(($|0)<2);if((V|0)!=0){AU(V)}ac=+(c[284322]|0);ai=ac*+h[12454];an=ac*10.87;V=0;do{b[875144+(V<<1)>>1]=~~(an- +W(+(V|0)*65536.0)-ai+.5);V=V+1|0;}while((V|0)<65536);ai=ac*.5*1.0e-6/4.7e-10*2.4336e-7;V=0;do{an=+ae(+ad((+(V|0)/ac+ -1.31)/.052)+1.0);b[1006216+(V<<1)>>1]=~~(an*ai*an);V=V+1|0;}while((V|0)<65536);a[90528]=1;k=d|0;a[k]=1;l=d+12|0;m=c[l>>2]|0;n=d+24|0;o=d+28|0;p=d+16|0;q=c[p>>2]|0;r=q&112;s=q>>>5;t=s&4;u=d+32|0;v=d+100|0;c[v>>2]=0;w=d+36|0;x=w;A2(x|0,0,28);c[n>>2]=247;y=m&247;c[o>>2]=y;z=m&7;A=r|z;B=A|t;C=B^7;c[u>>2]=C;D=b[2993494]|0;E=D&65535;F=d+64|0;c[F>>2]=E;G=d+4|0;H=G;A2(H|0,0,20);A2(x|0,0,28);I=d+84|0;J=c[I>>2]|0;K=b[4828503]|0;L=K&65535;M=c[284323]|0;N=L+J|0;O=M-N|0;P=ag(O,O)|0;Q=P>>>1;R=d+80|0;c[R>>2]=Q;S=d+92|0;c[S>>2]=40;T=d+88|0;c[T>>2]=15;U=d+96|0;c[U>>2]=1448;c[o>>2]=0;c[u>>2]=7;i=f;return}function rP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;f=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=a+32|0;if((g|0)==(b|0)){i=f;return}j=c[d>>2]|0;d=g;g=a+48|0;k=a;while(1){a=k+16|0;l=+h[a>>3];m=+h[d>>3];do{if(l!=m){n=+h[k>>3];o=+h[g>>3];p=m==o;do{if(n==l){if(p){q=+h[d+8>>3];r=+h[k+24>>3];s=m-l;t=(q-r)/s;u=t;v=t;w=r;x=q;y=s;break}else{s=+h[k+24>>3];q=(+h[g+8>>3]-s)/(+h[g>>3]-l);r=+h[d+8>>3];t=m-l;u=q;v=((r-s)*3.0/t-q)*.5;w=s;x=r;y=t;break}}else{t=+h[d+8>>3];r=(t- +h[k+8>>3])/(m-n);if(p){s=+h[k+24>>3];q=m-l;u=((t-s)*3.0/q-r)*.5;v=r;w=s;x=t;y=q;break}else{q=+h[k+24>>3];u=(+h[g+8>>3]-q)/(o-l);v=r;w=q;x=t;y=m-l;break}}}while(0);o=(v+u-(x-w)*2.0/y)/(y*y);n=((u-v)/y-(l+m)*3.0*o)*.5;t=n*2.0;q=v-l*(l*3.0*o+t);r=l*(l*(l*o+n)+q);s=l+e;z=o*6.0;A=z*e*e*e;if(l>m){break}B=l*(s*o*3.0+t)*e+((o*e+n)*e+q)*e;q=(s*z+t)*e*e;t=r+(w-r);r=l;while(1){c[j+(~~r<<2)>>2]=~~((t<0.0?0.0:t)+.5);z=t+B;s=r+e;if(s>m){break}else{B=q+B;q=A+q;t=z;r=s}}}}while(0);p=d+16|0;if((p|0)==(b|0)){break}else{d=p;g=g+16|0;k=a}}i=f;return}function rQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a[b|0]=d&1;if(d){d=c[b+12>>2]|0;e=c[b+24>>2]|0;c[b+28>>2]=e&d;f=c[b+16>>2]|0;g=(f>>>5&4|f&112|d&15)^15;h=e;i=g&h;j=b+32|0;c[j>>2]=i;return}else{e=c[b+24>>2]|0;c[b+28>>2]=0;g=15;h=e;i=g&h;j=b+32|0;c[j>>2]=i;return}}function rR(a,b){a=a|0;b=b|0;c[a+100>>2]=b;A2(a+36|0,0,28);return}function rS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=d&15|240;c[b+24>>2]=e;if((a[b|0]&1)==0){c[b+28>>2]=0;f=15;g=f&e;h=b+32|0;c[h>>2]=g;return}else{d=c[b+12>>2]|0;c[b+28>>2]=d&e;i=c[b+16>>2]|0;f=(i>>>5&4|i&112|d&15)^15;g=f&e;h=b+32|0;c[h>>2]=g;return}}function rT(a){a=a|0;var b=0,d=0,f=0;A2(a+4|0,0,20);A2(a+36|0,0,28);b=c[a+100>>2]|0;d=e[9657006+(ag(b,8523816)|0)>>1]|0;f=(c[1137292+(ag(b,8523816)|0)>>2]|0)-(d+(c[a+84>>2]|0))|0;c[a+80>>2]=(ag(f,f)|0)>>>1;c[a+92>>2]=40;c[a+88>>2]=15;c[a+96>>2]=1448;f=c[a+24>>2]|0;c[a+28>>2]=0;c[a+32>>2]=f&15;return}function rU(a,b){a=a|0;b=+b;var d=0,f=0,g=0,h=0,i=0;d=c[a+100>>2]|0;f=~~(+(c[1137288+(ag(d,8523816)|0)>>2]|0)*b);c[a+84>>2]=f;g=c[a+4>>2]|0;h=e[9657006+(ag(d,8523816)|0)+(g<<1)>>1]|0;i=(c[1137292+(ag(d,8523816)|0)>>2]|0)-(h+f)|0;c[a+80>>2]=(ag(i,i)|0)>>>1;c[a+92>>2]=((g*82355|0)+82355|0)>>>11;return}function rV(a,b){a=a|0;b=b|0;var d=0,f=0,g=0;d=a+4|0;f=c[d>>2]&2040|b&7;c[d>>2]=f;d=c[a+100>>2]|0;b=e[9657006+(ag(d,8523816)|0)+(f<<1)>>1]|0;g=(c[1137292+(ag(d,8523816)|0)>>2]|0)-(b+(c[a+84>>2]|0))|0;c[a+80>>2]=(ag(g,g)|0)>>>1;c[a+92>>2]=((f*82355|0)+82355|0)>>>11;return}function rW(a,b){a=a|0;b=b|0;var d=0,f=0,g=0;d=a+4|0;f=c[d>>2]&7|b<<3&2040;c[d>>2]=f;d=c[a+100>>2]|0;b=e[9657006+(ag(d,8523816)|0)+(f<<1)>>1]|0;g=(c[1137292+(ag(d,8523816)|0)>>2]|0)-(b+(c[a+84>>2]|0))|0;c[a+80>>2]=(ag(g,g)|0)>>>1;c[a+92>>2]=((f*82355|0)+82355|0)>>>11;return}function rX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=d>>>4&15;c[b+8>>2]=e;c[b+88>>2]=e^15;c[b+96>>2]=c[90536+(e<<2)>>2];e=d&15;c[b+12>>2]=e;d=c[b+24>>2]|0;if((a[b|0]&1)==0){c[b+28>>2]=0;f=15;g=f&d;h=b+32|0;c[h>>2]=g;return}else{c[b+28>>2]=d&e;i=c[b+16>>2]|0;f=(i>>>5&4|i&112|e)^15;g=f&d;h=b+32|0;c[h>>2]=g;return}}function rY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;c[b+16>>2]=d&240;if((a[b|0]&1)==0){e=c[b+24>>2]|0;c[b+28>>2]=0;f=15;g=e}else{e=c[b+12>>2]|0;h=c[b+24>>2]|0;c[b+28>>2]=h&e;f=(d>>>5&4|d&112|e&15)^15;g=h}c[b+32>>2]=f&g;c[b+20>>2]=d&15;return}function rZ(a){a=a|0;return 255}function r_(a){a=a|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;d=a+4|0;st(d);st(a+148|0);st(a+292|0);rO(a+436|0);rL(a+540|0);e=a+620|0;c[e>>2]=0;f=a+624|0;c[f>>2]=0;c[a>>2]=0;g=a+292|0;sv(d,g);i=a+148|0;sv(i,d);sv(g,i);h[a+584>>3]=985248.0;c[a+592>>2]=0;c[a+596>>2]=1464154;c[a+600>>2]=0;b[a+608>>1]=0;b[a+610>>1]=0;i=c[e>>2]|0;if((i|0)!=0){AU(i)}i=c[f>>2]|0;if((i|0)==0){c[e>>2]=0;c[f>>2]=0;j=a+564|0;c[j>>2]=0;k=a+568|0;c[k>>2]=0;l=a+572|0;c[l>>2]=0;return}AU(i);c[e>>2]=0;c[f>>2]=0;j=a+564|0;c[j>>2]=0;k=a+568|0;c[k>>2]=0;l=a+572|0;c[l>>2]=0;return}function r$(a,d,e,f,g,i){a=a|0;d=+d;e=e|0;f=+f;g=+g;i=+i;var j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0;j=(e|0)==2;do{if((e&-2|0)==2){if(d*125.0/f>=16384.0){k=0;return k|0}do{if(g<0.0){if(4.0e4/f<.9){l=2.0e4;break}l=f*.9*.5}else{if(f*.9*.5<g){k=0}else{l=g;break}return k|0}}while(0);if(i<.9|i>1.0){k=0}else{m=l;break}return k|0}else{m=g}}while(0);h[a+584>>3]=d;c[a+592>>2]=e;g=d/f;c[a+596>>2]=~~(g*65536.0+.5);c[a+600>>2]=0;b[a+608>>1]=0;b[a+610>>1]=0;if((e-2|0)>>>0>1>>>0){e=a+620|0;n=c[e>>2]|0;if((n|0)!=0){AU(n)}n=a+624|0;o=c[n>>2]|0;if((o|0)!=0){AU(o)}c[e>>2]=0;c[n>>2]=0;k=1;return k|0}l=(1.0-m*2.0/f)*3.141592653589793;n=1;m=1.0;p=1.0;while(1){q=4.828390883547317/+(n|0);r=p*q*q;s=m+r;if(r<s*1.0e-6){break}else{n=n+1|0;m=s;p=r}}n=~~(88.37959861247398/(l*2.0*2.285)+.5);e=a+612|0;o=~~(g*+((n&1)+n|0))+1|1;c[e>>2]=o;n=1<<~~+af(+ae((j?285.0:51473.0)/g)/.6931471805599453);j=a+616|0;c[j>>2]=n;t=a+624|0;u=c[t>>2]|0;if((u|0)==0){v=o;w=n}else{AU(u);v=c[e>>2]|0;w=c[j>>2]|0}u=aX(ag(w,v)|0,2)|0;c[t>>2]=AS(K?-1:u)|0;if((w|0)>0){l=i*32768.0*(f/d)*3.141592653589793/3.141592653589793;u=0;n=w;w=v;while(1){v=(w|0)/2|0;o=(ag(w,u)|0)+v|0;d=+(u|0)/+(n|0);x=(w|0)/-2|0;if((x|0)>(v|0)){y=w;z=n}else{A=x;x=v;while(1){f=+(A|0)-d;i=f*3.141592653589793/g;p=f/+(x|0);if(+V(+p)>1.0){B=0.0}else{f=+W(1.0-p*p)*9.656781767094634*.5;v=1;p=1.0;m=1.0;while(1){r=f/+(v|0);q=m*r*r;C=p+q;if(q<C*1.0e-6){break}else{v=v+1|0;p=C;m=q}}B=C/s}if(+V(+i)<1.0e-6){D=1.0}else{D=+Z(i)/i}m=B*D*l;if(m<0.0){E=+af(m+-.5)}else{E=+U(m+.5)}b[(c[t>>2]|0)+(o+A<<1)>>1]=~~E;F=c[e>>2]|0;v=(F|0)/2|0;if((A|0)<(v|0)){A=A+1|0;x=v}else{break}}y=F;z=c[j>>2]|0}x=u+1|0;if((x|0)<(z|0)){u=x;n=z;w=y}else{break}}}y=a+620|0;w=c[y>>2]|0;if((w|0)==0){z=AS(65536)|0;c[y>>2]=z;G=0;H=z}else{G=0;H=w}while(1){b[H+(G<<1)>>1]=0;w=G+1|0;if((w|0)>=32768){break}G=w;H=c[y>>2]|0}c[a+604>>2]=0;k=1;return k|0}function r0(a){a=a|0;var b=0;b=c[a+620>>2]|0;if((b|0)!=0){AU(b)}b=c[a+624>>2]|0;if((b|0)==0){return}AU(b);return}function r1(a,b){a=a|0;b=b|0;c[a>>2]=b;su(a+4|0,b);su(a+148|0,b);su(a+292|0,b);rR(a+436|0,b);return}function r2(a){a=a|0;sx(a+4|0);sx(a+148|0);sx(a+292|0);rT(a+436|0);rM(a+540|0);c[a+564>>2]=0;c[a+568>>2]=0;return}function r3(a,b){a=a|0;b=b|0;var d=0,f=0;d=c[a+536>>2]|0;f=(ag((b<<16>>16)*3|0,c[1137300+(ag(d,8523816)|0)>>2]|0)|0)>>14;c[a+500>>2]=f+(e[5986988+(ag(d,8523816)|0)>>1]|0);return}function r4(a,b){a=a|0;b=b|0;var d=0;if((b|0)==27){d=sH(a+292|0)|0}else if((b|0)==26){d=rZ(a+561|0)|0}else if((b|0)==28){d=rK(a+376|0)|0}else if((b|0)==25){d=rZ(a+560|0)|0}else{d=c[a+564>>2]|0}return d|0}function r5(a,b,d){a=a|0;b=b|0;d=d|0;c[a+576>>2]=b;c[a+564>>2]=d;c[a+568>>2]=16384;if((c[a>>2]|0)==1){c[a+572>>2]=1;return}else{r6(a);return}}function r6(a){a=a|0;switch(c[a+576>>2]|0){case 1:{sD(a+4|0,c[a+564>>2]|0);break};case 11:{sw(a+148|0,c[a+564>>2]|0);break};case 19:{rI(a+376|0,c[a+564>>2]|0);break};case 21:{rV(a+436|0,c[a+564>>2]|0);break};case 17:{sF(a+292|0,c[a+564>>2]|0);break};case 12:{rI(a+232|0,c[a+564>>2]|0);break};case 14:{sC(a+292|0,c[a+564>>2]|0);break};case 22:{rW(a+436|0,c[a+564>>2]|0);break};case 9:{sE(a+148|0,c[a+564>>2]|0);break};case 20:{rJ(a+376|0,c[a+564>>2]|0);break};case 8:{sD(a+148|0,c[a+564>>2]|0);break};case 16:{sE(a+292|0,c[a+564>>2]|0);break};case 18:{sw(a+292|0,c[a+564>>2]|0);break};case 6:{rJ(a+88|0,c[a+564>>2]|0);break};case 15:{sD(a+292|0,c[a+564>>2]|0);break};case 0:{sC(a+4|0,c[a+564>>2]|0);break};case 10:{sF(a+148|0,c[a+564>>2]|0);break};case 3:{sF(a+4|0,c[a+564>>2]|0);break};case 23:{rX(a+436|0,c[a+564>>2]|0);break};case 2:{sE(a+4|0,c[a+564>>2]|0);break};case 4:{sw(a+4|0,c[a+564>>2]|0);break};case 24:{rY(a+436|0,c[a+564>>2]|0);break};case 7:{sC(a+148|0,c[a+564>>2]|0);break};case 5:{rI(a+88|0,c[a+564>>2]|0);break};case 13:{rJ(a+232|0,c[a+564>>2]|0);break};default:{}}c[a+572>>2]=0;return}function r7(b){b=b|0;A2(b|0,0,48);c[b+48>>2]=255;c[b+52>>2]=0;c[b+64>>2]=8388607;c[b+76>>2]=0;c[b+88>>2]=0;c[b+100>>2]=0;c[b+112>>2]=0;c[b+124>>2]=0;c[b+136>>2]=9;c[b+148>>2]=0;c[b+160>>2]=1;c[b+172>>2]=0;c[b+184>>2]=2;a[b+196|0]=1;c[b+200>>2]=0;c[b+56>>2]=0;c[b+68>>2]=8388607;c[b+80>>2]=0;c[b+92>>2]=0;c[b+104>>2]=0;c[b+116>>2]=0;c[b+128>>2]=0;c[b+140>>2]=9;c[b+152>>2]=0;c[b+164>>2]=1;c[b+176>>2]=0;c[b+188>>2]=2;a[b+197|0]=1;c[b+204>>2]=0;c[b+60>>2]=0;c[b+72>>2]=8388607;c[b+84>>2]=0;c[b+96>>2]=0;c[b+108>>2]=0;c[b+120>>2]=0;c[b+132>>2]=0;c[b+144>>2]=9;c[b+156>>2]=0;c[b+168>>2]=1;c[b+180>>2]=0;c[b+192>>2]=2;a[b+198|0]=1;c[b+208>>2]=0;return}function r8(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,i=0;f=b+48|0;A2(b|0,0,48);c[f>>2]=255;c[b+52>>2]=0;c[b+64>>2]=8388607;c[b+76>>2]=0;c[b+88>>2]=0;c[b+100>>2]=0;c[b+112>>2]=0;c[b+124>>2]=0;c[b+136>>2]=9;c[b+148>>2]=0;c[b+160>>2]=1;c[b+172>>2]=0;c[b+184>>2]=2;a[b+196|0]=1;c[b+200>>2]=0;c[b+56>>2]=0;c[b+68>>2]=8388607;c[b+80>>2]=0;c[b+92>>2]=0;c[b+104>>2]=0;c[b+116>>2]=0;c[b+128>>2]=0;c[b+140>>2]=9;c[b+152>>2]=0;c[b+164>>2]=1;c[b+176>>2]=0;c[b+188>>2]=2;a[b+197|0]=1;c[b+204>>2]=0;c[b+60>>2]=0;c[b+72>>2]=8388607;c[b+84>>2]=0;c[b+96>>2]=0;c[b+108>>2]=0;c[b+120>>2]=0;c[b+132>>2]=0;c[b+144>>2]=9;c[b+156>>2]=0;c[b+168>>2]=1;c[b+180>>2]=0;c[b+192>>2]=2;a[b+198|0]=1;c[b+208>>2]=0;g=0;h=0;while(1){i=d+4+(h*144|0)+16|0;a[b+g|0]=c[i>>2]&255;a[b+(g+1)|0]=(c[i>>2]|0)>>>8&255;i=d+4+(h*144|0)+20|0;a[b+(g+2)|0]=c[i>>2]&255;a[b+(g+3)|0]=(c[i>>2]|0)>>>8&255;a[b+(g+4)|0]=(((c[d+4+(h*144|0)+56>>2]|0)!=0?8:0)|c[d+4+(h*144|0)+52>>2]<<4|((c[d+4+(h*144|0)+60>>2]|0)!=0?4:0)|((c[d+4+(h*144|0)+64>>2]|0)!=0?2:0)|(c[d+4+(h*144|0)+128>>2]|0)!=0)&255;a[b+(g+5)|0]=(c[d+4+(h*144|0)+112>>2]<<4|c[d+4+(h*144|0)+116>>2])&255;a[b+(g+6)|0]=(c[d+4+(h*144|0)+120>>2]<<4|c[d+4+(h*144|0)+124>>2])&255;i=h+1|0;if((i|0)<3){g=g+7|0;h=i}else{break}}h=d+440|0;a[b+21|0]=c[h>>2]&7;a[b+22|0]=(c[h>>2]|0)>>>3&255;a[b+23|0]=(c[d+444>>2]<<4|c[d+448>>2])&255;a[b+24|0]=(c[d+456>>2]|c[d+452>>2])&255;a[b+25|0]=(rZ(d+560|0)|0)&255;a[b+26|0]=(rZ(d+561|0)|0)&255;a[b+27|0]=(sH(d+292|0)|0)&255;a[b+28|0]=(rK(d+376|0)|0)&255;A2(b+29|0,0,3);c[b+32>>2]=c[d+564>>2];c[b+36>>2]=c[d+568>>2];c[b+40>>2]=c[d+572>>2];c[b+44>>2]=c[d+576>>2];c[f>>2]=c[d+460>>2];f=0;do{c[b+52+(f<<2)>>2]=c[d+4+(f*144|0)+8>>2];c[b+64+(f<<2)>>2]=c[d+4+(f*144|0)+24>>2];c[b+76+(f<<2)>>2]=c[d+4+(f*144|0)+28>>2];c[b+88+(f<<2)>>2]=c[d+4+(f*144|0)+32>>2];c[b+100+(f<<2)>>2]=e[d+4+(f*144|0)+48>>1]|0;c[b+112+(f<<2)>>2]=c[d+4+(f*144|0)+72>>2];c[b+124+(f<<2)>>2]=c[d+4+(f*144|0)+84>>2];c[b+136+(f<<2)>>2]=c[d+4+(f*144|0)+88>>2];c[b+148+(f<<2)>>2]=c[d+4+(f*144|0)+92>>2];c[b+160+(f<<2)>>2]=c[d+4+(f*144|0)+96>>2];c[b+172+(f<<2)>>2]=c[d+4+(f*144|0)+100>>2];c[b+184+(f<<2)>>2]=c[d+4+(f*144|0)+132>>2];a[b+196+f|0]=a[d+4+(f*144|0)+108|0]&1;c[b+200+(f<<2)>>2]=c[d+4+(f*144|0)+104>>2];f=f+1|0;}while((f|0)<3);return}function r9(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=d+576|0;g=d+564|0;h=d+568|0;i=d|0;j=d+572|0;k=0;do{l=a[e+k|0]|0;c[f>>2]=k;c[g>>2]=l;c[h>>2]=16384;if((c[i>>2]|0)==1){c[j>>2]=1}else{r6(d)}k=k+1|0;}while((k|0)<25);c[g>>2]=c[e+32>>2];c[h>>2]=c[e+36>>2];c[j>>2]=c[e+40>>2];c[f>>2]=c[e+44>>2];rS(d+436|0,c[e+48>>2]|0);f=0;do{c[d+4+(f*144|0)+8>>2]=c[e+52+(f<<2)>>2];c[d+4+(f*144|0)+24>>2]=c[e+64+(f<<2)>>2];c[d+4+(f*144|0)+28>>2]=c[e+76+(f<<2)>>2];c[d+4+(f*144|0)+32>>2]=c[e+88+(f<<2)>>2];b[d+4+(f*144|0)+48>>1]=c[e+100+(f<<2)>>2]&65535;c[d+4+(f*144|0)+72>>2]=c[e+112+(f<<2)>>2];c[d+4+(f*144|0)+84>>2]=c[e+124+(f<<2)>>2];c[d+4+(f*144|0)+88>>2]=c[e+136+(f<<2)>>2];c[d+4+(f*144|0)+92>>2]=c[e+148+(f<<2)>>2];c[d+4+(f*144|0)+96>>2]=c[e+160+(f<<2)>>2];c[d+4+(f*144|0)+100>>2]=c[e+172+(f<<2)>>2];c[d+4+(f*144|0)+132>>2]=c[e+184+(f<<2)>>2];a[d+4+(f*144|0)+108|0]=a[e+196+f|0]&1;c[d+4+(f*144|0)+104>>2]=c[e+200+(f<<2)>>2];f=f+1|0;}while((f|0)<3);return}function sa(a,b){a=a|0;b=b|0;rS(a+436|0,b);return}function sb(a,b){a=a|0;b=b|0;rQ(a+436|0,b);return}function sc(a,b){a=a|0;b=+b;rU(a+436|0,b);return}function sd(a,b){a=a|0;b=b|0;rN(a+540|0,b);return}function se(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=d+572|0;if((c[f>>2]|0)!=0&(e|0)>0){c[f>>2]=0;se(d,1);r6(d);g=e-1|0}else{g=e}if((g|0)<1){return}e=d+568|0;f=(c[e>>2]|0)-g|0;c[e>>2]=f;if((f|0)<1){c[d+564>>2]=0;c[e>>2]=0}sf(d+88|0,g);sf(d+232|0,g);sf(d+376|0,g);e=(g|0)==0;L5984:do{if(e){h=d+4|0;i=d+148|0;j=d+292|0}else{f=g;while(1){k=d+8|0;do{if((c[(c[k>>2]|0)+64>>2]|0)==0){l=f}else{m=c[d+20>>2]|0;if((m|0)==0){l=f;break}n=c[d+12>>2]|0;o=8388608-n+(n&8388608)|0;n=(((o>>>0)%(m>>>0)|0|0)!=0)+((o>>>0)/(m>>>0)|0)|0;l=(n|0)<(f|0)?n:f}}while(0);n=d+152|0;do{if((c[(c[n>>2]|0)+64>>2]|0)==0){p=l}else{m=c[d+164>>2]|0;if((m|0)==0){p=l;break}o=c[d+156>>2]|0;q=8388608-o+(o&8388608)|0;o=(((q>>>0)%(m>>>0)|0|0)!=0)+((q>>>0)/(m>>>0)|0)|0;p=(o|0)<(l|0)?o:l}}while(0);o=d+296|0;do{if((c[(c[o>>2]|0)+64>>2]|0)==0){r=p}else{m=c[d+308>>2]|0;if((m|0)==0){r=p;break}q=c[d+300>>2]|0;s=8388608-q+(q&8388608)|0;q=(((s>>>0)%(m>>>0)|0|0)!=0)+((s>>>0)/(m>>>0)|0)|0;r=(q|0)<(p|0)?q:p}}while(0);q=d+4|0;sg(q,r);m=d+148|0;sg(m,r);s=d+292|0;sg(s,r);do{if((a[d+16|0]&1)!=0){t=c[k>>2]|0;if((c[t+64>>2]|0)==0){break}if((c[d+68>>2]|0)!=0){if((a[(c[d+4>>2]|0)+12|0]&1)!=0){break}}c[t+8>>2]=0}}while(0);do{if((a[d+160|0]&1)!=0){k=c[n>>2]|0;if((c[k+64>>2]|0)==0){break}if((c[d+212>>2]|0)!=0){if((a[(c[d+148>>2]|0)+12|0]&1)!=0){break}}c[k+8>>2]=0}}while(0);do{if((a[d+304|0]&1)!=0){n=c[o>>2]|0;if((c[n+64>>2]|0)==0){break}if((c[d+356>>2]|0)!=0){if((a[(c[d+292>>2]|0)+12|0]&1)!=0){break}}c[n+8>>2]=0}}while(0);if((f|0)==(r|0)){h=q;i=m;j=s;break L5984}f=f-r|0}}}while(0);sh(h,g);sh(i,g);sh(j,g);j=d+436|0;i=ag(b[18201304+(c[d+140>>2]<<9)+(c[d+104>>2]<<1)>>1]|0,(b[18184920+(c[d+80>>2]<<13)+(c[d+72>>2]<<1)>>1]|0)-(b[d+144>>1]|0)|0)|0;h=ag(b[18201304+(c[d+284>>2]<<9)+(c[d+248>>2]<<1)>>1]|0,(b[18184920+(c[d+224>>2]<<13)+(c[d+216>>2]<<1)>>1]|0)-(b[d+288>>1]|0)|0)|0;si(j,g,i,h,ag(b[18201304+(c[d+428>>2]<<9)+(c[d+392>>2]<<1)>>1]|0,(b[18184920+(c[d+368>>2]<<13)+(c[d+360>>2]<<1)>>1]|0)-(b[d+432>>1]|0)|0)|0);h=sj(j)|0;if((a[d+540|0]&1)==0){c[d+544>>2]=h<<16>>16<<11;c[d+548>>2]=0;return}if(e){return}e=c[d+552>>2]|0;j=h<<16>>16<<11;h=d+544|0;i=c[d+556>>2]|0;r=d+548|0;d=8;p=g;g=c[h>>2]|0;l=c[r>>2]|0;while(1){f=(p|0)<(d|0)?p:d;u=((ag((ag(f,e)|0)>>3,j-g|0)|0)>>4)+g|0;v=((ag((ag(f,i)|0)>>3,g-l|0)|0)>>17)+l|0;if((p|0)==(f|0)){break}else{d=f;p=p-f|0;g=u;l=v}}c[h>>2]=u;c[r>>2]=v;return}function sf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=f-h|0;if((d|0)==0){return}j=b+48|0;k=b+8|0;l=b+24|0;m=b+16|0;n=b+12|0;o=b+32|0;p=b+36|0;b=d;d=(i|0)<1?i+32767|0:i;i=h;h=f;L6038:while(1){if((b|0)<(d|0)){q=4681;break}c[g>>2]=0;f=b-d|0;r=c[j>>2]|0;if((r|0)==0){q=4685}else{s=(c[k>>2]|0)+1|0;c[k>>2]=s;if((s|0)==(c[n>>2]|0)){q=4685}else{t=h}}L6043:do{if((q|0)==4685){q=0;c[k>>2]=0;if((a[l]&1)!=0){t=h;break}do{if((r|0)==0){s=(c[m>>2]|0)+1&255;c[m>>2]=s;if((s|0)!=255){u=s;q=4694;break}c[j>>2]=1;s=c[231504+(c[o>>2]<<2)>>2]|0;c[e>>2]=s;v=s}else if((r|0)==2){s=(c[m>>2]|0)+255&255;c[m>>2]=s;u=s;q=4694}else if((r|0)==1){s=c[m>>2]|0;if((s|0)==(c[231568+(c[p>>2]<<2)>>2]|0)){q=4706;break L6038}w=s-1|0;c[m>>2]=w;u=w;q=4694}else{u=c[m>>2]|0;q=4694}}while(0);L6053:do{if((q|0)==4694){q=0;switch(u|0){case 54:{c[n>>2]=4;t=h;break L6043;break};case 26:{c[n>>2]=8;t=h;break L6043;break};case 14:{c[n>>2]=16;t=h;break L6043;break};case 255:{v=h;break L6053;break};case 6:{c[n>>2]=30;t=h;break L6043;break};case 0:{c[n>>2]=1;a[l]=1;t=h;break L6043;break};case 93:{c[n>>2]=2;t=h;break L6043;break};default:{t=h;break L6043}}}}while(0);c[n>>2]=1;t=v}}while(0);if((b|0)==(d|0)){q=4704;break}else{b=f;d=t;i=0;h=t}}if((q|0)==4706){return}else if((q|0)==4704){return}else if((q|0)==4681){q=i+b|0;c[g>>2]=q;if((q&32768|0)==0){return}c[g>>2]=q+1&32767;return}}function sg(d,f){d=d|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((c[d+56>>2]|0)!=0){g=d+28|0;h=c[g>>2]|0;do{if((h|0)!=0){i=h-f|0;c[g>>2]=i;if((i|0)>=1){break}c[d+24>>2]=8388607;c[g>>2]=0;b[d+42>>1]=4080;b[d+44>>1]=b[d+40>>1]|4080}}while(0);b[d+48>>1]=4095;return}g=ag(c[d+16>>2]|0,f)|0;f=d+8|0;h=c[f>>2]|0;i=h+g|0;j=i&16777215;c[f>>2]=j;a[d+12|0]=(i&(h^8388608))>>>23&1;L6081:do{if((g|0)!=0){h=d+24|0;f=d+42|0;k=d+40|0;l=d+44|0;m=g;n=1048576;while(1){do{if(m>>>0<n>>>0){o=(i-m&524288|0)!=0;p=(i&524288|0)==0;if(m>>>0<524289>>>0){if(o|p){break L6081}else{q=m;break}}else{if(o&p){break L6081}else{q=m;break}}}else{q=n}}while(0);p=c[h>>2]|0;o=p>>>22^p>>>17;r=p<<1&8388606;c[h>>2]=o&1|r;s=p>>>8&2048|p>>>7&1024|p>>>4&512|p>>>2&256|p>>>1&128|r<<1&64|r<<3&32|o<<4&16;b[f>>1]=s&65535;b[l>>1]=(s|(e[k>>1]|0))&65535;if((m|0)==(q|0)){break}else{m=m-q|0;n=q}}}}while(0);b[d+48>>1]=j>>>12>>>0>=(c[d+20>>2]|0)>>>0?4095:0;return}function sh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=c[a+52>>2]|0;if((e|0)!=0){f=a+44|0;g=(b[a+48>>1]|b[a+46>>1])&b[(c[a+80>>2]|0)+((c[a+36>>2]&c[(c[a>>2]|0)+8>>2]^c[a+8>>2])>>>12<<1)>>1]&b[f>>1];h=g&65535;c[a+68>>2]=h;if(e>>>0<=8>>>0){return}e=a+24|0;c[e>>2]=c[e>>2]&(h<<9&1048576|h<<8&262144|h<<5&16384|h<<3&2048|h<<2&512|h>>>1&32|h>>>3&4|h>>>4&1|-1329702);h=a+42|0;e=b[h>>1]&g;b[h>>1]=e;b[f>>1]=b[a+40>>1]|e;return}e=a+72|0;f=c[e>>2]|0;if((f|0)==0){return}h=f-d|0;c[e>>2]=h;if((h|0)>=1){return}c[e>>2]=0;c[a+68>>2]=0;return}function si(b,d,f,g,h){b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=c[b+100>>2]|0;j=1137300+(ag(i,8523816)|0)|0;k=(ag(c[j>>2]|0,f)|0)>>18;f=1137304+(ag(i,8523816)|0)|0;l=k+(c[f>>2]|0)|0;c[b+76>>2]=l;k=(ag(c[j>>2]|0,g)|0)>>18;g=k+(c[f>>2]|0)|0;c[b+72>>2]=g;k=(ag(c[j>>2]|0,h)|0)>>18;h=k+(c[f>>2]|0)|0;c[b+68>>2]=h;if((a[b|0]&1)==0){return}switch(c[b+28>>2]&15|0){case 9:{m=l+(c[b+64>>2]|0)|0;n=327680;break};case 14:{m=(c[b+64>>2]|0)+h+g|0;n=589824;break};case 5:{m=l+h|0;n=327680;break};case 12:{m=(c[b+64>>2]|0)+h|0;n=327680;break};case 4:{m=h;n=131072;break};case 1:{m=l;n=131072;break};case 11:{m=g+(c[b+64>>2]|0)+l|0;n=589824;break};case 13:{m=(c[b+64>>2]|0)+h+l|0;n=589824;break};case 7:{m=g+h+l|0;n=589824;break};case 15:{m=(c[b+64>>2]|0)+h+g+l|0;n=917504;break};case 6:{m=g+h|0;n=327680;break};case 8:{m=c[b+64>>2]|0;n=131072;break};case 3:{m=l+g|0;n=327680;break};case 2:{m=g;n=131072;break};case 10:{m=g+(c[b+64>>2]|0)|0;n=327680;break};default:{m=0;n=0}}g=(d|0)==0;if((i|0)==0){if(g){return}i=b+40|0;l=b+56|0;h=b+60|0;f=b+52|0;k=b+36|0;j=b+44|0;o=b+48|0;p=c[b+80>>2]|0;q=c[b+88>>2]|0;r=3;s=d;t=c[i>>2]|0;u=c[l>>2]|0;v=c[h>>2]|0;w=c[k>>2]|0;x=c[j>>2]|0;y=c[o>>2]|0;while(1){z=(s|0)<(r|0)?s:r;A=c[284323]|0;B=A-u|0;C=A-t|0;A=ag(C,C)|0;C=ag((ag(B,B)|0)-A>>15,c[284324]|0)|0;B=e[875144+((p+(A>>>1)|0)>>>16<<1)>>1]|0;A=B-u|0;D=B-t|0;B=v-(ag(((e[1006216+(((A|0)<0?0:A)<<1)>>1]|0)-(e[1006216+(((D|0)<0?0:D)<<1)>>1]|0)<<15)+C|0,z)|0)|0;c[h>>2]=B;C=e[1137324+((B>>15)+32768<<1)>>1]|0;c[l>>2]=C;D=(B>>14)+C|0;c[f>>2]=D;A=c[284323]|0;E=A-x|0;F=A-w|0;A=ag(F,F)|0;F=ag((ag(E,E)|0)-A>>15,c[284324]|0)|0;E=e[875144+((p+(A>>>1)|0)>>>16<<1)>>1]|0;A=E-x|0;G=E-w|0;E=y-(ag(((e[1006216+(((A|0)<0?0:A)<<1)>>1]|0)-(e[1006216+(((G|0)<0?0:G)<<1)>>1]|0)<<15)+F|0,z)|0)|0;c[o>>2]=E;F=e[1137324+((E>>15)+32768<<1)>>1]|0;c[j>>2]=F;G=(E>>14)+F|0;c[i>>2]=G;A=e[1268396+(D+m+(e[3889836+(q<<17)+(G<<1)>>1]|0|n)<<1)>>1]|0;c[k>>2]=A;if((s|0)==(z|0)){break}else{r=z;s=s-z|0;t=G;u=C;v=B;w=A;x=F;y=E}}return}if(g){return}g=c[b+92>>2]|0;y=b+36|0;x=b+40|0;w=b+52|0;v=c[b+96>>2]|0;b=3;u=d;d=c[y>>2]|0;t=c[x>>2]|0;s=c[w>>2]|0;while(1){r=(u|0)<(b|0)?u:b;k=(ag(g,r)|0)>>2;H=t-((ag(k,d>>4)|0)>>14)|0;I=s-((ag(t>>4,k)|0)>>14)|0;J=((ag(v,H)|0)>>10)-(I+m)|0;if((u|0)==(r|0)){break}else{b=r;u=u-r|0;d=J;t=H;s=I}}c[y>>2]=J;c[x>>2]=H;c[w>>2]=I;return}function sj(a){a=a|0;var d=0,f=0,g=0;switch(c[a+32>>2]&127|0){case 30:{d=393217;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 17:{d=65537;f=(c[a+76>>2]|0)+(c[a+52>>2]|0)|0;break};case 70:{d=196609;f=(c[a+68>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)|0;break};case 71:{d=393217;f=(c[a+68>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 72:{d=65537;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)|0;break};case 9:{d=65537;f=(c[a+76>>2]|0)+(c[a+64>>2]|0)|0;break};case 6:{d=65537;f=(c[a+72>>2]|0)+(c[a+68>>2]|0)|0;break};case 47:{d=655361;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 1:{d=1;f=c[a+76>>2]|0;break};case 101:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 102:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 103:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 104:{d=196609;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)|0;break};case 8:{d=1;f=c[a+64>>2]|0;break};case 32:{d=1;f=c[a+40>>2]|0;break};case 40:{d=65537;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)|0;break};case 5:{d=65537;f=(c[a+76>>2]|0)+(c[a+68>>2]|0)|0;break};case 98:{d=196609;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)|0;break};case 99:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 100:{d=196609;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)|0;break};case 105:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 106:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)|0;break};case 12:{d=65537;f=(c[a+68>>2]|0)+(c[a+64>>2]|0)|0;break};case 34:{d=65537;f=(c[a+72>>2]|0)+(c[a+40>>2]|0)|0;break};case 48:{d=65537;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)|0;break};case 28:{d=196609;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)|0;break};case 21:{d=196609;f=(c[a+68>>2]|0)+(c[a+52>>2]|0)+(c[a+76>>2]|0)|0;break};case 3:{d=65537;f=(c[a+76>>2]|0)+(c[a+72>>2]|0)|0;break};case 83:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 84:{d=196609;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)|0;break};case 85:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 14:{d=196609;f=(c[a+68>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)|0;break};case 29:{d=393217;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 26:{d=196609;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)|0;break};case 93:{d=655361;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 43:{d=393217;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 80:{d=65537;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)|0;break};case 4:{d=1;f=c[a+68>>2]|0;break};case 90:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)|0;break};case 91:{d=655361;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 92:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)|0;break};case 39:{d=393217;f=(c[a+68>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 88:{d=196609;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)|0;break};case 89:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 35:{d=196609;f=(c[a+72>>2]|0)+(c[a+40>>2]|0)+(c[a+76>>2]|0)|0;break};case 54:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 2:{d=1;f=c[a+72>>2]|0;break};case 22:{d=196609;f=(c[a+68>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)|0;break};case 75:{d=393217;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 76:{d=196609;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)|0;break};case 25:{d=196609;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+76>>2]|0)|0;break};case 33:{d=65537;f=(c[a+76>>2]|0)+(c[a+40>>2]|0)|0;break};case 57:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 58:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)|0;break};case 55:{d=655361;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 56:{d=196609;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)|0;break};case 73:{d=196609;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+76>>2]|0)|0;break};case 74:{d=196609;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)|0;break};case 107:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 108:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)|0;break};case 109:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 110:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 15:{d=393217;f=(c[a+68>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 13:{d=196609;f=(c[a+68>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 95:{d=983041;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 96:{d=65537;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)|0;break};case 97:{d=196609;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+76>>2]|0)|0;break};case 77:{d=393217;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 78:{d=393217;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 79:{d=655361;f=(c[a+64>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 10:{d=65537;f=(c[a+72>>2]|0)+(c[a+64>>2]|0)|0;break};case 19:{d=196609;f=(c[a+72>>2]|0)+(c[a+52>>2]|0)+(c[a+76>>2]|0)|0;break};case 11:{d=196609;f=(c[a+72>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 20:{d=65537;f=(c[a+68>>2]|0)+(c[a+52>>2]|0)|0;break};case 94:{d=655361;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 42:{d=196609;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)|0;break};case 81:{d=196609;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+76>>2]|0)|0;break};case 82:{d=196609;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+72>>2]|0)|0;break};case 36:{d=65537;f=(c[a+68>>2]|0)+(c[a+40>>2]|0)|0;break};case 18:{d=65537;f=(c[a+72>>2]|0)+(c[a+52>>2]|0)|0;break};case 7:{d=196609;f=(c[a+72>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 27:{d=393217;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 23:{d=393217;f=(c[a+68>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 86:{d=393217;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 87:{d=655361;f=(c[a+52>>2]|0)+(c[a+36>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 51:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 41:{d=196609;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+76>>2]|0)|0;break};case 37:{d=196609;f=(c[a+68>>2]|0)+(c[a+40>>2]|0)+(c[a+76>>2]|0)|0;break};case 64:{d=1;f=c[a+36>>2]|0;break};case 24:{d=65537;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)|0;break};case 63:{d=983041;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 45:{d=393217;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 46:{d=393217;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 65:{d=65537;f=(c[a+76>>2]|0)+(c[a+36>>2]|0)|0;break};case 50:{d=196609;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)|0;break};case 118:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 119:{d=983041;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 113:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+76>>2]|0)|0;break};case 114:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)|0;break};case 115:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 116:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)|0;break};case 117:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 111:{d=983041;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 112:{d=196609;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)|0;break};case 66:{d=65537;f=(c[a+72>>2]|0)+(c[a+36>>2]|0)|0;break};case 67:{d=196609;f=(c[a+72>>2]|0)+(c[a+36>>2]|0)+(c[a+76>>2]|0)|0;break};case 125:{d=983041;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 126:{d=983041;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 127:{d=1376257;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 121:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+76>>2]|0)|0;break};case 122:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)|0;break};case 123:{d=983041;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 124:{d=655361;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)|0;break};case 120:{d=393217;f=(c[a+40>>2]|0)+(c[a+36>>2]|0)+(c[a+52>>2]|0)+(c[a+64>>2]|0)|0;break};case 44:{d=196609;f=(c[a+64>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)|0;break};case 61:{d=655361;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 62:{d=655361;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)|0;break};case 59:{d=655361;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 60:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+64>>2]|0)+(c[a+68>>2]|0)|0;break};case 68:{d=65537;f=(c[a+68>>2]|0)+(c[a+36>>2]|0)|0;break};case 69:{d=196609;f=(c[a+68>>2]|0)+(c[a+36>>2]|0)+(c[a+76>>2]|0)|0;break};case 53:{d=393217;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)+(c[a+76>>2]|0)|0;break};case 49:{d=196609;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+76>>2]|0)|0;break};case 52:{d=196609;f=(c[a+52>>2]|0)+(c[a+40>>2]|0)+(c[a+68>>2]|0)|0;break};case 16:{d=1;f=c[a+52>>2]|0;break};case 31:{d=655361;f=(c[a+64>>2]|0)+(c[a+52>>2]|0)+(c[a+68>>2]|0)+(c[a+72>>2]|0)+(c[a+76>>2]|0)|0;break};case 38:{d=196609;f=(c[a+68>>2]|0)+(c[a+40>>2]|0)+(c[a+72>>2]|0)|0;break};default:{d=0;f=0}}if((c[a+100>>2]|0)==0){g=b[3889836+(c[a+20>>2]<<17)+((e[5986988+(d+f<<1)>>1]|0)<<1)>>1]^-32768;return g|0}else{g=(ag(c[a+20>>2]|0,f)|0)>>>4&65535;return g|0}return 0}function sk(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=c[a+592>>2]|0;if((h|0)==2){i=sm(a,d,e,f,g)|0;return i|0}else if((h|0)==1){i=sl(a,d,e,f,g)|0;return i|0}else if((h|0)==3){i=sn(a,d,e,f,g)|0;return i|0}else{if((f|0)<=0){i=0;return i|0}h=a+600|0;j=a+596|0;k=a+544|0;l=a+548|0;m=0;while(1){n=(c[h>>2]|0)+32768+(c[j>>2]|0)|0;o=n>>16;p=c[d>>2]|0;q=(o|0)>(p|0)?p:o;se(a,q);o=c[d>>2]|0;c[d>>2]=o-q;if((o|0)==(q|0)){break}c[h>>2]=(n&65535)-32768;n=(c[k>>2]|0)-(c[l>>2]|0)>>11;if((n|0)>32767){r=32767}else{r=(n|0)<-32768?-32768:n&65535}b[e+((ag(m,g)|0)<<1)>>1]=r;n=m+1|0;if((n|0)<(f|0)){m=n}else{i=n;s=4913;break}}if((s|0)==4913){return i|0}c[h>>2]=(c[h>>2]|0)-(q<<16);i=m;return i|0}return 0}function sl(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((f|0)<=0){h=0;return h|0}i=a+600|0;j=a+596|0;k=a+608|0;l=a+610|0;m=a+544|0;n=a+548|0;o=0;while(1){p=(c[j>>2]|0)+(c[i>>2]|0)|0;q=p>>16;r=c[d>>2]|0;s=(q|0)>(r|0)?r:q;if((s|0)>0){q=s;do{so(a);if((q|0)<3){b[k>>1]=b[l>>1]|0;t=(c[m>>2]|0)-(c[n>>2]|0)>>11;if((t|0)>32767){u=32767}else{u=(t|0)<-32768?-32768:t&65535}b[l>>1]=u}q=q-1|0;}while((q|0)>0);v=c[d>>2]|0}else{v=r}c[d>>2]=v-s;if((v|0)==(s|0)){break}q=p&65535;c[i>>2]=q;t=b[k>>1]|0;b[e+((ag(o,g)|0)<<1)>>1]=((ag((b[l>>1]|0)-t|0,q)|0)>>>16)+t&65535;t=o+1|0;if((t|0)<(f|0)){o=t}else{h=t;w=4933;break}}if((w|0)==4933){return h|0}c[i>>2]=(c[i>>2]|0)-(s<<16);h=o;return h|0}function sm(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;if((f|0)<=0){h=0;return h|0}i=a+600|0;j=a+596|0;k=a+616|0;l=a+624|0;m=a+612|0;n=a+620|0;o=a+604|0;p=a+544|0;q=a+548|0;r=0;while(1){s=(c[j>>2]|0)+(c[i>>2]|0)|0;t=s>>16;u=c[d>>2]|0;v=(t|0)>(u|0)?u:t;if((v|0)>0){t=0;do{so(a);w=(c[p>>2]|0)-(c[q>>2]|0)>>11;if((w|0)>32767){x=32767}else{x=(w|0)<-32768?-32768:w&65535}b[(c[n>>2]|0)+((c[o>>2]|0)+16384<<1)>>1]=x;b[(c[n>>2]|0)+(c[o>>2]<<1)>>1]=x;c[o>>2]=(c[o>>2]|0)+1&16383;t=t+1|0;}while((t|0)<(v|0));y=c[d>>2]|0}else{y=u}c[d>>2]=y-v;if((y|0)==(v|0)){break}t=s&65535;c[i>>2]=t;w=c[k>>2]|0;z=ag(w,t)|0;t=z>>16;A=z&65535;z=c[l>>2]|0;B=c[m>>2]|0;C=ag(t,B)|0;D=c[n>>2]|0;E=(c[o>>2]|0)-B|0;F=E+16383|0;G=(B|0)>0;do{if(G){H=0;I=0;do{H=(ag(b[z+(I+C<<1)>>1]|0,b[D+(I+F<<1)>>1]|0)|0)+H|0;I=I+1|0;}while((I|0)<(B|0));I=t+1|0;J=(I|0)==(w|0);K=J?E+16384|0:F;L=ag(J?0:I,B)|0;if(G){M=0;N=0}else{O=0;P=H;break}while(1){I=(ag(b[z+(N+L<<1)>>1]|0,b[D+(N+K<<1)>>1]|0)|0)+M|0;J=N+1|0;if((J|0)<(B|0)){M=I;N=J}else{O=I;P=H;break}}}else{O=0;P=0}}while(0);B=((ag(O-P|0,A)|0)>>16)+P>>15;if((B|0)>32767){Q=32767}else{Q=(B|0)<-32768?-32768:B&65535}b[e+((ag(r,g)|0)<<1)>>1]=Q;B=r+1|0;if((B|0)<(f|0)){r=B}else{h=B;R=4954;break}}if((R|0)==4954){return h|0}c[i>>2]=(c[i>>2]|0)-(v<<16);h=r;return h|0}function sn(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;if((f|0)<=0){h=0;return h|0}i=a+600|0;j=a+596|0;k=a+616|0;l=a+624|0;m=a+612|0;n=a+620|0;o=a+604|0;p=a+544|0;q=a+548|0;r=0;while(1){s=(c[j>>2]|0)+(c[i>>2]|0)|0;t=s>>16;u=c[d>>2]|0;v=(t|0)>(u|0)?u:t;if((v|0)>0){t=0;do{so(a);w=(c[p>>2]|0)-(c[q>>2]|0)>>11;if((w|0)>32767){x=32767}else{x=(w|0)<-32768?-32768:w&65535}b[(c[n>>2]|0)+((c[o>>2]|0)+16384<<1)>>1]=x;b[(c[n>>2]|0)+(c[o>>2]<<1)>>1]=x;c[o>>2]=(c[o>>2]|0)+1&16383;t=t+1|0;}while((t|0)<(v|0));y=c[d>>2]|0}else{y=u}c[d>>2]=y-v;if((y|0)==(v|0)){break}t=s&65535;c[i>>2]=t;w=(ag(c[k>>2]|0,t)|0)>>16;t=c[l>>2]|0;z=c[m>>2]|0;A=ag(w,z)|0;w=c[n>>2]|0;if((z|0)>0){B=16384-z+(c[o>>2]|0)|0;C=0;D=0;do{C=(ag(b[t+(D+A<<1)>>1]|0,b[w+(B+D<<1)>>1]|0)|0)+C|0;D=D+1|0;}while((D|0)<(z|0));z=C>>15;if((z|0)>32767){E=32767}else{F=z;G=4968}}else{F=0;G=4968}if((G|0)==4968){G=0;E=(F|0)<-32768?-32768:F&65535}b[e+((ag(r,g)|0)<<1)>>1]=E;z=r+1|0;if((z|0)<(f|0)){r=z}else{h=z;G=4972;break}}if((G|0)==4972){return h|0}c[i>>2]=(c[i>>2]|0)-(v<<16);h=r;return h|0}function so(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;sp(d+88|0);sp(d+232|0);sp(d+376|0);e=d+4|0;sq(e);f=d+148|0;sq(f);g=d+292|0;sq(g);do{if((a[d+16|0]&1)!=0){h=c[d+8>>2]|0;if((c[h+64>>2]|0)==0){break}if((c[d+68>>2]|0)!=0){if((a[(c[d+4>>2]|0)+12|0]&1)!=0){break}}c[h+8>>2]=0}}while(0);do{if((a[d+160|0]&1)!=0){h=c[d+152>>2]|0;if((c[h+64>>2]|0)==0){break}if((c[d+212>>2]|0)!=0){if((a[(c[d+148>>2]|0)+12|0]&1)!=0){break}}c[h+8>>2]=0}}while(0);do{if((a[d+304|0]&1)!=0){h=c[d+296>>2]|0;if((c[h+64>>2]|0)==0){break}if((c[d+356>>2]|0)!=0){if((a[(c[d+292>>2]|0)+12|0]&1)!=0){break}}c[h+8>>2]=0}}while(0);sr(e);sr(f);sr(g);g=d+436|0;f=ag(b[18201304+(c[d+140>>2]<<9)+(c[d+104>>2]<<1)>>1]|0,(b[18184920+(c[d+80>>2]<<13)+(c[d+72>>2]<<1)>>1]|0)-(b[d+144>>1]|0)|0)|0;e=ag(b[18201304+(c[d+284>>2]<<9)+(c[d+248>>2]<<1)>>1]|0,(b[18184920+(c[d+224>>2]<<13)+(c[d+216>>2]<<1)>>1]|0)-(b[d+288>>1]|0)|0)|0;ss(g,f,e,ag(b[18201304+(c[d+428>>2]<<9)+(c[d+392>>2]<<1)>>1]|0,(b[18184920+(c[d+368>>2]<<13)+(c[d+360>>2]<<1)>>1]|0)-(b[d+432>>1]|0)|0)|0);e=sj(g)|0;if((a[d+540|0]&1)==0){c[d+544>>2]=e<<16>>16<<11;c[d+548>>2]=0}else{g=d+544|0;f=c[g>>2]|0;h=(ag((e<<16>>16<<11)-f|0,c[d+552>>2]|0)|0)>>7;e=d+548|0;i=c[e>>2]|0;j=(ag(f-i|0,c[d+556>>2]|0)|0)>>20;c[g>>2]=h+f;c[e>>2]=j+i}if((c[d+572>>2]|0)!=0){r6(d)}i=d+568|0;j=(c[i>>2]|0)-1|0;c[i>>2]=j;if((j|0)!=0){return}c[d+564>>2]=0;return}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b+20|0;L6414:do{if((c[d>>2]|0)!=0){e=b+16|0;f=c[e>>2]|0;c[e>>2]=f-1;c[d>>2]=0;switch(f|0){case 15:{c[b+12>>2]=16;break L6414;break};case 27:{c[b+12>>2]=8;break L6414;break};case 55:{c[b+12>>2]=4;break L6414;break};case 94:{c[b+12>>2]=2;break L6414;break};case 256:{c[b+12>>2]=1;break L6414;break};case 7:{c[b+12>>2]=30;break L6414;break};case 1:{c[b+12>>2]=1;a[b+24|0]=1;break L6414;break};default:{break L6414}}}}while(0);f=b|0;e=c[f>>2]|0;g=e+1|0;if((g&32768|0)==0){h=g}else{h=e+2&32767}c[f>>2]=h;e=b+4|0;if((h|0)!=(c[e>>2]|0)){return}c[f>>2]=0;f=b+48|0;h=c[f>>2]|0;g=b+8|0;do{if((h|0)!=0){i=(c[g>>2]|0)+1|0;c[g>>2]=i;if((i|0)==(c[b+12>>2]|0)){break}return}}while(0);c[g>>2]=0;g=b+24|0;if((a[g]&1)!=0){return}do{if((h|0)==2){if((c[b+12>>2]|0)==1){i=b+16|0;j=(c[i>>2]|0)+255&255;c[i>>2]=j;k=j;l=5025;break}c[d>>2]=1;return}else if((h|0)==1){j=b+16|0;i=c[j>>2]|0;if((i|0)==(c[231568+(c[b+36>>2]<<2)>>2]|0)){return}if((c[b+12>>2]|0)==1){m=i-1|0;c[j>>2]=m;k=m;l=5025;break}c[d>>2]=1;return}else if((h|0)==0){m=b+16|0;j=(c[m>>2]|0)+1&255;c[m>>2]=j;if((j|0)!=255){k=j;l=5025;break}c[f>>2]=1;c[e>>2]=c[231504+(c[b+32>>2]<<2)>>2]}else{k=c[b+16>>2]|0;l=5025}}while(0);L6455:do{if((l|0)==5025){switch(k|0){case 93:{c[b+12>>2]=2;return};case 54:{c[b+12>>2]=4;return};case 0:{c[b+12>>2]=1;a[g]=1;return};case 255:{break L6455;break};case 26:{c[b+12>>2]=8;return};case 6:{c[b+12>>2]=30;return};case 14:{c[b+12>>2]=16;return};default:{return}}}}while(0);c[b+12>>2]=1;return}function sq(d){d=d|0;var f=0,g=0,h=0,i=0;if((c[d+56>>2]|0)!=0){f=d+28|0;g=c[f>>2]|0;do{if((g|0)!=0){h=g-1|0;c[f>>2]=h;if((h|0)!=0){break}c[d+24>>2]=8388607;c[f>>2]=0;b[d+42>>1]=4080;b[d+44>>1]=b[d+40>>1]|4080}}while(0);b[d+48>>1]=4095;return}f=d+8|0;g=c[f>>2]|0;h=(c[d+16>>2]|0)+g&16777215;i=h&~g;c[f>>2]=h;a[d+12|0]=i>>>23&255;h=d+32|0;if((i&524288|0)!=0){c[h>>2]=2;return}i=c[h>>2]|0;if((i|0)==0){return}f=i-1|0;c[h>>2]=f;if((f|0)!=0){return}f=d+24|0;h=c[f>>2]|0;i=h>>>22^h>>>17;g=h<<1&8388606;c[f>>2]=i&1|g;f=h>>>8&2048|h>>>7&1024|h>>>4&512|h>>>2&256|h>>>1&128|g<<1&64|g<<3&32|i<<4&16;b[d+42>>1]=f&65535;b[d+44>>1]=(f|(e[d+40>>1]|0))&65535;return}function sr(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=c[a+52>>2]|0;do{if((d|0)==0){e=a+72|0;f=c[e>>2]|0;if((f|0)==0){break}g=f-1|0;c[e>>2]=g;if((g|0)!=0){break}c[a+68>>2]=0}else{g=a+44|0;e=(b[a+48>>1]|b[a+46>>1])&b[(c[a+80>>2]|0)+((c[a+36>>2]&c[(c[a>>2]|0)+8>>2]^c[a+8>>2])>>>12<<1)>>1]&b[g>>1];f=e&65535;c[a+68>>2]=f;if(d>>>0<=8>>>0){break}h=a+24|0;c[h>>2]=c[h>>2]&(f<<9&1048576|f<<8&262144|f<<5&16384|f<<3&2048|f<<2&512|f>>>1&32|f>>>3&4|f>>>4&1|-1329702);f=a+42|0;h=b[f>>1]&e;b[f>>1]=h;b[g>>1]=b[a+40>>1]|h}}while(0);b[a+48>>1]=(c[a+8>>2]|0)>>>12>>>0>=(c[a+20>>2]|0)>>>0?4095:0;return}function ss(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=c[a+100>>2]|0;h=1137300+(ag(g,8523816)|0)|0;i=(ag(c[h>>2]|0,b)|0)>>18;b=1137304+(ag(g,8523816)|0)|0;j=i+(c[b>>2]|0)|0;c[a+76>>2]=j;i=(ag(c[h>>2]|0,d)|0)>>18;d=i+(c[b>>2]|0)|0;c[a+72>>2]=d;i=(ag(c[h>>2]|0,f)|0)>>18;f=i+(c[b>>2]|0)|0;c[a+68>>2]=f;switch(c[a+28>>2]&15|0){case 4:{k=f;l=131072;break};case 9:{k=j+(c[a+64>>2]|0)|0;l=327680;break};case 2:{k=d;l=131072;break};case 12:{k=(c[a+64>>2]|0)+f|0;l=327680;break};case 11:{k=d+(c[a+64>>2]|0)+j|0;l=589824;break};case 14:{k=(c[a+64>>2]|0)+f+d|0;l=589824;break};case 13:{k=(c[a+64>>2]|0)+f+j|0;l=589824;break};case 15:{k=(c[a+64>>2]|0)+f+d+j|0;l=917504;break};case 8:{k=c[a+64>>2]|0;l=131072;break};case 7:{k=d+f+j|0;l=589824;break};case 10:{k=d+(c[a+64>>2]|0)|0;l=327680;break};case 1:{k=j;l=131072;break};case 3:{k=j+d|0;l=327680;break};case 5:{k=j+f|0;l=327680;break};case 6:{k=d+f|0;l=327680;break};default:{k=0;l=0}}if((g|0)==0){g=a+40|0;f=c[g>>2]|0;d=a+56|0;j=a+60|0;b=c[284323]|0;i=c[d>>2]|0;h=b-i|0;m=b-f|0;b=ag(m,m)|0;m=ag((ag(h,h)|0)-b>>15,c[284324]|0)|0;h=c[a+80>>2]|0;n=e[875144+((h+(b>>>1)|0)>>>16<<1)>>1]|0;b=n-i|0;i=n-f|0;f=(c[j>>2]|0)-m-((e[1006216+(((b|0)<0?0:b)<<1)>>1]|0)-(e[1006216+(((i|0)<0?0:i)<<1)>>1]|0)<<15)|0;c[j>>2]=f;j=e[1137324+((f>>15)+32768<<1)>>1]|0;c[d>>2]=j;d=(f>>14)+j|0;c[a+52>>2]=d;j=a+36|0;f=c[j>>2]|0;i=a+44|0;b=a+48|0;m=c[284323]|0;n=c[i>>2]|0;o=m-n|0;p=m-f|0;m=ag(p,p)|0;p=ag((ag(o,o)|0)-m>>15,c[284324]|0)|0;o=e[875144+((h+(m>>>1)|0)>>>16<<1)>>1]|0;m=o-n|0;n=o-f|0;f=(c[b>>2]|0)-p-((e[1006216+(((m|0)<0?0:m)<<1)>>1]|0)-(e[1006216+(((n|0)<0?0:n)<<1)>>1]|0)<<15)|0;c[b>>2]=f;b=e[1137324+((f>>15)+32768<<1)>>1]|0;c[i>>2]=b;i=(f>>14)+b|0;c[g>>2]=i;c[j>>2]=e[1268396+(d+k+(e[3889836+(c[a+88>>2]<<17)+(i<<1)>>1]|0|l)<<1)>>1]|0;return}else{l=c[a+92>>2]|0;i=a+36|0;d=(ag(c[i>>2]>>4,l)|0)>>16;j=a+40|0;g=c[j>>2]|0;b=(ag(g>>4,l)|0)>>16;l=g-d|0;c[j>>2]=l;j=a+52|0;d=(c[j>>2]|0)-b|0;c[j>>2]=d;c[i>>2]=((ag(c[a+96>>2]|0,l)|0)>>10)-(d+k);return}}function st(a){a=a|0;var c=0,d=0;c=a|0;sy(c);d=a+84|0;rE(d);sB(c,0);rF(d,0);b[a+140>>1]=896;return}function su(a,c){a=a|0;c=c|0;sB(a|0,c);rF(a+84|0,c);b[a+140>>1]=(c|0)==0?896:2048;return}function sv(a,b){a=a|0;b=b|0;sA(a|0,b|0);return}function sw(a,b){a=a|0;b=b|0;sG(a|0,b);rH(a+84|0,b);return}function sx(a){a=a|0;sz(a|0);rG(a+84|0);return}function sy(d){d=d|0;var e=0,f=0,g=0,h=0;e=d+8|0;if(!(a[90600]|0)){c[e>>2]=0;f=0;g=0;do{b[165968+(f<<1)>>1]=4094;b[100432+(f<<1)>>1]=4094;h=(c[e>>2]^-(g>>>23&1))>>>11&4095;b[174160+(f<<1)>>1]=h;b[108624+(f<<1)>>1]=h;h=(c[e>>2]|0)>>>12&65535;b[182352+(f<<1)>>1]=h;b[116816+(f<<1)>>1]=h;b[198736+(f<<1)>>1]=4095;b[133200+(f<<1)>>1]=4095;g=(c[e>>2]|0)+4096|0;c[e>>2]=g;f=f+1|0;}while((f|0)<4096);rD(18184920,12,2.2,0);rD(18193112,12,2.0,1);a[90600]=1}c[d>>2]=d;c[d+76>>2]=0;c[e>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;a[d+12|0]=0;A2(d+52|0,0,16);c[d+80>>2]=100432;c[d+36>>2]=0;b[d+40>>1]=4095;b[d+46>>1]=4095;b[d+48>>1]=4095;c[d+24>>2]=8388607;c[d+28>>2]=0;b[d+42>>1]=4080;b[d+44>>1]=4095;c[d+32>>2]=0;c[d+68>>2]=0;c[d+72>>2]=0;return}function sz(d){d=d|0;c[d+8>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;a[d+12|0]=0;A2(d+52|0,0,16);c[d+80>>2]=100432+(c[d+76>>2]<<16);c[d+36>>2]=0;b[d+40>>1]=4095;b[d+46>>1]=4095;b[d+48>>1]=4095;c[d+24>>2]=8388607;c[d+28>>2]=0;b[d+42>>1]=4080;b[d+44>>1]=4095;c[d+32>>2]=0;c[d+68>>2]=0;c[d+72>>2]=0;return}function sA(a,b){a=a|0;b=b|0;c[a>>2]=b;c[b+4>>2]=a;return}function sB(a,b){a=a|0;b=b|0;c[a+76>>2]=b;c[a+80>>2]=100432+(b<<16)+((c[a+52>>2]&7)<<13);return}function sC(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[d>>2]=c[d>>2]&65280|b&255;return}function sD(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[d>>2]=c[d>>2]&255|b<<8&65280;return}function sE(a,d){a=a|0;d=d|0;var e=0,f=0;e=a+20|0;f=c[e>>2]&3840|d&255;c[e>>2]=f;b[a+48>>1]=(c[a+8>>2]|0)>>>12>>>0>=f>>>0?4095:0;return}function sF(a,d){a=a|0;d=d|0;var e=0,f=0;e=a+20|0;f=c[e>>2]&255|d<<8&3840;c[e>>2]=f;b[a+48>>1]=(c[a+8>>2]|0)>>>12>>>0>=f>>>0?4095:0;return}function sG(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a+52|0;f=c[e>>2]|0;g=a+56|0;h=c[g>>2]|0;i=d>>>4;j=i&15;c[e>>2]=j;e=d&8;c[g>>2]=e;c[a+60>>2]=d&4;c[a+64>>2]=d&2;c[a+80>>2]=100432+(c[a+76>>2]<<16)+((i&7)<<13);c[a+36>>2]=((d>>>5^1)&d>>>2)<<23&8388608;d=(i&8|0)!=0?0:4095;b[a+40>>1]=d;g=a+42|0;k=a+44|0;b[k>>1]=d|b[g>>1];b[a+46>>1]=(i&4|0)!=0?0:4095;i=(e|0)==0;do{if((h|0)==0){if(i){break}c[a+8>>2]=0;c[a+32>>2]=0;c[a+28>>2]=32768;b[a+48>>1]=4095}else{if(!i){break}e=a+24|0;l=c[e>>2]|0;m=l<<1&8388606;n=(l>>>17&1|m)^1;c[e>>2]=n;e=l>>>8&2048|l>>>7&1024|l>>>4&512|l>>>2&256|l>>>1&128|m<<1&64|m<<3&32|n<<4&16;b[g>>1]=e&65535;b[k>>1]=(e|d&65535)&65535}}while(0);if((j|0)!=0){sr(a);return}if((f|0)==0){return}c[a+72>>2]=16384;return}function sH(a){a=a|0;return(c[a+68>>2]|0)>>>4|0}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b|0;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;s2(873992,h,874120);c[218746]=92932;c[218748]=92952;c[218747]=0;t4(874992,873992);c[218766]=0;c[218767]=-1;j=c[q>>2]|0;c[218474]=92712;yq(873900);A2(873904,0,24);c[218474]=93080;c[218482]=j;yr(g,873900);k=yt(g,874320)|0;l=k;ys(g);c[218483]=l;c[218484]=874128;a[873940]=(da[c[(c[k>>2]|0)+28>>2]&255](l)|0)&1;c[218680]=92836;c[218681]=92856;t4(874724,873896);c[218699]=0;c[218700]=-1;l=c[u>>2]|0;c[218486]=92712;yq(873948);A2(873952,0,24);c[218486]=93080;c[218494]=l;yr(f,873948);k=yt(f,874320)|0;g=k;ys(f);c[218495]=g;c[218496]=874136;a[873988]=(da[c[(c[k>>2]|0)+28>>2]&255](g)|0)&1;c[218724]=92836;c[218725]=92856;t4(874900,873944);c[218743]=0;c[218744]=-1;g=c[(c[(c[218724]|0)-12>>2]|0)+874920>>2]|0;c[218702]=92836;c[218703]=92856;t4(874812,g);c[218721]=0;c[218722]=-1;c[(c[(c[218746]|0)-12>>2]|0)+875056>>2]=874720;g=(c[(c[218724]|0)-12>>2]|0)+874900|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[218724]|0)-12>>2]|0)+874968>>2]=874720;sQ(873840,h,874144);c[218658]=92884;c[218660]=92904;c[218659]=0;t4(874640,873840);c[218678]=0;c[218679]=-1;c[218436]=92640;yq(873748);A2(873752,0,24);c[218436]=93008;c[218444]=j;yr(e,873748);j=yt(e,874312)|0;h=j;ys(e);c[218445]=h;c[218446]=874152;a[873788]=(da[c[(c[j>>2]|0)+28>>2]&255](h)|0)&1;c[218588]=92788;c[218589]=92808;t4(874356,873744);c[218607]=0;c[218608]=-1;c[218448]=92640;yq(873796);A2(873800,0,24);c[218448]=93008;c[218456]=l;yr(d,873796);l=yt(d,874312)|0;h=l;ys(d);c[218457]=h;c[218458]=874160;a[873836]=(da[c[(c[l>>2]|0)+28>>2]&255](h)|0)&1;c[218632]=92788;c[218633]=92808;t4(874532,873792);c[218651]=0;c[218652]=-1;h=c[(c[(c[218632]|0)-12>>2]|0)+874552>>2]|0;c[218610]=92788;c[218611]=92808;t4(874444,h);c[218629]=0;c[218630]=-1;c[(c[(c[218658]|0)-12>>2]|0)+874704>>2]=874352;h=(c[(c[218632]|0)-12>>2]|0)+874532|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[218632]|0)-12>>2]|0)+874600>>2]=874352;i=b;return}function sJ(a){a=a|0;uB(874720)|0;uB(874808)|0;uH(874352)|0;uH(874440)|0;return}function sK(a){a=a|0;c[a>>2]=92640;ys(a+4|0);return}function sL(a){a=a|0;c[a>>2]=92640;ys(a+4|0);AT(a);return}function sM(b,d){b=b|0;d=d|0;var e=0;da[c[(c[b>>2]|0)+24>>2]&255](b)|0;e=yt(d,874312)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(da[c[(c[e>>2]|0)+28>>2]&255](d)|0)&1;return}function sN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=dj[c[(c[a>>2]|0)+20>>2]&127](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((aU(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5163;break}if((l|0)==2){m=-1;n=5165;break}else if((l|0)!=1){n=5161;break}}if((n|0)==5161){m=((aQ(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5163){i=b;return m|0}else if((n|0)==5165){i=b;return m|0}return 0}function sO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if((a[b+44|0]&1)!=0){f=aU(d|0,4,e|0,c[b+32>>2]|0)|0;return f|0}g=b;if((e|0)>0){h=d;i=0}else{f=0;return f|0}while(1){if((c7[c[(c[g>>2]|0)+52>>2]&255](b,c[h>>2]|0)|0)==-1){f=i;j=5175;break}d=i+1|0;if((d|0)<(e|0)){h=h+4|0;i=d}else{f=d;j=5173;break}}if((j|0)==5175){return f|0}else if((j|0)==5173){return f|0}return 0}function sP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L6603:do{if(!k){c[g>>2]=d;if((a[b+44|0]&1)!=0){if((aU(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=de[c[(c[u>>2]|0)+12>>2]&63](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=5188;break}if((v|0)==3){w=5182;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=5190;break}v=(c[h>>2]|0)-r|0;if((aU(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=5193;break}if(u){t=u?c[j>>2]|0:t}else{break L6603}}if((w|0)==5193){i=e;return l|0}else if((w|0)==5188){i=e;return l|0}else if((w|0)==5190){i=e;return l|0}else if((w|0)==5182){if((aU(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function sQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=92640;j=b+4|0;yq(j);A2(b+8|0,0,24);c[h>>2]=93408;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;yr(g,j);j=yt(g,874312)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=da[c[(c[j>>2]|0)+24>>2]&255](e)|0;e=c[d>>2]|0;a[b+53|0]=(da[c[(c[e>>2]|0)+28>>2]&255](e)|0)&1;if((c[h>>2]|0)<=8){ys(g);i=f;return}xM(77656);ys(g);i=f;return}function sR(a){a=a|0;c[a>>2]=92640;ys(a+4|0);return}function sS(a){a=a|0;c[a>>2]=92640;ys(a+4|0);AT(a);return}function sT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=yt(d,874312)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=da[c[(c[e>>2]|0)+24>>2]&255](d)|0;d=c[f>>2]|0;a[b+53|0]=(da[c[(c[d>>2]|0)+28>>2]&255](d)|0)&1;if((c[g>>2]|0)<=8){return}xM(77656);return}function sU(a){a=a|0;return sX(a,0)|0}function sV(a){a=a|0;return sX(a,1)|0}function sW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L6646:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f|0;q=de[c[(c[o>>2]|0)+12>>2]&63](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2]&255;c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L6646}r=o-1|0;c[g>>2]=r;if((ck(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function sX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]&1)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;L6666:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=be(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o&255;l=l+1|0;if((l|0)>=(k|0)){break L6666}}i=e;return n|0}}while(0);L6673:do{if((a[b+53|0]&1)==0){l=b+40|0;m=b+36|0;o=f|0;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=de[c[(c[t>>2]|0)+16>>2]&63](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=5239;break}else if((x|0)==2){n=-1;y=5248;break}else if((x|0)!=1){z=r;break L6673}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=5256;break}v=be(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=5253;break}a[w]=v&255;r=r+1|0}if((y|0)==5239){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==5248){i=e;return n|0}else if((y|0)==5256){i=e;return n|0}else if((y|0)==5253){i=e;return n|0}}else{c[g>>2]=a[f|0]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b-1|0;if((ck(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=5250;break}else{b=z}}if((y|0)==5250){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function sY(a){a=a|0;c[a>>2]=92712;ys(a+4|0);return}function sZ(a){a=a|0;c[a>>2]=92712;ys(a+4|0);AT(a);return}function s_(b,d){b=b|0;d=d|0;var e=0;da[c[(c[b>>2]|0)+24>>2]&255](b)|0;e=yt(d,874320)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(da[c[(c[e>>2]|0)+28>>2]&255](d)|0)&1;return}function s$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=dj[c[(c[a>>2]|0)+20>>2]&127](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((aU(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5267;break}if((l|0)==2){m=-1;n=5265;break}else if((l|0)!=1){n=5263;break}}if((n|0)==5265){i=b;return m|0}else if((n|0)==5263){m=((aQ(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5267){i=b;return m|0}return 0}function s0(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;if((a[b+44|0]&1)!=0){g=aU(e|0,1,f|0,c[b+32>>2]|0)|0;return g|0}h=b;if((f|0)>0){i=e;j=0}else{g=0;return g|0}while(1){if((c7[c[(c[h>>2]|0)+52>>2]&255](b,d[i]|0)|0)==-1){g=j;k=5276;break}e=j+1|0;if((e|0)<(f|0)){i=i+1|0;j=e}else{g=e;k=5274;break}}if((k|0)==5274){return g|0}else if((k|0)==5276){return g|0}return 0}function s1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L1:do{if(!k){a[g]=d&255;if((a[b+44|0]&1)!=0){if((aU(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=de[c[(c[u>>2]|0)+12>>2]&63](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=14;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=16;break}v=(c[h>>2]|0)-r|0;if((aU(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=17;break}if(u){t=u?c[j>>2]|0:t}else{break L1}}if((w|0)==7){if((aU(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==14){i=e;return l|0}else if((w|0)==16){i=e;return l|0}else if((w|0)==17){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function s2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=92712;j=b+4|0;yq(j);A2(b+8|0,0,24);c[h>>2]=93480;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;yr(g,j);j=yt(g,874320)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=da[c[(c[j>>2]|0)+24>>2]&255](e)|0;e=c[d>>2]|0;a[b+53|0]=(da[c[(c[e>>2]|0)+28>>2]&255](e)|0)&1;if((c[h>>2]|0)<=8){ys(g);i=f;return}xM(77656);ys(g);i=f;return}function s3(a){a=a|0;c[a>>2]=92712;ys(a+4|0);return}function s4(a){a=a|0;c[a>>2]=92712;ys(a+4|0);AT(a);return}function s5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=yt(d,874320)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=da[c[(c[e>>2]|0)+24>>2]&255](d)|0;d=c[f>>2]|0;a[b+53|0]=(da[c[(c[d>>2]|0)+28>>2]&255](d)|0)&1;if((c[g>>2]|0)<=8){return}xM(77656);return}function s6(a){a=a|0;return s9(a,0)|0}function s7(a){a=a|0;return s9(a,1)|0}function s8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L44:do{if(l){a[h]=c[n>>2]&255;o=c[b+36>>2]|0;p=f|0;q=de[c[(c[o>>2]|0)+12>>2]&63](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2]&255;c[g>>2]=f+1}else if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L44}r=o-1|0;c[g>>2]=r;if((ck(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function s9(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]&1)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;L64:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=be(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p&255;m=m+1|0;if((m|0)>=(l|0)){break L64}}i=f;return o|0}}while(0);L71:do{if((a[b+53|0]&1)==0){m=b+40|0;n=b+36|0;p=g|0;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=de[c[(c[u>>2]|0)+16>>2]&63](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=64;break}else if((y|0)==2){o=-1;z=76;break}else if((y|0)!=1){A=s;break L71}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=77;break}w=be(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=75;break}a[x]=w&255;s=s+1|0}if((z|0)==64){a[h]=a[p]|0;A=s;break}else if((z|0)==75){i=f;return o|0}else if((z|0)==76){i=f;return o|0}else if((z|0)==77){i=f;return o|0}}else{a[h]=a[g|0]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=71;break}j=k-1|0;if((ck(d[g+j|0]|0|0,c[l>>2]|0)|0)==-1){o=-1;z=80;break}else{k=j}}if((z|0)==71){B=a[h]|0;break}else if((z|0)==80){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function ta(){sI(0);bh(102,875072,r|0)|0;return}function tb(a){a=a|0;return}function tc(a){a=a|0;var b=0;b=a+4|0;I=c[b>>2]|0,c[b>>2]=I+1,I;return}function td(a){a=a|0;var b=0,d=0;b=a+4|0;if(((I=c[b>>2]|0,c[b>>2]=I+ -1,I)|0)!=0){d=0;return d|0}c4[c[(c[a>>2]|0)+8>>2]&511](a);d=1;return d|0}function te(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=90840;d=A1(b|0)|0;e=d+1|0;f=AS(d+13|0)|0;c[f+4>>2]=d;c[f>>2]=d;d=f+12|0;c[a+4>>2]=d;c[f+8>>2]=0;A$(d|0,b|0,e)|0;return}function tf(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=90840;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;AT(e);return}AU((c[b>>2]|0)-12|0);e=a;AT(e);return}function tg(a){a=a|0;var b=0;c[a>>2]=90840;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((I=c[a>>2]|0,c[a>>2]=I+ -1,I)-1|0)>=0){return}AU((c[b>>2]|0)-12|0);return}function th(a){a=a|0;return c[a+4>>2]|0}function ti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=90744;if((a[d]&1)==0){e=d+1|0}else{e=c[d+8>>2]|0}d=A1(e|0)|0;f=d+1|0;g=AS(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;d=g+12|0;c[b+4>>2]=d;c[g+8>>2]=0;A$(d|0,e|0,f)|0;return}function tj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=90744;d=A1(b|0)|0;e=d+1|0;f=AS(d+13|0)|0;c[f+4>>2]=d;c[f>>2]=d;d=f+12|0;c[a+4>>2]=d;c[f+8>>2]=0;A$(d|0,b|0,e)|0;return}function tk(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=90744;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;AT(e);return}AU((c[b>>2]|0)-12|0);e=a;AT(e);return}function tl(a){a=a|0;var b=0;c[a>>2]=90744;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((I=c[a>>2]|0,c[a>>2]=I+ -1,I)-1|0)>=0){return}AU((c[b>>2]|0)-12|0);return}function tm(a){a=a|0;return c[a+4>>2]|0}function tn(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=90840;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;AT(e);return}AU((c[b>>2]|0)-12|0);e=a;AT(e);return}function to(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=90840;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;AT(e);return}AU((c[b>>2]|0)-12|0);e=a;AT(e);return}function tp(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=90744;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;AT(e);return}AU((c[b>>2]|0)-12|0);e=a;AT(e);return}function tq(a){a=a|0;return}function tr(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function ts(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;dk[c[(c[a>>2]|0)+12>>2]&127](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function tt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((c[b+4>>2]|0)!=(a|0)){e=0;return e|0}e=(c[b>>2]|0)==(d|0);return e|0}function tu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;d=ce(e|0)|0;e=A1(d|0)|0;if(e>>>0>4294967279>>>0){tB(0)}if(e>>>0<11>>>0){a[b]=e<<1&255;f=b+1|0;A$(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=AR(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;A$(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function tv(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=f;j=i;i=i+12|0;i=i+7&-8;k=e|0;l=c[k>>2]|0;do{if((l|0)!=0){m=d[h]|0;if((m&1|0)==0){n=m>>>1}else{n=c[f+4>>2]|0}if((n|0)==0){o=l}else{tO(f,84664,2)|0;o=c[k>>2]|0}m=c[e+4>>2]|0;dk[c[(c[m>>2]|0)+24>>2]&127](j,m,o);m=j;p=a[m]|0;if((p&1)==0){q=j+1|0}else{q=c[j+8>>2]|0}r=p&255;if((r&1|0)==0){s=r>>>1}else{s=c[j+4>>2]|0}tO(f,q,s)|0;if((a[m]&1)==0){break}AT(c[j+8>>2]|0)}}while(0);j=b;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];A2(h|0,0,12);i=g;return}function tw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=d;d=i;i=i+8|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];g=f|0;h=f+16|0;j=A1(e|0)|0;if(j>>>0>4294967279>>>0){tB(0)}if(j>>>0<11>>>0){a[h]=j<<1&255;k=h+1|0}else{l=j+16&-16;m=AR(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}A$(k|0,e|0,j)|0;a[k+j|0]=0;tv(g,d,h);ti(b|0,g);if((a[g]&1)!=0){AT(c[g+8>>2]|0)}if((a[h]&1)!=0){AT(c[h+8>>2]|0)}c[b>>2]=92976;h=d;d=b+8|0;b=c[h+4>>2]|0;c[d>>2]=c[h>>2];c[d+4>>2]=b;i=f;return}function tx(a){a=a|0;tl(a|0);AT(a);return}function ty(a){a=a|0;tl(a|0);return}function tz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(a>>>0<212>>>0){b=99064;d=48;L210:while(1){e=d;while(1){if((e|0)==0){break L210}f=(e|0)/2|0;if((c[b+(f<<2)>>2]|0)>>>0<a>>>0){break}else{e=f}}b=b+(f+1<<2)|0;d=e-1-f|0}g=c[b>>2]|0;return g|0}if(a>>>0>4294967291>>>0){b=cJ(8)|0;tj(b,79408);c[b>>2]=90712;bQ(b|0,97104,64);return 0}b=(a>>>0)/210|0;f=b*210|0;d=a-f|0;a=98872;h=48;L223:while(1){i=h;while(1){if((i|0)==0){break L223}j=(i|0)/2|0;if((c[a+(j<<2)>>2]|0)>>>0<d>>>0){break}else{i=j}}a=a+(j+1<<2)|0;h=i-1-j|0}j=a-98872>>2;a=b;b=j;h=(c[98872+(j<<2)>>2]|0)+f|0;L230:while(1){f=5;while(1){j=c[99064+(f<<2)>>2]|0;d=(h>>>0)/(j>>>0)|0;if(d>>>0<j>>>0){g=h;k=313;break L230}e=f+1|0;if((h|0)==(ag(d,j)|0)){break}if(e>>>0<47>>>0){f=e}else{k=212;break}}L236:do{if((k|0)==212){k=0;if(h>>>0<44521>>>0){g=h;k=314;break L230}f=211;i=(h>>>0)/211|0;while(1){if((h|0)==(ag(i,f)|0)){break L236}e=f+10|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=316;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+12|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=317;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+16|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=318;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+18|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=319;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+22|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=320;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+28|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=321;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+30|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=322;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+36|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=323;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+40|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=324;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+42|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=325;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+46|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=326;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+52|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=327;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+58|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=328;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+60|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=329;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+66|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=330;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+70|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=331;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+72|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=332;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+78|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=333;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+82|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=334;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+88|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=335;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+96|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=336;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+100|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=337;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+102|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=338;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+106|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=339;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+108|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=340;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+112|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=341;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+120|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=342;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+126|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=343;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+130|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=344;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+136|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=345;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+138|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=346;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+142|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=347;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+148|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=348;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+150|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=349;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+156|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=350;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+162|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=351;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+166|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=352;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+168|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=353;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+172|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=354;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+178|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=355;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+180|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=356;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+186|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=357;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+190|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=358;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+192|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=359;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+196|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=360;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+198|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=361;break L230}if((h|0)==(ag(j,e)|0)){break L236}e=f+208|0;j=(h>>>0)/(e>>>0)|0;if(j>>>0<e>>>0){g=h;k=362;break L230}d=f+210|0;if((h|0)==(ag(j,e)|0)){break L236}e=(h>>>0)/(d>>>0)|0;if(e>>>0<d>>>0){g=h;k=315;break L230}else{f=d;i=e}}}}while(0);i=b+1|0;f=(i|0)==48;e=f?0:i;i=(f&1)+a|0;a=i;b=e;h=(c[98872+(e<<2)>>2]|0)+(i*210|0)|0}if((k|0)==313){return g|0}else if((k|0)==314){return g|0}else if((k|0)==315){return g|0}else if((k|0)==316){return g|0}else if((k|0)==317){return g|0}else if((k|0)==318){return g|0}else if((k|0)==319){return g|0}else if((k|0)==320){return g|0}else if((k|0)==321){return g|0}else if((k|0)==322){return g|0}else if((k|0)==323){return g|0}else if((k|0)==324){return g|0}else if((k|0)==325){return g|0}else if((k|0)==326){return g|0}else if((k|0)==327){return g|0}else if((k|0)==328){return g|0}else if((k|0)==329){return g|0}else if((k|0)==330){return g|0}else if((k|0)==331){return g|0}else if((k|0)==332){return g|0}else if((k|0)==333){return g|0}else if((k|0)==334){return g|0}else if((k|0)==335){return g|0}else if((k|0)==336){return g|0}else if((k|0)==337){return g|0}else if((k|0)==338){return g|0}else if((k|0)==339){return g|0}else if((k|0)==340){return g|0}else if((k|0)==341){return g|0}else if((k|0)==342){return g|0}else if((k|0)==343){return g|0}else if((k|0)==344){return g|0}else if((k|0)==345){return g|0}else if((k|0)==346){return g|0}else if((k|0)==347){return g|0}else if((k|0)==348){return g|0}else if((k|0)==349){return g|0}else if((k|0)==350){return g|0}else if((k|0)==351){return g|0}else if((k|0)==352){return g|0}else if((k|0)==353){return g|0}else if((k|0)==354){return g|0}else if((k|0)==355){return g|0}else if((k|0)==356){return g|0}else if((k|0)==357){return g|0}else if((k|0)==358){return g|0}else if((k|0)==359){return g|0}else if((k|0)==360){return g|0}else if((k|0)==361){return g|0}else if((k|0)==362){return g|0}return 0}function tA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e;if((c[a>>2]|0)==1){do{a6(874072,874048)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)!=0){f;return}c[a>>2]=1;g;c4[d&511](b);h;c[a>>2]=-1;i;b3(874072)|0;return}function tB(a){a=a|0;a=cJ(8)|0;te(a,78344);c[a>>2]=90808;bQ(a|0,97152,58)}function tC(a){a=a|0;a=cJ(8)|0;te(a,78344);c[a>>2]=90776;bQ(a|0,97136,28)}function tD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=d;if((a[e]&1)==0){f=b;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];return}e=c[d+8>>2]|0;f=c[d+4>>2]|0;if(f>>>0>4294967279>>>0){tB(0)}if(f>>>0<11>>>0){a[b]=f<<1&255;g=b+1|0}else{d=f+16&-16;h=AR(d)|0;c[b+8>>2]=h;c[b>>2]=d|1;c[b+4>>2]=f;g=h}A$(g|0,e|0,f)|0;a[g+f|0]=0;return}function tE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(e>>>0>4294967279>>>0){tB(0)}if(e>>>0<11>>>0){a[b]=e<<1&255;f=b+1|0;A$(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=AR(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;A$(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function tF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(d>>>0>4294967279>>>0){tB(0)}if(d>>>0<11>>>0){a[b]=d<<1&255;f=b+1|0}else{g=d+16&-16;h=AR(g)|0;c[b+8>>2]=h;c[b>>2]=g|1;c[b+4>>2]=d;f=h}A2(f|0,e|0,d|0);a[f+d|0]=0;return}function tG(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=a[d]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}if(i>>>0<e>>>0){tC(0)}if((g&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}d=j+e|0;j=i-e|0;e=j>>>0<f>>>0?j:f;if(e>>>0>4294967279>>>0){tB(0)}if(e>>>0<11>>>0){a[b]=e<<1&255;k=b+1|0;A$(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}else{f=e+16&-16;j=AR(f)|0;c[b+8>>2]=j;c[b>>2]=f|1;c[b+4>>2]=e;k=j;A$(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}}function tH(b){b=b|0;if((a[b]&1)==0){return}AT(c[b+8>>2]|0);return}function tI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((b|0)==(d|0)){return b|0}e=a[d]|0;if((e&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}g=e&255;if((g&1|0)==0){h=g>>>1}else{h=c[d+4>>2]|0}d=b;g=b;e=a[g]|0;if((e&1)==0){i=10;j=e}else{e=c[b>>2]|0;i=(e&-2)-1|0;j=e&255}if(i>>>0<h>>>0){e=j&255;if((e&1|0)==0){k=e>>>1}else{k=c[b+4>>2]|0}tP(b,i,h-i|0,k,0,k,h,f);return b|0}if((j&1)==0){l=d+1|0}else{l=c[b+8>>2]|0}A3(l|0,f|0,h|0);a[l+h|0]=0;if((a[g]&1)==0){a[g]=h<<1&255;return b|0}else{c[b+4>>2]=h;return b|0}return 0}function tJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=A1(d|0)|0;f=b;g=b;h=a[g]|0;if((h&1)==0){i=10;j=h}else{h=c[b>>2]|0;i=(h&-2)-1|0;j=h&255}if(i>>>0<e>>>0){h=j&255;if((h&1|0)==0){k=h>>>1}else{k=c[b+4>>2]|0}tP(b,i,e-i|0,k,0,k,e,d);return b|0}if((j&1)==0){l=f+1|0}else{l=c[b+8>>2]|0}A3(l|0,d|0,e|0);a[l+e|0]=0;if((a[g]&1)==0){a[g]=e<<1&255;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function tK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b;g=a[f]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[b+4>>2]|0}if(i>>>0<d>>>0){h=d-i|0;tL(b,h,e)|0;return}if((g&1)==0){a[b+1+d|0]=0;a[f]=d<<1&255;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;return}}function tL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((d|0)==0){return b|0}f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<d>>>0){tQ(b,h,d-h+j|0,j,j,0,0);k=a[f]|0}else{k=i}if((k&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}A2(l+j|0,e|0,d|0);e=j+d|0;if((a[f]&1)==0){a[f]=e<<1&255}else{c[b+4>>2]=e}a[l+e|0]=0;return b|0}function tM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(d>>>0>4294967279>>>0){tB(0)}e=b;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}g=j>>>0>d>>>0?j:d;if(g>>>0<11>>>0){k=11}else{k=g+16&-16}g=k-1|0;if((g|0)==(h|0)){return}if((g|0)==10){l=e+1|0;m=c[b+8>>2]|0;n=1;o=0}else{if(g>>>0>h>>>0){p=AR(k)|0}else{p=AR(k)|0}h=i&1;if(h<<24>>24==0){q=e+1|0}else{q=c[b+8>>2]|0}l=p;m=q;n=h<<24>>24!=0;o=1}h=i&255;if((h&1|0)==0){r=h>>>1}else{r=c[b+4>>2]|0}h=r+1|0;A$(l|0,m|0,h)|0;if(n){AT(m)}if(o){c[b>>2]=k|1;c[b+4>>2]=j;c[b+8>>2]=l;return}else{a[f]=j<<1&255;return}}function tN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=10}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){tQ(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2&255;j=b+1|0;k=g+1|0;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}}function tO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<e>>>0){tP(b,h,e-h+j|0,j,j,0,e,d);return b|0}if((e|0)==0){return b|0}if((i&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}i=k+j|0;A$(i|0,d|0,e)|0;d=j+e|0;if((a[f]&1)==0){a[f]=d<<1&255}else{c[b+4>>2]=d}a[k+d|0]=0;return b|0}function tP(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((-18-d|0)>>>0<e>>>0){tB(0)}if((a[b]&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<11>>>0){o=11;break}o=n+16&-16}else{o=-17}}while(0);e=AR(o)|0;if((g|0)!=0){A$(e|0,k|0,g)|0}if((i|0)!=0){n=e+g|0;A$(n|0,j|0,i)|0}j=f-h|0;if((j|0)!=(g|0)){f=j-g|0;n=e+(i+g)|0;l=k+(h+g)|0;A$(n|0,l|0,f)|0}if((d|0)==10){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}AT(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}function tQ(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((-17-d|0)>>>0<e>>>0){tB(0)}if((a[b]&1)==0){j=b+1|0}else{j=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<11>>>0){n=11;break}n=m+16&-16}else{n=-17}}while(0);e=AR(n)|0;if((g|0)!=0){A$(e|0,j|0,g)|0}m=f-h|0;if((m|0)!=(g|0)){f=m-g|0;m=e+(i+g)|0;i=j+(h+g)|0;A$(m|0,i|0,f)|0}if((d|0)==10){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}AT(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function tR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=b;h=a[g]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){tC(0);return 0}if((h&1)==0){k=10;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}if((k-j|0)>>>0<f>>>0){tP(b,k,j+f-k|0,j,d,0,f,e);return b|0}if((f|0)==0){return b|0}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}l=j-d|0;k=m+d|0;if((j|0)==(d|0)){n=e}else{do{if(k>>>0>e>>>0){o=e}else{if((m+j|0)>>>0<=e>>>0){o=e;break}o=e+f|0}}while(0);A3(m+(f+d)|0,k|0,l|0);n=o}A3(k|0,n|0,f|0);n=j+f|0;if((a[g]&1)==0){a[g]=n<<1&255}else{c[b+4>>2]=n}a[m+n|0]=0;return b|0}function tS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=b;i=a[h]|0;j=i&255;if((j&1|0)==0){k=j>>>1}else{k=c[b+4>>2]|0}if(k>>>0<d>>>0){tC(0);return 0}j=k-d|0;l=j>>>0<e>>>0?j:e;if((i&1)==0){m=10;n=i}else{i=c[b>>2]|0;m=(i&-2)-1|0;n=i&255}if((l-k+m|0)>>>0<g>>>0){tP(b,m,k+g-l-m|0,k,d,l,g,f);return b|0}if((n&1)==0){o=b+1|0}else{o=c[b+8>>2]|0}do{if((l|0)==(g|0)){p=d;q=f;r=g;s=g;t=652}else{n=j-l|0;if((j|0)==(l|0)){p=d;q=f;r=g;s=j;t=652;break}m=o+d|0;if(l>>>0>g>>>0){A3(m|0,f|0,g|0);A3(o+(g+d)|0,o+(l+d)|0,n|0);u=g;v=l;break}do{if(m>>>0<f>>>0){if((o+k|0)>>>0<=f>>>0){w=d;x=f;y=g;z=l;break}i=l+d|0;if((o+i|0)>>>0>f>>>0){A3(m|0,f|0,l|0);w=i;x=f+g|0;y=g-l|0;z=0;break}else{w=d;x=f+(g-l)|0;y=g;z=l;break}}else{w=d;x=f;y=g;z=l}}while(0);A3(o+(w+y)|0,o+(w+z)|0,n|0);p=w;q=x;r=y;s=z;t=652}}while(0);if((t|0)==652){A3(o+p|0,q|0,r|0);u=r;v=s}s=u-v+k|0;if((a[h]&1)==0){a[h]=s<<1&255}else{c[b+4>>2]=s}a[o+s|0]=0;return b|0}function tT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e>>>0>1073741807>>>0){tB(0)}if(e>>>0<2>>>0){a[b]=e<<1&255;f=b+4|0;g=Am(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}else{i=e+4&-4;j=AR(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=e;f=j;g=Am(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}}function tU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(d>>>0>1073741807>>>0){tB(0)}if(d>>>0<2>>>0){a[b]=d<<1&255;f=b+4|0;g=Ao(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}else{i=d+4&-4;j=AR(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=d;f=j;g=Ao(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}}function tV(b){b=b|0;if((a[b]&1)==0){return}AT(c[b+8>>2]|0);return}function tW(a,b){a=a|0;b=b|0;return tX(a,b,Al(b)|0)|0}function tX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=1;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}if(h>>>0<e>>>0){g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}t_(b,h,e-h|0,j,0,j,e,d);return b|0}if((i&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}An(k,d,e)|0;c[k+(e<<2)>>2]=0;if((a[f]&1)==0){a[f]=e<<1&255;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function tY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(d>>>0>1073741807>>>0){tB(0)}e=b;f=a[e]|0;if((f&1)==0){g=1;h=f}else{f=c[b>>2]|0;g=(f&-2)-1|0;h=f&255}f=h&255;if((f&1|0)==0){i=f>>>1}else{i=c[b+4>>2]|0}f=i>>>0>d>>>0?i:d;if(f>>>0<2>>>0){j=2}else{j=f+4&-4}f=j-1|0;if((f|0)==(g|0)){return}if((f|0)==1){k=b+4|0;l=c[b+8>>2]|0;m=1;n=0}else{d=j<<2;if(f>>>0>g>>>0){o=AR(d)|0}else{o=AR(d)|0}d=h&1;if(d<<24>>24==0){p=b+4|0}else{p=c[b+8>>2]|0}k=o;l=p;m=d<<24>>24!=0;n=1}d=k;k=h&255;if((k&1|0)==0){q=k>>>1}else{q=c[b+4>>2]|0}Am(d,l,q+1|0)|0;if(m){AT(l)}if(n){c[b>>2]=j|1;c[b+4>>2]=i;c[b+8>>2]=d;return}else{a[e]=i<<1&255;return}}function tZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=1}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){t$(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2&255;j=b+4|0;k=g+1|0;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}}function t_(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((1073741806-d|0)>>>0<e>>>0){tB(0)}if((a[b]&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<2>>>0){o=2;break}o=n+4&-4}else{o=1073741807}}while(0);e=AR(o<<2)|0;if((g|0)!=0){Am(e,k,g)|0}if((i|0)!=0){n=e+(g<<2)|0;Am(n,j,i)|0}j=f-h|0;if((j|0)!=(g|0)){f=j-g|0;n=e+(i+g<<2)|0;l=k+(h+g<<2)|0;Am(n,l,f)|0}if((d|0)==1){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}AT(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}function t$(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((1073741807-d|0)>>>0<e>>>0){tB(0)}if((a[b]&1)==0){j=b+4|0}else{j=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<2>>>0){n=2;break}n=m+4&-4}else{n=1073741807}}while(0);e=AR(n<<2)|0;if((g|0)!=0){Am(e,j,g)|0}m=f-h|0;if((m|0)!=(g|0)){f=m-g|0;m=e+(i+g<<2)|0;i=j+(h+g<<2)|0;Am(m,i,f)|0}if((d|0)==1){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}AT(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function t0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e|0;g=f;A2(g|0,0,12);tL(f,10,0)|0;h=f;j=a[g]|0;k=j&255;if((k&1|0)==0){l=k>>>1;m=f+4|0}else{k=f+4|0;l=c[k>>2]|0;m=k}k=h+1|0;n=f+8|0;o=l;l=j;while(1){p=bd(((l&1)==0?k:c[n>>2]|0)|0,o+1|0,77456,(j=i,i=i+8|0,c[j>>2]=d,j)|0)|0;i=j;if((p|0)>-1){if(p>>>0>o>>>0){q=p}else{break}}else{q=o<<1|1}j=a[g]|0;r=j&255;if((r&1|0)==0){s=r>>>1}else{s=c[m>>2]|0}do{if(s>>>0<q>>>0){r=q-s|0;tL(f,r,0)|0}else{if((j&1)==0){a[h+1+q|0]=0;a[g]=q<<1&255;break}else{a[(c[n>>2]|0)+q|0]=0;c[m>>2]=q;break}}}while(0);o=q;l=a[g]|0}l=a[g]|0;q=l&255;if((q&1|0)==0){t=q>>>1}else{t=c[m>>2]|0}if(t>>>0<p>>>0){q=p-t|0;tL(f,q,0)|0;u=b;c[u>>2]=c[g>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];i=e;return}if((l&1)==0){a[h+1+p|0]=0;a[g]=p<<1&255;u=b;c[u>>2]=c[g>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];i=e;return}else{a[(c[n>>2]|0)+p|0]=0;c[m>>2]=p;u=b;c[u>>2]=c[g>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];i=e;return}}function t1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;g=(c[b+24>>2]|0)==0;if(g){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((g&1|d)&c[b+20>>2]|0)==0){i=e;return}e=cJ(16)|0;do{if((a[18202488]|0)==0){if((bD(18202488)|0)==0){break}c[218272]=92304;bh(108,873088,r|0)|0}}while(0);b=Bc(873088,0,32)|0;c[f>>2]=b|1;c[f+4>>2]=K;tw(e,f,85560);c[e>>2]=91488;bQ(e|0,97696,56)}function t2(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=91464;b=c[a+40>>2]|0;d=a+32|0;e=a+36|0;if((b|0)!=0){f=b;do{f=f-1|0;dk[c[(c[d>>2]|0)+(f<<2)>>2]&127](0,a,c[(c[e>>2]|0)+(f<<2)>>2]|0);}while((f|0)!=0)}ys(a+28|0);AM(c[d>>2]|0);AM(c[e>>2]|0);AM(c[a+48>>2]|0);AM(c[a+60>>2]|0);return}function t3(a,b){a=a|0;b=b|0;yr(a,b+28|0);return}function t4(a,b){a=a|0;b=b|0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;A2(a+32|0,0,40);yq(a+28|0);return}function t5(a){a=a|0;c[a>>2]=92712;ys(a+4|0);AT(a);return}function t6(a){a=a|0;c[a>>2]=92712;ys(a+4|0);return}function t7(a,b){a=a|0;b=b|0;return}function t8(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function t9(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function ua(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function ub(a){a=a|0;return 0}function uc(a){a=a|0;return 0}function ud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=b;if((e|0)<=0){g=0;return g|0}h=b+12|0;i=b+16|0;j=d;d=0;while(1){k=c[h>>2]|0;if(k>>>0<(c[i>>2]|0)>>>0){c[h>>2]=k+1;l=a[k]|0}else{k=da[c[(c[f>>2]|0)+40>>2]&255](b)|0;if((k|0)==-1){g=d;m=851;break}l=k&255}a[j]=l;k=d+1|0;if((k|0)<(e|0)){j=j+1|0;d=k}else{g=k;m=850;break}}if((m|0)==850){return g|0}else if((m|0)==851){return g|0}return 0}function ue(a){a=a|0;return-1|0}function uf(a){a=a|0;var b=0,e=0;if((da[c[(c[a>>2]|0)+36>>2]&255](a)|0)==-1){b=-1;return b|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+1;b=d[a]|0;return b|0}function ug(a,b){a=a|0;b=b|0;return-1|0}function uh(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=b;if((f|0)<=0){h=0;return h|0}i=b+24|0;j=b+28|0;k=0;l=e;while(1){e=c[i>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){m=a[l]|0;c[i>>2]=e+1;a[e]=m}else{if((c7[c[(c[g>>2]|0)+52>>2]&255](b,d[l]|0)|0)==-1){h=k;n=867;break}}m=k+1|0;if((m|0)<(f|0)){k=m;l=l+1|0}else{h=m;n=868;break}}if((n|0)==867){return h|0}else if((n|0)==868){return h|0}return 0}function ui(a,b){a=a|0;b=b|0;return-1|0}function uj(a){a=a|0;c[a>>2]=92640;ys(a+4|0);AT(a);return}function uk(a){a=a|0;c[a>>2]=92640;ys(a+4|0);return}function ul(a,b){a=a|0;b=b|0;return}function um(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function un(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function uo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function up(a){a=a|0;return 0}function uq(a){a=a|0;return 0}function ur(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+12|0;h=a+16|0;i=b;b=0;while(1){j=c[g>>2]|0;if(j>>>0<(c[h>>2]|0)>>>0){c[g>>2]=j+4;k=c[j>>2]|0}else{j=da[c[(c[e>>2]|0)+40>>2]&255](a)|0;if((j|0)==-1){f=b;l=888;break}else{k=j}}c[i>>2]=k;j=b+1|0;if((j|0)<(d|0)){i=i+4|0;b=j}else{f=j;l=886;break}}if((l|0)==886){return f|0}else if((l|0)==888){return f|0}return 0}function us(a){a=a|0;return-1|0}function ut(a){a=a|0;var b=0,d=0;if((da[c[(c[a>>2]|0)+36>>2]&255](a)|0)==-1){b=-1;return b|0}d=a+12|0;a=c[d>>2]|0;c[d>>2]=a+4;b=c[a>>2]|0;return b|0}function uu(a,b){a=a|0;b=b|0;return-1|0}function uv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+24|0;h=a+28|0;i=0;j=b;while(1){b=c[g>>2]|0;if(b>>>0<(c[h>>2]|0)>>>0){k=c[j>>2]|0;c[g>>2]=b+4;c[b>>2]=k}else{if((c7[c[(c[e>>2]|0)+52>>2]&255](a,c[j>>2]|0)|0)==-1){f=i;l=903;break}}k=i+1|0;if((k|0)<(d|0)){i=k;j=j+4|0}else{f=k;l=904;break}}if((l|0)==903){return f|0}else if((l|0)==904){return f|0}return 0}function uw(a,b){a=a|0;b=b|0;return-1|0}function ux(a){a=a|0;t2(a+8|0);AT(a);return}function uy(a){a=a|0;t2(a+8|0);return}function uz(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;t2(b+(d+8)|0);AT(b+d|0);return}function uA(a){a=a|0;t2(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function uB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;if((k|0)!=0){uB(k)|0}a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;if((da[c[(c[k>>2]|0)+24>>2]&255](k)|0)!=-1){break}k=c[(c[f>>2]|0)-12>>2]|0;t1(h+k|0,c[h+(k+16)>>2]|1)}}while(0);uM(e);i=d;return b|0}function uC(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){return}else{a7()}}function uD(a){a=a|0;t2(a+8|0);AT(a);return}function uE(a){a=a|0;t2(a+8|0);return}function uF(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;t2(b+(d+8)|0);AT(b+d|0);return}function uG(a){a=a|0;t2(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function uH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;if((k|0)!=0){uH(k)|0}a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;if((da[c[(c[k>>2]|0)+24>>2]&255](k)|0)!=-1){break}k=c[(c[f>>2]|0)-12>>2]|0;t1(h+k|0,c[h+(k+16)>>2]|1)}}while(0);uT(e);i=d;return b|0}function uI(a){a=a|0;t2(a+4|0);AT(a);return}function uJ(a){a=a|0;t2(a+4|0);return}function uK(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;t2(b+(d+4)|0);AT(b+d|0);return}function uL(a){a=a|0;t2(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function uM(a){a=a|0;var b=0,d=0,e=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bJ()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;if((da[c[(c[e>>2]|0)+24>>2]&255](e)|0)!=-1){return}e=c[b>>2]|0;b=c[(c[e>>2]|0)-12>>2]|0;d=e;t1(d+b|0,c[d+(b+16)>>2]|1);return}function uN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;if((p|0)!=0){uB(p)|0}a[l]=1;yr(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=yt(j,874272)|0;ys(j);q=c[(c[m>>2]|0)-12>>2]|0;r=c[o+(q+24)>>2]|0;s=o+(q+76)|0;t=c[s>>2]|0;if((t|0)==-1){yr(g,o+(q+28)|0);u=yt(g,874624)|0;v=c7[c[(c[u>>2]|0)+28>>2]&255](u,32)|0;ys(g);c[s>>2]=v<<24>>24;w=v}else{w=t&255}t=c[(c[p>>2]|0)+16>>2]|0;c[f>>2]=r;dh[t&63](k,p,f,o+q|0,w,d);if((c[k>>2]|0)!=0){break}q=c[(c[m>>2]|0)-12>>2]|0;t1(o+q|0,c[o+(q+16)>>2]|5)}}while(0);uM(h);i=e;return b|0}function uO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;if((p|0)!=0){uB(p)|0}a[l]=1;yr(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=yt(j,874272)|0;ys(j);q=c[(c[m>>2]|0)-12>>2]|0;r=c[o+(q+24)>>2]|0;s=o+(q+76)|0;t=c[s>>2]|0;if((t|0)==-1){yr(g,o+(q+28)|0);u=yt(g,874624)|0;v=c7[c[(c[u>>2]|0)+28>>2]&255](u,32)|0;ys(g);c[s>>2]=v<<24>>24;w=v}else{w=t&255}t=c[(c[p>>2]|0)+40>>2]|0;c[f>>2]=r;dh[t&63](k,p,f,o+q|0,w,d);if((c[k>>2]|0)!=0){break}q=c[(c[m>>2]|0)-12>>2]|0;t1(o+q|0,c[o+(q+16)>>2]|5)}}while(0);uM(h);i=e;return b|0}function uP(a){a=a|0;t2(a+4|0);AT(a);return}function uQ(a){a=a|0;t2(a+4|0);return}function uR(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;t2(b+(d+4)|0);AT(b+d|0);return}function uS(a){a=a|0;t2(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function uT(a){a=a|0;var b=0,d=0,e=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bJ()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;if((da[c[(c[e>>2]|0)+24>>2]&255](e)|0)!=-1){return}e=c[b>>2]|0;b=c[(c[e>>2]|0)-12>>2]|0;d=e;t1(d+b|0,c[d+(b+16)>>2]|1);return}function uU(a){a=a|0;return 88120}function uV(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)==1){tE(a,89168,35);return}else{tu(a,b|0,c);return}}function uW(a){a=a|0;tq(a|0);return}function uX(a){a=a|0;ty(a|0);AT(a);return}function uY(a){a=a|0;ty(a|0);return}function uZ(a){a=a|0;t2(a);AT(a);return}function u_(a){a=a|0;tq(a|0);AT(a);return}function u$(a){a=a|0;tb(a|0);AT(a);return}function u0(a){a=a|0;tb(a|0);return}function u1(a){a=a|0;tb(a|0);return}function u2(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1169:do{if((e|0)==(f|0)){g=c}else{b=c;h=e;while(1){if((b|0)==(d|0)){i=-1;j=1074;break}k=a[b]|0;l=a[h]|0;if(k<<24>>24<l<<24>>24){i=-1;j=1072;break}if(l<<24>>24<k<<24>>24){i=1;j=1073;break}k=b+1|0;l=h+1|0;if((l|0)==(f|0)){g=k;break L1169}else{b=k;h=l}}if((j|0)==1072){return i|0}else if((j|0)==1074){return i|0}else if((j|0)==1073){return i|0}}}while(0);i=(g|0)!=(d|0)|0;return i|0}function u3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;if(g>>>0>4294967279>>>0){tB(b)}if(g>>>0<11>>>0){a[b]=g<<1&255;h=b+1|0}else{i=g+16&-16;j=AR(i)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=g;h=j}if((e|0)==(f|0)){k=h;a[k]=0;return}j=f+(-d|0)|0;d=h;g=e;while(1){a[d]=a[g]|0;e=g+1|0;if((e|0)==(f|0)){break}else{d=d+1|0;g=e}}k=h+j|0;a[k]=0;return}function u4(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if((c|0)==(d|0)){e=0;return e|0}else{f=c;g=0}while(1){c=(a[f]|0)+(g<<4)|0;b=c&-268435456;h=(b>>>24|b)^c;c=f+1|0;if((c|0)==(d|0)){e=h;break}else{f=c;g=h}}return e|0}function u5(a){a=a|0;tb(a|0);AT(a);return}function u6(a){a=a|0;tb(a|0);return}function u7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1205:do{if((e|0)==(f|0)){g=b;h=1100}else{a=b;i=e;while(1){if((a|0)==(d|0)){j=-1;break L1205}k=c[a>>2]|0;l=c[i>>2]|0;if((k|0)<(l|0)){j=-1;break L1205}if((l|0)<(k|0)){j=1;break L1205}k=a+4|0;l=i+4|0;if((l|0)==(f|0)){g=k;h=1100;break}else{a=k;i=l}}}}while(0);if((h|0)==1100){j=(g|0)!=(d|0)|0}return j|0}function u8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;h=g>>2;if(h>>>0>1073741807>>>0){tB(b)}if(h>>>0<2>>>0){a[b]=g>>>1&255;i=b+4|0}else{g=h+4&-4;j=AR(g<<2)|0;c[b+8>>2]=j;c[b>>2]=g|1;c[b+4>>2]=h;i=j}if((e|0)==(f|0)){k=i;c[k>>2]=0;return}j=(f-4+(-d|0)|0)>>>2;d=i;h=e;while(1){c[d>>2]=c[h>>2];e=h+4|0;if((e|0)==(f|0)){break}else{d=d+4|0;h=e}}k=i+(j+1<<2)|0;c[k>>2]=0;return}function u9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=0;return e|0}else{f=b;g=0}while(1){b=(c[f>>2]|0)+(g<<4)|0;a=b&-268435456;h=(a>>>24|a)^b;b=f+4|0;if((b|0)==(d|0)){e=h;break}else{f=b;g=h}}return e|0}function va(a){a=a|0;tb(a|0);AT(a);return}function vb(a){a=a|0;tb(a|0);return}function vc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];db[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==1){a[j]=1}else if((w|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}t3(r,g);q=r|0;r=c[q>>2]|0;if((c[218656]|0)!=-1){c[m>>2]=874624;c[m+4>>2]=36;c[m+8>>2]=0;tA(874624,m,144)}m=(c[218657]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;n=c[q>>2]|0;td(n)|0;t3(s,g);n=s|0;p=c[n>>2]|0;if((c[218560]|0)!=-1){c[l>>2]=874240;c[l+4>>2]=36;c[l+8>>2]=0;tA(874240,l,144)}d=(c[218561]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){x=c[v+(d<<2)>>2]|0;if((x|0)==0){break}y=x;z=c[n>>2]|0;td(z)|0;z=t|0;A=x;c5[c[(c[A>>2]|0)+24>>2]&255](z,y);c5[c[(c[A>>2]|0)+28>>2]&255](t+12|0,y);c[u>>2]=c[f>>2];a[j]=(vd(e,u,z,t+24|0,o,h,1)|0)==(z|0)|0;c[b>>2]=c[e>>2];tH(t+12|0);tH(t|0);i=k;return}}while(0);o=cJ(4)|0;Aq(o);bQ(o|0,97088,288)}}while(0);k=cJ(4)|0;Aq(k);bQ(k|0,97088,288)}function vd(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=AL(m)|0;if((o|0)!=0){p=o;q=o;break}AY();p=0;q=0}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){r=m;s=0}else{o=m;m=0;t=p;u=f;while(1){v=d[u]|0;if((v&1|0)==0){w=v>>>1}else{w=c[u+4>>2]|0}if((w|0)==0){a[t]=2;x=m+1|0;y=o-1|0}else{a[t]=1;x=m;y=o}v=u+12|0;if((v|0)==(g|0)){r=y;s=x;break}else{o=y;m=x;t=t+1|0;u=v}}}u=b|0;b=e|0;e=h;t=0;x=s;s=r;while(1){r=c[u>>2]|0;do{if((r|0)==0){z=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){z=r;break}if((da[c[(c[r>>2]|0)+36>>2]&255](r)|0)==-1){c[u>>2]=0;z=0;break}else{z=c[u>>2]|0;break}}}while(0);r=(z|0)==0;m=c[b>>2]|0;if((m|0)==0){A=z;B=0}else{do{if((c[m+12>>2]|0)==(c[m+16>>2]|0)){if((da[c[(c[m>>2]|0)+36>>2]&255](m)|0)!=-1){C=m;break}c[b>>2]=0;C=0}else{C=m}}while(0);A=c[u>>2]|0;B=C}D=(B|0)==0;if(!((r^D)&(s|0)!=0)){break}m=c[A+12>>2]|0;if((m|0)==(c[A+16>>2]|0)){E=(da[c[(c[A>>2]|0)+36>>2]&255](A)|0)&255}else{E=a[m]|0}if(k){F=E}else{F=c7[c[(c[e>>2]|0)+12>>2]&255](h,E)|0}do{if(n){G=x;H=s}else{m=t+1|0;L1313:do{if(k){y=s;o=x;w=p;v=0;I=f;while(1){do{if((a[w]|0)==1){J=I;if((a[J]&1)==0){K=I+1|0}else{K=c[I+8>>2]|0}if(F<<24>>24!=(a[K+t|0]|0)){a[w]=0;L=v;M=o;N=y-1|0;break}O=d[J]|0;if((O&1|0)==0){P=O>>>1}else{P=c[I+4>>2]|0}if((P|0)!=(m|0)){L=1;M=o;N=y;break}a[w]=2;L=1;M=o+1|0;N=y-1|0}else{L=v;M=o;N=y}}while(0);O=I+12|0;if((O|0)==(g|0)){Q=N;R=M;S=L;break L1313}y=N;o=M;w=w+1|0;v=L;I=O}}else{I=s;v=x;w=p;o=0;y=f;while(1){do{if((a[w]|0)==1){O=y;if((a[O]&1)==0){T=y+1|0}else{T=c[y+8>>2]|0}if(F<<24>>24!=(c7[c[(c[e>>2]|0)+12>>2]&255](h,a[T+t|0]|0)|0)<<24>>24){a[w]=0;U=o;V=v;W=I-1|0;break}J=d[O]|0;if((J&1|0)==0){X=J>>>1}else{X=c[y+4>>2]|0}if((X|0)!=(m|0)){U=1;V=v;W=I;break}a[w]=2;U=1;V=v+1|0;W=I-1|0}else{U=o;V=v;W=I}}while(0);J=y+12|0;if((J|0)==(g|0)){Q=W;R=V;S=U;break L1313}I=W;v=V;w=w+1|0;o=U;y=J}}}while(0);if(!S){G=R;H=Q;break}m=c[u>>2]|0;y=m+12|0;o=c[y>>2]|0;if((o|0)==(c[m+16>>2]|0)){w=c[(c[m>>2]|0)+40>>2]|0;da[w&255](m)|0}else{c[y>>2]=o+1}if((R+Q|0)>>>0<2>>>0|n){G=R;H=Q;break}o=t+1|0;y=R;m=p;w=f;while(1){do{if((a[m]|0)==2){v=d[w]|0;if((v&1|0)==0){Y=v>>>1}else{Y=c[w+4>>2]|0}if((Y|0)==(o|0)){Z=y;break}a[m]=0;Z=y-1|0}else{Z=y}}while(0);v=w+12|0;if((v|0)==(g|0)){G=Z;H=Q;break}else{y=Z;m=m+1|0;w=v}}}}while(0);t=t+1|0;x=G;s=H}do{if((A|0)==0){_=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){_=A;break}if((da[c[(c[A>>2]|0)+36>>2]&255](A)|0)==-1){c[u>>2]=0;_=0;break}else{_=c[u>>2]|0;break}}}while(0);u=(_|0)==0;do{if(D){$=1244}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(u){break}else{$=1246;break}}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)==-1){c[b>>2]=0;$=1244;break}else{if(u^(B|0)==0){break}else{$=1246;break}}}}while(0);if(($|0)==1244){if(u){$=1246}}if(($|0)==1246){c[j>>2]=c[j>>2]|2}L1392:do{if(n){$=1251}else{u=f;B=p;while(1){if((a[B]|0)==2){aa=u;break L1392}b=u+12|0;if((b|0)==(g|0)){$=1251;break L1392}u=b;B=B+1|0}}}while(0);if(($|0)==1251){c[j>>2]=c[j>>2]|4;aa=g}if((q|0)==0){i=l;return aa|0}AM(q);i=l;return aa|0}function ve(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vf(a,0,j,k,f,g,h);i=b;return}function vf(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;vX(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=a[m]|0;m=w;w=c[h>>2]|0;L1416:while(1){do{if((w|0)==0){B=0}else{if((c[w+12>>2]|0)!=(c[w+16>>2]|0)){B=w;break}if((da[c[(c[w>>2]|0)+36>>2]&255](w)|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);C=(B|0)==0;D=c[f>>2]|0;do{if((D|0)==0){E=1279}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(C){F=D;G=0;break}else{H=m;I=D;J=0;break L1416}}if((da[c[(c[D>>2]|0)+36>>2]&255](D)|0)==-1){c[f>>2]=0;E=1279;break}else{K=(D|0)==0;if(C^K){F=D;G=K;break}else{H=m;I=D;J=K;break L1416}}}}while(0);if((E|0)==1279){E=0;if(C){H=m;I=0;J=1;break}else{F=0;G=1}}D=d[p]|0;K=(D&1|0)==0;if(((c[q>>2]|0)-m|0)==((K?D>>>1:c[z>>2]|0)|0)){if(K){L=D>>>1;M=D>>>1}else{D=c[z>>2]|0;L=D;M=D}tK(o,L<<1,0);if((a[p]&1)==0){N=10}else{N=(c[g>>2]&-2)-1|0}tK(o,N,0);if((a[p]&1)==0){O=x}else{O=c[y>>2]|0}c[q>>2]=O+M;P=O}else{P=m}D=B+12|0;K=c[D>>2]|0;Q=B+16|0;if((K|0)==(c[Q>>2]|0)){R=(da[c[(c[B>>2]|0)+36>>2]&255](B)|0)&255}else{R=a[K]|0}if((vx(R,v,P,q,t,A,n,l,s,u)|0)!=0){H=P;I=F;J=G;break}K=c[D>>2]|0;if((K|0)==(c[Q>>2]|0)){Q=c[(c[B>>2]|0)+40>>2]|0;da[Q&255](B)|0;m=P;w=B;continue}else{c[D>>2]=K+1;m=P;w=B;continue}}w=d[n]|0;if((w&1|0)==0){S=w>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}P=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=P}}while(0);c[k>>2]=z4(H,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(C){T=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){T=B;break}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){T=B;break}c[h>>2]=0;T=0}}while(0);h=(T|0)==0;L1476:do{if(J){E=1320}else{do{if((c[I+12>>2]|0)==(c[I+16>>2]|0)){if((da[c[(c[I>>2]|0)+36>>2]&255](I)|0)!=-1){break}c[f>>2]=0;E=1320;break L1476}}while(0);if(!(h^(I|0)==0)){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);do{if((E|0)==1320){if(h){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}function vg(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vh(a,0,j,k,f,g,h);i=b;return}function vh(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==64){v=8}else if((u|0)==0){v=0}else{v=10}u=l|0;vX(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=a[m]|0;m=w;w=c[h>>2]|0;L1501:while(1){do{if((w|0)==0){B=0}else{if((c[w+12>>2]|0)!=(c[w+16>>2]|0)){B=w;break}if((da[c[(c[w>>2]|0)+36>>2]&255](w)|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);C=(B|0)==0;D=c[f>>2]|0;do{if((D|0)==0){E=1348}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(C){F=D;G=0;break}else{H=m;I=D;J=0;break L1501}}if((da[c[(c[D>>2]|0)+36>>2]&255](D)|0)==-1){c[f>>2]=0;E=1348;break}else{L=(D|0)==0;if(C^L){F=D;G=L;break}else{H=m;I=D;J=L;break L1501}}}}while(0);if((E|0)==1348){E=0;if(C){H=m;I=0;J=1;break}else{F=0;G=1}}D=d[p]|0;L=(D&1|0)==0;if(((c[q>>2]|0)-m|0)==((L?D>>>1:c[z>>2]|0)|0)){if(L){M=D>>>1;N=D>>>1}else{D=c[z>>2]|0;M=D;N=D}tK(o,M<<1,0);if((a[p]&1)==0){O=10}else{O=(c[g>>2]&-2)-1|0}tK(o,O,0);if((a[p]&1)==0){P=x}else{P=c[y>>2]|0}c[q>>2]=P+N;Q=P}else{Q=m}D=B+12|0;L=c[D>>2]|0;R=B+16|0;if((L|0)==(c[R>>2]|0)){S=(da[c[(c[B>>2]|0)+36>>2]&255](B)|0)&255}else{S=a[L]|0}if((vx(S,v,Q,q,t,A,n,l,s,u)|0)!=0){H=Q;I=F;J=G;break}L=c[D>>2]|0;if((L|0)==(c[R>>2]|0)){R=c[(c[B>>2]|0)+40>>2]|0;da[R&255](B)|0;m=Q;w=B;continue}else{c[D>>2]=L+1;m=Q;w=B;continue}}w=d[n]|0;if((w&1|0)==0){T=w>>>1}else{T=c[n+4>>2]|0}do{if((T|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}Q=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=Q}}while(0);t=z3(H,c[q>>2]|0,j,v)|0;c[k>>2]=t;c[k+4>>2]=K;xQ(n,l,c[s>>2]|0,j);do{if(C){U=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){U=B;break}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){U=B;break}c[h>>2]=0;U=0}}while(0);h=(U|0)==0;L1561:do{if(J){E=1389}else{do{if((c[I+12>>2]|0)==(c[I+16>>2]|0)){if((da[c[(c[I>>2]|0)+36>>2]&255](I)|0)!=-1){break}c[f>>2]=0;E=1389;break L1561}}while(0);if(!(h^(I|0)==0)){break}V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}}while(0);do{if((E|0)==1389){if(h){break}V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}function vi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vj(a,0,j,k,f,g,h);i=b;return}function vj(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f=i;i=i+72|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+32|0;o=f+40|0;p=f+56|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==0){w=0}else if((v|0)==64){w=8}else if((v|0)==8){w=16}else{w=10}v=m|0;vX(o,j,v,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){m=j+1|0;x=m;y=m;z=p+8|0}else{m=p+8|0;x=c[m>>2]|0;y=j+1|0;z=m}c[r>>2]=x;m=s|0;c[t>>2]=m;c[u>>2]=0;j=g|0;g=h|0;h=p|0;A=p+4|0;B=a[n]|0;n=x;x=c[j>>2]|0;L1586:while(1){do{if((x|0)==0){C=0}else{if((c[x+12>>2]|0)!=(c[x+16>>2]|0)){C=x;break}if((da[c[(c[x>>2]|0)+36>>2]&255](x)|0)!=-1){C=x;break}c[j>>2]=0;C=0}}while(0);D=(C|0)==0;E=c[g>>2]|0;do{if((E|0)==0){F=1417}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(D){G=E;H=0;break}else{I=n;J=E;K=0;break L1586}}if((da[c[(c[E>>2]|0)+36>>2]&255](E)|0)==-1){c[g>>2]=0;F=1417;break}else{L=(E|0)==0;if(D^L){G=E;H=L;break}else{I=n;J=E;K=L;break L1586}}}}while(0);if((F|0)==1417){F=0;if(D){I=n;J=0;K=1;break}else{G=0;H=1}}E=d[q]|0;L=(E&1|0)==0;if(((c[r>>2]|0)-n|0)==((L?E>>>1:c[A>>2]|0)|0)){if(L){M=E>>>1;N=E>>>1}else{E=c[A>>2]|0;M=E;N=E}tK(p,M<<1,0);if((a[q]&1)==0){O=10}else{O=(c[h>>2]&-2)-1|0}tK(p,O,0);if((a[q]&1)==0){P=y}else{P=c[z>>2]|0}c[r>>2]=P+N;Q=P}else{Q=n}E=C+12|0;L=c[E>>2]|0;R=C+16|0;if((L|0)==(c[R>>2]|0)){S=(da[c[(c[C>>2]|0)+36>>2]&255](C)|0)&255}else{S=a[L]|0}if((vx(S,w,Q,r,u,B,o,m,t,v)|0)!=0){I=Q;J=G;K=H;break}L=c[E>>2]|0;if((L|0)==(c[R>>2]|0)){R=c[(c[C>>2]|0)+40>>2]|0;da[R&255](C)|0;n=Q;x=C;continue}else{c[E>>2]=L+1;n=Q;x=C;continue}}x=d[o]|0;if((x&1|0)==0){T=x>>>1}else{T=c[o+4>>2]|0}do{if((T|0)!=0){x=c[t>>2]|0;if((x-s|0)>=160){break}Q=c[u>>2]|0;c[t>>2]=x+4;c[x>>2]=Q}}while(0);b[l>>1]=z2(I,c[r>>2]|0,k,w)|0;xQ(o,m,c[t>>2]|0,k);do{if(D){U=0}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){U=C;break}if((da[c[(c[C>>2]|0)+36>>2]&255](C)|0)!=-1){U=C;break}c[j>>2]=0;U=0}}while(0);j=(U|0)==0;L1646:do{if(K){F=1458}else{do{if((c[J+12>>2]|0)==(c[J+16>>2]|0)){if((da[c[(c[J>>2]|0)+36>>2]&255](J)|0)!=-1){break}c[g>>2]=0;F=1458;break L1646}}while(0);if(!(j^(J|0)==0)){break}V=e|0;c[V>>2]=U;tH(p);tH(o);i=f;return}}while(0);do{if((F|0)==1458){if(j){break}V=e|0;c[V>>2]=U;tH(p);tH(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;V=e|0;c[V>>2]=U;tH(p);tH(o);i=f;return}function vk(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vl(a,0,j,k,f,g,h);i=b;return}function vl(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;vX(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=a[m]|0;m=w;w=c[h>>2]|0;L1671:while(1){do{if((w|0)==0){B=0}else{if((c[w+12>>2]|0)!=(c[w+16>>2]|0)){B=w;break}if((da[c[(c[w>>2]|0)+36>>2]&255](w)|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);C=(B|0)==0;D=c[f>>2]|0;do{if((D|0)==0){E=1486}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(C){F=D;G=0;break}else{H=m;I=D;J=0;break L1671}}if((da[c[(c[D>>2]|0)+36>>2]&255](D)|0)==-1){c[f>>2]=0;E=1486;break}else{K=(D|0)==0;if(C^K){F=D;G=K;break}else{H=m;I=D;J=K;break L1671}}}}while(0);if((E|0)==1486){E=0;if(C){H=m;I=0;J=1;break}else{F=0;G=1}}D=d[p]|0;K=(D&1|0)==0;if(((c[q>>2]|0)-m|0)==((K?D>>>1:c[z>>2]|0)|0)){if(K){L=D>>>1;M=D>>>1}else{D=c[z>>2]|0;L=D;M=D}tK(o,L<<1,0);if((a[p]&1)==0){N=10}else{N=(c[g>>2]&-2)-1|0}tK(o,N,0);if((a[p]&1)==0){O=x}else{O=c[y>>2]|0}c[q>>2]=O+M;P=O}else{P=m}D=B+12|0;K=c[D>>2]|0;Q=B+16|0;if((K|0)==(c[Q>>2]|0)){R=(da[c[(c[B>>2]|0)+36>>2]&255](B)|0)&255}else{R=a[K]|0}if((vx(R,v,P,q,t,A,n,l,s,u)|0)!=0){H=P;I=F;J=G;break}K=c[D>>2]|0;if((K|0)==(c[Q>>2]|0)){Q=c[(c[B>>2]|0)+40>>2]|0;da[Q&255](B)|0;m=P;w=B;continue}else{c[D>>2]=K+1;m=P;w=B;continue}}w=d[n]|0;if((w&1|0)==0){S=w>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}P=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=P}}while(0);c[k>>2]=z1(H,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(C){T=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){T=B;break}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){T=B;break}c[h>>2]=0;T=0}}while(0);h=(T|0)==0;L1731:do{if(J){E=1527}else{do{if((c[I+12>>2]|0)==(c[I+16>>2]|0)){if((da[c[(c[I>>2]|0)+36>>2]&255](I)|0)!=-1){break}c[f>>2]=0;E=1527;break L1731}}while(0);if(!(h^(I|0)==0)){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);do{if((E|0)==1527){if(h){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}function vm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vn(a,0,j,k,f,g,h);i=b;return}function vn(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;vX(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=a[m]|0;m=w;w=c[h>>2]|0;L1756:while(1){do{if((w|0)==0){B=0}else{if((c[w+12>>2]|0)!=(c[w+16>>2]|0)){B=w;break}if((da[c[(c[w>>2]|0)+36>>2]&255](w)|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);C=(B|0)==0;D=c[f>>2]|0;do{if((D|0)==0){E=1555}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(C){F=D;G=0;break}else{H=m;I=D;J=0;break L1756}}if((da[c[(c[D>>2]|0)+36>>2]&255](D)|0)==-1){c[f>>2]=0;E=1555;break}else{K=(D|0)==0;if(C^K){F=D;G=K;break}else{H=m;I=D;J=K;break L1756}}}}while(0);if((E|0)==1555){E=0;if(C){H=m;I=0;J=1;break}else{F=0;G=1}}D=d[p]|0;K=(D&1|0)==0;if(((c[q>>2]|0)-m|0)==((K?D>>>1:c[z>>2]|0)|0)){if(K){L=D>>>1;M=D>>>1}else{D=c[z>>2]|0;L=D;M=D}tK(o,L<<1,0);if((a[p]&1)==0){N=10}else{N=(c[g>>2]&-2)-1|0}tK(o,N,0);if((a[p]&1)==0){O=x}else{O=c[y>>2]|0}c[q>>2]=O+M;P=O}else{P=m}D=B+12|0;K=c[D>>2]|0;Q=B+16|0;if((K|0)==(c[Q>>2]|0)){R=(da[c[(c[B>>2]|0)+36>>2]&255](B)|0)&255}else{R=a[K]|0}if((vx(R,v,P,q,t,A,n,l,s,u)|0)!=0){H=P;I=F;J=G;break}K=c[D>>2]|0;if((K|0)==(c[Q>>2]|0)){Q=c[(c[B>>2]|0)+40>>2]|0;da[Q&255](B)|0;m=P;w=B;continue}else{c[D>>2]=K+1;m=P;w=B;continue}}w=d[n]|0;if((w&1|0)==0){S=w>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}P=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=P}}while(0);c[k>>2]=z0(H,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(C){T=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){T=B;break}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){T=B;break}c[h>>2]=0;T=0}}while(0);h=(T|0)==0;L1816:do{if(J){E=1596}else{do{if((c[I+12>>2]|0)==(c[I+16>>2]|0)){if((da[c[(c[I>>2]|0)+36>>2]&255](I)|0)!=-1){break}c[f>>2]=0;E=1596;break L1816}}while(0);if(!(h^(I|0)==0)){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);do{if((E|0)==1596){if(h){break}U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;U=b|0;c[U>>2]=T;tH(o);tH(n);i=e;return}function vo(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vp(a,0,j,k,f,g,h);i=b;return}function vp(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;vX(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=a[m]|0;m=w;w=c[h>>2]|0;L1841:while(1){do{if((w|0)==0){B=0}else{if((c[w+12>>2]|0)!=(c[w+16>>2]|0)){B=w;break}if((da[c[(c[w>>2]|0)+36>>2]&255](w)|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);C=(B|0)==0;D=c[f>>2]|0;do{if((D|0)==0){E=1624}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(C){F=D;G=0;break}else{H=m;I=D;J=0;break L1841}}if((da[c[(c[D>>2]|0)+36>>2]&255](D)|0)==-1){c[f>>2]=0;E=1624;break}else{L=(D|0)==0;if(C^L){F=D;G=L;break}else{H=m;I=D;J=L;break L1841}}}}while(0);if((E|0)==1624){E=0;if(C){H=m;I=0;J=1;break}else{F=0;G=1}}D=d[p]|0;L=(D&1|0)==0;if(((c[q>>2]|0)-m|0)==((L?D>>>1:c[z>>2]|0)|0)){if(L){M=D>>>1;N=D>>>1}else{D=c[z>>2]|0;M=D;N=D}tK(o,M<<1,0);if((a[p]&1)==0){O=10}else{O=(c[g>>2]&-2)-1|0}tK(o,O,0);if((a[p]&1)==0){P=x}else{P=c[y>>2]|0}c[q>>2]=P+N;Q=P}else{Q=m}D=B+12|0;L=c[D>>2]|0;R=B+16|0;if((L|0)==(c[R>>2]|0)){S=(da[c[(c[B>>2]|0)+36>>2]&255](B)|0)&255}else{S=a[L]|0}if((vx(S,v,Q,q,t,A,n,l,s,u)|0)!=0){H=Q;I=F;J=G;break}L=c[D>>2]|0;if((L|0)==(c[R>>2]|0)){R=c[(c[B>>2]|0)+40>>2]|0;da[R&255](B)|0;m=Q;w=B;continue}else{c[D>>2]=L+1;m=Q;w=B;continue}}w=d[n]|0;if((w&1|0)==0){T=w>>>1}else{T=c[n+4>>2]|0}do{if((T|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}Q=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=Q}}while(0);t=z$(H,c[q>>2]|0,j,v)|0;c[k>>2]=t;c[k+4>>2]=K;xQ(n,l,c[s>>2]|0,j);do{if(C){U=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){U=B;break}if((da[c[(c[B>>2]|0)+36>>2]&255](B)|0)!=-1){U=B;break}c[h>>2]=0;U=0}}while(0);h=(U|0)==0;L1901:do{if(J){E=1665}else{do{if((c[I+12>>2]|0)==(c[I+16>>2]|0)){if((da[c[(c[I>>2]|0)+36>>2]&255](I)|0)!=-1){break}c[f>>2]=0;E=1665;break L1901}}while(0);if(!(h^(I|0)==0)){break}V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}}while(0);do{if((E|0)==1665){if(h){break}V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;V=b|0;c[V>>2]=U;tH(o);tH(n);i=e;return}function vq(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vr(a,0,j,k,f,g,h);i=b;return}function vr(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;vY(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=h|0;h=p|0;C=p+4|0;D=a[m]|0;m=a[n]|0;n=z;z=c[j>>2]|0;L1921:while(1){do{if((z|0)==0){E=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){E=z;break}if((da[c[(c[z>>2]|0)+36>>2]&255](z)|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);F=(E|0)==0;G=c[f>>2]|0;do{if((G|0)==0){H=1689}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(F){I=G;J=0;break}else{K=n;L=G;M=0;break L1921}}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)==-1){c[f>>2]=0;H=1689;break}else{N=(G|0)==0;if(F^N){I=G;J=N;break}else{K=n;L=G;M=N;break L1921}}}}while(0);if((H|0)==1689){H=0;if(F){K=n;L=0;M=1;break}else{I=0;J=1}}G=d[q]|0;N=(G&1|0)==0;if(((c[r>>2]|0)-n|0)==((N?G>>>1:c[C>>2]|0)|0)){if(N){O=G>>>1;P=G>>>1}else{G=c[C>>2]|0;O=G;P=G}tK(p,O<<1,0);if((a[q]&1)==0){Q=10}else{Q=(c[h>>2]&-2)-1|0}tK(p,Q,0);if((a[q]&1)==0){R=A}else{R=c[B>>2]|0}c[r>>2]=R+P;S=R}else{S=n}G=E+12|0;N=c[G>>2]|0;T=E+16|0;if((N|0)==(c[T>>2]|0)){U=(da[c[(c[E>>2]|0)+36>>2]&255](E)|0)&255}else{U=a[N]|0}if((vZ(U,v,w,S,r,D,m,o,y,t,u,x)|0)!=0){K=S;L=I;M=J;break}N=c[G>>2]|0;if((N|0)==(c[T>>2]|0)){T=c[(c[E>>2]|0)+40>>2]|0;da[T&255](E)|0;n=S;z=E;continue}else{c[G>>2]=N+1;n=S;z=E;continue}}z=d[o]|0;if((z&1|0)==0){V=z>>>1}else{V=c[o+4>>2]|0}do{if((V|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}S=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=S}}while(0);g[l>>2]=+z_(K,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(F){W=0}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){W=E;break}if((da[c[(c[E>>2]|0)+36>>2]&255](E)|0)!=-1){W=E;break}c[j>>2]=0;W=0}}while(0);j=(W|0)==0;L1982:do{if(M){H=1731}else{do{if((c[L+12>>2]|0)==(c[L+16>>2]|0)){if((da[c[(c[L>>2]|0)+36>>2]&255](L)|0)!=-1){break}c[f>>2]=0;H=1731;break L1982}}while(0);if(!(j^(L|0)==0)){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);do{if((H|0)==1731){if(j){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}function vs(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vt(a,0,j,k,f,g,h);i=b;return}function vt(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;vY(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=g|0;g=p|0;C=p+4|0;D=a[m]|0;m=a[n]|0;n=z;z=c[j>>2]|0;L2002:while(1){do{if((z|0)==0){E=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){E=z;break}if((da[c[(c[z>>2]|0)+36>>2]&255](z)|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);F=(E|0)==0;G=c[f>>2]|0;do{if((G|0)==0){H=1755}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(F){I=G;J=0;break}else{K=n;L=G;M=0;break L2002}}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)==-1){c[f>>2]=0;H=1755;break}else{N=(G|0)==0;if(F^N){I=G;J=N;break}else{K=n;L=G;M=N;break L2002}}}}while(0);if((H|0)==1755){H=0;if(F){K=n;L=0;M=1;break}else{I=0;J=1}}G=d[q]|0;N=(G&1|0)==0;if(((c[r>>2]|0)-n|0)==((N?G>>>1:c[C>>2]|0)|0)){if(N){O=G>>>1;P=G>>>1}else{G=c[C>>2]|0;O=G;P=G}tK(p,O<<1,0);if((a[q]&1)==0){Q=10}else{Q=(c[g>>2]&-2)-1|0}tK(p,Q,0);if((a[q]&1)==0){R=A}else{R=c[B>>2]|0}c[r>>2]=R+P;S=R}else{S=n}G=E+12|0;N=c[G>>2]|0;T=E+16|0;if((N|0)==(c[T>>2]|0)){U=(da[c[(c[E>>2]|0)+36>>2]&255](E)|0)&255}else{U=a[N]|0}if((vZ(U,v,w,S,r,D,m,o,y,t,u,x)|0)!=0){K=S;L=I;M=J;break}N=c[G>>2]|0;if((N|0)==(c[T>>2]|0)){T=c[(c[E>>2]|0)+40>>2]|0;da[T&255](E)|0;n=S;z=E;continue}else{c[G>>2]=N+1;n=S;z=E;continue}}z=d[o]|0;if((z&1|0)==0){V=z>>>1}else{V=c[o+4>>2]|0}do{if((V|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}S=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=S}}while(0);h[l>>3]=+zZ(K,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(F){W=0}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){W=E;break}if((da[c[(c[E>>2]|0)+36>>2]&255](E)|0)!=-1){W=E;break}c[j>>2]=0;W=0}}while(0);j=(W|0)==0;L2063:do{if(M){H=1797}else{do{if((c[L+12>>2]|0)==(c[L+16>>2]|0)){if((da[c[(c[L>>2]|0)+36>>2]&255](L)|0)!=-1){break}c[f>>2]=0;H=1797;break L2063}}while(0);if(!(j^(L|0)==0)){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);do{if((H|0)==1797){if(j){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}function vu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vv(a,0,j,k,f,g,h);i=b;return}function vv(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;vY(o,j,x,m,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){y=j+1|0;z=y;A=y;B=p+8|0}else{y=p+8|0;z=c[y>>2]|0;A=j+1|0;B=y}c[r>>2]=z;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;j=f|0;f=g|0;g=p|0;C=p+4|0;D=a[m]|0;m=a[n]|0;n=z;z=c[j>>2]|0;L2083:while(1){do{if((z|0)==0){E=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){E=z;break}if((da[c[(c[z>>2]|0)+36>>2]&255](z)|0)!=-1){E=z;break}c[j>>2]=0;E=0}}while(0);F=(E|0)==0;G=c[f>>2]|0;do{if((G|0)==0){H=1821}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(F){I=G;J=0;break}else{K=n;L=G;M=0;break L2083}}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)==-1){c[f>>2]=0;H=1821;break}else{N=(G|0)==0;if(F^N){I=G;J=N;break}else{K=n;L=G;M=N;break L2083}}}}while(0);if((H|0)==1821){H=0;if(F){K=n;L=0;M=1;break}else{I=0;J=1}}G=d[q]|0;N=(G&1|0)==0;if(((c[r>>2]|0)-n|0)==((N?G>>>1:c[C>>2]|0)|0)){if(N){O=G>>>1;P=G>>>1}else{G=c[C>>2]|0;O=G;P=G}tK(p,O<<1,0);if((a[q]&1)==0){Q=10}else{Q=(c[g>>2]&-2)-1|0}tK(p,Q,0);if((a[q]&1)==0){R=A}else{R=c[B>>2]|0}c[r>>2]=R+P;S=R}else{S=n}G=E+12|0;N=c[G>>2]|0;T=E+16|0;if((N|0)==(c[T>>2]|0)){U=(da[c[(c[E>>2]|0)+36>>2]&255](E)|0)&255}else{U=a[N]|0}if((vZ(U,v,w,S,r,D,m,o,y,t,u,x)|0)!=0){K=S;L=I;M=J;break}N=c[G>>2]|0;if((N|0)==(c[T>>2]|0)){T=c[(c[E>>2]|0)+40>>2]|0;da[T&255](E)|0;n=S;z=E;continue}else{c[G>>2]=N+1;n=S;z=E;continue}}z=d[o]|0;if((z&1|0)==0){V=z>>>1}else{V=c[o+4>>2]|0}do{if((V|0)!=0){if((a[v]&1)==0){break}z=c[t>>2]|0;if((z-s|0)>=160){break}S=c[u>>2]|0;c[t>>2]=z+4;c[z>>2]=S}}while(0);h[l>>3]=+zY(K,c[r>>2]|0,k);xQ(o,y,c[t>>2]|0,k);do{if(F){W=0}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){W=E;break}if((da[c[(c[E>>2]|0)+36>>2]&255](E)|0)!=-1){W=E;break}c[j>>2]=0;W=0}}while(0);j=(W|0)==0;L2144:do{if(M){H=1863}else{do{if((c[L+12>>2]|0)==(c[L+16>>2]|0)){if((da[c[(c[L>>2]|0)+36>>2]&255](L)|0)!=-1){break}c[f>>2]=0;H=1863;break L2144}}while(0);if(!(j^(L|0)==0)){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);do{if((H|0)==1863){if(j){break}X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;X=b|0;c[X>>2]=W;tH(p);tH(o);i=e;return}function vw(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+48|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;A2(n|0,0,12);u=p;t3(o,h);h=o|0;o=c[h>>2]|0;if((c[218656]|0)!=-1){c[l>>2]=874624;c[l+4>>2]=36;c[l+8>>2]=0;tA(874624,l,144)}l=(c[218657]|0)-1|0;v=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-v>>2>>>0>l>>>0){w=c[v+(l<<2)>>2]|0;if((w|0)==0){break}x=w;y=m|0;z=c[(c[w>>2]|0)+32>>2]|0;di[z&63](x,98832,98858,y)|0;x=c[h>>2]|0;td(x)|0;A2(u|0,0,12);x=p;tK(p,10,0);if((a[u]&1)==0){z=x+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=x+1|0;C=z}c[q>>2]=A;z=r|0;c[s>>2]=z;c[t>>2]=0;x=f|0;w=g|0;D=p|0;E=p+4|0;F=A;G=c[x>>2]|0;L2171:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)!=-1){H=G;break}c[x>>2]=0;H=0}}while(0);I=(H|0)==0;J=c[w>>2]|0;do{if((J|0)==0){K=1894}else{if((c[J+12>>2]|0)!=(c[J+16>>2]|0)){if(I){break}else{L=F;break L2171}}if((da[c[(c[J>>2]|0)+36>>2]&255](J)|0)==-1){c[w>>2]=0;K=1894;break}else{if(I^(J|0)==0){break}else{L=F;break L2171}}}}while(0);if((K|0)==1894){K=0;if(I){L=F;break}}J=d[u]|0;M=(J&1|0)==0;if(((c[q>>2]|0)-F|0)==((M?J>>>1:c[E>>2]|0)|0)){if(M){N=J>>>1;O=J>>>1}else{J=c[E>>2]|0;N=J;O=J}tK(p,N<<1,0);if((a[u]&1)==0){P=10}else{P=(c[D>>2]&-2)-1|0}tK(p,P,0);if((a[u]&1)==0){Q=B}else{Q=c[C>>2]|0}c[q>>2]=Q+O;R=Q}else{R=F}J=H+12|0;M=c[J>>2]|0;S=H+16|0;if((M|0)==(c[S>>2]|0)){T=(da[c[(c[H>>2]|0)+36>>2]&255](H)|0)&255}else{T=a[M]|0}if((vx(T,16,R,q,t,0,n,z,s,y)|0)!=0){L=R;break}M=c[J>>2]|0;if((M|0)==(c[S>>2]|0)){S=c[(c[H>>2]|0)+40>>2]|0;da[S&255](H)|0;F=R;G=H;continue}else{c[J>>2]=M+1;F=R;G=H;continue}}a[L+3|0]=0;do{if((a[18202480]|0)==0){if((bD(18202480)|0)==0){break}c[218270]=a3(2147483647,86736,0)|0}}while(0);G=vy(L,c[218270]|0,84048,(F=i,i=i+8|0,c[F>>2]=k,F)|0)|0;i=F;if((G|0)!=1){c[j>>2]=4}G=c[x>>2]|0;do{if((G|0)==0){U=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){U=G;break}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)!=-1){U=G;break}c[x>>2]=0;U=0}}while(0);x=(U|0)==0;G=c[w>>2]|0;do{if((G|0)==0){K=1939}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(!x){break}V=b|0;c[V>>2]=U;tH(p);tH(n);i=e;return}if((da[c[(c[G>>2]|0)+36>>2]&255](G)|0)==-1){c[w>>2]=0;K=1939;break}if(!(x^(G|0)==0)){break}V=b|0;c[V>>2]=U;tH(p);tH(n);i=e;return}}while(0);do{if((K|0)==1939){if(x){break}V=b|0;c[V>>2]=U;tH(p);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;V=b|0;c[V>>2]=U;tH(p);tH(n);i=e;return}}while(0);e=cJ(4)|0;Aq(e);bQ(e|0,97088,288)}function vx(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(a[m+24|0]|0)==b<<24>>24;if(!p){if((a[m+25|0]|0)!=b<<24>>24){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&b<<24>>24==i<<24>>24){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+26|0;i=m;while(1){l=i+1|0;if((a[i]|0)==b<<24>>24){s=i;break}if((l|0)==(k|0)){s=k;break}else{i=l}}i=s-m|0;if((i|0)>23){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((i|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<22){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;m=a[98832+i|0]|0;s=c[g>>2]|0;c[g>>2]=s+1;a[s]=m;q=0;return q|0}}while(0);f=a[98832+i|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function vy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=cm(b|0)|0;b=bc(a|0,d|0,g|0)|0;if((h|0)==0){i=f;return b|0}cm(h|0)|0;i=f;return b|0}function vz(a){a=a|0;tb(a|0);AT(a);return}function vA(a){a=a|0;tb(a|0);return}function vB(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];db[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==0){a[j]=0}else if((w|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}t3(r,g);q=r|0;r=c[q>>2]|0;if((c[218654]|0)!=-1){c[m>>2]=874616;c[m+4>>2]=36;c[m+8>>2]=0;tA(874616,m,144)}m=(c[218655]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;n=c[q>>2]|0;td(n)|0;t3(s,g);n=s|0;p=c[n>>2]|0;if((c[218558]|0)!=-1){c[l>>2]=874232;c[l+4>>2]=36;c[l+8>>2]=0;tA(874232,l,144)}d=(c[218559]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){x=c[v+(d<<2)>>2]|0;if((x|0)==0){break}y=x;z=c[n>>2]|0;td(z)|0;z=t|0;A=x;c5[c[(c[A>>2]|0)+24>>2]&255](z,y);c5[c[(c[A>>2]|0)+28>>2]&255](t+12|0,y);c[u>>2]=c[f>>2];a[j]=(vC(e,u,z,t+24|0,o,h,1)|0)==(z|0)|0;c[b>>2]=c[e>>2];tV(t+12|0);tV(t|0);i=k;return}}while(0);o=cJ(4)|0;Aq(o);bQ(o|0,97088,288)}}while(0);k=cJ(4)|0;Aq(k);bQ(k|0,97088,288)}function vC(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=AL(m)|0;if((o|0)!=0){p=o;q=o;break}AY();p=0;q=0}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){r=m;s=0}else{o=m;m=0;t=p;u=f;while(1){v=d[u]|0;if((v&1|0)==0){w=v>>>1}else{w=c[u+4>>2]|0}if((w|0)==0){a[t]=2;x=m+1|0;y=o-1|0}else{a[t]=1;x=m;y=o}v=u+12|0;if((v|0)==(g|0)){r=y;s=x;break}else{o=y;m=x;t=t+1|0;u=v}}}u=b|0;b=e|0;e=h;t=0;x=s;s=r;while(1){r=c[u>>2]|0;do{if((r|0)==0){z=0}else{m=c[r+12>>2]|0;if((m|0)==(c[r+16>>2]|0)){A=da[c[(c[r>>2]|0)+36>>2]&255](r)|0}else{A=c[m>>2]|0}if((A|0)==-1){c[u>>2]=0;z=0;break}else{z=c[u>>2]|0;break}}}while(0);r=(z|0)==0;m=c[b>>2]|0;if((m|0)==0){B=z;C=0}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){D=da[c[(c[m>>2]|0)+36>>2]&255](m)|0}else{D=c[y>>2]|0}if((D|0)==-1){c[b>>2]=0;E=0}else{E=m}B=c[u>>2]|0;C=E}F=(C|0)==0;if(!((r^F)&(s|0)!=0)){break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){G=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{G=c[r>>2]|0}if(k){H=G}else{H=c7[c[(c[e>>2]|0)+28>>2]&255](h,G)|0}do{if(n){I=x;J=s}else{r=t+1|0;L2378:do{if(k){m=s;y=x;o=p;w=0;v=f;while(1){do{if((a[o]|0)==1){K=v;if((a[K]&1)==0){L=v+4|0}else{L=c[v+8>>2]|0}if((H|0)!=(c[L+(t<<2)>>2]|0)){a[o]=0;M=w;N=y;O=m-1|0;break}P=d[K]|0;if((P&1|0)==0){Q=P>>>1}else{Q=c[v+4>>2]|0}if((Q|0)!=(r|0)){M=1;N=y;O=m;break}a[o]=2;M=1;N=y+1|0;O=m-1|0}else{M=w;N=y;O=m}}while(0);P=v+12|0;if((P|0)==(g|0)){R=O;S=N;T=M;break L2378}m=O;y=N;o=o+1|0;w=M;v=P}}else{v=s;w=x;o=p;y=0;m=f;while(1){do{if((a[o]|0)==1){P=m;if((a[P]&1)==0){U=m+4|0}else{U=c[m+8>>2]|0}if((H|0)!=(c7[c[(c[e>>2]|0)+28>>2]&255](h,c[U+(t<<2)>>2]|0)|0)){a[o]=0;V=y;W=w;X=v-1|0;break}K=d[P]|0;if((K&1|0)==0){Y=K>>>1}else{Y=c[m+4>>2]|0}if((Y|0)!=(r|0)){V=1;W=w;X=v;break}a[o]=2;V=1;W=w+1|0;X=v-1|0}else{V=y;W=w;X=v}}while(0);K=m+12|0;if((K|0)==(g|0)){R=X;S=W;T=V;break L2378}v=X;w=W;o=o+1|0;y=V;m=K}}}while(0);if(!T){I=S;J=R;break}r=c[u>>2]|0;m=r+12|0;y=c[m>>2]|0;if((y|0)==(c[r+16>>2]|0)){o=c[(c[r>>2]|0)+40>>2]|0;da[o&255](r)|0}else{c[m>>2]=y+4}if((S+R|0)>>>0<2>>>0|n){I=S;J=R;break}y=t+1|0;m=S;r=p;o=f;while(1){do{if((a[r]|0)==2){w=d[o]|0;if((w&1|0)==0){Z=w>>>1}else{Z=c[o+4>>2]|0}if((Z|0)==(y|0)){_=m;break}a[r]=0;_=m-1|0}else{_=m}}while(0);w=o+12|0;if((w|0)==(g|0)){I=_;J=R;break}else{m=_;r=r+1|0;o=w}}}}while(0);t=t+1|0;x=I;s=J}do{if((B|0)==0){$=1}else{J=c[B+12>>2]|0;if((J|0)==(c[B+16>>2]|0)){aa=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{aa=c[J>>2]|0}if((aa|0)==-1){c[u>>2]=0;$=1;break}else{$=(c[u>>2]|0)==0;break}}}while(0);do{if(F){ab=2114}else{u=c[C+12>>2]|0;if((u|0)==(c[C+16>>2]|0)){ac=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{ac=c[u>>2]|0}if((ac|0)==-1){c[b>>2]=0;ab=2114;break}else{if($^(C|0)==0){break}else{ab=2116;break}}}}while(0);if((ab|0)==2114){if($){ab=2116}}if((ab|0)==2116){c[j>>2]=c[j>>2]|2}L2459:do{if(n){ab=2121}else{$=f;C=p;while(1){if((a[C]|0)==2){ad=$;break L2459}b=$+12|0;if((b|0)==(g|0)){ab=2121;break L2459}$=b;C=C+1|0}}}while(0);if((ab|0)==2121){c[j>>2]=c[j>>2]|4;ad=g}if((q|0)==0){i=l;return ad|0}AM(q);i=l;return ad|0}function vD(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vE(a,0,j,k,f,g,h);i=b;return}function vE(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==64){v=8}else if((u|0)==0){v=0}else{v=10}u=l|0;v_(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=c[m>>2]|0;m=w;w=c[h>>2]|0;L2483:while(1){do{if((w|0)==0){B=0}else{C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0)){D=da[c[(c[w>>2]|0)+36>>2]&255](w)|0}else{D=c[C>>2]|0}if((D|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);E=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){F=2150}else{G=c[C+12>>2]|0;if((G|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[G>>2]|0}if((H|0)==-1){c[f>>2]=0;F=2150;break}else{G=(C|0)==0;if(E^G){I=C;J=G;break}else{K=m;L=C;M=G;break L2483}}}}while(0);if((F|0)==2150){F=0;if(E){K=m;L=0;M=1;break}else{I=0;J=1}}C=d[p]|0;G=(C&1|0)==0;if(((c[q>>2]|0)-m|0)==((G?C>>>1:c[z>>2]|0)|0)){if(G){N=C>>>1;O=C>>>1}else{C=c[z>>2]|0;N=C;O=C}tK(o,N<<1,0);if((a[p]&1)==0){P=10}else{P=(c[g>>2]&-2)-1|0}tK(o,P,0);if((a[p]&1)==0){Q=x}else{Q=c[y>>2]|0}c[q>>2]=Q+O;R=Q}else{R=m}C=B+12|0;G=c[C>>2]|0;S=B+16|0;if((G|0)==(c[S>>2]|0)){T=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{T=c[G>>2]|0}if((vW(T,v,R,q,t,A,n,l,s,u)|0)!=0){K=R;L=I;M=J;break}G=c[C>>2]|0;if((G|0)==(c[S>>2]|0)){S=c[(c[B>>2]|0)+40>>2]|0;da[S&255](B)|0;m=R;w=B;continue}else{c[C>>2]=G+4;m=R;w=B;continue}}w=d[n]|0;if((w&1|0)==0){U=w>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}R=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=R}}while(0);c[k>>2]=z4(K,c[q>>2]|0,j,v)|0;xQ(n,l,c[s>>2]|0,j);do{if(E){V=0}else{s=c[B+12>>2]|0;if((s|0)==(c[B+16>>2]|0)){W=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{W=c[s>>2]|0}if((W|0)!=-1){V=B;break}c[h>>2]=0;V=0}}while(0);h=(V|0)==0;do{if(M){F=2192}else{B=c[L+12>>2]|0;if((B|0)==(c[L+16>>2]|0)){X=da[c[(c[L>>2]|0)+36>>2]&255](L)|0}else{X=c[B>>2]|0}if((X|0)==-1){c[f>>2]=0;F=2192;break}if(!(h^(L|0)==0)){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);do{if((F|0)==2192){if(h){break}Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Y=b|0;c[Y>>2]=V;tH(o);tH(n);i=e;return}function vF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vG(a,0,j,k,f,g,h);i=b;return}function vG(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;v_(n,h,u,m);A2(p|0,0,12);h=o;tK(o,10,0);if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;h=f|0;f=g|0;g=o|0;z=o+4|0;A=c[m>>2]|0;m=w;w=c[h>>2]|0;L2573:while(1){do{if((w|0)==0){B=0}else{C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0)){D=da[c[(c[w>>2]|0)+36>>2]&255](w)|0}else{D=c[C>>2]|0}if((D|0)!=-1){B=w;break}c[h>>2]=0;B=0}}while(0);E=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){F=2221}else{G=c[C+12>>2]|0;if((G|0)==(c[C+16>>2]|0)){H=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{H=c[G>>2]|0}if((H|0)==-1){c[f>>2]=0;F=2221;break}else{G=(C|0)==0;if(E^G){I=C;J=G;break}else{L=m;M=C;N=G;break L2573}}}}while(0);if((F|0)==2221){F=0;if(E){L=m;M=0;N=1;break}else{I=0;J=1}}C=d[p]|0;G=(C&1|0)==0;if(((c[q>>2]|0)-m|0)==((G?C>>>1:c[z>>2]|0)|0)){if(G){O=C>>>1;P=C>>>1}else{C=c[z>>2]|0;O=C;P=C}tK(o,O<<1,0);if((a[p]&1)==0){Q=10}else{Q=(c[g>>2]&-2)-1|0}tK(o,Q,0);if((a[p]&1)==0){R=x}else{R=c[y>>2]|0}c[q>>2]=R+P;S=R}else{S=m}C=B+12|0;G=c[C>>2]|0;T=B+16|0;if((G|0)==(c[T>>2]|0)){U=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{U=c[G>>2]|0}if((vW(U,v,S,q,t,A,n,l,s,u)|0)!=0){L=S;M=I;N=J;break}G=c[C>>2]|0;if((G|0)==(c[T>>2]|0)){T=c[(c[B>>2]|0)+40>>2]|0;da[T&255](B)|0;m=S;w=B;continue}else{c[C>>2]=G+4;m=S;w=B;continue}}w=d[n]|0;if((w&1|0)==0){V=w>>>1}else{V=c[n+4>>2]|0}do{if((V|0)!=0){w=c[s>>2]|0;if((w-r|0)>=160){break}S=c[t>>2]|0;c[s>>2]=w+4;c[w>>2]=S}}while(0);t=z3(L,c[q>>2]|0,j,v)|0;c[k>>2]=t;c[k+4>>2]=K;xQ(n,l,c[s>>2]|0,j);do{if(E){W=0}else{s=c[B+12>>2]|0;if((s|0)==(c[B+16>>2]|0)){X=da[c[(c[B>>2]|0)+36>>2]&255](B)|0}else{X=c[s>>2]|0}if((X|0)!=-1){W=B;break}c[h>>2]=0;W=0}}while(0);h=(W|0)==0;do{if(N){F=2263}else{B=c[M+12>>2]|0;if((B|0)==(c[M+16>>2]|0)){Y=da[c[(c[M>>2]|0)+36>>2]&255](M)|0}else{Y=c[B>>2]|0}if((Y|0)==-1){c[f>>2]=0;F=2263;break}if(!(h^(M|0)==0)){break}Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}}while(0);do{if((F|0)==2263){if(h){break}Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b|0;c[Z>>2]=W;tH(o);tH(n);i=e;return}function vH(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vI(a,0,j,k,f,g,h);i=b;return}function vI(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;f=i;i=i+144|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+104|0;o=f+112|0;p=f+128|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==8){w=16}else if((v|0)==64){w=8}else if((v|0)==0){w=0}else{w=10}v=m|0;v_(o,j,v,n);A2(q|0,0,12);j=p;tK(p,10,0);if((a[q]&1)==0){m=j+1|0;x=m;y=m;z=p+8|0}else{m=p+8|0;x=c[m>>2]|0;y=j+1|0;z=m}c[r>>2]=x;m=s|0;c[t>>2]=m;c[u>>2]=0;j=g|0;g=h|0;h=p|0;A=p+4|0;B=c[n>>2]|0;n=x;x=c[j>>2]|0;L2663:while(1){do{if((x|0)==0){C=0}else{D=c[x+12>>2]|0;if((D|0)==(c[x+16>>2]|0)){E=da[c[(c[x>>2]|0)+36>>2]&255](x)|0}else{E=c[D>>2]|0}if((E|0)!=-1){C=x;break}c[j>>2]=0;C=0}}while(0);F=(C|0)==0;D=c[g>>2]|0;do{if((D|0)==0){G=2292}else{H=c[D+12>>2]|0;if((H|0)==(c[D+16>>2]|0)){I=da[c[(c[D>>2]|0)+36>>2]&255](D)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[g>>2]=0;G=2292;break}else{H=(D|0)==0;if(F^H){J=D;K=H;break}else{L=n;M=D;N=H;break L2663}}}}while(0);if((G|0)==2292){G=0;if(F){L=n;M=0;N=1;break}else{J=0;K=1}}D=d[q]|0;H=(D&1|0)==0;if(((c[r>>2]|0)-n|0)==((H?D>>>1:c[A>>2]|0)|0)){if(H){O=D>>>1;P=D>>>1}else{D=c[A>>2]|0;O=D;P=D}tK(p,O<<1,0);if((a[q]&1)==0){Q=10}else{Q=(c[h>>2]&-2)-1|0}tK(p,Q,0);if((a[q]&1)==0){R=y}else{R=c[z>>2]|0}c[r>>2]=R+P;S=R}else{S=n}D=C+12|0;H=c[D>>2]|0;T=C+16|0;if((H|0)==(c[T>>2]|0)){U=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{U=c[H>>2]|0}if((vW(U,w,S,r,u,B,o,m,t,v)|0)!=0){L=S;M=J;N=K;break}H=c[D>>2]|0;if((H|0)==(c[T>>2]|0)){T=c[(c[C>>2]|0)+40>>2]|0;da[T&255](C)|0;n=S;x=C;continue}else{c[D>>2]=H+4;n=S;x=C;continue}}x=d[o]|0;if((x&1|0)==0){V=x>>>1}else{V=c[o+4>>2]|0}do{if((V|0)!=0){x=c[t>>2]|0;if((x-s|0)>=160){break}S=c[u>>2]|0;c[t>>2]=x+4;c[x>>2]=S}}while(0);b[l>>1]=z2(L,c[r>>2]|0,k,w)|0;xQ(o,m,c[t>>2]|0,k);do{if(F){W=0}else{t=c[C+12>>2]|0;if((t|0)==(c[C+16>>2]|0)){X=da[c[(c[C>>2]|0)+36>>2]&255](C)|0}else{X=c[t>>2]|0}if((X|0)!=-1){W=C;break}c[j>>2]=0;W=0}}while(0);j=(W|0)==0;do{if(N){G=2334}else{C=c[M+12>>2]|0;if((C|0)==(c[M+16>>2]|0)){Y=da[c[(c[M>>2]|0)+36>>2]&255](M)|0}else{Y=c[C>>2]|0}if((Y|0)==-1){c[g>>2]=0;G=2334;break}if(!(j^(M|0)==0)){break}Z=e|0;c[Z>>2]=W;tH(p);tH(o);i=f;return}}while(0);do{if((G|0)==2334){if(j){break}Z=e|0;c[Z>>2]=W;tH(p);tH(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;Z=e|0;c[Z>>2]=W;tH(p);tH(o);i=f;return}function vJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];vK(a,0,j,k,f,g,h);i=b;return}
function nJ(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+16|0;l=c[k>>2]|0;L8041:do{if((c[l+20>>2]|0)==0){do{if((c[b+152>>2]|0)!=0){m=b+96|0;if((c[m>>2]|0)!=0){break}n=b+92|0;if((c[n>>2]|0)!=0){break}o=b+64|0;p=c[o>>2]|0;q=c[b+148>>2]|0;r=q+(p*1640|0)|0;if((c[b+132>>2]|0)==0){s=b+140|0}else{s=(c[b+8>>2]|0)+8|0}t=c[s>>2]|0;u=b+4|0;v=p-1-(c[(c[u>>2]|0)+28>>2]|0)-(c[b+40>>2]|0)|0;w=q+(p*1640|0)+4|0;do{if((c[w>>2]|0)==0){if((c[b+156>>2]|0)!=0){x=6545;break}if((c[r>>2]|0)!=(v|0)){x=6545;break}if((c[q+(p*1640|0)+12>>2]|0)!=(c[b+36>>2]|0)){x=6545;break}if((c[q+(p*1640|0)+16>>2]|0)!=(t|0)){x=6545;break}if((c[q+(p*1640|0)+20>>2]|0)!=0){x=6545;break}if((c[q+(p*1640|0)+344>>2]|0)!=(c[b+136>>2]|0)){x=6545;break}if((c[q+(p*1640|0)+356>>2]|0)!=(c[b+68>>2]|0)){x=6545;break}if((c[q+(p*1640|0)+24>>2]|0)!=(c[b+124>>2]|0)){x=6545;break}if((c[q+(p*1640|0)+28>>2]|0)!=(c[b+128>>2]|0)){x=6545;break}if((c[q+(p*1640|0)+348>>2]|0)!=0){x=6545;break}if((c[q+(p*1640|0)+352>>2]|0)!=0){x=6545;break}if((d[q+(p*1640|0)+8|0]|0)!=(c[b+80>>2]|0)){x=6545;break}if((d[q+(p*1640|0)+9|0]|0)!=(c[b+76>>2]|0)){x=6545;break}if((c8[c[b+680>>2]&127](b,f,g)|0)!=0){x=6555}}else{x=6545}}while(0);do{if((x|0)==6545){c[r>>2]=v;c[q+(p*1640|0)+12>>2]=c[b+36>>2];c[q+(p*1640|0)+16>>2]=t;c[q+(p*1640|0)+20>>2]=0;c[q+(p*1640|0)+344>>2]=c[b+136>>2];y=b+68|0;c[q+(p*1640|0)+356>>2]=c[y>>2];z=b+124|0;c[q+(p*1640|0)+24>>2]=c[z>>2];A=b+128|0;c[q+(p*1640|0)+28>>2]=c[A>>2];c[q+(p*1640|0)+348>>2]=c[n>>2];c[q+(p*1640|0)+352>>2]=c[m>>2];a[q+(p*1640|0)+8|0]=c[b+80>>2]&255;a[q+(p*1640|0)+9|0]=c[b+76>>2]&255;nK(b);B=b+12|0;if((c[B>>2]|0)!=0){C=c[b+688>>2]|0;di[C&63](b,r,h,j)|0}C=b+8|0;D=c[(c[(c[C>>2]|0)+4>>2]|0)+(t*20|0)>>2]|0;di[D&63](r,h,j,1)|0;dk[c[(c[(c[C>>2]|0)+4>>2]|0)+(t*20|0)+4>>2]&127](r,c[h>>2]|0,c[j>>2]|0);if((c[B>>2]|0)!=0){c5[c[b+684>>2]&255](b,r)}c[f>>2]=0;c[g>>2]=(c[c[u>>2]>>2]|0)-1;if((c[b+104>>2]|0)!=0){x=6555;break}if((c[m>>2]|0)==0){A2(c[b+28>>2]|0,c[y>>2]&255|0,c[z>>2]|0)}if((c[n>>2]|0)!=0){x=6555;break}z=c[A>>2]|0;A2((c[b+28>>2]|0)+z|0,c[y>>2]&255|0,(c[c[u>>2]>>2]|0)-z|0);x=6555}}while(0);do{if((x|0)==6555){n=c[b+164>>2]|0;m=c[u>>2]|0;r=c[o>>2]|0;if((c[m+36>>2]|0)>>>0>r>>>0){t=c[m+4>>2]|0;E=(t>>>0>(c[m+40>>2]|0)>>>0?0:t)+r|0}else{E=r}r=c[f>>2]|0;t=c[g>>2]|0;m=n+16|0;if((c[m>>2]|0)==0){p=n|0;q=c[p>>2]|0;c[p>>2]=q>>>0>r>>>0?r:q;q=n+8|0;p=c[q>>2]|0;c[q>>2]=p>>>0<t>>>0?t:p;p=n+4|0;q=c[p>>2]|0;c[p>>2]=q>>>0>E>>>0?E:q;q=n+12|0;p=c[q>>2]|0;c[q>>2]=p>>>0<E>>>0?E:p;break}else{c[n+12>>2]=E;c[n+4>>2]=E;c[n>>2]=r;c[n+8>>2]=t;c[m>>2]=0;break}}}while(0);c[w>>2]=0;break L8041}}while(0);o=b+4|0;u=c[o>>2]|0;nK(b);m=c[b+8>>2]|0;dd[c[(c[m+4>>2]|0)+((c[((c[b+132>>2]|0)==0?b+140|0:m+8|0)>>2]|0)*20|0)+8>>2]&63]();m=b+12|0;t=c[m>>2]|0;do{if((t|0)!=0){n=c[t+8>>2]|0;if((n|0)==0){break}c5[n&255](c[b+28>>2]|0,b+168|0)}}while(0);do{if((c[b+104>>2]|0)==0){if((c[b+96>>2]|0)==0){A2(c[b+28>>2]|0,c[b+68>>2]&255|0,c[b+124>>2]|0)}if((c[b+92>>2]|0)!=0){break}t=c[b+128>>2]|0;A2((c[b+28>>2]|0)+t|0,c[b+68>>2]&255|0,(c[c[o>>2]>>2]|0)-t|0)}}while(0);t=b+64|0;n=c[t>>2]|0;r=c[b+148>>2]|0;do{if((c[b+156>>2]|0)==0){p=c[m>>2]|0;if((p|0)!=0){if((a[p+21|0]|0)!=0){break}}if((c[r+(n*1640|0)+4>>2]|0)!=0){break}if((c[r+(n*1640|0)+20>>2]|0)!=0){break}if((c[r+(n*1640|0)+356>>2]|0)!=(c[b+68>>2]|0)){break}if((c[r+(n*1640|0)+348>>2]|0)!=(c[b+92>>2]|0)){break}if((c[r+(n*1640|0)+352>>2]|0)!=(c[b+96>>2]|0)){break}if((d[r+(n*1640|0)+9|0]|0)!=(c[b+76>>2]|0)){break}if((d[r+(n*1640|0)+8|0]|0)!=(c[b+80>>2]|0)){break}p=c[b+164>>2]|0;q=c[o>>2]|0;if((c[q+36>>2]|0)>>>0>n>>>0){v=c[q+4>>2]|0;F=(v>>>0>(c[q+40>>2]|0)>>>0?0:v)+n|0}else{F=n}v=c[u+24>>2]|0;q=v-1+(c[u+8>>2]|0)|0;z=p+16|0;if((c[z>>2]|0)==0){y=p|0;A=c[y>>2]|0;c[y>>2]=A>>>0>v>>>0?v:A;A=p+8|0;y=c[A>>2]|0;c[A>>2]=y>>>0<q>>>0?q:y;y=p+4|0;A=c[y>>2]|0;c[y>>2]=A>>>0>F>>>0?F:A;A=p+12|0;y=c[A>>2]|0;c[A>>2]=y>>>0<F>>>0?F:y;break L8041}else{c[p+12>>2]=F;c[p+4>>2]=F;c[p>>2]=v;c[p+8>>2]=q;c[z>>2]=0;break L8041}}}while(0);c[r+(n*1640|0)+20>>2]=0;c[r+(n*1640|0)+4>>2]=0;c[r+(n*1640|0)+356>>2]=c[b+68>>2];c[r+(n*1640|0)+348>>2]=c[b+92>>2];c[r+(n*1640|0)+352>>2]=c[b+96>>2];a[r+(n*1640|0)+8|0]=c[b+80>>2]&255;a[r+(n*1640|0)+9|0]=c[b+76>>2]&255;u=c[b+164>>2]|0;m=c[o>>2]|0;z=c[t>>2]|0;if((c[m+36>>2]|0)>>>0>z>>>0){q=c[m+4>>2]|0;G=(q>>>0>(c[m+40>>2]|0)>>>0?0:q)+z|0}else{G=z}z=(c[m>>2]|0)-1|0;m=u+16|0;if((c[m>>2]|0)==0){c[u>>2]=0;q=u+8|0;p=c[q>>2]|0;c[q>>2]=p>>>0<z>>>0?z:p;p=u+4|0;q=c[p>>2]|0;c[p>>2]=q>>>0>G>>>0?G:q;q=u+12|0;p=c[q>>2]|0;c[q>>2]=p>>>0<G>>>0?G:p;break}else{c[u+12>>2]=G;c[u+4>>2]=G;c[u>>2]=0;c[u+8>>2]=z;c[m>>2]=0;break}}else{m=b+4|0;z=c[m>>2]|0;u=b+132|0;p=c[u>>2]|0;q=b+140|0;v=c[q>>2]|0;y=l|0;A=c[y>>2]|0;if((c[A>>2]|0)==0){H=0}else{B=b+8|0;C=0;D=0;I=A;while(1){A=c[I+4+(D<<4)>>2]|0;if((C|0)<(A|0)){J=c[B>>2]|0;c5[c[(c[J+4>>2]|0)+((c[((c[u>>2]|0)==0?q:J+8|0)>>2]|0)*20|0)+12>>2]&255](C,A-1|0);K=A;L=c[y>>2]|0}else{K=C;L=I}A=L+4+(D<<4)+8|0;J=L+4+(D<<4)+12|0;if((c[L+4+(D<<4)+4>>2]|0)==0){c[c[A>>2]>>2]=c[J>>2]}else{c[c[A>>2]>>2]=c[J>>2]}J=D+1|0;A=c[y>>2]|0;if(J>>>0<(c[A>>2]|0)>>>0){C=K;D=J;I=A}else{H=K;break}}}I=z|0;D=(c[I>>2]|0)-1|0;if((H|0)<=(D|0)){C=c[b+8>>2]|0;c5[c[(c[C+4>>2]|0)+((c[((c[u>>2]|0)==0?q:C+8|0)>>2]|0)*20|0)+12>>2]&255](H,D)}c[u>>2]=p;c[q>>2]=v;D=l+4|0;C=c[D>>2]|0;if((c[C>>2]|0)==0){M=0}else{B=b+8|0;t=b+48|0;o=0;n=0;r=C;while(1){C=c[r+4+(n<<4)>>2]|0;if((o|0)<(C|0)){A=c[B>>2]|0;c5[c[(c[A+4>>2]|0)+((c[((c[u>>2]|0)==0?q:A+8|0)>>2]|0)*20|0)+16>>2]&255](o,C-1|0);N=C}else{N=o}c[t>>2]=0;C=c[D>>2]|0;A=C+4+(n<<4)+8|0;J=C+4+(n<<4)+12|0;if((c[C+4+(n<<4)+4>>2]|0)==0){c[c[A>>2]>>2]=c[J>>2]}else{c[c[A>>2]>>2]=c[J>>2]}J=n+1|0;A=c[D>>2]|0;if(J>>>0<(c[A>>2]|0)>>>0){o=N;n=J;r=A}else{M=N;break}}}r=(c[z+16>>2]|0)-1|0;if((M|0)<=(r|0)){n=c[b+8>>2]|0;c5[c[(c[n+4>>2]|0)+((c[((c[u>>2]|0)==0?q:n+8|0)>>2]|0)*20|0)+16>>2]&255](M,r)}c[b+48>>2]=0;r=l+12|0;n=c[r>>2]|0;if((c[n>>2]|0)==0){O=0}else{o=b+12|0;t=b+56|0;B=b+28|0;v=b+424|0;p=b+168|0;A=0;J=0;C=n;while(1){n=c[C+4+(J<<4)>>2]|0;P=c[I>>2]|0;Q=(n|0)<(P|0)?n:P-1|0;do{if((A|0)<(Q|0)){P=Q-1|0;n=c[o>>2]|0;if((n|0)==0){R=Q;S=C;break}T=c[n+16>>2]|0;if((T|0)==0){R=Q;S=C;break}n=c[B>>2]|0;if((c[t>>2]|0)>0){c2[T&63](n,v,A,P)}else{c2[T&63](n,p,A,P)}c[t>>2]=0;R=Q;S=c[r>>2]|0}else{R=A;S=C}}while(0);Q=S+4+(J<<4)+8|0;w=S+4+(J<<4)+12|0;if((c[S+4+(J<<4)+4>>2]|0)==0){c[c[Q>>2]>>2]=c[w>>2]}else{c[c[Q>>2]>>2]=c[w>>2]}w=J+1|0;Q=c[r>>2]|0;if(w>>>0<(c[Q>>2]|0)>>>0){A=R;J=w;C=Q}else{O=R;break}}}C=(c[I>>2]|0)-1|0;do{if((O|0)<=(C|0)){J=c[b+12>>2]|0;if((J|0)==0){break}A=c[J+16>>2]|0;if((A|0)==0){break}J=b+56|0;t=c[b+28>>2]|0;if((c[J>>2]|0)>0){c2[A&63](t,b+424|0,O,C)}else{c2[A&63](t,b+168|0,O,C)}c[J>>2]=0}}while(0);do{if((c[b+100>>2]|0)==0){x=6477}else{if((c[b+88>>2]|0)==0){if((c[b+84>>2]|0)==0){x=6477;break}}if((c[b+96>>2]|0)!=0){x=6477;break}C=l+8|0;J=c[C>>2]|0;t=b+104|0;if((c[J>>2]|0)==0){U=0;V=0}else{A=b+28|0;p=b+68|0;v=0;B=0;o=0;q=J;while(1){J=c[q+4+(B<<4)>>2]|0;do{if((v|0)<(J|0)){if((c[t>>2]|0)!=0){W=J;X=q;break}A2((c[A>>2]|0)+v|0,c[p>>2]&255|0,J+o|0);W=J;X=c[C>>2]|0}else{W=v;X=q}}while(0);J=X+4+(B<<4)+8|0;u=X+4+(B<<4)+12|0;if((c[X+4+(B<<4)+4>>2]|0)==0){c[c[J>>2]>>2]=c[u>>2]}else{c[c[J>>2]>>2]=c[u>>2]}u=B+1|0;J=-W|0;z=c[C>>2]|0;if(u>>>0<(c[z>>2]|0)>>>0){v=W;B=u;o=J;q=z}else{U=W;V=J;break}}}if((c[t>>2]|0)!=0){break}q=c[I>>2]|0;if((U|0)>(q-1|0)){break}A2((c[b+28>>2]|0)+U|0,c[b+68>>2]&255|0,q+V|0)}}while(0);L8121:do{if((x|0)==6477){q=c[b+124>>2]|0;o=q-1|0;B=l+8|0;v=c[B>>2]|0;C=(c[v>>2]|0)==0;L8123:do{if((c[b+96>>2]|0)==0){p=b+104|0;L8133:do{if(C){Y=0;Z=0;_=0;$=v}else{A=b+28|0;J=b+68|0;z=0;u=0;Q=0;w=v;while(1){P=c[w+4+(u<<4)>>2]|0;if((P|0)>(o|0)){Y=z;Z=u;_=Q;$=w;break L8133}do{if((z|0)<(P|0)){if((c[p>>2]|0)!=0){aa=P;ab=w;break}A2((c[A>>2]|0)+z|0,c[J>>2]&255|0,P+Q|0);aa=P;ab=c[B>>2]|0}else{aa=z;ab=w}}while(0);P=ab+4+(u<<4)+8|0;n=ab+4+(u<<4)+12|0;if((c[ab+4+(u<<4)+4>>2]|0)==0){c[c[P>>2]>>2]=c[n>>2]}else{c[c[P>>2]>>2]=c[n>>2]}n=u+1|0;P=-aa|0;T=c[B>>2]|0;if(n>>>0<(c[T>>2]|0)>>>0){z=aa;u=n;Q=P;w=T}else{Y=aa;Z=n;_=P;$=T;break}}}}while(0);if((c[p>>2]|0)!=0|(Y|0)>(o|0)){ac=Z;ad=$;break}A2((c[b+28>>2]|0)+Y|0,c[b+68>>2]&255|0,_+q|0);ac=Z;ad=c[B>>2]|0}else{if(C){ac=0;ad=v;break}else{ae=0;af=v}while(1){if((c[af+4+(ae<<4)>>2]|0)>(o|0)){ac=ae;ad=af;break L8123}w=af+4+(ae<<4)+8|0;Q=af+4+(ae<<4)+12|0;if((c[af+4+(ae<<4)+4>>2]|0)==0){c[c[w>>2]>>2]=c[Q>>2]}else{c[c[w>>2]>>2]=c[Q>>2]}Q=ae+1|0;w=c[B>>2]|0;if(Q>>>0<(c[w>>2]|0)>>>0){ae=Q;af=w}else{ac=Q;ad=w;break}}}}while(0);o=c[ad>>2]|0;if((c[b+92>>2]|0)!=0){if((o|0)==0){break}else{ag=0;ah=ad}while(1){v=ah+4+(ag<<4)+8|0;C=ah+4+(ag<<4)+12|0;if((c[ah+4+(ag<<4)+4>>2]|0)==0){c[c[v>>2]>>2]=c[C>>2]}else{c[c[v>>2]>>2]=c[C>>2]}ag=ag+1|0;ah=c[B>>2]|0;if(ag>>>0>=(c[ah>>2]|0)>>>0){break L8121}}}C=b+128|0;L8158:do{if(ac>>>0<o>>>0){v=ac;q=ad;t=o;while(1){if((c[q+4+(v<<4)>>2]|0)>(c[C>>2]|0)){ai=v;aj=q;ak=t;break L8158}p=q+4+(v<<4)+8|0;w=q+4+(v<<4)+12|0;if((c[q+4+(v<<4)+4>>2]|0)==0){c[c[p>>2]>>2]=c[w>>2]}else{c[c[p>>2]>>2]=c[w>>2]}w=v+1|0;p=c[B>>2]|0;Q=c[p>>2]|0;if(w>>>0<Q>>>0){v=w;q=p;t=Q}else{ai=w;aj=p;ak=Q;break}}}else{ai=ac;aj=ad;ak=o}}while(0);o=c[C>>2]|0;t=-o|0;q=b+104|0;if(ai>>>0<ak>>>0){v=b+28|0;Q=b+68|0;p=o;w=ai;u=t;z=aj;while(1){J=c[z+4+(w<<4)>>2]|0;do{if((p|0)<(J|0)){if((c[q>>2]|0)!=0){al=J;am=z;break}A2((c[v>>2]|0)+p|0,c[Q>>2]&255|0,J+u|0);al=J;am=c[B>>2]|0}else{al=p;am=z}}while(0);J=am+4+(w<<4)+8|0;A=am+4+(w<<4)+12|0;if((c[am+4+(w<<4)+4>>2]|0)==0){c[c[J>>2]>>2]=c[A>>2]}else{c[c[J>>2]>>2]=c[A>>2]}A=w+1|0;J=-al|0;T=c[B>>2]|0;if(A>>>0<(c[T>>2]|0)>>>0){p=al;w=A;u=J;z=T}else{an=al;ao=J;break}}}else{an=o;ao=t}if((c[q>>2]|0)!=0){break}z=c[I>>2]|0;if((an|0)>(z-1|0)){break}A2((c[b+28>>2]|0)+an|0,c[b+68>>2]&255|0,z+ao|0)}}while(0);c[c[D>>2]>>2]=0;c[c[y>>2]>>2]=0;c[c[l+8>>2]>>2]=0;c[c[r>>2]>>2]=0;c[(c[k>>2]|0)+20>>2]=0;I=b+64|0;c[(c[b+148>>2]|0)+((c[I>>2]|0)*1640|0)+4>>2]=1;z=c[b+164>>2]|0;u=c[m>>2]|0;w=c[I>>2]|0;if((c[u+36>>2]|0)>>>0>w>>>0){I=c[u+4>>2]|0;ap=(I>>>0>(c[u+40>>2]|0)>>>0?0:I)+w|0}else{ap=w}w=(c[u>>2]|0)-1|0;u=z+16|0;if((c[u>>2]|0)==0){c[z>>2]=0;I=z+8|0;p=c[I>>2]|0;c[I>>2]=p>>>0<w>>>0?w:p;p=z+4|0;I=c[p>>2]|0;c[p>>2]=I>>>0>ap>>>0?ap:I;I=z+12|0;p=c[I>>2]|0;c[I>>2]=p>>>0<ap>>>0?ap:p;break}else{c[z+12>>2]=ap;c[z+4>>2]=ap;c[z>>2]=0;c[z+8>>2]=w;c[u>>2]=0;break}}}while(0);if((c[b+132>>2]|0)==0){i=e;return}c[b+80>>2]=c[b+76>>2];i=e;return}function nK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+36|0;d=c[b>>2]|0;if((d|0)!=0){A2((c[a+28>>2]|0)+(c[(c[a+4>>2]|0)+24>>2]|0)|0,c[a+80>>2]&255|0,d|0)}if((c[a+96>>2]|0)==0){if((c[a+104>>2]|0)!=0){e=6598}}else{e=6598}do{if((e|0)==6598){d=c[a+28>>2]|0;if((c[a+132>>2]|0)==0){A2(d|0,c[a+80>>2]&255|0,(c[b>>2]|0)+(c[(c[a+4>>2]|0)+24>>2]|0)|0);break}else{A2(d|0,c[a+76>>2]&255|0,(c[b>>2]|0)+(c[(c[a+4>>2]|0)+24>>2]|0)|0);break}}}while(0);do{if((c[a+92>>2]|0)==0){if((c[a+104>>2]|0)!=0){break}return}}while(0);if((c[a+100>>2]|0)==0){e=c[a+4>>2]|0;d=(c[e+8>>2]|0)+(c[e+24>>2]|0)+(c[b>>2]|0)|0;f=(c[a+28>>2]|0)+d|0;if((c[a+132>>2]|0)==0){A2(f|0,c[a+80>>2]&255|0,(c[e>>2]|0)-d|0);return}else{A2(f|0,c[a+76>>2]&255|0,(c[e>>2]|0)-d|0);return}}d=c[a+4>>2]|0;e=c[d+24>>2]|0;f=c[d+8>>2]|0;g=c[b>>2]|0;b=(c[d>>2]|0)-e-f-g|0;if((b|0)<=0){return}d=(c[a+28>>2]|0)+(f+e+g)|0;if((c[a+132>>2]|0)==0){A2(d|0,c[a+80>>2]&255|0,b|0);return}else{A2(d|0,c[a+76>>2]&255|0,b|0);return}}function nL(a){a=a|0;c[a+680>>2]=34;c[a+684>>2]=30;c[a+688>>2]=28;return}function nM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=nF(b)|0;m=b+64|0;n=c[m>>2]|0;o=b+148|0;p=c[o>>2]|0;q=p+(n*1640|0)|0;r=b+4|0;c[j>>2]=c[(c[r>>2]|0)+16>>2];c[k>>2]=0;s=nO(b,q,g,h)|0;t=b+8|0;u=di[c[(c[(c[t>>2]|0)+4>>2]|0)+(l*20|0)>>2]&63](q,j,k,s)|0;do{if((u|0)==0){v=c[b+12>>2]|0;if((v|0)==0){w=6632;break}x=c[v+12>>2]|0;if((x|0)==0){w=6632;break}c4[x&511]((c[o>>2]|0)+((c[m>>2]|0)*1640|0)|0);w=6632}else{dk[c[(c[(c[t>>2]|0)+4>>2]|0)+(l*20|0)+4>>2]&127](q,c[j>>2]|0,c[k>>2]|0);nH(b);x=b+12|0;v=c[x>>2]|0;do{if((v|0)!=0){y=c[v+8>>2]|0;if((y|0)==0){break}c5[y&255](c[b+28>>2]|0,c[p+(n*1640|0)+332>>2]|0);a[p+(n*1640|0)+336|0]=a[(c[x>>2]|0)+32|0]|0;a[p+(n*1640|0)+337|0]=a[(c[x>>2]|0)+33|0]|0}}while(0);nG(b);v=b+36|0;c[d>>2]=(c[v>>2]|0)+(c[(c[r>>2]|0)+24>>2]|0)+(c[j>>2]<<3);c[e>>2]=(c[(c[r>>2]|0)+24>>2]|0)+7+(c[v>>2]|0)+(c[k>>2]<<3);if((s|0)==0){z=x;break}if((c[b+96>>2]|0)!=0){c[d>>2]=0}if((c[b+92>>2]|0)!=0){c[e>>2]=(c[c[r>>2]>>2]|0)-1}v=c[d>>2]|0;y=c[g>>2]|0;c[d>>2]=v>>>0<y>>>0?v:y;y=c[e>>2]|0;v=c[h>>2]|0;c[e>>2]=y>>>0>v>>>0?y:v;v=c[d>>2]|0;y=c[b+124>>2]|0;c[d>>2]=(v|0)>(y|0)?v:y;y=c[e>>2]|0;v=c[b+128>>2]|0;c[e>>2]=(y|0)<(v|0)?y:v;w=6632}}while(0);do{if((w|0)==6632){if((s|0)==0){z=b+12|0;break}else{i=f;return u|0}}}while(0);a[(c[z>>2]|0)+32|0]=a[p+(n*1640|0)+336|0]|0;a[(c[z>>2]|0)+33|0]=a[p+(n*1640|0)+337|0]|0;i=f;return u|0}function nN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=b+12|0;f=c[e>>2]|0;if((f|0)==0){return}g=c[f+8>>2]|0;if((g|0)==0){return}c5[g&255](c[b+28>>2]|0,c[d+332>>2]|0);a[d+336|0]=a[(c[e>>2]|0)+32|0]|0;a[d+337|0]=a[(c[e>>2]|0)+33|0]|0;return}function nO(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;g=a+4|0;h=c[c[g>>2]>>2]|0;i=c[a+12>>2]|0;a=c[i>>2]|0;c[b+36>>2]=a;j=b+40|0;c[j>>2]=0;if((a|0)==0){k=0;l=0;m=h;n=c[g>>2]|0;o=n|0;p=c[o>>2]|0;q=l>>>0<p>>>0;r=p-1|0;s=q?l:r;c[f>>2]=s;c[e>>2]=m;return k|0}t=i+4|0;u=i+21|0;v=i+44|0;w=i+24|0;x=i+28|0;i=0;y=1;z=0;A=0;B=h;while(1){h=c[t>>2]|0;do{if(((d[u]|0)&y|0)==0){C=b+44+(z*36|0)+24|0;if((c[C>>2]|0)==0){D=B;E=A;F=i;break}c[C>>2]=0;C=c[b+44+(z*36|0)+20>>2]|0;G=((c[b+44+(z*36|0)+16>>2]|0)!=0?24:48)+C|0;H=(C|0)>0?C:0;C=(G|0)>0?G:0;D=B>>>0<H>>>0?B:H;E=A>>>0>C>>>0?A:C;F=1}else{C=c[(c[v>>2]|0)+(z<<2)>>2]|0;c[j>>2]=c[j>>2]|y;H=c[h+(z*56|0)>>2]|0;G=h+(z*56|0)+8|0;I=((c[G>>2]|0)!=0?48:24)+H|0;J=b+44+(z*36|0)+20|0;K=c[J>>2]|0;L=c[b+44+(z*36|0)+24>>2]|0;if((H|0)==(K|0)){M=0;N=I;O=H}else{if((L|0)==0){P=I;Q=H}else{R=((c[b+44+(z*36|0)+16>>2]|0)!=0?48:24)+K|0;P=(R|0)>(I|0)?R:I;Q=(K|0)<(H|0)?K:H}c[J>>2]=H;M=1;N=P;O=Q}if((L|0)==0){c[b+44+(z*36|0)+24>>2]=1;S=1}else{S=M}L=c[G>>2]|0;G=b+44+(z*36|0)+16|0;if((L|0)==(c[G>>2]|0)){T=S}else{c[G>>2]=L;T=1}L=c[h+(z*56|0)+24>>2]|0;G=b+44+(z*36|0)+32|0;if((L|0)==(c[G>>2]|0)){U=T}else{c[G>>2]=L;U=1}L=c[w>>2]|0;G=b+44+(z*36|0)|0;if((L|0)==(c[G>>2]|0)){V=U}else{c[G>>2]=L;V=1}L=c[x>>2]|0;G=b+44+(z*36|0)+4|0;if((L|0)==(c[G>>2]|0)){W=V}else{c[G>>2]=L;W=1}L=c[h+(z*56|0)+36>>2]|0;G=b+44+(z*36|0)+8|0;if((L|0)==(c[G>>2]|0)){X=W}else{c[G>>2]=L;X=1}L=c[h+(z*56|0)+32>>2]|0;G=b+44+(z*36|0)+28|0;if((L|0)==(c[G>>2]|0)){Y=X}else{c[G>>2]=L;Y=1}L=b+44+(z*36|0)+12|0;if((c[L>>2]|0)==(C|0)){if((Y|0)==0){D=B;E=A;F=i;break}}else{c[L>>2]=C}C=(O|0)>0?O:0;L=(N|0)>0?N:0;D=B>>>0<C>>>0?B:C;E=A>>>0>L>>>0?A:L;F=1}}while(0);h=z+1|0;if(h>>>0>=a>>>0){k=F;l=E;m=D;break}i=F;y=y<<1;z=h;A=E;B=D}n=c[g>>2]|0;o=n|0;p=c[o>>2]|0;q=l>>>0<p>>>0;r=p-1|0;s=q?l:r;c[f>>2]=s;c[e>>2]=m;return k|0}function nP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;c[a>>2]=b;c[a+8>>2]=0;d=hg(b*20|0)|0;e=a+4|0;c[e>>2]=d;if((b|0)==0){return}else{f=0;g=d}while(1){d=f+1|0;A2(g+(f*20|0)|0,0,20);if(d>>>0>=b>>>0){break}f=d;g=c[e>>2]|0}return}function nQ(a){a=a|0;hj(c[a+4>>2]|0);return}function nR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;i=c[a+4>>2]|0;c[i+(b*20|0)>>2]=d;c[i+(b*20|0)+4>>2]=e;c[i+(b*20|0)+8>>2]=f;c[i+(b*20|0)+12>>2]=g;c[i+(b*20|0)+16>>2]=h;return}function nS(a,b){a=a|0;b=b|0;var d=0;if((c[a>>2]|0)>>>0<=b>>>0){d=-1;return d|0}c[a+8>>2]=b;d=0;return d|0}function nT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=hh(1,8)|0;c[b+24>>2]=f;c[f>>2]=b;g=i0(a,(h=i,i=i+16|0,c[h>>2]=87984,c[h+8>>2]=0,h)|0)|0;i=h;c[12748]=g;c[12752]=f+4;c[12754]=f;f=b+20|0;c[f>>2]=q7()|0;if((h1(50992)|0)<0){j=-1;i=e;return j|0}hj(c[12748]|0);j=(ri(a,f,d)|0)>>31;i=e;return j|0}function nU(a){a=a|0;var b=0;b=a+20|0;rj(c[b>>2]|0);hj(c[a+24>>2]|0);q6(c[b>>2]|0);return}function nV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;do{if((a|0)==99){d=(c[13586]|0)!=8|0;e=6700}else{if((a|0)>-1){d=a;e=6700;break}f=c[b+4>>2]|0}}while(0);if((e|0)==6700){c[b+4>>2]=d;f=d}nv(c[b>>2]|0,f);return 0}function nW(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+24>>2]=0;A2(a+32|0,0,24);return}function nX(a){a=a|0;A2(a|0,0,36);return}function nY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=hg(56)|0;c[b+12>>2]=f;b=f;c[b>>2]=d;c[f+52>>2]=254;c[f+8>>2]=0;c[f+16>>2]=0;c[f+12>>2]=0;if((d|0)==0){c[f+4>>2]=0;c[f+36>>2]=0;c[f+40>>2]=0;g=0;h=0}else{c[f+4>>2]=hg(d*56|0)|0;i=d<<2;d=f+36|0;c[d>>2]=hg(i)|0;c[f+40>>2]=hg(i)|0;g=c[d>>2]|0;h=c[b>>2]<<2}a[f+20|0]=0;a[f+21|0]=0;a[f+22|0]=0;c[f+24>>2]=0;c[f+28>>2]=0;A2(g|0,0,h|0);h=f+40|0;A2(c[h>>2]|0,0,c[b>>2]<<2|0);c[f+44>>2]=c[f+36>>2];c[f+48>>2]=c[h>>2];if((c[b>>2]|0)==0){return}h=f+4|0;f=0;do{nW((c[h>>2]|0)+(f*56|0)|0,e);f=f+1|0;}while(f>>>0<(c[b>>2]|0)>>>0);return}function nZ(a){a=a|0;var b=0,d=0;b=a+12|0;a=c[b>>2]|0;if((a|0)==0){return}if((c[a>>2]|0)==0){d=a}else{hj(c[a+4>>2]|0);hj(c[a+36>>2]|0);hj(c[a+40>>2]|0);d=c[b>>2]|0}hj(d);return}function n_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;a[b+20|0]=0;a[b+21|0]=0;a[b+22|0]=0;c[b+24>>2]=0;c[b+28>>2]=0;e=b+36|0;f=b|0;A2(c[e>>2]|0,0,c[f>>2]<<2|0);g=b+40|0;A2(c[g>>2]|0,0,c[f>>2]<<2|0);c[b+44>>2]=c[e>>2];c[b+48>>2]=c[g>>2];if((c[f>>2]|0)==0){return}g=b+4|0;b=0;do{nW((c[g>>2]|0)+(b*56|0)|0,d);b=b+1|0;}while(b>>>0<(c[f>>2]|0)>>>0);return}function n$(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function n0(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function n1(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function n2(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;oe(d);e=d|0;of(e);f=d+88|0;of(f);g=d+176|0;of(g);h=d+16|0;i=aI(c[h>>2]|0,c[d+20>>2]|0)|0;j=i;c[h>>2]=j;if(K){i=d+56|0;k=c[i>>2]|0;c[i>>2]=(k>>>7^k>>>2)&65535|k<<16;l=(a[d+128|0]|0)!=0|0}else{l=0}k=d+104|0;i=aI(c[k>>2]|0,c[d+108>>2]|0)|0;m=i;c[k>>2]=m;if(K){i=d+144|0;n=c[i>>2]|0;c[i>>2]=(n>>>7^n>>>2)&65535|n<<16;o=(a[d+216|0]|0)!=0|0}else{o=0}n=d+192|0;i=aI(c[n>>2]|0,c[d+196>>2]|0)|0;p=i;c[n>>2]=p;do{if(K){i=d+232|0;q=c[i>>2]|0;c[i>>2]=(q>>>7^q>>>2)&65535|q<<16;if((a[d+40|0]|0)==0){break}q=d+56|0;i=c[q>>2]|0;r=j>>>28;c[q>>2]=(i>>>((23-r|0)>>>0)^i>>>((18-r|0)>>>0))&(1<<r)-1|i<<r;c[h>>2]=0}}while(0);if((o|0)!=0){o=d+232|0;j=c[o>>2]|0;r=p>>>28;c[o>>2]=(j>>>((23-r|0)>>>0)^j>>>((18-r|0)>>>0))&(1<<r)-1|j<<r;c[n>>2]=0}if((l|0)!=0){l=d+144|0;r=c[l>>2]|0;j=m>>>28;c[l>>2]=(r>>>((23-j|0)>>>0)^r>>>((18-j|0)>>>0))&(1<<j)-1|r<<j;c[k>>2]=0}j=d+28|0;r=(c[j>>2]|0)+(c[d+32>>2]|0)|0;c[j>>2]=r;do{if((r|0)<(c[d+36>>2]|0)){l=a[d+44|0]|0;m=l&255;if((m|0)==0){c[j>>2]=2147483647;og(e,1);break}else if(!((m|0)==1|(m|0)==3)){break}if((r|0)<0){c[j>>2]=0}og(e,l)}}while(0);r=d+116|0;l=(c[r>>2]|0)+(c[d+120>>2]|0)|0;c[r>>2]=l;do{if((l|0)<(c[d+124>>2]|0)){m=a[d+132|0]|0;o=m&255;if((o|0)==0){c[r>>2]=2147483647;og(f,1);break}else if(!((o|0)==1|(o|0)==3)){break}if((l|0)<0){c[r>>2]=0}og(f,m)}}while(0);l=d+204|0;m=(c[l>>2]|0)+(c[d+208>>2]|0)|0;c[l>>2]=m;do{if((m|0)<(c[d+212>>2]|0)){o=a[d+220|0]|0;p=o&255;if((p|0)==0){c[l>>2]=2147483647;og(g,1);break}else if(!((p|0)==1|(p|0)==3)){break}if((m|0)<0){c[l>>2]=0}og(g,o)}}while(0);m=(c[j>>2]|0)>>>16;j=(c[r>>2]|0)>>>16;r=(c[l>>2]|0)>>>16;if((m|0)==0){s=0}else{if((a[d+24|0]|0)==0){t=(b[d+72+((c[(c[d+4>>2]|0)+16>>2]|0)>>>31<<1)>>1]^b[(c[d+60>>2]|0)+(((c[d+64>>2]|0)+(c[h>>2]|0)|0)>>>((c[d+68>>2]|0)>>>0)<<1)>>1])&65535}else{l=c[d+56>>2]|0;o=(c[h>>2]|0)>>>28;h=(l>>>((23-o|0)>>>0)^l>>>((18-o|0)>>>0))&(1<<o)-1|l<<o;t=((a[486176+(h>>>8&255)|0]|a[486432+(h&255)|0]|a[485920+(h>>>16&255)|0])&255)<<7}s=ag(t,m)|0}if((j|0)==0){u=0}else{if((a[d+112|0]|0)==0){v=(b[d+160+((c[(c[d+92>>2]|0)+16>>2]|0)>>>31<<1)>>1]^b[(c[d+148>>2]|0)+(((c[d+152>>2]|0)+(c[k>>2]|0)|0)>>>((c[d+156>>2]|0)>>>0)<<1)>>1])&65535}else{m=c[d+144>>2]|0;t=(c[k>>2]|0)>>>28;k=(m>>>((23-t|0)>>>0)^m>>>((18-t|0)>>>0))&(1<<t)-1|m<<t;v=((a[486176+(k>>>8&255)|0]|a[486432+(k&255)|0]|a[485920+(k>>>16&255)|0])&255)<<7}u=ag(v,j)|0}if((a[d+296|0]|0)==0|(r|0)==0){w=0}else{if((a[d+200|0]|0)==0){x=(b[d+248+((c[(c[d+180>>2]|0)+16>>2]|0)>>>31<<1)>>1]^b[(c[d+236>>2]|0)+(((c[d+240>>2]|0)+(c[n>>2]|0)|0)>>>((c[d+244>>2]|0)>>>0)<<1)>>1])&65535}else{j=c[d+232>>2]|0;v=(c[n>>2]|0)>>>28;n=(j>>>((23-v|0)>>>0)^j>>>((18-v|0)>>>0))&(1<<v)-1|j<<v;x=((a[486176+(n>>>8&255)|0]|a[486432+(n&255)|0]|a[485920+(n>>>16&255)|0])&255)<<7}w=ag(x,r)|0}if((c[d+440>>2]|0)==0){y=s;z=u;A=w;B=z+A|0;C=B+y|0;D=C>>>20;E=D-1536|0;F=d+297|0;G=a[F]|0;H=G&255;I=ag(E,H)|0;J=I&65535;return J|0}r=d+76|0;a[r]=a[870736+(s>>>22)|0]|0;oh(e);e=(a[r]<<22)+536870912|0;r=d+164|0;a[r]=a[870736+(u>>>22)|0]|0;oh(f);f=(a[r]<<22)+536870912|0;r=d+252|0;a[r]=a[870736+(w>>>22)|0]|0;oh(g);y=e;z=f;A=(a[r]<<22)+536870912|0;B=z+A|0;C=B+y|0;D=C>>>20;E=D-1536|0;F=d+297|0;G=a[F]|0;H=G&255;I=ag(E,H)|0;J=I&65535;return J|0}function n3(a){a=a|0;var b=0,c=0,d=0;b=hh(1,456)|0;c=b;d=b+264|0;A$(d|0,a|0,32)|0;return c|0}function n4(f,h,j){f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;k=i;i=i+8|0;l=k|0;m=(j<<8|0)/(h|0)|0;j=f+428|0;c[j>>2]=m;n=0;o=m;while(1){c[f+300+(n<<2)>>2]=((o*4e3|0)>>>0)/((e[77384+(n<<1)>>1]|0)>>>0)|0;c[f+364+(n<<2)>>2]=ag(n,143165576)|0;m=n+1|0;if(m>>>0>=16>>>0){break}n=m;o=c[j>>2]|0}a[f+432|0]=1;j=f+440|0;if((ic(81736,j)|0)<0){p=0;i=k;return p|0}q=+(h|0);A2(f+444|0,0,12);o=0;n=0;while(1){r=(+ad(+(o|0)*.00048828125*5.991464547107982)/60.0+.05000000074505806)*44100.0/q;s=r<.009999999776482582?.009999999776482582:r;g[794432+((n&65535)<<2)>>2]=s>1.0?1.0:s;m=o+1|0;if((m|0)<2048){o=m;n=n+1&65535}else{break}}q=+(h|0);s=.0020000000949949026;h=0;n=0;while(1){g[862512+((n&65535)<<2)>>2]=s*44100.0/q;o=h+1|0;if((o|0)<2048){s=s+.00010644530993886292;h=o;n=n+1&65535}else{break}}g[200845]=1.9333332777023315;g[200846]=1.866666555404663;g[200847]=1.7999998331069946;g[200848]=1.7333331108093262;g[200849]=1.6666663885116577;g[200850]=1.5999996662139893;g[200851]=1.5333329439163208;g[200852]=1.4666662216186523;g[200853]=1.3999994993209839;g[200854]=1.3333327770233154;g[200855]=1.266666054725647;g[200856]=1.1999993324279785;g[200857]=1.13333261013031;g[200858]=1.0666658878326416;g[200844]=2.0;g[200859]=1.0;s=(c[j>>2]|0)==0?1.0:.699999988079071;j=0;n=0;while(1){a[870736+(n&65535)|0]=~~(s*+(j-128|0));h=j+1|0;if((h|0)<256){j=h;n=n+1&65535}else{break}}oe(f);n=f+176|0;j=f|0;c[f+4>>2]=n;h=f+88|0;c[f+8>>2]=h;c[f+12>>2]=0;c[f+52>>2]=f+264;c[f>>2]=f;c[f+56>>2]=8388600;g[f+80>>2]=0.0;g[f+84>>2]=0.0;a[f+76|0]=0;a[f+42|0]=1;of(j);c[f+92>>2]=j;c[f+96>>2]=n;c[f+100>>2]=1;c[f+140>>2]=f+271;c[h>>2]=f;c[f+144>>2]=8388600;g[f+168>>2]=0.0;g[f+172>>2]=0.0;a[f+164|0]=0;a[f+130|0]=1;of(h);c[f+180>>2]=h;c[f+184>>2]=j;c[f+188>>2]=2;c[f+228>>2]=f+278;c[n>>2]=f;c[f+232>>2]=8388600;g[f+256>>2]=0.0;g[f+260>>2]=0.0;a[f+252|0]=0;a[f+218|0]=1;of(n);if((ic(80536,l)|0)<0){p=0;i=k;return p|0}n=f+433|0;a[n]=((c[l>>2]|0)-1|0)>>>0<2>>>0|0;l=0;while(1){f=l<<4;b[313584+(l<<1)>>1]=(l>>>0<2048>>>0?f:65535-f|0)&65535;b[305392+(l<<1)>>1]=l<<3&65535;b[297200+(l<<1)>>1]=d[25112+l|0]<<7;f=l+4096|0;b[280816+(f<<1)>>1]=32767;if((a[n]|0)==0){b[264432+(f<<1)>>1]=d[24600+(l>>>3)|0]<<7;b[248048+(f<<1)>>1]=0;b[231664+(f<<1)>>1]=0}else{b[264432+(f<<1)>>1]=d[16408+l|0]<<7;b[248048+(f<<1)>>1]=d[8216+l|0]<<7;b[231664+(f<<1)>>1]=d[24+l|0]<<7}f=l+1|0;if(f>>>0<4096>>>0){l=f}else{t=0;break}}do{a[486432+t|0]=(t>>>5&4|t>>>3&2|t>>>2&1)&255;a[486176+t|0]=(t>>>1&16|t&8)&255;a[485920+t|0]=(t<<1&128|t<<2&64|t<<5&32)&255;t=t+1|0;}while(t>>>0<256>>>0);c[113946]=13;c[113947]=13;c[113948]=13;c[113949]=13;c[113950]=13;c[113951]=13;c[113952]=13;c[113953]=13;c[113954]=13;p=1;i=k;return p|0}function n5(a){a=a|0;hj(a);return}function n6(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f&65535;if((g|0)==28){h=(c[e+204>>2]|0)>>>23&255;return h|0}else if((g|0)==25|(g|0)==26){h=-1;return h|0}else if((g|0)==27){g=iz()|0;f=ag(c[e+196>>2]|0,g)|0;g=e+232|0;i=c[g>>2]|0;j=c[e+192>>2]|0;k=f&65535;if((a[e+200|0]|0)==0){f=e+192|0;l=j+k|0;c[f>>2]=l;m=((b[e+248+((c[(c[e+180>>2]|0)+16>>2]|0)>>>31<<1)>>1]^b[(c[e+236>>2]|0)+(((c[e+240>>2]|0)+l|0)>>>((c[e+244>>2]|0)>>>0)<<1)>>1])&65535)>>>7&255;n=f}else{aI(j|0,k|0)|0;if(K){f=(i>>>7^i>>>2)&65535|i<<16;c[g>>2]=f;l=e+192|0;o=j+k|0;c[l>>2]=o;p=f;q=l;r=o}else{o=e+192|0;l=j+k|0;c[o>>2]=l;p=i;q=o;r=l}l=r>>>28;r=(p>>>((23-l|0)>>>0)^p>>>((18-l|0)>>>0))&(1<<l)-1|p<<l;m=a[486176+(r>>>8&255)|0]|a[486432+(r&255)|0]|a[485920+(r>>>16&255)|0];n=q}c[n>>2]=j;c[g>>2]=i;h=m;return h|0}else{m=e+435|0;i=a[m]|0;L37:do{if(i<<24>>24==0){s=e+434|0}else{g=e+436|0;j=e+434|0;n=i;q=c[g>>2]|0;while(1){r=n&255;l=(c[455784+(r<<2)>>2]|0)+q|0;if(l>>>0>=(c[198580]|0)>>>0){s=j;break L37}c[g>>2]=l;p=n-1&255;a[m]=p;a[j]=d[j]&65279>>>(r>>>0)&255;if(p<<24>>24==0){s=j;break}else{n=p;q=l}}}}while(0);h=a[s]|0;return h|0}return 0}function n7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=d&65535;L56:do{switch(f|0){case 4:{if(((a[b+268|0]^e)&1)==0){g=47;break L56}a[b+43|0]=1;g=47;break};case 0:case 1:case 2:case 3:case 5:case 6:{g=47;break};case 11:{if(((a[b+275|0]^e)&1)==0){g=50;break L56}a[b+131|0]=1;g=50;break};case 7:case 8:case 9:case 10:case 12:case 13:{g=50;break};case 18:{if(((a[b+282|0]^e)&1)==0){g=53;break L56}a[b+219|0]=1;g=53;break};case 14:case 15:case 16:case 17:case 19:case 20:{g=53;break};default:{a[b+432|0]=1}}}while(0);if((g|0)==47){a[b+42|0]=1}else if((g|0)==50){a[b+130|0]=1}else if((g|0)==53){a[b+218|0]=1}a[b+264+f|0]=e;a[b+434|0]=e;a[b+435|0]=8;c[b+436>>2]=c[198580];return}function n8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=b+432|0;f=b+434|0;g=b+435|0;h=b+436|0;i=b+268|0;j=b+43|0;k=b+42|0;l=b+275|0;m=b+131|0;n=b+130|0;o=b+282|0;p=b+219|0;q=b+218|0;r=0;do{s=r&65535;L72:do{switch(s|0){case 18:{if((a[o]&1)==0){t=66;break L72}a[p]=1;t=66;break};case 4:{if((a[i]&1)==0){t=60;break L72}a[j]=1;t=60;break};case 0:case 1:case 2:case 3:case 5:case 6:{t=60;break};case 11:{if((a[l]&1)==0){t=63;break L72}a[m]=1;t=63;break};case 7:case 8:case 9:case 10:case 12:case 13:{t=63;break};case 14:case 15:case 16:case 17:case 19:case 20:{t=66;break};default:{a[e]=1}}}while(0);if((t|0)==60){t=0;a[k]=1}else if((t|0)==63){t=0;a[n]=1}else if((t|0)==66){t=0;a[q]=1}a[b+264+s|0]=0;a[f]=0;a[g]=8;c[h>>2]=c[198580];r=r+1&65535;}while((r&65535)>>>0<32>>>0);c[h>>2]=d;return}function n9(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;if((d|0)>0){g=0}else{return d|0}do{b[c+((ag(g,e)|0)<<1)>>1]=n2(a)|0;g=g+1|0;}while((g|0)<(d|0));return d|0}function oa(a,b){a=a|0;b=b|0;var d=0;d=a+436|0;c[d>>2]=(c[d>>2]|0)-b;return}function ob(b){b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;e=i;i=i+1024|0;f=e|0;g=f|0;j=d[b+297|0]|0;k=d[b+296|0]|0;bs(g|0,87952,(l=i,i=i+24|0,c[l>>2]=c[198580],c[l+8>>2]=j,c[l+16>>2]=k,l)|0)|0;i=l;k=0;do{j=f+(A1(g|0)|0)|0;m=+((c[b+(k*88|0)+28>>2]|0)>>>0>>>0)*100.0/2147483647.0;n=a[89128+(d[b+(k*88|0)+44|0]|0)|0]|0;o=+((c[b+(k*88|0)+20>>2]|0)>>>0>>>0)/+(c[(c[b+(k*88|0)>>2]|0)+428>>2]<<4>>>0>>>0);p=c[b+(k*88|0)+52>>2]|0;q=a[85536+((d[p+4|0]|0)>>>4)|0]|0;r=+((c[b+(k*88|0)+16>>2]|0)>>>0>>>0)*100.0/4294967295.0;s=+(d[p+3|0]<<8&3840|d[p+2|0]|0)/40.95;bs(j|0,83296,(l=i,i=i+56|0,c[l>>2]=c[b+(k*88|0)+12>>2],h[l+8>>3]=m,c[l+16>>2]=n,h[l+24>>3]=o,c[l+32>>2]=q,h[l+40>>3]=r,h[l+48>>3]=s,l)|0)|0;i=l;k=k+1|0;}while((k|0)<3);k=hk(g)|0;i=e;return k|0}function oc(a,b){a=a|0;b=b|0;return}function od(a,b){a=a|0;b=b|0;return}function oe(e){e=e|0;var f=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;f=e+432|0;if((a[f]|0)==0){return}h=a[e+288|0]|0;a[e+297|0]=h&15;if(h<<24>>24<0){i=(d[e+287|0]|0)>>>2&1}else{i=1}a[e+296|0]=i;do{if((c[e+440>>2]|0)==0){a[e+41|0]=0;a[e+129|0]=0;a[e+217|0]=0}else{i=a[e+287|0]|0;a[e+41|0]=i&1;a[e+129|0]=(i&255)>>>1&1;a[e+217|0]=(i&255)>>>2&1;j=h&112;a[e+452|0]=j;k=e+453|0;if(j<<24>>24!=(a[k]|0)){a[k]=j;g[e+80>>2]=0.0;g[e+84>>2]=0.0;g[e+168>>2]=0.0;g[e+172>>2]=0.0;g[e+256>>2]=0.0;g[e+260>>2]=0.0}k=d[e+286|0]<<3|a[e+285|0]&7;b[e+454>>1]=k;l=k&65535;if(j<<24>>24==32){m=+g[862512+(l<<2)>>2];g[e+444>>2]=m;n=m}else{m=+g[794432+(l<<2)>>2];g[e+444>>2]=m;n=m}m=+g[803376+((i&255)>>>4<<2)>>2]-n;i=e+448|0;g[i>>2]=m;if(m>=1.0){break}g[i>>2]=1.0}}while(0);a[f]=0;return}function of(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=e+42|0;if((a[f]|0)==0){return}g=c[e+52>>2]|0;h=g+5|0;a[e+45|0]=(d[h]|0)>>>4;a[e+46|0]=a[h]&15;h=g+6|0;a[e+47|0]=(d[h]|0)>>>4;a[e+48|0]=a[h]&15;h=g+4|0;a[e+40|0]=(d[h]|0)>>>1&1;i=c[e>>2]|0;j=e+20|0;c[j>>2]=ag(d[g+1|0]<<8|d[g],c[i+428>>2]|0)|0;if((a[h]&8)!=0){c[j>>2]=0;c[e+16>>2]=0;c[e+56>>2]=8388600}j=e+24|0;a[j]=0;k=e+68|0;c[k>>2]=20;l=e+64|0;c[l>>2]=0;m=e+74|0;b[m>>1]=0;n=d[h]|0;L126:do{switch(n>>>4|0){case 0:{c[e+60>>2]=321776;c[k>>2]=31;break};case 1:{c[e+60>>2]=313584;if((a[h]&4)==0){break L126}b[m>>1]=32767;break};case 2:{c[e+60>>2]=305392;break};case 3:{c[e+60>>2]=297200;if((a[h]&4)==0){break L126}b[m>>1]=32767;break};case 5:{o=4096-(d[g+3|0]<<8&3840|d[g+2|0])|0;c[e+60>>2]=264432+(o<<1);c[l>>2]=o<<20;if((a[h]&4)==0){break L126}b[m>>1]=32767;break};case 6:{o=4096-(d[g+3|0]<<8&3840|d[g+2|0])|0;c[e+60>>2]=248048+(o<<1);c[l>>2]=o<<20;break};case 7:{o=4096-(d[g+3|0]<<8&3840|d[g+2|0])|0;c[e+60>>2]=231664+(o<<1);c[l>>2]=o<<20;if((a[h]&4)==0){break L126}if((a[i+433|0]|0)==0){break L126}b[m>>1]=32767;break};case 8:{a[j]=1;c[e+60>>2]=0;c[k>>2]=0;break};case 4:{if((n&8|0)==0){c[e+60>>2]=280816+(4096-(d[g+3|0]<<8&3840|d[g+2|0])<<1);break L126}else{c[e+60>>2]=289008;break L126}break};default:{c[e+56>>2]=0;c[e+60>>2]=321776;c[k>>2]=31}}}while(0);k=a[e+44|0]|0;L146:do{switch(k&255|0){case 0:case 1:case 2:{if((a[h]&1)==0){og(e,3);break L146}else{og(e,(a[e+43|0]|0)==0?k:0);break L146}break};case 3:case 4:{if((a[h]&1)==0){og(e,k);break L146}else{og(e,0);break L146}break};default:{}}}while(0);a[f]=0;a[e+43|0]=0;return}function og(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=b+28|0;g=b+47|0;h=b|0;i=e;L158:while(1){switch(i&255|0){case 0:{j=131;break L158;break};case 2:{if((c[f>>2]|0)>>>0>(c[(c[h>>2]|0)+364+((d[g]|0)<<2)>>2]|0)>>>0){i=1;continue L158}else{j=136;break L158}break};case 3:{j=137;break L158;break};case 4:{j=141;break L158;break};case 1:{k=c[f>>2]|0;l=c[h>>2]|0;m=l+364+((d[g]|0)<<2)|0;if(k>>>0>(c[m>>2]|0)>>>0){n=0;j=133;break L158}else{i=2;continue L158}break};default:{break L158}}}do{if((j|0)==131){c[b+32>>2]=c[(c[h>>2]|0)+300+((d[b+45|0]|0)<<2)>>2];c[b+36>>2]=0}else if((j|0)==136){c[b+32>>2]=0;c[b+36>>2]=0}else if((j|0)==137){g=c[f>>2]|0;if((g|0)==0){c[b+32>>2]=0;c[b+36>>2]=0;a[b+44|0]=4;return}else{e=0;while(1){o=c[56096+(e<<2)>>2]|0;if(g>>>0<o>>>0){e=e+1|0}else{break}}c[b+32>>2]=-(c[(c[h>>2]|0)+300+((d[b+48|0]|0)<<2)>>2]|0)>>e;c[b+36>>2]=o;break}}else if((j|0)==141){c[b+32>>2]=0;c[b+36>>2]=0}else if((j|0)==133){while(1){j=0;p=c[56096+(n<<2)>>2]|0;if(k>>>0<p>>>0){n=n+1|0;j=133}else{break}}c[b+32>>2]=-(c[l+300+((d[b+46|0]|0)<<2)>>2]|0)>>n;e=c[m>>2]|0;c[b+36>>2]=p>>>0>e>>>0?p:e}}while(0);a[b+44|0]=i;return}function oh(b){b=b|0;var d=0,e=0,f=0,h=0,i=0.0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;if((a[b+41|0]|0)==0){return}d=c[b>>2]|0;e=d+452|0;f=a[e]|0;if((f<<24>>24|0)==32){h=b+84|0;i=+g[h>>2];j=d+444|0;k=b+80|0;l=+g[k>>2]+i*+g[j>>2];g[k>>2]=l;k=b+76|0;m=i+(+(a[k]|0)-l-i*+g[d+448>>2]*+g[j>>2]);g[h>>2]=m;a[k]=~~(m-l*.25)&255;return}else if((f<<24>>24|0)==0){a[b+76|0]=0;return}else{k=b+84|0;l=+g[k>>2];h=d+444|0;m=l*+g[h>>2];if(f<<24>>24==64){f=b+80|0;i=m*.1+ +g[f>>2];g[f>>2]=i;f=b+76|0;j=a[f]|0;n=l+(+(j<<24>>24|0)-i-l*+g[d+448>>2]*+g[h>>2]);g[k>>2]=n;i=n- +((j<<24>>24|0)/8|0|0);n=i<-128.0?-128.0:i;a[f]=n>127.0?127:~~n&255;return}f=b+80|0;n=m+ +g[f>>2];g[f>>2]=n;f=b+76|0;m=+(a[f]|0);i=m-n;b=~~i;g[k>>2]=l+ +g[h>>2]*(i-l*+g[d+448>>2]);switch(a[e]|0){case 16:{o=~~n&255;break};case 48:{o=~~n&255;break};case 80:{o=~~m-(b>>>1)&255;break};case 96:{o=b&255;break};case 112:{o=~~m-(b>>>1)&255;break};default:{o=0}}a[f]=o;return}}function oi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c[113992]|0;do{if((d|0)==1){e=b&65535;if(!(e>>>0>=(c[113988]|0)>>>0&e>>>0<(c[113990]|0)>>>0)){break}e=b&31;kN(0);if((c[13586]|0)==9){f=c7[c[114006]&255](e,1)|0}else{c[198580]=(c[198580]|0)+1;g=c7[c[114006]&255](e,1)|0;c[198580]=(c[198580]|0)-1;f=g}g=f&255;do{if((f|0)<0){if((e<<16>>16|0)==27|(e<<16>>16|0)==28){h=c[198580]&255;break}else if((e<<16>>16|0)==25|(e<<16>>16|0)==26){h=-1;break}else{h=0;break}}else{h=g}}while(0);a[802752]=h;i=h;return i|0}else if((d|0)==2){g=b&65535;if(!(g>>>0>=(c[113982]|0)>>>0&g>>>0<(c[113984]|0)>>>0)){break}g=b&31;kN(0);if((c[13586]|0)==9){j=c7[c[114006]&255](g,2)|0}else{c[198580]=(c[198580]|0)+1;e=c7[c[114006]&255](g,2)|0;c[198580]=(c[198580]|0)-1;j=e}e=j&255;do{if((j|0)<0){if((g<<16>>16|0)==27|(g<<16>>16|0)==28){k=c[198580]&255;break}else if((g<<16>>16|0)==25|(g<<16>>16|0)==26){k=-1;break}else{k=0;break}}else{k=e}}while(0);a[802752]=k;i=k;return i|0}}while(0);k=b&31;kN(0);if((c[13586]|0)==9){l=c7[c[114006]&255](k,0)|0}else{c[198580]=(c[198580]|0)+1;b=c7[c[114006]&255](k,0)|0;c[198580]=(c[198580]|0)-1;l=b}b=l&255;do{if((l|0)<0){if((k<<16>>16|0)==27|(k<<16>>16|0)==28){m=c[198580]&255;break}else if((k<<16>>16|0)==25|(k<<16>>16|0)==26){m=-1;break}else{m=0;break}}else{m=b}}while(0);a[802752]=m;i=m;return i|0}function oj(b){b=b|0;var d=0,e=0,f=0,g=0;d=c[113992]|0;do{if((d|0)==2){e=b&65535;if(!(e>>>0>=(c[113982]|0)>>>0&e>>>0<(c[113984]|0)>>>0)){break}f=455896+(b&31)|0;g=a[f]|0;return g|0}else if((d|0)==1){e=b&65535;if(!(e>>>0>=(c[113988]|0)>>>0&e>>>0<(c[113990]|0)>>>0)){break}f=455864+(b&31)|0;g=a[f]|0;return g|0}}while(0);f=455832+(b&31)|0;g=a[f]|0;return g|0}function ok(b){b=b|0;var d=0,e=0,f=0;d=b&31;kN(0);if((c[13586]|0)==9){e=c7[c[114006]&255](d,1)|0}else{c[198580]=(c[198580]|0)+1;b=c7[c[114006]&255](d,1)|0;c[198580]=(c[198580]|0)-1;e=b}b=e&255;do{if((e|0)<0){if((d<<16>>16|0)==25|(d<<16>>16|0)==26){f=-1;break}else if((d<<16>>16|0)==27|(d<<16>>16|0)==28){f=c[198580]&255;break}else{f=0;break}}else{f=b}}while(0);a[802752]=f;return f|0}function ol(b){b=b|0;var d=0,e=0,f=0;d=b&31;kN(0);if((c[13586]|0)==9){e=c7[c[114006]&255](d,2)|0}else{c[198580]=(c[198580]|0)+1;b=c7[c[114006]&255](d,2)|0;c[198580]=(c[198580]|0)-1;e=b}b=e&255;do{if((e|0)<0){if((d<<16>>16|0)==25|(d<<16>>16|0)==26){f=-1;break}else if((d<<16>>16|0)==27|(d<<16>>16|0)==28){f=c[198580]&255;break}else{f=0;break}}else{f=b}}while(0);a[802752]=f;return f|0}function om(b,d){b=b|0;d=d|0;var e=0,f=0;e=c[113992]|0;do{if((e|0)==1){f=b&65535;if(!(f>>>0>=(c[113988]|0)>>>0&f>>>0<(c[113990]|0)>>>0)){break}f=b&31;a[455864+(f&65535)|0]=d;kN((c[198568]|0)+1|0);if((c[198568]|0)!=0){c[198580]=(c[198580]|0)-1;dk[c[113986]&127](f,a[802752]|0,1);c[198580]=(c[198580]|0)+1}dk[c[113986]&127](f,d,1);return}else if((e|0)==2){f=b&65535;if(!(f>>>0>=(c[113982]|0)>>>0&f>>>0<(c[113984]|0)>>>0)){break}f=b&31;a[455896+(f&65535)|0]=d;kN((c[198568]|0)+1|0);if((c[198568]|0)!=0){c[198580]=(c[198580]|0)-1;dk[c[113986]&127](f,a[802752]|0,2);c[198580]=(c[198580]|0)+1}dk[c[113986]&127](f,d,2)}}while(0);e=b&31;a[455832+(e&65535)|0]=d;kN((c[198568]|0)+1|0);if((c[198568]|0)!=0){c[198580]=(c[198580]|0)-1;dk[c[113986]&127](e,a[802752]|0,0);c[198580]=(c[198580]|0)+1}dk[c[113986]&127](e,d,0);return}function on(b,d){b=b|0;d=d|0;var e=0,f=0;e=b&31;a[455864+(e&65535)|0]=d;kN((c[198568]|0)+1|0);if((c[198568]|0)==0){f=c[113986]|0;dk[f&127](e,d,1);return}c[198580]=(c[198580]|0)-1;dk[c[113986]&127](e,a[802752]|0,1);c[198580]=(c[198580]|0)+1;f=c[113986]|0;dk[f&127](e,d,1);return}function oo(b,d){b=b|0;d=d|0;var e=0,f=0;e=b&31;a[455896+(e&65535)|0]=d;kN((c[198568]|0)+1|0);if((c[198568]|0)==0){f=c[113986]|0;dk[f&127](e,d,2);return}c[198580]=(c[198580]|0)-1;dk[c[113986]&127](e,a[802752]|0,2);c[198580]=(c[198580]|0)+1;f=c[113986]|0;dk[f&127](e,d,2);return}function op(){is();A2(455832|0,0|0,96|0);return}function oq(a){a=a|0;var b=0;c[113956]=0;if((ic(87936,455824)|0)<0){b=0;return b|0}A$(456056,55984,44)|0;if((c[113956]|0)==1){A$(456056,51192,44)|0}b=da[c[114014]&255](455832+(a<<5)|0)|0;return b|0}function or(a,b,d){a=a|0;b=b|0;d=d|0;return c8[c[114015]&127](a,b,d)|0}function os(a){a=a|0;c4[c[114016]&511](a);return}function ot(a,b){a=a|0;b=b|0;return c7[c[114017]&255](a,b)|0}function ou(a,b,d){a=a|0;b=b|0;d=d|0;dk[c[114018]&127](a,b,d);return}function ov(a,b){a=a|0;b=b|0;c5[c[114019]&255](a,b);return}function ow(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;i=i+8|0;k=j|0;c[k>>2]=c[h>>2];l=(f|0)==1;m=(g|0)==1;if(l&m){n=dj[c[114020]&127](c[a>>2]|0,d,e,1,h)|0;i=j;return n|0}o=(g|0)==2;if(l&o){p=hg(e<<1)|0;q=p;r=c[114020]|0;s=c[a>>2]|0;dj[r&127](s,q,e,1,k)|0;s=dj[c[114020]&127](c[a+4>>2]|0,d,e,1,h)|0;if((s|0)>0){r=0;do{t=d+(r<<1)|0;u=b[t>>1]|0;v=u<<16>>16;w=b[q+(r<<1)>>1]|0;x=w<<16>>16;L325:do{if(u<<16>>16==0){y=w}else{if(w<<16>>16==0){y=u;break}z=u<<16>>16>0;do{if(!(z&w<<16>>16<0)){if(u<<16>>16<0&w<<16>>16>0){break}A=x+v|0;B=(ag(x,v)|0)/32768|0;if(z){y=A-B&65535;break L325}else{y=B+A&65535;break L325}}}while(0);y=w+u&65535}}while(0);b[t>>1]=y;r=r+1|0;}while((r|0)<(s|0))}hj(p);n=s;i=j;return n|0}s=(g|0)==3;if(l&s){l=e<<1;g=hg(l)|0;p=g;r=hg(l)|0;l=r;y=c[114020]|0;q=c[a>>2]|0;dj[y&127](q,p,e,1,k)|0;c[k>>2]=c[h>>2];q=c[114020]|0;y=c[a+8>>2]|0;dj[q&127](y,l,e,1,k)|0;y=dj[c[114020]&127](c[a+4>>2]|0,d,e,1,h)|0;if((y|0)>0){q=0;do{u=d+(q<<1)|0;w=b[u>>1]|0;v=w<<16>>16;x=b[p+(q<<1)>>1]|0;z=x<<16>>16;L344:do{if(w<<16>>16==0){C=x}else{if(x<<16>>16==0){C=w;break}A=w<<16>>16>0;do{if(!(A&x<<16>>16<0)){if(w<<16>>16<0&x<<16>>16>0){break}B=z+v|0;D=(ag(z,v)|0)/32768|0;if(A){C=B-D&65535;break L344}else{C=D+B&65535;break L344}}}while(0);C=x+w&65535}}while(0);b[u>>1]=C;w=C<<16>>16;x=b[l+(q<<1)>>1]|0;v=x<<16>>16;L355:do{if(C<<16>>16==0){E=x}else{if(x<<16>>16==0){E=C;break}z=C<<16>>16>0;do{if(!(z&x<<16>>16<0)){if(C<<16>>16<0&x<<16>>16>0){break}t=v+w|0;A=(ag(v,w)|0)/32768|0;if(z){E=t-A&65535;break L355}else{E=A+t&65535;break L355}}}while(0);E=x+C&65535}}while(0);b[u>>1]=E;q=q+1|0;}while((q|0)<(y|0))}hj(g);hj(r);n=y;i=j;return n|0}y=(f|0)==2;if(y&m){m=dj[c[114020]&127](c[a>>2]|0,d,e,2,h)|0;if((m|0)>0){F=0}else{n=m;i=j;return n|0}while(1){f=F<<1;b[d+((f|1)<<1)>>1]=b[d+(f<<1)>>1]|0;f=F+1|0;if((f|0)<(m|0)){F=f}else{n=m;break}}i=j;return n|0}if(y&o){o=c[114020]|0;m=c[a>>2]|0;dj[o&127](m,d,e,2,k)|0;n=dj[c[114020]&127](c[a+4>>2]|0,d+2|0,e,2,h)|0;i=j;return n|0}if(!(y&s)){n=0;i=j;return n|0}s=hg(e<<1)|0;y=s;dj[c[114020]&127](c[a+8>>2]|0,y,e,1,k)|0;c[k>>2]=c[h>>2];dj[c[114020]&127](c[a>>2]|0,d,e,2,k)|0;k=dj[c[114020]&127](c[a+4>>2]|0,d+2|0,e,2,h)|0;if((k|0)>0){h=0;do{e=h<<1;a=d+(e<<1)|0;m=b[a>>1]|0;o=m<<16>>16;F=y+(h<<1)|0;f=b[F>>1]|0;r=f<<16>>16;L387:do{if(m<<16>>16==0){G=f}else{if(f<<16>>16==0){G=m;break}g=m<<16>>16>0;do{if(!(g&f<<16>>16<0)){if(m<<16>>16<0&f<<16>>16>0){break}q=r+o|0;E=(ag(r,o)|0)/32768|0;if(g){G=q-E&65535;break L387}else{G=E+q&65535;break L387}}}while(0);G=f+m&65535}}while(0);b[a>>1]=G;m=d+((e|1)<<1)|0;f=b[m>>1]|0;o=f<<16>>16;r=b[F>>1]|0;u=r<<16>>16;L398:do{if(f<<16>>16==0){H=r}else{if(r<<16>>16==0){H=f;break}g=f<<16>>16>0;do{if(!(g&r<<16>>16<0)){if(f<<16>>16<0&r<<16>>16>0){break}q=u+o|0;E=(ag(u,o)|0)/32768|0;if(g){H=q-E&65535;break L398}else{H=E+q&65535;break L398}}}while(0);H=r+f&65535}}while(0);b[m>>1]=H;h=h+1|0;}while((h|0)<(k|0))}hj(s);n=k;i=j;return n|0}function ox(a,b){a=a|0;b=b|0;c5[c[114021]&255](a,b);return}function oy(a){a=a|0;return da[c[114022]&255](a)|0}function oz(){var a=0;a=c[113956]|0;return(a>>>0<2>>>0?a:0)|0}function oA(){var a=0,b=0;a=i;i=i+8|0;b=a|0;c[b>>2]=0;ic(89112,b)|0;i=a;return(c[b>>2]|0)+1|0}function oB(a){a=a|0;c[114026]=a;if((a|0)==0){c[114006]=110;c[113986]=40;return}a=c[12018]|0;if((a|0)==0){c[114006]=168;c[113986]=38;return}else if((a|0)==1){c[114006]=168;c[113986]=38;return}else{return}}function oC(a){a=a|0;c[12018]=a;if((c[114026]|0)==0){c[114006]=110;c[113986]=40;return 0}if((a|0)==0){c[114006]=168;c[113986]=38;return 0}else if((a|0)==1){c[114006]=168;c[113986]=38;return 0}else{return 0}return 0}function oD(a){a=a|0;return}function oE(a,b){a=a|0;b=b|0;var d=0;if((a<<16>>16|0)==25|(a<<16>>16|0)==26){d=255}else if((a<<16>>16|0)==27|(a<<16>>16|0)==28){d=c[198580]&255}else{d=0}return d|0}function oF(a,b,c){a=a|0;b=b|0;c=c|0;return}function oG(a,b){a=a|0;b=b|0;var d=0;if((ke(a)|0)<0){d=-1;return d|0}c[113988]=a;c[113990]=a+32;d=0;return d|0}function oH(a,b){a=a|0;b=b|0;var d=0;if((kf(a)|0)<0){d=-1;return d|0}c[113982]=a;c[113984]=a+32;d=0;return d|0}function oI(){var a=0;do{if((h1(51048)|0)<0){a=-1}else{if((h1(47904)|0)<0){a=-1;break}a=h1(56320)|0}}while(0);return a|0}function oJ(a,b){a=a|0;b=b|0;var d=0;if(((c[13586]|0)-3|0)>>>0<6>>>0){c[113992]=0;d=0;return d|0}if((c[113992]|0)==(a|0)){d=0;return d|0}if(a>>>0>2>>>0){d=-1;return d|0}c[113992]=a;c[81092]=1;kg(a);d=0;return d|0}function oK(a,b){a=a|0;b=b|0;c[113998]=a;c[113994]=1;return 0}function oL(a,b){a=a|0;b=b|0;var d=0;if((a|0)<0){d=0}else{d=(a|0)>90?90:a}c[114e3]=d;c[113994]=1;return 0}function oM(a,b){a=a|0;b=b|0;var d=0;if((a|0)<90){d=90}else{d=(a|0)>100?100:a}c[114002]=d;c[113994]=1;return 0}function oN(a,b){a=a|0;b=b|0;var d=0;if((a|0)<-5e3){d=5e3}else{d=(a|0)>5e3?5e3:a}c[114004]=d;c[113994]=1;return 0}function oO(a,b){a=a|0;b=b|0;var d=0,e=0;do{if((a|0)==99){d=(c[13586]|0)!=3|0}else{if(a>>>0>1>>>0){e=-1}else{d=a;break}return e|0}}while(0);if((oC(d)|0)<0){e=-1;return e|0}c[114012]=d;c[81092]=1;e=0;return e|0}function oP(a,b){a=a|0;b=b|0;c[114010]=a;c[113994]=1;return 0}function oQ(a,b){a=a|0;b=b|0;c[114008]=a;do{if((a|0)==99){c[114008]=0;b=c[13586]|0;if((b|0)==8){c[114008]=4;break}else if((b|0)==2){c[114008]=1;break}else{break}}}while(0);c[113994]=1;return 0}function oR(){return il(77336)|0}function oS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+56|0;e=f|0;h=e|0;A$(h|0,77280,54)|0;j=c[d>>2]|0;if((j-8e3|0)>>>0>4e4>>>0){k=1;i=f;return k|0}d=bV(((b|0)!=0?b:85504)|0,83264)|0;c[217748]=d;if((d|0)==0){k=1;i=f;return k|0}c[115230]=0;a[e+21|0]=c[g>>2]&255;g=e+29|0;b=e+30|0;l=e+31|0;e=0;m=2;while(1){n=m<<1;if(j>>>0>=m>>>0&j>>>0<n>>>0){a[g]=e&255;o=j<<14-e;a[b]=o>>>8&255;a[l]=o&255}o=e+1|0;if((o|0)<15){e=o;m=n}else{break}}k=(aU(h|0,1,54,d|0)|0)!=54|0;i=f;return k|0}function oT(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=(d|0)==0;if(!e){f=0;do{g=a+(f<<1)|0;b[g>>1]=cb(b[g>>1]|0)|0;f=f+1|0;}while(f>>>0<d>>>0)}if((aU(a|0,2,d|0,c[217748]|0)|0)!=(d|0)){h=1;return h|0}if(!e){e=0;do{f=a+(e<<1)|0;b[f>>1]=cb(b[f>>1]|0)|0;e=e+1|0;}while(e>>>0<d>>>0)}c[115230]=(c[115230]|0)+d;h=0;return h|0}function oU(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=b|0;e=b+8|0;f=b+16|0;g=c[115230]|0;h=e|0;a[h]=g>>>24&255;a[e+1|0]=g>>>16&255;a[e+2|0]=g>>>8&255;a[e+3|0]=g&255;e=g<<1;g=e+8|0;j=d|0;a[j]=g>>>24&255;a[d+1|0]=g>>>16&255;a[d+2|0]=g>>>8&255;a[d+3|0]=g&255;g=e+46|0;e=f|0;a[e]=g>>>24&255;a[f+1|0]=g>>>16&255;a[f+2|0]=g>>>8&255;a[f+3|0]=g&255;cE(c[217748]|0,4,0)|0;g=(aU(e|0,1,4,c[217748]|0)|0)==4;e=c[217748]|0;do{if(g){cE(e|0,22,0)|0;f=(aU(h|0,1,4,c[217748]|0)|0)==4;d=c[217748]|0;if(!f){aM(d|0)|0;c[217748]=0;break}cE(d|0,42,0)|0;d=(aU(j|0,1,4,c[217748]|0)|0)==4;f=c[217748]|0;aM(f|0)|0;c[217748]=0;if(!d){break}i=b;return}else{aM(e|0)|0;c[217748]=0}}while(0);hw(89048,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0)|0;i=e;i=b;return}function oV(){return il(56128)|0}function oW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=1;f=bV(((a|0)!=0?a:83248)|0,81704)|0;c[200906]=f;return(f|0)==0|0}function oX(a,b){a=a|0;b=b|0;return 0}function oY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=cu(c[200906]|0,85488,(g=i,i=i+24|0,c[g>>2]=d,c[g+8>>2]=a&65535,c[g+16>>2]=b&255,g)|0)|0;i=g;i=e;return f>>>31|0}function oZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=cu(c[200906]|0,89040,(e=i,i=i+8|0,c[e>>2]=a,e)|0)|0;i=e;if((d|0)<0){f=1;i=b;return f|0}f=aQ(c[200906]|0)|0;i=b;return f|0}function o_(){aM(c[200906]|0)|0;c[200906]=0;return}function o$(){return il(55640)|0}function o0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=1;f=bV(((a|0)!=0?a:89e3)|0,85480)|0;c[200826]=f;return(f|0)==0|0}function o1(a,b){a=a|0;b=b|0;return(aU(a|0,2,b|0,c[200826]|0)|0)!=(b|0)|0}function o2(){aM(c[200826]|0)|0;c[200826]=0;return}function o3(){return il(55592)|0}function o4(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;f=i;i=i+112|0;e=f|0;h=f+48|0;j=e|0;A$(j|0,55544,48)|0;k=h|0;A$(k|0,55480,60)|0;l=c[d>>2]|0;d=bV(((b|0)!=0?b:85464)|0,83240)|0;c[200810]=d;if((d|0)==0){m=1;i=f;return m|0}c[115228]=0;if((c[g>>2]|0)==2){a[47960]=1;a[h+32|0]=l>>>8&255;a[h+33|0]=l&255;if((aU(k|0,1,60,d|0)|0)==60){m=0;i=f;return m|0}k=c[200810]|0;aM(k|0)|0;m=1;i=f;return m|0}else{a[47960]=0;a[e+32|0]=l>>>8&255;a[e+33|0]=l&255;if((aU(j|0,1,48,d|0)|0)==48){m=0;i=f;return m|0}d=c[200810]|0;aM(d|0)|0;m=1;i=f;return m|0}return 0}function o5(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0;f=i;i=i+8|0;L571:do{if((d|0)!=0){g=f|0;h=0;while(1){a[g]=(e[b+(h<<1)>>1]|0)>>>8&255;h=h+1|0;if((aU(g|0,1,1,c[200810]|0)|0)!=1){j=1;break}if(h>>>0>=d>>>0){break L571}}i=f;return j|0}}while(0);c[115228]=(c[115228]|0)+d;j=0;i=f;return j|0}function o6(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+24|0;d=b|0;e=b+8|0;f=b+16|0;g=c[115228]|0;h=g>>>24&255;j=d|0;a[j]=h;k=g>>>16&255;a[d+1|0]=k;l=g>>>8&255;a[d+2|0]=l;m=g&255;a[d+3|0]=m;if(a[47960]|0){a[e|0]=g>>25&255;a[e+1|0]=g>>>17&255;a[e+2|0]=g>>>9&255;a[e+3|0]=g>>>1&255;d=g+52|0;a[f|0]=d>>>24&255;a[f+1|0]=d>>>16&255;a[f+2|0]=d>>>8&255;a[f+3|0]=d&255}else{a[e|0]=h;a[e+1|0]=k;a[e+2|0]=l;a[e+3|0]=m;m=g+40|0;a[f|0]=m>>>24&255;a[f+1|0]=m>>>16&255;a[f+2|0]=m>>>8&255;a[f+3|0]=m&255}cE(c[200810]|0,4,0)|0;m=(aU(f|0,1,4,c[200810]|0)|0)==4;f=c[200810]|0;do{if(m){cE(f|0,20,0)|0;if((aU(e|0,1,4,c[200810]|0)|0)!=4){g=c[200810]|0;aM(g|0)|0;c[200810]=0;break}g=c[200810]|0;if(a[47960]|0){cE(g|0,56,0)|0}else{cE(g|0,44,0)|0}g=(aU(j|0,1,4,c[200810]|0)|0)==4;l=c[200810]|0;aM(l|0)|0;c[200810]=0;if(!g){break}i=b;return}else{aM(f|0)|0;c[200810]=0}}while(0);hw(88976,(f=i,i=i+1|0,i=i+7&-8,c[f>>2]=0,f)|0)|0;i=f;i=b;return}function o7(){return il(47976)|0}function o8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;e=c[200822]|0;if((e|0)==0){g=-1;return g|0}d=c[e>>2]|0;if((d|0)==0){g=-1;return g|0}g=c8[d&127](c[b>>2]|0,c[f>>2]|0,862448)|0;return g|0}function o9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=c[200822]|0;if((d|0)==0){return 0}if((c[d+4>>2]|0)==0){return 0}d=c[215612]|0;if((d|0)==0){return 0}e=c[d+4>>2]|0;if((e|0)==0|(b|0)==0){return 0}else{f=0;g=d}while(1){d=c[g+8>>2]|0;h=e-d|0;i=b-f|0;j=(h|0)>(i|0)?i:h;h=(c[g>>2]|0)+(d<<1)|0;d=a+(f<<1)|0;i=j<<1;A$(h|0,d|0,i)|0;i=(c[215612]|0)+8|0;c[i>>2]=(c[i>>2]|0)+j;i=j+f|0;j=c[215612]|0;if((c[j+8>>2]|0)==(e|0)){d=c[(c[200822]|0)+4>>2]|0;da[d&255](j)|0;c[(c[215612]|0)+8>>2]=0}if(i>>>0>=b>>>0){break}f=i;g=c[215612]|0}return 0}function pa(){var a=0,b=0;a=c[200822]|0;if((a|0)==0){return}b=c[a+8>>2]|0;if((b|0)==0){return}dd[b&63]();return}function pb(){return il(29368)|0}function pc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;f=i;i=i+48|0;e=f+32|0;h=f|0;A$(h|0,29320,26)|0;j=e|0;A$(j|0,29352,16)|0;k=c[d>>2]|0;d=bV(((b|0)!=0?b:85448)|0,83232)|0;c[80480]=d;if((d|0)==0){l=1;i=f;return l|0}c[115226]=0;c[200882]=0;b=(aU(h|0,1,26,d|0)|0)==26;d=c[80480]|0;if(b){c[215614]=bq(d|0)|0;a[e+9|0]=c[g>>2]&255;a[e+4|0]=k&255;a[e+5|0]=k>>>8&255;a[e+6|0]=k>>>16&255;a[e+7|0]=k>>>24&255;l=(aU(j|0,1,16,c[80480]|0)|0)!=16|0;i=f;return l|0}else{aM(d|0)|0;l=1;i=f;return l|0}return 0}function pd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e|0;g=e+8|0;a[g]=a[29312]|0;a[g+1|0]=a[29313]|0;a[g+2|0]=a[29314]|0;a[g+3|0]=a[29315]|0;a[g+4|0]=a[29316]|0;h=c[115226]|0;do{if((h+(d<<1)|0)>>>0>7323647>>>0){j=h<<1;if((c[200882]|0)==0){k=j+12|0;l=f|0;a[l]=k&255;a[f+1|0]=k>>>8&255;a[f+2|0]=k>>>16&255;k=c[80480]|0;m=(c[215614]|0)+1|0;cE(k|0,m|0,0)|0;if((aU(l|0,1,3,c[80480]|0)|0)!=3){n=1;i=e;return n|0}l=c[80480]|0;cE(l|0,0,2)|0;c[215614]=bq(c[80480]|0)|0;if((aU(g|0,1,4,c[80480]|0)|0)==4){c[115226]=0;c[200882]=(c[200882]|0)+1;break}else{n=1;i=e;return n|0}}else{l=f|0;a[l]=j&255;a[f+1|0]=h>>>7&255;a[f+2|0]=h>>>15&255;j=c[80480]|0;m=(c[215614]|0)+1|0;cE(j|0,m|0,0)|0;if((aU(l|0,1,3,c[80480]|0)|0)!=3){n=1;i=e;return n|0}l=c[80480]|0;cE(l|0,0,2)|0;c[215614]=bq(c[80480]|0)|0;if((aU(g|0,1,4,c[80480]|0)|0)==4){c[115226]=0;break}else{n=1;i=e;return n|0}}}}while(0);if((aU(b|0,2,d|0,c[80480]|0)|0)!=(d|0)){n=1;i=e;return n|0}c[115226]=(c[115226]|0)+d;n=0;i=e;return n|0}function pe(){var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b|0;e=c[115226]|0;f=d|0;a[f]=e<<1&255;a[d+1|0]=e>>>7&255;a[d+2|0]=e>>>15&255;cE(c[80480]|0,(c[215614]|0)+1|0,0)|0;e=(aU(f|0,1,3,c[80480]|0)|0)==3;aM(c[80480]|0)|0;c[80480]=0;if(e){i=b;return}hw(88936,(e=i,i=i+1|0,i=i+7&-8,c[e>>2]=0,e)|0)|0;i=e;i=b;return}function pf(){return il(29256)|0}function pg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;f=i;i=i+48|0;e=f|0;h=e|0;A$(h|0,29208,45)|0;j=c[d>>2]|0;d=c[g>>2]|0;k=bV(((b|0)!=0?b:85432)|0,83224)|0;c[80446]=k;if((k|0)==0){l=1;i=f;return l|0}c[115224]=0;b=c[g>>2]|0;a[e+22|0]=b&255;a[e+23|0]=b>>>8&255;g=ag(j<<1,d)|0;a[e+24|0]=j&255;a[e+25|0]=j>>>8&255;a[e+26|0]=j>>>16&255;a[e+27|0]=j>>>24&255;a[e+28|0]=g&255;a[e+29|0]=g>>>8&255;a[e+30|0]=g>>>16&255;a[e+31|0]=g>>>24&255;a[e+32|0]=b<<1&255;a[e+33|0]=b>>>7&255;l=(aU(h|0,1,44,k|0)|0)!=44|0;i=f;return l|0}function ph(a,b){a=a|0;b=b|0;var d=0;if((aU(a|0,2,b|0,c[80446]|0)|0)!=(b|0)){d=1;return d|0}c[115224]=(c[115224]|0)+b;d=0;return d|0}function pi(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=c[115224]|0;g=f<<1;h=g+36|0;j=d|0;a[j]=h&255;a[d+1|0]=h>>>8&255;a[d+2|0]=h>>>16&255;a[d+3|0]=h>>>24&255;h=e|0;a[h]=g&255;a[e+1|0]=f>>>7&255;a[e+2|0]=f>>>15&255;a[e+3|0]=f>>>23&255;cE(c[80446]|0,4,0)|0;f=(aU(j|0,1,4,c[80446]|0)|0)==4;j=c[80446]|0;do{if(f){cE(j|0,32,1)|0;e=(aU(h|0,1,4,c[80446]|0)|0)==4;g=c[80446]|0;aM(g|0)|0;c[80446]=0;if(!e){break}i=b;return}else{aM(j|0)|0;c[80446]=0}}while(0);hw(88912,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;i=b;return}function pj(a,d){a=a|0;d=d|0;b[161614]=a;b[161616]=d;b[161615]=a;b[161617]=d;if((c[80534]|0)<=0){return}pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return}function pk(a,b){a=a|0;b=b|0;qn(a,b);if((c[80534]|0)==0){return}pl();np();return}function pl(){var a=0,b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0;a=i;i=i+16|0;b=a|0;d=a+8|0;e=c[80892]|0;f=c[80893]|0;h=e+320+f|0;j=c[80887]|0;k=c[80886]|0;nq(322140,h,j+1-k|0,h,c[80885]|0,320,200,40,25,e,c[80888]|0,(c[80908]|0)!=0|0,k,j,136-e|0,-456-f+(c[80897]|0)|0);ic(80912,d)|0;f=c[d>>2]|0;if((f|0)==(-4|0)){l=.9076923131942749}else if((f|0)==(-2|0)){l=.75}else if((f|0)==(-1|0)){l=.9365079402923584}else if((f|0)==(-3|0)){l=.76171875}else{l=1.0}g[(c[80536]|0)+52>>2]=l;ic(80912,b)|0;f=c[b>>2]|0;if((f|0)==(-1|0)|(f|0)==(-4|0)){m=1;n=4;o=0;p=c[80535]|0;q=p+28|0;c[q>>2]=m;i=a;return}m=0;n=4;o=0;p=c[80535]|0;q=p+28|0;c[q>>2]=m;i=a;return}function pm(){return}function pn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;if((a|0)==0){while(1){b=c[198580]|0;if(b>>>0<(c[80880]|0)>>>0){d=0;e=b}else{pF(0,0);d=1;e=c[198580]|0}if(e>>>0<(c[80881]|0)>>>0){if((d|0)==0){break}else{continue}}else{po(0,0);continue}}return}d=(c[198580]|0)-a|0;c[198580]=d;e=d;while(1){if(e>>>0>(c[80880]|0)>>>0){pF(0,0);f=1;g=c[198580]|0}else{f=0;g=e}if(g>>>0<(c[80881]|0)>>>0){if((f|0)==0){break}else{e=g;continue}}else{po(0,0);e=c[198580]|0;continue}}c[198580]=g+a;return}function po(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=a[323348]|0;b=a[323349]|0;f=c[80551]|0;g=c[80887]|0;if(f>>>0<(c[80886]|0)>>>0){h=0}else{h=f>>>0<=g>>>0|0}i=c[80885]|0;if(g>>>0<i>>>0){j=h}else{j=f>>>0<=(g-i|0)>>>0|h}c[80547]=0;qg();nI(322140);do{if((c[80551]|0)==0){if((c[80887]|0)>>>0<(c[80885]|0)>>>0){nu(322140,je(c[80540]|0,c[80550]|0)|0)}c[80845]=0;c[80846]=0;c[80853]=0;if((c[80852]|0)!=0){h=c[198580]|0;c[80853]=1;i=c[80894]|0;g=(((h>>>0)%(i>>>0)|0)<<3)-104|0;c[80854]=g;if((g|0)<0){f=(c[80897]|0)+g|0;c[80854]=f;k=f}else{k=g}c[80854]=((k|0)/2|0)+2+(c[80856]|0);c[80856]=0;c[80855]=(((h>>>0)/(i>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0;pO(h)}c[80562]=0;if((c[80908]|0)==0){break}A2(323304,0,40);if((c[215616]&64|0)!=0){qm()}if((c[200910]&64|0)!=0){ql()}h=c[80841]|0;if((h-13|0)>>>0>=5>>>0){break}c[80574]=1;if((h|0)!=17){break}pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)}}while(0);k=c[80887]|0;h=c[80885]|0;do{if(k>>>0>=h>>>0){if((c[80551]|0)!=(k+1-h|0)){break}nu(322140,je(c[80540]|0,c[80550]|0)|0)}}while(0);h=(c[80908]|0)==0;do{if(!h){k=c[80918]|0;i=c[80551]|0;if(!((k|0)==0&(i|0)==48)){if(!((k|0)!=0&(i|0)==10)){break}}c[80729]=d[322895]<<8|d[322894]|d[322905]<<16;c[80732]=d[322910]<<8|d[322909]|d[322911]<<16}}while(0);if((j|0)!=0){j=c[80842]|0;do{if((j|0)==0){c[80846]=(c[80847]|0)+(c[80846]|0)&1023;c[80847]=40;if(h){l=632;break}i=c[80841]|0;k=c[80569]|0;g=(k|0)==7;if(!((i|0)==5&g)){c[80729]=(c[80729]|0)+(c[80730]|0);c[80732]=(c[80732]|0)+(c[80733]|0)}f=c[80731]|0;if((c[80918]|0)==0){c[80729]=(c[80729]|0)+(f*40|0);m=(c[80732]|0)+((c[80734]|0)*40|0)|0}else{c[80729]=(c[80729]|0)+(f*48|0);m=(c[80732]|0)+((c[80734]|0)*48|0)|0}c[80732]=m;if(!((i|0)==17&g)){n=k;l=640;break}c[80814]=(c[80814]|0)+(c[80730]|0);l=641}else{c[80847]=40;l=632}}while(0);if((l|0)==632){n=c[80569]|0;l=640}if((l|0)==640){if((n|0)==7){l=641}else{o=j;p=n}}if((l|0)==641){c[80842]=1;c[80845]=c[80846];o=1;p=7}if((o|0)==0|(c[80848]|0)!=0){c[80569]=p+1&7;c[80842]=0;q=0}else{q=o}if((c[80843]|0)==0){r=q}else{c[80842]=0;c[80843]=0;r=0}c[80568]=r;c[80848]=0}c[80849]=0;c[80844]=0;c[80815]=0;if((c[80551]|0)==(c[80898]|0)){c[80836]=(c[80563]|0)==0}do{if((c[80523]|0)!=0){if(!((a[(c[80538]|0)+32|0]|0)!=0&e<<24>>24==0)){break}pM()}}while(0);do{if((c[80524]|0)!=0){if(!((a[(c[80538]|0)+33|0]|0)!=0&b<<24>>24==0)){break}pK()}}while(0);do{if((c[80842]|0)==0){c[80872]=0}else{if((a[322853]&64)==0){c[80872]=1;c[80859]=d[(c[80804]|0)+((c[80858]|0)+16383)|0]|0;break}else{c[80872]=2;c[80859]=d[(c[80804]|0)+((c[80858]|0)+14847)|0]|0;break}}}while(0);b=(c[80883]|0)+(c[80894]|0)|0;c[80883]=b;e=b+(c[80895]|0)|0;c[80881]=e;b=c[80875]|0;r=c[b+4>>2]|0;q=b+12|0;o=c[q>>2]|0;if((o|0)<0){p=r+2056|0;l=c[p>>2]|0;if(l>>>0>255>>>0){fW();return}c[r+8+(l<<3)>>2]=b;c[r+8+(l<<3)+4>>2]=e;c[p>>2]=(c[p>>2]|0)+1;p=r+2060|0;if((c[p>>2]|0)>>>0>e>>>0){c[p>>2]=e;c[r+2064>>2]=l}c[q>>2]=l;return}else{c[r+8+(o<<3)+4>>2]=e;l=r+2060|0;q=r+2064|0;p=c[q>>2]|0;do{if((c[l>>2]|0)>>>0>e>>>0){s=p}else{if((o|0)==(p|0)){s=o;break}return}}while(0);o=c[r+2056>>2]|0;if((o|0)==0){t=s;u=-1}else{p=s;s=0;e=-1;while(1){b=c[r+8+(s<<3)+4>>2]|0;n=b>>>0>e>>>0;j=n?p:s;m=n?e:b;b=s+1|0;if(b>>>0<o>>>0){p=j;s=b;e=m}else{t=j;u=m;break}}}c[l>>2]=u;c[q>>2]=t;return}}function pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;if((c[80534]|0)==0){return}if((a|0)==0){while(1){b=c[198580]|0;if(b>>>0<(c[80880]|0)>>>0){d=0;e=b}else{pF(0,0);d=1;e=c[198580]|0}if(e>>>0<(c[80881]|0)>>>0){if((d|0)==0){break}else{continue}}else{po(0,0);continue}}return}d=(c[198580]|0)-a|0;c[198580]=d;e=d;while(1){if(e>>>0>(c[80880]|0)>>>0){pF(0,0);f=1;g=c[198580]|0}else{f=0;g=e}if(g>>>0<(c[80881]|0)>>>0){if((f|0)==0){break}else{e=g;continue}}else{po(0,0);e=c[198580]|0;continue}}c[198580]=g+a;return}function pq(){var a=0,b=0,d=0,e=0,f=0,g=0;if((c[80534]|0)==0){return}a=(c[198568]|0)+1|0;if((a|0)==0){while(1){b=c[198580]|0;if(b>>>0<(c[80880]|0)>>>0){d=0;e=b}else{pF(0,0);d=1;e=c[198580]|0}if(e>>>0<(c[80881]|0)>>>0){if((d|0)==0){break}else{continue}}else{po(0,0);continue}}return}d=(c[198580]|0)-a|0;c[198580]=d;e=d;while(1){if(e>>>0>(c[80880]|0)>>>0){pF(0,0);f=1;g=c[198580]|0}else{f=0;g=e}if(g>>>0<(c[80881]|0)>>>0){if((f|0)==0){break}else{e=g;continue}}else{po(0,0);e=c[198580]|0;continue}}c[198580]=g+a;return}function pr(d){d=d|0;var e=0,f=0;e=i;c[80909]=0;c[80910]=0;if((d|0)==1){c[80907]=1;c[80908]=0;c[80873]=hq(87296)|0}else if((d|0)==2){c[80907]=0;c[80908]=1;c[80873]=hq(88896)|0}else{c[80907]=0;c[80908]=0;c[80873]=hq(85424)|0}pT();pG();c[80875]=fU(c[198582]|0,83208,56,0)|0;nY(322140,8,qf()|0);nL(322140);if((nn(322140,20)|0)<0){f=0;i=e;return f|0}nS(c[80537]|0,19)|0;ig(81144)|0;pl();if((pD(c[80540]|0)|0)<0){d=c[80873]|0;hv(d,81016,(d=i,i=i+1|0,i=i+7&-8,c[d>>2]=0,d)|0)|0;i=d;f=0;i=e;return f|0}nt(322140,54312);if((ns(322140)|0)<0){f=0;i=e;return f|0}c[80564]=c[80888];c[80565]=c[80889];d=c[80892]|0;c[80566]=d;c[80567]=d+320;if((c[80908]|0)!=0){c[80560]=1}A2(322836,0,80);c[80801]=0;c[80802]=0;c[80882]=1;c[80803]=719208;c[80804]=719208;b[161610]=-1;b[161611]=-1;b[161612]=0;b[161613]=0;c[80836]=0;a[323349]=0;a[323348]=0;c[80877]=0;c[80872]=0;c[80883]=0;A2(323368,0,36);A2(323408,0,32);pv();c[80563]=1;c[80564]=c[80890];c[80565]=c[80891];c[80545]=0;c[80841]=-1;ps(0);pt(0);q$();qa();c[80903]=0;c[80905]=0;c[80904]=hg(512)|0;c[80906]=hg(512)|0;c[80815]=0;c[80534]=1;fZ(c[198578]|0,36,0);f=322140;i=e;return f|0}function ps(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=(a[322858]&16|a[322853]&96)>>>4;if((c[80908]|0)==0){f=e}else{g=d[322896]|0;h=g&4;i=g<<3&8|e|h<<1;e=(i|0)==15&(h|0)==0?16:i;do{if((e|0)==13){if((g&16|0)!=0){j=13;k=733;break}l=18-(h>>>2)|0;k=732}else{l=e;k=732}}while(0);if((k|0)==732){if((l-13|0)>>>0<5>>>0){j=l;k=733}else{m=l}}if((k|0)==733){c[80574]=1;m=j}pY();f=m}if((f|0)==(c[80841]|0)){return}switch(f|0){case 2:{m=(b<<3)-136+(c[80892]|0)|0;do{if((m|0)<1){c[80554]=0}else{j=c[80539]|0;if((c[c[80536]>>2]|0)>(m|0)){k=c[j>>2]|0;l=k|0;e=c[l>>2]|0;c[l>>2]=e+1;c[k+4+(e<<4)>>2]=m;c[k+4+(e<<4)+4>>2]=0;c[k+4+(e<<4)+8>>2]=322216;c[k+4+(e<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1;break}else{e=c[j+16>>2]|0;j=e|0;k=c[j>>2]|0;c[j>>2]=k+1;c[e+4+(k<<4)>>2]=0;c[e+4+(k<<4)+4>>2]=0;c[e+4+(k<<4)+8>>2]=322216;c[e+4+(k<<4)+12>>2]=0;break}}}while(0);m=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;k=c[80851]&15;do{if((m|0)<1){c[80555]=k}else{e=c[80539]|0;if((c[c[80536]>>2]|0)>(m|0)){j=c[e>>2]|0;l=j|0;h=c[l>>2]|0;c[l>>2]=h+1;c[j+4+(h<<4)>>2]=m;c[j+4+(h<<4)+4>>2]=0;c[j+4+(h<<4)+8>>2]=322220;c[j+4+(h<<4)+12>>2]=k;c[(c[80539]|0)+20>>2]=1;break}else{h=c[e+16>>2]|0;e=h|0;j=c[e>>2]|0;c[e>>2]=j+1;c[h+4+(j<<4)>>2]=0;c[h+4+(j<<4)+4>>2]=0;c[h+4+(j<<4)+8>>2]=322220;c[h+4+(j<<4)+12>>2]=k;break}}}while(0);c[80900]=2;c[80850]=1;break};case 4:{k=(b<<3)-136+(c[80892]|0)|0;m=d[322869]|0;if((c[80908]|0)==0){n=m}else{n=d[322940+m|0]|0}do{if((k|0)<1){c[80554]=n}else{m=c[80539]|0;if((c[c[80536]>>2]|0)>(k|0)){j=c[m>>2]|0;h=j|0;e=c[h>>2]|0;c[h>>2]=e+1;c[j+4+(e<<4)>>2]=k;c[j+4+(e<<4)+4>>2]=0;c[j+4+(e<<4)+8>>2]=322216;c[j+4+(e<<4)+12>>2]=n;c[(c[80539]|0)+20>>2]=1;break}else{e=c[m+16>>2]|0;m=e|0;j=c[m>>2]|0;c[m>>2]=j+1;c[e+4+(j<<4)>>2]=0;c[e+4+(j<<4)+4>>2]=0;c[e+4+(j<<4)+8>>2]=322216;c[e+4+(j<<4)+12>>2]=n;break}}}while(0);n=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;k=d[(c[80851]>>6)+322869|0]|0;if((c[80908]|0)==0){o=k}else{o=d[322940+k|0]|0}do{if((n|0)<1){c[80555]=o}else{k=c[80539]|0;if((c[c[80536]>>2]|0)>(n|0)){j=c[k>>2]|0;e=j|0;m=c[e>>2]|0;c[e>>2]=m+1;c[j+4+(m<<4)>>2]=n;c[j+4+(m<<4)+4>>2]=0;c[j+4+(m<<4)+8>>2]=322220;c[j+4+(m<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1;break}else{m=c[k+16>>2]|0;k=m|0;j=c[k>>2]|0;c[k>>2]=j+1;c[m+4+(j<<4)>>2]=0;c[m+4+(j<<4)+4>>2]=0;c[m+4+(j<<4)+8>>2]=322220;c[m+4+(j<<4)+12>>2]=o;break}}}while(0);c[80900]=4;c[80850]=0;break};case 5:case 6:case 7:case 18:{o=(b<<3)-136+(c[80892]|0)|0;do{if((o|0)<1){c[80554]=0}else{n=c[80539]|0;if((c[c[80536]>>2]|0)>(o|0)){j=c[n>>2]|0;m=j|0;k=c[m>>2]|0;c[m>>2]=k+1;c[j+4+(k<<4)>>2]=o;c[j+4+(k<<4)+4>>2]=0;c[j+4+(k<<4)+8>>2]=322216;c[j+4+(k<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1;break}else{k=c[n+16>>2]|0;n=k|0;j=c[n>>2]|0;c[n>>2]=j+1;c[k+4+(j<<4)>>2]=0;c[k+4+(j<<4)+4>>2]=0;c[k+4+(j<<4)+8>>2]=322216;c[k+4+(j<<4)+12>>2]=0;break}}}while(0);o=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;do{if((o|0)<1){c[80555]=0}else{j=c[80539]|0;if((c[c[80536]>>2]|0)>(o|0)){k=c[j>>2]|0;n=k|0;m=c[n>>2]|0;c[n>>2]=m+1;c[k+4+(m<<4)>>2]=o;c[k+4+(m<<4)+4>>2]=0;c[k+4+(m<<4)+8>>2]=322220;c[k+4+(m<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1;break}else{m=c[j+16>>2]|0;j=m|0;k=c[j>>2]|0;c[j>>2]=k+1;c[m+4+(k<<4)>>2]=0;c[m+4+(k<<4)+4>>2]=0;c[m+4+(k<<4)+8>>2]=322220;c[m+4+(k<<4)+12>>2]=0;break}}}while(0);c[80900]=0;c[80850]=1;break};default:{o=(b<<3)-136+(c[80892]|0)|0;k=d[322869]|0;if((c[80908]|0)==0){p=k}else{p=d[322940+k|0]|0}do{if((o|0)<1){c[80554]=p}else{k=c[80539]|0;if((c[c[80536]>>2]|0)>(o|0)){m=c[k>>2]|0;j=m|0;n=c[j>>2]|0;c[j>>2]=n+1;c[m+4+(n<<4)>>2]=o;c[m+4+(n<<4)+4>>2]=0;c[m+4+(n<<4)+8>>2]=322216;c[m+4+(n<<4)+12>>2]=p;c[(c[80539]|0)+20>>2]=1;break}else{n=c[k+16>>2]|0;k=n|0;m=c[k>>2]|0;c[k>>2]=m+1;c[n+4+(m<<4)>>2]=0;c[n+4+(m<<4)+4>>2]=0;c[n+4+(m<<4)+8>>2]=322216;c[n+4+(m<<4)+12>>2]=p;break}}}while(0);p=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;o=d[322869]|0;if((c[80908]|0)==0){q=o}else{q=d[322940+o|0]|0}do{if((p|0)<1){c[80555]=q}else{o=c[80539]|0;if((c[c[80536]>>2]|0)>(p|0)){m=c[o>>2]|0;n=m|0;k=c[n>>2]|0;c[n>>2]=k+1;c[m+4+(k<<4)>>2]=p;c[m+4+(k<<4)+4>>2]=0;c[m+4+(k<<4)+8>>2]=322220;c[m+4+(k<<4)+12>>2]=q;c[(c[80539]|0)+20>>2]=1;break}else{k=c[o+16>>2]|0;o=k|0;m=c[o>>2]|0;c[o>>2]=m+1;c[k+4+(m<<4)>>2]=0;c[k+4+(m<<4)+4>>2]=0;c[k+4+(m<<4)+8>>2]=322220;c[k+4+(m<<4)+12>>2]=q;break}}}while(0);c[80900]=0;c[80850]=0}}q=b-15|0;p=b-16|0;m=(b<<3)-136+(c[80892]|0)|0;do{if((m|0)<1){c[80570]=f}else{k=c[80539]|0;if((c[c[80536]>>2]|0)>(m|0)){o=c[k>>2]|0;n=o|0;j=c[n>>2]|0;c[n>>2]=j+1;c[o+4+(j<<4)>>2]=m;c[o+4+(j<<4)+4>>2]=0;c[o+4+(j<<4)+8>>2]=322280;c[o+4+(j<<4)+12>>2]=f;c[(c[80539]|0)+20>>2]=1;break}else{j=c[k+16>>2]|0;k=j|0;o=c[k>>2]|0;c[k>>2]=o+1;c[j+4+(o<<4)>>2]=0;c[j+4+(o<<4)+4>>2]=0;c[j+4+(o<<4)+8>>2]=322280;c[j+4+(o<<4)+12>>2]=f;break}}}while(0);m=c[80841]|0;do{if((p|0)<1){c[80571]=m;c[80570]=f}else{o=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){j=c[o+4>>2]|0;k=j|0;n=c[k>>2]|0;c[k>>2]=n+1;c[j+4+(n<<4)>>2]=p;c[j+4+(n<<4)+4>>2]=0;c[j+4+(n<<4)+8>>2]=322284;c[j+4+(n<<4)+12>>2]=m;c[(c[80539]|0)+20>>2]=1}else{n=c[o+16>>2]|0;o=n|0;j=c[o>>2]|0;c[o>>2]=j+1;c[n+4+(j<<4)>>2]=0;c[n+4+(j<<4)+4>>2]=0;c[n+4+(j<<4)+8>>2]=322284;c[n+4+(j<<4)+12>>2]=m}j=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){n=c[j+4>>2]|0;o=n|0;k=c[o>>2]|0;c[o>>2]=k+1;c[n+4+(k<<4)>>2]=p;c[n+4+(k<<4)+4>>2]=0;c[n+4+(k<<4)+8>>2]=322280;c[n+4+(k<<4)+12>>2]=f;c[(c[80539]|0)+20>>2]=1;break}else{k=c[j+16>>2]|0;j=k|0;n=c[j>>2]|0;c[j>>2]=n+1;c[k+4+(n<<4)>>2]=0;c[k+4+(n<<4)+4>>2]=0;c[k+4+(n<<4)+8>>2]=322280;c[k+4+(n<<4)+12>>2]=f;break}}}while(0);do{if((c[80872]|0)!=0){p=c[80858]|0;if((a[322853]&64)==0){m=d[(c[80804]|0)+(p+16383)|0]|0;if((q|0)<1){c[80859]=m;break}n=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(q|0)){k=c[n+4>>2]|0;j=k|0;o=c[j>>2]|0;c[j>>2]=o+1;c[k+4+(o<<4)>>2]=q;c[k+4+(o<<4)+4>>2]=0;c[k+4+(o<<4)+8>>2]=323436;c[k+4+(o<<4)+12>>2]=m;c[(c[80539]|0)+20>>2]=1;break}else{o=c[n+16>>2]|0;n=o|0;k=c[n>>2]|0;c[n>>2]=k+1;c[o+4+(k<<4)>>2]=0;c[o+4+(k<<4)+4>>2]=0;c[o+4+(k<<4)+8>>2]=323436;c[o+4+(k<<4)+12>>2]=m;break}}else{m=d[(c[80804]|0)+(p+14847)|0]|0;if((q|0)<1){c[80859]=m;break}p=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(q|0)){k=c[p+4>>2]|0;o=k|0;n=c[o>>2]|0;c[o>>2]=n+1;c[k+4+(n<<4)>>2]=q;c[k+4+(n<<4)+4>>2]=0;c[k+4+(n<<4)+8>>2]=323436;c[k+4+(n<<4)+12>>2]=m;c[(c[80539]|0)+20>>2]=1;break}else{n=c[p+16>>2]|0;p=n|0;k=c[p>>2]|0;c[p>>2]=k+1;c[n+4+(k<<4)>>2]=0;c[n+4+(k<<4)+4>>2]=0;c[n+4+(k<<4)+8>>2]=323436;c[n+4+(k<<4)+12>>2]=m;break}}}}while(0);q=b-14|0;do{if((q|0)<1){c[80571]=-1}else{b=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(q|0)){m=c[b+4>>2]|0;k=m|0;n=c[k>>2]|0;c[k>>2]=n+1;c[m+4+(n<<4)>>2]=q;c[m+4+(n<<4)+4>>2]=0;c[m+4+(n<<4)+8>>2]=322284;c[m+4+(n<<4)+12>>2]=-1;c[(c[80539]|0)+20>>2]=1;break}else{n=c[b+16>>2]|0;b=n|0;m=c[b>>2]|0;c[b>>2]=m+1;c[n+4+(m<<4)>>2]=0;c[n+4+(m<<4)+4>>2]=0;c[n+4+(m<<4)+8>>2]=322284;c[n+4+(m<<4)+12>>2]=-1;break}}}while(0);c[80841]=f;return}function pt(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((c[80908]|0)!=0){pY()}f=d[322860]|0;g=(f<<6&15360)+(c[80858]|0)&e[161611]|e[161613];h=e[161610]&(f<<10&14336)+(c[80857]|0)|e[161612];f=h&57344;i=c[80803]|0;j=i+f|0;do{if((a[803539]|0)==0){k=830}else{l=mF((g&4095|4096)&65535)|0;if((l|0)==0){k=830;break}if((g&12288)>>>0>12287>>>0){c[80814]=l;break}else{c[80814]=(c[80804]|0)+g;break}}}while(0);do{if((k|0)==830){if((e[161615]&g|0)==(e[161617]|0)){c[80814]=(c[197474]|0)+(g&3072);break}else{c[80814]=(c[80804]|0)+g;break}}}while(0);do{if((a[803538]|0)==0){k=843}else{l=mE((g&4095|4096)&65535)|0;if((l|0)==0){k=843;break}if((g&12288)>>>0>12287>>>0){m=l}else{m=(c[80803]|0)+g|0}c[80813]=m;if((h&12288)>>>0>12287>>>0){n=mE((h&4095|4096)&65535)|0}else{n=(c[80803]|0)+h|0}if((h&8192|4096|0)==12288){o=n;p=mE(4096)|0;break}else{o=n;p=i+(f|4096)|0;break}}}while(0);do{if((k|0)==843){n=e[161614]|0;m=e[161616]|0;if((n&g|0)==(m|0)){q=(c[197474]|0)+(g&3072)|0}else{q=(c[80803]|0)+g|0}c[80813]=q;if((n&h|0)==(m|0)){r=(c[197474]|0)+(h&2048)|0}else{r=(c[80803]|0)+h|0}l=f|4096;if((n&l|0)==(m|0)){o=r;p=c[197474]|0;break}else{o=r;p=i+l|0;break}}}while(0);do{if((c[80908]|0)==0){s=o;t=j;u=p}else{if(((c[80841]|0)-17|0)>>>0<2>>>0){c[80814]=(c[80804]|0)+(d[322895]<<8|d[322905]<<16|d[322894]);s=o;t=j;u=p;break}else{c[80814]=(c[80814]|0)+(d[322905]<<16);r=d[322897]<<16;s=o+r|0;t=i+(r|f)|0;u=p+r|0;break}}}while(0);p=b-15|0;b=c[80872]|0;do{if((b|0)==0){k=869}else{f=c[80858]|0;if((c[7358]|0)==(f|0)){k=869;break}if((b|0)==2){i=d[(c[80804]|0)+(f+14847)|0]|0;if((p|0)<1){c[80859]=i;k=870;break}o=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){j=c[o+4>>2]|0;r=j|0;h=c[r>>2]|0;c[r>>2]=h+1;c[j+4+(h<<4)>>2]=p;c[j+4+(h<<4)+4>>2]=0;c[j+4+(h<<4)+8>>2]=323436;c[j+4+(h<<4)+12>>2]=i;c[(c[80539]|0)+20>>2]=1;k=869;break}else{h=c[o+16>>2]|0;o=h|0;j=c[o>>2]|0;c[o>>2]=j+1;c[h+4+(j<<4)>>2]=0;c[h+4+(j<<4)+4>>2]=0;c[h+4+(j<<4)+8>>2]=323436;c[h+4+(j<<4)+12>>2]=i;k=869;break}}else{i=d[(c[80804]|0)+(f+16383)|0]|0;if((p|0)<1){c[80859]=i;k=870;break}f=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){j=c[f+4>>2]|0;h=j|0;o=c[h>>2]|0;c[h>>2]=o+1;c[j+4+(o<<4)>>2]=p;c[j+4+(o<<4)+4>>2]=0;c[j+4+(o<<4)+8>>2]=323436;c[j+4+(o<<4)+12>>2]=i;c[(c[80539]|0)+20>>2]=1;k=869;break}else{o=c[f+16>>2]|0;f=o|0;j=c[f>>2]|0;c[f>>2]=j+1;c[o+4+(j<<4)>>2]=0;c[o+4+(j<<4)+4>>2]=0;c[o+4+(j<<4)+8>>2]=323436;c[o+4+(j<<4)+12>>2]=i;k=869;break}}}}while(0);if((k|0)==869){if((p|0)<1){k=870}else{v=0}}do{if((k|0)==870){if((c[198580]|0)>>>0>=(c[80881]|0)>>>0){v=1;break}b=c[80814]|0;c[80809]=b;c[80514]=b;c[80811]=t;c[80518]=t;c[80812]=u;c[80520]=u;c[80810]=s;c[80516]=s;c[7360]=c[80857];c[7358]=c[80858];return}}while(0);k=c[80814]|0;b=(k|0)!=(c[80514]|0);if((p|0)>=40){if(b){i=c[(c[80539]|0)+16>>2]|0;j=i|0;o=c[j>>2]|0;c[j>>2]=o+1;c[i+4+(o<<4)>>2]=0;c[i+4+(o<<4)+4>>2]=1;c[i+4+(o<<4)+8>>2]=323236;c[i+4+(o<<4)+12>>2]=k;c[80514]=c[80814]}if((t|0)!=(c[80518]|0)){o=c[(c[80539]|0)+16>>2]|0;i=o|0;j=c[i>>2]|0;c[i>>2]=j+1;c[o+4+(j<<4)>>2]=0;c[o+4+(j<<4)+4>>2]=1;c[o+4+(j<<4)+8>>2]=323244;c[o+4+(j<<4)+12>>2]=t;c[80518]=t}if((u|0)!=(c[80520]|0)){j=c[(c[80539]|0)+16>>2]|0;o=j|0;i=c[o>>2]|0;c[o>>2]=i+1;c[j+4+(i<<4)>>2]=0;c[j+4+(i<<4)+4>>2]=1;c[j+4+(i<<4)+8>>2]=323248;c[j+4+(i<<4)+12>>2]=u;c[80520]=u}if((s|0)!=(c[80516]|0)){i=c[(c[80539]|0)+16>>2]|0;j=i|0;o=c[j>>2]|0;c[j>>2]=o+1;c[i+4+(o<<4)>>2]=0;c[i+4+(o<<4)+4>>2]=1;c[i+4+(o<<4)+8>>2]=323240;c[i+4+(o<<4)+12>>2]=s;c[80516]=s}o=c[80857]|0;if((o|0)!=(c[7360]|0)){c[7360]=o}o=c[80858]|0;if((o|0)==(c[7358]|0)){return}c[7358]=o;return}if(b){do{if(v){c[80809]=k}else{b=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){o=c[b+4>>2]|0;i=o|0;j=c[i>>2]|0;c[i>>2]=j+1;c[o+4+(j<<4)>>2]=p;c[o+4+(j<<4)+4>>2]=1;c[o+4+(j<<4)+8>>2]=323236;c[o+4+(j<<4)+12>>2]=k;c[(c[80539]|0)+20>>2]=1;break}else{j=c[b+16>>2]|0;b=j|0;o=c[b>>2]|0;c[b>>2]=o+1;c[j+4+(o<<4)>>2]=0;c[j+4+(o<<4)+4>>2]=1;c[j+4+(o<<4)+8>>2]=323236;c[j+4+(o<<4)+12>>2]=k;break}}}while(0);c[80514]=c[80814]}if((t|0)!=(c[80518]|0)){do{if(v){c[80811]=t}else{k=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){o=c[k+4>>2]|0;j=o|0;b=c[j>>2]|0;c[j>>2]=b+1;c[o+4+(b<<4)>>2]=p;c[o+4+(b<<4)+4>>2]=1;c[o+4+(b<<4)+8>>2]=323244;c[o+4+(b<<4)+12>>2]=t;c[(c[80539]|0)+20>>2]=1;break}else{b=c[k+16>>2]|0;k=b|0;o=c[k>>2]|0;c[k>>2]=o+1;c[b+4+(o<<4)>>2]=0;c[b+4+(o<<4)+4>>2]=1;c[b+4+(o<<4)+8>>2]=323244;c[b+4+(o<<4)+12>>2]=t;break}}}while(0);c[80518]=t}if((u|0)!=(c[80520]|0)){do{if(v){c[80812]=u}else{t=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){o=c[t+4>>2]|0;b=o|0;k=c[b>>2]|0;c[b>>2]=k+1;c[o+4+(k<<4)>>2]=p;c[o+4+(k<<4)+4>>2]=1;c[o+4+(k<<4)+8>>2]=323248;c[o+4+(k<<4)+12>>2]=u;c[(c[80539]|0)+20>>2]=1;break}else{k=c[t+16>>2]|0;t=k|0;o=c[t>>2]|0;c[t>>2]=o+1;c[k+4+(o<<4)>>2]=0;c[k+4+(o<<4)+4>>2]=1;c[k+4+(o<<4)+8>>2]=323248;c[k+4+(o<<4)+12>>2]=u;break}}}while(0);c[80520]=u}if((s|0)!=(c[80516]|0)){do{if(v){c[80810]=s}else{u=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(p|0)){o=c[u+4>>2]|0;k=o|0;t=c[k>>2]|0;c[k>>2]=t+1;c[o+4+(t<<4)>>2]=p;c[o+4+(t<<4)+4>>2]=1;c[o+4+(t<<4)+8>>2]=323240;c[o+4+(t<<4)+12>>2]=s;c[(c[80539]|0)+20>>2]=1;break}else{t=c[u+16>>2]|0;u=t|0;o=c[u>>2]|0;c[u>>2]=o+1;c[t+4+(o<<4)>>2]=0;c[t+4+(o<<4)+4>>2]=1;c[t+4+(o<<4)+8>>2]=323240;c[t+4+(o<<4)+12>>2]=s;break}}}while(0);c[80516]=s}s=c[80857]|0;if((s|0)!=(c[7360]|0)){c[7360]=s}s=c[80858]|0;if((s|0)==(c[7358]|0)){return}c[7358]=s;return}function pu(a,b){a=a|0;b=b|0;c[80882]=(c[80882]|0)-a;c[80883]=(c[80883]|0)-a;c[80880]=(c[80880]|0)-a;c[80881]=(c[80881]|0)-a;c[80884]=(c[80884]|0)-a;return}function pv(){var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;no(322140);c[80883]=0;b=c[80895]|0;c[80881]=b;d=c[80875]|0;e=c[d+4>>2]|0;f=d+12|0;g=c[f>>2]|0;do{if((g|0)<0){h=e+2056|0;i=c[h>>2]|0;if(i>>>0>255>>>0){fW();break}c[e+8+(i<<3)>>2]=d;c[e+8+(i<<3)+4>>2]=b;c[h>>2]=(c[h>>2]|0)+1;h=e+2060|0;if((c[h>>2]|0)>>>0>b>>>0){c[h>>2]=b;c[e+2064>>2]=i}c[f>>2]=i}else{c[e+8+(g<<3)+4>>2]=b;i=e+2060|0;h=e+2064|0;j=c[h>>2]|0;if((c[i>>2]|0)>>>0>b>>>0){k=j}else{if((g|0)==(j|0)){k=g}else{break}}j=c[e+2056>>2]|0;if((j|0)==0){l=k;m=-1}else{n=k;o=0;p=-1;while(1){q=c[e+8+(o<<3)+4>>2]|0;r=q>>>0>p>>>0;s=r?n:o;t=r?p:q;q=o+1|0;if(q>>>0<j>>>0){n=s;o=q;p=t}else{l=s;m=t;break}}}c[i>>2]=m;c[h>>2]=l}}while(0);c[80880]=11;l=c[80874]|0;m=c[l+4>>2]|0;e=l+12|0;k=c[e>>2]|0;do{if((k|0)<0){g=m+2056|0;b=c[g>>2]|0;if(b>>>0>255>>>0){fW();break}c[m+8+(b<<3)>>2]=l;c[m+8+(b<<3)+4>>2]=11;c[g>>2]=(c[g>>2]|0)+1;g=m+2060|0;if((c[g>>2]|0)>>>0>11>>>0){c[g>>2]=11;c[m+2064>>2]=b}c[e>>2]=b}else{c[m+8+(k<<3)+4>>2]=11;b=m+2060|0;g=m+2064|0;f=c[g>>2]|0;if((c[b>>2]|0)>>>0>11>>>0){u=f}else{if((k|0)==(f|0)){u=k}else{break}}f=c[m+2056>>2]|0;if((f|0)==0){v=u;w=-1}else{d=u;p=0;o=-1;while(1){n=c[m+8+(p<<3)+4>>2]|0;j=n>>>0>o>>>0;t=j?d:p;s=j?o:n;n=p+1|0;if(n>>>0<f>>>0){d=t;p=n;o=s}else{v=t;w=s;break}}}c[b>>2]=w;c[g>>2]=v}}while(0);c[80877]=0;c[80878]=0;c[80879]=0;c[80884]=-1;c[80802]=0;c[80882]=0;a[322853]=0;a[322854]=0;v=c[80876]|0;w=c[v+4>>2]|0;m=v+12|0;u=c[m>>2]|0;do{if((u|0)<0){k=w+2056|0;e=c[k>>2]|0;if(e>>>0>255>>>0){fW();break}c[w+8+(e<<3)>>2]=v;c[w+8+(e<<3)+4>>2]=1;c[k>>2]=(c[k>>2]|0)+1;k=w+2060|0;if((c[k>>2]|0)>>>0>1>>>0){c[k>>2]=1;c[w+2064>>2]=e}c[m>>2]=e}else{c[w+8+(u<<3)+4>>2]=1;e=w+2060|0;k=w+2064|0;l=c[k>>2]|0;if((c[e>>2]|0)>>>0>1>>>0){x=l}else{if((u|0)==(l|0)){x=u}else{break}}l=c[w+2056>>2]|0;if((l|0)==0){y=x;z=-1}else{o=x;p=0;d=-1;while(1){f=c[w+8+(p<<3)+4>>2]|0;h=f>>>0>d>>>0;i=h?o:p;s=h?d:f;f=p+1|0;if(f>>>0<l>>>0){o=i;p=f;d=s}else{y=i;z=s;break}}}c[e>>2]=z;c[k>>2]=y}}while(0);c[80843]=0;a[322862]=0;A2(323408,0,20);c[80564]=c[80888];c[80565]=c[80889];c[80901]=-1;A2(322916,0,24);y=0;do{a[322940+y|0]=y&255;y=y+1|0;}while((y|0)<256);a[322940]=0;a[322941]=15;a[322942]=54;a[322943]=-66;a[322944]=88;a[322945]=-37;a[322946]=-122;a[322947]=-1;a[322948]=41;a[322949]=38;a[322950]=59;a[322951]=5;a[322952]=7;a[322953]=-33;a[322954]=-102;a[322955]=10;a[322868]=a[322868]&15;a[322869]=a[322869]&15;a[322870]=a[322870]&15;a[322871]=a[322871]&15;a[322872]=a[322872]&15;a[322896]=0;a[322890]=118;a[322897]=0;A2(322891,0,5);a[322904]=64;c[80914]=0;c[80916]=0;c[80917]=0;c[80920]=0;c[80918]=0;A2(322905,0,9);c[80921]=840040;c[80799]=0;c[80800]=0;c[80915]=(c[80908]|0)==0;return}function pw(){var a=0;if((c[80534]|0)==0){return}if((c[80908]|0)==0){a=0;do{p$(a,0);a=a+1&65535;}while((a&65535)>>>0<64>>>0)}else{c[80914]=1;c[80915]=0;a=0;do{p$(a,0);a=a+1&65535;}while((a&65535)>>>0<63>>>0);p$(54,118);p$(64,0);p$(65,0);p$(66,0);p$(67,0);p$(68,0);p$(69,0);p$(70,0);p$(71,0);p$(72,0);p$(73,0);p$(74,0);p$(75,0);p$(76,0);p$(77,0);p$(78,0);p$(79,0);p$(63,0)}a=c[80538]|0;n_(a,qf()|0);return}function px(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a<<14;a=(c[198568]|0)+1|0;if((a|0)==0){while(1){d=c[198580]|0;if(d>>>0<(c[80880]|0)>>>0){e=0;f=d}else{pF(0,0);e=1;f=c[198580]|0}d=c[80881]|0;if(f>>>0<d>>>0){if((e|0)==0){g=f;h=d;break}else{continue}}else{po(0,0);continue}}}else{f=(c[198580]|0)-a|0;c[198580]=f;e=f;while(1){if(e>>>0>(c[80880]|0)>>>0){pF(0,0);i=1;j=c[198580]|0}else{i=0;j=e}k=c[80881]|0;if(j>>>0<k>>>0){if((i|0)==0){break}else{e=j;continue}}else{po(0,0);e=c[198580]|0;continue}}e=j+a|0;c[198580]=e;g=e;h=k}if(g>>>0<h>>>0){l=g;c[80857]=b;c[80858]=b;m=c[80894]|0;n=(l>>>0)%(m>>>0)|0;pt(n);return}po(0,0);l=c[198580]|0;c[80857]=b;c[80858]=b;m=c[80894]|0;n=(l>>>0)%(m>>>0)|0;pt(n);return}function py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if(!((b|0)!=0&(c[80853]|0)==0)){c[80852]=b;return}c[80853]=1;d=c[80894]|0;e=(((a>>>0)%(d>>>0)|0)<<3)-104|0;c[80854]=e;if((e|0)<0){f=(c[80897]|0)+e|0;c[80854]=f;g=f}else{g=e}c[80854]=((g|0)/2|0)+2+(c[80856]|0);c[80856]=0;c[80855]=(((a>>>0)/(d>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0;pO(a);c[80852]=b;return}function pz(){hj(c[80904]|0);hj(c[80906]|0);qj();nZ(322140);nw(322140);return}function pA(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;e=d[322853]|0;f=a[322858]|0;g=c[80858]|0;h=c[80802]|0;qO(80464,(j=i,i=i+16|0,c[j>>2]=c[80551],c[j+8>>2]=h,j)|0)|0;i=j;qO(79560,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;h=(e&64|0)!=0;qO(h?78808:78256,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;k=(f&16)!=0;qO(k?77792:89984,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;f=(e&32|0)!=0;qO(f?89368:88656,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;e=d[322869]|0;qO(88248,(j=i,i=i+16|0,c[j>>2]=d[322868]|0,c[j+8>>2]=e,j)|0)|0;i=j;do{if(h){e=d[322870]|0;l=d[322871]|0;m=d[322872]|0;qO(87800,(j=i,i=i+24|0,c[j>>2]=e,c[j+8>>2]=l,c[j+16>>2]=m,j)|0)|0;i=j}else{if(f|k^1){break}m=d[322870]|0;l=d[322871]|0;qO(87384,(j=i,i=i+16|0,c[j>>2]=m,c[j+8>>2]=l,j)|0)|0;i=j}}while(0);k=a[322853]&7;qO(87104,(j=i,i=i+16|0,c[j>>2]=a[322858]&7,c[j+8>>2]=k,j)|0)|0;i=j;k=(d[322853]|0)>>>3&1|24;qO(86760,(j=i,i=i+16|0,c[j>>2]=((d[322858]|0)>>>3&1)+39,c[j+8>>2]=k,j)|0)|0;i=j;qO(86488,(j=i,i=i+16|0,c[j>>2]=g,c[j+8>>2]=g+16383,j)|0)|0;i=j;qO(86176,(j=i,i=i+8|0,c[j>>2]=((d[322860]|0)>>>4<<10)+g,j)|0)|0;i=j;k=d[322860]<<10;if(f){f=(k&8192)+g|0;qO(85904,(j=i,i=i+8|0,c[j>>2]=f,j)|0)|0;i=j}else{f=(k&14336)+g|0;k=c[13586]|0;do{if((k-1|0)>>>0<2>>>0|(k|0)==8|(k|0)==9){h=f>>12;if(!((h|0)==1|(h|0)==9)){n=f;break}n=f&3840|53248}else{n=f}}while(0);qO(85616,(j=i,i=i+8|0,c[j>>2]=n,j)|0)|0;i=j}qO(85216,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(84864,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(84648,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;n=d[322857]|0;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&1|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&2|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&4|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&8|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&16|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&32|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&64|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(n&128|0)!=0?84384:84160,j)|0)|0;i=j;qO(83920,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1016|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1017|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1018|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1019|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1020|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1021|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1022|0]|0,j)|0)|0;i=j;qO(83784,(j=i,i=i+8|0,c[j>>2]=d[(c[80809]|0)+1023|0]|0,j)|0)|0;i=j;qO(83600,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1016|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1017|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1018|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1019|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1020|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1021|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1022|0]<<6)+g,j)|0)|0;i=j;qO(83440,(j=i,i=i+8|0,c[j>>2]=(d[(c[80809]|0)+1023|0]<<6)+g,j)|0)|0;i=j;qO(83040,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;g=d[322852]|0;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322836]|g<<8&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322838]|g<<7&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322840]|g<<6&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322842]|g<<5&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322844]|g<<4&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322846]|g<<3&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322848]|g<<2&256,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322850]|g<<1&256,j)|0)|0;i=j;qO(82792,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322837]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322839]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322841]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322843]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322845]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322847]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322849]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322851]|0,j)|0)|0;i=j;qO(82648,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;g=d[322865]|0;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&1|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&2|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&4|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&8|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&16|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&32|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&64|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&128|0)!=0?84384:84160,j)|0)|0;i=j;qO(82464,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;g=d[322859]|0;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&1|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&2|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&4|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&8|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&16|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&32|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&64|0)!=0?84384:84160,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&128|0)!=0?84384:84160,j)|0)|0;i=j;qO(82288,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;g=d[322863]|0;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&1|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&2|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&4|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&8|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&16|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&32|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&64|0)!=0?82144:82080,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&128|0)!=0?82144:82080,j)|0)|0;i=j;qO(81912,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;g=d[322864]|0;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&1|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&2|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&4|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&8|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&16|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&32|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&64|0)!=0?81800:81584,j)|0)|0;i=j;qO(84584,(j=i,i=i+8|0,c[j>>2]=(g&128|0)!=0?81800:81584,j)|0)|0;i=j;qO(81456,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322875]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322876]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322877]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322878]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322879]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322880]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322881]|0,j)|0)|0;i=j;qO(82928,(j=i,i=i+8|0,c[j>>2]=d[322882]|0,j)|0)|0;i=j;if((a[322864]|0)==0){o=qO(81240,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;i=b;return 0}g=d[322874]|0;qO(81352,(j=i,i=i+16|0,c[j>>2]=d[322873]|0,c[j+8>>2]=g,j)|0)|0;i=j;o=qO(81240,(j=i,i=i+1|0,i=i+7&-8,c[j>>2]=0,j)|0)|0;i=j;i=b;return 0}function pB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((e|0)==0){f=0}else{f=(c[80545]|0)==(d&7|0)}if((c[80836]|0)==0){g=0}else{g=((a&255^d)&7|0)==0}if(!(g|f^1)){do{if((b|0)<11){c[80848]=0;if((b|0)>0){break}return}}while(0);pC(b);if((b|0)<14|(c[80849]|0)!=0){return}c[80569]=0;c[80849]=1;return}if(f|g^1){return}g=b-11|0;do{if(g>>>0<43>>>0){c[80848]=1;if((b|0)<14){c[80569]=0}f=(c[80908]|0)==0;d=(f?-14:-15)+b|0;a=40-d|0;e=c[80917]|0;do{if((c[80916]|c[80909]|e|0)==0){gb(c[198580]|0,a,0)}else{if(f|(e|0)!=0){break}c[200908]=(c[200908]|0)+a}}while(0);e=c[80842]|0;do{if((a|0)<41){if((e|0)==0){c[80846]=c[80845];h=(d|0)>39?39:d;i=40;j=a;k=3;break}else{l=3;m=a;n=(a|0)<0?0:a;o=1032;break}}else{l=g;m=40;n=40;o=1032}}while(0);do{if((o|0)==1032){c[80846]=c[80845];if(!((e|0)!=0&(d|0)>0)){h=0;i=n;j=m;k=l;break}c[80815]=d;h=0;i=n;j=m;k=l}}while(0);pC(b+1|0);if((j|0)>0){pE(h,j,k,b)}c[80847]=i;c[80844]=2}else{if((b|0)>=58){c[80843]=1;break}c[80848]=1;if((c[80842]|0)!=0){c[80847]=0}pC(b+1|0)}}while(0);c[80849]=1;return}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a-15|0;do{if((b|0)<1){c[80568]=0}else{d=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(b|0)){e=c[d+4>>2]|0;f=e|0;g=c[f>>2]|0;c[f>>2]=g+1;c[e+4+(g<<4)>>2]=b;c[e+4+(g<<4)+4>>2]=0;c[e+4+(g<<4)+8>>2]=322272;c[e+4+(g<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1;break}else{g=c[d+16>>2]|0;d=g|0;e=c[d>>2]|0;c[d>>2]=e+1;c[g+4+(e<<4)>>2]=0;c[g+4+(e<<4)+4>>2]=0;c[g+4+(e<<4)+8>>2]=322272;c[g+4+(e<<4)+12>>2]=0;break}}}while(0);b=(a<<3)-136+(c[80892]|0)|0;if((b|0)<1){c[80568]=0;c[80842]=0;c[80872]=0;return}a=c[80539]|0;if((c[c[80536]>>2]|0)>(b|0)){e=c[a>>2]|0;g=e|0;d=c[g>>2]|0;c[g>>2]=d+1;c[e+4+(d<<4)>>2]=b;c[e+4+(d<<4)+4>>2]=0;c[e+4+(d<<4)+8>>2]=322272;c[e+4+(d<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1;c[80842]=0;c[80872]=0;return}else{d=c[a+16>>2]|0;a=d|0;e=c[a>>2]|0;c[a>>2]=e+1;c[d+4+(e<<4)>>2]=0;c[d+4+(e<<4)+4>>2]=0;c[d+4+(e<<4)+8>>2]=322272;c[d+4+(e<<4)+12>>2]=0;c[80842]=0;c[80872]=0;return}}function pD(a){a=a|0;rk(a,(c[80525]|0)==0?46088:46104);return rl(a)|0}function pE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=(c[80908]|0)==0;h=g?f:0;f=g?c[197214]|0:c[80921]|0;do{if((h|0)>0){g=323264+b|0;if((h|0)<(e|0)){A2(g|0,-1|0,h|0);A2(323304+b|0,a[(c[80804]|0)+(c[115266]|0)|0]&15|0,h|0);break}else{A2(g|0,-1|0,e|0);A2(323304+b|0,a[(c[80804]|0)+(c[115266]|0)|0]&15|0,e|0);c[80851]=255;break}}}while(0);if((h|0)<(e|0)){g=h+b|0;i=e-h|0;h=(c[80846]|0)+g&1023;j=1024-h|0;k=323264+g|0;l=(c[80814]|0)+h|0;do{if((j|0)<(i|0)){A$(k|0,l|0,j)|0;m=j+g|0;n=323264+m|0;o=c[80814]|0;p=i-j|0;A$(n|0,o|0,p)|0;if((c[80917]|0)!=0){break}o=323304+g|0;n=f+h|0;A$(o|0,n|0,j)|0;if((c[80917]|0)!=0){break}n=323304+m|0;A$(n|0,f|0,p)|0}else{A$(k|0,l|0,i)|0;if((c[80917]|0)!=0){break}p=323304+g|0;n=f+h|0;A$(p|0,n|0,i)|0}}while(0);c[80851]=d[323303]|0;q=g;r=i}else{q=b;r=e}if((q+r|0)<=39){return}r=c[80900]|0;if((r|0)==2){q=c[80851]&15;e=c[(c[80539]|0)+16>>2]|0;b=e|0;i=c[b>>2]|0;c[b>>2]=i+1;c[e+4+(i<<4)>>2]=0;c[e+4+(i<<4)+4>>2]=0;c[e+4+(i<<4)+8>>2]=322220;c[e+4+(i<<4)+12>>2]=q;return}else if((r|0)==4){r=d[(c[80851]>>6)+322869|0]|0;q=c[(c[80539]|0)+16>>2]|0;i=q|0;e=c[i>>2]|0;c[i>>2]=e+1;c[q+4+(e<<4)>>2]=0;c[q+4+(e<<4)+4>>2]=0;c[q+4+(e<<4)+8>>2]=322220;c[q+4+(e<<4)+12>>2]=r;return}else{return}}function pF(b,f){b=b|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ah=0,ai=0,aj=0,ak=0;f=(b|0)==0;do{if(f){g=0;h=0}else{i=c[200694]&255;if((i|0)==32){j=c[198580]|0;g=j-2|0;h=j-3|0;break}else if((i|0)==0){j=c[198580]|0;g=j-3|0;h=j-5|0;break}else{j=c[53288+(i<<2)>>2]|0;if((j|0)==0){g=0;h=0;break}i=c[198580]|0;g=i-1|0;h=i-j|0;break}}}while(0);j=b-3|0;b=g;g=h;L1409:while(1){h=b+1|0;i=c[80880]|0;while(1){k=i>>>0<g>>>0|i>>>0>b>>>0?0:h-i|0;l=c[80877]|0;if((l|0)==0){m=1094;break}else if((l|0)!=1){m=1168;break}l=c[80538]|0;n=l+44|0;o=c[n>>2]|0;p=l+48|0;c[n>>2]=c[p>>2];c[p>>2]=o;o=c[80538]|0;p=o+20|0;n=a[p]|0;l=a[o+21|0]|0;if((l|n)<<24>>24==0){q=o;r=l}else{s=o+22|0;a[s]=l;l=o+4|0;o=1;t=0;u=n;while(1){n=c[l>>2]|0;do{if((o&(u&255)|0)==0){m=1131}else{if((c[n+(t*56|0)+4>>2]|0)!=(c[80551]&255|0)){m=1131;break}if((c[n+(t*56|0)+52>>2]|0)!=0){m=1131;break}v=c[80538]|0;w=c[v+4>>2]|0;x=v+22|0;a[x]=(d[x]|1<<t)&255;c[w+(t*56|0)+52>>2]=1;c[w+(t*56|0)+40>>2]=0;x=(c[w+(t*56|0)+12>>2]|0)==0;c[w+(t*56|0)+48>>2]=x&1;c[w+(t*56|0)+44>>2]=x?3:0}}while(0);do{if((m|0)==1131){m=0;x=n+(t*56|0)+52|0;if((c[x>>2]|0)==0){break}w=n+(t*56|0)+40|0;v=n+(t*56|0)+44|0;y=(c[v>>2]|0)+(c[w>>2]|0)&63;c[w>>2]=y;w=n+(t*56|0)+48|0;z=c[w>>2]|0;if((c[n+(t*56|0)+12>>2]|0)==0){A=z}else{B=(z|0)==0|0;c[w>>2]=B;A=B}c[v>>2]=(A|0)!=0?3:0;if((y|0)!=63){break}c[x>>2]=0;a[s]=d[s]&(o^255)&255;if((d[p]&o|0)==0){break}if((c[n+(t*56|0)+4>>2]|0)!=(c[80551]&255|0)){break}x=c[80538]|0;y=c[x+4>>2]|0;v=x+22|0;a[v]=(d[v]|1<<t)&255;c[y+(t*56|0)+52>>2]=1;c[y+(t*56|0)+40>>2]=0;v=(c[y+(t*56|0)+12>>2]|0)==0;c[y+(t*56|0)+48>>2]=v&1;c[y+(t*56|0)+44>>2]=v?3:0}}while(0);n=t+1|0;if((n|0)>=8){break}o=o<<1;t=n;u=a[p]|0}p=c[80538]|0;q=p;r=a[p+21|0]|0}if(r<<24>>24==0){if((a[q+22|0]|0)==0){C=q}else{m=1143}}else{m=1143}if((m|0)==1143){m=0;qh();C=c[80538]|0}p=c[198580]|0;u=c[80894]|0;t=p-((p>>>0)%(u>>>0)|0)|0;p=t+(c[80896]|0)|0;c[80884]=p;o=d[C+22|0]|0;c[80879]=o;s=c[29448+(o<<6)>>2]|0;L1440:do{if((s|0)==-1){o=c[80551]|0;do{if(o>>>0>=((c[80898]|0)-1|0)>>>0){if(o>>>0>((c[80899]|0)+1|0)>>>0){break}c[80877]=0;l=t+(u+11)|0;c[80880]=l;D=l;break L1440}}while(0);c[80877]=1;o=p+u|0;c[80880]=o;D=o}else{c[80877]=2;c[80878]=0;o=s+p|0;c[80880]=o;D=o}}while(0);p=c[80901]|0;if((p|0)!=-1){if((j+p|0)>>>0<D>>>0){a[(c[80804]|0)+(e[161804]|0)|0]=a[323610]|0}c[80901]=-1}p=c[80903]|0;c[80905]=p;if((p|0)!=0){s=c[80906]|0;u=c[80904]|0;t=p<<3;A$(s|0,u|0,t)|0}c[80903]=0;E=c[80880]|0;if(E>>>0>(c[198580]|0)>>>0|f){m=1157;break L1409}else{i=E}}do{if((m|0)==1094){m=0;i=c[80538]|0;if((a[i+20|0]|0)==0){if((a[i+21|0]|0)==0){m=1096;break L1409}}i=pH(k)|0;c[80877]=1;h=c[198580]|0;F=h-((h>>>0)%((c[80894]|0)>>>0)|0)+(c[80896]|0)|0;c[80880]=F;if(F>>>0>h>>>0|f){m=1113;break L1409}G=(i|0)!=0&(k|0)==0?43:0}else if((m|0)==1168){m=0;i=c[80878]|0;h=c[80879]|0;t=c[80538]|0;u=c[80803]|0;s=c[80857]|0;p=c[80804]|0;o=c[80858]|0;l=c[29448+(h<<6)+(i<<4)+8>>2]|0;n=l+1016|0;if((c[80908]|0)==0){H=n}else{H=(d[322913]<<16)+n|0}n=c[29448+(h<<6)+(i<<4)+12>>2]|0;L1467:do{if(l>>>0<=n>>>0){v=t+4|0;y=t+48|0;x=(c[80813]|0)+H|0;B=l;w=h;while(1){if((1<<B&w|0)!=0){z=a[x]|0;I=(z&255)<<6;J=u+(I+s)|0;K=p+(I+o)|0;L=c[(c[v>>2]|0)+(B*56|0)+40>>2]|0;M=(c[y>>2]|0)+(B<<2)|0;do{if((a[803538]|0)==0){N=z;m=1176}else{O=mE(I+57344&65535)|0;P=a[x]|0;if((O|0)==0){N=P;m=1176;break}Q=(P&255)>>>0>191>>>0?O:J;R=P}}while(0);do{if((m|0)==1176){m=0;I=(N&255)<<6;if((I+(c[80857]|0)&e[161614]|0)!=(e[161616]|0)){Q=J;R=N;break}Q=(c[197474]|0)+(I&4032)|0;R=N}}while(0);do{if((a[803539]|0)==0){S=R;m=1181}else{J=mF(((R&255)<<6)-8192&65535)|0;I=a[x]|0;if((J|0)==0){S=I;m=1181;break}T=(I&255)>>>0>191>>>0?J:K}}while(0);do{if((m|0)==1181){m=0;J=(S&255)<<6;if((J+(c[80858]|0)&e[161615]|0)!=(e[161617]|0)){T=K;break}T=(c[197474]|0)+(J&4032)|0}}while(0);if((c[80908]|0)==0){U=T;V=Q}else{K=d[322913]<<16;U=T+K|0;V=Q+K|0}a[M]=a[U+L|0]|0;a[M+1|0]=a[V+(L+1&63)|0]|0;a[M+2|0]=a[U+(L+2&63)|0]|0}K=B+1|0;if(K>>>0>n>>>0){break L1467}x=x+1|0;B=K;w=c[80879]|0}}}while(0);n=c[29448+(h<<6)+(i<<4)+4>>2]|0;do{if((c[80916]|c[80909]|0)==0){gb(c[80880]|0,n-k|0,k)}else{if((c[80908]|0)==0){break}c[200908]=(c[200908]|0)+n}}while(0);o=(k|0)==0?n:0;p=c[29448+(h<<6)+(i+1<<4)>>2]|0;c[80878]=(c[80878]|0)+1;L1498:do{if((p|0)==-1){s=c[80551]|0;do{if(s>>>0>=((c[80898]|0)-1|0)>>>0){if(s>>>0>((c[80899]|0)+1|0)>>>0){break}c[80877]=0;u=(c[80884]|0)+11-(c[80896]|0)+(c[80894]|0)|0;c[80880]=u;W=u;break L1498}}while(0);c[80877]=1;s=(c[80894]|0)+(c[80884]|0)|0;c[80880]=s;W=s}else{s=(c[80884]|0)+p|0;c[80880]=s;W=s}}while(0);p=c[198580]|0;i=c[80881]|0;if(p>>>0<i>>>0){X=W;Y=p}else{po(p-i|0,0);X=c[80880]|0;Y=c[198580]|0}if(X>>>0>Y>>>0|f){m=1201;break L1409}i=c[80882]|0;if(Y>>>0<i>>>0){G=o;break}pS(Y-i|0,0);G=o}}while(0);b=G+b|0;g=G+g|0}if((m|0)==1096){pH(k)|0;k=c[80551]|0;g=c[80898]|0;do{if(k>>>0<g>>>0){G=ag(c[80894]|0,g-k|0)|0;b=(c[80880]|0)+G|0;c[80880]=b;Z=b}else{if(k>>>0<(c[80899]|0)>>>0){b=(c[80880]|0)+(c[80894]|0)|0;c[80880]=b;Z=b;break}else{b=ag(g-k+(c[80885]|0)|0,c[80894]|0)|0;G=(c[80880]|0)+b|0;c[80880]=G;Z=G;break}}}while(0);k=c[80874]|0;g=c[k+4>>2]|0;G=k+12|0;b=c[G>>2]|0;if((b|0)<0){Y=g+2056|0;f=c[Y>>2]|0;if(f>>>0>255>>>0){fW();return}c[g+8+(f<<3)>>2]=k;c[g+8+(f<<3)+4>>2]=Z;c[Y>>2]=(c[Y>>2]|0)+1;Y=g+2060|0;if((c[Y>>2]|0)>>>0>Z>>>0){c[Y>>2]=Z;c[g+2064>>2]=f}c[G>>2]=f;return}else{c[g+8+(b<<3)+4>>2]=Z;f=g+2060|0;G=g+2064|0;Y=c[G>>2]|0;do{if((c[f>>2]|0)>>>0>Z>>>0){_=Y}else{if((b|0)==(Y|0)){_=b;break}return}}while(0);b=c[g+2056>>2]|0;if((b|0)==0){$=_;aa=-1}else{Y=_;_=0;Z=-1;while(1){k=c[g+8+(_<<3)+4>>2]|0;W=k>>>0>Z>>>0;U=W?Y:_;V=W?Z:k;k=_+1|0;if(k>>>0<b>>>0){Y=U;_=k;Z=V}else{$=U;aa=V;break}}}c[f>>2]=aa;c[G>>2]=$;return}}else if((m|0)==1157){$=c[80874]|0;G=c[$+4>>2]|0;aa=$+12|0;f=c[aa>>2]|0;if((f|0)<0){Z=G+2056|0;_=c[Z>>2]|0;if(_>>>0>255>>>0){fW();return}c[G+8+(_<<3)>>2]=$;c[G+8+(_<<3)+4>>2]=E;c[Z>>2]=(c[Z>>2]|0)+1;Z=G+2060|0;if((c[Z>>2]|0)>>>0>E>>>0){c[Z>>2]=E;c[G+2064>>2]=_}c[aa>>2]=_;return}else{c[G+8+(f<<3)+4>>2]=E;_=G+2060|0;aa=G+2064|0;Z=c[aa>>2]|0;do{if((c[_>>2]|0)>>>0>E>>>0){ab=Z}else{if((f|0)==(Z|0)){ab=f;break}return}}while(0);f=c[G+2056>>2]|0;if((f|0)==0){ac=ab;ad=-1}else{Z=ab;ab=0;E=-1;while(1){$=c[G+8+(ab<<3)+4>>2]|0;Y=$>>>0>E>>>0;b=Y?Z:ab;g=Y?E:$;$=ab+1|0;if($>>>0<f>>>0){Z=b;ab=$;E=g}else{ac=b;ad=g;break}}}c[_>>2]=ad;c[aa>>2]=ac;return}}else if((m|0)==1113){ac=c[80874]|0;aa=c[ac+4>>2]|0;ad=ac+12|0;_=c[ad>>2]|0;if((_|0)<0){E=aa+2056|0;ab=c[E>>2]|0;if(ab>>>0>255>>>0){fW();return}c[aa+8+(ab<<3)>>2]=ac;c[aa+8+(ab<<3)+4>>2]=F;c[E>>2]=(c[E>>2]|0)+1;E=aa+2060|0;if((c[E>>2]|0)>>>0>F>>>0){c[E>>2]=F;c[aa+2064>>2]=ab}c[ad>>2]=ab;return}else{c[aa+8+(_<<3)+4>>2]=F;ab=aa+2060|0;ad=aa+2064|0;E=c[ad>>2]|0;do{if((c[ab>>2]|0)>>>0>F>>>0){ae=E}else{if((_|0)==(E|0)){ae=_;break}return}}while(0);_=c[aa+2056>>2]|0;if((_|0)==0){af=ae;ah=-1}else{E=ae;ae=0;F=-1;while(1){ac=c[aa+8+(ae<<3)+4>>2]|0;Z=ac>>>0>F>>>0;f=Z?E:ae;G=Z?F:ac;ac=ae+1|0;if(ac>>>0<_>>>0){E=f;ae=ac;F=G}else{af=f;ah=G;break}}}c[ab>>2]=ah;c[ad>>2]=af;return}}else if((m|0)==1201){m=c[80874]|0;af=c[m+4>>2]|0;ad=m+12|0;ah=c[ad>>2]|0;if((ah|0)<0){ab=af+2056|0;F=c[ab>>2]|0;if(F>>>0>255>>>0){fW();return}c[af+8+(F<<3)>>2]=m;c[af+8+(F<<3)+4>>2]=X;c[ab>>2]=(c[ab>>2]|0)+1;ab=af+2060|0;if((c[ab>>2]|0)>>>0>X>>>0){c[ab>>2]=X;c[af+2064>>2]=F}c[ad>>2]=F;return}else{c[af+8+(ah<<3)+4>>2]=X;F=af+2060|0;ad=af+2064|0;ab=c[ad>>2]|0;do{if((c[F>>2]|0)>>>0>X>>>0){ai=ab}else{if((ah|0)==(ab|0)){ai=ah;break}return}}while(0);ah=c[af+2056>>2]|0;if((ah|0)==0){aj=ai;ak=-1}else{ab=ai;ai=0;X=-1;while(1){m=c[af+8+(ai<<3)+4>>2]|0;ae=m>>>0>X>>>0;E=ae?ab:ai;_=ae?X:m;m=ai+1|0;if(m>>>0<ah>>>0){ab=E;ai=m;X=_}else{aj=E;ak=_;break}}}c[F>>2]=ak;c[ad>>2]=aj;return}}}function pG(){c[80874]=fU(c[198582]|0,87e3,246,0)|0;return}function pH(a){a=a|0;var b=0,d=0;if((c[80844]|0)!=0){b=0;return b|0}c[80844]=1;c[80846]=c[80845];d=c[80551]|0;if((c[80836]|0)==0|(d&7|0)!=(c[80545]|0)|d>>>0<(c[80898]|0)>>>0|d>>>0>(c[80899]|0)>>>0){b=0;return b|0}pE(0,40,0,0);c[80568]=0;c[80569]=0;c[80842]=0;c[80872]=0;c[80849]=1;c[80844]=2;d=c[80917]|0;do{if((c[80916]|c[80909]|d|0)==0){gb(c[80880]|0,43-a|0,a)}else{if((c[80908]|0)==0|(d|0)!=0){break}c[200908]=(c[200908]|0)+43}}while(0);c[80848]=1;b=1;return b|0}function pI(){var a=0,b=0,e=0,f=0,g=0;a=c[80801]|0;if(((d[322862]|0)&a|0)!=0){c[80801]=a|128;b=c[198576]|0;e=c[80913]|0;f=c[198580]|0;if((b|0)==0){return}if((c[b>>2]|0)>>>0<=e>>>0){return}g=(c[b+4>>2]|0)+(e<<2)|0;if((c[g>>2]&2|0)!=0){return}e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;e=b+80128|0;c[e>>2]=c[e>>2]|66;c[g>>2]=c[g>>2]|2;c[b+80124>>2]=-1;c[b+80088>>2]=0;g=b+16|0;if((c[b+80120>>2]|0)>>>0>f>>>0){gI(b,f,g);return}else{c[g>>2]=f;return}}c[80801]=a&127;a=c[198576]|0;f=c[80913]|0;g=c[198580]|0;if((a|0)==0){return}if((c[a>>2]|0)>>>0<=f>>>0){return}b=(c[a+4>>2]|0)+(f<<2)|0;f=c[b>>2]|0;if((f&2|0)==0){return}e=a+12|0;if((c[e>>2]|0)<=0){gE();return}c[b>>2]=f&-3;f=(c[e>>2]|0)-1|0;c[e>>2]=f;if((f|0)!=0){return}f=a+80128|0;c[f>>2]=c[f>>2]&-3;c[a+80124>>2]=g+3;return}function pJ(a){a=a|0;var b=0,e=0,f=0,g=0;b=c[80801]|0;if(((d[322862]|0)&b|0)!=0){c[80801]=b|128;e=c[198576]|0;f=c[80913]|0;if((e|0)==0){return}if((c[e>>2]|0)>>>0<=f>>>0){return}g=(c[e+4>>2]|0)+(f<<2)|0;if((c[g>>2]&2|0)!=0){return}f=e+12|0;c[f>>2]=(c[f>>2]|0)+1;f=e+80128|0;c[f>>2]=c[f>>2]|66;c[g>>2]=c[g>>2]|2;c[e+80124>>2]=-1;c[e+80088>>2]=0;g=e+16|0;if((c[e+80120>>2]|0)>>>0>a>>>0){gI(e,a,g);return}else{c[g>>2]=a;return}}c[80801]=b&127;b=c[198576]|0;g=c[80913]|0;if((b|0)==0){return}if((c[b>>2]|0)>>>0<=g>>>0){return}e=(c[b+4>>2]|0)+(g<<2)|0;g=c[e>>2]|0;if((g&2|0)==0){return}f=b+12|0;if((c[f>>2]|0)<=0){gE();return}c[e>>2]=g&-3;g=(c[f>>2]|0)-1|0;c[f>>2]=g;if((g|0)!=0){return}g=b+80128|0;c[g>>2]=c[g>>2]&-3;c[b+80124>>2]=a+3;return}function pK(){c[80801]=c[80801]|2;pI();return}function pL(){c[80801]=c[80801]&253;pI();return}function pM(){c[80801]=c[80801]|4;pI();return}function pN(){c[80801]=c[80801]&251;pI();return}function pO(a){a=a|0;c[80801]=c[80801]|8;pJ(a);return}function pP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if((c[80800]|0)!=0){c[80882]=-1;fV(c[80876]|0);return}if((c[80802]|0)==(a|0)&(c[80882]|0)!=-1){return}b=c[80885]|0;do{if(b>>>0>a>>>0){d=c[80894]|0;e=((c[198580]|0)>>>0)/(d>>>0)|0;f=(e>>>0)%(b>>>0)|0;g=ag(e+a-f|0,d)|0;c[80882]=g;if((c[80908]|0)==0){h=g}else{e=(c[80799]|0)+g|0;c[80882]=e;h=e}if((a|0)==0){e=h+1|0;c[80882]=e;i=e}else{i=h}if(f>>>0<a>>>0){j=i}else{f=i+(ag(d,b)|0)|0;c[80882]=f;j=f}f=c[80876]|0;d=c[f+4>>2]|0;e=f+12|0;g=c[e>>2]|0;if((g|0)<0){k=d+2056|0;l=c[k>>2]|0;if(l>>>0>255>>>0){fW();break}c[d+8+(l<<3)>>2]=f;c[d+8+(l<<3)+4>>2]=j;c[k>>2]=(c[k>>2]|0)+1;k=d+2060|0;if((c[k>>2]|0)>>>0>j>>>0){c[k>>2]=j;c[d+2064>>2]=l}c[e>>2]=l;break}else{c[d+8+(g<<3)+4>>2]=j;l=d+2060|0;e=d+2064|0;k=c[e>>2]|0;if((c[l>>2]|0)>>>0>j>>>0){m=k}else{if((g|0)==(k|0)){m=g}else{break}}g=c[d+2056>>2]|0;if((g|0)==0){n=m;o=-1}else{k=m;f=0;p=-1;while(1){q=c[d+8+(f<<3)+4>>2]|0;r=q>>>0>p>>>0;s=r?k:f;t=r?p:q;q=f+1|0;if(q>>>0<g>>>0){k=s;f=q;p=t}else{n=s;o=t;break}}}c[l>>2]=o;c[e>>2]=n;break}}else{c[80882]=-1;fV(c[80876]|0)}}while(0);c[80802]=a;return}function pQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=c[80882]|0;f=(d|0)!=0;d=c[80802]|0;if(f){g=d&255|(b&255)<<1&256}else{g=d&256|b&255}if((g|0)==(d|0)){return}b=((((c[198580]|0)>>>0)/((c[80894]|0)>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0;pP(g);if((a[322862]&1)==0){return}g=c[198580]|0;h=(g>>>0)%((c[80894]|0)>>>0)|0;i=(e|0)==(g+((b|0)==0)-h|0)?2:0;L1742:do{if((c[198568]|0)==0){j=i}else{k=(h|0)==0;if(!f){if(k){l=((b|0)!=0?b:c[80885]|0)-1|0;if((l|0)==(d|0)){j=i;break}j=((l^d)&256|0)==0?1:i;break}else{if((b|0)==(d|0)){j=i;break}j=((b^d)&256|0)==0?1:i;break}}do{if(k){if((b&255|0)!=0){break}l=((b|0)!=0?b:c[80885]|0)-1|0;if((l|0)==(d|0)){j=i;break L1742}j=((l^d)&255|0)==0?1:i;break L1742}}while(0);if((b|0)==(d|0)){j=i;break}j=((b^d)&255|0)==0?1:i}}while(0);i=(c[80802]|0)!=(b|0)|(b|0)==(d|0)?j:1;if((i|0)==1){c[80801]=c[80801]|1;pJ(g);return}else if((i|0)==2){c[80801]=c[80801]|1;pJ(e);return}else{return}}function pR(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=ag(c[80894]|0,c[80885]|0)|0;b=(c[80882]|0)+a|0;c[80882]=b;a=c[80876]|0;d=c[a+4>>2]|0;e=a+12|0;f=c[e>>2]|0;if((f|0)<0){g=d+2056|0;h=c[g>>2]|0;if(h>>>0>255>>>0){fW();return}c[d+8+(h<<3)>>2]=a;c[d+8+(h<<3)+4>>2]=b;c[g>>2]=(c[g>>2]|0)+1;g=d+2060|0;if((c[g>>2]|0)>>>0>b>>>0){c[g>>2]=b;c[d+2064>>2]=h}c[e>>2]=h;return}else{c[d+8+(f<<3)+4>>2]=b;h=d+2060|0;e=d+2064|0;g=c[e>>2]|0;do{if((c[h>>2]|0)>>>0>b>>>0){i=g}else{if((f|0)==(g|0)){i=f;break}return}}while(0);f=c[d+2056>>2]|0;if((f|0)==0){j=i;k=-1}else{g=i;i=0;b=-1;while(1){a=c[d+8+(i<<3)+4>>2]|0;l=a>>>0>b>>>0;m=l?g:i;n=l?b:a;a=i+1|0;if(a>>>0<f>>>0){g=m;i=a;b=n}else{j=m;k=n;break}}}c[h>>2]=k;c[e>>2]=j;return}}function pS(a,b){a=a|0;b=b|0;if((c[215616]&16|0)!=0){qm()}if((c[200910]&16|0)!=0){ql()}b=c[80882]|0;c[80801]=c[80801]|1;pJ(b);pR();return}function pT(){c[80913]=gA(c[198576]|0,86992)|0;c[80876]=fU(c[198582]|0,88832,100,0)|0;return}function pU(a,b){a=a|0;b=b|0;pV(a,b);return}function pV(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;if((c[80907]|0)!=0){pm()}f=d&65535;do{g=(c[198580]|0)-(c[198568]|0)-1|0;h=c[80880]|0;if(g>>>0<h>>>0){i=g;j=0}else{if((g|0)==(h|0)){a[(c[80804]|0)+f|0]=e}if((c[80877]|0)==1){c[80901]=g;a[323610]=e;b[161804]=d}pF((c[198580]|0)-(c[80880]|0)|0,0);g=(c[198580]|0)-1-(c[198568]|0)|0;c[80901]=-1;i=g;j=1}if(i>>>0<(c[80881]|0)>>>0){k=j}else{po(0,0);k=1}if((c[80907]|0)!=0){pm()}}while((k|0)!=0);a[(c[80804]|0)+f|0]=e;return}function pW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;pV(a,b);if((c[80872]|0)!=2){return}if((a&16383)!=14847){return}a=(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)-15|0;d=b&255;if((a|0)<1){c[80859]=d;return}b=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(a|0)){e=c[b+4>>2]|0;f=e|0;g=c[f>>2]|0;c[f>>2]=g+1;c[e+4+(g<<4)>>2]=a;c[e+4+(g<<4)+4>>2]=0;c[e+4+(g<<4)+8>>2]=323436;c[e+4+(g<<4)+12>>2]=d;c[(c[80539]|0)+20>>2]=1;return}else{g=c[b+16>>2]|0;b=g|0;e=c[b>>2]|0;c[b>>2]=e+1;c[g+4+(e<<4)>>2]=0;c[g+4+(e<<4)+4>>2]=0;c[g+4+(e<<4)+8>>2]=323436;c[g+4+(e<<4)+12>>2]=d;return}}function pX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;pV(b,d);if((b&16383)!=16383){return}do{if((c[80872]|0)==1){b=(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)-15|0;e=d&255;if((b|0)<1){c[80859]=e;break}f=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(b|0)){g=c[f+4>>2]|0;h=g|0;i=c[h>>2]|0;c[h>>2]=i+1;c[g+4+(i<<4)>>2]=b;c[g+4+(i<<4)+4>>2]=0;c[g+4+(i<<4)+8>>2]=323436;c[g+4+(i<<4)+12>>2]=e;c[(c[80539]|0)+20>>2]=1;break}else{i=c[f+16>>2]|0;f=i|0;g=c[f>>2]|0;c[f>>2]=g+1;c[i+4+(g<<4)>>2]=0;c[i+4+(g<<4)+4>>2]=0;c[i+4+(g<<4)+8>>2]=323436;c[i+4+(g<<4)+12>>2]=e;break}}}while(0);e=c[80538]|0;do{if((a[e+20|0]|0)==0){if((a[e+21|0]|0)!=0){break}return}}while(0);c[(c[80904]|0)+(c[80903]<<3)>>2]=c[198580];a[(c[80904]|0)+(c[80903]<<3)+4|0]=d;c[80903]=(c[80903]|0)+1;return}function pY(){c[80921]=719208+((d[322891]|0)<<18&1835008|(d[322890]|0)<<10);return}function pZ(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(c[80919]|0)!=0?-1:15;f=a[322869]|0;if((c[80914]|0)==0){g=f&-16|b&15}else{g=b}b=c[80908]|0;if((b|0)==0&f<<24>>24==g<<24>>24){return}f=(b|0)!=0;b=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;h=f?b-2|0:b;do{if((c[80850]|0)==0){b=g&255;if(f){i=d[322940+(g&e&255)|0]|0}else{i=b}j=(h|0)<1;do{if(j){c[80554]=i}else{k=c[80539]|0;if((c[c[80536]>>2]|0)>(h|0)){l=c[k>>2]|0;m=l|0;n=c[m>>2]|0;c[m>>2]=n+1;c[l+4+(n<<4)>>2]=h;c[l+4+(n<<4)+4>>2]=0;c[l+4+(n<<4)+8>>2]=322216;c[l+4+(n<<4)+12>>2]=i;c[(c[80539]|0)+20>>2]=1;break}else{n=c[k+16>>2]|0;k=n|0;l=c[k>>2]|0;c[k>>2]=l+1;c[n+4+(l<<4)>>2]=0;c[n+4+(l<<4)+4>>2]=0;c[n+4+(l<<4)+8>>2]=322216;c[n+4+(l<<4)+12>>2]=i;break}}}while(0);if((c[80908]|0)==0){o=b}else{o=d[322940+(g&e&255)|0]|0}if(j){c[80555]=o;break}l=c[80539]|0;if((c[c[80536]>>2]|0)>(h|0)){n=c[l>>2]|0;k=n|0;m=c[k>>2]|0;c[k>>2]=m+1;c[n+4+(m<<4)>>2]=h;c[n+4+(m<<4)+4>>2]=0;c[n+4+(m<<4)+8>>2]=322220;c[n+4+(m<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1;break}else{m=c[l+16>>2]|0;l=m|0;n=c[l>>2]|0;c[l>>2]=n+1;c[m+4+(n<<4)>>2]=0;c[m+4+(n<<4)+4>>2]=0;c[m+4+(n<<4)+8>>2]=322220;c[m+4+(n<<4)+12>>2]=o;break}}}while(0);if((c[80908]|0)==0){p=g}else{p=a[322940+(g&e&255)|0]|0}e=p&255;do{if((h|0)<1){c[80553]=e}else{p=c[80539]|0;if((c[c[80536]>>2]|0)>(h|0)){o=c[p>>2]|0;i=o|0;f=c[i>>2]|0;c[i>>2]=f+1;c[o+4+(f<<4)>>2]=h;c[o+4+(f<<4)+4>>2]=0;c[o+4+(f<<4)+8>>2]=322212;c[o+4+(f<<4)+12>>2]=e;c[(c[80539]|0)+20>>2]=1;break}else{f=c[p+16>>2]|0;p=f|0;o=c[p>>2]|0;c[p>>2]=o+1;c[f+4+(o<<4)>>2]=0;c[f+4+(o<<4)+4>>2]=0;c[f+4+(o<<4)+8>>2]=322212;c[f+4+(o<<4)+12>>2]=e;break}}}while(0);a[322869]=g;return}function p_(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=(c[80919]|0)!=0;if((c[80914]|0)==0){g=a[322836+(b&65535)|0]&-16|e&15}else{g=e}e=b&65535;b=322836+e|0;do{if((c[80908]|0)==0){if((a[b]|0)!=g<<24>>24){break}return}}while(0);a[b]=g;b=((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0;do{if((c[80841]|0)==4){h=(b<<3)-136+(c[80892]|0)|0;i=d[(c[80851]>>6)+322869|0]|0;if((h|0)<1){c[80555]=i;break}j=c[80539]|0;if((c[c[80536]>>2]|0)>(h|0)){k=c[j>>2]|0;l=k|0;m=c[l>>2]|0;c[l>>2]=m+1;c[k+4+(m<<4)>>2]=h;c[k+4+(m<<4)+4>>2]=0;c[k+4+(m<<4)+8>>2]=322220;c[k+4+(m<<4)+12>>2]=i;c[(c[80539]|0)+20>>2]=1;break}else{m=c[j+16>>2]|0;j=m|0;k=c[j>>2]|0;c[j>>2]=k+1;c[m+4+(k<<4)>>2]=0;c[m+4+(k<<4)+4>>2]=0;c[m+4+(k<<4)+8>>2]=322220;c[m+4+(k<<4)+12>>2]=i;break}}}while(0);i=b-16|0;b=323352+(e-34<<2)|0;e=g&255;if((c[80908]|0)==0){n=e}else{n=d[322940+(e&(f?255:15))|0]|0}if((i|0)<1){c[b>>2]=n;return}f=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(i|0)){e=c[f+4>>2]|0;g=e|0;k=c[g>>2]|0;c[g>>2]=k+1;c[e+4+(k<<4)>>2]=i;c[e+4+(k<<4)+4>>2]=0;c[e+4+(k<<4)+8>>2]=b;c[e+4+(k<<4)+12>>2]=n;c[(c[80539]|0)+20>>2]=1;return}else{k=c[f+16>>2]|0;f=k|0;e=c[f>>2]|0;c[f>>2]=e+1;c[k+4+(e<<4)>>2]=0;c[k+4+(e<<4)+4>>2]=0;c[k+4+(e<<4)+8>>2]=b;c[k+4+(e<<4)+12>>2]=n;return}}function p$(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0;f=((c[80914]|0)==0?63:127)&b;pq();b=c[198580]|0;g=c[80881]|0;if(b>>>0>=g>>>0){po(b-g|0,0)}g=f&65535;switch(g|0){case 1:case 3:case 5:case 7:case 9:case 11:case 13:case 15:{b=322836+g|0;h=e&255;if((a[b]|0)==e<<24>>24){return}i=c[198580]|0;j=(i>>>0)%((c[80894]|0)>>>0)|0;k=c[80896]|0;do{if((j|0)==(k+1|0)){if((h|0)!=(c[80551]&255|0)){break}c[80877]=1;l=i+1-j+k|0;c[80880]=l;m=c[80874]|0;n=c[m+4>>2]|0;o=m+12|0;p=c[o>>2]|0;if((p|0)<0){q=n+2056|0;r=c[q>>2]|0;if(r>>>0>255>>>0){fW();break}c[n+8+(r<<3)>>2]=m;c[n+8+(r<<3)+4>>2]=l;c[q>>2]=(c[q>>2]|0)+1;q=n+2060|0;if((c[q>>2]|0)>>>0>l>>>0){c[q>>2]=l;c[n+2064>>2]=r}c[o>>2]=r;break}else{c[n+8+(p<<3)+4>>2]=l;r=n+2060|0;o=n+2064|0;q=c[o>>2]|0;if((c[r>>2]|0)>>>0>l>>>0){s=q}else{if((p|0)==(q|0)){s=p}else{break}}p=c[n+2056>>2]|0;if((p|0)==0){t=s;u=-1}else{q=s;l=0;m=-1;while(1){v=c[n+8+(l<<3)+4>>2]|0;w=v>>>0>m>>>0;x=w?q:l;y=w?m:v;v=l+1|0;if(v>>>0<p>>>0){q=x;l=v;m=y}else{t=x;u=y;break}}}c[r>>2]=u;c[o>>2]=t;break}}}while(0);c[(c[(c[80538]|0)+4>>2]|0)+((g>>>1)*56|0)+4>>2]=h;a[b]=e;return};case 22:{b=((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0;h=e&7;t=a[322858]&7;do{if((h|0)!=(t|0)){do{if(h>>>0<t>>>0){if((b|0)>=56){break}u=b-17|0;s=t-h|0;if((u|0)<1){c[80547]=s;break}k=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(u|0)){j=c[k+4>>2]|0;i=j|0;m=c[i>>2]|0;c[i>>2]=m+1;c[j+4+(m<<4)>>2]=u;c[j+4+(m<<4)+4>>2]=0;c[j+4+(m<<4)+8>>2]=322188;c[j+4+(m<<4)+12>>2]=s;c[(c[80539]|0)+20>>2]=1;break}else{m=c[k+16>>2]|0;k=m|0;j=c[k>>2]|0;c[k>>2]=j+1;c[m+4+(j<<4)>>2]=0;c[m+4+(j<<4)+4>>2]=0;c[m+4+(j<<4)+8>>2]=322188;c[m+4+(j<<4)+12>>2]=s;break}}else{s=b<<3;j=s-136|0;m=(c[80892]|0)+j|0;k=h-t|0;do{if((m|0)<1){c[80548]=k}else{u=c[80539]|0;if((c[c[80536]>>2]|0)>(m|0)){i=c[u>>2]|0;l=i|0;q=c[l>>2]|0;c[l>>2]=q+1;c[i+4+(q<<4)>>2]=m;c[i+4+(q<<4)+4>>2]=0;c[i+4+(q<<4)+8>>2]=322192;c[i+4+(q<<4)+12>>2]=k;c[(c[80539]|0)+20>>2]=1;break}else{q=c[u+16>>2]|0;u=q|0;i=c[u>>2]|0;c[u>>2]=i+1;c[q+4+(i<<4)>>2]=0;c[q+4+(i<<4)+4>>2]=0;c[q+4+(i<<4)+8>>2]=322192;c[q+4+(i<<4)+12>>2]=k;break}}}while(0);k=s-128+(c[80892]|0)+(a[322858]&7)|0;m=c[80536]|0;do{if((k|0)<(-(c[m+44>>2]|0)|0)){c[80549]=1}else{i=c[80539]|0;if(((c[m+48>>2]|0)+(c[m>>2]|0)|0)<=(k|0)){q=c[i+16>>2]|0;u=q|0;l=c[u>>2]|0;c[u>>2]=l+1;c[q+4+(l<<4)>>2]=0;c[q+4+(l<<4)+4>>2]=0;c[q+4+(l<<4)+8>>2]=322196;c[q+4+(l<<4)+12>>2]=1;break}l=c[i+12>>2]|0;i=l|0;q=c[i>>2]|0;u=q;while(1){z=u-1|0;if((z|0)<=-1){break}if((c[l+4+(z<<4)>>2]|0)>(k|0)){u=z}else{break}}p=q-1|0;if((p|0)>(z|0)){n=q;y=p;while(1){p=l+4+(n<<4)|0;x=l+4+(y<<4)|0;c[p>>2]=c[x>>2];c[p+4>>2]=c[x+4>>2];c[p+8>>2]=c[x+8>>2];c[p+12>>2]=c[x+12>>2];x=y-1|0;if((x|0)>(z|0)){n=y;y=x}else{break}}A=c[i>>2]|0}else{A=q}c[i>>2]=A+1;c[l+4+(u<<4)>>2]=k;c[l+4+(u<<4)+4>>2]=0;c[l+4+(u<<4)+8>>2]=322196;c[l+4+(u<<4)+12>>2]=1;c[(c[80539]|0)+20>>2]=1}}while(0);k=j+(h|8)+(c[80892]|0)|0;m=c[80536]|0;if((k|0)<(-(c[m+44>>2]|0)|0)){c[80549]=0;break}s=c[80539]|0;if(((c[m+48>>2]|0)+(c[m>>2]|0)|0)<=(k|0)){m=c[s+16>>2]|0;y=m|0;n=c[y>>2]|0;c[y>>2]=n+1;c[m+4+(n<<4)>>2]=0;c[m+4+(n<<4)+4>>2]=0;c[m+4+(n<<4)+8>>2]=322196;c[m+4+(n<<4)+12>>2]=0;break}n=c[s+12>>2]|0;s=n|0;m=c[s>>2]|0;y=m;while(1){B=y-1|0;if((B|0)<=-1){break}if((c[n+4+(B<<4)>>2]|0)>(k|0)){y=B}else{break}}j=m-1|0;if((j|0)>(B|0)){x=m;p=j;while(1){j=n+4+(x<<4)|0;v=n+4+(p<<4)|0;c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];v=p-1|0;if((v|0)>(B|0)){x=p;p=v}else{break}}C=c[s>>2]|0}else{C=m}c[s>>2]=C+1;c[n+4+(y<<4)>>2]=k;c[n+4+(y<<4)+4>>2]=0;c[n+4+(y<<4)+8>>2]=322196;c[n+4+(y<<4)+12>>2]=0;c[(c[80539]|0)+20>>2]=1}}while(0);o=b-16|0;do{if((o|0)<1){c[80544]=h}else{r=c[80539]|0;if((c[(c[80536]|0)+16>>2]|0)>(o|0)){p=c[r+4>>2]|0;x=p|0;v=c[x>>2]|0;c[x>>2]=v+1;c[p+4+(v<<4)>>2]=o;c[p+4+(v<<4)+4>>2]=0;c[p+4+(v<<4)+8>>2]=322176;c[p+4+(v<<4)+12>>2]=h;c[(c[80539]|0)+20>>2]=1;break}else{v=c[r+16>>2]|0;r=v|0;p=c[r>>2]|0;c[r>>2]=p+1;c[v+4+(p<<4)>>2]=0;c[v+4+(p<<4)+4>>2]=0;c[v+4+(p<<4)+8>>2]=322176;c[v+4+(p<<4)+12>>2]=h;break}}}while(0);o=(b<<3)+(h|-128)+(c[80892]|0)|0;p=c[80536]|0;if((o|0)<(-(c[p+44>>2]|0)|0)){c[80546]=h;break}v=c[80539]|0;if(((c[p+48>>2]|0)+(c[p>>2]|0)|0)<=(o|0)){p=c[v+16>>2]|0;r=p|0;x=c[r>>2]|0;c[r>>2]=x+1;c[p+4+(x<<4)>>2]=0;c[p+4+(x<<4)+4>>2]=0;c[p+4+(x<<4)+8>>2]=322184;c[p+4+(x<<4)+12>>2]=h;break}x=c[v+12>>2]|0;v=x|0;p=c[v>>2]|0;r=p;while(1){D=r-1|0;if((D|0)<=-1){break}if((c[x+4+(D<<4)>>2]|0)>(o|0)){r=D}else{break}}j=p-1|0;if((j|0)>(D|0)){w=p;E=j;while(1){j=x+4+(w<<4)|0;F=x+4+(E<<4)|0;c[j>>2]=c[F>>2];c[j+4>>2]=c[F+4>>2];c[j+8>>2]=c[F+8>>2];c[j+12>>2]=c[F+12>>2];F=E-1|0;if((F|0)>(D|0)){w=E;E=F}else{break}}G=c[v>>2]|0}else{G=p}c[v>>2]=G+1;c[x+4+(r<<4)>>2]=o;c[x+4+(r<<4)+4>>2]=0;c[x+4+(r<<4)+8>>2]=322184;c[x+4+(r<<4)+12>>2]=h;c[(c[80539]|0)+20>>2]=1}}while(0);h=e&8;do{if((h|0)!=(a[322858]&8|0)){G=(b|0)<18;D=c[80892]|0;if((h|0)!=0){do{if(G){c[80566]=D;H=D+320|0;I=1610}else{C=c[(c[80539]|0)+16>>2]|0;B=C|0;A=c[B>>2]|0;c[B>>2]=A+1;c[C+4+(A<<4)>>2]=0;c[C+4+(A<<4)+4>>2]=0;c[C+4+(A<<4)+8>>2]=322264;c[C+4+(A<<4)+12>>2]=D;A=(c[80892]|0)+320|0;if((b|0)<57){H=A;I=1610;break}C=c[(c[80539]|0)+16>>2]|0;B=C|0;z=c[B>>2]|0;c[B>>2]=z+1;c[C+4+(z<<4)>>2]=0;c[C+4+(z<<4)+4>>2]=0;c[C+4+(z<<4)+8>>2]=322268;c[C+4+(z<<4)+12>>2]=A}}while(0);if((I|0)==1610){c[80567]=H}if((b|0)!=17){break}if((a[322858]&8)!=0){break}c[80557]=1;break}r=c[80908]|0;x=D+7+r|0;do{if(G){c[80566]=x;J=D+311+r|0;I=1618}else{o=c[(c[80539]|0)+16>>2]|0;v=o|0;p=c[v>>2]|0;c[v>>2]=p+1;c[o+4+(p<<4)>>2]=0;c[o+4+(p<<4)+4>>2]=0;c[o+4+(p<<4)+8>>2]=322264;c[o+4+(p<<4)+12>>2]=x;p=(c[80892]|0)+311+(c[80908]|0)|0;if((b|0)<57){J=p;I=1618;break}o=c[(c[80539]|0)+16>>2]|0;v=o|0;A=c[v>>2]|0;c[v>>2]=A+1;c[o+4+(A<<4)>>2]=0;c[o+4+(A<<4)+4>>2]=0;c[o+4+(A<<4)+8>>2]=322268;c[o+4+(A<<4)+12>>2]=p}}while(0);if((I|0)==1618){c[80567]=J}if((b|0)!=56){break}if((a[322858]&8)==0){break}if((c[80559]|0)==0){if((c[80556]|0)!=0){break}if((c[80551]|0)==(c[80565]|0)){break}}c[80558]=1;x=c[80900]|0;if((x|0)==2){r=(c[80892]|0)+312|0;D=c[80851]&15;if((r|0)<1){c[80555]=D;break}G=c[80539]|0;if((c[c[80536]>>2]|0)>(r|0)){p=c[G>>2]|0;A=p|0;o=c[A>>2]|0;c[A>>2]=o+1;c[p+4+(o<<4)>>2]=r;c[p+4+(o<<4)+4>>2]=0;c[p+4+(o<<4)+8>>2]=322220;c[p+4+(o<<4)+12>>2]=D;c[(c[80539]|0)+20>>2]=1;break}else{o=c[G+16>>2]|0;G=o|0;p=c[G>>2]|0;c[G>>2]=p+1;c[o+4+(p<<4)>>2]=0;c[o+4+(p<<4)+4>>2]=0;c[o+4+(p<<4)+8>>2]=322220;c[o+4+(p<<4)+12>>2]=D;break}}else if((x|0)==4){x=(c[80892]|0)+312|0;D=d[(c[80851]>>6)+322869|0]|0;if((x|0)<1){c[80555]=D;break}p=c[80539]|0;if((c[c[80536]>>2]|0)>(x|0)){o=c[p>>2]|0;G=o|0;r=c[G>>2]|0;c[G>>2]=r+1;c[o+4+(r<<4)>>2]=x;c[o+4+(r<<4)+4>>2]=0;c[o+4+(r<<4)+8>>2]=322220;c[o+4+(r<<4)+12>>2]=D;c[(c[80539]|0)+20>>2]=1;break}else{r=c[p+16>>2]|0;p=r|0;o=c[p>>2]|0;c[p>>2]=o+1;c[r+4+(o<<4)>>2]=0;c[r+4+(o<<4)+4>>2]=0;c[r+4+(o<<4)+8>>2]=322220;c[r+4+(o<<4)+12>>2]=D;break}}else{break}}}while(0);a[322858]=e;ps(b);return};case 16:{if((a[322852]|0)==e<<24>>24){return}b=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;a[322852]=e;qe(0,d[322836]|((e&1)!=0?256:0),b);qe(1,d[322838]|((e&2)!=0?256:0),b);qe(2,d[322840]|((e&4)!=0?256:0),b);qe(3,d[322842]|((e&8)!=0?256:0),b);qe(4,d[322844]|((e&16)!=0?256:0),b);qe(5,d[322846]|((e&32)!=0?256:0),b);qe(6,d[322848]|((e&64)!=0?256:0),b);qe(7,d[322850]|(e<<24>>24<0?256:0),b);return};case 18:{if((a[322854]|0)==e<<24>>24){return}a[322854]=e;pQ(e,0);return};case 21:{b=c[198580]|0;J=(b>>>0)%((c[80894]|0)>>>0)|0;H=c[80896]|0;do{if((J|0)==(H+1|0)){if((~a[322857]&e)<<24>>24==0){break}c[80877]=1;h=b+1-J+H|0;c[80880]=h;D=c[80874]|0;o=c[D+4>>2]|0;r=D+12|0;p=c[r>>2]|0;if((p|0)<0){x=o+2056|0;G=c[x>>2]|0;if(G>>>0>255>>>0){fW();break}c[o+8+(G<<3)>>2]=D;c[o+8+(G<<3)+4>>2]=h;c[x>>2]=(c[x>>2]|0)+1;x=o+2060|0;if((c[x>>2]|0)>>>0>h>>>0){c[x>>2]=h;c[o+2064>>2]=G}c[r>>2]=G;break}else{c[o+8+(p<<3)+4>>2]=h;G=o+2060|0;r=o+2064|0;x=c[r>>2]|0;if((c[G>>2]|0)>>>0>h>>>0){K=x}else{if((p|0)==(x|0)){K=p}else{break}}p=c[o+2056>>2]|0;if((p|0)==0){L=K;M=-1}else{x=K;h=0;D=-1;while(1){A=c[o+8+(h<<3)+4>>2]|0;v=A>>>0>D>>>0;z=v?x:h;C=v?D:A;A=h+1|0;if(A>>>0<p>>>0){x=z;h=A;D=C}else{L=z;M=C;break}}}c[G>>2]=M;c[r>>2]=L;break}}}while(0);L=c[80538]|0;do{if((a[L+20|0]|0)==0){if((a[L+21|0]|0)!=0|e<<24>>24==0){break}if((c[80877]|0)==0){M=c[80880]|0;K=c[198580]|0;H=c[80896]|0;if((J|0)<12|M>>>0<=K>>>0|(J|0)>(H|0)){I=1539}else{N=K;O=H;P=M}}else{I=1539}if((I|0)==1539){M=c[80551]|0;if(M>>>0>=(c[80898]|0)>>>0&M>>>0<(c[80899]|0)>>>0){break}N=c[198580]|0;O=c[80896]|0;P=c[80880]|0}M=c[80894]|0;H=N+O-((N>>>0)%(M>>>0)|0)+((J|0)>(O|0)?M:0)|0;if(H>>>0>=P>>>0){break}c[80877]=1;c[80880]=H;M=c[80874]|0;K=c[M+4>>2]|0;b=M+12|0;D=c[b>>2]|0;if((D|0)<0){h=K+2056|0;x=c[h>>2]|0;if(x>>>0>255>>>0){fW();break}c[K+8+(x<<3)>>2]=M;c[K+8+(x<<3)+4>>2]=H;c[h>>2]=(c[h>>2]|0)+1;h=K+2060|0;if((c[h>>2]|0)>>>0>H>>>0){c[h>>2]=H;c[K+2064>>2]=x}c[b>>2]=x;break}else{c[K+8+(D<<3)+4>>2]=H;x=K+2060|0;b=K+2064|0;h=c[b>>2]|0;if((c[x>>2]|0)>>>0>H>>>0){Q=h}else{if((D|0)==(h|0)){Q=D}else{break}}D=c[K+2056>>2]|0;if((D|0)==0){R=Q;S=-1}else{h=Q;H=0;M=-1;while(1){p=c[K+8+(H<<3)+4>>2]|0;o=p>>>0>M>>>0;C=o?h:H;z=o?M:p;p=H+1|0;if(p>>>0<D>>>0){h=C;H=p;M=z}else{R=C;S=z;break}}}c[x>>2]=S;c[b>>2]=R;break}}}while(0);a[(c[80538]|0)+20|0]=e;a[322857]=e;return};case 0:case 2:case 4:case 6:case 8:case 10:case 12:case 14:{R=322836+g|0;if((a[R]|0)==e<<24>>24){return}a[R]=e;R=g>>>1;qe(R,((d[322852]&1<<R|0)!=0?256:0)|e&255,((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0);return};case 17:{R=c[198580]|0;S=c[80894]|0;Q=(R>>>0)%(S>>>0)|0;P=(((R>>>0)/(S>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0;pQ(e,1);S=c[80836]|0;R=c[80898]|0;if((P|0)==(R|0)&(Q|0)==0){O=(e&255)>>>4&1;c[80836]=O;T=O}else{T=S}do{if(((((((c[198580]|0)-1|0)>>>0)/((c[80894]|0)>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0|0)==(R|0)){if((e&16)==0){U=T;break}c[80836]=1;U=1}else{U=T}}while(0);T=e&255;O=T&7;if(!((c[80545]|0)==(O|0)&(U|0)==(S|0)|P>>>0<R>>>0|P>>>0>(c[80899]|0)>>>0)){pB(e,Q,P,S)}c[80545]=O;do{if(((a[322853]^e)&8)==0){V=c[80564]|0;I=1515}else{if((e&8)==0){O=c[80890]|0;c[80564]=O;c[80565]=c[80891];S=(Q|0)>0;if((c[80563]|0)==0&(c[80888]|0)==(P|0)&S){c[80556]=0;V=O;I=1515;break}if(!((c[80889]|0)==(P|0)&S)){V=O;I=1515;break}c[80556]=1;V=O;I=1515;break}O=c[80888]|0;c[80564]=O;c[80565]=c[80889];S=(Q|0)>0;if((c[80891]|0)==(P|0)&S){c[80556]=1;V=O;I=1515;break}R=c[80563]|0;U=(R|0)==0;if(U&(c[80890]|0)==(P|0)&S){c[80556]=0}if((O|0)!=(P|0)){V=O;I=1515;break}if(!(S&U)){W=R;I=1517;break}c[80556]=0;W=0;I=1517}}while(0);do{if((I|0)==1515){if((V|0)!=(P|0)){break}W=c[80563]|0;I=1517}}while(0);do{if((I|0)==1517){if((Q|0)<1|(W|0)!=0){break}c[80562]=1}}while(0);c[80563]=T>>>4&1^1;a[322853]=e;ps(Q);return};case 23:{Q=e&255;if((a[322859]|0)==e<<24>>24){return}T=((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0;W=(c[80538]|0)+4|0;L2175:do{if((T|0)==15){I=1;P=0;while(1){V=c[W>>2]|0;R=(I&Q|0)!=0;c[V+(P*56|0)+12>>2]=R&1;do{if(!R){U=V+(P*56|0)+48|0;if((c[U>>2]|0)!=0){break}c[V+(P*56|0)+44>>2]=c[45832+(c[V+(P*56|0)+40>>2]<<2)>>2];c[U>>2]=1}}while(0);V=P+1|0;if((V|0)<8){I=I<<1&254;P=V}else{break}}}else{if((T|0)>14){X=1;Y=0}else{P=1;I=0;while(1){b=c[W>>2]|0;x=(P&Q|0)!=0;c[b+(I*56|0)+12>>2]=x&1;do{if(!x){V=b+(I*56|0)+48|0;if((c[V>>2]|0)!=0){break}c[b+(I*56|0)+44>>2]=3;c[V>>2]=1}}while(0);b=I+1|0;if((b|0)<8){P=P<<1&254;I=b}else{break L2175}}}while(1){I=c[W>>2]|0;P=(X&Q|0)!=0;c[I+(Y*56|0)+12>>2]=P&1;do{if(!P){b=I+(Y*56|0)+48|0;if((c[b>>2]|0)!=0){break}if((T|0)>=(c[80896]|0)){c[I+(Y*56|0)+44>>2]=3}c[b>>2]=1}}while(0);I=Y+1|0;if((I|0)<8){X=X<<1&254;Y=I}else{break}}}}while(0);a[322859]=e;return};case 24:{if((a[322860]|0)==e<<24>>24){return}a[322860]=e;pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return};case 25:{do{if((c[198568]|0)!=0){c[80801]=(a[323644]&15^-129)&c[80801];Y=c[198580]|0;X=c[80882]|0;if((Y-1|0)>>>0<=X>>>0){break}if((c[80802]|0)>>>0>=(c[80885]|0)>>>0){break}if((Y-2|0)==(X|0)){pR();break}else{pS(0,0);break}}}while(0);X=e&255;do{if((X&1|0)!=0){Y=c[198580]|0;T=c[80882]|0;if(Y>>>0<=T>>>0){break}if((c[80802]|0)>>>0>=(c[80885]|0)>>>0){break}if((Y-1|0)==(T|0)){pR();break}else{pS(0,0);break}}}while(0);c[80801]=c[80801]&(X&15^-129);pI();return};case 26:{a[322862]=e&15;pI();return};case 27:{X=e&255;if((a[322863]|0)==e<<24>>24){return}T=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;Y=1;Q=0;while(1){W=c[(c[80538]|0)+4>>2]|0;if((c[W+(Q*56|0)>>2]|0)<(T|0)){I=c[(c[80539]|0)+16>>2]|0;P=I|0;b=c[P>>2]|0;c[P>>2]=b+1;c[I+4+(b<<4)>>2]=0;c[I+4+(b<<4)+4>>2]=0;c[I+4+(b<<4)+8>>2]=W+(Q*56|0)+32;c[I+4+(b<<4)+12>>2]=(Y&X|0)!=0}else{c[W+(Q*56|0)+32>>2]=(Y&X|0)!=0}W=Q+1|0;if((W|0)<8){Y=Y<<1&254;Q=W}else{break}}a[322863]=e;return};case 28:{Q=e&255;Y=a[322864]|0;if(Y<<24>>24==e<<24>>24){return}X=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;T=1;W=0;b=Y;while(1){Y=c[(c[80538]|0)+4>>2]|0;I=T&Q;do{if((T&(b&255)|0)!=(I|0)){P=(c[80892]|0)-32+(((d[322852]&T|0)!=0?256:0)|d[322836+(W<<1)|0])|0;do{if((P|0)<(X|0)){x=(d[322865]&T|0)!=0;if(((x?48:24)+P|0)<(X|0)){Z=6;break}do{if((I|0)==0){V=P&1;if(!x){_=V|6;$=0;aa=0;break}if((V|0)!=0){_=7;$=0;aa=0;break}_=8-(P&2)|0;$=0;aa=0}else{if(x){ab=(P>>>1^P)&1^1;ac=(P|0)%2|0}else{ab=P&1;ac=0}_=6-ac|0;$=ab;aa=ac}}while(0);x=_+X|0;u=Y+(W*56|0)+28|0;l=$<<1|aa;i=c[80536]|0;if((x|0)<(-(c[i+44>>2]|0)|0)){c[u>>2]=l;Z=_;break}q=c[80539]|0;if(((c[i+48>>2]|0)+(c[i>>2]|0)|0)<=(x|0)){i=c[q+16>>2]|0;V=i|0;R=c[V>>2]|0;c[V>>2]=R+1;c[i+4+(R<<4)>>2]=0;c[i+4+(R<<4)+4>>2]=0;c[i+4+(R<<4)+8>>2]=u;c[i+4+(R<<4)+12>>2]=l;Z=_;break}R=c[q+12>>2]|0;q=R|0;i=c[q>>2]|0;V=i;while(1){ad=V-1|0;if((ad|0)<=-1){break}if((c[R+4+(ad<<4)>>2]|0)>(x|0)){V=ad}else{break}}y=i-1|0;if((y|0)>(ad|0)){n=i;k=y;while(1){y=R+4+(n<<4)|0;s=R+4+(k<<4)|0;c[y>>2]=c[s>>2];c[y+4>>2]=c[s+4>>2];c[y+8>>2]=c[s+8>>2];c[y+12>>2]=c[s+12>>2];s=k-1|0;if((s|0)>(ad|0)){n=k;k=s}else{break}}ae=c[q>>2]|0}else{ae=i}c[q>>2]=ae+1;c[R+4+(V<<4)>>2]=x;c[R+4+(V<<4)+4>>2]=0;c[R+4+(V<<4)+8>>2]=u;c[R+4+(V<<4)+12>>2]=l;c[(c[80539]|0)+20>>2]=1;Z=_}else{Z=6}}while(0);P=Z+X|0;k=Y+(W*56|0)+24|0;n=(I|0)!=0|0;s=c[80536]|0;if((P|0)<(-(c[s+44>>2]|0)|0)){c[k>>2]=n;break}y=c[80539]|0;if(((c[s+48>>2]|0)+(c[s>>2]|0)|0)<=(P|0)){s=c[y+16>>2]|0;m=s|0;U=c[m>>2]|0;c[m>>2]=U+1;c[s+4+(U<<4)>>2]=0;c[s+4+(U<<4)+4>>2]=0;c[s+4+(U<<4)+8>>2]=k;c[s+4+(U<<4)+12>>2]=n;break}U=c[y+12>>2]|0;y=U|0;s=c[y>>2]|0;m=s;while(1){af=m-1|0;if((af|0)<=-1){break}if((c[U+4+(af<<4)>>2]|0)>(P|0)){m=af}else{break}}S=s-1|0;if((S|0)>(af|0)){O=s;J=S;while(1){S=U+4+(O<<4)|0;N=U+4+(J<<4)|0;c[S>>2]=c[N>>2];c[S+4>>2]=c[N+4>>2];c[S+8>>2]=c[N+8>>2];c[S+12>>2]=c[N+12>>2];N=J-1|0;if((N|0)>(af|0)){O=J;J=N}else{break}}ag=c[y>>2]|0}else{ag=s}c[y>>2]=ag+1;c[U+4+(m<<4)>>2]=P;c[U+4+(m<<4)+4>>2]=0;c[U+4+(m<<4)+8>>2]=k;c[U+4+(m<<4)+12>>2]=n;c[(c[80539]|0)+20>>2]=1}}while(0);I=W+1|0;if((I|0)>=8){break}T=T<<1&254;W=I;b=a[322864]|0}a[322864]=e;return};case 29:{b=e&255;W=a[322865]|0;if(W<<24>>24==e<<24>>24){return}T=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-130+(c[80892]|0)|0;ag=1;af=0;X=W;while(1){W=c[(c[80538]|0)+4>>2]|0;Z=ag&b;do{if((Z|0)!=(ag&(X&255)|0)){_=W+(af*56|0)+8|0;ae=(Z|0)!=0;ad=ae&1;aa=c[80536]|0;do{if((T|0)<(-(c[aa+44>>2]|0)|0)){c[_>>2]=ad}else{$=c[80539]|0;if(((c[aa+48>>2]|0)+(c[aa>>2]|0)|0)<=(T|0)){ac=c[$+16>>2]|0;ab=ac|0;Q=c[ab>>2]|0;c[ab>>2]=Q+1;c[ac+4+(Q<<4)>>2]=0;c[ac+4+(Q<<4)+4>>2]=0;c[ac+4+(Q<<4)+8>>2]=_;c[ac+4+(Q<<4)+12>>2]=ad;break}Q=c[$+12>>2]|0;$=Q|0;ac=c[$>>2]|0;ab=ac;while(1){ah=ab-1|0;if((ah|0)<=-1){break}if((c[Q+4+(ah<<4)>>2]|0)>(T|0)){ab=ah}else{break}}l=ac-1|0;if((l|0)>(ah|0)){V=ac;R=l;while(1){l=Q+4+(V<<4)|0;u=Q+4+(R<<4)|0;c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2];u=R-1|0;if((u|0)>(ah|0)){V=R;R=u}else{break}}ai=c[$>>2]|0}else{ai=ac}c[$>>2]=ai+1;c[Q+4+(ab<<4)>>2]=T;c[Q+4+(ab<<4)+4>>2]=0;c[Q+4+(ab<<4)+8>>2]=_;c[Q+4+(ab<<4)+12>>2]=ad;c[(c[80539]|0)+20>>2]=1}}while(0);ad=c[W+(af*56|0)>>2]|0;if((T|0)<=(ad|0)){break}if(ae){aj=ad-T|0}else{aj=(T-ad|0)/2|0}ad=W+(af*56|0)+20|0;_=(c[ad>>2]|0)+aj|0;c[ad>>2]=_;ad=W+(af*56|0)+16|0;aa=c[80536]|0;if((T|0)<(-(c[aa+44>>2]|0)|0)){c[ad>>2]=_;break}n=c[80539]|0;if(((c[aa+48>>2]|0)+(c[aa>>2]|0)|0)<=(T|0)){aa=c[n+16>>2]|0;m=aa|0;U=c[m>>2]|0;c[m>>2]=U+1;c[aa+4+(U<<4)>>2]=0;c[aa+4+(U<<4)+4>>2]=0;c[aa+4+(U<<4)+8>>2]=ad;c[aa+4+(U<<4)+12>>2]=_;break}U=c[n+12>>2]|0;n=U|0;aa=c[n>>2]|0;m=aa;while(1){ak=m-1|0;if((ak|0)<=-1){break}if((c[U+4+(ak<<4)>>2]|0)>(T|0)){m=ak}else{break}}ae=aa-1|0;if((ae|0)>(ak|0)){k=aa;P=ae;while(1){ae=U+4+(k<<4)|0;y=U+4+(P<<4)|0;c[ae>>2]=c[y>>2];c[ae+4>>2]=c[y+4>>2];c[ae+8>>2]=c[y+8>>2];c[ae+12>>2]=c[y+12>>2];y=P-1|0;if((y|0)>(ak|0)){k=P;P=y}else{break}}al=c[n>>2]|0}else{al=aa}c[n>>2]=al+1;c[U+4+(m<<4)>>2]=T;c[U+4+(m<<4)+4>>2]=0;c[U+4+(m<<4)+8>>2]=ad;c[U+4+(m<<4)+12>>2]=_;c[(c[80539]|0)+20>>2]=1}}while(0);W=af+1|0;if((W|0)>=8){break}ag=ag<<1&254;af=W;X=a[322865]|0}a[322865]=e;return};case 32:{X=a[322868]|0;if((c[80914]|0)==0){am=X&-16|e&15}else{am=e}af=c[80908]|0;if((af|0)==0&X<<24>>24==am<<24>>24){return}a[322868]=am;X=(af|0)!=0;af=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-136+(c[80892]|0)|0;ag=X?af-2|0:af;af=am&255;if(X){an=d[322940+af|0]|0}else{an=af}if((ag|0)<1){c[80552]=an;return}af=c[80539]|0;if((c[c[80536]>>2]|0)>(ag|0)){X=c[af+8>>2]|0;am=X|0;T=c[am>>2]|0;c[am>>2]=T+1;c[X+4+(T<<4)>>2]=ag;c[X+4+(T<<4)+4>>2]=0;c[X+4+(T<<4)+8>>2]=322208;c[X+4+(T<<4)+12>>2]=an;c[(c[80539]|0)+20>>2]=1;return}else{T=c[af+16>>2]|0;af=T|0;X=c[af>>2]|0;c[af>>2]=X+1;c[T+4+(X<<4)>>2]=0;c[T+4+(X<<4)+4>>2]=0;c[T+4+(X<<4)+8>>2]=322208;c[T+4+(X<<4)+12>>2]=an;return}break};case 33:{pZ(e);return};case 34:case 35:case 36:{p_(f,e);return};case 37:{f=e&15;an=(c[80908]|0)==0;if(an&(a[322873]|0)==f<<24>>24){return}X=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-135+(c[80892]|0)|0;T=(c[80538]|0)+24|0;af=f&255;if(an){ao=af}else{ao=d[322940+af|0]|0}af=c[80536]|0;do{if((X|0)<(-(c[af+44>>2]|0)|0)){c[T>>2]=ao}else{an=c[80539]|0;if(((c[af+48>>2]|0)+(c[af>>2]|0)|0)<=(X|0)){ag=c[an+16>>2]|0;am=ag|0;al=c[am>>2]|0;c[am>>2]=al+1;c[ag+4+(al<<4)>>2]=0;c[ag+4+(al<<4)+4>>2]=0;c[ag+4+(al<<4)+8>>2]=T;c[ag+4+(al<<4)+12>>2]=ao;break}al=c[an+12>>2]|0;an=al|0;ag=c[an>>2]|0;am=ag;while(1){ap=am-1|0;if((ap|0)<=-1){break}if((c[al+4+(ap<<4)>>2]|0)>(X|0)){am=ap}else{break}}ak=ag-1|0;if((ak|0)>(ap|0)){aj=ag;ai=ak;while(1){ak=al+4+(aj<<4)|0;ah=al+4+(ai<<4)|0;c[ak>>2]=c[ah>>2];c[ak+4>>2]=c[ah+4>>2];c[ak+8>>2]=c[ah+8>>2];c[ak+12>>2]=c[ah+12>>2];ah=ai-1|0;if((ah|0)>(ap|0)){aj=ai;ai=ah}else{break}}aq=c[an>>2]|0}else{aq=ag}c[an>>2]=aq+1;c[al+4+(am<<4)>>2]=X;c[al+4+(am<<4)+4>>2]=0;c[al+4+(am<<4)+8>>2]=T;c[al+4+(am<<4)+12>>2]=ao;c[(c[80539]|0)+20>>2]=1}}while(0);a[322873]=f;return};case 38:{f=e&15;ao=(c[80908]|0)==0;if(ao&(a[322874]|0)==f<<24>>24){return}T=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-135+(c[80892]|0)|0;X=(c[80538]|0)+28|0;aq=f&255;if(ao){ar=aq}else{ar=d[322940+aq|0]|0}aq=c[80536]|0;do{if((T|0)<(-(c[aq+44>>2]|0)|0)){c[X>>2]=ar}else{ao=c[80539]|0;if(((c[aq+48>>2]|0)+(c[aq>>2]|0)|0)<=(T|0)){ap=c[ao+16>>2]|0;af=ap|0;ai=c[af>>2]|0;c[af>>2]=ai+1;c[ap+4+(ai<<4)>>2]=0;c[ap+4+(ai<<4)+4>>2]=0;c[ap+4+(ai<<4)+8>>2]=X;c[ap+4+(ai<<4)+12>>2]=ar;break}ai=c[ao+12>>2]|0;ao=ai|0;ap=c[ao>>2]|0;af=ap;while(1){as=af-1|0;if((as|0)<=-1){break}if((c[ai+4+(as<<4)>>2]|0)>(T|0)){af=as}else{break}}am=ap-1|0;if((am|0)>(as|0)){al=ap;an=am;while(1){am=ai+4+(al<<4)|0;ag=ai+4+(an<<4)|0;c[am>>2]=c[ag>>2];c[am+4>>2]=c[ag+4>>2];c[am+8>>2]=c[ag+8>>2];c[am+12>>2]=c[ag+12>>2];ag=an-1|0;if((ag|0)>(as|0)){al=an;an=ag}else{break}}at=c[ao>>2]|0}else{at=ap}c[ao>>2]=at+1;c[ai+4+(af<<4)>>2]=T;c[ai+4+(af<<4)+4>>2]=0;c[ai+4+(af<<4)+8>>2]=X;c[ai+4+(af<<4)+12>>2]=ar;c[(c[80539]|0)+20>>2]=1}}while(0);a[322874]=f;return};case 39:case 40:case 41:case 42:case 43:case 44:case 45:case 46:{f=e&15;ar=(c[80908]|0)==0;do{if(ar){if((a[322836+g|0]|0)!=f<<24>>24){break}return}}while(0);X=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-135+(c[80892]|0)|0;T=(c[(c[80538]|0)+4>>2]|0)+((g-39|0)*56|0)+36|0;at=f&255;if(ar){au=at}else{au=d[322940+at|0]|0}at=c[80536]|0;do{if((X|0)<(-(c[at+44>>2]|0)|0)){c[T>>2]=au}else{ar=c[80539]|0;if(((c[at+48>>2]|0)+(c[at>>2]|0)|0)<=(X|0)){as=c[ar+16>>2]|0;aq=as|0;an=c[aq>>2]|0;c[aq>>2]=an+1;c[as+4+(an<<4)>>2]=0;c[as+4+(an<<4)+4>>2]=0;c[as+4+(an<<4)+8>>2]=T;c[as+4+(an<<4)+12>>2]=au;break}an=c[ar+12>>2]|0;ar=an|0;as=c[ar>>2]|0;aq=as;while(1){av=aq-1|0;if((av|0)<=-1){break}if((c[an+4+(av<<4)>>2]|0)>(X|0)){aq=av}else{break}}af=as-1|0;if((af|0)>(av|0)){ai=as;ao=af;while(1){af=an+4+(ai<<4)|0;ap=an+4+(ao<<4)|0;c[af>>2]=c[ap>>2];c[af+4>>2]=c[ap+4>>2];c[af+8>>2]=c[ap+8>>2];c[af+12>>2]=c[ap+12>>2];ap=ao-1|0;if((ap|0)>(av|0)){ai=ao;ao=ap}else{break}}aw=c[ar>>2]|0}else{aw=as}c[ar>>2]=aw+1;c[an+4+(aq<<4)>>2]=X;c[an+4+(aq<<4)+4>>2]=0;c[an+4+(aq<<4)+8>>2]=T;c[an+4+(aq<<4)+12>>2]=au;c[(c[80539]|0)+20>>2]=1}}while(0);a[322836+g|0]=f;return};case 47:{if((c[80907]|0)==0){return}a[322883]=e|-8;k6(e);return};case 48:{if((c[80907]|0)==0){return}a[322884]=e|-4;c[80909]=e&1;c[80910]=0;return};case 54:{if((c[80914]|0)==0){return}a[322890]=e;c[80921]=719208+(d[322891]<<18&1835008|(e&255)<<10);return};case 55:{if((c[80914]|0)==0){return}a[322891]=e;c[80921]=719208+(d[322890]<<10|(e&255)<<18&1835008);return};case 56:{if((c[80914]|0)==0){return}a[322892]=e;c[80730]=c[80730]&65280|e&255;return};case 57:{if((c[80914]|0)==0){return}f=e&15;a[322893]=f&255;c[80730]=c[80730]&255|f<<8;return};case 58:{if((c[80914]|0)==0){return}a[322894]=e;pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return};case 59:{if((c[80914]|0)==0){return}a[322895]=e;pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return};case 60:{if((c[80914]|0)==0){return}f=((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0;g=c[80918]|0;a[322896]=e;au=e&255;c[80916]=au>>>5&1;c[80917]=au>>>4&1;c[80918]=au>>>3&1;c[80919]=au>>>2&1;T=au>>>1&1;c[80920]=T;au=(f<<3)-138+(c[80892]|0)|0;do{if((au|0)<1){c[80561]=T}else{X=c[80539]|0;if((c[c[80536]>>2]|0)>(au|0)){aw=c[X+8>>2]|0;av=aw|0;at=c[av>>2]|0;c[av>>2]=at+1;c[aw+4+(at<<4)>>2]=au;c[aw+4+(at<<4)+4>>2]=0;c[aw+4+(at<<4)+8>>2]=322244;c[aw+4+(at<<4)+12>>2]=T;c[(c[80539]|0)+20>>2]=1;break}else{at=c[X+16>>2]|0;X=at|0;aw=c[X>>2]|0;c[X>>2]=aw+1;c[at+4+(aw<<4)>>2]=0;c[at+4+(aw<<4)+4>>2]=0;c[at+4+(aw<<4)+8>>2]=322244;c[at+4+(aw<<4)+12>>2]=T;break}}}while(0);T=(c[80536]|0)+8|0;do{if((c[80918]|0)==0){c[T>>2]=320;c[(c[80536]|0)+16>>2]=40;c[(c[80536]|0)+24>>2]=c[80892]}else{c[T>>2]=384;c[(c[80536]|0)+16>>2]=48;c[(c[80536]|0)+24>>2]=(c[80892]|0)-32;if((g|0)!=0){break}c[80729]=(c[80729]|0)-(c[80731]<<3);c[80732]=(c[80732]|0)-(c[80734]<<3)}}while(0);g=a[322868]|0;do{if((c[80908]|0)!=0){a[322868]=g;T=((((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0)<<3)-138+(c[80892]|0)|0;au=d[322940+(g&255)|0]|0;if((T|0)<1){c[80552]=au;break}aw=c[80539]|0;if((c[c[80536]>>2]|0)>(T|0)){at=c[aw+8>>2]|0;X=at|0;av=c[X>>2]|0;c[X>>2]=av+1;c[at+4+(av<<4)>>2]=T;c[at+4+(av<<4)+4>>2]=0;c[at+4+(av<<4)+8>>2]=322208;c[at+4+(av<<4)+12>>2]=au;c[(c[80539]|0)+20>>2]=1;break}else{av=c[aw+16>>2]|0;aw=av|0;at=c[aw>>2]|0;c[aw>>2]=at+1;c[av+4+(at<<4)>>2]=0;c[av+4+(at<<4)+4>>2]=0;c[av+4+(at<<4)+8>>2]=322208;c[av+4+(at<<4)+12>>2]=au;break}}}while(0);pZ(a[322869]|0);p_(34,a[322870]|0);p_(35,a[322871]|0);p_(36,a[322872]|0);ps(f);pt(f);return};case 61:{if((c[80914]|0)==0){return}a[322897]=e&31;pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return};case 63:{if((c[80915]|0)!=0){return}f=e&255;c[80914]=f&1;c[80915]=f>>>1&1;a[322899]=e;return};case 64:{if((c[80914]|0)==0){return}a[322900]=e;return};case 68:{if((c[80914]|0)==0){return}a[322904]=e;f=e&255;g=f&127;c[80800]=0;if(g>>>0<65>>>0){au=c[80894]|0;if((au|0)==63&g>>>0>53>>>0){if((f&126|0)==54){c[80800]=1}ax=g-2|0}else{ax=g}c[80799]=(ax+1|0)%(au|0)|0}else{c[80800]=1}pP(c[80802]|0);return};case 69:{if((c[80914]|0)==0){return}a[322905]=e&31;c[80921]=719208+(d[322891]<<18&1835008|d[322890]<<10);pt(((c[198580]|0)>>>0)%((c[80894]|0)>>>0)|0);return};case 70:{if((c[80914]|0)==0){return}a[322906]=e;c[80731]=e&255;return};case 71:{if((c[80914]|0)==0){return}a[322907]=e;c[80733]=c[80733]&65280|e&255;return};case 72:{if((c[80914]|0)==0){return}au=e&15;a[322908]=au&255;c[80733]=c[80733]&255|au<<8;return};case 73:{if((c[80914]|0)==0){return}a[322909]=e;return};case 74:{if((c[80914]|0)==0){return}a[322910]=e;return};case 75:{if((c[80914]|0)==0){return}a[322911]=e&31;return};case 76:{if((c[80914]|0)==0){return}a[322912]=e;c[80734]=e&255;return};case 77:{if((c[80914]|0)==0){return}a[322913]=e&31;return};default:{return}}}function p0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=((c[80914]|0)==0?63:127)&b;pn(0);b=d&65535;switch(b|0){case 21:{e=a[322857]|0;return e|0};case 20:{e=c[80855]&255;return e|0};case 17:case 18:{f=c[198580]|0;g=c[80894]|0;h=c[80885]|0;i=(((f>>>0)/(g>>>0)|0)>>>0)%(h>>>0)|0;if((i|0)==0){j=((f>>>0)%(g>>>0)|0|0)==0?h-1|0:0}else{j=i}if(d<<16>>16==17){k=(a[322853]&127|j>>>1&128)&255}else{k=j&255}a[323644]=k;e=k;return e|0};case 16:{e=a[322852]|0;return e|0};case 1:case 3:case 5:case 7:case 9:case 11:case 13:case 15:{e=a[322836+b|0]|0;return e|0};case 19:{e=c[80854]&255;return e|0};case 0:case 2:case 4:case 6:case 8:case 10:case 12:case 14:{e=a[322836+b|0]|0;return e|0};case 31:{if((c[80908]|0)==0){pL()}if((c[80524]|0)==0){l=0}else{k=a[323349]|0;a[322867]=k;l=k}a[323349]=0;e=l;return e|0};case 32:{l=a[322868]|0;e=(c[80908]|0)!=0?l:l|-16;return e|0};case 22:{e=a[322858]|-64;return e|0};case 37:case 38:{e=a[322836+b|0]|-16;return e|0};case 39:case 40:case 41:case 42:case 43:case 44:case 45:case 46:{e=a[322836+b|0]|-16;return e|0};case 33:case 34:case 35:case 36:{l=a[322836+b|0]|0;e=(c[80908]|0)!=0?l:l|-16;return e|0};case 48:{e=(c[80907]|0)==0?-1:a[322884]|0;return e|0};case 68:{l=c[80894]|0;b=(((c[198580]|0)-1|0)>>>0)%(l>>>0)|0;if((l|0)==63){m=b>>>0>53>>>0?2:0}else{m=0}e=(m+b|128)&255;return e|0};case 23:{e=a[322859]|0;return e|0};case 47:{return((c[80907]|0)==0?-1:a[322883]|0)|0};case 26:{e=a[322862]|-16;return e|0};case 28:{e=a[322864]|0;return e|0};case 25:{b=c[198580]|0;m=c[80882]|0;do{if((m|0)==-1|((((b>>>0)/((c[80894]|0)>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0|0)!=(c[80802]|0)|b>>>0<m>>>0){l=(c[80801]|112)&255;a[323644]=l;n=l}else{l=c[80801]|0;if((a[322862]&1)==0){k=(l|113)&255;a[323644]=k;n=k;break}else{k=(l|241)&255;a[323644]=k;n=k;break}}}while(0);if((c[80908]|0)==0){e=n;return e|0}e=((n&15)!=0?-128:0)|n;return e|0};case 27:{e=a[322863]|0;return e|0};case 24:{e=a[322860]|1;return e|0};case 29:{e=a[322865]|0;return e|0};case 30:{if((c[80908]|0)==0){pN()}if((c[80523]|0)==0){o=0}else{n=a[323348]|0;a[322866]=n;o=n}a[323348]=0;e=o;return e|0};default:{e=-1;return e|0}}return 0}function p1(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=(c[80908]|0)==0;f=(e?63:127)&b;b=f&65535;switch(b|0){case 25:{g=c[198580]|0;h=c[80882]|0;if((h|0)==-1|((((g>>>0)/((c[80894]|0)>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0|0)!=(c[80802]|0)|g>>>0<h>>>0){h=c[80801]|0;if(e){i=112}else{i=(h&15|0)!=0?240:112}j=(i|h)&255;return j|0}h=c[80801]|0;if((a[322862]&1)!=0){j=(h|241)&255;return j|0}if(e){k=113}else{k=(h&15|0)!=0?241:113}j=(k|h)&255;return j|0};case 18:{h=c[198580]|0;k=c[80894]|0;i=c[80885]|0;g=(((h>>>0)/(k>>>0)|0)>>>0)%(i>>>0)|0;if((g|0)!=0){j=g&255;return j|0}j=((h>>>0)%(k>>>0)|0|0)==0?i+255&255:0;return j|0};case 30:{j=a[323348]|0;return j|0};case 47:{if((c[80907]|0)==0){j=-1;return j|0}j=a[322883]|-8;return j|0};case 19:{j=c[80854]&255;return j|0};case 20:{j=c[80855]&255;return j|0};case 31:{j=a[323349]|0;return j|0};case 17:{i=c[198580]|0;k=c[80894]|0;h=c[80885]|0;g=(((i>>>0)/(k>>>0)|0)>>>0)%(h>>>0)|0;if((g|0)==0){l=((i>>>0)%(k>>>0)|0|0)==0?h-1|0:0}else{l=g}j=(l>>>1&128|a[322853]&127)&255;return j|0};default:{if(e){j=(d[322836+b|0]|0|c[47488+(b<<2)>>2])&255;return j|0}if((f&65535)>>>0>79>>>0){j=-1;return j|0}j=(d[322836+b|0]|0|c[47168+(b<<2)>>2])&255;return j|0}}return 0}function p2(){var b=0,e=0,f=0,g=0;b=c[198580]|0;e=c[80894]|0;f=(b>>>0)%(e>>>0)|0;if((e|0)==65){switch(f|0){case 7:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1023)+(c[80857]|0))|0]|0;return g|0};case 8:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 9:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 4:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 5:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1022)+(c[80857]|0))|0]|0;return g|0};case 6:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 61:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 62:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1018)+(c[80857]|0))|0]|0;return g|0};case 63:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 64:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1019)+(c[80857]|0))|0]|0;return g|0};case 10:case 11:case 12:case 13:case 14:{g=a[(c[80803]|0)+((c[80857]|0)+16128+(265-f+(((((b>>>0)/65|0)>>>0)%((c[80885]|0)>>>0)|0)*-5|0)&255))|0]|0;return g|0};case 55:case 56:case 57:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 58:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1016)+(c[80857]|0))|0]|0;return g|0};case 59:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 60:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1017)+(c[80857]|0))|0]|0;return g|0};case 1:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1020)+(c[80857]|0))|0]|0;return g|0};case 2:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 3:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1021)+(c[80857]|0))|0]|0;return g|0};case 0:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};default:{g=p4(f-15|0)|0;return g|0}}}else if((e|0)==64){switch(f|0){case 58:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1016)+(c[80857]|0))|0]|0;return g|0};case 55:case 56:case 57:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 5:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 62:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1018)+(c[80857]|0))|0]|0;return g|0};case 63:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 9:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 7:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 8:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1023)+(c[80857]|0))|0]|0;return g|0};case 10:case 11:case 12:case 13:case 14:{g=a[(c[80803]|0)+((c[80857]|0)+16128+(265-f+(((b>>>6>>>0)%((c[80885]|0)>>>0)|0)*-5|0)&255))|0]|0;return g|0};case 6:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1022)+(c[80857]|0))|0]|0;return g|0};case 59:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 60:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1017)+(c[80857]|0))|0]|0;return g|0};case 1:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 2:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1020)+(c[80857]|0))|0]|0;return g|0};case 61:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 0:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1019)+(c[80857]|0))|0]|0;return g|0};case 4:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1021)+(c[80857]|0))|0]|0;return g|0};case 3:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};default:{g=p4(f-15|0)|0;return g|0}}}else{switch(f|0){case 58:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 9:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 3:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 2:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1020)+(c[80857]|0))|0]|0;return g|0};case 5:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 1:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 57:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1016)+(c[80857]|0))|0]|0;return g|0};case 8:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1023)+(c[80857]|0))|0]|0;return g|0};case 0:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1019)+(c[80857]|0))|0]|0;return g|0};case 7:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 6:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1022)+(c[80857]|0))|0]|0;return g|0};case 59:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1017)+(c[80857]|0))|0]|0;return g|0};case 4:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1021)+(c[80857]|0))|0]|0;return g|0};case 10:case 11:case 12:case 13:case 14:{g=a[(c[80803]|0)+((c[80857]|0)+16128+(265-f+(((((b>>>0)/(e>>>0)|0)>>>0)%((c[80885]|0)>>>0)|0)*-5|0)&255))|0]|0;return g|0};case 61:{g=a[(c[80803]|0)+(((d[322860]|0)<<6|1018)+(c[80857]|0))|0]|0;return g|0};case 55:case 56:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 62:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};case 60:{g=a[(c[80803]|0)+((c[80857]|0)+16383)|0]|0;return g|0};default:{g=p4(f-15|0)|0;return g|0}}}return 0}function p3(){pn(0);return p2()|0}function p4(b){b=b|0;var e=0,f=0,g=0;L2839:do{switch(c[80570]|0){case 4:case 5:{if((c[80842]|0)==0){e=(c[80810]|0)+(((d[323264+b|0]|0)<<3&504)+(c[80569]|0))|0;break L2839}else{e=(c[80803]|0)+((c[80857]|0)+14847)|0;break L2839}break};case 6:case 7:{if((c[80842]|0)!=0){e=(c[80803]|0)+((c[80857]|0)+14847)|0;break L2839}f=(c[80569]|0)+(b<<3)+(c[80845]<<3)|0;g=f&2559;if((f&4096|0)==0){e=(c[80811]|0)+g|0;break L2839}else{e=(c[80812]|0)+g|0;break L2839}break};case 2:case 3:{if((c[80842]|0)!=0){e=(c[80803]|0)+((c[80857]|0)+16383)|0;break L2839}g=(c[80569]|0)+(b<<3)+(c[80845]<<3)|0;f=g&4095;if((g&4096|0)==0){e=(c[80811]|0)+f|0;break L2839}else{e=(c[80812]|0)+f|0;break L2839}break};case 0:case 1:{if((c[80842]|0)==0){e=(c[80810]|0)+(((d[323264+b|0]|0)<<3)+(c[80569]|0))|0;break L2839}else{e=(c[80803]|0)+((c[80857]|0)+16383)|0;break L2839}break};default:{e=(c[80803]|0)+((c[80857]|0)+16383)|0}}}while(0);return a[e]|0}function p5(){var a=0;c[80482]=1;c[80483]=1;c[80484]=0;c[80485]=0;c[80486]=1;c[80487]=1;c[80488]=1;c[80489]=1;c[80492]=86816;c[80490]=1;c[80491]=0;c[80493]=1;c[80494]=1;c[80495]=1;c[80496]=2;c[80497]=2;c[80498]=2;fv(321996);c[80912]=321928;if((nT(88824,322140,321928)|0)<0){a=-1;return a|0}a=h1(50504)|0;return a|0}function p6(a,b){a=a|0;b=b|0;var d=0;b=i;i=i+8|0;d=b|0;if((ic(79528,d)|0)<0){c[d>>2]=-1}if((c[80522]|0)==(a|0)){i=b;return 0}c[80522]=a;kS(c[d>>2]^a<<12);i=b;return 0}function p7(a,b){a=a|0;b=b|0;c[80523]=a;return 0}function p8(a,b){a=a|0;b=b|0;c[80524]=a;return 0}function p9(a,b){a=a|0;b=b|0;c[80525]=a;return pD(c[80540]|0)|0}function qa(){var d=0,e=0,f=0,g=0;d=0;e=0;while(1){a[794e3+d|0]=(d<<1&170|d|d>>>1&85)&255;b[323832+(d<<1)>>1]=e;f=e+1&65535;g=d+1|0;if(g>>>0<256>>>0){d=g;e=f<<1&-21846|f}else{break}}n$(c[80538]|0,142);n0(c[80538]|0,218);n1(c[80538]|0,40);return}function qb(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[80536]|0;e=(c[80892]|0)-136+(c[d+44>>2]|0)|0;qd(a,b,e,(c[d>>2]|0)-1+e|0);return}function qc(b){b=b|0;a[323348]=a[323348]|a[b+336|0];a[323349]=a[323349]|a[b+337|0];return}function qd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=c[80538]|0;do{if((a[g+21|0]|0)==0){if((a[g+22|0]|0)!=0){break}return}}while(0);h=g+4|0;i=0;do{j=c[h>>2]|0;k=c[j+(i*56|0)>>2]|0;l=c[80897]|0;do{if((k|0)<(l|0)){m=(c[j+(i*56|0)+16>>2]|0)+k|0;n=e-m|0;o=f-m|0;do{if((o|0)>-1){if((n|0)>=((c[80892]|0)-1+((c[j+(i*56|0)+8>>2]|0)!=0?24:0)|0)){p=l;break}qk(b,d,n,o,g,i,m);p=c[80897]|0}else{p=l}}while(0);q=p+n|0;r=p+o|0;if((r|0)<=-1){break}if((q|0)>=((c[80892]|0)-1+((c[(c[h>>2]|0)+(i*56|0)+8>>2]|0)!=0?24:0)|0)){break}qk(b,d,q,r,g,i,m-p|0)}}while(0);c[(c[h>>2]|0)+(i*56|0)+28>>2]=0;i=i+1|0;}while((i|0)<8);a[323348]=a[323348]|a[g+32|0];a[323349]=a[323349]|a[g+33|0];return}function qe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=c[80892]|0;f=e-24|0;g=c[80897]|0;if((g|0)>512&b>>>0>391>>>0){h=b-512+g|0}else{h=b}b=h+f|0;h=(a<<4)+342|0;i=h+e|0;j=((b-i+g|0)>>>0)%(g>>>0)|0;k=(c[(c[80538]|0)+4>>2]|0)+(a*56|0)|0;a=c[k>>2]|0;l=g<<1;m=d+8|0;d=((m-i+l|0)>>>0)%(g>>>0)|0;n=(a|0)==(g|0)?g:((l-i+a|0)>>>0)%(g>>>0)|0;if((b|0)<(e-136+g|0)){o=b}else{o=(b|0)<(g+f|0)?b-g|0:g}do{if((j|0)<(n|0)){if((d|0)<=(j|0)){if((m|0)<=(o|0)){c[k>>2]=o;break}b=c[80536]|0;if((i|0)<(-(c[b+44>>2]|0)|0)){c[k>>2]=o;break}f=c[80539]|0;if(((c[b+48>>2]|0)+(c[b>>2]|0)|0)<=(i|0)){b=c[f+16>>2]|0;e=b|0;l=c[e>>2]|0;c[e>>2]=l+1;c[b+4+(l<<4)>>2]=0;c[b+4+(l<<4)+4>>2]=0;c[b+4+(l<<4)+8>>2]=k;c[b+4+(l<<4)+12>>2]=o;break}l=c[f+12>>2]|0;f=l|0;b=c[f>>2]|0;e=b;while(1){p=e-1|0;if((p|0)<=-1){break}if((c[l+4+(p<<4)>>2]|0)>(i|0)){e=p}else{break}}q=b-1|0;if((q|0)>(p|0)){r=b;s=q;while(1){q=l+4+(r<<4)|0;t=l+4+(s<<4)|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];t=s-1|0;if((t|0)>(p|0)){r=s;s=t}else{break}}u=c[f>>2]|0}else{u=b}c[f>>2]=u+1;c[l+4+(e<<4)>>2]=i;c[l+4+(e<<4)+4>>2]=0;c[l+4+(e<<4)+8>>2]=k;c[l+4+(e<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1;break}if((d|0)<=(n|0)){c[k>>2]=g;break}if((m|0)<(o|0)&(a|0)>(m|0)){c[k>>2]=o;break}s=c[80536]|0;if((i|0)<(-(c[s+44>>2]|0)|0)){c[k>>2]=o;break}r=c[80539]|0;if(((c[s+48>>2]|0)+(c[s>>2]|0)|0)<=(i|0)){s=c[r+16>>2]|0;t=s|0;q=c[t>>2]|0;c[t>>2]=q+1;c[s+4+(q<<4)>>2]=0;c[s+4+(q<<4)+4>>2]=0;c[s+4+(q<<4)+8>>2]=k;c[s+4+(q<<4)+12>>2]=o;break}q=c[r+12>>2]|0;r=q|0;s=c[r>>2]|0;t=s;while(1){v=t-1|0;if((v|0)<=-1){break}if((c[q+4+(v<<4)>>2]|0)>(i|0)){t=v}else{break}}e=s-1|0;if((e|0)>(v|0)){l=s;f=e;while(1){e=q+4+(l<<4)|0;b=q+4+(f<<4)|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=f-1|0;if((b|0)>(v|0)){l=f;f=b}else{break}}w=c[r>>2]|0}else{w=s}c[r>>2]=w+1;c[q+4+(t<<4)>>2]=i;c[q+4+(t<<4)+4>>2]=0;c[q+4+(t<<4)+8>>2]=k;c[q+4+(t<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1}else{if((d|0)<=(n|0)){if((m|0)<=(o|0)){c[k>>2]=o;break}f=c[80536]|0;if((i|0)<(-(c[f+44>>2]|0)|0)){c[k>>2]=o;break}l=c[80539]|0;if(((c[f+48>>2]|0)+(c[f>>2]|0)|0)<=(i|0)){f=c[l+16>>2]|0;b=f|0;e=c[b>>2]|0;c[b>>2]=e+1;c[f+4+(e<<4)>>2]=0;c[f+4+(e<<4)+4>>2]=0;c[f+4+(e<<4)+8>>2]=k;c[f+4+(e<<4)+12>>2]=o;break}e=c[l+12>>2]|0;l=e|0;f=c[l>>2]|0;b=f;while(1){x=b-1|0;if((x|0)<=-1){break}if((c[e+4+(x<<4)>>2]|0)>(i|0)){b=x}else{break}}t=f-1|0;if((t|0)>(x|0)){q=f;r=t;while(1){t=e+4+(q<<4)|0;s=e+4+(r<<4)|0;c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];c[t+12>>2]=c[s+12>>2];s=r-1|0;if((s|0)>(x|0)){q=r;r=s}else{break}}y=c[l>>2]|0}else{y=f}c[l>>2]=y+1;c[e+4+(b<<4)>>2]=i;c[e+4+(b<<4)+4>>2]=0;c[e+4+(b<<4)+8>>2]=k;c[e+4+(b<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1;break}if((d|0)<(j|0)){break}if((m|0)<(a|0)&(o|0)>(m|0)){c[k>>2]=o;break}r=c[80536]|0;if((i|0)<(-(c[r+44>>2]|0)|0)){c[k>>2]=o;break}q=c[80539]|0;if(((c[r+48>>2]|0)+(c[r>>2]|0)|0)<=(i|0)){r=c[q+16>>2]|0;s=r|0;t=c[s>>2]|0;c[s>>2]=t+1;c[r+4+(t<<4)>>2]=0;c[r+4+(t<<4)+4>>2]=0;c[r+4+(t<<4)+8>>2]=k;c[r+4+(t<<4)+12>>2]=o;break}t=c[q+12>>2]|0;q=t|0;r=c[q>>2]|0;s=r;while(1){z=s-1|0;if((z|0)<=-1){break}if((c[t+4+(z<<4)>>2]|0)>(i|0)){s=z}else{break}}b=r-1|0;if((b|0)>(z|0)){e=r;l=b;while(1){b=t+4+(e<<4)|0;f=t+4+(l<<4)|0;c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];f=l-1|0;if((f|0)>(z|0)){e=l;l=f}else{break}}A=c[q>>2]|0}else{A=r}c[q>>2]=A+1;c[t+4+(s<<4)>>2]=i;c[t+4+(s<<4)+4>>2]=0;c[t+4+(s<<4)+8>>2]=k;c[t+4+(s<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1}}while(0);i=h+(c[80892]|0)|0;h=c[80536]|0;if((i|0)<(-(c[h+44>>2]|0)|0)){c[k>>2]=o;return}A=c[80539]|0;if(((c[h+48>>2]|0)+(c[h>>2]|0)|0)<=(i|0)){h=c[A+16>>2]|0;z=h|0;m=c[z>>2]|0;c[z>>2]=m+1;c[h+4+(m<<4)>>2]=0;c[h+4+(m<<4)+4>>2]=0;c[h+4+(m<<4)+8>>2]=k;c[h+4+(m<<4)+12>>2]=o;return}m=c[A+12>>2]|0;A=m|0;h=c[A>>2]|0;z=h;while(1){B=z-1|0;if((B|0)<=-1){break}if((c[m+4+(B<<4)>>2]|0)>(i|0)){z=B}else{break}}a=h-1|0;if((a|0)>(B|0)){j=h;d=a;while(1){a=m+4+(j<<4)|0;y=m+4+(d<<4)|0;c[a>>2]=c[y>>2];c[a+4>>2]=c[y+4>>2];c[a+8>>2]=c[y+8>>2];c[a+12>>2]=c[y+12>>2];y=d-1|0;if((y|0)>(B|0)){j=d;d=y}else{break}}C=c[A>>2]|0}else{C=h}c[A>>2]=C+1;c[m+4+(z<<4)>>2]=i;c[m+4+(z<<4)+4>>2]=0;c[m+4+(z<<4)+8>>2]=k;c[m+4+(z<<4)+12>>2]=o;c[(c[80539]|0)+20>>2]=1;return}function qf(){return(c[80892]|0)-24|0}function qg(){c[(c[(c[80538]|0)+4>>2]|0)+16>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+20>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+28>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+72>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+76>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+84>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+128>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+132>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+140>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+184>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+188>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+196>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+240>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+244>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+252>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+296>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+300>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+308>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+352>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+356>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+364>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+408>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+412>>2]=0;c[(c[(c[80538]|0)+4>>2]|0)+420>>2]=0;a[(c[80538]|0)+32|0]=0;a[(c[80538]|0)+33|0]=0;return}function qh(){A2(c[80956]|0,0,c[80897]|0);return}function qi(){c[80956]=hi(c[80956]|0,c[80897]|0)|0;return}function qj(){hj(c[80956]|0);return}function qk(b,f,g,h,j,k,l){b=b|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0;m=i;i=i+16|0;n=m|0;o=1<<k;p=((d[j+21|0]|0)&o|0)==0;do{if(p){q=2327}else{r=c[80892]|0;if((r+332|0)<=(l|0)){q=2327;break}s=(c[j+44>>2]|0)+(k<<2)|0;t=r}}while(0);do{if((q|0)==2327){if(((d[j+22|0]|0)&o|0)==0){i=m;return}L3029:do{if(((c[80892]|0)+332|0)>(l|0)){u=0}else{r=(c[j+44>>2]|0)+(k<<2)|0;if(!p){u=r;break}a[r]=-1;a[r+2|0]=-1;v=c[80903]|0;L3032:do{if((v|0)!=0){w=c[80894]|0;x=(((k<<1)+57|0)>>>0)%(w>>>0)|0;y=c[80904]|0;z=c[80885]|0;A=c[80551]|0;B=v;while(1){B=B-1|0;C=c[y+(B<<3)>>2]|0;if(((((C>>>0)/(w>>>0)|0)>>>0)%(z>>>0)|0)>>>0<=A>>>0){if(((C>>>0)%(w>>>0)|0)>>>0<=x>>>0){break}}if((B|0)==0){break L3032}}a[r+1|0]=a[y+(B<<3)+4|0]|0;u=r;break L3029}}while(0);v=c[80905]|0;L3041:do{if((v|0)!=0){x=c[80894]|0;w=(((k<<1)+57|0)>>>0)%(x>>>0)|0;A=c[80906]|0;z=c[80885]|0;C=c[80551]|0;D=v;while(1){D=D-1|0;E=c[A+(D<<3)>>2]|0;if(((((E>>>0)/(x>>>0)|0)>>>0)%(z>>>0)|0)>>>0<=C>>>0){if(((E>>>0)%(x>>>0)|0)>>>0<=w>>>0){break}}if((D|0)==0){break L3041}}a[r+1|0]=a[A+(D<<3)+4|0]|0;u=r;break L3029}}while(0);a[r+1|0]=a[(c[80804]|0)+((c[80858]|0)+16383)|0]|0;u=r}}while(0);v=c[80892]|0;if(((k<<4)+342+v|0)>=(l|0)){s=u;t=v;break}s=(c[j+48>>2]|0)+(k<<2)|0;t=v}}while(0);if((s|0)==0){i=m;return}u=c[80546]|0;p=(l+192-t-u|0)/8|0;v=f+p|0;w=b+l|0;x=l-u&7;u=c[80956]|0;C=136-t+l|0;z=u+C|0;B=j+4|0;y=c[B>>2]|0;if((c[y+(k*56|0)+24>>2]|0)==0){if((c[y+(k*56|0)+8>>2]|0)==0){E=c[80897]|0;F=(E+(c[y+(k*56|0)>>2]|0)|0)%(E|0)|0;G=(d[s+1|0]|0)<<8|(d[s]|0)<<16|(d[s+2|0]|0);H=(E|0)<512;E=t+(k<<4)|0;do{if((F|0)>(E+(H?306:314)|0)){I=E+(H?343:351)|0;if((F|0)>=(I|0)){J=G;K=24;break}L=I+(-12-F)|0;if((L|0)<=0){J=G;K=L;break}I=G>>>((24-L|0)>>>0);M=I&1;J=((((((I<<1|M)<<1|M)<<1|M)<<1|M)<<1|M)<<1|M)<<1|M;K=L+7|0}else{J=G;K=24}}while(0);G=(((d[f+(p+2)|0]|0)<<16|(d[f+(p+1)|0]|0)<<24|(d[f+(p+3)|0]|0)<<8|(d[f+(p+4)|0]|0))<<x|(d[f+(p+5)|0]|0)>>>((8-x|0)>>>0))>>>((32-K|0)>>>0);F=h+1|0;H=((F|0)<(K|0)?F:K)-((g|0)<0?0:g)|0;do{if((H|0)>0){F=0;E=0;do{F=F<<1|1;E=E+1|0;}while((E|0)<(H|0));E=K+~h|0;if((E|0)>0){N=F;O=0}else{P=F;break}while(1){L=N<<1;M=O+1|0;if((M|0)<(E|0)){N=L;O=M}else{P=L;break}}}else{P=0}}while(0);O=P&J;N=P&G;if((N&J|0)!=0){J=j+33|0;a[J]=(d[J]|0|o)&255}J=1<<K-1;G=(K|0)>0;if((c[y+(k*56|0)+32>>2]|0)==0){if(G){Q=0;R=J;S=0}else{i=m;return}while(1){if((R&O|0)==0){T=Q}else{P=u+(S+C)|0;H=a[P]|0;if(H<<24>>24==0){a[b+(S+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;U=a[P]|0}else{U=H}a[P]=(U&255|o)&255;T=U|Q}P=S+1|0;if((P|0)<(K|0)){Q=T;R=R>>>1;S=P}else{V=T;break}}}else{if(G){W=0;X=J;Y=0}else{i=m;return}while(1){do{if((X&O|0)==0){Z=W}else{J=u+(Y+C)|0;G=a[J]|0;if((X&N|0)!=0){a[J]=(G&255|o)&255;Z=G|W;break}if(G<<24>>24==0){a[b+(Y+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;_=a[J]|0}else{_=G}a[J]=(_&255|o)&255;Z=_|W}}while(0);J=Y+1|0;if((J|0)<(K|0)){W=Z;X=X>>>1;Y=J}else{V=Z;break}}}if(V<<24>>24==0){i=m;return}Z=j+32|0;a[Z]=(V&255|o|(d[Z]|0))&255;i=m;return}Z=257<<k;V=c[80897]|0;Y=(V+(c[y+(k*56|0)>>2]|0)|0)%(V|0)|0;X=e[323832+((d[s+1|0]|0)<<1)>>1]|0|(e[323832+((d[s]|0)<<1)>>1]|0)<<16;W=(V|0)<512;V=t+(k<<4)|0;do{if((Y|0)>(V+(W?282:290)|0)){K=V+(W?343:351)|0;if((Y|0)>=(K|0)){$=X;aa=0;ab=0;ac=0;ad=32;ae=48;break}_=K+(-12-Y)|0;N=(_|0)>0|0;O=(_|0)<32;if((_-1|0)>>>0>=32>>>0){$=X;aa=0;ab=N;ac=0;ad=O?_:32;ae=_;break}J=X>>>((32-_|0)>>>0);G=J&1;if(O){O=K+(-44-Y)|0;K=_;T=0;S=J;do{S=S<<1|G;K=K+1|0;T=T+1|0;}while((T|0)<7&(K|0)<32);K=O>>>0>4294967289>>>0?-O|0:7;af=K+_|0;ag=K;ah=S}else{af=32;ag=0;ah=J}$=ah;aa=G;ab=N;ac=7-ag|0;ad=af;ae=_}else{$=X;aa=0;ab=0;ac=0;ad=32;ae=48}}while(0);X=f+(p+5)|0;af=8-x|0;ag=(((d[f+(p+2)|0]|0)<<16|(d[f+(p+1)|0]|0)<<24|(d[f+(p+3)|0]|0)<<8|(d[f+(p+4)|0]|0))<<x|(d[X]|0)>>>(af>>>0))>>>((32-ad|0)>>>0);ah=h+1|0;Y=((ah|0)<(ad|0)?ah:ad)-((g|0)<0?0:g)|0;do{if((Y|0)>0){ah=0;W=0;do{ah=ah<<1|1;W=W+1|0;}while((W|0)<(Y|0));W=ad+~h|0;if((W|0)>0){ai=ah;aj=0}else{ak=ah;break}while(1){_=ai<<1;N=aj+1|0;if((N|0)<(W|0)){ai=_;aj=N}else{ak=_;break}}}else{ak=0}}while(0);aj=ak&$;ai=ak&ag;if((ai&$|0)!=0){$=j+33|0;a[$]=(d[$]|0|Z)&255}$=1<<ad-1;ag=(ad|0)>0;do{if((c[y+(k*56|0)+32>>2]|0)==0){if(ag){al=0;am=$;an=0}else{ao=0;break}while(1){if((am&aj|0)==0){ap=al}else{ak=u+(an+C)|0;Y=a[ak]|0;if(Y<<24>>24==0){a[b+(an+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;aq=a[ak]|0}else{aq=Y}Y=aq&255;a[ak]=(Y|Z)&255;ap=(Y|al&65535)&65535}Y=an+1|0;if((Y|0)<(ad|0)){al=ap;am=am>>>1;an=Y}else{ao=ap;break}}}else{if(ag){ar=0;as=$;at=0}else{ao=0;break}while(1){do{if((as&aj|0)==0){au=ar}else{Y=u+(at+C)|0;ak=a[Y]|0;W=ak&255;if((as&ai|0)!=0){a[Y]=(W|Z)&255;au=(W|ar&65535)&65535;break}if(ak<<24>>24==0){a[b+(at+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;av=a[Y]|0}else{av=ak}ak=av&255;a[Y]=(ak|Z)&255;au=(ak|ar&65535)&65535}}while(0);r=at+1|0;if((r|0)<(ad|0)){ar=au;as=as>>>1;at=r}else{ao=au;break}}}}while(0);au=e[323832+((d[s+2|0]|0)<<1)>>1]|0;if((ab|0)==0){aw=au;ax=ae-ad|0}else{if((ae|0)>32){ad=au>>>((48-ae|0)>>>0);ay=ae-32|0;az=7;aA=ad&1;aB=ad;q=2561}else{if((ac|0)>0){ay=0;az=ac;aA=aa;aB=au;q=2561}else{aC=au;aD=0;aE=ac}}if((q|0)==2561){q=0;ac=aB;while(1){aB=ac<<1|aA;au=q+1|0;if((au|0)<(az|0)){q=au;ac=aB}else{aC=aB;aD=ay;aE=az;break}}}aw=aC;ax=aD+aE|0}aE=(((d[f+(p+6)|0]|0)<<8|(d[X]|0)<<16|(d[f+(p+7)|0]|0))<<x|(d[f+(p+8)|0]|0)>>>(af>>>0))>>>((24-ax|0)>>>0);af=g-32|0;X=h-31|0;aD=((X|0)<(ax|0)?X:ax)-((af|0)<0?0:af)|0;do{if((aD|0)>0){af=0;X=0;do{af=af<<1|1;X=X+1|0;}while((X|0)<(aD|0));X=ax+(31-h)|0;if((X|0)>0){aF=af;aG=0}else{aH=af;break}while(1){aC=aF<<1;az=aG+1|0;if((az|0)<(X|0)){aF=aC;aG=az}else{aH=aC;break}}}else{aH=0}}while(0);aG=aH&aw;aF=aH&aE;if((aF&aw|0)!=0){aw=j+33|0;a[aw]=(d[aw]|0|Z)&255}aw=1<<ax-1;aE=(ax|0)>0;do{if((c[(c[B>>2]|0)+(k*56|0)+32>>2]|0)==0){if(aE){aI=ao;aJ=aw;aK=0}else{aL=ao;break}while(1){if((aJ&aG|0)==0){aM=aI}else{aH=aK+32|0;aD=u+(aH+C)|0;X=a[aD]|0;if(X<<24>>24==0){a[b+(aH+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;aN=a[aD]|0}else{aN=X}X=aN&255;a[aD]=(X|Z)&255;aM=(X|aI&65535)&65535}X=aK+1|0;if((X|0)<(ax|0)){aI=aM;aJ=aJ>>>1;aK=X}else{aL=aM;break}}}else{if(aE){aO=ao;aP=aw;aQ=0}else{aL=ao;break}while(1){do{if((aP&aG|0)==0){aR=aO}else{X=aQ+32|0;aD=u+(X+C)|0;aH=a[aD]|0;af=aH&255;if((aP&aF|0)!=0){a[aD]=(af|Z)&255;aR=(af|aO&65535)&65535;break}if(aH<<24>>24==0){a[b+(X+l)|0]=c[(c[B>>2]|0)+(k*56|0)+36>>2]&255;aS=a[aD]|0}else{aS=aH}aH=aS&255;a[aD]=(aH|Z)&255;aR=(aH|aO&65535)&65535}}while(0);aH=aQ+1|0;if((aH|0)<(ax|0)){aO=aR;aP=aP>>>1;aQ=aH}else{aL=aR;break}}}}while(0);if(aL<<16>>16==0){i=m;return}aR=aL&65535;aL=j+32|0;a[aL]=(aR|Z|aR>>>8|(d[aL]|0))&255;i=m;return}c[n+4>>2]=c[j+24>>2];c[n+8>>2]=c[y+(k*56|0)+36>>2];c[n+12>>2]=c[j+28>>2];if((c[y+(k*56|0)+8>>2]|0)==0){aL=a[s]|0;aR=a[s+1|0]|0;Z=a[s+2|0]|0;aQ=c[80897]|0;aP=(aQ+(c[y+(k*56|0)>>2]|0)|0)%(aQ|0)|0;aO=aL&255;ax=aR&255;aS=Z&255;aF=ax<<8|aO<<16|aS;aG=d[f+(p+4)|0]|0;ao=((d[f+(p+1)|0]|0)<<16|(d[v]|0)<<24|(d[f+(p+2)|0]|0)<<8|(d[f+(p+3)|0]|0))<<x|aG>>>((8-x|0)>>>0);if((c[y+(k*56|0)+28>>2]|0)>>>0>1>>>0){aT=b+(l+1)|0;aU=u+(C+1)|0;aV=aF<<1;aW=(d[794e3+(((Z&255)>>>7|aR<<1)&255)|0]|0)<<8|(d[794e3+(((aR&255)>>>7|aL<<1)&255)|0]|0)<<16|(d[794e3+(Z<<1&255)|0]|0);aX=(d[f+(p+6)|0]|0|aG<<8)>>>((x^15)>>>0)|ao<<1;aY=25}else{aT=w;aU=z;aV=aF;aW=(d[794e3+ax|0]|0)<<8|(d[794e3+aO|0]|0)<<16|(d[794e3+aS|0]|0);aX=ao;aY=24}ao=(aQ|0)<512;aQ=k<<4;do{if((aP|0)>((ao?306:314)+aQ+t|0)){aS=(ao?343:351)+aQ+t|0;if((aP|0)>=(aS|0)){aZ=aV;a_=0;a$=0;a0=0;a1=0;break}aO=aS+(-12-aP)|0;aS=(aO|0)<0?0:aO;aO=24-aS|0;ax=aV>>>(aO>>>0);aZ=ax<<aO;a_=ax&3;a$=aS;a0=aS&1;a1=(aS|0)>0|0}else{aZ=aV;a_=0;a$=0;a0=0;a1=0}}while(0);aV=h+1|0;aP=((aV|0)<(aY|0)?aV:aY)-((g|0)<0?0:g)|0;do{if((aP|0)>0){aV=0;aQ=0;do{aV=aV<<1|1;aQ=aQ+1|0;}while((aQ|0)<(aP|0));aQ=aY+~h|0;if((aQ|0)>0){a2=aV;a3=0}else{a4=aV;break}while(1){ao=a2<<1;aS=a3+1|0;if((aS|0)<(aQ|0)){a2=ao;a3=aS}else{a4=ao;break}}}else{a4=0}}while(0);a3=a4&aX;if((a3&aW|0)!=0){aW=j+33|0;a[aW]=(d[aW]|0|o)&255}if((c[y+(k*56|0)+32>>2]|0)==0){aW=0;aX=a4;a2=aZ;aY=0;while(1){aP=a2>>>22&3;do{if(aP<<24>>24==0){a5=aW}else{aQ=aX>>>22;if((aQ&2|0)==0){a6=aW}else{aV=aU+aY|0;ao=a[aV]|0;if(ao<<24>>24==0){a[aT+aY|0]=c[n+((aP&255)<<2)>>2]&255;a7=a[aV]|0}else{a7=ao}a[aV]=(a7&255|o)&255;a6=a7|aW}if((aQ&1|0)==0){a5=a6;break}aQ=aY|1;aV=aU+aQ|0;ao=a[aV]|0;if(ao<<24>>24==0){a[aT+aQ|0]=c[n+((aP&255)<<2)>>2]&255;a8=a[aV]|0}else{a8=ao}a[aV]=(a8&255|o)&255;a5=a8|a6}}while(0);aP=aY+2|0;if((aP|0)<24){aW=a5;aX=aX<<2;a2=a2<<2;aY=aP}else{a9=a5;break}}}else{a5=0;aY=a4;a4=8388608;a2=0;aX=aZ;while(1){aZ=aX>>>22&3;do{if(aZ<<24>>24==0){ba=a5}else{aW=aY>>>22;do{if((aW&2|0)==0){bb=a5}else{a6=aU+a2|0;a8=a[a6]|0;if((a4&a3|0)!=0){a[a6]=(a8&255|o)&255;bb=a8|a5;break}if(a8<<24>>24==0){a[aT+a2|0]=c[n+((aZ&255)<<2)>>2]&255;bc=a[a6]|0}else{bc=a8}a[a6]=(bc&255|o)&255;bb=bc|a5}}while(0);if((aW&1|0)==0){ba=bb;break}a6=a2|1;a8=aU+a6|0;a7=a[a8]|0;if((a4>>>1&a3|0)!=0){a[a8]=(a7&255|o)&255;ba=a7|bb;break}if(a7<<24>>24==0){a[aT+a6|0]=c[n+((aZ&255)<<2)>>2]&255;bd=a[a8]|0}else{bd=a7}a[a8]=(bd&255|o)&255;ba=bd|bb}}while(0);aZ=a2+2|0;if((aZ|0)<24){a5=ba;aY=aY<<2;a4=a4>>>2;a2=aZ;aX=aX<<2}else{a9=ba;break}}}if((a1|0)==0){be=a9}else{if((a0|0)==0){bf=a_}else{bf=a_<<1&2}a_=(bf|0)!=0|0;a1=(((((a_<<1|a_)<<1|a_)<<1|a_)<<1|a_)<<1|a_)<<1|a_;a_=c[n+(bf<<2)>>2]|0;bf=a$+a0|0;a$=h-bf|0;ba=g-bf|0;aX=a$+1|0;a2=a0^7;a0=((aX|0)<(a2|0)?aX:a2)-((ba|0)<0?0:ba)|0;do{if((a0|0)>0){ba=0;aX=0;do{ba=ba<<1|1;aX=aX+1|0;}while((aX|0)<(a0|0));aX=a2-1|0;a4=aX-a$|0;if((a4|0)>0){bg=ba;bh=0}else{bi=ba;bj=aX;break}while(1){aY=bg<<1;a5=bh+1|0;if((a5|0)<(a4|0)){bg=aY;bh=a5}else{bi=aY;bj=aX;break}}}else{bi=0;bj=a2-1|0}}while(0);bh=bi&a1;a1=a_&255;a_=a9;a9=1<<bj;bj=0;while(1){if((bh&a9|0)==0){bk=a_}else{bi=bj+bf|0;bg=aU+bi|0;a$=a[bg]|0;if(a$<<24>>24==0){a[aT+bi|0]=a1;bl=a[bg]|0}else{bl=a$}a[bg]=(bl&255|o)&255;bk=bl|a_}bg=bj+1|0;if((bg|0)<(a2|0)){a_=bk;a9=a9>>>1;bj=bg}else{be=bk;break}}}if(be<<24>>24==0){i=m;return}bk=j+32|0;a[bk]=(be&255|o|(d[bk]|0))&255;i=m;return}bk=c[80897]|0;be=(bk+(c[y+(k*56|0)>>2]|0)|0)%(bk|0)|0;bj=a[s]|0;a9=bj&255;a_=a[s+1|0]|0;a2=a_&255;bl=s+2|0;s=a2<<8|a9<<16|(d[bl]|0);a1=f+(p+5)|0;aT=d[a1]|0;aU=8-x|0;bf=((d[f+(p+2)|0]|0)<<16|(d[f+(p+1)|0]|0)<<24|(d[f+(p+3)|0]|0)<<8|(d[f+(p+4)|0]|0))<<x|aT>>>(aU>>>0);bh=c[y+(k*56|0)+28>>2]|0;bg=bh>>1;a$=(bg|0)!=0;if(a$){bm=b+(l+2)|0;bn=u+(C+2)|0;bo=s<<1;bp=e[323832+((d[794e3+(a_<<1&255)|0]|0)<<1)>>1]|0|(e[323832+((d[794e3+(((a_&255)>>>7|bj<<1)&255)|0]|0)<<1)>>1]|0)<<16;bq=(d[f+(p+6)|0]|0|aT<<8)>>>((14-x|0)>>>0)|bf<<2;br=34}else{bm=w;bn=z;bo=s;bp=e[323832+((d[794e3+a2|0]|0)<<1)>>1]|0|(e[323832+((d[794e3+a9|0]|0)<<1)>>1]|0)<<16;bq=bf;br=32}if((bh&1|0)==0){bs=bo}else{bs=bo&~(1<<22-(g>>1)+bg)}bo=(bk|0)<512;bk=k<<4;do{if((be|0)>((bo?282:290)+bk+t|0)){bh=(bo?343:351)+bk+t|0;if((be|0)>=(bh|0)){bt=bs;bu=0;bv=0;bw=0;bx=0;by=0;break}bf=bh+(-12-be)|0;bh=(bf|0)<0?0:bf;bf=bh&3;a9=(bf|0)==1|0;a2=(a9|24)-(((bh+3|0)/4|0)<<1)|0;s=bs>>>(a2>>>0);bt=s<<a2;bu=s&3;bv=bh;bw=(bh|0)>0|0;bx=a9;by=((bf|0)==2?2:0)|bh&1}else{bt=bs;bu=0;bv=0;bw=0;bx=0;by=0}}while(0);bs=h+1|0;be=((bs|0)<(br|0)?bs:br)-((g|0)<0?0:g)|0;do{if((be|0)>0){bs=0;t=0;do{t=t<<1|1;bs=bs+1|0;}while((bs|0)<(be|0));bs=br+~h|0;if((bs|0)>0){bz=0;bA=t}else{bB=t;break}while(1){bk=bA<<1;bo=bz+1|0;if((bo|0)<(bs|0)){bz=bo;bA=bk}else{bB=bk;break}}}else{bB=0}}while(0);bA=bB&bq;if((bA&bp|0)!=0){bp=j+33|0;a[bp]=(d[bp]|0|o)&255}if((c[y+(k*56|0)+32>>2]|0)==0){y=0;bp=bB;bq=0;bz=bt;while(1){br=bp>>>28;be=bz>>>22&3;bs=n+(be<<2)|0;do{if((be|0)==0){bC=y}else{if((br&8|0)==0){bD=y}else{t=bn+bq|0;bk=a[t]|0;if(bk<<24>>24==0){a[bm+bq|0]=c[bs>>2]&255;bE=a[t]|0}else{bE=bk}a[t]=(bE&255|o)&255;bD=bE|y}if((br&4|0)==0){bF=bD}else{t=bq|1;bk=bn+t|0;bo=a[bk]|0;if(bo<<24>>24==0){a[bm+t|0]=c[bs>>2]&255;bG=a[bk]|0}else{bG=bo}a[bk]=(bG&255|o)&255;bF=bG|bD}if((br&2|0)==0){bH=bF}else{bk=bq|2;bo=bn+bk|0;t=a[bo]|0;if(t<<24>>24==0){a[bm+bk|0]=c[bs>>2]&255;bI=a[bo]|0}else{bI=t}a[bo]=(bI&255|o)&255;bH=bI|bF}if((br&1|0)==0){bC=bH;break}bo=bq|3;t=bn+bo|0;bk=a[t]|0;if(bk<<24>>24==0){a[bm+bo|0]=c[bs>>2]&255;bJ=a[t]|0}else{bJ=bk}a[t]=(bJ&255|o)&255;bC=bJ|bH}}while(0);bs=bq+4|0;br=bz<<2;if((bs|0)<32){y=bC;bp=bp<<4;bq=bs;bz=br}else{bK=br;bL=bC;break}}}else{bC=0;bz=bB;bB=-2147483648;bq=0;bp=bt;while(1){bt=bz>>>28;y=bp>>>22&3;bH=n+(y<<2)|0;do{if((y|0)==0){bM=bC}else{do{if((bt&8|0)==0){bN=bC}else{bJ=bn+bq|0;bF=a[bJ]|0;if((bB&bA|0)!=0){a[bJ]=(bF&255|o)&255;bN=bF|bC;break}if(bF<<24>>24==0){a[bm+bq|0]=c[bH>>2]&255;bO=a[bJ]|0}else{bO=bF}a[bJ]=(bO&255|o)&255;bN=bO|bC}}while(0);do{if((bt&4|0)==0){bP=bN}else{aW=bq|1;bJ=bn+aW|0;bF=a[bJ]|0;if((bB>>>1&bA|0)!=0){a[bJ]=(bF&255|o)&255;bP=bF|bN;break}if(bF<<24>>24==0){a[bm+aW|0]=c[bH>>2]&255;bQ=a[bJ]|0}else{bQ=bF}a[bJ]=(bQ&255|o)&255;bP=bQ|bN}}while(0);if((bt&2|0)==0){bR=bP}else{bJ=bq|2;bF=bn+bJ|0;aW=a[bF]|0;if((bB>>>2&bA|0)==0&aW<<24>>24==0){a[bm+bJ|0]=c[bH>>2]&255;bS=a[bF]|0}else{bS=aW}a[bF]=(bS&255|o)&255;bR=bS|bP}if((bt&1|0)==0){bM=bR;break}bF=bq|3;aW=bn+bF|0;bJ=a[aW]|0;if((bB>>>3&bA|0)!=0){a[aW]=(bJ&255|o)&255;bM=bJ|bR;break}if(bJ<<24>>24==0){a[bm+bF|0]=c[bH>>2]&255;bT=a[aW]|0}else{bT=bJ}a[aW]=(bT&255|o)&255;bM=bT|bR}}while(0);bH=bq+4|0;bt=bp<<2;if((bH|0)<32){bC=bM;bz=bz<<4;bB=bB>>>4;bq=bH;bp=bt}else{bK=bt;bL=bM;break}}}bM=d[bl]|0;bl=d[f+(p+7)|0]|0;bp=((d[a1]|0)<<8|(d[f+(p+6)|0]|0))<<x|bl>>>(aU>>>0);if(a$){bU=bM<<bg&255;bV=(d[f+(p+8)|0]|0|bl<<8)>>>((14-x|0)>>>0)|bp<<2;bW=18}else{bU=bM;bV=bp;bW=16}bp=e[323832+((d[794e3+bU|0]|0)<<1)>>1]|0;bU=h-32|0;bM=g-32|0;g=h-31|0;x=((g|0)<(bW|0)?g:bW)-((bM|0)<0?0:bM)|0;do{if((x|0)>0){g=0;bl=0;do{g=g<<1|1;bl=bl+1|0;}while((bl|0)<(x|0));bl=bW+(31-h)|0;if((bl|0)>0){bX=g;bY=0}else{bZ=g;break}while(1){p=bX<<1;f=bY+1|0;if((f|0)<(bl|0)){bX=p;bY=f}else{bZ=p;break}}}else{bZ=0}}while(0);bY=bZ&bV;if((bY&bp|0)!=0){bp=j+33|0;a[bp]=(d[bp]|0|o)&255}if((c[(c[B>>2]|0)+(k*56|0)+32>>2]|0)==0){k=bL;B=bZ;bp=bK;bV=0;while(1){bX=B>>>12;h=bp>>>22&3;bW=bV+32|0;x=n+(h<<2)|0;do{if((h|0)==0){b_=k}else{if((bX&8|0)==0){b$=k}else{bl=bn+bW|0;g=a[bl]|0;if(g<<24>>24==0){a[bm+bW|0]=c[x>>2]&255;b0=a[bl]|0}else{b0=g}a[bl]=(b0&255|o)&255;b$=b0|k}if((bX&4|0)==0){b1=b$}else{bl=bV+33|0;g=bn+bl|0;p=a[g]|0;if(p<<24>>24==0){a[bm+bl|0]=c[x>>2]&255;b2=a[g]|0}else{b2=p}a[g]=(b2&255|o)&255;b1=b2|b$}if((bX&2|0)==0){b3=b1}else{g=bV+34|0;p=bn+g|0;bl=a[p]|0;if(bl<<24>>24==0){a[bm+g|0]=c[x>>2]&255;b4=a[p]|0}else{b4=bl}a[p]=(b4&255|o)&255;b3=b4|b1}if((bX&1|0)==0){b_=b3;break}p=bV+35|0;bl=bn+p|0;g=a[bl]|0;if(g<<24>>24==0){a[bm+p|0]=c[x>>2]&255;b5=a[bl]|0}else{b5=g}a[bl]=(b5&255|o)&255;b_=b5|b3}}while(0);x=bV+4|0;if((x|0)<16){k=b_;B=B<<4;bp=bp<<2;bV=x}else{b6=b_;break}}}else{b_=bL;bL=bZ;bZ=bK;bK=32768;bV=0;while(1){bp=bL>>>12;B=bZ>>>22&3;k=bV+32|0;b3=n+(B<<2)|0;do{if((B|0)==0){b7=b_}else{do{if((bp&8|0)==0){b8=b_}else{b5=bn+k|0;b1=a[b5]|0;if((bK&bY|0)!=0){a[b5]=(b1&255|o)&255;b8=b1|b_;break}if(b1<<24>>24==0){a[bm+k|0]=c[b3>>2]&255;b9=a[b5]|0}else{b9=b1}a[b5]=(b9&255|o)&255;b8=b9|b_}}while(0);do{if((bp&4|0)==0){ca=b8}else{b5=bV+33|0;b1=bn+b5|0;b4=a[b1]|0;if((bK>>>1&bY|0)!=0){a[b1]=(b4&255|o)&255;ca=b4|b8;break}if(b4<<24>>24==0){a[bm+b5|0]=c[b3>>2]&255;cb=a[b1]|0}else{cb=b4}a[b1]=(cb&255|o)&255;ca=cb|b8}}while(0);do{if((bp&2|0)==0){cc=ca}else{b1=bV+34|0;b4=bn+b1|0;b5=a[b4]|0;if((bK>>>2&bY|0)!=0){a[b4]=(b5&255|o)&255;cc=b5|ca;break}if(b5<<24>>24==0){a[bm+b1|0]=c[b3>>2]&255;cd=a[b4]|0}else{cd=b5}a[b4]=(cd&255|o)&255;cc=cd|ca}}while(0);if((bp&1|0)==0){b7=cc;break}b4=bV+35|0;b5=bn+b4|0;b1=a[b5]|0;if((bK>>>3&bY|0)!=0){a[b5]=(b1&255|o)&255;b7=b1|cc;break}if(b1<<24>>24==0){a[bm+b4|0]=c[b3>>2]&255;ce=a[b5]|0}else{ce=b1}a[b5]=(ce&255|o)&255;b7=ce|cc}}while(0);b3=bV+4|0;if((b3|0)<16){b_=b7;bL=bL<<4;bZ=bZ<<2;bK=bK>>>4;bV=b3}else{b6=b7;break}}}if((bw|0)==0){cf=b6}else{if((bx|0)==0){cg=bu}else{cg=bu<<1&2}bu=(cg|0)!=0|0;bx=(((((bu<<1|bu)<<1|bu)<<1|bu)<<1|bu)<<1|bu)<<1|bu;bu=c[n+(cg<<2)>>2]|0;cg=by-32+bv|0;n=bU-cg|0;bU=bM-cg|0;cg=n+1|0;bM=7-by|0;bw=((cg|0)<(bM|0)?cg:bM)-((bU|0)<0?0:bU)|0;do{if((bw|0)>0){bU=0;cg=0;do{bU=bU<<1|1;cg=cg+1|0;}while((cg|0)<(bw|0));cg=bM-1-n|0;if((cg|0)>0){ch=bU;ci=0}else{cj=bU;break}while(1){b7=ch<<1;bV=ci+1|0;if((bV|0)<(cg|0)){ch=b7;ci=bV}else{cj=b7;break}}}else{cj=0}}while(0);ci=cj&bx;if((bM|0)>0){bx=bv+by|0;by=bu&255;bu=b6;bv=1<<bM-1;cj=0;while(1){if((ci&bv|0)==0){ck=bu}else{ch=bx+cj|0;n=bn+ch|0;bw=a[n]|0;if(bw<<24>>24==0){a[bm+ch|0]=by;cl=a[n]|0}else{cl=bw}a[n]=(cl&255|o)&255;ck=cl|bu}n=cj+1|0;if((n|0)<(bM|0)){bu=ck;bv=bv>>>1;cj=n}else{cm=ck;break}}}else{cm=b6}cf=cm<<24>>24==(o&255)<<24>>24?0:cm}if(cf<<24>>24==0){i=m;return}cm=j+32|0;a[cm]=(cf&255|o|(d[cm]|0))&255;i=m;return}function ql(){return}function qm(){return}function qn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+8|0;d=a|0;ic(86640,d)|0;c[80892]=0;c[80893]=0;c[80886]=51;c[80887]=250;e=c[d>>2]|0;if((e|0)==(-3|0)){c[80885]=262;if((b|0)==2){c[80892]=136;c[80893]=56;c[80886]=20;c[80887]=281;f=136}else if((b|0)==1){c[80892]=56;c[80893]=44;c[80886]=22;c[80887]=274;f=56}else if((b|0)==3){f=0}else{c[80892]=32;c[80893]=32;c[80886]=28;c[80887]=274;f=32}c[80894]=64;c[80895]=64;c[80896]=55;c[80897]=512;g=f}else if((e|0)==(-4|0)){c[80885]=312;if((b|0)==2){c[80892]=136;c[80893]=64;c[80886]=0;c[80887]=311;h=136}else if((b|0)==1){c[80892]=56;c[80893]=44;c[80886]=8;c[80887]=300;h=56}else if((b|0)==3){h=0}else{c[80892]=32;c[80893]=32;c[80886]=16;c[80887]=287;h=32}c[80894]=65;c[80895]=65;c[80896]=55;c[80897]=520;g=h}else if((e|0)==(-2|0)){c[80885]=263;if((b|0)==2){c[80892]=136;c[80893]=64;c[80886]=20;c[80887]=282;j=136}else if((b|0)==3){j=0}else if((b|0)==1){c[80892]=56;c[80893]=44;c[80886]=22;c[80887]=274;j=56}else{c[80892]=32;c[80893]=32;c[80886]=28;c[80887]=274;j=32}c[80894]=65;c[80895]=65;c[80896]=55;c[80897]=520;g=j}else{c[80885]=312;if((b|0)==1){c[80892]=48;c[80893]=36;c[80886]=8;c[80887]=300;k=48}else if((b|0)==2){c[80892]=136;c[80893]=48;c[80886]=0;c[80887]=311;k=136}else if((b|0)==3){k=0}else{c[80892]=32;c[80893]=32;c[80886]=16;c[80887]=287;k=32}c[80894]=63;c[80895]=63;c[80896]=54;c[80897]=504;g=k}c[80898]=48;c[80899]=247;c[80888]=51;c[80889]=251;c[80890]=55;c[80891]=247;c[80566]=g;c[80567]=g+320;qi();i=a;return}function qo(){return 0}function qp(){return}function qq(){return}function qr(a,b){a=a|0;b=b|0;return 0}function qs(){return}function qt(a,b){a=a|0;b=b|0;return}function qu(){return 0}function qv(){return}function qw(){return}function qx(){return}function qy(){c[c[198574]>>2]=794280;c[(c[198574]|0)+12>>2]=0;c[(c[198574]|0)+8>>2]=0;c[(c[198574]|0)+16>>2]=0;c[(c[198574]|0)+20>>2]=c[198576];c[(c[198574]|0)+24>>2]=794320;c[(c[198574]|0)+28>>2]=0;c[(c[198574]|0)+32>>2]=28;c[(c[198574]|0)+36>>2]=66;c[(c[198574]|0)+40>>2]=24;c[(c[198574]|0)+44>>2]=30;c[(c[198574]|0)+48>>2]=22;c[(c[198574]|0)+52>>2]=36;c[(c[198574]|0)+56>>2]=98;c[(c[198574]|0)+60>>2]=0;c[(c[198574]|0)+64>>2]=70;return c[198574]|0}function qz(){c[198576]=gB()|0;return}function qA(){gy(c[198576]|0,802776);return}function qB(){gC(c[198576]|0);return}function qC(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;h=i;c[119386]=f;c[119384]=0;c[119382]=g;if((g|0)==0){i=h;return}do{g=c[198580]|0;f=c[198582]|0;j=c[f+2060>>2]|0;if(g>>>0<j>>>0){k=g}else{l=g;g=f;f=j;while(1){j=c[g+8+(c[g+2064>>2]<<3)>>2]|0;c5[c[j+8>>2]&255](l-f|0,c[j+16>>2]|0);j=c[198580]|0;m=c[198582]|0;n=c[m+2060>>2]|0;if(j>>>0<n>>>0){k=j;break}else{l=j;g=m;f=n}}}f=c[198576]|0;g=f+80128|0;l=c[g>>2]|0;do{if((l&66|0)==64){n=f+80124|0;if((c[n>>2]|0)>>>0>k>>>0){o=f;p=l;break}c[g>>2]=l&-65;c[n>>2]=-1;n=c[198576]|0;o=n;p=c[n+80128>>2]|0}else{o=f;p=l}}while(0);l=o+80128|0;do{if((p|0)!=0){f=p&255;L3537:do{if((p&67|0)!=0){do{if((p&1|0)!=0){if((((c[c[o+80112>>2]>>2]|0)>>>8&1|2)+(c[o+24>>2]|0)|0)>>>0>(c[198580]|0)>>>0){break}if((c[121711]&4|0)==0){q=o;r=p}else{qK();g=c[198576]|0;q=g;r=c[g+80128>>2]|0}c[q+80128>>2]=r&-2;g=c[q+80132>>2]|0;if((g|0)!=0){dd[g&63]()}g=a[461072]&-17;n=c[115266]|0;m=a[461056]|0;a[719208+(m&255|256)|0]=n>>>8&255;a[719208+(m-1&255|256)|0]=n&255;n=g|a[803368]&-128|((a[803360]|0)==0?2:0)|32;a[461056]=m-3&255;a[719208+(m-2&255|256)|0]=n;a[461072]=g|4;g=(da[c[(c[217768]|0)+1020>>2]&255](-5)|0)&255;n=g<<8;m=(da[c[(c[217768]|0)+1020>>2]&255](-6)|0)&255|n;c[115266]=m;j=c[(c[217770]|0)+(g<<2)>>2]|0;if((j|0)==0){s=0}else{s=j+(-n|0)|0}c[215624]=s;c[215620]=c[(c[163352]|0)+(g<<2)>>2];c[197210]=m;c[200694]=0;c[198580]=(c[198580]|0)+7;break L3537}}while(0);if((p&66|0)==0){break}m=a[461072]|0;if((m&4)!=0){if((c[200694]&512|0)==0){break}}g=c[c[o+80112>>2]>>2]|0;if(((g>>>8&1|2)+(c[o+16>>2]|0)|0)>>>0>(c[198580]|0)>>>0){break}if((g&1024|0)!=0){c[l>>2]=p|64;break}if((c[121711]&4|0)==0){t=o;u=p;v=m}else{qK();m=c[198576]|0;t=m;u=c[m+80128>>2]|0;v=a[461072]|0}c[t+80128>>2]=u&-65;c[t+80124>>2]=-1;m=v&-17;g=c[115266]|0;n=a[461056]|0;a[719208+(n&255|256)|0]=g>>>8&255;a[719208+(n-1&255|256)|0]=g&255;g=m|a[803368]&-128|((a[803360]|0)==0?2:0)|32;a[461056]=n-3&255;a[719208+(n-2&255|256)|0]=g;a[461072]=m|4;m=(da[c[(c[217768]|0)+1020>>2]&255](-1)|0)&255;g=m<<8;n=(da[c[(c[217768]|0)+1020>>2]&255](-2)|0)&255|g;c[115266]=n;j=c[(c[217770]|0)+(m<<2)>>2]|0;if((j|0)==0){w=0}else{w=j+(-g|0)|0}c[215624]=w;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=n;c[200694]=0;c[198580]=(c[198580]|0)+7}}while(0);do{if((p&12|0)==0){x=f}else{do{if((p&8|0)==0){y=f}else{n=c[115266]|0;c[198570]=n;a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;gM(c[198576]|0,n&65535);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;n=c[198570]|0;c[115266]=n;m=n>>8;g=c[(c[217770]|0)+(m<<2)>>2]|0;if((g|0)==0){z=0}else{z=g+(-(n&65280)|0)|0}c[215624]=z;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=n;if((c[(c[198576]|0)+80128>>2]&4|0)==0){y=f;break}y=(p|4)&255}}while(0);if((y&4)==0){x=y;break}gL(c[198576]|0);n=c[198576]|0;m=c[n+80128>>2]&16;gz(n);if((m|0)!=0){gN(c[198576]|0)}c[198580]=6;hB();m=(da[c[(c[217768]|0)+1020>>2]&255](-3)|0)&255;n=m<<8;g=(da[c[(c[217768]|0)+1020>>2]&255](-4)|0)&255|n;c[115266]=g;j=c[(c[217770]|0)+(m<<2)>>2]|0;if((j|0)==0){A=0}else{A=j+(-n|0)|0}c[215624]=A;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=g;x=y}}while(0);f=x&255;do{if((f&48|0)!=0){do{if((f&16|0)!=0){if((qI(1)|0)!=0){a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;g=c[198570]|0;c[115266]=g;m=g>>8;n=c[(c[217770]|0)+(m<<2)>>2]|0;if((n|0)==0){B=0}else{B=n+(-(g&65280)|0)|0}c[215624]=B;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=g}g=c[121711]|0;do{if((g|0)!=0){c[198570]=c[115266];a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;if((g&1|0)==0){break}if((qP(1,c[115266]&65535)|0)==0){break}qH(1);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;m=c[198570]|0;c[115266]=m;n=m>>8;j=c[(c[217770]|0)+(n<<2)>>2]|0;if((j|0)==0){C=0}else{C=j+(-(m&65280)|0)|0}c[215624]=C;c[215620]=c[(c[163352]|0)+(n<<2)>>2];c[197210]=m}}while(0);g=c[121711]|0;if((g&4|0)==0){D=g}else{qJ(c[115266]&65535);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;g=c[198570]|0;c[115266]=g;m=g>>8;n=c[(c[217770]|0)+(m<<2)>>2]|0;if((n|0)==0){E=0}else{E=n+(-(g&65280)|0)|0}c[215624]=E;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=g;D=c[121711]|0}if((D&2|0)==0){break}qL(c[200696]|0,c[115266]&65535);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;g=c[198570]|0;c[115266]=g;m=g>>8;n=c[(c[217770]|0)+(m<<2)>>2]|0;if((n|0)==0){F=0}else{F=n+(-(g&65280)|0)|0}c[215624]=F;c[215620]=c[(c[163352]|0)+(m<<2)>>2];c[197210]=g}}while(0);if((f&32|0)==0){break}c[198570]=c[115266];a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;gJ(c[198576]|0);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;g=c[198570]|0;c[115266]=g;m=g>>8;n=(c[217770]|0)+(m<<2)|0;j=c[n>>2]|0;if((j|0)==0){G=0}else{G=j+(-(g&65280)|0)|0}c[215624]=G;j=(c[163352]|0)+(m<<2)|0;c[215620]=c[j>>2];c[197210]=g;c[115266]=g;m=c[n>>2]|0;if((m|0)==0){H=0}else{H=m+(-(g&65280)|0)|0}c[215624]=H;c[215620]=c[j>>2];c[197210]=g}}while(0);f=(c[198576]|0)+80128|0;g=c[f>>2]|0;if((g&66|0)==64){c[f>>2]=g&-65}g=c[198580]|0;f=c[198582]|0;j=c[f+2060>>2]|0;if(g>>>0<j>>>0){break}else{I=g;J=f;K=j}do{j=c[J+8+(c[J+2064>>2]<<3)>>2]|0;c5[c[j+8>>2]&255](I-K|0,c[j+16>>2]|0);I=c[198580]|0;J=c[198582]|0;K=c[J+2060>>2]|0;}while(I>>>0>=K>>>0)}}while(0);l=c[115266]|0;c[200696]=l;do{if((l|0)<(c[215620]|0)){j=c[215624]|0;f=a[j+l|0]|0;a[485832]=f;g=a[j+(l+1)|0]|0;b[242917]=d[j+(l+2)|0]<<8|g&255;j=c[198580]|0;m=j+2|0;c[198580]=m;if((a[55728+(f&255)|0]|0)==0){L=f;M=m;N=g;break}m=j+3|0;c[198580]=m;L=f;M=m;N=g}else{a[485832]=da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0;c[198580]=(c[198580]|0)+1;g=(c[115266]|0)+1|0;m=da[c[(c[217768]|0)+(g>>>8<<2)>>2]&255](g&65535)|0;b[242917]=m&255;g=(c[198580]|0)+1|0;c[198580]=g;f=a[485832]|0;if((a[55728+(f&255)|0]|0)==0){L=f;M=g;N=m;break}m=(c[115266]|0)+2|0;g=((da[c[(c[217768]|0)+(m>>>8<<2)>>2]&255](m&65535)|0)&255)<<8;m=b[242917]|0;b[242917]=g|m;g=(c[198580]|0)+1|0;c[198580]=g;L=a[485832]|0;M=g;N=m&255}}while(0);L3632:while(1){l=L&255;c[200694]=l;switch(l|0){case 76:{O=2741;break L3632;break};case 240:{O=2744;break L3632;break};case 169:{O=2751;break L3632;break};case 234:{O=2752;break L3632;break};case 173:{O=2753;break L3632;break};case 174:{O=2754;break L3632;break};case 157:{O=2755;break L3632;break};case 208:{O=2756;break L3632;break};case 165:{O=2763;break L3632;break};case 141:{O=2764;break L3632;break};case 189:{O=2765;break L3632;break};case 190:{O=2769;break L3632;break};case 125:{O=2773;break L3632;break};case 16:{O=2792;break L3632;break};case 133:{O=2799;break L3632;break};case 153:{O=2800;break L3632;break};case 136:{O=2801;break L3632;break};case 64:{O=2802;break L3632;break};case 185:{O=2805;break L3632;break};case 2:{break};default:{O=2832;break L3632}}l=c[115266]|0;c[198570]=l;a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;if((ma(l&65535)|0)==0){O=2811;break}l=i_()|0;if((l|0)==(-1|0)){O=2811;break}else if((l|0)==0){O=2829;break}m=(c[198580]|0)-2|0;c[198580]=m;g=l&255;a[485832]=g;f=l>>>8&255;a[485834]=f;a[485835]=l>>>16&255;a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;l=c[198570]|0;c[115266]=l;j=l>>8;n=c[(c[217770]|0)+(j<<2)>>2]|0;if((n|0)==0){P=0}else{P=n+(-(l&65280)|0)|0}c[215624]=P;c[215620]=c[(c[163352]|0)+(j<<2)>>2];c[197210]=l;L=g;M=m;N=f}do{if((O|0)==2741){O=0;f=e[242917]|0;c[115266]=f;m=c[(c[217770]|0)+(f>>>8<<2)>>2]|0;if((m|0)==0){Q=0}else{Q=m+(-(f&65280)|0)|0}c[215624]=Q;c[215620]=c[(c[163352]|0)+(f>>>8<<2)>>2];c[197210]=f}else if((O|0)==2744){O=0;f=(c[115266]|0)+2|0;c[115266]=f;if((a[803360]|0)!=0){break}m=(N<<24>>24)+f|0;da[c[(c[217768]|0)+(f>>>8<<2)>>2]&255](f&65535)|0;c[198580]=(c[198580]|0)+1;f=c[115266]|0;if(((f^m)&65280|0)==0){c[200694]=c[200694]|256}else{g=f&65280;f=c[(c[217768]|0)+(g>>>8<<2)>>2]|0;l=(g|m&255)&65535;da[f&255](l)|0;c[198580]=(c[198580]|0)+1}l=m&65535;c[115266]=l;f=c[(c[217770]|0)+(l>>>8<<2)>>2]|0;if((f|0)==0){R=0}else{R=f+(-(m&65280)|0)|0}c[215624]=R;c[215620]=c[(c[163352]|0)+(l>>>8<<2)>>2];c[197210]=l}else if((O|0)==2751){O=0;a[461080]=N;a[803368]=N;a[803360]=N;c[115266]=(c[115266]|0)+2}else if((O|0)==2752){O=0;c[115266]=(c[115266]|0)+1}else if((O|0)==2753){O=0;l=b[242917]|0;m=da[c[(c[217768]|0)+((l&65535)>>>8<<2)>>2]&255](l)|0;a[461080]=m;c[198580]=(c[198580]|0)+1;a[803368]=m;a[803360]=m;c[115266]=(c[115266]|0)+3}else if((O|0)==2754){O=0;m=b[242917]|0;l=da[c[(c[217768]|0)+((m&65535)>>>8<<2)>>2]&255](m)|0;a[461048]=l;a[803368]=l;a[803360]=l;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3}else if((O|0)==2755){O=0;l=b[242917]|0;m=l&65535;c[115266]=(c[115266]|0)+3;da[c[(c[217768]|0)+(m>>>8<<2)>>2]&255]((d[461048]|0)+l&255|l&-256)|0;c[198580]=(c[198580]|0)+2;l=(d[461048]|0)+m|0;c5[c[(c[217766]|0)+(l>>>8<<2)>>2]&255](l&65535,a[461080]|0)}else if((O|0)==2756){O=0;l=(c[115266]|0)+2|0;c[115266]=l;if((a[803360]|0)==0){break}m=(N<<24>>24)+l|0;da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0;c[198580]=(c[198580]|0)+1;l=c[115266]|0;if(((l^m)&65280|0)==0){c[200694]=c[200694]|256}else{f=l&65280;l=c[(c[217768]|0)+(f>>>8<<2)>>2]|0;g=(f|m&255)&65535;da[l&255](g)|0;c[198580]=(c[198580]|0)+1}g=m&65535;c[115266]=g;l=c[(c[217770]|0)+(g>>>8<<2)>>2]|0;if((l|0)==0){S=0}else{S=l+(-(m&65280)|0)|0}c[215624]=S;c[215620]=c[(c[163352]|0)+(g>>>8<<2)>>2];c[197210]=g}else if((O|0)==2763){O=0;g=da[c[c[217768]>>2]&255](N&255)|0;a[461080]=g;c[198580]=(c[198580]|0)+1;a[803368]=g;a[803360]=g;c[115266]=(c[115266]|0)+2}else if((O|0)==2764){O=0;g=b[242917]|0;c[115266]=(c[115266]|0)+3;c[198580]=M+1;c5[c[(c[217766]|0)+((g&65535)>>>8<<2)>>2]&255](g,a[461080]|0)}else if((O|0)==2765){O=0;g=e[242917]|0;m=d[461048]|0;if(((g&255)+m|0)>255){l=c[(c[217768]|0)+(g>>>8<<2)>>2]|0;f=(m+g&255|g&65280)&65535;da[l&255](f)|0;c[198580]=(c[198580]|0)+1;f=(d[461048]|0)+(e[242917]|0)|0;T=da[c[(c[217768]|0)+(f>>>8<<2)>>2]&255](f&65535)|0}else{f=m+g|0;T=da[c[(c[217768]|0)+(f>>>8<<2)>>2]&255](f&65535)|0}a[461080]=T;c[198580]=(c[198580]|0)+1;a[803368]=T;a[803360]=T;c[115266]=(c[115266]|0)+3}else if((O|0)==2769){O=0;f=e[242917]|0;g=d[461040]|0;if(((f&255)+g|0)>255){m=c[(c[217768]|0)+(f>>>8<<2)>>2]|0;l=(g+f&255|f&65280)&65535;da[m&255](l)|0;c[198580]=(c[198580]|0)+1;l=(d[461040]|0)+(e[242917]|0)|0;U=da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0}else{l=g+f|0;U=da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0}a[461048]=U;a[803368]=U;a[803360]=U;c[198580]=(c[198580]|0)+1;c[115266]=(c[115266]|0)+3}else if((O|0)==2773){O=0;l=e[242917]|0;f=d[461048]|0;if(((l&255)+f|0)>255){g=c[(c[217768]|0)+(l>>>8<<2)>>2]|0;m=(f+l&255|l&65280)&65535;da[g&255](m)|0;c[198580]=(c[198580]|0)+1;m=(d[461048]|0)+(e[242917]|0)|0;V=da[c[(c[217768]|0)+(m>>>8<<2)>>2]&255](m&65535)|0}else{m=f+l|0;V=da[c[(c[217768]|0)+(m>>>8<<2)>>2]&255](m&65535)|0}m=V&255;c[198580]=(c[198580]|0)+1;l=a[461072]|0;f=l&255;g=a[461080]|0;j=g&255;do{if((f&8|0)==0){n=j+m+(f&1)|0;W=n&255;a[803368]=W;a[803360]=W;do{if((g^V)<<24>>24<0){O=2787}else{if(((j^n)&128|0)==0){O=2787;break}X=l|64}}while(0);if((O|0)==2787){O=0;X=l&-65}a[461072]=X;if(n>>>0>255>>>0){a[461072]=X|1;Y=W;break}else{a[461072]=X&-2;Y=W;break}}else{Z=f&1;_=Z+(m&15)+(j&15)|0;$=_>>>0>9>>>0?_+6|0:_;_=($&15|j&240)+(m&240)|0;aa=$>>>0<16>>>0?_:_+16|0;a[803360]=(j+m+Z&255|0)!=0|0;a[803368]=aa&255&-128;do{if(((j^aa)&128|0)==0){O=2780}else{if((g^V)<<24>>24<0){O=2780;break}ab=l|64}}while(0);if((O|0)==2780){O=0;ab=l&-65}a[461072]=ab;W=(aa&496)>>>0>144>>>0?aa+96|0:aa;if((W&4080)>>>0>240>>>0){a[461072]=ab|1;Y=W&255;break}else{a[461072]=ab&-2;Y=W&255;break}}}while(0);a[461080]=Y;c[115266]=(c[115266]|0)+3}else if((O|0)==2792){O=0;l=(c[115266]|0)+2|0;c[115266]=l;if((a[803368]|0)<0){break}g=(N<<24>>24)+l|0;da[c[(c[217768]|0)+(l>>>8<<2)>>2]&255](l&65535)|0;c[198580]=(c[198580]|0)+1;l=c[115266]|0;if(((l^g)&65280|0)==0){c[200694]=c[200694]|256}else{j=l&65280;l=c[(c[217768]|0)+(j>>>8<<2)>>2]|0;m=(j|g&255)&65535;da[l&255](m)|0;c[198580]=(c[198580]|0)+1}m=g&65535;c[115266]=m;l=c[(c[217770]|0)+(m>>>8<<2)>>2]|0;if((l|0)==0){ac=0}else{ac=l+(-(g&65280)|0)|0}c[215624]=ac;c[215620]=c[(c[163352]|0)+(m>>>8<<2)>>2];c[197210]=m}else if((O|0)==2799){O=0;c[198580]=M+1;c5[c[c[217766]>>2]&255](N&255,a[461080]|0);c[115266]=(c[115266]|0)+2}else if((O|0)==2800){O=0;m=b[242917]|0;g=m&65535;c[115266]=(c[115266]|0)+3;da[c[(c[217768]|0)+(g>>>8<<2)>>2]&255]((d[461040]|0)+m&255|m&-256)|0;c[198580]=(c[198580]|0)+2;m=(d[461040]|0)+g|0;c5[c[(c[217766]|0)+(m>>>8<<2)>>2]&255](m&65535,a[461080]|0)}else if((O|0)==2801){O=0;m=(a[461040]|0)-1&255;a[461040]=m;a[803368]=m;a[803360]=m;c[115266]=(c[115266]|0)+1}else if((O|0)==2802){O=0;c[198580]=M+4;m=a[461056]|0;g=a[719208+(m+1&255|256)|0]|0;a[461072]=g&125;a[803360]=(g&255)>>>1&1^1;a[803368]=g;g=a[719208+(m+2&255|256)|0]|0;l=m+3&255;a[461056]=l;m=(d[719208+(l&255|256)|0]<<8|g&255)&65535;c[115266]=m;g=c[(c[217770]|0)+(m>>>8<<2)>>2]|0;if((g|0)==0){ad=0}else{ad=g+(-(m&65280)|0)|0}c[215624]=ad;c[215620]=c[(c[163352]|0)+(m>>>8<<2)>>2];c[197210]=m}else if((O|0)==2805){O=0;m=e[242917]|0;g=d[461040]|0;if(((m&255)+g|0)>255){l=c[(c[217768]|0)+(m>>>8<<2)>>2]|0;j=(g+m&255|m&65280)&65535;da[l&255](j)|0;c[198580]=(c[198580]|0)+1;j=(d[461040]|0)+(e[242917]|0)|0;ae=da[c[(c[217768]|0)+(j>>>8<<2)>>2]&255](j&65535)|0}else{j=g+m|0;ae=da[c[(c[217768]|0)+(j>>>8<<2)>>2]&255](j&65535)|0}a[461080]=ae;c[198580]=(c[198580]|0)+1;a[803368]=ae;a[803360]=ae;c[115266]=(c[115266]|0)+3}else if((O|0)==2811){O=0;c[198580]=(c[198580]|0)-2;j=c[115266]|0;c[198570]=j;a[794284]=a[461080]|0;a[794285]=a[461048]|0;a[794286]=a[461040]|0;a[794287]=a[461056]|0;a[794288]=a[461072]|0;a[794289]=a[803368]|0;a[794290]=a[803360]|0;m=hy(86568,(g=i,i=i+8|0,c[g>>2]=j,g)|0)|0;i=g;if((m|0)==1){gL(c[198576]|0);g=c[198576]|0;j=c[g+80128>>2]&16;gz(g);if((j|0)!=0){gN(c[198576]|0)}c[198580]=6;hB();j=(da[c[(c[217768]|0)+1020>>2]&255](-3)|0)&255;g=j<<8;l=(da[c[(c[217768]|0)+1020>>2]&255](-4)|0)&255|g;c[115266]=l;f=c[(c[217770]|0)+(j<<2)>>2]|0;if((f|0)==0){af=0}else{af=f+(-g|0)|0}c[215624]=af;c[215620]=c[(c[163352]|0)+(j<<2)>>2];c[197210]=l;break}else if((m|0)==2){l8();gL(c[198576]|0);l=c[198576]|0;j=c[l+80128>>2]&16;gz(l);if((j|0)!=0){gN(c[198576]|0)}c[198580]=6;hB();j=(da[c[(c[217768]|0)+1020>>2]&255](-3)|0)&255;l=j<<8;g=(da[c[(c[217768]|0)+1020>>2]&255](-4)|0)&255|l;c[115266]=g;f=c[(c[217770]|0)+(j<<2)>>2]|0;if((f|0)==0){ag=0}else{ag=f+(-l|0)|0}c[215624]=ag;c[215620]=c[(c[163352]|0)+(j<<2)>>2];c[197210]=g;break}else if((m|0)==3){qH(1);a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;m=c[198570]|0;c[115266]=m;g=m>>8;j=c[(c[217770]|0)+(g<<2)>>2]|0;if((j|0)==0){ah=0}else{ah=j+(-(m&65280)|0)|0}c[215624]=ah;c[215620]=c[(c[163352]|0)+(g<<2)>>2];c[197210]=m;break}else{c[198580]=(c[198580]|0)+1;break}}else if((O|0)==2829){O=0;a[461080]=a[794284]|0;a[461048]=a[794285]|0;a[461040]=a[794286]|0;a[461056]=a[794287]|0;a[461072]=a[794288]|0;a[803368]=a[794289]|0;a[803360]=a[794290]|0;m=c[198570]|0;c[115266]=m;g=m>>8;j=c[(c[217770]|0)+(g<<2)>>2]|0;if((j|0)==0){ai=0}else{ai=j+(-(m&65280)|0)|0}c[215624]=ai;c[215620]=c[(c[163352]|0)+(g<<2)>>2];c[197210]=m}else if((O|0)==2832){O=0;qD()}}while(0);c[(c[198576]|0)+28>>2]=0;}while((c[119384]|0)!=(c[119382]|0));i=h;return}
function AP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+4|0;e=c[d>>2]|0;f=e&-8;g=a;h=g+f|0;i=h;j=c[217776]|0;if(g>>>0<j>>>0){ct();return 0}k=e&3;if(!((k|0)!=1&g>>>0<h>>>0)){ct();return 0}l=g+(f|4)|0;m=c[l>>2]|0;if((m&1|0)==0){ct();return 0}if((k|0)==0){if(b>>>0<256>>>0){n=0;return n|0}do{if(f>>>0>=(b+4|0)>>>0){if((f-b|0)>>>0>c[121704]<<1>>>0){break}else{n=a}return n|0}}while(0);n=0;return n|0}if(f>>>0>=b>>>0){k=f-b|0;if(k>>>0<=15>>>0){n=a;return n|0}c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|3;c[l>>2]=c[l>>2]|1;AQ(g+b|0,k);n=a;return n|0}if((i|0)==(c[217778]|0)){k=(c[217775]|0)+f|0;if(k>>>0<=b>>>0){n=0;return n|0}l=k-b|0;c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=l|1;c[217778]=g+b;c[217775]=l;n=a;return n|0}if((i|0)==(c[217777]|0)){l=(c[217774]|0)+f|0;if(l>>>0<b>>>0){n=0;return n|0}k=l-b|0;if(k>>>0>15>>>0){c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|1;c[g+l>>2]=k;o=g+(l+4)|0;c[o>>2]=c[o>>2]&-2;p=g+b|0;q=k}else{c[d>>2]=e&1|l|2;e=g+(l+4)|0;c[e>>2]=c[e>>2]|1;p=0;q=0}c[217774]=q;c[217777]=p;n=a;return n|0}if((m&2|0)!=0){n=0;return n|0}p=(m&-8)+f|0;if(p>>>0<b>>>0){n=0;return n|0}q=p-b|0;e=m>>>3;L4224:do{if(m>>>0<256>>>0){l=c[g+(f+8)>>2]|0;k=c[g+(f+12)>>2]|0;o=871128+(e<<1<<2)|0;do{if((l|0)!=(o|0)){if(l>>>0<j>>>0){ct();return 0}if((c[l+12>>2]|0)==(i|0)){break}ct();return 0}}while(0);if((k|0)==(l|0)){c[217772]=c[217772]&~(1<<e);break}do{if((k|0)==(o|0)){r=k+8|0}else{if(k>>>0<j>>>0){ct();return 0}s=k+8|0;if((c[s>>2]|0)==(i|0)){r=s;break}ct();return 0}}while(0);c[l+12>>2]=k;c[r>>2]=l}else{o=h;s=c[g+(f+24)>>2]|0;t=c[g+(f+12)>>2]|0;do{if((t|0)==(o|0)){u=g+(f+20)|0;v=c[u>>2]|0;if((v|0)==0){w=g+(f+16)|0;x=c[w>>2]|0;if((x|0)==0){y=0;break}else{z=x;A=w}}else{z=v;A=u}while(1){u=z+20|0;v=c[u>>2]|0;if((v|0)!=0){z=v;A=u;continue}u=z+16|0;v=c[u>>2]|0;if((v|0)==0){break}else{z=v;A=u}}if(A>>>0<j>>>0){ct();return 0}else{c[A>>2]=0;y=z;break}}else{u=c[g+(f+8)>>2]|0;if(u>>>0<j>>>0){ct();return 0}v=u+12|0;if((c[v>>2]|0)!=(o|0)){ct();return 0}w=t+8|0;if((c[w>>2]|0)==(o|0)){c[v>>2]=t;c[w>>2]=u;y=t;break}else{ct();return 0}}}while(0);if((s|0)==0){break}t=g+(f+28)|0;l=871392+(c[t>>2]<<2)|0;do{if((o|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[217773]=c[217773]&~(1<<c[t>>2]);break L4224}else{if(s>>>0<(c[217776]|0)>>>0){ct();return 0}k=s+16|0;if((c[k>>2]|0)==(o|0)){c[k>>2]=y}else{c[s+20>>2]=y}if((y|0)==0){break L4224}}}while(0);if(y>>>0<(c[217776]|0)>>>0){ct();return 0}c[y+24>>2]=s;o=c[g+(f+16)>>2]|0;do{if((o|0)!=0){if(o>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[y+16>>2]=o;c[o+24>>2]=y;break}}}while(0);o=c[g+(f+20)>>2]|0;if((o|0)==0){break}if(o>>>0<(c[217776]|0)>>>0){ct();return 0}else{c[y+20>>2]=o;c[o+24>>2]=y;break}}}while(0);if(q>>>0<16>>>0){c[d>>2]=p|c[d>>2]&1|2;y=g+(p|4)|0;c[y>>2]=c[y>>2]|1;n=a;return n|0}else{c[d>>2]=c[d>>2]&1|b|2;c[g+(b+4)>>2]=q|3;d=g+(p|4)|0;c[d>>2]=c[d>>2]|1;AQ(g+b|0,q);n=a;return n|0}return 0}function AQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=a;e=d+b|0;f=e;g=c[a+4>>2]|0;L4300:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){return}i=d+(-h|0)|0;j=i;k=h+b|0;l=c[217776]|0;if(i>>>0<l>>>0){ct()}if((j|0)==(c[217777]|0)){m=d+(b+4)|0;if((c[m>>2]&3|0)!=3){n=j;o=k;break}c[217774]=k;c[m>>2]=c[m>>2]&-2;c[d+(4-h)>>2]=k|1;c[e>>2]=k;return}m=h>>>3;if(h>>>0<256>>>0){p=c[d+(8-h)>>2]|0;q=c[d+(12-h)>>2]|0;r=871128+(m<<1<<2)|0;do{if((p|0)!=(r|0)){if(p>>>0<l>>>0){ct()}if((c[p+12>>2]|0)==(j|0)){break}ct()}}while(0);if((q|0)==(p|0)){c[217772]=c[217772]&~(1<<m);n=j;o=k;break}do{if((q|0)==(r|0)){s=q+8|0}else{if(q>>>0<l>>>0){ct()}t=q+8|0;if((c[t>>2]|0)==(j|0)){s=t;break}ct()}}while(0);c[p+12>>2]=q;c[s>>2]=p;n=j;o=k;break}r=i;m=c[d+(24-h)>>2]|0;t=c[d+(12-h)>>2]|0;do{if((t|0)==(r|0)){u=16-h|0;v=d+(u+4)|0;w=c[v>>2]|0;if((w|0)==0){x=d+u|0;u=c[x>>2]|0;if((u|0)==0){y=0;break}else{z=u;A=x}}else{z=w;A=v}while(1){v=z+20|0;w=c[v>>2]|0;if((w|0)!=0){z=w;A=v;continue}v=z+16|0;w=c[v>>2]|0;if((w|0)==0){break}else{z=w;A=v}}if(A>>>0<l>>>0){ct()}else{c[A>>2]=0;y=z;break}}else{v=c[d+(8-h)>>2]|0;if(v>>>0<l>>>0){ct()}w=v+12|0;if((c[w>>2]|0)!=(r|0)){ct()}x=t+8|0;if((c[x>>2]|0)==(r|0)){c[w>>2]=t;c[x>>2]=v;y=t;break}else{ct()}}}while(0);if((m|0)==0){n=j;o=k;break}t=d+(28-h)|0;l=871392+(c[t>>2]<<2)|0;do{if((r|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[217773]=c[217773]&~(1<<c[t>>2]);n=j;o=k;break L4300}else{if(m>>>0<(c[217776]|0)>>>0){ct()}i=m+16|0;if((c[i>>2]|0)==(r|0)){c[i>>2]=y}else{c[m+20>>2]=y}if((y|0)==0){n=j;o=k;break L4300}}}while(0);if(y>>>0<(c[217776]|0)>>>0){ct()}c[y+24>>2]=m;r=16-h|0;t=c[d+r>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[217776]|0)>>>0){ct()}else{c[y+16>>2]=t;c[t+24>>2]=y;break}}}while(0);t=c[d+(r+4)>>2]|0;if((t|0)==0){n=j;o=k;break}if(t>>>0<(c[217776]|0)>>>0){ct()}else{c[y+20>>2]=t;c[t+24>>2]=y;n=j;o=k;break}}else{n=a;o=b}}while(0);a=c[217776]|0;if(e>>>0<a>>>0){ct()}y=d+(b+4)|0;z=c[y>>2]|0;do{if((z&2|0)==0){if((f|0)==(c[217778]|0)){A=(c[217775]|0)+o|0;c[217775]=A;c[217778]=n;c[n+4>>2]=A|1;if((n|0)!=(c[217777]|0)){return}c[217777]=0;c[217774]=0;return}if((f|0)==(c[217777]|0)){A=(c[217774]|0)+o|0;c[217774]=A;c[217777]=n;c[n+4>>2]=A|1;c[n+A>>2]=A;return}A=(z&-8)+o|0;s=z>>>3;L4400:do{if(z>>>0<256>>>0){g=c[d+(b+8)>>2]|0;t=c[d+(b+12)>>2]|0;h=871128+(s<<1<<2)|0;do{if((g|0)!=(h|0)){if(g>>>0<a>>>0){ct()}if((c[g+12>>2]|0)==(f|0)){break}ct()}}while(0);if((t|0)==(g|0)){c[217772]=c[217772]&~(1<<s);break}do{if((t|0)==(h|0)){B=t+8|0}else{if(t>>>0<a>>>0){ct()}m=t+8|0;if((c[m>>2]|0)==(f|0)){B=m;break}ct()}}while(0);c[g+12>>2]=t;c[B>>2]=g}else{h=e;m=c[d+(b+24)>>2]|0;l=c[d+(b+12)>>2]|0;do{if((l|0)==(h|0)){i=d+(b+20)|0;p=c[i>>2]|0;if((p|0)==0){q=d+(b+16)|0;v=c[q>>2]|0;if((v|0)==0){C=0;break}else{D=v;E=q}}else{D=p;E=i}while(1){i=D+20|0;p=c[i>>2]|0;if((p|0)!=0){D=p;E=i;continue}i=D+16|0;p=c[i>>2]|0;if((p|0)==0){break}else{D=p;E=i}}if(E>>>0<a>>>0){ct()}else{c[E>>2]=0;C=D;break}}else{i=c[d+(b+8)>>2]|0;if(i>>>0<a>>>0){ct()}p=i+12|0;if((c[p>>2]|0)!=(h|0)){ct()}q=l+8|0;if((c[q>>2]|0)==(h|0)){c[p>>2]=l;c[q>>2]=i;C=l;break}else{ct()}}}while(0);if((m|0)==0){break}l=d+(b+28)|0;g=871392+(c[l>>2]<<2)|0;do{if((h|0)==(c[g>>2]|0)){c[g>>2]=C;if((C|0)!=0){break}c[217773]=c[217773]&~(1<<c[l>>2]);break L4400}else{if(m>>>0<(c[217776]|0)>>>0){ct()}t=m+16|0;if((c[t>>2]|0)==(h|0)){c[t>>2]=C}else{c[m+20>>2]=C}if((C|0)==0){break L4400}}}while(0);if(C>>>0<(c[217776]|0)>>>0){ct()}c[C+24>>2]=m;h=c[d+(b+16)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[217776]|0)>>>0){ct()}else{c[C+16>>2]=h;c[h+24>>2]=C;break}}}while(0);h=c[d+(b+20)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[217776]|0)>>>0){ct()}else{c[C+20>>2]=h;c[h+24>>2]=C;break}}}while(0);c[n+4>>2]=A|1;c[n+A>>2]=A;if((n|0)!=(c[217777]|0)){F=A;break}c[217774]=A;return}else{c[y>>2]=z&-2;c[n+4>>2]=o|1;c[n+o>>2]=o;F=o}}while(0);o=F>>>3;if(F>>>0<256>>>0){z=o<<1;y=871128+(z<<2)|0;C=c[217772]|0;b=1<<o;do{if((C&b|0)==0){c[217772]=C|b;G=y;H=871128+(z+2<<2)|0}else{o=871128+(z+2<<2)|0;d=c[o>>2]|0;if(d>>>0>=(c[217776]|0)>>>0){G=d;H=o;break}ct()}}while(0);c[H>>2]=n;c[G+12>>2]=n;c[n+8>>2]=G;c[n+12>>2]=y;return}y=n;G=F>>>8;do{if((G|0)==0){I=0}else{if(F>>>0>16777215>>>0){I=31;break}H=(G+1048320|0)>>>16&8;z=G<<H;b=(z+520192|0)>>>16&4;C=z<<b;z=(C+245760|0)>>>16&2;o=14-(b|H|z)+(C<<z>>>15)|0;I=F>>>((o+7|0)>>>0)&1|o<<1}}while(0);G=871392+(I<<2)|0;c[n+28>>2]=I;c[n+20>>2]=0;c[n+16>>2]=0;o=c[217773]|0;z=1<<I;if((o&z|0)==0){c[217773]=o|z;c[G>>2]=y;c[n+24>>2]=G;c[n+12>>2]=n;c[n+8>>2]=n;return}z=c[G>>2]|0;if((I|0)==31){J=0}else{J=25-(I>>>1)|0}L4493:do{if((c[z+4>>2]&-8|0)==(F|0)){K=z}else{I=z;G=F<<J;while(1){L=I+16+(G>>>31<<2)|0;o=c[L>>2]|0;if((o|0)==0){break}if((c[o+4>>2]&-8|0)==(F|0)){K=o;break L4493}else{I=o;G=G<<1}}if(L>>>0<(c[217776]|0)>>>0){ct()}c[L>>2]=y;c[n+24>>2]=I;c[n+12>>2]=n;c[n+8>>2]=n;return}}while(0);L=K+8|0;F=c[L>>2]|0;J=c[217776]|0;if(K>>>0<J>>>0){ct()}if(F>>>0<J>>>0){ct()}c[F+12>>2]=y;c[L>>2]=y;c[n+8>>2]=F;c[n+12>>2]=K;c[n+24>>2]=0;return}function AR(a){a=a|0;var b=0,d=0,e=0;b=(a|0)==0?1:a;while(1){d=AL(b)|0;if((d|0)!=0){e=3756;break}a=(I=c[4550598]|0,c[4550598]=I+0,I);if((a|0)==0){break}dd[a&63]()}if((e|0)==3756){return d|0}d=cJ(4)|0;c[d>>2]=90648;bQ(d|0,97072,204);return 0}function AS(a){a=a|0;return AR(a)|0}function AT(a){a=a|0;if((a|0)==0){return}AM(a);return}function AU(a){a=a|0;AT(a);return}function AV(a){a=a|0;AT(a);return}function AW(a){a=a|0;return}function AX(a){a=a|0;return 83e3}function AY(){var a=0;a=cJ(4)|0;c[a>>2]=90648;bQ(a|0,97072,204)}function AZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0;e=b;while(1){f=e+1|0;if((aY(a[e]|0)|0)==0){break}else{e=f}}g=a[e]|0;if((g<<24>>24|0)==45){i=f;j=1}else if((g<<24>>24|0)==43){i=f;j=0}else{i=e;j=0}e=-1;f=0;g=i;while(1){k=a[g]|0;if(((k<<24>>24)-48|0)>>>0<10>>>0){l=e}else{if(k<<24>>24!=46|(e|0)>-1){break}else{l=f}}e=l;f=f+1|0;g=g+1|0}l=g+(-f|0)|0;i=(e|0)<0;m=((i^1)<<31>>31)+f|0;n=(m|0)>18;o=(n?-18:-m|0)+(i?f:e)|0;e=n?18:m;do{if((e|0)==0){p=b;q=0.0}else{if((e|0)>9){m=l;n=e;f=0;while(1){i=a[m]|0;r=m+1|0;if(i<<24>>24==46){s=a[r]|0;t=m+2|0}else{s=i;t=r}u=(f*10|0)-48+(s<<24>>24)|0;r=n-1|0;if((r|0)>9){m=t;n=r;f=u}else{break}}v=+(u|0)*1.0e9;w=9;x=t;y=3787}else{if((e|0)>0){v=0.0;w=e;x=l;y=3787}else{z=0.0;A=0.0}}if((y|0)==3787){f=x;n=w;m=0;while(1){r=a[f]|0;i=f+1|0;if(r<<24>>24==46){B=a[i]|0;C=f+2|0}else{B=r;C=i}D=(m*10|0)-48+(B<<24>>24)|0;i=n-1|0;if((i|0)>0){f=C;n=i;m=D}else{break}}z=+(D|0);A=v}E=A+z;do{if((k<<24>>24|0)==69|(k<<24>>24|0)==101){m=g+1|0;n=a[m]|0;if((n<<24>>24|0)==45){F=g+2|0;G=1}else if((n<<24>>24|0)==43){F=g+2|0;G=0}else{F=m;G=0}m=a[F]|0;if((m-48|0)>>>0<10>>>0){H=F;I=0;J=m}else{K=0;L=F;M=G;break}while(1){m=(I*10|0)-48+J|0;n=H+1|0;f=a[n]|0;if((f-48|0)>>>0<10>>>0){H=n;I=m;J=f}else{K=m;L=n;M=G;break}}}else{K=0;L=g;M=0}}while(0);n=o+((M|0)==0?K:-K|0)|0;m=(n|0)<0?-n|0:n;if((m|0)>511){c[(cd()|0)>>2]=34;N=1.0;O=51696;P=511;y=3804}else{if((m|0)==0){Q=1.0}else{N=1.0;O=51696;P=m;y=3804}}if((y|0)==3804){while(1){y=0;if((P&1|0)==0){R=N}else{R=N*+h[O>>3]}m=P>>1;if((m|0)==0){Q=R;break}else{N=R;O=O+8|0;P=m;y=3804}}}if((n|0)>-1){p=L;q=E*Q;break}else{p=L;q=E/Q;break}}}while(0);if((d|0)!=0){c[d>>2]=p}if((j|0)==0){S=q;return+S}S=-0.0-q;return+S}function A_(a,b,c){a=a|0;b=b|0;c=c|0;return+(+AZ(a,b))}function A$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function A0(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0;while((e|0)<(c|0)){f=d[a+e|0]|0;g=d[b+e|0]|0;if((f|0)!=(g|0))return((f|0)>(g|0)?1:-1)|0;e=e+1|0}return 0}function A1(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function A2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function A3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{A$(b,c,d)|0}return b|0}function A4(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function A5(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function A6(a){a=a|0;if((a|0)<65)return a|0;if((a|0)>90)return a|0;return a-65+97|0}function A7(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;while(e>>>0<d>>>0){f=A6(a[b+e|0]|0)|0;g=A6(a[c+e|0]|0)|0;if((f|0)==(g|0)&(f|0)==0)return 0;if((f|0)==0)return-1;if((g|0)==0)return 1;if((f|0)==(g|0)){e=e+1|0;continue}else{return(f>>>0>g>>>0?1:-1)|0}}return 0}function A8(a,b){a=a|0;b=b|0;return A7(a,b,-1)|0}function A9(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(K=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Bb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(K=e,a-c>>>0|0)|0}function Bc(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}K=a<<c-32;return 0}function Bd(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}K=0;return b>>>c-32|0}function Be(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}K=(b|0)<0?-1:0;return b>>c-32|0}function Bf(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Bg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=ag(d,c)|0;f=a>>>16;a=(e>>>16)+(ag(d,f)|0)|0;d=b>>>16;b=ag(d,c)|0;return(K=(a>>>16)+(ag(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Bh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Bb(e^a,f^b,e,f)|0;b=K;a=g^e;e=h^f;f=Bb((Bm(i,b,Bb(g^c,h^d,g,h)|0,K,0)|0)^a,K^e,a,e)|0;return(K=K,f)|0}function Bi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Bb(h^a,j^b,h,j)|0;b=K;a=Bb(k^d,l^e,k,l)|0;Bm(m,b,a,K,g)|0;a=Bb(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=K;i=f;return(K=j,a)|0}function Bj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Bg(e,a)|0;f=K;return(K=(ag(b,a)|0)+(ag(d,e)|0)+f|f&0,c|0|0)|0}function Bk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Bm(a,b,c,d,0)|0;return(K=K,e)|0}function Bl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Bm(a,b,d,e,g)|0;i=f;return(K=c[g+4>>2]|0,c[g>>2]|0)|0}function Bm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(K=n,o)|0}else{if(!m){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(K=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(K=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(K=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Bf(l|0)|0)>>>0);return(K=n,o)|0}p=(A4(l|0)|0)-(A4(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(K=n,o)|0}else{if(!m){r=(A4(l|0)|0)-(A4(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(K=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(A4(j|0)|0)+33-(A4(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(K=n,o)|0}else{p=Bf(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(K=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Ba(g,d,-1,-1)|0;k=K;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Bb(e,k,j,a)|0;b=K;h=b>>31|((b|0)<0?-1:0)<<1;J=h&1;L=Bb(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=K;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=J}}B=H;C=I;D=M;E=L;F=0;G=J}J=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(J|0)>>>31|(B|C)<<1|(C<<1|J>>>31)&0|F;o=(J<<1|0>>>31)&-2|G;return(K=n,o)|0}function Bn(){cN()}function Bo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;c1[a&31](b|0,c|0,d|0,e|0,f|0)}function Bp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(0,a|0,b|0,c|0,d|0,e|0)}function Bq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(1,a|0,b|0,c|0,d|0,e|0)}function Br(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(2,a|0,b|0,c|0,d|0,e|0)}function Bs(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(3,a|0,b|0,c|0,d|0,e|0)}function Bt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(4,a|0,b|0,c|0,d|0,e|0)}function Bu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(5,a|0,b|0,c|0,d|0,e|0)}function Bv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(6,a|0,b|0,c|0,d|0,e|0)}function Bw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(7,a|0,b|0,c|0,d|0,e|0)}function Bx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(8,a|0,b|0,c|0,d|0,e|0)}function By(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;am(9,a|0,b|0,c|0,d|0,e|0)}function Bz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c2[a&63](b|0,c|0,d|0,e|0)}function BA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(0,a|0,b|0,c|0,d|0)}function BB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(1,a|0,b|0,c|0,d|0)}function BC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(2,a|0,b|0,c|0,d|0)}function BD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(3,a|0,b|0,c|0,d|0)}function BE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(4,a|0,b|0,c|0,d|0)}function BF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(5,a|0,b|0,c|0,d|0)}function BG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(6,a|0,b|0,c|0,d|0)}function BH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(7,a|0,b|0,c|0,d|0)}function BI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(8,a|0,b|0,c|0,d|0)}function BJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;am(9,a|0,b|0,c|0,d|0)}function BK(a){a=a|0;return c3[a&31]()|0}function BL(){return am(0)|0}function BM(){return am(1)|0}function BN(){return am(2)|0}function BO(){return am(3)|0}function BP(){return am(4)|0}function BQ(){return am(5)|0}function BR(){return am(6)|0}function BS(){return am(7)|0}function BT(){return am(8)|0}function BU(){return am(9)|0}function BV(a,b){a=a|0;b=b|0;c4[a&511](b|0)}function BW(a){a=a|0;am(0,a|0)}function BX(a){a=a|0;am(1,a|0)}function BY(a){a=a|0;am(2,a|0)}function BZ(a){a=a|0;am(3,a|0)}function B_(a){a=a|0;am(4,a|0)}function B$(a){a=a|0;am(5,a|0)}function B0(a){a=a|0;am(6,a|0)}function B1(a){a=a|0;am(7,a|0)}function B2(a){a=a|0;am(8,a|0)}function B3(a){a=a|0;am(9,a|0)}function B4(a,b,c){a=a|0;b=b|0;c=c|0;c5[a&255](b|0,c|0)}function B5(a,b){a=a|0;b=b|0;am(0,a|0,b|0)}function B6(a,b){a=a|0;b=b|0;am(1,a|0,b|0)}function B7(a,b){a=a|0;b=b|0;am(2,a|0,b|0)}function B8(a,b){a=a|0;b=b|0;am(3,a|0,b|0)}function B9(a,b){a=a|0;b=b|0;am(4,a|0,b|0)}function Ca(a,b){a=a|0;b=b|0;am(5,a|0,b|0)}function Cb(a,b){a=a|0;b=b|0;am(6,a|0,b|0)}function Cc(a,b){a=a|0;b=b|0;am(7,a|0,b|0)}function Cd(a,b){a=a|0;b=b|0;am(8,a|0,b|0)}function Ce(a,b){a=a|0;b=b|0;am(9,a|0,b|0)}function Cf(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return c6[a&31](b|0,c|0,d|0,e|0,f|0,g|0)|0}function Cg(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(0,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Ch(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(1,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Ci(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(2,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(3,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Ck(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(4,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(5,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(6,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(7,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Co(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(8,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return am(9,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Cq(a,b,c){a=a|0;b=b|0;c=c|0;return c7[a&255](b|0,c|0)|0}function Cr(a,b){a=a|0;b=b|0;return am(0,a|0,b|0)|0}function Cs(a,b){a=a|0;b=b|0;return am(1,a|0,b|0)|0}function Ct(a,b){a=a|0;b=b|0;return am(2,a|0,b|0)|0}function Cu(a,b){a=a|0;b=b|0;return am(3,a|0,b|0)|0}function Cv(a,b){a=a|0;b=b|0;return am(4,a|0,b|0)|0}function Cw(a,b){a=a|0;b=b|0;return am(5,a|0,b|0)|0}function Cx(a,b){a=a|0;b=b|0;return am(6,a|0,b|0)|0}function Cy(a,b){a=a|0;b=b|0;return am(7,a|0,b|0)|0}function Cz(a,b){a=a|0;b=b|0;return am(8,a|0,b|0)|0}function CA(a,b){a=a|0;b=b|0;return am(9,a|0,b|0)|0}function CB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return c8[a&127](b|0,c|0,d|0)|0}function CC(a,b,c){a=a|0;b=b|0;c=c|0;return am(0,a|0,b|0,c|0)|0}function CD(a,b,c){a=a|0;b=b|0;c=c|0;return am(1,a|0,b|0,c|0)|0}function CE(a,b,c){a=a|0;b=b|0;c=c|0;return am(2,a|0,b|0,c|0)|0}function CF(a,b,c){a=a|0;b=b|0;c=c|0;return am(3,a|0,b|0,c|0)|0}function CG(a,b,c){a=a|0;b=b|0;c=c|0;return am(4,a|0,b|0,c|0)|0}function CH(a,b,c){a=a|0;b=b|0;c=c|0;return am(5,a|0,b|0,c|0)|0}function CI(a,b,c){a=a|0;b=b|0;c=c|0;return am(6,a|0,b|0,c|0)|0}function CJ(a,b,c){a=a|0;b=b|0;c=c|0;return am(7,a|0,b|0,c|0)|0}function CK(a,b,c){a=a|0;b=b|0;c=c|0;return am(8,a|0,b|0,c|0)|0}function CL(a,b,c){a=a|0;b=b|0;c=c|0;return am(9,a|0,b|0,c|0)|0}function CM(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;c9[a&31](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function CN(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(0,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CO(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(1,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CP(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(2,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CQ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(3,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CR(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(4,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CS(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(5,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(6,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(7,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(8,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;am(9,a|0,b|0,c|0,d|0,e|0,f|0,+g)}function CX(a,b){a=a|0;b=b|0;return da[a&255](b|0)|0}function CY(a){a=a|0;return am(0,a|0)|0}function CZ(a){a=a|0;return am(1,a|0)|0}function C_(a){a=a|0;return am(2,a|0)|0}function C$(a){a=a|0;return am(3,a|0)|0}function C0(a){a=a|0;return am(4,a|0)|0}function C1(a){a=a|0;return am(5,a|0)|0}function C2(a){a=a|0;return am(6,a|0)|0}function C3(a){a=a|0;return am(7,a|0)|0}function C4(a){a=a|0;return am(8,a|0)|0}function C5(a){a=a|0;return am(9,a|0)|0}function C6(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;db[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function C7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function C8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function C9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Da(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Db(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Dc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Dd(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function De(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Df(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(8,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Dg(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;am(9,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Dh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;dc[a&31](b|0,c|0,d|0,e|0,f|0,+g)}function Di(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(0,a|0,b|0,c|0,d|0,e|0,+f)}function Dj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(1,a|0,b|0,c|0,d|0,e|0,+f)}function Dk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(2,a|0,b|0,c|0,d|0,e|0,+f)}function Dl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(3,a|0,b|0,c|0,d|0,e|0,+f)}function Dm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(4,a|0,b|0,c|0,d|0,e|0,+f)}function Dn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(5,a|0,b|0,c|0,d|0,e|0,+f)}function Do(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(6,a|0,b|0,c|0,d|0,e|0,+f)}function Dp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(7,a|0,b|0,c|0,d|0,e|0,+f)}function Dq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(8,a|0,b|0,c|0,d|0,e|0,+f)}function Dr(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;am(9,a|0,b|0,c|0,d|0,e|0,+f)}function Ds(a){a=a|0;dd[a&63]()}function Dt(){am(0)}function Du(){am(1)}function Dv(){am(2)}function Dw(){am(3)}function Dx(){am(4)}function Dy(){am(5)}function Dz(){am(6)}function DA(){am(7)}function DB(){am(8)}function DC(){am(9)}function DD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return de[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function DE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DL(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DM(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(8,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DN(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return am(9,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function DO(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;df[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function DP(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DQ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DR(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DS(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DX(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(8,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DY(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;am(9,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function DZ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dg[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function D_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D4(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D5(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D6(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(8,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;am(9,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function D8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dh[a&63](b|0,c|0,d|0,e|0,f|0,g|0)}function D9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(0,a|0,b|0,c|0,d|0,e|0,f|0)}function Ea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(1,a|0,b|0,c|0,d|0,e|0,f|0)}function Eb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(2,a|0,b|0,c|0,d|0,e|0,f|0)}function Ec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(3,a|0,b|0,c|0,d|0,e|0,f|0)}function Ed(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(4,a|0,b|0,c|0,d|0,e|0,f|0)}function Ee(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(5,a|0,b|0,c|0,d|0,e|0,f|0)}function Ef(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(6,a|0,b|0,c|0,d|0,e|0,f|0)}function Eg(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(7,a|0,b|0,c|0,d|0,e|0,f|0)}function Eh(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(8,a|0,b|0,c|0,d|0,e|0,f|0)}function Ei(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;am(9,a|0,b|0,c|0,d|0,e|0,f|0)}function Ej(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return di[a&63](b|0,c|0,d|0,e|0)|0}function Ek(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(0,a|0,b|0,c|0,d|0)|0}function El(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(1,a|0,b|0,c|0,d|0)|0}function Em(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(2,a|0,b|0,c|0,d|0)|0}function En(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(3,a|0,b|0,c|0,d|0)|0}function Eo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(4,a|0,b|0,c|0,d|0)|0}function Ep(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(5,a|0,b|0,c|0,d|0)|0}function Eq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(6,a|0,b|0,c|0,d|0)|0}function Er(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(7,a|0,b|0,c|0,d|0)|0}function Es(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(8,a|0,b|0,c|0,d|0)|0}function Et(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return am(9,a|0,b|0,c|0,d|0)|0}function Eu(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dj[a&127](b|0,c|0,d|0,e|0,f|0)|0}function Ev(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(0,a|0,b|0,c|0,d|0,e|0)|0}function Ew(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(1,a|0,b|0,c|0,d|0,e|0)|0}function Ex(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(2,a|0,b|0,c|0,d|0,e|0)|0}function Ey(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(3,a|0,b|0,c|0,d|0,e|0)|0}function Ez(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(4,a|0,b|0,c|0,d|0,e|0)|0}function EA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(5,a|0,b|0,c|0,d|0,e|0)|0}function EB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(6,a|0,b|0,c|0,d|0,e|0)|0}function EC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(7,a|0,b|0,c|0,d|0,e|0)|0}function ED(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(8,a|0,b|0,c|0,d|0,e|0)|0}function EE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return am(9,a|0,b|0,c|0,d|0,e|0)|0}function EF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dk[a&127](b|0,c|0,d|0)}function EG(a,b,c){a=a|0;b=b|0;c=c|0;am(0,a|0,b|0,c|0)}function EH(a,b,c){a=a|0;b=b|0;c=c|0;am(1,a|0,b|0,c|0)}function EI(a,b,c){a=a|0;b=b|0;c=c|0;am(2,a|0,b|0,c|0)}function EJ(a,b,c){a=a|0;b=b|0;c=c|0;am(3,a|0,b|0,c|0)}function EK(a,b,c){a=a|0;b=b|0;c=c|0;am(4,a|0,b|0,c|0)}function EL(a,b,c){a=a|0;b=b|0;c=c|0;am(5,a|0,b|0,c|0)}function EM(a,b,c){a=a|0;b=b|0;c=c|0;am(6,a|0,b|0,c|0)}function EN(a,b,c){a=a|0;b=b|0;c=c|0;am(7,a|0,b|0,c|0)}function EO(a,b,c){a=a|0;b=b|0;c=c|0;am(8,a|0,b|0,c|0)}function EP(a,b,c){a=a|0;b=b|0;c=c|0;am(9,a|0,b|0,c|0)}function EQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ah(0)}function ER(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ah(1)}function ES(){ah(2);return 0}function ET(a){a=a|0;ah(3)}function EU(a,b){a=a|0;b=b|0;ah(4)}function EV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ah(5);return 0}function EW(a,b){a=a|0;b=b|0;ah(6);return 0}function EX(a,b,c){a=a|0;b=b|0;c=c|0;ah(7);return 0}function EY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ah(8)}function EZ(a){a=a|0;ah(9);return 0}function E_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ah(10)}function E$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ah(11)}function E0(){ah(12)}function E1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ah(13);return 0}function E2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ah(14)}function E3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ah(15)}function E4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ah(16)}function E5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ah(17);return 0}function E6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ah(18);return 0}function E7(a,b,c){a=a|0;b=b|0;c=c|0;ah(19)}
// EMSCRIPTEN_END_FUNCS
var c1=[EQ,EQ,Bp,EQ,Bq,EQ,Br,EQ,Bs,EQ,Bt,EQ,Bu,EQ,Bv,EQ,Bw,EQ,Bx,EQ,By,EQ,AH,EQ,AG,EQ,AF,EQ,EQ,EQ,EQ,EQ];var c2=[ER,ER,BA,ER,BB,ER,BC,ER,BD,ER,BE,ER,BF,ER,BG,ER,BH,ER,BI,ER,BJ,ER,mi,ER,ed,ER,AC,ER,AD,ER,AB,ER,ua,ER,u8,ER,uo,ER,u3,ER,qd,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER,ER];var c3=[ES,ES,BL,ES,BM,ES,BN,ES,BO,ES,BP,ES,BQ,ES,BR,ES,BS,ES,BT,ES,BU,ES,oz,ES,hI,ES,oA,ES,md,ES,pA,ES];var c4=[ET,ET,BW,ET,BX,ET,BY,ET,BZ,ET,B_,ET,B$,ET,B0,ET,B1,ET,B2,ET,B3,ET,ye,ET,va,ET,x9,ET,tg,ET,tn,ET,t6,ET,es,ET,yw,ET,s3,ET,sS,ET,v1,ET,tf,ET,tl,ET,vz,ET,eH,ET,ll,ET,u0,ET,uY,ET,tg,ET,yu,ET,yK,ET,tl,ET,wI,ET,vA,ET,Aq,ET,rL,ET,uQ,ET,uJ,ET,ya,ET,li,ET,d5,ET,yv,ET,wg,ET,uz,ET,vb,ET,xl,ET,r0,ET,yo,ET,yj,ET,d8,ET,sJ,ET,Av,ET,zw,ET,uW,ET,n5,ET,u6,ET,w0,ET,zz,ET,dF,ET,yx,ET,AM,ET,tp,ET,x3,ET,zv,ET,st,ET,uE,ET,ey,ET,u5,ET,wX,ET,tg,ET,Aw,ET,z5,ET,v2,ET,dS,ET,zx,ET,zj,ET,rE,ET,xm,ET,uy,ET,uL,ET,dR,ET,uZ,ET,xa,ET,AV,ET,t5,ET,d$,ET,dH,ET,z8,ET,z9,ET,uR,ET,uk,ET,Ay,ET,yU,ET,lI,ET,uA,ET,d0,ET,uX,ET,xH,ET,xw,ET,uS,ET,ys,ET,AW,ET,Ab,ET,wU,ET,wH,ET,sY,ET,yn,ET,tl,ET,qc,ET,wV,ET,lh,ET,xS,ET,Ar,ET,lE,ET,xK,ET,x4,ET,w$,ET,wf,ET,y8,ET,u$,ET,sZ,ET,u1,ET,uG,ET,tx,ET,rO,ET,y0,ET,nX,ET,xZ,ET,xR,ET,zy,ET,lF,ET,Aa,ET,tV,ET,rr,ET,sR,ET,As,ET,Az,ET,uK,ET,r_,ET,d4,ET,d9,ET,ty,ET,ux,ET,As,ET,d6,ET,r7,ET,uP,ET,eb,ET,t2,ET,s4,ET,yq,ET,dZ,ET,u_,ET,xx,ET,sy,ET,wt,ET,xb,ET,sL,ET,d7,ET,dG,ET,uF,ET,uj,ET,uI,ET,to,ET,zu,ET,z7,ET,tH,ET,wu,ET,ea,ET,Ax,ET,yf,ET,sK,ET,Au,ET,os,ET,wY,ET,er,ET,x_,ET,xI,ET,yL,ET,tk,ET,uD,ET,Ac,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET,ET];var c5=[EU,EU,B5,EU,B6,EU,B7,EU,B8,EU,B9,EU,Ca,EU,Cb,EU,Cc,EU,Cd,EU,Ce,EU,zI,EU,km,EU,jJ,EU,xC,EU,nN,EU,xe,EU,kk,EU,pu,EU,ne,EU,zF,EU,jZ,EU,pW,EU,xv,EU,g1,EU,mv,EU,jt,EU,zE,EU,po,EU,xk,EU,om,EU,sM,EU,yd,EU,ul,EU,w6,EU,xF,EU,mp,EU,eB,EU,eF,EU,xs,EU,w5,EU,mB,EU,g0,EU,iy,EU,w3,EU,xD,EU,yr,EU,l7,EU,lk,EU,lO,EU,pS,EU,p$,EU,lr,EU,s_,EU,lm,EU,lH,EU,l0,EU,lY,EU,nb,EU,nc,EU,jV,EU,mD,EU,lQ,EU,dW,EU,mt,EU,xG,EU,mu,EU,jA,EU,zH,EU,jM,EU,ms,EU,qb,EU,oa,EU,nd,EU,xf,EU,tj,EU,ov,EU,xA,EU,n8,EU,od,EU,jb,EU,zJ,EU,xu,EU,xh,EU,jG,EU,zG,EU,xj,EU,sT,EU,oc,EU,lX,EU,t7,EU,g8,EU,jS,EU,eG,EU,k2,EU,lT,EU,jD,EU,yi,EU,le,EU,s5,EU,xp,EU,pU,EU,mx,EU,w9,EU,gj,EU,w8,EU,hE,EU,mz,EU,w4,EU,lJ,EU,xq,EU,gk,EU,pX,EU,q3,EU,xr,EU,dE,EU,na,EU,eD,EU,xB,EU,eN,EU,eM,EU,jX,EU,xg,EU,pF,EU,lB,EU,jP,EU,EU,EU,EU,EU];var c6=[EV,EV,Cg,EV,Ch,EV,Ci,EV,Cj,EV,Ck,EV,Cl,EV,Cm,EV,Cn,EV,Co,EV,Cp,EV,ow,EV,EV,EV,EV,EV,EV,EV,EV,EV];var c7=[EW,EW,Cr,EW,Cs,EW,Ct,EW,Cu,EW,Cv,EW,Cw,EW,Cx,EW,Cy,EW,Cz,EW,CA,EW,hU,EW,ju,EW,h_,EW,yM,EW,s8,EW,o5,EW,hx,EW,p7,EW,iM,EW,k_,EW,dJ,EW,hd,EW,yG,EW,iE,EW,uu,EW,n6,EW,h$,EW,yQ,EW,dI,EW,sW,EW,iN,EW,s1,EW,p8,EW,p9,EW,yC,EW,pd,EW,gZ,EW,eg,EW,iL,EW,iP,EW,q_,EW,oQ,EW,nV,EW,k1,EW,go,EW,k$,EW,h0,EW,oO,EW,iW,EW,oM,EW,oT,EW,jh,EW,oL,EW,yO,EW,oE,EW,g_,EW,hZ,EW,kZ,EW,o1,EW,gv,EW,oK,EW,k0,EW,kC,EW,oP,EW,jg,EW,oJ,EW,hS,EW,oH,EW,f6,EW,i$,EW,hT,EW,oN,EW,g9,EW,iI,EW,ui,EW,ky,EW,uw,EW,oG,EW,yE,EW,iH,EW,ha,EW,oX,EW,ot,EW,iA,EW,he,EW,gl,EW,iK,EW,gn,EW,ef,EW,kV,EW,iO,EW,p6,EW,hb,EW,o9,EW,hc,EW,ez,EW,iG,EW,iF,EW,ph,EW,kW,EW,ug,EW,sP,EW,iJ,EW,gm,EW,jf,EW,gp,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW,EW];var c8=[EX,EX,CC,EX,CD,EX,CE,EX,CF,EX,CG,EX,CH,EX,CI,EX,CJ,EX,CK,EX,CL,EX,u4,EX,mf,EX,yN,EX,yF,EX,mg,EX,or,EX,nM,EX,AA,EX,yb,EX,yI,EX,u9,EX,n4,EX,ts,EX,uh,EX,ud,EX,yy,EX,um,EX,yg,EX,yS,EX,dT,EX,ex,EX,oY,EX,yD,EX,sO,EX,tt,EX,ur,EX,yP,EX,t8,EX,s0,EX,uv,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX,EX];var c9=[EY,EY,CN,EY,CO,EY,CP,EY,CQ,EY,CR,EY,CS,EY,CT,EY,CU,EY,CV,EY,CW,EY,x$,EY,x5,EY,EY,EY,EY,EY,EY,EY];var da=[EZ,EZ,CY,EZ,CZ,EZ,C_,EZ,C$,EZ,C0,EZ,C1,EZ,C2,EZ,C3,EZ,C4,EZ,C5,EZ,zX,EZ,mk,EZ,ue,EZ,yZ,EZ,zN,EZ,uf,EZ,jx,EZ,mj,EZ,zq,EZ,my,EZ,lC,EZ,zV,EZ,xc,EZ,s6,EZ,ut,EZ,jQ,EZ,wv,EZ,zL,EZ,mr,EZ,oj,EZ,d1,EZ,s7,EZ,me,EZ,us,EZ,zp,EZ,zR,EZ,zP,EZ,j1,EZ,j2,EZ,At,EZ,kn,EZ,tm,EZ,zD,EZ,p0,EZ,zA,EZ,kl,EZ,zQ,EZ,jW,EZ,jK,EZ,zB,EZ,ub,EZ,n3,EZ,yY,EZ,xE,EZ,zS,EZ,mC,EZ,sN,EZ,oZ,EZ,lW,EZ,xd,EZ,zf,EZ,mq,EZ,lD,EZ,y5,EZ,xy,EZ,zK,EZ,sU,EZ,lS,EZ,jN,EZ,jY,EZ,jT,EZ,uU,EZ,w7,EZ,l6,EZ,lU,EZ,sV,EZ,mA,EZ,mo,EZ,zC,EZ,uc,EZ,jH,EZ,up,EZ,s$,EZ,y$,EZ,k3,EZ,xi,EZ,zW,EZ,ze,EZ,AX,EZ,uq,EZ,w1,EZ,zM,EZ,w2,EZ,mw,EZ,th,EZ,xn,EZ,y7,EZ,xt,EZ,xo,EZ,jB,EZ,eE,EZ,zO,EZ,xz,EZ,lf,EZ,y4,EZ,wJ,EZ,l1,EZ,ee,EZ,jE,EZ,zU,EZ,lg,EZ,zT,EZ,ob,EZ,p1,EZ,oq,EZ,zi,EZ,oi,EZ,ew,EZ,zt,EZ,ls,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ];var db=[E_,E_,C7,E_,C8,E_,C9,E_,Da,E_,Db,E_,Dc,E_,Dd,E_,De,E_,Df,E_,Dg,E_,ww,E_,wA,E_,wK,E_,wM,E_,x8,E_,wn,E_,wl,E_,x2,E_,wz,E_,wN,E_,v9,E_,vV,E_,wy,E_,vJ,E_,wL,E_,v7,E_,vL,E_,vD,E_,vT,E_,vN,E_,vF,E_,vH,E_,vw,E_,vB,E_,vR,E_,vP,E_,vq,E_,wO,E_,vk,E_,wx,E_,vo,E_,vg,E_,vi,E_,vm,E_,ve,E_,vu,E_,vs,E_,vc,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_,E_];var dc=[E$,E$,Di,E$,Dj,E$,Dk,E$,Dl,E$,Dm,E$,Dn,E$,Do,E$,Dp,E$,Dq,E$,Dr,E$,wq,E$,wo,E$,wd,E$,wa,E$,E$,E$];var dd=[E0,E0,Dt,E0,Du,E0,Dv,E0,Dw,E0,Dx,E0,Dy,E0,Dz,E0,DA,E0,DB,E0,DC,E0,q2,E0,pa,E0,o6,E0,o_,E0,kJ,E0,lp,E0,lo,E0,pi,E0,fx,E0,oU,E0,lK,E0,Bn,E0,o2,E0,lM,E0,ln,E0,pe,E0,lL,E0,E0,E0,E0,E0,E0,E0,E0,E0];var de=[E1,E1,DE,E1,DF,E1,DG,E1,DH,E1,DI,E1,DJ,E1,DK,E1,DL,E1,DM,E1,DN,E1,y1,E1,zb,E1,y9,E1,zm,E1,y2,E1,zk,E1,yV,E1,yW,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1,E1];var df=[E2,E2,DP,E2,DQ,E2,DR,E2,DS,E2,DT,E2,DU,E2,DV,E2,DW,E2,DX,E2,DY,E2,wB,E2,wP,E2,E2,E2,E2,E2,E2,E2];var dg=[E3,E3,D_,E3,D$,E3,D0,E3,D1,E3,D2,E3,D3,E3,D4,E3,D5,E3,D6,E3,D7,E3,wZ,E3,wW,E3,xJ,E3,xT,E3,xN,E3,xV,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3,E3];var dh=[E4,E4,D9,E4,Ea,E4,Eb,E4,Ec,E4,Ed,E4,Ee,E4,Ef,E4,Eg,E4,Eh,E4,Ei,E4,AI,E4,wm,E4,wi,E4,AJ,E4,wr,E4,un,E4,yc,E4,we,E4,v3,E4,v8,E4,v4,E4,ec,E4,wh,E4,AK,E4,t9,E4,yh,E4,E4,E4,E4,E4,E4,E4,E4,E4,E4,E4];var di=[E5,E5,Ek,E5,El,E5,Em,E5,En,E5,Eo,E5,Ep,E5,Eq,E5,Er,E5,Es,E5,Et,E5,yz,E5,yA,E5,yR,E5,nO,E5,q0,E5,yH,E5,yB,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5,E5];var dj=[E6,E6,Ev,E6,Ew,E6,Ex,E6,Ey,E6,Ez,E6,EA,E6,EB,E6,EC,E6,ED,E6,EE,E6,pc,E6,n9,E6,o4,E6,yJ,E6,o8,E6,zd,E6,yT,E6,u7,E6,zr,E6,pg,E6,zg,E6,qZ,E6,y3,E6,oS,E6,u2,E6,yX,E6,y_,E6,zo,E6,eC,E6,y6,E6,oW,E6,o0,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6,E6];var dk=[E7,E7,EG,E7,EH,E7,EI,E7,EJ,E7,EK,E7,EL,E7,EM,E7,EN,E7,EO,E7,EP,E7,lc,E7,eA,E7,la,E7,lb,E7,dU,E7,dV,E7,et,E7,ld,E7,iB,E7,oF,E7,lG,E7,q1,E7,lA,E7,eL,E7,dX,E7,lj,E7,tr,E7,ou,E7,uV,E7,lx,E7,dY,E7,ly,E7,n7,E7,lz,E7,kR,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7,E7];return{__GLOBAL__I_a1926:rA,_strlen:A1,_tolower:A6,__GLOBAL__I_a2115:ta,_calloc:AN,_strncpy:A5,_memset:A2,__GLOBAL__I_a43:eS,_memcpy:A$,_strcasecmp:A8,_playsid_setsong:eJ,_strncasecmp:A7,_playsid_pause:eI,_realloc:AO,_memcmp:A0,_free:AM,_memmove:A3,__GLOBAL__I_a:ev,_playsid_play:eK,_malloc:AL,_llvm_ctlz_i32:A4,_strcpy:A9,runPostSets:dC,stackAlloc:dl,stackSave:dm,stackRestore:dn,setThrew:dp,setTempRet0:ds,setTempRet1:dt,setTempRet2:du,setTempRet3:dv,setTempRet4:dw,setTempRet5:dx,setTempRet6:dy,setTempRet7:dz,setTempRet8:dA,setTempRet9:dB,dynCall_viiiii:Bo,dynCall_viiii:Bz,dynCall_i:BK,dynCall_vi:BV,dynCall_vii:B4,dynCall_iiiiiii:Cf,dynCall_iii:Cq,dynCall_iiii:CB,dynCall_viiiiiid:CM,dynCall_ii:CX,dynCall_viiiiiii:C6,dynCall_viiiiid:Dh,dynCall_v:Ds,dynCall_iiiiiiiii:DD,dynCall_viiiiiiiii:DO,dynCall_viiiiiiii:DZ,dynCall_viiiiii:D8,dynCall_iiiii:Ej,dynCall_iiiiii:Eu,dynCall_viii:EF}})
// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "jsCall": jsCall, "invoke_viiiii": invoke_viiiii, "invoke_viiii": invoke_viiii, "invoke_i": invoke_i, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiii": invoke_iiiiiii, "invoke_iii": invoke_iii, "invoke_iiii": invoke_iiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_ii": invoke_ii, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_iiiii": invoke_iiiii, "invoke_iiiiii": invoke_iiiiii, "invoke_viii": invoke_viii, "_llvm_lifetime_end": _llvm_lifetime_end, "_llvm_uadd_with_overflow_i32": _llvm_uadd_with_overflow_i32, "_sysconf": _sysconf, "_lseek": _lseek, "__scanString": __scanString, "_fclose": _fclose, "_pthread_mutex_lock": _pthread_mutex_lock, "___cxa_end_catch": ___cxa_end_catch, "_strtoull": _strtoull, "_fflush": _fflush, "_strtol": _strtol, "_fputc": _fputc, "_strtok": _strtok, "_fwrite": _fwrite, "_llvm_eh_exception": _llvm_eh_exception, "_fputs": _fputs, "_llvm_umul_with_overflow_i32": _llvm_umul_with_overflow_i32, "_isspace": _isspace, "_localtime": _localtime, "_read": _read, "_ceil": _ceil, "_strstr": _strstr, "_fsync": _fsync, "___cxa_guard_abort": ___cxa_guard_abort, "_newlocale": _newlocale, "_SDL_PauseAudio": _SDL_PauseAudio, "___gxx_personality_v0": ___gxx_personality_v0, "_pthread_cond_wait": _pthread_cond_wait, "___cxa_rethrow": ___cxa_rethrow, "___resumeException": ___resumeException, "_strcmp": _strcmp, "_memchr": _memchr, "_strncmp": _strncmp, "_vsscanf": _vsscanf, "_snprintf": _snprintf, "_fgetc": _fgetc, "_ceilf": _ceilf, "__getFloat": __getFloat, "_atexit": _atexit, "_mknod": _mknod, "___cxa_free_exception": ___cxa_free_exception, "_fgets": _fgets, "_close": _close, "_mktemp": _mktemp, "___setErrNo": ___setErrNo, "_isxdigit": _isxdigit, "_access": _access, "_ftell": _ftell, "_exit": _exit, "_sprintf": _sprintf, "_asprintf": _asprintf, "___ctype_b_loc": ___ctype_b_loc, "_strrchr": _strrchr, "_freelocale": _freelocale, "_catopen": _catopen, "_catgets": _catgets, "_getcwd": _getcwd, "_ferror": _ferror, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_does_inherit": ___cxa_does_inherit, "___cxa_guard_acquire": ___cxa_guard_acquire, "_localtime_r": _localtime_r, "___cxa_begin_catch": ___cxa_begin_catch, "_recv": _recv, "__parseInt64": __parseInt64, "_log": _log, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_putchar": _putchar, "___cxa_call_unexpected": ___cxa_call_unexpected, "__exit": __exit, "_strftime": _strftime, "_rand": _rand, "_tzset": _tzset, "___cxa_throw": ___cxa_throw, "_send": _send, "_toupper": _toupper, "_printf": _printf, "_pread": _pread, "_fopen": _fopen, "_open": _open, "__arraySum": __arraySum, "___assert_fail": ___assert_fail, "_puts": _puts, "_fdopen": _fdopen, "_mkdir": _mkdir, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_SDL_GetError": _SDL_GetError, "__formatString": __formatString, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_getenv": _getenv, "__ZSt9terminatev": __ZSt9terminatev, "_gettimeofday": _gettimeofday, "_atoi": _atoi, "_vfprintf": _vfprintf, "_isascii": _isascii, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_llvm_bswap_i16": _llvm_bswap_i16, "_sbrk": _sbrk, "___errno_location": ___errno_location, "_strerror": _strerror, "_gzopen": _gzopen, "_catclose": _catclose, "_llvm_lifetime_start": _llvm_lifetime_start, "__parseInt": __parseInt, "___cxa_guard_release": ___cxa_guard_release, "_ungetc": _ungetc, "_SDL_OpenAudio": _SDL_OpenAudio, "_uselocale": _uselocale, "_rename": _rename, "_vsnprintf": _vsnprintf, "_sscanf": _sscanf, "_creat": _creat, "_fread": _fread, "_strtok_r": _strtok_r, "_abort": _abort, "_fprintf": _fprintf, "_isdigit": _isdigit, "_strtoll": _strtoll, "___buildEnvironment": ___buildEnvironment, "_feof": _feof, "__addDays": __addDays, "_emscripten_async_wget2": _emscripten_async_wget2, "_fabs": _fabs, "_floor": _floor, "__reallyNegative": __reallyNegative, "_fseek": _fseek, "_sqrt": _sqrt, "_write": _write, "_gzread": _gzread, "_mkstemp": _mkstemp, "___cxa_allocate_exception": ___cxa_allocate_exception, "_sin": _sin, "_strchr": _strchr, "_stat": _stat, "___cxa_pure_virtual": ___cxa_pure_virtual, "_vasprintf": _vasprintf, "_gzwrite": _gzwrite, "___ctype_toupper_loc": ___ctype_toupper_loc, "___ctype_tolower_loc": ___ctype_tolower_loc, "_setbuf": _setbuf, "_llvm_va_end": _llvm_va_end, "_unlink": _unlink, "_pwrite": _pwrite, "_strerror_r": _strerror_r, "_gzclose": _gzclose, "__isLeapYear": __isLeapYear, "_exp": _exp, "_time": _time, "_setvbuf": _setvbuf, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "NaN": NaN, "Infinity": Infinity, "__ZTVN10__cxxabiv117__class_type_infoE": __ZTVN10__cxxabiv117__class_type_infoE, "___fsmu8": ___fsmu8, "_stdout": _stdout, "___dso_handle": ___dso_handle, "_stdin": _stdin, "__ZTVN10__cxxabiv120__si_class_type_infoE": __ZTVN10__cxxabiv120__si_class_type_infoE, "_stderr": _stderr }, buffer);
var __GLOBAL__I_a1926 = Module["__GLOBAL__I_a1926"] = asm["__GLOBAL__I_a1926"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _tolower = Module["_tolower"] = asm["_tolower"];
var __GLOBAL__I_a2115 = Module["__GLOBAL__I_a2115"] = asm["__GLOBAL__I_a2115"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memset = Module["_memset"] = asm["_memset"];
var __GLOBAL__I_a43 = Module["__GLOBAL__I_a43"] = asm["__GLOBAL__I_a43"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strcasecmp = Module["_strcasecmp"] = asm["_strcasecmp"];
var _playsid_setsong = Module["_playsid_setsong"] = asm["_playsid_setsong"];
var _strncasecmp = Module["_strncasecmp"] = asm["_strncasecmp"];
var _playsid_pause = Module["_playsid_pause"] = asm["_playsid_pause"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _memcmp = Module["_memcmp"] = asm["_memcmp"];
var _free = Module["_free"] = asm["_free"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var _playsid_play = Module["_playsid_play"] = asm["_playsid_play"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _llvm_ctlz_i32 = Module["_llvm_ctlz_i32"] = asm["_llvm_ctlz_i32"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };
// TODO: strip out parts of this we do not need
//======= begin closure i64 code =======
// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */
var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };
  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.
    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };
  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.
  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};
  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }
    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };
  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };
  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };
  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }
    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };
  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.
  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;
  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);
  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);
  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);
  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);
  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };
  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };
  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (this.isZero()) {
      return '0';
    }
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }
    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);
      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };
  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };
  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };
  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };
  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };
  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };
  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };
  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };
  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }
    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }
    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };
  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };
  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };
  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }
    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }
    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }
    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);
      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }
      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }
      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };
  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };
  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };
  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };
  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };
  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };
  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };
  //======= begin jsbn =======
  var navigator = { appName: 'Modern Browser' }; // polyfill a little
  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/
  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */
  // Basic JavaScript BN library - subset useful for RSA encryption.
  // Bits per digit
  var dbits;
  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);
  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }
  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }
  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.
  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }
  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);
  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;
  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }
  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }
  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }
  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }
  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }
  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }
  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }
  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }
  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }
  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }
  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }
  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }
  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }
  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }
  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }
  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }
  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }
  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }
  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }
  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }
  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;
  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }
  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }
  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }
  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }
  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }
  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;
  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }
  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }
  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }
  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;
  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;
  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);
  // jsbn2 stuff
  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }
  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }
  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }
  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }
  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }
  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }
  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }
  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;
  //======= end jsbn =======
  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();
//======= end closure i64 code =======
// === Auto-generated postamble setup entry stuff ===
if (memoryInitializer) {
  function applyData(data) {
    HEAPU8.set(data, STATIC_BASE);
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    applyData(Module['readBinary'](memoryInitializer));
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      applyData(data);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}
function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}
Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');
  args = args || [];
  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }
  ensureInitRuntime();
  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);
  initialStackTop = STACKTOP;
  try {
    var ret = Module['_main'](argc, argv, 0);
    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}
function run(args) {
  args = args || Module['arguments'];
  if (preloadStartTime === null) preloadStartTime = Date.now();
  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }
  preRun();
  if (runDependencies > 0) {
    // a preRun added a dependency, run will be called later
    return;
  }
  function doRun() {
    ensureInitRuntime();
    preMain();
    Module['calledRun'] = true;
    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }
    postRun();
  }
  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;
function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;
  // exit the runtime
  exitRuntime();
  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371
  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;
function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }
  ABORT = true;
  EXITSTATUS = 1;
  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;
// {{PRE_RUN_ADDITIONS}}
if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}
// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}
run();
// {{POST_RUN_ADDITIONS}}
// {{MODULE_ADDITIONS}}
playsid_play = function(name, done_cb, progress_cb) {
	var done_num = Runtime.addFunction(function(title, composer, copyright, max_song, start_song) {
		var o = {};
		o.title = Pointer_stringify(title);
		o.composer = Pointer_stringify(composer);
		o.copyright = Pointer_stringify(copyright);
		o.songs = max_song;
		o.start_song = start_song+1;
		done_cb(o);
		Runtime.removeFunction(done_num);
	});
	//var progress_num = Runtime.addFunction(progress_cb);
	Module.ccall('playsid_play', 'void', ['string', 'number', 'number'], [name, done_num, 0]);
}
playsid_pause = function(dopause) {
	Module.ccall('playsid_pause', 'void', ['number'], [dopause]);
}
playsid_setsong = function(song) {
	Module.ccall('playsid_setsong', 'void', ['number'], [song-1]);
}
